
local CardMaster = {}
CardMaster.TAG = "[CardMaster]"
-- type
-- 主卡尺寸 410 * 615
CardMaster.MASTERCARD      = 1
-- 副卡尺寸 210 * 315
CardMaster.VICECARD        = 2
-- 副卡尺寸 800 * 1200
CardMaster.MAXCARD         = 3
CardMaster.CONFIGCARD      = 4
CardMaster.CONFIGMAINCARD  = 5
CardMaster.LOCKCARD        = 6
CardMaster.MINICARD        = 7
CardMaster.MINISTARCARD    = 8
CardMaster.FRAGMENTCARD    = 9
CardMaster.ALBUMCARD       = 10
CardMaster.MONSTERCARD     = 11
CardMaster.SELECTCARD      = 12

local LinearNum = require("cardui.LinearNum")

local CARD_SCALE_HALF = 0.5125
local CARD_SCALE_HALF_2 = 0.2625

local IMAGE_SIZE = {
    LARGE = "l",
    SMALL = "s",
    MIDDLE = "m",
}
-- local IMAGE_CARD_LEVEL      = "card/bg_card_level.png"
local IMAGE_CARD_STAR       = "card/img_card_star.png"
local IMAGE_CARD_HOURGLASS  = "card/img_card_hourglass.png"
local IMAGE_CARD_WAITROUND  = "card/bg_card_waitround.png"

local IMAGE_CARD_FRAME = {}
IMAGE_CARD_FRAME[1] = {"card/img_card_frame_alliance.png", "card/img_card_frame_tribe.png", "card/img_card_frame_undead.png"}
IMAGE_CARD_FRAME[2] = {"card/img_card_frame_alliance_1.png", "card/img_card_frame_tribe_1.png", "card/img_card_frame_undead_1.png"}
local IMAGE_CARD_FRAME_S = {}
IMAGE_CARD_FRAME_S[1] = {"card/img_card_frame_s_alliance.png", "card/img_card_frame_s_tribe.png", "card/img_card_frame_s_undead.png"}
IMAGE_CARD_FRAME_S[2] = {"card/img_card_frame_s_alliance_1.png", "card/img_card_frame_s_tribe_1.png", "card/img_card_frame_s_undead_1.png"}
local BG_IMACE_CARD_RACE = {}
-- BG_IMACE_CARD_RACE[1] = {"card/img_card_race_alliance.png", "card/img_card_race_tribe.png", "card/img_card_race_undead.png"}
-- BG_IMACE_CARD_RACE[2] = {"card/img_card_race_alliance_1.png", "card/img_card_race_tribe_1.png", "card/img_card_race_undead_1.png"}
BG_IMACE_CARD_RACE[1] = "card/img_card_race.png"
BG_IMACE_CARD_RACE[2] = "card/img_card_race_1.png"
local IMACE_CARD_RACE = {"card/img_race_alliance.png", "card/img_race_tribe.png", "card/img_race_undead.png"}
local IMACE_CARD_RACE_S = {"card/img_race_s_alliance.png", "card/img_race_s_tribe.png", "card/img_race_s_undead.png"}
local BG_CARD_COST = {"card/bg_card_cost_alliance.png", "card/bg_card_cost_tribe.png", "card/bg_card_cost_undead.png"}
-- local BG_CARD_COST = "card/bg_card_cost.png"
local BG_CARD_COST_S = {"card/bg_card_cost_s_alliance.png", "card/bg_card_cost_s_tribe.png", "card/bg_card_cost_s_undead.png"}
-- local BG_CARD_COST_S = "card/bg_card_s_cost.png"
-- local BG_CARD_EVO = "card/bg_card_evo.png"
-- local BG_CARD_EVO_S = "card/bg_card_evo_s.png"
local BG_CARD_EVO = {"card/bg_card_evo_1.png", "card/bg_card_evo_2.png", "card/bg_card_evo_3.png", "card/bg_card_evo_4.png", "card/bg_card_evo_5.png"}
local BG_CARD_EVO_S = {"card/bg_card_evo_s_1.png", "card/bg_card_evo_s_2.png", "card/bg_card_evo_s_3.png", "card/bg_card_evo_s_4.png", "card/bg_card_evo_s_5.png"}
local IMAGE_CARD_COST = {"card/img_card_cost.png", "card/img_card_cost.png", "card/img_card_cost.png"}
local IMAGE_CARD_COST_S = "card/img_card_s_cost.png"

local IMAGE_CARD_MIN_FRAME = {}
IMAGE_CARD_MIN_FRAME[1] = {"card/img_card_min_frame.png", }
IMAGE_CARD_MIN_FRAME[2] = {"card/img_card_min_frame_1.png",}

local IMAGE_CARD_RARE = {"card/img_card_rare_l.png", "card/img_card_rare_m.png", "card/img_card_rare_s.png",}

-- 获取星级图片
local function getStarLevelImage( level, size, padding )
    padding = padding or 0
    size = size or IMAGE_SIZE.LARGE
    local numFomat = "card/img_card_%s_star.png"
    local layer = widget.newLinearLayer{padding = padding,}
    for i = 1, level do
        local sprite = widget.newSprite{file = string.format(numFomat, size),}
        layer:addChild(sprite)
    end
    layer:setCascadeColorEnabled(true)
    layer:setColor(ccc3(255, 255, 255))
    return layer
end

-- 获取数字图片
local function getNumImage( nums, size, padding )
    padding = padding or -4
    size = size or IMAGE_SIZE.MIDDLE
    local numFomat = "#img_num_%s_%s.png"
    local layer = widget.newLinearLayer{padding = padding,}
    local numsStr = tostring(nums)
    local numsLen = string.len(numsStr)
    display.addSpriteFramesWithFile("card/img_num.plist", "card/img_num.png")
    for i = 1, numsLen do
        local num = string.byte(numsStr, i)
        local numSprite = widget.newSprite{file = string.format(numFomat, size, string.char(num)),}
        layer:addChild(numSprite)
    end
    layer:setCascadeColorEnabled(true)
    layer:setColor(ccc3(255, 255, 255))
    return layer
end
-- 获取进阶图片
local function getEvoLvImage( evolv, size, padding )
    padding = padding or 0
    size = size or IMAGE_SIZE.LARGE
    local numFomat = "#img_evo_num_%s_%s.png"
    local layer = widget.newLinearLayer{padding = padding,}
    local evoStr = tostring(evolv)
    local numLen = string.len(evoStr)
    display.addSpriteFramesWithFile("card/img_evo_num.plist", "card/img_evo_num.png")
    local addSprite = widget.newSprite{file = string.format(numFomat, size, "plus"),}
    layer:addChild(addSprite)
    for i = 1, numLen do
        local num = string.byte(evoStr, i)
        local numSprite = widget.newSprite{file = string.format(numFomat, size, string.char(num)),}
        layer:addChild(numSprite)
    end
    layer:setCascadeColorEnabled(true)
    layer:setColor(ccc3(255, 255, 255))
    return layer
end
-- create CardMaster

--[[**Parameters:**

            [必填项]
            cardEntity      params              卡片entity

            [选填项]
            int             params.type                绑定类型(默认不绑定)
                                                            CardMaster.MASTERCARD     
                                                            CardMaster.VICECARD       
                                                            CardMaster.MAXCARD        
                                                            CardMaster.CONFIGCARD 
--]]

function CardMaster.new(params)
--[[ ## local params --]]
    local _card = display.newLayer()
--#必填项#
    local _cardParams = params
--#选填项#
    -- local _listener = params.listener
--#内部参数#   

--[[ ## local fuction --]]
    -- Log.d(CardMaster.TAG, "Card's ID = %d", params:getId())
    -- params:setEvolv(1)
    local function init( )
        util.checkParams(CardMaster.TAG, "new()", {
            { istable(_cardParams), "is not a table" },
        })
        if _cardParams.type == CardMaster.MASTERCARD then
            CardMaster.bindMasterCard(_card)
        elseif _cardParams.type == CardMaster.VICECARD then
            CardMaster.bindViceCard(_card)
        elseif _cardParams.type == CardMaster.MAXCARD then
            CardMaster.bindMaxCard(_card)
        elseif _cardParams.type == CardMaster.CONFIGCARD then
            CardMaster.bindSelectedCard(_card)
        elseif _cardParams.type == CardMaster.CONFIGMAINCARD then
            CardMaster.bindSelectedCard(_card)
        elseif _cardParams.type == CardMaster.LOCKCARD then
            CardMaster.bindSelectedCard(_card)
        elseif _cardParams.type == CardMaster.SELECTCARD then
            CardMaster.bindSelectedCard(_card)
        elseif _cardParams.type == CardMaster.MINICARD then
            CardMaster.bindMiniCard(_card)
        elseif _cardParams.type == CardMaster.MINISTARCARD then
            CardMaster.bindMiniStarCard(_card)
        elseif _cardParams.type == CardMaster.FRAGMENTCARD then
            CardMaster.bindFragmentCard(_card)
        elseif _cardParams.type == CardMaster.ALBUMCARD then
            CardMaster.bindAlbumCard(_card)
        elseif _cardParams.type == CardMaster.MONSTERCARD then
            CardMaster.bindMonsterCard(_card)
        end
    end

--[[ ## public fuction --]]
    function _card.getParams( )
        return _cardParams
    end

    function _card.setParams( cardEntity )
        _cardParams = cardEntity
    end
    
--[[ ## running --]]
    init()
    return _card
end
--[[ 

绑定成主卡牌

--]]
function CardMaster.bindMasterCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()
    local _handler        = _params.handler               -- 点击事件处理
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end

    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(205, 312.5))
        if _id then
            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardImageEx(),
                ignoreAnchor = true,
            }
            -- sprite:setScale(SCALE_FOR_SPECIAL_NODE )
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -12})

            -- cost背景
            local costBg = widget.newSprite{
                -- file = BG_CARD_COST,
                file = BG_CARD_COST[_params:getCardRaceId()],
            }
            costBg:setScale(0.5)
            _card:addChild(costBg)
            util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 33, right = 10})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            frameSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card)

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {top = 4,})

            -- 回合背景
            local wtBg = widget.newSprite{
                file = IMAGE_CARD_WAITROUND,
            }
            wtBg:setScale(CARD_SCALE_HALF)
            _card:addChild(wtBg)
            util.alignNodeWithPadding(wtBg, _card, display.BOTTOM_RIGHT , {bottom = 47, right = 3})

            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            raceBg:setScale(CARD_SCALE_HALF)
            _card:addChild(raceBg)
            util.alignNodeWithPadding(raceBg, _card, display.TOP_LEFT, {top = 2})
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 2, right = 6})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.MIDDLE, 0)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -84, top = 12})
            end
            -- 种族
            -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
            -- -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 2})
            -- 攻击力图标
            local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            atkSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(atkSprite)
            util.alignNodeWithPadding(atkSprite, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 24, left = 52})
            -- 血量图标
            local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            hpSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(hpSprite)
            util.alignNodeWithPadding(hpSprite, _card:getContentSize(), display.CENTER_BOTTOM, {left = -52, bottom = 24})
            -- (1)加载攻击力
            local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
            labelAttack:setScale(0.3/SCALE_FOR_SPECIAL_LABEL )
            _card:addChild(labelAttack)
            util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.CENTER_BOTTOM, {left = 52, bottom = 8})

            -- (2)加载HP
            local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
            labelHP:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL )
            _card:addChild(labelHP)
            util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.CENTER_BOTTOM, {left = -52, bottom = 8})

            -- (3)加载名称
            -- local labelName = widget.newTTFLabelWithOutline{
            local labelName = widget.newTTFLabelWithShadow{
            -- local labelName = ui.newTTFLabel{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text            = tostring(_params:getCardName()),       -- 标签文字
                size            = 16,                                    -- 字体大小
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 76,})


            -- (4)加载等级
            local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
            labelLevel:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelLevel)
            util.alignNodeWithPadding(labelLevel, _card, display.TOP_CENTER, {left = 74, top = 14})

            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            _card:addChild(starLayer)
            starLayer:setScale(CARD_SCALE_HALF)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 54,})

            -- (6)cost召唤值
            local cost = widget.newTTFLabelWithShadow{
            -- local cost = ui.newTTFLabel{
                text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
                size = 14,
            }
            _card:addChild(cost)
            util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 55, top = 30} )
            util.modifyPositionInAndroid( cost, 0, -1 )
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 14,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 44, top = 20} )

            -- (7)等待上场回合
            local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.MIDDLE)
            wtLabel:setScale(CARD_SCALE_HALF)
            _card:addChild(wtLabel)
            util.alignNodeWithPadding(wtLabel, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 50, right = 5,})

            -- (8)沙漏
            local hourglassSprite = widget.newSprite{
                file = IMAGE_CARD_HOURGLASS,
            }
            hourglassSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(hourglassSprite)
            util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 47, right = 12})

            -- (9)稀有标志
            if _params:getIsRare() then
                local rareSprite = widget.newSprite{
                    file = IMAGE_CARD_RARE[2],
                }
                -- rareSprite:setScale(CARD_SCALE_HALF)
                _card:addChild(rareSprite)
                util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 44, left = 3})
            end
        end        
        -- 绑定点击
        widget.bindTouchEvent{
            layer = _card,
            clickListener = onClick,
        }
    end
--[[ ## public fuction --]]

--[[ ## running --]]
    init()
    return _card
end
-- 绑定成副卡牌
function CardMaster.bindViceCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _handler        = _params.handler               -- 点击事件处理
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end
    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(105, 157.5))
        -- 取值
        if _id then
            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardImage(),
                ignoreAnchor = true,
            }
            -- sprite:setScale(SCALE_FOR_SPECIAL_NODE)
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -6})

            -- cost背景
            local costBg = widget.newSprite{
                -- file = BG_CARD_COST_S,
                file = BG_CARD_COST_S[_params:getCardRaceId()],
            }
            costBg:setScale(0.7)
            _card:addChild(costBg)
            util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 24, right = 4})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME_S[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            frameSprite:setScale( CARD_SCALE_HALF )
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card)

            -- 顶部边框
            -- local topSprite = widget.newSprite{
            --     file = getTopImage(_params:getCardRaceId()),
            -- }
            -- topSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
            -- _card:addChild(topSprite)
            -- util.alignNode(topSprite, _card:getContentSize(), display.CENTER_TOP)

            -- 底部边框
            -- local bottomSprite = widget.newSprite{
            --     file = getBottomImage(_params:getCardRaceId()),
            -- }
            -- bottomSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
            -- _card:addChild(bottomSprite)
            -- util.alignNode(bottomSprite, _card:getContentSize(), display.CENTER_BOTTOM )

            -- cost背景
            -- local costBg = widget.newSprite{
            --     file = IMAGE_CARD_COST,
            -- }
            -- costBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
            -- _card:addChild(costBg)
            -- util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 9.5, right = 6})

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {left = -2, top = -2})

            

            -- 回合背景
            local wtBg = widget.newSprite{
                file = IMAGE_CARD_WAITROUND,
            }
            wtBg:setScale(CARD_SCALE_HALF_2 * 1.4)
            _card:addChild(wtBg)
            util.alignNodeWithPadding(wtBg, _card:getContentSize(), display.BOTTOM_RIGHT , {bottom = 24, right = 1})

            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            raceBg:setScale(CARD_SCALE_HALF_2 * 1.4)
            _card:addChild(raceBg)
            util.alignNodeWithPadding(raceBg, _card, display.TOP_LEFT)
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                evoBg:setScale(0.8)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 0, right = 2})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.SMALL, 0)
                evoLayer:setScale(1.3)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -40, top = 8})
            end
            -- 种族
            -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
            -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = -2})
            -- -- 攻击力图标
            -- local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            -- atkSprite:setScale(SCALE_FOR_SPECIAL_LABEL * CARD_SCALE_HALF)
            -- _card:addChild(atkSprite)
            -- util.alignNodeWithPadding(atkSprite, _card:getContentSize(), display.LEFT_BOTTOM, {bottom = 9.5})
            -- -- 血量图标
            -- local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            -- hpSprite:setScale(SCALE_FOR_SPECIAL_LABEL * CARD_SCALE_HALF)
            -- _card:addChild(hpSprite)
            -- util.alignNodeWithPadding(hpSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {right = 25, bottom = 9.5})
            -- (1)加载攻击力
            local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
            labelAttack:setScale(0.22 / SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelAttack)
            util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.CENTER_BOTTOM, {left = 28, bottom = 0})

            -- (2)加载HP
            local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
            labelHP:setScale(0.22 / SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelHP)
            util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.CENTER_BOTTOM, {left = -28, bottom = 0})

            -- (3)加载名称
            -- local labelName = widget.newTTFLabelWithOutline{
            -- local labelName = ui.newTTFLabel{
            local labelName = widget.newTTFLabelWithShadow{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text       = tostring(_params:getCardName()),       -- 标签文字
                size       = 12,                                    -- 字体大小
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 36})

            -- (4)加载等级
            local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
            labelLevel:setScale(0.4)
            _card:addChild(labelLevel)
            util.alignNodeWithPadding(labelLevel, _card:getContentSize(), display.TOP_CENTER, {left = 32, top = 8})
            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            _card:addChild(starLayer)
            starLayer:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 27,})

            -- (6)cost召唤值
            local cost = widget.newTTFLabelWithShadow{
                text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
                size = 10,
            }
            _card:addChild(cost)
            util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 26, top = 23} )
            util.modifyPositionInAndroid( cost, 0, -1 )
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 8,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 24, top = 7} )
            -- local costSprite = widget.newSprite{file = IMAGE_CARD_COST_S }
            -- costSprite:setScale(0.7)
            -- _card:addChild(costSprite)
            -- util.alignNodeWithPadding(costSprite, _card:getContentSize(), display.TOP_CENTER, {left = - 22, top = 14} )
            -- (7)等待上场回合
            local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.SMALL)
            wtLabel:setScale(0.6)
            _card:addChild(wtLabel)
            util.alignNodeWithPadding(wtLabel, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 25, right = 1,})

            -- (8)沙漏
            local hourglassSprite = widget.newSprite{
                file = IMAGE_CARD_HOURGLASS,
            }
            hourglassSprite:setScale(CARD_SCALE_HALF_2 * 1.4)
            _card:addChild(hourglassSprite)
            util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 24, right = 6,})
            -- (9)稀有标志
            if _params:getIsRare() then
                local rareSprite = widget.newSprite{
                    file = IMAGE_CARD_RARE[3],
                }
                -- rareSprite:setScale(CARD_SCALE_HALF)
                _card:addChild(rareSprite)
                util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 24, left = 1})
            end
        end
        -- 绑定点击
        widget.bindTouchEvent{
                                layer = _card,
                                clickListener = onClick,
                            }
    end
--[[ ## public fuction --]]
    
--[[ ## running --]]
    init()
    return _card
end
-- 绑定成详情卡片,超大, 不可点击
function CardMaster.bindMaxCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _handler        = _params.handler
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end
    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(400, 600))
        -- 取值
        if _id then
            -- 卡牌
            local sprite = widget.newSprite{
                file = _params:getCardImageMax(),
                ignoreAnchor = true,
            }
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -24,})

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {left = -4, })

            -- cost背景
            local costBg = widget.newSprite{
                -- file = BG_CARD_COST,
                file = BG_CARD_COST[_params:getCardRaceId()],
            }
            -- costBg:setScale(1.2)
            _card:addChild(costBg)
            util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 60, right = 19})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card)
            
            -- 回合背景
            local wtBg = widget.newSprite{
                file = IMAGE_CARD_WAITROUND,
            }
            _card:addChild(wtBg)
            util.alignNodeWithPadding(wtBg, _card:getContentSize(), display.BOTTOM_RIGHT , {bottom = 94, right = 6})
            
            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            _card:addChild(raceBg)
            util.alignNodeWithPadding(raceBg, _card:getContentSize(), display.LEFT_TOP, {top = 4,})
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {right = 16})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -160, top = 20})
            end
            -- 种族
            -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE[_params:getCardRaceId()]}
            -- -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = -2})
            -- 攻击力图标
            local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            -- atkSprite:setScale(0.8)
            _card:addChild(atkSprite)
            util.alignNodeWithPadding(atkSprite, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 40, left = 104})
            -- 血量图标
            local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            -- hpSprite:setScale(0.8)
            _card:addChild(hpSprite)
            util.alignNodeWithPadding(hpSprite, _card:getContentSize(), display.CENTER_BOTTOM, {left = -104, bottom = 40})
            
            -- (1)加载攻击力
            local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
            _card:addChild(labelAttack)
            util.alignNodeWithPadding(labelAttack, _card, display.CENTER_BOTTOM, {left = 104, bottom = 14})
            -- (2)加载HP
            local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
            _card:addChild(labelHP)
            util.alignNodeWithPadding(labelHP, _card, display.CENTER_BOTTOM, {left = -104, bottom = 14})

            -- (3)加载名称
            -- local labelName = widget.newTTFLabelWithOutline{
            local labelName = widget.newTTFLabelWithShadow{
            -- local labelName = ui.newTTFLabel{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text       = tostring(_params:getCardName()),       -- 标签文字
                size       = 30,                                    -- 字体大小
                offset     = 2 / (display.widthInPixels / display.width)
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 140,})

            -- (4)加载等级
            local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
            _card:addChild(labelLevel)
            util.alignNodeWithPadding(labelLevel, _card, display.TOP_CENTER, {left = 144, top = 26})

            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            starLayer:setScale(SCALE_FOR_SPECIAL_NODE)
            _card:addChild(starLayer)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 100,})

            -- (6)cost召唤值
            local cost = widget.newTTFLabelWithShadow{
            -- local cost = ui.newTTFLabel{
                text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
                size = 24,
            }
            _card:addChild(cost)
            util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 110, top = 64} )
            util.modifyPositionInAndroid( cost, 0, 4 )
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 22,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 80, top = 42} )
           
            -- (7)等待上场回合
            local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.MIDDLE) 
            _card:addChild(wtLabel)
            util.alignNodeWithPadding(wtLabel, _card, display.RIGHT_BOTTOM, {right = 12, bottom = 100})
            -- (8)沙漏
            local hourglassSprite = widget.newSprite{
                file = IMAGE_CARD_HOURGLASS,
            }
            hourglassSprite:setScale(SCALE_FOR_SPECIAL_NODE)
            _card:addChild(hourglassSprite)
            util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 94, right = 24})
            
            -- (9)稀有标志
            if _params:getIsRare() then
                local rareSprite = widget.newSprite{
                    file = IMAGE_CARD_RARE[1],
                }
                -- rareSprite:setScale(CARD_SCALE_HALF)
                _card:addChild(rareSprite)
                util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 94, left = 6})
            end
            -- 绑定点击
            widget.bindTouchEvent{
                                    layer = _card,
                                    clickListener = onClick,
                                }
        end
    end
--[[ ## public fuction --]]
    
--[[ ## running --]]
    init()
    return _card
end
--[[ 

绑定成可选中卡片, 带详情按钮,选中标识边框

--]]
function CardMaster.bindSelectedCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _handler        = _params.handler               -- 点击事件处理
    local _padding        = _params.padding or {left = 5, right = 5, }

--#必填项#

--#选填项#

--#内部参数#   
    local _selectFrame, _selectNode, _selectViceNode
    local _isSelect = false
--[[ ## local fuction --]]
    local function onDetailBtnClick( card )
        if _id then
            _params.shareButton = true
            CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", _params)
        end
    end

    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(205 + _padding.left + _padding.right , 312.5))
        if _id then
            -- 背景阴影
            local bgSprite = widget.newSprite{ file = "cardgroup/filter/bg_card_shadow.png", }
            bgSprite:setScale(SCALE_FOR_SPECIAL_NODE)
            _card:addChild(bgSprite, 0)
            util.alignNodeWithPadding(bgSprite, _card:getContentSize(), display.CENTER, {top = 6,})
            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardImageEx(),
            }
            sprite:setScale(SCALE_FOR_SPECIAL_NODE)
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -13})            
            
            -- 进化阶数
            -- local evoLabel = ui.newTTFLabel{text = _params:getEvolv() .. "阶", size = 22}
            -- _card:addChild(evoLabel)
            -- util.alignNodeWithPadding(evoLabel, _card:getContentSize(), display.CENTER)

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {top = 4,left = _padding.left})

            -- cost背景
            local costBg = widget.newSprite{
                -- file = BG_CARD_COST,
                file = BG_CARD_COST[_params:getCardRaceId()],
            }
            costBg:setScale(0.5)
            _card:addChild(costBg)
            util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 33, right = 10 + _padding.left})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            frameSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card:getContentSize(), display.CENTER)

            -- 回合背景
            local wtBg = widget.newSprite{
                file = IMAGE_CARD_WAITROUND,
            }
            wtBg:setScale(CARD_SCALE_HALF)
            _card:addChild(wtBg)
            util.alignNodeWithPadding(wtBg, _card, display.BOTTOM_RIGHT , {bottom = 47, right = 3 + _padding.right})

            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            raceBg:setScale(CARD_SCALE_HALF)
            _card:addChild(raceBg)
            util.alignNodeWithPadding(raceBg, _card, display.TOP_LEFT, {top = 2 })
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 2, right = 6 + _padding.right})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.MIDDLE, 0)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -80 - _padding.left, top = 12})
            end
            -- 种族
            -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
            -- -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- -- util.alignNode(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 2})
            -- 攻击力图标
            local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            atkSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(atkSprite)
            util.alignNodeWithPadding(atkSprite, _card, display.CENTER_BOTTOM, {bottom = 24, left = 52 + _padding.left})
            -- 血量图标
            local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            hpSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(hpSprite)
            util.alignNodeWithPadding(hpSprite, _card, display.CENTER_BOTTOM, {left = -52 - _padding.left, bottom = 24})
            -- (1)加载攻击力
            local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
            labelAttack:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelAttack)
            util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.CENTER_BOTTOM, {left = 52 + _padding.left, bottom = 8})

            -- (2)加载HP
            local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
            labelHP:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelHP)
            util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.CENTER_BOTTOM, {left = -52 - _padding.left, bottom = 8})

            -- (3)加载名称
            -- local labelName = ui.newTTFLabel{
            -- local labelName = widget.newTTFLabelWithOutline{
            local labelName = widget.newTTFLabelWithShadow{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text       = tostring(_params:getCardName()),       -- 标签文字
                size       = 16,                                    -- 字体大小
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 76,})

            -- (4)加载等级
            local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE)
            labelLevel:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelLevel)
            util.alignNodeWithPadding(labelLevel, _card:getContentSize(), display.TOP_CENTER, {left = 74 + _padding.left, top = 14})

            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            _card:addChild(starLayer)
            starLayer:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 54,})

            -- (6)cost召唤值
            local cost = widget.newTTFLabelWithShadow{
            -- local cost = ui.newTTFLabel{
                text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
                size = 14,
            }
            _card:addChild(cost)
            util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 55, top = 30}  )
            util.modifyPositionInAndroid( cost, 0, -1 ) 
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 14,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 44, top = 20} )

            -- local costSprite = widget.newSprite{file = IMAGE_CARD_COST_S }
            -- -- costSprite:setScale(0.7)
            -- _card:addChild(costSprite)
            -- util.alignNodeWithPadding(costSprite, _card:getContentSize(), display.TOP_CENTER, {left = - 40, top = 26} )

            -- (7)等待上场回合
            local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.MIDDLE)
            wtLabel:setScale(CARD_SCALE_HALF )
            _card:addChild(wtLabel)
            util.alignNodeWithPadding(wtLabel, _card, display.RIGHT_BOTTOM, {bottom = 50, right = 5 + _padding.right,})

            -- (8)沙漏
            local hourglassSprite = widget.newSprite{
                file = IMAGE_CARD_HOURGLASS,
            }
            hourglassSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(hourglassSprite)
            util.alignNodeWithPadding(hourglassSprite, _card, display.RIGHT_BOTTOM, {bottom = 47, right = 12 + _padding.right,})

            -- (9)稀有标志
            if _params:getIsRare() then
                local rareSprite = widget.newSprite{
                    file = IMAGE_CARD_RARE[2],
                }
                -- rareSprite:setScale(CARD_SCALE_HALF)
                _card:addChild(rareSprite)
                util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 44, left = 3 + _padding.right,})
            end

            -- 增加选中边框
            _selectFrame = widget.newSprite{
                file        = "img_rect_frame_yellow.png",
            }
            _selectFrame:setScaleX(SCALE_FOR_SPECIAL_NODE + 0.006)
            _selectFrame:setScaleY(SCALE_FOR_SPECIAL_NODE + 0.01)
            -- _selectFrame:setScale(SCALE_FOR_SPECIAL_NODE + 0.012)
            _card:addChild(_selectFrame, -1)
            util.alignNodeWithPadding(_selectFrame, _card:getContentSize(), display.CENTER)
            _selectFrame:setVisible(false)

            local selectSignImage = "cardgroup/filter/img_card_filter_yellow_select.png"
            if _params.type == CardMaster.LOCKCARD then
                selectSignImage = "cardgroup/img_cardgroup_lock.png"
                selectViceImage = "cardgroup/img_cardgroup_lock.png"
                selectLabel = ""
                selectViceLabel = ""
            elseif _params.type == CardMaster.CONFIGMAINCARD then
                selectSignImage = "cardgroup/filter/img_card_filter_yellow_select.png"
                selectViceImage = "cardgroup/filter/img_card_filter_select.png"
                selectLabel = _s("CARD_MAIN")
                selectViceLabel = _s("CARD_VICE")
            elseif _params.type == CardMaster.CONFIGCARD then
                selectSignImage = "cardgroup/filter/img_card_filter_select.png"
                selectViceImage = "cardgroup/filter/img_card_filter_yellow_select.png"
                selectLabel = _s("CARD_VICE")
                selectViceLabel = _s("CARD_MAIN")
            else
                selectSignImage = "cardgroup/filter/img_card_filter_yellow_select.png"
                selectViceImage = "cardgroup/filter/img_card_filter_select.png"
                selectLabel = _s("COMMON_SELECTED")
                selectViceLabel = ""
            end
            -- 添加选中小勾勾
            _selectNode = display.newNode()
            local selectSign = widget.newSprite{
                file        = selectSignImage ,
            }
            _selectNode:setContentSize(selectSign:getContentSize())
            _selectNode:addChild(selectSign, 0)
            _card:addChild(_selectNode)

            local selectLabel = widget.newTTFLabelWithShadow{text = selectLabel, size = 30 }
            _selectNode:addChild(selectLabel, 1)
            util.alignNodeWithPadding(selectLabel, _selectNode:getContentSize(), display.CENTER, {top = 1,})
            util.alignNodeWithPadding(selectSign, _selectNode:getContentSize(), display.CENTER)
            util.alignNodeWithPadding(_selectNode, _card:getContentSize(), display.CENTER)
            _selectNode:setVisible(false)
            -- 添加副卡选中标识
            _selectViceNode = display.newNode()
            local selectViceSign = widget.newSprite{
                file        = selectViceImage,
            }
            _selectViceNode:setContentSize(selectViceSign:getContentSize())
            _selectViceNode:addChild(selectViceSign, 0)
            _card:addChild(_selectViceNode)

            local selectViceLabel = widget.newTTFLabelWithShadow{text = selectViceLabel, size = 30 }
            _selectViceNode:addChild(selectViceLabel, 1)
            util.alignNodeWithPadding(selectViceLabel, _selectViceNode:getContentSize(), display.CENTER, {top = 1,})
            util.alignNodeWithPadding(selectViceSign, _selectViceNode:getContentSize(), display.CENTER)
            util.alignNodeWithPadding(_selectViceNode, _card:getContentSize(), display.CENTER)
            _selectViceNode:setVisible(false)

            -- 增加详情按钮
            local detailButton = widget.newButton{
                labelParams        = {text = _s("COMMON_VIEW"), size = 20, shadow = true, padding = {top = 2}},
                normalImage        = "cardgroup/filter/btn_card_yellow_normal.png",
                selectImage        = "cardgroup/filter/btn_card_yellow_select.png",
                contentSize        = CCSize(65, 36),
                listener           = onDetailBtnClick,
            }
            detailButton:setScale(SCALE_FOR_SPECIAL_NODE)
            -- 添加到精灵中
            _card:addChild(detailButton)
            util.alignNodeWithPadding(detailButton, _card:getContentSize(), display.TOP_CENTER, {top = 50, left = -62})

            -- 卡牌状态
            if _params.showStatus then
                local statusLayer = widget.newLinearLayer{
                    direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
                    contentSize = CCSize(0, 0),
                }
                local status = false
                local function addTTFlabel_( text )
                    status = true
                    local ttfLabel = ui.newTTFLabel{text = text, size = 20}
                    statusLayer:addChild(ttfLabel, 1)
                end
                if _params:getOnwar() == TRUE then
                    addTTFlabel_(_s("CARD_STATUS_ON_WAR"))
                end
                if _params:getLocked() == TRUE then
                    addTTFlabel_(_s("CARD_STATUS_LOCKED"))
                end
                if _params:getTeamcard() == TRUE then
                    addTTFlabel_(_s("CARD_STATUS_TEAM_CARD"))
                end
                if _params:getIsover() == TRUE then
                    addTTFlabel_(_s("CARD_STATUS_EVO_OVERFLOW"))
                end

                local statusNode = widget.newLayer{contentSize = statusLayer:getContentSize(),}
                statusNode:addChild(statusLayer, 1)
                util.alignNode(statusLayer, statusNode, display.CENTER, {top = 2})
                if status then
                    local bgSprite = widget.newScale9{ file = "map/submaps/bg_title.png", contentSize = statusLayer:getContentSize(),}
                    statusNode:addChild(bgSprite, 0)
                    util.alignNode(bgSprite, statusNode)
                end
                _card:addChild(statusNode)
                util.alignNode(statusNode, _card)
            end
        end
    end
--[[ ## public fuction --]]
    function _card:setSelected( bool, anim, isVice )
        _isSelect = bool
        local node
        if not isVice then
            node = _selectNode
            if bool then
                _selectNode:setVisible(bool)
                _selectViceNode:setVisible(not bool)
            else
                _selectNode:setVisible(bool)
                _selectViceNode:setVisible(bool)
            end
        else
            node = _selectViceNode
            if bool then
                _selectViceNode:setVisible(bool)
                _selectNode:setVisible(not bool)
            else
                _selectNode:setVisible(bool)
                _selectViceNode:setVisible(bool)
            end
        end
        
        if anim and bool then
            node:setScale(1.5)
            node:setPosition(ccpAdd(ccp(util.centerNode(_card)), ccp(50, 50)))
            local action = CCSpawn:createWithTwoActions(CCScaleTo:create(0.1, 1, 1), CCMoveTo:create(0.1, ccp(util.centerNode(_card))))
            node:runAction(action)
        end
        _selectFrame:setVisible(bool)
    end
    function _card:getSelected( )
        return _isSelect
    end
--[[ ## running --]]
    init()
    return _card
end
--[[ 

绑定成小卡片, 可点击

--]]

function CardMaster.bindMiniCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _showDetail     = _params.showDetail
    local _showLv         = _params.showLv
    local _handler        = _params.handler               -- 点击事件处理
    local _disenableTouch = _params.disenableTouch        -- 点击事件关闭
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        elseif _showDetail then
            CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", _params)
        end
    end
    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(108, 108))
        -- 取值
        if _id then
            -- 背景
            -- local bgSprite = widget.newSprite{file = "cardgroup/filter/bg_card_mini_shadow.png"}
            -- bgSprite:setScale(SCALE_FOR_SPECIAL_NODE)
            -- _card:addChild(bgSprite)
            -- util.alignNode(bgSprite, _card:getContentSize(), display.CENTER)

            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardIcon(),
                ignoreAnchor = true,
            }
            -- sprite:setScale(SCALE_FOR_SPECIAL_NODE)
            -- 加入容器
            _card:addChild(sprite)
            
            -- 边框
            local frameSprite = widget.newSprite{
                file = IMAGE_CARD_MIN_FRAME[_params:getEvolv() > 1 and 2 or 1][1],
            }
            frameSprite:setScale(1.31)
            _card:addChild(frameSprite)
            -- 设置位置
            util.alignNode(frameSprite, _card)
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
               local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNode(evoBg, _card, display.LEFT_TOP, 2)
            end
            if _showLv then
                local labelLevel = widget.newTTFLabelWithShadow{
                    text = "LV:" .. _params:getLv(),
                    size = 20,
                }
                -- local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
                -- labelLevel:setScale(0.7)
                
                _card:addChild(labelLevel)
                util.alignNode(labelLevel, _card, display.RIGHT_TOP, 4)
            end
        end
        if not _disenableTouch then
            -- 绑定点击
            widget.bindTouchEvent{
                layer = _card,
                clickListener = onClick,
                container = _params.container,
            }
        end
    end
--[[ ## public fuction --]]
    function _card:showDetail( )
        CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", _params)
    end
--[[ ## running --]]
    init()
    return _card
end
--[[ 

绑定成小卡片, 有星星

--]]

function CardMaster.bindMiniStarCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _showDetail     = _params.showDetail
    local _showLv         = _params.showLv
    local _handler        = _params.handler               -- 点击事件处理
    local _disenableTouch    = _params.disenableTouch        -- 点击事件关闭
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        elseif _showDetail then
            CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", _params)
        end
    end
    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(108, 108))
        -- 取值
        if _id then
            -- 背景
            -- local bgSprite = widget.newSprite{file = "cardgroup/filter/bg_card_mini_shadow.png"}
            -- bgSprite:setScale(SCALE_FOR_SPECIAL_NODE)
            -- _card:addChild(bgSprite)
            -- util.alignNode(bgSprite, _card:getContentSize(), display.CENTER)

            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardIcon(),
                ignoreAnchor = true,
            }
            -- sprite:setScale(SCALE_FOR_SPECIAL_NODE)
            -- 加入容器
            _card:addChild(sprite)
            -- 边框
            local frameSprite = widget.newSprite{
                file = IMAGE_CARD_MIN_FRAME[_params:getEvolv() > 1 and 2 or 1][1],
            }
            frameSprite:setScale(1.31)
            _card:addChild(frameSprite)
            -- 设置位置
            util.alignNode(frameSprite, _card:getContentSize(), display.CENTER)
            -- 星星
            local starLayer = getStarLevelImage( _params:getCardStar( ), IMAGE_SIZE.MIDDLE)
            _card:addChild(starLayer)
            starLayer:setScale(0.7)
            util.alignNode(starLayer, _card, display.BOTTOM_CENTER, 10)
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
               local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNode(evoBg, _card, display.LEFT_TOP, 2)
            end

            if _showLv then
                local labelLevel = widget.newTTFLabelWithShadow{
                    text = "LV:" .. _params:getLv(),
                    size = 20,
                }
                -- local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
                -- labelLevel:setScale(0.7)

                _card:addChild(labelLevel)
                util.alignNode(labelLevel, _card, display.RIGHT_TOP, 4)
            end
            -- 设置位置
            util.alignNode(sprite, _card:getContentSize(), display.CENTER)
           
        end
        if not _disenableTouch then
            -- 绑定点击
            widget.bindTouchEvent{
                layer = _card,
                clickListener = onClick,
                container = _params.container,
            }
        end
    end
--[[ ## public fuction --]]
    function _card:showDetail( )
        CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", _params)
    end
--[[ ## running --]]
    init()
    return _card
end

--[[ 

绑定成卡牌碎片

--]]
function CardMaster.bindFragmentCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _handler        = _params.handler               -- 点击事件处理
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end

    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(205, 312.5))
        if _id then
            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardImageEx(),
                ignoreAnchor = true,
            }
            sprite:setScale(SCALE_FOR_SPECIAL_NODE )
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -13})

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {top = 4,})

            -- cost背景
            local costBg = widget.newSprite{
                -- file = BG_CARD_COST,
                file = BG_CARD_COST[_params:getCardRaceId()],
            }
            costBg:setScale(0.5)
            _card:addChild(costBg)
            util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 33, right = 10})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            frameSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card:getContentSize(), display.CENTER)


            -- 回合背景
            local wtBg = widget.newSprite{
                file = IMAGE_CARD_WAITROUND,
            }
            wtBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            _card:addChild(wtBg)
            util.alignNodeWithPadding(wtBg, _card:getContentSize(), display.BOTTOM_RIGHT , {bottom = 47, right = 3})

            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            raceBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            _card:addChild(raceBg)
            util.alignNodeWithPadding(raceBg, _card:getContentSize(), display.TOP_LEFT, {top = 2})
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 2, right = 6})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.MIDDLE, 0)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -84, top = 12})
            end
            -- 种族
            --  local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
            -- -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- -- util.alignNode(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 2})
            -- 攻击力图标
            local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            atkSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(atkSprite)
            util.alignNodeWithPadding(atkSprite, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 24, left = 52})
            -- 血量图标
            local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            hpSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(hpSprite)
            util.alignNodeWithPadding(hpSprite, _card:getContentSize(), display.CENTER_BOTTOM, {left = -52, bottom = 24})
            -- (1)加载攻击力
            local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
            labelAttack:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL )
            _card:addChild(labelAttack)
            util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.CENTER_BOTTOM, {left = 52, bottom = 8})

            -- (2)加载HP
            local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
            labelHP:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL )
            _card:addChild(labelHP)
            util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.CENTER_BOTTOM, {left = -52, bottom = 8})

            -- (3)加载名称
            -- local labelName = widget.newTTFLabelWithOutline{
            local labelName = widget.newTTFLabelWithShadow{
            -- local labelName = ui.newTTFLabel{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text       = tostring(_params:getCardName()),       -- 标签文字
                size       = 16,                                    -- 字体大小
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 76,})


            -- (4)加载等级
            local labelLevel = getNumImage(_level, IMAGE_SIZE.MIDDLE) 
            labelLevel:setScale(SCALE_FOR_SPECIAL_LABEL)
            _card:addChild(labelLevel)
            util.alignNodeWithPadding(labelLevel, _card, display.TOP_CENTER, {left = 74, top = 14})

            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            _card:addChild(starLayer)
            starLayer:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 54,})

            -- (6)cost召唤值
            local cost = widget.newTTFLabelWithShadow{
            -- local cost = ui.newTTFLabel{
                text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
                size = 14,
            }
            _card:addChild(cost)
            util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 55, top = 30} )
            
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 14,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 44, top = 20} )

            -- local costSprite = widget.newSprite{file = IMAGE_CARD_COST_S }
            -- -- costSprite:setScale(0.7)
            -- _card:addChild(costSprite)
            -- util.alignNodeWithPadding(costSprite, _card:getContentSize(), display.TOP_CENTER, {left = - 40, top = 26} )
            -- (7)等待上场回合
            local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.MIDDLE)
            wtLabel:setScale(CARD_SCALE_HALF )
            _card:addChild(wtLabel)
            util.alignNodeWithPadding(wtLabel, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 50, right = 5,})

            -- (8)沙漏
            local hourglassSprite = widget.newSprite{
                file = IMAGE_CARD_HOURGLASS,
            }
            hourglassSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(hourglassSprite)
            util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 47, right = 12})

            -- (9)稀有标志
            if _params:getIsRare() then
                local rareSprite = widget.newSprite{
                    file = IMAGE_CARD_RARE[2],
                }
                -- rareSprite:setScale(CARD_SCALE_HALF)
                _card:addChild(rareSprite)
                util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 44, left = 3})
            end
            -- 添加蒙板
            local cur = _params:getCur()
            local max = _params:getTotal()
            local fragment = FragmentView.new( tonumber(cur)/tonumber(max) , _id )
            fragment:setScale(SCALE_FOR_SPECIAL_NODE + 0.02)
            -- fragment:setScaleX(SCALE_FOR_SPECIAL_NODE + 0.012)
            -- fragment:setScaleY(SCALE_FOR_SPECIAL_NODE + 0.012)
            _card:addChild(fragment)
            -- 定位结点
            util.alignNode(fragment, _card)
        end        
        -- 绑定点击
        widget.bindTouchEvent{
                                layer = _card,
                                clickListener = onClick,
                            }
    end
--[[ ## public fuction --]]

--[[ ## running --]]
    init()
    return _card
end

--[[ 

绑定成图鉴用小图片

--]]

function CardMaster.bindAlbumCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()               -- 卡片等级
    local _handler        = _params.handler               -- 点击事件处理
    local _unlock         = false
--#必填项#

--#选填项#

--#内部参数#   
    -- local _maskSprite
--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end
    local function fillCardView( unlock )
        -- 生成精灵
        local sprite = widget.newSprite{
            file = _params:getCardImage(),
            ignoreAnchor = true,
        }
        _card:addChild(sprite)
        util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -6})

        -- cost背景
        local costBg = widget.newSprite{
            -- file = BG_CARD_COST_S,
            file = BG_CARD_COST_S[_params:getCardRaceId()],
        }
        costBg:setScale(0.7)
        _card:addChild(costBg)
        util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 24, right = 4})

        -- 边框
        local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME_S[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
        frameSprite:setScale( CARD_SCALE_HALF )
        _card:addChild(frameSprite)
        util.alignNode(frameSprite, _card)

        -- 顶部等级背景
        -- local levelBg = widget.newSprite{
        --     file = IMAGE_CARD_LEVEL,
        -- }
        -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
        -- _card:addChild(levelBg)
        -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {left = -2, top = -2})

        -- 回合背景
        local wtBg = widget.newSprite{
            file = IMAGE_CARD_WAITROUND,
        }
        wtBg:setScale(CARD_SCALE_HALF_2 * 1.4)
        _card:addChild(wtBg)
        util.alignNodeWithPadding(wtBg, _card:getContentSize(), display.BOTTOM_RIGHT , {bottom = 24, right = 1})

        -- 种族等级图标
        -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
        -- local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
        -- raceBg:setScale(CARD_SCALE_HALF_2 * 1.4)
        -- _card:addChild(raceBg)
        -- util.alignNodeWithPadding(raceBg, _card, display.TOP_LEFT)
        if _params:getEvolv() > 1 then
            -- 进阶数值背景
            local evoBg = widget.newSprite{
                file = BG_CARD_EVO_S[_params:getEvolv() - 1],
            }
            _card:addChild(evoBg)
            evoBg:setScale(0.8)
            util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 0, right = 2})
            local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.SMALL, 0)
            evoLayer:setScale(1.3)
            _card:addChild(evoLayer)
            util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -40, top = 8})
        end
        -- 种族
        -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
        -- raceSprite:setScale(CARD_SCALE_HALF)
        -- _card:addChild(raceSprite)
        -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = -2})
        -- (1)加载攻击力
        local labelAttack = getNumImage(_params:getFinalAttack(), IMAGE_SIZE.SMALL) 
        labelAttack:setScale(0.22 / SCALE_FOR_SPECIAL_LABEL)
        _card:addChild(labelAttack)
        util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.CENTER_BOTTOM, {left = 28, bottom = 0})

        -- (2)加载HP
        local labelHP = getNumImage(_params:getFinalHp(), IMAGE_SIZE.SMALL) 
        labelHP:setScale(0.22 / SCALE_FOR_SPECIAL_LABEL)
        _card:addChild(labelHP)
        util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.CENTER_BOTTOM, {left = -28, bottom = 0})

        -- (3)加载名称
        -- local labelName = widget.newTTFLabelWithOutline{
        -- local labelName = ui.newTTFLabel{
        local labelName = widget.newTTFLabelWithShadow{
            color           = display.COLOR_WHITE,
            -- outlineColor    = display.COLOR_WHITE,
            font            = FONT_1,
            -- outlineWidth    = 1.5,
            text       = tostring(_params:getCardName()),       -- 标签文字
            size       = 12,                                    -- 字体大小
        }
        labelName:setCascadeColorEnabled(true)
        _card:addChild(labelName)
        util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 36})

        -- (4)加载等级
        -- local labelLevel = LinearNum.new{
        --     resource               = "card/img_num",                     -- 资源名(不包含后缀名的前缀，如要缓存要引入num.plist和num.png，则resource为num)
        --     prefix                 = "img_num_m_",                       -- 数字及符号前缀
        --     value                  = _level,                                 -- 值
        --     margin                 = ccp(-10 * SCALE_FOR_SPECIAL_LABEL, 0),                        -- 项目间隔
        --     align                  = LinearNum.ALIGN_CENTER,             -- 项目对齐方式
        -- }
        -- labelLevel:setScale(0.125 / SCALE_FOR_SPECIAL_LABEL)
        -- _card:addChild(labelLevel)
        -- util.alignNodeWithPadding(labelLevel, _card:getContentSize(), display.TOP_LEFT , {left = 14, top = 15.5})
        -- (5)加载星级
        local starLayer = getStarLevelImage( _params:getCardStar( ))
        _card:addChild(starLayer)
        starLayer:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF_2)
        util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 27,})

        -- (6)cost召唤值
        local cost = widget.newTTFLabelWithShadow{
            text = tostring(_s("CARD_COST_ON_CARD", _params:getCardCost())),
            size = 10,
        }
        _card:addChild(cost)
        util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 26, top = 23} )
        util.modifyPositionInAndroid( cost, 0, -1 )
        -- local costLabel = widget.newTTFLabelWithShadow{
        -- -- local costLabel = ui.newTTFLabel{
        --     text = _s("CARD_COST"),
        --     size = 8,
        -- }
        -- _card:addChild(costLabel)
        -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 24, top = 7} )
    
        -- (7)等待上场回合
        local wtLabel = getNumImage(_params:getCardWaitRounds(), IMAGE_SIZE.SMALL)
        wtLabel:setScale(0.6)
        _card:addChild(wtLabel)
        util.alignNodeWithPadding(wtLabel, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 25, right = 1,})

        -- (8)沙漏
        local hourglassSprite = widget.newSprite{
            file = IMAGE_CARD_HOURGLASS,
        }
        hourglassSprite:setScale(CARD_SCALE_HALF_2 * 1.4)
        _card:addChild(hourglassSprite)
        util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {bottom = 24, right = 6,})
        -- (9)稀有标志
        if _params:getIsRare() then
            local rareSprite = widget.newSprite{
                file = IMAGE_CARD_RARE[3],
            }
            -- rareSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(rareSprite)
            util.alignNodeWithPadding(rareSprite, _card, display.LEFT_BOTTOM, {bottom = 24, left = 1})
        end
        _card:setCascadeColorEnabled(true)
        if unlock then
            _card:setColor(ccc3(255, 255, 255))
        else
            _card:setColor(ccc3(120, 120, 120))
            labelName:setColor(ccc3(120, 120, 120))
            cost:setColor(ccc3(120, 120, 120))
            wtLabel:setVisible(false)
            labelAttack:setVisible(false)
            labelHP:setVisible(false)
        end
    end
    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(105, 157.5))
        -- 绑定点击
        widget.bindTouchEvent{
            layer = _card,
            clickListener = onClick,
            container = _params.container,
        }
        -- fillCardView()
        
    end
--[[ ## public fuction --]]
    function _card:setUnlock( bool )
        _unlock = bool
        -- _maskSprite:setVisible(not bool)
        -- if bool then
            fillCardView(bool)
            -- _card:setColor(ccc3(255, 255, 255))
        -- end
    end
    function _card:isUnlock( )
        return _unlock
    end
--[[ ## running --]]
    init()
    return _card
end
--[[ 

绑定成图鉴用小图片

--]]

function CardMaster.bindMonsterCard( card )
--[[ ## local params --]]
    local _card           = card
    local _params         = _card.getParams()
    local _id             = _params:getId()
    local _level          = _params:getLv()
    local _handler        = _params.handler               -- 点击事件处理
    local _nameLabel
--#必填项#

--#选填项#

--#内部参数#   

--[[ ## local fuction --]]
    local function onClick( card )
        if _handler then
            _handler(card)
        end
    end

    local function init( )
        -- 清空容器
        _card:removeAllChildrenWithCleanup(true)
        -- 设置Size
        _card:setContentSize(CCSize(205, 312.5))
        if _id then
            -- 生成精灵
            local sprite = widget.newSprite{
                file = _params:getCardImageEx(),
                ignoreAnchor = true,
            }
            -- sprite:setScale(SCALE_FOR_SPECIAL_NODE )
            _card:addChild(sprite)
            util.alignNodeWithPadding(sprite, _card:getContentSize(), display.CENTER, {top = -12})

            -- 边框
            local frameSprite = widget.newSprite{file = IMAGE_CARD_FRAME[_params:getEvolv() > 1 and 2 or 1][_params:getCardRaceId()]}
            frameSprite:setScale(CARD_SCALE_HALF)
            _card:addChild(frameSprite)
            util.alignNode(frameSprite, _card:getContentSize(), display.CENTER)

            -- 顶部等级背景
            -- local levelBg = widget.newSprite{
            --     file = IMAGE_CARD_LEVEL,
            -- }
            -- levelBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(levelBg)
            -- util.alignNodeWithPadding(levelBg, _card:getContentSize(), display.LEFT_TOP, {top = 4,})

            -- cost背景
            -- local costBg = widget.newSprite{
            --     file = BG_CARD_COST,--[_params:getCardRaceId()],
            -- }
            -- costBg:setScale(0.8)
            -- _card:addChild(costBg)
            -- util.alignNodeWithPadding(costBg, _card:getContentSize(), display.RIGHT_TOP, {top = 22, right = 10})

            -- 回合背景
            -- local wtBg = widget.newSprite{
            --     file = IMAGE_CARD_WAITROUND,
            -- }
            -- wtBg:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(wtBg)
            -- util.alignNodeWithPadding(wtBg, _card:getContentSize(), display.BOTTOM_LEFT , {bottom = 50, left = 17})

            -- 种族等级图标
            -- local raceBg = widget.newSprite{file = BG_IMACE_CARD_RACE[_params:getEvolv()][_params:getCardRaceId()]}
            -- local raceBg = widget.newSprite{file = _params:getEvolv() > 1 and BG_IMACE_CARD_RACE[2] or BG_IMACE_CARD_RACE[1]}
            -- raceBg:setScale(CARD_SCALE_HALF)
            -- _card:addChild(raceBg)
            -- util.alignNodeWithPadding(raceBg, _card:getContentSize(), display.TOP_LEFT, {top = 2})
            if _params:getEvolv() > 1 then
                -- 进阶数值背景
                local evoBg = widget.newSprite{
                    file = BG_CARD_EVO_S[_params:getEvolv() - 1],
                }
                _card:addChild(evoBg)
                util.alignNodeWithPadding(evoBg, _card, display.RIGHT_TOP, {top = 2, right = 6})
                local evoLayer = getEvoLvImage(_params:getEvolv() - 1, IMAGE_SIZE.MIDDLE, 0)
                _card:addChild(evoLayer)
                util.alignNodeWithPadding(evoLayer, _card, display.CENTER_TOP, {left = -84, top = 12})
            end
            -- 种族
            -- local raceSprite = widget.newSprite{file = IMACE_CARD_RACE_S[_params:getCardRaceId()]}
            -- -- raceSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(raceSprite)
            -- util.alignNodeWithPadding(raceSprite, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 2})
            -- 攻击力图标
            -- local atkSprite = widget.newSprite{file = "card/img_card_atk.png"}
            -- atkSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            -- _card:addChild(atkSprite)
            -- util.alignNodeWithPadding(atkSprite, _card:getContentSize(), display.LEFT_BOTTOM, {bottom = 18})
            -- 血量图标
            -- local hpSprite = widget.newSprite{file = "card/img_card_hp.png"}
            -- hpSprite:setScale(SCALE_FOR_SPECIAL_LABEL)
            -- _card:addChild(hpSprite)
            -- util.alignNodeWithPadding(hpSprite, _card:getContentSize(), display.RIGHT_BOTTOM, {right = 58, bottom = 18})
            -- (1)加载攻击力
            -- local labelAttack = LinearNum.new{
            --     resource               = "card/img_num",                        -- 资源名(不包含后缀名的前缀，如要缓存要引入num.plist和num.png，则resource为num)
            --     prefix                 = "img_num_s_",                          -- 数字及符号前缀
            --     value                  = _params:getFinalAttack(),              -- 值
            --     margin                 = ccp(- 6 * SCALE_FOR_SPECIAL_LABEL, 0), -- 项目间隔
            --     align                  = LinearNum.ALIGN_CENTER,                -- 项目对齐方式
            -- }
            -- labelAttack:setScale(0.3/SCALE_FOR_SPECIAL_LABEL )
            -- _card:addChild(labelAttack)
            -- util.alignNodeWithPadding(labelAttack, _card:getContentSize(), display.LEFT_BOTTOM, {left = 56, bottom = 24})

            -- (2)加载HP
            -- local labelHP = LinearNum.new{
            --     resource               = "card/img_num",                        -- 资源名(不包含后缀名的前缀，如要缓存要引入num.plist和num.png，则resource为num)
            --     prefix                 = "img_num_s_",                          -- 数字及符号前缀
            --     value                  = _params:getFinalHp(),                  -- 值
            --     margin                 = ccp(- 6 * SCALE_FOR_SPECIAL_LABEL, 0), -- 项目间隔
            --     align                  = LinearNum.ALIGN_CENTER,                -- 项目对齐方式
            -- }
            -- labelHP:setScale(0.3 / SCALE_FOR_SPECIAL_LABEL )
            -- _card:addChild(labelHP)
            -- util.alignNodeWithPadding(labelHP, _card:getContentSize(), display.RIGHT_BOTTOM, {right = 32, bottom = 24})

            -- (3)加载名称
            -- local labelName = widget.newTTFLabelWithOutline{
            local labelName = widget.newTTFLabelWithShadow{
            -- local labelName = ui.newTTFLabel{
                color           = display.COLOR_WHITE,
                -- outlineColor    = display.COLOR_WHITE,
                font            = FONT_1,
                -- outlineWidth    = 1.5,
                text            = tostring(_params:getCardName()),       -- 标签文字
                size            = 16,                                    -- 字体大小
            }
            _card:addChild(labelName)
            util.alignNodeWithPadding(labelName, _card:getContentSize(), display.CENTER_BOTTOM, {bottom = 76,})
            _nameLabel = labelName
            -- (4)加载等级
            -- local labelLevel = LinearNum.new{
            --     resource               = "card/img_num",                        -- 资源名(不包含后缀名的前缀，如要缓存要引入num.plist和num.png，则resource为num)
            --     prefix                 = "img_num_m_",                          -- 数字及符号前缀
            --     value                  = _level,                                -- 值
            --     margin                 = ccp(-10 * SCALE_FOR_SPECIAL_LABEL, 0), -- 项目间隔
            --     align                  = LinearNum.ALIGN_CENTER,                -- 项目对齐方式
            -- }
            -- labelLevel:setScale(SCALE_FOR_SPECIAL_LABEL)
            -- _card:addChild(labelLevel)
            -- local padding = {left = 22, top = 24}
            -- if _params:getEvolv() == 2 then
            --     padding = {left = 26, top = 30}
            -- end
            -- util.alignNodeWithPadding(labelLevel, _card:getContentSize(), display.TOP_LEFT, padding)

            -- (5)加载星级
            local starLayer = getStarLevelImage( _params:getCardStar( ))
            _card:addChild(starLayer)
            starLayer:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            util.alignNodeWithPadding(starLayer, _card:getContentSize(), display.BOTTOM_CENTER, {bottom = 54,})
            starLayer:setCascadeOpacityEnabled(true)
            -- (6)cost召唤值
            -- local cost = widget.newTTFLabelWithShadow{
            -- -- local cost = ui.newTTFLabel{
            --     text = tostring(_params:getCardCost()),
            --     size = 14,
            -- }
            -- _card:addChild(cost)
            -- util.alignNodeWithPadding(cost, _card:getContentSize(), display.TOP_CENTER, {left = - 78, top = 24} )
            -- util.modifyPositionInAndroid( cost, 0, 2 )
            -- local costLabel = widget.newTTFLabelWithShadow{
            -- -- local costLabel = ui.newTTFLabel{
            --     text = _s("CARD_COST"),
            --     size = 14,
            -- }
            -- _card:addChild(costLabel)
            -- util.alignNodeWithPadding(costLabel, _card:getContentSize(), display.TOP_CENTER, {left = - 44, top = 20} )

            -- local costSprite = widget.newSprite{file = IMAGE_CARD_COST_S }
            -- -- costSprite:setScale(0.7)
            -- _card:addChild(costSprite)
            -- util.alignNodeWithPadding(costSprite, _card:getContentSize(), display.TOP_CENTER, {left = - 40, top = 26} )
            -- (7)等待上场回合
            -- local wtLabel = LinearNum.new{
            --     resource               = "card/img_num",                     -- 资源名(不包含后缀名的前缀，如要缓存要引入num.plist和num.png，则resource为num)
            --     prefix                 = "img_num_m_",                       -- 数字及符号前缀
            --     value                  = _params:getCardWaitRounds(),                                 -- 值
            --     margin                 = ccp(- 10 * SCALE_FOR_SPECIAL_LABEL, 0),                        -- 项目间隔
            --     align                  = LinearNum.ALIGN_CENTER,             -- 项目对齐方式
            -- }
            -- wtLabel:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF )
            -- _card:addChild(wtLabel)
            -- util.alignNodeWithPadding(wtLabel, _card:getContentSize(), display.LEFT_BOTTOM, {bottom = 63, left = 25,})

            -- (8)沙漏
            -- local hourglassSprite = widget.newSprite{
            --     file = IMAGE_CARD_HOURGLASS,
            -- }
            -- hourglassSprite:setScale(SCALE_FOR_SPECIAL_NODE * CARD_SCALE_HALF)
            -- _card:addChild(hourglassSprite)
            -- util.alignNodeWithPadding(hourglassSprite, _card:getContentSize(), display.LEFT_BOTTOM, {bottom = 50, left = 4})
        end      
        _card:setRotationY(20)
        -- _card:setRotationX(20)
        _card:setScaleX(0.8)
        _card:setCascadeOpacityEnabled(true)
        -- _card:setScaleY(0.7)
        -- 绑定点击
        widget.bindTouchEvent{
            layer = _card,
            clickListener = onClick,
        }
    end
--[[ ## public fuction --]]
    function _card:setFadeOut( args )
        if _nameLabel then
            _nameLabel:setVisible(false)
        end
        transition.fadeOut(_card, args)
    end
--[[ ## running --]]
    init()
    return _card
end
return CardMaster
