
local M = {}
M.TAG = "[cardui.FastScrollView]"
--[[ 

## FastScrollView
TODO 水平的还没有
**Parameters:**

-   params: 数组包含
            [必填项]
            CCSize                                  contentSize          尺寸
            function( fastScrollView, item, cell)   cellAtIndexListener  填充cell
            CCSize                                  cellSize             cell尺寸
            [选填项]
            function( fastScrollView, index)        onCompleteListener   完成事件
            table                                   items                cell内容
            int                                     scrollTimes          滚动次数(default: 10)
            int                                     roundTime            滚动圈时间秒(default: 0.2 m)
            enum                                    direction            方向(TODO)
                                                             widget.TABLEVIEW_DIRECTION_NONE
                                                             widget.TABLEVIEW_DIRECTION_HORIZONTAL
                                                             widget.TABLEVIEW_DIRECTION_VERTICAL (default)
                                                             widget.TABLEVIEW_DIRECTION_BOTH
--]]
function M.new(params)
    
--[=[ ## local params --]=]
    --#必填项#
    local _contentSize              = params.contentSize
    Log.a(_contentSize, M.TAG, " FastScrollView.new() invalid params.contentSize")
    local _cellAtIndexListener      = params.cellAtIndexListener
    Log.a(_cellAtIndexListener, M.TAG, " FastScrollView.new() invalid params.cellAtIndexListener")
    local _cellSize                 = params.cellSize
    Log.a(_cellSize, M.TAG, " FastScrollView.new() invalid params.cellSize")
    --#选填项#
    local _onCompleteListener       = params.onCompleteListener
    local _items                    = params.items
    local _scrollTimes              = params.scrollTimes or 10
    local _roundTime                = params.roundTime or 0.2
    --#内部参数#
    local _layer                    = widget.newLayer{contentSize = _contentSize,}-- color = ccc4(255,255,255,255)}
    local _node                     = display.newClippingRegionNode(CCRect(0, 0, _contentSize.width, _contentSize.height))
    local _linearTable = {}
    local _linearContainer = widget.newLinearLayer{direction = DIRECTION_VERTICAL}
    local _linearContentSize
    local _scrollToIndex = 0
    local _isAnim = false
    local doStartAnim, doProcessAnim, doEndAnim


--[=[ ## local fuction --]=]

    -- 开始动画(TODO 动画的减速方式需要优化...)
    function doStartAnim( )
        _isAnim = true
        local startY = _linearContainer:getPositionY()

        -- 初始位置调整
        if _linearContentSize.height > _contentSize.height and startY < - _linearContainer:getContentSize().height/2 then
            startY = startY + _linearContainer:getContentSize().height/2
            _linearContainer:setPosition(0, startY)
        end
        
        local array     = {}
        array[#array + 1] = CCMoveTo:create(0.5 - math.abs(startY/_linearContainer:getContentSize().height)*0.5, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.5, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.4, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.3, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.2, ccp(0, - _linearContainer:getContentSize().height/2))
        transition.execute(_linearContainer, transition.sequence(array), {delay = 0.5, easing = "CCEaseSineIn", onComplete = function ()
            doProcessAnim()
        end })
    end

    -- 过程动画
    function doProcessAnim(times)
        if not times then
            times = 0
        end
        
        _linearContainer:setPosition(0, 0)
        local array     = {}
        array[#array + 1] = CCMoveTo:create(_roundTime, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            if times < _scrollTimes then
                times = times + 1
                doProcessAnim(times)
            else
                doEndAnim( )
            end
            
        end )
        _linearContainer:runAction(transition.sequence(array))
    end

    -- 结束动画
    function doEndAnim( )
        _linearContainer:setPosition(0, 0)
        local array     = {}
        array[#array + 1] = CCMoveTo:create(0.2, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.3, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.4, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )
        array[#array + 1] = CCMoveTo:create(0.5, ccp(0, - _linearContainer:getContentSize().height/2))
        array[#array + 1] = CCCallFunc:create(function ()
            _linearContainer:setPosition(0, 0)
        end )

        -- 最后的位置计算
        local num = math.ceil(_contentSize.height/_cellSize.height/2)
        local offset = 0

        if _linearContentSize.height <= _contentSize.height/2 then
            -- cell集合小于一半高度的情况
            local baseNum = math.ceil(_contentSize.height/_linearContentSize.height/2)
            offset = _contentSize.height/2 - ((#_items - _scrollToIndex) * _cellSize.height + _cellSize.height/2 + baseNum * _linearContentSize.height)
        elseif _linearContentSize.height > _contentSize.height/2 and _linearContentSize.height < _contentSize.height  then
            -- cell集合大于一半高度小于高度的情况
            offset = _contentSize.height/2 - ((#_items - _scrollToIndex) * _cellSize.height + _cellSize.height/2 + _linearContentSize.height) 
        elseif _linearContentSize.height > _contentSize.height then
            local baseNum = math.ceil(_linearContentSize.height/_cellSize.height/2) 
            -- 这里的存在必要缺少验证,先跳过吧
            if _scrollToIndex < baseNum or false then
                offset = _contentSize.height/2 - (baseNum * _cellSize.height - _cellSize.height/2) - _cellSize.height * (baseNum - _scrollToIndex + iff(#_items%2 == 0, 1, 0))
            else
                offset = - _linearContentSize.height + _contentSize.height/2 - (baseNum * _cellSize.height - _cellSize.height/2) + _cellSize.height * (_scrollToIndex - baseNum - iff(#_items%2 == 0, 1, 0))
            end
        end

        array[#array + 1] = CCMoveTo:create(0.5 - offset/_linearContainer:getContentSize().height/2, ccp(0, offset))
        array[#array + 1] = CCCallFunc:create(function ()
            -- _linearContainer:setPosition(0, offset)
        end )

        transition.execute(_linearContainer, transition.sequence(array), {easing = "CCEaseSineOut", onComplete = function ()
            -- 动画结束了
            _isAnim = false
            if _onCompleteListener then
                _onCompleteListener(_layer, _scrollToIndex)
            end
        end })
    end
    
    -- 创建单倍长度
    local function createLinearCells( )
        local linearLayer = widget.newLinearLayer{direction = DIRECTION_VERTICAL}

        for i,item in ipairs(_items) do
            local cell = widget.newLayer{contentSize = _cellSize,}
            cell:ignoreAnchorPointForPosition(false)
            local view = _cellAtIndexListener( _layer, item, cell)
            linearLayer:addChild(view)
        end
        return linearLayer
    end
    -- 根据高度创建所需Cell数量
    local function createCells( )
        -- 清空
        _linearContainer = widget.newLinearLayer{direction = DIRECTION_VERTICAL}
        _linearContainer:removeAllChildrenWithCleanup(true)

        local number = 2
        _linearContentSize = CCSize( _cellSize.width, _cellSize.height * #_items) 
        if _contentSize.height > _linearContentSize.height then
            number = math.ceil(_contentSize.height / _linearContentSize.height) + 1
        end
        for i = 1, number do
            _linearTable[i] = createLinearCells( )
            _linearTable[i]._index = i
            _linearTable[i]:ignoreAnchorPointForPosition(false)
            _linearContainer:addChild(_linearTable[i])
        end
        -- 初始中间应该指向第几个
        local num = math.ceil(_contentSize.height/_cellSize.height/2) + 1 * iff(#_items%2 == 0, 1, 0)
        local offset = _contentSize.height/2 - (num * _cellSize.height - _cellSize.height/2)
        _linearContainer:setPosition(ccp(0, offset))
        _node:addChild(_linearContainer)
    end

    local function init( )
        _layer:addChild(_node)
        if _items and #_items > 0 then
            createCells( )
        end
        --使用定义的参数
        widget.initView(_layer, params)
    end
--[=[ ## public fuction --]=]
    function _layer:startScrollToItem( item )
        for i,v in ipairs(_items) do
            if item == v then
                _layer:startScrollToIndex( i )
                break
            end
        end
    end
    -- 滚到某一个, 没有就滚到最后一个
    function _layer:startScrollToIndex( index )
        if _isAnim then
            return true
        end
        if _items then
            _scrollToIndex = #_items
            if index and _scrollToIndex ~= index then
                _scrollToIndex = index
            end
            doStartAnim( )
        else
            Log.a(_cellSize, M.TAG, " Please, set items first.")
        end
    end
    function _layer:setItems( items )
        if items and #items > 0 then
            _items = items
            createCells( )
        end
    end
    init()
    return _layer
end

return M
