local M = {}

local _debug = nil

-- HELPER_INFO_00开头：基础引导
-- HELPER_INFO_01开头：卡牌强化
-- HELPER_INFO_02开头：卡牌进化
-- HELPER_INFO_03开头：好友系统
-- HELPER_INFO_04开头：星星收集
-- HELPER_INFO_05开头：天赋系统
-- HELPER_INFO_07开头：竞技场
-- HELPER_INFO_08开头：卡牌碎片
-- HELPER_INFO_11开头：地图探索
-- HELPER_INFO_12开头：装备
-- HELPER_INFO_13开头：竞技场周赛
-- HELPER_INFO_14开头：铁匠铺
-- HELPER_INFO_15开头：矿山
-- HELPER_INFO_16开头：装备进阶
-- HELPER_INFO_17开头：装备追加
-- HELPER_INFO_90开头：剧情故事(点击关卡触发式)
-- HELPER_INFO_91开头：剧情故事(关卡战斗胜利触发式)


-- local TAG_HELPERVIEW_CURINDEX = "TAG_HELPERVIEW_CURINDEX"
local COVER_COLOR = COLOR_MASK --ccc4(0, 0, 0, 0)
local COLOR_DARK = ccc3(80, 80, 80)
local INDEX_START = 10
local INDEX_END   = 1010

-- if _debug then COVER_COLOR = nil end
local _curIndex   = INDEX_START
local _enable = false --_curIndex <= 760

local INFO 	

local _helpInfos 
local _lastHelpInfo = nil
local _waitForClose = nil
local _curShowingView = nil
local SIZE_SCREEN = { width = CONFIG_SCREEN_WIDTH, height = CONFIG_SCREEN_HEIGHT }
local Z_ORDER = 99999
local TAG_HELPERVIEW = 99999

local createDialog_
local createCover_
local createHint_
local createHandText_
local createTriggerMsgLayer_
local createTriggerMsgMaskLayer_

local show_

local function init( )
	INFO = require("static.helper_info2")
	_helpInfos = INFO.infos
end

-- [网络请求]
-- 处理网络请求失败的回调函数
local function netReceiveFail_(result, cbParams)
    -- 显示[购买体力]对话框
    AlertLayer.new{
        titleStr    = _s("COMMON_NEWS_TIPS"),                       	-- 标题
        content     = _s("NETWORK_CONNECT_FAILED2"),   -- 内容
        btnStr      = { _s("COMMON_OK") },        				-- 按钮文字数组
        btnColor    = { AlertLayer.BTN_COLOR_YELLOW },
        -- 按钮颜色数组
        btnClickEvent = {                   -- 按钮事件数组
            function()                      -- 按钮[确定]回调
                -- print("出错[保存新手帮助步骤]回调")
            end,
        }, 
    }
end

-- 发起网络请求，保存新手帮助步骤
local function netSend_( update, typ )
    NetHelper.createRequest(
       ACTID.MSG_UPDATE_EVEN,              -- 请求ID
       nil,                                -- 回调函数
       {                                   -- 请求信息实体或参数Table
            tno = update, -- _curIndex,             	-- 步骤索引
            typ = typ or 3,
       },
       {
            failedCb = netReceiveFail_,       	-- 请求失败回调函数
            cbParams = { update = update },
            -- showLoading = false,
        }
    )
end

local function saveCurIndex_( update )
	-- 保存下一个将要显示的下标
	-- ISGSVALUES()[TAG_HELPERVIEW_CURINDEX] = _curIndex
	-- GS.save(ISGSVALUES())

	-- 这里还要保存到服务器中
	netSend_(update)
end 

local function closeAndShowNext_( layer, node, helpInfo )
	if layer then
		if _curShowingView and layer ~= _curShowingView then 
			_curShowingView:removeSelf(true)
		end
		layer:removeSelf(true)
	end
	_curShowingView = nil

	if helpInfo.callback then 
		helpInfo.callback(helpInfo.index)
	end

	if helpInfo.stop ~= true then
		show_(node, nil, helpInfo.callback)
	end

	if helpInfo.update then
		saveCurIndex_(helpInfo.update)
	end

	if helpInfo.enable == false then 
		_enable = false
	end
end

local function waitForClose( layer, node, helpInfo )
	_waitForClose = {
		layer = layer,
		node = node,
		helpInfo = helpInfo,
	}
	if helpInfo.callback then 
		helpInfo.callback(helpInfo.index)
	end
end


function createDialog_( node, helpInfo )
	local layer = display.newLayer()
	local isAside = (helpInfo.left or helpInfo.right or helpInfo.speaker) == nil
	-- [解析布局去]
	local sprite
	
	-- 文本区
	local bgFileName = iff(isAside, INFO.IMG_DIALOG_ASIDE_BG, INFO.IMG_DIALOG_BG)
	sprite = widget.newSprite{ 
		file = bgFileName, 
		ignoreAnchor = true,
	}
	local textNode = widget.newLayer{ 
		contentSize = sprite:getContentSize(),
		ignoreAnchor = true,
	}
	textNode:addChild(sprite)
	layer:addChild(textNode, 100)
	util.alignNode(textNode, layer:getContentSize(), display.BOTTOM_CENTER)
	-- text
	local text = helpInfo.text
	if not text then 
		text = _s(string.format("HELPER_INFO_%06d", helpInfo.index))
	end
	-- if helpInfo.left then 
	-- 	text = helpInfo.left.NAME .. ": \n" .. text
	-- elseif helpInfo.right then 
	-- 	text = helpInfo.right.NAME .. ": \n" .. text
	-- end
	if helpInfo.speaker then
		text = helpInfo.speaker.NAME .. ": \n" .. text
	end
	local label = ui.newTTFLabel{
			text = text,
			font = FONT_1,
		}
	label:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
	label:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
	textNode:addChild(label)

	-- 左边站个人
	if helpInfo.left then 
		sprite = widget.newSprite{ file = helpInfo.left.IMG }
		if not (helpInfo.speaker and helpInfo.speaker == helpInfo.left) then 
			-- 变色下
			sprite:setColor(COLOR_DARK)
		end
		if helpInfo.left_flip or helpInfo.flip then 
			sprite:setFlipX(true)
		end
		layer:addChild(sprite)
		util.alignNode(sprite, layer:getContentSize(), display.BOTTOM_LEFT)
		-- -- 文本位置小调下
		-- local textSize = CCSizeAdd(textNode:getContentSize(), - sprite:getContentSize().width - 10, -10)
		-- label:setDimensions(textSize)
		-- util.alignNode(label, textNode:getContentSize(), display.TOP_RIGHT, 5)
	end
	-- 右边来个对称下
	if helpInfo.right then 
		sprite = widget.newSprite{ file = helpInfo.right.IMG }
		if not (helpInfo.speaker and helpInfo.speaker == helpInfo.right) then 
			-- 变色下
			sprite:setColor(COLOR_DARK)
		end
		if not (helpInfo.right_flip == false or helpInfo.flip == false) then 
			sprite:setFlipX(true)
		end
		layer:addChild(sprite)
		util.alignNode(sprite, layer:getContentSize(), display.BOTTOM_RIGHT)
		-- -- 文本位置小调下
		-- local textSize = CCSizeAdd(textNode:getContentSize(), - sprite:getContentSize().width - 10, -10)
		-- label:setDimensions(textSize)
		-- util.alignNode(label, textNode:getContentSize(), display.TOP_LEFT, 5)
	end
	if helpInfo.speaker then
		-- 老师,有人说话~~~要把字给弄过来,花客
		-- 放个头像
		sprite = widget.newSprite{ file = helpInfo.speaker.HEAD }
		textNode:addChild(sprite)
		util.alignNode(sprite, textNode:getContentSize(), display.TOP_LEFT, { top = 6, left = 18})
		-- 文本位置小调下
		local textSize = CCSizeAdd(textNode:getContentSize(), - sprite:getContentSize().width - 64, -30)
		label:setDimensions(textSize)
		util.alignNodeWithPadding(label, textNode:getContentSize(), display.TOP_RIGHT, {top = 14, right = 40})
	else 
		-- cow,不说话也要弄字...
		local textSize = CCSizeAdd(textNode:getContentSize(), - 80, -30)
		label:setDimensions(textSize)
		util.alignNodeWithPadding(label, textNode:getContentSize(), display.TOP_LEFT, {top = 16, left = 48})
	end

	-- 创建指示提示
	if helpInfo.hint then
		createHand_(layer, helpInfo.hint)
	end

	-- 加个东东遮下
	if helpInfo.hint and helpInfo.hint.cover then 
		local coverLayer = widget.newHelpMaskLayer{
			rect = CCRectMake(helpInfo.hint.x, helpInfo.hint.y, helpInfo.hint.w, helpInfo.hint.h),
			color = COVER_COLOR, 
			swallowsTouches = helpInfo.swallowsTouches,
			clickListener = function ( coverLayer, rectLayer )
				waitForClose(layer, node, helpInfo)
			end
		}
		layer:addChild(coverLayer, -9999)
	elseif helpInfo.triggerMsg then
		-- 创建屏蔽层
		widget.bindTouchEvent{
			layer = layer, 
			priority = - 1000,
			swallowsTouches = true,
		}
		-- 加入中断弹出框
		createTriggerMsgLayer_(layer, node, helpInfo, helpInfo.triggerMsg)
	else
		-- [绑下事件]
		widget.bindTouchEvent{
			layer = layer, 
			priority = - 1000,
			swallowsTouches = true,
			clickInner = true,
			clickListener = function ( xlayer )
				closeAndShowNext_(layer, node, helpInfo)
			end
		}
	end
	return layer
end
function createTriggerMsgLayer_(layer, node, helpInfo, params)
	params.onConfirmClick = function( )
		closeAndShowNext_(layer, node, helpInfo)
		if params.id and params.path then
			CCBCenter.replaceLayer(params.id, params.path, params.data, function(node) 
				game.requestDateForLoad(node)
			end)
		end
	end
	params.onCancelClick = function( )
		closeAndShowNext_(layer, node, helpInfo)
		if params.msgId then
			netSend_(params.msgId, 2)
		end
	end
	CCBCenter.loadCCB(
		"MSG_TRIGGERMSGALERTLAYER_MODEL", 
		"ccb.c.main.TriggerMsgAlertLayer", 
		params,
		function ( ccbNode )
			layer:addChild(ccbNode)
			anim.topIn(ccbNode, {startPoi = ccp(220, 640), endPoi = ccp(220, 380)})
		end
	)
end
function createTriggerMsgMaskLayer_( node, helpInfo )
	local layer = widget.newLayer{color = COVER_COLOR,}
	-- 创建屏蔽层
	widget.bindTouchEvent{
		layer = layer, 
		priority = - 1000,
		swallowsTouches = true,
	}
	-- 加入中断弹出框
	createTriggerMsgLayer_(layer, node, helpInfo, helpInfo.triggerMsg)
	return layer
end
function createCover_( node, helpInfo )
	local layer = widget.newHelpMaskLayer{
		rect = CCRectMake(helpInfo.x, helpInfo.y, helpInfo.w, helpInfo.h),
		color = COVER_COLOR,
		allLayerClickable = helpInfo.allClickable,
		swallowsTouches = helpInfo.swallowsTouches,
		clickListener = function ( layer, rectLayer )
			if helpInfo.allClickable or helpInfo.swallowsTouches then
				closeAndShowNext_(layer, node, helpInfo)
			else
				waitForClose(layer, node, helpInfo)
			end
		end
	}
	if not (helpInfo.allClickable or helpInfo.swallowsTouches) then 
		_waitForClose = {
			layer = layer,
			node = node,
			helpInfo = helpInfo,
		}
	end
	-- 创建指示提示
	createHand_(layer, helpInfo)
	return layer
end

function createHint_( node, helpInfo )
	local layer = widget.newLayer()
	widget.bindTouchEvent{
		layer = layer, 
		priority = -1000,
		swallowsTouches = true,
		clickListener = function ( layer )
			closeAndShowNext_(layer, node, helpInfo)
		end
	}
	-- 创建指示提示
	createHand_(layer, helpInfo)
	return layer
end

function createHand_( layer, helpInfo )
	-- 那么,先要确定下方向
	if helpInfo.hand then 
		-- if not helpInfo.hand then 
		-- 	if helpInfo.x > SIZE_SCREEN.width / 2 then
		-- 		-- 放左边吧
		-- 	end
		-- 	if helpInfo.y + helpInfo.h > SIZE_SCREEN / 3 * 2 then
		-- 		-- 放下边吧
		-- 	end
		-- end
		-- 看看用哪张图好
		local moveDistance = helpInfo.anim_move_desdance or 10 
		local moveTime = helpInfo.anim_move_time or 0.5
		local handNode = widget.newLayer{ ignoreAnchor = false, }
		local handSprint, movePoint1, movePoint2
		local labelX, labelY
		local hasText = helpInfo.text ~= nil

		if helpInfo.hand == INFO.HAND_DIRECTION_UP then -- 236, 110
			if hasText then 
				handSprint = widget.newSprite{ file = INFO.IMG_HAND_DOWN }
				labelX, labelY = 22, 35
			else
				handSprint = widget.newSprite{ file = INFO.IMG_HAND }
				handSprint:setFlipY(true)
			end
			handNode:setAnchorPoint(ccp(0.5, 0))
			handNode:setPosition(helpInfo.x + helpInfo.w / 2, helpInfo.y + helpInfo.h)
			movePoint1 = ccp(0, moveDistance)
			movePoint2 = ccp(0, -moveDistance)
		elseif helpInfo.hand == INFO.HAND_DIRECTION_DOWN then
			if hasText then 
				handSprint = widget.newSprite{ file = INFO.IMG_HAND_DOWN }
				handSprint:setFlipY(true)
				labelX, labelY = 22, 18
			else
				handSprint = widget.newSprite{ file = INFO.IMG_HAND }
			end
			handNode:setAnchorPoint(ccp(0.5, 1))
			handNode:setPosition(helpInfo.x + helpInfo.w / 2, helpInfo.y)
			movePoint1 = ccp(0, -moveDistance)
			movePoint2 = ccp(0, moveDistance)
		elseif helpInfo.hand == INFO.HAND_DIRECTION_LEFT then
			if hasText then 
				handSprint = widget.newSprite{ file = INFO.IMG_HAND_LEFT }
				handSprint:setFlipX(true)
				labelX, labelY = 20, 25
			else
				handSprint = widget.newSprite{ file = INFO.IMG_HAND }
				handSprint:setRotation(90)
			end
			handNode:setAnchorPoint(ccp(1, 0.5))
			handNode:setPosition(helpInfo.x, helpInfo.y + helpInfo.h / 2)
			movePoint1 = ccp(-moveDistance, 0)
			movePoint2 = ccp(moveDistance, 0)
		elseif helpInfo.hand == INFO.HAND_DIRECTION_RIGHT then
			if hasText then 
				handSprint = widget.newSprite{ file = INFO.IMG_HAND_LEFT }
				labelX, labelY = 36, 24
			else
				handSprint = widget.newSprite{ file = INFO.IMG_HAND }
				handSprint:setRotation(270)
			end
			handNode:setAnchorPoint(ccp(0, 0.5))
			handNode:setPosition(helpInfo.x + helpInfo.w, helpInfo.y + helpInfo.h / 2)
			movePoint1 = ccp(moveDistance, 0)
			movePoint2 = ccp(-moveDistance, 0)
		elseif helpInfo.hand == INFO.HAND_DIRECTION_CENTER then 
			-- 放在正中吧
			handSprint = widget.newSprite{ file = INFO.IMG_HAND_CENTER }
			handNode:setContentSize(handSprint:getContentSize())
			labelX, labelY = 22, 24
			util.alignNodeWithPadding(handNode, layer:getContentSize(), display.CENTER, { top = -50 })
		end
			
		handNode:setContentSize(handSprint:getContentSize())
		handNode:addChild(handSprint)
		util.alignNode(handSprint, handNode:getContentSize(), display.CENTER)

		if hasText then 
			local textNode = widget.newLayer{
				-- color = ccc4(0,255,0,120),
				contentSize = CCSize(236, 110),
			}
			local label = ui.newTTFLabel{ 
				text = helpInfo.text, 
				size = 20,
				color = COLOR3.BLACK,
				dimensions = textNode:getContentSize(),
			}
			label:setVerticalAlignment(ui.TEXT_VALIGN_CENTER)
			label:setHorizontalAlignment(ui.TEXT_ALIGN_CENTER)
			util.alignNode(label, textNode:getContentSize(), display.CENTER)
			textNode:setPosition(labelX, labelY)
			handNode:addChild(textNode)
			textNode:addChild(label)
		end

		layer:addChild(handNode)
		if helpInfo.anim ~= false then 
			local action = CCRepeatForever:create(transition.sequence{
				CCMoveBy:create(moveTime, movePoint1),
				CCMoveBy:create(moveTime, movePoint2)
				})
			handNode:runAction(action)
		end

		return handNode
	end
	return nil
end

function show_( node, index, callback )
	local result = nil
	if not isnumber(index) then index = _curIndex end
	if not node then 
		node = display.getRunningScene()
	end
	if not INFO then init() end
	if index == _curIndex and node  then 
		if _curShowingView then 
			_curShowingView:removeSelf(true)
		end
		local helpInfo = _helpInfos[index]
		if helpInfo then
			helpInfo.callback = callback
			helpInfo.index 	  = index
			if _debug then Log.d("HelperView2", "@@@@@@@@@@@@ HelperView2 index: %d", index) end
			local function addHelper_()
				_curIndex = helpInfo.nextIndex or (math.floor((_curIndex + 10) / 10) * 10)

				if helpInfo.mode == INFO.MODE_COVER then
					-- 显示帮助层,只能点击显示定义区域
					result = createCover_( node, helpInfo )
				elseif helpInfo.mode == INFO.MODE_HINT then
					-- 显示说明文字
					result = createHint_(node, helpInfo)
				elseif helpInfo.mode == INFO.MODE_TRIGGERMSG then
					result = createTriggerMsgMaskLayer_(node, helpInfo)
				else
					-- 显示对话
					result = createDialog_(node, helpInfo)
				end
				node:addChild(result, Z_ORDER, TAG_HELPERVIEW)
				_curShowingView = result
				-- TODO:看看要不要保存到状态里...
				_lastHelpInfo = helpInfo

				local autoNext = helpInfo.autoNext
				if autoNext then 
			        util.delayCall(function()
			        	if result then 
			            	closeAndShowNext_(result, node, helpInfo)
			            end
			        end, helpInfo.autoNextTime or INFO.TIME_DEFAULT_AUTO_NEXT_TIME)
				end
			end
			
			if isnumber(helpInfo.delay) then
				util.delayCall(addHelper_, helpInfo.delay)
			else
				addHelper_()
			end
		end
	end
	return result
end
--[[ 

显示帮助层,仅在设定的index时显示

**Parameters:**

-   node :        CCNode      将要显示帮助层的Node
- 	... : 		  int,int,... 要显示的帮助层的indexs

**Returns:**

-   return 帮助层

--]]
function M.show( node, ... )
	if _enable == false then return end
	local result = nil
	local indexs = { ... }
	if #indexs > 0 then 
		for i, index in ipairs(indexs) do
			result = show_(node, index)
			if result then
				break
			end
		end
	else
		result = show_(node)
	end
	return result
end

--[[ 

显示帮助层,仅在设定的区间内时显示,并可调用回调

**Parameters:**

-   node :        CCNode      				将要显示帮助层的Node
- 	callback: 	  fun(index) 				显示前回调
- 	... : 		  {int,int},{int,int},... 	要显示的帮助层的区间集

**Returns:**

-   return 帮助层

--]]
function M.showBetween( node, callback, ... )
	if _enable == false then return end
	local result = nil
	local indexs = { ... }
	if #indexs > 0 then 
		for i, index in ipairs(indexs) do
			if index[1] <= _curIndex and _curIndex <= index[2] then 
				result = show_(node, nil, callback)
				if result then
					break
				end
			end
		end
	end
	return result
end

function M.getCurIndex()
	return _enable and _curIndex or -1
end

function M.setCurIndex( index )
	_curIndex = index
	M.setEnabled(true)
	-- if _debug then _curIndex = 0 end

	-- -- 如果index为0，表示重置新手帮助索引为开始
	-- if _curIndex == 0 then 
	-- 	_curIndex = INDEX_START
	-- end

	-- -- 如果索引超过新手帮助最大索引，则取消新手帮助
	-- if _curIndex >= INDEX_END or ME:getLv() > 5 then 
 -- 		M.setEnabled(false)
	-- end
end

function M.setEnabled( enabled )
	_enable = enabled
end

function M.isEnabled()
	return _enable
end

function M.isShowing( )
	-- return display.getRunningScene():getChildByTag(TAG_HELPERVIEW) ~= nil
	return _curShowingView ~= nil
end

function M.showNext( ... )
	if M.isEnabled() and M.isShowing() then 
		if _debug then Log.d("HelperView2", "@@@@@@@@@@@@@@@@@@@@@ HelperView2.showNext()") end
		-- if nextIndex and nextIndex ~= M.getCurIndex() then return end
		local nexts = { ... }
		if nexts and #nexts > 0 then 
			local cur = M.getCurIndex()
			local exists = false
			for _, nextIndex in ipairs(nexts) do
				if nextIndex == cur then 
					exists = true
					break
				end
			end
			if not exists then return end 
		end 
		if _waitForClose and _waitForClose.layer then 
			closeAndShowNext_( _waitForClose.layer, _waitForClose.node, _waitForClose.helpInfo )
			_waitForClose = nil
		end
	end
end

function M.isNextIndex( index )
	return M.isEnabled() and index == M.getCurIndex()
end

function M.isNextIndexIn( startIndex, endIndex )
	if M.isEnabled() then 
		local cur = M.getCurIndex()
		return startIndex <= cur and cur <= endIndex
	end
	return false
end

function M.playStory( node, mapIndex, submapIndex, callback )
	-- if not _debug then return false end
	-- if _debug then print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	playStory\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@") end
	local result = false
	if node and isnumber(mapIndex) and isnumber(submapIndex) and isfunction(callback)
		and 1 <= mapIndex and mapIndex <= 12
		and 1 <= submapIndex and submapIndex <= 15 then
		-- 计算下应该是什么下标吧
		local startIndex = tonumber(string.format("90%d%d%d", (mapIndex - 1),(submapIndex - 1),10))
		if not INFO then init() end
		if INFO.infos[startIndex] then 
			local endIndex = tonumber(string.format("90%d%d%d",(mapIndex - 1),(submapIndex  - 1),99))
			-- 打到对应下标后开始播放~~~播放完成后就要callback回去了
			M.setCurIndex(startIndex)
			local function callback_( index )
				if M.getCurIndex() > endIndex or not INFO.infos[M.getCurIndex()] then 
					-- 结束了
					callback(mapIndex, submapIndex)
				end
			end
			M.showBetween(node, callback_, { startIndex, endIndex }) 
			-- if _debug then print("@@ 显示每个关卡首次点击的引导", mapIndex, submapIndex, startIndex, endIndex) end
			result = true
		else
			-- if _debug then print("@@ 你确定有引导要显示?", mapIndex, submapIndex, startIndex) end
		end 
	end
	-- if _debug then print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@") end
	return result
end

function M.playStoryEnd( node, mapIndex, callback )
	-- if not _debug then return false end
	-- if _debug then print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	playStoryEnd\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@") end
	local result = false
	if node and isnumber(mapIndex) and 1 <= mapIndex and mapIndex <= 12 then 
		local startIndex = tonumber(string.format("91%d%d%d", (mapIndex - 1),9,10))

		if not INFO then init() end
		if INFO.infos[startIndex] then 
			local endIndex = tonumber(string.format("91%d%d%d", (mapIndex - 1),9,99))
			-- 打到对应下标后开始播放~~~播放完成后就要callback回去了
			M.setCurIndex(startIndex)
			local function callback_( index )
				if M.getCurIndex() > endIndex or not INFO.infos[M.getCurIndex()] then 
					-- 结束了
					callback(mapIndex)
				end
			end
			M.showBetween(node, callback_, { startIndex, endIndex })
			-- if _debug then print("@@ 显示每个大关首次结束后的引导", mapIndex, startIndex, endIndex) end
			result = true 
		else
			-- if _debug then print("@@ 你确定有引导要显示?", mapIndex, startIndex) end
		end
	end
	-- if _debug then print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@") end
	return result
end

function M.skipTo( index, update )
	M.setCurIndex( index )
	if update then 
		netSend_( update )
	end
end

return M