--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

关卡点类，定义关卡点相关操作方法及逻辑实现。

-   提供关卡点的公共方法。
-   示例：
    local sprite = require("cardui.LinearStar").new({ fileName = "map/popup/lp_icon_star.png", count = 4, unitScale = 1, })
    _node:addChild(sprite)
    sprite:setPosition(ccp(300, 300))
]]

local M = {}



-- [包含文件]
-- ...




-- [公共参数]
-- 常量
-- ..

-- 枚举
-- ..

-- 操作变量
-- ..










-- [构造方法]
function M.new(params)
    -- [验证参数合法性]
    -- 验证参数集
    TDAssertUtils.assertParameters(params)

    -- [参数赋值]
    local po            = params.po                         -- PO对象
    local isLocked      = po:getIslocked()                  -- 关卡是否解锁


    -- 定义实体
    local sprite
    -- 渲染实体
    if po then 
        -- 构建实体
        sprite = display.newSprite(PHI_MAP .. "map_p_p.png")

        -- 构建锁
        local nodeLock = display.newSprite(PHI_MAP .. "map_l_lock.png")
        sprite:addChild(nodeLock)
        util.alignNode(nodeLock, sprite:getContentSize(), display.CENTER)

        -- 加载渲染以外其他操作
        if isLocked then 
            nodeLock:setVisible(false)
        end
    end

    return sprite
end





return M