
local Player = require("cardui.Player")
local PlayerHead = class("PlayerHead", Player)

PlayerHead.HEAD_RECT = CCRect(0, 0, 150, 150)

function PlayerHead:ctor( sex, head, equipment, params )
	PlayerHead.super.ctor(self, sex, head, equipment, params)
end

function PlayerHead:dress_( sex, equipment )
	local function doDress_( partId, ... )
		self:dressPart(partId, equipment[partId], ...)
	end
	-- 头部
	doDress_(Player.PARTS.HEAD)
end

function PlayerHead:defaultAction()
	
end

function PlayerHead:createCircle()
    rect = rect or PlayerHead.HEAD_RECT
	local layer = widget.newLayer{
		-- color = ccc4(120,120,120,120),
		contentSize = CCSize(150, 150), 
		ignoreAnchor = false
	}
	local clipper = ClippingNodeManager:createNodeRound(75, ccp(0, 0))
    clipper:addChild(self)
    self:setPosition(0, -35)
    layer:addChild(clipper)
    util.alignNode(clipper, layer)
    return layer
end

function PlayerHead:createRect(clickListener)
	local rect = PlayerHead.HEAD_RECT
	local layer = widget.newLayer{
		-- color = ccc4(120,120,120,120),
		contentSize = rect.size, 
		ignoreAnchor = false
	}
    local function createClippingNode_( rect )
        local container = widget.newNode{contentSize = rect.size}
        local scrollView = widget.newScrollView{
            bounceable = false, 
            contentSize = rect.size, 
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            contentLayer = container
        }
        -- scrollView.addChild_ = scrollView.addChild_ or scrollView.addChild
        -- function scrollView:addChild( child )
        --     -- try(
        --         -- function ( )
        --             scrollView:getContentView():addChild(child)
        --         -- end
        --     -- )
        -- end
        return scrollView
    end
	
    local function removeBone_( play )
        local role = play.role
        local bonesTable = {
            "role_shadow",
            "role_arm_r",
            "role_hand_r",
            "parts_shoulder_r",
            "parts_glove_r",
            "parts_weapon",
            "role_foot_r",
            "role_leg_r",
            "parts_trousers_r",
            "parts_shoes_r",
            "role_foot_l",
            "role_leg_l",
            "parts_trousers_l",
            "parts_shoes_l",
            "parts_body",
            "parts_belt",
            "parts_clothes",
            "parts_book",
            "role_arm_l",
            "role_hand_l",
            "parts_shoulder_l",
            "parts_glove_l",
            "parts_shield",
        }
        for i, v in ipairs(bonesTable) do
            local bone = role:getBone(v)
            if bone then
                role:removeBone(bone, true)
            end
        end
        return play
    end
    local clipper = createClippingNode_(rect)--display.newClippingRegionNode(rect)
    -- clipper:addChild(removeBone_(self))
    clipper:getContentView():addChild(removeBone_(self))
    self:setPosition(75, 35)
    layer:addChild(clipper)
    util.alignNode(clipper, layer)
    if isfunction(clickListener) then 
    	widget.bindTouchEvent{
            layer = layer,
            clickListener = clickListener,
        }
    end
    layer.getRole = function ( layer )
    	return self
    end
    return layer
end

return PlayerHead