local ScrollTalkPanel = {}
ScrollTalkPanel.TAG = "[cardui.ScrollTalkPanel]"

--[[ 

## 首页显示聊天界面

**Parameters:**

-   params: 数组包含

            [必填项]
            CCSize      contentSize            尺寸

            [选填项]
            table       labelParams            字体属性
            function    onComplete             缓存中都播放完成事件
            
--]]
function ScrollTalkPanel.new( params )


	--#必填项#  
	local _contentSize              = params.contentSize
	local _playTime             = params.playTime or 10
	--#选填项#
 	local _labelParams          = params.labelParams or {}
	--#内部参数#
	local _clipNode             = display.newClippingRegionNode(CCRect(0, 0, _contentSize.width, _contentSize.height))
	local oldmsgcount = 0      --旧行数
 	local _selectOffset        --底行位置
    local _offsetY = -25       --单行高度
 	local _gridTable           --table实体
	local ChatUtil = require("ccb.m.chat.ChatUtil")

	--创建cell
    local function createCell( grid,index,item )
        local cell = widget.newLayer()
        cell:setContentSize(grid:getCellSize())
        cell:ignoreAnchorPointForPosition(false)
        -- x坐标
        local curX = 0
        local c_item = item.cellItem
        local ctype = item.ctype
        -- local key = 1
        local color = COLOR3.WHITE
        local color4 = ccc4(255,255,255,200) 
        if ctype and ctype == ChatUtil.ChatSystem then 
        
            color = COLOR3.YELLOW 
            color4 = ccc4(255,242,0,200)
        end
               
        -- 循环添加表格元素
        for i=1,#c_item do
            local content = c_item[i]
            if content and content.title then

                content.title = ChatUtil.filterFlag( content.title )
                
                if content.flag == 1 then 
                    local ly = widget.newLayer{
                                         x = curX,
                                         y = 0
                                }
                    local cttf = widget.newTTFLabelWithShadow{
                            text = content.title, 
                            shadow = true,
                            size = 20, 
                            color = color, 
                            offset = 1
                        }
                    ly:setContentSize(cttf:getContentSize())
                    ly:addChild(cttf, 1)
                    cell:addChild(ly, 1)
                    curX = curX + cttf:getContentSize().width

                    local rtext = content.text

                    local cardEntity
                    -- 去除"[]"
                    if rtext and string.find(rtext,"%[") and string.find(rtext,"%]") then 
                        rtext = string.gsub(rtext,"%[","")
                        rtext = string.gsub(rtext,"%]","")
                        cardEntity = CardDB.getByName(rtext)
                    end



                    if content.uid and content.uid ~= ME:getUserid()  then
                        cttf:setColor(COLOR3.GREEN)
                        -- local cly = widget.newLayer{
                        --     color = color4,
                        --     contentSize = CCSize( cttf:getContentSize().width - 20 * SCALE_FOR_SPECIAL_LABEL,  0.5),
                        --     x = 2 * SCALE_FOR_SPECIAL_LABEL,
                        --     y = 6 * SCALE_FOR_SPECIAL_LABEL
                        -- }
                        -- ly:addChild(cly, 1)
                    end

                    if cardEntity then 
                        cttf:setColor(COLOR3.ORANGE)
                        -- local cly = widget.newLayer{
                        --     color = color4,
                        --     contentSize = CCSize( cttf:getContentSize().width - 20 * SCALE_FOR_SPECIAL_LABEL,  0.5),
                        --     x = 8 * SCALE_FOR_SPECIAL_LABEL,
                        --     y = 6  * SCALE_FOR_SPECIAL_LABEL
                        -- }
                        -- ly:addChild(cly, 1)
                    end

                    widget.bindTouchEvent{
                        layer = ly,
                        -- onTouchBegan = function (x,y )
                        --     print("~~~~x ",x)
                        -- end
                        clickListener = function ( layer )
                            if canuserchick and content.uid and content.uid ~= ME:getUserid() then
                                canuserchick = false
                                Log.d(TAG,"~~~~~~~~~~~~~~~~",content.uid) 
                                NetHelper.showLoading(true,true)
                                --   创建http请求
                                NetHelper.createRequest(
                                    
                                   ACTID.MSG_GET_PLAYERDETAIL,                   --      请求id
                                   function ( properties, params )
                                        _node.toggleSendMsgEnable( )
                                        canuserchick = true
                                        NetHelper.hideLoading(true)
                                       local entityFriend = require("ccb.m.friend.EntityFriend")
                                       local user = entityFriend.new(properties)
                                   CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = user, key = MSG_ID.MSG_CHATLAYER_MODEL, fnNextView = function() CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH) end })
                                       
                                       -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", user)
                                   end,                   --        回调函数
                                   {pid = content.uid},                    --      请求信息实体或参数table
                                   {failedCb = function (  )
                                       canuserchick = true
                                       NetHelper.hideLoading(true)
                                   end}
                                )
                                
                            else
                                if cardEntity then
                                    _node.toggleSendMsgEnable( )
                                    cardEntity._KEY = MSG_ID.MSG_CHATLAYER_MODEL
                                    CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", cardEntity)
                                    Log.d(TAG,"have card ",content.text)
                                else 
                                    Log.d(TAG,"no card~~~~~~~~~~~~~~~~",content.text)
                                end
                            end
                            
                        end
                    }
                else
                     -- print("22222222222222222222222222222222222222222222222"..content.title)
                    local cttf = widget.newTTFLabelWithShadow{
                                                text = content.title, 
                                                shadow = true,
                                                size = 20, 
                                                color = color, 
                                                offset = 1,
                                                x = curX,
                                                y = 0
                                            }
                    cell:addChild(cttf, 1)
                    curX = curX + cttf:getContentSize().width
                  
                end

            end 
        end
        
        return cell
    end

	--创建table
    local function createTable()

        local function createItemCellListener( grid,index,item )
             
            local cell = createCell(grid,index,item)
            return cell
        end
        local function modifyItemCellListener( grid,index,item,itemCell )
            Log.d(TAG,"modifyItemCellListener")
        end
        local function tapListener( grid,index,item )
            -- Log.d(TAG,"YOU CLICKED %d", index)
           
        end

        local scrollGrid = widget.newScrollGrid{

            contentSize = _clipNode:getContentSize(),
            contentParams = {
                cellSize = CCSize( _clipNode:getContentSize().width, 25),
                padding = { 
                    middleH = 0, middleV = 0,
                    left = 0, right = 0, top = 4, bottom = -4,
                },
                column = 1,
                createItemCellListener = createItemCellListener,
                modifyItemCellListener = modifyItemCellListener,
                tapListener = tapListener,
                selectedParams = nil,

            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _clipNode,
        }
        util.enableCustomTouch(scrollGrid,false)
        return scrollGrid
    end

    --重置table数据
	function  _clipNode.setNewMessage( params )
    	local realMessages = {}
    	local chat_messages = params.messages
    	
        -- 过滤消息类型
        for i=1,#chat_messages do
          
            realMessages[#realMessages + 1] = chat_messages[i]      
        end

        if realMessages then
            -- 当前位置缓存
            if not (_gridTable and _gridTable.getContentOffset) then
                return
            end
            -- 限制realMessages长度2条
            local limitMessages
            if #realMessages > 2 then
                limitMessages = {realMessages[#realMessages - 1], realMessages[#realMessages]}
            else
                limitMessages = realMessages
            end
            realMessages = limitMessages
            -- FIXME: 
            try(function() 
                _selectOffset = _gridTable:getContentOffset()
                -- 刷新table
                _gridTable:setItems(realMessages) 
            end)
        end

         -- 超过一页滚动到最下面
        if #realMessages > 2 then
            -- FIXME: 
            try(function() 
                -- 小于一行的位移自动移动
                if _selectOffset.y > _offsetY then
                    _gridTable:setContentOffset(_gridTable:maxContainerOffset())
                    _selectOffset = _gridTable:getContentOffset()
                else
                    -- 新消息数
                    local newMsg = #realMessages - oldmsgcount
                    -- 设置到缓存位置
                    _gridTable:setContentOffset(ccpAdd(_selectOffset, ccp(0, (_offsetY * newMsg))))
                end
            end)
        end

        oldmsgcount = #realMessages
    end

	local function init( ... )
		--背景
		local bgSprite = widget.newScale9{file = "hook_ac.png",}
        bgSprite:setContentSize(_clipNode:getContentSize())
        _clipNode:addChild(bgSprite, 0)
        util.alignNode(bgSprite, _clipNode:getContentSize(), display.CENTER)
    	
    	_gridTable = createTable() --数据table     
	end

	init()
	
	return _clipNode
end

return ScrollTalkPanel