--ActivityChargeListLayer.lua

MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL 				= 22600

MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ONBTNBUYDIAMONDCLICK = MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST = MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL + 11
MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYREWARD = MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL + 12
MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHSACRIFICE = MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL + 13
MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHJOIN = MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL + 14

local TAG = "[ActivityChargeListLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- CCBCenter.popLastLevelCCBNode()
end

local function jumpToShop( )
    CCBCenter.replaceLayer("MSG_SHOPNEWLAYER_MODEL", "ccb.c.shop.ShopNewLayer", {fromMain = false, }, function (node)
                node:performWithDelay(function ( ... )
                    game.requestDateForLoad( node )
                end, 0.01)
                node.onExit = function ( self )
                    util.removeUnusedTextures()
                end
            end, CCBCenter.ANIM_LAYER_RIGHT_TO_LEFT)
end
local function jumpToBuyDiamond( )
    _sdkPlatform.storeView()
end
local function jumpToDungeon( )
    CCBCenter.replaceLayer(MAP_MESSAGE_ID, MAP_LAYER_ID, {fromMain = false, }, function (node)
                node:performWithDelay(function ( ... )
                    game.requestDateForLoad( node )
                end, 0.01)
                node.onExit = function ( self )
                    util.removeUnusedTextures()
                end
            end, CCBCenter.ANIM_LAYER_RIGHT_TO_LEFT)
end
local function jumpToDailyExpense( )
   
end
_nodeTable.INTERFACE = {
    [ACTIVITY_ATYPE.LIMIT_TIME_CHARGE] = {LIST = "fetchLimitCharge", REWARD = "fetchLimitChargeReward", JUMPTO = jumpToBuyDiamond},
    [ACTIVITY_ATYPE.LIMIT_TIME_COST] = {LIST = "fetchLimitCost", REWARD = "fetchLimitCostReward", JUMPTO = jumpToShop},
    [ACTIVITY_ATYPE.LIMIT_TIME_LOGIN] = {LIST = "fetchConLogin", REWARD = "fetchConLoginReward", JUMPTO = jumpToBuyDiamond},
    [ACTIVITY_ATYPE.SINGLE_CHARGE] = {LIST = "fetchSingleCharge", REWARD = "fetchSingleChargeReward", JUMPTO = jumpToBuyDiamond},
    [ACTIVITY_ATYPE.ONE_DAY_CHARGE] = {LIST = "fetchOneDayCharge", REWARD = "fetchOneDayChargeReward", JUMPTO = jumpToBuyDiamond},
    [ACTIVITY_ATYPE.ONE_DAY_COST] = {LIST = "fetchOneDayCost", REWARD = "fetchOneDayCostReward", JUMPTO = jumpToShop},
    [ACTIVITY_ATYPE.WORSHIP] = {LIST = "fetchWaeship", REWARD = "fetchSacrificeReward", JUMPTO = jumpToDungeon}, 
    [ACTIVITY_ATYPE.KILL_BUG] = {LIST = "fetchKillBug", REWARD = "fetchKillBugReward", JUMPTO = jumpToDungeon},
    [ACTIVITY_ATYPE.Daily_Expense] = {LIST = "fetchDailyExpense", REWARD = "fetchDailyExpenseReward", JUMPTO = jumpToShop},
    [ACTIVITY_ATYPE.DAILY_DIAMOND] = {LIST = "fetchDailyDiamond", REWARD = "fetchDailyDiamondReward", JUMPTO = jumpToDailyDiamond},
}
local function onBtnBuyDiamondClick( msg, luaValue )
	--22600 + 10
	Log.d(TAG, "btnBuyDiamond: MSG_ID = %d", MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ONBTNBUYDIAMONDCLICK)
	-- _sdkPlatform.storeView()
    -- print('_nodeTable.INTERFACE[_nodeTable._ATYPE]', _nodeTable.INTERFACE[_nodeTable._ATYPE].LIST)
    _nodeTable.INTERFACE[_nodeTable._ATYPE].JUMPTO()
end

local function onActionFetchActivityList( msg, luaValue )
	-- 1700 + 11
	Log.d(TAG, "onActionFetchActivityList: MSG_ID = %d", msg:getMsgId())
	NetHelper.showLoading(true,true)

	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		_nodeTable._DATA = items
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
	    "model.activity.ActivityModel",
	    _nodeTable.INTERFACE[_nodeTable._ATYPE].LIST,
	    onFetchCallback
    )
    -- onFetchCallback{}
end
local function onActionFetchJoin( msg, luaValue )
	local function onFetchCallback( items )

		CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
    end
    ModelHelper.requireDataWithFun(
	    "model.activity.ActivityModel",
	    "fetchDailyDiamondJoin",
	    onFetchCallback,
	    msg.userdata
    )
end
local function onActionFetchActivityReward( msg, luaValue )
	-- 1700 + 12
	Log.d(TAG, "onActionFetchActivityReward: MSG_ID = %d", msg:getMsgId())
	NetHelper.showLoading(true,true)
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		local rewardEntity = require("model.main.RewardEntity").new(items.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
    end
    ModelHelper.requireDataWithFun(
	    "model.activity.ActivityModel",
	    _nodeTable.INTERFACE[_nodeTable._ATYPE].REWARD,
	    onFetchCallback,
	    msg.userdata
    )
end
local function onActionFetchSacrifice( msg, luaValue )
	-- 1700 + 13
	Log.d(TAG, "onActionFetchSacrifice: MSG_ID = %d", msg:getMsgId())
	NetHelper.showLoading(true,true)
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		local rewardEntity = require("model.main.RewardEntity").new(items.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
    end
    ModelHelper.requireDataWithFun(
	    "model.activity.ActivityModel",
	    "fetchSacrifice",
	    onFetchCallback,
	    msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--22600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityChargeListLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_nodeTable._ATYPE = data.atype
	-- Quick element
	_nodeTable["mTTFLabel1"] = _ccbNode:getTTFLabel("mTTFLabel1")
	_nodeTable["mTTFLabel2"] = _ccbNode:getTTFLabel("mTTFLabel2")
	_nodeTable["mTTFLabel3"] = _ccbNode:getTTFLabel("mTTFLabel3")
	
	-- CCControlButton
	_nodeTable["btnBuyDiamond"] = _ccbNode:bindButton("btnBuyDiamond", onBtnBuyDiamondClick, _s("ACTIVITY_BUY_DIAMOND"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.activity.ActivityChargeListLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ONBTNBUYDIAMONDCLICK]	= onBtnBuyDiamondClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST]	= onActionFetchActivityList
MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYREWARD]	= onActionFetchActivityReward
MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHSACRIFICE]	= onActionFetchSacrifice
MSG_HANDLER[MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHJOIN]	= onActionFetchJoin