--ActivityMonthCardLayer.lua

MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL 				= 22800

MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ONMBUYMONTHCARDCLICK = MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD = MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL + 11
MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARDREWARD = MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL + 12

local TAG = "[ActivityMonthCardLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
    -- 清空msgid
    MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD] = nil
    MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD = nil
    package.loaded["ccb.c.activity.ActivityMonthCardLayer"] = nil
end


local function onMBuyMonthCardClick( msg, luaValue )
	--22800 + 10
	Log.d(TAG, "mBuyMonthCard: MSG_ID = %d", MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ONMBUYMONTHCARDCLICK)
	_sdkPlatform.storeView()
	-- CCBCenter.loadCCB("MSG_SHOPBUYDIAMONDLAYER_MODEL", "ccb.c.shop.ShopBuyDiamondLayer", {})
end

local function onActionFetchMonthCard( msg, luaValue )
	-- 1000 + 11
	Log.d(TAG, "onActionFetchMonthCard: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.activity.ActivityModel",
        "fetchMonthCard",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchMonthCardReward( msg, luaValue )
	-- 1000 + 12
	Log.d(TAG, "onActionFetchMonthCardReward: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD)
    end
    ModelHelper.requireDataWithFun(
        "model.activity.ActivityModel",
        "fetchMonthCardReward",
        onFetchCallback,
        msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--22800
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityMonthCardLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mMonthCardTitleLabel"] = _ccbNode:getTTFLabel("mMonthCardTitleLabel", _s("ACTIVITY_MONTH_CARD"))
	_nodeTable["mDetailLabel"] = _ccbNode:getTTFLabel("mDetailLabel")
	_nodeTable["mDaysLeftLabel"] = _ccbNode:getTTFLabel("mDaysLeftLabel")
	_nodeTable["mPriceLabel"] = _ccbNode:getTTFLabel("mPriceLabel")
	_nodeTable["mRewardTipLabel"] = _ccbNode:getTTFLabel("mRewardTipLabel", _s("ACTIVITY_MONTH_CARD_REWARD_TIP"))

	-- CCControlButton
	_ccbNode:bindButton("mBuyMonthCard", onMBuyMonthCardClick, _s("ACTIVITY_MONTH_CARD_BUY"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.activity.ActivityMonthCardLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD)
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ONMBUYMONTHCARDCLICK]	= onMBuyMonthCardClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD]	= onActionFetchMonthCard
MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARDREWARD]	= onActionFetchMonthCardReward