MSG_ID.MSG_ARENALAYER_MODEL 				= 8000

MSG_ID.MSG_ARENALAYER_ONBTNRANKCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 10
MSG_ID.MSG_ARENALAYER_ONBTNRECORDCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 11
MSG_ID.MSG_ARENALAYER_ONBTNRULECLICK = MSG_ID.MSG_ARENALAYER_MODEL + 12

MSG_ID.MSG_ARENALAYER_ONBTNBUYCDCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 13
MSG_ID.MSG_ARENALAYER_ONBTNBUYCOUNTCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 14

MSG_ID.MSG_ARENALAYER_ONBTNBACKCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 15

MSG_ID.MSG_ARENALAYER_ONBTNFIGHTCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 16
MSG_ID.MSG_ARENALAYER_ONBTNPLAYRECORDCLICK = MSG_ID.MSG_ARENALAYER_MODEL + 17
MSG_ID.MSG_ARENALAYER_ONGETRECORDLIST = MSG_ID.MSG_ARENALAYER_MODEL + 18
MSG_ID.MSG_ARENALAYER_ONRELOADARENAINFO = MSG_ID.MSG_ARENALAYER_MODEL + 19


local TAG = "[ArenaLayer]"
local _ccbNode 
local _nodeTable = {}
local EntityArena = require("ccb.m.arena.EntityArena")
local EntityRecords = require("ccb.m.arena.EntityRecords")
local buyArenaCd
local buyArenaCount
local canClick = true

--********************* 打架 ***********************

--[[

-   回调函数 2002

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_arenaFight( properties, params )
	-- body
end

-- 竞技战斗 2002
local function arenaFight( oid, oname )
	-- [排名战]
	-- 参数赋值
	local FightViewFactory 			= require(PH_MDL_FACTORY .. "FightViewFactory") 		-- 战斗视图工厂
	local friendId                  = oid  						-- 好友ID
	local friendName                = oname 					-- 好友名称

	-- 场景转换
	FightViewFactory.viewPkRankWar({ friendId = friendId, friendName = friendName, })
end

local function onBtnFightClick( msg, luaValue )

	if not _ccbNode.isCdok() then 
		-- 购买冷却时间
		NetHelper.QuickToast(_s("ARENA_DAY_HINT_COLD_TIME"))
	  -- AlertLayer.new4IAP{
	  --   content = "冷却时间未到，请耐心等待，或者您也可以花费10钻石重置冷却时间",  
	  --   btnClickEvent = {buyArenaCd}
	  -- }
		return
	end

	if not _ccbNode.isCountOk() then 
		-- 购买挑战次数 5002
		NetHelper.QuickToast(_s("ARENA_DAY_HINT_TIMES_OVER"))
	  -- AlertLayer.new4IAP{
	  --   content = "今日挑战次数已经用完，您可以花费20钻石增加一次挑战机会",  
	  --   btnClickEvent = {buyArenaCount}
	  -- }
		return
	end

	SOUND:playEffectButton1()

	local oid = msg.userdata.id 
	local oname = msg.userdata.name

	-- print("oid ",oid)
	arenaFight( tonumber( oid ), tostring(oname) )
end
--********************* 打架 ***********************









--********************* 播放录像 ***********************
--[[

-   回调函数 5007

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--   result:      number   操作结果
--]]
function callback_playRecord( properties, params, result )
	-- body
end

-- 播放战斗录像 5007
local function playRecord( recordId )
	-- [查看记录]
	-- 参数赋值
	local FightViewFactory 			= require(PH_MDL_FACTORY .. "FightViewFactory") 		-- 战斗视图工厂
	local recordId                  = recordId													-- 记录ID

	-- 场景转换
	FightViewFactory.viewRecordRankWar({ recordId = recordId, })
end

local function onBtnPlayRecordClick( msg, luaValue )

	SOUND:playEffectButton1()

	local recordId = msg.userdata

	-- print("recordId ",recordId)
	playRecord( tonumber( recordId ) )
end

--********************* 播放录像 ***********************









--********************* 获得排行 ***********************
--[[

-   回调函数 5001 错误

--   result:  number    结果
--]]
local function callback_ranklist_failed( result )
	Log.d(TAG,"~出错了 %d",result)
	_ccbNode.reloadArenaList( {} )

	NetHelper.hideLoading(true)
	canClick = true
end
--[[

-   回调函数 5001

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_ranklist( properties, params )

	try(function (  )
		_ccbNode.changeBtnStatus(_ccbNode.sel_rank)
		local entity = EntityArena.new(properties)
		_ccbNode.reloadArenaList( entity:getPlayers() )
		_ccbNode.reloadArenaCount( entity:getCount() )
		_ccbNode.reloadArenaCd( entity:getCd() )
		_ccbNode.reloadArenaTop10List( entity:getTop10players() )
		_ccbNode.reloadArenaMyRank( entity:getMyrank() )
		_ccbNode.reloadArenaJjcState( entity:getJjcState() )
		
	end,nil,nil)
	canClick = true
	NetHelper.hideLoading(true)
end

-- 初始化竞技场信息 5001
local function getArenaInfo( kind )

	NetHelper.showLoading(true,true)
	Log.d(TAG,"getArenaInfo kind:%d",kind)
	--   创建http请求
	NetHelper.createRequest(
	   ACTID.MSG_GET_RANKLIST ,    --       请求id
	   callback_ranklist,    --    	  回调函数
	   {kind = kind},      --       请求信息实体或参数table
	   {failedCb = callback_ranklist_failed
		}
	)
end

-- 初始化竞技场信息 5001 view调用
local function reloadArenaInfo( msg, luaValue )
	-- local kind = msg.userdata

	getArenaInfo(_ccbNode.MYORDER)
end 

local function onBtnRankClick( msg, luaValue )
	if not canClick then return end 
	canClick = false
	-- local kind = msg.userdata
	SOUND:playEffectButton1()
	getArenaInfo(_ccbNode.MYORDER)
end
--********************* 获得排行 ***********************







--********************* 获得录像 ***********************
--[[

-   回调函数 5006 错误

--   result:  number    结果
--]]
function callback_recordlist_failed( result )
	_ccbNode.reloadRecordList( {} )

	NetHelper.hideLoading(true)

	canClick = true
end
--[[

-   回调函数 5006

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--   result:      number   操作结果
--]]
local function callback_getRecordList( properties, params, result )
	
	try(function ( )
		_ccbNode.changeBtnStatus(_ccbNode.sel_record)
		local entity = EntityRecords.new(properties)
		_ccbNode.reloadRecordList(entity:getRecords())
		_ccbNode.reloadArenaTop10List( entity:getTop10players() )
		
	end,nil,nil)
	canClick = true
	NetHelper.hideLoading(true)
end



-- 获取战斗记录列表 5006
local function getRecordList()

	NetHelper.showLoading(true,true)
	
	--   创建http请求
	NetHelper.createRequest(
	
	   ACTID.MSG_GET_RECORDLIST ,    --       请求id
	   callback_getRecordList,    --    	  回调函数
	   {},      --       请求信息实体或参数table
	   {failedCb = callback_recordlist_failed
		}
	)
end

local function onBtnRecordClick( msg, luaValue )
	if not canClick then return end 
	canClick = false
	SOUND:playEffectButton1()
	getRecordList()
end
--********************* 获得录像 ***********************










--********************* 规则 ***********************
local function onBtnRuleClick( msg, luaValue )
	SOUND:playEffectButton1()
	HelperView2.showNext()
	_ccbNode.changeBtnStatus(_ccbNode.sel_rule)
end
--********************* 规则 ***********************







--********************* 购买冷却时间 ***********************
local function callback_buycd_failed( )
	canClick = true
end
--[[

-   回调函数 5003

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_arenaCd( properties, params )
	_ccbNode.reloadArenaCd( 0 ) -- 重置为0
	NetHelper.hideLoading(true)
	canClick = true
end

-- 购买冷却时间 5003
function buyArenaCd()
	if not canClick then return end 
	canClick = false
	NetHelper.showLoading(true,true)
	--   创建http请求
	NetHelper.createRequest(
	   ACTID.MSG_BUY_RANKCD,     --       请求id
	   callback_arenaCd,
	   {},      --       请求信息实体或参数table
	   {failedCb = callback_buycd_failed
		}
	)
end

local function onBtnBuyCdClick( msg, luaValue )
	SOUND:playEffectButton1()
	-- 购买冷却时间
	  AlertLayer.new4IAP{
	    isUserDiamond = true,
	    diamondIndex = 12,
	    content = _s("ARENA_BUY_FIGHT_CD"),  
	    btnClickEvent = {buyArenaCd}
	  }
end
--********************* 购买冷却时间 ***********************







--********************* 购买挑战次数 ***********************
local function callback_buycount_failed(  )
	canClick = true
end
--[[

-   回调函数 5002

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_arenaCount( properties, params )
	_ccbNode.reloadArenaCount( properties.count )
	NetHelper.hideLoading(true)
	canClick = true
end

-- 购买挑战次数 5002
function buyArenaCount()
	if not canClick then return end 
	canClick = false
	NetHelper.showLoading(true,true)
	--   创建http请求
	NetHelper.createRequest(
	   ACTID.MSG_BUY_RANKCOUNT,     --       请求id
	   callback_arenaCount,
   	   {},      --       请求信息实体或参数table
	   {failedCb = callback_buycount_failed
		}
	)
end

local function onBtnBuyCountClick( msg, luaValue )
	SOUND:playEffectButton1()
	-- 购买挑战次数 5002
	  AlertLayer.new4IAP{
	  	isUserDiamond = true,
	  	diamondIndex = 13,
	    content = _s("ARENA_BUY_FIGHT_COUNT"),  
	    btnClickEvent = {buyArenaCount}
	  }
end
--********************* 购买挑战次数 ***********************






--********************* 关闭 ***********************
local function closeLayer()
	local TDAnimationUtils = require(PH_MDL_UTIL .. "TDAnimationUtils")
    local array     = {}
    array[#array + 1] = CCMoveTo:create(0.2,ccp(0,-1*_ccbNode:getContentSize().height))
    array[#array + 1] = CCCallFunc:create(
              function (  )
              	CCBCenter.popSecondCCBNode()
              	-- CCBCenter.popFirstCCBNode()
              end
            )
    _ccbNode:runAction(TDAnimationUtils.sequence(array))
end

local function onBtnBackClick( msg, luaValue )
	closeLayer()
end
--********************* 关闭 ***********************


-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--8000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARENALAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArenaLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._DATA = data
	-- Quick element
	_nodeTable["rankno1"] = _ccbNode:getNode("rankno1", "CCNode")

	_nodeTable["btnRank"] = _ccbNode:getNode("btnRank", "CCControlButton")
	_nodeTable["btnRecord"] = _ccbNode:getNode("btnRecord", "CCControlButton")
	_nodeTable["btnRule"] = _ccbNode:getNode("btnRule", "CCControlButton")
	
	_nodeTable["ttfRank"] = _ccbNode:getNode("ttfRank", "CCLabelTTF")
	_nodeTable["ttfRecord"] = _ccbNode:getNode("ttfRecord", "CCLabelTTF")
	_nodeTable["ttfRule"] = _ccbNode:getNode("ttfRule", "CCLabelTTF")
	
	_nodeTable["btnBuyCd"] = _ccbNode:getNode("btnBuyCd", "CCControlButton")
	_nodeTable["btnBuyCount"] = _ccbNode:getNode("btnBuyCount", "CCControlButton")
	
	_nodeTable["tablenode"] = _ccbNode:getNode("tablenode", "CCNode")
	_nodeTable["cdtime"] = _ccbNode:getNode("cdtime", "CCSprite")

	_nodeTable["btnBack"] = _ccbNode:getNode("btnBack", "CCControlButton")

	_nodeTable["mTopHeroesLabel"] = _ccbNode:getNode("mTopHeroesLabel", "CCLabelTTF")
	_nodeTable["mCdTimeLabel"] = _ccbNode:getNode("mCdTimeLabel", "CCLabelTTF")

	_nodeTable["mMyRankNode"] = _ccbNode:getNode("mMyRankNode", "CCNode")
	_nodeTable["mCurCountNode"] = _ccbNode:getNode("mCurCountNode", "CCNode")

	-- CCControlButton
	_ccbNode:bindButton("btnRank", onBtnRankClick)
	_ccbNode:bindButton("btnRecord", onBtnRecordClick)
	_ccbNode:bindButton("btnRule", onBtnRuleClick)

	_ccbNode:bindButton("btnBuyCd", onBtnBuyCdClick)
	_ccbNode:bindButton("btnBuyCount", onBtnBuyCountClick)

	_ccbNode:bindButton("btnBack", onBtnBackClick, _s("COMMON_BACK"))

	-- MenuItem
	-- _proxy:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	--util.modifyPositionInAndroid( _nodeTable.mCurRankLabel, 0, 4 ) 	-- 当前排名名次

	-- 填充文字
	_nodeTable["mTopHeroesLabel"]:setString(_s("ARENA_TOP_HEROES"))
	_nodeTable["ttfRank"]:setString(_s("ARENA_RANK"))
	_nodeTable["ttfRecord"]:setString(_s("ARENA_RECORD"))
	_nodeTable["ttfRule"]:setString(_s("ARENA_RULE"))
	_nodeTable["mCdTimeLabel"]:setString(_s("ARENA_CD_TIME"))

	CCBCenter.bindView("ccb.v.arena.ArenaLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushSecondCCBNode(_ccbNode)
	end

	local flag = false 
	if  data then 
		flag = data.flag
		_ccbNode:setPositionY(0)
		if flag then
			getRecordList()
		else
			getArenaInfo( _ccbNode.MYORDER )	
		end
	else
		anim.bottomIn(_ccbNode, { onComplete =  function ( )
				getArenaInfo( _ccbNode.MYORDER )
			end})		
	end
end


MSG_HANDLER[MSG_ID.MSG_ARENALAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNRANKCLICK]	= onBtnRankClick
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNRECORDCLICK]	= onBtnRecordClick
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNRULECLICK]	= onBtnRuleClick

MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNBUYCDCLICK]	= onBtnBuyCdClick
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNBUYCOUNTCLICK]	= onBtnBuyCountClick

MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNBACKCLICK] = onBtnBackClick

MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNFIGHTCLICK] = onBtnFightClick
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONBTNPLAYRECORDCLICK] = onBtnPlayRecordClick
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONGETRECORDLIST] = getRecordList
MSG_HANDLER[MSG_ID.MSG_ARENALAYER_ONRELOADARENAINFO] = reloadArenaInfo
