--ArenaSelectLayer.lua

MSG_ID.MSG_ARENASELECTLAYER_MODEL 				= 8200

MSG_ID.MSG_ARENASELECTLAYER_ONBTNRANKINGCLICK = MSG_ID.MSG_ARENASELECTLAYER_MODEL + 10
MSG_ID.MSG_ARENASELECTLAYER_ONBTNWEEKCLICK = MSG_ID.MSG_ARENASELECTLAYER_MODEL + 11
MSG_ID.MSG_ARENASELECTLAYER_SHOWRANKINGCLICK = MSG_ID.MSG_ARENASELECTLAYER_MODEL + 12

local TAG = "[ArenaSelectLayer]"
local _ccbNode 
local _nodeTable = {}

local SHOWRANKING_RANK = 1
local SHOWRANKING_RECORD = 2
local SHOWRANKING_WEEK_RANK = 3
local SHOWRANKING_WEEK_RECORD = 4

local function closeLayer()
	-- CCBCenter.popFirstCCBNode()
	game.enterMainLayer()
end

local function showRankingLayer(flag)
    CCBCenter.loadCCB("MSG_ARENALAYER_MODEL", "ccb.c.arena.ArenaLayer",{flag = flag})
end

local function showWeekRankingLayer( showRecord )
    CCBCenter.loadCCB("MSG_ARENAWEEKLAYER_MODEL", "ccb.c.arena.ArenaWeekLayer",{showRecord = showRecord})
end

local function onBtnRankingClick( msg, luaValue )
	--8200 + 10
	Log.d(TAG, "btnRanking: MSG_ID = %d", MSG_ID.MSG_ARENASELECTLAYER_ONBTNRANKINGCLICK)
	SOUND:playEffectButton1()
	HelperView2.showNext()
    ----跳转到竞技场
    CCBCenter.loadCCB("MSG_ARENALAYER_MODEL", "ccb.c.arena.ArenaLayer")
end

local function onBtnWeekClick( msg, luaValue )
	--8200 + 11
	Log.d(TAG, "btnWeek: MSG_ID = %d", MSG_ID.MSG_ARENASELECTLAYER_ONBTNWEEKCLICK)
	SOUND:playEffectButton1()
	-- NetHelper.QuickToast("周赛竞技场即将开放！敬请期待！")
	if isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE) or isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE_EN) then
		if GAMERATE:getArenaWeekUnlock() == FALSE then
			NetHelper.QuickToast(_s("ARENA_WEEK_UNOPEN"))
			return
		end
	end
	if not ME:getTriggerMsgEntity():isUnlockArenaWeek() then
		NetHelper.QuickToast(_s("COMMON_UNOPEN", require("static.unlock_level").ARENAWEEK , _s("ARENA_WEEK_GAME")))
        return
	end
	----跳转到竞技周场
    CCBCenter.loadCCB("MSG_ARENAWEEKLAYER_MODEL", "ccb.c.arena.ArenaWeekLayer")
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--8200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARENASELECTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArenaSelectLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_ARENASELECTLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mRankGameLabel"] = _ccbNode:getNode("mRankGameLabel", "CCLabelTTF")
	_nodeTable["mWeekGameLabel"] = _ccbNode:getNode("mWeekGameLabel", "CCLabelTTF")
	
	-- CCControlButton
	_ccbNode:bindButton("btnRanking", onBtnRankingClick)
	_ccbNode:bindButton("btnWeek", onBtnWeekClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mRankGameLabel, 0, 3 ) 	-- 排名赛
	util.modifyPositionInAndroid( _nodeTable.mWeekGameLabel, 0, 3 ) 	-- 周季争霸赛

	-- 填充文字
	_nodeTable["mRankGameLabel"]:setString(_s("ARENA_RANK_GAME"))
	_nodeTable["mWeekGameLabel"]:setString(_s("ARENA_WEEK_GAME"))

	CCBCenter.bindView("ccb.v.arena.ArenaSelectLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end

	local flag 
	if  data and data.flag then 
		flag = tonumber(data.flag)
	end
	-- 显示排名赛界面
	if flag == SHOWRANKING_RANK then 
		-- 排名列表
		showRankingLayer(false)
	elseif flag == SHOWRANKING_RECORD  then 
		-- 录像列表
		showRankingLayer(true)
	elseif flag == SHOWRANKING_WEEK_RANK then
		showWeekRankingLayer(false)
	elseif flag == SHOWRANKING_WEEK_RECORD then
		showWeekRankingLayer(true)
	end
	SOUND:playMusicArena(true)
end


MSG_HANDLER[MSG_ID.MSG_ARENASELECTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARENASELECTLAYER_ONBTNRANKINGCLICK]	= onBtnRankingClick
MSG_HANDLER[MSG_ID.MSG_ARENASELECTLAYER_ONBTNWEEKCLICK]	= onBtnWeekClick

MSG_HANDLER[MSG_ID.MSG_ARENASELECTLAYER_SHOWRANKINGCLICK]	= showRankingLayer
