--ArenaWeekAlertLayer.lua

MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL 				= 8400

MSG_ID.MSG_ARENAWEEKALERTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL + 10
MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRECORDLIST = MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL + 11
MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHCHARGEACTIVITY = MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL + 12

local TAG = "[ArenaWeekAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--8400 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKALERTLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onActionFetchWeekRecordList( msg, luaValue )
	-- 8300 + 11
	Log.d(TAG, "onActionFetchWeekRecordList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.showRecord(items)
    end
    ModelHelper.requireDataWithFun(
        "model.arena.ArenaModel",
        "fetchWeekRecordList",
        onFetchCallback
    )
end

local function onActionFetchChargeActivity( msg, luaValue )
	-- 8300 + 11
	Log.d(TAG, "onActionFetchChargeActivity: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.showChargeActivity(items)
    end
    ModelHelper.requireDataWithFun(
	    "model.activity.ActivityModel",
	    "fetchChargeActivity",
	    onFetchCallback
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--8400
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArenaWeekAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	_ccbNode._DATA = data
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.arena.ArenaWeekAlertLayerView", _ccbNode, _nodeTable)
	_ccbNode._TEXT = data.text
	if data.isRule then
		-- 规则
		_ccbNode.showRuleLabel() 
	elseif data.isRankRule then
		-- 排名规则
		_ccbNode.showRankRuleLabel() 
	elseif data.isEvoRule then
		-- 排名规则
		_ccbNode.showEvoRuleLabel() 
	elseif data.isExploreRule then
		-- 排名规则
		_ccbNode.showExploreRuleLabel() 
	elseif data.isCardFragmentRule then
		-- 卡牌碎片
		_ccbNode.showCardFragmentRuleLabel() 
	elseif data.isMakeHopeRule then
		-- 许愿池
		_ccbNode.showMakeHopeRuleLabel() 
	elseif data.isMiningRule then
		-- 挖矿
		_ccbNode.showMiningRuleLabel() 
	elseif data.isEquipmentLvRule then
		-- 装备强化
		_ccbNode.showEquipmentLvRuleLabel() 
	elseif data.isEquipmentEvoRule then
		-- 装备进阶
		_ccbNode.showEquipmentEvoRuleLabel()
	elseif data.isEquipmentAddRule then
		-- 装备追加
		_ccbNode.showEquipmentAddRuleLabel()
	elseif data.isEquipmentDismantleRule then
		-- 装备拆解
		_ccbNode.showEquipmentDismantleRuleLabel()
	elseif data.isBossRule then
		-- boss战
		_ccbNode.showBossRuleLabel()
	elseif data.isTeamRule then
		-- 战队首页
		_ccbNode.showTeamRuleLabel()
	elseif data.isTeamRewardRule then
		-- 战队首页奖励
		_ccbNode.showTeamRewardRuleLabel()
	elseif data.isTeamSameServerRule then
		-- 战队区赛
		_ccbNode.showTeamSameServerRuleLabel()
	elseif data.isTeamInterServerRule then
		-- 战队跨服战
		_ccbNode.showTeamInterServerRuleLabel()
	elseif data.isTeamSameServerRewardRule then
		-- 战队区赛奖励
		_ccbNode.showTeamSameServerRewardRuleLabel()
	elseif data.isTeamInterServerRewardRule then
		-- 战队跨服赛奖励
		_ccbNode.showTeamInterServerRewardRuleLabel()
	elseif data.isTowerRule then
		-- 幽灵魔塔规则
		_ccbNode.showTowerRuleLabel()
	elseif data.isArmyBoss then
		-- 军团boss规则
		_ccbNode.showArmyBossLabel()
	elseif data.isArmyMain then
		-- 军团规则
		_ccbNode.showArmyRuleLabel()
	end
	
	CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( )
		if data.isRecord then
			-- 战报
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRECORDLIST)
		elseif data.isChargeActivity then
			-- 充值活动
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHCHARGEACTIVITY)
		end
	end})
	
end


MSG_HANDLER[MSG_ID.MSG_ARENAWEEKALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARENAWEEKALERTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRECORDLIST]	= onActionFetchWeekRecordList
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHCHARGEACTIVITY]	= onActionFetchChargeActivity
