--ArenaWeekLayer.lua

MSG_ID.MSG_ARENAWEEKLAYER_MODEL 				= 8300

MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECEIVECLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 10
MSG_ID.MSG_ARENAWEEKLAYER_ONBTNFIGHTCLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 11
MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECORDCLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 12
MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRULECLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 13
MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBACKCLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 14
MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBUYCDCLICK = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 15
MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 16
MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKREWARD = MSG_ID.MSG_ARENAWEEKLAYER_MODEL + 17

local TAG = "[ArenaWeekLayer]"
local _ccbNode 
local _nodeTable = {}
local canClick = true
local buyArenaCd
local function closeLayer()
    anim.bottomOut(_ccbNode, { onComplete = function ( )
    	CCBCenter.popSecondCCBNode()
    end})
end


local function onBtnReceiveClick( msg, luaValue )
	--8300 + 10
	Log.d(TAG, "btnReceive: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECEIVECLICK)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKREWARD)
end

local function onBtnFightClick( msg, luaValue )
	--8300 + 11
	Log.d(TAG, "btnFight: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNFIGHTCLICK)
	-- _nodeTable.mBtnFight:setEnabled(false)
	-- _ccbNode.startScrollToIndex()
	_ccbNode.doFightClick()
end

local function onBtnRecordClick( msg, luaValue )
	--8300 + 12
	Log.d(TAG, "btnRecord: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECORDCLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isRecord = true,})
end

local function onBtnRuleClick( msg, luaValue )
	--8300 + 13
	Log.d(TAG, "btnRule: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRULECLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isRule = true,})
end

local function onBtnBackClick( msg, luaValue )
	--8300 + 14
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBACKCLICK)
	closeLayer()
end

--********************* 购买冷却时间 ***********************
local function callback_buycd_failed( )
	canClick = true
end
--[[

-   回调函数 5003

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_arenaCd( properties, params )
	-- _ccbNode.reloadArenaCd( 0 ) -- 重置为0
	_ccbNode.reloadCdTimer()
	NetHelper.hideLoading(true)
	canClick = true
end

-- 购买冷却时间 5003
function buyArenaCd()
	if not canClick then return end 
	canClick = false
	NetHelper.showLoading(true,true)
	--   创建http请求
	NetHelper.createRequest(
	   ACTID.MSG_WEEK_BUY_RANKCD,     --       请求id
	   callback_arenaCd,
	   {},      --       请求信息实体或参数table
	   {failedCb = callback_buycd_failed
		}
	)
end

local function onBtnBuyCdClick( msg, luaValue )
	--8300 + 15
	Log.d(TAG, "btnBuyCd: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBUYCDCLICK)
	SOUND:playEffectButton1()
	-- 购买冷却时间
	  AlertLayer.new4IAP{
	  	isUserDiamond = true,
	  	diamondIndex = 14,
	    content = _s("ARENA_BUY_FIGHT_CD"),  
	    btnClickEvent = {buyArenaCd}
	  }
end
--********************* 购买冷却时间 ***********************

local function onActionFetchWeekRankList( msg, luaValue )
	-- 8300 + 16
	Log.d(TAG, "onActionFetchWeekRankList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
            "model.arena.ArenaModel",
            "fetchWeekRankList",
            onFetchCallback
            )
end

local function onActionFetchWeekReward( msg, luaValue )
	-- 8300 + 16
	Log.d(TAG, "onActionFetchWeekReward: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST)
                end
            }
        )
    end
    ModelHelper.requireDataWithFun(
            "model.arena.ArenaModel",
            "fetchWeekReward",
            onFetchCallback
            )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--8300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARENAWEEKLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArenaWeekLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_NONE
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mLastRankLabel"] = _ccbNode:getNode("mLastRankLabel", "CCLabelTTF")
	_nodeTable["mSeasonLabel"] = _ccbNode:getNode("mSeasonLabel", "CCLabelTTF")
	_nodeTable["mScroeLabel"] = _ccbNode:getNode("mScroeLabel", "CCLabelTTF")
	_nodeTable["mRankLabel"] = _ccbNode:getNode("mRankLabel", "CCLabelTTF")
	_nodeTable["mNextTimeTitleLabel"] = _ccbNode:getNode("mNextTimeTitleLabel", "CCLabelTTF")
	_nodeTable["mBtnFight"] = _ccbNode:getNode("btnFight", "CCControlButton")
	_nodeTable["mBtnReceive"] = _ccbNode:getNode("btnReceive", "CCControlButton")
	_nodeTable["btnBack"] = _ccbNode:getNode("btnBack", "CCControlButton")
	_nodeTable["btnBuyCd"] = _ccbNode:getNode("btnBuyCd", "CCControlButton")
	_nodeTable["mTopScoresLabel"] = _ccbNode:getNode("mTopScoresLabel", "CCLabelTTF")
	_nodeTable["mCdTimeTitleLabel"] = _ccbNode:getNode("mCdTimeTitleLabel", "CCLabelTTF")
	_nodeTable["mLastSeasonRankLabel"] = _ccbNode:getNode("mLastSeasonRankLabel", "CCLabelTTF")
	_nodeTable["mChooseFightLabel"] = _ccbNode:getNode("mChooseFightLabel", "CCLabelTTF")


	-- CCControlButton
	_ccbNode:bindButton("btnReceive", onBtnReceiveClick, _s("ARENA_RECEIVE_REWARD"))
	_ccbNode:bindButton("btnFight", onBtnFightClick, _s("ARENA_DARE"))
	_ccbNode:bindButton("btnRecord", onBtnRecordClick, _s("ARENA_RECORD"))
	_ccbNode:bindButton("btnRule", onBtnRuleClick, _s("ARENA_RULE"))
	_ccbNode:bindButton("btnBack", onBtnBackClick, _s("COMMON_BACK"))
	_ccbNode:bindButton("btnBuyCd", onBtnBuyCdClick)


	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android位置微调
	util.modifyPositionInAndroid( _nodeTable.mScroeLabel, 0, 1 )
	util.modifyPositionInAndroid( _nodeTable.mRankLabel, 0, 1 )
	util.modifyPositionInAndroid( _nodeTable.mSeasonLabel, 0, 1 )
	util.modifyPositionInAndroid( _nodeTable.mTopScoresLabel, 0, 2 ) 	-- 积分榜
	util.modifyPositionInAndroid( _nodeTable.mChooseFightLabel, 0, 4 ) 	-- 选择挑战对手

	-- 填充文字
	_nodeTable["mTopScoresLabel"]:setString(_s("ARENA_TOP_SCORES"))
	_nodeTable["mCdTimeTitleLabel"]:setString(_s("ARENA_CD_TIME"))
	_nodeTable["mLastSeasonRankLabel"]:setString(_s("ARENA_LAST_SEASON_RANK"))
	_nodeTable["mChooseFightLabel"]:setString(_s("ARENA_CHOOSE_FIGHT"))

	CCBCenter.bindView("ccb.v.arena.ArenaWeekLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushSecondCCBNode(_ccbNode)
	end

	-- 录像返回,直接弹出
	if data then
		if data.showRecord then
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST)
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECORDCLICK)
		else
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST)
		end
	else
		-- 不是录像返回,调用动画
		anim.bottomIn(_ccbNode, { onComplete = function ( )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST)
		end})
	end
end


MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECEIVECLICK]	= onBtnReceiveClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNFIGHTCLICK]	= onBtnFightClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRECORDCLICK]	= onBtnRecordClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNRULECLICK]	= onBtnRuleClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ONBTNBUYCDCLICK]	= onBtnBuyCdClick
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST]	= onActionFetchWeekRankList
MSG_HANDLER[MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKREWARD]	= onActionFetchWeekReward