--ArmyAlertLayer.lua

MSG_ID.MSG_ARMYALERTLAYER_MODEL 				= 31200

MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_1CLICK = MSG_ID.MSG_ARMYALERTLAYER_MODEL + 10
MSG_ID.MSG_ARMYALERTLAYER_ONBTNCANCELCLICK = MSG_ID.MSG_ARMYALERTLAYER_MODEL + 11
MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_2CLICK = MSG_ID.MSG_ARMYALERTLAYER_MODEL + 12
MSG_ID.MSG_ARMYALERTLAYER_ONFETCHCREATEARMY =  MSG_ID.MSG_ARMYALERTLAYER_MODEL + 13
MSG_ID.MSG_ARMYALERTLAYER_ONFETCHNOTICE =  MSG_ID.MSG_ARMYALERTLAYER_MODEL + 14
MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYLVUP = MSG_ID.MSG_ARMYALERTLAYER_MODEL + 15
MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYSHOPLVUP = MSG_ID.MSG_ARMYALERTLAYER_MODEL + 16

local TAG = "[ArmyAlertLayer]"
local _ccbNode 
local _nodeTable = {}
local _callback

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCommit_1Click( msg, luaValue )
	--31200 + 10
	Log.d(TAG, "btnCommit_1: MSG_ID = %d", MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_1CLICK)
	if _ccbNode._DATA.isCreate then
		if _ccbNode.isCompliance() then
			AlertLayer.new4IAP{
				isUserDiamond = true,
				diamondIndex = 21,
				content = _s("USE_DIAMOND_21",_ccbNode._DATA.createDiamond,_ccbNode.getArmyName()),
				btnClickEvent = {
				function ( )
					_nodeTable["btnCommit_1"]:setEnabled(false)
					CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYALERTLAYER_ONFETCHCREATEARMY)
				end,
				}
			}
		end
	elseif _ccbNode._DATA.isNotice then
		if _ccbNode.isNoticeCompliance() then
			_nodeTable["btnCommit_1"]:setEnabled(false)
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYALERTLAYER_ONFETCHNOTICE)
		end
	elseif _ccbNode._DATA.isQuit then
		if isfunction(_callback) then
			_callback()
		end
		closeLayer()
	elseif _ccbNode._DATA.isArmyLvUp then
		if _ccbNode._DATA.apoint >=  _ccbNode._DATA.nextApoint then
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYLVUP)
		else
			NetHelper.QuickToast(_s("ARMY_LV_UP_FAIL"),true,1)
		end
	elseif _ccbNode._DATA.isArmyShopLvUp then
		if _ccbNode._DATA.apoint >=  _ccbNode._DATA.nextApoint then
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYSHOPLVUP)
		else
			NetHelper.QuickToast(_s("ARMY_LV_UP_FAIL"),true,1)
		end
	end
end

local function onBtnCancelClick( msg, luaValue )
	--31200 + 11
	Log.d(TAG, "btnCancel: MSG_ID = %d", MSG_ID.MSG_ARMYALERTLAYER_ONBTNCANCELCLICK)
	closeLayer()
	if _ccbNode._DATA.isArmyLvUp then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
	elseif _ccbNode._DATA.isArmyShopLvUp then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHSHOPLIST)
	end
end

local function onBtnCommit_2Click( msg, luaValue )
	--31200 + 12
	Log.d(TAG, "btnCommit_2: MSG_ID = %d", MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_2CLICK)
	closeLayer()
	if _ccbNode._DATA.isApply then
		if isfunction(_callback) then
			_callback()
		end
	end
	
end

local function onFetchCreateArmy( ... )
	local function onFetchCallback( properties )
		NetHelper.QuickToast(_s("ARMY_CREATE_SUCCESS"),true,1)
    	util.delayCall(
            function ( )
            	CCBCenter.loadCCB("MSG_ARMYMAINLAYER_MODEL", "ccb.c.army.ArmyMainLayer",{fnNextView = function ( )
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
                    CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                end})
            end, 1
        )	
	end
	local function failedCb( ... )
		_nodeTable["btnCommit_1"]:setEnabled(true)
	end

	
	NetHelper.createRequest(
        ACTID.MSG_CREATE_ARMY,
        onFetchCallback,
		{ aname =  _ccbNode.getArmyName()},
		{failedCb = failedCb}
    )
end

local function onFetchNotice( ... )
	local function onFetchCallback( properties )
		NetHelper.QuickToast(_s("ARMY_NOTICE_SUCCESS"),true,1)
    	util.delayCall(
            function ( )
            	closeLayer()
            	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
            end, 1
        )	
	end
	local function failedCb( ... )
		_nodeTable["btnCommit_1"]:setEnabled(true)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_WRITE_ARMYDE,
        onFetchCallback,
		{ content =  _ccbNode.getArmyName()},
		{ failedCb = failedCb}
    )
end

local function onFetchArmyLvUp( ... )
	local function onFetchCallback( properties )
		_ccbNode.runProgressbar(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_UP_ARMY,
        onFetchCallback,
		{ },
		{}
    )
end

local function onFetchArmyShopLvUp( ... )
	local function onFetchCallback( properties )
		_ccbNode.runProgressbar(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_UP_ARMYSHOP,
        onFetchCallback,
		{ },
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._DATA	= data
	_callback = data.callback
	-- Quick element
	_nodeTable["btnCommit_1"] = _ccbNode:getNode("btnCommit_1", "CCControlButton")
	_nodeTable["btnCancel"] = _ccbNode:getNode("btnCancel", "CCControlButton")
	_nodeTable["btnCommit_2"] = _ccbNode:getNode("btnCommit_2", "CCControlButton")
	_nodeTable["mCreateTitleLabel"] = _ccbNode:getNode("mCreateTitleLabel", "CCLabelTTF")
	_nodeTable["mApplyContentLabel"] = _ccbNode:getNode("mApplyContentLabel", "CCLabelTTF")
	_nodeTable["mNoticeTitleLabel"] = _ccbNode:getNode("mNoticeTitleLabel", "CCLabelTTF")
	_nodeTable["mAlertTitleLabel"] = _ccbNode:getNode("mAlertTitleLabel", "CCLabelTTF")
	_nodeTable["btnCommit_1"] = _ccbNode:getNode("btnCommit_1", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnCommit_1", onBtnCommit_1Click,_s("ARMY_COMMIT"))
	_ccbNode:bindButton("btnCancel", onBtnCancelClick,_s("ARMY_CANCEL"))
	_ccbNode:bindButton("btnCommit_2", onBtnCommit_2Click,_s("ARMY_COMMIT"))

	-- 填充文字
	

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_1CLICK]	= onBtnCommit_1Click
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONBTNCANCELCLICK]	= onBtnCancelClick
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONBTNCOMMIT_2CLICK]	= onBtnCommit_2Click
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONFETCHCREATEARMY]	= onFetchCreateArmy
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONFETCHNOTICE]		= onFetchNotice
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYLVUP]		= onFetchArmyLvUp
MSG_HANDLER[MSG_ID.MSG_ARMYALERTLAYER_ONFETCHARMYSHOPLVUP]		= onFetchArmyShopLvUp
