--ArmyBossLayer.lua

MSG_ID.MSG_ARMYBOSSLAYER_MODEL 				= 32100

MSG_ID.MSG_ARMYBOSSLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYBOSSLAYER_MODEL + 10
MSG_ID.MSG_ARMYBOSSLAYER_ONFETCHBOSSLIST = MSG_ID.MSG_ARMYBOSSLAYER_MODEL + 11
MSG_ID.MSG_ARMYBOSSLAYER_ONFETCHFIGHT = MSG_ID.MSG_ARMYBOSSLAYER_MODEL + 12

local TAG = "[ArmyBossLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--32100 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYBOSSLAYER_ONBTNCLOSECLICK)
	closeLayer()
end
--请求Boss列表
local function onFetchBossList( ... )
	NetHelper.showLoading(true, true)
	local function onFetchCallback( properties )
		_ccbNode.reloadBossGrid(properties)
		NetHelper.hideLoading(true)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_ARMY_INTOCOPY,
        onFetchCallback,
		{ },
		{}
    )
end
--请求Boss攻打
local function onBossFight( msg, luaValue )
	local function onFetchCallback( properties )
		
	end
	
	NetHelper.createRequest(
        ACTID.MSG_ARMY_ATTACK,
        onFetchCallback,
		{ armybossno = msg.userdata.armybossno},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--32100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYBOSSLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyBossLayer.ccbi")
	_ccbNode.closeLayer = closeLayer

	_ccbNode.currentLv = data.currentLV

	-- Quick element
	_nodeTable["mBossTitleLabel"] = _ccbNode:getNode("mBossTitleLabel", "CCLabelTTF")
	_nodeTable["mTopButtoms"] = _ccbNode:getNode("mTopButtoms", "CCNode")
	_nodeTable["mBossList"] = _ccbNode:getNode("mBossList", "CCNode")
	_nodeTable["mButtons"] = _ccbNode:getNode("mButtons", "CCNode")
	_nodeTable["mBossBlood"] = _ccbNode:getNode("mBossBlood", "CCNode")
	_nodeTable["mFightButtons"] = _ccbNode:getNode("mFightButtons", "CCNode")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- 填充文字
	_nodeTable["mBossTitleLabel"]:setString(_s("ARMY_BOSS_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyBossLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBOSSLAYER_ONFETCHBOSSLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYBOSSLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYBOSSLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYBOSSLAYER_ONFETCHBOSSLIST]	= onFetchBossList
MSG_HANDLER[MSG_ID.MSG_ARMYBOSSLAYER_ONFETCHFIGHT]	= onBossFight
