--ArmyBossRankLayer.lua

MSG_ID.MSG_ARMYBOSSRANKLAYER_MODEL 				= 32200

MSG_ID.MSG_ARMYBOSSRANKLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYBOSSRANKLAYER_MODEL + 10
MSG_ID.MSG_ARMYBOSSRANKLAYER_ONFETCHRANKLIST = MSG_ID.MSG_ARMYBOSSRANKLAYER_MODEL + 11

local TAG = "[ArmyBossRankLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--32200 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYBOSSRANKLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

--请求伤害排行列表
local function onFetchRankList( ... )
	local function onFetchCallback( properties )
		_ccbNode.reloadRankGrid(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_ARMY_ATTACKSORT,
        onFetchCallback,
		{ armybossno = _ccbNode.bossno },
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--32200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYBOSSRANKLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyBossRankLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mBossRankLabel"] = _ccbNode:getNode("mBossRankLabel", "CCLabelTTF")
	_nodeTable["mRank"] = _ccbNode:getNode("mRank", "CCNode")

	_ccbNode.bossno = data.bossno
	_ccbNode.bossName = data.bossName

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	--填充文字
	_nodeTable["mBossRankLabel"]:setString(_s("ARMY_BOSS_RANK_TITLE",_ccbNode.bossName))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyBossRankLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBOSSRANKLAYER_ONFETCHRANKLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYBOSSRANKLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYBOSSRANKLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYBOSSRANKLAYER_ONFETCHRANKLIST]	= onFetchRankList