--ArmyBuildLayer.lua

MSG_ID.MSG_ARMYBUILDLAYER_MODEL 				= 31300

MSG_ID.MSG_ARMYBUILDLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYBUILDLAYER_MODEL + 10
MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILDLIST = MSG_ID.MSG_ARMYBUILDLAYER_MODEL + 11
MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILD = MSG_ID.MSG_ARMYBUILDLAYER_MODEL + 12

local TAG = "[ArmyBuildLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
end


local function onBtnCloseClick( msg, luaValue )
	--31300 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYBUILDLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onFetchBuildList( msg, luaValue )
	local function onFetchCallback( properties )
		_ccbNode.reloadBuildTimesGrid(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYBUILDLIST,
        onFetchCallback,
		{ },
		{}
    )
end

local function onFetchBuild( msg, luaValue )
	local function onFetchCallback( properties )
		NetHelper.QuickToast(_s("ARMY_BUILD_SUCCESS"))
		local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILDLIST)
                end
            }
        )
		
	end
	
	NetHelper.createRequest(
        ACTID.MSG_BUY_ARMY,
        onFetchCallback,
		{ buildid = msg.userdata.buildid },
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYBUILDLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyBuildLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mBuildeTitleLabel"] = _ccbNode:getNode("mBuildeTitleLabel", "CCLabelTTF")
	_nodeTable["mTabNode"] = _ccbNode:getNode("mTabNode", "CCNode")
	_nodeTable["mBuildLabel"] = _ccbNode:getNode("mBuildLabel", "CCLabelTTF")
	_nodeTable["mDiamondLabel"] = _ccbNode:getNode("mDiamondLabel", "CCLabelTTF")
	_nodeTable["mGoldLabel"] = _ccbNode:getNode("mGoldLabel", "CCLabelTTF")
	_nodeTable["mBuildCount"] = _ccbNode:getNode("mBuildCount", "CCNode")
	_nodeTable["mBuildList"] = _ccbNode:getNode("mBuildList", "CCNode")
	_nodeTable["mMyContributeLabel"] = _ccbNode:getNode("mMyContributeLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- 填充文字
	_nodeTable["mBuildeTitleLabel"]:setString(_s("ARMY_BUILDE_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyBuildLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILDLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYBUILDLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYBUILDLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILDLIST]	= onFetchBuildList
MSG_HANDLER[MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILD]	= onFetchBuild
