--ArmyMainLayer.lua

MSG_ID.MSG_ARMYMAINLAYER_MODEL 				= 31000

MSG_ID.MSG_ARMYMAINLAYER_ONBTNARMYLVUPCLICK = MSG_ID.MSG_ARMYMAINLAYER_MODEL + 10
MSG_ID.MSG_ARMYMAINLAYER_ONBTNEDITCLICK = MSG_ID.MSG_ARMYMAINLAYER_MODEL + 11
MSG_ID.MSG_ARMYMAINLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYMAINLAYER_MODEL + 12
MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY = MSG_ID.MSG_ARMYMAINLAYER_MODEL + 13
MSG_ID.MSG_ARMYMAINLAYER_ONBTNRULECLICK = MSG_ID.MSG_ARMYMAINLAYER_MODEL + 14

local TAG = "[ArmyMainLayer]"
local _ccbNode 
local _nodeTable = {}

local fnNextView
local fromSearch

local function closeLayer()
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ENABLEMESSAGESCHEDULE, nil, true)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	if isfunction(fnNextView) then
		
		CCBCenter.popSecondCCBNode()
	elseif fromSearch then

		CCBCenter.popSecondCCBNode()
	else
		CCBCenter.popLastLevelCCBNode()
	end
	SOUND:playMusicHome()
end


local function onBtnArmyLvUpClick( msg, luaValue )
	--31000 + 10
	Log.d(TAG, "btnArmyLvUp: MSG_ID = %d", MSG_ID.MSG_ARMYMAINLAYER_ONBTNARMYLVUPCLICK)
	CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isArmyLvUp = true,apoint = _ccbNode.getArmyApoint(),nextApoint = _ccbNode.getNextApoint(),armylv = _ccbNode.getArmyLv()})
end

local function onBtnEditClick( msg, luaValue )
	--31000 + 11
	Log.d(TAG, "btnEdit: MSG_ID = %d", MSG_ID.MSG_ARMYMAINLAYER_ONBTNEDITCLICK)
	CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isNotice = true,oldNotice = _ccbNode.getNotice()})
end

local function onBtnCloseClick( msg, luaValue )
	--31000 + 12
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYMAINLAYER_ONBTNCLOSECLICK)
	closeLayer()
end
--获取我的军团
local function onFetchMyArmy( msg, luaValue )
	local function onFetchCallback( properties )
		_ccbNode.setArmyInfo(properties)
		NetHelper.hideLoading(true)
	end
	NetHelper.showLoading(true, true)
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYSELF,
        onFetchCallback,
		{ },
		{}
    )
end
--军团规则
local function onBtnRuleClick( ... )
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isArmyMain = true,})
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYMAINLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyMainLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	if data then
		fnNextView = data.fnNextView
		fromSearch = data.fromSearch
	end
	-- Quick element
	_nodeTable["mArmyMessageNode"] = _ccbNode:getNode("mArmyMessageNode", "CCNode")
	_nodeTable["mArmyLvLabel"] = _ccbNode:getNode("mArmyLvLabel", "CCLabelTTF")
	_nodeTable["mArmyNoticeLabel"] = _ccbNode:getNode("mArmyNoticeLabel", "CCLabelTTF")
	_nodeTable["mBuildTitleLabel"] = _ccbNode:getTTFLabel("mBuildTitleLabel", _s("ARMY_BUILD_POINT"))
	_nodeTable["mContributeTitleLabel"] = _ccbNode:getTTFLabel("mContributeTitleLabel", _s("ARMY_CONTRIBUTE"))
	-- _nodeTable["mAmryBuild"] = _ccbNode:getNode("mAmryBuild", "CCNode")
	-- _nodeTable["mMyContribution"] = _ccbNode:getNode("mMyContribution", "CCNode")
	_nodeTable["btnArmyLvUp"] = _ccbNode:getNode("btnArmyLvUp", "CCControlButton")
	_nodeTable["btnEdit"] = _ccbNode:getNode("btnEdit", "CCControlButton")
	_nodeTable["mArmyBuildLabel"] = _ccbNode:getNode("mArmyBuildLabel", "CCLabelTTF")
	_nodeTable["mMyContributeLabel"] = _ccbNode:getNode("mMyContributeLabel", "CCLabelTTF")
	_nodeTable["mIndextityLabel"] = _ccbNode:getNode("mIndextityLabel", "CCLabelTTF")
	_nodeTable["mArmyRuleLabel"] = _ccbNode:getNode("mArmyRuleLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnArmyLvUp", onBtnArmyLvUpClick,_s("ARMY_LV_UP"))
	_ccbNode:bindButton("btnEdit", onBtnEditClick,_s("ARMY_NOTICE_EDIT"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnArmyRule", onBtnRuleClick)

	-- 填充文字
	_nodeTable["mArmyRuleLabel"]:setString(_s("ARMY_BOSS_WARM_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyMainLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		 --音效
  		SOUND:playMusicArmy() 
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_ONBTNARMYLVUPCLICK]	= onBtnArmyLvUpClick
MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_ONBTNEDITCLICK]	= onBtnEditClick
MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY]	= onFetchMyArmy
MSG_HANDLER[MSG_ID.MSG_ARMYMAINLAYER_ONBTNRULECLICK]	= onBtnRuleClick
