--ArmyMenberLayer.lua

MSG_ID.MSG_ARMYMENBERLAYER_MODEL 				= 31600

MSG_ID.MSG_ARMYMENBERLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 10
MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHMENBERLIST = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 11
MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHPROPOSERLIST = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 12
MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHAPPLY = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 13
MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHQUIT = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 14
MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHOPERATE = MSG_ID.MSG_ARMYMENBERLAYER_MODEL + 15


local TAG = "[ArmyMenberLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--31600 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYMENBERLAYER_ONBTNCLOSECLICK)
	closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
end

--请求成员列表
local function onFetchMenberList( msg, luaValue )
	local function onFetchCallback( properties )
		--dump(properties)
		_ccbNode.reloadMenberGrid(properties.armyplayerlist)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYPLAYERLIST,
        onFetchCallback,
		{ },
		{}
    )
end

--请求申请人员列表
local function onFetchProposerList( msg, luaValue )
	local function onFetchCallback( properties )
		_ccbNode.reloadProposerGrid(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_INTO_ARMYAPP,
        onFetchCallback,
		{ },
		{}
    )
end
--申请审核
local function onFetchApply( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHPROPOSERLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_MAG_ARMYAPP,
        onFetchCallback,
		{ typ = msg.userdata.typ,pid = msg.userdata.pid},
		{}
    )
end
--退出军团
local function onFetchQuit( msg, luaValue )
	local function onFetchCallback( properties )
		NetHelper.QuickToast(_s("ARMY_QUIT_SUCCESS"))
		CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
		--CCBCenter.popThirdCCBNode()
	end
	
	NetHelper.createRequest(
        ACTID.MSG_REMOVE_ARMY,
        onFetchCallback,
		{},
		{}
    )
end

local function onFetchOperate( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHMENBERLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_MAG_ARMYPLAYER,
        onFetchCallback,
		{ typ = msg.userdata.typ,id = msg.userdata.id},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYMENBERLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyMenberLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mTabNode"] = _ccbNode:getNode("mTabNode", "CCNode")
	_nodeTable["mMenberList"] = _ccbNode:getNode("mMenberList", "CCNode")
	_nodeTable["mProposerList"] = _ccbNode:getNode("mProposerList", "CCNode")

	_ccbNode.isNew = data.isNew

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyMenberLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHMENBERLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHMENBERLIST]	= onFetchMenberList
MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHPROPOSERLIST]	= onFetchProposerList
MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHAPPLY]	= onFetchApply
MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHQUIT]	= onFetchQuit
MSG_HANDLER[MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHOPERATE]	= onFetchOperate
