--ArmySearchLayer.lua

MSG_ID.MSG_ARMYSEARCHLAYER_MODEL 				= 31100

MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 10
MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYSEARCHCLICK = MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 11
MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYCREATECLICK = MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 12
MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST	= MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 13
MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMY	= MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 14
MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMYCANCEL = MSG_ID.MSG_ARMYSEARCHLAYER_MODEL + 15

local TAG = "[ArmySearchLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--31100 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onBtnArmySearchClick( msg, luaValue )
	--31100 + 11
	Log.d(TAG, "btnArmySearch: MSG_ID = %d", MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYSEARCHCLICK)

	local function onFetchCallback( properties )
		_ccbNode.setSearchArmy(properties.armyinfo)
	end
	
	if _ccbNode.getSearchName() ~= "" then

		NetHelper.createRequest(
	        ACTID.MSG_SEEK_ARMY,
	        onFetchCallback,
			{ aname = _ccbNode.getSearchName() },
			{}
	    )
	end
end

local function onBtnArmyCreateClick( msg, luaValue )
	--31100 + 12
	Log.d(TAG, "btnArmyCreate: MSG_ID = %d", MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYCREATECLICK)
	CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isCreate = true,createDiamond = _ccbNode.getCreateDiamond(),createLv = _ccbNode.getCreateLv()})
end
--获取军团列表
local function onFetchArmyList( ... )
	local function onFetchCallback( properties )
		_ccbNode.setCreateDiamond(properties.creatarmy)
		_ccbNode.setCreateLv(properties.creatlv)
		_ccbNode.isOver24(properties.lastexitarmytime)
		_ccbNode.reloadArmyList(properties.armylist)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYLIST,
        onFetchCallback,
		{ },
		{}
    )
end

local function failedCb( ... )
	local function onFetchCallback( properties )
		if properties.armytyp == 1 then
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST)
		elseif properties.armytyp == 2 then
			CCBCenter.loadCCB("MSG_ARMYMAINLAYER_MODEL", "ccb.c.army.ArmyMainLayer",{fromSearch = true})
		elseif properties.armytyp == 0 then
			NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.ARMY, _s("MAIN_ARMY")))
		end
	end
	NetHelper.createRequest(
	        ACTID.MSG_IN_ARMYSYSTEM,
	        onFetchCallback,
			{ },
			{}
	    )
end

--申请加入军团
local function onFetchAddArmy( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isApply = true,callback = function ( ... )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST)
		end})
		--CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_APP_ARMY,
        onFetchCallback,
		{ aid = msg.userdata.aid },
		{failedCb = failedCb}
    )
end

--取消申请
local function onFetchAddArmyCancel( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_CANVElAPP_ARMY,
        onFetchCallback,
		{ aid = msg.userdata.aid },
		{failedCb = failedCb}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYSEARCHLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmySearchLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mArmyLabel"] = _ccbNode:getNode("mArmyLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnArmySearch", onBtnArmySearchClick,_s("ARMY_SEARCH"))
	_ccbNode:bindButton("btnArmyCreate", onBtnArmyCreateClick,_s("ARMY_CREATE_TITLE"))

	-- 填充文字
	_nodeTable["mArmyLabel"]:setString(_s("ARMY_SEARCH_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmySearchLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYSEARCHCLICK]	= onBtnArmySearchClick
MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONBTNARMYCREATECLICK]	= onBtnArmyCreateClick
MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHARMYLIST]	= onFetchArmyList
MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMY]	= onFetchAddArmy
MSG_HANDLER[MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMYCANCEL]	= onFetchAddArmyCancel
