--ArmyShopLayer.lua

MSG_ID.MSG_ARMYSHOPLAYER_MODEL 				= 31800

MSG_ID.MSG_ARMYSHOPLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYSHOPLAYER_MODEL + 10
MSG_ID.MSG_ARMYSHOPLAYER_ONMSHOPLVUPCLICK = MSG_ID.MSG_ARMYSHOPLAYER_MODEL + 11
MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHSHOPLIST = MSG_ID.MSG_ARMYSHOPLAYER_MODEL + 12
MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHBUYGOODS = MSG_ID.MSG_ARMYSHOPLAYER_MODEL + 13

local TAG = "[ArmyShopLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
end


local function onBtnCloseClick( msg, luaValue )
	--31800 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYSHOPLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onMShopLvUpClick( msg, luaValue )
	--31800 + 11
	Log.d(TAG, "mShopLvUp: MSG_ID = %d", MSG_ID.MSG_ARMYSHOPLAYER_ONMSHOPLVUPCLICK)
	CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isArmyShopLvUp = true,apoint = _ccbNode.getApoint(),nextApoint = _ccbNode.getNextApoint(),armylv = _ccbNode.getShopLv()})
end

local function onFetchShopList( msg, luaValue )
	local function onFetchCallback( properties )
		_ccbNode.setShopInfo(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYSHOPLIST,
        onFetchCallback,
		{ },
		{}
    )
end

local function onFetchBuyGoods( msg, luaValue )
	local function onFetchCallback( properties )
		local rewardEntity = require("model.main.RewardEntity").new(properties.rs)
		CCBCenter.loadCCB(
	            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            	"ccb.c.main.ReceiveRewardAlertLayer", 
	            {
	                entity = rewardEntity,
	                onConfirm = function( )
	     				CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHSHOPLIST)
	                end
	            }
	        )

	end
	
	NetHelper.createRequest(
        ACTID.MSG_BUY_ARMYSHOP,
        onFetchCallback,
		{ proid = msg.userdata.proid },
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31800
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYSHOPLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyShopLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mShopTitleLabel"] = _ccbNode:getNode("mShopTitleLabel", "CCLabelTTF")
	_nodeTable["mTabNode"] = _ccbNode:getNode("mTabNode", "CCNode")
	_nodeTable["mArmyBuildLabel"] = _ccbNode:getNode("mArmyBuildLabel", "CCLabelTTF")
	_nodeTable["mMyContributeLabel"] = _ccbNode:getNode("mMyContributeLabel", "CCLabelTTF")
	_nodeTable["mShopGoodsList"] = _ccbNode:getNode("mShopGoodsList", "CCNode")
	_nodeTable["mShopLvUp"] = _ccbNode:getNode("mShopLvUp", "CCControlButton")
	
	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("mShopLvUp", onMShopLvUpClick,_s("ARMY_SHOP_LV_UP"))

	-- 填充文字

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyShopLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHSHOPLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYSHOPLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYSHOPLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYSHOPLAYER_ONMSHOPLVUPCLICK]	= onMShopLvUpClick
MSG_HANDLER[MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHSHOPLIST]	= onFetchShopList
MSG_HANDLER[MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHBUYGOODS]	= onFetchBuyGoods
