--ArmyTablentLayer.lua

MSG_ID.MSG_ARMYTABLENTLAYER_MODEL 				= 31900

MSG_ID.MSG_ARMYTABLENTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_ARMYTABLENTLAYER_MODEL + 10
MSG_ID.MSG_ARMYTABLENTLAYER_ONFETCHTALENTLIST = MSG_ID.MSG_ARMYTABLENTLAYER_MODEL + 11
MSG_ID.MSG_ARMYTABLENTLAYER_ONCHOOSECARDS = MSG_ID.MSG_ARMYTABLENTLAYER_MODEL + 12

local TAG = "[ArmyTablentLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMAINLAYER_ONFETCHMYARMY)
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--31900 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_ARMYTABLENTLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onFetchTalentList( msg, luaValue )
	
	local function onFetchCallback( properties )
		_nodeTable["armylv"] = properties.armylv
		_ccbNode.reloadTalentGrid(properties.armytalents)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYTALENTLIST,
        onFetchCallback,
		{ },
		{}
    )
end

local function onChooseCards( msg, luaValue )

	CCBCenter.loadCCB("MSG_ARMYTALENTLVUPCARDLAYER_MODEL", 
					"ccb.c.army.ArmyTalentLvUpCardLayer", 
					{item = _nodeTable["item"],armylv = _nodeTable["armylv"]})
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31900
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYTABLENTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyTalentLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mTalentLabel"] = _ccbNode:getNode("mTalentLabel", "CCLabelTTF")
	_nodeTable["mTabNode"] = _ccbNode:getNode("mTabNode", "CCNode")
	_nodeTable["mTalentList"] = _ccbNode:getNode("mTalentList", "CCNode")
	_nodeTable["mArmyTalentWarm"] = _ccbNode:getNode("mArmyTalentWarm", "CCLabelTTF")
	
	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- 填充文字
	_nodeTable["mTalentLabel"]:setString(_s("ARMY_TALENT_TITLE"))
	_nodeTable["mArmyTalentWarm"]:setString(_s("ARMY_TALENT_WARM_1"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyTablentLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYTABLENTLAYER_ONFETCHTALENTLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYTABLENTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYTABLENTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_ARMYTABLENTLAYER_ONFETCHTALENTLIST]	= onFetchTalentList
MSG_HANDLER[MSG_ID.MSG_ARMYTABLENTLAYER_ONCHOOSECARDS]	= onChooseCards
