--ArmyTalentLvUpCardLayer.lua

MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL 				= 32000

MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNUPTALENTCLICK = MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL + 10
MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNCLOSETLCCLICK = MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL + 11
MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONFETCHCARDLIST = MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL + 12

local TAG = "[ArmyTalentLvUpCardLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

local function onBtnCloseTLCClick( msg, luaValue )
	--32000 + 11
	Log.d(TAG, "btnCloseTLC: MSG_ID = %d", MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNCLOSETLCCLICK)
	closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYTABLENTLAYER_ONFETCHTALENTLIST)
end

local function onBtnUpTalentClick( msg, luaValue )
	--32000 + 10
	Log.d(TAG, "btnUpTalent: MSG_ID = %d", MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNUPTALENTCLICK)

	local function onFetchCallback( properties )
		local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    onBtnCloseTLCClick()
                end
            }
        )
	end

	if _ccbNode:enterStatus() == 1 then 
		NetHelper.QuickToast(_s("TALENT_TOAST_NOT_ENOUGH_GOLD"))
		return
	elseif _ccbNode:enterStatus() == 2 then 
		NetHelper.QuickToast(_s("TALENT_TOAST_NOT_ENOUGH_STAR"))
		return
	end

	--拼凑选中的卡牌
	local selectitem = _ccbNode:getSelectItems()
	local card = {}
	dump(selectitem)
	for i,v in ipairs(selectitem) do

		 card[#card + 1] = v:getCpid()
	end
	local _cardsId = {}
	if #card > 0 then

		NetHelper.createRequest(
	        ACTID.MSG_GET_UPARMYTALENT,
	        onFetchCallback,
			{ 	lv  = _nodeTable["lv"],--原始等级 
				typ = _nodeTable["item"]:getTyp(), 
				camp = _nodeTable["item"]:getCamp(), 
				cards = card
			},
			{}
	    )
	else
		NetHelper.QuickToast(_s("TALENT_TOST_PLSELCARD"))
	end
end

local function onFetchCardList( msg,luaValue )
	local function onFetchCallback( properties )
		_ccbNode.callBackTalentCards(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_ARMYTALENTCARDLIST,
        onFetchCallback,
		{ typ = _nodeTable["item"]:getTyp(),camp = _nodeTable["item"]:getCamp() },
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--32000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ArmyTalentLvUpCardLayer.ccbi")
	_ccbNode.closeLayer = closeLayer

	_nodeTable["item"] = data.item
	_nodeTable["armylv"] = data.armylv

	-- Quick element
	_nodeTable["mArmyTalentLv"] = _ccbNode:getNode("mArmyTalentLv", "CCLabelTTF")
	_nodeTable["mArmyTalentExp"] = _ccbNode:getNode("mArmyTalentExp", "CCLabelTTF")
	_nodeTable["mExpNode"] = _ccbNode:getNode("mExpNode", "CCNode")
	_nodeTable["mArmyTalentGold"] = _ccbNode:getNode("mArmyTalentGold", "CCLabelTTF")
	_nodeTable["mArmyTalentName"] = _ccbNode:getNode("mArmyTalentName", "CCLabelTTF")
	_nodeTable["mIntroduceLabel"] = _ccbNode:getNode("mIntroduceLabel", "CCLabelTTF")
	_nodeTable["mCardList"] = _ccbNode:getNode("mCardList", "CCNode")
	_nodeTable["mArmyTalentCardTitle"] = _ccbNode:getNode("mArmyTalentCardTitle", "CCLabelTTF")
	_nodeTable["mArmyTalentStar"] = _ccbNode:getNode("mArmyTalentStar", "CCLabelTTF")
	_nodeTable["mMyGold"] = _ccbNode:getNode("mMyGold", "CCLabelTTF")
	_nodeTable["mArmyTalent"] = _ccbNode:getNode("mArmyTalent", "CCNode")

	-- CCControlButton
	_ccbNode:bindButton("btnUpTalent", onBtnUpTalentClick,_s("TALENT_UPGRADE_TALENT"))
	_ccbNode:bindButton("btnCloseTLC", onBtnCloseTLCClick)

	-- 填充文字
	_nodeTable["mArmyTalentCardTitle"]:setString(_s("ARMY_TALENT_TITLE"))
	_nodeTable["mArmyTalentExp"]:setString("exp:")

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.army.ArmyTalentLvUpCardLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONFETCHCARDLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNUPTALENTCLICK]	= onBtnUpTalentClick
MSG_HANDLER[MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONBTNCLOSETLCCLICK]	= onBtnCloseTLCClick
MSG_HANDLER[MSG_ID.MSG_ARMYTALENTLVUPCARDLAYER_ONFETCHCARDLIST]	= onFetchCardList
