--BigWheelLayer.lua

MSG_ID.MSG_BIGWHEELLAYER_MODEL 				= 22000

MSG_ID.MSG_BIGWHEELLAYER_ONBTNGOLDBEGINCLICK = MSG_ID.MSG_BIGWHEELLAYER_MODEL + 10
MSG_ID.MSG_BIGWHEELLAYER_ONBTNDIAMONDBEGINCLICK = MSG_ID.MSG_BIGWHEELLAYER_MODEL + 11
MSG_ID.MSG_BIGWHEELLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_BIGWHEELLAYER_MODEL + 12
MSG_ID.MSG_BIGWHEELLAYER_ACTION_ONFETCHINFOROTARY = MSG_ID.MSG_BIGWHEELLAYER_MODEL + 13

local TAG = "[BigWheelLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	CCBCenter.popLastLevelCCBNode()
	SOUND:playMusicHome()
end


local function onBtnGoldBeginClick( msg, luaValue )
	--22000 + 10
	Log.d(TAG, "btnGoldBegin: MSG_ID = %d", MSG_ID.MSG_BIGWHEELLAYER_ONBTNGOLDBEGINCLICK)

	local function onFetchCallback( properties )
		--大转盘转动
		_ccbNode.bingWheelRun(properties)
	end

	local function failCallback( ... )
		util.enableCustomTouch(_ccbNode,true)
	end

	util.enableCustomTouch(_ccbNode,false)
	


	NetHelper.createRequest(
        ACTID.MSG_GET_ROTARY,
        onFetchCallback,
		{typ = 1},
		{
			failedCb = failCallback,
			showLoading = false,
		}
    )
end

local function onBtnDiamondBeginClick( msg, luaValue )
	--22000 + 11
	Log.d(TAG, "btnDiamondBegin: MSG_ID = %d", MSG_ID.MSG_BIGWHEELLAYER_ONBTNDIAMONDBEGINCLICK)
	local function onFetchCallback( properties )
		
		--大转盘转动
		_ccbNode.bingWheelRun(properties)
	end

	local function failCallback( ... )
		util.enableCustomTouch(_ccbNode,true)
	end

	 AlertLayer.new4IAP{
	  	isUserDiamond = true,
	  	diamondIndex = 1,
	    content = _s("USE_DIAMOND_01",_ccbNode.getDiamondPrice()),
	    btnClickEvent = {
	    	function ( )
	        	util.enableCustomTouch(_ccbNode,false)

				NetHelper.createRequest(
			        ACTID.MSG_GET_ROTARY,
			        onFetchCallback,
					{typ = 2,},
					{failedCb = failCallback}
			    )
	        end,
	    }
	  }

end

local function onBtnCloseClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_BIGWHEELLAYER_ONBTNCLOSECLICK)
	
	closeLayer()
end
--进入大转盘界面
local function onActionFetchInfoRotary( ... )
	local function onFetchCallback( properties )
		--设置大转盘数据
		_ccbNode.setValues(properties.rewardlst)
		_ccbNode.setButtons(properties.DamPrice,properties.GoldPrice)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_INTO_ROTARY,
        onFetchCallback,
		{},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--22000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_BIGWHEELLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "BigWheelLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["btnGoldBegin"] = _ccbNode:getNode("btnGoldBegin", "CCControlButton")
	_nodeTable["btnDiamondBegin"] = _ccbNode:getNode("btnDiamondBegin", "CCControlButton")
	_nodeTable["btnClose"] = _ccbNode:getNode("btnClose", "CCControlButton")
	-- CCControlButton
	_ccbNode:bindButton("btnGoldBegin", onBtnGoldBeginClick)
	_ccbNode:bindButton("btnDiamondBegin", onBtnDiamondBeginClick)
	_ccbNode:bindButton("btnClose", onBtnCloseClick)


	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.bigWheel.BigWheelLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_BIGWHEELLAYER_ACTION_ONFETCHINFOROTARY)
   		 end})
	end
end


MSG_HANDLER[MSG_ID.MSG_BIGWHEELLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_BIGWHEELLAYER_ONBTNGOLDBEGINCLICK]	= onBtnGoldBeginClick
MSG_HANDLER[MSG_ID.MSG_BIGWHEELLAYER_ONBTNDIAMONDBEGINCLICK]	= onBtnDiamondBeginClick
MSG_HANDLER[MSG_ID.MSG_BIGWHEELLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_BIGWHEELLAYER_ACTION_ONFETCHINFOROTARY]	= onActionFetchInfoRotary
