--BossLayer.lua

MSG_ID.MSG_BOSSLAYER_MODEL 				= 29100

MSG_ID.MSG_BOSSLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_BOSSLAYER_MODEL + 10
MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO = MSG_ID.MSG_BOSSLAYER_MODEL + 11
MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHENCOURAGE = MSG_ID.MSG_BOSSLAYER_MODEL + 12
MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSFIGHT = MSG_ID.MSG_BOSSLAYER_MODEL + 13
MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSREWARD = MSG_ID.MSG_BOSSLAYER_MODEL + 14
MSG_ID.MSG_BOSSLAYER_ONBTNHELPCLICK = MSG_ID.MSG_BOSSLAYER_MODEL + 15

local TAG = "[BossLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	--CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--29100 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_BOSSLAYER_ONBTNCLOSECLICK)
	SOUND:playMusicHome()
	closeLayer()
end
local function onBtnHelpClick( msg, luaValue )
	--29100 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_BOSSLAYER_ONBTNCLOSECLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isBossRule = true,})
end

--boss信息
local function onActionFetchBossInfo( msg, luaValue )
	local function onFetchCallback( properties )
		
		-- --刷新排名数据
		_ccbNode.reloadRankGrid(properties.players)

		-- --填充Boss信息
		_ccbNode.setValues(properties)

		-- --设置按钮
		_ccbNode.createEncourageBtn(properties.status,properties.cddia)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_BOSS_INFO,
        onFetchCallback,
		{},
		{}
    )

end

--boss信息
local function onActionFetchBossReward( msg, luaValue )
	local function onFetchCallback( properties )
		
		local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_BOSS_GETREWARD,
        onFetchCallback,
		{},
		{}
    )

end

--金币，钻石鼓舞
local function onActionFetchEncourage( msg, luaValue )
	local function onFetchCallback( properties )
		
		--增加提示
		if properties.addmorale == 0 then
			NetHelper.QuickToast(_s("BOSS_ENCOURAGE_FAILURE"))
		elseif properties.addstar == 0 then
			NetHelper.QuickToast(_s("BOSS_ENCOURAGE_FULL", properties.addmorale))
		else
			NetHelper.QuickToast(_s("BOSS_ENCOURAGE_UP", properties.addmorale,properties.addstar))
		end

		--刷新排名数据
		_ccbNode.reloadRankGrid(properties.players)

		--填充Boss信息
		_ccbNode.setValues(properties)

		--设置按钮
		_ccbNode.createEncourageBtn(properties.status,properties.cddia)
	end

	NetHelper.createRequest(
        ACTID.MSG_BOSS_ENCOURAGE,
        onFetchCallback,
		{typ = msg.userdata.typ},
		{}
    )
end

--战斗
local function onActionFetchBossFight( ... )

	local function onFetchCallback( properties )
		
		CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_BOSS_FIGHT,
        onFetchCallback,
		{},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--29100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_BOSSLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "BossLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mBossRank"] = _ccbNode:getNode("mBossRank", "CCNode")
	_nodeTable["mMyRankLabel"] = _ccbNode:getNode("mMyRankLabel", "CCLabelTTF")
	_nodeTable["mHPProgressbar"] = _ccbNode:getNode("mHPProgressbar", "CCNode")
	_nodeTable["mBossBg"] = _ccbNode:getNode("mBossBg", "CCNode")
	--_nodeTable["mCDTimeLabel"] = _ccbNode:getNode("mCDTimeLabel", "CCLabelTTF")
	_nodeTable["mReactivatingLayer"] = _ccbNode:getNode("mReactivatingLayer", "CCLayer")
	_nodeTable["mEncourageLabel"] = _ccbNode:getNode("mEncourageLabel", "CCLabelTTF")
	_nodeTable["mEncourageReward"] = _ccbNode:getNode("mEncourageReward", "CCLabelTTF")
	_nodeTable["mEncourageAll"] = _ccbNode:getNode("mEncourageAll", "CCLabelTTF")
	_nodeTable["mAllEncourageAtk"] = _ccbNode:getNode("mAllEncourageAtk", "CCLabelTTF")
	_nodeTable["mAllEncourageHP"] = _ccbNode:getNode("mAllEncourageHP", "CCLabelTTF")
	_nodeTable["mMyEncourageReward"] = _ccbNode:getNode("mMyEncourageReward", "CCLabelTTF")
	_nodeTable["mMyEncourageAtk"] = _ccbNode:getNode("mMyEncourageAtk", "CCLabelTTF")
	_nodeTable["mMyEncourageHP"] = _ccbNode:getNode("mMyEncourageHP", "CCLabelTTF")
	_nodeTable["mGoldEncourageLayer"] = _ccbNode:getNode("mGoldEncourageLayer", "CCLayer")
	_nodeTable["mDamondLabel"] = _ccbNode:getNode("mDamondLabel", "CCLabelTTF")
	_nodeTable["mDamondEncourageLayer"] = _ccbNode:getNode("mDamondEncourageLayer", "CCLayer")
	_nodeTable["mEncourageProgressbar"] = _ccbNode:getNode("mEncourageProgressbar", "CCNode")
	--_nodeTable["mEndTimeLabel"] = _ccbNode:getNode("mEndTimeLabel", "CCLabelTTF")
	_nodeTable["mRankLabel"] = _ccbNode:getNode("mRankLabel", "CCLabelTTF")
	_nodeTable["mGoldLabel"] = _ccbNode:getNode("mGoldLabel", "CCLabelTTF")
	_nodeTable["mMyPointLabel"] = _ccbNode:getNode("mMyPointLabel", "CCLabelTTF")
	_nodeTable["mGoldSuccessRateLabel"] = _ccbNode:getNode("mGoldSuccessRateLabel", "CCLabelTTF")
	_nodeTable["mDamondSuccessRateLabel"] = _ccbNode:getNode("mDamondSuccessRateLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)

	--填充文字
	_nodeTable["mRankLabel"]:setString(_s("BOSS_RANK"))
	_nodeTable["mEncourageLabel"]:setString(_s("BOSS_ENCOURAGE_REWARD"))
	_nodeTable["mGoldLabel"]:setString(_s("BOSS_GOLD_ENCOURAGE"))
	_nodeTable["mDamondLabel"]:setString(_s("BOSS_DAMOND_ENCOURAGE"))
	_nodeTable["mEncourageAll"]:setString(_s("BOSS_ALL_ENCOURAGE"))
	_nodeTable["mMyEncourageReward"]:setString(_s("BOSS_MY_ENCOURAGE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.boss.BossLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO)
        	_ccbNode:schedule(onActionFetchBossInfo,60)
   		 end})
	end
end


MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO]	= onActionFetchBossInfo
MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHENCOURAGE]	= onActionFetchEncourage
MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSFIGHT]		= onActionFetchBossFight
MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSREWARD]		= onActionFetchBossReward
MSG_HANDLER[MSG_ID.MSG_BOSSLAYER_ONBTNHELPCLICK]		= onBtnHelpClick

