MSG_ID.MSG_CARDENHANCEDLAYER_MODEL 				= 3300

MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNBACKCLICK = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 10
MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNUPGRADECLICK = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 11
MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNMAINLAYERCLICK = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 12
MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNFEEDLAYERCLICK = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 13
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONUPDATEUPGRADECARD = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 14
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONUPDATEFEEDCARD = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 15
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHUPGRADECARD = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 16
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONPLAYANIMATION = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 17
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONSTOPANIMATION = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 18
MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHINTOENHANCEDCARD = MSG_ID.MSG_CARDENHANCEDLAYER_MODEL + 19

local TAG = "[CardEnhancedLayer]"
local _ccbNode 
local _nodeTable = {}
local _playAnimation, _fromCardGroup

local function closeLayer()
	CCBCenter.popLastLevelCCBNode(anim.ANIMATION_TOP_OUT, {
		onComplete = function ( ... )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONHELPJUDGE, nil, nil)
		end
		})
end

-- 播放按钮音乐
local function playBtnSound( )
	SOUND:playEffectButton1()
end
local function onBtnBackClick( msg, luaValue )
	--3300 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNBACKCLICK)
	playBtnSound( )
	closeLayer()
end

local function onBtnUpgradeClick( msg, luaValue )
	--3300 + 11
	Log.d(TAG, "btnUpgrade: MSG_ID = %d", MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNUPGRADECLICK)
	playBtnSound( )
	HelperView2.showNext()
	-- 验证合理性
	if _ccbNode.isReasonable() then
		AlertLayer.new{
    		titleStr = _s("COMMON_NEWS_TIPS"),  -- 标题
            btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},  --按钮1 蓝色
            btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  --标题
            content = _s("CARD_CONFIRM_FEED"),  --内容
            btnClickEvent = {
    			function (  )  --按钮1事件  默认为确定
                    HelperView2.showNext()
    		        local requestData = {
    						cpid  = _ccbNode._DATA._SELECTMAIN[1],
    						cards = _ccbNode._DATA._SELECTFEED,
    					}
    				CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHUPGRADECARD, nil, requestData)
    	        end,
    		}, 
        }	
		HelperView2.show(display.getRunningScene(), 10131)
	end
end

-- 更新主卡牌
local function onUpdateUpgradeCard( msg, luaValue )
	--3300 + 14
	_ccbNode.updateUpgradeCard(msg.userdata)
end

-- 更新饲料卡牌
local function onUpdateFeedCard( msg, luaValue )
	--3300 + 15
	_ccbNode.updateFeedCard(msg.userdata)
end

local function onActionfetchUpgradeCard( msg, luaValue )
	-- 3300 + 16
	Log.d(TAG, "onActionfetchUpgradeCard: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        -- HelperView2.show(_node, 10140)
        HelperView2.showBetween(_node, nil, {10140, 10140})
		local selectMain = _ccbNode._DATA._SELECTMAIN[1]
        _ccbNode._DATA = items
        _ccbNode._DATA._SELECTMAIN = {}
        _ccbNode._DATA._SELECTMAIN[1] = selectMain
        -- 更新卡组页
        if _fromCardGroup then
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP)
        end
        -- 更新本页
    	-- 升级卡区, 这里要套一层
        local cardEntitys = {}
        for i = 1, #items:getCards() do
        	if _ccbNode._DATA._SELECTMAIN[1] == items:getCards()[i]:getCpid() then
                cardEntitys[#cardEntitys + 1] = items:getCards()[i]
        		break
        	end
        end
        _ccbNode.cardUpgrade(cardEntitys)
        -- 饲料卡区
        _ccbNode._DATA._SELECTFEED = {}
        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONUPDATEFEEDCARD, nil, {})
        -- 更新金币数
        _ccbNode.updateGold()
    end
    ModelHelper.requireDataWithFun(
            "model.card.CardModel",
            "fetchUpgradeCard", 
            onFetchCallback,
            msg.userdata
            )
end

local function onActionPlayAnimation( msg, luaValue )
	-- 3300 + 17
	Log.d(TAG, "onActionPlayAnimation: MSG_ID = %d", msg:getMsgId())
	_playAnimation = true
	_ccbNode:playCCBAnimation("Flash")
end

local function onActionStopAnimation( msg, luaValue )
	-- 3300 + 18
	Log.d(TAG, "onActionStopAnimation: MSG_ID = %d", msg:getMsgId())
	_playAnimation = false
end
local function onActionFetchIntoEnhancedCard( msg, luaValue )
    -- 3300 + 19
    Log.d(TAG, "onActionFetchIntoEnhancedCard: MSG_ID = %d", msg:getMsgId())
    
    local function onFetchCallback( items )
        _ccbNode._DATA = items
        -- 初始化值
        _ccbNode._DATA._SELECTMAIN = {}
        _ccbNode._DATA._SELECTFEED = {}
        _ccbNode._DATA._SELECTFEEDENTITYS = {}
        NetHelper.hideLoading(true)
    end
    ModelHelper.requireDataWithFun(
        "model.card.CardModel",
        "fetchIntoEnhancedCard", 
        onFetchCallback,
        {
            failedCb = function ( )
                NetHelper.hideLoading(true)
            end
        }
    )
end

local function animationCompletedCallback( animationManager, animName, luaEventHandler )
	Log.d(TAG, "animationCompletedCallback: %s", animName)
	-- 循环播放动画
	if animName == "Flash" then
		if _playAnimation then
			_ccbNode:playCCBAnimation("Flash")
		end
	end
end

local function onCCBLoad(data, callback)
	--3300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CARDENHANCEDLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "CardEnhancedLayer.ccbi")
	-- _ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_CARDGROUPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mLevelLabel"] = _ccbNode:getNode("mLevelLabel", "CCLabelTTF")
	_nodeTable["mCoinLabel"] = _ccbNode:getNode("mCoinLabel", "CCLabelTTF")
	_nodeTable["mNewLevelLabel"] = _ccbNode:getNode("mNewLevelLabel", "CCLabelTTF")
	_nodeTable["mWhiteLightSprite"] = _ccbNode:getNode("mWhiteLightSprite", "CCSprite")
	_nodeTable["mCardEnhancedLabel"] = _ccbNode:getNode("mCardEnhancedLabel", "CCLabelTTF")
	_nodeTable["mSelectMainCardLabel"] = _ccbNode:getNode("mSelectMainCardLabel", "CCLabelTTF")
	_nodeTable["mSelecFeedCardLabel"] = _ccbNode:getNode("mSelecFeedCardLabel", "CCLabelTTF")
	_nodeTable["mFeedCardLabel"] = _ccbNode:getNode("mFeedCardLabel", "CCLabelTTF")
	_nodeTable["mCurPropertyLabel"] = _ccbNode:getNode("mCurPropertyLabel", "CCLabelTTF")
	_nodeTable["mAtkTitleLabel"] = _ccbNode:getNode("mAtkTitleLabel", "CCLabelTTF")
	_nodeTable["mHpTitleLabel"] = _ccbNode:getNode("mHpTitleLabel", "CCLabelTTF")
	_nodeTable["mMyGlodLabel"] = _ccbNode:getNode("mMyGlodLabel", "CCLabelTTF")
	_nodeTable["mLayerTitleLabel"] = _ccbNode:getNode("mLayerTitleLabel", "CCLabelTTF")
    _nodeTable["mExpTitleLabel"] = _ccbNode:getNode("mExpTitleLabel", "CCLabelTTF")
	_nodeTable["mLvTitleLabel"] = _ccbNode:getNode("mLvTitleLabel", "CCLabelTTF")
	_nodeTable["mCostNode"] = _ccbNode:getNode("mCostNode", "CCNode")
	_nodeTable["mXpNewNode"] = _ccbNode:getNode("mXpNewNode", "CCNode")

	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)
	_ccbNode:bindButton("btnUpgrade", onBtnUpgradeClick, _s("CARD_UPGRADE"))
	-- GET DATA
	_ccbNode._DATA = {}
    _fromCardGroup = data.fromCardGroup
	-- MenuItem
	_ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- 填充文字
	_nodeTable["mCardEnhancedLabel"]:setString(_s("CARD_ENHANCED_CARD"))
	_nodeTable["mSelectMainCardLabel"]:setString(_s("CARD_SELECT_CARD"))
	_nodeTable["mSelecFeedCardLabel"]:setString(_s("CARD_SELECT_CARD"))
	_nodeTable["mFeedCardLabel"]:setString(_s("CARD_FEED_CARD"))
	_nodeTable["mCurPropertyLabel"]:setString(_s("CARD_CUR_PROPERTY"))
	_nodeTable["mAtkTitleLabel"]:setString(_s("CARD_ATTACK"))
	_nodeTable["mHpTitleLabel"]:setString(_s("CARD_HP"))
	_nodeTable["mMyGlodLabel"]:setString(_s("CARD_MY_MONEY"))
	_nodeTable["mLayerTitleLabel"]:setString(_s("CARD_ENHANCED"))
	_nodeTable["mExpTitleLabel"]:setString(_s("ROLE_EXP"))

	-- 微调在android下的文字位置
	util.modifyPositionInAndroid( _nodeTable.mLayerTitleLabel, 0, 2 ) 		-- 标题
	util.modifyPositionInAndroid( _nodeTable.mCardEnhancedLabel, 0, 2 )		-- 强化卡标题
	util.modifyPositionInAndroid( _nodeTable.mFeedCardLabel, 0, 2 ) 		-- 饲料卡标题
    util.modifyPositionInAndroid( _nodeTable.mCoinLabel, 0, 6 )             -- 我的金币值
    util.modifyPositionInAndroid( _nodeTable.mLvTitleLabel, 0, 10 )          -- 我的lv_title
    util.modifyPositionInAndroid( _nodeTable.mNewLevelLabel, 0, 8 )         -- 我的new lv
	util.modifyPositionInAndroid( _nodeTable.mLevelLabel, 0, 8 ) 			-- 我的lv
	
	CCBCenter.bindView("ccb.v.cardgroup.CardEnhancedLayerView", _ccbNode, _nodeTable)

	CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        NetHelper.showLoading(true,true)
        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHINTOENHANCEDCARD)
        -- 更新我的金币
        _ccbNode.updateGold()
    end})
	
end


MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNUPGRADECLICK]	= onBtnUpgradeClick
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONUPDATEUPGRADECARD]	= onUpdateUpgradeCard
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONUPDATEFEEDCARD]	= onUpdateFeedCard
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHUPGRADECARD]	= onActionfetchUpgradeCard
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONPLAYANIMATION]	= onActionPlayAnimation
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONSTOPANIMATION]    = onActionStopAnimation
MSG_HANDLER[MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONFETCHINTOENHANCEDCARD]	= onActionFetchIntoEnhancedCard
