--CardEvolutionLayer.lua

MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL 				= 3600

MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNEVOLUTIONCONFIRMCLICK = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 10
MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNHELPCLICK = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 11
MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNBACKCLICK = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 12
MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 13
MSG_ID.MSG_CARDEVOLUTIONLAYER_ACTION_ONUPDATEEVOLUTIONCARD = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 14
MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOLUTIONCARD = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 15
MSG_ID.MSG_CARDEVOLUTIONLAYER_ACTION_ONUPDATEEVOLUTIONMATERIALCARD = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL + 16

local TAG = "[CardEvolutionLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

-- 处理网络请求失败的回调函数
local function netReceiveFail(result, cbParams)
    -- 显示[购买体力]对话框
    -- AlertLayer.new{
    --     titleStr    = _s("COMMON_NEWS_TIPS"),                           -- 标题
    --     content     = _s("NETWORK_CONNECT_FAILED2"),   -- 内容
    --     btnStr      = { _s("COMMON_OK") },                      -- 按钮文字数组
    --     btnColor    = { AlertLayer.BTN_COLOR_YELLOW },
    --     -- 按钮颜色数组
    --     btnClickEvent = {                   -- 按钮事件数组
    --         function()                      -- 按钮[确定]回调
    --             Log.d(TAG, "请求出错..")
    --             _ccbNode.enableSelectEvoCard(true)
    --             _nodeTable["btnEvolutionConfirm"]:setEnabled(true)
    --             quickui.hideLoadingLayer()
    --         end,
    --     }, 
    -- }
    Log.d(TAG, "请求出错..")
    _ccbNode.enableSelectEvoCard(true)
    _nodeTable["btnEvolutionConfirm"]:setEnabled(true)
    quickui.hideLoadingLayer()
end

local function onBtnEvolutionConfirmClick( msg, luaValue )
	--3600 + 10
	Log.d(TAG, "btnEvolutionConfirm: MSG_ID = %d", MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNEVOLUTIONCONFIRMCLICK)
    local selectCards = _ccbNode.getSelectCard()
    if #selectCards < 1 then
        NetHelper.QuickToast(_s("CARD_SELECT_EVO_CARD"))
    elseif #selectCards < 2 then
        NetHelper.QuickToast(_s("CARD_MATERIAL_CARD_NOT_ENOUGH"))
    elseif #selectCards == 2 then
        -- local costGold = 0
        -- if selectCards[1]:getCardStar() == 4 then
        --     costGold = tonumber(GAMERATE:getEvoFourStarGold())
        -- elseif selectCards[1]:getCardStar() == 5 then
        --     costGold = tonumber(GAMERATE:getEvoFiveStarGold())
        -- end

        -- if costGold > ME:getGold() then
        --     NetHelper.QuickToast(_s("CARD_MONEY_NOT_ENOUGH"))
        --     return
        -- end

        local function onConfirmClick( )
            local data   = {}
            data.cpid1   = selectCards[1]:getCpid()
            data.cpid2   = selectCards[2]:getCpid()
            -- data.usediam = FALSE
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOLUTIONCARD, nil, data)
        end
        -- AlertLayer.new{
        --     btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
        --     btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_YELLOW, },  
        --     titleStr = _s("COMMON_OK"),  --标题
        --     content = _s("CARD_CONFIRM_EVOLUTION") ,--.. "，" .. _s("CARD_USE_MONEY") .. costGold,  --内容
        --     btnClickEvent = {onConfirmClick,},
        -- } 
        if _ccbNode.isMaterialEnough() then
            _nodeTable["btnEvolutionConfirm"]:setEnabled(false)
            onConfirmClick( )
        end
    end
end

local function onBtnHelpClick( msg, luaValue )
	--3600 + 11
	Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNHELPCLICK)
    -- 说明
    CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isEvoRule = true,})
end

local function onBtnBackClick( msg, luaValue )
	--3600 + 12
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onActionEvoCardGroup( msg, luaValue )
	-- 3000 + 13
	Log.d(TAG, "onActionEvoCardGroup: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items, userdata )
		local selectMain = _ccbNode._DATA._SELECTMAIN
        local selectMaterialCard = _ccbNode._DATA._SELECTMATERIALCARD

        _ccbNode._DATA = items

        _ccbNode._DATA._SELECTMAIN = {}
        _ccbNode._DATA._SELECTMAIN = selectMain

        local data = _ccbNode._DATA
        if userdata.isMaterial then
            data._KEY = MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP
        else
            data._KEY = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL
        end
		-- data._KEY = MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL
        
        if userdata.isFinish then
            NetHelper.hideLoading(true)
            _ccbNode.updateMaterialCard{selectCard = _ccbNode._DATA._SELECTMAIN, materialList = items._LIST}
            _ccbNode.updateResultCard(_ccbNode._DATA._SELECTMAIN)
            -- _ccbNode.updateEvolutionCard(msg.userdata)
            -- _ccbNode.updateEvoButtonStatus()
        else
            _ccbNode.enableSelectEvoCard( true )
            CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", data)
        end
		
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
            "model.card.CardModel",
            "fetchEvoCardGroup",
            onFetchCallback,
            msg.userdata
            -- ,
            -- {failedCb = function ( )
            --     _ccbNode.enableSelectEvoCard( true )
            --     quickui.hideLoadingLayer()  
            -- end,}
            )
end

local function onActionUpdateEvolutionCard( msg, luaValue )
    -- 3000 + 14
    Log.d(TAG, "onActionUpdateEvolutionCard: MSG_ID = %d", msg:getMsgId())
    _ccbNode._DATA._SELECTMAIN[1] = msg.userdata.selectCard[1]
    _ccbNode._DATA._SELECTMAIN[2] = nil
    _ccbNode.updateEvolutionCard(msg.userdata)
    -- _ccbNode.updateEvoButtonStatus()
end

local function onActionEvolutionCard( msg, luaValue )
    -- 3000 + 15
    Log.d(TAG, "onActionEvolutionCard: MSG_ID = %d", msg:getMsgId())
    local function onFetchCallback( items )
        -- 执行进化动画
        _ccbNode.playEvoAnim()
        -- 刷新卡组页
        if _ccbNode.fromCardGroup then
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP, nil, {showLoading = false})
        end
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
        "model.card.CardModel",
        "fetchEvolutionCard",
        onFetchCallback,
        msg.userdata--,
        -- {cpid = 0, failedCb = function ( )
        --     _ccbNode.enableSelectEvoCard( true )
        --     quickui.hideLoadingLayer()  
        -- end,}
    )
    -- _ccbNode.playEvoAnim()
end

local function onActionUpdateEvolutionMaterialCard( msg, luaValue )
    -- 3000 + 16
    Log.d(TAG, "onActionUpdateEvolutionMaterialCard: MSG_ID = %d", msg:getMsgId())
    _ccbNode._DATA._SELECTMAIN[2] = msg.userdata.selectCard[1]
    CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP, nil, {isFinish = true, cpid1 = _ccbNode._DATA._SELECTMAIN[1]:getCpid(), cpid2 = _ccbNode._DATA._SELECTMAIN[2]:getCpid()})
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--3600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "CardEvolutionLayer.ccbi")
    _ccbNode.closeLayer = closeLayer
	_ccbNode._DATA = {}
    _ccbNode.fromCardGroup = data.fromCardGroup
	-- Quick element
    _nodeTable["mLayerTitleLabel"] = _ccbNode:getNode("mLayerTitleLabel", "CCLabelTTF")
	_nodeTable["btnEvolutionConfirm"] = _ccbNode:getNode("btnEvolutionConfirm", "CCControlButton")
    _nodeTable["mSelectMainCardLabel"] = _ccbNode:getTTFLabel("mSelectMainCardLabel", _s("CARD_EVOLUTION_SELECT_CARD"))
    _nodeTable["mSelectMaterialCardLabel"] = _ccbNode:getTTFLabel("mSelectMaterialCardLabel", _s("CARD_EVOLUTION_MATERIAL_CARD"))
    
	-- CCControlButton
	_ccbNode:bindButton("btnEvolutionConfirm", onBtnEvolutionConfirmClick, _s("CARD_EVOLUTION_CARD"))
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

    -- android上的位置调整
    util.modifyPositionInAndroid( _nodeTable.mLayerTitleLabel, 0, 2 )     -- 标题

    -- 填充文字
    _nodeTable["mLayerTitleLabel"]:setString(_s("CARD_EVOLUTION"))

	CCBCenter.bindView("ccb.v.cardgroup.CardEvolutionLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( )
			-- _ccbNode.playLightAnim( )
		end})
	end
end


MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNEVOLUTIONCONFIRMCLICK]	= onBtnEvolutionConfirmClick
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNHELPCLICK]	= onBtnHelpClick
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP] = onActionEvoCardGroup
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ACTION_ONUPDATEEVOLUTIONCARD]	= onActionUpdateEvolutionCard
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOLUTIONCARD] = onActionEvolutionCard
MSG_HANDLER[MSG_ID.MSG_CARDEVOLUTIONLAYER_ACTION_ONUPDATEEVOLUTIONMATERIALCARD] = onActionUpdateEvolutionMaterialCard