MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL 				= 3500

MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNBACKCLICK = MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL + 10
MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHFRAGMENT = MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL + 11
MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHRECEIVECARDFRAGMENT = MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL + 12
MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNHELPCLICK = MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL + 13

local TAG = "[CardFragmentLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popSecondCCBNode(anim.ANIMATION_TOP_OUT)
end

-- 播放按钮音乐
local function playBtnSound( )
	SOUND:playEffectButton1()
end

local function onBtnBackClick( msg, luaValue )
	--3500 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNBACKCLICK)
	playBtnSound( )
	closeLayer()
end

local function onBtnHelpClick( msg, luaValue )
    --3500 + 13
    Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNHELPCLICK)
    -- 说明
    CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isCardFragmentRule = true,})
end

local function onActionFetchFragment( msg, luaValue )
	-- 3500 + 11
	Log.d(TAG, "onActionFetchFragment: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        _ccbNode.fillFragmentCard(items)
        -- 更新卡组
        if _ccbNode._RECEIVE then
        	_ccbNode._RECEIVE = false
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP)
        end
		quickui.hideLoadingLayer()
    end
    ModelHelper.requireDataWithFun(
            "model.card.CardModel",
            "fetchCardFragment",
            onFetchCallback
            )
end

local function onActionfetchReceiveCardFragment( msg, luaValue )
	-- 3500 + 12
	Log.d(TAG, "onActionfetchReceiveCardFragment: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		-- 更新碎片
        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHFRAGMENT)
    end
    ModelHelper.requireDataWithFun(
            "model.card.CardModel",
            "fetchReceiveCardFragment",
            onFetchCallback,
            msg.userdata
            )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--3500
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "CardFragmentLayer.ccbi")
	-- _ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_CARDGROUPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mLayerTitleLabel"] = _ccbNode:getNode("mLayerTitleLabel", "CCLabelTTF")
	-- CCControlButton
    _ccbNode:bindButton("btnBack", onBtnBackClick)
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- 填充文字
	_nodeTable["mLayerTitleLabel"]:setString(_s("CARD_FRAGMENT"))
	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mLayerTitleLabel, 0, 2 ) 			-- 标题

	CCBCenter.bindView("ccb.v.cardgroup.CardFragmentLayerView", _ccbNode, _nodeTable)
	CCBCenter.pushSecondCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {
		onComplete = function ( )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHFRAGMENT)
		end
		})
end
MSG_HANDLER[MSG_ID.MSG_CARDFRAGMENTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHFRAGMENT]	= onActionFetchFragment
MSG_HANDLER[MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHRECEIVECARDFRAGMENT] = onActionfetchReceiveCardFragment
MSG_HANDLER[MSG_ID.MSG_CARDFRAGMENTLAYER_ONBTNHELPCLICK]	= onBtnHelpClick
