MSG_ID.MSG_CARDGROUPLAYER_MODEL 				= 3000
MSG_ID.MSG_CARDGROUPLAYER_CCB_LOAD_BACK		= MSG_ID.MSG_CARDGROUPLAYER_MODEL + 1
MSG_ID.MSG_CARDGROUPLAYER_NODE_LOADED		= MSG_ID.MSG_CARDGROUPLAYER_MODEL + 2

MSG_ID.MSG_CARDGROUPLAYER_ONBTNENHANCEDCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 10
MSG_ID.MSG_CARDGROUPLAYER_ONBTNALBUMCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 11
MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 12
MSG_ID.MSG_CARDGROUPLAYER_ONBTNSWITCHCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 13
MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 14
MSG_ID.MSG_CARDGROUPLAYER_ONBTNFRAGMENTCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 15
MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 16
MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 17
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 18
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONUPDATEDATA = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 19
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONSTOPCONFIGANIMATION = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 20
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONPLAYCONFIGANIMATION = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 21
MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 22
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHSWITCHCARD = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 23
MSG_ID.MSG_CARDGROUPLAYER_ONBTNEVOLUTIONCLICK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 24
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONHELPJUDGE = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 25
MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHUNLOCK = MSG_ID.MSG_CARDGROUPLAYER_MODEL + 26

local TAG = "[CardGroupLayer]"
local _ccbNode
local _nodeTable = {}
-- local _cardGroup
local _playAnimation
local _unlockLevel = require("static.unlock_level")

local function closeLayer()
	--CCBCenter.popFirstCCBNode()
	game.enterMainLayer()
end

-- 播放按钮音乐
local function playBtnSound( )
	SOUND:playEffectButton1()
end

local function onBtnEnhancedClick( msg, luaValue )
	--3000 + 10
	Log.d(TAG, "onBtnEnhancedClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNENHANCEDCLICK)
	playBtnSound( )
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
    if not ME:getTriggerMsgEntity():isUnlockEnhanced() then
        NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.ENHANCED, _s("CARD_ENHANCED")))
        return
    end
	-- local data = _ccbNode._DATA -- :getCards()
	HelperView2.showNext()
	CCBCenter.loadCCB("MSG_CARDENHANCEDLAYER_MODEL", "ccb.c.cardgroup.CardEnhancedLayer", {fromCardGroup = true})
end

local function onBtnAlbumClick( msg, luaValue )
	--3000 + 11
	Log.d(TAG, "onBtnAlbumClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNALBUMCLICK)
	playBtnSound( )
	quickui.showLoadingLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	CCBCenter.loadCCB("MSG_CARDALBUMLAYER_MODEL", "ccb.c.cardgroup.CardAlbumLayer")
end
 
local function onBtnSellClick( msg, luaValue )
	--3000 + 12
	Log.d(TAG, "onBtnSellClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK)
	playBtnSound( )
	quickui.showLoadingLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	local data = _ccbNode._DATA -- :getCards()
	data._KEY = MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK
	CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", data)
end

local function onBtnSwitchClick( msg, luaValue )
	--3000 + 13
	Log.d(TAG, "onBtnSwitchClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNSWITCHCLICK)
	playBtnSound( )
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	_ccbNode.showSwitchLayer()
end

local function onBtnEvolutionClick( msg, luaValue )
	--3000 + 13
	Log.d(TAG, "onBtnEvolutionClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNEVOLUTIONCLICK)
	playBtnSound( )
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	if not ME:getTriggerMsgEntity():isUnlockEvolution() then
        NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.EVOLUTION, _s("CARD_EVOLUTION")))
        return
    end
	HelperView2.showNext()
	CCBCenter.loadCCB("MSG_CARDEVOLUTIONLAYER_MODEL", "ccb.c.cardgroup.CardEvolutionLayer", {fromCardGroup = true})
end

local function onBtnProtectionClick( msg, luaValue )
	--3000 + 14
	Log.d(TAG, "onBtnProtectionClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK)
	playBtnSound( )
	quickui.showLoadingLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	local data = _ccbNode._DATA -- :getCards()
	data._KEY = MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK
	CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", data)
end

local function onBtnFragmentClick( msg, luaValue )
	--3000 + 15
	Log.d(TAG, "onBtnFragmentClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNFRAGMENTCLICK)
	playBtnSound( )
	CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	if not ME:getTriggerMsgEntity():isUnlockChip() then
        NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.CARDCHIP, _s("CARD_FRAGMENT")))
        return
    end
	quickui.showLoadingLayer()
	HelperView2.showNext()
	CCBCenter.loadCCB("MSG_CARDFRAGMENTLAYER_MODEL", "ccb.c.cardgroup.CardFragmentLayer")
end

local function onBtnConfigClick( msg, luaValue )
	--3000 + 16
	Log.d(TAG, "onBtnConfigClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK)
	playBtnSound( )
	_ccbNode.toggleConfigButton(false)
	_playAnimation = true
end

local function onBtnConfirmClick( msg, luaValue )
	--3000 + 17
	Log.d(TAG, "onBtnConfirmClick: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
	playBtnSound( )
	_ccbNode.toggleConfigButton(true)
	_playAnimation = false
end

local function onActionFetchCardGroup( msg, luaValue )
	-- 3000 + 18
	Log.d(TAG, "onActionFetchCardGroup: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        -- _cardGroup = items
        _ccbNode._DATA = items
        -- CARD_CACHE = items
        -- _ccbNode.updateData(items)
        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONUPDATEDATA, nil, items)
        if _ccbNode._TOENHANCED then
        	_ccbNode._TOENHANCED = false
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNENHANCEDCLICK)
		end
    end
    ModelHelper.requireDataWithFun(
        "model.card.CardModel",
        "fetchIntoCardGroup",
        onFetchCallback,
        msg.userdata
        -- {showLoading = false}
        -- -- msg.userdata
    )
end
-- 更新数据
local function onActionUpdateData( msg, luaValue )
	-- 3000 + 19
	Log.d(TAG, "onActionUpdateData: MSG_ID = %d", msg:getMsgId())
	if msg.userdata then 
		_ccbNode._DATA = msg.userdata
		_ccbNode.updateData(msg.userdata)
	end
end

local function onActionHelpJudge( msg, luaValue )
	_ccbNode.checkHelperInfo()
end

local function onActionStopConfigAnimation( msg, luaValue )
	-- 3000 + 20
	Log.d(TAG, "onActionStopConfigAnimation: MSG_ID = %d", msg:getMsgId())
	_playAnimation = false
end

local function onActionPlayConfigAnimation( msg, luaValue )
	-- 3000 + 21
	Log.d(TAG, "onActionPlayConfigAnimation: MSG_ID = %d", msg:getMsgId())
	_playAnimation = true
	_ccbNode:playCCBAnimation("Flash")
end

-- 切换卡组
local function onActionFetchSwitchCard( msg, luaValue )
	-- 2000 + 23
	Log.d(TAG, "onActionFetchSwitchCard: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        _ccbNode._DATA = items
        -- 更新卡组界面
        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONUPDATEDATA, nil, items)
        quickui.hideLoadingLayer()
    end
    ModelHelper.requireDataWithFun(
            "model.card.CardModel",
            "fetchSwitchCard",
            onFetchCallback,
            msg.userdata,
            {failedCb = function ( )
            	quickui.hideLoadingLayer()
            end}
            )
end

-- 解锁卡组与卡槽
local function onActionFetchUnlock( msg, luaValue )
	-- 2000 + 23
	Log.d(TAG, "onActionFetchUnlock: MSG_ID = %d", msg:getMsgId())
	-- 处理网络请求失败的回调函数
	local function netReceiveFail_()
	    -- 显示[购买体力]对话框
	    AlertLayer.new{
	        titleStr    = _s("COMMON_NEWS_TIPS"),           -- 标题
	        content     = _s("NETWORK_CONNECT_FAILED2"),    -- 内容
	        btnStr      = { _s("COMMON_OK") },        		-- 按钮文字数组
	        btnColor    = { AlertLayer.BTN_COLOR_YELLOW },  -- 按钮颜色数组
	        btnClickEvent = {                   			-- 按钮事件数组
	            function()                      			-- 按钮[确定]回调
	                -- print("出错[保存新手帮助步骤]回调")
	            end,
	        }, 
	    }
	end
	local function onFetchCallback( items )
		Log.d(TAG, "Unlock")
    end
    NetHelper.createRequest(
        ACTID.MSG_UPDATE_EVEN,              -- 请求ID
       	onFetchCallback,                    -- 回调函数
       	{                                   -- 请求信息实体或参数Table
            tno = msg.userdata, 			-- 步骤索引
            typ = 3,
       	},
       	{
            failedCb = netReceiveFail_,     -- 请求失败回调函数
        }
    )
end

local function animationCompletedCallback( animationManager, animName, luaEventHandler )
	-- Log.d(TAG, "animationCompletedCallback: %s", animName)
	-- 循环播放动画
	if animName == "Flash" then 
		if _playAnimation then
			_ccbNode:playCCBAnimation("Flash")
		end
	end
end
local function onCCBLoad(data, callback)
	--3000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CARDGROUPLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "CardGroupLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_CARDGROUPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mLevelLabel"] = _ccbNode:getNode("mLevelLabel", "CCLabelTTF")
	_nodeTable["mCostLabel"] = _ccbNode:getNode("mCostLabel", "CCLabelTTF")
	_nodeTable["mNameLabel"] = _ccbNode:getNode("mNameLabel", "CCLabelTTF")
	_nodeTable["mAtkLabel"] = _ccbNode:getNode("mAtkLabel", "CCLabelTTF")
	_nodeTable["mHpLabel"] = _ccbNode:getNode("mHpLabel", "CCLabelTTF")
	_nodeTable["mServiceLabel"] = _ccbNode:getNode("mServiceLabel", "CCLabelTTF")
	_nodeTable["mSpTitleLabel"] = _ccbNode:getNode("mSpTitleLabel", "CCLabelTTF")
	_nodeTable["mSpFullLabel"] = _ccbNode:getNode("mSpFullLabel", "CCLabelTTF")
	_nodeTable["mCurGroupLabel"] = _ccbNode:getNode("mCurGroupLabel", "CCLabelTTF")
	_nodeTable["mCostTitleLabel"] = _ccbNode:getNode("mCostTitleLabel", "CCLabelTTF")
	_nodeTable["mCurFightLabel"] = _ccbNode:getNode("mCurFightLabel", "CCLabelTTF")
	_nodeTable["mTotalAttackLabel"] = _ccbNode:getNode("mTotalAttackLabel", "CCLabelTTF")
	_nodeTable["mTotalHpLabel"] = _ccbNode:getNode("mTotalHpLabel", "CCLabelTTF")
	_nodeTable["mCurServiceLabel"] = _ccbNode:getNode("mCurServiceLabel", "CCLabelTTF")
	_nodeTable["mUnlockOneLabel"] = _ccbNode:getNode("mUnlockOneLabel", "CCLabelTTF")
	_nodeTable["mUnlockTwoLabel"] = _ccbNode:getNode("mUnlockTwoLabel", "CCLabelTTF")
	_nodeTable["mUnlockThreeLabel"] = _ccbNode:getNode("mUnlockThreeLabel", "CCLabelTTF")
	_nodeTable["mUnlockFourLabel"] = _ccbNode:getNode("mUnlockFourLabel", "CCLabelTTF")
	_nodeTable["mUnlockFiveLabel"] = _ccbNode:getNode("mUnlockFiveLabel", "CCLabelTTF")
	_nodeTable["mUnlockSixLabel"] = _ccbNode:getNode("mUnlockSixLabel", "CCLabelTTF")
	_nodeTable["mUnlockSevenLabel"] = _ccbNode:getNode("mUnlockSevenLabel", "CCLabelTTF")
	_nodeTable["mHPLabel"] = _ccbNode:getNode("mHPLabel", "CCLabelTTF")
	_nodeTable["mSPLabel"] = _ccbNode:getNode("mSPLabel", "CCLabelTTF")
	_nodeTable["mEXPLabel"] = _ccbNode:getNode("mEXPLabel", "CCLabelTTF")
	
	_ccbNode:bindButton("btnEnhanced", onBtnEnhancedClick, _s("CARD_ENHANCED")) 
	_ccbNode:bindButton("btnAlbum", onBtnAlbumClick, _s("CARD_ALBUM"))
	_ccbNode:bindButton("btnSell", onBtnSellClick, _s("CARD_SELL"))
	_ccbNode:bindButton("btnSwitch", onBtnSwitchClick, _s("CARD_SWITCH"))
	_ccbNode:bindButton("btnEvolution", onBtnEvolutionClick, _s("CARD_EVOLUTION"))
	_ccbNode:bindButton("btnProtection", onBtnProtectionClick, _s("CARD_PROTECTION"))
	_ccbNode:bindButton("btnFragment", onBtnFragmentClick, _s("CARD_FRAGMENT"))
	_ccbNode:bindButton("btnConfig", onBtnConfigClick, _s("CARD_CONFIG"))
	_ccbNode:bindButton("btnConfirm", onBtnConfirmClick, _s("CARD_CONFIRM"))
	_ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mNameLabel, 0, 6 ) -- 名字
	-- util.modifyPositionInAndroid( _nodeTable.mLevelLabel, 0, -2 ) -- 等级
	util.modifyPositionInAndroid( _nodeTable.mCostTitleLabel, 0, 2 ) -- 召唤值标题
	util.modifyPositionInAndroid( _nodeTable.mCostLabel, 0, 2 ) -- 召唤值
	-- util.modifyPositionInAndroid( _nodeTable.mCurGroupLabel, 0, 4 ) -- 当前卡组
	util.modifyPositionInAndroid( _nodeTable.mServiceLabel, 0, 8 ) -- 服务器
	util.modifyPositionInAndroid( _nodeTable.mAtkLabel, 0, 2 ) -- 总攻击
	util.modifyPositionInAndroid( _nodeTable.mHpLabel, 0, 2 ) -- 总血量

	-- 填充文字
	_nodeTable["mCostTitleLabel"]:setString(_s("ROLE_COST"))
	_nodeTable["mSpFullLabel"]:setString(_s("ROLE_SP_FULL"))
	_nodeTable["mSpTitleLabel"]:setString(_s("ROLE_SP_TIME"))
	_nodeTable["mCurFightLabel"]:setString(_s("CARD_CUR_FIGHT"))
	_nodeTable["mTotalAttackLabel"]:setString(_s("CARD_TOTAL_ATTACK"))
	_nodeTable["mTotalHpLabel"]:setString(_s("CARD_TOTAL_HP"))
	_nodeTable["mCurServiceLabel"]:setString(_s("CARD_CUR_SERVICE"))
	_nodeTable["mUnlockOneLabel"]:setString(_s("CARD_UNLOCK_LEVEL_ONE"))
	_nodeTable["mUnlockTwoLabel"]:setString(_s("CARD_UNLOCK_LEVEL_TWO"))
	_nodeTable["mUnlockThreeLabel"]:setString(_s("CARD_UNLOCK_LEVEL_THREE"))
	_nodeTable["mUnlockFourLabel"]:setString(_s("CARD_UNLOCK_LEVEL_FOUR"))
	_nodeTable["mUnlockFiveLabel"]:setString(_s("CARD_UNLOCK_LEVEL_FIVE"))
	_nodeTable["mUnlockSixLabel"]:setString(_s("CARD_UNLOCK_LEVEL_SIX"))
	_nodeTable["mUnlockSevenLabel"]:setString(_s("CARD_UNLOCK_LEVEL_SEVEN"))
	_nodeTable["mHPLabel"]:setString(_s("CARDGROUP_HP"))
	_nodeTable["mSPLabel"]:setString(_s("CARDGROUP_SP"))
	_nodeTable["mEXPLabel"]:setString(_s("CARDGROUP_EXP"))

	CCBCenter.bindView("ccb.v.cardgroup.CardGroupLayerView", _ccbNode, _nodeTable)
	

	_ccbNode._TOENHANCED = data.toEnhanced

	_ccbNode.requestDataForLoad = function ()
		-- quickui.showLoadingLayer()
		CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP)
	end	

	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end
	_ccbNode.initHelperInfo()
	_ccbNode.checkHelperInfo()
end

MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_CCB_LOAD_BACK]		= onCCBLoadBack
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_NODE_LOADED]		= onNodeLoaded

MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNENHANCEDCLICK]	= onBtnEnhancedClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNALBUMCLICK]	= onBtnAlbumClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK]	= onBtnSellClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNSWITCHCLICK]	= onBtnSwitchClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNEVOLUTIONCLICK]	= onBtnEvolutionClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK]	= onBtnProtectionClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNFRAGMENTCLICK]	= onBtnFragmentClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK]	= onBtnConfigClick
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK]	= onBtnConfirmClick

MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHCARDGROUP]	= onActionFetchCardGroup
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONUPDATEDATA]	= onActionUpdateData
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONSTOPCONFIGANIMATION]	= onActionStopConfigAnimation
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONPLAYCONFIGANIMATION]	= onActionPlayConfigAnimation
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHSWITCHCARD]	= onActionFetchSwitchCard
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONHELPJUDGE] = onActionHelpJudge
MSG_HANDLER[MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHUNLOCK] = onActionFetchUnlock
