--ChatLayer.lua

MSG_ID.MSG_CHATLAYER_MODEL 				= 10000

MSG_ID.MSG_CHATLAYER_ONBTNBACKCLICK = MSG_ID.MSG_CHATLAYER_MODEL + 10
MSG_ID.MSG_CHATLAYER_SENDMSG = MSG_ID.MSG_CHATLAYER_MODEL + 11
MSG_ID.MSG_CHATLAYER_ACTION_ONTOGGLESENDENABLE = MSG_ID.MSG_CHATLAYER_MODEL + 12

local TAG = "[ChatLayer]"
local _ccbNode 
local _nodeTable = {}

local CHAT_REC_TIME = 3 --聊天消息刷新时间

local ChatUtil = require("ccb.m.chat.ChatUtil")
local Chat = require("ccb.m.chat.EntityChat")
-- local BadwordDB   = require("db.badworddb") --数据库
-- local badwords

local function resetMessage( properties )


    -- 加到信息集合
        if properties then 
            for i=1,#properties do
                local item = properties[i]

                if item  then -- and (item:getSenderId() ~= ME:getUserid() or item:getMessageType() == ChatUtil.ChatSystem)


                    -- 判断BigShow为0或1情况
                    if item:getIsBigShow() == 0 or item:getIsBigShow() == 1 then 
                        -- 初始化表格集合
                        local initItem = {}
                        local initItem2 = {}
                        -- 消息头添加消息类型
                        initItem[#initItem + 1] = { f = 0 , w = "["..ChatUtil.ChatTypeStr[item:getMessageType()].."]"}
                        initItem2[#initItem2 + 1] = { f = 0 , w = "["..ChatUtil.ChatTypeStr[item:getMessageType()].."]"}

                        -- 添加消息发送人
                        local nname = item:getSenderNickName() or ""
                        if nname ~= "" and item:getMessageType() ~= ChatUtil.ChatSystem then 
                            nname = nname .. "：" 
                        end
                        if item:getSenderId() == -1 then item:setSenderId(ME:getUserid()) end
                        initItem[#initItem + 1] = { f = 1 , w = nname, o = item:getSenderId()}
                        initItem2[#initItem2 + 1] = { f = 1 , w = nname, o = item:getSenderId()}

                        -- 生成表格集合
                        local cellItems = ChatUtil.createCellItems(initItem,item:getContent())
                        for i=1,#cellItems do
                            chat_messages[#chat_messages + 1] = { cellItem = cellItems[i], ctype = item:getMessageType(), key = item:getKey() }
                        end

                        local cellItems2 = ChatUtil.createCellItems(initItem2,item:getContent(),500)
                        -- print("....___________________....."..item:getContent())
                        for i=1,#cellItems2 do
                            -- print("__________"..json.encode(cellItems2[i]))
                            chat_messages2[#chat_messages2 + 1] = { cellItem = cellItems2[i], ctype = item:getMessageType(), key = item:getKey() }
                        end
                        

                        if item:getIsBigShow() == 1 then
                            -- postMessage[#postMessage + 1] = item:getContent()
                            
                            if _scrollLabel ~= nil then
                                CCBCenter.getNodeByTag(_node, 6):setVisible(true)

                                local showword = ChatUtil.filterFlag( item:getContent() )

                                _scrollLabel.playText({text = item:getSenderNickName()..":".. showword, size = 30, color = COLOR3.WHITE})
                            end
                        elseif item:getIsBigShow() == 0 then 

                            if scrollTalkPanel ~= nil then 

                                scrollTalkPanel.setNewMessage({messages = chat_messages2})
                            end
                        end
                    end

                    -- 判断BigShow为2情况（幸运转盘）
                    if item:getIsBigShow() == 2 then 
                        -- 初始化表格集合
                        local initItem = {}

                        -- 消息头添加消息类型
                        initItem[#initItem + 1] = { f = 0 , w = _s("CHAT_INITIAL_WHEEL"), }

                        -- 添加消息发送人
                        local nname = item:getSenderNickName() or ""
                        if item:getSenderId() == -1 then item:setSenderId(ME:getUserid()) end
                        initItem[#initItem + 1] = { f = 1 , w = nname, o = item:getSenderId()}

                        ---------------------------------------------------------------------------------------------------------------
                        -- 意图：根据是否是当前玩家的获奖消息来加入到不同的消息集中，对于非玩家自身的消息都先列出，自己的奖励消息待转盘动画结束后列出
                        ---------------------------------------------------------------------------------------------------------------
                        -- 消息集合
                        local globalMessages = (nname == ME:getName()) and globalMessageMeFW or globalMessagesFW            -- (item:getSenderId() == ME:getUserid())
                        -- 生成表格集合
                        local cellItems = ChatUtil.createCellItems(initItem, item:getContent(), 605)
                        for i = 1, #cellItems do
                            table.insert(globalMessages, { cellItem = cellItems[i], ctype = item:getMessageType(), key = item:getKey() })
                        end
                    end
                    -- print("数量:"..#postMessage)
                end
            end
        end

        -- 太多了，清除1页
        if #chat_messages > ChatUtil.maxMsgCount then 
            local count = #chat_messages - ChatUtil.maxMsgCount
            for i=1,count do
                table.remove(chat_messages,1)
                -- print("chat_messages ",json.encode(chat_messages))
            end
        end

        _ccbNode.reloadRecMsg()
end

--[[

-   回调函数

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_recchat( properties, params )
	Log.d(TAG,"chat: %s",json.encode(properties))
	local messages = Chat.new(properties)
	resetMessage(messages:getItems())
end


function callback_SENDCHAT( properties, params )
	-- print("~~~~~~ss ", params)
end

local function sendFailed( res, params )
	
	local key = params
	for i=1,#chat_messages do
		if key == chat_messages[i].key then 
			-- print("sendFailed ", key)
		end
	end
end

--[[

-   发送聊天信息
--]]
local function sendChatRequest()

	if ME:getNospeaktime() > 0 then 

		local time = ME:getNospeaktime() --2*24*60 + 3*60 + 45
		local d = math.floor(time/(24*60))
		local h = math.floor((time%(24*60))/60)
		local m = (time%(24*60))%60
		local text = string.format(_s("CHAT_STOP_SPEECH"), d, h, m)

		NetHelper.QuickToast(text)
    return
	end 

	if _ccbNode.getSendMsg == nil then return end
	if _ccbNode.getSendMsg and string.trim(_ccbNode.getSendMsg()) ==  "" then 
		Log.d(TAG,"空信息")
		return
	end

	local key = os.time()

	local content = _ccbNode.getSendMsg()

	-- if badwords == nil then
	-- 	badwords = BadWrodDB.getAllBadWrodContent()
	-- end
	
	-- for i=1,#badwords do

	-- 	content = string.gsub(content, badwords[i], "**") 
	-- end

	--   创建http请求
	NetHelper.createRequest(
	    
	   ACTID.MSG_SEND_CHAT,         --      请求id
	   callback_SENDCHAT,                   		--    	回调函数
	   	{
	   		messagetype = ChatUtil.ChatWorld,	-- 消息类型 默认都是世界
			content = _ccbNode.getSendMsg(),	-- 内容   
			touserid = 0,                        -- 接收者id，这里为0

		},										-- 请求信息实体或参数table
		{ 
			showLoading = false,
			failedCb = sendFailed,
			cbParams = key
		}					        
	)

		-- if false and LOGINBASEINFO.usertype ~= SDK_91 then 

			-- -- 自己的信息直接发送出去显示
			-- local sendMsg = { items = {} }
			-- local items = sendMsg.items

			-- local sendMsgItem = 
			-- {
		 --     	senderId = -1,--values.userid,
		 --        senderNickName = ME:getName(),
		 --        -- vipLevel = 0,
		 --        -- msgId = 0,
		 --        content = content,--"12345678[90]一二[小僵尸][三四五六][]][2adalds]",
		 --        sendTime = 0,
		 --        messageType = ChatUtil.ChatWorld,
		 --        key = key,
		 --        isBigShow = 0
			-- }

			-- items[#items + 1] = sendMsgItem
			-- local messages = Chat.new(sendMsg)
			-- resetMessage(messages:getItems())

		-- end




	-- 清空发送消息
	_ccbNode.clearSendMsg()
end



local function closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ENABLEMESSAGESCHEDULE, nil, true)
	CCBCenter.popSecondCCBNode(anim.ANIMATION_BOTTOM_OUT)
end


local function onBtnBackClick( msg, luaValue )
	--10000 + 11
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_CHATLAYER_ONBTNBACKCLICK)

	closeLayer()
end

local function onToggleSendEnable( msg, luaValue )
	--10000 + 12
	Log.d(TAG, "onToggleSendEnable: MSG_ID = %d", MSG_ID.MSG_CHATLAYER_ACTION_ONTOGGLESENDENABLE)
	_ccbNode.toggleSendMsgEnable()
end

--[[

-   获取聊天信息
--]]
local function recChatRequest()
	--   创建http请求
	NetHelper.createRequest(
	    
	   ACTID.MSG_GET_CHATLIST,                   --      请求id
	   callback_recchat,                   --    	回调函数
	   { kind = ChatUtil.ChatWorld, typ = 2, },
	   { showLoading = false }
	)
-- _ccbNode.reloadRecMsg()
end 

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--10000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CHATLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ChatLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
	_nodeTable["btnBack"] = _ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.chat.ChatLayerView", _ccbNode, _nodeTable)

	_ccbNode.onEnter = function ( self )
		-- print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ ChatLayer onEnter @@@")
		_sdkPlatform.hideToolBar()
	end
	_ccbNode.onExit = function ( self )
		-- print("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ ChatLayer onExit @@@")
		_sdkPlatform.showToolBar()
	end


	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushSecondCCBNode(_ccbNode, anim.ANIMATION_BOTTOM_IN, {
			onComplete = function ( )
				-- 定时接收聊天信息
			 	_ccbNode:schedule(recChatRequest, 3.0)
			end
			})
	end

end


MSG_HANDLER[MSG_ID.MSG_CHATLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_CHATLAYER_ONBTNBACKCLICK]	= onBtnBackClick

MSG_HANDLER[MSG_ID.MSG_CHATLAYER_SENDMSG] = sendChatRequest

MSG_HANDLER[MSG_ID.MSG_CHATLAYER_ACTION_ONTOGGLESENDENABLE]	= onToggleSendEnable