--ComicOpening_05_Layer.lua

MSG_ID.MSG_COMICOPENING_05_LAYER_MODEL 				= 26400
MSG_ID.MSG_COMICOPENING_05_LAYER_ONBTNSKIPCLICK 	= MSG_ID.MSG_COMICOPENING_01_LAYER_MODEL + 10

local TAG = "[ComicOpening_05_Layer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

local function animationCompletedCallback( animationManager, animName, luaEventHandler )
	Log.d(TAG, "animationCompletedCallback: %s", animName)
	if "play" == animName then
		-- 我已经动完了
		_ccbNode._isFinish = true
	elseif "End" == animName then
		-- 结束动画已经over了, 执行下一场景
		-- CCBCenter.replaceLayer("MSG_COMICOPENING_01_LAYER_MODEL", "ccb.c.comic.ComicOpening_01_Layer")
        SOUND:playMusicHome()
		CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
	end
end

local function onBtnSkipClick( msg, luaValue )
	Log.d(TAG, "onBtnSkipClick: MSG_ID = %d", MSG_ID.MSG_COMICOPENING_01_LAYER_ONBTNSKIPCLICK)
	SOUND:playMusicHome()
	_ccbNode:getAnimationManager():getRootNode():stopAllActions()
	closeLayer()
	CCBCenter.replaceLayer(MAINLAYER_ID, MAINLAYER_PATH)
end

local function onCCBLoad(data, callback)
	--26400
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_COMICOPENING_05_LAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ComicOpening_05_Layer.ccbi")
	-- Quick element
	_nodeTable["mDialog1Label"] = _ccbNode:getNode("mDialog1Label", "CCLabelTTF")
	_nodeTable["mDialog2Label"] = _ccbNode:getNode("mDialog2Label", "CCLabelTTF")
	_nodeTable["mDialog3Label"] = _ccbNode:getNode("mDialog3Label", "CCLabelTTF")
	_nodeTable["mDialog4Label"] = _ccbNode:getNode("mDialog4Label", "CCLabelTTF")
	_nodeTable["mDialog5Label"] = _ccbNode:getNode("mDialog5Label", "CCLabelTTF")
	_nodeTable["mDialog6Label"] = _ccbNode:getNode("mDialog6Label", "CCLabelTTF")
	_nodeTable["mDialog7Label"] = _ccbNode:getNode("mDialog7Label", "CCLabelTTF")

	_nodeTable["btnSkip"] = _ccbNode:getNode("btnSkip", "CCControlButton")
	-- _nodeTable["btnSkip"]:setVisible(false)
	-- CCControlButton
	_ccbNode:bindButton("btnSkip", onBtnSkipClick)
	-- MenuItem
	_ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	_nodeTable["mDialog1Label"]:setString(_s("COMICOPENING_05_01"))
	_nodeTable["mDialog2Label"]:setString(_s("COMICOPENING_05_02"))
	_nodeTable["mDialog3Label"]:setString(_s("COMICOPENING_05_03"))
	_nodeTable["mDialog4Label"]:setString(_s("COMICOPENING_05_04"))
	_nodeTable["mDialog5Label"]:setString(_s("COMICOPENING_05_05"))
	_nodeTable["mDialog6Label"]:setString(_s("COMICOPENING_05_06"))
	_nodeTable["mDialog7Label"]:setString(_s("COMICOPENING_05_07"))

	CCBCenter.bindView("ccb.v.comic.ComicOpening_05_LayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_COMICOPENING_05_LAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_COMICOPENING_05_LAYER_ONBTNSKIPCLICK]	= onBtnSkipClick
