--AlertLayer.lua

MSG_ID.MSG_ALERTLAYER_MODEL 				= 11100

local TAG = "[AlertLayer]"
local _ccbNode 
local _nodeTable = {}

local btn1ClickEvent
local btn2ClickEvent
local btn3ClickEvent

local _ccbLevel = nil

local function closeLayer()
	-- CCBCenter.popThirdCCBNode()
	-- CCBCenter.popSecondCCBNode()
	if isnumber(_ccbLevel) then 
		CCBCenter.popLevelCCBNode(_ccbLevel)
	else
		CCBCenter.popLastLevelCCBNode()
	end
	ISOPENALERT = false
	return 99
end


local function onBtn1Click()
	closeLayer()
	if btn1ClickEvent then 
		btn1ClickEvent()
	end

	if _ccbNode.isAlert then
		DiamondAlertEntity:updateValue(_ccbNode.diamondIndex,_ccbNode.newIsAlert)
	end
end

local function onBtn2Click()
	closeLayer()
	if btn2ClickEvent then 
		btn2ClickEvent()
	end
end

local function onBtn3Click()
	closeLayer()
	if btn3ClickEvent then 
		btn3ClickEvent()
	end
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--11001
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "AlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["lblTitle"] = _ccbNode:getNode("lblTitle", "CCLabelTTF")
	_nodeTable["lblContent"] = _ccbNode:getNode("lblContent", "CCLabelTTF")

	_ccbNode.btnStr = data.btnStr -- 按钮文字数组
	_ccbNode.btnColor = data.btnColor -- 按钮颜色数组
	_ccbNode.titleStr = data.titleStr -- 标题文字
	_ccbNode.content = data.content -- 内容
	_ccbNode.btnPriority = data.btnPriority -- 按键优先级
	_ccbNode.noanim = data.noanim -- bool 不需要动画,默认为false
	_ccbNode.btnClickEvent = { onBtn1Click,onBtn2Click,onBtn3Click } -- 按钮事件数组
	_ccbNode._IGNOR_PRESS_BACK = data.ignorPressBack
	_ccbNode.isAlert = data.isAlert --是否弹窗
	_ccbNode.diamondIndex = data.diamondIndex

	_ccbNode.newIsAlert =	1

	data.btnClickEvent = data.btnClickEvent or {}
	btn1ClickEvent = data.btnClickEvent[1]
	btn2ClickEvent = data.btnClickEvent[2]
	btn3ClickEvent = data.btnClickEvent[3]

	_ccbLevel = data.ccbLevel

	if ISOPENALERT then 
		closeLayer()
	end
	ISOPENALERT = true

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- 填充文字
	_nodeTable["lblTitle"]:setString(_s("COMMON_NEWS_TIPS"))
	CCBCenter.bindView("ccb.v.common.AlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		-- CCBCenter.pushSecondCCBNode(_ccbNode)
		-- CCBCenter.pushThirdCCBNode(_ccbNode)
		if isnumber(_ccbLevel) then 
			CCBCenter.pushLevelCCBNode(_ccbLevel, _ccbNode)
		else
			CCBCenter.pushLastLevelCCBNode(_ccbNode)
		end
	end

end


MSG_HANDLER[MSG_ID.MSG_ALERTLAYER_MODEL]				= onCCBLoad
