--AntiPlugAlertLayer.lua

MSG_ID.MSG_ANTIPLUGALERTLAYER_MODEL 				= 11200
MSG_ID.MSG_ANTIPLUGALERTLAYER_ACTION_ONCOMPLETE = MSG_ID.MSG_ANTIPLUGALERTLAYER_MODEL + 10

local TAG = "[AntiPlugAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

-- 正确返回
local function onActionComplete( msg, luaValue )
	-- 11200 + 10
	Log.d(TAG, "onActionComplete: MSG_ID = %d", msg:getMsgId())
	if _ccbNode.onComplete then
		_ccbNode.onComplete()
	end
	closeLayer()
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--11200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ANTIPLUGALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "AntiPlugAlertLayer.ccbi")
	-- Quick element
	_nodeTable["mTitleLabel"] = _ccbNode:getNode("mTitleLabel", "CCLabelTTF")
	_nodeTable["mContentLabel"] = _ccbNode:getNode("mContentLabel", "CCLabelTTF")
	_ccbNode.closeLayer = closeLayer
	-- CCControlButton
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	if data and data.position then
		_ccbNode:setPosition(data.position)
	else
		local position = math.random(display.CENTER, display.BOTTOM_CENTER)
		util.alignNode(_ccbNode, CCSize(CONFIG_SCREEN_WIDTH, CONFIG_SCREEN_HEIGHT), position)
	end
	if data and data.onComplete then
		_ccbNode.onComplete = data.onComplete
	end
	CCBCenter.bindView("ccb.v.common.AntiPlugAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	-- 增加点击关闭按钮
	-- widget.bindTouchEvent{
	-- 	layer =  util.toCCLayer(_ccbNode),
	-- 	clickListener = closeLayer,
	-- 	swallowsTouches = true,
	-- 	priority = -999999,
	-- }
end


MSG_HANDLER[MSG_ID.MSG_ANTIPLUGALERTLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_ANTIPLUGALERTLAYER_ACTION_ONCOMPLETE]	= onActionComplete
