--EquipmentLVLayer.lua

MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL 				= 27200

MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNBACKCLICK = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 10
MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNEQUIPMENTLVUPCLICK = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 11
MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 12
MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPMENTLVUPLIST = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 13
MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNHELPCLICK = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 14
MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNCHOOSECLICK = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 15
MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNDISMANTLECLICK = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 16
MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPDISMANTLE = MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL + 17

local TAG = "[EquipmentLVLayer]"
local _ccbNode 
local _nodeTable = {}
--装备操作类型 1 装备强化 2 装备进阶 3 装备追加 4 装备拆解
local equipProcessing

local function closeLayer()
	CCBCenter.popLastLevelCCBNode(anim.ANIMATION_TOP_OUT)
	if _ccbNode.fromEquipment then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHGETEQUIPMENTLIST)
	elseif _ccbNode.fromMain then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	end
end


local function onBtnBackClick( msg, luaValue )
	--27200 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onBtnEquipmentLVUPClick( msg, luaValue )
	--27200 + 11
	Log.d(TAG, "btnEquipmentLVUP: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNEQUIPMENTLVUPCLICK)
	if _ccbNode.getIsUseDamond() == 1 then
		 AlertLayer.new4IAP{
		  	isUserDiamond = true,
		  	diamondIndex = 10,
		    content = _s("USE_DIAMOND_10",_ccbNode.getNeedDiamond()),  --内容
		    btnClickEvent = {
		    	function ( )
		        	 _ccbNode.equipLvUpAnim()
		        end,
		    }
		  }
	else
		_ccbNode.equipLvUpAnim()
	end
end

local function onBtnHelpClick( msg, luaValue )
    --27200 + 14
    Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNHELPCLICK)
    -- 说明
    if equipProcessing == 1 then
		CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isEquipmentLvRule = true,})
	elseif equipProcessing == 2 then
		CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isEquipmentEvoRule = true,})
	elseif equipProcessing == 3 then
		CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isEquipmentAddRule = true,})
	elseif equipProcessing == 4 then
		CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isEquipmentDismantleRule = true,})
	end
end

local function onActionFetchEquipmentLvList( msg, luaValue )
	local function onFetchCallback( properties )
		if properties then

			if equipProcessing ~= 4 then
				_ccbNode.setStone(properties.stone1, properties.stone2, equipProcessing)			
				_ccbNode.reloadEquipLvUpDetail(properties.equips[1])
				_ccbNode.reloadEquipmentListGrid(properties.equips)
			else
				
				_ccbNode.setEquipProcessing(equipProcessing)
				_ccbNode.reloadEquipmentListGrid(properties.equips)
			end
		else
			Log.d(TAG,"err")
		end
	end
	equipProcessing = msg.userdata.equipProcessing

	local actionId

	if equipProcessing == 1 then
		actionId = ACTID.MES_GET_EQUIPMENTLV
	elseif equipProcessing == 2 then
		actionId = ACTID.MSG_GET_EQUIPMENTSTEUP
	elseif equipProcessing == 3 then
		actionId = ACTID.MSG_GET_EQUIPMENTSUPPLEMENT
	elseif equipProcessing == 4 then
		actionId = ACTID.MSG_GET_STREQUIP
	end
	NetHelper.createRequest(
        actionId,
        onFetchCallback,
		{}
    )
    HelperView2.showNext()
end

local function onActionFetchEquipmentLvUpList( msg, luaValue )
	local function sendFailed( res, params  )
		_ccbNode.removeLvUpLayer()
	end
	local function onFetchCallback( properties )
		if properties then
			--设置各种值
			_ccbNode.setValue(properties,equipProcessing,luaValue.action)
		else
			Log.d(TAG,"err")
		end
	end
	local actionId,params
	if equipProcessing == 1 then
		actionId = ACTID.MES_LVUP_EQUIPMENT
		params = { useg = msg.userdata.useg, eqid = msg.userdata.eqid }
	elseif equipProcessing == 2 then
		actionId = ACTID.MES_SETUO_EQUIPMENT
		params = { useg = msg.userdata.useg, eqid = msg.userdata.eqid,used = msg.userdata.used  }
	elseif equipProcessing == 3 then
		actionId = ACTID.MES_SUPPLEMENT_EQUIPMENT
		params = { useg = msg.userdata.useg, eqid = msg.userdata.eqid }
	end
	NetHelper.createRequest(
        actionId,
        onFetchCallback,
		params,
		{failedCb = sendFailed,}
    )
end

local  function onBtnChooseClick( msg, luaValue )
	_ccbNode.onUseDamond()
end

local function onBtnDismantleClick( ... )

	if _ccbNode.getQuality() >= 3 then
		--高级装备拆解对话框
		AlertLayer.new{
	        btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
	        btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
	        titleStr = _s("EQUIPMENT_DISMANTLE_CONFIRM_TITLE"),  --标题
	        content = _s("EQUIPMENT_DISMANTLE_CONFIRM"),  --内容
	        btnClickEvent = {
	        	function ( )
					CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPDISMANTLE)
		        end,
	        },
		}
	else
		
		CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPDISMANTLE)
	end

end

local function onActionFetchEquipDismantle( ... )

	local function onFetchCallback( properties )
		_ccbNode.equipDismantleAnim(properties)
		
    end
	--NetHelper.showLoading(true, true)
	NetHelper.createRequest(
        ACTID.MSG_DISMANTLE_EQUIPMENT,
        onFetchCallback,
        {eqid = _ccbNode.getEqid()}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--27200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "EquipmentLVLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode.fromEquipment = data.fromEquipment
	_ccbNode.fromMain = data.fromMain
	equipProcessing = data.equipProcessing
	-- Quick element
	_nodeTable["mEquipmentList"] = _ccbNode:getNode("mEquipmentList", "CCNode")
	_nodeTable["mEquipmentListLabel"] = _ccbNode:getNode("mEquipmentListLabel", "CCLabelTTF")
	_nodeTable["mEquipmentNameLabel"] = _ccbNode:getNode("mEquipmentNameLabel", "CCLabelTTF")
	_nodeTable["mMaterialmLabel"] = _ccbNode:getNode("mMaterialmLabel", "CCLabelTTF")
	_nodeTable["mMaterialList"] = _ccbNode:getNode("mMaterialList", "CCNode")
	_nodeTable["mEquipmentImg"] = _ccbNode:getNode("mEquipmentImg", "CCSprite")
	_nodeTable["mNowATKLabel"] = _ccbNode:getNode("mNowATKLabel", "CCLabelTTF")
	_nodeTable["mNextAtkLabel"] = _ccbNode:getNode("mNextAtkLabel", "CCLabelTTF")
	_nodeTable["mNowBloodLabel"] = _ccbNode:getNode("mNowBloodLabel", "CCLabelTTF")
	_nodeTable["mNextBloodLabel"] = _ccbNode:getNode("mNextBloodLabel", "CCLabelTTF")
	_nodeTable["btnEquipmentLVUP"] =  _ccbNode:getNode("btnEquipmentLVUP", "CCControlButton")
	_nodeTable["mUserGoldLabel"] = _ccbNode:getNode("mUserGoldLabel", "CCLabelTTF")
	_nodeTable["mUserDamondLabel"] = _ccbNode:getNode("mUserDamondLabel", "CCLabelTTF")
	_nodeTable["mEquipLvUpDetail"] = _ccbNode:getNode("mEquipLvUpDetail", "CCNode")
	_nodeTable["mSuccessRateLabel"] = _ccbNode:getNode("mSuccessRateLabel", "CCLabelTTF")
	_nodeTable["mSuccessRateNode"] = _ccbNode:getNode("mSuccessRateNode", "CCNode")
	_nodeTable["mSetUpMaterialName"] = _ccbNode:getNode("mSetUpMaterialName", "CCLabelTTF")
	_nodeTable["mSetUpEquipName"] = _ccbNode:getNode("mSetUpEquipName", "CCLabelTTF")
	_nodeTable["mSetUpSuccessRateLabel"] = _ccbNode:getNode("mSetUpSuccessRateLabel", "CCLabelTTF")
	_nodeTable["mChooseDamondLabel"] = _ccbNode:getNode("mChooseDamondLabel", "CCLabelTTF")
	_nodeTable["mDamondLabel"] = _ccbNode:getNode("mDamondLabel", "CCLabelTTF")
	_nodeTable["mSuccessRateUpLabel"] = _ccbNode:getNode("mSuccessRateUpLabel", "CCLabelTTF")
	_nodeTable["btnChoose"] =  _ccbNode:getNode("btnChoose", "CCControlButton")
	_nodeTable["btnEquipSetUp"] =  _ccbNode:getNode("btnEquipSetUp", "CCControlButton")
	_nodeTable["mEquipmentHelpLabel"] = _ccbNode:getNode("mEquipmentHelpLabel", "CCLabelTTF")
	_nodeTable["mDismantleEquipLabel"] = _ccbNode:getNode("mDismantleEquipLabel", "CCLabelTTF")
	_nodeTable["mDismantleEqupLayer"] = _ccbNode:getNode("mDismantleEqupLayer", "CCLayer")
	_nodeTable["btnDismantle"] =  _ccbNode:getNode("btnDismantle", "CCControlButton")
	_nodeTable["mDismantleEquipLayer"] =  _ccbNode:getNode("mDismantleEquipLayer", "CCLayer")
	_nodeTable["mDismantleEquIpLv"] = _ccbNode:getNode("mDismantleEquIpLv", "CCLabelTTF")
	_nodeTable["mDismantleEquIpEvo"] = _ccbNode:getNode("mDismantleEquIpEvo", "CCLabelTTF")
	_nodeTable["mDismantleEquIpSetUp"] = _ccbNode:getNode("mDismantleEquIpSetUp", "CCLabelTTF")
	_nodeTable["mDismantleEquIpQuality"] = _ccbNode:getNode("mDismantleEquIpQuality", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)
	_ccbNode:bindButton("btnEquipmentLVUP", onBtnEquipmentLVUPClick,_s("EQUIPMENT_LVUP"))
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)
	_ccbNode:bindButton("btnEquipSetUp", onBtnEquipmentLVUPClick,_s("EQUIPMENT_STEPUPTITLE"))
	_ccbNode:bindButton("btnChoose", onBtnChooseClick,_s("EQUIPMENT_CHOOSE"))
	_ccbNode:bindButton("btnDismantle", onBtnDismantleClick,_s("EQUIPMENT_DISMANTLE_TITLE"))

	--填充文字
	_nodeTable["mEquipmentListLabel"]:setString(_s("EQUIPMENT_LIST"))
	_nodeTable["mMaterialmLabel"]:setString(_s("EQUIPMENT_MATERIALM"))
	_nodeTable["mUserGoldLabel"]:setString(ME:getGold())
	_nodeTable["mUserDamondLabel"]:setString(ME:getDiamond())
	_nodeTable["mSuccessRateLabel"]:setString(_s("EQUIPMENT_SUCCESSRATE"))
	_nodeTable["mSetUpMaterialName"]:setString(_s("EQUIPMENT_MATERIALM"))
	_nodeTable["mSetUpSuccessRateLabel"]:setString(_s("EQUIPMENT_SUCCESSRATE"))
	_nodeTable["mChooseDamondLabel"]:setString(_s("EQUIPMENT_USEDAMOND"))
	_nodeTable["mSuccessRateUpLabel"]:setString(_s("EQUIPMENT_SUCCESSRATEUP",GAMERATE:getEquipEvoGemRate()))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.equipment.EquipmentLVLayerView", _ccbNode, _nodeTable, equipProcessing)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		util.delayCall(function ( )
		 	CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST,nil, { equipProcessing = equipProcessing })
		end, 0.2) 
	end
end


MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNEQUIPMENTLVUPCLICK]	= onBtnEquipmentLVUPClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST] = onActionFetchEquipmentLvList
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPMENTLVUPLIST] = onActionFetchEquipmentLvUpList
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNHELPCLICK]	= onBtnHelpClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNCHOOSECLICK]	= onBtnChooseClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ONBTNDISMANTLECLICK]	= onBtnDismantleClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPDISMANTLE] = onActionFetchEquipDismantle