--EquipmentLayer.lua

local SOUND                = require("GameSoundManager")

MSG_ID.MSG_EQUIPMENTLAYER_MODEL 				= 27000

MSG_ID.MSG_EQUIPMENTLAYER_ONBTNEQUATTCLICK = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 10
MSG_ID.MSG_EQUIPMENTLAYER_ONBTNBLACKSMITHCLICK = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 11
MSG_ID.MSG_EQUIPMENTLAYER_ONBTNCARDCLICK = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 12
MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHGETEQUIPMENTLIST = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 13
MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHUSEEQUIPMENT = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 14
MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHSELLEQUIPMENT = MSG_ID.MSG_EQUIPMENTLAYER_MODEL + 15

local TAG = "[EquipmentLayer]"
local _ccbNode 
local _nodeTable = {}
local _unlockLevel = require("static.unlock_level")
local function closeLayer()
	-- CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	-- CCBCenter.popLastLevelCCBNode()
	game.enterMainLayer()
end

local function onBtnEquAttClick( msg, luaValue )
	--27000 + 10
	Log.d(TAG, "btnEquAtt: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLAYER_ONBTNEQUATTCLICK)

	--_ccbNode:setButtonTitle( "btnEquAtt", _s("EQUIPMENT_ATTRIBUTE"))
	_ccbNode.onEquAttChange()
end

local function onBtnBlacksmithClick( msg, luaValue )
	--27000 + 11
	Log.d(TAG, "btnBlacksmith: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLAYER_ONBTNBLACKSMITHCLICK)
	--NetHelper.QuickToast(_s("EQUIPMENT_BLACKSMITHOPEN"))
    if not ME:getTriggerMsgEntity():isUnlockEquipEnhanced() then
        NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.EQUIPENHANCED, _s("MAIN_SMITHY")))
        return
    end
	CCBCenter.loadCCB("MSG_EQUIPMENTLVLAYER_MODEL", "ccb.c.equipment.EquipmentLVLayer",{equipProcessing = 1,fromEquipment = true,})
end

local function onBtnCardClick( msg, luaValue )
	--27000 + 12
	Log.d(TAG, "btnCard: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLAYER_ONBTNCARDCLICK)
	if not ME:getTriggerMsgEntity():isUnlockMining() then
        NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.MINING, _s("MAIN_MINING")))
        return
    end
	HelperView2.showNext()
	CCBCenter.loadCCB("MSG_MAPMININGLAYER_MODEL", "ccb.c.map.MapMiningLayer")
end
--获取装备列表
local function onActionFetchEquipmentList( msg, luaValue )
	
	local function onFetchCallback( properties )
		if properties then

			if istable(luaValue) and luaValue.index == 1 then
				if #properties.equippackage[1].objs >= _GAME.CONFIG.GOODS.GOODS_LIMIT then
		            -- 对话框提示
		            AlertLayer.new4OK({
		                content     = _s("EQUIP_OVERFLOW")
		            })
		        end
			end

			--装备列表
			_ccbNode.reloadEquipmentListGrid(properties.equippackage[1].objs)
			--穿在身上的装备
			_ccbNode.reloadUserEquipmentGrid(properties.parts[1].objs)
			--刷新人物形象
			_ccbNode.reloadHero()
			--刷新属性
			_ccbNode.reloadAtt()
		else
			Log.d(TAG,"err")
		end
	end

	NetHelper.createRequest(
        ACTID.MSG_GET_EQUIPMENT,
        onFetchCallback,
        {}
    )
end
--穿上装备
local function onActionFetchUseEquipment( msg, luaValue )
	local function onFetchCallback( properties )
		if properties then
			_GAME.CACHE[ACTID.MSG_GET_EQUIPMENT] = properties
			SOUND:playEquip()
			--装备列表
			_ccbNode.reloadEquipmentListGrid(properties.equippackage[1].objs)
			--穿在身上的装备reloadHero
			_ccbNode.reloadUserEquipmentGrid(properties.parts[1].objs)
			--刷新人物形象
			_ccbNode.reloadHero()
			--刷新属性
			_ccbNode.reloadAtt()
		else
			Log.d(TAG,"err")
		end
	end

	NetHelper.createRequest(
        ACTID.MSG_USE_EQUIPMENT,
        onFetchCallback,
		{typ = 1, act = msg.userdata.act, eqid = msg.userdata.eqid}
    )
end

--出售装备
local function onActionFetchSellEquipment( msg, luaValue )
	local function onFetchCallback( properties )
		if properties then
			NetHelper.QuickToast(_s("EQUIPMENT_SELL_SUCCESS"))
	        SOUND:playGold()
			--装备列表
			_ccbNode.reloadEquipmentListGrid(properties.equip.equippackage[1].objs)
			--穿在身上的装备
			_ccbNode.reloadUserEquipmentGrid(properties.equip.parts[1].objs)
			--刷新人物形象
			_ccbNode.reloadHero()
			--刷新属性
			_ccbNode.reloadAtt()
			-- local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
	  --       CCBCenter.loadCCB(
	  --           "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
	  --           "ccb.c.main.ReceiveRewardAlertLayer", 
	  --           {
	  --               entity = rewardEntity,
	  --           }
	  --       )
		else
			Log.d(TAG,"err")
		end
	end
	NetHelper.showLoading(true, true)
	NetHelper.createRequest(
        ACTID.MSG_SELL_EQUIPMENT,
        onFetchCallback,
		{typ = 1, eqid = msg.userdata.eqid}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--27000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_EQUIPMENTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "EquipmentLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_EQUIPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mLevelLabel"] = _ccbNode:getNode("mLevelLabel", "CCLabelTTF")
	_nodeTable["mNameLabel"] = _ccbNode:getNode("mNameLabel", "CCLabelTTF")
	_nodeTable["mATKLabel"] = _ccbNode:getNode("mATKLabel", "CCLabelTTF")
	_nodeTable["mHPLabel"] = _ccbNode:getNode("mHPLabel", "CCLabelTTF")
	_nodeTable["mATKAttLabel"] = _ccbNode:getNode("mATKAttLabel", "CCLabelTTF")
	_nodeTable["mHPAttLabel"] = _ccbNode:getNode("mHPAttLabel", "CCLabelTTF")
	_nodeTable["mSkill"] = _ccbNode:getNode("mSkill", "CCNode")
	_nodeTable["mEquipmentList"] = _ccbNode:getNode("mEquipmentList", "CCLayer")
	_nodeTable["mEquipmentTitleLabel"] = _ccbNode:getNode("mEquipmentTitleLabel", "CCLabelTTF")
	_nodeTable["mHPTitleLable"] = _ccbNode:getNode("mHPTitleLable", "CCLabelTTF")
	_nodeTable["mAid"] = _ccbNode:getNode("mAid", "CCNode")
	_nodeTable["mSkillTitleLabel"] = _ccbNode:getTTFLabel("mSkillTitleLabel", _s("EQUIPMENT_SKILL"))

	_nodeTable["btnEquAtt"] = _ccbNode:getNode("btnEquAtt", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnEquAtt", onBtnEquAttClick, _s("EQUIPMENT_ATTRIBUTE"))
	_ccbNode:bindButton("btnBlacksmith", onBtnBlacksmithClick,_s("EQUIPMENT_BLACKSMITH"))
	_ccbNode:bindButton("btnCard", onBtnCardClick,_s("EQUIPMENT_MINE"))

	--填充文字
	 _nodeTable["mEquipmentTitleLabel"]:setString(_s("EQUIPMENT_TITLE"))
 	 _nodeTable["mHPTitleLable"]:setString(_s("EQUIPMENT_ATTRIBUTE_TOTALHP"))
	
	-- android上的位置调整
    util.modifyPositionInAndroid( _nodeTable.mEquipmentTitleLabel, 0, 2 )     -- 标题
    util.modifyPositionInAndroid( _nodeTable.mNameLabel, 0, 4 )     -- 名字
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.equipment.EquipmentLayerView", _ccbNode, _nodeTable)
	_ccbNode.requestDataForLoad = function ()
		-- quickui.showLoadingLayer()
		CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHGETEQUIPMENTLIST, nil, {index = 1})
	end	
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	--onActionFetchEquipmentList()
    	CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHGETEQUIPMENTLIST,nil,{index = 1})
   		 end})
	end
	
end


MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ONBTNEQUATTCLICK]	= onBtnEquAttClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ONBTNBLACKSMITHCLICK]	= onBtnBlacksmithClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ONBTNCARDCLICK]	= onBtnCardClick
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHGETEQUIPMENTLIST]	= onActionFetchEquipmentList
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHUSEEQUIPMENT]	= onActionFetchUseEquipment
MSG_HANDLER[MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHSELLEQUIPMENT]  = onActionFetchSellEquipment
