--FestivalSignLayer.lua

MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL 				= 22500

MSG_ID.MSG_FESTIVALSIGNLAYER_ONBTNBACKCLICK = MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL + 10
MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHSIGNINFO = MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL + 11
MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHGETREWARD = MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL + 12

local TAG = "[FestivalSignLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	SOUND:playMusicHome(true)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ONFETCHCHECKHELPERINFO)
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnBackClick( msg, luaValue )
	--22500 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_FESTIVALSIGNLAYER_ONBTNBACKCLICK)
	HelperView2.showNext()
	closeLayer()
end

local function onBtnActionFetchSignInfo( msg, luaValue )
	local function onFetchCallback( properties, params )
        if properties then
            _ccbNode.drawBg(properties)
        else
            Log.d(TAG,"err")
        end
    end
    --
    NetHelper.showLoading(true, true)
	NetHelper.createRequest(
			        ACTID.MSG_INFO_FESTIVAL_SIGN,
			        onFetchCallback,
			        {}
			    )
end

local function onBtnActionFetchGetReward( msg, luaValue )
	local function onFetchCallback( properties, params )
	    NetHelper.hideLoading(true)
	    local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
	    CCBCenter.loadCCB(
	        "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
	        "ccb.c.main.ReceiveRewardAlertLayer", 
	        {
	            entity = rewardEntity,
	        	onConfirm = function( )
	        		_ccbNode.checkHelperInfo()
	        		CCBCenter.sendLuaMessage(MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHSIGNINFO)
	        	end
	        }
	    )
    end
    NetHelper.showLoading(true, true)
	NetHelper.createRequest(
			        ACTID.MSG_GET_FESTIVAL_SIGN,
			        onFetchCallback,
			        { tag = msg.userdata.tag}
			    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--22500
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "FestivalSignLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mRuleLabel"] = _ccbNode:getNode("mRuleLabel", "CCLabelTTF")
	_nodeTable["mTitleLabel"] = _ccbNode:getNode("mTitleLabel", "CCLabelTTF")
	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- 填充文字
	_nodeTable["mRuleLabel"]:setString(_s("ACTIVITY_FESTIVAL_SIGN_RULE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.festivalsign.FestivalSignLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHSIGNINFO)
   		 end})
	end
end


MSG_HANDLER[MSG_ID.MSG_FESTIVALSIGNLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_FESTIVALSIGNLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHSIGNINFO]	= onBtnActionFetchSignInfo
MSG_HANDLER[MSG_ID.MSG_FESTIVALSIGNLAYER_ONACTIONFETCHGETREWARD]	= onBtnActionFetchGetReward
