--EquipOffAlertLayer.lua

MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL 				= 25300

MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNCONFIRMCLICK = MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL + 10
MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNSELLCLICK = MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL + 11
MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNEQUIPCLICK = MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL + 12

local TAG = "[EquipOffAlertLayer]"
local _ccbNode 
local _nodeTable = {}
local _autoClose
local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnConfirmClick( msg, luaValue )
	--25200 + 10
	Log.d(TAG, "btnConfirm: MSG_ID = %d", MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNCONFIRMCLICK)
	if HelperView2.isNextIndex(120060) then
		NetHelper.QuickToast(_s("EQUIP_SELECT_EQUIP"))
		return
	end
	if _ccbNode._DATA.onConfirm then
		_ccbNode._DATA.onConfirm()
	end
	if _autoClose then
		closeLayer()
	end
end
local function onBtnSellClick( msg, luaValue )
	--25200 + 11
	Log.d(TAG, "btnSell: MSG_ID = %d", MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNSELLCLICK)
	if HelperView2.isNextIndex(120060) then
		NetHelper.QuickToast(_s("EQUIP_SELECT_EQUIP"))
		return
	end
	if _ccbNode._DATA.onSellClick then
		_ccbNode._DATA.onSellClick()
	end
	if _autoClose then
		closeLayer()
	end
end
local function onBtnEquipClick( msg, luaValue )
	--25200 + 12
	Log.d(TAG, "btnEquip: MSG_ID = %d", MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNEQUIPCLICK)
	if _ccbNode._DATA.onConfirm then
		_ccbNode._DATA.onConfirm()
	end
	if _autoClose then
		closeLayer()
	end
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--25200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "EquipOffAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._DATA = data
	_ccbNode._TYPE = 3
	-- Quick element
	_nodeTable["mEquipNameLabel"] = _ccbNode:getNode("mEquipNameLabel", "CCLabelTTF")
	_nodeTable["mTypeLabel"] = _ccbNode:getNode("mTypeLabel", "CCLabelTTF")
	_nodeTable["mLevelLabel"] = _ccbNode:getNode("mLevelLabel", "CCLabelTTF")
	_nodeTable["mAddLabel"] = _ccbNode:getNode("mAddLabel", "CCLabelTTF")
	_nodeTable["mDetailTitleLabel"] = _ccbNode:getNode("mDetailTitleLabel", "CCLabelTTF")
	_nodeTable["mSellLabel"] = _ccbNode:getNode("mSellLabel", "CCLabelTTF")
	_nodeTable["mEquipPoiLabel"] = _ccbNode:getNode("mEquipPoiLabel", "CCLabelTTF")
	_nodeTable["btnConfirm"] = _ccbNode:getNode("btnConfirm", "CCControlButton")
	_nodeTable["btnSell"] = _ccbNode:getNode("btnSell", "CCControlButton")
	_nodeTable["btnEquip"] = _ccbNode:getNode("btnEquip", "CCControlButton")
	_nodeTable["mBgSprite"] = _ccbNode:getNode("mBgSprite", "CCScale9Sprite")
	
	-- CCControlButton
	_ccbNode:bindButton("btnConfirm", onBtnConfirmClick)
	_ccbNode:bindButton("btnSell", onBtnSellClick, _s("GOODS_SELL"))
	_ccbNode:bindButton("btnEquip", onBtnEquipClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- 填充文字
	_nodeTable["mDetailTitleLabel"]:setString(_s("EQUIP_EFFECT"))
	CCBCenter.bindView("ccb.v.goods.EquipAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		_autoClose = false
		callback(_ccbNode)
	else
		util.alignNode(_ccbNode, CCSize(960, 640))
		local layer = widget.newLayer{contentSize = CCSize(960, 640)}
		if not HelperView2.isNextIndex(120060) then
			widget.bindTouchEvent{
				layer = layer,
				priority = 10000,
				clickListener = closeLayer,
			}
		end
		_ccbNode:addChild(layer)
		util.alignNode(layer, _ccbNode)
		_autoClose = true
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_EQUIPOFFALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNCONFIRMCLICK]	= onBtnConfirmClick
MSG_HANDLER[MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNSELLCLICK]	= onBtnSellClick
MSG_HANDLER[MSG_ID.MSG_EQUIPOFFALERTLAYER_ONBTNEQUIPCLICK]	= onBtnEquipClick
