--GoodsLayer.lua

MSG_ID.MSG_GOODSLAYER_MODEL 				= 25000

MSG_ID.MSG_GOODSLAYER_ONBTNUSECLICK = MSG_ID.MSG_GOODSLAYER_MODEL + 10
MSG_ID.MSG_GOODSLAYER_ONBTNSELLCLICK = MSG_ID.MSG_GOODSLAYER_MODEL + 11
MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE = MSG_ID.MSG_GOODSLAYER_MODEL + 12
MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHSELLGOODS = MSG_ID.MSG_GOODSLAYER_MODEL + 13
MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHUSEGOODS = MSG_ID.MSG_GOODSLAYER_MODEL + 14

local TAG = "[GoodsLayer]"
local _ccbNode 
local _nodeTable = {}
local _canClick 
local function closeLayer()
	-- CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	-- CCBCenter.popLastLevelCCBNode()
	game.enterMainLayer()
end

local function onRequestFailed( )
	_ccbNode.updatePlayerInfo()
	_canClick = true
end

local function onBtnUseClick( msg, luaValue )
	--25000 + 10
	Log.d(TAG, "btnUse: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_ONBTNUSECLICK)
	if _canClick then
		_canClick = false
	else
		return
	end
	local curGoods = _ccbNode.getCurGoods( )
	if not curGoods then
		_ccbNode.cleanGoodsInfo()
		_canClick = true
		return
	end
	if _GAME.CONFIG.GOODS.USETYPE.POPWIN == curGoods:getUsetype() then
		_canClick = true
		local id, path = string.splitlast(curGoods:getExt(), ",")
		CCBCenter.loadCCB(id, path, {onConfirm = function ( )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE, nil, {typ = 0})
		end})
	else
		CCBCenter.sendLuaMessage(MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHUSEGOODS, nil, {no = curGoods:getNo()})
	end
end

local function onBtnSellClick( msg, luaValue )
	--25000 + 11
	Log.d(TAG, "btnSell: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_ONBTNSELLCLICK)
	if _canClick then
		_canClick = false
	else
		return
	end
	local curGoods = _ccbNode.getCurGoods( )
	if not curGoods then
		_ccbNode.cleanGoodsInfo()
		_canClick = true
		return
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHSELLGOODS, nil, {no = curGoods:getNo(), count = 1})
end

local function onActionFetchPackage( msg, luaValue )
	--25000 + 12
	Log.d(TAG, "onActionFetchPackage: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE)
	local function onFetchCallback( items )
		_ccbNode.updatePackageInfo(items:getPackage())
    end
    ModelHelper.requireDataWithFun(
        "model.goods.GoodsModel",
        "fetchPackage",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchSellGoods( msg, luaValue )
	--25000 + 13
	Log.d(TAG, "onActionFetchSellGoods: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHSELLGOODS)
	local function onFetchCallback( items )
		NetHelper.QuickToast(_s("CARD_SELL_MONEY") .. " " .. _ccbNode.getCurGoods( ):getPrice(), true, 1)
		_ccbNode.updatePlayerInfo()
		_ccbNode.updatePackageInfo(items:getPackage())
		_canClick = true
    end
    msg.userdata.failed = onRequestFailed
    ModelHelper.requireDataWithFun(
        "model.goods.GoodsModel",
        "fetchSellGoods",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchUseGoods( msg, luaValue )
	--25000 + 14
	Log.d(TAG, "onActionFetchUseGoods: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHUSEGOODS)
	local function onFetchCallback( items )
		local result = items:getResult()
		if result:notEmpty() then
			CCBCenter.loadCCB(
	            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
	            "ccb.c.main.ReceiveRewardAlertLayer", 
	            {
	                entity = result,
	            }
	        )
		else
			NetHelper.QuickToast(_s("GOODS_USE_SUCCESS"), true, 1)
		end
		-- 领取回来刷新
        _ccbNode.updatePlayerInfo()
		_ccbNode.updatePackageInfo(items:getPackage())
		_canClick = true
    end
    msg.userdata.failed = onRequestFailed
    ModelHelper.requireDataWithFun(
	    "model.goods.GoodsModel",
	    "fetchUseGoods",
	    onFetchCallback,
	    msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--25000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_GOODSLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "GoodsLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_GOODSLAYER
	_canClick = true
	-- Quick element
	_nodeTable["mGoodsNameLabel"] = _ccbNode:getNode("mGoodsNameLabel", "CCLabelTTF")
	_nodeTable["mLayerTitleLabel"] = _ccbNode:getNode("mLayerTitleLabel", "CCLabelTTF")
	_nodeTable["mSellPriceTitleLabel"] = _ccbNode:getNode("mSellPriceTitleLabel", "CCLabelTTF")
	_nodeTable["mDetailsTitleLabel"] = _ccbNode:getNode("mDetailsTitleLabel", "CCLabelTTF")
	_nodeTable["mGoldLabel"] = _ccbNode:getNode("mGoldLabel", "CCLabelTTF")
	_nodeTable["mDiamondLabel"] = _ccbNode:getNode("mDiamondLabel", "CCLabelTTF")
	_nodeTable["mPriveLabel"] = _ccbNode:getNode("mPriveLabel", "CCLabelTTF")
	_nodeTable["btnUse"] = _ccbNode:getNode("btnUse", "CCControlButton")
	_nodeTable["btnSell"] = _ccbNode:getNode("btnSell", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnUse", onBtnUseClick, _s("GOODS_USE"))
	_ccbNode:bindButton("btnSell", onBtnSellClick, _s("GOODS_SELL"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mLayerTitleLabel, 0, 2 ) 	-- 名字
	util.modifyPositionInAndroid( _nodeTable.mGoodsNameLabel, 0, 2 ) 	-- 物品名称
	util.modifyPositionInAndroid( _nodeTable.mSellPriceTitleLabel, 0, 2 ) 	-- 出售价格标题
	util.modifyPositionInAndroid( _nodeTable.mPriveLabel, 0, 2 ) 	-- 出售价格值
	util.modifyPositionInAndroid( _nodeTable.mDetailsTitleLabel, 0, 2 ) 	-- 详细信息标题

	-- 填充文字
	_nodeTable["mLayerTitleLabel"]:setString(_s("GOODS_TITLE"))
	_nodeTable["mSellPriceTitleLabel"]:setString(_s("GOODS_SELL_PRICE"))
	_nodeTable["mDetailsTitleLabel"]:setString(_s("GOODS_DETAILS"))

	CCBCenter.bindView("ccb.v.goods.GoodsLayerView", _ccbNode, _nodeTable)
	_ccbNode.requestDataForLoad = function ()
		-- quickui.showLoadingLayer()
		CCBCenter.sendLuaMessage(MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE, nil, {typ = 0})
	end	
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, { onComplete = function ( )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE, nil, {typ = 0})
		end })
	end
	
end


MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_ONBTNUSECLICK]	= onBtnUseClick
MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_ONBTNSELLCLICK]	= onBtnSellClick
MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHPACKAGE]	= onActionFetchPackage
MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHSELLGOODS]	= onActionFetchSellGoods
MSG_HANDLER[MSG_ID.MSG_GOODSLAYER_ACTION_ONFETCHUSEGOODS]	= onActionFetchUseGoods