--MailAlertLayer.lua

MSG_ID.MSG_MAILALERTLAYER_MODEL 				= 4100

MSG_ID.MSG_MAILALERTLAYER_ONBTNDELETECLICK = MSG_ID.MSG_MAILALERTLAYER_MODEL + 10
MSG_ID.MSG_MAILALERTLAYER_ONBTNRECEIVECLICK = MSG_ID.MSG_MAILALERTLAYER_MODEL + 11
MSG_ID.MSG_MAILALERTLAYER_ONBTNBACKCLICK = MSG_ID.MSG_MAILALERTLAYER_MODEL + 12
MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILLIST = MSG_ID.MSG_MAILALERTLAYER_MODEL + 13
MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILREWARD = MSG_ID.MSG_MAILALERTLAYER_MODEL + 14
MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHDELETEMAIL = MSG_ID.MSG_MAILALERTLAYER_MODEL + 15
MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHSENDMAIL = MSG_ID.MSG_MAILALERTLAYER_MODEL + 16
MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHREADMAIL = MSG_ID.MSG_MAILALERTLAYER_MODEL + 17

local TAG = "[MailAlertLayer]"
local _ccbNode 
local _nodeTable = {}
local _isFinish = true
local RewardEntity = require("model.main.RewardEntity")
local function closeLayer()
    if _isFinish then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ENABLEMESSAGESCHEDULE, nil, true)
        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
        CCBCenter.popLastLevelCCBNode(anim.ANIMATION_TOP_OUT)
    end
end


local function onBtnDeleteClick( msg, luaValue )
	--4100 + 10
	Log.d(TAG, "btnDelete: MSG_ID = %d", MSG_ID.MSG_MAILALERTLAYER_ONBTNDELETECLICK)
	_ccbNode.deleteMail()
end

local function onBtnReceiveClick( msg, luaValue )
	--4100 + 11
	Log.d(TAG, "btnReceive: MSG_ID = %d", MSG_ID.MSG_MAILALERTLAYER_ONBTNRECEIVECLICK)
	_nodeTable["btnReceive"]:setEnabled(false)
	_ccbNode.receiveReward()
end

local function onBtnBackClick( msg, luaValue )
	--4100 + 12
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_MAILALERTLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onActionFetchMailList( msg, luaValue )
	-- 1000 + 13
	Log.d(TAG, "onActionFetchMailList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items, params )
        _isFinish = false
        try(
            function ( )
                if params and params.chat then
                    _ccbNode.updateChat(items)
                else
                    _ccbNode.updateData(items)
                end
            end,
            function ( )
                Log.d(TAG, "callback error !!!!")
            end
        )
        _isFinish = true
    end
    if msg.userdata and msg.userdata.chat then msg.userdata.showLoading = false end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchMailList",
        onFetchCallback,
        msg.userdata
    )
--     mcontent //内容大纲
-- [
-- {
--   mtyp//大类型 1、系统收件箱2、收件箱
--   mid//Id 1、赞美消息2、打劫消息，收件箱中Id即为对象
--          Id，系统消息id从1000开始
--   sendername//发送者昵称
--   sendtime//发送时间
--   title//标题
--   state//状态1、未读2、已读
--   head//头像
--   detailed//消息详细内容
--   [
--     sendid//发送者id
--     content//具体内容
--     reward{}//奖励
--     state//奖励的状态1、可提取2、已提取
--   ]
-- }
-- ]
 --    onFetchCallback{
 --    	mcontent = {
 --    		{mtyp = 1, mid = 1, sendername = "名称1补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {}, state = 1}, }},
 --    		{mtyp = 1, mid = 2, sendername = "名称2补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {}, state = 1}, }},
 --    		{mtyp = 1, mid = 1000, sendername = "名称1000补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 1}, }},
 --    		{mtyp = 1, mid = 1001, sendername = "名称1001补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 2}, }},
 --    		{mtyp = 1, mid = 1002, sendername = "名称1002补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 0}, }},
 --    		{mtyp = 2, mid = 1, sendername = "1补丁补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息1补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {}, state = 1}, {sendid = 1, content = "消息2补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {}, state = 1}, {sendid = ME:getUserid(), content = "消息3", reward = {}, state = 1},}},
 --    		{mtyp = 2, mid = 2, sendername = "2补丁补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息1", reward = {}, state = 1}, {sendid = 1, content = "消息2", reward = {}, state = 1}, {sendid = 1, content = "What the hell Four Dreadlords! I'm gonna make sure you can all reunite in hell! Come and taste the sacred prowess of the Holy Sword!", reward = {}, state = 1}, {sendid = 1, content = "Heehee, did you notice the question mark at the bottom right? Click and view, and you'll get some information on advancement. Now it's your turn, Your Highness.", reward = {}, state = 1},}},
	--     }
	-- }
end
local function onActionFetchMailReward( msg, luaValue )
	-- 1000 + 14
	Log.d(TAG, "onActionFetchMailReward: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = RewardEntity.new(items.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILLIST)
    end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchMailReward",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchDeleteMail( msg, luaValue )
	-- 1000 + 15
	Log.d(TAG, "onActionFetchDeleteMail: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = RewardEntity.new(items.reward)
		if rewardEntity:notEmpty() then
			CCBCenter.loadCCB(
	            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
	            "ccb.c.main.ReceiveRewardAlertLayer", 
	            {
	                entity = rewardEntity,
	            }
	        )
		end
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILLIST)
    end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchDeleteMail",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchSendMail( msg, luaValue )
	-- 1000 + 16
	Log.d(TAG, "onActionFetchSendMail: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchSendMail",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchReadMail( msg, luaValue )
	-- 1000 + 17
	Log.d(TAG, "onActionFetchReadMail: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		-- _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchReadMail",
        onFetchCallback,
        msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--4100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAILALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MailAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._SELECTTAB = data and data._SELECTTAB or 1
	-- Quick element
	_nodeTable["mSenderLabel"] = _ccbNode:getNode("mSenderLabel", "CCLabelTTF")

	-- CCControlButton
	_nodeTable["btnDelete"] = _ccbNode:bindButton("btnDelete", onBtnDeleteClick, _s("MAIL_DELETE"))
	_nodeTable["btnReceive"] = _ccbNode:bindButton("btnReceive", onBtnReceiveClick)
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.mail.MailAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILLIST)
end


MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ONBTNDELETECLICK]	= onBtnDeleteClick
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ONBTNRECEIVECLICK]	= onBtnReceiveClick
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILLIST] = onActionFetchMailList
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHMAILREWARD] = onActionFetchMailReward
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHDELETEMAIL] = onActionFetchDeleteMail
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHSENDMAIL] = onActionFetchSendMail
MSG_HANDLER[MSG_ID.MSG_MAILALERTLAYER_ACTION_ONFETCHREADMAIL] = onActionFetchReadMail