--MessageLayer.lua

MSG_ID.MSG_MESSAGELAYER_MODEL 				= 4000

MSG_ID.MSG_MESSAGELAYER_ONBTNBACKCLICK = MSG_ID.MSG_MESSAGELAYER_MODEL + 10
MSG_ID.MSG_MESSAGELAYER_ACTION_ONFETCHMAILLIST = MSG_ID.MSG_MESSAGELAYER_MODEL + 11
MSG_ID.MSG_MESSAGELAYER_ACTION_ONFETCHSENDMAIL = MSG_ID.MSG_MESSAGELAYER_MODEL + 12

local TAG = "[MessageLayer]"
local _ccbNode 
local _nodeTable = {}
local _isFinish = true

local function closeLayer()
    if _isFinish then
        CCBCenter.popLastLevelCCBNode()
    end
end


local function onBtnBackClick( msg, luaValue )
	--4000 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_MESSAGELAYER_ONBTNBACKCLICK)
	closeLayer()
end
local function onActionFetchMailList( msg, luaValue )
	-- 1000 + 13
	Log.d(TAG, "onActionFetchMailList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        _isFinish = false
		_ccbNode.updateData(items)
        _isFinish = true
    end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchMailList",
        onFetchCallback,
        {}
    )
--     mcontent //内容大纲
-- [
-- {
--   mtyp//大类型 1、系统收件箱2、收件箱
--   mid//Id 1、赞美消息2、打劫消息，收件箱中Id即为对象
--          Id，系统消息id从1000开始
--   sendername//发送者昵称
--   sendtime//发送时间
--   title//标题
--   state//状态1、未读2、已读
--   head//头像
--   detailed//消息详细内容
--   [
--     sendid//发送者id
--     content//具体内容
--     reward{}//奖励
--     state//奖励的状态1、可提取2、已提取
--   ]
-- }
-- ]
 --    onFetchCallback{
 --    	mcontent = {
 --    		{mtyp = 1, mid = 1, sendername = "名称1补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {}, state = 1}, }},
 --    		{mtyp = 1, mid = 2, sendername = "名称2补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {}, state = 1}, }},
 --    		{mtyp = 1, mid = 1000, sendername = "名称1000补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 1}, }},
 --    		{mtyp = 1, mid = 1001, sendername = "名称1001补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 2}, }},
 --    		{mtyp = 1, mid = 1002, sendername = "名称1002补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {gold = 1000, diamond = 500, star = 100, brlist = {{no = 10001, count = 1,}, {no = 1, count = 1,}, {no = 20003, count = 1,}, {no = 5002, count = 1,},}}, state = 0}, }},
 --    		{mtyp = 2, mid = 1, sendername = "1补丁补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息1补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {}, state = 1}, {sendid = 1, content = "消息2补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁补丁", reward = {}, state = 1}, {sendid = ME:getUserid(), content = "消息3", reward = {}, state = 1},}},
 --    		{mtyp = 2, mid = 2, sendername = "2补丁补丁补丁", sendtime = "2014年1月1日", title = "标题补丁补丁补丁", state = 1, head = "", detailed = {{sendid = 1, content = "消息1", reward = {}, state = 1}, {sendid = 1, content = "消息2", reward = {}, state = 1}, {sendid = 1, content = "What the hell Four Dreadlords! I'm gonna make sure you can all reunite in hell! Come and taste the sacred prowess of the Holy Sword!", reward = {}, state = 1}, {sendid = 1, content = "Heehee, did you notice the question mark at the bottom right? Click and view, and you'll get some information on advancement. Now it's your turn, Your Highness.", reward = {}, state = 1},}},
	--     }
	-- }
end
local function onActionFetchSendMail( msg, luaValue )
	-- 1000 + 16
	Log.d(TAG, "onActionFetchSendMail: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
    end
    if msg.userdata then msg.userdata.showLoading = false end
    ModelHelper.requireDataWithFun(
        "model.mail.MailModel",
        "fetchSendMail",
        onFetchCallback,
        msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--4000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MESSAGELAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MessageLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._FID = data.fid
	_ccbNode._NICKNAME = data.nickName

	-- Quick element
	_nodeTable["mMessageTitleLabel"] = _ccbNode:getTTFLabel("mMessageTitleLabel", _s("FRIEND_LEAVE_MESSAGE"))
	_nodeTable["mSenderLabel"] = _ccbNode:getTTFLabel("mSenderLabel", _s("MAIL_SENDER_NAME", _ccbNode._NICKNAME))

	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.mail.MessageLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MESSAGELAYER_ACTION_ONFETCHMAILLIST)
end


MSG_HANDLER[MSG_ID.MSG_MESSAGELAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MESSAGELAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_MESSAGELAYER_ACTION_ONFETCHMAILLIST] = onActionFetchMailList
MSG_HANDLER[MSG_ID.MSG_MESSAGELAYER_ACTION_ONFETCHSENDMAIL] = onActionFetchSendMail