--ActivityEightDayLayer.lua

MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL              = 1900
MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYLIST = MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYREWARD = MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL + 11
MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHRESETEIGHTDAYREWARD = MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL + 12

local TAG = "[ActivityEightDayLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
    -- CCBCenter.popFirstCCBNode()
end

local function onActionFetchEightDayList( msg, luaValue )
    -- 1900 + 10
    Log.d(TAG, "onActionFetchEightDayList: MSG_ID = %d", msg:getMsgId())
    local function onFetchCallback( items )
        _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchEightDayList",
            onFetchCallback
            )
end

local function onActionFetchEightDayReward( msg, luaValue )
    -- 1900 + 11
    Log.d(TAG, "onActionFetchEightDayReward: MSG_ID = %d", msg:getMsgId())
    local function onFetchCallback( items )
        local rewardEntity = require("model.main.RewardEntity").new(items)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYLIST)
--                    if MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW then
--                        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
--                    end
                end
            }
        )
        -- _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchEightDayReward",
            onFetchCallback,
            msg.userdata
            )
end



local function onActionFetchResetEightDayReward( msg, luaValue )
    -- 2000 + 12
    Log.d(TAG, "onActionFetchResetEightDayReward: MSG_ID = %d", msg:getMsgId())
    local function onFetchCallback( items )
        AlertLayer.new4OK{
            titleStr = _s("COMMON_NEWS_TIPS"),
            content = _s("ACTIVITY_RESET_SUCCESS"),
            btnClickEvent = {
                        function (  )  --按钮1事件  默认为确定
                            -- 领取回来刷新
                            CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYLIST)
--                            if MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW then
--                                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
--                            end
                        end
                    }, -- 按钮事件数组
        }
        -- _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchResetEightDayReward",
            onFetchCallback,
            msg.userdata
            )
    
end



-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
--  Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
    --1900
    Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL)
    _ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityEightDayLayer.ccbi")
    -- Quick element
    _nodeTable["mEightDaysInfoLabel"] = _ccbNode:getNode("mEightDaysInfoLabel", "CCLabelTTF")

    _nodeTable["mTitleNode"] = _ccbNode:getNode("mTitleNode", "CCNode")

    -- CCControlButton
    -- MenuItem
    -- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
    --填充文字
    _nodeTable["mEightDaysInfoLabel"]:setString(_s("ACTIVITY_RECEIVE_DIAMOND"))
    
    CCBCenter.bindView("ccb.v.main.ActivityEightDayLayerView", _ccbNode, _nodeTable)
    if callback then
        callback(_ccbNode)
    else
        CCBCenter.pushFirstCCBNode(_ccbNode)
    end
    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYLIST)
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_MODEL]             = onCCBLoad
MSG_HANDLER[MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYLIST]    = onActionFetchEightDayList
MSG_HANDLER[MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHEIGHTDAYREWARD]  = onActionFetchEightDayReward
MSG_HANDLER[MSG_ID.MSG_ACTIVITYEIGHTDAYLAYER_ACTION_ONFETCHRESETEIGHTDAYREWARD] = onActionFetchResetEightDayReward