--ActivityInviteLayer.lua

MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL 				= 1700

MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNRECEIVECLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITELIST = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 11
MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITEDIAMOND = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 12
MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNSINAWEIBOCLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 13
MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTENCENTWEIBOCLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 14
MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNWECHATCLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 15
MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNFACEBOOKCLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 16
MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTWITTERCLICK = MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL + 17

local TAG = "[ActivityInviteLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- CCBCenter.popFirstCCBNode()
end


local function onBtnReceiveClick( msg, luaValue )
	--1700 + 10
	Log.d(TAG, "btnReceive: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNRECEIVECLICK)
	SOUND:playEffectButton1()
	if _ccbNode._DATA and _ccbNode._DATA.diamonds > 0 then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITEDIAMOND)
	else
		NetHelper.QuickToast(_s("ACTIVITY_NO_DIAMOND_RECEIVE"))
	end
end

local function onActionFetchInviteList( msg, luaValue )
	-- 1700 + 11
	Log.d(TAG, "onActionFetchInviteList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode._DATA = items
		_ccbNode.updateList(items)
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchInviteList",
            onFetchCallback
            )
end

local function onActionFetchInviteDiamond( msg, luaValue )
	-- 1700 + 12
	Log.d(TAG, "onActionFetchInviteDiamond: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new({diamond = _ccbNode._DATA.diamonds,})
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITELIST)
--                    if MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW then
--                        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
--                    end
                end
            }
        )
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchInviteDiamond",
            onFetchCallback
            )
end

local function onActionFetchShareSucess( ... )
	local function onFetchCallback( properties )
		--获取奖励
		 local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
				CCBCenter.loadCCB(
			            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
		            	"ccb.c.main.ReceiveRewardAlertLayer", 
			            {
			                entity = rewardEntity,
			            }
			        )

	end
	
	NetHelper.createRequest(
        ACTID.MSG_SHARE_SUCCESS,
        onFetchCallback,
		{},
		{}
    )
end


local _sharePlatform = require("sdk.SharePlatform").new()
local function shareSdkInfo(sdkType)

	_sharePlatform:shareInfo(
			function ( ... )
				-- 好像不用做什么的样子...
				-- print("分享完成保存到服务端啦")
				onActionFetchShareSucess()
			end, 
			function ( ... )
				-- 同样无所事事的,会不会被干掉啊~~~
				-- print("分享失败，，，，，，，，")
				NetHelper.QuickToast(_s("ACTIVITY_INVITE_FAILURE"))
			end,
			{	shareId = sdkType,
				shareStr = _ccbNode._DATA.showstr,
				shareshowstr = _ccbNode._DATA.shareshowstr,
				shareDefaultContent = _ccbNode._DATA.shareDefaultContent,
				shareImage = _ccbNode._DATA.shareImage,
				shareUrl = _ccbNode._DATA.shareUrl,
				shareDescription = _ccbNode._DATA.shareDescription,
				shareTitle	=	_ccbNode._DATA.shareTitle,
				shareImageWithPath = _ccbNode._DATA.shareImageWithPath,
			}
		)
end


--新浪微博分享
local function onBtnSinaWeiboClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnSinaWeibo: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNSINAWEIBOCLICK)
	shareSdkInfo('1') --分享
end
--腾讯微博分享
local function onBtnTentcentWeiboClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnTencentWeibo: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTENCENTWEIBOCLICK)
	 shareSdkInfo('2') --分享
end

--微信朋友圈分享
local function onBtnWechatClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnWechat: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNWECHATCLICK)
	 shareSdkInfo('23') --分享
end

--facebook分享
local function onBtnFacebookClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnFacebook: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNFACEBOOKCLICK)
	shareSdkInfo('10') --分享
end
--twitter分享
local function onBtnTwitterClick( msg, luaValue )
	--22000 + 12
	Log.d(TAG, "btnTwitter: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTWITTERCLICK)
	shareSdkInfo('11') --分享
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--1700
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityInviteLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mUserNoLabel"] = _ccbNode:getNode("mUserNoLabel", "CCLabelTTF")
	_nodeTable["mAllDiamondLabel"] = _ccbNode:getNode("mAllDiamondLabel", "CCLabelTTF")
	_nodeTable["mLeftContentLabel"] = _ccbNode:getNode("mLeftContentLabel", "CCLabelTTF")
	_nodeTable["mYourIdLabel"] = _ccbNode:getNode("mYourIdLabel", "CCLabelTTF")
	_nodeTable["mFirstInviteLabel"] = _ccbNode:getNode("mFirstInviteLabel", "CCLabelTTF")
	_nodeTable["mRightTitleSprite"] = _ccbNode:getNode("mRightTitleSprite", "CCSprite")
	_nodeTable["mLeftTitleSprite"] = _ccbNode:getNode("mLeftTitleSprite", "CCSprite")
	_nodeTable["mOpenLabel"] = _ccbNode:getNode("mOpenLabel", "CCLabelTTF")
	_nodeTable["btnSinaWeibo"] = _ccbNode:getNode("btnSinaWeibo", "CCControlButton")
	_nodeTable["btnTencentWeibo"] = _ccbNode:getNode("btnTencentWeibo", "CCControlButton")
	_nodeTable["btnWechat"] = _ccbNode:getNode("btnWechat", "CCControlButton")
	_nodeTable["btnFacebook"] = _ccbNode:getNode("btnFacebook", "CCControlButton")
	_nodeTable["btnTwitter"] = _ccbNode:getNode("btnTwitter", "CCControlButton")
    _nodeTable["mLeftTitleNode"] = _ccbNode:getNode("mLeftTitleNode", "CCNode")
    _nodeTable["mRightTitleNode"] = _ccbNode:getNode("mRightTitleNode", "CCNode")
	
	-- CCControlButton
	_ccbNode:bindButton("btnReceive", onBtnReceiveClick, _s("REWARD_RECEIVE"))
	_ccbNode:bindButton("btnSinaWeibo", onBtnSinaWeiboClick)
	_ccbNode:bindButton("btnTencentWeibo", onBtnTentcentWeiboClick)
	_ccbNode:bindButton("btnWechat", onBtnWechatClick)
	_ccbNode:bindButton("btnFacebook", onBtnFacebookClick)
	_ccbNode:bindButton("btnTwitter", onBtnTwitterClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- 填充文字
	_nodeTable["mYourIdLabel"]:setString(_s("ACTIVITY_YOUR_INVITATION_CODE"))
	_nodeTable["mLeftContentLabel"]:setString(_s("ACTIVITY_INVITE_FRIENDS_INFO"))
	_nodeTable["mOpenLabel"]:setString(_s("ACTIVITY_INVITE_SHARE_OPEN"))
	
	CCBCenter.bindView("ccb.v.main.ActivityInviteLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITELIST)
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNRECEIVECLICK]	= onBtnReceiveClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITELIST]	= onActionFetchInviteList
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ACTION_ONFETCHINVITEDIAMOND]	= onActionFetchInviteDiamond
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNSINAWEIBOCLICK]	= onBtnSinaWeiboClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTENCENTWEIBOCLICK]	= onBtnTentcentWeiboClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNWECHATCLICK]	= onBtnWechatClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNFACEBOOKCLICK]	= onBtnFacebookClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYINVITELAYER_ONBTNTWITTERCLICK]	= onBtnTwitterClick
