--ActivityLevelRankLayer.lua

MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL 				= 1600

MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ONBTNRECEIVECLICK = MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKLIST = MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL + 11
MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKREWARD = MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL + 12

local TAG = "[ActivityLevelRankLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- CCBCenter.popFirstCCBNode()
end


local function onBtnReceiveClick( msg, luaValue )
	--1600 + 10
	Log.d(TAG, "btnReceive: MSG_ID = %d", MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ONBTNRECEIVECLICK)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKREWARD)
end

local function onActionFetchLevelRankList( msg, luaValue )
	-- 1600 + 11
	Log.d(TAG, "onActionFetchLevelRankList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchLevelRankList",
            onFetchCallback
            )
end

local function onActionFetchLevelRankReward( msg, luaValue )
	-- 1600 + 12
	Log.d(TAG, "onActionFetchLevelRankReward: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKLIST)
--                    if MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW then
--                        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
--                    end
                end
            }
        )
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchLevelRankReward",
            onFetchCallback
            )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--1600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityLevelRankLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mMyRankLabel"] = _ccbNode:getNode("mMyRankLabel", "CCLabelTTF")
	_nodeTable["mInfoLabel"] = _ccbNode:getNode("mInfoLabel", "CCLabelTTF")
	_nodeTable["btnReceive"] = _ccbNode:getNode("btnReceive", "CCControlButton")
	_nodeTable["mInfoTitleLabel"] = _ccbNode:getNode("mInfoTitleLabel", "CCLabelTTF")
	_nodeTable["mTopTenLabel"] = _ccbNode:getNode("mTopTenLabel", "CCLabelTTF")
	_nodeTable["mMyRankTitleLabel"] = _ccbNode:getNode("mMyRankTitleLabel", "CCLabelTTF")
	_nodeTable["mOverTimeLabel"] = _ccbNode:getNode("mOverTimeLabel", "CCLabelTTF")
	_nodeTable["mLevelRankRewardLabel"] = _ccbNode:getNode("mLevelRankRewardLabel", "CCLabelTTF")
	_nodeTable["mTitleNode"] = _ccbNode:getNode("mTitleNode", "CCNode")
    
	-- CCControlButton
	_ccbNode:bindButton("btnReceive", onBtnReceiveClick, _s("ACTIVITY_RECEIVE_REWARD"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.main.ActivityLevelRankLayerView", _ccbNode, _nodeTable)
	-- 填充文字
	_nodeTable["mInfoTitleLabel"]:setString(_s("ACTIVITY_CAPTION"))
	_nodeTable["mTopTenLabel"]:setString(_s("ACTIVITY_LEVEL_RANK_TOP_10"))
	_nodeTable["mMyRankTitleLabel"]:setString(_s("ACTIVITY_MY_RANK"))
	_nodeTable["mOverTimeLabel"]:setString(_s("ACTIVITY_OVER_TIME"))
	_nodeTable["mLevelRankRewardLabel"]:setString(_s("ACTIVITY_LEVEL_RANK_REWARD"))
	
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKLIST)
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ONBTNRECEIVECLICK]	= onBtnReceiveClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKLIST]	= onActionFetchLevelRankList
MSG_HANDLER[MSG_ID.MSG_ACTIVITYLEVELRANKLAYER_ACTION_ONFETCHLEVELRANKREWARD]	= onActionFetchLevelRankReward