--ActivityRedemptionCodeLayer.lua

MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_MODEL 				= 22400

MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ONBTNEXCHANGECLICK = MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_MODEL + 10
MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ACTION_ONFETCHEXCHANGECODE = MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_MODEL + 11

local TAG = "[ActivityRedemptionCodeLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	_ccbNode.resetCode()
	CCBCenter.popLastLevelCCBNode()
end

-- 处理网络请求失败的回调函数
local function netReceiveFail(result, cbParams)
    -- 显示[购买体力]对话框
    -- AlertLayer.new{
    --     titleStr    = _s("COMMON_NEWS_TIPS"),                       	-- 标题
    --     content     = _s("NETWORK_CONNECT_FAILED2"),   -- 内容
    --     btnStr      = { _s("COMMON_OK") },        				-- 按钮文字数组
    --     btnColor    = { AlertLayer.BTN_COLOR_YELLOW },
    --     -- 按钮颜色数组
    --     btnClickEvent = {                   -- 按钮事件数组
    --         function()                      -- 按钮[确定]回调
    --             Log.d(TAG, "请求出错..")
    --             _nodeTable["btnExchange"]:setEnabled(true)
    --         end,
    --     }, 
    -- }
    _nodeTable["btnExchange"]:setEnabled(true)
end

local function onBtnExchangeClick( msg, luaValue )
	--22400 + 10
	Log.d(TAG, "btnExchange: MSG_ID = %d", MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ONBTNEXCHANGECLICK)
	if _ccbNode.isCodeCompliance() then
		_nodeTable["btnExchange"]:setEnabled(false)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ACTION_ONFETCHEXCHANGECODE, nil, {code = _ccbNode.getCode()})
	end
end

local function onActionFetchExchangeCode( msg, luaValue )
	-- 1900 + 11
	Log.d(TAG, "onActionFetchExchangeCode: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.resetCode( )
        local rewardEntity = require("model.main.RewardEntity").new(items)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                    -- 领取回来刷新
                    _nodeTable["btnExchange"]:setEnabled(true)
                end
            }
        )
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
        "model.main.MainModel",
        "fetchExchangeCode",
        onFetchCallback,
        msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--22400
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ActivityRedemptionCodeLayer.ccbi")
	-- Quick element
	_nodeTable["mExchangeTitleLabel"] = _ccbNode:getNode("mExchangeTitleLabel", "CCLabelTTF")
	_nodeTable["btnExchange"] = _ccbNode:getNode("btnExchange", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnExchange", onBtnExchangeClick, _s("ACTIVITY_BTN_TITLE_EXCHANGE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- 填充文字
	_nodeTable["mExchangeTitleLabel"]:setString(_s("ACTIVITY_EXCHANGE_CODE"))
	CCBCenter.bindView("ccb.v.main.ActivityRedemptionCodeLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ONBTNEXCHANGECLICK]	= onBtnExchangeClick
MSG_HANDLER[MSG_ID.MSG_ACTIVITYREDEMPTIONCODELAYER_ACTION_ONFETCHEXCHANGECODE]	= onActionFetchExchangeCode