--MainActivityLayer.lua

MSG_ID.MSG_MAINACTIVITYLAYER_MODEL 				= 1300

MSG_ID.MSG_MAINACTIVITYLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAINACTIVITYLAYER_MODEL + 10
MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONFETCHACTIVITYLIST = MSG_ID.MSG_MAINACTIVITYLAYER_MODEL + 11
MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONENABLECLOSE = MSG_ID.MSG_MAINACTIVITYLAYER_MODEL + 12
MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONDISENABLECLOSE = MSG_ID.MSG_MAINACTIVITYLAYER_MODEL + 13

local TAG = "[MainActivityLayer]"
local _ccbNode 
local _nodeTable = {}
local _onSelectOne = true
local _fromMain = false
local function closeLayer()
	-- 刷新下首页
	if _fromMain then
	    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	end
	CCBCenter.popLastLevelCCBNode(anim.ANIMATION_TOP_OUT)
	-- 清空月卡msgid
	if MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD then
		MSG_HANDLER[MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD] = nil
		MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARD = nil
		package.loaded["ccb.c.activity.ActivityMonthCardLayer"] = nil
	end
end


local function onBtnCloseClick( msg, luaValue )
	--1300 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAINACTIVITYLAYER_ONBTNCLOSECLICK)
	SOUND:playEffectButton1()
	closeLayer()
end

local function onActionFetchActivityList( msg, luaValue )
	-- 1300 + 11
	Log.d(TAG, "onActionFetchActivityList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateData(items)
		-- quickui.hideLoadingLayer()
    end
    ModelHelper.requireDataWithFun(
            "model.main.MainModel",
            "fetchActivityList",
            onFetchCallback,
            msg.userdata
            )
end

local function onActionEnableClose( msg, luaValue )
	-- 1300 + 12
	Log.d(TAG, "onActionEnableClose: MSG_ID = %d", msg:getMsgId())
	_nodeTable["btnClose"]:setEnabled(true)
	_ccbNode.enableTouchTab(true)
end

local function onActionDisenableClose( msg, luaValue )
	-- 1300 + 13
	Log.d(TAG, "onActionDisenableClose: MSG_ID = %d", msg:getMsgId())
	_nodeTable["btnClose"]:setEnabled(false)
	_ccbNode.enableTouchTab(false)
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--1300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAINACTIVITYLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MainActivityLayer.ccbi")
	-- _ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_NONE
	_ccbNode.closeLayer = closeLayer
	_nodeTable._TYP = data.typ or 2
	if data then
		_fromMain = data.fromMain
		if data.showFirshCharge then
			_ccbNode._SELECTATYPE = ACTIVITY_ATYPE.FIRST
		else
			_ccbNode._SELECTATYPE = tonumber(data.selectAtype)
		end
		-- _nodeTable.btnRecharge:setVisible(false)
	end
	-- Quick element
	_nodeTable["btnClose"] = _ccbNode:getNode("btnClose", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	
	-- 屏蔽的时候直接跳过所有
	if SKILL_NEW_FUNCTION then
		return
	end
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.main.MainActivityLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_TOP_IN, {
			onComplete = function ( )
				CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONFETCHACTIVITYLIST, nil, {typ = _nodeTable._TYP})
			end
			}
		)
	end
	
end


MSG_HANDLER[MSG_ID.MSG_MAINACTIVITYLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAINACTIVITYLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONFETCHACTIVITYLIST]	= onActionFetchActivityList
MSG_HANDLER[MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONENABLECLOSE]	= onActionEnableClose
MSG_HANDLER[MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONDISENABLECLOSE]	= onActionDisenableClose
