--MainRewardAlertLayer.lua

MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL 				= 20200

MSG_ID.MSG_MAINREWARDALERTLAYER_ONBTNBACKCLICK = MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL + 10
MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHREWARDLIST = MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL + 11
MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHRECEIVEREWARD = MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL + 12

local TAG = "[MainRewardAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnBackClick( msg, luaValue )
	--20200 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_MAINREWARDALERTLAYER_ONBTNBACKCLICK)
	-- 更新玩家信息
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	closeLayer()
end

local function onActionFetchRewardList( msg, luaValue )
	-- 1000 + 11
	Log.d(TAG, "onActionFetchRewardList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateReward(items)
    end
    ModelHelper.requireDataWithFun(
        "model.main.MainModel",
        "fetchRewardList",
        onFetchCallback,
        {}
    )
end

local function onActionFetchReceiveReward( msg, luaValue )
	-- 1000 + 12
	Log.d(TAG, "onActionFetchReceiveReward: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items.reward)
		CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity, 
                onConfirm = _ccbNode.checkHelperInfo,
                mission = true,
            }
        )
		-- 刷新列表
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHREWARDLIST)
    end
    ModelHelper.requireDataWithFun(
        "model.main.MainModel",
        "fetchReceiveReward",
        onFetchCallback,
        msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--20200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MainRewardAlertLayer.ccbi")
    _ccbNode.closeLayer = closeLayer

	-- if data and data.day then
	-- 	_ccbNode._SELECT = 2
	-- else
		_ccbNode._SELECT = 1
	-- end
	-- Quick element
	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.main.MainRewardAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, { playTime = 0.3, onComplete = function ( )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHREWARDLIST)
		end })
	end
end


MSG_HANDLER[MSG_ID.MSG_MAINREWARDALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAINREWARDALERTLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHREWARDLIST]	= onActionFetchRewardList
MSG_HANDLER[MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHRECEIVEREWARD]	= onActionFetchReceiveReward