--SignLayer.lua

MSG_ID.MSG_SIGNLAYER_MODEL 				= 1100

MSG_ID.MSG_SIGNLAYER_ONBTNBACKCLICK = MSG_ID.MSG_SIGNLAYER_MODEL + 10
MSG_ID.MSG_SIGNLAYER_ONBTNSIGNCLICK = MSG_ID.MSG_SIGNLAYER_MODEL + 11
MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETSIGNLIST = MSG_ID.MSG_SIGNLAYER_MODEL + 12
MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETREWARDLIST = MSG_ID.MSG_SIGNLAYER_MODEL +13

local TAG = "[SignLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnBackClick( msg, luaValue )
	--1100 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_SIGNLAYER_ONBTNBACKCLICK)

	closeLayer()
end

local function onBtnSignClick( msg, luaValue )
	--1100 + 11
	Log.d(TAG, "btnSign: MSG_ID = %d", MSG_ID.MSG_SIGNLAYER_ONBTNSIGNCLICK)
	 _ccbNode:getNode("btnSign", "CCControlButton"):setEnabled(false)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETREWARDLIST, nil, {signintype = 1, rewardno = "0"})
end

local function onActionFetchSignList( msg, luaValue )

	local function onFetchCallback( properties, params )
        if properties then
            _ccbNode.setSignlist(properties.signlist, properties.signcount)
            _ccbNode.setSignTimes(properties.totalsign, properties.signcount)
            _ccbNode.setOnlineTimesList(properties.timereward)
   			_ccbNode.setSignEnabled(properties.signed)
        else
            Log.d(TAG,"err")
        end
        NetHelper.hideLoading(true)
    end
    --
    NetHelper.showLoading(true, true)
	NetHelper.createRequest(
			        ACTID.MSG_GET_SIGNIN_LIST,
			        onFetchCallback,
			        {}
			    )
end

local function onActionFetchRewardList( msg, luaValue )
	-- body
	local function onFetchCallback( properties )
		NetHelper.hideLoading(true)
        local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
        onActionFetchSignList()
    end
    NetHelper.showLoading(true, true)
	NetHelper.createRequest(
			        ACTID.MSG_GET_SIGNIN_REWARD,
			        onFetchCallback,
			        {signintype = msg.userdata.signintype, rewardno = msg.userdata.rewardno}
			    )

end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--1100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SIGNLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "SignLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element  
	_nodeTable["mOnLineReward"] = _ccbNode:getNode("mOnLineReward", "CCNode")
	_nodeTable["mSignTitleLabel"] = _ccbNode:getNode("mSignTitleLabel", "CCLabelTTF")
	_nodeTable["mSigns"] = _ccbNode:getNode("mSigns", "CCNode")
	_nodeTable["mSignsReward"] = _ccbNode:getNode("mSignsReward", "CCNode")
	_nodeTable["mSignCalender"] = _ccbNode:getNode("mSignCalender", "CCNode")
	_nodeTable["mSignWeek"] = _ccbNode:getNode("mSignWeek", "CCNode")
	_nodeTable["mSignTitleLabel"] = _ccbNode:getNode("mSignTitleLabel", "CCLabelTTF")

	_nodeTable["mTotalSignedLabel"] =  _ccbNode:getNode("mTotalSignedLabel", "CCLabelTTF")
	_nodeTable["btnSign"] =  _ccbNode:getNode("btnSign", "CCControlButton")

	_nodeTable["mSignTitleLabel"]:setString(_s("REWARD_SIGN"))

	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)
	_ccbNode:bindButton("btnSign", onBtnSignClick, _s("REWARD_SIGN"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
    
	-- 填充文字
    _nodeTable["mSignTitleLabel"]:setString(_s("REWARD_SIGN"))

    CCBCenter.bindView("ccb.v.main.SignLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		--CCBCenter.pushLastLevelCCBNode(_ccbNode,)
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	onActionFetchSignList()
   		 end})
	end

	--_ccbNode.reloadSignGrid()

	
end

MSG_HANDLER[MSG_ID.MSG_SIGNLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_SIGNLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_SIGNLAYER_ONBTNSIGNCLICK]	= onBtnSignClick
MSG_HANDLER[MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETSIGNLIST]	= onActionFetchSignList
MSG_HANDLER[MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETREWARDLIST]	= onActionFetchRewardList
