--MakeHopeLayer.lua

MSG_ID.MSG_MAKEHOPELAYER_MODEL 				= 28000

MSG_ID.MSG_MAKEHOPELAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAKEHOPELAYER_MODEL + 10
MSG_ID.MSG_MAKEHOPELAYER_ONBTNMAKEHOPECLICK = MSG_ID.MSG_MAKEHOPELAYER_MODEL + 11
MSG_ID.MSG_MAKEHOPELAYER_ONBTNHELPCLICK = MSG_ID.MSG_MAKEHOPELAYER_MODEL + 12

local TAG = "[MakeHopeLayer]"
local _ccbNode 
local _nodeTable = {}
local makehopeModel = require("ccb.m.makehope.MakeHopeModel")

local function closeLayer()
	SOUND:playMusicHome(true)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	CCBCenter.popLastLevelCCBNode()
end

--根据不同参数请求数据
local function netGetHopeInfo( msg, luaValue )
		makehopeModel.getHopeInfo{
				callback = _ccbNode.callBackHopeInfo,
		 		methodId = msg.userdata.methodId,
		 		args     = msg.userdata.arg
		}
end
local function getHeopInfoAndReward( msg, luaValue )
		makehopeModel.getHeopInfoAndReward{
				callback = _ccbNode.callBackMakeHopeInfo,
		 		methodId = msg.userdata.methodId,
		 		args     = msg.userdata.arg
		}
end


local function onBtnCloseClick( msg, luaValue )
	--28000 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAKEHOPELAYER_ONBTNCLOSECLICK)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	SOUND:playMusicHome(true)
	closeLayer()

end

local function onBtnHelpClick( msg, luaValue )
    --3500 + 12
    Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_MAKEHOPELAYER_ONBTNHELPCLICK)
    -- 说明
    CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isMakeHopeRule = true,})
end

local function onBtnMakeHopeClick( msg, luaValue )
	--28000 + 11
	Log.d(TAG, "btnMakeHope: MSG_ID = %d", MSG_ID.MSG_MAKEHOPELAYER_ONBTNMAKEHOPECLICK)
	
	if _nodeTable['canMakeHope'] == 1 then
		getHeopInfoAndReward({userdata = {arg = {}, methodId = ACTID.MSG_GET_WISH}})
	else
		NetHelper.QuickToast(_s("COMMON_HAVEGET"))  
	end
end

local function animationCompletedCallback( animationManager, animName, luaEventHandler )
	Log.d(TAG, "animationCompletedCallback: %s", animName)
end

local function onCCBLoad(data, callback)
	--28000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAKEHOPELAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MakeHopeLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnMakeHope", onBtnMakeHopeClick)
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)
	_nodeTable["mTItleLabel"] = _ccbNode:getNode("mTItleLabel", "CCLabelTTF")

	_nodeTable["mLineLabel"] = _ccbNode:getNode("mLineLabel", "CCLabelTTF")
 
	_nodeTable["mLineLabel"]:setString(_s("COMMON_SPEED"))
	_nodeTable["mTItleLabel"]:setString(_s("MAIN_WISHING"))
	_nodeTable["mTItleLabel"]:setString(_s("MAIN_WISHING"))
	-- MenuItem
	_ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.makehope.MakeHopeLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( )
			--获取数据
			netGetHopeInfo({userdata = {arg = {}, methodId = ACTID.MSG_INTO_WISH}})
		end})
	end
	SOUND:playMusicWishPool(true)
end


MSG_HANDLER[MSG_ID.MSG_MAKEHOPELAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAKEHOPELAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAKEHOPELAYER_ONBTNMAKEHOPECLICK]	= onBtnMakeHopeClick
MSG_HANDLER[MSG_ID.MSG_MAKEHOPELAYER_ONBTNHELPCLICK]	= onBtnHelpClick
