--MapExploreLayer.lua

MSG_ID.MSG_MAPEXPLORELAYER_MODEL 				= 9400

MSG_ID.MSG_MAPEXPLORELAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 10
MSG_ID.MSG_MAPEXPLORELAYER_ONBTNEXPLORECLICK = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 11
MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHLEVELEXPLORE = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 12
MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHADDFRIEND = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 13
MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLOREPRAISE = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 14
MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLORESTEAL = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 15
MSG_ID.MSG_MAPEXPLORELAYER_ONBTNADDSPCLICK = MSG_ID.MSG_MAPEXPLORELAYER_MODEL + 16

local TAG = "[MapExploreLayer]"
local _ccbNode 
local _nodeTable = {}
local SpManager                     = require("cardui.SpManager")

local function closeLayer()
    SOUND:playMusicHome(true)
    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONFETCHEXPLOREREWARD, nil, {sn = _ccbNode._DATA.mapSn})
	CCBCenter.popLastLevelCCBNode()
end

-- 处理网络请求失败的回调函数
local function netReceiveFail(result, cbParams)
    -- 显示[购买体力]对话框
    AlertLayer.new{
        titleStr    = _s("COMMON_NEWS_TIPS"),                       	-- 标题
        content     = _s("NETWORK_CONNECT_FAILED2"),   -- 内容
        btnStr      = { _s("COMMON_OK") },        				-- 按钮文字数组
        btnColor    = { AlertLayer.BTN_COLOR_YELLOW },
        -- 按钮颜色数组
        btnClickEvent = {                   -- 按钮事件数组
            function()                      -- 按钮[确定]回调
                Log.d(TAG, "请求出错..")
                _ccbNode._DATA._EXPLORE = false
                closeLayer()
            end,
        }, 
    }
end
local function onBtnCloseClick( msg, luaValue )
	--9200 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORELAYER_ONBTNCLOSECLICK)
    SOUND:playEffectButton1()
	if _ccbNode._DATA._EXPLORE then
		NetHelper.QuickToast(_s("MAP_EXPLORING"))
		return
	end
	closeLayer()
end

local function onBtnExploreClick( msg, luaValue )
	--9200 + 11
	Log.d(TAG, "btnExplore: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORELAYER_ONBTNEXPLORECLICK)
    SOUND:playEffectButton1()
	local function isSpEmpty()
		return _ccbNode._DATA.costSp > ME:getCursp()
	end
	local function isProgressReached( ... )
		 return _ccbNode._DATA.progress >= _ccbNode._DATA.maxLv 
	end
	-- 显示对话框[体力不足]
	if isSpEmpty() then
		-- AlertLayer.new4OK({
		-- 	content 	= _s("MAP_SP_NOT_ENOUGH"),
  --           btnClickEvent = {closeLayer},
		-- })
        -- 发起添加SP体力请求
        SpManager.netAdd(_ccbNode.updateSp)
		return
	end
	if isProgressReached() then
		AlertLayer.new4OK({
			content 	= _s("MAP_EXPLORE_FINISH"),
            btnClickEvent = {closeLayer},
		})
		return
	end
	if _ccbNode._DATA._EXPLORE then
		return
	end
	_ccbNode.runExplore()
	_ccbNode._DATA._EXPLORE = true
	_nodeTable["btnExplore"]:setEnabled(false)
end

local function onActionFetchLevelExplore( msg, luaValue )
	-- 1000 + 12
	Log.d(TAG, "onActionFetchLevelExplore: MSG_ID = %d", msg:getMsgId())
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( result )
        _ccbNode:removeAction(handler)
		_ccbNode.updateExploreData(result)
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
	    "model.map.MapModel",
	    "fetchLevelExplore",
	    onFetchCallback,
	    msg.userdata
    )
	-- _ccbNode.updateExploreData{res = 3, mid = 102, fin = 5, fid = 12, lv = 12, name = "花客"}
end

local function onActionFetchAddFriend( msg, luaValue )
	-- 1000 + 13
	Log.d(TAG, "onActionFetchAddFriend: MSG_ID = %d", msg:getMsgId())
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( result )
        _ccbNode:removeAction(handler)
    end
    -- msg.userdata.failedCb = netReceiveAddFriendFail
    ModelHelper.requireDataWithFun(
	    "model.map.MapModel",
	    "fetchAddFriend",
	    onFetchCallback,
	    msg.userdata
    )
end

local function onBtnAddSpClick( msg, luaValue )
    --13000 + 10
    Log.d(TAG, "btnAddSp: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORELAYER_ONBTNADDSPCLICK)

    -- 发起添加SP体力请求
    SpManager.netAdd(_ccbNode.updateSp)
end

local function onActionFetchExplorePraise( msg, luaValue )
	-- 1000 + 14
	Log.d(TAG, "onActionFetchExplorePraise: MSG_ID = %d", msg:getMsgId())
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( result )
        _ccbNode:removeAction(handler)
		_ccbNode.updatePraiseResult(result)
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
	    "model.map.MapModel",
	    "fetchExplorePraise",
	    onFetchCallback,
	    msg.userdata
    )
end

local function onActionFetchExploreSteal( msg, luaValue )
	-- 1000 + 15
	Log.d(TAG, "onActionFetchExploreSteal: MSG_ID = %d", msg:getMsgId())
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( result )
        _ccbNode:removeAction(handler)
		_ccbNode.updateRobberyResult(result)
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
	    "model.map.MapModel",
	    "fetchExploreSteal",
	    onFetchCallback,
	    msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--9200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORELAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MapExploreLayer.ccbi")
	_ccbNode._DATA = data
	-- Quick element
	_nodeTable["mNameLabel"] = _ccbNode:getNode("mNameLabel", "CCLabelTTF")
	_nodeTable["mAttackLabel"] = _ccbNode:getNode("mAttackLabel", "CCLabelTTF")
	_nodeTable["mHpLabel"] = _ccbNode:getNode("mHpLabel", "CCLabelTTF")
	_nodeTable["mSpLabel"] = _ccbNode:getTTFLabel("mSpLabel", _s("MAP_EXPLORE_SP"))
	_nodeTable["mExpLabel"] = _ccbNode:getTTFLabel("mExpLabel", _s("MAP_EXPLORE_EXP"))
	_nodeTable["mLevelLabel"] = _ccbNode:getNode("mLevelLabel", "CCLabelTTF")
	_nodeTable["mProgressLabel"] = _ccbNode:getNode("mProgressLabel", "CCLabelTTF")
    _nodeTable["btnExplore"] = _ccbNode:getNode("btnExplore", "CCControlButton")
	_nodeTable["btnAddSp"] = _ccbNode:getNode("btnAddSp", "CCControlButton")
	
	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
    _ccbNode:bindButton("btnExplore", onBtnExploreClick)
    _ccbNode:bindButton("btnHelp", onBtnHelpClick)
	_ccbNode:bindButton("btnAddSp", onBtnAddSpClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mLevelLabel, 0, 6 ) 	-- 等级

	CCBCenter.bindView("ccb.v.map.MapExploreLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
    _ccbNode.closeLayer = closeLayer
    SOUND:playMusicExplore(true)
end


MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ONBTNEXPLORECLICK]	= onBtnExploreClick
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHLEVELEXPLORE]	= onActionFetchLevelExplore
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHADDFRIEND]	= onActionFetchAddFriend
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLOREPRAISE]	= onActionFetchExplorePraise
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLORESTEAL] = onActionFetchExploreSteal
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORELAYER_ONBTNADDSPCLICK] = onBtnAddSpClick
