--MapExploreSelectLayer.lua

MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL 				= 9500

MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNEXPLORECLICK = MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL + 10
MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL + 11
MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONFETCHEXPLOREREWARD = MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL + 12
MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONBTNHELPCLICK = MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL + 13

local TAG = "[MapExploreSelectLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	SOUND:playEffectButton1()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA)
	CCBCenter.popLastLevelCCBNode()
end

local function onBtnCloseClick( msg, luaValue )
	--9500 + 11
	Log.d(TAG, "btnExplore: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNEXPLORECLICK)
	closeLayer()
end

local function onBtnHelpClick( msg, luaValue )
    --9200 + 13
    Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONBTNHELPCLICK)
    -- 说明
    CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isExploreRule = true,})
end

local function onBtnExploreClick( msg, luaValue )
	--9500 + 10
	Log.d(TAG, "btnExplore: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNCLOSECLICK)
	SOUND:playEffectButton1()
	local result = _ccbNode.getSelectLevel()
	local function isProgressReached( ... )
		 return result.progress >= _ccbNode._DATA._MAXLV 
	end
	local function isSpEmpty()
		return _ccbNode._DATA._SP > ME:getCursp()
	end
	if not result or isProgressReached() then
		AlertLayer.new4OK{
			content 	= _s("MAP_EXPLORE_FINISH")
		}
		return
	end
	if isSpEmpty() then
		AlertLayer.new4OK{
			content 	= _s("MAP_SP_NOT_ENOUGH"),
		}
		return
	end
	CCBCenter.loadCCB("MSG_MAPEXPLORELAYER_MODEL", "ccb.c.map.MapExploreLayer", result)
end

local function onActionFetchExploreReward( msg, luaValue )
	--9500 + 12
	Log.d(TAG, "btnExplore: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONFETCHEXPLOREREWARD)
	local function onFetchCallback( items )
		_ccbNode._DATA._RESULT = items.expInfos
		_ccbNode._DATA._SP = items.sp
		_ccbNode._DATA._MAXLV = items.maxlv
		_ccbNode.updateExploreData(items.expInfos)
    end
    _ccbNode.saveScrollOffset(msg.userdata.first)
    ModelHelper.requireDataWithFun(
        "model.map.MapModel",
        "fetchExploreReward",
        onFetchCallback,
        msg.userdata,
        msg.userdata
    )
    -- 状态 0 未解锁 1 解锁 但未获得 2 解锁 并已获得
 --    local result = {
 --    	{ rewards = {{no = 10001, count = 10, status = 0}, }, fin = 20, cd = 10, subsn = 1, isopen = TRUE},
 --    	{ rewards = {{no = 10002, count =  9, status = 1}, }, fin = 1, cd =  9, subsn = 2, isopen = TRUE},
 --    	{ rewards = {{no = 10003, count =  8, status = 2}, }, fin = 20, cd =  8, subsn = 3, isopen = TRUE},
 --    	{ rewards = {{no = 10004, count =  7, status = 0}, }, fin = 3, cd =  7, subsn = 4, isopen = FALSE},
	-- }
 --    _ccbNode.updateExploreData(result)
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--9500
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MapExploreSelectLayer.ccbi")
	_ccbNode.closeLayer = closeLayer

	_ccbNode._DATA = data
	_ccbNode._DATA.first = true
	-- Quick element
	_nodeTable["mLayerTitleLabel"] = _ccbNode:getNode("mLayerTitleLabel", "CCLabelTTF")
	_nodeTable["mBtnExploreLabel"] = _ccbNode:getNode("mBtnExploreLabel", "CCLabelTTF")
	_nodeTable["mProgressTitleLabel"] = _ccbNode:getTTFLabel("mProgressTitleLabel", _s("MAP_EXPLORE_PROGRESS_TITLE"))
	_nodeTable["btnExplore"] = _ccbNode:getNode("btnExplore", "CCControlButton")

	-- CCControlButton
	_ccbNode:bindButton("btnExplore", onBtnExploreClick)
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.mLayerTitleLabel, 0, 6 ) 	-- 标题

	-- 填充文字
	_nodeTable["mBtnExploreLabel"]:setString(_s("MAP_EXPLORE_LEVEL"))
	_nodeTable["mLayerTitleLabel"]:setString(_s("MAP_EXPLORE_TITLE"))
	
	CCBCenter.bindView("ccb.v.map.MapExploreSelectLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(
			_ccbNode, 
			anim.ANIMATION_POP_OUT, 
			{
				onComplete = function ( )
					CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONFETCHEXPLOREREWARD, nil, _ccbNode._DATA)
				end 
			}
		)
	end
end


MSG_HANDLER[MSG_ID.MSG_MAPEXPLORESELECTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNEXPLORECLICK]	= onBtnExploreClick
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORESELECTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONFETCHEXPLOREREWARD]	= onActionFetchExploreReward
MSG_HANDLER[MSG_ID.MSG_MAPEXPLORESELECTLAYER_ACTION_ONBTNHELPCLICK]	= onBtnHelpClick