--MapMiningLayer.lua

MSG_ID.MSG_MAPMININGLAYER_MODEL 				= 9600
MSG_ID.MSG_MAPMININGLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAPMININGLAYER_MODEL + 10
MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGLIST = MSG_ID.MSG_MAPMININGLAYER_MODEL + 11
MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGREWARD = MSG_ID.MSG_MAPMININGLAYER_MODEL + 12
MSG_ID.MSG_MAPMININGLAYER_ONBTNHELPCLICK = MSG_ID.MSG_MAPMININGLAYER_MODEL + 13
MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHBUYDIGSKIP = MSG_ID.MSG_MAPMININGLAYER_MODEL + 14

local TAG = "[MapMiningLayer]"
local _ccbNode 
local _nodeTable = {}
local _receiveFail = false
local function closeLayer()
    if _ccbNode.fromMain then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
    end
	-- CCBCenter.popLastLevelCCBNode()
    CCBCenter.popFirstCCBNode()
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

-- 处理网络请求失败的回调函数
local function netReceiveFail(result, cbParams)
    -- 显示[购买体力]对话框
    AlertLayer.new{
        titleStr    = _s("COMMON_NEWS_TIPS"),                           -- 标题
        content     = _s("NETWORK_CONNECT_FAILED2"),   -- 内容
        btnStr      = { _s("COMMON_OK") },                      -- 按钮文字数组
        btnColor    = { AlertLayer.BTN_COLOR_YELLOW },
        -- 按钮颜色数组
        btnClickEvent = {                   -- 按钮事件数组
            function()                      -- 按钮[确定]回调
                Log.d(TAG, "请求出错..")
                _receiveFail = true
                closeLayer()
            end,
        }, 
    }
end  
local function onBtnCloseClick( msg, luaValue )
	--9600 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ONBTNCLOSECLICK)
    SOUND:playEffectButton1()
    if _ccbNode.isAllowExit() or _receiveFail then
    	closeLayer()
    end
end
local function onBtnHelpClick( msg, luaValue )
    --9600 + 13
    Log.d(TAG, "btnHelp: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ONBTNHELPCLICK)
    -- 说明
    CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isMiningRule = true,})
end
local function onActionFetchDigList( msg, luaValue )
	-- 9600 + 11
	Log.d(TAG, "onActionFetchDigList: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGLIST)
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( items )
        if _ccbNode then
            _ccbNode:removeAction(handler)
        end
		_ccbNode.updateMineData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.map.MapModel",
        "fetchDigList",
        onFetchCallback,
        {failedCb = netReceiveFail}
    )
end

local function onActionFetchDigReward( msg, luaValue )
	-- 9600 + 12
	Log.d(TAG, "onActionFetchDigReward: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGREWARD)
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
	local function onFetchCallback( items )
        if _ccbNode then
            _ccbNode:removeAction(handler)
            _ccbNode.onMiningResponse( items.reward )
        end
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
        "model.map.MapModel",
        "fetchDigReward",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchBuyDigSkip( msg, luaValue )
    -- 9600 + 14
    Log.d(TAG, "onActionFetchBuyDigSkip: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHBUYDIGSKIP)
    -- 超时
    local handler = _ccbNode:performWithDelay(netReceiveFail, 30)
    local function onFetchCallback( items, params )
        if _ccbNode then
            NetHelper.QuickToast(_s("ACTIVITY_RESET_SUCCESS"))
            _ccbNode:removeAction(handler)
            _ccbNode.updateMineData(items)
            _ccbNode.starMineClick(params.digid)
        end
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
        "model.map.MapModel",
        "fetchBuyDigSkip",
        onFetchCallback,
        msg.userdata
    )
    -- onFetchCallback{}
end

local function onCCBLoad(data, callback)
	--9600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAPMININGLAYER_ONBTNCLOSECLICK)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MapMiningLayer.ccbi")
    _receiveFail = false
    _ccbNode.fromMain = false
    if data then
        _ccbNode.fromMain = data.fromMain
    end
	-- Quick element
	_nodeTable["mProgressLabel"] = _ccbNode:getNode("mProgressLabel", "CCLabelTTF")
	-- CCControlButton
    _ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnHelp", onBtnHelpClick)
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.map.MapMiningLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		-- CCBCenter.pushLastLevelCCBNode(_ccbNode)
        CCBCenter.pushFirstCCBNode(_ccbNode)
		onActionFetchDigList()
	end
end


MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_ONBTNCLOSECLICK]		= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGLIST]	= onActionFetchDigList
MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGREWARD]	= onActionFetchDigReward
MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_ONBTNHELPCLICK]    = onBtnHelpClick
MSG_HANDLER[MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHBUYDIGSKIP]    = onActionFetchBuyDigSkip
