--MapPopupDifficultyLayer.lua

MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL 				= 9200

MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 10
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 11
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 12
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNSTARTCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 13
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALLOCKCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 14
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYLOCKCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 15
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTLOCKCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 16
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 17
MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNADDSPCLICK = MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL + 18

local TAG = "[MapPopupDifficultyLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- 返回界面回调
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_RETURN_TO_VIEW)

	if VERSION_MAP == VERSION_MAP_1 then 
		CCBCenter.popSecondCCBNode()
	else 
		CCBCenter.popThirdCCBNode(anim.ANIMATION_TOP_OUT)
	end
end










-- [操作变量]
-- [工具]
-- 断言
local TDAssertUtils      			= require("view.Fight.Util.TDAssertUtils")
-- SP管理
local SpManager 					= require("cardui.SpManager")










-- [函数定义]
-- [辅助]
-- 判断是否还有体力值
local isSpEmpty
-- 显示对话框[体力不足]
local showAlertSpEmpty

-- [音效]
-- 播放按钮音效
local playButtonSound

-- [事件]
-- 处理按钮点击事件[难度]
local onBtnDifficultyClick
-- 处理按钮点击事件[开始]
local onBtnStartClick

-- [其他]
-- 判断难度是否锁定
local isDifficultyLocked
-- 获得等级ID
local getLevelId
-- 获得结点
local NODE










-- [事件处理]
local function onBtnDNormalClick( msg, luaValue )
	--9200 + 10
	Log.d(TAG, "btnDNormal: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALCLICK)
	onBtnDifficultyClick(DIFFICULTY_SIMPLE)
end

local function onBtnDOrdinaryClick( msg, luaValue )
	--9200 + 11
	Log.d(TAG, "btnDOrdinary: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYCLICK)
	onBtnDifficultyClick(DIFFICULTY_ORDINARY)
end

local function onBtnDDifficultClick( msg, luaValue )
	--9200 + 12
	Log.d(TAG, "btnDDifficult: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTCLICK)
	onBtnDifficultyClick(DIFFICULTY_DIFFICULT)
end

local function onBtnStartClick( msg, luaValue )
	--9200 + 13
	Log.d(TAG, "btnStart: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNSTARTCLICK)
end

local function onBtnDNormalLockClick( msg, luaValue )
	--9200 + 14
	Log.d(TAG, "btnDNormalLock: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALLOCKCLICK)
	onBtnDifficultyClick(DIFFICULTY_SIMPLE)
end

local function onBtnDOrdinaryLockClick( msg, luaValue )
	--9200 + 15
	Log.d(TAG, "btnDOrdinaryLock: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYLOCKCLICK)
	onBtnDifficultyClick(DIFFICULTY_ORDINARY)
end

local function onBtnDDifficultLockClick( msg, luaValue )
	--9200 + 16
	Log.d(TAG, "btnDDifficultLock: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTLOCKCLICK)
	onBtnDifficultyClick(DIFFICULTY_DIFFICULT)
end

local function onBtnCloseClick( msg, luaValue )
	--9200 + 17
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNCLOSECLICK)
	
	-- 播放按钮音效
	playButtonSound()
	-- 关闭层
	closeLayer()
end

local function onBtnAddSpClick( msg, luaValue )
	--9200 + 17
	Log.d(TAG, "onBtnAddSpClick: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNADDSPCLICK)
	
	-- 发起添加sp请求
	SpManager.netAdd(_ccbNode.refleshSp)
end










-- [辅助]
-- 判断是否还有体力值
function isSpEmpty()
	local costSp = math.ceil(_ccbNode._DATA.po.sp / GAMERATE:getSpRate())
	return costSp > ME:getCursp()
end

-- 显示对话框[体力不足]
function showAlertSpEmpty()
	AlertLayer.new4OK({
		content 	= _s("MAP_SP_NOT_ENOUGH")
	})
end

-- [按钮]
-- 公共按钮点击事件处理[难度]
function onBtnDifficultyClick(difficulty)
	-- [过滤判断]
    local canTouch = not isDifficultyLocked(difficulty)
	NODE(10309):setEnabled(canTouch)
    -- if not canTouch then
    -- 	print("cannottouch...............")
    -- 	return
    -- end



    -- [点击处理]
    -- 数据对象
    local po = _ccbNode._DATA.po
	-- 存储数据
	po.difficulty = difficulty

	local e1, e2, e3
	if difficulty == DIFFICULTY_SIMPLE then 
		e1 = true
		e2 = false
		e3 = false
	elseif difficulty == DIFFICULTY_ORDINARY then 
		e1 = false
		e2 = true
		e3 = false
	elseif difficulty == DIFFICULTY_DIFFICULT then 
		e1 = false
		e2 = false
		e3 = true
	end

	NODE(10301):setVisible(not e1); 	NODE(10304):setVisible(e1) 		-- N["btnDNormal"]
	NODE(10302):setVisible(not e2); 	NODE(10305):setVisible(e2) 		-- N["btnDOrdinary"]
	NODE(10303):setVisible(not e3); 	NODE(10306):setVisible(e3) 		-- N["btnDDifficult"]

	-- 重新渲染
	_ccbNode.rerender()
end

function onBtnStartClick()
    HelperView2.showNext()
    -- [数据对象]
    local po 			= _ccbNode._DATA.po
    local difficulty 	= po.difficulty
    local difficultyMax = po.star



	-- [过滤判断]
    local canTouch = not isDifficultyLocked(difficulty)
    if not canTouch then
    	return
    end

	-- 过滤判断
	if isSpEmpty() then 
		-- 显示对话框[体力不足]
		showAlertSpEmpty()
		return
	end

	-- 播放按钮音效
	playButtonSound()

	



    ------------------------------------------------------
    -- 意图：如果点击当前难度为专家级，则切换至无好友模式，单挑
    ------------------------------------------------------
    if difficulty == DIFFICULTY_DIFFICULT then
        -- [单独模式]
        AlertLayer.new({
            content     = _s("MAP_CONFIRM_DIFFICULT"), -- "进入专家模式，独战开始! :)",
            btnStr      = { _s("COMMON_OK"), _s("COMMON_CANCEL"), },
            btnClickEvent = {       -- 按钮事件数组
                function()
                    local friendId                  = 0                     			-- 好友ID
                    local friendName                = ""                    			-- 好友名称
                    local friendPoint               = 0                     			-- 友情点
                    local levelId                   = getLevelId(po)       				-- 关卡ID
                    local difficulty                = difficulty       					-- 关卡难度
    				local difficultyMax 			= difficultyMax    					-- 关卡难度[最大]
    				local isBreak 					= po.isBreak 						-- 是否是最新关卡（如果胜利则展开新关卡）
    				local mode 		 				= { battle = MODE_BATTLE_LEVEL }  	-- 战斗模式

                    -- print("friendId", friendId)
                    -- print("friendName", friendName)
                    -- print("friendPoint", friendPoint)
                    -- print("levelId", levelId)
                    -- print("difficulty", difficulty)
                    -- print("difficultyMax", difficultyMax)
                    -- print("isBreak", isBreak)

                    -- 场景转换
                    local scene = require("view.Fight.Scene.FightScene").new({ friendId = friendId, friendName = friendName, 
                    	friendPoint = friendPoint, levelId = levelId, difficulty = difficulty, difficultyMax = difficultyMax,
                    	 isBreak = isBreak, mode = mode, data = _ccbNode._DATA })
                    CCBCenter.replaceScene(scene)
                end,
                function()
                    -- print("Triggle Cancel!")
                end,
            }, 
        })
    else
		-- 加载视图
		CCBCenter.popThirdCCBNode()
		CCBCenter.loadCCB("MSG_MAPPOPUPFRIENDLAYER_MODEL", "ccb.c.map.MapPopupFriendLayer", _ccbNode._DATA)
		-- CCBCenter.popSecondCCBNode()
    end
end

-- 判断难度是否锁定
function isDifficultyLocked(difficulty)
    local star = _ccbNode._DATA.po.star
    return difficulty > star + 1
end

-- 获得等级ID
function getLevelId(po)
	return format("%d-%d", po.levelid, po.sublevelid)
end

-- 获得结点
function NODE(tag)
	return CCBCenter.getNodeByTag(_ccbNode, tag)
end


---------


-- [声音]
-- 播放按钮音效
function playButtonSound()
	SOUND:playEffectButton2()
end










-- [加载/卸载]
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--9200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MapPopupDifficultyLayer.ccbi")
	_ccbNode._DATA = data
	_ccbNode.closeLayer = closeLayer
	_ccbNode.ccbLevel = 3

	-- Quick element
	_nodeTable["lblPopName"] = _ccbNode:getNode("lblPopName", "CCLabelTTF")
	_nodeTable["lblTitle"] = _ccbNode:getNode("lblTitle", "CCLabelTTF")
	_nodeTable["lblCostPoint"] = _ccbNode:getNode("lblCostPoint", "CCLabelTTF")
	_nodeTable["lyrButtons"] = _ccbNode:getNode("lyrButtons", "CCLayer")
	_nodeTable["lyrButtonD0"] = _ccbNode:getNode("lyrButtonD0", "CCLayer")
	_nodeTable["lyrButtonD1"] = _ccbNode:getNode("lyrButtonD1", "CCLayer")
	_nodeTable["lyrButtonD2"] = _ccbNode:getNode("lyrButtonD2", "CCLayer")
	_nodeTable["lyrButtonD0Lock"] = _ccbNode:getNode("lyrButtonD0Lock", "CCLayer")
	_nodeTable["lyrButtonD1Lock"] = _ccbNode:getNode("lyrButtonD1Lock", "CCLayer")
	_nodeTable["lyrButtonD2Lock"] = _ccbNode:getNode("lyrButtonD2Lock", "CCLayer")
	_nodeTable["mCostSpLabel"] = _ccbNode:getNode("mCostSpLabel", "CCLabelTTF")
	_nodeTable["lyrSpLine"] = _ccbNode:getNode("lyrSpLine", "CCLayer")
	_nodeTable["lblSpTitle"] = _ccbNode:getNode("lblSpTitle", "CCLabelTTF")
	_nodeTable["lblSpValue"] = _ccbNode:getNode("lblSpValue", "CCLabelTTF")

	-- 附加操作
	_ccbNode.onBtnStartClick = onBtnStartClick

	-- CCControlButton
	_ccbNode:bindButton("btnDNormal", onBtnDNormalClick)
	_ccbNode:bindButton("btnDOrdinary", onBtnDOrdinaryClick)
	_ccbNode:bindButton("btnDDifficult", onBtnDDifficultClick)
	_ccbNode:bindButton("btnDNormalLine", onBtnDNormalClick, _s("MAP_DIFFICULTY_ORDINARY"))
	_ccbNode:bindButton("btnDOrdinaryLine", onBtnDOrdinaryClick, _s("MAP_DIFFICULTY_HERO"))
	_ccbNode:bindButton("btnDDifficultLine", onBtnDDifficultClick, _s("MAP_DIFFICULTY_CHALLENGE"))
	_ccbNode:bindButton("btnDNormalLock", onBtnDNormalLockClick)
	_ccbNode:bindButton("btnDOrdinaryLock", onBtnDOrdinaryLockClick)
	_ccbNode:bindButton("btnDDifficultLock", onBtnDDifficultLockClick)
	_ccbNode:bindButton("btnDNormalLineLock", onBtnDNormalLockClick, _s("MAP_DIFFICULTY_ORDINARY"))
	_ccbNode:bindButton("btnDOrdinaryLineLock", onBtnDOrdinaryLockClick, _s("MAP_DIFFICULTY_HERO"))
	_ccbNode:bindButton("btnDDifficultLineLock", onBtnDDifficultLockClick, _s("MAP_DIFFICULTY_CHALLENGE"))
	_ccbNode:bindButton("btnStart", onBtnStartClick, _s("COMMON_OK"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnAddSp", onBtnAddSpClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.lblPopName, 0, 4 ) -- 标题
	util.modifyPositionInAndroid( _nodeTable.lblTitle, 0, 3 ) -- 关卡标题
	util.modifyPositionInAndroid( _nodeTable.mCostSpLabel, 0, 3 ) -- 消耗体力点
	util.modifyPositionInAndroid( _nodeTable.lblCostPoint, 0, 3 ) -- 消耗体力点值
	util.modifyPositionInAndroid( _nodeTable.lblSpTitle, 0, 4 ) -- 体力

	-- 填充文字
	_nodeTable["mCostSpLabel"]:setString(_s("MAP_COST_SP"))
	_nodeTable["lblSpTitle"]:setString(_s("MAP_SP"))
	_nodeTable["lblPopName"]:setString(_s("MAP_CHOOSE_DIFFICULTY"))


	CCBCenter.bindView("ccb.v.map.MapPopupDifficultyLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		if VERSION_MAP == VERSION_MAP_1 then 
			CCBCenter.pushSecondCCBNode(_ccbNode)
		else 
			CCBCenter.pushThirdCCBNode(_ccbNode, anim.ANIMATION_TOP_IN)
		end
		-- CCBCenter.pushFirstCCBNode(_ccbNode)
	end
	-- 判断是否执行新手帮助
    _ccbNode.helpJudge()
end


MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALCLICK]	= onBtnDNormalClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYCLICK]	= onBtnDOrdinaryClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTCLICK]	= onBtnDDifficultClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNSTARTCLICK]	= onBtnStartClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDNORMALLOCKCLICK]	= onBtnDNormalLockClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDORDINARYLOCKCLICK]	= onBtnDOrdinaryLockClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNDDIFFICULTLOCKCLICK]	= onBtnDDifficultLockClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPDIFFICULTYLAYER_ONBTNADDSPCLICK]	= onBtnAddSpClick
