--MapPopupFriendLayer.lua

MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL 				= 9300

MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNFIGHTCLICK = MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL + 10
MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNRETURNCLICK = MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL + 11
MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL + 12

local TAG = "[MapPopupFriendLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- 返回界面回调
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_RETURN_TO_VIEW)

	if VERSION_MAP == VERSION_MAP_1 then 
		CCBCenter.popSecondCCBNode()
	else 
		CCBCenter.popThirdCCBNode(anim.ANIMATION_TOP_OUT)
	end
end










-- [操作变量]
-- [动画]
-- 动画[关闭层]时间
local A_CLOSELAYER_T 				= 1.0

-- [工具]
-- 断言
local TDAssertUtils      			= require("view.Fight.Util.TDAssertUtils")










-- [函数定义]
-- [辅助]
-- 判断是否还有体力值
local isSpEmpty
-- 显示对话框[体力不足]
local showAlertSpEmpty
-- 公共按钮点击事件处理[难度]
local onBtnDifficultyClick

-- [音效]
-- 播放按钮音效
local playButtonSound

-- [动画]
-- 动画关闭层
local animateCloseNode










-- [事件处理]
local function onBtnFightClick( msg, luaValue )
	--9300 + 10
	Log.d(TAG, "btnFight: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNFIGHTCLICK)
	
	-- 播放按钮音效
	playButtonSound()


	-- 过滤判断
	if isSpEmpty() then 
		-- 显示对话框[体力不足]
		showAlertSpEmpty()
		return
	end

	
	-- 参数赋值
    local friendId                  = _ccbNode.getFriendId()           						-- 好友ID
    local friendName                = _ccbNode.getFriendName()       						-- 好友名称
    local friendPoint               = _ccbNode.getFriendPoint()       						-- 友情点
    local levelId                   = _ccbNode.getLevelId()          						-- 关卡ID
    local difficulty              	= _ccbNode.getDifficulty()         						-- 关卡难度
    local difficultyMax 			= _ccbNode.getDifficultyMax()         					-- 关卡信息[最新]
	local isBreak 					= _ccbNode.isBreak() 									-- 是否是最新关卡（如果胜利则展开新关卡）
    local mode 		 				= { battle = MODE_BATTLE_LEVEL }  						-- 战斗模式

    -- print("friendId", friendId)
    -- print("friendName", friendName)
    -- print("friendPoint", friendPoint)
    -- print("levelId", levelId)
    -- print("difficulty", difficulty)
    -- print("difficultyMax", difficultyMax)
    -- print("isBreak", isBreak)

	-- 场景转换
    local scene = require("view.Fight.Scene.FightScene").new({ friendId = friendId, friendName = friendName, friendPoint = friendPoint, levelId = levelId, difficulty = difficulty, difficultyMax = difficultyMax, isBreak = isBreak, mode = mode, data = _ccbNode._DATA })
    CCBCenter.replaceScene(scene)
end

local function onBtnReturnClick( msg, luaValue )
	--9300 + 11
	Log.d(TAG, "btnReturn: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNRETURNCLICK)

	-- 播放按钮音效
	playButtonSound()
	-- 关闭层
	closeLayer()
	-- 加载视图
	-- CCBCenter.loadCCB("MSG_MAPPOPUPDIFFICULTYLAYER_MODEL", "ccb.c.map.MapPopupDifficultyLayer", _ccbNode._DATA)
	-- CCBCenter.popSecondCCBNode()
end

local function onBtnCloseClick( msg, luaValue )
	--9300 + 12
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNCLOSECLICK)

	-- 播放按钮音效
	playButtonSound()
	
	-- 返回界面回调
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_RETURN_TO_VIEW)

	if VERSION_MAP == VERSION_MAP_1 then 
		CCBCenter.popSecondCCBNode()
	else 
		CCBCenter.popThirdCCBNode()
	end
end










-- [辅助]
-- 判断是否还有体力值
function isSpEmpty()
	local costSp = math.ceil(_ccbNode._DATA.po.sp / GAMERATE:getSpRate())
	return costSp > ME:getCursp()
end

-- 显示对话框[体力不足]
function showAlertSpEmpty()
	AlertLayer.new4OK({
		content 	= _s("MAP_SP_NOT_ENOUGH")
	})
end


---------


-- [按钮]
-- 公共按钮点击事件处理[难度]
function onBtnDifficultyClick(difficulty)
	-- 存储数据
	_ccbNode._DATA.po.difficulty = difficulty
	-- 加载视图
	CCBCenter.loadCCB("MSG_MAPPOPUPFRIENDLAYER_MODEL", "ccb.c.map.MapPopupFriendLayer", _ccbNode._DATA)
	-- CCBCenter.popSecondCCBNode()
end


---------


-- [声音]
-- 播放按钮音效
function playButtonSound()
	SOUND:playEffectButton2()
end


---------


-- [动画]
-- 动画关闭层
function animateCloseNode(node, callback)
	if node == nil then 
		return
	end

	-- 获得子结点
	local children = node:getChildren()
	-- 处理子结点关闭动画
	if children ~= nil and children:count() > 0 then 
		for i = 1, children:count() do
			animateCloseNode(children[i])
		end
	end

	-- 动画逻辑
	-- 时间
	local time 		= A_CLOSELAYER_T
	local actions 	= transition.sequence({
		CCFadeOut:create(time),
		CCCallFunc:create(callback),
	})
	node:runAction(actions)
end










-- [加载/卸载]
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--9300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MapPopupFriendLayer.ccbi")
	_ccbNode._DATA = data
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["lblTitleFriend"] = _ccbNode:getNode("lblTitleFriend", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnFight", onBtnFightClick, _s("MAP_FIGHT"))
	_ccbNode:bindButton("btnReturn", onBtnReturnClick, _s("COMMON_BACK"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	-- android上的位置调整
	util.modifyPositionInAndroid( _nodeTable.lblTitleFriend, 0, 4 ) -- 标题
	
	CCBCenter.bindView("ccb.v.map.MapPopupFriendLayerView", _ccbNode, _nodeTable)
	-- 填充文字
	_nodeTable["lblTitleFriend"]:setString(_s("MAP_CHOOSE_FRIEND"))
	--隐藏关闭按钮
	if data.ynShowCloseBtn then
		 _ccbNode:getNode("btnClose", "CCControlButton"):setVisible(false)
	end
	if callback then
		callback(_ccbNode)
	else
		if VERSION_MAP == VERSION_MAP_1 then 
			CCBCenter.pushSecondCCBNode(_ccbNode)
		else 
			CCBCenter.pushThirdCCBNode(_ccbNode, anim.ANIMATION_TOP_IN)
		end
	end
	_ccbNode.helpJudge()
end


MSG_HANDLER[MSG_ID.MSG_MAPPOPUPFRIENDLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNFIGHTCLICK]	= onBtnFightClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNRETURNCLICK]	= onBtnReturnClick
MSG_HANDLER[MSG_ID.MSG_MAPPOPUPFRIENDLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
