--BindPasswordAlertLayer.lua

MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL 				= 31000

MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCONFIRMCLICK = MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL + 10
MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL + 11
MSG_ID.MSG_BINDPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS = MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL + 12

local TAG = "[BindPasswordAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnConfirmClick( msg, luaValue )
	--31000 + 10
	Log.d(TAG, "btnConfirm: MSG_ID = %d", MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCONFIRMCLICK)
	if _ccbNode.isCompliance( ) then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_BINDPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS, nil, 
			{ 
				newpass = _ccbNode.getPassword(),
			}
		)
	end
end

local function onBtnCloseClick( msg, luaValue )
	--31000 + 11
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onActionFetchModPass( msg, luaValue )
	-- 31200 + 12
	Log.d(TAG, "onActionFetchModPass: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		if items.pass ~= "" and items.username ~= "" then
			game.addGameState("pass", items.pass)
			game.addGameState("username", items.username)
			game.addGameState("modpass", TRUE, true)
		end
		
		closeLayer()
		if _nodeTable._ONCONFIRM then
			_nodeTable._ONCONFIRM()
		end
    end
    ModelHelper.requireDataWithFun(
	    "model.password.PasswordModel",
	    "fetchModPass",
	    onFetchCallback,
	    msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "BindPasswordAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_nodeTable._ONCONFIRM = data.onConfirm
	-- Quick element
	_nodeTable["mNameTitleLabel"] = _ccbNode:getTTFLabel("mNameTitleLabel", _s("ACCOUNT_NAME"))
	_nodeTable["mNameLabel"] = _ccbNode:getNode("mNameLabel", "CCLabelTTF")
	_nodeTable["mPasswordTitleLabel"] = _ccbNode:getTTFLabel("mPasswordTitleLabel", _s("BIND_PASSWORD"))
	_nodeTable["mPasswordTipLabel"] = _ccbNode:getTTFLabel("mPasswordTipLabel", _s("BIND_PASSWORD_TIP"))
	_nodeTable["mPasswordConfirmTitleLabel"] = _ccbNode:getTTFLabel("mPasswordConfirmTitleLabel", _s("BIND_PASSWORD_CONFIRM"))
	_nodeTable["mPasswordConfirmTipLabel"] = _ccbNode:getTTFLabel("mPasswordConfirmTipLabel", _s("BIND_TIP"))

	-- CCControlButton
	_ccbNode:bindButton("btnConfirm", onBtnConfirmClick, _s("BIND_SIGN"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.password.BindPasswordAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_BINDPASSWORDALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCONFIRMCLICK]	= onBtnConfirmClick
MSG_HANDLER[MSG_ID.MSG_BINDPASSWORDALERTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_BINDPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS]	= onActionFetchModPass