--ChangePasswordAlertLayer.lua

MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL 				= 31100

MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCONFIRMCLICK = MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL + 10
MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL + 11
MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS = MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL + 12

local TAG = "[ChangePasswordAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnConfirmClick( msg, luaValue )
	--31100 + 10
	Log.d(TAG, "btnConfirm: MSG_ID = %d", MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCONFIRMCLICK)
	if _ccbNode.isCompliance() then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS, nil, 
			{ 
				newpass = _ccbNode.getPassword(),
			}
		)
	end
end

local function onBtnCloseClick( msg, luaValue )
	--31100 + 11
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCLOSECLICK)
	closeLayer()
end
local function onActionFetchModPass( msg, luaValue )
	-- 31200 + 12
	Log.d(TAG, "onActionFetchModPass: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		if items.pass ~= "" and items.username ~= "" then
			game.addGameState("pass", items.pass)
			game.addGameState("username", items.username)
			game.addGameState("modpass", TRUE, true)
		end
		
		closeLayer()
		if _nodeTable._ONCONFIRM then
			_nodeTable._ONCONFIRM()
		end
    end
    ModelHelper.requireDataWithFun(
	    "model.password.PasswordModel",
	    "fetchModPass",
	    onFetchCallback,
	    msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ChangePasswordAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mNameTitleLabel"] = _ccbNode:getTTFLabel("mNameTitleLabel", _s("ACCOUNT_NAME"))
	_nodeTable["mNameLabel"] = _ccbNode:getNode("mNameLabel", "CCLabelTTF")
	_nodeTable["mNowPasswordTitleLabel"] = _ccbNode:getTTFLabel("mNowPasswordTitleLabel", _s("CHANGE_NOW_PASSWORD"))
	_nodeTable["mPasswordTitleLabel"] = _ccbNode:getTTFLabel("mPasswordTitleLabel", _s("CHANGE_NEW_PASSWORD"))
	_nodeTable["mPasswordTipLabel"] = _ccbNode:getTTFLabel("mPasswordTipLabel", _s("BIND_PASSWORD_TIP"))
	_nodeTable["mPasswordTitle2Label"] = _ccbNode:getTTFLabel("mPasswordTitle2Label", _s("BIND_PASSWORD_CONFIRM"))

	-- CCControlButton
	_ccbNode:bindButton("btnConfirm", onBtnConfirmClick, _s("CHANGE_CONFIRM"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.password.ChangePasswordAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCONFIRMCLICK]	= onBtnConfirmClick
MSG_HANDLER[MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_CHANGEPASSWORDALERTLAYER_ACTION_ONFETCHMODPASS]	= onActionFetchModPass