--MigrationAccountAlertLayer.lua

MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL 				= 31200

MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCONFIRMCLICK = MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL + 10
MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL + 11
MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ACTION_ONFETCHBINDOLDPASS = MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL + 12

local TAG = "[MigrationAccountAlertLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

local function netReceiveFail( error )
	NetHelper.hideLoading(true)
	NetHelper.QuickToast(error.errorStr)
end
local function onBtnConfirmClick( msg, luaValue )
	--31200 + 10
	Log.d(TAG, "btnConfirm: MSG_ID = %d", MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCONFIRMCLICK)
	if _ccbNode.isCompliance( ) then
		NetHelper.showLoading(true,true)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ACTION_ONFETCHBINDOLDPASS, nil, 
			{ 
				nickname = _ccbNode.getId(),	
				pass = crypto.md5(_ccbNode.getPassword()),
			}
		)
	end
end

local function onBtnCloseClick( msg, luaValue )
	--31200 + 11
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onActionFetchBindOldPass( msg, luaValue )
	-- 31200 + 12
	Log.d(TAG, "onActionFetchBindOldPass: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		closeLayer()
		if _nodeTable._ONCONFIRM then
			_nodeTable._ONCONFIRM(items.username, items.pass, items.serverid)
		end
    end
    msg.userdata.failedCb = netReceiveFail
    ModelHelper.requireDataWithFun(
	    "model.password.PasswordModel",
	    "fetchBindOldPass",
	    onFetchCallback,
	    msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--31200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "MigrationAccountAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_nodeTable._ONCONFIRM = data.onConfirm
	-- Quick element
	_nodeTable["mTitleLabel"] = _ccbNode:getTTFLabel("mTitleLabel", _s("MIGRATION_ACCOUNT"))
	_nodeTable["mIdTitleLabel"] = _ccbNode:getTTFLabel("mIdTitleLabel", _s("ACCOUNT_ID"))
	_nodeTable["mPasswordTitleLabel"] = _ccbNode:getTTFLabel("mPasswordTitleLabel", _s("ACCOUNT_PASSWORD"))

	-- CCControlButton
	_ccbNode:bindButton("btnConfirm", onBtnConfirmClick, _s("COMMON_VIEW"))
	_ccbNode:bindButton("btnClose", onBtnCloseClick, _s("COMMON_BACK"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.password.MigrationAccountAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCONFIRMCLICK]	= onBtnConfirmClick
MSG_HANDLER[MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_MIGRATIONACCOUNTALERTLAYER_ACTION_ONFETCHBINDOLDPASS]	= onActionFetchBindOldPass