--RankingsLayer.lua

MSG_ID.MSG_RANKINGSLAYER_MODEL 				= 14000

MSG_ID.MSG_RANKINGSLAYER_ONBTNWORSHIPCLICK = MSG_ID.MSG_RANKINGSLAYER_MODEL + 10
MSG_ID.MSG_RANKINGSLAYER_ONBTNBACKCLICK = MSG_ID.MSG_RANKINGSLAYER_MODEL + 11
MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHRANKINGS = MSG_ID.MSG_RANKINGSLAYER_MODEL + 12
MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHWORSHIP = MSG_ID.MSG_RANKINGSLAYER_MODEL + 13

local TAG = "[RankingsLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnWorshipClick( msg, luaValue )
	--14000 + 10
	Log.d(TAG, "btnWorship: MSG_ID = %d", MSG_ID.MSG_RANKINGSLAYER_ONBTNWORSHIPCLICK)
    if _ccbNode.canWorship() then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHWORSHIP, nil, {typ = _ccbNode.getRankType()})
    end
end

local function onBtnBackClick( msg, luaValue )
	--14000 + 11
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_RANKINGSLAYER_ONBTNBACKCLICK)
	closeLayer()
end
local function onActionFetchRankings( msg, luaValue )
	-- 14000 + 12
	Log.d(TAG, "onActionFetchRankings: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		-- 更新信息
		_ccbNode.updateData(items)
    end
    NetHelper.showLoading(true, true)
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_ALL_RANK ,   		--  请求id
      onFetchCallback,              --  回调函数
      msg.userdata                  --  请求信息实体或参数table
    )
end
local function onActionFetchWorship( msg, luaValue )
	-- 14000 + 13
	Log.d(TAG, "onActionFetchWorship: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
		-- 更新信息
		local rewardEntity = require("model.main.RewardEntity").new(items.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
            }
        )
    end
    NetHelper.showLoading(true, true)
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_RANK_WORSHIP ,   		--  请求id
      onFetchCallback,              --  回调函数
      msg.userdata                  --  请求信息实体或参数table
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--14000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_RANKINGSLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "RankingsLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mHeroRankingLabel"] = _ccbNode:getTTFLabel("mHeroRankingLabel")
	_nodeTable["mHeroNameLabel"] = _ccbNode:getTTFLabel("mHeroNameLabel")
	_nodeTable["mMyRankingLabel"] = _ccbNode:getTTFLabel("mMyRankingLabel")
	_nodeTable["mMyValueLabel"] = _ccbNode:getTTFLabel("mMyValueLabel")
	_nodeTable["mRankLabel"] = _ccbNode:getTTFLabel("mRankLabel", _s("RANK_TITLE"))
	_nodeTable["mPlayerNameLabel"] = _ccbNode:getTTFLabel("mPlayerNameLabel", _s("RANK_PLAYER_NAME"))
	_nodeTable["mValueLabel"] = _ccbNode:getTTFLabel("mValueLabel")
	_nodeTable["mHeroValueLabel"] = _ccbNode:getTTFLabel("mHeroValueLabel")
	_nodeTable["mMyNameLabel"] = _ccbNode:getTTFLabel("mMyNameLabel")
	_nodeTable["mRankTitleLabel"] = _ccbNode:getTTFLabel("mRankTitleLabel", _s("RANK_MY_RANK"))

	-- CCControlButton
	_nodeTable["btnWorship"] = _ccbNode:bindButton("btnWorship", onBtnWorshipClick, _s("RANK_TYPE_WORSHIPTIMES"))
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.rankings.RankingsLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHRANKINGS, nil, {typ = 1})
end


MSG_HANDLER[MSG_ID.MSG_RANKINGSLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_RANKINGSLAYER_ONBTNWORSHIPCLICK]	= onBtnWorshipClick
MSG_HANDLER[MSG_ID.MSG_RANKINGSLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHRANKINGS]	= onActionFetchRankings
MSG_HANDLER[MSG_ID.MSG_RANKINGSLAYER_ACTION_ONFETCHWORSHIP]	= onActionFetchWorship
