MSG_ID.MSG_SHOPGOODSLAYER_MODEL 				= 6400
MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBACKCLICK = MSG_ID.MSG_SHOPGOODSLAYER_MODEL + 10
MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBUYDIAMONDCLICK = MSG_ID.MSG_SHOPGOODSLAYER_MODEL + 11
MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHGOODSSHOPLIST = MSG_ID.MSG_SHOPGOODSLAYER_MODEL + 12
MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHBUYGOODSSHOP = MSG_ID.MSG_SHOPGOODSLAYER_MODEL + 13

local TAG = "[ShopGoodsLayer]"
local _proxy, _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage( MSG_ID.MSG_SHOPNEWLAYER_ACTION_ONREFRESHPLAYERSTATUS )
	CCBCenter.popLastLevelCCBNode()
end

local function onBtnBackClick( msg, luaValue )
	-- 6300 + 10
	Log.d(TAG, "onBtnBackClick: MSG_ID = %d", MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBACKCLICK)
	SOUND:playEffectButton1()
	closeLayer()
end

local function onBtnBuyDiamondClick( msg, luaValue )
    -- 6300 + 11
    Log.d(TAG, "onBtnBuyDiamondClick: MSG_ID = %d", MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBUYDIAMONDCLICK)
    SOUND:playEffectButton1()
    _sdkPlatform.storeView()
end

local function onActionFetchGoodsShopList( msg, luaValue )
	-- 6300 + 12
	Log.d(TAG, "onActionFetchGoodsShopList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateGoods(items)
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchGoodsShopList",
        onFetchCallback
    )
end
local function onActionFetchBuyGoodsShop( msg, luaValue )
	-- 6300 + 12
	Log.d(TAG, "onActionFetchBuyGoodsShop: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items.rs)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                title = _s("SHOP_GOODSSHOP"),
            }
        )
		_ccbNode.refreshPlayerStatus()
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchBuyGoodsShop",
        onFetchCallback,
        msg.userdata
    )
end
local function onCCBLoad(data, callback)
	--6300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SHOPGOODSLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ShopBuyDiamondLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_SHOPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick, _s("COMMON_BACK"))
    _ccbNode:bindButton("btnBuyDiamond", onBtnBuyDiamondClick)
	-- MenuItem
	-- _proxy:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.shop.ShopGoodsLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	--请求网络商品数据
	CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHGOODSSHOPLIST)
end


MSG_HANDLER[MSG_ID.MSG_SHOPGOODSLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_SHOPGOODSLAYER_ONBTNBUYDIAMONDCLICK]  = onBtnBuyDiamondClick
MSG_HANDLER[MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHGOODSSHOPLIST]	= onActionFetchGoodsShopList
MSG_HANDLER[MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHBUYGOODSSHOP]	= onActionFetchBuyGoodsShop