MSG_ID.MSG_SHOPLAYER_MODEL 				= 6000
MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBACKCLICK = MSG_ID.MSG_SHOPLAYER_MODEL + 10
MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBUYDIAMONDCLICK = MSG_ID.MSG_SHOPLAYER_MODEL + 11
MSG_ID.MSG_SHOPLAYER_NETGETSHOPS = MSG_ID.MSG_SHOPLAYER_MODEL + 14
MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP = MSG_ID.MSG_SHOPLAYER_MODEL + 15

local TAG = "[ShopLayer]"
local _ccbNode 
local _nodeTable = {}
local shopModel = require("ccb.m.shop.ShopModel")

local function closeLayer()
    CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPNEWLAYER_ACTION_ONREFRESHPLAYERSTATUS)
    CCBCenter.popLastLevelCCBNode()
end

----------------------------------------------------------------------------------------------------
-- [操作变量]
-- [工具]
-- 断言
TDAssertUtils      			= require("view.Fight.Util.TDAssertUtils")
-- 字符串
TDStringUtils      			= require("view.Fight.Util.TDStringUtils")


-- [函数定义]
-- [网络]
-- 发送网络请求[购买体力]
local netSendAddSp
-- 接收网络请求[购买体力]
local netReceiveAddSp

-- [对话框]
-- 显示体力已满对话框
local showAlertFullSp
-- 显示购买体力对话框
local showAlertAddSp

-- [辅助]
-- 判断Sp值是否已满
local isSpFull
-- 获得当天日期
local getDateToday
-- 获得Sp体力次数
local getSpBuyTimes


-- [辅助功能]
-- [对话框]
-- 显示体力已满对话框
function showAlertFullSp()
	-- 显示[购买体力]对话框
      AlertLayer.new{
        titleStr 	= _s("COMMON_NEWS_TIPS"),  			-- 标题
        content 	= _s("BUY_SP_FULL"), -- 内容
        btnStr 		= { _s("COMMON_OK") },			-- 按钮文字数组
        btnColor 	= { AlertLayer.BTN_COLOR_YELLOW, },
        -- 按钮颜色数组
		btnClickEvent = { 					-- 按钮事件数组
			function() 						-- 按钮[确定]回调
	        	-- print("按钮[确定]回调")
	        end,
		}, 
      }
end

-- 显示购买体力对话框
function showAlertAddSp()
	-- 获得当天购买体力次数
	local times = getSpBuyTimes()
	-- 获得购买钻石数
	local spParams = TDStringUtils.split(GAMERATE:getSpDiamond(), "|")
	local cost 	   = spParams[1]
	local sp 	   = spParams[2]
	local rate 	   = spParams[3]


	-- 显示[购买体力]对话框
    AlertLayer.new{
        titleStr 	= _s("COMMON_NEWS_TIPS"),  			-- 标题
        content 	= format(_s("BUY_SP_CONFIRM"), cost * (rate ^ (times - 1)), sp, times), 	-- 内容
        btnStr 		= { _s("COMMON_OK"), _s("COMMON_CANCEL") },		-- 按钮文字数组
        btnColor 	= { AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_YELLOW },
        isUserDiamond = true,
        diamondIndex = 6,
        -- 按钮颜色数组
		btnClickEvent = { 					-- 按钮事件数组
			function() 						-- 按钮[确定]回调
	        	-- print("按钮[确定]回调")
	        	-- 发起网络请请求
				netSendAddSp()
	        end,
	        function() 						-- 按钮[取消]回调
	        	-- print("按钮[取消]回调")
	        end,
		}, 
    }
end


---------


-- [辅助]
-- 判断Sp值是否已满
function isSpFull()
	return ME:getCursp() >= ME:getActlimit()
end

-- 获得当天日期
function getDateToday()
	return os.date("%m/%d/%Y")
end

-- 获得Sp体力次数
function getSpBuyTimes()
	return ME:getBuyCostCount()
end


---------


-- [网络]
-- 发送网络请求[购买体力]
function netSendAddSp(params)
    NetHelper.createRequest(
       ACTID.MSG_BUY_SP,                  		-- 请求ID
       netReceiveAddSpSuccess,               	-- 回调函数[成功]
       {}, 										-- 请求实体
       {                                        -- 请求信息实体或参数Table
       	-- failedCb = netReceiveAddSpFail,
       	cbParams = {oldSp = ME:getCursp()},     -- 回调参数
       }
    )
end

-- 接收网络请求[购买体力][成功]
function netReceiveAddSpSuccess(params, markProperties)
 	-- [更新数值]
    _ccbNode.refreshPlayerStatus()



    -- 对话框提示
	AlertLayer.new4OK({
		content 	= _s("BUY_SP_SUCCESS")
	})
end

-- 接收网络请求[购买体力][失败]
function netReceiveAddSpFail(params)
	AlertLayer.new4OK({
		content 	= _s(NETWORK_CONNECT_FAILED)
	})
end

----------------------------------------------------------------------------------------------------

--请求数据
local function netGetShops( msg, luaValue )

		--//MSG_GET_SHOPLIST 进入商店页面 6001
		Log.d(TAG, "请求数据 %d", MSG_ID.MSG_SHOPLAYER_MODEL)
		shopModel.getShops{
				callback = msg.userdata.callBackmethod,
		 		methodId = msg.userdata.methodId,
		 		args = msg.userdata.arg
		}
end

local function netGetBuyShop( msg, luaValue )

		--//MSG_BUY_SHOP 购买请求 6002
		Log.d(TAG, "请求数据 %d", msg.userdata.methodId)
		shopModel.getBuyShop{
				callback = msg.userdata.callBackmethod,
		 		methodId = msg.userdata.methodId,
		 		args = msg.userdata.arg
		}
end

-- local function onBtnButBloodClick( msg, luaValue )
-- 	--6000 + 12
-- 	Log.d(TAG, "btnButBlood: MSG_ID = %d", MSG_ID.MSG_SHOPLAYER_ONBTNBUTBLOODCLICK)
	
-- 	if isSpFull() then
-- 		-- 显示体力已满对话框
-- 		showAlertFullSp()
-- 	else
-- 		-- 显示购买体力对话框
-- 		showAlertAddSp()
-- 	end
-- end

local function onBtnBackClick( msg, luaValue )
    --6000 + 10
    Log.d(TAG, "onBtnBackClick: MSG_ID = %d", MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBACKCLICK)
    SOUND:playEffectButton1()
    closeLayer()
end

local function onBtnBuyDiamondClick( msg, luaValue )
    --6000 + 11
    Log.d(TAG, "onBtnBuyDiamondClick: MSG_ID = %d", MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBUYDIAMONDCLICK)
    SOUND:playEffectButton1()
    _sdkPlatform.storeView()  
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--6000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SHOPLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ShopLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_SHOPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
    _ccbNode:bindButton("btnBack", onBtnBackClick, _s("COMMON_BACK"))
    _ccbNode:bindButton("btnBuyDiamond", onBtnBuyDiamondClick)

	-- MenuItem
	-- _proxy:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.shop.ShopLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
        CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end

	--请求网络商品数据
	-- netGetShops({userdata = {arg = {}, methodId = ACTID.MSG_GET_SHOPLIST  , callBackmethod = _ccbNode.callBackShopList}})
end


MSG_HANDLER[MSG_ID.MSG_SHOPLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_SHOPLAYER_NETGETSHOPS] = netGetShops
MSG_HANDLER[MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP] = netGetBuyShop
MSG_HANDLER[MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBACKCLICK]  = onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_SHOPLAYER_MODEL_ONBTNBUYDIAMONDCLICK]  = onBtnBuyDiamondClick
