--ShopMysteryLayer.lua

MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL 				= 6500
MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL + 10
MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOPLIST = MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL + 11
MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOP = MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL + 12
MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNBUYDIAMOND = MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL + 13

local TAG = "[ShopMysteryLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATEMAPDATA)
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--6500 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNCLOSECLICK)
	closeLayer()
	if _nodeTable.ONCLOSE then
		_nodeTable.ONCLOSE()
	end
end
local function onBtnBuyDiamond( msg, luaValue )
    --6500 + 10
    Log.d(TAG, "btnBuyDiamond: MSG_ID = %d", MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNBUYDIAMOND)
    _sdkPlatform.storeView()
end
local function onActionFetchMysteryShopList( msg, luaValue )
	-- 6300 + 11
	Log.d(TAG, "onActionFetchMysteryShopList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		-- _ccbNode.refreshPlayerStatus()
		_ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchMysteryShopList",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchMysteryShop( msg, luaValue )
	-- 6300 + 12
	Log.d(TAG, "onActionFetchMysteryShop: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items.rs)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                title = _nodeTable._TYPE == 4 and _s("MAP_EXPLORE_MYSTERY_SHOP") or _s("MAP_EXPLORE_TRAVEL_SHOP"),
            }
        )
		_ccbNode.refreshPlayerStatus()
		CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOPLIST)
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchMysteryShop",
        onFetchCallback,
        msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--6500
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ShopMysteryLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_nodeTable.ONCLOSE = data and data.onClose or nil
	_nodeTable._TYPE = data and data.typ or nil
	-- Quick element
	-- CCControlButton
    _ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnBuyDiamond", onBtnBuyDiamond, _s("ACTIVITY_BUY_DIAMOND"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.shop.ShopMysteryLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOPLIST)
   		 end})
	end
end


MSG_HANDLER[MSG_ID.MSG_SHOPMYSTERYLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOPLIST]	= onActionFetchMysteryShopList
MSG_HANDLER[MSG_ID.MSG_SHOPMYSTERYLAYER_ACTION_ONFETCHMYSTERYSHOP]  = onActionFetchMysteryShop
MSG_HANDLER[MSG_ID.MSG_SHOPMYSTERYLAYER_ONBTNBUYDIAMOND]	= onBtnBuyDiamond
