MSG_ID.MSG_SHOPSTARLAYER_MODEL 				= 6300
MSG_ID.MSG_SHOPSTARLAYER_ONBTNBACKCLICK = MSG_ID.MSG_SHOPSTARLAYER_MODEL + 10
MSG_ID.MSG_SHOPSTARLAYER_ONBTNBUYDIAMONDCLICK = MSG_ID.MSG_SHOPSTARLAYER_MODEL + 11
MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHSTARSHOPLIST = MSG_ID.MSG_SHOPSTARLAYER_MODEL + 12
MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHBUYSTARSHOP = MSG_ID.MSG_SHOPSTARLAYER_MODEL + 13

local TAG = "[ShopStarLayer]"
local _proxy, _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.sendLuaMessage( MSG_ID.MSG_SHOPNEWLAYER_ACTION_ONREFRESHPLAYERSTATUS )
	CCBCenter.popLastLevelCCBNode()
end

local function onBtnBackClick( msg, luaValue )
	-- 6300 + 10
	Log.d(TAG, "onBtnBackClick: MSG_ID = %d", MSG_ID.MSG_SHOPSTARLAYER_ONBTNBACKCLICK)
	SOUND:playEffectButton1()
	closeLayer()
end

local function onBtnBuyDiamondClick( msg, luaValue )
    -- 6300 + 11
    Log.d(TAG, "onBtnBuyDiamondClick: MSG_ID = %d", MSG_ID.MSG_SHOPSTARLAYER_ONBTNBUYDIAMONDCLICK)
    SOUND:playEffectButton1()
    _sdkPlatform.storeView()
end

local function onActionFetchStarShopList( msg, luaValue )
	-- 6300 + 12
	Log.d(TAG, "onActionFetchStarShopList: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		_ccbNode.updateGoods(items)
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchStarShopList",
        onFetchCallback
    )
end
local function onActionFetchBuyStarShop( msg, luaValue )
	-- 2000 + 12
	Log.d(TAG, "onActionFetchBuyStarShop: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		local rewardEntity = require("model.main.RewardEntity").new(items.rs)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                title = _s("MAIN_STARSHOP_L"),
            }
        )
		_ccbNode.refreshPlayerStatus()
    end
    ModelHelper.requireDataWithFun(
        "ccb.m.shop.ShopModel",
        "fetchBuyStarShop",
        onFetchCallback,
        msg.userdata
    )
end
local function onCCBLoad(data, callback)
	--6100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SHOPSTARLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "ShopBuyDiamondLayer.ccbi")
	_ccbNode.SHOW_TOPBUTTONS = TopButtons.INDEX_SHOPLAYER
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick, _s("COMMON_BACK"))
    _ccbNode:bindButton("btnBuyDiamond", onBtnBuyDiamondClick)
	-- MenuItem
	-- _proxy:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.shop.ShopStarLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	--请求网络商品数据
	CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHSTARSHOPLIST)
end


MSG_HANDLER[MSG_ID.MSG_SHOPSTARLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_SHOPSTARLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_SHOPSTARLAYER_ONBTNBUYDIAMONDCLICK]  = onBtnBuyDiamondClick
MSG_HANDLER[MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHSTARSHOPLIST]	= onActionFetchStarShopList
MSG_HANDLER[MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHBUYSTARSHOP]	= onActionFetchBuyStarShop