--TowerLayer.lua

MSG_ID.MSG_SPECIALMAPLAYER_MODEL 				= 29000

MSG_ID.MSG_SPECIALMAPLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 10
MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 11
MSG_ID.MSG_SPECIALMAPLAYER_ONBTNREWARDPREVIEWCLICK = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 12
MSG_ID.MSG_SPECIALMAPLAYER_ONBTNSWEEPINGCLICK = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 13
MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 14
MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHSWEEPING = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 15
MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHFIGHTING = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 16
MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHBACKMAP = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 17
MSG_ID.MSG_SPECIALMAPLAYER_ONBTNRESETCLICK = MSG_ID.MSG_SPECIALMAPLAYER_MODEL + 18

local TAG = "[SpecialMapLayer]"
local _ccbNode 
local _nodeTable = {}

local _specialMapType

local function closeLayer()
	if _ccbNode.fromMap then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA)
	end
	CCBCenter.popLastLevelCCBNode()
end

--获得特殊副本列表
local function onGetSpeMapList(msg, luaValue )

	local function onFetchCallback( properties )
		
		--刷新特殊副本数据
		_ccbNode.reloadSpeMapListGrid(properties)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_EXPFB,
        onFetchCallback,
		{ typ = msg.userdata.typ },
		{}
    )
end

local function onBtnCloseClick( msg, luaValue )
	--29000 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_SPECIALMAPLAYER_ONBTNCLOSECLICK)

	closeLayer()
end

local function onBtnRewardPreViewClick( msg, luaValue )
	--奖励预览串
	local rewardEntity = require("model.main.RewardEntity").new(_ccbNode.getRewards())
	CCBCenter.loadCCB(
            "MSG_SPECIALMAPREWARDPREVIEWLAYER_MODEL", 
            "ccb.c.specialMap.SpecialMapRewardPreviewLayer", 
            {
                entity = rewardEntity,
            }
        )
end

local function onBtnSweepingClick( msg, luaValue )
	--特殊副本扫荡
	_ccbNode.mapSweeping()
end

--副本重置接口
local function onFetchReSet( msg, luaValue )

	local typ = msg.userdata.typ

	local function onFetchCallback( properties )
		
		CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = typ})
	end
	
	NetHelper.createRequest(
        ACTID.MSG_EXPFB_RESET,
        onFetchCallback,
		{ typ = typ },
		{}
    )
end
--副本扫荡接口
local function onFetchSweeping( msg, luaValue )

	local typ = msg.userdata.typ

	local function onFetchCallback( properties )
		
		CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = typ})
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_SD,
        onFetchCallback,
		{ typ = typ },
		{}
    )
end

--战斗接口
local function onFetchFighting( msg, luaValue )
	-- body
	local function onFetchCallback( properties )
		
		CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = msg.userdata.typ})
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_EXPFBFLIGHT,
        onFetchCallback,
		{ typ = msg.userdata.typ,no = msg.userdata.no },
		{}
    )
end

local function onBtnBackMapClick( ... )
	-- body
	_ccbNode.setIsCheckPoint(0)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = 0})
end

local function onBtnReSetClick( ... )
	-- body
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--29000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SPECIALMAPLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "SpecialMapLayer.ccbi")
	_ccbNode.closeLayer = closeLayer

	_ccbNode.fromMap = data.fromMap
	
	_ccbNode._specialMapType = tonumber(data.specialMapType)
	local mapTyp = 	tonumber(data.mapTyp)
	_ccbNode.isCheckpoint = tonumber(data.isCheckpoint)
	-- Quick element
	_nodeTable["mBtnLayer"] = _ccbNode:getNode("mBtnLayer", "CCLayer")
	_nodeTable["mSpeMapList"] = _ccbNode:getNode("mSpeMapList", "CCLayer")
	_nodeTable["btnSweeping"] = _ccbNode:getNode("btnSweeping", "CCControlButton")
	_nodeTable["btnBackMap"] = _ccbNode:getNode("btnBackMap", "CCControlButton")
	_nodeTable["mRewardReviewLabel"] = _ccbNode:getNode("mRewardReviewLabel", "CCLabelTTF")
	_nodeTable["mSweepingLabel"] = _ccbNode:getNode("mSweepingLabel", "CCLabelTTF")
	_nodeTable["mResetLabel"] = _ccbNode:getNode("mResetLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnRewardPreView", onBtnRewardPreViewClick)
	_ccbNode:bindButton("btnSweeping", onBtnSweepingClick)
	_ccbNode:bindButton("btnReSet", onBtnReSetClick)
	_ccbNode:bindButton("btnBackMap", onBtnBackMapClick,_s("SPECIALMAP_BACK_MAP"))

	--填充文字
	_nodeTable["mRewardReviewLabel"]:setString(_s("SPECIALMAP_REWARD_REWVIEW"))
	_nodeTable["mSweepingLabel"]:setString(_s("SPECIALMAP_SWEEPING"))
	_nodeTable["mResetLabel"]:setString(_s("SPECIALMAP_RESET_COUNT_1"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.specialMap.SpecialMapLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = mapTyp})
end


MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST]	= onGetSpeMapList
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ONBTNREWARDPREVIEWCLICK]	= onBtnRewardPreViewClick
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ONBTNSWEEPINGCLICK]	= onBtnSweepingClick
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET]	= onFetchReSet
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHSWEEPING]	= onFetchSweeping
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHFIGHTING]	= onFetchFighting
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHBACKMAP]	= onBtnBackMapClick
MSG_HANDLER[MSG_ID.MSG_SPECIALMAPLAYER_ONBTNRESETCLICK]	= onBtnReSetClick
