--BlacksmithLayer.lua

MSG_ID.MSG_SWEEPINGLAYER_MODEL 				= 29200

MSG_ID.MSG_SWEEPINGLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_SWEEPINGLAYER_MODEL + 10
MSG_ID.MSG_SWEEPINGLAYER_ONBTNREWARDCLICK = MSG_ID.MSG_SWEEPINGLAYER_MODEL + 11
MSG_ID.MSG_SWEEPINGLAYER_ONBTNCOMPLETESWEEPINGCLICK = MSG_ID.MSG_SWEEPINGLAYER_MODEL + 12

local TAG = "[SweepingLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
    CCBCenter.popSecondCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--27001 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_SWEEPINGLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onBtnRewardClick( ... )

	local function onFetchCallback( properties )
		
		local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function( )
                	CCBCenter.popLastLevelCCBNode()
                	CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = _ccbNode.sdTyp})
                end
            }
        )
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_EXPFBREWARD,
        onFetchCallback,
		{ typ = _ccbNode.sdTyp },
		{}
    )
end

local function onBtnCompleteSweepingClick( ... )
	 AlertLayer.new4IAP{
	  	isUserDiamond = true,
	  	diamondIndex = 17,
	    content = _s("USE_DIAMOND_17",GAMERATE:getFinishSweepDiamond()),  --内容
	    btnClickEvent = {
	    	function ( )
	        	 onBtnRewardClick()
	        end,
	    }
	  }
     -- onBtnRewardClick()
	
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--27001
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_SWEEPINGLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "SweepingLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode.issd = data.issd
	_ccbNode.sdTime = data.sdTime
	_ccbNode.sdTyp = data.sdTyp
	_ccbNode.needdia = data.needdia

	-- Quick element
	_nodeTable["btnCompleteSweeping"] = _ccbNode:getNode("btnCompleteSweeping", "CCControlButton")
	_nodeTable["btnReward"] = _ccbNode:getNode("btnReward", "CCControlButton")
	_nodeTable["mSweepingLabel"] = _ccbNode:getNode("mSweepingLabel", "CCLabelTTF")
	_nodeTable["mSweepingLayer"] = _ccbNode:getNode("mSweepingLayer", "CCLayer")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnCompleteSweeping", onBtnCompleteSweepingClick)
	_ccbNode:bindButton("btnReward", onBtnRewardClick,_s("TEAM_GET_REWARD"))

	--填充文字
	_nodeTable["mSweepingLabel"]:setString(_s("SPECIALMAP_REWARD_PREVIEW"))
	--_ccbNode:bindButton("btnEquipmentLV", onBtnEquipmentLVClick)
	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.specialMap.SweepingLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT)
	end
end


MSG_HANDLER[MSG_ID.MSG_SWEEPINGLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_SWEEPINGLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_SWEEPINGLAYER_ONBTNREWARDCLICK]	= onBtnRewardClick
MSG_HANDLER[MSG_ID.MSG_SWEEPINGLAYER_ONBTNCOMPLETESWEEPINGCLICK]	= onBtnCompleteSweepingClick
