--TeamAddMemberLayer.lua

MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL 				= 17300

MSG_ID.MSG_TEAMADDMEMBERLAYER_ONBTNBACKCLICK = MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL + 10
MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHINTOTEAMAPP = MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL + 11
MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHADDTEAMER = MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL + 12

local TAG = "[TeamAddMemberLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnBackClick( msg, luaValue )
	--17300 + 10
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_TEAMADDMEMBERLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onActionFetchIntoTeamApp( msg, luaValue )
	--17300 + 11
	Log.d(TAG, "onActionFetchIntoTeamApp: MSG_ID = %d", MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHINTOTEAMAPP)
	local function onFetchCallback( items )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO, nil, {tid = 0, serid = 0})
        _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchIntoTeamApp",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchAddTeamer( msg, luaValue )
	--17300 + 12
	Log.d(TAG, "onActionFetchAddTeamer: MSG_ID = %d", MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHADDTEAMER)
	local function onFetchCallback( items )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHINTOTEAMAPP)
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchAddTeamer",
        onFetchCallback,
        msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--17300
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TeamAddMemberLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._COUNT = data.count or 0
	-- Quick element
	_nodeTable["mTeamMemberCountTitleLabel"] = _ccbNode:getTTFLabel("mTeamMemberCountTitleLabel", _s("TEAM_MEMBER_COUNT"))
    _nodeTable["mTeamMemberCountLabel"] = _ccbNode:getTTFLabel("mTeamMemberCountLabel")
	_nodeTable["mNoAppMemberLabel"] = _ccbNode:getTTFLabel("mNoAppMemberLabel", _s("TEAM_NO_APP"))

	-- CCControlButton
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.team.TeamAddMemberLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHINTOTEAMAPP)
end


MSG_HANDLER[MSG_ID.MSG_TEAMADDMEMBERLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TEAMADDMEMBERLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHINTOTEAMAPP]	= onActionFetchIntoTeamApp
MSG_HANDLER[MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHADDTEAMER]	= onActionFetchAddTeamer
