--TeamCreateAlertLayer.lua

MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL 				= 17200

MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCREATETEAMCLICK = MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL + 10
MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCANCELCLICK = MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL + 11
MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNBACKCLICK = MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL + 12
MSG_ID.MSG_TEAMCREATEALERTLAYER_ACTION_ONFETCHCREATETEAM = MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL + 13

local TAG = "[TeamCreateAlertLayer]"
local TeamViewUtil = require("cardui.TeamViewUtil")
local _ccbNode 
local _nodeTable = {}
local _fromKey = 1

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCreateTeamClick( msg, luaValue )
	--17200 + 10
	Log.d(TAG, "btnCreateTeam: MSG_ID = %d", MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCREATETEAMCLICK)
	_ccbNode.isHideEditBox(true)

	AlertLayer.new4IAP{
	  	isUserDiamond = true,
	  	diamondIndex = 3,
	    content = _s("USE_DIAMOND_03",_ccbNode._DIAMOND,_ccbNode.getCode()),  --内容
	    btnClickEvent = {
	    	function ( )
	        	if _ccbNode.isCompliance() then
	        		_ccbNode.isHideEditBox(false)
					CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMCREATEALERTLAYER_ACTION_ONFETCHCREATETEAM, nil, {tname = _ccbNode.getCode()})
				end
	        end,
	    }
	  }
end

local function onBtnCancelClick( msg, luaValue )
	--17200 + 11
	Log.d(TAG, "btnCancel: MSG_ID = %d", MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCANCELCLICK)
	closeLayer()
end

local function onBtnBackClick( msg, luaValue )
	--17200 + 12
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNBACKCLICK)
	closeLayer()
end
local function onActionFetchCreateTeam( msg, luaValue )
	local function onFetchCallback( items )
        closeLayer()
        if TeamViewUtil.FROM_KEY.TEAMMAIN == _fromKey then
        	CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = 0, serid = 0, fromTeamMain = true, fromKey = 2, fromKey = TeamViewUtil.FROM_KEY.TEAMMAIN})
    	elseif TeamViewUtil.FROM_KEY.INTERSERVER == _fromKey then
    		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMINTERSERVICELAYER_ONBTNMYTEAMCLICK)
    	elseif TeamViewUtil.FROM_KEY.SAMESERVER == _fromKey then
    		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMWARLAYER_ONBTNMYTEAMCLICK)
        end
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchCreateTeam",
        onFetchCallback,
        msg.userdata
    )
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--17200
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TeamCreateAlertLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._LV = data.limit.needlv
	_ccbNode._DIAMOND = data.limit.needdiamond
	_fromKey = (data and data.fromKey) or TeamViewUtil.FROM_KEY.TEAMMAIN
	-- Quick element
	_nodeTable["mTeamCreateTitleLabel"] = _ccbNode:getTTFLabel("mTeamCreateTitleLabel", _s("TEAM_CREATE_TEAM"))
	_nodeTable["mTeamNameTitleLabel"] = _ccbNode:getTTFLabel("mTeamNameTitleLabel", _s("TEAM_NAME"))

	-- CCControlButton
	_ccbNode:bindButton("btnCreateTeam", onBtnCreateTeamClick, _s("TEAM_CREATE_TEAM"))
	_ccbNode:bindButton("btnCancel", onBtnCancelClick, _s("COMMON_CANCEL"))
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.team.TeamCreateAlertLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT)
	end
end


MSG_HANDLER[MSG_ID.MSG_TEAMCREATEALERTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCREATETEAMCLICK]	= onBtnCreateTeamClick
MSG_HANDLER[MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNCANCELCLICK]	= onBtnCancelClick
MSG_HANDLER[MSG_ID.MSG_TEAMCREATEALERTLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_TEAMCREATEALERTLAYER_ACTION_ONFETCHCREATETEAM]	= onActionFetchCreateTeam
