--TeamListLayer.lua

MSG_ID.MSG_TEAMLISTLAYER_MODEL 				= 17400

MSG_ID.MSG_TEAMLISTLAYER_ONBTNLASTCLICK = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 10
MSG_ID.MSG_TEAMLISTLAYER_ONBTNNEXTCLICK = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 11
MSG_ID.MSG_TEAMLISTLAYER_ONBTNSEARCHCLICK = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 12
MSG_ID.MSG_TEAMLISTLAYER_ONBTNBACKCLICK = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 13
MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 14
MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMAPPCONTENT = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 15
MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHJOINTEAM = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 16
MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHREFRESHTEAMLIST = MSG_ID.MSG_TEAMLISTLAYER_MODEL + 17

local TAG = "[TeamListLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnLastClick( msg, luaValue )
	--17400 + 10
	Log.d(TAG, "btnLast: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ONBTNLASTCLICK)
    if _ccbNode._PAGE > 1 then
        _ccbNode._PAGE = _ccbNode._PAGE - 1
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST, nil, {tno = _ccbNode.getSearchKey(), page = _ccbNode._PAGE, typ = _ccbNode._SERTYPE})
    else
        NetHelper.QuickToast(_s("TEAM_NO_LAST_PAGE"))
        _nodeTable["btnLast"]:setEnabled(false)
    end
end

local function onBtnNextClick( msg, luaValue )
	--17400 + 11
	Log.d(TAG, "btnNext: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ONBTNNEXTCLICK)
    if _ccbNode._PAGE < _ccbNode._MAXPAGE then
        _ccbNode._PAGE = _ccbNode._PAGE + 1
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST, nil, {tno = _ccbNode.getSearchKey(), page = _ccbNode._PAGE, typ = _ccbNode._SERTYPE})
    else
        NetHelper.QuickToast(_s("TEAM_NO_NEXT_PAGE"))
        _nodeTable["btnNext"]:setEnabled(false)
    end
end

local function onBtnSearchClick( msg, luaValue )
	--17400 + 12
	Log.d(TAG, "btnSearch: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ONBTNSEARCHCLICK)
	-- if _ccbNode.getSearchKey() ~= "" then
    if _ccbNode.getSearchKey() ~= _ccbNode._TNO then
        _ccbNode._PAGE = 1
        _ccbNode._TNO = _ccbNode.getSearchKey()
    end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST, nil, {tno = _ccbNode.getSearchKey(), page = _ccbNode._PAGE, typ = _ccbNode._SERTYPE})
	-- end
end

local function onBtnBackClick( msg, luaValue )
	--17400 + 13
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ONBTNBACKCLICK)
	closeLayer()
end
local function onActionFetchTeamList( msg, luaValue )
	--17400 + 14
	Log.d(TAG, "onActionFetchTeamList: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST)
	local function onFetchCallback( items )
        -- NetHelper.hideLoading(true)
        _ccbNode.updateData(items)
    end
    -- NetHelper.showLoading(true,true)
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchTeamList",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchTeamAppContent( msg, luaValue )
	--17400 + 15
	Log.d(TAG, "onActionFetchTeamAppContent: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMAPPCONTENT)
	local function onFetchCallback( items )
        -- _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchTeamAppContent",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchJoinTeam( msg, luaValue )
	-- 3000 + 23
	Log.d(TAG, "onActionFetchJoinTeam: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.QuickToast(_s("CHAT_SEND_SUCCESS"))
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchJoinTeam",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchRefreshTeamList( msg, luaValue )
    CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST, nil, {tno = _ccbNode.getSearchKey(), page = _ccbNode._PAGE, typ = _ccbNode._SERTYPE})
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--17400
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TEAMLISTLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TeamListLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	_ccbNode._TNO = (data and data.tid) or ""
    _ccbNode._SERTYPE = (data and data.serType) or 1 -- 1 本区 2 跨服
    _ccbNode._PAGE = 1
    _ccbNode._MAXPAGE = 1
    _ccbNode._FINISH = false
	-- Quick element
	_nodeTable["mTeamNameLabel"] = _ccbNode:getTTFLabel("mTeamNameLabel")
	_nodeTable["mTeamIdTitleLabel"] = _ccbNode:getTTFLabel("mTeamIdTitleLabel")
	_nodeTable["mTeamIdLabel"] = _ccbNode:getTTFLabel("mTeamIdLabel")
	_nodeTable["mManifestoTitleLabel"] = _ccbNode:getTTFLabel("mManifestoTitleLabel", _s("TEAM_APPLICATION_MESSAGE"))

	-- CCControlButton
	_nodeTable["btnLast"] = _ccbNode:bindButton("btnLast", onBtnLastClick)
	_nodeTable["btnNext"] = _ccbNode:bindButton("btnNext", onBtnNextClick)
	_ccbNode:bindButton("btnSearch", onBtnSearchClick, _s("TEAM_SEARCH"))
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.team.TeamListLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST, nil, {tno = _ccbNode._TNO, page = _ccbNode._PAGE, typ = _ccbNode._SERTYPE})
end


MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ONBTNLASTCLICK]	= onBtnLastClick
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ONBTNNEXTCLICK]	= onBtnNextClick
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ONBTNSEARCHCLICK]	= onBtnSearchClick
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMLIST]	= onActionFetchTeamList
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMAPPCONTENT]	= onActionFetchTeamAppContent
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHJOINTEAM]    = onActionFetchJoinTeam
MSG_HANDLER[MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHREFRESHTEAMLIST]	= onActionFetchRefreshTeamList
