--TeamMainLayer.lua

MSG_ID.MSG_TEAMMAINLAYER_MODEL 				= 17700

MSG_ID.MSG_TEAMMAINLAYER_ONBTNSAMESERVICECLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 10
MSG_ID.MSG_TEAMMAINLAYER_ONBTNINTERSERVICECLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 11
MSG_ID.MSG_TEAMMAINLAYER_ONBTNMYTEAMCLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 12
MSG_ID.MSG_TEAMMAINLAYER_ONBTNRULECLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 13
MSG_ID.MSG_TEAMMAINLAYER_ONBTNREWARDSCLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 14
MSG_ID.MSG_TEAMMAINLAYER_ONBTNBACKCLICK = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 15
MSG_ID.MSG_TEAMMAINLAYER_ACTION_ONFETCHTEAMINDEX = MSG_ID.MSG_TEAMMAINLAYER_MODEL + 16

local TAG = "[TeamMainLayer]"
local TeamViewUtil = require("cardui.TeamViewUtil")
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	-- CCBCenter.popLastLevelCCBNode()
	SOUND:playMusicHome(true)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
	CCBCenter.popFirstCCBNode()
end


local function onBtnSameServiceClick( msg, luaValue )
	--17700 + 10
	Log.d(TAG, "btnSameService: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNSAMESERVICECLICK)
	CCBCenter.loadCCB("MSG_TEAMWARLAYER_MODEL", "ccb.c.team.TeamWarLayer")
end

local function onBtnInterServiceClick( msg, luaValue )
	--17700 + 11
	Log.d(TAG, "btnInterService: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNINTERSERVICECLICK)
	CCBCenter.loadCCB("MSG_TEAMINTERSERVICELAYER_MODEL", "ccb.c.team.TeamInterServiceLayer")
end

local function onBtnMyTeamClick( msg, luaValue )
	--17700 + 12
	Log.d(TAG, "btnMyTeam: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNMYTEAMCLICK)
	if _ccbNode.inTeam() then
		CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = 0, serid = 0, fromTeamMain = true, fromKey = TeamViewUtil.FROM_KEY.TEAMMAIN})
	else
		if _ccbNode.getCreateLimit() then
			CCBCenter.loadCCB("MSG_TEAMCREATEALERTLAYER_MODEL", "ccb.c.team.TeamCreateAlertLayer", {limit = _ccbNode.getCreateLimit(), fromKey = TeamViewUtil.FROM_KEY.TEAMMAIN})
		end
	end
end

local function onBtnRuleClick( msg, luaValue )
	--17700 + 13
	Log.d(TAG, "btnRule: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNRULECLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isTeamRule = true,})
end

local function onBtnRewardsClick( msg, luaValue )
	--17700 + 14
	Log.d(TAG, "btnRewards: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNREWARDSCLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isTeamRewardRule = true,})
end

local function onBtnBackClick( msg, luaValue )
	--17700 + 15
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onActionFetchTeamIndex( msg, luaValue )
	-- 17000 + 16
	Log.d(TAG, "onActionFetchTeamIndex: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.hideLoading(true)
        _ccbNode.updateData(items)
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchTeamIndex",
        onFetchCallback,
        msg.userdata
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--17700
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TEAMMAINLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TeamMainLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mSameServerTitleLabel"] = _ccbNode:getNode("mSameServerTitleLabel", "CCLabelTTF")
	_nodeTable["mSameSeverChampionsLabel"] = _ccbNode:getNode("mSameSeverChampionsLabel", "CCLabelTTF")
	_nodeTable["mSameServerLabel"] = _ccbNode:getNode("mSameServerLabel", "CCLabelTTF")
	_nodeTable["mSameServerTimeTitleLabel"] = _ccbNode:getNode("mSameServerTimeTitleLabel", "CCLabelTTF")
	_nodeTable["mInterServerTitleLabel"] = _ccbNode:getNode("mInterServerTitleLabel", "CCLabelTTF")
	_nodeTable["mInterServerChampionsLabel"] = _ccbNode:getNode("mInterServerChampionsLabel", "CCLabelTTF")
	_nodeTable["mInterServerLabel"] = _ccbNode:getNode("mInterServerLabel", "CCLabelTTF")
	_nodeTable["mInterServerTimeTitleLabel"] = _ccbNode:getNode("mInterServerTimeTitleLabel", "CCLabelTTF")
	_nodeTable["mTipLabel"] = _ccbNode:getNode("mTipLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnSameService", onBtnSameServiceClick, _s("TEAM_SAME_SERVER_WAR"))
	_ccbNode:bindButton("btnInterService", onBtnInterServiceClick, _s("TEAM_INTER_SERVER_WAR"))
	_ccbNode:bindButton("btnMyTeam", onBtnMyTeamClick)
	_ccbNode:bindButton("btnRule", onBtnRuleClick)
	_ccbNode:bindButton("btnRewards", onBtnRewardsClick)
	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.team.TeamMainLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		-- CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end
	SOUND:playMusicTeamWar(true)
	NetHelper.showLoading(true,true)
	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMAINLAYER_ACTION_ONFETCHTEAMINDEX)
end


MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNSAMESERVICECLICK]	= onBtnSameServiceClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNINTERSERVICECLICK]	= onBtnInterServiceClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNMYTEAMCLICK]	= onBtnMyTeamClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNRULECLICK]	= onBtnRuleClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNREWARDSCLICK]	= onBtnRewardsClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_TEAMMAINLAYER_ACTION_ONFETCHTEAMINDEX]	= onActionFetchTeamIndex