--TeamMemberLayer.lua

MSG_ID.MSG_TEAMMEMBERLAYER_MODEL 				= 17100

MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNVIEWAPPLICATIONCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 10
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNWORLDRECRUITSCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 11
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNDISMISSALCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 12
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNSIGNUPCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 13
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNEXITTEAMCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 14
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNBACKCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 15
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNJOINCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 16
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 17
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHDISMISSALTEAM = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 18
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHWRITETEAMDECLARATION = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 19
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHSIGNUPTEAMWAR = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 20
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHKICKTEAMMEMBER = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 21
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHEXITTEAM = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 22
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHJOINTEAM = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 23
MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHSENDTEAMAD = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 24
MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNPKCLICK = MSG_ID.MSG_TEAMMEMBERLAYER_MODEL + 25

local TAG = "[TeamMemberLayer]"
local TeamViewUtil = require("cardui.TeamViewUtil")
local _ccbNode 
local _nodeTable = {}
local _tid = 0
local _serid = 0
local _fromMain = false
local _fromTeamMain = false
local _fromInter = false
-- local _fromSame = false
local _fromKey = 1
-- local _serType = 1
-- local FROM_KEY = {
--     MAIN = 1,
--     TEAMMAIN = 2,
--     INTERSERVER = 3,
--     SAMESERVER = 4,
--     INTERSERVERLIST = 5,
--     SAMESERVERLIST = 6,
--     INTERSERVERRECORD = 7,
--     SAMESERVERRECORD = 8,
--     INTERSERVERRECORDLIST = 9,
--     SAMESERVERRECORDLIST = 10,
-- }

local function closeLayer()
    -- if not _fromMain and not _fromTeamMain then
    --     if _fromInter then
    --         CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMINTERSERVICELAYER_ACTION_ONFETCHTEAMINDEX)
    --     else
    --         CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMWARLAYER_ACTION_ONFETCHTEAMINDEX)
    --     end
    -- end
    if TeamViewUtil.FROM_KEY.TEAMMAIN == _fromKey then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMAINLAYER_ACTION_ONFETCHTEAMINDEX)
    elseif TeamViewUtil.FROM_KEY.INTERSERVERLIST == _fromKey then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMINTERSERVICELAYER_ACTION_ONFETCHTEAMINDEX)
    elseif TeamViewUtil.FROM_KEY.SAMESERVERLIST == _fromKey then
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMWARLAYER_ACTION_ONFETCHTEAMINDEX)
    end
    CCBCenter.popLastLevelCCBNode()
end


local function onBtnViewApplicationClick( msg, luaValue )
	--17100 + 10
	Log.d(TAG, "btnViewApplication: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNVIEWAPPLICATIONCLICK)
	if not _ccbNode.isNeedSelect() and _ccbNode.canDoEdit() then
		local count = _ccbNode.getCount()
		if count > 0 then
			CCBCenter.loadCCB("MSG_TEAMADDMEMBERLAYER_MODEL", "ccb.c.team.TeamAddMemberLayer", {count = count})
		end
	end
end

local function onBtnWorldRecruitsClick( msg, luaValue )
	--17100 + 11
	Log.d(TAG, "btnWorldRecruits: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNWORLDRECRUITSCLICK)
	if not _ccbNode.isNeedSelect() then
		if ME:CanSpeak( ) and _ccbNode.getTeamNo() and _ccbNode.getTeamName() then
			_ccbNode.sendTeamRecruitsClick()
		end
	end
end

local function onBtnDismissalClick( msg, luaValue )
	--17100 + 12
	Log.d(TAG, "btnDismissal: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNDISMISSALCLICK)
	if not _ccbNode.isNeedSelect() and _ccbNode.canDoEdit() then
		AlertLayer.new{
	        btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
	        btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
	        titleStr = _s("TEAM_DISMISSAL_TEAM"),  --标题
	        content = _s("TEAM_DISMISSAL_TEAM_INFO"),  --内容
	        btnClickEvent = {
	        	function ( )
		        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHDISMISSALTEAM)
		        end,
	        },
		}
	end
end

local function onBtnSignUpClick( msg, luaValue )
	--17100 + 13
	Log.d(TAG, "btnSignUp: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNSIGNUPCLICK)
	if not _ccbNode.isNeedSelect() and _ccbNode.canDoEdit() then
		local status = _ccbNode.getSignUpStatus()
		if not status then
			return
		else
            if status == TRUE and _ccbNode.getCount() ~= GAMERATE:getTeamMemberLimit() then
                NetHelper.QuickToast(_s("TEAM_MEMBER_NOT_ENOUGH", GAMERATE:getTeamMemberLimit()))
                return
            end
			local title = status == TRUE and _s("TEAM_WAR_SIGN_UP") or _s("TEAM_WAR_UN_SIGN_UP")
			local content = status == TRUE and _s("TEAM_WAR_SIGN_UP_INFO") or _s("TEAM_WAR_UN_SIGN_UP_INFO")
			AlertLayer.new{
		        btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
		        btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
		        titleStr = title,  --标题
		        content = content,  --内容
		        btnClickEvent = {
		        	function ( )
			        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHSIGNUPTEAMWAR, nil, {sta = status,})
			        end,
		        },
			}	
		end
	end
end
local function onBtnJoinClick( msg, luaValue )
	--17100 + 16
	Log.d(TAG, "btnSignUp: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNJOINCLICK)
	if not _ccbNode.isNeedSelect() and _ccbNode.canDoEdit() then
		local teamId = _ccbNode.getTeamId()
		if not teamId then
			return
		else
			AlertLayer.new{
		        btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
		        btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
		        titleStr = _s("TEAM_JOIN_TEAM"),  --标题
		        content = _s("TEAM_JOIN_TEAM_INFO"),  --内容
		        btnClickEvent = {
		        	function ( )
			        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHJOINTEAM, nil, {tid = teamId})
			        end,
		        },
			}
		end
	end
end

local function onBtnExitTeamClick( msg, luaValue )
	--17100 + 14
	Log.d(TAG, "btnExitTeam: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNEXITTEAMCLICK)

    local contentText = _ccbNode.isInterServiceStatus() and _s("TEAM_SERVICR_REMOVE") or _s("TEAM_EXIT_TEAM_INFO")
    if not _ccbNode.isNeedSelect() and _ccbNode.canDoEdit() then
		AlertLayer.new{
	        btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
	        btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
	        titleStr = _s("TEAM_EXIT_TEAM"),  --标题
	        content = contentText,  --内容
	        btnClickEvent = {
	        	function ( )
		        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHEXITTEAM)
		        end,
	        },
		}
	end
end

local function onBtnBackClick( msg, luaValue )
	--17100 + 15
	Log.d(TAG, "btnBack: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNBACKCLICK)
	closeLayer()
end

local function onActionFetchTeamInfo( msg, luaValue )
	-- 17100 + 17
	Log.d(TAG, "onActionFetchTeamInfo: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        -- NetHelper.hideLoading(true)
        _ccbNode.updateInfo(items)
    end
    NetHelper.showLoading(true,true)
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchTeamInfo",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchDismissalTeam( msg, luaValue )
	-- 17100 + 18
	Log.d(TAG, "onActionFetchDismissalTeam: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMWARLAYER_ACTION_ONFETCHTEAMINDEX)
        closeLayer()
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchDismissalTeam",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchWriteTeamDeclaration( msg, luaValue )
	-- 17100 + 19
	Log.d(TAG, "onActionFetchDismissalTeam: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )

    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchWriteTeamDeclaration",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchSignUpTeamWar( msg, luaValue )
	-- 17100 + 20
	Log.d(TAG, "onActionFetchSignUpTeamWar: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO, nil, {tid = _tid, serid = _serid})
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchSignUpTeamWar",
        onFetchCallback,
        msg.userdata
    )
end

local function onActionFetchKickTeamMember( msg, luaValue )
	-- 17100 + 21
	Log.d(TAG, "onActionFetchKickTeamMember: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO, nil, {tid = _tid, serid = _serid})
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchKickTeamMember",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchExitTeam( msg, luaValue )
	-- 17100 + 22
	Log.d(TAG, "onActionFetchExitTeam: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMWARLAYER_ACTION_ONFETCHTEAMINDEX)
        closeLayer()
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchExitTeam",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchJoinTeam( msg, luaValue )
	-- 17100 + 23
	Log.d(TAG, "onActionFetchJoinTeam: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
        NetHelper.QuickToast(_s("CHAT_SEND_SUCCESS"))
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO, nil, {tid = _tid, serid = _serid})
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchJoinTeam",
        onFetchCallback,
        msg.userdata
    )
end
local function onActionFetchSendTeamAD( msg, luaValue )
	-- 17100 + 24
	Log.d(TAG, "onActionFetchSendTeamAD: MSG_ID = %d", msg:getMsgId())
	local function onFetchCallback( items )
		NetHelper.QuickToast(_s("CHAT_SEND_SUCCESS"))
    end
    ModelHelper.requireDataWithFun(
        "model.team.TeamModel",
        "fetchSendTeamAD",
        onFetchCallback,
        msg.userdata
    )
end
local function onBtnPkClick( msg, luaValue )
    --17100 + 25
    Log.d(TAG, "btnPk: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNPKCLICK)
    local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")        -- 战斗视图工厂
    -- 场景转换
    FightViewFactory.viewPkTeamWar({ tid = _tid, serid = _serid, fnNextView = function() 
            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
            if TeamViewUtil.FROM_KEY.TEAMMAIN <= _fromKey then
                CCBCenter.loadCCB("MSG_TEAMMAINLAYER_MODEL", "ccb.c.team.TeamMainLayer")
            end
            if TeamViewUtil.FROM_KEY.INTERSERVER == _fromKey 
            or TeamViewUtil.FROM_KEY.INTERSERVERLIST == _fromKey 
            or TeamViewUtil.FROM_KEY.INTERSERVERRECORD == _fromKey 
            or TeamViewUtil.FROM_KEY.INTERSERVERRECORDLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMINTERSERVICELAYER_MODEL", "ccb.c.team.TeamInterServiceLayer")   
            elseif TeamViewUtil.FROM_KEY.SAMESERVER == _fromKey 
            or TeamViewUtil.FROM_KEY.SAMESERVERLIST == _fromKey 
            or TeamViewUtil.FROM_KEY.SAMESERVERRECORD == _fromKey 
            or TeamViewUtil.FROM_KEY.SAMESERVERRECORDLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMWARLAYER_MODEL", "ccb.c.team.TeamWarLayer")
            end

            if TeamViewUtil.FROM_KEY.INTERSERVERLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMLISTLAYER_MODEL", "ccb.c.team.TeamListLayer", {serType = 2})
            elseif TeamViewUtil.FROM_KEY.SAMESERVERLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMLISTLAYER_MODEL", "ccb.c.team.TeamListLayer", {serType = 1})
            elseif TeamViewUtil.FROM_KEY.INTERSERVERRECORD == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer", {tag = 2, typ2 = 2})
            elseif TeamViewUtil.FROM_KEY.SAMESERVERRECORD == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer", {tag = 2, typ2 = 1})
            elseif TeamViewUtil.FROM_KEY.INTERSERVERRECORDLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer", {tag = 1, typ2 = 2})
            elseif TeamViewUtil.FROM_KEY.SAMESERVERRECORDLIST == _fromKey then
                CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer", {tag = 1, typ2 = 1})   
            end

            CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = _tid, serid = _serid, fromKey = _fromKey})      
    end, })
end
-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--17100
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TEAMMEMBERLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TeamMemberLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
    _tid = (data and data.tid) or 0
    _serid = (data and data.serid) or 0
    -- _serType = (data and data.serType) or 1 -- 1 本区 2 跨服
    _fromMain = (data and data.fromMain) or false
    _fromTeamMain = (data and data.fromTeamMain) or false
    _fromInter = (data and data.fromInter) or false
    -- _fromSame = (data and data.fromSame) or false
    _fromKey = (data and data.fromKey) or TeamViewUtil.FROM_KEY.TEAMMAIN
	-- Quick element
	_nodeTable["mTeamNameTitleLabel"] = _ccbNode:getTTFLabel("mTeamNameTitleLabel", _s("ROLE_NAME"))
	_nodeTable["mTeamNameLabel"] = _ccbNode:getTTFLabel("mTeamNameLabel")
	_nodeTable["mTeamIdTitleLabel"] = _ccbNode:getTTFLabel("mTeamIdTitleLabel")
	_nodeTable["mTeamIdLabel"] = _ccbNode:getTTFLabel("mTeamIdLabel")
	_nodeTable["mTeamScoreTitleLabel"] = _ccbNode:getTTFLabel("mTeamScoreTitleLabel", _s("TEAM_SCORE"))
	_nodeTable["mTeamScoreLabel"] = _ccbNode:getTTFLabel("mTeamScoreLabel")
	_nodeTable["mManifestoTitleLabel"] = _ccbNode:getTTFLabel("mManifestoTitleLabel", _s("TEAM_MANIFESTO"))
    _nodeTable["mServiceNameLabel"] = _ccbNode:getTTFLabel("mServiceNameLabel")

	-- CCControlButton
	_nodeTable["btnViewApplication"] = _ccbNode:bindButton("btnViewApplication", onBtnViewApplicationClick, _s("TEAM_VIEW_APPLICATION"))
	_nodeTable["btnWorldRecruits"] = _ccbNode:bindButton("btnWorldRecruits", onBtnWorldRecruitsClick, _s("TEAM_WORLD_RECRUITSCLICK"))
	_nodeTable["btnDismissal"] = _ccbNode:bindButton("btnDismissal", onBtnDismissalClick, _s("TEAM_DISMISSAL_TEAM"))
	_nodeTable["btnSignUp"] = _ccbNode:bindButton("btnSignUp", onBtnSignUpClick, _s("TEAM_WAR_SIGN_UP"))
	_nodeTable["btnJoin"] = _ccbNode:bindButton("btnJoin", onBtnJoinClick, _s("TEAM_JOIN"))
    _nodeTable["btnExitTeam"] = _ccbNode:bindButton("btnExitTeam", onBtnExitTeamClick, _s("TEAM_EXIT_TEAM"))
	_nodeTable["btnPk"] = _ccbNode:bindButton("btnPk", onBtnPkClick)

	_ccbNode:bindButton("btnBack", onBtnBackClick)

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.team.TeamMemberLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
    
	CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO, nil, {tid = _tid, serid = _serid})
end


MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNVIEWAPPLICATIONCLICK]	= onBtnViewApplicationClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNWORLDRECRUITSCLICK]	= onBtnWorldRecruitsClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNDISMISSALCLICK]	= onBtnDismissalClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNSIGNUPCLICK]	= onBtnSignUpClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNJOINCLICK]  = onBtnJoinClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNPKCLICK]	= onBtnPkClick

MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNEXITTEAMCLICK]	= onBtnExitTeamClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ONBTNBACKCLICK]	= onBtnBackClick
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHTEAMINFO]	= onActionFetchTeamInfo
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHDISMISSALTEAM]	= onActionFetchDismissalTeam
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHWRITETEAMDECLARATION]	= onActionFetchWriteTeamDeclaration
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHSIGNUPTEAMWAR]	= onActionFetchSignUpTeamWar
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHKICKTEAMMEMBER]	= onActionFetchKickTeamMember
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHEXITTEAM]	= onActionFetchExitTeam
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHJOINTEAM]	= onActionFetchJoinTeam
MSG_HANDLER[MSG_ID.MSG_TEAMMEMBERLAYER_ACTION_ONFETCHSENDTEAMAD]	= onActionFetchSendTeamAD
