--TowerBuffLayer.lua

MSG_ID.MSG_TOWERBUFFLAYER_MODEL 				= 29500

MSG_ID.MSG_TOWERBUFFLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_TOWERBUFFLAYER_MODEL + 10
MSG_ID.MSG_TOWERBUFFLAYER_ONBTNCONFIRMBUFFCLICK = MSG_ID.MSG_TOWERBUFFLAYER_MODEL + 11
MSG_ID.MSG_TOWERBUFFLAYER_ONBTNRECHOOSEBUFFCLICK = MSG_ID.MSG_TOWERBUFFLAYER_MODEL + 12

local TAG = "[TowerBuffLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popSecondCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--29500 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_TOWERBUFFLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onBtnConfirmBuffClick( ... )
	local function onFetchCallback( properties )
		closeLayer()
		CCBCenter.loadCCB("MSG_TOWERLAYER_MODEL", "ccb.c.tower.TowerLayer",{fromMap = true})
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_BUFF,
        onFetchCallback,
		{ no = _ccbNode.getSelectedIndex()},
		{}
    )
end

local function onBtnReChooseBuff( )
	local function onFetchCallback( properties )
		--刷新buff
		_ccbNode.reloadBuff(properties.Buff)
		--创建BuffGrid
		-- _ccbNode.createBuffGrid(properties.ResetBuffPrice)

		_ccbNode.createPriceBtn(properties.ResetBuffPrice)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_UPDATE_BUFF,
        onFetchCallback,
		{},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--29500
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TOWERBUFFLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TowerBuffLayer.ccbi")

	_ccbNode.buff = data.buff
	_ccbNode.price = data.price
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mBuffTtitleLabel"] = _ccbNode:getNode("mBuffTtitleLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnConfirmBuff", onBtnConfirmBuffClick,_s("TOWER_BUFF_CONFIRM"))

	--填充文字
	_nodeTable["mBuffTtitleLabel"]:setString(_s("TOWER_BUFF_CHOOSE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.tower.TowerBuffLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_TOWERBUFFLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TOWERBUFFLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_TOWERBUFFLAYER_ONBTNCONFIRMBUFFCLICK]	= onBtnConfirmBuffClick
MSG_HANDLER[MSG_ID.MSG_TOWERBUFFLAYER_ONBTNRECHOOSEBUFFCLICK]	= onBtnReChooseBuff
