--TowerLayer.lua

MSG_ID.MSG_TOWERLAYER_MODEL 				= 29400

MSG_ID.MSG_TOWERLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_TOWERLAYER_MODEL + 10
MSG_ID.MSG_TOWERLAYER_ONBTNBUFFCLICK = MSG_ID.MSG_TOWERLAYER_MODEL + 11
MSG_ID.MSG_TOWERLAYER_ONBTNRANKCLICK = MSG_ID.MSG_TOWERLAYER_MODEL + 12
MSG_ID.MSG_TOWERLAYER_ONBTNTOWERRULECLICK = MSG_ID.MSG_TOWERLAYER_MODEL + 13
MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST = MSG_ID.MSG_TOWERLAYER_MODEL + 14
MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHBUYCHALLENGE = MSG_ID.MSG_TOWERLAYER_MODEL + 15
MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHFIGHT = MSG_ID.MSG_TOWERLAYER_MODEL + 16

local TAG = "[TowerLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	if _ccbNode.fromMap then
		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA)
	end
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--29400 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_TOWERLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onBtnBuffClick( msg, luaValue )
	--29400 + 11
	Log.d(TAG, "btnBuff: MSG_ID = %d", MSG_ID.MSG_TOWERLAYER_ONBTNBUFFCLICK)
end

local function onBtnRankClick( msg, luaValue )
	--29400 + 12
	Log.d(TAG, "btnRedHeart: MSG_ID = %d", MSG_ID.MSG_TOWERLAYER_ONBTNRANKCLICK)
	CCBCenter.loadCCB("MSG_TOWERRANKLAYER_MODEL", "ccb.c.tower.TowerRankLayer")
end

local function onBtnTowerRuleClick( msg, luaValue )
	--29400 + 13
	Log.d(TAG, "btnTowerRule: MSG_ID = %d", MSG_ID.MSG_TOWERLAYER_ONBTNTOWERRULECLICK)
	CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isTowerRule = true,})
end

local function onFetchTowerList( msg, luaValue )

	local function onFetchCallback( properties )
		if #properties.Buff > 0 then
			_ccbNode.openSchedule(false)
			CCBCenter.loadCCB("MSG_TOWERBUFFLAYER_MODEL", "ccb.c.tower.TowerBuffLayer", {buff = properties.Buff,price = properties.ResetBuffPrice})
		else
			_ccbNode.openSchedule(true)
		end
		--刷新特殊副本数据
		_ccbNode.reloadCheckpointyGrid(properties.tinfos)
		--创建挑战次数按钮
		_ccbNode.createRedHeartBtn(properties.ChallengeNum,properties.TotalChallengeNum,properties.ChallengePrice)
		--设置记录数值
		_ccbNode.setRecordString(properties.TodayResults,properties.myrank,properties.SelfBuff,properties.ChallengePrice)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_TOWER,
        onFetchCallback,
		{},
		{}
    )
end
--购买挑战次数
local function onFetchBuyChallenge( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_BUY_CHALLENGE,
        onFetchCallback,
		{},
		{}
    )
end

local function onFetchFight( msg, luaValue )
	local function onFetchCallback( properties )
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_LADDERLIST,
        onFetchCallback,
		{ no =  msg.userdata.no},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--29400
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TOWERLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TowerLayer.ccbi")
	_ccbNode.closeLayer = closeLayer

	_ccbNode.fromMap = data.fromMap

	-- Quick element
	_nodeTable["mTowerList"] = _ccbNode:getNode("mTowerList", "CCLayer")
	_nodeTable["mChallengeLabel"] = _ccbNode:getNode("mChallengeLabel", "CCLabelTTF")
	_nodeTable["mRankLabel"] = _ccbNode:getNode("mRankLabel", "CCLabelTTF")
	_nodeTable["mBtnLayer"] = _ccbNode:getNode("mBtnLayer", "CCLayer")
	_nodeTable["mTowerRuleLabel"] = _ccbNode:getNode("mTowerRuleLabel", "CCLabelTTF")
	_nodeTable["mRecordLabel"] = _ccbNode:getNode("mRecordLabel", "CCLabelTTF")
	_nodeTable["mMyRecordTitleLabel"] = _ccbNode:getNode("mMyRecordTitleLabel", "CCLabelTTF")
	_nodeTable["mMyRecordLabel"] = _ccbNode:getNode("mMyRecordLabel", "CCLabelTTF")
	_nodeTable["mMyRankTitleLabel"] = _ccbNode:getNode("mMyRankTitleLabel", "CCLabelTTF")
	_nodeTable["mMyRankLabel"] = _ccbNode:getNode("mMyRankLabel", "CCLabelTTF")
	_nodeTable["mMyBuffTitleLabel"] = _ccbNode:getNode("mMyBuffTitleLabel", "CCLabelTTF")
	_nodeTable["mHeroHPLabel"] = _ccbNode:getNode("mHeroHPLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)
	_ccbNode:bindButton("btnRank", onBtnRankClick)
	_ccbNode:bindButton("btnTowerRule", onBtnTowerRuleClick)

	--填充文字
	_nodeTable["mRankLabel"]:setString(_s("RANK_RANKING_TITLE"))
	_nodeTable["mTowerRuleLabel"]:setString(_s("TOWER_RULE_TITLE"))
	-- _nodeTable["mChallengeLabel"]:setString(_s("TOWER_CHALLENGE"))
	_nodeTable["mRecordLabel"]:setString(_s("TOWER_RECORD"))
	_nodeTable["mMyRecordTitleLabel"]:setString(_s("TOWER_MY_RECORD_TITLE"))
	_nodeTable["mMyRankTitleLabel"]:setString(_s("TOWER_MY_RANK"))
	_nodeTable["mMyBuffTitleLabel"]:setString(_s("TOWER_BUFF_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.tower.TowerLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
		CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST)
	end
end


MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ONBTNBUFFCLICK]	= onBtnBuffClick
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ONBTNRANKCLICK]	= onBtnRankClick
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ONBTNTOWERRULECLICK]	= onBtnTowerRuleClick
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST]	= onFetchTowerList
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHBUYCHALLENGE]	= onFetchBuyChallenge
MSG_HANDLER[MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHFIGHT]	= onFetchFight
