--TowerRankLayer.lua

MSG_ID.MSG_TOWERRANKLAYER_MODEL 				= 29600

MSG_ID.MSG_TOWERRANKLAYER_ONBTNCLOSECLICK = MSG_ID.MSG_TOWERRANKLAYER_MODEL + 10
MSG_ID.MSG_TOWERRANKLAYER_ACTION_ONFETCHRANKLIST = MSG_ID.MSG_TOWERRANKLAYER_MODEL + 11

local TAG = "[TowerRankLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end


local function onBtnCloseClick( msg, luaValue )
	--29600 + 10
	Log.d(TAG, "btnClose: MSG_ID = %d", MSG_ID.MSG_TOWERRANKLAYER_ONBTNCLOSECLICK)
	closeLayer()
end

local function onFetchRankList( ... )
	local function onFetchCallback( properties )
		--设置我的记录
		_ccbNode.setMyRecord(properties.myresults,properties.myrank)
		--刷新排名Grid
		_ccbNode.reloadRankGrid(properties.playerlist)
	end
	
	NetHelper.createRequest(
        ACTID.MSG_GET_RANK,
        onFetchCallback,
		{},
		{}
    )
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--29600
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_TOWERRANKLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "TowerRankLayer.ccbi")
	_ccbNode.closeLayer = closeLayer
	-- Quick element
	_nodeTable["mRankTtitleLabel"] = _ccbNode:getNode("mRankTtitleLabel", "CCLabelTTF")
	_nodeTable["mMyRecordLabel"] = _ccbNode:getNode("mMyRecordLabel", "CCLabelTTF")
	_nodeTable["mMyRankLabel"] = _ccbNode:getNode("mMyRankLabel", "CCLabelTTF")

	-- CCControlButton
	_ccbNode:bindButton("btnClose", onBtnCloseClick)

	--填充文字
	_nodeTable["mRankTtitleLabel"]:setString(_s("TOWER_RANK_TITLE"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.tower.TowerRankLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode, anim.ANIMATION_POP_OUT, {onComplete = function ( ... )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERRANKLAYER_ACTION_ONFETCHRANKLIST)
		end})
	end
end


MSG_HANDLER[MSG_ID.MSG_TOWERRANKLAYER_MODEL]				= onCCBLoad

MSG_HANDLER[MSG_ID.MSG_TOWERRANKLAYER_ONBTNCLOSECLICK]	= onBtnCloseClick
MSG_HANDLER[MSG_ID.MSG_TOWERRANKLAYER_ACTION_ONFETCHRANKLIST]	= onFetchRankList
