--LoginNewLayer.lua

MSG_ID.MSG_LOGINNEWLAYER_MODEL 				= 7000
MSG_ID.MSG_GETSERLIST			= MSG_ID.MSG_LOGINNEWLAYER_MODEL + 10
MSG_ID.MSG_OPENSDK			= MSG_ID.MSG_LOGINNEWLAYER_MODEL + 11
MSG_ID.MSG_LOGINNewLAYER_LOGIN	= MSG_ID.MSG_LOGINNEWLAYER_MODEL + 12
MSG_ID.MSG_LOGINNewLAYER_ONBTNREFLESHCLICK = MSG_ID.MSG_LOGINNEWLAYER_MODEL + 13

local TAG = "[LoginNewLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popLastLevelCCBNode()
end

--[[

-   回调函数	登录

--   properties:  table    服务端返回信息
--	 params:      table    回调参数
--]]
local function callback_login( properties, params )
 	
    if ISGSVALUES() == nil then return end
    if properties then 
	    -- 保存用户id ，no
	    GSVALUES.userid = properties.userid
	    GSVALUES.userno = properties.userno
	    -- 修改密码
    	GSVALUES.modpass = properties.modpass
    end 
	-- 保存sessionid
    if properties and properties.sessionid then
    	NetWriter:setSessionID(properties.sessionid)
    	-- 存入session
    	GSVALUES.sid = properties.sessionid
    end
    -- 需要更改信息
    if properties and properties.needmodify == 1 then
    	-- 存入
    	GSVALUES.needmodify = properties.needmodify
    	Log.d(TAG,"~~~~~~update")

    	-- 旧
		-- CCBCenter.replaceScene("MSG_USERUPDATELAYER_MODEL", "ccb.c.user.UserUpdateLayer")
		-- 新
		CCBCenter.replaceScene("MSG_USERREGISTERLAYER_MODEL", "ccb.c.user.UserRegisterLayer")
    else
    	-- 存入
    	GSVALUES.needmodify = 0
    	-- 不需要修改则存入名字，性别，头像
    	GSVALUES.name = properties.name
    	GSVALUES.sex = properties.sex
    	GSVALUES.head = properties.head
    	-- 不需修改则跳到主页面
    	Log.d(TAG,"~~~~~~login")
    	SOUND:playMusicHome()
		CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
    end
    GS.save(GSVALUES)

    -- 初始化本地基本信息
    NetHelper.initLocalBaseInfo()
 
    -- if isandroid() then 
    	
    	_sdkPlatform.initServerInfo(
    		tostring(ME:getSerid()), 
    		ME:getSername(), 
    		tostring(ME:getUserid()), 
    		ME:getName()
    		)
    -- end
    NetHelper.hideLoading(true)
end

--[[

-   获取服务器列表
--]]
local function getSerListRequest(msg, luaValue)
	--[[

	-   回调函数

	--   properties:  table    服务端返回信息
	--	 params:      table    回调参数
	--]]
	local function callback_getSerList( properties, params )
		 NetHelper.hideLoading(true)
		if properties and _ccbNode.reloadSerList then 
			_nodeTable["btnReflesh"]:setVisible(false)
			_nodeTable["l_enter"] :setVisible(true)
			_nodeTable["mMyServerLabel"]:setVisible(false)
			_ccbNode.reloadSerList(properties,params)
		else
			getSerListRequest()
		end
	end

	local function errorcallback_getSerList( ... )
		if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "ja" then
			util.delayCall(function ( )
	            -- createRefreshButton()
	          _ccbNode.setCanenter()
	        end, 2 )
		else
			_nodeTable["mMyServerLabel"]:setString(_s("NETWORK_GET_SERVER_ERROR"))
			_nodeTable["mMyServerLabel"]:setVisible(true)
			_nodeTable["btnReflesh"]:setVisible(true)
			_nodeTable["l_enter"] :setVisible(false)
		end
	end
	NetHelper.sendGetSerListRequest(callback_getSerList, errorcallback_getSerList, msg.userdata, getSerListRequest)
end

local function failCallback( result, cbParams )
	Log.d(TAG,"~~~~~~failCallback")

	NetHelper.hideLoading(true)
	_ccbNode.setCanenter(true)
end
--[[

-   登录请求失败
--]]
local function failLoginCallback( ... )
	failCallback()
	--重新请求服务器列表
	CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
end

--[[

-   登录请求
--]]
local function loginRequest()

	Log.d(TAG,"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@device.platform",device.platform)
	local debug = false
	-- 修改的帐号密码

	local username = "user_fed72aa0-ec00-4052-ad4d-cf49b870abe0"
	local pass = "257ff0cbf59fcfa366ca19fcc0a3fc9a"
	local function regRequest( result, cbParams )
		Log.d(TAG,"~~~~~~reg")

		local properties = clone(LOGINBASEINFO) 
		if _GAME.CONFIG.SDK_PLATFORM[1] == 14 then
			properties.usertype = 3
		elseif _GAME.CONFIG.SDK_PLATFORM[1] == 1 and _GAME.CONFIG.SDK_PLATFORM[2] == "_knm" then
			properties.usertype = 3
		end
		local function callback_reg( properties, params )
		    if properties then
		        Log.d(TAG,"===========================================================\n")
		       	properties.udid = LOGINBASEINFO.udid
		       	-- 保存账号密码
		       	ISGSVALUES()
		       	if GSVALUES then
			       	if debug then
		       			GSVALUES.username = username
						GSVALUES.pass = pass
		       		end 
		       		table.merge(GSVALUES, properties)
		       	end
		        GS.save(properties)
		        -- 登录请求
		        NetHelper.createRequest(
			        ACTID.MSG_USER_LOGIN,
			        callback_login,
			        properties,
		            { other = LOGINBASEINFO }
			    )
		    else
		    	NetHelper.hideLoading(true)
		    	_ccbNode.setCanenter(true)
		        Log.d(TAG,"err")
		    end
		end
		NetHelper.showLoading(true, true)
		NetHelper.createRequest(
		    ACTID.MSG_USER_REG,
		    callback_reg,
		    properties,
		    {
		    	failedCb = failCallback
			}
		)
		Log.d(TAG,"~~~~~~reg end")
	end
	if ISGSVALUES() and GSVALUES.udid and GSVALUES.udid == LOGINBASEINFO.udid then
		-- 已存在则调用登录请求
		Log.d(TAG,"+++++++%s",json.encode(GSVALUES))
		-- 保存玩家姓名与性别, 其他的看情况暂时没存
		ME:setProperties(GSVALUES)
		if debug then
   			GSVALUES.username = username
			GSVALUES.pass = pass
   		end
		Log.d(TAG,"~~~~~~MSG_USER_LOGIN")
		NetHelper.showLoading(true, true)
		NetHelper.createRequest(
	        ACTID.MSG_USER_LOGIN,
	        callback_login,
	        GSVALUES,
	        { 
	        	other = LOGINBASEINFO ,
	        	failedCb = failLoginCallback
	    	}
	    )
		Log.d(TAG,"~~~~~~MSG_USER_LOGIN end")
	else
		-- 不存在则调用注册请求
		regRequest( )
	end
end

local function openSdkLayer()
	if ENABLED_SDK_ONEKEYLOGIN then 
		-- 非云顶SDK
		loginRequest()
	else
		-- 云顶SDK
		Log.d(TAG,"openSdkLayer@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@")
		NetHelper.showLoading(true,true)

		local function sdkloginSuccessCalBack( result )
			Log.d(TAG, "登录成功: MSG_ID = %s", result["usertocken"])
			Log.d(TAG, "usertocken: MSG_ID = %s", result["usertocken"])
			Log.d(TAG, "userid: MSG_ID = %s", result["userid"])
			Log.d(TAG, "nickname: MSG_ID = %s", result["nickname"])
			---后台验证
			if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 
				LOGINBASEINFO.udid = result["userid"]
			elseif isSDK(_GAME.CONFIG.SDK.SDK_91) then 
				LOGINBASEINFO.udid = result["91uin"]
				-- 如果是91，必须赋值
		        LOGINBASEINFO.ext1 = result["91appid"] --AppId
		        LOGINBASEINFO.ext2 = result["91sign"] --Sign
		        LOGINBASEINFO.ext3 = result["91sessionId"] --SessionID
			elseif isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE) or isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE_EN) then
				LOGINBASEINFO.udid = result["userid"]
			elseif isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then 
				LOGINBASEINFO.udid = result["userid"]
			elseif isSDK(_GAME.CONFIG.SDK.SDK_360) then 
				LOGINBASEINFO.udid = result["userid"]
				LOGINBASEINFO.ext1 = result["360accesstoken"] 
		        LOGINBASEINFO.ext2 = result["360refreshtoken"] 
		   	elseif isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) then 
				LOGINBASEINFO.udid = result["userid"]
				LOGINBASEINFO.ext1 = result["usertocken"] 
			elseif isSDK(_GAME.CONFIG.SDK.SDK_3G) then 
				LOGINBASEINFO.udid = result["userid"]
				LOGINBASEINFO.ext1 = result["usertocken"] 
			elseif isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then 
				LOGINBASEINFO.udid = result["userid"]
				LOGINBASEINFO.ext1 = result["usertocken"]
			elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE) then 
				LOGINBASEINFO.udid = result["userid"]
			else
				LOGINBASEINFO.udid = result["userid"]
			end
			if not isandroid() then 
				try(function (  )
					NetHelper.showLoading(true,true,false, _s("LOGIN_LOADING"))
				end, function (  )
					Log.d(TAG, "@@@@@@@@@@@@@@@@@ showLoading error")
				end)
				
			end

			if _sdkPlatform.hasCheckSession() then
				_sdkPlatform.checkSession(
					function ( val )
						-- 验证session成功
--						print("@@@@ 来验证下session 成功")
						if val then 
							if isSDK(_GAME.CONFIG.SDK.SDK_MZW) then
								LOGINBASEINFO.udid = val	
							end
						end
						loginRequest()
					end,
					function ( val )
						-- 验证session失败
--						print("@@@@ 来验证下session 失败")
						NetHelper.hideLoading(true)
						AlertLayer.new4OK{
					        -- 按钮颜色数组
							btnClickEvent = {
								function (  )  --按钮1事件  默认为确定
						        end
							}, -- 按钮事件数组
					        titleStr = _s("COMMON_NEWS_TIPS"),  -- 标题
					        content = val["errorStr"]  -- 内容
				      	}
					end,
					{ uid = result["userid"], session = result["usertocken"] }
					)
			else 
				loginRequest()
			end
		end

		local function sdkloginErrorCallBack( result )
			NetHelper.hideLoading(true)
			_ccbNode.setCanenter(true)
			Log.d(TAG, "登录失败: MSG_ID = %s", result["usertocken"])
			Log.d(TAG, "errorCode: MSG_ID = %s", result["errorCode"])
			if isios() then 
				NetHelper.QuickToast(_s("LOGIN_FAILED") .. result["errorCode"])
			end
		end

		if isSDK(_GAME.CONFIG.SDK.SDK_UCUBE) and _GAME.AUTOLOGIN.USERID and _GAME.AUTOLOGIN.USERID ~= "" and _GAME.AUTOLOGIN.TOKEN and _GAME.AUTOLOGIN.TOKEN ~= "" then
			sdkloginSuccessCalBack{userid = _GAME.AUTOLOGIN.USERID, usertocken = _GAME.AUTOLOGIN.TOKEN}
		else
			_sdkPlatform.login(sdkloginSuccessCalBack, sdkloginErrorCallBack, {})
		end
	end
end 

local function onBtnRefleshClick( ... )
	CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

local function onCCBLoad(data, callback)
	--7000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_LOGINNEWLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "LoginNewLayer.ccbi")
	_ccbNode.onExit = function ( self )
        util.removeUnusedTextures()
    end
	-- Quick element
	_nodeTable["l_enter"] = _ccbNode:getNode("l_enter", "CCNode")
	_nodeTable["mMyServerLayer"] = _ccbNode:getNode("mMyServerLayer", "CCLayer")
	_nodeTable["mServerListLayer"] = _ccbNode:getNode("mServerListLayer", "CCLayer")
	_nodeTable["mVersionLabel"] = _ccbNode:getNode("mVersionLabel", "CCLabelTTF")
	_nodeTable["mServerTitileLabel"] = _ccbNode:getNode("mServerTitileLabel", "CCLabelTTF")
	_nodeTable["mMyServerLabel"] = _ccbNode:getNode("mMyServerLabel", "CCLabelTTF")
	_nodeTable["mRecentlyLoginLabel"] = _ccbNode:getNode("mRecentlyLoginLabel", "CCLabelTTF")
	_nodeTable["mRecentlyServerLabel"] = _ccbNode:getNode("mRecentlyServerLabel", "CCLabelTTF")
	_nodeTable["mServerStatusLabel"] = _ccbNode:getNode("mServerStatusLabel", "CCLabelTTF")
	_nodeTable["mAllServerLabel"] = _ccbNode:getNode("mAllServerLabel", "CCLabelTTF")
	_nodeTable["mMyServer"] = _ccbNode:getNode("mMyServer", "CCLayer")
	_nodeTable["btnReflesh"] = _ccbNode:getNode("btnReflesh", "CCControlButton")

	-- 填充文字
	_nodeTable["mServerTitileLabel"]:setString(_s("LOGIN_CHOOSE_SERVICE"))
	_nodeTable["mRecentlyLoginLabel"]:setString(_s("LOGIN_RECENTLY_ENTER"))
	_nodeTable["mAllServerLabel"]:setString(_s("LOGIN_ALL_SERVER"))


	-- CCControlButton
	_ccbNode:bindButton("btnReflesh", onBtnRefleshClick,_s("LOGIN_SERVER_REFESH"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)
	CCBCenter.bindView("ccb.v.user.LoginNewLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushLastLevelCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_LOGINNEWLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_GETSERLIST]						= getSerListRequest
MSG_HANDLER[MSG_ID.MSG_OPENSDK]							= openSdkLayer 
MSG_HANDLER[MSG_ID.MSG_LOGINNewLAYER_LOGIN]				= loginRequest
MSG_HANDLER[MSG_ID.MSG_LOGINNewLAYER_ONBTNREFLESHCLICK]				= onBtnRefleshClick

