--UserRegisterLayer.lua

MSG_ID.MSG_USERREGISTERLAYER_MODEL 				= 23000

MSG_ID.MSG_USERREGISTERLAYER_ONBTNREGISTERCLICK = MSG_ID.MSG_USERREGISTERLAYER_MODEL + 10
MSG_ID.MSG_USERREGISTERLAYER_ONBTNINVITECLICK = MSG_ID.MSG_USERREGISTERLAYER_MODEL + 11
MSG_ID.MSG_USERREGISTERLAYER_ONBTNRANDOMCLICK = MSG_ID.MSG_USERREGISTERLAYER_MODEL + 12

local TAG = "[UserRegisterLayer]"
local _ccbNode 
local _nodeTable = {}

local function closeLayer()
	CCBCenter.popFirstCCBNode()
end

local TDNumberUtils           	= require(PH_MDL_UTIL .. "TDNumberUtils")
local ChatUtil 					= require("ccb.m.chat.ChatUtil")

-- [常量]
local NAME_RIGHT  				= 1
local NAME_WRONG1 				= 2
local NAME_WRONG2 				= 3
local NAME_WRONG3 				= 4

-- [函数定义]
-- 验证角色名
function checkWord()
	local flag = NAME_RIGHT
	local name = _ccbNode.getRoleName()

	if ChatUtil.getTextCount2(name) > 30 then 
		flag = NAME_WRONG1
	elseif ChatUtil.getTextCount2(name) < 0 then 
		flag = NAME_WRONG2
	elseif ChatUtil.getTextCount2(name) < 2 then 
		flag = NAME_WRONG3
	end

	return flag
end

--验证邀请码
function checkInvite( ... )
	local flag = NAME_RIGHT
	local inviteCode = _ccbNode.getRoleName()

	if inviteCode ~= "" and ChatUtil.getTextCount(inviteCode) ~= 10  then 
		flag = NAME_WRONG1
	elseif ChatUtil.getTextCount(inviteCode) < 0 then 
		flag = NAME_WRONG2
	end

	local utextStr = UTF8(inviteCode)
	local m = string.match( inviteCode, "[\128-\255]+")

	for i = 1,utextStr:len() do
		local str = tostring(utextStr:sub(i,i))
		if  string.match(str,"%w+") then
		else
			flag = NAME_WRONG3
			break
		end
	end
	return flag
end

-- 回调方法
function callbackRegister(properties, params)
	Log.d(TAG,"properties:%s",json.encode(properties))


	if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK) then  --facebook分享
		_sdkPlatform.fxFacebookFirst(
			function ( ... )
				-- 好像不用做什么的样子...
			end, 
			function ( ... )
				-- 同样无所事事的,会不会被干掉啊~~~
			end
			)
	elseif isSDK(_GAME.CONFIG.SDK.SDK_TWITTER) then  --twitter分享
		_sdkPlatform.fxTwitterFirst(
			function ( ... )
				-- 好像不用做什么的样子...
			end, 
			function ( ... )
				-- 同样无所事事的,会不会被干掉啊~~~
			end
			)
	end

	-- 存入
	if ISGSVALUES() then 
		GSVALUES.needmodify = 0
		-- 存入名字，性别，头像
		GSVALUES.name = _ccbNode.getRoleName()
		GSVALUES.sex = _ccbNode.getGenderId()
		GSVALUES.head = "1|1"
		-- 清除地图数据
		GSVALUES.levelIdLast = nil
		GSVALUES.MAX_LEVEL = nil

		GS.save(GSVALUES)
	end

    -- 初始化本地基本信息
    NetHelper.initLocalBaseInfo()

    -- print("success!!!!!")
    -- 上传用户信息到云顶
    _sdkPlatform.initServerInfo(
    		tostring(ME:getSerid()), 
    		ME:getSername(), 
    		tostring(ME:getUserid()), 
    		ME:getName()
    		)

    _ccbNode.setInvitecode()

end


-- [函数定义]

local function onBtnRegisterClick( msg, luaValue )
	--23000 + 14
	-- Log.d(TAG, "btnRegister: MSG_ID = %d", MSG_ID.MSG_USERREGISTERLAYER_ONBTNREGISTERCLICK)
	local errorTag = checkWord()
	if errorTag == NAME_WRONG1 then 
		NetHelper.QuickToast(_s("ACCOUNT_NAME_OVER_LIMIT"))
		return
	elseif errorTag == NAME_WRONG2 then
		NetHelper.QuickToast(_s("ACCOUNT_NAME_LLLEGAL"))
		return
	elseif errorTag == NAME_WRONG3 then
		NetHelper.QuickToast(_s("ACCOUNT_LESS_THAN_TWO_WORDS"))
		return
	end

	-- 获取信息
	local properties = {
 		nickname	= _ccbNode.getRoleName(),
		email		= "",								-- 此属性无用
		face		= "1|1",		-- 装扮字符串（包括头发，眼睛等）
		sex			= _ccbNode.getGenderId(),
		invitecode  = nil, 		-- 邀请码
    }
    Log.d(TAG,"send properties:%s",json.encode(properties))
    -- 发送请求
    NetHelper.createRequest(
        ACTID.MSG_UPDATE_USER,
        callbackRegister,
        properties
    )
end

local function onBtnInviteClick( ... )
	-- body

	local errorTag = checkInvite()
	if errorTag == NAME_WRONG1 then 
		NetHelper.QuickToast(_s("REGISTER_INVITE_ERROR_1"))
		_ccbNode.setRoleName("")
		return
	elseif errorTag == NAME_WRONG2 then
		NetHelper.QuickToast(_s("REGISTER_INVITE_ERROR_2"))		
		_ccbNode.setRoleName("")
		return
	elseif errorTag == NAME_WRONG3 then
		NetHelper.QuickToast(_s("REGISTER_INVITE_ERROR_3"))
		_ccbNode.setRoleName("")
		return
	end

	local function callBackInvite( ... )
		closeLayer()
		-- CCBCenter.replaceScene("MSG_COMICOPENING_01_LAYER_MODEL", "ccb.c.comic.ComicOpening_01_Layer")
		SOUND:playMusicHome()
		CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
	end

	-- 获取信息
	local properties = {
 		invitecode	= _ccbNode.getRoleName(),
    }

    if _ccbNode.getRoleName() ~= "" then
		-- 发送请求
	    NetHelper.createRequest(
	        ACTID.MSG_INVITECODE,
	        callBackInvite,
	        properties
	    )
	else
		callBackInvite()
	end

end

local function onBtnRandomClick( msg, luaValue )
	--23000 + 17
	Log.d(TAG, "onBtnRandomClick: MSG_ID = %d", MSG_ID.MSG_USERREGISTERLAYER_ONBTNRANDOMCLICK)

	-- 设置随机角色名
	_ccbNode.setRandomRoleName()
end

-- local function animationCompletedCallback( animationManager, animName, luaEventHandler )
-- 	Log.d(TAG, "animationCompletedCallback: %s", animName)
-- end

-- [加载/卸载]
local function onCCBLoad(data, callback)
	--23000
	Log.d(TAG, "onCCBLoad: MSG_ID = %d", MSG_ID.MSG_USERREGISTERLAYER_MODEL)
	_ccbNode = CCBCenter.readCCBFromFile(PATH_CCB_FILE .. "UserRegisterLayer.ccbi")
	-- Quick element
	_nodeTable["mTitleLabel"] = _ccbNode:getNode("mTitleLabel", "CCLabelTTF")
	_nodeTable["mNameTitleLabel"] = _ccbNode:getNode("mNameTitleLabel", "CCLabelTTF")
	_nodeTable["mInviteWarming"] = _ccbNode:getNode("mInviteWarming", "CCLabelTTF")
	_nodeTable["btnRandom"] = _ccbNode:getNode("btnRandom", "CCControlButton")
	_nodeTable["btnRegist"] = _ccbNode:getNode("btnRegist", "CCControlButton")
	_nodeTable["btnInvite"] = _ccbNode:getNode("btnInvite", "CCControlButton")
	_nodeTable["mInvitecodeTitleLabel"] = _ccbNode:getNode("mInvitecodeTitleLabel", "CCLabelTTF")

	-- CCControlButton

	_ccbNode:bindButton("btnInvite", onBtnInviteClick, _s("REGISTER_ENTER_GAME"))
	_ccbNode:bindButton("btnRegist", onBtnRegisterClick,_s("REGISTER_NEXT"))
	_ccbNode:bindButton("btnRandom", onBtnRandomClick,_s("REGISTER_NAME_RANDOM"))

	-- MenuItem
	-- _ccbNode:bindAnimationCompletedEvent(animationCompletedCallback)

	-- 填充文字
	_nodeTable["mTitleLabel"]:setString(_s("REGISTER_TITLE"))
	_nodeTable["mNameTitleLabel"]:setString(_s("REGISTER_NAME_TITLE"))
	_nodeTable["mInvitecodeTitleLabel"]:setString(_s("REGISTER_INVITE_TITLE"))
	_nodeTable["mInviteWarming"]:setString(_s("REGISTER_INVITE_WARMING"))

	CCBCenter.bindView("ccb.v.user.UserRegisterLayerView", _ccbNode, _nodeTable)
	if callback then
		callback(_ccbNode)
	else
		CCBCenter.pushFirstCCBNode(_ccbNode)
	end
end


MSG_HANDLER[MSG_ID.MSG_USERREGISTERLAYER_MODEL]				= onCCBLoad
MSG_HANDLER[MSG_ID.MSG_USERREGISTERLAYER_ONBTNREGISTERCLICK]	= onBtnRegisterClick
MSG_HANDLER[MSG_ID.MSG_USERREGISTERLAYER_ONBTNINVITECLICK]	= onBtnInviteClick
MSG_HANDLER[MSG_ID.MSG_USERREGISTERLAYER_ONBTNRANDOMCLICK]	= onBtnRandomClick
