--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

竞技信息实体类

]]

local M = class("EntityArena", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "cd",           --挑战cd
    "count",        --剩余挑战次
    "myrank",       --我的名次
    "players",      --玩家数组
    "top10players", --top10玩家数组
    "jjcState",     --状态 0:开始 （竞技中） 1：结束 （竞技休战） int
 }

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 挑战cd
    cd         = { "number", I.UNSET_NUMBER },
    -- 剩余挑战次
    count         = { "number", I.UNSET_NUMBER },
    -- 我的名次
    myrank         = { "number", I.UNSET_NUMBER },
    -- 玩家数组
    players      = { "table", {}, "ccb.m.friend.EntityFriend"},--PH_EN_FIGHT .. "EntityUser" },
    -- top10玩家数组
    top10players = { "table", {}, "ccb.m.friend.EntityFriend"},
    --状态 0:开始 （竞技中） 1：结束 （竞技休战） int
    jjcState = { "number", I.UNSET_NUMBER },
}
 
function M:getCd( )
    return self.cd_
end

function M:setCd( cd )
    self.cd_ = cd
end

function M:getCount(  )
    return self.count_
end

function M:setCount( count )
    self.count_ = count
end

function M:getMyrank(  )
    return self.myrank_
end

function M:setMyrank( myrank )
    self.myrank_ = myrank
end

function M:getPlayers(  )
    return self.players_
end

function M:setPlayers( players )
    self.players_ = players
end

function M:getTop10players(  )
    return self.top10players_
end

function M:setTop10players( top10players )
    self.top10players_ = top10players
end

function M:getJjcState(  )
    return self.jjcState_
end

function M:setJjcState( jjcState )
    self.jjcState_ = jjcState
end

return M