--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

竞技信息实体类

]]

local M = class("EntityRecord", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",
    "res",           --战斗结果
    "rankvar",        --排名变化情况，正数上升，负数下降
    "pkdate",       --战斗时间
    "players",      --玩家信息
 }

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    id        = { "number", I.UNSET_NUMBER },
    -- 结果
    res         = { "number", I.UNSET_NUMBER },
    -- 名次变化
    rankvar         = { "number", I.UNSET_NUMBER },
    -- 对战时间
    pkdate         = { "string", I.UNSET_STRING },
    -- 玩家数组
    players      = { "ccb.m.friend.EntityFriend", {}  },
}
 
function M:getId(  )
    return self.id_
end

function M:setId( id )
    self.id_ = id
end

function M:getRes(  )
    return self.res_
end

function M:setRes( res )
    self.res_ = res
end

function M:getRankvar(  )
    return self.rankvar_
end

function M:setRankvar( rankvar )
    self.rankvar_ = rankvar
end

function M:getPkdate(  )
    return self.pkdate_
end

function M:setPkdate( pkdate )
    self.pkdate_ = pkdate
end

function M:getPlayers(  )
    return self.players_
end

function M:setPlayers( players )
    self.players_ = players
end

return M