--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

聊天信息实体类

]]

local M = class("EntityChatItem", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "senderId",      		--发送者id
    "senderNickName",      	--发送者昵称
    "vipLevel",      		--vip等级
    "msgId",      			--消息id
    "content",      		--消息内容
    "sendTime",      		--发送时间
    "messageType",      	--消息类型
    "key",                  --标识
    "receiveId",
    "isBigShow",


}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 发送者id
    senderId = { "number", I.UNSET_NUMBER },
    -- 发送者昵称
    senderNickName = { "string", I.UNSET_STRING },
    -- vip等级
    vipLevel = { "number", I.UNSET_NUMBER },
    -- 消息id
    msgId = { "number", I.UNSET_NUMBER },
    -- 消息内容
    content = { "string", I.UNSET_STRING },
    -- 发送时间
    sendTime = { "number", I.UNSET_NUMBER },
    -- 消息类型
    messageType = { "number", I.UNSET_NUMBER },
    -- 标识
    key = { "number", I.UNSET_NUMBER},
    receiveId = { "number", I.UNSET_NUMBER},
    isBigShow = { "number", I.UNSET_NUMBER},

}
 
function M:getSenderId(  )
    return self.senderId_
end

function M:setSenderId( senderId )
    self.senderId_ = senderId
end

function M:getSenderNickName(  )
    return self.senderNickName_
end

function M:setSenderNickName( senderNickName )
    self.senderNickName_ = senderNickName
end

function M:getVipLevel(  )
    return self.vipLevel_
end

function M:setVipLevel( vipLevel )
    self.vipLevel_ = vipLevel
end

function M:getMsgId(  )
    return self.msgId_
end

function M:setMsgId( msgId )
    self.msgId_ = msgId
end

function M:getContent(  )
    return self.content_
end

function M:setContent( content )
    self.content_ = content
end

function M:getSendTime(  )
    return self.sendTime_
end

function M:setSendTime( sendTime )
    self.sendTime_ = sendTime
end

function M:getMessageType(  )
    return self.messageType_
end

function M:setMessageType( messageType )
    self.messageType_ = messageType
end

function M:getKey(  )
    return self.key_
end

function M:setKey( key )
    self.key_ = key
end

function M:getReceiveId(  )
    return self.receiveId_
end

function M:setReceiveId( receiveId )
    self.receiveId_ = receiveId
end
function M:getIsBigShow(  )
    return self.isBigShow_
end

function M:setIsBigShow( isBigShow )
    self.isBigShow_ = isBigShow
end

return M