--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗状态实体类，定义战斗状态实体Entity相关操作方法及逻辑实现。

-   存储战斗状态相关信息。

]]

local M = class("EntityFightState", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
	self:setProperties( properties )
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
	"lv",				-- 等级
	"hp" ,				-- 血量
	"totalcost",		-- 召唤值
	"ccount", 			-- 卡牌上限
	"gcount", 			-- 卡组上限
	"tcount", 			-- 好友上限
	"curexp",			-- 当前经验
	"totalexp", 		-- 总经验值
	"gold" , 			-- 金币
	"diamond",			-- 钻石
	"cursp" ,			-- 当前疲劳
	"mname",			-- 姓名[我]
	"mp",				-- 友情点[我]
	"fname",			-- 姓名[好友]
	"fp",				-- 友情点[好友]

	-- "res",				-- 结果标识
 --    "cards",                -- 类型：EntityCard。   获得卡牌数组，不超过5张
 --    "chips",                -- 类型：EntityChip。   获得碎片数组，不超过5张
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
	-- 等级
	lv 			= { "number", },
	-- 生命
	hp 			= { "number", },
	-- 总召唤值
	totalcost 	= { "number", },
	-- 卡牌上限
	ccount 		= { "number", },
	-- 卡组上限
	gcount 		= { "number", },
	-- 好友上限
	tcount 		= { "number", },
	-- 当前经验
	curexp      = { "number", },
	-- 总经验值
	totalexp 	= { "number", },
	-- 金币
	gold 		= { "number", }, 
	-- 钻石
	diamond		= { "number", },
	-- 当前疲劳值
	cursp 		= { "number", },
	-- 姓名[我]
	mname 		= { "string", },
	-- 友情点[我]
	mp 			= { "number", },
	-- 姓名[好友]
	fname 		= { "string", },
	-- 友情点[好友
	fp 			= { "number", },

	-- -- 结果标识
	-- res 			= { "number", },
 --    -- 卡牌数组，不超过5张
 --    cards       = { "table", M.UNSET_TABLE, PH_EN_FIGHT .. "EntityCard" },
 --    -- 碎片数组，不超过5张
 --    chips       = { "table", M.UNSET_TABLE, PH_EN_FIGHT .. "EntityCard" },
	
}

function M:getLv(  )
    return self.lv_
end

function M:setLv( lv )
    self.lv_ = lv
end

function M:getHp(  )
    return self.hp_
end

function M:setHp( hp )
    self.hp_ = hp
end

function M:getTotalcost(  )
    return self.totalcost_
end

function M:setTotalcost( totalcost )
    self.totalcost_ = totalcost
end

function M:getCcount(  )
    return self.ccount_
end

function M:setCcount( ccount )
    self.ccount_ = ccount
end

function M:getGcount(  )
    return self.gcount_
end

function M:setGcount( gcount )
    self.gcount_ = gcount
end

function M:getTcount(  )
    return self.tcount_
end

function M:setTcount( tcount )
    self.tcount_ = tcount
end

function M:getCurexp(  )
    return self.curexp_
end

function M:setCurexp( curexp )
    self.curexp_ = curexp
end

function M:getTotalexp(  )
    return self.totalexp_
end

function M:setTotalexp( totalexp )
    self.totalexp_ = totalexp
end

function M:getGold(  )
    return self.gold_
end

function M:setGold( gold )
    self.gold_ = gold
end

function M:getDiamond(  )
    return self.diamond_
end

function M:setDiamond( diamond )
    self.diamond_ = diamond
end

function M:getCursp(  )
    return self.cursp_
end

function M:setCursp( cursp )
    self.cursp_ = cursp
end

function M:getMname(  )
    return self.mname_
end

function M:setMname( mname )
    self.mname_ = mname
end

function M:getMp(  )
    return self.mp_
end

function M:setMp( mp )
    self.mp_ = mp
end

function M:getFname(  )
    return self.fname_
end

function M:setFname( fname )
    self.fname_ = fname
end

function M:getFp(  )
    return self.fp_
end

function M:setFp( fp )
    self.fp_ = fp
end

return M