--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

好友信息实体类

]]

local M = class("EntityFriend", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)
local PlayerTalentsEntity = require("model.player.PlayerTalentsEntity")
-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "hero",      	   -- hero实体              (公共)
    "card",			   -- 主卡实体               (公共)
    "afripoint",	   -- 对方是否赠送你友情点数   (好友列表)
    "sfripoint",       -- 你是否可以送对方友情点数 (好友列表)
    "appId",           -- 好友申请id
    "isfriend",        -- 是否好友               (查看玩家详细信息)
    "fPoint",          -- 友情点。
    "status",          -- 状态
    "nextInviteTime",  -- 下次邀请时间 秒 单位
    "talent",          -- 天赋等级
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 人物
    hero = {PH_EN_FIGHT .. "EntityHero"},
    card = {"model.card.CardEntity"},
    
    afripoint   =   {"number", I.UNSET_NUMBER},
    sfripoint   =   {"number", I.UNSET_NUMBER},
    appId       =   {"number", I.UNSET_NUMBER},
    isfriend    =   {"number", I.UNSET_NUMBER},
    fPoint      =   {"number", I.UNSET_NUMBER},
    status      =   {"number", I.UNSET_NUMBER},
    nextInviteTime      =   {"number", I.UNSET_NUMBER},
    talent      =   {"string", I.UNSET_STRING},
}
 
function M:getHero(  )
    return self.hero_
end

function M:setHero( hero )
    self.hero_ = hero
end

function M:getCard( ) return self.card_ end 
function M:setCard(card) self.card_ = card end

function M:getTalent( ) return self.talent_ end 
function M:setTalent(talent) self.talent_ = talent end

function M:getAfripoint( ) return self.afripoint_ end 
function M:setAfripoint(afripoint ) self.afripoint_ = afripoint end

function M:getSfripoint( ) return self.sfripoint_ end 
function M:setSfripoint(sfripoint ) self.sfripoint_ = sfripoint end

function M:getAppId() return self.appId_ end
function M:setAppId(appId) self.appId_ = appId end

function M:getIsfriend() return self.isfriend_ end
function M:setIsfriend(isfriend) self.isfriend_ = isfriend end

function M:getFPoint() return self.fPoint_ end
function M:setFPoint(fPoint) self.fPoint_ = fPoint end

function M:getStatus() return self.status_ end
function M:setStatus(status) self.status_ = status end

function M:getNextInviteTime() return self.nextInviteTime_ end
function M:setNextInviteTime(nextInviteTime) self.nextInviteTime_ = nextInviteTime end


-- 取得天赋实体
function M:getPlayerTalentsEntity( )
    return PlayerTalentsEntity.new{ talent = self:getTalent()}
end

return M
















