--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

	(好友请求)信息实体类，定义英雄基础信息实体Entity相关操作方法及逻辑实现。

-   存储好友请求基础信息相关信息。

]]

local M = class("EntityFriendApplys", BaseEntity)


-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "fcount",		--好友数
    "friends",       --好友请求列表
    "friendapps",       --好友请求列表
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    fcount = { "number"},		--好友数
    friends = {"table", nil,"ccb.m.friend.EntityFriend"},
    friendapps = {"table", nil,"ccb.m.friend.EntityFriend"},
}
 
function M:getFcount() return self.fcount_ end
function M:setFcount(fcount) self.fcount_ = fcount end

function M:getFriends() 
    return self.friends_ or self.friendapps_
end
function M:setFriends(friends) 
    self.friends_ = friends 
    self.friendapps_ = friends 
end


return M