--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

留言信息实体类，定义英雄基础信息实体Entity相关操作方法及逻辑实现。

-   存储留言信息相关信息。

    上周（）完成
]]

local M = class("EntityMessage", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)


-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)

    
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    
    "senderId",
    "senderNickName",
    "receiverId",
    "receiverName",
    "msgId",
    "vipLevel",
    "content",
    "sendTime",
    "messageType",
    "isSucceed",
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 发送者id
    senderId = { "number", I.UNSET_NUMBER },
    -- 发送者昵称
    senderNickName = { "string", I.UNSET_STRING },
    -- 接收者id
    receiverId = { "number", I.UNSET_NUMBER },
    -- 接受者名称
    receiverName = { "string", I.UNSET_STRING },
    -- vip等级
    vipLevel = { "number", I.UNSET_NUMBER },
    -- 消息id
    msgId = { "number", I.UNSET_NUMBER },
    -- 消息内容
    content = { "string", I.UNSET_STRING },
    -- 发送时间
    sendTime = { "number", I.UNSET_NUMBER },
    -- 消息类型
    messageType = { "number", I.UNSET_NUMBER },
    -- 是否成功
    isSucceed = { "number", I.UNSET_NUMBER },

}










-- [Gettor/Settor方法]
-- 发送者id
function M:getSenderId()
    return self.senderId_
end
function M:setSenderId(newKey)
    self.senderId_ = newKey
end

-- 发送者昵称
function M:getSenderNickName()
    return self.senderNickName_
end
function M:setSenderNickName(newKey)
    self.senderNickName_ = newKey
end

-- 接收者id
function M:getReceiverId()
    return self.receiverId_
end
function M:setReceiverId(newKey)
    self.receiverId_ = newKey
end

-- 接受者名称
function M:getReceiverName()
    return self.receiverName_
end
function M:setReceiverName(newKey)
    self.receiverName_ = newKey
end

-- vip等级
function M:getVipLevel()
    return self.vipLevel_
end
function M:setVipLevel(newKey)
    self.vipLevel_ = newKey
end

-- 消息id
function M:getMsgId()
    return self.msgId_
end
function M:setMsgId(newKey)
    self.msgId_ = newKey
end

-- 消息内容
function M:getContent()
    return self.content_
end
function M:setContent(newKey)
    self.content_ = newKey
end

-- 发送时间
function M:getSendTime()
    return self.sendTime_
end
function M:setSendTime(newKey)
    self.sendTime_ = newKey
end

-- 消息类型
function M:getMessageType()
    return self.messageType_
end
function M:setMessageType(newKey)
    self.messageType_ = newKey
end

-- 是否成功
function M:getIsSucceed()
    return self.isSucceed_
end
function M:setIsSucceed(newKey)
    self.isSucceed_ = newKey
end



return M