--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

信息实体类，定义英雄基础信息实体Entity相关操作方法及逻辑实现。

-   存储基础信息相关信息。

]]

local M = class("EntityTalks", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)


-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
	
    "senderId",
	"senderNickName",
	"isSucceed",
	"isnew",
	"uptime",
	"content",
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    
     -- 发送者id
    senderId = { "number", I.UNSET_NUMBER },
    -- 发送者昵称
    senderNickName = { "string", I.UNSET_STRING },
    -- 上一条消息是否发生成功
    isSucceed = { "number", I.UNSET_NUMBER },
    -- 是否最新
    isnew = { "number", I.UNSET_NUMBER },
    -- 更新时间
    uptime = { "number", I.UNSET_NUMBER },
    -- 最后一条消息
    content = { "string", I.UNSET_STRING },
    
}
 
function M:getSenderId() return self.senderId_ end
function M:setSenderId(senderId) self.senderId_ = senderId end

function M:getSenderNickName() return self.senderNickName_ end
function M:setSenderNickName(senderNickName) self.senderNickName_ = senderNickName end

function M:getIsSucceed() return self.isSucceed_ end
function M:setIsSucceed(isSucceed) self.isSucceed_ = isSucceed end

function M:getIsnew() return self.isnew_ end
function M:setIsnew(isnew) self.isnew_ = isnew end

function M:getUptime() return self.uptime_ end
function M:setUptime(uptime) self.uptime_ = uptime end

function M:getContent() return self.content_ end
function M:setContent(content) self.content_ = content end



return M