--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

商品实体类
MSG_GET_IAPLIST
{
    "iaps"
    [   
        {
            "id"    //string
            "kind"   //类型 number   91 当乐  云顶...
            "desc1":"", //说明 strin
            "desc2":"", //说明 string
            "btnStr": //按钮文字
            "statuspic":"" //商品标签图片 string
            "pic"  图片
        },
        ...
    ]
}
]]

local M = class("EntityIap", BaseEntity) 

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    
    "kind", --//标题 string
    "titlepic", --//title图片 
    "pic"  ,    --图片 string
    "desc1",    --//说明 string 10个字以内
    "btnstring",--//按钮文字 string
    "desc2",    --//说明 string
    "statuspic",--//商品标签图片 string
    "id",       --//string
    "price",    --//价格
    "iapproductid" --string  iapid
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    
    kind    =   {"number"},
    price    =   {"number"},
    titlepic = {"string"},
    pic    =   {"string"},
    desc1    =   {"string"},
    btnstring    =   {"string"},
    desc2    =   {"string"},
    statuspic    =   {"string"},
    id = {"string"},
    iapproductid = {"string"}
}





function M:getKind()
    return self.kind_
end
function M:setKind(newKey)
    self.kind_ = newKey
end

function M:getPrice()
    return self.price_
end
function M:setPrice(newKey)
    self.price_ = newKey
end

function M:getTitlepic()
    return self.titlepic_
end
function M:setTitlepic(newKey)
    self.titlepic_ = newKey
end

function M:getPic()
    return self.pic_
end
function M:setPic(newKey)
    self.pic_ = newKey
end

function M:getDesc1()
    return self.desc1_
end
function M:setDesc1(newKey)
    self.desc1_ = newKey
end

function M:getBtnstring()
    return self.btnstring_
end
function M:setBtnstring(newKey)
    self.btnstring_ = newKey
end

function M:getDesc2()
    return self.desc2_
end
function M:setDesc2(newKey)
    self.desc2_ = newKey
end

function M:getStatuspic()
    return self.statuspic_
end
function M:setStatuspic(newKey)
    self.statuspic_ = newKey
end

function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

function M:getIapproductid()
    return self.iapproductid_
end
function M:setIapproductid(newKey)
    self.iapproductid_ = newKey
end




return M