--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

商品实体类

]]

local M = class("EntityShop", BaseEntity) 

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "titlepic", --//title图片 
    "title",	--//标题 string
    "pic"  ,    --图片 string
    "desc1",    --//说明 string 10个字以内
    "btnstring",--//按钮文字 string
    "desc2",    --//说明 string
    "statuspic",--//商品标签图片 string
    "id",       --//购买选项id number
    "costvalue",
    "memo",
    "shoptype"
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    titlepic = {"string"},
    title    =   {"string"},
    costvalue    =   {"number"},
    pic    =   {"string"},
    desc1    =   {"string"},
    btnstring    =   {"string"},
    desc2    =   {"string"},
    statuspic    =   {"string"},
    id = {"number"},
    memo = {"string"},
    shoptype = {"number"}
}

function M:getShoptype(  )
    return self.shoptype_
end
function M:setShoptype( newkey )
    self.shoptype_ = newkey
end
 

function M:getMemo(  )
    return self.memo_
end
function M:setMemo( memo )
    self.memo_ = memo
end

function M:getTitlepic(  )
    return self.titlepic_
end
function M:setTitlepic( titlepic )
    self.titlepic_ = titlepic
end

function M:getCostvalue(  )
    return self.costvalue_
end
function M:setCostvalue( costvalue )
    self.costvalue_ = costvalue
end

function M:getTitle(  )
    return self.title_
end
function M:setTitle(  )
    self.title_ = title
end

function M:getPic(  )
    return self.pic_
end
function M:setPic( pic )
    self.pic_ = pic
end

function M:getDesc1(  )
    return self.desc1_
end
function M:setDesc1( desc1 )
    self.desc1 = desc1
end

function M:getBtnstring(  )
    return self.btnstring_
end
function M:setBtnstring( btnstring )
    self.btnstring_ = btnstring
end

function M:getDesc2(  )
    return self.desc2_
end
function M:setDesc2( desc2 )
    self.desc2 = desc2
end

function M:getStatuspic(  )
    return self.statuspic_
end
function M:setStatuspic(statuspic  )
    self.statuspic_ = statuspic
end

function M:getId(  )
    return self.id_
end
function M:setId( id )
    self.id_ = id
end



return M