local ShopModel = {}
local entityShops = require("ccb.m.shop.EntityShops")
local entityCards = require("ccb.m.shop.EntityShopCards")
local entityIaps = require("ccb.m.shop.EntityIaps")
local entitySDKIap = require("ccb.m.shop.EntitySDKIap")
local goodsEntity = require("model.goods.GoodsEntity")
local CardEntity = require("model.card.CardEntity")
--//MSG_GET_SHOPLIST 进入商店页面 6001
function ShopModel.getShops( params )
	-- print("methodId",params.methodId)
	if not params then params = {} end

    local function callBackMethos(  properties, param )
    
        if properties then
            properties  = entityShops.new(properties)
            --回调
            params.callback(properties,param)
        else
            -- print("err")
        end
    end
    NetHelper.showLoading(true)
     NetHelper.createRequest(
            params.methodId,  -- 请求id
            callBackMethos ,        -- 回调函数
            params.args   ,             -- 请求实体
            {
                cbParams = params,                 -- 回调参数
                showLoading = true             -- 回调参数
            }
    )
end

function ShopModel.getBuyShop( params )
    if not params then params = {} end

    local function callBackMethos(  properties, param )
        if properties then
            
            local newS = properties['newcards']
            

            -- if newS[1]['id'] > 10000 and newS[1]['id'] < 20000 then
            --     local info = ''
            --     for i = 1, #newS do
            --         local goodentity = goodsEntity.new{ no = newS[i]['id'] }
                    
            --         info = info..goodentity:getName().."("..goodentity:getDetails()..")"
            --     end
            --     params.callback(info,param)
            -- else
            --     properties  = entityCards.new(properties)
            --     --回调
            --     params.callback(properties,param)
            -- end
            if properties.typ == 7 then
                -- 卡牌
                properties  = entityCards.new(properties)
                -- properties  = entityCards.new{id = newS[i]['no']}
                local newCards = {}
                for i = 1, #newS do
                    -- local cardEntity = CardEntity.new{id = newS[i]['no']}
                    newCards[i] = CardEntity.new{id = newS[i]['no']}
                end
                properties:setNewcards(newCards)
                --回调
                params.callback(properties,param)
            elseif properties.typ == 9 then
                -- 卡牌
                properties  = entityCards.new(properties)
                -- properties  = entityCards.new{id = newS[i]['no']}
                local newCards = {}
                for i = 1, #newS do
                    -- local cardEntity = CardEntity.new{id = newS[i]['no']}
                    if newS[i]['no'] < 10000 then
                        newCards[i] = CardEntity.new{id = newS[i]['no']}
                    else
                        newCards[i] = goodsEntity.new(newS[i])
                    end
                end
                properties:setNewcards(newCards)
                --回调
                params.callback(properties,param)
            else
                -- 物品
                local info = ''
                for i = 1, #newS do
                    -- local goodentity = properties['newcards']
                    local goodentity = goodsEntity.new(newS[i])
                    info = info..goodentity:getName().."("..goodentity:getDetails()..")"
                end
                params.callback(info, param)
            end

        else
            -- print("err")
        end
    end
    NetHelper.showLoading(true)
    NetHelper.createRequest(
            params.methodId,  -- 请求id
            callBackMethos ,        -- 回调函数
            params.args   ,             -- 请求实体
            {
                cbParams = params,            -- 回调参数
                 showLoading = true
            }
    )
end

function ShopModel.getIapList( params )
    if not params then params = {} end

    local function callBackMethos(  properties, param )
        if properties then
            local reward = properties.reward
            local rewardEntity = require("model.main.RewardEntity").new(reward)
            properties  = entityIaps.new(properties)
            properties:setReward(rewardEntity)
            --回调
            params.callback(properties,param)
        else
        end
    end
    NetHelper.showLoading(true)
    NetHelper.createRequest(
            params.methodId,  -- 请求id
            callBackMethos ,        -- 回调函数
            params.args   ,             -- 请求实体
            {
                cbParams = params ,               -- 回调参数
                showLoading = true
            }
    )
end

--获取购买单号
function ShopModel.getSDKIapApporderCode( params )
    if not params then params = {} end

    local function callBackMethos(  properties, param )
        if properties then
            properties  = entitySDKIap.new(properties)        
            --回调
            params.callback(properties,param)
        else
        end
    end
    
    NetHelper.showLoading(true,true)
    NetHelper.createRequest(
            params.methodId,  -- 请求id
            callBackMethos ,        -- 回调函数
            params.args   ,             -- 请求实体
            {
                cbParams = params  ,             -- 回调参数
                showLoading = false
            }
    )
end
-- 获取星星商店商品
function ShopModel.fetchStarShopList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_STAR_SHOPLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 星星商店购买
function ShopModel.fetchBuyStarShop( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_BUY_STAR_SHOP , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
-- 获取物品商店商品
function ShopModel.fetchGoodsShopList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_DIA_SHOPLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 物品商店购买
function ShopModel.fetchBuyGoodsShop( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_BUY_DIA_SHOP , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
-- 神秘商店列表
function ShopModel.fetchMysteryShopList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_MYSTERY_SHOPLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
-- 购买神秘商店
function ShopModel.fetchMysteryShop( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_BUY_MYSTERY_SHOPLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
return ShopModel