--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

留言信息实体类，定义英雄基础信息实体Entity相关操作方法及逻辑实现。

-   存储留言信息相关信息。

	上周（）完成
]]

local M = class("EntityMessage", BaseEntity)


-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    
	-- "id"		--留言id	  (系统邮件／留言)
	"content",	--内容	  (系统邮件／留言)
	"isnew",	--是否是新消息 (系统邮件／留言)
	"date",		--时间	  (系统邮件／留言)
			
    "hero",		--玩家实体 (玩家留言)
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    content = { "string" },
    isnew	= { "number" },
    date 	= { "number" },
    hero 	= { "ccb.m.friend.EntityFriend" },	--好友实体
}
 


function M:getContent(  )
    return self.content_
end
function M:setContent( content )
    self.content_ = content
end



function M:getIsnew(  )
    return self.isnew_
end
function M:setIsnew( isnew )
    self.isnew_ = isnew
end



function M:getDate(  )
    return self.date_
end
function M:setDate( date )
    self.date_ = date
end



function M:getHero(  )
    return self.hero_
end
function M:setHero( hero )
    self.hero_ = hero
end



return M