--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

更新信息实体类

]]

local M = class("VerUpdateEntity", BaseEntity)
local I = require(PH_EN_I .. NAM_CONSTANT)

-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)
end


-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "ver",      		  --版本号
    "desc",      	      --更新描述
    "url",      		  --更新地址
    "adddate",      	  --时间
    "md5",      		  --校验码
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 版本号
    ver = { "string", I.UNSET_STRING },
    -- 更新描述
    desc = { "string", I.UNSET_STRING },
    -- 更新地址
    url = { "string", I.UNSET_STRING },
    -- 时间
    adddate = { "string", I.UNSET_STRING },
    -- 校验码
    md5 = { "string", I.UNSET_STRING },
}
 


function M:getVer(  )
    return self.ver_
end
function M:setVer( ver )
    self.ver_ = ver
end



function M:getDesc(  )
    return self.desc_
end
function M:setDesc( desc )
    self.desc_ = desc
end



function M:getUrl(  )
    return self.url_
end
function M:setUrl( url )
    self.url_ = url
end



function M:getAdddate(  )
    return self.adddate_
end
function M:setAdddate( adddate )
    self.adddate_ = adddate
end



function M:getMd5(  )
    return self.md5_
end
function M:setMd5( md5 )
    self.md5_ = md5
end


return M