--ActivityChargeListLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityChargeListLayerView]"
	local _node, _nodeTable = node, luaValue
    local RewardEntity = require("model.main.RewardEntity")
    local _atype = luaValue._ATYPE
    local _activityGrid
    local _btnSacrifice
    local _contentOffset
    local _openTime
    local _rewardTime
    local BUTTON_STATUS = {
        [0] = {text = _s("ACTIVITY_CHARGE_CANNOT_RECEIVE")}, -- 未达到
        [1] = {text = _s("ACTIVITY_CHARGE_RECEIVE")}, -- 可领取
        [2] = {text = _s("ACTIVITY_CHARGE_ALREADY_RECEIVE")}, -- 已领取
        [3] = {text = ""}, -- 可补领
    }
    local ACTIVITY_ATYPE = {
        [99997] = {cur = _s("ACTIVITY_WORSHIP_CUR"), content = _s("ACTIVITY_WORSHIP"), tip = _s("ACTIVITY_WORSHIP_TIP"), titleBtnTitle = _s("ACTIVITY_SACRIFICE"), visibleBtn = false, showCount = false},
        [99996] = {cur = _s("ACTIVITY_KILL_BUG_CUR"), content = _s("ACTIVITY_KILL_BUG"), tip = _s("ACTIVITY_KILL_BUG_TIP"), titleBtnTitle = _s("REWARD_JOIN"), visibleBtn = true, showCount = false},
        [99995] = {cur = _s("ACTIVITY_LIMIT_TIME_LOGIN_CUR"), content = _s("ACTIVITY_LIMIT_TIME_LOGIN"), tip = _s("ACTIVITY_LIMIT_TIME_LOGIN_TIP"), titleBtnTitle = _s("ACTIVITY_BUY_DIAMOND"), visibleBtn = false, showCount = false},
        [99994] = {cur = _s("ACTIVITY_ONE_DAY_COST_CUR"), content = _s("ACTIVITY_ONE_DAY_COST"), tip = _s("ACTIVITY_ONE_DAY_COST_TIP"), titleBtnTitle = _s("ACTIVITY_TO_SHOPPING"), visibleBtn = true, showCount = false},
        [99993] = {cur = _s("ACTIVITY_ONE_DAY_CHARGE_CUR"), content = _s("ACTIVITY_ONE_DAY_CHARGE"), tip = _s("ACTIVITY_ONE_DAY_CHARGE_TIP"), titleBtnTitle = _s("ACTIVITY_BUY_DIAMOND"), visibleBtn = true, showCount = false},
        [99990] = {cur = _s("ACTIVITY_LIMIT_TIME_CHARGE_CUR"), content = _s("ACTIVITY_LIMIT_TIME_CHARGE"), tip = _s("ACTIVITY_LIMIT_TIME_CHARGE_TIP"), titleBtnTitle = _s("ACTIVITY_BUY_DIAMOND"), visibleBtn = true, showCount = false},
        [99992] = {cur = _s("ACTIVITY_SINGLE_CHARGE_CUR"), content = _s("ACTIVITY_SINGLE_CHARGE"), tip = _s("ACTIVITY_SINGLE_CHARGE_TIP"), titleBtnTitle = _s("ACTIVITY_BUY_DIAMOND"), visibleBtn = true, showCount = true},
        [99991] = {cur = _s("ACTIVITY_LIMIT_TIME_COST_CUR"), content = _s("ACTIVITY_LIMIT_TIME_COST"), tip = _s("ACTIVITY_LIMIT_TIME_COST_TIP"), titleBtnTitle = _s("ACTIVITY_TO_SHOPPING"), visibleBtn = true, showCount = false},
        [99998] = {cur = _s("ACTIVITY_DAILY_EXPENSE_CUR"), content = _s("ACTIVITY_DAILY_EXPENSE"), tip = _s("ACTIVITY_DAILY_EXPENSE_TIP"), titleBtnTitle = _s("ACTIVITY_DAILY_EXPENSE_BTN"), visibleBtn = true, showCount = false},
        [99989] = {cur = _s("ACTIVITY_DAILY_DIAMOND_CUR"), content = _s("ACTIVITY_DAILY_DIAMOND_CUR"), tip = _s("ACTIVITY_DAILY_DIAMOND_TIP"), titleBtnTitle = _s("ACTIVITY_DAILY_EXPENSE_BTN"), visibleBtn = false, showCount = false},
    }
--[[ ## local fuction --]]
    local function createRewardGrid( node )
        local touchNode = CCBCenter.getNodeByTag(_node, 202)
        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- 奖励
            cell:addChild(item)
            util.alignNode(item, cell)
            return cell
        end
        local function onBtnClick(grid, index, item, x, y)
            if not util.isPointInNode(touchNode, x, y) then 
                return
            end
            if item:getType() == RewardEntity.REWARD_TYPE.CARD or item:getType() == RewardEntity.REWARD_TYPE.CHIP then
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item:getEntity())
            elseif item:getType() == RewardEntity.REWARD_TYPE.GOODS then
                if item:getEntity():getNo() > 20000 then
                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item:getEntity())
                else
                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item:getEntity())
                end
            end
        end
        local scrollGrid = widget.newScrollGrid{
            contentSize = node:getContentSize(),
            contentParams = {
                cellSize = CCSize( 91, node:getContentSize().height),
                row = 1,
                createItemCellListener = createItemCellListener,
                tapListener = onBtnClick,
                padding = {middleH = 2,},
                container = CCBCenter.getNodeByTag(_node, 202),
            },
            direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
            parentNode = node,
        }
        -- node:addChild(scrollGrid)
        return scrollGrid
    end
    local function createActivityList( )
        local node = CCBCenter.getNodeByTag(_node, 202)
        node:removeAllChildrenWithCleanup(true)
        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- 背景
            local bgSprite = widget.newScale9{
                file = "main/activity/bg_content_list_cell.png",
                rect = CCRect(0, 0, 221, 130),
                contentSize = grid:getCellSize(),--CCSizeAdd(grid:getCellSize(), 0, -20) ,
            }
            cell:addChild(bgSprite, 0)
            util.alignNode(bgSprite, cell)
            -- 说明
            local tipText
            if 99996 == _atype then
                tipText = _s(ACTIVITY_ATYPE[_atype].tip, CardDB.getByID(item.tag).name, item.target)
            elseif 99998 == _atype then
                tipText = _s(ACTIVITY_ATYPE[_atype].tip, item.targetDay, item.targetExpense)
            elseif 99989 == _atype then
                tipText = _s(ACTIVITY_ATYPE[_atype].tip)
            else
                tipText = _s(ACTIVITY_ATYPE[_atype].tip, item.tag)
            end
            local tipNode = widget.newNode{contentSize = CCSize(730, 30)}
            cell:addChild(tipNode, 1)
            util.alignNode(tipNode, cell, display.LEFT_TOP, {top = 10, left = 20})
            local bgTip = widget.newScale9{file = "main/activity/bg_content_list_cell_title.png", contentSize = CCSize(730, 30)}
            tipNode:addChild(bgTip, 0)
            util.alignNode(bgTip, tipNode)
            if 99989 == _atype then
                -- 开启时间
                _openTime = CountDownView.new{ 
                    format = tipText,
                    labelParams = {color = BUTTON_COLOR3.BROWN,size = 18,textValign},
                    listener = function()
                        if item.joindStatus == 0 then

                            CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
                           -- item.joindStatus = 1
                        end
                    end
                }
                util.alignNode(_openTime, tipNode)
                tipNode:addChild(_openTime)

                
                _openTime:start(item.openTime)

                 -- 奖励时间
                _rewardTime = CountDownView.new{ 
                    format = _s("ACTIVITY_DAILY_DIAMOND_WAIT"),
                    labelParams = {color = BUTTON_COLOR3.BLUE,size = 30,textValign},
                    listener = function()
                        if item.rewardStatus == 3 and item.joindStatus == 2 then

                            CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYLIST)
                        end
                    end
                }
                util.alignNode(_rewardTime, cell)
                cell:addChild(_rewardTime)

                
                _rewardTime:start(item.rewardTime)
            
            else
                local tipLabel = ui.newTTFLabel{text = tipText, size = 18, color = BUTTON_COLOR3.BROWN}
                tipNode:addChild(tipLabel, 1)
                util.alignNode(tipLabel, tipNode)
                -- 次数说明
            end
            
            if ACTIVITY_ATYPE[_atype].showCount and item.count then
                local countLabel = ui.newTTFLabel{text = _s("ACTIVITY_RECEIVE_COUNT", item.count), color = BUTTON_COLOR3.BROWN, size = 18}
                cell:addChild(countLabel, 3)
                util.alignNode(countLabel, cell, display.CENTER_BOTTOM, {left = - 300, bottom = 86})
            end
            -- 奖励
            local rewardNode = widget.newNode{contentSize = CCSize(592, 91)}
            cell:addChild(rewardNode, 1)
            util.alignNode(rewardNode, cell, display.LEFT_BOTTOM, 20)
            local rewardGrid = createRewardGrid(rewardNode)
            local rewardEntity = RewardEntity.new(item.reward)
            rewardGrid:setItems(rewardEntity:getRewardViews())

            local btnText  = ""
            if 99989 == _atype then
                btnText = BUTTON_STATUS[item.rewardStatus].text
            else
                btnText = BUTTON_STATUS[item.status].text
            end

            -- 按钮
            local btnReward = widget.newButton{
                contentSize = CCSize(200, 60),
                rect = CCRect(0, 0, 80, 58),
                labelParams = {text = btnText, size = 26, color = BUTTON_COLOR3.BROWN},
                normalImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                scale = 1.1,
                listener = function ( button )
                    if item.status == 3 and item.needdia and ME:getDiamond() < item.needdia then
                        NetHelper.QuickToast(_s("ACTIVITY_DIAMOND_NOT_ENOUGH", item.needdia))
                        return
                    end
                    _contentOffset = _activityGrid:getContentOffset()
                    if 99998 == _atype then
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYREWARD, nil, {targetDay = item.targetDay})
                    elseif 99989 == _atype then
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYREWARD, nil, {index = item.index})
                    else
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHACTIVITYREWARD, nil, {tag = item.tag, target = item.target})
                    end
                end,
            }
            cell:addChild(btnReward, 2)
            util.alignNode(btnReward, cell, display.CENTER_BOTTOM, {left = - 300, bottom = 20})
            
            -- 0 未达到 1 可领取 2 已领取 3 可补领
            if 99989 == _atype then
                btnReward:setScale(0.8)
                util.alignNode(btnReward, cell, display.CENTER_BOTTOM, {left = - 300, bottom = 10})
                if 0 == item.rewardStatus or 2 == item.rewardStatus then
                    btnReward.setStateDisabled(true)                  
                end
                if 3 == item.rewardStatus then
                    btnReward.setStateDisabled(true)
                    btnReward.setTextString(_s("ACTIVITY_DAILY_DIAMOND_JOINING"))
                end

                -- 按钮
                local btnJoin = widget.newButton{
                    contentSize = CCSize(200, 60),
                    rect = CCRect(0, 0, 80, 58),
                    labelParams = {text = _s("ACTIVITY_DAILY_DIAMOND_JOIN"), size = 26, color = BUTTON_COLOR3.BROWN},
                    normalImage = "common/buttons/btn_normal_yellow.png",
                    disableImage = "common/buttons/btn_normal_gray.png",
                    scale = 1.1,
                    listener = function ( button )
                         CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHJOIN, nil, {index = item.index})
                    end,
                }
                cell:addChild(btnJoin, 2)
                btnJoin:setScale(0.8)

                util.alignNode(btnJoin, cell, display.CENTER_BOTTOM,{left = - 300, bottom = 60})--_TOP, {left = - 300, top = 10}
                btnJoin.setStateDisabled(true)

                if 1 == item.joindStatus then

                    btnJoin.setStateDisabled(false)
                end
            else

                if 0 == item.status or 2 == item.status then
                    btnReward.setStateDisabled(true)
                elseif 3 == item.status and item.needdia then
                    
                    local diamondSprite = widget.newSprite{file = "main/img_sign_diamond.png"}
                    diamondSprite:setScale(0.8)
                    local diamondLabel = ui.newTTFLabel{text = _s("ACTIVITY_CHARGE_ADD_RECEIVE", item.needdia), color = BUTTON_COLOR3.BROWN}
                    local diamondNode = widget.newNode{color = ccc4(255, 255, 255, 100), contentSize = CCSizeAdd(diamondLabel:getContentSize(), diamondSprite:getContentSize().width - 16, 0)}
                    diamondNode:addChild(diamondSprite)
                    util.alignNode(diamondSprite, diamondNode, display.LEFT_CENTER)
                    diamondNode:addChild(diamondLabel)
                    util.alignNode(diamondLabel, diamondNode, display.RIGHT_CENTER)
                    btnReward:addChild(diamondNode, 10)
                    -- diamondNode:setPosition(ccp(0, 0))
                    -- diamondNode:setAnchorPoint(ccp(0.5, 0.5))
                    util.alignNode(diamondNode, btnReward)
                end
            end

            return cell
        end
        local scrollGrid = widget.newScrollGrid{
            contentSize = node:getContentSize(),
            contentParams = {
                cellSize = CCSize( node:getContentSize().width, 156),
                column = 1,
                createItemCellListener = createItemCellListener,
                container = node,
                -- tapListener = onBtnClick,
                padding = {middleV = 2,}
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = node,
        }
        -- node:addChild(scrollGrid)
        return scrollGrid
    end
    local function updateText( data )
        local showstr = _s("ACTIVITY_CHARGE_DATE", data.showstr)
        local content = _s("ACTIVITY_CONTENT_TITLE", ACTIVITY_ATYPE[_atype].content)
        local curval = data.curval
        if 99996 == _atype then
            local cardTable = string.split(curval, ",") 
            local hitCount, cardName
            local contentStr = ""
            local curStr = ""
            for i, card in ipairs(cardTable) do
                if card and card ~= "" then
                    card = string.split(card, ":")
                    cardName = CardDB.getByID(card[1]).name
                    if not string.find(contentStr, cardName) then
                        contentStr = contentStr .. cardName .. " "
                    end
                    hitCount = card[2]
                    curval = curStr .. _s("ACTIVITY_KILL_BUG_CUR_FORMAT", cardName, hitCount)
                    if i < #cardTable then curval = curval .. "," end
                end
            end
            content = _s("ACTIVITY_CONTENT_TITLE", string.format(content, contentStr))
            _nodeTable["mTTFLabel3"]:setString(_s(ACTIVITY_ATYPE[_atype].cur, curval))
        elseif 99998 == _atype then

            showstr = _s("ACTIVITY_CHARGE_DATE", data.activityTime)
            content = _s("ACTIVITY_CONTENT_TITLE", string.format(content, data.totalTargetExpense))
            _nodeTable["mTTFLabel3"]:setString(_s(ACTIVITY_ATYPE[_atype].cur, data.curExpenseDay,data.totalTargetExpense,curval))
        elseif 99989 == _atype then
            showstr = _s("ACTIVITY_DAILY_DIAMOND_CUR",data.publishTime)
            content = _s("ACTIVITY_DAILY_DIAMOND",data.rewardTime)
            _nodeTable["mTTFLabel3"]:setString(_s("ACTIVITY_DAILY_DIAMOND_TITLE", data.activityTime))
        else
            _nodeTable["mTTFLabel3"]:setString(_s(ACTIVITY_ATYPE[_atype].cur, curval))
        end
        _nodeTable["mTTFLabel1"]:setString(showstr)
        _nodeTable["mTTFLabel2"]:setString(content)
        
    end
    -- 献祭按钮
    local function createBtnSacrifice( )
        local price = 0
        local btnSacrifice = widget.newButton{
            normalImage = "main/effect_buttons/bg_main_activity.png",
            contentSize = CCSize(109, 71),
            scale = 1.1,
            listener = function ( buttons )
                local function sendSacrifice_( )
                    _contentOffset = _activityGrid:getContentOffset()
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYCHARGELISTLAYER_ACTION_ONFETCHSACRIFICE)
                end
                if price == 0 then
                    sendSacrifice_()
                elseif price > ME:getDiamond() then
                    NetHelper.QuickToast(_s("ACTIVITY_DIAMOND_NOT_ENOUGH", price))
                else
                    AlertLayer.new4IAP{
                        isUserDiamond = true,
                        diamondIndex = 22,
                        titleStr    = _s("COMMON_NEWS_TIPS"), 
                        content = _s("USE_DIAMOND_22", price),     -- 内容
                        btnClickEvent = {
                            function ( )
                                sendSacrifice_()
                            end,
                        }
                    }
                end
            end,
        }
        local sacrificeLabel = ui.newTTFLabel{
            text = _s("ACTIVITY_SACRIFICE"),
            size = 22,
            color = BUTTON_COLOR3.BROWN,
        }
        btnSacrifice:addChild(sacrificeLabel, 10)
        util.alignNode(sacrificeLabel, btnSacrifice, display.TOP_CENTER, 6)
        local diamondLabel = ui.newTTFLabel{
            text = "",
            size = 18,
            color = BUTTON_COLOR3.BROWN,
        }
        local diamondNode = widget.newLinearLabel{
            paramTable = {"main/img_main_diamond.png", diamondLabel},
            padding = 6,
        }
        btnSacrifice:addChild(diamondNode, 10)
        util.alignNode(diamondNode, btnSacrifice, display.BOTTOM_CENTER, 6)
        function btnSacrifice:setPrice( text )
            price = text
            if text == 0 then text = _s("MINE_FREE") end
            diamondLabel:setString(text)
            diamondNode:refresh()
        end
        local node = CCBCenter.getNodeByTag(_node, 1)
        node:addChild(btnSacrifice, 10)
        util.alignNode(btnSacrifice, node, display.RIGHT_CENTER, 10)
        return btnSacrifice
    end
	local function initViews()
		_activityGrid = createActivityList( )
        -- _activityGrid:setItems{{},{},{},{},{}}
        _nodeTable["btnBuyDiamond"]:setVisible(ACTIVITY_ATYPE[_atype].visibleBtn)
        _node:setButtonTitle( "btnBuyDiamond", ACTIVITY_ATYPE[_atype].titleBtnTitle)
        if 99997 == _atype then
            _btnSacrifice = createBtnSacrifice()
        end
	end

--[[ ## public fuction --]]
    local function updateData( data )
        -- 献祭价格
        if 99997 == _atype then
            _btnSacrifice:setPrice(data.price)
        end
            -- data = {
            --     showstr = "活动" .. luaValue._ATYPE, -- 文字
            --     curval = 1000, -- 符合笔数
            -- }
        -- data = {
        --     showstr = "活动" .. luaValue._ATYPE, -- 文字
            -- data.curval = 1000, -- 符合笔数
            -- data.lst = {
            --     {
            --         tag = 1, -- 目标值
            --         target = 100,
            --         status = 0, -- 状态 0 不可领 1 可领取 2 已领取 3 今天已领取
            --         needdia = 100, -- 补领钻石
            --         reward = {gold = 100, brlist = {{no = 31, count = 1}, {no = 32, count = 1}, {no = 33, count = 1}, {no = 34, count = 1},{no = 35, count = 1},{no = 36, count = 1},{no = 37, count = 1},{no = 38, count = 1},{no = 39, count = 1},},}, -- 奖励
            --     },
            --     {
            --         tag = 2, -- 目标值
            --         target = 100,
            --         status = 1, -- 状态 0 不可领 1 可领取 2 已领取 3 今天已领取
            --         needdia = 101, -- 补领钻石
            --         reward = {diamond = 100, brlist = {{no = 21, count = 1}, {no = 22, count = 1}, {no = 23, count = 1}, {no = 24, count = 1},{no = 25, count = 1},},}, -- 奖励
            --     },
            --     {
            --         tag = 3, -- 目标值
            --         target = 100,
            --         status = 2, -- 状态 0 不可领 1 可领取 2 已领取 3 今天已领取
            --         needdia = 102, -- 补领钻石
            --         reward = {sp = 100, brlist = {{no = 10, count = 1}, {no = 12, count = 1}, {no = 13, count = 1}, {no = 14, count = 1},{no = 15, count = 1},},}, -- 奖励
            --     },
            --     {
            --         tag = 4, -- 目标值
            --         target = 100,
            --         status = 3, -- 状态 0 不可领 1 可领取 2 已领取 3 今天已领取
            --         needdia = 999, -- 补领钻石
            --         reward = {brlist = {{no = 1, count = 1}, {no = 2, count = 1}, {no = 3, count = 1}, {no = 4, count = 1},{no = 5, count = 1},},}, -- 奖励
            --     },
            -- }
        -- }
        _activityGrid:setItems(data.lst)
        if _contentOffset then
            _activityGrid:setContentOffset(_contentOffset)
        end
        updateText(data)
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData = updateData
end

return M