--ActivityJumpPageLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityJumpPageLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = _node._DATA
    local _scrollView
--[[ ## local fuction --]]
    local function fillInfo( info )
        _nodeTable.mTitleLabel:setString(info.title)
        local textLabel = ui.newTTFLabel{text = "" , color = BUTTON_COLOR3.BROWN, size = 20}
        local size = _scrollView:getContentSize()
        textLabel:setDimensions(CCSize(size.width, 0))
        textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
        textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
        textLabel:setString(info.detail)
        _scrollView:setContainer(textLabel)
        _scrollView:updateInset()
        util.autoFixScrollView(_scrollView)
    end
	local function createScrollView( )
        local layer = CCBCenter.getNodeByTag(_node, 102)
        local scrollView = widget.newScrollView{
            -- bounceable = false, 
            contentSize = layer:getContentSize(), 
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL, 
        }
        layer:addChild(scrollView)
        return scrollView
    end

    local function initViews()
        _scrollView = createScrollView( )
        if _data then
            fillInfo(_data)
        end
    end

--[[ ## public fuction --]]
    local function jumpToPage( )
        -- MSG_MAINACTIVITYLAYER_MODEL,ccb.c.main.MainActivityLayer,selectAtype:99990
        local function resolveData_( content )
            local msgid, path, param
            param = {}
            local contentString = string.split(content, ",")
            for i, v in ipairs(contentString) do
                if string.find(v, ":") then
                    local kv = string.split(v, ":")
                    param[kv[1]] = kv[2]
                elseif not msgid then
                    msgid = v
                elseif not path then
                    path = v
                end
            end
            return msgid, path, param
        end
        content = _data.content
        if content then
            local msgid, path, param = resolveData_(content)
            CCBCenter.loadCCB(msgid, path, param)
        end
    end
--[[ ## MAINs --]]
	initViews()
    _node.jumpToPage = jumpToPage 
end

return M