--ActivityMonthCardLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityMonthCardLayerView]"
	local _node, _nodeTable = node, luaValue
    local _btnReceive
    local _data
    local BUTTON_STATUS = {
        [0] = {text = _s("REWARD_NOT_RECEIVE"), disable = true},
        [1] = {text = _s("REWARD_RECEIVE"), disable = false},
        [2] = {text = _s("REWARD_ALREADY_RECEIVE"), disable = true},
    }
--[[ ## local fuction --]]
    local function createReceiveBtn( )
        local node = CCBCenter.getNodeByTag(_node, 108)
        local button = widget.newButton{
            normalImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            rect = CCRect(0, 0, 80, 58),
            contentSize = node:getContentSize(),
            listener = function ( btn )
                if _data and _data.status == TRUE then
                    btn:setButtonStatus(2)
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYMONTHCARDLAYER_ACTION_ONFETCHMONTHCARDREWARD)
                end
            end,
            scale = 1.1,
        }
        button.setStateDisabled(true)
        node:addChild(button)
        util.alignNode(button, node)
        local iconNode = widget.newNode{contentSize = node:getContentSize()}
        button:addChild(iconNode, 10)
        util.alignNode(iconNode, button)
        -- 钻石图片
        local diamondSprite = widget.newSprite{file = "main/activity/monthcard/img_diamond.png"}
        iconNode:addChild(diamondSprite)
        util.alignNode(diamondSprite, iconNode, display.LEFT_CENTER, 10)
        -- 领取数量
        local countLabel = ui.newTTFLabel{text = "", color = BUTTON_COLOR3.BROWN, size = 46}
        iconNode:addChild(countLabel)
        util.alignNode(countLabel, iconNode, display.CENTER_TOP, {left = - 63, top = 10})
        -- 领取状态
        local statusLabel = ui.newTTFLabel{text = "", color = BUTTON_COLOR3.BROWN, size = 46}
        iconNode:addChild(statusLabel)
        util.alignNode(statusLabel, iconNode, display.CENTER_BOTTOM, {left = - 63, bottom = 10})

        function button:setDiamondCount( count )
            countLabel:setString(count)
        end

        function button:setButtonStatus( status )
            statusLabel:setString(BUTTON_STATUS[status].text)
            self.setStateDisabled(BUTTON_STATUS[status].disable)
        end
        return button
    end
	local function initViews()
		_btnReceive = createReceiveBtn()
	end

--[[ ## public fuction --]]
    local function updateData( data )
        _data = data
        _nodeTable["mDaysLeftLabel"]:setString(_s("ACTIVITY_MONTH_CARD_DATE", data.days))
        _nodeTable["mPriceLabel"]:setString(data.cost)
        _nodeTable["mDetailLabel"]:setString(_s("ACTIVITY_MONTH_CARD_DETAIL", data.cost, data.dia))
        _btnReceive:setDiamondCount(_s("REWARD_COUNT", data.dia))
        _btnReceive:setButtonStatus(data.status)
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData = updateData
end

return M