local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArenaLayerView]"
	local _node, _nodeTable = node, luaValue

	-- 列表类型
	local MYORDER = 1	-- 我的排名
	local MAXORDER = 2    -- 最高排名

	local _tableNode 	--table父node
	local _rankGrid 	--排行table实体
	local _recordGrid	--录像table实体
	local _ruleTTF  	--规则
	local _selTop = 	MYORDER	--列表类型 我的排名（默认），最高排名 
	local _cdTimer  -- cd计时器
	local _cdFlag = true 	-- cd状态
	local _countFlag = true -- 挑战次数
	local EntityArena = require("ccb.m.arena.EntityArena")

	local sel_rank = 1
	local sel_record = 2
	local sel_rule = 3

	local _jjcState = 0 --状态 0:开始 （竞技中） 1：结束 （竞技休战） int

	local top10Players = {}


--[[ ## local fuction --]]


    -- 刷新录像列表
	local function reloadRecordList( properties )
		_recordGrid:setItems(properties)
	end

	-- 刷新top10排名
	local function reloadArenaTop10List(properties)

		-- print("~~~~~~~#top10Players",#top10Players," #properties",#properties)
		if top10Players and #top10Players > 0 and properties and #properties > 0 then 
			for i=1,#properties do
				if properties[i] and properties[i]:getHero() then 
					local hero = properties[i]:getHero()
					if top10Players[hero:getRank()] then 
						local btn =  top10Players[hero:getRank()]

						if btn then 
							-- local nttf = btn:getChildByTag(999)
							-- print("hero:getName()",hero:getName())

							btn.setTextString(hero:getName() or "")
							-- if nttf and nttf.setString then 
							-- 	print("2hero:getName()",hero:getName())
							-- 	nttf:setString(hero:getName() or "")
							-- end
								
							if hero:getId() > 0 then 
								btn.setListener(function (  )
										if hero:getId() ~= ME:getUserid()  then 
											-- print("hero:getId()",hero:getId())
											CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = properties[i], key = MSG_ID.MSG_ARENALAYER_MODEL, fnNextView = function() CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 1}) end, })
										end

								end)
							end	
						end 

					end
				end
				
			end
			
		end

	end


	local function reloadFightEnable()
		-- _nodeTable.btnFight:setVisible(_cdFlag and _countFlag and _selTop == MYORDER)
		-- _nodeTable.btnFight:setEnabled(_cdFlag and _countFlag and _selTop == MYORDER)
	end

	-- 刷新挑战冷却时间
	local function reloadArenaCd ( cd )
		if cd > 0 then 
			_cdFlag = false -- cd大于0 无法挑战
			-- _cdTimer:stop()
			_cdTimer:start(cd)
			_nodeTable.btnBuyCd:setEnabled(true)
		else 
			_cdTimer:stop()
			_cdTimer:modifyTime(0)
			-- _cdTimer:stop()
			_cdFlag = true
			_nodeTable.btnBuyCd:setEnabled(false)
		end 

		reloadFightEnable()
	end

	-- 刷新挑战次数
	local function reloadArenaCount ( count )
		local params = {{text = _s("ARENA_CHALLENGE_TIMES_TITLE"), size = 30},
            {text = count, size = 30,color = ccc3(0, 249, 55)},
            {text = _s("ARENA_CHALLENGE_TIMES_END"), size = 30},}

        local  linearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(linearLabel, _nodeTable.mCurCountNode,display.CENTER_LEFT)
        _nodeTable.mCurCountNode:removeAllChildrenWithCleanup(true)
        _nodeTable.mCurCountNode:addChild(linearLabel)
		if count == 0 then 
			_countFlag = false -- 挑战次数为0 无法挑战
		else 
			_countFlag = true
		end 

		reloadFightEnable()
	end

	-- 刷新排名列表
	local function reloadArenaList( properties )

		_rankGrid:setItems(properties)
		if #properties > 6 then 
			_rankGrid:setContentOffset(_rankGrid:maxContainerOffset())
		end
		reloadFightEnable()
	end

	-- 刷新我的排名
	local function reloadArenaMyRank( rank )
		local params = {{text = _s("ARENA_CUR_RANK"), size = 30},
                {text = rank, size = 30,color = ccc3(0, 249, 55)}}

        local  linearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(linearLabel, _nodeTable.mMyRankNode,display.CENTER_LEFT)
        _nodeTable.mMyRankNode:removeAllChildrenWithCleanup(true)
        _nodeTable.mMyRankNode:addChild(linearLabel)
	end


	--********************* 初始化 ***********************

	-- 录像列表单元格 
	local function createRecordCell( grid,index,item )
		  if not item:getPlayers() then return end
          local hero = item:getPlayers():getHero()
          if not hero then return end

          local cell = display.newSprite("arena/arena_rrank.png", 0, 0)

          cell:ignoreAnchorPointForPosition(false)

          -- ***************** 排名变化 *****************
          	local rankvar = item:getRankvar()
          	local resn = item:getRes() -- 1 胜利 2 失败
          	local res

          	if resn == 1 then -- 胜利
          		res	= display.newSprite("arena/arena_win.png", 0,0)
      		elseif resn ~= 1 and rankvar < 0 then -- 失败 排名下降
      			res	= display.newSprite("arena/arena_lostd.png", 0,0)
      		else -- 失败 排名不变
      			res	= display.newSprite("arena/arena_lostn.png", 0,0)
      		end

           res:setPosition(41, 31)
           cell:addChild(res,1)

           local phttf = widget.newTTFLabelWithShadow{
                text = math.abs(rankvar), 
                shadow = true,
                size = 14, 
                offset = 1,
                x =  43.5,
                y = 6,
                align = ui.TEXT_ALIGN_CENTER
            }
            cell:addChild(phttf, 2)
            util.modifyPositionInAndroid( phttf, 0, 5 )
            -- ***************** 排名变化 *****************

	    	-- ***************** 头像 *****************
           local heroIconSp = display.newSprite("arena/arena_rrankhead.png", 0,0)
           heroIconSp:setPosition(119, 41)
           cell:addChild(heroIconSp,1)

          	local imgFile
			if hero:getSex() == MALE then 
				imgFile = "role/r_ico_m.png"
			elseif hero:getSex() == FEMALE then
				imgFile = "role/r_ico_fm.png"
			end

          local heroIconBtn = 
          widget.newButton({
          		normalImage= item:getPlayers():getCard():getCardIcon(), -- 
                ignoreAnchor = true,
                container = _rankGrid, --cell滑出scroll外，禁止按钮点击
                listener = function()
                	if hero:getId() ~= ME:getUserid()  then 
                   		CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = item:getPlayers(), key = MSG_ID.MSG_ARENALAYER_MODEL, fnNextView = function() CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 2}) end,})
               		end
                end})
		  heroIconBtn:setScale(0.63)
          heroIconBtn:setPosition(heroIconSp:getContentSize().width/2, heroIconSp:getContentSize().height/2)
          heroIconSp:addChild(heroIconBtn)
	     -- ***************** 头像 *****************

	    	-- ***************** 基本信息 *****************
          	local nttf = widget.newTTFLabelWithShadow{
                text = hero:getName() or "", 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  165,
                y = 40,
            }
	    	cell:addChild(nttf, 1)
	    	util.modifyPositionInAndroid( nttf, 0, 4 )

	    	local winrate = hero:getWinrate() or ""
          	local rttf = widget.newTTFLabelWithShadow{
                text = string.format(_s("ARENA_WIN_RATE"), winrate/10), 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  165,
                y = 5,
            }
	    	cell:addChild(rttf, 1)
	    	util.modifyPositionInAndroid( rttf, 0, 4 )

	    	-- 等级
          	local lvttf = widget.newTTFLabelWithShadow{
                text = hero:getLv(), 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  410,
                y = 40,
                align = ui.TEXT_ALIGN_CENTER,
            }
	    	cell:addChild(lvttf, 1)
	    	util.modifyPositionInAndroid( lvttf, 0, 4 )

	    	-- pk时间
	    	local pkdate = item:getPkdate() or ""
          	local pkttf = widget.newTTFLabelWithShadow{
                text = pkdate, 
                shadow = true,
                size = 18, 
                offset = 1,
                x =  360,
                y = 6,
                align = ui.TEXT_ALIGN_CENTER,
            }
	    	cell:addChild(pkttf, 1)
	    	util.modifyPositionInAndroid( pkttf, 0, 4 )
	    	-- ***************** 基本信息 *****************

	    	-- ***************** 播放按钮 *****************
	    	if item:getId() then
		        local btnPlay =
	       		 widget.newButton{
		            normalImage = "arena/arena_play.png",
		            selectImage = "arena/arena_play_.png",
		            disableImage = "arena/arena_play_.png",
		            container = _rankGrid,
		            listener = function (  )
		            	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENALAYER_ONBTNPLAYRECORDCLICK, nil , item:getId())
		            end
		        }
		        btnPlay:setScale(SCALE_FOR_SPECIAL_NODE)
		        btnPlay:setPosition(ccp(505,40))
		        cell:addChild(btnPlay, 1)
	    	end
	    	-- ***************** 播放按钮 *****************

	    	return cell
	end

	--创建table
    local function createRecordTable()
    	
        local function createItemCellListener( grid,index,item )
        	local cell = createRecordCell(grid,index,item)
          	return cell
	    end
	    local function modifyItemCellListener( grid,index,item,itemCell )
	        -- body
	    end
	    local function tapListener( grid,index,item )
	        Log.d(TAG,"YOU CLICKED ", index)
	        -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer")
	    end
	    --scrollview
	    local cellSp = display.newSprite("arena/arena_rrank.png", 0, 0)
	    local scrollGrid = widget.newScrollGrid{

	        contentSize = _tableNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( _tableNode:getContentSize().width, cellSp:getContentSize().height),
	            padding = { 
	                middleH = 0, middleV = 5,
	                left = 0, right = 0, top = 5, bottom = 0,
	            },
	            column = 1,
	            createItemCellListener = createItemCellListener,
	            modifyItemCellListener = modifyItemCellListener,
	            tapListener = tapListener,
	            selectedParams = nil,

	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _tableNode,
	    }

	    return scrollGrid
    end


    -- 排行列表单元格
	local function createRankCell( grid,index,item )

          local hero = item:getHero()

          if not hero then return end

          local cell

          if hero:getId() == ME:getUserid() then
          	cell = display.newSprite("arena/arena_rrankself.png", 0, 0)
          else
  		  	cell = display.newSprite("arena/arena_rrank.png", 0, 0)
  		  end


          cell:ignoreAnchorPointForPosition(false)

          -- ***************** 排行 *****************

          local phttf = widget.newTTFLabelWithShadow{
                text = _s("ARENA_RANKING"), 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  20,
                y = 35,
            }
	    	cell:addChild(phttf, 1)

          	local phnttf = widget.newTTFLabelWithShadow{
                text = hero:getRank() or "", 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  40,
                y = 10,
                align = ui.TEXT_ALIGN_CENTER,
            }
	    	cell:addChild(phnttf, 1)
	    	util.modifyPositionInAndroid( phnttf, 0, 2 )  -- 右排行序号
	    	-- ***************** 排行 *****************

	    	-- ***************** 头像 *****************
           local heroIconSp = display.newSprite("arena/arena_rrankhead.png", 0,0)
           heroIconSp:setPosition(119, 41)
           cell:addChild(heroIconSp,1)

          	local imgFile
			if hero:getSex() == MALE then 
				imgFile = "role/r_ico_m.png"
			elseif hero:getSex() == FEMALE then
				imgFile = "role/r_ico_fm.png"
			end
          
    --       local heroIconBtn = 
    --       widget.newButton({
    --       		normalImage=   item:getCard():getCardIcon(),
    --             ignoreAnchor = true,
    --             container = _rankGrid, --cell滑出scroll外，禁止按钮点击
    --             listener = function ( )
    --             	if hero:getId() ~= ME:getUserid()  then 
    --                		CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = item, key = MSG_ID.MSG_ARENALAYER_MODEL, fnNextView = function() CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 1}) end,})
    --            		end
    --             end})
		  -- heroIconBtn:setScale(0.63)
    --       heroIconBtn:setPosition(heroIconSp:getContentSize().width/2, heroIconSp:getContentSize().height/2)
    --       heroIconSp:addChild(heroIconBtn)

          local CardMaster = require("cardui.CardMaster")
          local cardEntity = item:getCard()
          cardEntity.type = CardMaster.MINISTARCARD
          cardEntity.handler = function ( )
                                        if hero:getId() ~= ME:getUserid()  then 
                                            CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = item, key = MSG_ID.MSG_ARENALAYER_MODEL, fnNextView = function() CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 1}) end,})
                                        end
                                    end
          local cardView = CardMaster.new(cardEntity)
          cardView:setScale(0.68)
          -- cardView:setPosition(heroIconSp:getContentSize().width/2, heroIconSp:getContentSize().height/2)
          util.alignNode(cardView, heroIconSp:getContentSize(), display.CENTER)
          heroIconSp:addChild(cardView)
	    	-- ***************** 头像 *****************

	    	-- ***************** 基本信息 *****************
          	local nttf = widget.newTTFLabelWithShadow{
                text = hero:getName() or "", 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  165,
                y = 42,
            }
	    	cell:addChild(nttf, 1)
	    	-- util.modifyPositionInAndroid( nttf, 0, 0 )  -- 右排行玩家名

	    	local winrate = hero:getWinrate() or ""
          	local rttf = widget.newTTFLabelWithShadow{
                text = string.format(_s("ARENA_WIN_RATE"), winrate/10), 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  165,
                y = 8,
            }
	    	cell:addChild(rttf, 1)
	    	-- util.modifyPositionInAndroid( rttf, 0, 0 )  -- 右排行玩家胜率
	    	-- 等级
          	local lvttf = widget.newTTFLabelWithShadow{
                text = hero:getLv(), 
                shadow = true,
                size = 20, 
                offset = 1,
                x =  410,
                y = 43,
                align = ui.TEXT_ALIGN_CENTER,
            }
	    	cell:addChild(lvttf, 1)
	    	-- util.modifyPositionInAndroid( lvttf, 0, 0 )  -- 右排行玩家特级
	    	-- ***************** 基本信息 *****************

	    	-- ***************** 攻击按钮 *****************
	    	if hero:getId() ~= ME:getUserid() then
		        local btnFight =
	       		 widget.newButton{
		            normalImage = "arena/arena_fight.png",
		            selectImage = "arena/arena_fight_.png",
		            disableImage = "arena/arena_fight_.png",
		            listener = function (  )

		            	if _jjcState == 1 then 
		            		NetHelper.QuickToast(_s("ARENA_TRUCE_IN_WAIT"))
		            	else
		            		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENALAYER_ONBTNFIGHTCLICK, nil , {id = hero:getId(),name = hero:getName()})
		            	end
		            	
		            end
		        }
		        btnFight:setScale(SCALE_FOR_SPECIAL_NODE)
		        btnFight:setPosition(ccp(505,40))
		        cell:addChild(btnFight, 1)
	    	end
	    	-- ***************** 攻击按钮 *****************
          return cell
    end
	--创建table
    local function createRankTable()
    	
        local function createItemCellListener( grid,index,item )
        	local cell = createRankCell(grid,index,item)
          	return cell
	    end
	    local function modifyItemCellListener( grid,index,item,itemCell )
	        -- body
	    end
	    local function tapListener( grid,index,item )
	        Log.d(TAG,"YOU CLICKED ", index)
	        -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer")
	    end
	    --scrollview
	    local cellSp = display.newSprite("arena/arena_rrank.png", 0, 0)
	    local scrollGrid = widget.newScrollGrid{

	        contentSize = _tableNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( _tableNode:getContentSize().width, cellSp:getContentSize().height),
	            padding = { 
	                middleH = 0, middleV = 5,
	                left = 0, right = 0, top = 5, bottom = 0,
	            },
	            column = 1,
	            createItemCellListener = createItemCellListener,
	            modifyItemCellListener = modifyItemCellListener,
	            tapListener = tapListener,
	            selectedParams = nil,

	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _tableNode,
	    }

	    return scrollGrid
    end

	-- 创建cd计时器
	local function createCdTimer()
		local timerNode = _nodeTable["cdtime"]
		_cdTimer = CountDownView.new({ 
							format = "[mm]:[ss]",
							listener = function()
                                if _node._DATA and _node._DATA.flag then
                                    -- getRecordList()
                                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENALAYER_ONGETRECORDLIST)
                                else
                                    CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENALAYER_ONRELOADARENAINFO)
                                    -- getArenaInfo( _node.MYORDER )
                                end
								-- print("createCdTimer")
							end

						})
		-- _cdTimer:start(0)
		_cdTimer:setPosition(ccp(48,9))		
		timerNode:addChild(_cdTimer)
		util.modifyPositionInAndroid( _cdTimer, 0, 3 )
	end

	-- 创建top10
	local function createTop10List()
		local rankno1  = _nodeTable["rankno1"]
		local padding_top = 3
		if isandroid() then padding_top = 0 end
		for i=1,10 do
			local btn = --display.newSprite("arena/arena_lrank.png", 0, 0)
          	widget.newButton({
	      		normalImage =   "arena/arena_lrank.png",
	            ignoreAnchor = true,
	            container = _node, 
	            labelParams = {text = "",color = ccc3(38,34,98), padding = { top = padding_top }}
            })

			btn:setPosition(ccp(rankno1:getPositionX(),rankno1:getPositionY() - ( i - 1 ) * 44))

			_node:addChild(btn)

			-- 前3名有奖牌
            if i == 1 then 
            	local no1 = display.newSprite("arena/arena_no1.png", 0, 0)
            	local nop1 = display.newSprite("arena/arena_nop1.png", 0, 0)

            	no1:setPosition(ccp(23,20))
            	nop1:setPosition(ccp(225,20))

            	btn:addChild(no1, 1)
            	btn:addChild(nop1, 1)
            elseif i == 2 then 
            	local no2 = display.newSprite("arena/arena_no2.png", 0, 0)
            	local nop2 = display.newSprite("arena/arena_nop2.png", 0, 0)

            	no2:setPosition(ccp(23,20))
            	nop2:setPosition(ccp(225,20))

            	btn:addChild(no2, 1)
            	btn:addChild(nop2, 1)
            elseif i == 3 then
            	local no3 = display.newSprite("arena/arena_no3.png", 0, 0)
            	local nop3 = display.newSprite("arena/arena_nop3.png", 0, 0)

            	no3:setPosition(ccp(23,20))
            	nop3:setPosition(ccp(225,20))

            	btn:addChild(no3, 1)
            	btn:addChild(nop3, 1)
            end


            local cttf = widget.newTTFLabelWithShadow{
                            text = i, 
                            shadow = false,
                            color = COLOR3.ORANGE  ,
                            size = 28, 
                            offset = 0,
                            x =  23,
                            y = 2,
                            align = ui.TEXT_ALIGN_CENTER,
                        }
            btn:addChild(cttf, 2)
            -- util.modifyPositionInAndroid(cttf, 0, 0) 	-- top10的序号

            -- local nttf = widget.newTTFLabelWithShadow{
            --     text = "", 
            --     shadow = false,
            --     color = ccc3(38,34,98) ,
            --     size = 24, 
            --     offset = 0,
            --     x =  130,
            --     y = 0,
            --     align = ui.TEXT_ALIGN_CENTER,
            -- }
            -- btn:addChild(nttf, 2)
            -- nttf:setTag(999)
            -- util.modifyPositionInAndroid(nttf, 0, 4) 	-- top10的玩家名

            top10Players[i] = btn
		end
	end

	-- local function createRuleTTF()

 --        local ly = widget.newLayer()
 --        ly:setContentSize(_tableNode:getContentSize())
 --        _tableNode:addChild(ly, 1)

 --        local tttf = widget.newTTFLabelWithShadow{
 --            text = "竞技场排名赛规则", 
 --            shadow = true,
 --            size = 40, 
 --            offset = 1,
 --            dimensions = CCSize( _tableNode:getContentSize().width,  42), --30
 --            align = ui.TEXT_ALIGN_CENTER
 --        }
 --        tttf:setPosition(ccp(560 / 2 ,_tableNode:getContentSize().height - tttf:getContentSize().height - 15))
 --        ly:addChild(tttf, 1)
		
	-- 	local text =   "\r【挑战规则】\r\n玩家在排名赛中，可以挑战若干排名自己之前的玩家，公平起见挑战一律以自动模式战斗，如果战胜则玩家可以与其排名互换，失败则无变化。"
	-- 	text = text .. "\r\n\r\n【战斗间隔/挑战次数】\r\n玩家每日有10次挑战次数，每次战斗后会有10分钟CD时间，玩家可以使用钻石减少CD时间，增加挑战次数。"
	-- 	text = text .. "\r\n\r\n【收益奖励】\r\n每日中午12:00点时会进行排名结算，玩家可以根据自己的排名获得一定的金币收益。每天完成10次排名赛挑战还可以获得额外奖励哦。"
            
 --        local bttf = widget.newTTFLabelWithShadow{
 --        	text = text,
 --            shadow = true,
 --            size = 24, 
 --            offset = 1,
 --            dimensions = CCSize( _tableNode:getContentSize().width,  560)
 --        }

 --        bttf:setPosition(ccp(0,_tableNode:getContentSize().height - bttf:getContentSize().height ))
 --        ly:addChild(bttf, 1)

 --        return ly
	-- end
	--********************* 初始化 ***********************

	local function changeBtnStatus( sel )
		local btnRank   =  	_nodeTable["btnRank"]
		local btnRecord = 	_nodeTable["btnRecord"]
		local btnRule   = 	_nodeTable["btnRule"]
		-- print("sel ",sel)
		if sel == sel_rank then 
			btnRank:setEnabled(false)
			btnRecord:setEnabled(true)
			-- btnRule:setEnabled(true)
			_rankGrid:setVisible(true)
			_recordGrid:setVisible(false)
			-- _ruleTTF:setVisible(false)
		elseif sel == sel_record then
			btnRank:setEnabled(true)
			btnRecord:setEnabled(false)
			-- btnRule:setEnabled(true)
			_rankGrid:setVisible(false)
			_recordGrid:setVisible(true)
			-- _ruleTTF:setVisible(false)
		elseif sel == sel_rule then 

			CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isRankRule = true,})
			-- btnRank:setEnabled(true)
			-- btnRecord:setEnabled(true)
			-- btnRule:setEnabled(false)
			-- _rankGrid:setVisible(false)
			-- _recordGrid:setVisible(false)
			-- _ruleTTF:setVisible(true)
		else 
			btnRank:setEnabled(false)
			btnRecord:setEnabled(true)
			-- btnRule:setEnabled(true)
			_rankGrid:setVisible(true)
			_recordGrid:setVisible(false)
			-- _ruleTTF:setVisible(false)
		end
	end
    local function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {70070, 70070})
    end
	local function initViews()

		_node:setPositionY(-1 * _node:getContentSize().height)
       
   		_tableNode = _nodeTable["tablenode"]

		_rankGrid = createRankTable()--创建排行table

		_recordGrid = createRecordTable()--创建录像table

		-- _ruleTTF = createRuleTTF()--创建规则页面

		createTop10List()--创建top10列表

		createCdTimer()--创建cd计时器

		changeBtnStatus( sel_rank ) -- 默认选中排名
        checkHelperInfo( )
	end

	local function isCdok()
		return _cdFlag
	end

	local function isCountOk()
		return _countFlag
	end

	local function reloadArenaJjcState( state )
		_jjcState = state
		if _jjcState == 1 then
			_nodeTable.btnBuyCd:setEnabled(false)
		end
	end

--[[ ## public fuction --]]
	_node.reloadMyrank = reloadMyrank
	_node.reloadArenaCd = reloadArenaCd
	_node.reloadArenaCount = reloadArenaCount
	_node.reloadArenaList = reloadArenaList
	_node.reloadArenaTop10List = reloadArenaTop10List
	_node.reloadRecordList = reloadRecordList
	_node.changeBtnStatus = changeBtnStatus
	_node.reloadArenaMyRank = reloadArenaMyRank
	_node.isCdok = isCdok
	_node.isCountOk = isCountOk
	_node.reloadArenaJjcState = reloadArenaJjcState

	_node.sel_rank = sel_rank
	_node.sel_record = sel_record
	_node.sel_rule = sel_rule

	_node.MYORDER = MYORDER
	_node.MAXORDER = MAXORDER
--[[ ## MAINs --]]
	initViews()
end

return M