--ArenaWeekAlertLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArenaWeekAlertLayerView]"
	local _node, _nodeTable = node, luaValue
	local data = _node._DATA
	local _scrollGrid
--[[ ## local fuction --]]
	-- 排名赛规则 
	local function fillRuleLabel( title, content )
		if _node._TEXT then
			content = _node._TEXT
		end
		local titleNode = CCBCenter.getNodeByTag(_node, 20201)
		local title = ui.newTTFLabel{text = title, size = 30,}
		titleNode:addChild(title)
		util.alignNodeWithPadding(title, titleNode:getContentSize(), display.CENTER)
		local node = CCBCenter.getNodeByTag(_node, 20202)
		-- local ruleText = content

		-- local ruleLabel = ui.newTTFLabel{text = ruleText, size = 20, dimensions = node:getContentSize(), valign = ui.TEXT_VALIGN_TOP}
		-- node:addChild(ruleLabel)
		-- util.alignNodeWithPadding(ruleLabel, node:getContentSize(), display.CENTER)

		local scrollView = widget.newScrollView{
			-- bounceable = false, 
			contentSize = node:getContentSize(), 
			direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
		}
		node:addChild(scrollView)

		local textLabel = ui.newTTFLabel{text = "" , color = COLOR_WHITE, size = 20,}
		-- local colorLayer = widget.newColorLayer(ccc4(255,100,100,255))
		-- colorLayer:setContentSize(calcContainerSize(textLabel))
		local size = scrollView:getContentSize()
		textLabel:setDimensions(CCSize(size.width, 0))--calcContainerSize(textLabel))
		textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
		textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
		textLabel:setString(content)
		-- colorLayer:addChild(textLabel)
		-- util.alignNode(textLabel, colorLayer:getContentSize(), display.TOP_CENTER )
		scrollView:setContainer(textLabel)
		scrollView:updateInset()
		util.autoFixScrollView(scrollView)
	end
	-- 规则 
	local function createRuleLabel( )
		fillRuleLabel( _s("ARENA_WEEK_GAME"), _s("ARENA_RULE_WEEK_GAME") )
	end
	-- 进阶规则 
	local function createEvoRuleLabel( )
		fillRuleLabel( _s("CARD_EVOLUTION"), _s("CARD_EVOLUTION_RULE") )
	end
	-- 探索规则 
	local function createExploreRuleLabel( )
		fillRuleLabel( _s("MAP_EXPLORE_RULE_TITLE"), _s("MAP_EXPLORE_RULE") )
	end
	-- 排名赛规则 
	local function createRankRuleLabel( )
		fillRuleLabel( _s("ARENA_RANK_GAME"), _s("ARENA_RULE_RANK_GAME") )
	end
	-- 卡牌碎片规则
	local function createCardFragmentRuleLabel( )
		fillRuleLabel( _s("CARD_FRAGMENT"), _s("CARD_FRAGMENT_RULE") )
	end
	-- 许愿池规则
	local function createMakeHopeRuleLabel( )
		fillRuleLabel( _s("MAIN_WISHING"), _s("WISHING_RULE") )
	end
	-- 矿山规则
	local function createMiningRuleLabel( )
		fillRuleLabel( _s("MAIN_MINING"), _s("MINE_RULE") )
	end
	-- 装备强化规则
	local function createEquipmentLvRuleLabel( )
		fillRuleLabel( _s("EQUIPMENT_LVUPTITLE"), _s("EQUIPMENT_LV_RULE") )
	end
	-- 装备进阶规则
	local function createEquipmentEvoRuleLabel( )
		fillRuleLabel( _s("EQUIPMENT_STEPUPTITLE"), _s("EQUIPMENT_EVO_RULE") )
	end
	-- 装备追加规则
	local function createEquipmentAddRuleLabel( )
		fillRuleLabel( _s("EQUIPMENT_SUPPLEMENTTITLE"), _s("EQUIPMENT_ADD_RULE") )
	end
	-- 装备追加规则
	local function createEquipmentAddRuleLabel( )
		fillRuleLabel( _s("EQUIPMENT_SUPPLEMENTTITLE"), _s("EQUIPMENT_ADD_RULE") )
	end
	--装备拆解规则
	local function showEquipmentDismantleRuleLabel( ... )
		fillRuleLabel( _s("EQUIP_DISMANTLE"), _s("EQUIPMENT_DISMANTLE_RULE") )
	end
	-- Boss规则
	local function createBossRuleLabel( )
		fillRuleLabel( _s("MAIN_BOSS"), _s("BOSS_RULE") )
	end

	-- 战队规则
	local function createTeamRuleLabel( )
		fillRuleLabel( _s("TEAM_RULE_TITLE"), _s("TEAM_RULE") )
	end
	-- 区赛规则
	local function createTeamSameServerRuleLabel( )
		fillRuleLabel( _s("TEAM_SAME_SERVER_RULE_TITLE"), _s("TEAM_SAME_SERVER_RULE") )
	end
	-- 跨服战规则
	local function createTeamInterServerRuleLabel( )
		fillRuleLabel( _s("TEAM_INTER_SERVER_RULE_TITLE"), _s("TEAM_INTER_SERVER_RULE") )
	end
	-- 战队奖励说明
	local function createTeamRewardRuleLabel( )
		fillRuleLabel( _s("TEAM_REWARD_INFO"), _s("TEAM_REWARD_RULE") )
	end
	-- 区赛奖励说明
	local function createTeamSameServerRewardRuleLabel( )
		fillRuleLabel( _s("TEAM_SAME_SERVER_REWARD_INFO"), _s("TEAM_SAME_SERVER_REWARD_RULE") )
	end
	-- 跨服战奖励说明
	local function createTeamInterServerRewardRuleLabel( )
		fillRuleLabel( _s("TEAM_INTER_SERVER_REWARD_INFO"), _s("TEAM_INTER_SERVER_REWARD_RULE") )
	end
	-- 幽灵魔塔规则
	local function createTowerRule( )
		fillRuleLabel( _s("MAP_TOWER"), _s("TOWER_RULE") )
	end
	-- 幽灵魔塔规则
	local function createArmyBossRule( )
		fillRuleLabel( _s("ARMY_BOSS_WARM_TITLE"), _s("ARMY_BOSS_WARM") )
	end
	--军团规则
	local function createArmyRule( ... )
		fillRuleLabel( _s("MAIN_ARMY"), _s("ARMY_RULE") )
	end
	-- 录像战报
	local function createRecord( items )
		local node = CCBCenter.getNodeByTag(_node, 201)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(node:getContentSize().width, 90))

			local bgSprite = widget.newSprite{file = "arena/arena_rrank.png"}
			cell:addChild(bgSprite)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER)

			-- 战况图标
			local rankSprite
			if item.res == 1 then
				-- 胜利
          		rankSprite	= widget.newSprite{ file = "arena/arena_win.png"}
      		elseif item.res ~= 1 and item.rankvar < 0 then
      			rankSprite	= widget.newSprite{ file = "arena/arena_lostd.png"}
      		else -- 排名不变
      			rankSprite	= widget.newSprite{ file = "arena/arena_lostn.png"}
      		end
      		cell:addChild(rankSprite)
      		util.alignNodeWithPadding(rankSprite, cell:getContentSize(), display.BOTTOM_LEFT, {bottom = 13, left = 8,})

      		local rankTitle = ui.newTTFLabel{text = _s("ARENA_TOP_GAME"), size = 14}
      		rankSprite:addChild(rankTitle)
      		util.alignNodeWithPadding(rankTitle, rankSprite:getContentSize(), display.TOP_CENTER, {top = -14,})

      		--排名变化
      		local rankLabel = ui.newTTFLabel{text = math.abs(item.rankvar), size = 20}
      		rankSprite:addChild(rankLabel)
      		util.alignNodeWithPadding(rankLabel, rankSprite:getContentSize(), display.BOTTOM_CENTER, {bottom = -6, left = -10,})
      		util.modifyPositionInAndroid( rankLabel, 0, 5 )

      		-- 头像根据性别来
      		local heroIconSp = widget.newSprite{file = "arena/arena_rrankhead.png"}
	        cell:addChild(heroIconSp)
	        util.alignNodeWithPadding(heroIconSp, cell:getContentSize(), display.LEFT_CENTER, {bottom = 13, left = 84,})
	        -- ====== 现在直接拿 主卡牌当作头像
	        local friendEntity = require("ccb.m.friend.EntityFriend").new(item.players)
	        -- ====== 现在直接拿 主卡牌当作头像
	        local heroIconBtn = widget.newButton{
	        		normalImage = friendEntity:getCard():getCardIcon(),--iff(item.players.hero.sex == MALE, "role/r_ico_m.png", "role/r_ico_fm.png"),--item:getCard():getCardIcon(),
	              	ignoreAnchor = true,
	              	container = node,
	              	-- container = _rankGrid, --cell滑出scroll外，禁止按钮点击
	              	listener = function ( )
						local friendEntity = require("ccb.m.friend.EntityFriend").new(item.players)
	                 	CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", 
	                 		{entity = friendEntity, key = MSG_ID.MSG_ARENALAYER_MODEL, 
	                 		fnNextView = function ( )
		                 		CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 4})
	                 		end,
	                 		})
	              	end}
			heroIconBtn:setScale(0.63)
	        heroIconSp:addChild(heroIconBtn)
	        util.alignNodeWithPadding(heroIconBtn, heroIconSp:getContentSize(), display.CENTER)

	        -- 名字
	        local nameLabel = ui.newTTFLabel{text = item.players.hero.name}
	        cell:addChild(nameLabel)
	        util.alignNodeWithPadding(nameLabel, cell:getContentSize(), display.LEFT_TOP, {left = 162, top = 14})

	        -- 胜率
	        local rateLabel = ui.newTTFLabel{text = string.format(_s("ARENA_WIN_RATE"), item.players.hero.winrate/10), }
	        cell:addChild(rateLabel)
	        util.alignNodeWithPadding(rateLabel, cell:getContentSize(), display.LEFT_BOTTOM, {left = 162, bottom = 6})
	        util.modifyPositionInAndroid( rateLabel, 0, 5 )

	        -- 等级
	        local levelLabel = ui.newTTFLabel{text = item.players.hero.lv}
	        cell:addChild(levelLabel)
	        util.alignNodeWithPadding(levelLabel, cell:getContentSize(), display.TOP_CENTER, {left = -126, top = 14})

	        -- 回放按钮

	        local btnPlay = widget.newButton{
		            normalImage = "arena/arena_play.png",
		            selectImage = "arena/arena_play_.png",
		            disableImage = "arena/arena_play_.png",
		            container = node,
		            listener = function (  )
			            SOUND:playEffectButton1()
			            local FightViewFactory = require(PH_MDL_FACTORY .. "FightViewFactory") 		-- 战斗视图工厂
						FightViewFactory.viewRecordCompetitiveRace{ recordId = item.id, }
		            end
		        }
	        btnPlay:setScale(SCALE_FOR_SPECIAL_NODE)
	        cell:addChild(btnPlay)
	        util.alignNodeWithPadding(btnPlay, cell:getContentSize(), display.RIGHT_CENTER, {right = 10})

			-- FightViewFactory.viewRecordCompetitiveRace({ recordId = recordId, })
			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		_scrollGrid = widget.newScrollGrid{
	        contentSize = node:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(node:getContentSize().width, 79),
	            padding = { 
	                middleH = 4, middleV = 4,
	            },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            selectedParams = nil,
	            items = items,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = node,
	    }
	    util.autoFixScrollView(_scrollGrid)
	end
	local function createActivityScrollLinear( )
        local node = CCBCenter.getNodeByTag(_node, 202)
		node:removeAllChildrenWithCleanup(true)

        local function cellAtIndex( scrollGrid, idx , item)
            local cell = widget.newLayer()
            cell:ignoreAnchorPointForPosition(false)

			local title = ui.newTTFLabel{
				text = item.title,
				size = 24,
			}
			cell:addChild(title)
			local content = ui.newTTFLabel{
				text = item.str,
				szie = 22,
				dimensions = CCSize(node:getContentSize().width, 0),
			}
			cell:addChild(content)
            local cellHeight = title:getContentSize().height + content:getContentSize().height

            cell:setContentSize(CCSize(node:getContentSize().width, cellHeight))
            util.alignNode(title, cell, display.TOP_CENTER)
            content:ignoreAnchorPointForPosition(true)
            content:setPosition(ccp(0, title:getPositionY() - content:getContentSize().height - title:getContentSize().height))

            return cell
        end
        local scrollGrid = widget.newScrollLinear{
            contentSize = node:getContentSize(),
            cellAtIndexListener = cellAtIndex,
            contentParams = {
                column = 1,
                -- tapListener = tapListener,
                selectedParams = nil,
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        node:addChild(scrollGrid)
        return scrollGrid
    end
	-- 充值活动
	local function createChargeActivity( items )
		local scroll = createActivityScrollLinear()
		scroll:setItems(items.lst)
	end
	local function checkHelperInfo( )
		HelperView2.showBetween(_node, nil, {70080, 70080})
	end
	local function initViews()
		-- animateShow()
	end

--[[ ## public fuction --]]
	-- 动画显示
	function M.animateShow(onComplete)
		-- 动画
		anim.popOut(_node, { playTime = 0.3, onComplete = onComplete})
	end
	function M.showRuleLabel( )
		createRuleLabel( )
	end
	function M.showRankRuleLabel( )
		checkHelperInfo( )
		createRankRuleLabel( )
	end
	function M.showEvoRuleLabel( )
		createEvoRuleLabel( )
	end
	function M.showExploreRuleLabel( )
		createExploreRuleLabel( )
	end
	function M.showCardFragmentRuleLabel( )
		createCardFragmentRuleLabel( )
	end
	function M.showMakeHopeRuleLabel( )
		createMakeHopeRuleLabel( )
	end
	function M.showMiningRuleLabel( )
		createMiningRuleLabel( )
	end
	function M.showEquipmentLvRuleLabel( )
		createEquipmentLvRuleLabel( )
	end
	function M.showEquipmentEvoRuleLabel( )
		createEquipmentEvoRuleLabel( )
	end
	function M.showEquipmentAddRuleLabel( )
		createEquipmentAddRuleLabel( )
	end
	function M.showEquipmentDismantleRuleLabel( )
		showEquipmentDismantleRuleLabel( )
	end
	function M.showBossRuleLabel( )
		createBossRuleLabel( )
	end
	function M.showTeamRuleLabel( )
		createTeamRuleLabel( )
	end
	function M.showTeamRewardRuleLabel( )
		createTeamRewardRuleLabel( )
	end
	function M.showTeamSameServerRuleLabel( )
		createTeamSameServerRuleLabel( )
	end
	function M.showTeamInterServerRuleLabel( )
		createTeamInterServerRuleLabel( )
	end
	function M.showTeamSameServerRewardRuleLabel( )
		createTeamSameServerRewardRuleLabel( )
	end
	function M.showTeamInterServerRewardRuleLabel( )
		createTeamInterServerRewardRuleLabel( )
	end
	function M.showRecord( items )
		createRecord( items.records )
	end
	function M.showChargeActivity( items )
		createChargeActivity( items)
	end
	function M.showTowerRuleLabel(  )
		createTowerRule()
	end
	function M.showArmyBossLabel(  )
		createArmyBossRule()
	end
	function M.showArmyRuleLabel( ... )
		createArmyRule()
	end
--[[ ## MAINs --]]
	initViews()
	_node.animateShow = M.animateShow
	_node.showRuleLabel = M.showRuleLabel 
	_node.showRankRuleLabel = M.showRankRuleLabel 
	_node.showEvoRuleLabel = M.showEvoRuleLabel 
	_node.showExploreRuleLabel = M.showExploreRuleLabel 
	_node.showCardFragmentRuleLabel = M.showCardFragmentRuleLabel 
	_node.showMakeHopeRuleLabel = M.showMakeHopeRuleLabel 
	_node.showMiningRuleLabel = M.showMiningRuleLabel 
	_node.showEquipmentLvRuleLabel = M.showEquipmentLvRuleLabel 
	_node.showEquipmentEvoRuleLabel = M.showEquipmentEvoRuleLabel 
	_node.showEquipmentAddRuleLabel = M.showEquipmentAddRuleLabel 
	_node.showEquipmentDismantleRuleLabel = M.showEquipmentDismantleRuleLabel
	_node.showBossRuleLabel = M.showBossRuleLabel 
	_node.showTeamRuleLabel = M.showTeamRuleLabel 
	_node.showTeamRewardRuleLabel = M.showTeamRewardRuleLabel 
	_node.showTeamSameServerRuleLabel = M.showTeamSameServerRuleLabel 
	_node.showTeamInterServerRuleLabel = M.showTeamInterServerRuleLabel 
	_node.showTeamSameServerRewardRuleLabel = M.showTeamSameServerRewardRuleLabel 
	_node.showTeamInterServerRewardRuleLabel = M.showTeamInterServerRewardRuleLabel 
	_node.showRecord = M.showRecord
	_node.showChargeActivity = M.showChargeActivity
	_node.showTowerRuleLabel = M.showTowerRuleLabel
	_node.showArmyBossLabel = M.showArmyBossLabel
	_node.showArmyRuleLabel = M.showArmyRuleLabel

end

return M