--ArenaWeekLayer.lua
local M = {}
local FastScrollView = require("cardui.FastScrollView")

function M.bindView(node, luaValue)
	local TAG = "[ArenaWeekLayerView]"
	local _node, _nodeTable = node, luaValue
	local _fastScroll, _rankGrid, _cdTimer, _nextTimer
	local playArrowStartAnim, playArrowShakeAnim, playArrowStopAnim
	local _leftparticleBatch, _rightparticleBatch, _leftParticle, _rightParticle
	local _players
--[[ ## local fuction --]]
	local function playLight()
		if _leftparticleBatch then
			_leftParticle:resetSystem()
			_rightParticle:resetSystem()
		else
			-- 粒子效果
	    	_leftParticle = CCParticleSystemQuad:create("arena/fireArrow.plist")
	    	_leftparticleBatch = CCParticleBatchNode:createWithTexture(_leftParticle:getTexture())
	    	_leftparticleBatch:addChild(_leftParticle)
	    	CCBCenter.getNodeByTag(_node, 1206):addChild(_leftparticleBatch, 10)
	    	_leftparticleBatch:setPosition(ccp(CCBCenter.getNodeByTag(_node, 1206):getContentSize().width, 0))

	    	_rightParticle = CCParticleSystemQuad:create("arena/fireArrow.plist")
	    	_rightparticleBatch = CCParticleBatchNode:createWithTexture(_rightParticle:getTexture())
	    	_rightparticleBatch:addChild(_rightParticle)
	    	CCBCenter.getNodeByTag(_node, 1207):addChild(_rightparticleBatch, 10)
	    	_rightparticleBatch:setPosition(ccp(0, 0))
		end
		
	end
	local function stopLight( )
		_leftParticle:stopSystem()
		_rightParticle:stopSystem()
	end
	function playArrowStartAnim( _node, isReverse )
		local array     = {}
        array[#array + 1] = CCRotateTo:create(2, iff(isReverse, -1, 1) * 30)
        transition.execute(_node, transition.sequence(array), {easing = "CCEaseBackInOut", onComplete = function ()
        	playLight()
            playArrowShakeAnim( _node, isReverse )
        end })
	end
	function playArrowShakeAnim( _node, isReverse )
		local array     = {}
        array[#array + 1] = CCRotateTo:create(0.1, iff(isReverse, -1, 1) * 26)
        array[#array + 1] = CCRotateTo:create(0.1, iff(isReverse, -1, 1) * 30)
        transition.execute(_node, transition.sequence(array), {easing = "CCEaseBackInOut", onComplete = function ()
            playArrowShakeAnim( _node, isReverse )
        end })
	end
	function playArrowStopAnim( _node, isReverse, callback )
		_node:stopAllActions()
		local array     = {}
        array[#array + 1] = CCRotateTo:create(0.5, iff(isReverse, 0, 0))
        transition.execute(_node, transition.sequence(array), {easing = "CCEaseBackInOut", onComplete = function ()
            if callback then
            	util.delayCall(callback, 0.5)
            end
        end })
	end
	local function createFastScrollView( )
		local layer = CCBCenter.getNodeByTag(_node, 1201)
		local function cellAtIndex( FastScrollView, item , cell)
			-- 背景
			local bgSprite = widget.newSprite{file = "arena/bg_week_cell.png",}
			cell:addChild(bgSprite, 0)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER)

			local title = ui.newTTFLabel{text = item.hero.name}
			cell:addChild(title)
			util.alignNodeWithPadding(title, cell:getContentSize(), display.CENTER)

			return cell
		end
		local function onComplete( fastScrollView, index )
			local function doFight( )
				local FightViewFactory 	= require(PH_MDL_FACTORY .. "FightViewFactory")
				FightViewFactory.viewPkCompetitiveRace({ friendId = _players[index].hero.id, friendName = _players[index].hero.name, })
			end
			stopLight()
			playArrowStopAnim(CCBCenter.getNodeByTag(_node, 1204))
			playArrowStopAnim(CCBCenter.getNodeByTag(_node, 1205), true, doFight)
		end 
		_fastScroll = FastScrollView.new{
			contentSize = layer:getContentSize(), 
			parentNode = layer, 
			cellSize = CCSize(layer:getContentSize().width, 48),
			onCompleteListener = onComplete,
			cellAtIndexListener = cellAtIndex,
		}
		util.alignNodeWithPadding(_fastScroll, layer:getContentSize(), display.CENTER)
	end
	local function createRankGrid( )
		local node = CCBCenter.getNodeByTag(_node, 3)
		local function onCellClick( grid, index, item )
			if item.hero.id ~= ME:getUserid() then
				local friendEntity = require("ccb.m.friend.EntityFriend").new(item)
	         	CCBCenter.loadCCB(
	         		"MSG_FRIENDPANELLAYER_MODEL", 
	         		"ccb.c.friend.FriendPanelLayer", 
	         		{
	         			entity = friendEntity, 
		         		key = MSG_ID.MSG_ARENALAYER_MODEL, 
		         		fnNextView = function ( )
		         			CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer", {flag = 3})
		         		end,
		         	}
		         )
			end
		end
		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(node:getContentSize().width, 78))

			-- 背景
			local bgSprite = widget.newSprite{file = "arena/bg_week_rank.png"}
			cell:addChild(bgSprite)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER)

			-- 排名背景 和 奖牌
			if item.hero.rank <= 3 then
				local rankSpriteFile
				local MedalsSpriteFile
				if item.hero.rank == 1 then
					rankSpriteFile = "arena/arena_no1.png"
					MedalsSpriteFile = "arena/arena_nop1.png"
				elseif item.hero.rank == 2 then
					rankSpriteFile = "arena/arena_no2.png"
					MedalsSpriteFile = "arena/arena_nop2.png"
				else
					rankSpriteFile = "arena/arena_no3.png"
					MedalsSpriteFile = "arena/arena_nop3.png"
				end
				local rankSprite = widget.newSprite{file = rankSpriteFile}
				cell:addChild(rankSprite)
				util.alignNodeWithPadding(rankSprite, cell:getContentSize(), display.TOP_LEFT, {left = 5, top = 2,})

				local medalsSprite = widget.newSprite{file = MedalsSpriteFile}
				cell:addChild(medalsSprite)
				util.alignNodeWithPadding(medalsSprite, cell:getContentSize(), display.BOTTOM_LEFT, {left = 10, bottom = 4,})
			end

			-- 积分图标
			local pointsIcon = widget.newSprite{file = "arena/img_week_score.png"}
			cell:addChild(pointsIcon)
			util.alignNodeWithPadding(pointsIcon, cell:getContentSize(), display.BOTTOM_LEFT, {left = 58, bottom = 6,})

			-- 排名文字
			local rankLabel = ui.newTTFLabel{text = item.hero.rank, color = ccc3(25, 25, 112), size = 26}
			cell:addChild(rankLabel)
			util.alignNodeWithPadding(rankLabel, cell:getContentSize(), display.TOP_LEFT, {left = 14, top = 5,})
			util.modifyPositionInAndroid( rankLabel, 2, 4 )

			-- 名字
			local nameLabel = ui.newTTFLabel{text = item.hero.name, color = ccc3(60, 36, 21), size = 26}
			cell:addChild(nameLabel)
			util.alignNodeWithPadding(nameLabel, cell:getContentSize(), display.TOP_LEFT, {left = 62, top = 6,})
			util.modifyPositionInAndroid( nameLabel, 0, 2 )

			-- 积分
			local scroeLabel = ui.newTTFLabel{text = item.score, size = 26}
			cell:addChild(scroeLabel)
			util.alignNodeWithPadding(scroeLabel, cell:getContentSize(), display.BOTTOM_LEFT, {left = 106, bottom = 3 })
			-- util.modifyPositionInAndroid( scroeLabel, 0, 0 )

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		_rankGrid = widget.newScrollGrid{
	        contentSize = node:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(node:getContentSize().width, 79),
	            padding = { 
	                middleH = 4, middleV = 4,
	            },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            selectedParams = nil,
	            tapListener = onCellClick,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = node,
	    }
	    util.autoFixScrollView(_rankGrid)
	end
	-- 创建cd计时器
	local function createCdTimer()
		-- 时间
        _cdTimer = CountDownView.new{ 
            format = "[mm]:[ss]",
            labelParams = {size = 22,},
            listener = function()
            	_cdTimer:stop()
                if _players and #_players > 0 and _node._DATA and _node._DATA.jjcState ~= 1 then
                	_nodeTable.mBtnFight:setEnabled(true)
                end
            end
        }
        CCBCenter.getNodeByTag(_node, 902):addChild(_cdTimer)
        util.alignNodeWithPadding(_cdTimer, CCBCenter.getNodeByTag(_node, 902):getContentSize(), display.CENTER)
	end
	local function comparingDates( date )
		local now = os.time()
		local year, month, day, hour, min, sec = string.match(date, "(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)")
		local newDate = os.time{
			year = year, 
			month = month,
			day = day,
			hour = hour,
			min = min,
			sec = sec,
		}
	 	return now - newDate
	end
	local function createNextRewardTime( )
		_nextTimer = CountDownView.new{ 
            format = _s("ARENA_TIME"),
            labelParams = {size = 20,},
            listener = function()
                _nextTimer:stop()
				CCBCenter.sendLuaMessage(MSG_ID.MSG_ARENAWEEKLAYER_ACTION_ONFETCHWEEKRANKLIST)
            end
        }
        CCBCenter.getNodeByTag(_node, 402):addChild(_nextTimer)
        util.alignNodeWithPadding(_nextTimer, CCBCenter.getNodeByTag(_node, 402):getContentSize(), display.BOTTOM_CENTER, {bottom = 10})
        -- util.modifyPositionInAndroid( _nextTimer, 0, 2 )
	end
	local function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {130050, 130050})
    end
	local function initViews()
		-- 排行
		createRankGrid( )
		-- 滚动对手
		createFastScrollView( )
		-- 计时器
		createCdTimer()
		-- 对战按钮
		_nodeTable.mBtnFight:setEnabled(false)
		-- 领取按钮
		_nodeTable.mBtnReceive:setEnabled(false)
		-- 显示下一场时间
		createNextRewardTime( )
		CCBCenter.getNodeByTag(_node, 402):setVisible(false)
		checkHelperInfo( )
	end

--[[ ## public fuction --]]
	function M.startScrollToIndex( )
		_nodeTable.mBtnFight:setEnabled(false)
		_nodeTable.btnBack:setEnabled(false)
		math.randomseed(os.time())
		_fastScroll:startScrollToIndex(math.random(#_players))
		CCBCenter.getNodeByTag(_node, 1204):stopAllActions()
		playArrowStartAnim(CCBCenter.getNodeByTag(_node, 1204))
		playArrowStartAnim(CCBCenter.getNodeByTag(_node, 1205), true)
	end
	function M.updateData( data )
		_node._DATA = data
		_players = {}
		for i,v in ipairs(data.players) do
			-- 未了防止脏数据 -__-|||
			if v.hero.id ~= ME:getUserid() and v.hero.name ~= ME:getName() then
				-- table.insert(_players, v)
				_players[#_players + 1] = v
			end
		end
		_fastScroll:setItems(_players)
		_rankGrid:setItems(data.top10players)
		_nodeTable.mScroeLabel:setString(_s("ARENA_MY_SCROE") .. data.jjcScore)
		_nodeTable.mRankLabel:setString(_s("ARENA_MY_RANK") .. data.curRank)
		_nodeTable.mSeasonLabel:setString(string.format(_s("ARENA_SEASON"), data.curGameNum))
		_nodeTable.mLastRankLabel:setString(data.upRank)

		if data.spareTime == "0" then
			_nodeTable.btnBuyCd:setEnabled(false)
		else
			_nodeTable.btnBuyCd:setEnabled(true)
		end

		_cdTimer:start(data.spareTime)
		_nodeTable.mBtnFight:setEnabled(#_players > 0 and data.spareTime == "0")
		_nodeTable.mBtnReceive:setEnabled(data.reward == TRUE)

		-- 竞技场状态
		
		if data.jjcState == 1 then
			-- 休战中
			_node:setButtonTitle("btnFight", _s("ARENA_TRUCE_IN"), nil, CCControlStateDisabled)
			_nodeTable.mBtnFight:setEnabled(false)
			_nodeTable.btnBuyCd:setEnabled(false)
			_nodeTable.mNextTimeTitleLabel:setString(_s("ARENA_SEASON_START"))
		else
			_node:setButtonTitle("btnFight", _s("ARENA_COOLING"), nil, CCControlStateDisabled)
			-- 开始中
			_nodeTable.mNextTimeTitleLabel:setString(_s("ARENA_SEASON_END"))
		end

		-- 显示到下个赛季的时间
		-- local time = comparingDates(data.getNextRewardTime)
		local time = tonumber(data.getNextRewardTime)
		if data.reward == FALSE then
			CCBCenter.getNodeByTag(_node, 402):setVisible(true)
			_nextTimer:start(math.abs(time))
		end
	end
	function M.reloadCdTimer( )
		_cdTimer:stop(0)
		_cdTimer:modifyTime(0)
		if _players and #_players > 0 and _node._DATA and _node._DATA.jjcState ~= 1 then
	    	_nodeTable.mBtnFight:setEnabled(true)
	    end
	end
	local function doFightClick( )
		local doAntiPlug = math.random(TRUE, 6)
		if doAntiPlug == TRUE then
			CCBCenter.loadCCB("MSG_ANTIPLUGALERTLAYER_MODEL", "ccb.c.common.AntiPlugAlertLayer", {onComplete = _node.startScrollToIndex})
		else
			_node.startScrollToIndex()
		end
	end
--[[ ## MAINs --]]
	initViews()
	_node.startScrollToIndex = M.startScrollToIndex
	_node.updateData = M.updateData
	_node.reloadCdTimer = M.reloadCdTimer
	_node.doFightClick = doFightClick
end

return M