--ArmyAlertLayer.lua
local M = {}

local ChatUtil                  = require("ccb.m.chat.ChatUtil")

function M.bindView(node, luaValue)
	local TAG = "[ArmyAlertLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = _node._DATA

	local _contentNode
	-- 军团名输入框
    local _ebArmy    			= nil

    local MAX_LENGTH    = 10

	local MAX_ARMYLV = 30

    local _armyLvUpProgressBar

	--创建军团名字内容
	local function createArmyNameEditBox( ... )

		local nameLayer = CCBCenter.getNodeByTag(_node, 4)

		_ebArmy = widget.newEditBox{
            contentSize = CCSizeAdd(nameLayer:getContentSize(), 0, -6),
            normalBgImage = {file = "hook_ac.png"},
            placeHolderText = _s("ARMY_CREATE_CONFIRM"),
            -- textMaxLength   = 100,
            x = nameLayer:getPositionX() ,
            y = nameLayer:getPositionY() ,
            textMaxLength 	= MAX_LENGTH,
        }

			--_ebArmy:setPosition(nameLayer:getPositionX(),nameLayer:getPositionY())
			--util.alignNode(_ebArmy,nameLayer)
		_node:addChild(_ebArmy, 100,100)
	end

	--创建军团公告输入框
	local function createNoticeEditBox( ... )

		local noticeLayer = CCBCenter.getNodeByTag(_node, 4)

		_ebArmy = widget.newEditBox{
            contentSize = CCSizeAdd(noticeLayer:getContentSize(), 0, -6),
            normalBgImage = {file = "hook_ac.png"},
            -- placeHolderText = _s("ARMY_NOTICE_NOMAL"),
            -- textMaxLength   = 100,
            x = noticeLayer:getPositionX() ,
            y = noticeLayer:getPositionY() ,
            textMaxLength 	= MAX_LENGTH * 3,
        }
		--util.alignNode(_ebArmy,noticeLayer)
		_node:addChild(_ebArmy, 100,100) 
		_ebArmy:setVisible(false)

		if _data.oldNotice and _data.oldNotice ~= "" then
			_ebArmy:setText(_data.oldNotice)
			--_ebArmy:setPlaceHolder(_data.oldNotice)
		else 
			_ebArmy:setText(_s("ARMY_NOTICE_NOMAL"))
			--_ebArmy:setPlaceHolder(_s("ARMY_NOTICE_NOMAL"))
		end
		_ebArmy:setVisible(true)
	end

	local function getArmyName( ... )
		return _ebArmy:getText()
	end

	local function createArmyAppointProgressBar( ... )

		CCBCenter.getNodeByTag(_node, 20501):removeAllChildrenWithCleanup(true)

		_armyLvUpProgressBar = widget.newProgressBar{ 
            frontSprintParams = {file = "army/img_progressbar_army_lv_up.png",},
            bgSprintParams = {file = "army/bg_progressbar_army_lv_up.png"},
            ttfLabelParams = { size = 18, padding = { top = top } }
        }

        util.alignNode(_armyLvUpProgressBar,CCBCenter.getNodeByTag(_node, 20501))
       CCBCenter.getNodeByTag(_node, 20501):addChild(_armyLvUpProgressBar)

        _armyLvUpProgressBar:setPercentage(0)
        _armyLvUpProgressBar:setString("")

        local params = {{text = _s("ARMY_EXP_NEED"), size = 25 , color = BUTTON_COLOR3.BROWN},
        		"army/img_army_build.png",
                {text =_data.nextApoint, size = 25, color = BUTTON_COLOR3.BROWN}}

        local  linearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(linearLabel, CCBCenter.getNodeByTag(_node, 20501),display.CENTER)
        CCBCenter.getNodeByTag(_node, 20501):addChild(linearLabel,10000)
	end

    local function createLvUpInfo( ... )

		CCBCenter.getNodeByTag(_node, 20502):removeAllChildrenWithCleanup(true)
		CCBCenter.getNodeByTag(_node, 20503):removeAllChildrenWithCleanup(true)

		local nextLv = _data.armylv + 1

		if _data.armylv == MAX_ARMYLV then
			nextLv = MAX_ARMYLV
		end

		local params = {{text = "LV ".._data.armylv, size = 25},
                    "equipment/blacksmith/img_equipment_lvTo.png",
                    {text = "LV "..nextLv, size = 25}}


        local  linearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(linearLabel, CCBCenter.getNodeByTag(_node, 20502),display.CENTER)
        CCBCenter.getNodeByTag(_node, 20502):addChild(linearLabel)

        local params = {{text = _s("ARMY_EXP_NOW"), size = 25},
        		"army/img_army_build.png",
                    {text =_data.apoint, size = 25}}

        local  linearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(linearLabel, CCBCenter.getNodeByTag(_node, 20503),display.CENTER)
        CCBCenter.getNodeByTag(_node, 20503):addChild(linearLabel)

        createArmyAppointProgressBar()
	end

	local function runProgressbar( properties )
		if _armyLvUpProgressBar then
			_armyLvUpProgressBar:runProgressTo(0.5,100,false,nil,
                        function (progressBar,percentage,totalPercentage)

                            if _data.isArmyLvUp then
                            	NetHelper.QuickToast(_s("ARMY_LV_UP_SUCCESS"),true,1)
						    	util.delayCall(
						            function ( )
						            	_node._DATA.armylv = properties.armylv
						            	_node._DATA.apoint = properties.apoint
						            	_node._DATA.nextApoint = properties.nextpoint
						            	createLvUpInfo()
						            end, 1
						        )	
                        	elseif _data.isArmyShopLvUp then
                            	NetHelper.QuickToast(_s("ARMY_SHOP_LV_UP_SUCCESS"),true,1)
						    	util.delayCall(
						            function ( )
						            	_node._DATA.armylv = properties.shoplv
						            	_node._DATA.apoint = properties.apoint
						            	_node._DATA.nextApoint = properties.nextpoint
						            	createLvUpInfo()
						            end, 1
						        )	
                            end
                        end)
		end
	end

--[[ ## local fuction --]]
	local function initViews()

		if _data.isCreate then
			--创建军团
			_nodeTable["btnCommit_1"]:setVisible(true)
			_nodeTable["btnCancel"]:setVisible(true)
			_nodeTable["mCreateTitleLabel"]:setString(_s("ARMY_CREATE_CONTENT",_data.createDiamond))
			CCBCenter.getNodeByTag(_node, 202):setVisible(true)
			createArmyNameEditBox()
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_CREATE_TITLE"))
		elseif _data.isApply then
			--申请
			_nodeTable["btnCommit_2"]:setVisible(true)
			CCBCenter.getNodeByTag(_node, 203):setVisible(true)
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_APPLY_TITLE"))
			_nodeTable["mApplyContentLabel"]:setString(_s("ARMY_ADD_SUCCESS"))
		elseif _data.isNotice then
			_nodeTable["btnCommit_1"]:setVisible(true)
			_nodeTable["btnCancel"]:setVisible(true)
			--军团公告
			CCBCenter.getNodeByTag(_node, 204):setVisible(true)
			createNoticeEditBox()
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_NOTICE_TITLE"))
			_nodeTable["mNoticeTitleLabel"]:setString(_s("ARMY_NOTICE_WARM"))
		elseif _data.isArmyLvUp then
			_nodeTable["btnCommit_1"]:setVisible(true)
			_nodeTable["btnCancel"]:setVisible(true)
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_LV_UP_TITLE"))
			--军团升级
			CCBCenter.getNodeByTag(_node, 205):setVisible(true)

			createLvUpInfo()
		elseif _data.isQuit then
			_nodeTable["btnCommit_1"]:setVisible(true)
			_nodeTable["btnCancel"]:setVisible(true)
			CCBCenter.getNodeByTag(_node, 203):setVisible(true)
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_QUIT_CONFIRM_TITLE"))
			_nodeTable["mApplyContentLabel"]:setString(_s("ARMY_QUIT_CONFIRM_CONTENT"))
		elseif _data.isArmyShopLvUp then
			_nodeTable["btnCommit_1"]:setVisible(true)
			_nodeTable["btnCancel"]:setVisible(true)
			_nodeTable["mAlertTitleLabel"]:setString(_s("ARMY_SHOP_LV_UP"))
			--军团升级
			CCBCenter.getNodeByTag(_node, 205):setVisible(true)

			createLvUpInfo()
		end
	end

	local function getWordCount( word )
	    local m = string.match( word, "[\128-\255]+")
	    local n = string.match( word, "[%a%d_]+")
	    local count = 0
	    if m and m == word then 
	        count = 1 -- 若是汉字 算5个
	    elseif n == word then
	        count = 1 -- 不是汉字 算3个
	    else 
	        count = -1
	    end

	    return count
	end

	local function getTextCount( textStr )
	    local utextStr = UTF8(textStr)
	    local count = 0
	    if utextStr:len() < 2 then 
	        return utextStr:len()
	    end

	    for i=1,utextStr:len() do
	        local w = utextStr:sub(i,i)
	        local wcount = getWordCount( tostring(w) )
	        if wcount < 0 then 
	            return wcount
	        end
	        count = count + wcount
	    end

	    return count
	end

	-- 是否规范
    local function isCompliance( )
        if ME:getLv() < _data.createLv then
            NetHelper.QuickToast(_s("TEAM_CREATE_LEVEL_NOT_ENOUGH"))
            return false
        elseif ME:getDiamond() < _data.createDiamond then
            NetHelper.QuickToast(_s("TEAM_DIAMOND_NOT_ENOUGH"))
            return false
        elseif getArmyName( ) == "" then
            NetHelper.QuickToast(_s("ARMY_CREATE_CONFIRM"))
            return false
        elseif ChatUtil.getTextCount2(getArmyName( )) > 30 then
            NetHelper.QuickToast(_s("TEAM_NAME_OVERFLOW"))
            return false
        else
            return true
        end
    end
    --公告是否规范
    local function isNoticeCompliance( ... )
    	if getTextCount(getArmyName( )) > 30 then
    		NetHelper.QuickToast(_s("ARMY_NOTICE_LONG"))
            return false
         elseif getArmyName( ) == "" then
            NetHelper.QuickToast(_s("ARMY_NOTICE_NIL"))
            return false
        else
            return true
        end
    end

--[[ ## public fuction --]]
	--获取军团名称
	_node.getArmyName = getArmyName
	--是否规范
	_node.isCompliance = isCompliance
	--公告是否规范
	_node.isNoticeCompliance = isNoticeCompliance
	--进度条滚动
	_node.runProgressbar = runProgressbar
	--等级提升数据
	_node.createLvUpInfo = createLvUpInfo
--[[ ## MAINs --]]
	initViews()
end

return M