--ArmyBossLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyBossLayerView]"
	local _node, _nodeTable = node, luaValue

	--击杀按钮
	local _fightBtn
	--创建顶部BossGrid
	local _topGrid
	--bossGrid
	local _bossGrid
	--选中的index
	local _selectIndex = 1

	local _mBossList

	local _mTopButtoms
	--选中白点
	local _selectedImg
	local _oldX

	local _bossNo
	--血量进度条
	local _hpProgressBar

	local bossRewards

	local _bossName
	--选中的BOSS编号
	local _selectedBossNo
	--当前攻打的boss
	local _currentFightBoss

	local action

	--创建击杀按钮
	local function createFightBtn( attackNum,attackPrice,armylv )

		local function fight( attackNum,attackPrice,fightBtn )
			local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")         -- 战斗视图工厂
            local friendId                  = ""                    -- 好友ID
            local friendName                = ""
            local fnNextView                = ""

			

	        if attackNum > 0 then
	        	-- -- 场景转换
	            local scene = require("view.Fight.Scene.FightScene").new({  mode = {battle = MODE_BATTLE_ARMY_BOSS},no = _bossNo,fnNextView = function ( )        
	                                CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
	                                CCBCenter.loadCCB("MSG_ARMYMAINLAYER_MODEL", "ccb.c.army.ArmyMainLayer")
	                                CCBCenter.loadCCB("MSG_ARMYBOSSLAYER_MODEL", "ccb.c.army.ArmyBossLayer",{currentLV = _node.currentLv})
	                        end, })
	        	NetHelper.showLoading(true, true)
           		CCBCenter.replaceScene(scene)
           	else
           		AlertLayer.new4IAP{
				  	isUserDiamond = true,
				  	diamondIndex = 5,
				    content = _s("USE_DIAMOND_05",attackPrice),
				    btnClickEvent = {
				    	function ( )
				    		-- -- 场景转换
	            			local scene = require("view.Fight.Scene.FightScene").new({  mode = {battle = MODE_BATTLE_ARMY_BOSS},no = _bossNo,fnNextView = function ( )        
	                                CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
	                                CCBCenter.loadCCB("MSG_ARMYMAINLAYER_MODEL", "ccb.c.army.ArmyMainLayer")
	                                CCBCenter.loadCCB("MSG_ARMYBOSSLAYER_MODEL", "ccb.c.army.ArmyBossLayer",{currentLV = _node.currentLv})
	                        end, })
				    		NetHelper.showLoading(true, true)
				        	CCBCenter.replaceScene(scene)
				        end,
				        function ( )

				    		fightBtn.setStateDisabled(false)
				        end,
				    }
				  }
           	end	
           	NetHelper.hideLoading(true)
		end

		local fightBtnNode = _nodeTable["mFightButtons"]
		fightBtnNode:removeAllChildrenWithCleanup(true)
		--击杀按钮
		_fightBtn = widget.newButton{
            scale = 1.1,
            contentSize = fightBtnNode:getContentSize(),
            rect        = CCRectMake(0, 0, 80, 58) , 
            normalImage = "common/buttons/btn_normal_yellow.png",
            selectImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            listener = function ( button )
            	if _node.currentLv < armylv then
            		NetHelper.QuickToast(_s("ARMY_BOSS_LV_WARM", armylv))
            		return
            	end
            	_fightBtn.setStateDisabled(true) 

            	local nextGridX = math.abs(_bossGrid:getContentOffset().x)
            	local index = math.floor(nextGridX / (_mBossList:getContentSize().width / 3))
            	_bossGrid:scrollToItemIndex(_currentFightBoss)
            	if index + 1 == _currentFightBoss then
            		fight( attackNum,attackPrice,_fightBtn )
            	else
            		util.delayCall(function()
                		fight( attackNum,attackPrice,_fightBtn )
		        	end, 1.5)
            	end
            end
        } 
        util.alignNode(_fightBtn, fightBtnNode)
        fightBtnNode:addChild(_fightBtn)

        --击杀图片
        local fightImg = display.newSprite("army/boss/img_army_boss_fight.png")

        --击杀文字Layer
        local fightLayer = widget.newLayer{
            contentSize = CCSize(114,75)
        }
        fightLayer:ignoreAnchorPointForPosition(false)

        --发起攻击
        local fightLabel = widget.newTTFLabelWithShadow{
			text = _s("ARMY_BOSS_FIGHT"),
			size = 20,
			color = BUTTON_COLOR3.BROWN,
			}
		util.alignNode(fightLabel, fightLayer,display.TOP_LEFT,{top = 5})
		fightLayer:addChild(fightLabel)

		if attackNum > 0 then
			--攻击次数
	        local fightTimesLabel = widget.newTTFLabelWithShadow{
				text = _s("ARMY_BOSS_FIGHT_TIMES",attackNum),
				size = 20,
				color = BUTTON_COLOR3.BROWN,
				}
			util.alignNode(fightTimesLabel, fightLayer,display.BOTTOM_LEFT,{bottom = 5})
			fightLayer:addChild(fightTimesLabel)
		else

			local params = {"main/img_main_diamond.png",
				{ text = attackPrice,
		            size = 20,
		            color = BUTTON_COLOR3.BROWN,
	        	}
	        }

	        local  linearLabel = widget.newLinearLabel({paramTable = params})
	        util.alignNode(linearLabel, fightLayer,display.BOTTOM_LEFT,{bottom = 5})
	        fightLayer:addChild(linearLabel,2)
		end

        local params = {fightImg,fightLayer}

        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 12})
        util.alignNode(linearLabel, _fightBtn,display.CENTER_LEFT,{left = 5})
        _fightBtn:addChild(linearLabel,2)

	end

	--创建3个按钮
	local function create3Btns( ... )
		local btnsNode = _nodeTable["mButtons"]
		--排行按钮
		local rankBtn = widget.newButton{
            scale = 1.1,
            contentSize = CCSize(90,77),
            rect        = CCRectMake(0, 0, 80, 58) , 
            normalImage = "common/buttons/btn_normal_yellow.png",
            selectImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            listener = function ( button )
            print(_selectedBossNo)
            print(_selectedBossNo)
            print(_selectedBossNo)
            print(_bossName)
            print(_bossName)
            print(_bossName)
            	--军团动态
        		CCBCenter.loadCCB("MSG_ARMYBOSSRANKLAYER_MODEL", "ccb.c.army.ArmyBossRankLayer",{bossno = _selectedBossNo,bossName = _bossName})
            end
        } 

         --排行文字
        local rankLabel = widget.newTTFLabelWithShadow{
			text = _s("ARMY_BOSS_RANK"),
			size = 20,
			color = BUTTON_COLOR3.BROWN,
			}
		util.alignNode(rankLabel, rankBtn,display.BOTTOM_CENTER,{bottom = 10})
		rankBtn:addChild(rankLabel,2)

		 --击杀图片
        local rankImg = display.newSprite("main/effect_buttons/btn_main_rank.png")
        rankImg:setScale(0.5)
        util.alignNode(rankImg, rankBtn,display.TOP_CENTER,{top = 10})
		rankBtn:addChild(rankImg,2)

		--奖励预览按钮
        local rewardBtn = widget.newButton{
            scale = 1.1,
            contentSize = CCSize(90,77),
            rect        = CCRectMake(0, 0, 80, 58) , 
            normalImage = "common/buttons/btn_normal_yellow.png",
            selectImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            listener = function ( button )

        		if bossRewards then 

        			--奖励预览串
					local rewardEntity = require("model.main.RewardEntity").new(bossRewards)
					CCBCenter.loadCCB(
				            "MSG_SPECIALMAPREWARDPREVIEWLAYER_MODEL", 
				            "ccb.c.specialMap.SpecialMapRewardPreviewLayer", 
				            {
				                entity = rewardEntity,
				                title = _s("ARMY_BOSS_KILL_REWARD",_bossName)
				            }
				        )
        		end
            end
        }

         --奖励预览文字
        local rewardLabel = widget.newTTFLabelWithShadow{
			text = _s("ARMY_BOSS_REWARD"),
			size = 20,
			color = BUTTON_COLOR3.BROWN,
			}
		util.alignNode(rewardLabel, rewardBtn,display.BOTTOM_CENTER,{bottom = 10})
		rewardBtn:addChild(rewardLabel,2)

		 --奖励预览图片
        local rewardImg = display.newSprite("team/img_cross_server_reward.png")
        rewardImg:setScale(0.5)
        util.alignNode(rewardImg, rewardBtn,display.TOP_CENTER,{top = 5})
		rewardBtn:addChild(rewardImg,2)

		--说明按钮
        local noticeBtn = widget.newButton{
            scale = 1.1,
            contentSize = CCSize(90,77),
            rect        = CCRectMake(0, 0, 80, 58) , 
            normalImage = "common/buttons/btn_normal_yellow.png",
            selectImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            listener = function ( button )

               CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isArmyBoss = true,})
            end
        }

         --说明文字
        local noticeLabel = widget.newTTFLabelWithShadow{
			text = _s("ARMY_BOSS_WARM_TITLE"),
			size = 20,
			color = BUTTON_COLOR3.BROWN,
			}
		util.alignNode(noticeLabel, noticeBtn,display.BOTTOM_CENTER,{bottom = 10})
		noticeBtn:addChild(noticeLabel,2)

		--说明图片
        local noticeImg = display.newSprite("team/img_cross_server_rule.png")
        noticeImg:setScale(0.5)
        util.alignNode(noticeImg, noticeBtn,display.TOP_CENTER,{top = 5})
		noticeBtn:addChild(noticeImg,2)

        local params = {rankBtn,rewardBtn,noticeBtn}

        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 10})
        util.alignNode(linearLabel, btnsNode,display.CENTER)
        btnsNode:removeAllChildrenWithCleanup(true)
        btnsNode:addChild(linearLabel)
	end

	--设置Boss血量进度条
	local function setBossHpProgressBar( hp,totalHp )
		local mProgressBar = _nodeTable["mBossBlood"]
		mProgressBar:removeAllChildrenWithCleanup(true)
		--经验进度条
        _hpProgressBar = widget.newProgressBar{
            frontSprintParams = {file = "army/boss/img_hp_progressbar.png",},
            bgSprintParams = {file = "army/boss/bg_hp_progressbar.png"},
            ttfLabelParams = {size = 14/SCALE_FOR_SPECIAL_NODE, padding = {top = 3}},
        }
        util.alignNode(_hpProgressBar, mProgressBar)
        mProgressBar:addChild(_hpProgressBar)
     	_hpProgressBar:setPercentage(0)
     	if math.floor(hp / totalHp * 100) == 0 and hp ~= 0 then
     		_hpProgressBar:setPercentage( 1)
     	else
     		_hpProgressBar:setPercentage( math.floor(hp / totalHp * 100))
     	end
	end
	--选中BOSS
	local function bossSelected( item )
		-- if _fightBtn then
	 --    	if item.status == 1 then
	 --    		_fightBtn:setVisible(true)
	 --    	else
	 --    		_fightBtn:setVisible(false)
	 --    	end
	 --    end
    	_selectIndex = item.bossSortNo
    	_selectedBossNo = item.bossNo

    	setBossHpProgressBar(item.hp,item.totalhp)

    	bossRewards = item.Rw

    	_bossName = item.bossName
	end

	--创建顶部BossGrid
	local function createArmyBossMinGrid( ... )
		
		local function createItemCellListener(grid, index, item)

            local cell = widget.newLayer{contentSize = CCSize( _mTopButtoms:getContentSize().width / 10, _mTopButtoms:getContentSize().height)}

            local bossImgPath = string.format(CARD_ICON, item.showno)
            --boss图片
	        local bossMinImg = display.newSprite(bossImgPath)
	        bossMinImg:setScale(0.5)
	        util.alignNode(bossMinImg, cell,display.TOP_CENTER,{top = 10})
			cell:addChild(bossMinImg)

			if item.bossSortNo == _selectIndex then
				 --选中图片
		        _selectedImg = display.newSprite("army/boss/img_army_boss_selected.png")
		        util.alignNode(_selectedImg, cell,display.BOTTOM_CENTER,{bottom = 5})
				cell:addChild(_selectedImg)
				_oldX = _selectedImg:getPositionX()
			end

			if item.status == 0 then
				--已击杀
	 			local bossKilled = display.newSprite("army/boss/img_army_boss_fighted.png")
	 			bossKilled:setScale(0.5)
		        util.alignNode(bossKilled, bossMinImg)
				bossMinImg:addChild(bossKilled)
			elseif item.status == 1 then
				local particle = CCParticleSystemQuad:create("army/boss/topFire.plist")
	            local particleBatch = CCParticleBatchNode:createWithTexture(particle:getTexture())
	            particleBatch:addChild(particle)
	            particleBatch:setScale(0.1)
	            util.alignNode(particleBatch, cell,display.CENTER)
	            cell:addChild(particleBatch)
			elseif item.status == 2 then
				--不可攻击
				local bossNoKill = display.newSprite("army/boss/img_army_boss_no_fight.png")
		        util.alignNode(bossNoKill, cell)
		        bossNoKill:setScale(0.3)
				cell:addChild(bossNoKill)
			end

            return cell
        end

        local function tapListener( grid,index,item )
        	_bossGrid:stopAllActions()
        	_bossGrid:scrollToItemIndex(index, 1.0)
        	action = _bossGrid:schedule(function ( ... )
        		_bossGrid:scrollToItemIndex(index, 0)
        		if action then
        			_bossGrid:removeAction(action)
        		end
        	end, 1.0)

			--bossSelected(item)
        end

         --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _mTopButtoms:getContentSize(),
            cellSize = CCSize( _mTopButtoms:getContentSize().width / 10, _mTopButtoms:getContentSize().height),
            column = 10,
            row = 1,
            createItemCellListener = createItemCellListener,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            tapListener = tapListener,
        }
        _mTopButtoms:addChild(scrollGrid)

        return scrollGrid
	end
	--创建BossGrid
	local function createArmyBossGrid( ... )

		local function nodeScroll(  )
			
			local nextGridX = math.abs(_bossGrid:getContentOffset().x)
			
			local nextGridX_1 = (_mTopButtoms:getContentSize().width / 10)  /  (_mBossList:getContentSize().width / 3) * nextGridX

			if _selectedImg then
				_selectedImg:setPositionX(_oldX + nextGridX_1)
			end

			local index = nextGridX / (_mBossList:getContentSize().width / 3)
			if index > 0 then
				index = math.floor(index)
				bossSelected(_topGrid:itemAt(1,index + 1))
			end
		end

		_node:scheduleUpdate(nodeScroll)
		local function createItemCellListener(grid, index, item)
            local cell = widget.newLayer{contentSize = CCSize( _mBossList:getContentSize().width / 3, _mBossList:getContentSize().height)}

            if item and item.status then


            	local bossBg1 = display.newSprite("army/boss/bg_army_boss_1.png")
				bossBg1:setScale(0.9)
				util.alignNode(bossBg1, cell,display.CENTER)
            	cell:addChild(bossBg1)
            	
				local bossBg = widget.newScale9{ 
					file = "army/boss/bg_army_boss.png", 
	                contentSize = CCSize(238,315),
	                capInsets = CCRectMake(20, 30,10, 10),
            	}
	            util.alignNode(bossBg, bossBg1,display.CENTER,{top = 10})
	            bossBg1:addChild(bossBg)



	            local bossImgPath = string.format(CARD_IMAGEEX, item.showno)
	            --Boss图片
		        local bossMinImg = display.newSprite(bossImgPath)
		         bossMinImg:setScale(1.08)
		        util.alignNode(bossMinImg, bossBg)
				bossBg:addChild(bossMinImg)

				if item.status == 0 then
					--已击杀
		 			local bossKilled = display.newSprite("army/boss/img_army_boss_fighted.png")
			        util.alignNode(bossKilled, bossBg)
					bossBg:addChild(bossKilled)
				elseif item.status == 1 then
					local particle = CCParticleSystemQuad:create("army/boss/topFire.plist")
		            local particleBatch = CCParticleBatchNode:createWithTexture(particle:getTexture())
		            particleBatch:addChild(particle)
		            util.alignNode(particleBatch, bossBg,display.BOTTOM_CENTER)
		            bossBg:addChild(particleBatch)

		            local apoint = display.newSprite("army/img_army_build.png")
					-- apoint:setScale(1.5)

					local killRewardTitle = widget.newTTFLabelWithShadow{

			                color           = display.COLOR_WHITE,
			                text            = _s("ARMY_BOSS_KILL"),       -- 标签文字
			                size            = 25,                                    -- 字体大小
			            }
			        local layer1 = widget.newLayer{
		            	contentSize = killRewardTitle:getContentSize()
		            }
		             util.alignNode(killRewardTitle, layer1)
		            layer1:addChild(killRewardTitle)
		            layer1:ignoreAnchorPointForPosition(false)
			         
			        local killReward = widget.newTTFLabelWithShadow{
			                color           = display.COLOR_WHITE,
			                text            = item.bpoint,       -- 标签文字
			                size            = 25,                                    -- 字体大小
			            }
			         local layer2 = widget.newLayer{
		            	contentSize = killReward:getContentSize()
		            }
		             util.alignNode(killReward, layer2)
		            layer2:addChild(killReward)
		            layer2:ignoreAnchorPointForPosition(false)


					local params = {layer1,
			            apoint,
			            layer2}

			        local  linearLabel = widget.newLinearLabel({paramTable = params})
			        util.alignNode(linearLabel, bossBg,display.CENTER)
					bossBg:addChild(linearLabel)
				elseif item.status == 2 then
					--不可攻击
					local bossNoKill = display.newSprite("army/boss/img_army_boss_no_fight.png")
			        util.alignNode(bossNoKill, bossBg)
					bossBg:addChild(bossNoKill)
				end

				-- local bossIndex = ui.newTTFLabel{
				-- 	text = item.bossSortNo,
				-- 	size = 30,
				-- 	}
				-- util.alignNode(bossIndex, bossBg,display.TOP_LEFT,{top = 20,left = 30})
				-- bossBg:addChild(bossIndex)

				local bossName = widget.newTTFLabelWithShadow{
			                color           = display.COLOR_WHITE,
			                text            = item.bossName,       -- 标签文字
			                size            = 30,                                    -- 字体大小
			            }

				-- local bossName = ui.newTTFLabel{
				-- 	text = item.bossName,
				-- 	size = 30
				-- 	}
				util.alignNode(bossName, bossBg,display.TOP_CENTER,{top = 20})
				bossBg:addChild(bossName)

			end

            return cell
        end

        local function tapListener( grid,index,item )
        	if item and item.armylv then
        		NetHelper.QuickToast(_s("ARMY_BOSS_LV_WARM",item.armylv))
        	end
        end

         --scrollview
		local scrollGrid = widget.newScrollGrid{
			contentSize = _mBossList:getContentSize(),
			contentParams = {
			    cellSize = CCSize(_mBossList:getContentSize().width /3, _mBossList:getContentSize().height ),
			    padding = {
			    	middleV = 1
				},
			    row = 1,
			    createItemCellListener = createItemCellListener,
			    tapListener = tapListener,
			 },
			direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
			parentNode = _mBossList,
			bounceable = false,
	    }

        return scrollGrid
	end
	--刷新列表
	local function reloadBossGrid( properties )

		_topGrid:setItems(properties.bossList)
		_currentFightBoss = 1
		local t = {{}}
		local count = 0
		for i,v in ipairs(properties.bossList) do
			table.insert(t,v)
			if v.status == 1 then
				_bossNo = v.bossNo
				_currentFightBoss = i 
				bossRewards = v.Rw
				_bossName = v.bossName
				_selectedBossNo = v.bossNo
			elseif v.status == 2 then
				count = count + 1
			end

			if _selectedBossNo == nil and count == 1 then

				_currentFightBoss = i 
				bossRewards = v.Rw
				_bossName = v.bossName
				_selectedBossNo = v.bossNo
			end
		end
		table.insert(t,{})
		_bossGrid:setItems(t)
		_bossGrid:scrollToItemIndex(_currentFightBoss)

		--创建战斗按钮
		if _bossNo then
			createFightBtn(properties.attackNum,properties.attackPrice,t[_currentFightBoss + 1].armylv)
		end

		setBossHpProgressBar(properties.bossList[1].hp,properties.bossList[1].totalhp)
	end

--[[ ## local fuction --]]
	local function initViews()
		_mTopButtoms = _nodeTable["mTopButtoms"]
		_mBossList = _nodeTable["mBossList"]
		--创建三个按钮
		create3Btns()
		--创建顶部BossGrid
		_topGrid = createArmyBossMinGrid()

		--创建Boss大图
		_bossGrid = createArmyBossGrid()
	end

--[[ ## public fuction --]]
	--刷新列表
	_node.reloadBossGrid = reloadBossGrid

--[[ ## MAINs --]]
	initViews()
end

return M