--ArmyBossRankLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyBossRankLayerView]"
	local _node, _nodeTable = node, luaValue

	local _rankGrid

	local function createRankGrid( ... )
		local layer = _nodeTable["mRank"]
		
	    local function createItemCellListener(grid, index, item)

	    	 local cell = widget.newLayer{contentSize = CCSize(layer:getContentSize().width,
                layer:getContentSize().height / 7)}

        	  --排行文字
	        local rankLabel = widget.newTTFLabelWithShadow{
				text = index.."."..item.palyerNmae,
				size = 30,
				}
			util.alignNode(rankLabel, cell,display.CENTER_LEFT,{left = 10})
			cell:addChild(rankLabel,2)

			 --排行文字
	        local hurtLabel = widget.newTTFLabelWithShadow{
				text = item.attackTotal,
				size = 30,
				}
			util.alignNode(hurtLabel, cell,display.CENTER_RIGHT,{right = 10})
			cell:addChild(hurtLabel,2)

			 local lineSprite = widget.newScale9{ file = "diamondalert/img_line.png", contentSize = CCSize(341,3),}
            cell:addChild(lineSprite, 0)
            util.alignNode(lineSprite, cell,display.BOTTOM_CENTER)

        	return cell

	    end	

		  --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = layer:getContentSize(),
            contentParams = {
                cellSize = CCSize(layer:getContentSize().width , layer:getContentSize().height / 7 ),
                column = 1,
                createItemCellListener = createItemCellListener, 
             },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = layer,
        }

		return scrollGrid
	end

	local function reloadRankGrid( properties )
		_rankGrid:setItems(properties.bossList)
	end

--[[ ## local fuction --]]
	local function initViews()
		_rankGrid = createRankGrid()
	end

--[[ ## public fuction --]]
_node.reloadRankGrid = reloadRankGrid
--[[ ## MAINs --]]
	initViews()
end

return M