--ArmyBuildLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyBuildLayerView]"
	local _node, _nodeTable = node, luaValue

	local _buildTimesGrid

    local _contentOffSet

	--建设次数
	local _count

	-- 创建建设grid
	local function createBuildGrid( buildLyer,count )

		local function createItemCellListener(grid, index, item)
            local cell = widget.newLayer{contentSize = CCSize( buildLyer:getContentSize().width / count, buildLyer:getContentSize().height)}
            cell:ignoreAnchorPointForPosition(true)

         	local armyBg = widget.newScale9{ 
				file = "army/bg_army_shop.png", 
                contentSize = cell:getContentSize(),
                capInsets = CCRectMake(20, 60,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)

             --活动名称
            local countLabel = ui.newTTFLabel{
				text = item.bname,
				size = 30,
				color = COLOR3.BLACK,
				}
			util.alignNode(countLabel, armyBg,display.TOP_CENTER,{top = 10})
			armyBg:addChild(countLabel)


			local buildImgLyer = widget.newLayer{
            	contentSize = CCSize(180,180)
            }

            util.alignNode(buildImgLyer,armyBg,display.TOP_CENTER,{top = 70})
			armyBg:addChild(buildImgLyer)

			--图片背景
			local buildImgBg = widget.newScale9{ 
				file = "army/bg_army_talent_introduce.png", 
                contentSize = CCSize(195,195),
            }
            util.alignNode(buildImgBg, buildImgLyer)
            buildImgLyer:addChild(buildImgBg)

            local imgPath = "army/img_army_activity_2.png"

            if item.bno ~= 0  then
            	imgPath = "army/img_army_material_"..item.bno..".png"
            end

            --材料图片
            local materialSprite = widget.newSprite{
                file = imgPath,
            }
            materialSprite:setScale(121 / materialSprite:getContentSize().width)
            buildImgBg:addChild(materialSprite, 1)
            util.alignNode(materialSprite, buildImgBg:getContentSize(), display.TOP_CENTER,{top = 5}) 

            --获得的建设度
            local params = {{text = _s("ARMY_BUILD_GET"), size = 20,color = BUTTON_COLOR3.BROWN},
            "army/img_army_build.png",
            {text = item.bpoint, size = 20,color = BUTTON_COLOR3.BROWN}}

	        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 5})
	        util.alignNode(linearLabel, buildImgBg,display.BOTTOM_LEFT,{bottom = 40,left = 35})
	        buildImgBg:addChild(linearLabel)

            --获得的贡献度
            local params = {{text = _s("ARMY_BUILD_GET"), size = 20,color = BUTTON_COLOR3.BROWN},
            "army/img_army_my_contribute.png",
            {text = item.bcredit, size = 20,color = BUTTON_COLOR3.BROWN}}

	        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 5})
	        util.alignNode(linearLabel, buildImgBg,display.BOTTOM_LEFT,{bottom = 5,left = 35})
	        buildImgBg:addChild(linearLabel)

            --所需花费layer
            local costLyer = widget.newLayer{
            	contentSize = CCSize(180,35)
            }

            util.alignNode(costLyer,armyBg,display.BOTTOM_CENTER,{bottom = 80})
			armyBg:addChild(costLyer)

            --花费背景
			local costBg = widget.newScale9{ 
				file = "army/bg_army_talent_introduce.png", 
                contentSize = CCSize(147,40),
            }
            util.alignNode(costBg, costLyer)
            costLyer:addChild(costBg)

            --所需花费
            local costLabel = ui.newTTFLabel{
				text = item.sprice,
				size = 20,
				color =  COLOR3.BLACK
				}
			util.alignNode(costLabel, costBg,display.CENTER_RIGHT,{right = 5})
			costBg:addChild(costLabel)

			local minImg = "army/img_gold.png"

			if item.btyp == 2 then
				minImg = "army/img_diamond.png"
			elseif item.btyp == 3 then
				minImg = "army/img_army_minMaterial_"..item.bno..".png"
			end	
			 --花费材料
            local materialSprite = widget.newSprite{
                file = minImg,
            }
            costBg:addChild(materialSprite, 1)
            util.alignNode(materialSprite, costBg:getContentSize(), display.CENTER_LEFT,{left = 5}) 

            --建设按钮
            local buildBtn = widget.newButton{
                scale = 1.1,
                contentSize = CCSize(141,58),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { 
                	size = 30,text = _s("ARMY_BUILD") , 
                	color = BUTTON_COLOR3.BROWN, 
                },
                listener = function ( button )
                	if item.btyp == 3 then
                        _contentOffSet = _buildTimesGrid:getScrollView():getContentOffset()
                		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILD,nil,{buildid = item.bid})
                	else
                        if _count > 0 then
                            if item.btyp == 2 then
                                AlertLayer.new4IAP{
                                    isUserDiamond = true,
                                    diamondIndex = 23,
                                    content = _s("USE_DIAMOND_23",item.sprice),
                                    btnClickEvent = {
                                        function ( )
                                            _contentOffSet = _buildTimesGrid:getScrollView():getContentOffset()
                                            CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILD,nil,{buildid = item.bid})
                                        end,
                                    }
                                  }
                            else
                                _contentOffSet = _buildTimesGrid:getScrollView():getContentOffset()
                                CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYBUILDLAYER_ONFETCHBUILD,nil,{buildid = item.bid})
                            end
                        else
                            NetHelper.QuickToast(_s("ARMY_BUUILD_NO_COUNT"))
                        end
                    end
                end
            }

	        util.alignNode(buildBtn,armyBg,display.BOTTOM_CENTER,{bottom = 10})
			armyBg:addChild(buildBtn)

            return cell
        end

		  --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = buildLyer:getContentSize(),
            cellSize = CCSize( buildLyer:getContentSize().width / count, buildLyer:getContentSize().height ),
            column = count,
            row = 1,
            createItemCellListener = createItemCellListener,
            direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
            tapListener = tapListener,
        }
        buildLyer:addChild(scrollGrid)
        return scrollGrid
	end

	-- 创建建设次数Gtid
	local function createBuildTimesGrid( ... )

		local listNode = _nodeTable["mBuildList"]

        local function createItemCellListener( grid, index, item )

            local cell = widget.newLayer{contentSize = CCSize(263 * #item,467)}
             cell:ignoreAnchorPointForPosition(false)
           	
           	local armyBg = widget.newScale9{ 
				file = "army/bg_army_shop.png", 
                contentSize = cell:getContentSize(),
                capInsets = CCRectMake(20, 60,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)

             --活动名称
            local countLabel = ui.newTTFLabel{
				text = item.title,
				size = 30,
				color = COLOR3.BLACK,
				}
			util.alignNode(countLabel, armyBg,display.TOP_CENTER,{top = 10})
			armyBg:addChild(countLabel)

            local buildLyer = widget.newLayer{
            	contentSize = CCSize(cell:getContentSize().width - 20,385)
            }
            util.alignNodeWithPadding(buildLyer, cell,display.BOTTOM_CENTER,{bottom = 10})
            cell:addChild(buildLyer)

            local buildGrid = createBuildGrid(buildLyer,#item)

            buildGrid:setItems(item)
            return cell

        end

        --scrollview
	    local scrollGrid = widget.newScrollLinear{
	        x = 0,
	        y = 0,
	        contentSize = listNode:getContentSize(),
		    cellAtIndexListener = createItemCellListener,
	        contentParams = {
					            row = 1,
					            tapListener = tapListener,
					            selectedParams = nil,
					        },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	    }
	    listNode:addChild(scrollGrid)
        return scrollGrid
	end

	local function reloadBuildTimesGrid( properties )

		_nodeTable["mDiamondLabel"]:setString(ME:getDiamond())
		_nodeTable["mGoldLabel"]:setString(ME:getGold())
		_nodeTable["mBuildLabel"]:setString(properties.apoint)

        _nodeTable["mMyContributeLabel"]:setString(properties.bcredit)

		_count = properties.count

		local t = {{title = _s("ARMY_BUILD_TIMES",properties.count) },{title = _s("ARMY_BUILD_NO_TIMES")}}

		for i,v in ipairs(properties.armybuildlist) do
			if v.btyp == 3 then
				table.insert(t[2],v)
			elseif v.btyp == 1 or v.btyp == 2 then
				table.insert(t[1],v)
			end
		end

		_buildTimesGrid:setItems(t)
        if _contentOffSet then
            _buildTimesGrid:getScrollView():setContentOffset(_contentOffSet)
        end
	end

--[[ ## local fuction --]]
	local function initViews()
		-- 创建建设次数Gtid
		_buildTimesGrid = createBuildTimesGrid()

		--reloadBuildTimesGrid()
	end

--[[ ## public fuction --]]
	--刷新建设列表
	_node.reloadBuildTimesGrid = reloadBuildTimesGrid
--[[ ## MAINs --]]
	initViews()
end

return M