--ArmyMainLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyMainLayerView]"
	local _node, _nodeTable = node, luaValue

	--军团职务
	local _identity
	--军团活动
	local _armyActivityNode
	--军团活动Grid
	local _armyActivityGrid
	--军团建设值
	local _apoint
	--军团升级所需建设值
	local _nextApoint

	local _isNew

	local _armyLv
	--公告
	local _notice

--[[ ## local fuction --]]
	
	--军团建设值
	local function setArmyPoint( point,nextpoint )

		_nodeTable["mAmryBuild"]:removeAllChildrenWithCleanup(true)
		--{text = _s("ARMY_POINT"), size = 30},
		local params = {
            "army/img_army_build.png",
            {text = point.."/"..nextpoint, size = 30},}

        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 5})
        util.alignNode(linearLabel,_nodeTable["mAmryBuild"] ,display.CENTER_LEFT)
		_nodeTable["mAmryBuild"]:addChild(linearLabel)
	end

	--我的贡献值
	local function setMyContribution( armycontribute )

		_nodeTable["mMyContribution"]:removeAllChildrenWithCleanup(true)
		--{text = _s("ARMY_IDENTITY"), size = 30},
		local params = {
			{text = _s("ARMY_IDENTITY_".._identity), size = 30},
			-- {text = _s("ARMY_MY_CONTRIBUTION"), size = 30},
            "army/img_army_my_contribute.png",
            {text = armycontribute, size = 30},}

        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 5})
        util.alignNode(linearLabel,_nodeTable["mMyContribution"] ,display.CENTER_LEFT)
		_nodeTable["mMyContribution"]:addChild(linearLabel)
	end

	local function reloadArmyActivity( ... )
		local t = {{},{},{},{},{},{},{},{},}
		_armyActivityGrid:setItems(t)
	end 
	
	--设置军团的基本信息
	local function setArmyInfo( info )

		_nodeTable["mArmyMessageNode"]:removeAllChildrenWithCleanup(true)

		--军团名称
		local armyNameLabel = ui.newTTFLabel{
			text =  info.armyname,
			size = 30
			}
		util.alignNode(armyNameLabel,_nodeTable["mArmyMessageNode"] ,display.CENTER_LEFT)
		_nodeTable["mArmyMessageNode"]:addChild(armyNameLabel)

		--军团长
		local leaderNameLabel = ui.newTTFLabel{
			text =  _s("ARMY_LEADER_NAME",info.leadername),
			size = 30
			}
		util.alignNode(leaderNameLabel, _nodeTable["mArmyMessageNode"],display.CENTER)
		_nodeTable["mArmyMessageNode"]:addChild(leaderNameLabel)

		--成员人数
		local armyCountLabel = ui.newTTFLabel{
			text = _s("ARMY_ACOUNT",info.armyplayercount,info.armyplayerlimit),
			size = 30
			}
		util.alignNode(armyCountLabel, _nodeTable["mArmyMessageNode"],display.CENTER_RIGHT)
		_nodeTable["mArmyMessageNode"]:addChild(armyCountLabel)

		_nodeTable["mArmyLvLabel"]:setString("LV"..info.armylv)

		_nodeTable["mArmyNoticeLabel"]:setString(info.armynotice)

		_identity = info.identity

		if _identity == 1 or _identity == 2 then
			_nodeTable["btnArmyLvUp"]:setVisible(true)
			_nodeTable["btnEdit"]:setVisible(true)
		else
			_nodeTable["btnArmyLvUp"]:setVisible(false)
			_nodeTable["btnEdit"]:setVisible(false)
		end

		-- if info.apoint < info.nextpoint then
		-- 	_nodeTable["btnArmyLvUp"]:setEnabled(false)
		-- else
		-- 	_nodeTable["btnArmyLvUp"]:setEnabled(true)
		-- end

		-- setArmyPoint(info.apoint,info.nextpoint)
		_nodeTable["mArmyBuildLabel"]:setString(info.apoint)

		-- setMyContribution(info.armycontribute)
		_nodeTable["mMyContributeLabel"]:setString(info.armycontribute)

		_nodeTable["mIndextityLabel"]:setString( _s("ARMY_IDENTITY",_s("ARMY_IDENTITY_".._identity)) )

		_apoint = info.apoint
		_nextApoint = info.nextpoint

		_isNew = info.isnew 

		_armyLv = info.armylv

		_notice = info.armynotice

		reloadArmyActivity()
	end

	--军团活动grid
	local function createArmyActivityGrid( ... )
		local function createItemCellListener(grid, index, item)

            local cell = widget.newLayer{contentSize = CCSize( _armyActivityNode:getContentSize().width / 4, _armyActivityNode:getContentSize().height / 2)}

             --活动按钮
            local activityBtn = widget.newButton{
                scale = 1.1,
                normalImage = "army/bg_army_activity.png",
                selectImage = "army/bg_army_activity.png",
                disableImage = "army/bg_army_activity.png",
                cancelOnMove = true,
                swallowsTouches = false,
            }

            cell:addChild(activityBtn, 1)
            util.alignNode(activityBtn, cell:getContentSize(), display.CENTER) 

            local activitySprite = widget.newSprite{
                file = "army/img_army_activity_"..index..".png",
            }
            activityBtn:addChild(activitySprite, 1)
            util.alignNode(activitySprite, activityBtn:getContentSize(), display.CENTER) 

            --军团活动背景
            local activityNameBg = widget.newScale9{ 
				file = "army/bg_army_development.png", 
                contentSize = CCSize(162,41),
                --capInsets = CCRectMake(50, 10,10, 10),
            }
            util.alignNode(activityNameBg, activityBtn,display.BOTTOM_CENTER)
            activityBtn:addChild(activityNameBg,2)

            --活动名称
            local activityNameLabel = ui.newTTFLabel{
				text = _s("ARMY_ACTIVITY_NAME_"..index),
				size = 30,
				}
			util.alignNode(activityNameLabel, activityNameBg,display.CENTER)
			activityNameBg:addChild(activityNameLabel)

			if _isNew == 1 and index == 1 then

				local newSprite = widget.newSprite{
               		file = "main/activity/img_activity_sign_new.png",
	            }
	            activityBtn:addChild(newSprite, 3)
	            util.alignNode(newSprite, activityBtn:getContentSize(), display.TOP_RIGHT) 
			end

            return cell
        end

        local function tapListener( grid,index,item )

        	if index == 1 then
        		--成员管理
        		CCBCenter.loadCCB("MSG_ARMYMENBERLAYER_MODEL", "ccb.c.army.ArmyMenberLayer",{isNew = _isNew})
        	elseif index == 2 then
        		--军团建设
        		CCBCenter.loadCCB("MSG_ARMYBUILDLAYER_MODEL", "ccb.c.army.ArmyBuildLayer")
        	elseif index == 3 then
        		--军团天赋
        		CCBCenter.loadCCB("MSG_ARMYTABLENTLAYER_MODEL", "ccb.c.army.ArmyTablentLayer")
        	elseif index == 4 then
        		--军团商店
        		CCBCenter.loadCCB("MSG_ARMYSHOPLAYER_MODEL", "ccb.c.army.ArmyShopLayer")
        	elseif index == 5 then
        		--军团动态
        		CCBCenter.loadCCB("MSG_ARMYDEVELOPMENTLAYER_MODEL", "ccb.c.army.ArmyDevelopmentLayer")
        	elseif index == 6 then
        		NetHelper.QuickToast(_s("ARMY_ACTIVITY_WILL_OPEN"),true,1)
        	elseif index == 7 then
        		--军团副本
        		CCBCenter.loadCCB("MSG_ARMYBOSSLAYER_MODEL", "ccb.c.army.ArmyBossLayer",{currentLV = _armyLv})
        	elseif index == 8 then
        		--其他军团
        		CCBCenter.loadCCB("MSG_ARMYELSELAYER_MODEL", "ccb.c.army.ArmyElseLayer")
        	end
        end

         --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _armyActivityNode:getContentSize(),
            cellSize = CCSize( _armyActivityNode:getContentSize().width / 4, _armyActivityNode:getContentSize().height / 2),
            column = 4,
            row = 2,
            createItemCellListener = createItemCellListener,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            tapListener = tapListener,
        }
        _armyActivityNode:addChild(scrollGrid)

        return scrollGrid
	end

	local function initViews()
		--军团活动
		_armyActivityNode = CCBCenter.getNodeByTag(_node, 3)
		--军团活动grid
		_armyActivityGrid = createArmyActivityGrid()
		
	end
	--获取军团建设值
	local function getArmyApoint(  )
		return _apoint
	end
	--获取升级所需建设值
	local function getNextApoint( ... )
		return _nextApoint
	end
	--获取军团等级
	local function getArmyLv( ... )
		return _armyLv
	end
	--获取公告
	local function getNotice( ... )
		return _notice
	end

--[[ ## public fuction --]]
	--设置军团的基本信息
	_node.setArmyInfo = setArmyInfo
	--获取军团建设值
	_node.getArmyApoint = getArmyApoint
	--获取升级所需建设值
	_node.getNextApoint = getNextApoint
	--获取军团等级
	_node.getArmyLv = getArmyLv
	--获取公告
	_node.getNotice = getNotice
--[[ ## MAINs --]]
	initViews()
end

return M