--ArmyMenberLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyMenberLayerView]"
	local _node, _nodeTable = node, luaValue

    local CardEntity = require("model.card.CardEntity")
    local CardMaster = require("cardui.CardMaster")

	--申请人员grid
	local _proposerGrid
    --军团成员Grid
    local _menberGrid
    --身份：1军团长，2副团长，3普通成员
    local _usreIndentity

    local   buttons = { }  

	local function createTab( ... )

		local tabNode = _nodeTable["mTabNode"]

		local function onTabClick( index, button )
			if index == 1 then
                CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHMENBERLIST)
                _nodeTable["mMenberList"]:setVisible(true)
                _nodeTable["mProposerList"]:setVisible(false)
            elseif index == 2 then
                CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHPROPOSERLIST)
                _nodeTable["mMenberList"]:setVisible(false)
                _nodeTable["mProposerList"]:setVisible(true)
            end
        end

        local btnTab1 = widget.newButton{
                normalImage = "common/buttons/btn_normal_yellow.png",
   	    	    selectImage = "common/buttons/btn_normal_brown.png",
   	    	    contentSize = CCSize(189,53),
                rect        = CCRectMake(0, 0, 80, 58) ,
   	    	    labelParams = { 
			 	    text = _s("ARMY_MENBER"),
			 	    size = 30,
                    color = BUTTON_COLOR3.BROWN,
			 	}
   	    	}
	    table.insert(buttons, btnTab1)   

	    local btnTab2 = widget.newButton{
                normalImage = "common/buttons/btn_normal_yellow.png",
   	    	    selectImage = "common/buttons/btn_normal_brown.png",
   	    	    contentSize = CCSize(189,53),
                rect        = CCRectMake(0, 0, 80, 58) ,
   	    	    labelParams = { 
			 	    text = _s("ARMY_PROPOSER"),
			 	    size = 30,
                    color = BUTTON_COLOR3.BROWN,
			 	}
   	    	}

        if _node.isNew == 1 then

            local newSprite = widget.newSprite{
                file = "main/activity/img_activity_sign_new.png",
            }
            btnTab2:addChild(newSprite,10, 1000)
            util.alignNode(newSprite, btnTab2:getContentSize(), display.TOP_RIGHT,{top = -10, right = -10}) 
        end 

	    table.insert(buttons, btnTab2)   

        local tab = widget.newTab{
            items = buttons,
            padding = #buttons,
            listener = onTabClick,
            direction = DIRECTION_HORIZONTAL,
        }
        tabNode:addChild(tab)
        util.alignNode(tab, tabNode, display.CENTER_LEFT)

        tab.selectButton(1)
	end

	--创建申请人员grid
	local function createProposerGrid( ... )

		local proposerNode = _nodeTable["mProposerList"]

		local function createItemCellListener( grid, index, item )
			local cell = widget.newLayer{contentSize = CCSize(proposerNode:getContentSize().width - 20 ,proposerNode:getContentSize().height / 4)}
			--cell:ignoreAnchorPointForPosition(true)

			local armyBg = widget.newScale9{ 
				file = "faq/btn_faq_nomal.png", 
                contentSize = cell:getContentSize(),
                capInsets = CCRectMake(100, 40,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)
            --armyBg:ignoreAnchorPointForPosition(false)

            -- 头像
            local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(headNode, 2)
            util.alignNode(headNode, cell:getContentSize(), display.CENTER_LEFT, {left = 40})

            local bgHead = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            headNode:addChild(bgHead, 0)
            util.alignNode(bgHead, headNode:getContentSize(), display.CENTER)
            local bgFrameHead = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            headNode:addChild(bgFrameHead, 1)
            util.alignNode(bgFrameHead, headNode:getContentSize(), display.CENTER) 

            local heroHead = PlayerHead.new(item.sex, item.head, item.equiplst):createRect()
            headNode:addChild(heroHead, 2)
            util.alignNode(heroHead, headNode)
            heroHead:setScale(0.5)
            if item.proposerid ~= ME:getUserid() then
                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {fid = item.proposerid, fnNextView = function ( )
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                        end})
                    end,
                    container = layer,
                }
            end
            --主卡
            local entity = CardEntity.new{id = item.maincard.id,lv = item.maincard.lv,evolv = item.maincard.evolv,equipEffect = item.equipEffect,talent = item.talent}
            entity.type = CardMaster.MINISTARCARD
            entity.showDetail = true
            local goodsView = CardMaster.new(entity)
            goodsView:setScale(86 / goodsView:getContentSize().height)
            cell:addChild(goodsView, 2)
            util.alignNode(goodsView, cell:getContentSize(), display.CENTER_LEFT, {left = 141})

            --玩家信息
            local armyInfoLyer = widget.newLayer{
                contentSize = CCSize(450,cell:getContentSize().height - 10)
            }

            cell:addChild(armyInfoLyer, 2)
            util.alignNode(armyInfoLyer, cell:getContentSize(), display.CENTER)

            local armyNameBg = widget.newScale9{ 
                file = "army/bg_army_name_1.png", 
                contentSize = CCSize(armyInfoLyer:getContentSize().width,40),
                capInsets = CCRectMake(50, 10,10, 10),
            }
            util.alignNode(armyNameBg, armyInfoLyer,display.TOP_CENTER)
            armyInfoLyer:addChild(armyNameBg)

             --玩家姓名
            local userNameLabel = ui.newTTFLabel{
                text = item.proposername,
                size = 25,
                }
            util.alignNode(userNameLabel, armyNameBg,display.CENTER_LEFT,{left = 20})
            armyNameBg:addChild(userNameLabel)

             --最后登录时间
            local lastLoginLabel = ui.newTTFLabel{
                text = _s("FRIEND_LAST_LOGIN_TIME")..item.lastdate,
                size = 25,
                color = BUTTON_COLOR3.BROWN, 
                }
            util.alignNode(lastLoginLabel, armyInfoLyer,display.CENTER_LEFT,{left = 10,top = 10})
            armyInfoLyer:addChild(lastLoginLabel)

             --排名
            local rankLabel = ui.newTTFLabel{
                text = _s("ARMY_RANK",item.rank) ,
                size = 25,
                color = BUTTON_COLOR3.BROWN, 
                }
            util.alignNode(rankLabel, armyInfoLyer,display.BOTTOM_LEFT,{left = 10})
            armyInfoLyer:addChild(rankLabel)


            if item.isshowstatus == 0 then
                --通过申请
                local passBtn = widget.newButton{
                    scale = 1.1,
                    contentSize = CCSize(117,55),
                    rect        = CCRectMake(0, 0, 80, 58) , 
                    normalImage = "common/buttons/btn_normal_yellow.png",
                    selectImage = "common/buttons/btn_normal_yellow.png",
                    disableImage = "common/buttons/btn_normal_gray.png",
                    labelParams = { 
                        size = 30,text = _s("ARMY_APPLY_PASS") , 
                        color = BUTTON_COLOR3.BROWN, 
                    },
                    listener = function ( button )
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHAPPLY,nil,{typ = 1,pid = item.proposerid})
                    end
                }

                cell:addChild(passBtn, 2)
                util.alignNode(passBtn, cell:getContentSize(), display.BOTTOM_RIGHT,{bottom = 10,right = 137})

                --拒绝按钮
                local refusedBtn = widget.newButton{
                    scale = 1.1,
                    contentSize = CCSize(117,55),
                    rect        = CCRectMake(0, 0, 80, 58) , 
                    normalImage = "common/buttons/btn_normal_red.png",
                    selectImage = "common/buttons/btn_normal_red.png",
                    disableImage = "common/buttons/btn_normal_gray.png",
                    labelParams = { 
                        size = 30,text = _s("COMMON_REFUSE") , 
                        color = BUTTON_COLOR3.BROWN, 
                    },
                    listener = function ( button )
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHAPPLY,nil,{typ = 2,pid = item.proposerid})
                    end
                }

                cell:addChild(refusedBtn, 2)
                util.alignNode(refusedBtn, cell:getContentSize(), display.BOTTOM_RIGHT,{bottom = 10,right = 10})
            end

			return cell
		end

		--scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = proposerNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(proposerNode:getContentSize().width , proposerNode:getContentSize().height / 4),
	            padding = {
	            	middleV = 1
	        	},
	            column = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = proposerNode,
	    }
        return scrollGrid
	end
    --刷新申请者列表
    local function reloadProposerGrid( properties )
        if properties.isNew == 1  then
            buttons[2]:removeChildByTag(1000, true)
        else
            buttons[2]:removeChildByTag(1000, false)
        end
        _proposerGrid:setItems(properties.armyproposerlist)
    end

    --军团成员
    local function createMenberGrid( ... )
        local menberNode = _nodeTable["mMenberList"]

        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer{contentSize = CCSize(menberNode:getContentSize().width - 20 ,menberNode:getContentSize().height / 4)}
            --cell:ignoreAnchorPointForPosition(true)

            local armyBg = widget.newScale9{ 
                file = "faq/btn_faq_nomal.png", 
                contentSize = cell:getContentSize(),
                capInsets = CCRectMake(100, 40,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)
            --armyBg:ignoreAnchorPointForPosition(false)

            -- 头像
            local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(headNode, 2)
            util.alignNode(headNode, cell:getContentSize(), display.CENTER_LEFT, {left = 40})

            local bgHead = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            headNode:addChild(bgHead, 0)
            util.alignNode(bgHead, headNode:getContentSize(), display.CENTER)
            local bgFrameHead = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            headNode:addChild(bgFrameHead, 1)
            util.alignNode(bgFrameHead, headNode:getContentSize(), display.CENTER) 

            local heroHead = PlayerHead.new(item.sex, item.head, item.equiplst):createRect()
            headNode:addChild(heroHead, 2)
            util.alignNode(heroHead, headNode)
            heroHead:setScale(0.5)
            if item.proposerid ~= ME:getUserid() then
                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {fid = item.id, fnNextView = function ( )
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                        end})
                    end,
                    container = layer,
                }
            end

            --主卡
            local entity = CardEntity.new{id = item.maincard.id,lv = item.maincard.lv,evolv = item.maincard.evolv,equipEffect = item.equipEffect,talent = item.talent}
            entity.type = CardMaster.MINISTARCARD
            entity.showDetail = true
            local goodsView = CardMaster.new(entity)
            goodsView:setScale(86 / goodsView:getContentSize().height)
            cell:addChild(goodsView, 2)
            util.alignNode(goodsView, cell:getContentSize(), display.CENTER_LEFT, {left = 141})

            -- --玩家信息
            local armyInfoLyer = widget.newLayer{
                contentSize = CCSize(450,cell:getContentSize().height - 10)
            }

            cell:addChild(armyInfoLyer, 2)
            util.alignNode(armyInfoLyer, cell:getContentSize(), display.CENTER)

             local bgNameImg = "army/bg_army_name_1.png"

            if item.id == ME:getUserid() then
                bgNameImg = "army/bg_army_name_2.png"
                _usreIndentity = item.identity
            end 

            local armyNameBg = widget.newScale9{ 
                file = bgNameImg, 
                contentSize = CCSize(armyInfoLyer:getContentSize().width,40),
                capInsets = CCRectMake(50, 10,10, 10),
            }
            util.alignNode(armyNameBg, armyInfoLyer,display.TOP_CENTER)
            armyInfoLyer:addChild(armyNameBg)

            local armyIdentity = ui.newTTFLabel{
                text = _s("ARMY_IDENTITY_"..item.identity),
                size = 25,
                }
            util.alignNode(armyIdentity, armyNameBg,display.CENTER_TIGHT,{left = 40})
            armyNameBg:addChild(armyIdentity)

             --玩家姓名
            local userNameLabel = ui.newTTFLabel{
                text = item.name,
                size = 25,
                }
            util.alignNode(userNameLabel, armyNameBg,display.CENTER_LEFT,{left = 20})
            armyNameBg:addChild(userNameLabel)

             --最后登录时间
            local lastLoginLabel = ui.newTTFLabel{
                text = _s("FRIEND_LAST_LOGIN_TIME")..item.lastdate,
                size = 25,
                color = BUTTON_COLOR3.BROWN, 
                }
            util.alignNode(lastLoginLabel, armyInfoLyer,display.CENTER_LEFT,{left = 10,top = 10})
            armyInfoLyer:addChild(lastLoginLabel)

             --排名
            local rankLabel = ui.newTTFLabel{
                text = _s("ARMY_RANK",item.rank) ,
                size = 25,
                color = BUTTON_COLOR3.BROWN, 
                }
            util.alignNode(rankLabel, armyInfoLyer,display.BOTTOM_LEFT,{left = 10})
            armyInfoLyer:addChild(rankLabel)

            local statusTable = string.split(item.status, ",")

            for i,v in ipairs(statusTable) do
                -- 0隐藏，1退出，2管理，3踢出军团，4弹劾军团长
                if v ~= "" and tonumber(v) ~= 0 then

                    local btnImg = "common/buttons/btn_normal_yellow.png"

                    if tonumber(v) == 1 then
                        btnImg = "common/buttons/btn_normal_red.png"
                    end

                    --操作按钮
                    local btn = widget.newButton{
                        scale = 1.1,
                        contentSize = CCSize(160,55),
                        rect        = CCRectMake(0, 0, 80, 58) , 
                        normalImage = btnImg,
                        selectImage = btnImg,
                        disableImage = "common/buttons/btn_normal_gray.png",
                        labelParams = { 
                            size = 30,text = _s("ARMY_STATUS_"..tonumber(v)) , 
                            color = BUTTON_COLOR3.BROWN, 
                        },
                        listener = function ( button )
                            if tonumber(v) == 1 then
                                CCBCenter.loadCCB("MSG_ARMYALERTLAYER_MODEL", "ccb.c.army.ArmyAlertLayer",{isQuit = true,callback = function ( ... )
                                     CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHQUIT)
                                end})
                            elseif tonumber(v) == 2 then 
                                CCBCenter.loadCCB("MSG_ARMYOPERATELAYER_MODEL", "ccb.c.army.ArmyOperateLayer",{jurisdiction = item.jurisdiction,pid = item.id})
                            else
                                CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYMENBERLAYER_ONFETCHOPERATE,nil,{typ = v,id = item.id})
                            end
                        end
                    }

                    cell:addChild(btn, 2)
                    util.alignNode(btn, cell:getContentSize(), display.BOTTOM_RIGHT,{bottom = 10 ,right = 10 + 117 * ( i - 1 )})
                end
            end

            return cell
        end

        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = menberNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(menberNode:getContentSize().width , menberNode:getContentSize().height / 4),
                padding = {
                    middleV = 1
                },
                column = 1,
                createItemCellListener = createItemCellListener,
             },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = menberNode,
        }
        return scrollGrid
    end

    local function reloadMenberGrid( menberList )
        _menberGrid:setItems(menberList)
    end

--[[ ## local fuction --]]
	local function initViews()
		
		createTab()

		_proposerGrid = createProposerGrid()

        _menberGrid = createMenberGrid()
	end

--[[ ## public fuction --]]
    --刷新申请者列表
    _node.reloadProposerGrid = reloadProposerGrid
     --刷新军团成员列表
    _node.reloadMenberGrid = reloadMenberGrid
--[[ ## MAINs --]]
	initViews()
end

return M