--ArmyOperateLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyOperateLayerView]"
	local _node, _nodeTable = node, luaValue

	--操作grid
	local _operateGrid

	local function createOperateGrid( ... )
		-- 1升级为副军团长 2降级为普通成员 3转让军团 4踢出军团 5弹劾军团长
		 local btnNode = _nodeTable["mButtons"]

        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer{contentSize = CCSize(btnNode:getContentSize().width ,btnNode:getContentSize().height / 4)}
           	--操作按钮
            local btn = widget.newButton{
                scale = 1.1,
                contentSize = CCSize(276,56),
                rect        = CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { 
                    size = 30,text = _s("ARMY_OPERATE_"..item) , 
                    color = BUTTON_COLOR3.BROWN, 
                },
                listener = function ( button )
                   CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYOPERATELAYER_ONFETCHOPERATE,nil,{typ = item})
                end
            }

            cell:addChild(btn, 2)
            util.alignNode(btn, cell)

            return cell
        end

        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = btnNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(btnNode:getContentSize().width , btnNode:getContentSize().height / 4),
                padding = {
                    middleV = 1
                },
                column = 1,
                createItemCellListener = createItemCellListener,
             },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = btnNode,
        }
        return scrollGrid
	end

	local function reloadOperateGrid( ... )
		local t = string.split(_node._DATA.jurisdiction, ",")

		_operateGrid:setItems(t)
	end

--[[ ## local fuction --]]
	local function initViews()
		_operateGrid = createOperateGrid()
		--刷新操作Grid
		reloadOperateGrid()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M