--ArmySearchLayer.lua
local M = {}

local MessageModel = require("ccb.m.message.MessageModel")

function M.bindView(node, luaValue)
	local TAG = "[ArmySearchLayerView]"
	local _node, _nodeTable = node, luaValue
	--创建军团所需要的钻石
	local _createDiamond
	--创建军团所需要的等级
	local _createLv
	--军团列表Node
	local _armyListNode
	--军团列表Grid
	local _armyListGrid

	local MAX_LENGTH = 10

	--军团搜索框
	local _ebArmyName

	local _overTime

	--是否超过24小时
	local function isOver24( time )
		local t = { 
			year = string.sub(time,1,4),
			month = string.sub(time,5,6),
			day = string.sub(time,7,8),
			hour = string.sub(time,9,10),
			min = string.sub(time,11,12)
		}
		
		_overTime = (os.time() - os.time(t)) / 3600

	end


	--军团列表Grid
	local function createArmyListGrid( ... )
		local function createItemCellListener( grid, index, item )
			local cell = widget.newLayer{contentSize = CCSize(_armyListNode:getContentSize().width - 20 ,_armyListNode:getContentSize().height /  3.5)}
			cell:ignoreAnchorPointForPosition(false)

			local armyBg = widget.newScale9{ 
				file = "faq/btn_faq_nomal.png", 
                contentSize = cell:getContentSize(),
                capInsets = CCRectMake(100, 40,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)

            local btnStr = _s("ARMY_ADD")
            if item.butstatus == 2 then
            	btnStr = _s("ARMY_ADD_CANCEL")
            end

            --申请
            local addBtn = widget.newButton{
                scale = 1.1,
                contentSize = CCSize(142,55),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { 
                	size = 30,text = btnStr , 
                	color = BUTTON_COLOR3.BROWN, 
                },
                listener = function ( button )
                	if item.butstatus == 1 then
                		-- if _overTime > 24  then
                			CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMY,nil,{aid = item.aid})
                		-- else
                		-- 	NetHelper.QuickToast(_s("ARMY_ADD_OVER24",math.ceil(24 - _overTime)))
                		-- end
                	elseif item.butstatus == 2 then
                		CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSEARCHLAYER_ONFETCHADDARMYCANCEL,nil,{aid = item.aid})
                	end
                end
            }

            util.alignNodeWithPadding(addBtn, cell,display.BOTTOM_RIGHT,{bottom = 10,right = 10})
           	if item.butstatus ~= 0 then
            	cell:addChild(addBtn)
            end

            local armyInfoLyer = widget.newLayer{
            	contentSize = CCSize(570,cell:getContentSize().height - 10)
            }
            util.alignNodeWithPadding(armyInfoLyer, cell,display.CENTER,{left = - 20})
            cell:addChild(armyInfoLyer)

            local armyNameBg = widget.newScale9{ 
				file = "army/bg_army_name_1.png", 
                contentSize = CCSize(armyInfoLyer:getContentSize().width,40),
                capInsets = CCRectMake(50, 10,10, 10),
            }
            util.alignNode(armyNameBg, armyInfoLyer,display.TOP_CENTER)
            armyInfoLyer:addChild(armyNameBg)

            --军团等级和名称
            local nameLvLabel = ui.newTTFLabel{
				text = _s("ARMY_LV_NAME",item.aleve,item.aname),
				size = 30,
				}
			util.alignNode(nameLvLabel, armyNameBg,display.CENTER_LEFT,{left = 20})
			armyNameBg:addChild(nameLvLabel)

			--军团长
			local leaderLabel = ui.newTTFLabel{
				text = _s("ARMY_LEADER",item.aleadername,item.aleaderlv),
				size = 30,
				color = BUTTON_COLOR3.BROWN
				}
			util.alignNode(leaderLabel, armyInfoLyer,display.CENTER_LEFT)
			armyInfoLyer:addChild(leaderLabel)

			--军团人数
			local acountLabel = ui.newTTFLabel{
				text =  _s("ARMY_ACOUNT",item.acount,item.alimit),
				size = 30,
				color = BUTTON_COLOR3.BROWN
				}
			util.alignNode(acountLabel, armyInfoLyer,display.CENTER_RIGHT)
			armyInfoLyer:addChild(acountLabel)

			local noticeStr = MessageModel.interceptMessage(
				_s("ARMY_NOTICE",item.anotice),nil,30,1.5,armyInfoLyer:getContentSize().width - 10)

			--军团公告
			local noticeLabel = ui.newTTFLabel{
				text =  noticeStr,
				size = 30,
				color = BUTTON_COLOR3.BROWN,
				dimensions = CCSize(armyInfoLyer:getContentSize().width + 30, 32)
				}
			util.alignNode(noticeLabel, armyInfoLyer,display.BOTTOM_LEFT)
			armyInfoLyer:addChild(noticeLabel)

			-- 头像
            local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(headNode, 2)
            util.alignNode(headNode, cell:getContentSize(), display.CENTER_LEFT, {left = 40})

            local bgHead = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            headNode:addChild(bgHead, 0)
            util.alignNode(bgHead, headNode:getContentSize(), display.CENTER)
            local bgFrameHead = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            headNode:addChild(bgFrameHead, 1)
            util.alignNode(bgFrameHead, headNode:getContentSize(), display.CENTER) 

            local heroHead = PlayerHead.new(item.aleadersex, item.aleaderhead, item.aleadereq):createRect()
            headNode:addChild(heroHead, 2)
            util.alignNode(heroHead, headNode)
            heroHead:setScale(0.5)
            if item.aleaderid ~= ME:getUserid() then
                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {fid = item.aleaderid, fnNextView = function ( )
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                        end})
                    end,
                    container = layer,
                }
            end

			return cell
		end

		--scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = _armyListNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_armyListNode:getContentSize().width , _armyListNode:getContentSize().height / 3.5),
	            padding = {
	            	middleV = 1
	        	},
	            column = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _armyListNode,
	    }
        return scrollGrid
	end
	--刷新军团列表
	local function reloadArmyList( armyList )
		_armyListGrid:setItems(armyList)
	end

	--搜索军团名字框
	local function createSearchEditBox( ... )
		local nameLayer = CCBCenter.getNodeByTag(_node, 4)

		_ebArmyName = widget.newEditBox({
				contentSize 	= CCSizeAdd(nameLayer:getContentSize(), 0,-6), -- parent:getContentSize(),
				x 				= nameLayer:getPositionX() , 
				y 				= nameLayer:getPositionY() - 2 ,
				normalBgImage 	= {file = "hook_ac.png"},
				placeHolderText = _s("ARMY_SEARCH_WARM"),
				placeholderFontColor =  COLOR3.GREE ,
				textMaxLength 	= MAX_LENGTH,
				textChangedListener = function(editBox, text)
					if text == "" then 
						_ebArmyName:setPlaceHolder(_s("ARMY_SEARCH_WARM"))
					end
				end,
			})   

			--_ebArmyName:setPosition(nameLayer:getPositionX(),nameLayer:getPositionY())
			_node:addChild(_ebArmyName, 99000, 99000)
			-- _ebArmyName:set
			-- util.alignNode(_ebArmyName,nameLayer)
	end

	local function getSearchName(  )
		return _ebArmyName:getText()
	end

--[[ ## local fuction --]]
	local function initViews()
		--军团列表Node
		_armyListNode = CCBCenter.getNodeByTag(_node, 3)
		--军团列表Grid
		_armyListGrid = createArmyListGrid()

		createSearchEditBox()
	end
	--设置创建军团所需要的钻石
	local function setCreateDiamond( diamond )
		_createDiamond = diamond
	end
	--获取钻石
	local function getCreateDiamond( ... )
		return _createDiamond
	end

	--设置创建军团所需要的等级
	local function setCreateLv( lv )
		_createLv = lv
	end
	--获取等级
	local function getCreateLv( ... )
		return _createLv
	end

	local function setSearchArmy( armyInfo )
		local t = {armyInfo}
		reloadArmyList(t)
	end

--[[ ## public fuction --]]
	--设置创建军团所需要的钻石
	_node.setCreateDiamond = setCreateDiamond
	--获取钻石
	_node.getCreateDiamond = getCreateDiamond
	--设置创建军团所需要的等级
	_node.setCreateLv = setCreateLv
	--获取等级
	_node.getCreateLv = getCreateLv
	--刷新军团列表
	_node.reloadArmyList = reloadArmyList
	--搜索框
	_node.getSearchName = getSearchName
	--设置所搜索的军团
	_node.setSearchArmy = setSearchArmy
	--是否退团超过24小时
	_node.isOver24 = isOver24
--[[ ## MAINs --]]
	initViews()
end

return M