--ArmyShopLayer.lua



local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ArmyShopLayerView]"
	local _node, _nodeTable = node, luaValue

	local GoodsMaster = require("cardui.GoodsMaster")
	local GoodsEntity = require("model.goods.GoodsEntity")
	local CardEntity = require("model.card.CardEntity")
	local CardMaster = require("cardui.CardMaster")
    local RewardEntity = require("model.main.RewardEntity")

	local REWARD_TYPE_CARD  	= 0
	local REWARD_TYPE_CHIP  	= 1
	local REWARD_TYPE_GOODS 	= 2
	local REWARD_TYPE_SP		= 3
	local REWARD_TYPE_GOLD  	= 4
	local REWARD_TYPE_FP    	= 5
	local REWARD_TYPE_DIAMOND  	= 6
	local REWARD_TYPE_FREEBUY  	= 7
	local REWARD_TYPE_STAR  	= 8
	local REWARD_TYPE_EXP   	= 9

	--商店列表grid
	local _shopListGrid

    local _shoplv

    local _nextApoint

    local _apoint

    local _contentOffSet

	--设置军团商店信息
	local function setShopInfo( info )
		--军团点
		_nodeTable["mArmyBuildLabel"]:setString(info.apoint)
		--个人贡献值
		_nodeTable["mMyContributeLabel"]:setString(info.acredit)

        _shoplv = info.shoplv

		_shopListGrid:setItems(info.armyshoplist)

        if _contentOffSet then
            _shopListGrid:setContentOffset(_contentOffSet)
        end

        _nodeTable["mShopTitleLabel"]:setString(_s("ARMY_SHOP_TITLE") .. "  LV:" .. info.shoplv)

        _nextApoint = info.nextpoint

        _apoint = info.apoint

        if info.identity == 1 or info.identity == 2 then
            _nodeTable["mShopLvUp"]:setVisible(true)
        else
            _nodeTable["mShopLvUp"]:setVisible(false)
        end
	end

	--创建商品
	local function createShopGoods( sid,num )
		local entity
		if sid then
            if sid < 5000 then
                -- 绑成卡牌
                entity = CardEntity.new{id = sid}
                entity._TYPE = REWARD_TYPE_CARD
                entity._VALUE = num
            elseif sid < 10000 then
                -- 绑成碎片
                entity = CardEntity.new{id = sid}
                entity._TYPE = REWARD_TYPE_CHIP
                entity._VALUE = num
            -- elseif sid > 20000 then
            --      -- 装备
            --     entity = GoodsEntity.new{no = sid}
            --     entity._TYPE = GoodsMaster.BAGEQUIP
            --     entity._VALUE = num
            else
                -- 物品
                entity = GoodsEntity.new{no = sid}
                entity._TYPE = REWARD_TYPE_GOODS
                entity._VALUE = num

            end
        end
        return entity
	end

	local function createShopListGrid( ... )
		local listNode = _nodeTable["mShopGoodsList"]

        local function createItemCellListener( grid, index, item )

            local cell = widget.newLayer{contentSize = CCSize(236, listNode:getContentSize().height)}
            cell:ignoreAnchorPointForPosition(false)
           	
           	local armyBg = widget.newScale9{ 
				file = "army/bg_army_shop.png", 
                contentSize = CCSize(235,357),
                capInsets = CCRectMake(20, 60,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)

            --活动名称
            local goodsLabel = ui.newTTFLabel{
				text = item.sname,
				size = 30,
				color = COLOR3.BLACK,
				}
			util.alignNode(goodsLabel, armyBg,display.TOP_CENTER,{top = 10})
			armyBg:addChild(goodsLabel)

            local goodsLayer = widget.newLayer{
            	contentSize = CCSize(91,91)
            }
            goodsLayer:ignoreAnchorPointForPosition(false)
            local rewardEntity = RewardEntity.new(item.reward)
            local rewardTable = rewardEntity:getRewardViews()
            count = item.num

            widget.bindTouchEvent{
                layer = goodsLayer,
                clickListener = function ( layer )
                   if rewardTable[1]:getType() == RewardEntity.REWARD_TYPE.CARD or rewardTable[1]:getType() == RewardEntity.REWARD_TYPE.CHIP then
                        CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", rewardTable[1]:getEntity())
                    elseif rewardTable[1]:getType() == RewardEntity.REWARD_TYPE.GOODS then
                        if rewardTable[1]:getEntity():getNo() > 20000 then
                            CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", rewardTable[1]:getEntity())
                        else
                            CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", rewardTable[1]:getEntity())
                        end
                    end
                end
            }

            --兑换的商品
   --          local goodsEntity = createShopGoods(item.sid,item.num)

   --          local goodsSprite

   --          if goodsEntity._TYPE == REWARD_TYPE_CARD then
   --  			-- 卡牌
   --              goodsEntity.type = CardMaster.MINISTARCARD
   --              goodsEntity.showDetail = true
   --              goodsEntity.showFrame = true
   --              goodsSprite = CardMaster.new(goodsEntity)
   --              goodsSprite:setScale(0.75)
   --              count = goodsEntity._VALUE
			-- elseif goodsEntity._TYPE == REWARD_TYPE_CHIP then
			-- 	-- 碎片
			-- 	goodsEntity.type = CardMaster.MINISTARCARD
			-- 	goodsEntity.showDetail = true
   --              goodsEntity.showFrame = true
   --              goodsSprite = CardMaster.new(goodsEntity)
   --              goodsEntity:setScale(0.75)
   --              local chipSprite = widget.newSprite{file = "fight/result3/f_r3_cardchip.png"}
   --              goodsLayer:addChild(chipSprite, 2)
			-- 	util.alignNode(chipSprite, goodsLayer:getContentSize(), display.CENTER)
   --              count = goodsEntity._VALUE
			-- elseif goodsEntity._TYPE == REWARD_TYPE_GOODS then
   --              -- dump(goodsEntity)
			-- 	-- 物品
   --              goodsEntity.type = GoodsMaster.MATERIAL
   --              goodsEntity.showDetail = true
   --              goodsEntity.showFrame = true
   --              goodsSprite = GoodsMaster.new(goodsEntity)
   --              goodsSprite.showDetail = true
   --              count = goodsEntity._VALUE
   --          -- elseif goodsEntity._TYPE == GoodsMaster.BAGEQUIP then
   --          --     -- 物品
   --          --     goodsEntity.type = GoodsMaster.BAGEQUIP
   --          --     goodsEntity.showDetail = true
   --          --     goodsEntity.showFrame = true
   --          --     goodsSprite = GoodsMaster.new(goodsEntity)
   --          --     goodsSprite.showDetail = true

   --          --     count = goodsEntity._VALUE
   --          end
            if istable(rewardTable)  then
				goodsLayer:addChild(rewardTable[1], 1)
				util.alignNode(rewardTable[1], goodsLayer:getContentSize(), display.CENTER)
			end

            if count > 1 then 
				--数量
	          	local count = ui.newTTFLabel{
	                size = 30,
	                text = "x"..count
				}
	      		util.alignNode(count, goodsLayer, display.BOTTOM_RIGHT,{right = 10})
	          	goodsLayer:addChild(count)
	        end


            local costLayer = widget.newLayer{
            	contentSize = CCSize(180,35)
            }
            costLayer:ignoreAnchorPointForPosition(false)

              --花费背景
			local costBg = widget.newScale9{ 
				file = "army/bg_army_talent_introduce.png", 
                contentSize = CCSize(147,40),
            }
            util.alignNode(costBg, costLayer)
            costLayer:addChild(costBg)

            --所需花费
            local costLabel = ui.newTTFLabel{
				text = item.sprice,
				size = 20,
				color =  COLOR3.BLACK
				}
			util.alignNode(costLabel, costBg,display.CENTER_RIGHT,{right = 5})
			costBg:addChild(costLabel)

			--花费材料
            local materialSprite = widget.newSprite{
                file = "army/img_army_my_contribute.png",
            }
            costBg:addChild(materialSprite, 1)
            util.alignNode(materialSprite, costBg:getContentSize(), display.CENTER_LEFT,{left = 5})

             --购买按钮
            local buyBtn = widget.newButton{
                scale = 1.1,
                contentSize = CCSize(141,58),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { 
                	size = 30,text = _s("ARMY_SHOP_BUY"), 
                	color = BUTTON_COLOR3.BROWN, 
                },
                listener = function ( button )
                    _contentOffSet = _shopListGrid:getContentOffset()
                	CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYSHOPLAYER_ONFETCHBUYGOODS, nil, {proid = item.sid})
                end
            }

             --获得的贡献度
            local params = {
                goodsLayer,costLayer,buyBtn,
                {text = _s("ARMY_SHOP_COUNT", item.count), size = 25, color = BUTTON_COLOR3.BROWN},
                {text = _s("ARMY_SHOP_NEED_LV", item.needlv), size = 25, color = (_shoplv >= item.needlv and BUTTON_COLOR3.BROWN or COLOR3.RED)}
            }

	        local  linearLabel = widget.newLinearLabel({paramTable = params, padding = 8, direction = widget.TABLEVIEW_DIRECTION_VERTICAL })
	        util.alignNode(linearLabel, armyBg,display.BOTTOM_CENTER, {bottom = 5})
	        armyBg:addChild(linearLabel)

            return cell

        end

        --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = listNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(listNode:getContentSize().width / 3.5 , listNode:getContentSize().height ),
	            padding = {
	            	middleV = 1
	        	},
	            row = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = listNode,
	    }

        
        return scrollGrid
	end

    local function getShopLv( )
        return _shoplv
    end

    local function getApoint( )
        return _apoint
    end

    local function getNextApoint( )
        return _nextApoint
    end

--[[ ## local fuction --]]
	local function initViews()
		_shopListGrid = createShopListGrid()
	end

--[[ ## public fuction --]]
	--设置军团商店信息
	_node.setShopInfo = setShopInfo

    _node.getShopLv = getShopLv

    _node.getApoint = getApoint

    _node.getNextApoint = getNextApoint
--[[ ## MAINs --]]
	initViews()
end

return M