--ArmyTablentLayer.lua
local M = {}
local entityTalent = require("ccb.m.talent.EntityArmyTalent")

function M.bindView(node, luaValue)
	local TAG = "[ArmyTablentLayerView]"
	local _node, _nodeTable = node, luaValue

    local _contentOffSet

	local _talentGrid

	local function createTalentListGrid( ... )
		local listNode = _nodeTable["mTalentList"]

        local function createItemCellListener( grid, index, item )

            local cell = widget.newLayer{contentSize = CCSize(236,listNode:getContentSize().height)}
            cell:ignoreAnchorPointForPosition(false)
           	
           	local armyBg = widget.newScale9{ 
				file = "army/bg_army_shop.png", 
                contentSize = CCSize(235,400),
                capInsets = CCRectMake(20, 60,10, 10),
            }
            util.alignNodeWithPadding(armyBg, cell)
            cell:addChild(armyBg)

            --天赋名称
            local talentNameLabel = ui.newTTFLabel{
				text = "LV"..item:getLv().."  "..item:getName(),
				size = 30,
				color = COLOR3.BLACK,
				}
			util.alignNode(talentNameLabel, armyBg,display.TOP_CENTER,{top = 10})
			armyBg:addChild(talentNameLabel)

			--天赋图标
		    local talentImgLayer = widget.newLayer{
            	contentSize = CCSize(91,91)
            }
            talentImgLayer:ignoreAnchorPointForPosition(false)

            local bgImg = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            talentImgLayer:addChild(bgImg, 0)
            util.alignNode(bgImg, talentImgLayer:getContentSize(), display.CENTER)

            local bgFrameImg = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            talentImgLayer:addChild(bgFrameImg, 1)
            util.alignNode(bgFrameImg, talentImgLayer:getContentSize(), display.CENTER) 
            --天赋图标
         	local talentImg = widget.newSprite{
                file = "army/img_army_talent_"..item:getTyp().."_"..item:getCamp()..".png",
            }
            talentImgLayer:addChild(talentImg, 1)
            util.alignNode(talentImg, talentImgLayer:getContentSize(), display.CENTER) 

             --天赋介绍Layer
            local talentIntroduceLayer = widget.newLayer{
            	contentSize = CCSize(206,95)
            }
            talentIntroduceLayer:ignoreAnchorPointForPosition(false)

            --介绍背景
            local introduceBg = widget.newScale9{ 
				file = "army/bg_army_talent_introduce.png", 
                contentSize = talentIntroduceLayer:getContentSize(),
                -- capInsets = CCRectMake(20, 60,10, 10),
            }
            util.alignNodeWithPadding(introduceBg, talentIntroduceLayer)
            talentIntroduceLayer:addChild(introduceBg)
            --introduceBg:ignoreAnchorPointForPosition(false)
            --天赋介绍
			local introduceLabel = ui.newTTFLabel{
				text = string.format(item:getIntroduce(),tostring(item:getTalentval()) ) ,
				size = 20,
				color = BUTTON_COLOR3.BROWN,
				dimensions = CCSize(introduceBg:getContentSize().width - 10 , introduceBg:getContentSize().height - 10) 
				}
			introduceLabel:setContentSize(CCSize(introduceBg:getContentSize().width - 10 , introduceBg:getContentSize().height - 10))
			util.alignNode(introduceLabel, introduceBg,display.TOP_LEFT,{left = 10,top = 10})
			introduceBg:addChild(introduceLabel)

            --天赋经验
            local talentExpLayer = widget.newLayer{
            	contentSize = CCSize(260,34)
            }
            talentExpLayer:ignoreAnchorPointForPosition(false)

            --经验进度条
            local _expProgressBar = widget.newProgressBar{
                frontSprintParams = {file = "army/img_progressbar_army_talent.png",},
                bgSprintParams = {file = "army/bg_progressbar_army_talent.png"},
                ttfLabelParams = {size = 14/SCALE_FOR_SPECIAL_NODE, padding = {top = 3}},
            }
            util.alignNode(_expProgressBar, talentExpLayer)
            talentExpLayer:addChild(_expProgressBar)

            _expProgressBar:setPercentage(0)
            _expProgressBar:runProgressTo( 0.5, 
               math.floor(tonumber(item:getCurexp())/tonumber(item:getNeedExp()) * 100), 
                        false,nil,
                        function (progressBar,percentage,totalPercentage)
                            
                            
                        end
                    )

           --升级按钮
            local lvUpBtn = widget.newButton{
                scale = 1.1,
                contentSize = CCSize(141,58),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { 
                	size = 30,text = _s("ARMU_TALENT_LV_UP") , 
                	color = BUTTON_COLOR3.BROWN, 
                },
                listener = function ( button )
                    if _nodeTable["armylv"] < item:getLv() or ( _nodeTable["armylv"] == item:getLv() and item:getCurexp() >= item:getNeedExp() - 1 ) then
                         NetHelper.QuickToast(_s("ARMY_TALENT_WARM"))
                    else
                        
                        _nodeTable["item"] = item
                        _contentOffSet = _talentGrid:getContentOffset()
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_ARMYTABLENTLAYER_ONCHOOSECARDS)
                    end
                end
            }
            
            --获得的贡献度
            local params = {talentImgLayer,talentIntroduceLayer,talentExpLayer,lvUpBtn}

	        local  linearLabel = widget.newLinearLabel({paramTable = params,padding = 12,direction = widget.TABLEVIEW_DIRECTION_VERTICAL })
	        util.alignNode(linearLabel, armyBg,display.BOTTOM_CENTER,{bottom = 5})
	        armyBg:addChild(linearLabel)

            return cell

        end

        --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = listNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(listNode:getContentSize().width / 3.5 , listNode:getContentSize().height ),
	            padding = {
	            	middleV = 1
	        	},
	            row = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = listNode,
	    }

        
        return scrollGrid
	end	

	--刷新grid数据
	local function reloadTalentGrid( armytalents )

		local t = {}

		for i,v in ipairs(armytalents) do
			local entity = entityTalent.new(v)
			table.insert(t,entity)
		end
		_talentGrid:setItems(t)
        if _contentOffSet then
            _talentGrid:setContentOffset(_contentOffSet)
        end
	end

--[[ ## local fuction --]]
	local function initViews()
		_talentGrid = createTalentListGrid()
	end

--[[ ## public fuction --]]
	--刷新grid数据
	_node.reloadTalentGrid = reloadTalentGrid

--[[ ## MAINs --]]
	initViews()
end

return M