--BossLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[BossLayerView]"
	local _node, _nodeTable = node, luaValue

	--boss血条
	local _hpProgressBar
	--士气条
	local _encourageProgressbar
	--排名列表
	local _rankGrid
    --排名node
    --local _rankNode
    --cd时间
    local _cdTime
    --结束倒计时
    local _endTime
    --复活按钮
    local reactivateButton

--[[ ## local fuction --]]
	
	--创建boss血条
	local function createHPProgressbar( ... )

		local hpNode = CCBCenter.getNodeByTag(_node, 502)

		_hpProgressBar = widget.newProgressBar{
            frontSprintParams = {file =  "common/progressbar/progressbar_hp.png",},
            bgSprintParams = {file = "boss/bg_progressbar_1.png"},
            ttfLabelParams = { shadow = true}
        }
        util.alignNode(_hpProgressBar, hpNode)
        hpNode:removeAllChildrenWithCleanup(true)
        hpNode:addChild(_hpProgressBar)
	end

	--创建士气条
	local function createEncourageProgressbar( ... )
		local encourageNode = CCBCenter.getNodeByTag(_node, 1002)

		_encourageProgressbar = widget.newProgressBar{
            frontSprintParams = {file = "common/progressbar/progressbar_encourage.png",},
            bgSprintParams = {file = "boss/bg_progressbar_1.png"},
            ttfLabelParams = {  shadow = true}
        }

        util.alignNode(_encourageProgressbar, encourageNode)
        encourageNode:removeAllChildrenWithCleanup(true)
        encourageNode:addChild(_encourageProgressbar)

        -- _encourageProgressbar:runProgressTo(0.5,500000/1000000 * 100)
        -- _encourageProgressbar:setString(_s("BOSS_ENCOURAGE","500000/1000000"))
	end

	--加载排名数据
	local function reloadRankGrid( players )
		
        _rankGrid:setItems(players)
	end

	--创建排名列表
	local function createRankGrid( ... )

        --排名Node
        local _rankNode = CCBCenter.getNodeByTag(_node, 204)

        local function tapListener( grid, index, item )

            if item.uid ~= ME:getUserid() then
               CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", 
                {fid = item.uid})
            end
        end

        local function createItemCellListener(grid, index, item)
            
            local cell = widget.newLayer{contentSize = CCSize(_rankNode:getContentSize().width,
                _rankNode:getContentSize().height / 7)}
           
            -- 玩家排名
            local rankLabel = ui.newTTFLabel{           
                size = 20,
                text = item.rank.."."
            }
            util.alignNode(rankLabel, cell:getContentSize(),display.TOP_LEFT,{left = 20,top = 5})
            cell:addChild(rankLabel)

            -- 玩家用户名
            local nameLabel = ui.newTTFLabel{           
                size = 20,
                text = item.uname
            }
            nameLabel:setAnchorPoint(ccp(0, 0.5))
            -- util.alignNode(nameLabel, cell:getContentSize(),display.TOP_CENTER,{left = 20,top = 5})
            nameLabel:setPosition(rankLabel:getPositionX() + rankLabel:getContentSize().width,rankLabel:getPositionY() - rankLabel:getContentSize().height / 2)
            cell:addChild(nameLabel)

            -- 伤害
            local pointLabel = ui.newTTFLabel{           
                size = 20,
                text = item.point
            }
            util.alignNode(pointLabel, cell:getContentSize(),display.BOTTOM_LEFT,{left = 20 + rankLabel:getContentSize().width})
            cell:addChild(pointLabel)

            local per = item.pointper / 100

            -- 百分比
            local perLabel = ui.newTTFLabel{           
                size = 20,
                text = "("..per.."%)"
            }
            perLabel:setAnchorPoint(ccp(0, 0.5))
            -- util.alignNode(perLabel, cell:getContentSize(),display.BOTTOM_RIGHT)
            perLabel:setPosition(pointLabel:getPositionX() + pointLabel:getContentSize().width,pointLabel:getPositionY() + pointLabel:getContentSize().height / 2)
            cell:addChild(perLabel)

            --底线
            local bgImg = display.newSprite("boss/img_rank_line.png")
            util.alignNode(bgImg, cell:getContentSize(),display.BOTTOM_CENTER)
            cell:addChild(bgImg)

            return cell
        end
        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = _rankNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(_rankNode:getContentSize().width , _rankNode:getContentSize().height / 7 ),
                column = 1,
                tapListener = tapListener,
                createItemCellListener = createItemCellListener, 
             },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _rankNode,
        }
        return scrollGrid

	end

    --创建倒计时
    local function createTime( cd,time,status,killers,bossno,memo )

        local cdLayer = CCBCenter.getNodeByTag(_node, 808)
        cdLayer:removeAllChildrenWithCleanup(true)

        local str 
        if status == 0 or status == 3 then
            str = _s("BOSS_BEGIN")
            -- 击杀者
            local killerLabel = ui.newTTFLabel{           
                size = 20,
                text = _s("BOSS_KILLER",killers)
            }
            util.alignNode(killerLabel, cdLayer:getContentSize(),display.CENTER)
            cdLayer:addChild(killerLabel)
        else
            _cdTime = CountDownView.new{ 
                    format = _s("BOSS_CD"),
                    labelParams = {size = 20},
                    listener = function()
                        NetHelper.hideLoading(true)
                        if status == 2 then
                            _cdTime:stop()
                            CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO)
                        end
                        -- _cdTime:setVisible(false)
                    end
                }
                  
            util.alignNodeWithPadding(_cdTime, cdLayer:getContentSize(),display.CENTER)
            cdLayer:addChild(_cdTime)
            str = _s("BOSS_END_TIME")

            if status == 1 then
                cd = 0
            end

            _cdTime:start(cd)
        end

        --boss战结束时间
        local bossLayer = CCBCenter.getNodeByTag(_node, 803)
        bossLayer:removeAllChildrenWithCleanup(true)

        local sprite = display.newSprite("main/bg_button_title.png")
        sprite:setScaleX(bossLayer:getContentSize().width / sprite:getContentSize().width)
        sprite:setScaleY(3)
        util.alignNode(sprite, bossLayer,display.CENTER,{top = sprite:getContentSize().height })
        bossLayer:addChild(sprite,10000)

        local openTime = _s("BOSS_OPEN_TIME")

        if memo ~= nil or memo == "" then
            openTime = memo
        end

        -- 花费钻石复活
        local timeLabel = ui.newTTFLabel{           
            size = 25,
            text = openTime
        }
        util.alignNode(timeLabel, bossLayer:getContentSize(),display.CENTER,{top =  10})
        bossLayer:addChild(timeLabel,10001)

        _endTime = CountDownView.new{ 
                    format = str,
                    labelParams = {size = 25},
                    listener = function()
                        NetHelper.hideLoading(true)
                        _endTime:stop()
                        -- _cdTime:setVisible(false)
                       CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETBOSSINFO)
                    end
                }
                  
        util.alignNodeWithPadding(_endTime, bossLayer:getContentSize(),display.CENTER,{top = sprite:getContentSize().height * 2 - 5})
        bossLayer:addChild(_endTime,10001)   
        --开启倒计时
        _endTime:start(time)  

        --boss圆圈
        local bossImgPath = string.format("boss/bossImg/img_boss_%d.png",bossno)

        local bossImg = display.newSprite(bossImgPath)
        
        util.alignNode(bossImg, bossLayer)
        bossLayer:addChild(bossImg)

    end

	--填充Boss数据
	local function setValues( properties )

		--boss血量
		--_hpProgressBar:runProgressTo(0.5,properties.hp / properties.totalhp * 100)
        _hpProgressBar:setPercentage(properties.hp / properties.totalhp * 100)
        _hpProgressBar:setString("HP:"..properties.hp .."/"..properties.totalhp)
        --全区士气
        _encourageProgressbar:setPercentage(properties.morale/properties.maxmorale*100)
        --_encourageProgressbar:runProgressTo(0.5,properties.morale/properties.maxmorale*100)
        _encourageProgressbar:setString(_s("BOSS_ENCOURAGE",properties.morale.."/"..properties.maxmorale))

        --鼓舞奖励
        _nodeTable.mEncourageReward:setString("+"..properties.star.."/"..GAMERATE:getBossRewardStarLimit())
        --全区士气加成攻击
        _nodeTable.mAllEncourageAtk:setString("+"..properties.moraleAddAtk)
        --全区士气加成血量
        _nodeTable.mAllEncourageHP:setString("+"..properties.moraleAddHp)
        --个人士气加成攻击
        _nodeTable.mMyEncourageAtk:setString("+"..properties.moraleAddAtkSelf.."/"..GAMERATE:getInspirationAtkLimit())
        --个人士气加成血量
        _nodeTable.mMyEncourageHP:setString("+"..properties.moraleAddHpSelf.."/"..GAMERATE:getInspirationHpLimit())
        --个人排名
        _nodeTable.mMyRankLabel:setString(_s("BOSS_MY_RANK",properties.myrank))
        --个人伤害
        _nodeTable.mMyPointLabel:setString(_s("BOSS_MY_POINT",properties.mypoint))
        --金币鼓舞成功率
        _nodeTable.mGoldSuccessRateLabel:setString(_s("EQUIPMENT_SUCCESSRATE")..GAMERATE:getBossInspirationGoldRate().."%")
        --钻石鼓舞成功率
        _nodeTable.mDamondSuccessRateLabel:setString(_s("EQUIPMENT_SUCCESSRATE")..GAMERATE:getBossInspirationDiamondRate().."%")

        --创建倒计时
        createTime(properties.cd,properties.time,properties.status,properties.killname,properties.bossno,properties.memo)

	end

	--创建鼓舞按钮
	local function createEncourageBtn( status,cddia )
		
		--金币鼓舞layer
		local goldEncourageLayer = CCBCenter.getNodeByTag(_node, 907)
        goldEncourageLayer:removeAllChildrenWithCleanup(true)
		--钻石鼓舞layer
		local damondEncourageLayer = CCBCenter.getNodeByTag(_node, 911)
        damondEncourageLayer:removeAllChildrenWithCleanup(true)
		--复活layer
		local reactivateLayer	= CCBCenter.getNodeByTag(_node, 807)
        reactivateLayer:removeAllChildrenWithCleanup(true)

		--金币鼓舞按钮
		local goldButton = widget.newButton{
                scale = 1.1,
                contentSize = goldEncourageLayer:getContentSize(),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { size = 18,text = GAMERATE:getBossInspirationGold() , color = BUTTON_COLOR3.BROWN, padding = {left = 10}},
                listener = function ( button )
                	CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHENCOURAGE,nil,{typ = 1})
                end
            }
        util.alignNode(goldButton, goldEncourageLayer)
        goldEncourageLayer:addChild(goldButton)

        local goldImg = display.newSprite("main/img_main_glod.png")
        util.alignNodeWithPadding(goldImg, goldButton:getContentSize(),display.CENTER_LEFT,{left =  10})
        goldButton:addChild(goldImg,10000)

        --钻石鼓舞按钮
        local damondButton = widget.newButton{
                scale = 1.1,
                contentSize = damondEncourageLayer:getContentSize(),
                rect 		= CCRectMake(0, 0, 80, 58) , 
                normalImage = "common/buttons/btn_normal_yellow.png",
                selectImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                labelParams = { size = 18,text = GAMERATE:getBossInspirationDiamond() , color = BUTTON_COLOR3.BROWN, padding = {left = 20}},
                listener = function ( button )
                     AlertLayer.new4IAP{
                        isUserDiamond = true,
                        diamondIndex = 18,
                        content = _s("USE_DIAMOND_18",GAMERATE:getBossInspirationDiamond()),  --内容
                        btnClickEvent = {
                            function ( )
                               CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHENCOURAGE,nil,{typ = 2})
                            end
                        }
                      }
                end
            }
        util.alignNode(damondButton, damondEncourageLayer)
        damondEncourageLayer:addChild(damondButton)

        local damondImg = display.newSprite("main/img_main_diamond.png")
        util.alignNodeWithPadding(damondImg, damondButton:getContentSize(),display.CENTER_LEFT,{left =  10})
        damondButton:addChild(damondImg,10000)

        --复活按钮
        local reactivateButton = widget.newButton{
                    scale = 1.1,
                    contentSize = reactivateLayer:getContentSize(),
                    rect        = CCRectMake(0, 0, 80, 58) , 
                    normalImage = "common/buttons/btn_normal_yellow.png",
                    selectImage = "common/buttons/btn_normal_yellow.png",
                    disableImage = "common/buttons/btn_normal_gray.png",
                    labelParams = {  color = BUTTON_COLOR3.BROWN },
                    listener = function ( button )
                        if status == 3 then
                            CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSREWARD)
                        else
                          
                            local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")         -- 战斗视图工厂
                            local friendId                  = ""                    -- 好友ID
                            local friendName                = ""
                            local fnNextView                = ""

                            -- 场景转换
                            FightViewFactory.viewBOSSLearn({ friendId = friendId, friendName = friendName, fnNextView = function ( )        
                                    CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                                    CCBCenter.loadCCB("MSG_BOSSLAYER_MODEL", "ccb.c.boss.BossLayer")                        
                            end, })
                        end
                    end
                } 
        
        if status == 0 then
        	reactivateButton.setTextString(_s("BOSS_BEGIN_FIGHT"))
        	reactivateButton.setStateDisabled(true)
            goldButton.setStateDisabled(true)
            damondButton.setStateDisabled(true)
        elseif status == 1 then
        	reactivateButton.setTextString(_s("BOSS_BEGIN_FIGHT"))
        elseif status == 2 then

            --复活按钮
            reactivateButton = widget.newButton{
                    scale = 1.1,
                    contentSize = reactivateLayer:getContentSize(),
                    rect        = CCRectMake(0, 0, 80, 58) , 
                    normalImage = "common/buttons/btn_normal_yellow.png",
                    selectImage = "common/buttons/btn_normal_yellow.png",
                    disableImage = "common/buttons/btn_normal_gray.png",
                    labelParams = {  color = BUTTON_COLOR3.BROWN,padding = {top = - 10 } },
                    listener = function ( button )

                        if status == 3 then
                            CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHBOSSREWARD)
                        else
                            
                            local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")         -- 战斗视图工厂
                            local friendId                  = ""                    -- 好友ID
                            local friendName                = ""
                            local fnNextView                = ""

                             AlertLayer.new4IAP{
                                isUserDiamond = true,
                                diamondIndex = 4,
                                content = _s("USE_DIAMOND_04",cddia),  --内容
                                btnClickEvent = {
                                    function ( )
                                        -- 场景转换
                                            FightViewFactory.viewBOSSLearn({ friendId = friendId, friendName = friendName, fnNextView = function ( )        
                                                    CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                                                    CCBCenter.loadCCB("MSG_BOSSLAYER_MODEL", "ccb.c.boss.BossLayer")                        
                                            end, })
                                    end,
                                }
                              }

                        end
                    end
                } 
            

        	reactivateButton.setTextString(_s("BOSS_REACTIVATING"))
	        local damondImg = display.newSprite("main/img_main_diamond.png")
	        util.alignNodeWithPadding(damondImg, reactivateButton:getContentSize(),display.BOTTOM_CENTER,{left = 20,bottom = 10})
	        reactivateButton:addChild(damondImg,10000)

	        -- 花费钻石复活
	        local damondLabel = ui.newTTFLabel{           
	            size = 25,
	            text = cddia,
	            color = BUTTON_COLOR3.BROWN
	        }
	        util.alignNode(damondLabel, reactivateButton:getContentSize(),display.BOTTOM_CENTER,{left = - 20, bottom = 15})
	        reactivateButton:addChild(damondLabel,10001)
        else
        	reactivateButton.setTextString(_s("BOSS_GETREWARD"))
            goldButton.setStateDisabled(true)
            damondButton.setStateDisabled(true)
        end

        util.alignNode(reactivateButton, reactivateLayer)
        reactivateLayer:addChild(reactivateButton)

	end

	local function initViews()

		--创建排名列表
		_rankGrid = createRankGrid()

		--创建boss血条
		createHPProgressbar()

		--创建士气条
		createEncourageProgressbar()

        local array     = {}
        array[#array + 1] = CCFadeTo:create(1,50)
        array[#array + 1] = CCFadeTo:create(1,255)

        local sprite = CCBCenter.getNodeByTag(_node, 801)
        
        sprite:runAction(CCRepeatForever:create(transition.sequence(array)))

        --音效
        SOUND:playMusicBoss() 

	end

--[[ ## public fuction --]]
	--刷新排名列表
	_node.reloadRankGrid = reloadRankGrid
	--填充Boss数据
	_node.setValues = setValues
	--设置三个按钮
	_node.createEncourageBtn = createEncourageBtn

--[[ ## MAINs --]]
	initViews()
end

return M