local M = {}

local CardMaster = require("cardui.CardMaster")
function M.bindView(node, luaValue)
	local TAG = "[CardAlbumLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = node.data
	local _scrollGrid, _filterItems, _showItems, _selectItems
	local _chbAlliance, _chbTribe, _chbUndead
	local BTN_RACE_IMAGE = {
								"cardgroup/filter/img_race_all.png", 
								"cardgroup/filter/img_race_undead.png",
								"cardgroup/filter/img_race_tribe.png",
								"cardgroup/filter/img_race_alliance.png",
							}
--[[ ## local fuction --]]
	local function createTableView( )
		local layer = CCBCenter.getNodeByTag(_node, 5)
		
	    local function createItemCellListener( tableView, index, item, cell )
	        for i, v in ipairs(item) do
	        	local function onCardClick( card )
			        -- if card:isUnlock() then
		        	SOUND:playEffectButton1()
		        	CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", v)
			        -- end
			    end
	        	-- 放个背景
		        local bgSprite = widget.newSprite{ file = "cardgroup/album/bg_album_card_back.png"}
	            cell:addChild(bgSprite, 1)
	            bgSprite:setPosition((i - 1) * 130 + bgSprite:getContentSize().width/2, cell:getContentSize().height/2)

	            if not (_GAME.CONFIG.SDK_PLATFORM.albumShowCard == false and not v._UNLOCK) then
	            	-- 放个卡片
		            v.type = CardMaster.ALBUMCARD
		            v.handler = onCardClick
		            v.container = layer
		        	-- 生成卡片
			        local card = CardMaster.new(v)
		        	-- 填充头像
			        cell:addChild(card, 1)
			        cell._CARD = card
			        card:setPosition((i - 1) * 130 + 10, 10)
			        -- if v._UNLOCK then
			        -- 	card:setUnlock(true)
			        -- end
			        card:setUnlock(v._UNLOCK)
	            end
	            
	        end

	        return cell
	    end		

		local tableView = widget.newTable{
	    	contentSize = layer:getContentSize(),
	    	cellSize = CCSize( 126 * 6, 174),
	    	direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	    	createItemCellListener = createItemCellListener,
	    	parentNode = layer,
		}
		return tableView
	end
	
	-- 筛选然后展示
	local function filterShowItems( )
		_filterItems = {}
		for i = 1 , #_showItems do
			local race = CardDB.getByID(_showItems[i]:getId()).race
			if (race == RACE_ALLIANCE and _chbAlliance.getState() == TRUE ) 
				or (race == RACE_TRIBE and _chbTribe.getState() == TRUE ) 
				or (race == RACE_UNDEAD and _chbUndead.getState() == TRUE ) then
				table.insert(_filterItems, _showItems[i]) 
			end
		end
		-- 展示卡牌
		_scrollGrid:setItems(createTableItems(_filterItems, 6))
	end

	-- 创建所有卡牌
	local function getAllCards( )
		local cards = {}
		-- local allID = CardDB.getAllCardsID( )
		-- for i, cardId in ipairs(allID) do
		-- 	if cardId <= CARD_MAX_COUNT then
		-- 		local card = CardEntity.new{
		-- 						id 			= cardId,
		-- 					}
		-- 		table.insert(cards, card)
		-- 	end
		-- end
		local allCards = CardDB.getAllCards( )
		for i, v in ipairs(allCards) do
			if v.kind <= 6 then
				local card = CardEntity.new{
								id 			= v.cardno,
							}
				table.insert(cards, card)
			end
		end
		table.sort (cards ,function(a,b) 
			return a:getId() < b:getId()
		end)
		return cards
	end

	-- 创建每一行的Items
	local function createTableItems( cards, rows )
		local items = {}
		for i, v in ipairs(cards) do
			local row = math.ceil(i/rows)
			if not items[row] then
				items[row] = {}
			end
			table.insert(items[row], v)
		end
		return items
	end

	local function createTab(  )
		local function onTabClick( index, button )
			SOUND:playEffectButton1()
			quickui.showLoadingLayer()
			_filterItems = {}
           	local filterRace = index - 1
           	if filterRace == 0 then
           		_filterItems = _showItems
           	else
           		if filterRace == 1 then
           			filterRace = 3
       			elseif filterRace == 3 then
       				filterRace = 1
           		end
           		for i = 1 , #_showItems do
					local race = CardDB.getByID(_showItems[i]:getId()).race
					if race == filterRace then
						table.insert(_filterItems, _showItems[i]) 
					end
				end
           	end
       		_scrollGrid:setPosition(ccp(0, -display.height))
       		-- 展示卡牌
			_scrollGrid:setItems(createTableItems(_filterItems, 6))
			-- 动画
   --     		local action = CCMoveTo:create(0.2, ccp(0, 0))
   --     		_scrollGrid:runAction(action)
			-- quickui.hideLoadingLayer(  )
			local array     = {}
			array[#array + 1] = CCMoveTo:create(0.2, ccp(0, 0))
	        transition.execute(_scrollGrid, transition.sequence(array), {onComplete = function ()
	            -- 动画结束了
	            -- _isAnim = false
	            quickui.hideLoadingLayer()
	        end })
        end

        local buttons = { }                     
	    for i = 1, 4 do
	    	local btnRace = widget.newButton{   
                normalImage = BTN_RACE_IMAGE[i],
                contentSize = CCSize(110, 81),
                scale = 1.1,
            } 
		    table.insert(buttons, btnRace)   
	    end

        local tab = widget.newTab{
            items = buttons,
            selectIndex = 1,
            listener = onTabClick,
            direction = DIRECTION_VERTICAL,
        }
        CCBCenter.getNodeByTag(_node, 3):addChild(tab)
        util.alignNode(tab, CCBCenter.getNodeByTag(_node, 3):getContentSize(), display.CENTER)
        return tab
	end
	-- 创建筛选按钮, 默认选中
	local function initViews()
		-- 增加topButtons
		-- CCBCenter.getNodeByTag(_node, 2):addChild(require("cardui.TopButtons").new{select = 3})
		-- 增加种族选择
		createTab( )
		_scrollGrid = createTableView()
		-- _showItems = getAllCards()
		-- _scrollGrid:setItems(createTableItems(_showItems, 6))
	end

	function M.fillCards( items )
		if not _showItems then
			_showItems = getAllCards()
		end
		_selectItems = items
		for i = 1, #_selectItems do
			if _selectItems[i]:getKind() <= 6 then
				-- _showItems[_selectItems[i]:getId()]._UNLOCK = true
				for j,v in ipairs(_showItems) do
					if _selectItems[i]:getId() == v:getId() then
						v._UNLOCK = true
					end
				end
			end
		end
		_scrollGrid:setItems(createTableItems(_showItems, 6))
	end
--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
	_node.fillCards = M.fillCards
end

return M