local M = {}

local CardMaster = require("cardui.CardMaster")

function M.bindView(node, luaValue, ...)
	local TAG = "[CardDetailLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = node._DATA
    local ChatUtil = require("ccb.m.chat.ChatUtil")
	local _card
    local _skillScrollLinear
--[[ ## local fuction --]]
    -- 封装聊天发送卡牌名字       
    local function getChatSendRealCardName( cardname, no, lv, evolv, playname )
        
        if cardname == nil then return "" end
        if no == nil or not isnumber(no) or no <=0 or no > 10000 then return "[" .. cardname .. "]" end
        if lv == nil or not isnumber(lv) then lv = 1 end
        if evolv == nil or not isnumber(evolv) then evolv = 1 end

        if lv <= 0 then lv = 1 end
        if lv > 99 then lv = 99 end
        if evolv <= 0 then evolv = 1 end
        -- if evolv > 2 then evolv = 2 end

        if playname == nil then playname = "" end

        local str = "[" .. cardname .. GAMERATE:getChatCardFlag() .. no .. GAMERATE:getChatCardFlag() .. lv .. GAMERATE:getChatCardFlag() .. evolv ..GAMERATE:getChatCardFlag() .. playname .."]"
        return str
    end
    local function shareToChat( button )
        button.setStateDisabled(true)
        local sendString 
        if _data:getId() < 5000 then
            sendString = getChatSendRealCardName(_data:getCardName(), _data:getId(), _data:getLv(), _data:getEvolv(), ME:getName())
        end
        if sendString and ME:CanSpeak() then
            --   创建http请求
            NetHelper.createRequest(
                
                ACTID.MSG_SEND_CHAT,                     -- 请求id
                function ( properties, params )
                    NetHelper.QuickToast(_s("CHAT_SEND_SUCCESS"))
                end,                       -- 回调函数
                {
                    messagetype = ChatUtil.ChatWorld,   -- 消息类型 默认都是世界
                    content = sendString,               -- 内容   
                    touserid = 0,                       -- 接收者id，这里为0
                },                                      -- 请求信息实体或参数table
                { 
                    showLoading = false,
                }                           
            )
        end
    end
    local function createScrollLinear( )
        local node = CCBCenter.getNodeByTag(_node, 412)

        local function cellAtIndex( scrollGrid, idx , item)
            local cell = widget.newLayer()
            cell:ignoreAnchorPointForPosition(false)

            local nameLabel = ui.newTTFLabel{
                text = item.name,
                size = 22,
                color = BUTTON_COLOR3.BROWN,
            }
            cell:addChild(nameLabel)

            local tempLabel = ui.newTTFLabel{
                text = item:getInfo(),
                size = 20,
            }
            local lines = math.ceil(tempLabel:getContentSize().width / node:getContentSize().width)
            local infoLabel = ui.newTTFLabel{
                text = item:getInfo(),
                size = 20,
                color = BUTTON_COLOR3.BROWN,
                dimensions = CCSize(node:getContentSize().width, lines * tempLabel:getContentSize().height),
            }
            cell:addChild(infoLabel)

            local cellHeight = nameLabel:getContentSize().height + infoLabel:getContentSize().height + nameLabel:getContentSize().height/2
            -- local cellHeight = node:getContentSize().height / 3
            -- if cellHeight < nameLabel:getContentSize().height + infoLabel:getContentSize().height then
            --     cellHeight = nameLabel:getContentSize().height + infoLabel:getContentSize().height
            -- end
            cell:setContentSize(CCSize(node:getContentSize().width, cellHeight))
            util.alignNode(nameLabel, cell, display.TOP_LEFT)
            infoLabel:ignoreAnchorPointForPosition(true)
            infoLabel:setPosition(ccp(nameLabel:getPositionX(), nameLabel:getPositionY() - infoLabel:getContentSize().height - nameLabel:getContentSize().height))
            return cell
        end
        local scrollGrid = widget.newScrollLinear{
            contentSize = node:getContentSize(),
            cellAtIndexListener = cellAtIndex,
            contentParams = {
                column = 1,
                tapListener = tapListener,
                selectedParams = nil,
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        node:addChild(scrollGrid)
        return scrollGrid
    end
    local function createShareButton( )
        local shareButton = widget.newButton{
            normalImage = "btn_share.png",
            scale = 1.1,
            listener = shareToChat,
            priority = -1000000,
            labelParams = {text = _s("GOODS_SHOW_OFF"), color = BUTTON_COLOR3.BROWN, size = 16, padding = {top = 20}},
        }
        CCBCenter.getNodeByTag(_node, 5):addChild(shareButton)
        util.alignNode(shareButton, CCBCenter.getNodeByTag(_node, 5))
    end
	local function initViews()
        _skillScrollLinear = createScrollLinear()
		-- 加入卡片
		_data.type = CardMaster.MAXCARD
        _data.handler = nil
        _card = CardMaster.new(_data)
	    CCBCenter.getNodeByTag(_node, 202):addChild(_card)
	    
        -- 名字
	    _nodeTable.mNameLabel:setString(_data:getCardName())
        --玩家名字
        if _data.userName and _data.userName ~= "" then
            _nodeTable["mPlayerNameLabel"]:setString(_s("EQUIP_HERO_HAVE", _data.userName))
        end
	    -- 等级
	    if _data:getLv() then
	    	_nodeTable.mLevelLabel:setString(_data:getLv())
	    end
	   
	    -- 种族
	    _nodeTable.mRaceLabel:setString(_s("CARD_RACE_VALUE", _data:getRace()))

	    -- 血量
	    local talentHp = _data:getTalentHp()
        local equipEffectHp = _data:getEquipEffectHp() 
        local addValueHp = _data:getAddvalueHp()
        local finalHp = tonumber(talentHp) + equipEffectHp + addValueHp
	    _nodeTable.mHpLabel:setString(_data:getLvHp())
	    if finalHp > 0 then
	    	local addHpLabel = ui.newTTFLabel{text = " + " .. finalHp, color = BUTTON_COLOR3.GREEN, size = 23}
	    	CCBCenter.getNodeByTag(_node, 4):addChild(addHpLabel)
	    	addHpLabel:setPosition(ccp(_nodeTable.mHpLabel:getPositionX() + _nodeTable.mHpLabel:getContentSize().width + addHpLabel:getContentSize().width/2, _nodeTable.mHpLabel:getPositionY() + _nodeTable.mHpLabel:getContentSize().height/2))
	    end

	    -- 攻击力
	    local talentAtk = _data:getTalentAttack()
        local equipEffectAtk = _data:getEquipEffectAttack() 
        local addValueAtk = _data:getAddvalueAtk()
        local finalAtk = tonumber(talentAtk) + equipEffectAtk + addValueAtk
	    _nodeTable.mAtkLabel:setString(_data:getLvAttack())
	    if finalAtk > 0 then
	    	local addAtkLabel = ui.newTTFLabel{text = " + " .. finalAtk, color = BUTTON_COLOR3.GREEN, size = 23}
	    	CCBCenter.getNodeByTag(_node, 4):addChild(addAtkLabel)
	    	addAtkLabel:setPosition(ccp(_nodeTable.mAtkLabel:getPositionX() + _nodeTable.mAtkLabel:getContentSize().width + addAtkLabel:getContentSize().width/2, _nodeTable.mAtkLabel:getPositionY() + _nodeTable.mAtkLabel:getContentSize().height/2))
	    end

		-- 增加经验条
        local _xp = widget.newProgressBar{
            frontSprintParams = {file = "progressBar_blue_long_img.png",},
            bgSprintParams = {file = "progressBar_blue_long_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, },
            percentage = 0,
        }
        _xp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 407):addChild(_xp)

        -- 当前经验
    	local progress = _data:getCurexp() /  _data:getLevelMaxExp( ) * 100
    	_xp:runProgressTo( 0.4 , progress )
    	_xp:setString(_data:getCurexp() .. "/" .. _data:getLevelMaxExp( ))
        
        -- 技能
        local skillsTable = {}
    	local skills = _data:getSkills()
    	local nums = 1
    	for i = 1, 3 do
    		local tip = ""
    		local level = ""
    		if (i == 1 and skills.skill1 ~= nil) then
                skills.skill1.name = skills.skill1:getName()
    			if skills.skill1:getLevel() > 0 then
    				level = skills.skill1:getLevel()
                    skills.skill1.name = skills.skill1:getName() .. level
    			end
	    		nums = nums + 1
                skillsTable[#skillsTable + 1] = skills.skill1
			elseif (i == 2 and skills.skill2 ~= nil) then
                skills.skill2.name = skills.skill2:getName()
				if skills.skill2:getLevel() > 0 then
    				level = skills.skill2:getLevel()
                    skills.skill2.name = skills.skill2:getName() .. level
    			end
				if _data:getLv() < 30 then
					tip = _s("CARD_SKILL_UNLOCK_ONE")
                    skills.skill2.name = skills.skill2:getName() .. level .. tip
				end
	    		nums = nums + 1
                skillsTable[#skillsTable + 1] = skills.skill2
			elseif (i == 3 and skills.skill3 ~= nil) then
                skills.skill3.name = skills.skill3:getName()
				if skills.skill3:getLevel() > 0 then
    				level = skills.skill3:getLevel()
                    skills.skill3.name = skills.skill3:getName() .. level
    			end
				if _data:getLv() < 60 then
					tip = _s("CARD_SKILL_UNLOCK_TWO")
                    skills.skill3.name = skills.skill3:getName() .. level .. tip
				end
	    		nums = nums + 1
                skillsTable[#skillsTable + 1] = skills.skill3
    		end
    	end
        _skillScrollLinear:setItems(skillsTable)
        if _data.shareButton and _data:getCardStar( ) > 3 and _GAME.CONFIG.SDK_PLATFORM.chat ~= false then
            createShareButton( )
        end
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M