local M = {}

local CardMaster = require("cardui.CardMaster")
local LabelMarquee = require("cardui.LabelMarquee")

function M.bindView(node, luaValue)
	local TAG = "[CardEnhancedLayerView]"
	local _node, _nodeTable = node, luaValue
	-- local _node._DATA = node._DATA
	local _xp, _atk, _hp, _newAtk, _newHp, _particleBatch, _mainLayer, _feedLayer
	local _feedCardsScrollGrid
	local _selectMainCard
	local _selectFeedCard = {}
	local _sellCostGlod = 0
	local _isAnim = false
--[[ ## local fuction --]]

	-- 停止动画
	local function stopAnim( )
		_xp:stopAllActions()
	end
	-- 点击选择主卡牌
	local function onMainLayerClick( button )
		SOUND:playEffectButton1()
		if _isAnim then
			stopAnim( )
			_isAnim = false
		end
		_node._DATA._KEY = MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNMAINLAYERCLICK
		HelperView2.showNext()
		CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", _node._DATA)
	end

	local function onFeedLayerClick( button )
		SOUND:playEffectButton1()
		_node._DATA._KEY = MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNFEEDLAYERCLICK
		if #_node._DATA._SELECTMAIN < 1 then
			AlertLayer.new4OK{
	    		content 	= _s("CARD_SELECT_MAIN_CARD"),
	    	}
			return 
		end
		HelperView2.showNext()
		CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", _node._DATA)
	end
	-- 新手引导
    local function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {10040, 10040}, {10070, 10080}, {10130, 10130})
    end

	local function createFeedScrollGrid( )
		local layer = CCBCenter.getNodeByTag(_node, 502)
		--scrollview
	    local function createItemCellListener( grid, index, item )
	        -- local cell = display.newColorLayer(ccc4(255, 200, 0, 255))
	        local cell = widget.newLayer()
	        cell:setContentSize(grid:getCellSize())
	        cell:ignoreAnchorPointForPosition(false)
	        
	        -- 背景
	        local sprite = widget.newSprite{file = "cardgroup/enhanced/bg_card_enhanced_cell_feed.png"}
	        sprite:setScale(SCALE_FOR_SPECIAL_NODE)
	        cell:addChild(sprite)
            util.alignNode(sprite, cell:getContentSize(), display.CENTER)
            -- 头像
            item.type = CardMaster.MINICARD
        	-- 生成卡片
	        local card = CardMaster.new(item)
        	-- 填充头像
	        cell:addChild(card)
	        util.alignNodeWithPadding(card, cell:getContentSize(), display.LEFT_CENTER, {left = 4})
	        card:setScale(0.68)

	        -- 等级
	        local levelTTF = widget.newTTFLabelWithShadow{
	        				text = "LV" .. item:getLv(),
	        				size = 23,
	    	}
	    	cell:addChild(levelTTF)
			util.alignNodeWithPadding(levelTTF, cell:getContentSize(), display.CENTER_TOP, {left = 40, top = 10})

			-- 名字
			local nameTTF = widget.newTTFLabelWithShadow{
							text = item:getCardName(),
							size = 23,
			}
			cell:addChild(nameTTF)
			util.alignNodeWithPadding(nameTTF, cell:getContentSize(), display.CENTER_TOP, {left = -50, top = 10})

			-- 阵营
			-- local raceTTF = widget.newTTFLabelWithShadow{
			-- 				text = _s("CARD_RACE") .. item:getCardRace(),
			-- 				size = 23,
			-- }
			-- cell:addChild(raceTTF)
			-- util.alignNodeWithPadding(raceTTF, cell:getContentSize(), display.CENTER_LEFT, {left = 126, top = 21})

			-- 星星
			local star = require("cardui.LinearStar").new({ fileName = "card/img_card_star.png",margin = ccp(3, 0), count = item:getCardStar( ), unitScale = 0.6, })
			cell:addChild(star)
			util.alignNodeWithPadding(star, cell:getContentSize(), display.CENTER_BOTTOM, {left = 80, bottom = 20})

	        return cell
	    end
	    --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( 307, 78),
	            padding = { 
	                middleH = 4, middleV = 4,
	            },
	            column = 1,
	            createItemCellListener = createItemCellListener,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	    }
	    return scrollGrid
	end
	local function onProgressListener( progressBar, percentage, totalPercentage )
		if percentage < totalPercentage then
			progressBar:setString(string.format("%d%%", percentage%100))
		end
	end
	local function initViews()

		-- 增加topButtons
		-- CCBCenter.getNodeByTag(_node, 2):addChild(require("cardui.TopButtons").new{select = 3})

		--增加经验ProgressBar
        _xp = widget.newProgressBar{
            frontSprintParams = {file = "cardgroup/enhanced/progressBar_blue_img.png",},
            bgSprintParams = {file = "cardgroup/enhanced/progressBar_blue_bg.png"},
            percentage = 0,
            updateProgressListener = onProgressListener,
            ttfLabelParams = {size = 14/SCALE_FOR_SPECIAL_NODE, padding = {top = 3}},
        }
        _xp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 411):addChild(_xp)
        _mainLayer = CCBCenter.getNodeByTag(_node, 303, "CCLayer")
        _feedLayer = CCBCenter.getNodeByTag(_node, 502, "CCLayer")
		-- bind主卡牌选择
		widget.bindTouchEvent{
								layer = _mainLayer,
								clickListener = onMainLayerClick,
		}
		-- bind饲料牌选择
		widget.bindTouchEvent{
								layer = _feedLayer,
								clickListener = onFeedLayerClick,
		}

		-- 饲料牌区域
		_feedCardsScrollGrid = createFeedScrollGrid()
		-- 滚动数字
		_atk = LabelMarquee.new{
					classType  = LabelMarquee.CLASSTYPE_TTF,      -- 类型
			        text       = "0",                                 	-- 标签文字
			        size       = 23,                                    -- 字体大小
			        -- color      = ccc3(255, 255, 255),
			        times         = 5,   
			        duration      = 0.5,
    				}
		CCBCenter.getNodeByTag(_node, 419):addChild(_atk)
		util.alignNode(_atk, CCBCenter.getNodeByTag(_node, 418):getContentSize(), display.CENTER_LEFT)

		_hp = LabelMarquee.new{
					classType  = LabelMarquee.CLASSTYPE_TTF,      -- 类型
			        text       = "0",                                 	-- 标签文字
			        size       = 23,                                    -- 字体大小
			        times         = 5,   
			        duration      = 0.5,
			        -- color      = ccc3(255, 255, 255),
    				}
	    CCBCenter.getNodeByTag(_node, 418):addChild(_hp)
	    util.alignNode(_hp, CCBCenter.getNodeByTag(_node, 418):getContentSize(), display.CENTER_LEFT)

	    _newAtk = LabelMarquee.new{
					classType  = LabelMarquee.CLASSTYPE_TTF,      -- 类型
			        text       = "0",                                 	-- 标签文字
			        size       = 23,                                    -- 字体大小
			        times         = 10,   
			        duration      = 0.5,
			        color      = ccc3(244, 89, 69),
    				}
	    CCBCenter.getNodeByTag(_node, 408):addChild(_newAtk)
	    util.alignNode(_newAtk, CCBCenter.getNodeByTag(_node, 408):getContentSize(), display.CENTER_LEFT)

	    _newHp = LabelMarquee.new{
					classType  = LabelMarquee.CLASSTYPE_TTF,      -- 类型
			        text       = "0",                                 	-- 标签文字
			        size       = 23,                                    -- 字体大小
			        times         = 10,   
			        duration      = 0.5,
			        color      = ccc3(244, 89, 69),
    				}
	    CCBCenter.getNodeByTag(_node, 405):addChild(_newHp)
	    util.alignNode(_newHp, CCBCenter.getNodeByTag(_node, 405):getContentSize(), display.CENTER_LEFT)
		
		checkHelperInfo()
	end

--[[ ## public fuction --]]
	function M.cardUpgrade( cardEntitys )
		local addLevel = cardEntitys[1]:getLv() - _nodeTable.mLevelLabel:getString()
		local oldLevel = tonumber(_nodeTable.mLevelLabel:getString())

		local function whiteLight( )
			_nodeTable.mWhiteLightSprite:setVisible(true)
   			transition.fadeOut(_nodeTable.mWhiteLightSprite , {time = 0.5})
		end
		local function playLight()
			-- if isios() or true then 
			-- 粒子效果
        	local emitter = CCParticleSystemQuad:create("card/cardUpgrade.plist")
        	_particleBatch = CCParticleBatchNode:createWithTexture(emitter:getTexture())
        	_particleBatch:addChild(emitter)
        	CCBCenter.getNodeByTag(_node, 3):addChild(_particleBatch, 10)
        	_particleBatch:setPosition(util.centerNode(CCBCenter.getNodeByTag(_node, 3)))
			-- end
		end
		local function stopLight( )
			-- if isios() or true then
			_particleBatch:removeFromParentAndCleanup(true)
			-- end
		end
		local function onProgressComplete ( progressBar, percentage )
			local progress = cardEntitys[1]:getCurexp() /  cardEntitys[1]:getLevelMaxExp( ) * 100
			_xp:runProgressFromTo( 0.5, 0, progress, function ( )
				
				whiteLight()
				stopLight( )
				if cardEntitys[1]:getLv() >= CARD_MAX_LEVEL then
					-- 变为60
					local layer = CCBCenter.getNodeByTag(_node, 303)
					layer:removeAllChildrenWithCleanup(true)
					local cardEntity = CardEntity.new{ id = cardEntitys[1]:getId(), lv = 60,}
					cardEntity.type = CardMaster.MASTERCARD
			        local card = CardMaster.new(cardEntity)
			        layer:addChild(card)

					AlertLayer.new4OK{
						titleStr = _s("CARD_CONGRATULATION"),
						content = _s("CARD_ALREADY_MAX_LEVEL"),
						btnClickEvent = {
							function ( )
								M.updateUpgradeCard{}
							end
						},
					}
				else
					M.updateUpgradeCard(cardEntitys)
				end
			end )
			_isAnim = false
			util.enableCustomTouch(_mainLayer, true)
			util.enableCustomTouch(_feedLayer, true)
		end

		local function onProgressRun( progressBar, percentage, totalPercentage )
			local level =  oldLevel + percentage / 100
			_nodeTable.mLevelLabel:setString(level)
			local layer = CCBCenter.getNodeByTag(_node, 303)
			layer:removeAllChildrenWithCleanup(true)
			local cardEntity = CardEntity.new{ id = cardEntitys[1]:getId(), lv = level, evolv = cardEntitys[1]:getEvolv()}
			cardEntity.type = CardMaster.MASTERCARD
	        local card = CardMaster.new(cardEntity)
	        layer:addChild(card)
	        util.alignNode(card, layer:getContentSize(), display.CENTER)
	        _atk:animateText{
		         valueTo       = cardEntity:getLvAttack(),          -- 到达值
		         times         = 50,                                -- 动画次数
		         duration      = 0.4,                               -- 动画时长
		    }
		    -- _atk:setText(cardEntity:getLvAttack())
		    _hp:animateText{
		         valueTo       = cardEntity:getLvHp(),         		-- 到达值
		         times         = 50,                                -- 动画次数
		         duration      = 0.4,                               -- 动画时长
		    }
		    -- whiteLight()
		    -- _hp:setText(cardEntity:getLvHp())
		end
		
		if addLevel > 0 then
			_isAnim = true
			util.enableCustomTouch(_mainLayer, false)
			util.enableCustomTouch(_feedLayer, false)
			playLight()
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONSTOPANIMATION)
			_newAtk:animateText{
		         valueTo       = 0,          -- 到达值
		         times         = addLevel + 1,                                -- 动画次数
		         duration      = addLevel * 0.4,                               -- 动画时长
		         -- increase      = -10,
		    }
			_newHp:animateText{
		         valueTo       = 0,          -- 到达值
		         times         = addLevel + 1,                                -- 动画次数
		         duration      = addLevel * 0.4,                               -- 动画时长
		    }
			_xp:runProgressTo(0.5, addLevel * 100, false, onProgressComplete, onProgressRun)
		else
			M.updateUpgradeCard(cardEntitys)
		end
		checkHelperInfo()
	end
	-- 更新升级卡牌
	function M.updateUpgradeCard( cardEntitys )
		local layer = CCBCenter.getNodeByTag(_node, 303)
		layer:removeAllChildrenWithCleanup(true)

		if #cardEntitys > 0 then
			_selectMainCard = cardEntitys[1]
			local cardEntity = cardEntitys[1]
			_node._DATA._SELECTMAIN[1] = cardEntity:getCpid()
			cardEntity.type = CardMaster.MASTERCARD
	        local card = CardMaster.new(cardEntity)
	        layer:addChild(card)
	        util.alignNode(card, layer:getContentSize(), display.CENTER)

	        
	        _nodeTable.mLevelLabel:setString(cardEntity:getLv())
	        _atk:animateText{
		         valueTo       = cardEntity:getLvAttack(),          -- 到达值
		         times         = 5,                                -- 动画次数
		         duration      = 0.5,                               -- 动画时长
		    }
		    _hp:animateText{
		         valueTo       = cardEntity:getLvHp(),         		-- 到达值
		         times         = 5,                                -- 动画次数
		         duration      = 0.5,                               -- 动画时长
		    }
	        if cardEntity:getCurexp() then
	        	local progress = cardEntity:getCurexp() /  cardEntity:getLevelMaxExp( ) * 100
	        	_xp:runProgressTo( 0.5 , progress )
	        	_xp:setString(cardEntity:getCurexp() .. "/" .. cardEntity:getLevelMaxExp())
	        end
	    else
			_node._DATA._SELECTMAIN = {}
	    	_selectMainCard = {}
	    	_nodeTable.mLevelLabel:setString(0)
	    	_atk:animateText{
		         valueTo       = 0,          -- 到达值
		         times         = 5,                                -- 动画次数
		         duration      = 0.5,                               -- 动画时长
		    }
		    _hp:animateText{
		         valueTo       = 0,         		-- 到达值
		         times         = 5,                                -- 动画次数
		         duration      = 0.5,                               -- 动画时长
		    }
		    _xp:runProgressTo( 0.5 , 0 )
	        _xp:setString(0)
	        _nodeTable.mNewLevelLabel:setString("0")
	        _newAtk:setText(0)
	        _newHp:setText(0)
	        CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONSTOPANIMATION)
		end
		checkHelperInfo()
	end
	-- 更新金币
	function M.updateGold( )
		_nodeTable.mCoinLabel:setString(ME:getGold())
	end

	-- 可升等级计算
	function M.getUpgradeLevel( exp )
		local getExp = exp
		local level 
		if _selectMainCard and table.nums(_selectMainCard) > 0 and _selectMainCard:getLv() then
			level = _selectMainCard:getLv()
		else
			return 0
		end
		-- 上限为60
		for i = _selectMainCard:getLv(), (CARD_MAX_LEVEL + 1) do
			local nextUpgradeExp = CardDB.getExp(_selectMainCard:getId(), level)
			if nextUpgradeExp then
				if i == _selectMainCard:getLv() then
					nextUpgradeExp = nextUpgradeExp - _selectMainCard:getCurexp()
				end
				Log.d("当前等级", i)
				Log.d("当前级别上限 ", CardDB.getExp(_selectMainCard:getId(), level) )
				Log.d("剩余经验", getExp)
				Log.d("下一级还需", nextUpgradeExp)
				if getExp > nextUpgradeExp and i < (CARD_MAX_LEVEL + 1) then
					getExp = getExp - nextUpgradeExp
					level = level + 1
				else
					Log.d("能升级到", level, i)
					return level
				end
			else
				Log.d("能升级到", level, i)
				return level
			end
		end
	end
	-- 更新饲料卡牌
	function M.updateFeedCard( cardEntitys )
		_node._DATA._SELECTFEED = {}
		_sellCostGlod = 0
		local exp = 0
		local addAttack = 0
		local addHp = 0
		-- 提示文字
		CCBCenter.getNodeByTag(_node, 501):setVisible(iff(#cardEntitys == 0, true, false))
		for i,v in ipairs(cardEntitys) do
			table.insert(_node._DATA._SELECTFEED, v:getCpid())
			_sellCostGlod = _sellCostGlod + v:getEnhancedGlod()
			exp = exp + v:getEnhancedExp()
		end
		_selectFeedCard = cardEntitys
		_node._DATA._SELECTFEEDENTITYS = _selectFeedCard
		_feedCardsScrollGrid:setItems( cardEntitys )
		-- 花费
		_nodeTable.mCostNode:removeAllChildrenWithCleanup(true)
		local params = {{text = _s("CARD_USE_MONEY"), size = 18},
            {text = tostring(math.floor(_sellCostGlod)), size = 18,color = ccc3(231, 209, 168)},}
        local  costLinearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(costLinearLabel, _nodeTable.mCostNode,display.CENTER)
        _nodeTable.mCostNode:addChild(costLinearLabel)

		-- 经验
		_nodeTable.mXpNewNode:removeAllChildrenWithCleanup(true)
		local params = {{text = _s("CARD_GET_EXP"), size = 18},
            {text = tostring(math.floor(exp)), size = 18,color = ccc3(231, 209, 168)},}
        local  expLinearLabel = widget.newLinearLabel({paramTable = params})
        util.alignNode(expLinearLabel, _nodeTable.mXpNewNode,display.CENTER)
        _nodeTable.mXpNewNode:addChild(expLinearLabel)
		local newLevel = M.getUpgradeLevel( exp )
		local cardDb 
		if _selectMainCard and table.nums(_selectMainCard) > 0 then
			cardDb = CardDB.getByID(_selectMainCard:getId())
			local evoRate = GAMERATE[string.format("getEvoRate_%d", _selectMainCard:getEvolv())](GAMERATE)
			-- if _selectMainCard:getEvolv() > 1 then
			-- 	evoRate = GAMERATE:getEvoRate()
			-- end
			-- 新增攻击力
			addAttack = math.floor(cardDb.attack + (newLevel - 1) * cardDb.atrate * evoRate - _selectMainCard:getLvAttack())
			-- 新增生命
			addHp = math.floor(cardDb.hp + (newLevel - 1)  * cardDb.hprate * evoRate - _selectMainCard:getLvHp())
		end
		
		_newAtk:setText(addAttack)
		_newHp:setText(addHp)

		-- 升级计算
		_nodeTable.mNewLevelLabel:setString(newLevel)
		if _selectMainCard and table.nums(_selectMainCard) > 0 and newLevel > _selectMainCard:getLv() then
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONPLAYANIMATION)
		else
			CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDENHANCEDLAYER_ACTION_ONSTOPANIMATION)
		end
		checkHelperInfo()
	end
	-- 判断升级参数合理性
	function M.isReasonable( )
		if #_node._DATA._SELECTMAIN < 1 then
			AlertLayer.new4OK{
	    		content 	= _s("CARD_SELECT_MAIN_CARD")
	    	}
			return false
		end
		if #_node._DATA._SELECTFEED < 1 then
			AlertLayer.new4OK{
	    		content 	= _s("CARD_SELECT_FEED_CARD")
	    	}
			return false
		end
		if _sellCostGlod > ME:getGold() and not HelperView2.isNextIndex(10131) then
			AlertLayer.new4OK{
	    		content 	= _s("CARD_MONEY_NOT_ENOUGH")
	    	}
			return false
		end
		return true
	end
--[[ ## MAINs --]]
	initViews()
	_node.updateUpgradeCard = M.updateUpgradeCard
	_node.updateFeedCard = M.updateFeedCard
	_node.isReasonable = M.isReasonable
	_node.updateGold   = M.updateGold
	_node.cardUpgrade  = M.cardUpgrade
end

return M