--CardEvolutionLayer.lua
local M = {}

local CardMaster = require("cardui.CardMaster")
local GoodsMaster = require("cardui.GoodsMaster")
local GoodsEntity = require("model.goods.GoodsEntity")
function M.bindView(node, luaValue)
	local TAG = "[CardEvolutionLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = _node._DATA
    local _lightSprite, _originalLayer
--[[ ## local fuction --]]
    -- 阴影文字
    local function addShadowCenterById( nodeId, text )
        local node = CCBCenter.getNodeByTag(_node, nodeId)
        local ttfLabel = widget.newTTFLabelWithOutline{
            text = text,
            size = 22,
        }
        node:addChild(ttfLabel)
        util.alignNode(ttfLabel, node)
    end
    -- 创建新消息渐隐动画
    local function playFadeAction( sprite )
        sprite:stopAllActions()
        local sequence = transition.sequence{
            CCFadeTo:create(1, 255),
            CCDelayTime:create(0.5),
            CCFadeTo:create(1, 0),
            CCDelayTime:create(0.5),
        }
        local action = CCRepeatForever:create(sequence)
        sprite:runAction(action)
    end
    -- 爆炸
    local function playLightBoom( onComplete )
        local layer = CCBCenter.getNodeByTag(_node, 404)
        local lightSprite = anim.playAnimation(nil, "cardgroup/evolution/img_evo_boom", "img_evo_boom_%d.png", 10, 1, 1, false, true, onComplete)
        layer:addChild(lightSprite)
        util.alignNodeWithPadding(lightSprite, layer, display.CENTER, {top = -5,})
    end
    -- 吸收光
    local function createLightAbsorb( onComplete )
        local lightAbsorbSprite = anim.playAnimation(nil, "cardgroup/evolution/img_evo_absorb", "img_evo_absorb_%d.png", 16, 1, 1, false, true, onComplete)
        return lightAbsorbSprite
    end
    local function createLightBall( )
        local lightBallSprite = anim.playAnimation(nil, "cardgroup/evolution/img_evo_ball", "img_evo_ball_%d.png", 11, 1, 1, true)
        transition.fadeIn(lightBallSprite, {time = 1})
        return lightBallSprite
    end
    local function createOriginalTouchLayer( )
        _originalLayer = CCBCenter.getNodeByTag(_node, 3, "CCLayer")
        widget.bindTouchEvent{
            layer = _originalLayer,
            clickListener = function ( )
                -- util.enableCustomTouch(_originalLayer, false)
                quickui.showLoadingLayer()
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP, nil, {isMaterial = false, cpid1 = 0, cpid2 = 0})
            end,
        }
    end
    local function createMaterialTouchLayer( )
        _materialLayer = CCBCenter.getNodeByTag(_node, 10, "CCLayer")
        widget.bindTouchEvent{
            layer = _materialLayer,
            clickListener = function ( )
                if #_data._SELECTMAIN > 0 then
                    -- util.enableCustomTouch(_materialLayer, false)
                    quickui.showLoadingLayer()
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP, nil, {isMaterial = true, cpid1 = _data._SELECTMAIN[1]:getCpid(), cpid2 = 0})
                else
                    NetHelper.QuickToast(_s("CARD_SELECT_EVO_CARD"))
                end
            end,
        }
    end
    -- local function createLightEffect( )
    --     -- 清空节点容器
    --     local node = CCBCenter.getNodeByTag(_node, 101)
    --     node:removeAllChildrenWithCleanup(true)
    --     -- 创建切割区域
    --     local clipNode = display.newClippingRegionNode(CCRect(0, 0, node:getContentSize().width, node:getContentSize().height))
    --     node:addChild(clipNode)
    --     util.alignNode(clipNode, node:getContentSize(), display.CENTER)
    --     -- 创建光精灵
    --     _lightSprite = widget.newSprite{file = "cardgroup/evolution/bg_evolution_light.png"}
    --     clipNode:addChild(_lightSprite)
    --     _lightSprite:setPosition(clipNode:getContentSize().width/2, -_lightSprite:getContentSize().height/2)
    -- end
    -- 创建升级材料entity
    local function createGoodsEntity( no, count )
        return GoodsEntity.new{no = no, count = count, typ = _GAME.CONFIG.GOODS.TYPE.MATERIAL.KEY, price = 100}
    end
    local function getMaterialValue( card, index, materialList )
        local result = 0
        if not materialList then
            return result
        end
        local materialCost = materialList
        result = string.split(materialCost, ",")[index]
        result = string.split(result, ":")
        local no = result[1]
        local count = result[2]
        local cost = result[3]
        return tonumber(count), createGoodsEntity(no, cost)
    end

    local function getMaterialCostEntity( card, index )
        local result = {}
        local materialCost = GAMERATE:getEvoFourStarMaterial()
        local num = (card:getCardRaceId() - 1) * 4 + index
        result = string.split(materialCost, ",")[num]
        result = string.split(result, ":")
        local no = result[1]
        local count = result[2]
        return createGoodsEntity(no, count)
    end
    -- 新手引导
    local function checkHelperInfo( )
        HelperView2.showBetween(
            _node, 
            nil, 
            {20030, 20080}
        )
    end
	local function initViews()
        -- 文字阴影
        addShadowCenterById(602, _s("TEAM_RULE_DETAIL"))
		-- createLightEffect( )
        createOriginalTouchLayer( )
        createMaterialTouchLayer( )
        _data._SELECTMAIN = {}
        _data._MATERIALLIST = {}
        -- M.updateEvoButtonStatus( )
        checkHelperInfo()
	end

--[[ ## public fuction --]]
    -- 素材是否足够
    local function isMaterialEnough( )
        local materialList = _data._MATERIALLIST
        local cardEntitys = _data._SELECTMAIN
        for i = 1, 4 do
            local material, materialCostEntity = getMaterialValue(cardEntitys[1], i, materialList)--:getCount()
            local cost = materialCostEntity:getCount()
            if material < cost then
                NetHelper.QuickToast(_s("CARD_MATERIAL_NOT_ENOUGH"))
                return false
            end
        end
        return true
    end
    -- 选中的卡牌
    function M.getSelectCard( )
        return _data._SELECTMAIN
    end
    -- 循环光效动画
    -- function M.playLightAnim( )
    --     local node = CCBCenter.getNodeByTag(_node, 101)
    --     _lightSprite:stopAllActions()
    --     _lightSprite:setPosition(node:getContentSize().width/2, -_lightSprite:getContentSize().height/2)
    --     local array     = {}
    --     array[#array + 1] = CCMoveTo:create(3, ccp(node:getContentSize().width/2, _lightSprite:getContentSize().height/2 + node:getContentSize().height))
    --     array[#array + 1] = CCCallFunc:create(function ()
    --         _lightSprite:setPosition(node:getContentSize().width/2, -_lightSprite:getContentSize().height/2)
    --     end )
    --     -- array[#array + 1] = CCDelayTime:create(1)
    --     local action = transition.sequence(array)
    --     action = CCRepeatForever:create(action)
    --     transition.execute(_lightSprite, action, {})
    -- end
    -- 循环卡牌渐隐渐现
    function M.playFadeAnim( enable )
        local maskSprite = CCBCenter.getNodeByTag(_node, 402, "CCSprite")
        maskSprite:stopAllActions()
        maskSprite:setVisible(enable)
        if enable then
            maskSprite:setOpacity(160)
            local array     = {}
            array[#array + 1] = CCFadeTo:create(1.5, 60)
            array[#array + 1] = CCFadeTo:create(1.5, 160)

            local action = transition.sequence(array)
            action = CCRepeatForever:create(action)
            transition.execute(maskSprite, action, {})
        end
    end
    -- 合成动画
    function M.playEvoAnim( )
        -- 粒子效果
        -- local particleBatch
        -- local particle = CCParticleSystemQuad:create("cardgroup/evolution/whiteRipples.plist")
        -- particleBatch = CCParticleBatchNode:createWithTexture(particle:getTexture())
        -- particleBatch:addChild(particle)
        -- _node:addChild(particleBatch, 20)
        -- particleBatch:setPosition(ccp(249, 369))
        -- 求两点间直线距离
        local function getDistance( pointA, pointB )
            local result = ((pointA.x - pointB.x)^2 + (pointA.y - pointB.y)^2)^0.5
            return math.abs(result) 
        end
        -- 禁止进入选卡
        M.enableSelectEvoCard( false )
        -- 隐藏文字
        _nodeTable["mSelectMainCardLabel"]:setVisible(false)
        _nodeTable["mSelectMaterialCardLabel"]:setVisible(false)

        -- 加入光球
        local ballList = {}
        for i = 1, 6 do
            ballList[i] = createLightBall()
        end

        -- 素材们消失
        for i = 1, 4 do
            -- 吸收光出现
            local nodeTag = string.format("70%d", i)
            local node = CCBCenter.getNodeByTag(_node, tonumber(nodeTag))
            local absorbSprite = createLightAbsorb()
            absorbSprite:setScale(0.5)
            node:addChild(absorbSprite, 10)
            util.alignNode(absorbSprite, node)
            ballList[i]:setScale(0.5)
            _node:addChild(ballList[i], 11)
            local position = _node:convertToNodeSpace(ccp(node:getPositionX() + ballList[i]:getContentSize().width - 8, node:getPositionY() + ballList[i]:getContentSize().height / 2 - 18))
            ballList[i]:setPosition(position)
            -- util.alignNode(ballList[i], node)
            -- 挡板出现
            local frameSprite = CCBCenter.getNodeByTag(_node, tonumber(nodeTag .. "04"), "CCSprite")
            local frontprite = CCBCenter.getNodeByTag(_node, tonumber(nodeTag .. "05"), "CCSprite")
            transition.fadeIn(frameSprite, {time = 1, onComplete = function ( )
                CCBCenter.getNodeByTag(_node, tonumber(nodeTag .. "02")):removeAllChildrenWithCleanup(true)
                frameSprite:setOpacity(0)
            end})
            transition.fadeIn(frontprite, {time = 1, onComplete = function ( )
                frontprite:setOpacity(0)
            end})
        end

        -- 素材卡牌消失
        local materialMaskSprite = CCBCenter.getNodeByTag(_node, 1002, "CCSprite")
        materialMaskSprite:stopAllActions()
        transition.fadeIn(materialMaskSprite, {time = 1, onComplete = function ( )
            CCBCenter.getNodeByTag(_node, 1001):removeAllChildrenWithCleanup(true)
            materialMaskSprite:setOpacity(0)
        end})
        local materialNode = CCBCenter.getNodeByTag(_node, 10)
        local materialAbsorbSprite = createLightAbsorb()
        materialNode:addChild(materialAbsorbSprite, 10)
        util.alignNode(materialAbsorbSprite, materialNode)
        _node:addChild(ballList[5], 11)
        local position = _node:convertToNodeSpace(ccp(materialNode:getPositionX(), materialNode:getPositionY()))
        ballList[5]:setPosition(position)
        -- 素材卡消失
        -- M.updateMaterialCard{selectCard = {}}
        -- 合成按钮阻止
        -- _nodeTable.btnEvolutionConfirm:setEnabled(false)
        -- 合成卡消失
        local maskSprite = CCBCenter.getNodeByTag(_node, 302, "CCSprite")
        maskSprite:stopAllActions()
        maskSprite:setOpacity(0)
        maskSprite:setVisible(true)
        local evoNode = CCBCenter.getNodeByTag(_node, 3)
        local evoAbsorbSprite = createLightAbsorb()
        evoNode:addChild(evoAbsorbSprite, 10)
        util.alignNode(evoAbsorbSprite, evoNode)
        _node:addChild(ballList[6], 11)
        local position = _node:convertToNodeSpace(ccp(evoNode:getPositionX(), evoNode:getPositionY()))
        ballList[6]:setPosition(position)
        transition.fadeIn(maskSprite, {time = 1, onComplete = function ( )
            -- 光球移位
            local count = 0
            for i, ball in ipairs(ballList) do
                -- local time = getDistance(ccp(ball:getPositionX(), ball:getPositionY()), ccp(770, 362)) / 800
                transition.moveTo(ball, {delay = 0.3, easing = "CCEaseSineIn", x = 770, y = 362, time = 0.2, onComplete = function ( )
                    transition.fadeOut(ball, {time = 0.5, onComplete = function ( )
                        count = count + 1
                        if count == #ballList then
                            M.updateEvolutionCard{selectCard = {}}
                            -- M.updateEvoButtonStatus()
                            maskSprite:setVisible(false)
                            -- 延迟一会
                            -- util.delayCall(function ( )
                                -- particle:stopSystem()
                                -- 合成成功
                                M.playFadeAnim( false )
                                playLightBoom(function ( )
                                    M.enableSelectEvoCard( true )
                                    -- particleBatch:removeFromParentAndCleanup(true)
                                    _nodeTable["mSelectMainCardLabel"]:setVisible(true)
                                    _nodeTable["mSelectMaterialCardLabel"]:setVisible(true)
                                    _nodeTable["btnEvolutionConfirm"]:setEnabled(true)
                                end)
                            --     -- 白光一现
                            --     -- local lightSprite = CCBCenter.getNodeByTag(_node, 403, "CCSprite")
                            --     -- lightSprite:setVisible(true)
                            --     -- transition.fadeOut(lightSprite , {time = 0.5, delay = 0.3, onComplete = function ( )
                            --     --     M.enableSelectEvoCard( true )
                            --     --     particleBatch:removeFromParentAndCleanup(true)
                            --     -- end})
                            -- end, 1)
                        end
                    end})
                end})
            end
            -- 光效移位
            -- transition.moveTo(particleBatch, {x = 714, y = 362, time = 0.5, onComplete = function ( )
            --     M.updateEvolutionCard{selectCard = {}}
            --     M.updateEvoButtonStatus()
            --     maskSprite:setVisible(false)
            --     -- 延迟一会
            --     util.delayCall(function ( )
            --         particle:stopSystem()
            --         -- 合成成功
            --         M.playFadeAnim( false )
            --         playLightBoom(function ( )
            --             M.enableSelectEvoCard( true )
            --             particleBatch:removeFromParentAndCleanup(true)
            --             _nodeTable["mSelectMainCardLabel"]:setVisible(true)
            --             _nodeTable["mSelectMaterialCardLabel"]:setVisible(true)
            --         end)
            --         -- 白光一现 
            --         -- local lightSprite = CCBCenter.getNodeByTag(_node, 403, "CCSprite")
            --         -- lightSprite:setVisible(true)
            --         -- transition.fadeOut(lightSprite , {time = 0.5, delay = 0.3, onComplete = function ( )
            --         --     M.enableSelectEvoCard( true )
            --         --     particleBatch:removeFromParentAndCleanup(true)
            --         -- end})
            --     end, 1)
            -- end})
        end})
    end
    -- 更新结果卡牌
    function M.updateResultCard( evoCard )
        local layer = CCBCenter.getNodeByTag(_node, 401)
        layer:removeAllChildrenWithCleanup(true)
        
        if #evoCard > 1 then
            local resultCard = clone(evoCard[1])
            local evolv = evoCard[1]:getEvolv() + evoCard[2]:getEvolv()
            resultCard:setEvolv(evolv)
            resultCard:setLv(1)
            resultCard:setCurexp(0)
            resultCard.type = CardMaster.MASTERCARD
            resultCard.handler = function ( card )
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", card.getParams())
            end
            local card = CardMaster.new(resultCard)
            layer:addChild(card)
            util.alignNode(card, layer:getContentSize(), display.CENTER)
            M.playFadeAnim(true)
        -- else
            -- _data._SELECTMAIN = {}
        end
    end
    -- 更新卡牌和素材
    function M.updateMaterialCard( data )
        local function getMaterialLayerTag( index )
            return tonumber(string.format("70%d02", index))
        end

        local function addNotEnough( node, tip )
            tip = tip or _s("CARD_MATERIAL_NOT_ENOUGH_WRAP")
            local maskSprite = widget.newScale9{file = "img_mask.png", contentSize = node:getContentSize() }--CCSize(node:getContentSize().width, node:getContentSize().height - 1) }
            node:addChild(maskSprite, 2)
            util.alignNode(maskSprite, node:getContentSize(), display.CENTER)
            local tipLabel = ui.newTTFLabel{text = tip, dimensions = node:getContentSize(), size = 22, align = ui.TEXT_ALIGN_CENTER}
            node:addChild(tipLabel, 2)
            util.alignNode(tipLabel, node:getContentSize(), display.CENTER)
            local frameSprite = widget.newSprite{file = "cardgroup/evolution/img_evolution_cell.png"}
            node:addChild(frameSprite, 2)
            util.alignNode(frameSprite, node:getContentSize(), display.CENTER)
            playFadeAction(tipLabel)
            playFadeAction(maskSprite)
        end
        
        _data._MATERIALLIST = data.materialList
        if not _data._MATERIALLIST then
            _data._MATERIALLIST = {}
        end
        local cardEntitys = data.selectCard
        local materialList = data.materialList
        
        -- 素材卡
        local layer = CCBCenter.getNodeByTag(_node, 1001)
        layer:removeAllChildrenWithCleanup(true)
        _data._SELECTMAIN = data.selectCard
        if #_data._SELECTMAIN > 1 then
            local cardEntity = _data._SELECTMAIN[2]
            cardEntity.type = CardMaster.MASTERCARD
            local card = CardMaster.new(cardEntity)
            layer:addChild(card)
            util.alignNode(card, layer:getContentSize(), display.CENTER)
        end

        -- 清空材料栏位
        for i = 1, 4 do
            local layer = CCBCenter.getNodeByTag(_node, getMaterialLayerTag(i))
            layer:removeAllChildrenWithCleanup(true)
            if #cardEntitys > 0 then
                -- if i == 1 then
                --     local materCard
                --     if  #cardEntitys > 1 then
                --         materCard = cardEntitys[2]
                --         materCard.handler = function ( card )
                --             CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", card.getParams())
                --         end
                --     else
                --         materCard = cardEntitys[1]
                --         addNotEnough(layer, _s("CARD_MATERIAL_NOT_ENOUGH_CAED"))
                --     end
                --     materCard.type = CardMaster.MINICARD
                --     local card = CardMaster.new(materCard)
                --     card:setScale(0.77)
                --     layer:addChild(card, 1)
                --     util.alignNode(card, layer:getContentSize(), display.CENTER)
                -- else
                    local material, materialCostEntity = getMaterialValue(cardEntitys[1], i, materialList)--:getCount()
                    -- local materialCostEntity = getMaterialCostEntity(cardEntitys[1], i)
                    -- 图片
                    materialCostEntity.type = GoodsMaster.MATERIAL
                    materialCostEntity.showDetail = true
                    local materialView = GoodsMaster.new(materialCostEntity)
                    layer:addChild(materialView, 1)
                    util.alignNodeWithPadding(materialView, layer:getContentSize(), display.CENTER)

                    -- 名称
                    -- local materialNameLabel = ui.newTTFLabel{text = materialCostEntity:getName(), size = 10}
                    -- layer:addChild(materialNameLabel, 3)
                    -- util.alignNodeWithPadding(materialNameLabel, layer:getContentSize(), display.TOP_CENTER, {top = 10})
                    -- 数量
                    local cost = materialCostEntity:getCount()
                    -- local material = getMaterialValue(cardEntitys[1], i, materialList):getCount()
                    local color = COLOR3.WHITE
                    if material < cost then
                        addNotEnough(layer)
                        color = COLOR3.RED
                    end
                    local valueLabel = ui.newTTFLabel{text = material .. " / " .. cost, size = 18, color = color}
                    layer:addChild(valueLabel, 2)
                    util.alignNode(valueLabel, layer:getContentSize(), display.BOTTOM_CENTER)
                -- end
            end
        end
        -- 更新合成结果卡
        -- M.updateResultCard( _data._SELECTMAIN )
    end
    -- 更新进化卡牌
    function M.updateEvolutionCard( data )
        local layer = CCBCenter.getNodeByTag(_node, 301)
        layer:removeAllChildrenWithCleanup(true)
        -- 更新卡牌素材
        M.updateMaterialCard{selectCard = {}}
        _data._SELECTMAIN = data.selectCard
        _data._SELECTMAIN[2] = nil
        if #_data._SELECTMAIN > 0 then
            local cardEntity = _data._SELECTMAIN[1]
            cardEntity.type = CardMaster.MASTERCARD
            local card = CardMaster.new(cardEntity)
            layer:addChild(card)
            util.alignNode(card, layer:getContentSize(), display.CENTER)

            -- 更新合成结果卡
            M.updateResultCard{}

        else
            _data._SELECTMAIN = {}
        end
        
    end
    -- 可点击选牌
    function M.enableSelectEvoCard( enable )
        util.enableCustomTouch(_node, enable)
        -- util.enableCustomTouch(_originalLayer, enable)
        -- util.enableCustomTouch(_materialLayer, enable)
    end
    -- 更新合成按钮状态
    -- function M.updateEvoButtonStatus( )
        -- _nodeTable.btnEvolutionConfirm:setEnabled(#_data._SELECTMAIN > 1 and M.isMaterialEnough())
    -- end
--[[ ## MAINs --]]
	initViews()
    _node.playEvoAnim                 = M.playEvoAnim
    -- _node.updateEvoButtonStatus       = M.updateEvoButtonStatus
    _node.getSelectCard               = M.getSelectCard
    _node.updateMaterialCard          = M.updateMaterialCard
    _node.updateResultCard            = M.updateResultCard
    -- _node.playLightAnim               = M.playLightAnim
    _node.isMaterialEnough            = isMaterialEnough
    _node.playFadeAnim                = M.playFadeAnim
    _node.enableSelectEvoCard         = M.enableSelectEvoCard
    _node.updateEvolutionCard         = M.updateEvolutionCard
end

return M