local M = {}

local CardMaster = require("cardui.CardMaster")
function M.bindView(node, luaValue)
	local TAG = "[CardFilterLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = _node._DATA
	-- local _card = _data:getCards()
	local _cCount = ((_data.getCcount and _data:getCcount()) or 0) - 1
	local _maxCost = 0
	local _scrollGrid, _smallScrollGrid , _raceTab
	local _oneStarCheckBox, _twoStarCheckBox, _smartButton
	local _protected
	local _selectItems = {}
	local _selectItems2 = {}
	local _showItems   = {}
	local _filterItems = {}
	local _cardType
	local _isMultiple
	local _minCost, _curCost
	local _costLabel
	local _contentOffset
	local _isCheck = false
	local _upgradeCard
	local _racePopLayer
	local _updateGlod = true
	local _updateCost = true
	local _isMe = true
	local BTN_RACE_IMAGE = {
		{normalImage = "cardgroup/filter/img_race_all.png", selectImage = "cardgroup/filter/img_race_all_select.png" }, 
		{normalImage = "cardgroup/filter/img_race_undead.png", selectImage = "cardgroup/filter/img_race_undead_select.png" },
		{normalImage = "cardgroup/filter/img_race_tribe.png", selectImage = "cardgroup/filter/img_race_tribe_select.png" },
		{normalImage = "cardgroup/filter/img_race_alliance.png", selectImage = "cardgroup/filter/img_race_alliance_select.png" },
	}
	local _helperCard = {}
	local setCardInfo, isCompliance
--[[ ## local fuction --]]
	--[[
		e.g.: _nodeTable["mSprite"]
	--]]
	local function isOnwar( card )
		for i, v in ipairs(_data:getOnwarcards()) do
			if v:getCpid() == card:getCpid() then
				return true
			end
		end
		return false
	end
	local function isInSelect2( card )
		for i, v in ipairs(_selectItems2) do
			if v:getCpid() == card:getCpid() then
				return true
			end
		end
		return false
	end
	-- 更新选中多少张
	local function updateSelectTip( )
		if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK then
			_nodeTable.mSelectItemsLabel:setString(string.format(_s("CARD_ALSO_SELECT"), _cCount - #_selectItems))
		else
			_nodeTable.mSelectItemsLabel:setString(string.format(_s("CARD_ALREADY_SELECT"), #_selectItems))
		end
	end
	-- 更新金币
	local function updateGlodTip( )
		if not _updateGlod then
			return
		end
		local sellGold = 0

		for i, v in ipairs(_selectItems) do
			sellGold = sellGold + v:getSellGlod()
		end
		-- 出售金币
		_nodeTable.mSellMoneyLabel:setString(tostring(sellGold))
		-- 我的金币
		_nodeTable.mMyMoneyLabel:setString(ME:getGold())
	end
	-- 更新Cost
	local function updateCostTip( )
		if not _updateCost then
			return
		end
		-- 初始化最小Cost
		if not _minCost then
			_minCost = 0
			for i , v in ipairs(_data:getOnwarcards()) do
				local cardDB = CardDB.getByID(v:getId())
				if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK 
					and v:getMain() == TRUE then
					_minCost = _minCost + cardDB.cost
					break
				-- elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK 
				-- 	and v:getMain() ~= TRUE then
				-- 	_minCost = _minCost + cardDB.cost
				end
			end
		end
		-- 计算当前选中Cost
		_curCost = _minCost
		-- _curCost = 0
		for i , v in ipairs(_selectItems) do
			local cardDB = CardDB.getByID(v:getId())
			_curCost = _curCost + cardDB.cost
		end
		for i,v in ipairs(_selectItems2) do
			local cardDB = CardDB.getByID(v:getId())
			_curCost = _curCost + cardDB.cost
		end
		if not _costLabel then
			_costLabel = widget.newTTFLabelWithShadow{text = "", size = 20,}
			_costLabel:setContentSize(CCSize(153, 31))
			CCBCenter.getNodeByTag(_node, 4):addChild(_costLabel)
			util.alignNode(_costLabel, CCBCenter.getNodeByTag(_node, 4):getContentSize(), display.CENTER_LEFT)
		end
		_costLabel:setString(string.format(_s("CARD_COST_VALUE"), _curCost, _maxCost))
		_costLabel:setColor(_curCost > _maxCost and ccc3(239, 65, 54) or display.COLOR_WHITE )
		-- luaValue.mCostLabel:setString(_curCost .. "/" .. _maxCost)
		-- luaValue.mCostLabel:setColor(_curCost > _maxCost and ccc3(239, 65, 54) or display.COLOR_WHITE )
	end

	local function selectShowingCard_(index)
		index = index or 1
		if _helperCard and _helperCard[index] and _filterItems[index] then 
			_helperCard[index]:setSelected( true )
			table.insert( _selectItems, clone(_filterItems[index]))
			_helperCard = {}
			if _isMultiple then 
				_smallScrollGrid:setItems(_selectItems)
			else
				setCardInfo(_selectItems[1])
			end
			updateSelectTip( )
			updateCostTip( )
		end
	end

	local function isInSelect( item )
		for i,v in ipairs(_selectItems) do
			if v:getCpid() == item:getCpid() then
				return i
			end
		end
		return false
	end
	local function selectStar( star )
		_contentOffset = _scrollGrid:getContentOffset()
		for i,v in ipairs(_filterItems) do
			if v:getCardStar() == star then
				if not isInSelect(v) then
					table.insert(_selectItems, v)
				end
			end
		end
		_smallScrollGrid:setItems(_selectItems)
		updateSelectTip( )
		updateGlodTip( )
		_scrollGrid:refresh()
		if _contentOffset then
			_scrollGrid:setContentOffset(_contentOffset)
			_contentOffset = nil
		end
	end
	local function removeStar( star )
		_contentOffset = _scrollGrid:getContentOffset()
		for i,v in ipairs(_filterItems) do
			if v:getCardStar() == star then
				local poi = isInSelect(v)
				if poi then
					-- table.insert(_selectItems, v)
					table.remove(_selectItems, poi)
				end
			end
		end
		_smallScrollGrid:setItems(_selectItems)
		updateSelectTip( )
		updateGlodTip( )
		_scrollGrid:refresh()
		if _contentOffset then
			_scrollGrid:setContentOffset(_contentOffset)
			_contentOffset = nil
		end
	end
	-- 单个信息, 点击后跳转过去
	local function createSingleInfoLayer( )
		local function clickListener( )
			local card = _selectItems[1]
			if card then
				local race = CardDB.getByID(card:getId()).race
		        -- 取得当前点击卡牌
		        local filterRace = _raceTab.getSelected()
		        if filterRace == 1 then
           			filterRace = 3
       			elseif filterRace == 3 then
       				filterRace = 1
           		end
		        if filterRace == 4 or race == filterRace then
		        	for i = 1, #_filterItems do
						if _filterItems[i] == card then
							_scrollGrid:scrollToItemIndex(i)
							break
						end
					end
		        end
			end
	    end

		widget.bindTouchEvent{ 
				layer = CCBCenter.getNodeByTag(_node, 702, "CCLayer"),
				clickListener = clickListener, 
			}
	end
	-- 单选, 展示卡片信息
	function setCardInfo( item )
		-- 头像layer
		local cardLayer = CCBCenter.getNodeByTag(_node, 70201)

		if item then
			cardLayer:removeAllChildrenWithCleanup(true)
			
			-- 显示头像
			cardLayer:setVisible(true)
	        item.type = CardMaster.MINICARD
	        -- 生成卡片
	        local card = CardMaster.new(item)
	        card:setScale(0.68)
	        -- 填充头像
	        cardLayer:addChild(card)
	        util.alignNode(card, cardLayer:getContentSize(), display.CENTER)

	        -- 名字
	        if item:getCardName() then
				_nodeTable.mNameLabel:setVisible(true)
				_nodeTable.mNameLabel:setString(item:getCardName())
	        end
			
			-- 等级
			if item:getLv() then
				CCBCenter.getNodeByTag(_node, 70203):setVisible(true)
				_nodeTable.mLevelLabel:setVisible(true)
				_nodeTable.mLevelLabel:setString(item:getLv())
			end
			
			-- 阵营
			if item:getEthnicity() then
				CCBCenter.getNodeByTag(_node, 70205):setVisible(true)
				_nodeTable.mRaceLabel:setVisible(true)
				_nodeTable.mRaceLabel:setString(item:getCardRace())
			end

			-- 星级
			if item:getCardStar() then
				-- 星星
				CCBCenter.getNodeByTag(_node, 70207):removeAllChildrenWithCleanup(true)
				local star = require("cardui.LinearStar").new({ fileName = "card/img_card_star.png",margin = ccp(3, 0), count = item:getCardStar( ), unitScale = 0.6, })
				CCBCenter.getNodeByTag(_node, 70207):addChild(star)
				util.alignNodeWithPadding(star, CCBCenter.getNodeByTag(_node, 70207):getContentSize(), display.CENTER_BOTTOM, {left = 120, bottom = 10})
				-- CCBCenter.getNodeByTag(_node, 70205):setVisible(true)
				-- _nodeTable.mRaceLabel:setVisible(true)
				-- _nodeTable.mRaceLabel:setString(item:getCardRace())
			end
		else
			cardLayer:setVisible(false)
			-- 名字
			_nodeTable.mNameLabel:setVisible(false)
			-- 等级
			_nodeTable.mLevelLabel:setVisible(false)
			-- 阵营
			_nodeTable.mRaceLabel:setVisible(false)
		end
	end
	-- 多选, 已选中展示scroll
	local function createSmallScrollGrid( )
		local layer = CCBCenter.getNodeByTag(_node, 703)
		--scrollview
	    local function createItemCellListener( grid, index, item )
	        -- local cell = display.newColorLayer(ccc4(255, 200, 0, 255))
	        local cell = widget.newLayer()
	        cell:setContentSize(grid:getCellSize())
	        cell:ignoreAnchorPointForPosition(false)
	        -- 生成卡片
	        item.type = CardMaster.MINICARD
            local card = CardMaster.new(item)
            card:setScale(0.68)
            -- 这里用tag测试, 有方法被清掉的情况, so改成了如下
	        cell._CARD = card
	        cell:addChild(card)
            util.alignNode(card, cell:getContentSize(), display.CENTER)

	        return cell
	    end
	    local function tapListener( grid, index, item )
	    	SOUND:playEffectButton2()
	    	local race = CardDB.getByID(item:getId()).race
	        -- 取得当前点击卡牌
	        local filterRace = _raceTab.getSelected()
	        if filterRace == 1 then
       			filterRace = 3
   			elseif filterRace == 3 then
   				filterRace = 1
       		end
	        if filterRace == 4 or race == filterRace then
	        	for i = 1, #_filterItems do
					if _filterItems[i]:getCpid() == item:getCpid() then
						_scrollGrid:scrollToItemIndex(i)
						break
					end
				end
	        end
	    end
	    --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( 73, 73),
	            padding = { 
	                middleH = 8,
	                -- middleV = 4,
	            },
	            row = 1,
	            createItemCellListener = createItemCellListener,
	            -- tapListener = tapListener,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = layer,
	    }
	    return scrollGrid
	end

	local function createScrollView( )
		local layer = CCBCenter.getNodeByTag(_node, 5)
	    local function createItemCellListener(tableView, index, item, cell)
	    	if item then 
		    	item._INDEX = index
		        item.type = _cardType
		        if _isMe then
		        	item:setTalent(ME:getTalent())
		        	item:setEquipEffect(ME:getEquipEffect())
		        end
		        
	            local card = CardMaster.new(item)
		        cell:addChild(card)
		        -- 这里用tag测试, 有方法被清掉的情况, so改成了如下
		        cell._CARD = card
		        if HelperView2.isEnabled() then 
		        	if 1 <= index and index <= 2 then 
		        		_helperCard[index] = card
		        	end
		        end
	            for i = 1, #_selectItems do
	            	if item == _selectItems[i] then
	            		card:setSelected( true )
	            		break
	            	end
	            end
	            for i = 1, #_selectItems2 do
	            	if item == _selectItems2[i] and item ~= _selectItems[1] then
	            		card:setSelected( true, nil, true )
	            		-- break
	            	end
	            end
	            -- CCBCenter.changeAllLayerTouchPriorityToLast(card)
	        end
	    end

	    local function tapCellListener(tableView, index, item, cell) 
	        -- 取得当前点击卡牌
	        SOUND:playEffectButton1()
	        local card = cell._CARD 
	        if not card then
	        	cell:removeAllChildrenWithCleanup(true)
	        	createItemCellListener(tableView, index, item, cell)
	        	card = cell._CARD 
	        end
	        -- 多选时候, 未选中添加, 已选中移除
	        if _isMultiple then
	        	if card:getSelected() then
	        		-- 取消移除
		        	card:setSelected( false , true)
		        	-- 遍历选中列表, 找到并剔除
		        	for i = 1, #_selectItems do
	        			if _selectItems[i] == item then table.remove(_selectItems, i) end
	        		end
		       	elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK then
		       		-- 这里是多选卡牌要计算cost上限和卡牌数量的上限
		       		if _cCount > #_selectItems then
		       			-- 这里需要选中上限的判定(Cost, 解锁上限)
			       		-- 选中插入
			       		card:setSelected( true , true)
			       		table.insert(_selectItems, item)
			       		-- 移动到下一个
			       		-- if index < #tableView:getItems() then
			       		-- 	tableView:scrollToItemIndex(index)
			       		-- end
			       	else
			       		AlertLayer.new4OK{
							titleStr = _s("COMMON_NEWS_TIPS"),
							content = _s("CARD_UNLOCK_NOT_ENOUGH"),
						}
		       		end
	       		elseif _data._KEY == MSG_ID.MSG_TEAMMEMBERLAYER_MODEL or _data._KEY == MSG_ID.MSG_TEAMLISTLAYER_MODEL then
	       			-- 战队卡只能选择四张
		       		if GAMERATE:getTeamCardLimit() > #_selectItems then
		       			-- 这里需要选中上限的判定(Cost, 解锁上限)
			       		-- 选中插入
			       		card:setSelected( true , true)
			       		table.insert(_selectItems, item)
			       	else
			       		NetHelper.QuickToast(_s("TEAM_CARD_LIMIT", GAMERATE:getTeamCardLimit()))
		       		end
		       	else
		       		-- 选中插入
		       		card:setSelected( true , true)
		       		table.insert(_selectItems, item)
		       		-- 移动到下一个
		       		-- if index < #tableView:getItems() then
		       		-- 	tableView:scrollToItemIndex(index)
		       		-- end
		        end
		        _smallScrollGrid:setItems(_selectItems)
		        -- 更新下cost
		       	updateCostTip( )
		       	updateGlodTip( )
	        else
	        	if card.getParams().showStatus and not isCompliance(card.getParams()) then

	        	-- 单选 这时候要判断下要不要移除除上次选中
	        	elseif not card:getSelected() then
	        		-- 单选时候取消上次选择, 修改选中_selectItems[1]
		        	-- 取得上次卡牌
		        	
		        	if _selectItems[1] and _selectItems[1]._INDEX then
		        		if tableView:cellAt( _selectItems[1]._INDEX ) then
		        			local lastCard = tableView:cellAt( _selectItems[1]._INDEX )._CARD
			        		if not lastCard then
					        	cell:removeAllChildrenWithCleanup(true)
					        	createItemCellListener(tableView, index, item, cell)
					        	lastCard = cell._CARD 
					        end
			        		lastCard:setSelected( false , true)
		        		end
		        		
		        	end
		        	-- 选中新点击
		        	card:setSelected( true ,true)
		        	_selectItems[1] = item
		        	setCardInfo(_selectItems[1])
		        	if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK then
		        		-- 更新下cost
			       		updateCostTip( )
		        	end
		        	-- 移动到选中
		        	-- if index < #tableView:getItems() then
		       		-- 	tableView:scrollToItemIndex(index)
		       		-- end
	       		elseif isInSelect2(item) and _selectItems[1] ~= item then
	       			if _selectItems[1] and _selectItems[1]._INDEX then
		        		if tableView:cellAt( _selectItems[1]._INDEX ) then
		        			local lastCard = tableView:cellAt( _selectItems[1]._INDEX )._CARD
			        		if not lastCard then
					        	cell:removeAllChildrenWithCleanup(true)
					        	createItemCellListener(tableView, index, item, cell)
					        	lastCard = cell._CARD 
					        end
			        		lastCard:setSelected( true , false, true)
		        		end
		        	end
		        	for i, v in ipairs(_selectItems2) do
		        		if v == item then
		        			if _selectItems2[i] and _selectItems2[i]._INDEX then
				        		if tableView:cellAt( _selectItems2[i]._INDEX ) then
				        			local lastCard = tableView:cellAt( _selectItems2[i]._INDEX )._CARD
					        		if not lastCard then
							        	cell:removeAllChildrenWithCleanup(true)
							        	createItemCellListener(tableView, index, item, cell)
							        	lastCard = cell._CARD 
							        end
					        		lastCard:setSelected( true , true, false)
				        		end
				        	end
		        			_selectItems2[i] = _selectItems[1]
		        			_selectItems[1] = item
		        			break
		        		end
		        	end
		        	
		        	setCardInfo(_selectItems[1])
		        	if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK then
		        		-- 更新下cost
			       		updateCostTip( )
		        	end
	        	end
	        end
	        updateSelectTip( )
	    end
	    
	    local scrollGrid = widget.newTable{
	    	contentSize = layer:getContentSize(),
	    	cellSize = CCSize( 230, 326),
	    	direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	    	tapListener = tapCellListener,
	    	createItemCellListener = createItemCellListener,
	    	parentNode = layer,
		}
	    
	    return scrollGrid
	end

	local function isFeeds( card )
		for i = 1, #_data._SELECTFEED do
			if _data._SELECTFEED[i] == card:getCpid() then
				return true
			end
		end
		return false
	end
	
	local function createTab( )
		local function createRaceButton( fileName )
			CCBCenter.getNodeByTag(_node, 3):removeAllChildrenWithCleanup(true)
			local btnRace = widget.newButton{
				normalImage = fileName,
				listener = function ( button )
					local isVisible = _racePopLayer:isVisible()
					-- _racePopLayer:setVisible(not isVisible)
					if isVisible then
						_racePopLayer:hideWithMask(false)
					else
						_racePopLayer:showWithMask()
						anim.bottomFadeIn(_racePopLayer)
					end
				end,
				scale = 1.1,
				contentSize = CCSize(110, 81),
			}
	        CCBCenter.getNodeByTag(_node, 3):addChild(btnRace)
	        util.alignNode(btnRace, CCBCenter.getNodeByTag(_node, 3):getContentSize(), display.CENTER)
		end
		local function onTabClick( index, button )
			SOUND:playEffectButton1()
			quickui.showLoadingLayer()

			_racePopLayer:hideWithMask(false)
			createRaceButton(BTN_RACE_IMAGE[index].normalImage)
			
			_filterItems = {}
           	local filterRace = index - 1
           	if filterRace == 0 then
           		_filterItems = _showItems
           	else
           		if filterRace == 1 then
           			filterRace = 3
       			elseif filterRace == 3 then
       				filterRace = 1
           		end
           		for i = 1 , #_showItems do
					local race = CardDB.getByID(_showItems[i]:getId()).race
					if race == filterRace then
						table.insert(_filterItems, _showItems[i]) 
					end
				end
           	end
           	
       		_scrollGrid:setPosition(ccp(display.width, 0))
       		-- 展示卡牌
			_scrollGrid:setItems(_filterItems)
			-- 动画
       		-- local action = CCMoveTo:create(0.3, ccp(0, 0))
       		-- _scrollGrid:runAction(action)
			-- quickui.hideLoadingLayer()
			local array     = {}
			array[#array + 1] = CCMoveTo:create(0.3, ccp(0, 0))
	        transition.execute(_scrollGrid, transition.sequence(array), {onComplete = function ()
	            -- 动画结束了
	            -- _isAnim = false
	            quickui.hideLoadingLayer()
	        end })
        end

        local buttons = { }

	    for i = 1, 4 do
	    	local btnRace = widget.newButton{   
                normalImage = BTN_RACE_IMAGE[i].normalImage,
                selectImage = BTN_RACE_IMAGE[i].selectImage,
                disableImage = BTN_RACE_IMAGE[i].selectImage,
                contentSize = CCSize(110, 81),
                scale = 1.1,
            } 
		    table.insert(buttons, btnRace)   
	    end
        _raceTab = widget.newTab{
            items = buttons,
            selectIndex = 1,
            listener = onTabClick,
            direction = DIRECTION_VERTICAL,
        }
        _racePopLayer = widget.newLayer{}
        local bgSprite = widget.newSprite{file = "cardgroup/filter/bg_race_select_layer.png",}
        _racePopLayer:setContentSize(bgSprite:getContentSize())
        _racePopLayer:addChild(bgSprite, 0)
        util.alignNode(bgSprite, _racePopLayer:getContentSize(), display.CENTER)
        _racePopLayer:addChild(_raceTab, 1)
        util.alignNode(_raceTab, _racePopLayer:getContentSize(), display.CENTER)
        _node:addChild(_racePopLayer)
        widget.bindMaskLayer(_racePopLayer, false, false, ccc4(0,0,0,0))
        _racePopLayer:setPosition(ccp(4, 220))
        createRaceButton("cardgroup/filter/img_race_all.png")
	end

	local function starCheckBox( )
		local function onCheck( check )
			if _isCheck then
				return
			end
			_isCheck = true
			quickui.showLoadingLayer()
			-- print("check.isSelected", check.isSelected())
			if check.isSelected() then
				selectStar(check._STAR)
			else
				removeStar(check._STAR)
			end
			quickui.hideLoadingLayer( )
			_isCheck = false
		end
		_oneStarCheckBox = widget.newCheckBox{selectImage = "cardgroup/album/btn_tribe_select.png",
                                            normalImage = "cardgroup/album/btn_tribe_normal.png",
                                            labelParams = {text = "全选1星"},
	                                        listener = onCheck,
	                                    	}
	    _oneStarCheckBox._STAR = 1
        CCBCenter.getNodeByTag(_node, 3):addChild(_oneStarCheckBox)
        util.alignNodeWithPadding(_oneStarCheckBox, CCBCenter.getNodeByTag(_node, 3):getContentSize(), display.CENTER_RIGHT, {right = -117.5})
		_twoStarCheckBox = widget.newCheckBox{selectImage = "cardgroup/album/btn_tribe_select.png",
                                            normalImage = "cardgroup/album/btn_tribe_normal.png",
                                            labelParams = {text = "全选2星"},
	                                        listener = onCheck,
	                                    	}
	    _twoStarCheckBox._STAR = 2                                	
        CCBCenter.getNodeByTag(_node, 3):addChild(_twoStarCheckBox)
        util.alignNodeWithPadding(_twoStarCheckBox, CCBCenter.getNodeByTag(_node, 3):getContentSize(), display.CENTER_RIGHT, {right = -235})
	end

	local function getMaxLevelNeedExp( card )
		if card:getLv() >= CARD_MAX_LEVEL then
			return 0
		end
		-- 需要升级
		local needTotalLevel = CARD_MAX_LEVEL - card:getLv()
		-- 下一级经验
		local needTotalExp = CardDB.getExp(card:getId(), card:getLv()) - card:getCurexp()

		if needTotalLevel > 1 then
			for i = 1, needTotalLevel - 1 do
				needTotalExp = needTotalExp + CardDB.getExp(card:getId(), card:getLv() + i)
			end
		end
		return needTotalExp
	end

	local function createSmartButton( )
		local function updateScrollGrid( )
			_contentOffset = _scrollGrid:getContentOffset()
			_scrollGrid:refresh()
			_scrollGrid:setContentOffset(_contentOffset)
			_contentOffset = nil
			updateSelectTip()
		end
		local function smartSelect( )
			if _upgradeCard then
				-- 先清空选中框
				_selectItems = {}
				-- 取得升级需要总经验
				local totalExp = getMaxLevelNeedExp(_upgradeCard)
				-- 筛选
				for i, v in ipairs(_filterItems) do
					if v:getCardStar() < 3 and v:getId() < 1000 then
						totalExp = totalExp - v:getEnhancedExp()
						table.insert(_selectItems, v)
						if totalExp <= 0 then
							break
						end
					end
				end
				_smallScrollGrid:setItems(_selectItems)
				updateScrollGrid( )
				quickui.hideLoadingLayer( )
			end
		end
		local function onClick( check )
			if check.isSelected() then
				quickui.showLoadingLayer()
				smartSelect( )
			else
				_selectItems = {}
				_smallScrollGrid:setItems(_selectItems)
				updateScrollGrid( )
			end
		end
		_smartButton = widget.newCheckBox{
			selectImage = "cardgroup/filter/chb_smart_select.png",
            normalImage = "cardgroup/filter/chb_smart_normal.png",
            labelParams = {text = _s("CARD_SMART_SELECT"), color = BUTTON_COLOR3.BROWN},
            listener = onClick,
    	}
        CCBCenter.getNodeByTag(_node, 11):addChild(_smartButton)
        util.alignNode(_smartButton, CCBCenter.getNodeByTag(_node, 11):getContentSize(), display.CENTER)

        -- 说明按钮
        local btnHelp = widget.newButton{
	        normalImage = "cardgroup/filter/btn_help.png",
	        scale = 1.1,
	        listener = function ( button )
	        	NetHelper.QuickToast(_s("CARD_SMART_SELECT_HELP"), nil, 6)
	        end,
     	}
        CCBCenter.getNodeByTag(_node, 11):addChild(btnHelp)
        util.alignNodeWithPadding(btnHelp, CCBCenter.getNodeByTag(_node, 11):getContentSize(), display.CENTER, {left = 100})                          	
	end

	local function createStarSmartButton( )
		local function updateScrollGrid( )
			_contentOffset = _scrollGrid:getContentOffset()
			_scrollGrid:refresh()
			_scrollGrid:setContentOffset(_contentOffset)
			_contentOffset = nil
			updateSelectTip()
		end
		local function selectStar( star )
			_contentOffset = _scrollGrid:getContentOffset()
			_selectItems = {}

			for i,v in ipairs(_filterItems) do
				if (v:getCardStar() <= star and v:getId() < 1000) or v:getId() > 2000 then
					table.insert(_selectItems, v)
				end
			end
			_smallScrollGrid:setItems(_selectItems)
			updateSelectTip( )
			updateGlodTip( )
			_scrollGrid:refresh()
			
			if _contentOffset then
				_scrollGrid:setContentOffset(_contentOffset)
				_contentOffset = nil
			end
			quickui.hideLoadingLayer( )
		end
		local function onClick( check )
			if check.isSelected() then
				quickui.showLoadingLayer()
				selectStar(2)
			else
				_selectItems = {}
				_smallScrollGrid:setItems(_selectItems)
				updateScrollGrid( )
				updateGlodTip( )
			end
		end
		_smartButton = widget.newCheckBox{
			selectImage = "cardgroup/filter/chb_smart_select.png",
            normalImage = "cardgroup/filter/chb_smart_normal.png",
            labelParams = {text = _s("CARD_SMART_SELECT"), color = BUTTON_COLOR3.BROWN},
            listener = onClick,
    	}
        CCBCenter.getNodeByTag(_node, 11):addChild(_smartButton)
        util.alignNode(_smartButton, CCBCenter.getNodeByTag(_node, 11):getContentSize(), display.CENTER)

        -- 说明按钮
        local btnHelp = widget.newButton{
	        normalImage = "cardgroup/filter/btn_help.png",
	        scale = 1.1,
	        listener = function ( button )
	        	NetHelper.QuickToast(_s("CARD_STAR_SMART_SELECT_HELP"), nil, 6)
	        end,
     	}
        CCBCenter.getNodeByTag(_node, 11):addChild(btnHelp)
        util.alignNodeWithPadding(btnHelp, CCBCenter.getNodeByTag(_node, 11):getContentSize(), display.CENTER, {left = 100})                          	
	end
	local function createTip( string )
		local node = CCBCenter.getNodeByTag(_node, 13)
		local tipLabel = ui.newTTFLabel{
			text = string,
			color = BUTTON_COLOR3.BROWN,
			size = 26,
		}
		node:addChild(tipLabel)
		util.alignNode(tipLabel, node, display.CENTER_LEFT)
	end
	local function disableBtnBack()
		_nodeTable["btnBack"]:setVisible(false)
		_node.closeLayer = function () return false end
	end

	local function initViews()
		-- 增加顶部种族选择
		createTab( )
		-- 添加卡片展示区域
		_scrollGrid = createScrollView()
		-- 类型区别
		if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK then
			-- 1.卡牌出售
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_SELL"))
			_isMultiple = true
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			-- 显示金币
			CCBCenter.getNodeByTag(_node, 8):setVisible(true)
			-- 星级智能选取
			createStarSmartButton( )
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK then
			-- 2.卡牌保护
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_PROTECTION"))
			_isMultiple = true
			_cardType = CardMaster.LOCKCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK then
			-- 3.配置副卡牌
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_CONFIG_VICE"))
			_isMultiple = true
			_cardType = CardMaster.CONFIGCARD
			if ME:getTotalcost() then
				_maxCost = ME:getTotalcost()
			end
			if HelperView2.show(_node, 510) ~= nil or HelperView2.show(_node, 890) ~= nil  then 
				-- 在新手引导中,要把关闭给隐藏掉
				disableBtnBack()
			end
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK then
			-- 4.配置主卡牌
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_CONFIG_MAIN"))
			_isMultiple = false
			_cardType = CardMaster.CONFIGMAINCARD
			if ME:getTotalcost() then
				_maxCost = ME:getTotalcost()
			end
			if HelperView2.show(_node, 480) ~= nil then 
				-- 在新手引导中,要把关闭给隐藏掉
				disableBtnBack()
			end
		elseif _data._KEY == MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNMAINLAYERCLICK then
			-- 5.选择要升级的牌
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_ENHANCED_CARD"))
			_isMultiple = false
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			-- 显示向导
			local function callback( index )
				if index == 10050 then 
					selectShowingCard_(1)
				elseif index == 490 then
					CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDFILTERLAYER_ONBTNCONFIRMCLICK) 
				end
			end
			-- if HelperView2.isNextIndex(10041) then 
			-- 	disableBtnBack()
			-- end
			if HelperView2.showBetween(_node, callback, {10041, 10041}) ~= nil then 
				-- 在新手引导中,要把关闭给隐藏掉
				disableBtnBack()
			end
		elseif _data._KEY == MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNFEEDLAYERCLICK then
			-- 6.选择饲料牌
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_ENHANCED_FEED_CARD"))
			_isMultiple = true
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			-- starCheckBox( )
			createSmartButton( )
			-- 显示向导
			local function callback( index )
				if index == 10110 then 
					selectShowingCard_(1)
				elseif index == 520 then
					CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDFILTERLAYER_ONBTNCONFIRMCLICK) 
				end
			end
			if HelperView2.showBetween(_node, callback, {10090, 10120}) ~= nil then 
				-- 在新手引导中,要把关闭给隐藏掉
				disableBtnBack()
			end
		elseif _data._KEY == MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL then
			-- 7.选择要进化的卡
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_EVOLUTION"))
			_isMultiple = false
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			createTip(_s("CARD_EVO_SELECT_CARD"))
		elseif _data._KEY == MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP then
			-- 8.选择进化的素材卡
			_nodeTable.mLayerTitleLabel:setString(_s("CARD_EVOLUTION"))
			_isMultiple = false
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			createTip(_s("CARD_EVO_SELECT_MATERIAL_CARD"))
		elseif _data._KEY == MSG_ID.MSG_TEAMMEMBERLAYER_MODEL or _data._KEY == MSG_ID.MSG_TEAMLISTLAYER_MODEL then
			-- 9.选择战队卡
			_nodeTable.mLayerTitleLabel:setString(_s("TEAM_CARD_SELECT"))
			_isMultiple = true
			_isMe = false
			_cardType = CardMaster.SELECTCARD
			-- 隐藏Cost
			CCBCenter.getNodeByTag(_node, 4):setVisible(false)
			createTip(_s("TEAM_CONFIG_CARD", GAMERATE:getTeamCardLimit()))
		end
		if _isMultiple then
			-- 多选, 展示选中
			_smallScrollGrid = createSmallScrollGrid()
		end
		CCBCenter.getNodeByTag(_node, 702):setVisible(not _isMultiple)
	end

--[[ ## public fuction --]]
	function M.updateCardFilter( cards )
		_selectItems = {}
		-- 类型区别
		if _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNSELLCLICK then
			-- 1.卡牌出售
			_showItems = cards
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNPROTECTIONCLICK then
			-- 2.卡牌保护
			for i = 1, #cards do
				if cards[i]:getLocked() == TRUE then 
					_selectItems[#_selectItems + 1] = cards[i]
				end
			end
			_showItems = cards
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK then
			-- 3.配置副卡牌
			for i = 1, #cards do
				if isOnwar(cards[i]) and cards[i]:getMain() ~= TRUE then 
					_selectItems[#_selectItems + 1] = cards[i]
				end
			end
			_showItems = cards
			if ME:getTotalcost() then
				_maxCost = ME:getTotalcost()
			end
		elseif _data._KEY == MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK then
			-- 4.配置主卡牌
			for i = 1, #_data:getOnwarcards() do
				if isOnwar(_data:getOnwarcards()[i]) then
					if _data:getOnwarcards()[i]:getMain() == TRUE then 
						local cpid = _data:getOnwarcards()[i]:getCpid()
						for i = 1, #cards do
							if cards[i]:getCpid() == cpid then 
								_selectItems[#_selectItems + 1] = cards[i]
								-- break 
							end
						end
					else
						local cpid = _data:getOnwarcards()[i]:getCpid()
						for i = 1, #cards do
							if cards[i]:getCpid() == cpid then 
								_selectItems2[#_selectItems2 + 1] = cards[i]
								-- break 
							end
						end
					end
				end
				
			end
			-- 排除副卡牌
			_showItems = cards
		elseif _data._KEY == MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNMAINLAYERCLICK then
			-- 5.选择要升级的牌
			if _data._SELECTMAIN[1] then
				for i = 1, #cards do
					if cards[i]:getCpid() == _data._SELECTMAIN[1] then 
						-- table.insert(_selectItems, cards[i]) 
						_selectItems[#_selectItems + 1] = cards[i]
					end
				end
			end
			
			if _data._SELECTFEED then
				for i = 1, #cards do
					-- 等级小于100 并且 不是饲料卡中选中的, 不是饲料卡
					if cards[i]:getId() < 1000 and cards[i]:getLv() < CARD_MAX_LEVEL and not isFeeds(cards[i]) then 
						_showItems[#_showItems + 1] = cards[i]
					end
				end
			else
				_showItems = cards
			end
		elseif _data._KEY == MSG_ID.MSG_CARDENHANCEDLAYER_ONBTNFEEDLAYERCLICK then
			-- 6.选择饲料牌
			for i = 1, #cards do
				if cards[i]:getCpid() == _data._SELECTMAIN[1] then 
					_upgradeCard = cards[i] 
				end
				if cards[i]:getCpid() ~= _data._SELECTMAIN[1] and cards[i]:getOnwar() ~= TRUE and cards[i]:getTeamcard() ~= TRUE and cards[i]:getLocked() ~= TRUE then 
					-- table.insert(_showItems, cards[i]) 
					_showItems[#_showItems + 1] = cards[i]
				end
			end
			_showItems = util.reversionTable(_showItems)
			if _data._SELECTFEED then
				for i = 1, #cards do
					if isFeeds(cards[i]) then 
						_selectItems[#_selectItems + 1] = cards[i]
					end
				end
			end
			_selectItems = util.reversionTable(_selectItems)
		elseif _data._KEY == MSG_ID.MSG_CARDEVOLUTIONLAYER_MODEL then
			-- 7.选择要进化的卡
			for i, v in ipairs(cards) do
				v.showStatus = true
			end
			if _data._SELECTMAIN and _data._SELECTMAIN[1] then
				for i = 1, #cards do
					if cards[i]:getCpid() == _data._SELECTMAIN[1]:getCpid() then table.insert(_selectItems, cards[i]) end
				end
			end
			_showItems = cards
		elseif _data._KEY == MSG_ID.MSG_CARDEVOLUTIONLAYER_ONACTIONEVOCARDGROUP then
			-- 8.选择进化的素材卡
			for i, v in ipairs(cards) do
				v.showStatus = true
			end
			if _data._SELECTMAIN and _data._SELECTMAIN[2] then
				for i = 1, #cards do
					if cards[i]:getCpid() == _data._SELECTMAIN[2]:getCpid() then table.insert(_selectItems, cards[i]) end
				end
			end
			_showItems = cards
		elseif _data._KEY == MSG_ID.MSG_TEAMMEMBERLAYER_MODEL or _data._KEY == MSG_ID.MSG_TEAMLISTLAYER_MODEL then
			-- 9.选择战队卡
			for i = 1, #cards do
				if cards[i]:getTeamcard() == TRUE then 
					_selectItems[#_selectItems + 1] = cards[i]
				end
			end
			_showItems = cards
			_updateGlod = false
			_updateCost = false
		end 
		-- 筛选卡牌, 展示卡牌
		_filterItems = _showItems
		_scrollGrid:setItems(_showItems)
		if _isMultiple then
			-- 多选, 展示选中
			_smallScrollGrid:setItems(_selectItems)
		else
			setCardInfo(_selectItems[1])
		end
		updateGlodTip( )
		updateCostTip( )
		updateSelectTip( )
		-- 调整scroll位置
		util.autoFixScrollView(_scrollGrid)
	end
	function M.getSelectItems( )
		return _selectItems
	end
	function M.getSelectItems2( )
		return _selectItems2
	end
	function M.isCostOverflow( )
		return _curCost > _maxCost
	end

	function M.isContainHighLevelCard( )
		for i, v in ipairs(_selectItems) do
			if v:getLv() == CARD_MAX_LEVEL or v:getCardStar() > 3 then
				return true
			end
		end
		return false
	end
	function isCompliance( card )
		local cardEntity = card or _selectItems[1]
		if cardEntity:getOnwar() == TRUE then
			NetHelper.QuickToast(_s("CARD_ON_WAR"))
			return false
		elseif cardEntity:getLocked() == TRUE then
			NetHelper.QuickToast(_s("CARD_LOCKED"))
			return false
		elseif cardEntity:getTeamcard() == TRUE then
			NetHelper.QuickToast(_s("CARD_TEAM_CARD"))
			return false
		elseif cardEntity:getIsover() == TRUE then
			NetHelper.QuickToast(_s("CARD_EVO_OVERFLOW"))
			return false
		else 
			return true
		end
	end
--[[ ## MAINs --]]
	initViews()
	_node.getSelectItems 		 = M.getSelectItems
	_node.isCompliance 		 	 = isCompliance
	_node.getSelectItems2 		 = M.getSelectItems2
	_node.updateCardFilter 		 = M.updateCardFilter
	_node.isCostOverflow 		 = M.isCostOverflow
	_node.isContainHighLevelCard = M.isContainHighLevelCard
end

return M