local M = {}

local CardMaster = require("cardui.CardMaster")
local LevelDao   = require("db.leveldb")

function M.bindView(node, luaValue)
	local TAG = "[CardFragmentLayerView]"
	local _node, _nodeTable = node, luaValue
	local _tableView
	local _offset
	local _isReceive = false
--[[ ## local fuction --]]
	local function createTableView( )
		local layer = CCBCenter.getNodeByTag(_node, 3)
		local function onCardClick( card )
            if card.getParams():getId() then
            	SOUND:playEffectButton1()
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", card.getParams())
            end
	    end
		local function createItemCellListener( tableView, index, item,cell)
	        -- local cell = display.newColorLayer(ccc4(255, 200, 0, 255))
	        -- local cell = widget.newLayer()
	        -- cell:setContentSize(tableView:getCellSize())
	        -- cell:ignoreAnchorPointForPosition(false)
	        -- 放入背景
	        local bgSprite = widget.newSprite{file = "cardgroup/fragment/bg_card_fragment.png"}
	        bgSprite:setScale(SCALE_FOR_SPECIAL_NODE)
	        cell:addChild(bgSprite, 0)
            util.alignNode(bgSprite, cell:getContentSize(), display.CENTER)

            -- 卡牌entity
            local cardEntity = CardEntity.new(item)
            cardEntity.type = CardMaster.FRAGMENTCARD
            cardEntity.handler = onCardClick
            -- 收集进度
            local progressTTF = widget.newTTFLabelWithShadow{
            				text = _s("CARD_ALREADY_COLLECT"),
            				color = ccc3(196, 154, 108),
            				size = 20,
        	}
        	cell:addChild(progressTTF)
            util.alignNodeWithPadding(progressTTF, cell:getContentSize(), display.LEFT_BOTTOM, {left = 72, bottom = 40,})
            local progressTTFValue = widget.newTTFLabelWithShadow{
            				text = cardEntity:getCur() .. "/" .. cardEntity:getTotal(),
            				color = ccc3(141, 198, 63),
            				size = 20,
        	}
        	cell:addChild(progressTTFValue)
            util.alignNodeWithPadding(progressTTFValue, cell:getContentSize(), display.LEFT_BOTTOM, {left = 72 + progressTTF:getContentSize().width, bottom = 40,})
			-- android上的位置调整
			util.modifyPositionInAndroid(progressTTF, 0, 2) 		-- 底部"已收集碎片" 
			util.modifyPositionInAndroid(progressTTFValue, 0, 2)  	-- 底部"x/y"
            -- 获取地图
            local levelid, subid = string.match(item.levelid, "([+-]?%d+)-([+-]?%d+)")
            local mapPo = LevelDao.getByIndexes(string.match(item.levelid, "([+-]?%d+)-([+-]?%d+)"))
            
            local dropMapLabel = widget.newTTFLabelWithShadow{text = item.levelid .. " " .. mapPo.subname , color = ccc3(196, 154, 108),}
            cell:addChild(dropMapLabel)
            util.alignNodeWithPadding(dropMapLabel, cell:getContentSize(), display.CENTER_TOP, {top = 36,})
            util.modifyPositionInAndroid(dropMapLabel, 0, 4) 		-- 顶部标题 

            -- 可以领取
            if cardEntity:getStatus() == TRUE then
            	local function onBtnClick( button )
            		if not _isReceive then
            			_isReceive = true
            			-- 位置缓存
	            		_offset = _tableView:getContentOffset()
	            		local data = {}
	            		data.cid = cardEntity:getId()
	            		_node._RECEIVE = true
	            		-- 如果要加入动画在这里加入, 动画完成后再请求
	            		CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDFRAGMENTLAYER_ACTION_ONFETCHRECEIVECARDFRAGMENT, nil, data)
            		end
				end
				-- 领取按钮
            	local button = widget.newButton{
											contentSize = CCSize(113, 60),
											normalImage = "mission/btn_mission_normal.png",
											selectImage = "mission/btn_mission_normal.png",
											disableImage = "mission/btn_mission_select.png",
											scale = 1.1,
											labelParams = {
																text = _s("CARD_RECEIVE"), 
																shadow = true, 
																size = 22, 
															},
											listener = onBtnClick,
										}
				util.alignNodeWithPadding(button, cell:getContentSize(), display.CENTER , {top = 10,})
				cell:addChild(button, 2)
			else
				if cardEntity:getCur() >= cardEntity:getTotal() then
					-- 这里已经领取
					progressTTFValue:setVisible(false)
					progressTTF:setString(_s("CARD_ALREADY_RECEIVE"))
					cardEntity.type = CardMaster.MASTERCARD
					util.alignNodeWithPadding(progressTTF, cell:getContentSize(), display.CENTER_BOTTOM, { left = 18, bottom = 40,})
				else
					-- 不能领取, 目前没有特别处理

				end
            end
            -- 放入卡片
            local card = CardMaster.new(cardEntity)
            cell:addChild(card, 1)
            util.alignNodeWithPadding(card, cell:getContentSize(), display.CENTER)

	        -- return cell
	    end
		local tableView = widget.newTable{
	    	contentSize = layer:getContentSize(),
	    	cellSize = CCSize( 310, 520),
	    	direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	    	-- tapListener = tapCellListener,
	    	createItemCellListener = createItemCellListener,
	    	parentNode = layer,
		}
		return tableView
	end

	-- 按地图排序
	local function sortForMapId( items )
		table.sort (items ,function(a,b) 
			local levelida, subaid = string.match(a.levelid, "([+-]?%d+)-([+-]?%d+)")
			local levelidb, subaib = string.match(b.levelid, "([+-]?%d+)-([+-]?%d+)") 
			levelida = tonumber(levelida)
			levelidb = tonumber(levelidb)
			if levelida == levelidb then 
				return levelida < levelidb 
			else 
				return levelida < levelidb 
			end 
		end)
	end
    -- 新手引导
    local function checkHelperInfo()
        HelperView2.showBetween(_node, nil, {80070, 80080})
    end
	local function initViews()
		-- 增加topButtons
		-- CCBCenter.getNodeByTag(_node, 2):addChild(require("cardui.TopButtons").new{select = 3})
		-- 创建ScrollGrid
		-- _tableView = createScrollView()
		_tableView = createTableView()
        checkHelperInfo()
	end

--[[ ## public fuction --]]
	function M.fillFragmentCard( items )
		-- 排序
		sortForMapId(items)
		_tableView:setItems(items)
		-- 回复缓存位置
		if _offset then
			_isReceive = false
			_tableView:setContentOffset(_offset)
			_offset = nil
		end
	end
--[[ ## MAINs --]]
	initViews()
	_node.fillFragmentCard = M.fillFragmentCard
end

return M