local M = {}

local CardMaster = require("cardui.CardMaster")
local CardEntity = require("model.card.CardEntity")
function M.bindView(node, luaValue )
	local TAG = "[CardGroupLayerView]"
	local _node, _nodeTable = node, luaValue
    local _xp, _sp, _hp, _spTime
    local _switchLayer, _roleHead
    -- local _cardGroup = node._DATA
    local _isConfig
--[[ ## local fuction --]]
	--[[
		e.g.: _nodeTable["mSprite"]
	--]]
    local function onCardClick( card, key )
        local function jumpToCardFilter( )
            SOUND:playEffectButton1()
            local data = node._DATA -- :getCards()
            data._KEY = key or (card.getParams():getMain() == TRUE and MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK 
                                                        or MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK)
            quickui.showLoadingLayer()
            HelperView2.showNext()
            CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", data)
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONSTOPCONFIGANIMATION)
        end
        if _isConfig then
            jumpToCardFilter( )
            -- SOUND:playEffectButton1()
            -- local data = node._DATA -- :getCards()
            -- data._KEY = key or (card.getParams():getMain() == TRUE and MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGMAINCLICK 
            --                                             or MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK)
            -- quickui.showLoadingLayer()
            -- HelperView2.showNext()
            -- CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", data)
            -- CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONSTOPCONFIGANIMATION)
        else
            -- 没有卡的去配置卡组
            if card.getParams():getId() then
                SOUND:playEffectButton2()
                card.getParams().shareButton = true
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", card.getParams())
            else
                if not card.unlock then
                    jumpToCardFilter( )
                end
            end
        end
    end
    local function enableGameTouch( enable )
        util.enableCustomTouch(_node, enable)
        game.enableTopButtonTouch(enable)
    end
    -- 卡槽解锁动画
    local function unlockCard( index )
        enableGameTouch( false )
        local layer = CCBCenter.getNodeByTag(_node, 400 + index)
        local lightSprite = anim.playAnimation(
            nil, 
            "cardgroup/img_unlock_card", 
            "img_unlock_card_%d.png", 
            30, 2, 1, false, true,  
            function ( )
                if ME:getTriggerMsgEntity():isShowHelpInfo() then
                    if not HelperView2.isNextIndex(300) then 
                        local step = ME:getTriggerMsgEntity():getHelpInfoStep()
                        if 5 == step then
                            -- 卡牌解锁
                            HelperView2.setCurIndex(870)
                            HelperView2.showBetween(_node, callback, {870, 880})
                        end
                    end
                end
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHUNLOCK, nil, 2)
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK)
                enableGameTouch( true )
            end
        )
        layer:addChild(lightSprite)
        util.alignNodeWithPadding(lightSprite, layer:getContentSize(), display.CENTER, {top = 50})
    end
    -- 卡组解锁动画
    local function unlockCardGroup( index, layer )
        enableGameTouch( false )
        local lightSprite = anim.playAnimation(
            nil, 
            "cardgroup/img_unlock_card", 
            "img_unlock_card_%d.png", 
            30, 3, 1, false, true, 
            function ( )
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHUNLOCK, nil, 3)
                enableGameTouch( true )
            end
        )
        layer:addChild(lightSprite, 10)
        util.alignNodeWithPadding(lightSprite, layer:getContentSize(), display.CENTER, {top = 50})
    end
    -- 初始化新手帮助
    local function initHelperInfo( )
        local msgEntity = ME:getTriggerMsgEntity()
        -- 卡牌强化
        if msgEntity:isShowEnhancedHelper() then
            HelperView2.setCurIndex(10020)
        -- 卡牌进阶
        elseif msgEntity:isShowEvolutionHelper() then
            HelperView2.setCurIndex(20020)
        -- 卡牌碎片
        elseif msgEntity:isShowChipHelper() then
            HelperView2.setCurIndex(80020)
        end
    end
    -- 新手引导
    local function checkHelperInfo(  )
        local function callback( index )
            if index == 460 then 
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIGCLICK)
            elseif index == 520 then 
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ONBTNCONFIRMCLICK)
            end
        end
        HelperView2.showBetween(
            _node, 
            callback, 
            {440, 470}, 
            {490, 500}, 
            {520, 540}, 
            {900, 910}, 
            {10020, 10030}, 
            {20020, 20020}, 
            {80020, 80060}
        )
    end
    
	local function initViews()
		-- 增加topButtons
		-- CCBCenter.getNodeByTag(_node, 2):addChild(require("cardui.TopButtons").new{select = 3})
        -- game.addTopButtons(3)
        --增加生命ProgressBar
        _hp = widget.newProgressBar{
            frontSprintParams = {file = "cardgroup/progressBar_red_img.png",},
            bgSprintParams = {file = "map/progressBar_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, padding = {top = 18}},
            percentage = 100,
        }
        _hp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 318):addChild(_hp)

        --增加经验ProgressBar
        _xp = widget.newProgressBar{
            frontSprintParams = {file = "map/progressBar_blue_img.png",},
            bgSprintParams = {file = "map/progressBar_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, padding = {top = 18}},
            percentage = 0,
        }
        _xp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 319):addChild(_xp)

        --增加体力ProgressBar
        _sp = widget.newProgressBar{
            frontSprintsParams = {{file = "map/progressBar_green_img.png",}, {file = "map/progressBar_deep_green_img.png",}},
            bgSprintParams = {file = "map/progressBar_bg.png"},
            ttfLabelParams = {size = 14, shadow = true, padding = {top = 20, left = -50}},
            percentage = 0,
        }
        _sp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 320):addChild(_sp)

        -- 时间
        _spTime = CountDownView.new{ 
            format = "[mm]:[ss]",
            labelParams = {size = 15,},
            listener = function()
                local sp = ME:getCursp() + 1
                ME:setCursp(sp)
                if sp < 100 then
                    _spTime:start(300)
                    local sp = ME:getCursp() /  ME:getActlimit() * 100
                    _sp:runProgressTo( 0.5 , sp )
                    _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
                else
                    _spTime:stop()
                    if sp == 100 then
                        _sp:runProgressTo( 0.1 , sp )
                        _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
                    end
                    _nodeTable.mSpTitleLabel:setVisible(false)
                    _spTime:setVisible(false)
                    _nodeTable.mSpFullLabel:setVisible(true)
                end
            end
        }
        CCBCenter.getNodeByTag(_node, 325):addChild(_spTime)
        util.alignNodeWithPadding(_spTime, CCBCenter.getNodeByTag(_node, 325):getContentSize(), display.CENTER)
        if ME:getSpNextTime() ~= 0 then
            _spTime:start(ME:getSpNextTime())
        else
            _spTime:setVisible(false)
        end
        -- initHelperInfo()
        -- checkHelperInfo()
	end

--[[ ## public fuction --]]
    function M.fillOnwarCards( items, count )
        local index = 402
        for i = 1, 9 do
            local item = items[i]
            if item and item:getMain() == TRUE then
                local layer = CCBCenter.getNodeByTag(_node, 40102)
                layer:removeAllChildrenWithCleanup(true)
                item.type = CardMaster.MASTERCARD
                item.handler = onCardClick
                item:setTalent(ME:getTalent())
                item:setEquipEffect(ME:getEquipEffect())
                local card = CardMaster.new(item)
                layer:addChild(card)
                util.alignNode(card, layer:getContentSize(), display.CENTER)
            else
                -- 没有新建一个空的占位, 来添加点击事件
                if not item then
                    item = CardEntity.new{}
                end
                local poi = index .. "02"
                ---------
                -- Log.d(TAG, "这里的判断完全是为了测试,不可能超过9张")
                -- if i < 9 then
                --------
                local layer = CCBCenter.getNodeByTag(_node, tonumber(poi))
                layer:removeAllChildrenWithCleanup(true)
                index = index + 1
                item.type = CardMaster.VICECARD
                item.handler = onCardClick
                item:setTalent(ME:getTalent())
                item:setEquipEffect(ME:getEquipEffect())
                local card = CardMaster.new(item)
                if i > count then
                    card.unlock =  true
                end
                layer:addChild(card)
                util.alignNode(card, layer:getContentSize(), display.CENTER)
                -- end
            end

        end
    end

    function M.toggleConfigButton( bool )
        CCBCenter.getNodeByTag(_node, 601):setVisible(bool)
        CCBCenter.getNodeByTag(_node, 602):setVisible(not bool)
        -- 动画框
        -- 加号
        CCBCenter.getNodeByTag(_node, 411):setVisible(not bool)
        if not bool then
            -- _proxy:playCCBAnimation("Flash")
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONPLAYCONFIGANIMATION)
        end

        _isConfig = not bool
    end
    -- 卡组切换弹出layer初始化
    function M.initSwitchLayer( cur , unlock )
        local layer = CCBCenter.getNodeByTag(_node, 7)
        layer:removeAllChildrenWithCleanup(true)

        local tab
        local buttons = {}

        local function onTabClick( index, button )
            if index <= unlock then
                quickui.showLoadingLayer()
                util.enableCustomTouch(tab, false)
                SOUND:playEffectButton1()
                local requestData = {}
                requestData.group = index
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CARDGROUPLAYER_ACTION_ONFETCHSWITCHCARD, nil, requestData)
            else
                tab.selectButton(cur)
            end
        end

        for i = 1, 3 do
            local button = widget.newButton{   
                normalImage = "cardgroup/btn_switch_normal.png",
                selectImage = "cardgroup/btn_switch_select.png",
                contentSize = CCSize(94, 49),
                labelParams = {text = _s("MAIN_CARDGROUP") .. i, size = 20, color = iff( i == cur, COLOR3.WHITE, BUTTON_COLOR3.BROWN), padding = {top = 4}},
            }
            table.insert(buttons, button)
        end
        -- 加锁
        for i = unlock + 1, 3 do
            local lock = widget.newSprite{file = "cardgroup/img_card_protection.png",}
            buttons[i]:addChild(lock, 10)
            util.alignNode(lock, buttons[i]:getContentSize(), display.CENTER)
        end
        -- 卡组解锁动画
        local msgEntity = ME:getTriggerMsgEntity()
        if msgEntity:isShowUnlockCardGroup() then
            Log.d(TAG, "卡组解锁动画")
            local index = msgEntity:getUnlockCardGroupIndex()
            unlockCardGroup(index, buttons[index])
        end
        tab = widget.newTab{
            items = buttons,
            selectIndex = cur,
            listener = onTabClick,
        }
        layer:addChild(tab, 1)
        util.alignNode(tab, layer:getContentSize(), display.CENTER)
    end
    -- 初始化卡片区域, 显示点击标识 && 锁住标识
    function M.initCardLayer( count )
        local msgEntity = ME:getTriggerMsgEntity()
        if msgEntity:isShowUnlockCard() then
        -- 卡槽解锁动画
            Log.d(TAG, "卡槽解锁动画")
            unlockCard(msgEntity:getUnlockCardIndex())
        end
        for i = 1, 8 do
            CCBCenter.getNodeByTag(_node, 41101 + i):setVisible(i <= (count - 1))
            CCBCenter.getNodeByTag(_node, 41201 + i):setVisible(not (i <= (count - 1)))
        end
    end
    -- 弹出卡组选择
    function M.showSwitchLayer( )
        -- _switchLayer:showWithMask()
        M.initSwitchLayer(_node._DATA:getCurgroup(), _node._DATA:getGcount())
    end

    function M.updateCachePlayerInfo( )
        -- 头像
        if not _roleHead then 
            local headLayer = CCBCenter.getNodeByTag(_node, 30202)
            headLayer:removeAllChildrenWithCleanup(true)
            local head = ME:createPlayerHeadRectView()
            head:setScale((headLayer:getContentSize().width - 10) / head:getContentSize().width)
            headLayer:addChild(head)
            util.alignNode(head, headLayer, display.CENTER)
            _roleHead = head
        end

        -- 名字
        _nodeTable.mNameLabel:setString(ME:getName())
        -- 等级
        _nodeTable.mLevelLabel:setString(ME:getLv())
        -- 召唤值
        -- _nodeTable.mCostLabel:setString( cost .. "/".. ME:getTotalcost())
        -- 生命
        local talentHp = ME:getPlayerTalentsEntity():getHeroHp()
        local equipEffectHp = ME:getPlayerEquipEffectEntity():getHeroHp()
        local finalHp = tonumber(talentHp) + equipEffectHp
        local addHp = ""
        if finalHp > 0 then
            addHp = " + " .. finalHp
        end
        _hp:setString(ME:getHp() .. addHp)
        -- 经验
        local xp = ME:getCurexp() /  ME:getTotalexp() * 100
        _xp:runProgressTo( 0.5 , xp )
        _xp:setString(ME:getCurexp() .. "/" .. ME:getTotalexp())
        -- 体力
        local sp = ME:getCursp() /  ME:getActlimit() * 100
        _sp:runProgressTo( 0.5 , sp )
        _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
        -- 体力时间
        _spTime:modifyTime(ME:getSpNextTime())

        _nodeTable.mSpTitleLabel:setVisible(ME:getSpNextTime() ~= 0)
        _spTime:setVisible(ME:getSpNextTime() ~= 0)
        _nodeTable.mSpFullLabel:setVisible(ME:getSpNextTime() == 0)
        -- 服务器
        _nodeTable.mServiceLabel:setString(ME:getSername())
    end
    -- 玩家信息
    function M.updatePlayerInfo( onwarcards )
        local cost = 0
        local atk = 0
        local hp = 0
        for i , v in ipairs(onwarcards) do
            cost = cost + v:getCardCost()
            atk  = atk + v:getFinalAttack()
            hp   = hp  + v:getFinalHp()
        end
        -- 总攻击力
        _nodeTable.mAtkLabel:setString(tostring(atk))
        -- 总体力
        _nodeTable.mHpLabel:setString(tostring(hp))
        -- 召唤值
        _nodeTable.mCostLabel:setString( cost .. "/".. ME:getTotalcost())

        -- 更新本地玩家缓存信息
        M.updateCachePlayerInfo( )
        -- 当前卡组
        _nodeTable.mCurGroupLabel:setString(_s("MAIN_CARDGROUP") .. " " .. _node._DATA:getCurgroup())
        
    end
    -- 更新数据
    function M.updateData( data )
        M.fillOnwarCards(data:getOnwarcards(), data:getCcount())
        M.initSwitchLayer(data:getCurgroup(), data:getGcount())
        M.initCardLayer(data:getCcount())
        M.updatePlayerInfo(data:getOnwarcards())
        -- CCBCenter.changeAllLayerTouchPriorityToLast(_node)
        -- NetHelper.hideLoading(true)
        quickui.hideLoadingLayer()
    end
--[[ ## MAINs --]]
	initViews()
	_node.toggleConfigButton = M.toggleConfigButton
    _node.fillOnwarCards = M.fillOnwarCards
    _node.initSwitchLayer = M.initSwitchLayer
    _node.showSwitchLayer = M.showSwitchLayer
    _node.updateData = M.updateData
    _node.checkHelperInfo = checkHelperInfo
    _node.initHelperInfo = initHelperInfo

end

return M