--ChatLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ChatLayerView]"
	local _node, _nodeTable = node, luaValue

    local ChatUtil = require("ccb.m.chat.ChatUtil")

    local _sendmsgTf        -- 消息输入框
    local _tableNode    --table父node
    local _gridTable    --table实体
    local _tapNode   

    local _curMsgType =  ChatUtil.ChatAll

    local oldmsgcount = 0

    local canuserchick = true

    local _selectOffset
    -- 单行高度
    local _offsetY = -45
    --[[ ## local fuction --]]
    -- 刷新聊天消息
    local function reloadRecMsg(ctype)
        
        ctype = ctype or _curMsgType 
        _curMsgType = ctype
        local realMessages = {}
        -- 过滤消息类型
        for i=1,#chat_messages do
            if ctype == ChatUtil.ChatAll or chat_messages[i].ctype == ctype then 
                realMessages[#realMessages + 1] = chat_messages[i]
            end             
        end

        if realMessages then
            -- 当前位置缓存
            if not (_gridTable and _gridTable.getContentOffset) then
                return
            end

            -- FIXME: 
            try(function() 
                _selectOffset = _gridTable:getContentOffset()
                -- 刷新table
                _gridTable:setItems(realMessages) 
            end)
        end

        -- 超过一页滚动到最下面
        if #realMessages > ChatUtil.maxMsgCountPerPage then
            -- 小于一行的位移自动移动
            if _selectOffset.y > _offsetY then
                _gridTable:setContentOffset(_gridTable:maxContainerOffset())
                _selectOffset = _gridTable:getContentOffset()
            else
                -- 新消息数
                local newMsg = #realMessages - oldmsgcount
                -- 设置到缓存位置
                _gridTable:setContentOffset(ccpAdd(_selectOffset, ccp(0, (_offsetY * newMsg))))
            end
        end

        oldmsgcount = #realMessages

        NetHelper.hideLoading(true)

    end

    --创建cell
    local function createCell( grid,index,item )
        local cell = widget.newLayer()
        cell:setContentSize(grid:getCellSize())
        cell:ignoreAnchorPointForPosition(false)
        -- x坐标
        local curX = 0

        local c_item = item.cellItem
        local ctype = item.ctype
        -- local key = 1
        local color = COLOR3.WHITE
        local color4 = ccc4(255,255,255,200)
        if ctype and ctype == ChatUtil.ChatSystem then 
            color = COLOR3.YELLOW 
            color4 = ccc4(255,242,0,200)
        end
                
        -- 循环添加表格元素
        for i=1,#c_item do
            local content = c_item[i]
            if content and content.title then

                
                if content.flag == 1 then 
                    local ly = widget.newLayer{
                                         x = curX,
                                         y = 0
                                }
                    local cttf = widget.newTTFLabelWithShadow{
                            text = content.title, 
                            shadow = true,
                            size = 30, 
                            color = color, 
                            offset = 1
                        }
                    ly:setContentSize(cttf:getContentSize())
                    ly:addChild(cttf, 1)
                    cell:addChild(ly, 1)
                    curX = curX + cttf:getContentSize().width

                    local rtext = content.text

                    local cardEntity
                    local equipEntity
                    local equipEntity2
                    local playerEntity
                    local goodEntity
                    local goodEntity2
                    local teamEntity
                    -- 去除"[]"
                    if rtext and string.find(rtext,"%[") and string.find(rtext,"%]") then 
                        rtext = string.gsub(rtext,"%[","")
                        

                        cardEntity = CardDB.getByName(string.gsub(rtext,"%]",""))
                        equipEntity2 = EquipDB.getByName(string.gsub(rtext,"%]",""))
                        goodEntity2 = BackpackDB.getByName(string.gsub(rtext,"%]",""))
                        if cardEntity then 
                            cardEntity:setLv(1)
                        end

                        -- 有卡牌标识，说明是卡牌，它的后面跟的是卡牌的等级
                        if string.find(rtext, GAMERATE:getChatCardFlag() .. ".+%]") then 
                            --local sname,lv = string.splitlast(rtext, GAMERATE:getChatCardFlag())
                            rtext = string.gsub(rtext,"%]","")
                            local strtb = string.split(rtext, GAMERATE:getChatCardFlag())
                            --if sname and lv then 
                            if strtb and #strtb == 5 and strtb[1] and strtb[2] and strtb[3] and strtb[4] and strtb[5] and tonumber(strtb[2]) ~= 0  and tonumber(strtb[3]) ~= 0 and tonumber(strtb[4]) ~= 0 then
                              
                                local sname = strtb[1]
                                local cno = tonumber(strtb[2])
                                local lv = tonumber(strtb[3])
                                local evolv = tonumber(strtb[4])
                                local playname = strtb[5]

                                if lv < 0 then lv = 1 end 
                                if lv > 99 then lv = 99 end
                                if evolv == nil or evolv <= 0 then evolv = 1 end
                                -- if evolv > 2 then evolv = 2 end
                                if playname == nil then playname = "" end
                                if cno > 0 and cno < 10000 then 
                                    -- 用编号取
                                    cardEntity = CardDB.getByCardNo(cno)
                                else
                                    cardEntity = CardDB.getByName(sname)
                                end
                                
                                if cardEntity then 
                                    cardEntity.userName = playname
                                    cardEntity:setLv(lv)
                                    cardEntity:setEvolv(evolv)
                                end
                                
                            end
                        end

                        -- 有装备标识，说明是装备，它的后面跟的是装备的id，点击后触发请求事件
                        if string.find(rtext, GAMERATE:getChatEquipFlag() .. ".+%]") then 
                            rtext = string.gsub(rtext,"%]","")
                            local strtb = string.split(rtext, GAMERATE:getChatEquipFlag())
                            if strtb and #strtb == 4 and strtb[1] and strtb[2] and strtb[3] and strtb[4] and tonumber(strtb[2]) ~= 0  and tonumber(strtb[3]) ~= 0 and tonumber(strtb[4]) ~= 0 then
                                equipEntity = {sname = strtb[1], eid = strtb[2], quality = strtb[3], pid = strtb[4]}
                            end
                        end

                        -- 有人名标识，说明是人名，它的后面跟的是玩家的id，点击后触发请求事件
                        if string.find(rtext, GAMERATE:getChatPlayerFlag() .. ".+%]") then 
                            rtext = string.gsub(rtext,"%]","")
                            local sname,pid = string.splitlast(rtext, GAMERATE:getChatPlayerFlag())
                            if sname and pid and tonumber(pid) ~= 0 then 
                                playerEntity = {sname = sname, pid = pid}
                            end
                            
                        end

                        -- 有物品标识，说明是物品，它的后面跟的是物品的编号，点击后触发请求事件
                        if string.find(rtext, GAMERATE:getChatGoodsFlag() .. ".+%]") then 
                            rtext = string.gsub(rtext,"%]","")
                            local strtb = string.split(rtext, GAMERATE:getChatGoodsFlag())
                            if strtb and #strtb == 4 and strtb[1] and strtb[2] and strtb[3] and strtb[4] and tonumber(strtb[2]) ~= 0  and tonumber(strtb[3]) ~= 0  and tonumber(strtb[4]) ~= 0 then
                                goodEntity = {sname = strtb[1], no = strtb[2], quality = strtb[3], pid = strtb[4]}
                            end
                        end

                       -- 有战队标识，说明是战队，它的后面跟的是战队id，点击后触发请求事件
                        if string.find(rtext, GAMERATE:getChatTeamFlag() .. ".+%]") then 
                            rtext = string.gsub(rtext,"%]","")
                            local strtb = string.split(rtext, GAMERATE:getChatTeamFlag())
                            if strtb and #strtb == 3 and strtb[1] and strtb[2] and strtb[3] and tonumber(strtb[2]) > 0 and tonumber(strtb[3]) >= 0 then
                                teamEntity = {tname = strtb[1], tid = strtb[2], serid = strtb[3]}
                            end
                        end
                        
                    end



                    if content.uid and content.uid ~= ME:getUserid()  then
                        cttf:setColor(COLOR3.GREEN)
                    elseif cardEntity then 
                        cttf:setColor(COLOR3.ORANGE)
                    elseif equipEntity then 

                        local eqcolor = _GAME.CONFIG.GOODS.QUALITY[tonumber(equipEntity.quality)] 
                        if eqcolor then 
                            cttf:setColor(eqcolor.rgb)
                        end
                    elseif equipEntity2 then 

                        local eqcolor = _GAME.CONFIG.GOODS.QUALITY[tonumber(equipEntity2.quality)] 
                        if eqcolor then 
                            cttf:setColor(eqcolor.rgb)
                        end

                    elseif playerEntity then 
                        cttf:setColor(COLOR3.GREEN)
                    elseif goodEntity then 

                        local gcolor = _GAME.CONFIG.GOODS.QUALITY[tonumber(goodEntity.quality)] 
                        if gcolor then 
                            cttf:setColor(gcolor.rgb)
                        end
                    elseif goodEntity2 then 

                        local gcolor = _GAME.CONFIG.GOODS.QUALITY[tonumber(goodEntity2.quality)] 
                        if gcolor then 
                            cttf:setColor(gcolor.rgb)
                        end
                    elseif teamEntity then 
                        cttf:setColor(COLOR3.GREEN)
                    end

                    widget.bindTouchEvent{
                        layer = ly,
                        -- onTouchBegan = function (x,y )
                        --     print("~~~~x ",x)
                        -- end
                        clickListener = function ( layer )
                            if content.uid  then
                               
                                Log.d(TAG,"~~~~~~~~~~~~~~~~",content.uid) 
                                NetHelper.showLoading(true,true)
                                --   创建http请求
                                -- NetHelper.createRequest(
                                    
                                --    ACTID.MSG_GET_PLAYERDETAIL,                   --      请求id
                                --    function ( properties, params )
                                -- 屏蔽editbox
                                _node.toggleSendMsgEnable( )
                                --         canuserchick = true
                                --         NetHelper.hideLoading(true)
                                --        local entityFriend = require("ccb.m.friend.EntityFriend")
                               --  print("")
                               --  dump(content)
                               -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {showPK = true, fid = content.uid, key = MSG_ID.MSG_CHATLAYER_MODEL, fnNextView = function() CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH) end })
                                NetHelper.showLoading(true,true)
                                --   创建http请求
                                NetHelper.createRequest(
                                    
                                   ACTID.MSG_GET_PLAYERDETAIL,                   --      请求id
                                   function ( properties, params )
                                        
                                        canuserchick = true
                                        NetHelper.hideLoading(true)
                                       local entityFriend = require("ccb.m.friend.EntityFriend")
                                       local user = entityFriend.new(properties)
                                   CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = user, key = MSG_ID.MSG_CHATLAYER_MODEL, fnNextView = function() CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH) end })
                                       
                                       -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", user)
                                   end,                   --        回调函数
                                   {pid = content.uid},                    --      请求信息实体或参数table
                                   {failedCb = function (  )
                                       canuserchick = true
                                       NetHelper.hideLoading(true)
                                   end}
                                )         
                                --        -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", user)
                                --    end,                   --        回调函数
                                --    {pid = content.uid},                    --      请求信息实体或参数table
                                --    {failedCb = function (  )
                                --        canuserchick = true
                                --        NetHelper.hideLoading(true)
                                --    end}
                                -- )
                                
                            else
                                if cardEntity then
                                    _node.toggleSendMsgEnable( )
                                    -- cardEntity.userName =  -- 这里加人名
                                    cardEntity._KEY = MSG_ID.MSG_CHATLAYER_MODEL
                                    CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", cardEntity)
                                    Log.d(TAG,"have card ",content.text)
                                elseif  equipEntity then 
                                    -- 展示装备
                                    --NetHelper.QuickToast(equipEntity.eid)
                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    NetHelper.createRequest(
                                        
                                       ACTID.MSG_GET_EQUIPINFO,         --    请求id
                                       function ( properties, params )
                                            if properties then 
                                                canuserchick = true
                                                NetHelper.hideLoading(true)
                                                local entity = require("model.goods.GoodsEntity").new(properties.obj)
                                                entity.userName = properties.uname
                                                if entity then
                                                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", entity)
                                                end
                                           end
                                       end,                             --  回调函数
                                       {eqid = equipEntity.eid,pid = equipEntity.pid},        --  请求信息实体或参数table
                                       {failedCb = function (  )
                                           canuserchick = true
                                           NetHelper.hideLoading(true)
                                       end}
                                    ) 
                                elseif  equipEntity2 then 
                                    -- 展示装备
                                    --NetHelper.QuickToast(equipEntity.eid)

                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    NetHelper.createRequest(
                                        
                                       ACTID.MSG_GET_EQUIPINFO,         --    请求id
                                       function ( properties, params )
                                            if properties then 
                                                canuserchick = true
                                                NetHelper.hideLoading(true)
                                                local entity = require("model.goods.GoodsEntity").new(properties.obj)
                                                entity.userName = properties.uname
                                                if entity then
                                                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", entity)
                                                end
                                           end
                                       end,                             --  回调函数
                                       {eqid = equipEntity2.no,pid = 0},        --  请求信息实体或参数table
                                       {failedCb = function (  )
                                           canuserchick = true
                                           NetHelper.hideLoading(true)
                                       end}
                                    ) 
                                elseif playerEntity then

                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    -- NetHelper.createRequest(
                                        
                                    --    ACTID.MSG_GET_PLAYERDETAIL,                   --      请求id
                                    --    function ( properties, params )
                                    -- 屏蔽editbox
                                    _node.toggleSendMsgEnable( )
                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    NetHelper.createRequest(
                                        
                                       ACTID.MSG_GET_PLAYERDETAIL,                   --      请求id
                                       function ( properties, params )
                                            
                                            if properties then 
                                                canuserchick = true
                                                NetHelper.hideLoading(true)
                                               local entityFriend = require("ccb.m.friend.EntityFriend")
                                               local user = entityFriend.new(properties)
                                               if user then
                                                CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {entity = user, key = MSG_ID.MSG_CHATLAYER_MODEL, fnNextView = function() CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH) end })
                                               end
                                           end
                                           -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", user)
                                       end,                   --        回调函数
                                       {pid = playerEntity.pid},                    --      请求信息实体或参数table
                                       {failedCb = function (  )
                                           canuserchick = true
                                           NetHelper.hideLoading(true)
                                       end}
                                    ) 
                                elseif goodEntity then 
                                    -- 物品展示
                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    NetHelper.createRequest(
                                       ACTID.MSG_GET_GOODSINFO,         --    请求id
                                       function ( properties, params )
                                            if properties then 
                                                canuserchick = true
                                                NetHelper.hideLoading(true)
                                                local entity = require("model.goods.GoodsEntity").new(properties.obj)
                                                entity.userName = properties.uname
                                                if entity then
                                                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", entity)
                                                end
                                            end
                                       end,                             --  回调函数
                                       {no = goodEntity.no, pid = goodEntity.pid},        --  请求信息实体或参数table
                                       {failedCb = function (  )
                                           canuserchick = true
                                           NetHelper.hideLoading(true)
                                       end}
                                    ) 
                                elseif goodEntity2 then 
                                    -- 物品展示
                                    NetHelper.showLoading(true,true)
                                    --   创建http请求
                                    NetHelper.createRequest(
                                       ACTID.MSG_GET_GOODSINFO,         --    请求id
                                       function ( properties, params )
                                            if properties then 
                                                canuserchick = true
                                                NetHelper.hideLoading(true)
                                                local entity = require("model.goods.GoodsEntity").new(properties.obj)
                                                entity.userName = properties.uname
                                                if entity then
                                                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", entity)
                                                end
                                           end
                                       end,                             --  回调函数
                                       {no = goodEntity2.no,pid = 0},        --  请求信息实体或参数table
                                       {failedCb = function (  )
                                           canuserchick = true
                                           NetHelper.hideLoading(true)
                                       end}
                                    ) 
                                elseif teamEntity then 
                                    NetHelper.showLoading(true,true)
                                    -- 战队
                                    CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = teamEntity.tid, fromMain = true, serid = teamEntity.serid, fromKey = 1})
                                else
                                    Log.d(TAG,"no card~~~~~~~~~~~~~~~~",content.text)
                                end
                            end
                            
                        end
                    }
                else
                    local cttf = widget.newTTFLabelWithShadow{
                                                text = content.title, 
                                                shadow = true,
                                                size = 30, 
                                                color = color, 
                                                offset = 1,
                                                x = curX,
                                                y = 0
                                            }
                    cell:addChild(cttf, 1)
                    curX = curX + cttf:getContentSize().width
                end

            end 
        end
        
        return cell
    end

    --创建table
    local function createTable()

        local function createItemCellListener( grid,index,item )
            -- Log.d(TAG,"createItemCellListener")
            local cell = createCell(grid,index,item)
            return cell
        end
        local function modifyItemCellListener( grid,index,item,itemCell )
            Log.d(TAG,"modifyItemCellListener")
        end
        local function tapListener( grid,index,item )
            -- Log.d(TAG,"YOU CLICKED %d", index)
           
        end

        local scrollGrid = widget.newScrollGrid{

            contentSize = _tableNode:getContentSize(),
            contentParams = {
                cellSize = CCSize( _tableNode:getContentSize().width, 35),
                padding = { 
                    middleH = 0, middleV = 10,
                    left = 15, right = 0, top = 10, bottom = 0,
                },
                column = 1,
                createItemCellListener = createItemCellListener,
                modifyItemCellListener = modifyItemCellListener,
                tapListener = tapListener,
                selectedParams = nil,

            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _tableNode,
        }

        return scrollGrid
    end

    --[[
    -   初始化输入框
    --]]
    local function initEditBox()
        
        -- 消息输入框
        local msgtf = CCBCenter.getNodeByTag(_node , 2)
        Log.d(TAG,"msgtf..getZOrder:%d", msgtf:getZOrder())
        _sendmsgTf = widget.newEditBox({
            returnType = kKeyboardReturnTypeSend,
            fontColor = COLOR3.BLACK,
            contentSize = CCSizeAdd(msgtf:getContentSize(), 0, 10) ,
            x = msgtf:getPositionX() ,
            y = msgtf:getPositionY() ,
            normalBgImage = {file = "chat/chat_tfBg.png"},
            textMaxLength = ChatUtil.maxSendMsgCount,
            returnListener = function ( )

                -- 发送消息
                CCBCenter.sendLuaMessage(MSG_ID.MSG_CHATLAYER_SENDMSG)
            end
            })
        _node:addChild(_sendmsgTf, 0, 0)
        if _GAME.CONFIG.SDK_PLATFORM.chat == false then
            msgtf:setVisible(false)
            _sendmsgTf:setVisible(false)
        end
    end 

    local function createTab()
        local IMG_BLUE = "chat/chat_tabBtn_.png"
        local IMG_BLUE_ = "chat/chat_tabBtn.png"

        local padding_top = 5
        if isandroid() then padding_top = 0 end
        local Btn1 =
        widget.newButton{
            normalImage = IMG_BLUE,
            selectImage = IMG_BLUE_,
            disableImage = IMG_BLUE_,
            labelParams = 
            {text = _s("CHAT_ALL"),textAlign = ui.TEXT_ALIGN_CENTER,size = 50 * SCALE_FOR_SPECIAL_LABEL,padding = { top = padding_top }},
            textValign = ui.TEXT_VALIGN_CENTER,

        }

        local Btn2 =
        widget.newButton{
            normalImage = IMG_BLUE,
            selectImage = IMG_BLUE_,
            disableImage = IMG_BLUE_,
            labelParams = 
            {text = _s("CHAT_WORLD"),textAlign = ui.TEXT_ALIGN_CENTER,size = 50 * SCALE_FOR_SPECIAL_LABEL,padding = { top = padding_top }},
            textValign = ui.TEXT_VALIGN_CENTER,
        }

        local Btn3 =
        widget.newButton{
            normalImage = IMG_BLUE,
            selectImage = IMG_BLUE_,
            disableImage = IMG_BLUE_,
            labelParams = 
            {text = _s("CHAT_SYSTEM"),textAlign = ui.TEXT_ALIGN_CENTER,size = 50 * SCALE_FOR_SPECIAL_LABEL,padding = { top = padding_top }},
            textValign = ui.TEXT_VALIGN_CENTER,
        }

        local yyy = _tapNode:getPositionY() - 17
        local tab = widget.newTab{
            padding = 20,
            direction = DIRECTION_HORIZONTAL,
            x = _tapNode:getPositionX()  + 15,
            y = yyy,
            items = {Btn1,Btn2,Btn3},
            listener = function ( index, button )
                if index == 1 then 
                    reloadRecMsg(ChatUtil.ChatAll)
                elseif index == 2 then 
                    reloadRecMsg(ChatUtil.ChatWorld)
                else 
                    reloadRecMsg(ChatUtil.ChatSystem)
                end
            end
        }

        tab:setAnchorPoint(ccp(0,1.0))

        _node:addChild(tab, 1)

        tab.selectButton(1)
        if _GAME.CONFIG.SDK_PLATFORM.chat == false then
            Btn2:setVisible(false)
            Btn3:setVisible(false)
        end
    end 

    -- 创建发送按钮
    local function createBtn()

        local btnNode = CCBCenter.getNodeByTag(_node,106)
        local btnImg1,btnImg1_ = "chat/chat_sendBtn.png","chat/chat_sendBtn_.png"
        local Btn1 = 
        widget.newButton{
        normalImage = btnImg1,
        selectImage = btnImg1_,
        disableImage = btnImg1_,
        x = btnNode:getPositionX(),
        y = btnNode:getPositionY(),
        listener = function ( )

            -- 发送消息
            CCBCenter.sendLuaMessage(MSG_ID.MSG_CHATLAYER_SENDMSG)
        end,
        labelParams = 
        {text = _s("COMMON_SEND"), textAlign = ui.TEXT_ALIGN_CENTER, size = 25, color = BUTTON_COLOR3.BROWN}
        }
        _node:addChild(Btn1)
        Btn1:setScale(SCALE_FOR_SPECIAL_NODE)
        if _GAME.CONFIG.SDK_PLATFORM.chat == false then
            Btn1:setVisible(false)
        end
    end 

    -- 获取发送消息
    local function getSendMsg()
        return _sendmsgTf:getText()
    end

    -- 设置发送消息
    local function setSendMsg( text )
        _sendmsgTf:setText( text )
    end

    -- 切换显示隐藏状态
    local function toggleSendMsgEnable( )
        -- local isVisible = _sendmsgTf:isVisible()
        if _sendmsgTf:getPositionY() == 99999 then
            _sendmsgTf:setPosition(CCBCenter.getNodeByTag(_node , 2):getPosition())
        else
            _sendmsgTf:setPosition(ccp(0, 99999))
        end
    end

    -- 清空发送消息
    local function clearSendMsg()
        setSendMsg("")
    end

    local function initViews()
    	Log.d(TAG,"into chat")

        NetHelper.showLoading(true,true)

        -- _node:setPositionY(-1 * _node:getContentSize().height)

        -- 初始化输入框
        initEditBox()

        _tapNode = CCBCenter.getNodeByTag(_node,103)

        createTab()

        _tableNode = CCBCenter.getNodeByTag(_node,104) --tableNode

        _gridTable = createTable()--创建table

        reloadRecMsg() -- 刷新聊天消息

        createBtn() -- 创建发送按钮
    end

--[[ ## public fuction --]]
    _node.toggleSendMsgEnable = toggleSendMsgEnable
    _node.getSendMsg = getSendMsg
    _node.setSendMsg = setSendMsg
    _node.clearSendMsg = clearSendMsg
    _node.reloadRecMsg = reloadRecMsg

--[[ ## MAINs --]]
	initViews()
end

return M