--AlertLayer.lua
local M = {}

--[[
	例子：
      AlertLayer.new{
        btnStr = {"确定","取消","充值" }, -- 按钮文字数组
        btnColor = {AlertLayer.BTN_COLOR_YELLOW,AlertLayer.BTN_COLOR_YELLOW,AlertLayer.BTN_COLOR_BLUE},
        -- 按钮颜色数组
		btnClickEvent = {
			function (  )  按钮1事件  默认为确定
	          print("btn1ClickEvent")
	        end,
	        function (  ) 按钮2事件 默认为取消
	          print("btn2ClickEvent")
	        end,
			function (  ) 按钮3事件 一般为充值
	          print("btn3ClickEvent")
	        end
		}, -- 按钮事件数组
        titleStr = "标题",  -- 标题
        content = "内容"  -- 内容
      }

      注：全部参数都是选填，若只填一个btnStr那会只显示一个按钮
      ,若写2个则显示2个，若都不填则显示默认2个按钮，为"确定"和
      “取消”，内容默认为空，标题默认为“提示信息”


	  -- 这个接口默认显示2个按钮“确定”和“取消”
	  AlertLayer.new( params )
	  -- 这个接口默认显示3个按钮“确定”，“取消”和“充值”
      AlertLayer.new4IAP( params )
	  -- 这个接口默认显示1个按钮“取消”
      AlertLayer.new4Cancel( params )
	  -- 这个接口默认显示1个按钮“确定”
      AlertLayer.new4OK( params )


--]]

M.BTN_COLOR_YELLOW = 1
M.BTN_COLOR_BLUE = 2

local DEFAULTOKSTR = _s("COMMON_OK")
local DEFAULTCANCELSTR = _s("COMMON_CANCEL")
local DEFAULTIAPSTR = _s("COMMON_RECHARGE")

local IMG_BLUE = "alert/alertBtn1.png"
local IMG_BLUE_ = "alert/alertBtn1_.png"
local IMG_YELLOW = "alert/alertBtn2.png"
local IMG_YELLOW_ = "alert/alertBtn2_.png"

local BTNFONTSIZE = 50 * SCALE_FOR_SPECIAL_LABEL


local function buyDiamond( )
	SOUND:playEffectButton1()
	if isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE, _GAME.CONFIG.SDK.SDK_APPSTORE_EN, _GAME.CONFIG.SDK.SDK_UCUBE, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
		if GAMERATE:isBuyDiamond() then
		 	CCBCenter.loadCCB("MSG_SHOPBUYDIAMONDLAYER_MODEL", "ccb.c.shop.ShopBuyDiamondLayer", {})
		end
	--云顶充值
	elseif isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then
		local function storeSuccessCallBack(result)
			Log.d(TAG, "购买成功: MSG_ID = %s", "sss")
			NetHelper.hideLoading(true)
			util.delayCall(
	        	function ( )
					util.delayCall(
			        	function ( )
							CCBCenter.sendLuaMessage( MSG_ID.MSG_SHOPLAYER_NETGETSHOPS, 
					 						nil,
					 			 			{arg = {}, methodId = ACTID.MSG_GET_SHOPLIST, callBackmethod = reflashData} )--请求
						end, 
						0.7
					)
				end, 
				35.7
			)
			---后台验证
			AlertLayer.new4OK{
		        -- 按钮颜色数组
				btnClickEvent = {
					function (  )  --按钮1事件  默认为确定
			          -- print("btn1ClickEvent")
			        end
				}, -- 按钮事件数组
		        titleStr = _s("BUY_SUCCESS"),  -- 标题
		        content = _s("BUY_SUCCESS_REFRESH") -- 内容
	      	}
		end

		local function storeErrorCallBack( result )
			-- body
			Log.d(TAG, "购买失败: MSG_ID = %s", result["errorStr"])
			Log.d(TAG, "errorCode: MSG_ID = %s", result["errorCode"])
			NetHelper.hideLoading(true)
			AlertLayer.new4OK{
		        -- 按钮颜色数组
				btnClickEvent = {
					function (  )  --按钮1事件  默认为确定
			          -- print("btn1ClickEvent")
			        end
				}, -- 按钮事件数组
		        titleStr = _s("COMMON_NEWS_TIPS"),  -- 标题
		        content = result["errorStr"]  -- 内容
	      	}
		end
		SOUND:playEffectButton1()
       --云顶sdk
       _sdkPlatform.store(storeSuccessCallBack, storeErrorCallBack, {iapId = "1",deviceno = DEFLOGINBASEINFO.deviceid})
	end

end

function M.new4IAP( params )

	params.btnStr = params.btnStr or {}

	params.btnStr[1] = params.btnStr[1] or DEFAULTOKSTR
	params.btnStr[2] = params.btnStr[2] or DEFAULTCANCELSTR
	params.btnStr[3] = params.btnStr[3] or DEFAULTIAPSTR

	params.btnColor = params.btnColor or {}

	params.btnColor[1] = params.btnColor[1] or M.BTN_COLOR_YELLOW
	params.btnColor[2] = params.btnColor[2] or M.BTN_COLOR_YELLOW
	params.btnColor[3] = params.btnColor[3] or M.BTN_COLOR_BLUE

	params.btnClickEvent[3] = buyDiamond

	M.new(params)
end

function M.new4Cancel( params )
	params.btnStr = params.btnStr or {}
	params.btnStr[1] = params.btnStr[1] or DEFAULTCANCELSTR
	params.btnColor = params.btnColor or {}
	params.btnColor[1] = params.btnColor[1] or M.BTN_COLOR_YELLOW

	M.new(params)
end

function M.new4OK( params )
	params.btnStr = params.btnStr or {}
	params.btnStr[1] = params.btnStr[1] or DEFAULTOKSTR
	params.btnColor = params.btnColor or {}
	params.btnColor[1] = params.btnColor[1] or M.BTN_COLOR_YELLOW

	M.new(params)
end

function M.new( params )

	-- local ccbdata = {}
	-- ccbdata.btnStr = params.btnStr
	-- ccbdata.btnColor = params.btnColor
	-- ccbdata.btnClickEvent = params.btnClickEvent 
	-- ccbdata.titleStr = params.titleStr
	-- ccbdata.content = params.content
	-- ccbdata.ccbLevel = params.ccbLevel
	-- 关闭loading
	quickui.hideLoadingLayer()

	if params.isUserDiamond then
		local diamondIndex = params.diamondIndex
		params.isAlert = false
		if DiamondAlertEntity:getIsAlert(diamondIndex) and DiamondAlertEntity:getIsAlert(diamondIndex) == 1 then
			params.isAlert = true
		end
		local btn1ClickEvent = params.btnClickEvent[1]
		-- if device.language == "cn" then
		if params.isAlert then
			CCBCenter.loadCCB("MSG_ALERTLAYER_MODEL", "ccb.c.common.AlertLayer",params, params.callback)
			-- if btn1ClickEvent then
			-- 	btn1ClickEvent()
			-- end
		else
			if btn1ClickEvent then
				btn1ClickEvent()
			end
		end
	else
		CCBCenter.loadCCB("MSG_ALERTLAYER_MODEL", "ccb.c.common.AlertLayer",params, params.callback)
	end
end

function M.bindView(node, luaValue)
	local TAG = "[AlertLayerView]"
	local _node, _nodeTable = node, luaValue

	local t3_btnLeft 
	local t3_btnRight
	local t3_btnMiddle
	local t2_btnLeft 
	local t2_btnRight
	local t1_btn


	local btnStr = node.btnStr or {} -- 按钮文字数组
	local btnClickEvent = node.btnClickEvent or {} -- 按钮事件数组
	local btnColor = node.btnColor or {}-- 按钮颜色数组
	local titleStr = node.titleStr
	local content = node.content
	local btnPriority = node.btnPriority

	local function getBtnImg( index )
		local img = IMG_YELLOW
		local img_ = IMG_YELLOW_
		if btnColor[index] and btnColor[index] == M.BTN_COLOR_BLUE then 
			img = IMG_BLUE
			img_ = IMG_BLUE_
		end
		return img,img_
	end

	-- 初始化文字
	local function initWords()

	    -- local ly = widget.newLayer{
	    --         color = ccc4(16,8,11,0.6*255)
	    --     }
	    -- _node:addChild(ly, -1)

		if titleStr then 
			_nodeTable.lblTitle:setString(titleStr)
		end
		if content then 
			_nodeTable.lblContent:setString(content)
		end

		local Btn1
		local Btn2
		local Btn3

		local btnStr1 = btnStr[1] or DEFAULTOKSTR
		local btnStr2 = btnStr[2] or DEFAULTCANCELSTR
		local btnStr3 = btnStr[3] or DEFAULTIAPSTR

		local btnImg1,btnImg1_ = getBtnImg( 1 )
		local btnImg2,btnImg2_ = getBtnImg( 2 )
		local btnImg3,btnImg3_ = getBtnImg( 3 )

		if #btnStr == 1 then 
			Btn1 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg1,
				selectImage = btnImg1_,
				disableImage = btnImg1_,
				x = t1_btn:getPositionX(),
				y = t1_btn:getPositionY(),
				listener = btnClickEvent[1],
				priority = btnPriority,
				labelParams = 
				{text = btnStr1,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn1)
			Btn1:setScale(SCALE_FOR_SPECIAL_NODE)
		elseif #btnStr == 2 then
			Btn1 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg1,
				selectImage = btnImg1_,
				disableImage = btnImg1_,
				x = t2_btnLeft:getPositionX(),
				y = t2_btnLeft:getPositionY(),
				listener = btnClickEvent[1],
				priority = btnPriority,
				labelParams = 
				{text = btnStr1,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn1)
			Btn1:setScale(SCALE_FOR_SPECIAL_NODE)

			Btn2 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg2,
				selectImage = btnImg2_,
				disableImage = btnImg2_,
				x = t2_btnRight:getPositionX(),
				y = t2_btnRight:getPositionY(),
				listener = btnClickEvent[2],
				priority = btnPriority,
				labelParams = 
				{text = btnStr2,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn2)
			Btn2:setScale(SCALE_FOR_SPECIAL_NODE)
		elseif #btnStr == 3 then 
			Btn1 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg1,
				selectImage = btnImg1_,
				disableImage = btnImg1_,
				x = t3_btnLeft:getPositionX(),
				y = t3_btnLeft:getPositionY(),
				listener = btnClickEvent[1],
				priority = btnPriority,
				labelParams = 
				{text = btnStr1,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn1)
			Btn1:setScale(SCALE_FOR_SPECIAL_NODE)

			Btn2 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg2,
				selectImage = btnImg2_,
				disableImage = btnImg2_,
				x = t3_btnMiddle:getPositionX(),
				y = t3_btnMiddle:getPositionY(),
				listener = btnClickEvent[2],
				priority = btnPriority,
				labelParams = 
				{text = btnStr2,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn2)
			Btn2:setScale(SCALE_FOR_SPECIAL_NODE)

			Btn3 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg3,
				selectImage = btnImg3_,
				disableImage = btnImg3_,
				x = t3_btnRight:getPositionX(),
				y = t3_btnRight:getPositionY(),
				listener = btnClickEvent[3],
				priority = btnPriority,
				labelParams = 
				{text = btnStr3,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn3)
			Btn3:setScale(SCALE_FOR_SPECIAL_NODE)
		else 
			Btn1 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg1,
				selectImage = btnImg1_,
				disableImage = btnImg1_,
				x = t2_btnLeft:getPositionX(),
				y = t2_btnLeft:getPositionY(),
				listener = btnClickEvent[1],
				priority = btnPriority,
				labelParams = 
				{text = btnStr1,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn1)
			Btn1:setScale(SCALE_FOR_SPECIAL_NODE)

			Btn2 =
			widget.newButton{
				scale = 1.1,
				normalImage = btnImg2,
				selectImage = btnImg2_,
				disableImage = btnImg2_,
				x = t2_btnRight:getPositionX(),
				y = t2_btnRight:getPositionY(),
				listener = btnClickEvent[2],
				priority = btnPriority,
				labelParams = 
				{text = btnStr2,textAlign = ui.TEXT_ALIGN_CENTER,size = BTNFONTSIZE,color = BUTTON_COLOR3.BROWN}
			}
			_node:addChild(Btn2)
			Btn2:setScale(SCALE_FOR_SPECIAL_NODE)
		end

	end
	-- 动画显示
	local function animateShow()
		-- 动画
		anim.popOut(_node, { playTime = 0.3 })
	end
	--创建是否弹窗单选框
	local function createCheckbox( ... )
		local checkboxNode = CCBCenter.getNodeByTag(_node,113)

		local checkBox = widget.newCheckBox{
			--contentSize = checkboxNode:getContentSize(),
			normalImage = "diamondalert/btn_alert_nomal.png",
			selectImage = "diamondalert/btn_alert_selected.png", 
			ignoreAnchor = true,
			listener = function ( button )
            	_node.newIsAlert = 1 - _node.newIsAlert
        	end,
		}

		local params = {checkBox,{text = _s("USE_DIAMOND_CHECKBOX"), size = 25}
                }

	    local  linearLabel = widget.newLinearLabel({paramTable = params,params = 5})
        util.alignNode(linearLabel, checkboxNode,display.CENTER_LEFT)
        checkboxNode:removeAllChildrenWithCleanup(true)
        checkboxNode:addChild(linearLabel)
	end
--[[ ## local fuction --]]
	local function initViews()

		t3_btnLeft = CCBCenter.getNodeByTag(_node,108)
		t3_btnRight = CCBCenter.getNodeByTag(_node,109)
		t3_btnMiddle = CCBCenter.getNodeByTag(_node,107)

		t2_btnLeft = CCBCenter.getNodeByTag(_node,110)
		t2_btnRight = CCBCenter.getNodeByTag(_node,111)

		t1_btn = CCBCenter.getNodeByTag(_node,112)

		initWords()
		if not _node.noanim then 
			animateShow()
		end

		if _node.isAlert then
			createCheckbox()
		end
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
	M.buyDiamond = buyDiamond
end

return M