--StatusBarLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[StatusBarLayerView]"
	local _node, _nodeTable = node, luaValue
--[[ ## local fuction --]]
	local function initViews()
	    -- [包含文件]
	    -- require("static.data_map")



	    

	    




	    -- [常量]
	    local A_PROGRESS_T 				= .5



	    

	    




	    -- [操作变量]
	    -- 数字
	    local TDNumberUtils 			= require(PH_MDL_UTIL .. "TDNumberUtils")
	    -- 动画
	    local TDAnimationUtils 			= require(PH_MDL_UTIL .. "TDAnimationUtils")
	    -- 经验值
	    local _progressBarExp 			= nil
	    -- 体力值
	    local _progressBarSp 			= nil
	    -- 体力时间
	    local _ctlSpTime 				= nil
	    -- 结点表[快捷调用]
		local N 						= _nodeTable
		-- 金币值[刷新动画]
		local _hookGold 				= -1
		-- 钻石值[刷新动画]
		local _hookDiamond				= -1



	    

	    



	    -- [私有方法声明]
	    -- [视图渲染]
	    -- 视图渲染
	    local viewRender
	    -- 加载状态栏
	    local loadStatusBar
	    -- 加载经验值
	    local loadProgressBarExp
	    -- 加载体力值
	    local loadProgressBarSp
		-- 加载时间视图
		local loadTimeView
		-- 加载渲染以外的其他操作
		local loadRenderOtherwise
		-- 刷新状态数据
		local refleshData

	    -- [数据]
	    -- 加载数据
	    local loadData

	    -- [工具]
	    -- 设置进度条值
	    local setProgressValue
	    -- 设置进度条文本
	    local setProgressText


	        

	        





	    -- [私有方法定义]
	    -- [实例方法][视图渲染]
	    -- 视图渲染
	    function viewRender()
	    	-- 加载数据
	    	loadData()

		    -- 加载状态栏
			loadStatusBar()
			-- 加载时间视图
			loadTimeView()

			-- 加载渲染以外的其他操作
			loadRenderOtherwise()
		end
	    
	    -- 加载状态栏
	    function loadStatusBar()
	    	-- 加载经验值
	    	loadProgressBarExp()
	    	-- 加载体力值
	    	loadProgressBarSp()
	    end

		-- 加载经验值
	    function loadProgressBarExp()
	    	-- 生成对象
			local sprite = widget.newProgressBar({
				frontSprintParams   = {file = "map/progressBar_blue_img.png",},
				bgSprintParams 		= {file = "map/progressBar_bg.png"},
				percentage 			= 0,
				ttfLabelParams 		= {size = 16 / SCALE_FOR_SPECIAL_NODE, padding = {top = 24, left = 20},},
			})
			sprite:ignoreAnchorPointForPosition(true)
			CCBCenter.getNodeByTag(_node, 302):addChild(sprite)

			-- 存储变量
			_progressBarExp = sprite
	    end

		-- 加载体力值
	    function loadProgressBarSp()
	    	-- 生成对象
			local sprite = widget.newProgressBar({
				frontSprintsParams  = {{file = "map/progressBar_green_img.png",}, {file = "map/progressBar_deep_green_img.png",}},
				bgSprintParams 		= {file = "map/progressBar_bg.png"},
				percentage 			= 0,
				ttfLabelParams 		= {size = 16 / SCALE_FOR_SPECIAL_NODE, padding = {top = 24, left = -20},},
			})
			sprite:ignoreAnchorPointForPosition(true)
			CCBCenter.getNodeByTag(_node, 303):addChild(sprite)

			-- 存储变量
			_progressBarSp = sprite
	    end

		-- 加载时间视图
	    function loadTimeView()
	    	local view = CountDownView.new{ 
	            format = "[mm]:[ss]",
	            labelParams = {size = 16,},
	            listener = function()
	                local sp = ME:getCursp() + 1
	                ME:setCursp(sp)
	                if sp < ME:getActlimit() then
	                    _ctlSpTime:start(300)
	                    local sp = ME:getCursp() /  ME:getActlimit() * 100
	                    _progressBarSp:runProgressTo( 0.5 , sp )
	                    _progressBarSp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
	                else
	                    _ctlSpTime:stop()
	                    if sp == ME:getActlimit() then
	                        _progressBarSp:runProgressTo( 0.5 , sp )
                            _progressBarSp:setString(sp .. "/" .. ME:getActlimit())
	                    end
	                    N["lblSpTimeLabel"]:setVisible(false)
	                    _ctlSpTime:setVisible(false)
	                    N["lblSpTimeFull"]:setVisible(true)
	                end
	            end
	        }
	        _nodeTable["lyrTime"]:addChild(view)
	        util.alignNode(view, _nodeTable["lyrTime"]:getContentSize(), display.CENTER)
	        if ME:getSpNextTime() ~= 0 then
	            view:start(ME:getSpNextTime())
	        else
                N["lblSpTimeLabel"]:setVisible(false)
                view:setVisible(false)
                N["lblSpTimeFull"]:setVisible(true)
	        end

	        _ctlSpTime = view
	    end

		-- 加载渲染以外的其他操作	
	    function loadRenderOtherwise()
			-- 刷新状态数据
			refleshData(true)
	    end

	    -- 刷新状态数据
	    function refleshData(isRerenderRole)
	    	-- 等级
	    	local level 		= ME:getLv()
	    	-- 经验[当前]
	    	local expCurrent 	= ME:getCurexp()
	    	-- 经验[总]
	    	local expTotal 		= ME:getTotalexp()
	    	-- 召唤值[当前]
	    	local costCurrent 	= ME:getUsedcost()
	    	-- 召唤值[总]
	    	local costTotal 	= ME:getTotalcost()
	    	-- 体力[当前]
	    	local spCurrent 	= ME:getCursp()
	    	-- 体力[总]
	    	local spTotal 		= ME:getActlimit()	
	    	-- 金币
	    	local gold 			= ME:getGold()
	    	-- 钻石
	    	local diamond 		= ME:getDiamond()	
	    	-- 星星
	    	local star 			= ME:getStar()
	    	-- 友情点
	    	local friendPoint 	= ME:getFp()

	    	-- 人物头像
	    	if isRerenderRole then 
		    	local roleContainer = util.toCCNode(CCBCenter.getNodeByTag(_node, 31102))
		    	roleContainer:removeAllChildrenWithCleanup(true)
		        local head = ME:createPlayerHeadRectView()
		        head:setScale((roleContainer:getContentSize().width - 20) / head:getContentSize().width)
		        roleContainer:addChild(head)
		        util.alignNode(head, roleContainer, display.CENTER)
		    end

	    	-- 等级
	    	N["lblLevel"]:setString(tostring(level))
	    	-- 经验[xp]
	    	setProgressValue(_progressBarExp, expCurrent, expTotal, false)
	    	setProgressText(_progressBarExp, expCurrent, expTotal)
	    	-- 体力[sp]
	    	setProgressValue(_progressBarSp, spCurrent, spTotal, true)
	    	setProgressText(_progressBarSp, spCurrent, spTotal)
	    	-- 召唤值[当前]
	    	N["lblSummonCurrent"]:setString(tostring(costCurrent))
	    	-- 召唤值[总]
	    	N["lblSummonTotal"]:setString(tostring(costTotal))


	    	-- 金币
	    	-- [Version1]
	    	--[[
	    	if true then 
		    	if _hookGold ~= -1 and _hookGold ~= gold then 
		    		local time 		  = .3
		    		local scaleOrigin = N["lblGold"]:getScale()
		    		N["lblGold"]:runAction(TDAnimationUtils.sequence({
		    			CCScaleTo:create(time, 0, scaleOrigin),
		    			CCCallFunc:create(function() N["lblGold"]:setString(tostring(gold)) end),
		    			CCScaleTo:create(time, scaleOrigin),
		    		}))
		    	else
			    	N["lblGold"]:setString(tostring(gold))
		    	end
	    	end

	    	-- [Version1]
	    	--[[
	    	if true then 
		    	-- 钻石
		    	if _hookDiamond ~= -1 and _hookDiamond ~= diamond then 
		    		local time 		  = .3
		    		local scaleOrigin = N["lblDiamond"]:getScale()
		    		N["lblDiamond"]:runAction(TDAnimationUtils.sequence({
		    			CCScaleTo:create(time, 0, scaleOrigin),
		    			CCCallFunc:create(function() N["lblDiamond"]:setString(tostring(diamond)) end),
		    			CCScaleTo:create(time, scaleOrigin),
		    		}))
		    	else
			    	N["lblDiamond"]:setString(tostring(diamond))
		    	end
		    end
	    	-- 记录Hook值
	    	_hookGold    = gold
	    	_hookDiamond = diamond
	    	]]
	    	
	    	N["lblGold"]:setString(tostring(gold))
	    	N["lblDiamond"]:setString(tostring(diamond))
	    	N["lblStar"]:setString(tostring(star))
	    	N["lblFriendPoint"]:setString(tostring(friendPoint))


	    	-- 更新体力逻辑
		    -- 体力时间
		    _ctlSpTime:modifyTime(ME:getSpNextTime())

		    N["lblSpTimeLabel"]:setVisible(ME:getSpNextTime() ~= 0)
		    _ctlSpTime:setVisible(ME:getSpNextTime() ~= 0)
		    N["lblSpTimeFull"]:setVisible(ME:getSpNextTime() == 0)
	    end


	    ---------


	    -- [数据]
	    -- 加载数据
	    function loadData()
	    	-- ..
	    end


	    ---------


	    -- [工具]
	    -- 设置进度条值
	    function setProgressValue(node, current, total, isAnimate)

	    	local value = current * 1.0 / total * 100

	    	if isAnimate then 
	        	node:runProgressTo(A_PROGRESS_T , value)
	        else
	        	node:setPercentage(value)
	        end
	    end

	    -- 设置进度条文本
	    function setProgressText(node, current, total)
	    	node:setString(current .. "/" .. total)
	    end


	        

	        





	    -- [具体操作]
	    -- 视图渲染
	    viewRender()


	        

	        





	    -- [赋加属性]
	    -- 刷新数据
		_node.refleshData 				= refleshData
	    -- 经验值
	    _node.progressBarExp 			= _progressBarExp
	    -- 体力值
	    _node.progressBarSp 			= _progressBarSp
		-- 体力时间
	    _node.ctlSpTime 				= _ctlSpTime
	    -- 设置进度条文本
	    _node.setProgressText 			= setProgressText
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M