--DiamondAlertLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[DiamondAlertLayerView]"
	local _node, _nodeTable = node, luaValue
	--全选Layer
	local _allLayer
	--全选点击背景
	local _bgCkick

	--创建点击sprite
	local createCkickSprite

	local _clickSprite

	local diamondAleryTable = {}

	local _diamondAlertView 

	local function createAllClick( ... )
		widget.bindTouchEvent{
    		layer = _allLayer,
    		clickListener = function ( layer )

				diamondAleryTable[0] = 1 - diamondAleryTable[0]

				for i,v in ipairs(diamondAleryTable) do
					diamondAleryTable[i] = diamondAleryTable[0]
				end

				if diamondAleryTable[0] == 1 then
					_clickSprite:setVisible(true)
				else
					_clickSprite:setVisible(false)
				end

				_diamondAlertView:getGrid():refresh()
    		end
   		}
	end

	local function createTableView( ... )
		local layer = CCBCenter.getNodeByTag(_node, 202)
		
	    local function createItemCellListener(grid, index, item)
	    	local cell = widget.newLayer{contentSize = CCSize(layer:getContentSize().width,
                layer:getContentSize().height / 6.5)}

        	local bgClick = widget.newSprite{file = "diamondalert/bg_diamond_alert_choose.png",}
        	if diamondAleryTable[0] == 1 or item == 1 then
        		local clickSprint = widget.newSprite{file = "diamondalert/img_diamond_alert.png",}
        		util.alignNode(clickSprint, bgClick,display.CENTER)
        		bgClick:addChild(clickSprint)
        	end

        	local params = {bgClick,{text = _s("USE_DIAMOND_"..index.."_TITLE"), size = 25},
	          }
	        local  costLinearLabel = widget.newLinearLabel({paramTable = params,padding = 10})
	        util.alignNode(costLinearLabel, cell,display.CENTER_LEFT,{left = 25})
	        cell:addChild(costLinearLabel,2)

	         local lineSprite = widget.newScale9{ file = "diamondalert/img_line.png", contentSize = CCSize(379,3),}
            cell:addChild(lineSprite, 0)
            util.alignNode(lineSprite, cell,display.BOTTOM_CENTER)
        

    		return cell

	    end	

	    local function tapListener( grid, index, item )
	    	diamondAleryTable[index] = 1 - diamondAleryTable[index]
	    	diamondAleryTable[0] = 0
	    	_clickSprite:setVisible(false)
	    	grid:refresh()
	    end	

		  --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = layer:getContentSize(),
            contentParams = {
                cellSize = CCSize(layer:getContentSize().width , layer:getContentSize().height / 6.5 ),
                column = 1,
                tapListener = tapListener,
                createItemCellListener = createItemCellListener, 
             },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = layer,
        }

		scrollGrid:setItems(diamondAleryTable)

		return scrollGrid
	end

	local function saveTable( ... )
		DiamondAlertEntity:updateTable(diamondAleryTable)
	end

--[[ ## local fuction --]]
	local function initViews()
		
		diamondAleryTable = DiamondAlertEntity:getDiamondAleryTable()

		_allLayer = CCBCenter.getNodeByTag(_node, 201,"CCLayer")
		_bgCkick = CCBCenter.getNodeByTag(_node, 20101)

		_clickSprite = CCBCenter.getNodeByTag(_node, 20104)

		if diamondAleryTable[0] == 1 then
			_clickSprite:setVisible(true)
		else
			_clickSprite:setVisible(false)
		end

		createAllClick()

		_diamondAlertView = createTableView()
	end

--[[ ## public fuction --]]
	--保存Table
	_node.saveTable = saveTable

--[[ ## MAINs --]]
	initViews()
end

return M