--EquipmentLVLayer.lua
local GoodsMaster = require("cardui.GoodsMaster")
local GoodsEntity = require("model.goods.GoodsEntity")
local EffectButton = require("cardui.EffectButton")
local _unlockLevel = require("static.unlock_level")
-- 字符串
TDStringUtils               = require("view.Fight.Util.TDStringUtils")

require("db.equipevosetdb")
require("db.equipevodb")
require("db.equipaddsetdb")

local M = {}

function M.bindView(node, luaValue, ...)
    local TAG = "[EquipmentLVLayerView]"
    local _node, _nodeTable = node, luaValue
    --装备操作类型 1 装备强化 2 装备进阶 3 装备追加 4 装备拆解
    local _equipProcessing = ...

    --装备列表node
    local _nodeEquipmentList
    --装备列表
    local _equipmentListGrid
    --材料消耗node
    local _mMaterialNode
    --材料消耗Grid
    local _mMaterialGrid
    --装备强化node
    local _mEquipLvUpDetail
    --装备强化数值列表
    local _mEquipLvUpDetailGrid
    --用户身上矿石1数量
    local userStone1
    --用户身上矿石2数量
    local userStone2
    --关系表id
    local eqid
    --装备强化Layer
    local equipLvUpLayer
    --装备操作按钮
    local _equipBtns = {}
    --装备实体
    local equipEntity
    --是否是高级矿石
    local isHighLevelStone
    --成功率进度条
    local _successRateProgressBar
    --强化进度条
    local equipLvUpProgressBar
    --是否使用钻石提升陈功功率
    local isUseDamond = 0

    local _eqid
    --装备品质
    local _quality
    --拆解时定到当前界面
    local _nowPageIndex = 1

    --装备进阶等级
    local _mEquipLvUpNode
    --提升成功率需要的钻石
    local _needDiamond

    --设置提升成功率需要的钻石
    local function setNeedDiamond( diamond )
        _needDiamond = diamond
    end

    --成功率进度条
    local function createSuccessRate()

        local successRateNode,frontSprint
        if _equipProcessing == 2 then
            successRateNode = CCBCenter.getNodeByTag(_node, 617)
            frontSprint = "equipment/blacksmith/img_successrate_2.png"
        else
            successRateNode = CCBCenter.getNodeByTag(_node, 320)
            frontSprint = "equipment/blacksmith/img_successrate_1.png"
        end

        _successRateProgressBar = widget.newProgressBar{
            frontSprintParams = {file = frontSprint,},
            bgSprintParams = {file = "equipment/blacksmith/bg_successrate.png"},
            percentage = 0,
        }
         util.alignNodeWithPadding(_successRateProgressBar, successRateNode, display.CENTER_LEFT)
       -- _successRateProgressBar:ignoreAnchorPointForPosition(true)
        successRateNode:removeAllChildrenWithCleanup(true)
        successRateNode:addChild(_successRateProgressBar)

    end 

    --设置要拆解的装备
    local function setDismantleEquip( equip )

        _nodeTable["mDismantleEqupLayer"]:removeAllChildrenWithCleanup(true)

       local dismantleEquipEntity = GoodsEntity.new(equip)
        dismantleEquipEntity.type = GoodsMaster.MATERIAL
        dismantleEquipEntity.showDetail = true
        dismantleEquipEntity.showFrame = true
        dismantleEquipEntity.shareButton = true
        local equipment = GoodsMaster.new(dismantleEquipEntity)
        equipment:setPosition(2,2)
        _nodeTable["mDismantleEqupLayer"]:addChild(equipment,10001)
        _nodeTable["mDismantleEquipLabel"]:setString(dismantleEquipEntity:getName())
        _nodeTable["btnDismantle"]:setEnabled(true)

        _nodeTable["mDismantleEquIpLv"]:setString(_s("EQUIPMENT_DISMANTLE_LV",dismantleEquipEntity:getStrlv()))
        _nodeTable["mDismantleEquIpEvo"]:setString(_s("EQUIPMENT_DISMANTLE_EVO",dismantleEquipEntity:getEvolv()))
        _nodeTable["mDismantleEquIpSetUp"]:setString(_s("EQUIPMENT_DISMANTLE_SETUP",dismantleEquipEntity:getAdd()))
        _nodeTable["mDismantleEquIpQuality"]:setString(_s("EQUIPMENT_DISMANTLE_QUALITY_"..dismantleEquipEntity:getQuality()))
        _eqid = dismantleEquipEntity:getEqid()

        _quality = dismantleEquipEntity:getQuality()
    end  

    --加载材料数据
    local function reloadMaterialGrid( value )

        local stoneNewCount,goldNewCount

        if _equipProcessing == 1 then
            stoneNewCount = value.strlv * GAMERATE:getEquipGemRate()
            goldNewCount = value.strlv * GAMERATE:getEquipGoldRate()
        elseif _equipProcessing == 2 then
            stoneNewCount = 1
            goldNewCount = (value.evolv + 1) * GAMERATE:getEquipEvoGoldRate()
        elseif _equipProcessing == 3 then
            stoneNewCount = 1 
            goldNewCount = ( value.add + 1 ) * GAMERATE:getEquipAddGoldRate()
        end

        local material = {{typ = 1, userCount = userStone1, newCount = stoneNewCount },
            {typ = 2, userCount = userStone2, newCount = 1},
            {typ = 3, userCount = ME:getGold(), newCount = goldNewCount},{nil}}

        _mMaterialGrid:setItems(material)
    end

    --加载装备详细信息
    local function reloadEquipLvUpDetail( value )
        if value.no then
            --装备图像
            local bg 
            if _equipProcessing == 2 then
                bg = CCBCenter.getNodeByTag(_node, 612)
            else
                bg = CCBCenter.getNodeByTag(_node, 309)
            end
            bg:removeAllChildrenWithCleanup(true)

            --装备实体
            equipEntity = GoodsEntity.new(value)
            equipEntity.type = GoodsMaster.MATERIAL
            equipEntity.showDetail = true
            equipEntity.showFrame = true
            equipEntity.shareButton = true
            local equipment = GoodsMaster.new(equipEntity)
            equipment:setPosition(2,2)
            bg:addChild(equipment,10001)

            local pros = {}
            --去除装备套装属性
            if #value.pros > 0 then

                for i,v in ipairs(value.pros) do
                    if v.isact == 1 then
                        table.insert(pros,v)
                    end
                end
            end
            for i=1,2 - #pros do
                table.insert(pros,{})
            end
            _mEquipLvUpDetailGrid:setItems(pros)

            local stoneNowValue
            local stoneNeedValue

            if isHighLevelStone == nil or isHighLevelStone == 0 then
                --普通矿石
                stoneNowValue = userStone1
                stoneNeedValue = value.strlv * GAMERATE:getEquipGemRate()
            else
                --高级矿石
                stoneNowValue = userStone2
                stoneNeedValue = 1
            end

            local successPercent,equipLv,equipMaxLv,goldNewCount

            if _equipProcessing == 1 then
                _mEquipLvUpNode:removeAllChildrenWithCleanup(true)
                local params = {{text = _s("EQUIPMENT_LV",value.strlv), size = 20},
                "equipment/blacksmith/img_equipment_lvTo.png",
                {text = value.strlv+1, size = 20}}

                local  linearLabel = widget.newLinearLabel({paramTable = params})
                util.alignNode(linearLabel, _mEquipLvUpNode,display.CENTER)
                _mEquipLvUpNode:addChild(linearLabel)

                _mEquipLvUpNode:setVisible(true)

                successPercent = 100
                equipLv = value.strlv
                equipMaxLv = ME:getLv()
                goldNewCount = value.strlv * GAMERATE:getEquipGoldRate()

                _nodeTable.mEquipmentNameLabel:setString(equipEntity:getName())
            elseif _equipProcessing == 2 then

                _mEquipLvUpNode:removeAllChildrenWithCleanup(true)
                local params 

                equipLv = value.evolv
                equipMaxLv = tonumber(EquipevosetDB.getByID(value.quality).evolimit)
                if equipLv >= equipMaxLv then
                    successPercent = EquipevoDB.getByID(equipLv).showgl
                    params = {{text = _s("EQUIPMENT_STEPUPTITLE_LV",value.evolv), size = 20}}
                else
                    successPercent = EquipevoDB.getByID(equipLv + 1).showgl
                    params = {{text = _s("EQUIPMENT_STEPUPTITLE_LV",value.evolv), size = 20},
                        "equipment/blacksmith/img_equipment_lvTo.png",
                        {text = value.evolv+1, size = 20}}
                end

                local  linearLabel = widget.newLinearLabel({paramTable = params})
                util.alignNode(linearLabel, _mEquipLvUpNode, display.CENTER)
                _mEquipLvUpNode:addChild(linearLabel)

                stoneNeedValue = 1
                goldNewCount = (value.evolv + 1) * GAMERATE:getEquipEvoGoldRate()

                _nodeTable.mDamondLabel:setString(EquipevoDB.getByID(equipLv + 1).adddiam)
                _nodeTable.mSetUpEquipName:setString(equipEntity:getName())

                if tonumber(EquipevoDB.getByID(equipLv + 1).adddiam) > ME:getDiamond() then
                    _nodeTable.btnChoose:setEnabled(false)
                else
                    _nodeTable.btnChoose:setEnabled(true)
                end
                setNeedDiamond(EquipevoDB.getByID(equipLv + 1).adddiam)
            elseif _equipProcessing == 3 then

                _mEquipLvUpNode:removeAllChildrenWithCleanup(true)
                local params 

                equipLv = value.add
                equipMaxLv = equipEntity:getAddMax()
                if equipLv >= equipMaxLv then
                    if equipLv == 0 then
                        successPercent = 0 
                    else
                        successPercent = EquipaddsetDB.getByID( equipLv  ).probability
                    end
                    params = {{text = _s("EQUIPMENT_SUPPLEMENT_LV",value.add), size = 20},}
                else
                    successPercent = EquipaddsetDB.getByID( equipLv + 1).probability
                    params = {{text = _s("EQUIPMENT_SUPPLEMENT_LV",value.add), size = 20},
                        "equipment/blacksmith/img_equipment_lvTo.png",
                        {text = value.add+1, size = 20}}
                end

                local  linearLabel = widget.newLinearLabel({paramTable = params})
                util.alignNode(linearLabel, _mEquipLvUpNode,display.CENTER)
                _mEquipLvUpNode:addChild(linearLabel)

                _mEquipLvUpNode:setVisible(true)

                stoneNeedValue = 1
                goldNewCount = (value.add + 1) * GAMERATE:getEquipAddGoldRate()
                _nodeTable.mEquipmentNameLabel:setString(equipEntity:getName())
            end
            --判断是否可以强化
            if equipLv < equipMaxLv and  ME:getGold() >= goldNewCount and stoneNowValue >= stoneNeedValue  then
                if _equipProcessing ~= 2 then
                    _nodeTable.btnEquipmentLVUP:setEnabled(true)
                else
                    _nodeTable.btnEquipSetUp:setEnabled(true)
                end
                eqid = value.eqid
            else
                if _equipProcessing ~= 2 then
                    _nodeTable.btnEquipmentLVUP:setEnabled(false)
                else
                    _nodeTable.btnEquipSetUp:setEnabled(false)
                    _nodeTable.btnChoose:setEnabled(false)
                end  
            end

            _successRateProgressBar:runProgressTo(0.5,tonumber(successPercent))

            --加载材料数据
            reloadMaterialGrid(value)

       end
       
    end

    --加载装备列表
	local function reloadEquipmentListGrid( value )

        --默认到第一件
        _equipmentListGrid:setItems(value,true)
        _equipmentListGrid:highLight(1)

        if _equipProcessing == 4 then
            _equipmentListGrid:jumpToPage(_nowPageIndex)
        end

        --定位到装备所在位置
        if eqid then 
            for i,v in ipairs(value) do
                if  eqid == v.eqid then
                    if _equipProcessing ~= 4 then
                        reloadEquipLvUpDetail(v)
                    end
                    _equipmentListGrid:highLight(i)
                    local index = math.floor( i / 9 )
                    if i % 9 > 0 then
                        _equipmentListGrid:jumpToPage(index + 1)
                    else
                        _equipmentListGrid:jumpToPage(index )
                    end
                end
            end
        end	
	end

    --创建装备列表
	local function createEquipmentListGrid(  )
		local function createItemCellListener( grid, index, item )
			local gridCell = widget.newLayer{ contentSize = grid:getCellSize() }
            gridCell.VIEWS_ = {}

             -- 背景
         	local bg = display.newSprite("equipment/bg_equipment_3.png")
            gridCell:addChild(bg, 0)
            gridCell.VIEWS_.bg = bg
            util.alignNode(bg, gridCell:getContentSize(), display.CENTER)

            gridCell:ignoreAnchorPointForPosition(false)

          	if item.no then

                --装备实体
                local entity = GoodsEntity.new(item)
                entity.type = GoodsMaster.BAGEQUIP
                entity.showDetail = true
                entity.showFrame = true
                entity.disenableTouch = true
                entity.shareButton = true
                local equipment = GoodsMaster.new(entity)
                equipment:setPosition(8,13)
                equipment:setTag(1)
                gridCell:addChild(equipment)

			 	if grid.getPageGrid():isHighLight(item) then 
	                local light = widget.newSprite{file = "goods/bg_goods_select.png"}
	                util.alignNode(light, gridCell:getContentSize(), display.CENTER)
	                gridCell:addChild(light, -1)
	                gridCell.VIEWS_.light = light
                end
          	end
          	
            return gridCell
		end
		local function modifyItemCellListener( grid, index, item, itemCell )
		 	local isHighLight = grid.getPageGrid():isHighLight(item)
            if not isHighLight and itemCell.VIEWS_.light then 
                -- 都叫你不要亮了还亮个P,给我灭掉!!!
                itemCell.VIEWS_.light:removeSelf()
                itemCell.VIEWS_.light = nil
            elseif isHighLight and not itemCell.VIEWS_.light then 
                -- 要你亮时你又在这卖萌,找屎
                local light = widget.newSprite{file = "goods/bg_goods_select.png"}
                util.alignNode(light, itemCell:getContentSize(), display.CENTER)
                itemCell:addChild(light, -1)
                itemCell.VIEWS_.light = light
            end
		end
		local function tapListener( grid, index, item )

			local cell = grid:cellAt(index)
            local array     = {}
            array[#array + 1] = CCScaleTo:create(0.2, 1.1)
            array[#array + 1] = CCScaleTo:create(0.2, 1)
            transition.execute(cell, transition.sequence(array), {easing = "CCEaseBackInOut", onComplete = function ()
                -- playArrowShakeAnim( _node, isReverse )
            end })

            local pageIndex = _equipmentListGrid:getScrollLayer().getCurPageIndex()
            item.index = (pageIndex - 1)  * 18 + index
            grid.getPageGrid():highLight(_equipmentListGrid:getScrollLayer().getCurPageIndex(), index)

             --点击物品时默认是普通矿石
            isHighLevelStone = 0
            --展示物品详细
            if _equipProcessing ~= 4 then
                reloadEquipLvUpDetail(item)
            else
                setDismantleEquip(item)
                _nowPageIndex = pageIndex
            end
		end
		local pageGrid = widget.newPageGrid{
            pageParams = {
                rect = CCRect(0, 0, _nodeEquipmentList:getContentSize().width, _nodeEquipmentList:getContentSize().height),
                totalPages = 1,
                contentSize = _nodeEquipmentList:getContentSize(),
                ignoreAnchor = true,
                indicatorParams = {
                    normal = "goods/goods_Indicator.png",
                    selected = "goods/goods_Indicator_selected.png",
                    height = 30,
                    padding = 10,
                },
            },
            gridParams = {
                disableAutoCalcContentSize = true,
                row = 3, 
                column = 3, 
                createItemCellListener = createItemCellListener,
                modifyItemCellListener = modifyItemCellListener,
                tapListener = tapListener,
            },
        }

        _nodeEquipmentList:addChild(pageGrid)
        return pageGrid
	end

    --加载装备强化数值
    local function createEquipLvUpDetailGrid( ... )
        local materialLayer = widget.newLayer{contentSize = CCSize(160,30)}

        local function createItemCellListener(grid, index, item)

            if item and item.isact then

                local gridCell = widget.newLayer{contentSize = CCSize(160,45)}

                local str 
                
                --数值类型
                if item.camp == RACE_HERO then
                    str = _s("EQUIP_HERO")
                elseif item.camp == RACE_ALL then
                    str = _s("EQUIP_ALLRACE")
                elseif item.camp == RACE_ALLIANCE then
                    str = _s("CARD_RACE_ALLIANCE")
                elseif item.camp == RACE_TRIBE then
                    str = _s("CARD_RACE_TRIBE")
                elseif item.camp == RACE_UNDEAD then
                    str = _s("CARD_RACE_UNDEAD")
                elseif item.camp == RACE_MAIN then
                    str = _s("FRIEND_MAIN_CARD")
                end
                if item.typ == 1 then
                    str = str.."ATK"
                else
                    str = str.."HP"
                end

                local detailTitle = ui.newTTFLabel{
                    size = 18,
                    text = str
                }
                util.alignNodeWithPadding(detailTitle, gridCell:getContentSize(), display.TOP_LEFT, {left = 10 , top = 2})
                gridCell:addChild(detailTitle)

                local nowValueLayer = widget.newLayer{contentSize = CCSize(70,20)}
                util.alignNodeWithPadding(nowValueLayer, gridCell:getContentSize(), display.BOTTOM_LEFT,{bottom = 1})
                gridCell:addChild(nowValueLayer)

                --升级系数
                local proAddrates = TDStringUtils.split(equipEntity:getProAddrate(), ",")
                -- 追加值
                local addInits = TDStringUtils.split(equipEntity:getAddInit(), ",")
                --阶数值 
                local equipevoset = EquipevosetDB.getByID(equipEntity:getQuality())
                local exts = {equipevoset.initial, equipevoset.evo1, equipevoset.evo2, equipevoset.evo3, equipevoset.evo4, equipevoset.evo5, equipevoset.evo6}
                local evolv = equipEntity:getEvolv()
                local equipExt = exts[evolv + 1]

                local addValue = ""

                --强化后的值
                local proAddrate =  proAddrates[index]
                if item.isact == 1 then
                     
                    local pro = proAddrate * equipExt / 10000

                    if _equipProcessing == 1 then
                        addValue = item.initval + pro * equipEntity:getStrlv() + equipEntity:getAdd() * addInits[index]
                    elseif _equipProcessing == 2 then
                        equipExt = exts[evolv + 2]
                        pro = proAddrate * equipExt / 10000
                        addValue = item.initval + pro * ( equipEntity:getStrlv() - 1 ) + equipEntity:getAdd() * addInits[index]
                    elseif _equipProcessing == 3 then

                        addValue = item.initval + pro * ( equipEntity:getStrlv() - 1 ) + ( equipEntity:getAdd() + 1 ) * addInits[index]
                    end

                    local c,j = math.modf(addValue)

                    if j >= 0.5 then
                        addValue = math.ceil(addValue)
                    else
                        addValue = math.floor(addValue)
                    end
                end    

                local params = {{text = item.value, size = 18},
                    "equipment/blacksmith/img_equipment_lvTo.png",
                    {text = addValue, size = 18}}

                local  linearLabel = widget.newLinearLabel({paramTable = params})
                util.alignNode(linearLabel, gridCell,display.BOTTOM_LEFT,{left = 15})
                gridCell:addChild(linearLabel)

                 return gridCell
            end
           
        end
        --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _mEquipLvUpDetail:getContentSize(),
            cellSize = CCSize( materialLayer:getContentSize().width, _mEquipLvUpDetail:getContentSize().height / 2),
            column = 1,
            row    = 2,
            createItemCellListener = createItemCellListener,
            selectedParams = nil,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        _mEquipLvUpDetail:addChild(scrollGrid)

        return scrollGrid
    end

    --创建材料列表
    local function createMaterialGrid(  )
        local materialLayer = widget.newLayer{contentSize = CCSize(250,50)}

        local function tapListener( grid, index, item )
            if  index < 3 then

                --将所有打钩去掉
                grid:getChildByTag(1):getChildByTag(1):removeAllChildrenWithCleanup(true)
                grid:getChildByTag(2):getChildByTag(1):removeAllChildrenWithCleanup(true)

                --将所有选中框去掉
                grid:getChildByTag(1):removeChild(grid:getChildByTag(1):getChildByTag(3))
                grid:getChildByTag(2):removeChild(grid:getChildByTag(2):getChildByTag(3))


                local bg = grid:getChildByTag(index):getChildByTag(1)

                --选中打钩
                local enoughSpr = display.newSprite("equipment/blacksmith/img_equipmentLv_enough.png")
                util.alignNode(enoughSpr, bg:getContentSize(), display.CENTER)
                bg:addChild(enoughSpr)

                --选中的框
                local selectImg = widget.newScale9{ file = "equipment/blacksmith/bg_stone_select.png", 
                    contentSize = CCSize(grid:getChildByTag(index):getContentSize().width + 10, grid:getChildByTag(index):getContentSize().height), }
                util.alignNodeWithPadding(selectImg, grid:getChildByTag(index):getContentSize(), display.CENTER, { left = 5} )
                selectImg:setTag(3)
                grid:getChildByTag(index):addChild(selectImg)

                isHighLevelStone = index - 1

                --改变成功率
                local successPercent,equipLv,equipMaxLv
                if _equipProcessing == 1 then
                    successPercent = 100
                    equipLv = equipEntity:getStrlv()
                    equipMaxLv = ME:getLv()
                elseif _equipProcessing == 2 then
                    equipLv = equipEntity:getEvolv()
                    equipMaxLv = tonumber(EquipevosetDB.getByID(equipEntity:getQuality()).evolimit)
                    if equipLv >= equipMaxLv then
                        successPercent = EquipevoDB.getByID(equipLv).showgl
                    else
                        successPercent = EquipevoDB.getByID(equipLv + 1).showgl
                    end
                elseif _equipProcessing == 3 then
                    
                    equipLv = equipEntity:getAdd()
                    equipMaxLv = equipEntity:getAddMax()

                    if equipLv >= equipEntity:getAddMax() then
                        successPercent = EquipaddsetDB.getByID( equipLv  ).probability
                    else
                        successPercent = EquipaddsetDB.getByID( equipLv + 1 ).probability
                    end
                end

                if index == 2 then
                   successPercent = 100
                   _nodeTable.btnChoose:setEnabled(false)
                   isUseDamond = 0
                else
                    _nodeTable.btnChoose:setEnabled(true)
                end
               
                _successRateProgressBar:runProgressTo(0.5,tonumber(successPercent))
                
                --判断是否可以强化,追加,进阶
                if equipLv < equipMaxLv and  item.userCount >= item.newCount and ME:getGold() >= grid:itemAt(1,3).newCount  then
                    if _equipProcessing ~= 2 then
                        _nodeTable.btnEquipmentLVUP:setEnabled(true)
                    else
                        _nodeTable.btnEquipSetUp:setEnabled(true)
                    end
                    eqid = equipEntity:getEqid()
                else
                    if _equipProcessing ~= 2 then
                        _nodeTable.btnEquipmentLVUP:setEnabled(false)
                    else
                        _nodeTable.btnEquipSetUp:setEnabled(false)
                        _nodeTable.btnChoose:setEnabled(false)
                    end  
                end
            end
        end

        local function createItemCellListener(grid, index, item)
             -- local cell = display.newColorLayer(ccc4(255, 200, 0, 255))

            local gridCell = widget.newLayer{contentSize = CCSize(250,50)}
            local params

            if item.newCount then
                local img,str,color

                if item.typ ~= 3 then

                    --是否足够 不够红色
                    if item.userCount < item.newCount then
                       color = COLOR3.RED
                    else
                        color = COLOR3.WHITE
                    end
                    
                    params = {{text = item.userCount, size = WEEK_TABLE_TEXT_SIZE,color = color},
                        {text = "/"..item.newCount, size = WEEK_TABLE_TEXT_SIZE},
                    }

                    --矿石图片
                    img = "equipment/blacksmith/img_equipment_ore_".._equipProcessing..".png"
                    if item.typ == 2 then
                        img = "equipment/blacksmith/img_equipment_highlevel_ore_".._equipProcessing..".png"
                    end
                  
                elseif item.typ == 3 then

                    if item.userCount < item.newCount then
                       color = COLOR3.RED
                    else
                        color = COLOR3.WHITE
                    end
                    --needGlodValue:setTag(2)

                    params = {{text = item.newCount, size = WEEK_TABLE_TEXT_SIZE,color = color}
                    }

                    img = "equipment/blacksmith/img_equpment_glod_1.png"
                end

                local  linearLabel = widget.newLinearLabel({paramTable = params})
                util.alignNode(linearLabel, gridCell,display.CENTER)
                gridCell:addChild(linearLabel,3)

                local stoneImg = display.newSprite(img)
                util.alignNodeWithPadding(stoneImg, gridCell:getContentSize(), display.CENTER_LEFT, {left = 10})
                gridCell:addChild(stoneImg)

                if item.typ ~= 3 then
                    --材料是否足够
                    local enoughBg = display.newSprite("equipment/blacksmith/bg_equipmentLv_enough.png")
                    util.alignNodeWithPadding(enoughBg, gridCell:getContentSize(), display.CENTER_RIGHT, {right = 3})
                    enoughBg:setTag(1)
                    gridCell:addChild(enoughBg)

                    if isHighLevelStone == nil then
                        isHighLevelStone = 0 
                    end

                    if item.typ ==  isHighLevelStone + 1 then    
                        local enoughSpr = display.newSprite("equipment/blacksmith/img_equipmentLv_enough.png")
                        util.alignNode(enoughSpr, enoughBg:getContentSize(), display.CENTER)
                        enoughBg:addChild(enoughSpr)

                        --选中的框
                        local selectImg = widget.newScale9{ file = "equipment/blacksmith/bg_stone_select.png", 
                            contentSize = CCSize(gridCell:getContentSize().width + 10, gridCell:getContentSize().height), }
                        util.alignNodeWithPadding(selectImg, gridCell:getContentSize(), display.CENTER, { left = 5} )
                        selectImg:setTag(3)
                        gridCell:addChild(selectImg)

                        if item.typ == 2 then
                            _successRateProgressBar:runProgressTo(0.5,100)
                            _nodeTable.btnChoose:setEnabled(false)
                            isUseDamond = 0
                        end
                    end
                end
            end

            local bottomLine = display.newSprite("equipment/bg_equipment_4.png")
            bottomLine:setScaleX(gridCell:getContentSize().width / bottomLine:getContentSize().width)
            util.alignNode(bottomLine, gridCell:getContentSize(), display.BOTTOM_CENTER)
            gridCell:addChild(bottomLine)
            gridCell:ignoreAnchorPointForPosition(false)

            return gridCell
        end
        --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _mMaterialNode:getContentSize(),
            cellSize = CCSize( materialLayer:getContentSize().width, _mMaterialNode:getContentSize().height / 4 ),
            column = 1,
            row    = 4,
            tapListener = tapListener,
            createItemCellListener = createItemCellListener,
            selectedParams = nil,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        _mMaterialNode:addChild(scrollGrid)

        scrollGrid:setSelectEffect(1)

        return scrollGrid

    end

    --移除装备强化动画Layer
    local function removeLvUpLayer( ... )
        if equipLvUpLayer then
            CCBCenter.popLastLevelCCBNode()
        end
    end

    --暴击动画
    local function lvUpCritAnim( crit )

        if _equipProcessing == 1 then
            if crit == 1 then
                NetHelper.QuickToast(_s("EQUIPMENT_LVUP_SUCCESS"),true,1)
            else
                NetHelper.QuickToast(_s("EQUIPMENT_LUUP_CRIT")..crit,true,3)
            end

            if crit > 1 then
                display.addSpriteFramesWithFile("equipment/blacksmith/equip_lv_up_crit.plist","equipment/blacksmith/equip_lv_up_crit.png")

                --暴击背景
                local sprit_1 = display.newSprite("#bg_equip_lv_up_crit.png")
                sprit_1:setScale(2)
                util.alignNodeWithPadding(sprit_1, equipLvUpLayer:getContentSize(), display.CENTER)
                equipLvUpLayer:addChild(sprit_1)

                transition.scaleTo(sprit_1, {time = 1.0, scale = 1.0})

                util.delayCall(function ( )
                    --强化背景
                    local sprit_multi = display.newSprite("#equip_lv_up_crit_multi.png")
                    sprit_multi:setScale(2)
                    util.alignNodeWithPadding(sprit_multi, equipLvUpLayer:getContentSize(), display.CENTER,{left = -35})
                    equipLvUpLayer:addChild(sprit_multi)

                    transition.scaleTo(sprit_multi, {time = 1.0, scale = 1.0})

                    --强化数值
                    local sprit_2 = display.newSprite(string.format("#equip_lv_up_crit_%d.png",crit))
                    sprit_2:setScale(2)
                    util.alignNodeWithPadding(sprit_2, equipLvUpLayer:getContentSize(), display.CENTER,{left = 35})
                    equipLvUpLayer:addChild(sprit_2)

                    transition.scaleTo(sprit_2, {time = 1.5, scale = 1.0})
                end, 0.2)
            end
        elseif _equipProcessing == 2 then
            if crit == 1 then
                NetHelper.QuickToast(_s("EQUIPMENT_SETUP_SUCCESS"),true,1)
            else
                NetHelper.QuickToast(_s("EQUIPMENT_SETUP_FAILURE"),true,1)
            end
        elseif _equipProcessing == 3 then
            if crit == 1 then
                NetHelper.QuickToast(_s("EQUIPMENT_SUPPLEMENT_SUCCESS"),true,1)
            else
                if equipEntity:getAdd() ~= 0 then
                    NetHelper.QuickToast(_s("EQUIPMENT_SUPPLEMENT_FAILURE"),true,1)
                else
                     NetHelper.QuickToast(_s("EQUIPMENT_SUPPLEMENT_FAILURE_02"),true,1)
                end
            end
        end

        util.delayCall(function ( )
            removeLvUpLayer()    
        end, 0.8)

        
        --CCBCenter.pushLastLevelCCBNode(lvUpCritLayer)
    end

    --装备强化动画
    local function equipLvUpAnim(  )
  
        if _equipProcessing == 3 and isHighLevelStone == 1 and equipEntity:getAdd() >= GAMERATE:getEquipAddLevelLimit() then
            NetHelper.QuickToast(_s("EQUIPMENT_SUPPLEMENT_STONE",GAMERATE:getEquipAddLevelLimit()))
            return
        end

        --装备强化动画
        equipLvUpLayer = widget.newLayer{contentSize = CCSize(960,640)}

        display.addSpriteFramesWithFile("equipment/blacksmith/equip_lv_up.plist","equipment/blacksmith/equip_lv_up.png")

        --石台
        local sprit_1 = display.newSprite("#equipment_lv_up_5.png")
        util.alignNodeWithPadding(sprit_1, equipLvUpLayer:getContentSize(), display.CENTER)
        equipLvUpLayer:addChild(sprit_1)

        --锤子挥动
        local treasureChest = display.newSprite("#equipment_lv_up_1.png")
        local animation = anim.createAnimation(
          "equipment/blacksmith/equip_lv_up"
            , "equipment_lv_up_%d.png"
            , 1, 4, 0.6 / 6
            , {1, 4}, {3, 2})
        local action = transition.playAnimationForever(treasureChest,animation)

        CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHEQUIPMENTLVUPLIST, nil, {useg = isHighLevelStone, eqid = eqid, action = action, used = isUseDamond})

        util.alignNodeWithPadding(treasureChest, equipLvUpLayer:getContentSize(), display.CENTER, 
            {top = - sprit_1:getContentSize().height * 1.3,left = - 20 })
        equipLvUpLayer:addChild(treasureChest)
       
       --音效
        SOUND:playBlackSmith() 

        --强化进度条
        equipLvUpProgressBar = widget.newProgressBar{
            frontSprintParams = {file = "#equipment_lv_up_pb.png",},
            bgSprintParams = {file = "#equipment_lv_up_pb_bg.png"},
            ttfLabelParams = { size = 18, padding = { top = top } }
        }
        equipLvUpLayer:addChild(equipLvUpProgressBar)
        util.alignNodeWithPadding(equipLvUpProgressBar, equipLvUpLayer:getContentSize(), display.CENTER,
              {top =  65 })

        CCBCenter.pushLastLevelCCBNode(equipLvUpLayer)

    end

    --装备操作按钮
    local function createMainButtons()
        _equipBtns = {}
        local function createMainButton_( parentTag, filename, text, msgId, params )
            local button = EffectButton.new(filename, text
                , function ( button )
                    HelperView2.showNext()
                    local nowLayer,nextLayer 
                    if params.equipProcessing == 2 then
                        if not ME:getTriggerMsgEntity():isUnlockEquipEvo() then
                            NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.EQUIPEVO, _s("EQUIPMENT_STEPUPTITLE")))
                            return
                        end

                        if _equipProcessing == 1 or _equipProcessing == 3 then 
                            nowLayer = CCBCenter.getNodeByTag(_node, 3)
                        else
                            nowLayer = CCBCenter.getNodeByTag(_node, 8)
                            _nodeTable["btnDismantle"]:setEnabled(false)
                            _nodeTable["mDismantleEquIpLv"]:setString("")
                            _nodeTable["mDismantleEquIpEvo"]:setString("")
                            _nodeTable["mDismantleEquIpSetUp"]:setString("")
                            _nodeTable["mDismantleEquIpQuality"]:setString("")
                        end
                        --nowLayer = CCBCenter.getNodeByTag(_node, 3)
                        nextLayer = CCBCenter.getNodeByTag(_node, 6)
                        CCBCenter.getNodeByTag(_node, 6):setVisible(true)
                    elseif  params.equipProcessing == 1 or params.equipProcessing == 3 then
                        if params.equipProcessing == 1 then
                            if not ME:getTriggerMsgEntity():isUnlockEquip() then
                                NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.EQUIPENHANCED, _s("EQUIPMENT_LVUPTITLE")))
                                return
                            end
                        else
                            if not ME:getTriggerMsgEntity():isUnlockEquipAdd() then
                                NetHelper.QuickToast(_s("COMMON_UNOPEN", _unlockLevel.EQUIPADD, _s("EQUIPMENT_SUPPLEMENTTITLE")))
                                return
                            end
                        end

                        if _equipProcessing == 2 then 
                            nowLayer = CCBCenter.getNodeByTag(_node, 6)
                        elseif _equipProcessing == 4 then
                            nowLayer = CCBCenter.getNodeByTag(_node, 8)
                            _nodeTable["btnDismantle"]:setEnabled(false)
                            _nodeTable["mDismantleEquIpLv"]:setString("")
                            _nodeTable["mDismantleEquIpEvo"]:setString("")
                            _nodeTable["mDismantleEquIpSetUp"]:setString("")
                            _nodeTable["mDismantleEquIpQuality"]:setString("")
                        else
                            nowLayer = CCBCenter.getNodeByTag(_node, 3)
                        end
                        CCBCenter.getNodeByTag(_node, 3):setVisible(true)
                        nextLayer = CCBCenter.getNodeByTag(_node, 3)
                    elseif params.equipProcessing == 4 then
                        _nodeTable["mDismantleEqupLayer"]:removeAllChildrenWithCleanup(true)
                        if _equipProcessing == 1 or _equipProcessing == 3 then 
                            nowLayer = CCBCenter.getNodeByTag(_node, 3)
                        else
                            nowLayer = CCBCenter.getNodeByTag(_node, 6)
                        end
                        nextLayer = CCBCenter.getNodeByTag(_node, 8)
                        CCBCenter.getNodeByTag(_node, 8):setVisible(true)
                    end

                    eqid = nil
                    isHighLevelStone = 0

                    for i,v in ipairs(_equipBtns) do
                         util.enableCustomTouch(v,false)
                    end

                    transition.scaleTo(_equipBtns[params.equipProcessing], {scale = 1.2})
                    transition.scaleTo(_equipBtns[_equipProcessing], {scale = 1})

                    transition.execute(CCBCenter.getNodeByTag(_node, 2),
                        CCMoveTo:create(0.5, CCPoint(-350, CCBCenter.getNodeByTag(_node, 2):getPositionY())),
                        {easing = "BACKOUT", onComplete = function ()
                            util.delayCall(function ( )
                    
                                transition.execute(CCBCenter.getNodeByTag(_node, 2),
                                CCMoveTo:create(0.5, CCPoint(180, CCBCenter.getNodeByTag(_node, 2):getPositionY())),
                                {easing = "BOUNCEOUT", onComplete = function ()
                                   
                                end })

                            end, 0.2) 
                    end })

                    transition.execute(CCBCenter.getNodeByTag(_node, 4),
                        CCMoveTo:create(0.5, CCPoint(1300, CCBCenter.getNodeByTag(_node, 4):getPositionY())),
                        {easing = "BACKOUT", onComplete = function ()
                            --发送请求
                            CCBCenter.sendLuaMessage(msgId,nil,params)
                            util.delayCall(function ( )
                                if params.equipProcessing ~= 4 then
                                    transition.execute(CCBCenter.getNodeByTag(_node, 4),
                                    CCMoveTo:create(0.5, CCPoint(465, CCBCenter.getNodeByTag(_node, 4):getPositionY())),
                                    {easing = "BOUNCEOUT", onComplete = function ()

                                        for i,v in ipairs(_equipBtns) do

                                            if i ~= params.equipProcessing then

                                                util.enableCustomTouch(v,true)
                                            end
                                        end
                                    end })
                                else
                                    for i,v in ipairs(_equipBtns) do

                                        if i ~= params.equipProcessing then

                                            util.enableCustomTouch(v,true)
                                        end
                                    end
                                end

                            end, 0.2) 
                    end })

                    transition.execute(nowLayer,
                         CCMoveTo:create(0.5, CCPoint(1300, nowLayer:getPositionY())),
                        {easing = "BACKOUT", onComplete = function ()
                             util.delayCall(function ( )
                    
                                transition.execute(nextLayer,
                                CCMoveTo:create(0.5, CCPoint(656, nextLayer:getPositionY())),
                                {easing = "BOUNCEOUT", onComplete = function ()
                                end })

                            end, 0.2)
                    end })
                end, params)
    
            local parent = CCBCenter.getNodeByTag(_node, parentTag)
            parent:removeAllChildrenWithCleanup(true)
            parent:addChild(button)
            util.alignNode(button, parent)
            table.insert(_equipBtns, button)
            return button
        end

         -- 强化
        local btnEquipLvUp = createMainButton_(
                101, "btn_equipment_lvup", _s("EQUIPMENT_LVUPTITLE")
                ,  MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST , { equipProcessing = 1 }
            )
         --进阶
        local btnEquipStepUp = createMainButton_(
                103, "btn_equipment_stepup", _s("EQUIPMENT_STEPUPTITLE")
                ,  MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST , { equipProcessing = 2 }
            )
         -- 追加
        local btnEquipSupplement = createMainButton_(
                102, "btn_equipment_supplement", _s("EQUIPMENT_SUPPLEMENTTITLE")
                ,  MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST , { equipProcessing = 3 }
            )
         -- 追加
        local btnEquipSupplement = createMainButton_(
                105, "btn_equipment_dismantle", _s("EQUIP_DISMANTLE")
                ,  MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST , { equipProcessing = 4 }
            )
    end

    local function onUseDamond( msg, luaValue )
        local successPercent 
        if isUseDamond == 1 then
            successPercent = EquipevoDB.getByID(equipEntity:getEvolv() + 1).showgl
            _node:setButtonTitle( "btnChoose", _s("EQUIPMENT_CHOOSE"))
        else
            successPercent = EquipevoDB.getByID(equipEntity:getEvolv() + 1).showgl + GAMERATE:getEquipEvoGemRate()
            _node:setButtonTitle( "btnChoose", _s("COMMON_CANCEL"))
        end
        _successRateProgressBar:runProgressTo(0.5,tonumber(successPercent))
        isUseDamond = 1 - isUseDamond
    end 
    --设置可拆解的装备列表
    local function setEquipProcessing( equipProcessing )
        _equipProcessing = equipProcessing   
        _nodeTable.mEquipmentHelpLabel:setString(_s("EQUIPMENT_DISMANTLE_HELP")) 

        _nodeTable["btnDismantle"]:setEnabled(false)
        _nodeTable["mDismantleEquIpLv"]:setString("")
        _nodeTable["mDismantleEquIpEvo"]:setString("")
        _nodeTable["mDismantleEquIpSetUp"]:setString("")
        _nodeTable["mDismantleEquIpQuality"]:setString("")
        _nodeTable["mDismantleEqupLayer"]:removeAllChildrenWithCleanup(true)
    end 

--[[ ## local fuction --]]
    local function checkHelperInfo( )
        local msgEntity = ME:getTriggerMsgEntity()
        if msgEntity:isShowEquipEnhancedHelper() then
            HelperView2.setCurIndex(140030)
        elseif msgEntity:isShowEquipEvoHelper() then
            HelperView2.setCurIndex(160030)
        elseif msgEntity:isShowEquipAddHelper() then  
            HelperView2.setCurIndex(170030)
        end
        return HelperView2.showBetween(_node, nil, {140030, 140070}, {160030, 160080}, {170030, 170080}) ~= nil
    end
	local function initViews()

        CCBCenter.getNodeByTag(_node, 308):removeAllChildrenWithCleanup(true)
        CCBCenter.getNodeByTag(_node, 313):removeAllChildrenWithCleanup(true)
        CCBCenter.getNodeByTag(_node, 614):removeAllChildrenWithCleanup(true)
        CCBCenter.getNodeByTag(_node, 616):removeAllChildrenWithCleanup(true)
        CCBCenter.getNodeByTag(_node, 202):removeAllChildrenWithCleanup(true)

        createSuccessRate()

        if _equipProcessing == 1 or _equipProcessing == 3 then

            CCBCenter.getNodeByTag(_node, 3):setVisible(true)
            CCBCenter.getNodeByTag(_node, 6):setVisible(false)
            CCBCenter.getNodeByTag(_node, 8):setVisible(false)

            transition.execute( CCBCenter.getNodeByTag(_node, 6),
                CCMoveTo:create(0.1, CCPoint(1300,  CCBCenter.getNodeByTag(_node, 6):getPositionY())),
                {easing = "BACKOUT", onComplete = function ()
            end })

            transition.execute( CCBCenter.getNodeByTag(_node, 8),
                CCMoveTo:create(0.1, CCPoint(1300,  CCBCenter.getNodeByTag(_node, 8):getPositionY())),
                {easing = "BACKOUT", onComplete = function ()
            end })

            --材料消耗node
            _mMaterialNode = CCBCenter.getNodeByTag(_node, 308)
             --装备强化node
            _mEquipLvUpDetail =  CCBCenter.getNodeByTag(_node, 313)
            --装备数值Node
            _mEquipLvUpNode = CCBCenter.getNodeByTag(_node, 312)
    		
        elseif _equipProcessing == 2 then

            CCBCenter.getNodeByTag(_node, 3):setVisible(false)
            CCBCenter.getNodeByTag(_node, 6):setVisible(true)
            CCBCenter.getNodeByTag(_node, 8):setVisible(false)

            transition.execute( CCBCenter.getNodeByTag(_node, 3),
                CCMoveTo:create(0.1, CCPoint(1300,  CCBCenter.getNodeByTag(_node, 3):getPositionY())),
                {easing = "BACKOUT", onComplete = function ()
            end })
            transition.execute( CCBCenter.getNodeByTag(_node, 8),
                CCMoveTo:create(0.1, CCPoint(1300,  CCBCenter.getNodeByTag(_node, 8):getPositionY())),
                {easing = "BACKOUT", onComplete = function ()
            end })

             --材料消耗node
            _mMaterialNode = CCBCenter.getNodeByTag(_node, 616)
             --装备强化node
            _mEquipLvUpDetail =  CCBCenter.getNodeByTag(_node, 614)
            --装备数值Node
            _mEquipLvUpNode =  CCBCenter.getNodeByTag(_node, 610)

        end

        --isHighLevelStone = 0

        --装备列表node 
        _nodeEquipmentList = CCBCenter.getNodeByTag(_node, 202)

        --加载装备列表
        _equipmentListGrid = createEquipmentListGrid()
        --加载材料列表
        _mMaterialGrid = createMaterialGrid()   
        --加载装备强化数值
        _mEquipLvUpDetailGrid = createEquipLvUpDetailGrid()

         if _equipBtns then 
            for _, button in ipairs(_equipBtns) do
                button:refresh()
            end
        end
    
        --reloadMaterialGrid()
	end

    --设置玩家身上的宝石鼠
    local function setStone( stone1, stone2, equipProcessing )
        _equipProcessing = equipProcessing
        util.enableCustomTouch(_equipBtns[_equipProcessing],false)
        transition.scaleTo(_equipBtns[_equipProcessing], {scale = 1.2})

        initViews()

        if _equipProcessing == 1 then
            _node:setButtonTitle( "btnEquipmentLVUP", _s("EQUIPMENT_LVUPTITLE"))
            _nodeTable.mEquipmentHelpLabel:setString(_s("EQUIPMENT_LV_HELP"))
        elseif _equipProcessing == 2 then
            _node:setButtonTitle( "btnEquipmentLVUP", _s("EQUIPMENT_STEPUPTITLE"))
            isUseDamond = 0
            _node:setButtonTitle( "btnChoose", _s("EQUIPMENT_CHOOSE"))
            _nodeTable.mEquipmentHelpLabel:setString(_s("EQUIPMENT_EVO_HELP"))
        elseif _equipProcessing == 3 then
            _node:setButtonTitle( "btnEquipmentLVUP", _s("EQUIPMENT_SUPPLEMENTTITLE"))
            _nodeTable.mEquipmentHelpLabel:setString(_s("EQUIPMENT_ADD_HELP"))
        end
        userStone1 = stone1
        userStone2 = stone2
        _nodeTable.mUserGoldLabel:setString(ME:getGold())
        _nodeTable.mUserDamondLabel:setString(ME:getDiamond())
    end

    local function setValue(properties ,equipProcessing ,action)
        --强化进度
        local percent = equipLvUpProgressBar:getPercentage()

        if percent < 100 then
            --数据返回时,动画没播完，等待播完后设值
            equipLvUpProgressBar:runProgressFromTo(1, 0, 100, function ( progressBar,percentage )
                --进度条结束事件
                transition.removeAction(action)
                setStone(properties.stone1, properties.stone2, equipProcessing )
                reloadEquipmentListGrid(properties.equips)
                lvUpCritAnim( properties.crit )
            end)
        else    
            --动画已播完，直接设值
            lvUpCritAnim( properties.crit )
            setStone(properties.stone1, properties.stone2, equipProcessing )
            reloadEquipmentListGrid(properties.equips)

        end 
    end
    --获取装备关系id
    local function getEqid( ... )
        return _eqid
    end
    --获取装备品质
    local function getQuality( ... )
        return _quality
    end
    --装备拆解动画
    local function equipDismantleAnim( properties )

        local function onAnimComplete( ... )
            local rewardEntity = require("model.main.RewardEntity").new(properties.reward)
            CCBCenter.loadCCB(
                "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
                "ccb.c.main.ReceiveRewardAlertLayer", 
                {
                    title = _s("EQUIPMENT_GET"),
                    entity = rewardEntity,
                    onConfirm = function( )
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLVLAYER_ACTION_ONFETCHGETEQUIPMENTLVLIST,nil, { equipProcessing = 4 })
                    end
                }
            )
            _nodeTable["mDismantleEquipLabel"]:setString("")
            setEquipProcessing(4)
        end

        display.addSpriteFramesWithFile("equipment/blacksmith/img_equip_dismantle.plist","equipment/blacksmith/img_equip_dismantle.png")
        local equipDismantle = display.newSprite("#img_equip_dismantle_1.png")
        local animation = anim.createAnimation(
          "equipment/blacksmith/img_equip_dismantle"
            , "img_equip_dismantle_%d.png"
            , 1, 11, 1.1 / 11
            , {1, 11})
        transition.playAnimationOnce(equipDismantle,animation,true,onAnimComplete)
        util.alignNode(equipDismantle,_nodeTable["mDismantleEqupLayer"])
        _nodeTable["mDismantleEqupLayer"]:addChild(equipDismantle,10002)
    end

    local function getIsUseDamond( ... )
        return isUseDamond
    end

    local function getNeedDiamond( ... )
        return _needDiamond
    end

--[[ ## public fuction --]]

  _node.equipLvUpAnim = equipLvUpAnim
  _node.reloadEquipmentListGrid = reloadEquipmentListGrid 
  _node.reloadEquipLvUpDetail = reloadEquipLvUpDetail
  _node.setStone = setStone
  _node.lvUpCritAnim = lvUpCritAnim
  _node.removeLvUpLayer = removeLvUpLayer
  _node.setValue = setValue
  _node.onUseDamond = onUseDamond
  --设置装备操作类型
  _node.setEquipProcessing = setEquipProcessing
  --获取装备关系id
  _node.getEqid = getEqid
  --获取装备品质
  _node.getQuality = getQuality
  --装备拆解动画
  _node.equipDismantleAnim = equipDismantleAnim
  --获取提升成功率需要的钻石
  _node.getNeedDiamond = getNeedDiamond
    --是否使用钻石
  _node.getIsUseDamond = getIsUseDamond
--[[ ## MAINs --]]
    createMainButtons()
	initViews()
    checkHelperInfo( )
end

return M