--EquipmentLayer.lua

local GoodsMaster = require("cardui.GoodsMaster")
local GoodsEntity = require("model.goods.GoodsEntity")
local PlayerEquipEffectEntity = require("model.player.PlayerEquipEffectEntity")
local MessageModel = require("ccb.m.message.MessageModel")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[EquipmentLayerView]"
	local _node, _nodeTable = node, luaValue

	--装备界面
	local EQU = 1
	--属性界面
	local ATT = 2 
	--穿上装备 
	local GETON = 1 
	--脱下装备 
	local GETDOWN = 0

	local equAtt =EQU

	--属性界面详细
	local _nodeAttributeDetail
	--装备界面
	local _nodeEquipment
	--属性界面简易
	local _nodeAttribute
	--角色Layer
	local _player
	--玩家所传装备Node
	local _nodeUserEquipment
	--装备列表
	local _equipmentListGrid
	--装备列表node
	local _nodeEquipmentList
	--装备详细layer
	local _equipmentDetailLayer 
	--装备技能
	local _nodeEquipSkill
	--装备技能列表
	local _equipSkillGrid
	--是否是两个框
	local is2Detail
	--装备操作按钮
	local _equipBtns = {}
	--装备附加属性node
	local _nodeEquipAtt
	--装备附加属性
	local _equipAttGrid
	--玩家所传装备
	local _userEquipGrid

	--用户装备背景
	local userEquipmentBgTable = {}
	--用户身上装备Entity Table
	local userEquipmentEntityTable = {}
	--用户所有装备Entity Table
	local equipmentEntityTable = {}
    local checkHelperInfo
	local function createHero()
        -- 英雄形象
        local heroLayer = CCBCenter.getNodeByTag(_node, 307)
       -- heroLayer:removeAllChildrenWithCleanup(true)
        -- 创建角色
        _player = ME:createPlayerView{randomAction = true}
        util.alignNodeWithPadding(_player, heroLayer:getContentSize(), display.CENTER, { top = -35 })
        heroLayer:addChild(_player)
    end

    --刷新英雄形象
    local function reloadHero( ... )
    	_player:dressEquipments(ME:getEquiplst())
    end
    --加载装备列表数据
	local function reloadEquipmentListGrid( value )
        checkHelperInfo()
		equipmentEntityTable = {}

		for i,v in ipairs(value) do
			--装备实体
			local entity = GoodsEntity.new(v)
			entity.type = GoodsMaster.BAGEQUIP
            entity.showDetail = true
            entity.showFrame = true
            entity.disenableTouch = true
            entity.shareButton = true
            --装备穿上点击事件
            entity.onConfirm = function (  )

				CCBCenter.popLastLevelCCBNode()
				CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHUSEEQUIPMENT, nil, {act = GETON, eqid = v.eqid})
			end
			--装备出售点击事件
			entity.onSellClick = function ( )
				AlertLayer.new{
			        titleStr    = _s("COMMON_NEWS_TIPS"),           -- 标题
			        content     = _s("EQUIPMENT_SELL"), -- 内容
			        btnStr      = { _s("COMMON_OK"), _s("COMMON_CANCEL") },          -- 按钮文字数组
			        btnColor    = { AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_YELLOW  },
			        -- 按钮颜色数组
			        btnClickEvent = {                   -- 按钮事件数组
			            function()                      -- 按钮[确定]回调
		                	CCBCenter.popLastLevelCCBNode()
							CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHSELLEQUIPMENT, nil, {eqid =v.eqid})
			            end,
			            function()                      -- 按钮[取消]回调
			                -- print("按钮[取消]回调")
			            end,
			        }, 
			      }
			end

			table.insert(equipmentEntityTable,entity)
		end
		_equipmentListGrid:setItems(value,true,true)
		_equipmentListGrid:highLight(1)
	end

	--加载技能数据
	local function reloadEquipSkillGrid(  )
		local skillTable = {}
		for i,v in ipairs(ME:getEquipSkill()) do
			local str = v.name_ .. "LV" .. v.level_ .. ":" ..v.info_

			table.insert(skillTable,str)
		end
		_equipSkillGrid:setItems(skillTable)
	end

	--创建装备列表
	local function createEquipmentListGrid( ... )
		
		local function createItemCellListener( grid, index, item )
			local gridCell = widget.newLayer{ contentSize = grid:getCellSize() }
            gridCell.VIEWS_ = {}

             -- 背景
         	local bg = display.newSprite("equipment/bg_equipment_3.png")
            gridCell:addChild(bg, 0)
            gridCell.VIEWS_.bg = bg
            util.alignNode(bg, gridCell:getContentSize(), display.CENTER)
            gridCell:ignoreAnchorPointForPosition(false)
          	if item.no then
          		--装备实体
        		local entity = GoodsEntity.new(item)
				entity.type = GoodsMaster.BAGEQUIP
				entity.showFrame = true
				entity.disenableTouch = true
                entity.shareButton = true
				local equipment = GoodsMaster.new(entity)
				equipment:setPosition(8,15)
				equipment:setTag(1)
				gridCell:addChild(equipment)

			 	if grid.getPageGrid():isHighLight(item) then 
	                local light = widget.newSprite{file = "goods/bg_goods_select.png"}
	                util.alignNode(light, gridCell:getContentSize(), display.CENTER)
	                gridCell:addChild(light, -1)
	                gridCell.VIEWS_.light = light
                end
          	end
          	
            return gridCell
		end
		local function modifyItemCellListener( grid, index, item, itemCell )
		 	local isHighLight = grid.getPageGrid():isHighLight(item)
            if not isHighLight and itemCell.VIEWS_.light then 
                -- 都叫你不要亮了还亮个P,给我灭掉!!!
                itemCell.VIEWS_.light:removeSelf()
                itemCell.VIEWS_.light = nil
            elseif isHighLight and not itemCell.VIEWS_.light then 
                -- 要你亮时你又在这卖萌,找屎
                local light = widget.newSprite{file = "goods/bg_goods_select.png"}
                util.alignNode(light, itemCell:getContentSize(), display.CENTER)
                itemCell:addChild(light, -1)
                itemCell.VIEWS_.light = light
            end
		end
		local function tapListener( grid, index, item )

			local cell = grid:cellAt(index)
			local array     = {}
            array[#array + 1] = CCScaleTo:create(0.2, 1.1)
            array[#array + 1] = CCScaleTo:create(0.2, 1)
            transition.execute(cell, transition.sequence(array), {easing = "CCEaseBackInOut", onComplete = function ()
                -- playArrowShakeAnim( _node, isReverse )
            end })

            local pageIndex = _equipmentListGrid:getScrollLayer().getCurPageIndex()
            item.index = (pageIndex - 1)  * 18 + index
            grid.getPageGrid():highLight(_equipmentListGrid:getScrollLayer().getCurPageIndex(), index)

            HelperView2.showNext()
			-- body
			
			local equipment = cell:getChildByTag(1)

			local userEquip = userEquipmentEntityTable[item.part]

			if userEquip ~= item.part then
				--装备详情
				local detailLayer = widget.newLayer{ 
					contentSize = CCSize(960,640)
				}
				--点击取消的区域
				widget.bindTouchEvent{
					layer = detailLayer,
					priority = 10000,
					clickListener = function (  )
                        CCBCenter.popLastLevelCCBNode()
					end,
				}

				CCBCenter.pushLastLevelCCBNode(detailLayer)

				detailLayer.closeLayer = function ( ... )
					CCBCenter.popLastLevelCCBNode()
				end

				--去当前Entity所在index

				local currentIndex = (_equipmentListGrid:getScrollLayer().getCurPageIndex() - 1 ) * 12 + index 

				if currentIndex <= #equipmentEntityTable then
					--装备详细界面
					CCBCenter.loadCCB("MSG_EQUIPUSEALERTLAYER_MODEL", "ccb.c.goods.EquipUseAlertLayer",equipmentEntityTable[currentIndex], --  equipment:getParams()
						function ( _ccbNode )
							if userEquip ~=nil and userEquip ~= item.part then
								util.alignNodeWithPadding(_ccbNode, detailLayer:getContentSize(), display.CENTER_RIGHT, {right =  230})
							else
								util.alignNodeWithPadding(_ccbNode, detailLayer:getContentSize(), display.CENTER)
							end
							detailLayer:addChild(_ccbNode,20001)	
					end)	

					if userEquip ~= nil and userEquip ~= item.part then

						--身上所穿装备界面
						CCBCenter.loadCCB("MSG_EQUIPOFFALERTLAYER_MODEL", "ccb.c.goods.EquipOffAlertLayer", userEquip , 
						function ( _ccbNode )

							util.alignNodeWithPadding(_ccbNode, detailLayer:getContentSize(), display.CENTER_LEFT,{left = 230})
							detailLayer:addChild(_ccbNode,20001)	
						end)
					end 
				end
			else
				--展示装备详细
			if equipment then
					equipment:showDetail()
				end	
			end
		end
		local pageGrid = widget.newPageGrid{
            pageParams = {
                rect = CCRect(0, 0, _nodeEquipmentList:getContentSize().width, _nodeEquipmentList:getContentSize().height),
                totalPages = 1,
                contentSize = _nodeEquipmentList:getContentSize(),
                ignoreAnchor = true,
                indicatorParams = {
                    normal = "goods/goods_Indicator.png",
                    selected = "goods/goods_Indicator_selected.png",
                    height = 30,
                    padding = 10,
                },
            },
            gridParams = {
                disableAutoCalcContentSize = true,
                row = 3, 
                column = 4, 
                createItemCellListener = createItemCellListener,
                modifyItemCellListener = modifyItemCellListener,
                tapListener = tapListener,
            },
        }

        _nodeEquipmentList:addChild(pageGrid)
        return pageGrid
	end

	--玩家身上所穿装备
	local function reloadUserEquipmentGrid( value )

		local userEquipmentTable = {{},{},{},{},{},{},}
		userEquipmentEntityTable = {{},{},{},{},{},{},}

		for i,v in ipairs(value) do

			if v.part <7 then 
				userEquipmentTable[v.part] = v
			else
				local bg = CCBCenter.getNodeByTag(_node,30605)
				bg:removeAllChildrenWithCleanup(true)
				local scoopLayer = widget.newLayer{ contentSize = CCSize(41,41)}
				util.alignNode(scoopLayer, bg:getContentSize(), display.CENTER)
				bg:addChild(scoopLayer)

				local scoopImg = display.newSprite(string.format("minEquip/miniScoop/img_minScoop_%d.png",v.no))
				util.alignNode(scoopImg, bg:getContentSize(), display.CENTER)
				bg:addChild(scoopImg)

				local entity = GoodsEntity.new(v)
				entity.type = GoodsMaster.CUREQUIP
                entity.shareButton = true
				entity.buttonEnable = false					
				userEquipmentEntityTable[v.part] = entity
				--点击取消的区域
				widget.bindTouchEvent{
					layer = scoopLayer,
					priority = 10000,
					clickListener = function (  )
						CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", entity)	
					end,
				}
			end
		end

		_userEquipGrid:setItems(userEquipmentTable)

		--加载装备技能数据
		reloadEquipSkillGrid()
	end

	--用户所穿装备列表
	local function createUserEquipmentGrid(  )

		--部位名称
		local bone = {_s("EQUIPMENT_HEAD"),_s("EQUIPMENT_BODY"),_s("EQUIPMENT_HAND"),
			_s("EQUIPMENT_SHOES"),_s("EQUIPMENT_WEAPON"),_s("EQUIPMENT_SHIELD")}

		local function createItemCellListener(grid, index, item)
            local cell = widget.newLayer{contentSize = CCSize(_nodeEquipment:getContentSize().width / 2,_nodeEquipment:getContentSize().height / 3)}

			local equipmentBg = display.newSprite("equipment/bg_equipment_3.png")
			if index % 2 == 0 then
				util.alignNode(equipmentBg, cell:getContentSize(), display.CENTER_RIGHT,{left = 5})
			else 
				util.alignNode(equipmentBg, cell:getContentSize(), display.CENTER_LEFT,{right = 5})
			end
			cell:addChild(equipmentBg,-1)

			if item.part then

				local entity = GoodsEntity.new(item)
				entity.type = GoodsMaster.CUREQUIP
	            entity.showDetail = true
	            entity.showFrame = true
	            entity.shareButton = true
	            --脱下点击事件
	            entity.onConfirm = function (  )
	            	if is2Detail then
	            		is2Detail = false
	            		CCBCenter.popLastLevelCCBNode()
	            	else
	            		is2Detail = true
	            	end
	            	userEquipmentEntityTable[item.part] = item.part
	            	--装备脱下
					CCBCenter.sendLuaMessage(MSG_ID.MSG_EQUIPMENTLAYER_ACTION_ONFETCHUSEEQUIPMENT, nil, {act = GETDOWN, eqid = item.eqid})
				end
				userEquipmentEntityTable[item.part] = entity
				local equipment = GoodsMaster.new(entity)
	            equipment.shareButton = true
				equipment:setPosition(2,2)
				equipmentBg:addChild(equipment,10001)
			else
				--部位名称
				local lblCalender = ui.newTTFLabel{				  
		              size = TALK_TABLE_TEXT_SIZE,
		              text = bone[index],
		              color =COLOR3.GREE
		  		}
		  		util.alignNode(lblCalender, equipmentBg:getContentSize(), display.CENTER)
	        	equipmentBg:addChild(lblCalender,10000)
	        	userEquipmentEntityTable[index] = nil
			end

            return cell
        end

        --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _nodeEquipment:getContentSize(),
            cellSize = CCSize( _nodeEquipment:getContentSize().width / 2, _nodeEquipment:getContentSize().height / 3),
            column = 2,
            row = 3,
            createItemCellListener = createItemCellListener,
            direction = widget.TABLEVIEW_DIRECTION_BOTH,
        }
        _nodeEquipment:addChild(scrollGrid)

        return scrollGrid

	end
	local function getMessageSize ( msg,width )
		-- body
		local width,height = MessageModel.getMessageSize(
														msg,
														nil,
														18,
														1.5,
														width)
		
		return CCSize(_nodeEquipSkill:getContentSize().width,height+10),CCSize(width,height)
	end
	--装备技能列表
	local function createEquipSkillGrid( ... )

		--scrollview
	    local function createItemCellListener( grid, index, item )
	        local gridCell = widget.newLayer{contentSize = CCSize(385,20)}
       		-- 装备技能
	        local contentSize,textSize = getMessageSize(item,_nodeEquipSkill:getContentSize().width)

			local equipSkill = ui.newTTFLabel{
                size = 18,
                text = item,
                dimensions = textSize
			}

          	gridCell:addChild(equipSkill)

          	gridCell:setContentSize(CCSize(_nodeEquipSkill:getContentSize().width,textSize.height ))
       	  
          	return gridCell
	    end

	    --scrollview
	    local scrollGrid = widget.newScrollLinear{
	        x = 0,
	        y = 0,
	        contentSize = _nodeEquipSkill:getContentSize(),
		    cellAtIndexListener = createItemCellListener,
	        contentParams = {
					            column = 1,
					            tapListener = tapListener,
					            selectedParams = nil,
					        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	    }
	    _nodeEquipSkill:addChild(scrollGrid)

	    return scrollGrid
	end

	--刷新属性
	local function reloadAtt( ... )

        --血量
        _nodeTable.mHPLabel:setString(ME:getTotalHp())
        _nodeTable.mHPAttLabel:setString(ME:getTotalHp())

        --攻击
        _nodeTable.mATKLabel:setString(ME:getTotalatk())
        _nodeTable.mATKAttLabel:setString(ME:getTotalatk())

        local equipEffectEntity = ME:getPlayerEquipEffectEntity()

        local attTable = {{title = _s("CARD_RACE_ALLIANCE"), atk = equipEffectEntity:getAllianceAttack(), hp = equipEffectEntity:getAllianceHp()},
	        {title = _s("CARD_RACE_TRIBE"), atk = equipEffectEntity:getTribeAttack(), hp = equipEffectEntity:getTribeHp()},
	        {title = _s("CARD_RACE_UNDEAD"), atk = equipEffectEntity:getUndeadAttack(), hp = equipEffectEntity:getUndeadHp()},
	        {title = _s("EQUIP_ALLRACE"), atk = equipEffectEntity:getAllRaceAtk(), hp = equipEffectEntity:getAllRaceHp()},
	        {title = _s("FRIEND_MAIN_CARD"), atk = equipEffectEntity:getMainAtk(), hp = equipEffectEntity:getMainHp()}
    	}

    	_equipAttGrid:setItems(attTable)

		--玩家生命条
		local _hpProgressBar = widget.newProgressBar{
            frontSprintParams = {file = "cardgroup/progressBar_red_img.png",},
            bgSprintParams = {file = "map/progressBar_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, padding = {top = 18}},
            percentage = 100,
        }
        _hpProgressBar:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 30820):removeAllChildrenWithCleanup(true)
        CCBCenter.getNodeByTag(_node, 30820):addChild(_hpProgressBar)

        --玩家生命值
        local talentHp = ME:getPlayerTalentsEntity():getHeroHp()
        local equipEffectHp = ME:getPlayerEquipEffectEntity():getHeroHp()
        local finalHp = tonumber(talentHp) + equipEffectHp
        local addHp = ""
        if finalHp > 0 then
            addHp = " + " .. finalHp
        end
        _hpProgressBar:setString(ME:getHp() .. addHp)
	end

	--装备附加属性列表
	local function createEquipAttGrid( ... )

        local function createItemCellListener(grid, index, item)

            local cell = widget.newLayer{contentSize = CCSize(390,_nodeEquipAtt:getContentSize().height / 4)}

            local atk = _s("EQUIPMENT_ATTRIBUTE_ATK",item.atk)

            -- 附加攻击
            local atkTTF = ui.newTTFLabel{           
                size = 18,
                text = item.title..atk
            }
            util.alignNodeWithPadding(atkTTF, cell:getContentSize(),display.CENTER_LEFT)
            cell:addChild(atkTTF)

            local hp = _s("EQUIPMENT_ATTRIBUTE_HP",item.hp)

            -- 附加血量
            local hpTTF = ui.newTTFLabel{           
                size = 18,
                text = hp
            }
            hpTTF:setAnchorPoint(ccp(0, 0.5))
            hpTTF:setPosition(cell:getPositionX() + cell:getContentSize().width / 2,cell:getPositionY() + cell:getContentSize().height / 2)
            cell:addChild(hpTTF)

            return cell
        end

         --scrollview
        local scrollGrid = widget.newGrid{
            contentSize = _nodeEquipAtt:getContentSize(),
            cellSize = CCSize( _nodeEquipAtt:getContentSize().width, _nodeEquipAtt:getContentSize().height / 5),
            column = 1,
            createItemCellListener = createItemCellListener,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        _nodeEquipAtt:addChild(scrollGrid)

        return scrollGrid
	end

--[[ ## local fuction --]]
    -- 新手引导
    function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {120020, 120040}, {120060, 120080}, {150030, 150050})
    end
	local function initViews()
		
		--属性界面详细
		_nodeAttributeDetail = CCBCenter.getNodeByTag(_node, 308)
		--装备界面
		_nodeEquipment = CCBCenter.getNodeByTag(_node,307)
		--属性界面简易
		_nodeAttribute = CCBCenter.getNodeByTag(_node,306)

		_nodeEquipmentList = CCBCenter.getNodeByTag(_node,402)

		--装备详细Layer
		_equipmentDetailLayer = CCBCenter.getNodeByTag(_node, 6)

		--装备技能
		_nodeEquipSkill = CCBCenter.getNodeByTag(_node, 30818)

		--装备附加属性node
		_nodeEquipAtt = CCBCenter.getNodeByTag(_node, 30822)

		--其他不知道啥玩意
		-- _nodeElse =  CCBCenter.getNodeByTag(_node,30604)

		--显示装备界面
		_nodeAttributeDetail:setVisible(false)
		_nodeEquipment:setVisible(true)
		_nodeAttribute:setVisible(true)

		--装备列表
		_equipmentListGrid = createEquipmentListGrid()
		--技能列表
		_equipSkillGrid = createEquipSkillGrid()
		--玩家所穿装备
		_userEquipGrid = createUserEquipmentGrid()
		--装备附加属性
		_equipAttGrid = createEquipAttGrid()

		-- 名字
        _nodeTable.mNameLabel:setString(ME:getName())
         -- 等级
        _nodeTable.mLevelLabel:setString(ME:getLv())

        createHero()

        is2Detail = false


	end
	--属性界面和装备界面切换
	local function onEquAttChange()
		if equAtt == EQU then
			--显示装备界面
			equAtt = ATT
			_nodeAttributeDetail:setVisible(true)
			_nodeEquipment:setVisible(false)
			_nodeAttribute:setVisible(false)
			_node:setButtonTitle( "btnEquAtt", _s("EQUIPMENT_TITLE"))
		elseif equAtt == ATT then
			--显示属性界面
			equAtt = EQU
			_nodeAttributeDetail:setVisible(false)
			_nodeEquipment:setVisible(true)
			_nodeAttribute:setVisible(true)
			_node:setButtonTitle( "btnEquAtt", _s("EQUIPMENT_ATTRIBUTE"))
		end
	end

--[[ ## public fuction --]]
	_node.onEquAttChange = onEquAttChange
	_node.reloadHero = reloadHero
	_node.reloadEquipmentListGrid = reloadEquipmentListGrid
	_node.reloadUserEquipmentGrid = reloadUserEquipmentGrid
	_node.reloadAtt = reloadAtt
--[[ ## MAINs --]]

	initViews()
end

return M