--FaqLayer.lua

local MessageModel = require("ccb.m.message.MessageModel")
require("db.faqdb")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[FaqLayerView]"
	local _node, _nodeTable = node, luaValue
	
	--问题类别node
	local _mFaqTypeNode
	--问题node
	local _mFaqNode
	--问题类别Grid
	local _mFaqTypeGrid
	--问题Grid
	local _mFaqGrid

	local _selectedIndex = 1

	--刷新问题类别数据
	local function reloadFaqTypeGrid( ... )
		local faqTypeList = FaqDB.getFaqType( )
		_mFaqTypeGrid:setItems(faqTypeList)
	end

	--刷新问题类别数据
	local function reloadFaqGrid( ... )
		local faqList = FaqDB.getFaqContent(1)
		_mFaqGrid:setItems(faqList)
	end

	local function getMessageSize ( msg,width )
		-- body
		local width,height = MessageModel.getMessageSize(
														msg,
														nil,
														20,
														1.5,
														width)
		
		return CCSize(width,height)
	end

	--问题类别Grid
	local function createFaqTypeGrid( ... )

		local function createItemCellListener(grid, index, item)
			--183.83
	        local cell = widget.newLayer{contentSize = CCSize(183,83)}

	        local filePath = "faq/btn_faq_nomal.png"

	        if index == _selectedIndex then
	        	filePath = "faq/btn_faq_selected.png"
	        end

	        local selectImg = widget.newScale9{ file = filePath, 
                    contentSize = cell:getContentSize() }
            util.alignNodeWithPadding(selectImg, cell)
            cell:addChild(selectImg)

            -- 装备技能
	        local textSize = getMessageSize(item.name,160)
            --问题类型
            local faqTypeLabel = ui.newTTFLabel{			  
	                size = 20,
	                text = item.name,
	                color = BUTTON_COLOR3.BROWN,
	                dimensions =  CCSize(textSize.width + 12,70)
				}
			--faqTypeLabel:setContentSize(cell:getContentSize())
      		util.alignNode(faqTypeLabel, selectImg,display.CENTER)
          	selectImg:addChild(faqTypeLabel)

          	return cell
		end

		local function tapListener( grid, index, item )
			_selectedIndex = index
			grid:refresh()

			local faqList = FaqDB.getFaqContent(index)
			_mFaqGrid:setItems(faqList)
		end

	    --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = _mFaqTypeNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_mFaqTypeNode:getContentSize().width , _mFaqTypeNode:getContentSize().height / 5.5),
	            column = 1,
	            createItemCellListener = createItemCellListener,
	            tapListener = tapListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _mFaqTypeNode,
	    }

	    return scrollGrid
	end
	--问题Grid
	local function createFaqGrid( ... )
		local function createItemCellListener(grid, index, item)
			--183.83
	        local cell = widget.newLayer{contentSize = CCSize(390,130)}
	        cell:ignoreAnchorPointForPosition(false)

	        local selectImg = widget.newScale9{ 
	        	file = "faq/btn_faq_nomal.png", 
                contentSize = cell:getContentSize(),
                capInsets 		= CCRectMake(100, 40, 10, 10) ,
            }

            local questionStr = _s("FAQ_QUESTION",index,item.content)
            local answerStr = _s("FAQ_ANSWER",index,item.memo)
	        local questionTextSize = getMessageSize(questionStr,300)
	        local answerTextSize = getMessageSize(answerStr,300)

	        --问题类型
            local faqIndexLabel = ui.newTTFLabel{			  
	                size = 20,
	                text = string.format("[%d/%d]",index,#grid:getItems()),
	                color = BUTTON_COLOR3.BROWN,
				}

			local params = {{text = questionStr, size = 20,color = BUTTON_COLOR3.BROWN,dimensions = CCSize(300,questionTextSize.height)},
                {text = answerStr, size = 20,color = BUTTON_COLOR3.BROWN,dimensions = CCSize(300,answerTextSize.height + 28) }}

        	local  linearLabel = widget.newLinearLabel({paramTable = params,direction = widget.TABLEVIEW_DIRECTION_VERTICAL })
              
			cell:setContentSize(CCSize(390,linearLabel:getContentSize().height + 30))
			selectImg:setContentSize(CCSize(cell:getContentSize().width,cell:getContentSize().height - 5 ))

			util.alignNodeWithPadding(selectImg, cell)
            cell:addChild(selectImg)

			util.alignNode(faqIndexLabel, selectImg,display.TOP_RIGHT,{top = 10,right = 15})
          	selectImg:addChild(faqIndexLabel)

			util.alignNode(linearLabel, selectImg,display.TOP_LEFT,{top = 10,left = 15})
        	selectImg:addChild(linearLabel)


          	return cell
		end

	    --scrollview
	    local scrollGrid = widget.newScrollLinear{
	        contentSize = _mFaqNode:getContentSize(),
	        cellAtIndexListener = createItemCellListener,
	        contentParams = {
	            column = 1,
	            selectedParams = nil,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	    }
	    _mFaqNode:addChild(scrollGrid)

	    return scrollGrid
	end

--[[ ## local fuction --]]
	local function initViews()
		--问题类别node
		_mFaqTypeNode = CCBCenter.getNodeByTag(_node, 2)
		--问题node
		_mFaqNode = CCBCenter.getNodeByTag(_node, 3)
		--问题类别Grid
		_mFaqTypeGrid = createFaqTypeGrid()
		--问题Grid
		_mFaqGrid = createFaqGrid()

		reloadFaqTypeGrid()
		reloadFaqGrid()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M