--DoorLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[DoorLayerView]"
	local _node, _nodeTable = node, luaValue
	local door_l = _nodeTable["door_l"]
	local door_r = _nodeTable["door_r"]
	local door_m = _nodeTable["door_m"]
	local door_m2 = _nodeTable["door_m2"]
	local TDAnimationUtils = require(PH_MDL_UTIL .. "TDAnimationUtils")

	local closeAni
	local openAni
	local onClosedCallback
	local onOpeningCallback
	local onEndingCallback
	local canOpen = false
	local needOpen = false

	local function doOpenDoor()

		canOpen = false
		needOpen = false
		door_m2:setOpacity(0)
		door_m:stopAllActions()
		door_m:setOpacity(255)
	    local array     = {}
        array[#array + 1] = CCDelayTime:create(0.1)
        array[#array + 1] = CCRotateBy:create(0.5,270)
      	array[#array + 1] = CCCallFunc:create(
            function ()
            	openAni()
            end
      	)
        door_m:runAction(TDAnimationUtils.sequence(array))
	end

	local function openDoor()
		-- 需要打开为true
		needOpen = true
		-- 可以打开时才打开
		if canOpen then 
			doOpenDoor()
		end
	end

	local function mAni()

		util.delayCall(function ()
				-- 可以打开为true
				canOpen = true
				-- 需要打开时才打开
				if needOpen then
              		doOpenDoor()
              	end
              end, 1)

        local array2 = {}
        array2[#array2 + 1] = CCDelayTime:create(0.1)
        array2[#array2 + 1] = CCFadeTo:create(0.3,255)
        door_m2:runAction(TDAnimationUtils.sequence(array2))

        
        -- V1:
        --[[
        ]]
        local array     = {}
        array[#array + 1] = CCDelayTime:create(0.1)
        array[#array + 1] = CCFadeTo:create(0.3,255)
        array[#array + 1] = CCDelayTime:create(0.5)
        array[#array + 1] = CCFadeTo:create(0.5,0)
        door_m:runAction(TDAnimationUtils.sequenceRepeat(array))
        -- V2:
        --[[
        door_m:setOpacity(255)
        ]]
	end

	function openAni()
          local array1     = {}
          array1[#array1 + 1] = CCCallFunc:create(
              function ()
              	-- door_m:setOpacity(0)
              end
          )
          
          array1[#array1 + 1] = CCCallFunc:create(onOpeningCallback)
          array1[#array1 + 1] = CCMoveTo:create(0.5,ccp(0,door_l:getPositionY()))
          array1[#array1 + 1] = CCDelayTime:create(0.1)
          array1[#array1 + 1] = CCCallFunc:create(onOpenedCallback)
          door_l:runAction(TDAnimationUtils.sequence(array1))

          local array2     = {}
          array2[#array2 + 1] = CCMoveTo:create(0.5,ccp(1603,door_l:getPositionY()))
          door_r:runAction(TDAnimationUtils.sequence(array2))
	end

	function closeAni()
          local array1     = {}
          array1[#array1 + 1] = CCDelayTime:create(0.5)
          array1[#array1 + 1] = CCMoveTo:create(0.2,ccp(480,door_l:getPositionY()))
          array1[#array1 + 1] = CCDelayTime:create(0.1)
          door_l:runAction(TDAnimationUtils.sequence(array1))

          local array2     = {}
          array2[#array2 + 1] = CCDelayTime:create(0.5)
          array2[#array2 + 1] = CCMoveTo:create(0.2,ccp(960,door_l:getPositionY()))
          array2[#array2 + 1] = CCDelayTime:create(0.1)
          array2[#array2 + 1] = CCCallFunc:create(
              function ()
              	mAni()
              	onClosedCallback()
              end
          )
          door_r:runAction(TDAnimationUtils.sequence(array2))
	end

	function onClosedCallback()
	    -- 卸载遮罩
	    _node:getParent():netSendStart()
	end

	function onOpeningCallback()
		-- 播放声音
		SOUND:playFightDoorOpen()
	    -- 卸载遮罩
	    _node:getParent():unloadMask()
	end

	-- 结束时处理
	function onOpenedCallback()
	    -- 加载阶段2
	    _node:getParent():loadStep2()
		-- 清除自身
		_node:removeFromParentAndCleanup(true)
	end

	local flag = true
--[[ ## local fuction --]]
	local function initViews()
		SOUND:playFightDoorClose()
	    closeAni()

  --      widget.bindTouchEvent{
		-- 	layer = util.toCCLayer(_node),
		-- 	clickListener = function (  )
		-- 		if flag then 
		-- 			flag = false
		-- 			openDoor()
		-- 		else
		-- 			flag = true
		-- 			closeAni()
		-- 		end
		-- 	end
		-- }	



	end

--[[ ## public fuction --]]
	_node.openDoor = openDoor
--[[ ## MAINs --]]
	initViews()
end

return M