--FightResult2Layer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[FightResult3LayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = node._DATA
--[[ ## local fuction --]]
	local function initViews()
	    -- [包含文件]
	    local TDArrayUtils  	= require(PH_MDL_UTIL .. "TDArrayUtils")
	    local TDAnimationUtils	= require(PH_MDL_UTIL .. "TDAnimationUtils")
	    local TDNumberUtils 	= require(PH_MDL_UTIL .. "TDNumberUtils")
	    local TipsDao		 	= require("db.tipsdb")
		local LabelMarquee = require("cardui.LabelMarquee")


	    

	    




	    -- [常量]
	    -- [路径]
	    local PHI 							= "fight/result3/"
	    -- [缩放比例]
	    local SCALE 						= SCALE_FOR_SPECIAL_NODE
	    local SCALE_CARD					= .8 / SCALE

	    -- [结点]
	    -- 结点标识[总体]
	    local NODETAG_WHOLE 				= 1

	    -- [动画]
	    -- ..



	    

	    




	    -- [操作变量]
	    local EntityFightState 		= require("ccb.m.fight.EntityFightState")
	    local EntityFightResult 	= require(PH_EN_FIGHT .. "EntityFightResult")
	    local EntityCard 			= require(PH_EN_FIGHT .. "EntityCard")
	    local CardMaster 			= require("cardui.CardMaster")
	    local CardEntity 			= require("model.card.CardEntity")
	    local GoodsMaster = require("cardui.GoodsMaster")
		local GoodsEntity = require("model.goods.GoodsEntity")
	    local LanguageDifference 	= require("cardui.LanguageDifference")
		local _stateBefore 		 	= nil
		local _stateCurrent 		= nil
		local _progressBarXp		= nil
		local _progressBarXpMask	= nil
		local _cards 				= {}
		local _entitiesAdvanced 	= {}
		local _views 				= {}
		local _viewIndex 			= 1
		local _isViewLock 			= true
		local N 					= _nodeTable



	    

	    



	    -- [私有方法声明]
	    -- [视图渲染]
	    -- 视图渲染
	    local viewRender
	    -- 加载状态
	    local loadState
		-- 加载结点
		local loadNode
		-- 加载渲染以外其他操作
		local loadRenderOtherwise
		-- 记录状态
		local record
		-- 绑定点击事件侦听器
		local bindTouchListener


	    -- [状态]
	    -- 获得先前状态
		local getStateBefore
		-- 获得当前状态
		local getStateCurrent

	    -- [状态判断]
		-- 是否是对战[关卡]
		local isBattleLevel
		-- boss
		local isBOSSWar
		-- 是否是对战[PK]
		local isBattlePk
		-- 是否是对战[PK][好友切磋]
		local isBattlePkLearn
		-- 是否是对战[PK][排名战]
		local isBattlePkRankWar
		-- 是否是对战[PK][竞技赛]
		local isBattlePkCompetitiveRace
		-- 是否是对战[录像]
		local isBattleRecord
		-- 是否是对战[录像][好友切磋]
		local isBattleRecordLearn
		-- 是否是对战[录像][排名战]
		local isBattleRecordPkRankWar
		-- 是否是对战[录像][竞技赛]
		local isBattleRecordCompetitiveRace

		-- [前处理]
		-- 前处理
		local prepare
		-- 前处理对战[公共]
		local prepareCommon
		-- 前处理对战[关卡]
		local prepareBattleLevel
		-- 前处理对战[PK][好友切磋]
		local prepareBattlePkLearn
		-- 前处理对战[PK][排名战]
		local prepareBattlePkRankWar
		-- 前处理对战[PK][竞技赛]
		local prepareBattlePkCompetitiveRace
		-- 前处理对战[录像]
		local prepareBattleRecord
		-- boss
		local prepareBattleBOSSWar


		-- [结点]
		-- 加载结点[公共]
		local loadNodeCommon
		-- 加载结点[关卡]
		local loadNodeBattleLevel
		-- 加载结点[PK][好友切磋]
		local loadNodeBattlePkLearn
		-- 加载结点[PK][排名战]
		local loadNodeBattlePkRankWar
		-- 加载结点[PK][竞技赛]
		local loadNodeBattlePkCompetitiveRace
		-- 加载结点[录像]
		local loadNodeBattleRecord

	    -- [结点][经验条]
		-- 加载经验条
		local loadNodeProgressBarXp
		-- 加载经验条[主]
	    local loadNodeProgressBarXpMain
	    -- 加载经验条[遮罩]
	    local loadNodeProgressBarXpMask
	    -- 设置进度条值
	    local setProgressValue

	    -- [结点][卡片]
		-- 加载卡片
		local loadCard
	    -- 获得卡牌所在容器
	    local getCardContainer



	    -- [动画]
		-- 动画显示
		local animate
		-- 动画显示背景
	    local animateBackground
		-- 动画显示标题
		local animateTitle
	    -- 动画显示进度条
	    local animateProgress
	    -- 动画显示[高级卡牌]
	    local animateAdvancedCard
		-- 动画显示视图过渡
		local animateViewTransition
		-- 动画显示提示
		local animateTips
		-- label动画
		local animateLabels
		-- 动画回调成功后的处理函数
		local callbckAnimateCompleted
		-- 动画回调成功后的处理函数[关卡]
		local callbckAnimateLayerLevel
		-- 动画回调成功后的处理函数[卡牌]
		local callbckAnimateLayerCards
		-- 动画回调成功后的处理函数[升级]
		local callbckAnimateLayerLevelUp
		-- 动画回调成功后的处理函数[排名战]
		local callbckAnimateLayerRankWar
		-- 动画回调成功后的处理函数[周竞技]
		local callbckAnimateLayerCompetitiveRace
		-- 动画回调成功后的处理函数[录像]
		local callbckAnimateLayerRecord
		-- 动画回调成功后的处理函数[失败]
		local callbckAnimateLayerFail

		-- [视图过渡]
		-- 处理视图过渡
		local handleViewTransition
		-- 跳转下一视图
		local switchNextView

		-- 新手引导
		local checkHelperInfo
		---------


		-- [事件处理]
		-- 处理点击事件[强化卡牌]
		local onButtonStrongCard
		-- 处理点击事件[邀请好友]
		local onButtonInviteFriend
		-- 处理点击事件[购买卡牌]
		local onButtonBuyCard


		---------


		-- [声音]
		-- 播放音效[结果]
		local playSoundResult
		-- 播放音效[获得奖励]
		local playSoundReward
		-- 播放音效[按钮]
		local playSoundButton
		-- 播放背景音乐[主页]
		local playMusicHome
		-- 播放卡牌出现
		local playSoundCardShow


		-- [辅助方法]
	    -- 获得结点
	    local NODE
		-- 获得层[标题]
	    local getLayerTitle
		-- 获得纹理图片[标题]
	    local getTextureTitle
	    -- 获得经验值
	    local getExpValue
	    -- 添加视图
	    local addView
	    -- 判断是否显示对方信息（用于对方名字、友情点等）
	    local isShowOpponent
	    -- 判断是否升级
	    local isLevelUp
	    -- 获得排名上升下降文字
	    local getRankUpDownText
	    -- 获得排名上升下降颜色
	    local getRankUpDownColor


	        

	        





	    -- [私有方法定义]
	    -- [视图渲染]
	    -- 视图渲染
	    function viewRender()
		    -- 加载状态
		    loadState()
		    -- 加载结点
		    loadNode()

		    -- 加载渲染以外其他操作
		    loadRenderOtherwise()
		end

		-- 加载状态
		function loadState()
			-- 获得先前状态
			_stateBefore  = getStateBefore()
			-- 获得当前状态
			_stateCurrent = getStateCurrent()
		end

		-- 加载渲染以外其他操作
		function loadRenderOtherwise()
	    	-- 处理语言差异
	    	-- LanguageDifference.fightResult2Diamond(_node, _nodeTable)

			-- 播放结果音乐
			playSoundResult()

			-- 前处理
			prepare()
			-- 动画显示
			animate()
			-- 记录信息
			record()

			-- 绑定点击事件侦听器
			if isBattleLevel() then --
			else
				-- bindTouchListener() --非打关卡
			end
		end


	    ---------


	    -- [视图渲染][其他操作]

		-- 记录信息
		function record()
			
		end

		-- 绑定点击事件侦听器
		function bindTouchListener()
	    	-- 绑定点击事件
	    	TDTouchUtils.bindNodeTouchEvent({ node = _node, priority = 1, handler = function() 
	    		if not _isViewLock then 
					-- 跳转下一视图
	    			switchNextView()
	    		end
			end})
		end


	    ---------


	    -- [状态]
	    -- 获得先前状态
		function getStateBefore()
		    return _data.stateBefore
		end

		-- 获得当前状态
		function getStateCurrent()
			-- 定义参数集
		    local properties = {
		    	id 				= 0, 									-- ID
		    	res 			= _data.result,							-- 战斗结果（成功、失败）
		    	diamond 		= _data.diamond, 						-- 钻石
		    	gold 			= _data.gold, 							-- 金币
		    	exp 			= _data.experience, 					-- 经验
		    	-- cards 			= _data.cards,           				-- 获得卡片集
		    	-- chips 			= _data.chips,           				-- 获得碎片集
		    	brlist          = _data.brlist,
		        star            = _data.star,                       	-- 获得星星
		        jjcScore        = _data.jjcScore,                  		-- 获得竞技场分数
		        rank            = _data.rank,                         	-- 获得排名
		        rankvar         = _data.rankvar,                        -- 获得排名变化值
		    } 
		     
		    local entity = EntityFightResult.new(properties)
		    entity:setBrlist(_data.brlist) 
	-- dump(entity:getBrlist()[0]:getCount())
		    -- 从Data中获得
		    -- 获得卡片集
		    -- entity:setCards(_data.cards)
		    -- -- 获得碎片集
		    -- entity:setChips(_data.chips)

		    -- 从全局Me中获得
		    -- 等级
		    entity:setLv(ME:getLv())
		    -- 生命
		    entity:setHp(ME:getHp())
		    -- 总召唤值
		    entity:setTotalcost(ME:getTotalcost())
		    -- 卡牌上限
		    entity:setCcount(ME:getCcount())
		    -- 卡组上限
		    entity:setGcount(ME:getGcount())
		    -- 好友上限
		    entity:setTcount(ME:getTcount())
		    -- 当前经验
			entity:setCurexp(ME:getCurexp())
		    -- 总经验
			entity:setTotalexp(ME:getTotalexp())

		    return entity
		end


	    ---------


	    -- [状态判断]
		-- 是否是对战[关卡]
		function isBattleLevel()
			return _data.mode.battle == MODE_BATTLE_LEVEL
		end

		-- 是否是BOSS战[关卡]
		function isBOSSWar()
			return _data.mode.battle == MODE_BATTLE_BOSS or _data.mode.battle == MODE_BATTLE_ARMY_BOSS
		end		

		--
		function isBattleEXPFBFLIGHT()

			return _data.mode.battle == MODE_BATTLE_EXPFBFLIGHT or _data.mode.battle == MODE_BATTLE_LADDERLIST
		end

		-- 是否是对战[PK]
		function isBattlePk()
			return _data.mode.battle == MODE_BATTLE_PK
		end

		-- 是否是对战[PK][好友切磋]
		function isBattlePkLearn()
			return isBattlePk() and _data.mode.pk == MODE_PK_LEARN
		end

		-- 是否是对战[PK][排名战]
		function isBattlePkRankWar()
			return isBattlePk() and _data.mode.pk == MODE_PK_RANK_WAR
		end

		-- 是否是对战[PK][竞技赛]
		function isBattlePkCompetitiveRace()
			return isBattlePk() and _data.mode.pk == MODE_PK_COMPETITIVE_RACE
		end

		-- 是否是对战[PK][团队战斗]
		function isBattlePkTeamRace()
			return isBattlePk() and _data.mode.pk == MODE_PK_TEAM_FIGHT
		end

		-- 是否是对战[录像]
		function isBattleRecord()
			return _data.mode.battle == MODE_BATTLE_RECORD
		end

		-- 是否是对战[录像][好友切磋]
		function isBattleRecordLearn()
			return isBattleRecord() and _data.mode.pk == MODE_PK_LEARN 
		end

		-- 是否是对战[录像][排名战]
		function isBattleRecordPkRankWar()
			return isBattleRecord() and _data.mode.pk == MODE_PK_RANK_WAR 
		end

		-- 是否是对战[录像][竞技赛]
		function isBattleRecordCompetitiveRace()
			return isBattleRecord() and _data.mode.pk == MODE_PK_COMPETITIVE_RACE 
		end


	    ---------


	    -- [结点加载]
		-- 加载结点
		function loadNode()
			


			-- [关卡]
			-- 是否是对战[关卡]
			if isBattleLevel() then 
				loadNodeBattleLevel()
				-- return
			end

			if isBattleEXPFBFLIGHT() then 
				loadNodeFbFight()
				-- return
			end


			-- [PK]
			-- 是否是对战[PK][好友切磋]
			if isBattlePkLearn() then 
				loadNodeBattlePkLearn()
				-- return
			end

			
			-- boss战
			if isBOSSWar() then 
				loadNodeBattleBOSSWar()
				-- return
			end

			-- 是否是对战[PK][排名战]
			if isBattlePkRankWar() then 
				loadNodeBattlePkRankWar()
				-- return
			end
			-- 是否是对战[PK][竞技赛]
			if isBattlePkCompetitiveRace() then 
				loadNodeBattlePkCompetitiveRace()
				-- return
			end


			-- [录像]
			-- 是否是对战[录像]
			if isBattleRecord() then 
				loadNodeBattleRecord()
				-- return
			end

			-- [公共]
			loadNodeCommon()
		end

		-- 加载结点[公共]
		function loadNodeCommon()
			-- 设置标题
			local layerTitle = getLayerTitle()
			layerTitle:setVisible(true)

			if not isBattleLevel() and not isBattleEXPFBFLIGHT()  then 
				addView(N["lyrSuccess"])
			end
			
			function _newFailButton(text, handler, parent, style)
	
				local image = (style == STYLE_FAILBUTTON_BLUE) and (PHI .. "f_r3_btn_1.png") or (PHI .. "f_r3_btn_0.png")

	            local button = widget.newButton({
	                labelParams        = {text = text, size = 32, color = BUTTON_COLOR3.BROWN},
	                normalImage        = image,
	                selectImage        = image,
	                contentSize        = CCSize(222, 69),
	                scale 			   = 1.1,
	                -- priority 		   = -1000000,
	                swallowsTouches    = true,
	                listener           = handler,
	            })
	            parent:addChild(button)
	            util.alignNode(button, parent:getContentSize(), display.CENTER)
			end
			-- 关闭（成功）
			_newFailButton(_s("FIGHT_BTN_BACKMAP"), switchNextView, N["lyrSuccessClose"], 0)
		end

		function loadNodeFbFight()  

			 N["lyrExpfbflight"]:setVisible(true)
			-- 金币
			N["lblfblightstart"]:setString("+"..tostring(_stateCurrent:getStar()))
			-- 经验值[获得]
			N["lblfblightGold"]:setString("+"..tostring(_stateCurrent:getGold()))
			if _data.mode.battle == MODE_BATTLE_LADDERLIST then
				N["lytowerresult"]:setVisible(true)
				N["lbltowerresults"]:setString("+"..tostring(_stateCurrent:getJjcScore()))
			else
				N["lytowerresult"]:setVisible(false)
			end

			-- [失败层]
			local STYLE_FAILBUTTON_YELLOW = 0
			local STYLE_FAILBUTTON_BLUE   = 1
			function _newFailButton(text, handler, parent, style)
				local image = (style == STYLE_FAILBUTTON_BLUE) and (PHI .. "f_r3_btn_1.png") or (PHI .. "f_r3_btn_0.png")

	            local button = widget.newButton({
	                labelParams        = {text = text, size = 32, color = BUTTON_COLOR3.BROWN},
	                normalImage        = image,
	                selectImage        = image,
	                contentSize        = CCSize(222, 69),
	                scale 			   = 1.1,
	                -- priority 		   = -1000000,
	                swallowsTouches    = true,
	                listener           = handler,
	            })
	            parent:addChild(button)
	            util.alignNode(button, parent:getContentSize(), display.CENTER)
			end
 
			if not HelperView2.isNextIndex(700) then 
				-- 再来一次（成功）
				_newFailButton(_s("FIGHT_BTN_RETRY"), onButtonRetry, N["lyrSuccessRetry"], STYLE_FAILBUTTON_YELLOW)
			end

			if isBattleEXPFBFLIGHT() then
				N["lyrSuccessRetry"]:setVisible(false)
			end
			-- end
			
			-- 关闭（成功）
			_newFailButton(_s("FIGHT_BTN_BACKMAP"), switchNextView, N["lyrSuccessClose"], STYLE_FAILBUTTON_YELLOW)

            -- 购买卡牌
             if _data.mode.battle == MODE_BATTLE_EXPFBFLIGHT or _stateCurrent:getRankvar() > 0 then
            	_newFailButton(_s("FIGHT_BTN_RETRY"), onButtonRetry, N["lyrFailRetry"], STYLE_FAILBUTTON_BLUE)
            end
			-- 强化卡牌
			_newFailButton(_s("FIGHT_BTN_STRONG_CARD"), onButtonStrongCard, N["lyrFailStrongCard"], STYLE_FAILBUTTON_YELLOW)
			-- 邀请战友
			_newFailButton(_s("FIGHT_BTN_BACKMAP"), switchNextView, N["lyrFailInviteFriend"], STYLE_FAILBUTTON_YELLOW)
            -- 购买卡牌
            _newFailButton(_s("FIGHT_BTN_BUY_CARD"), onButtonBuyCard, N["lyrFailBuyCard"], STYLE_FAILBUTTON_YELLOW)

			-- [卡片层]
			loadCard()
		end

		-- 加载结点[关卡]
		function loadNodeBattleLevel() 
			-- 友情点[我]
			if _stateCurrent:getRes() == RES_WIN then
				N["lblMeFriendPoint"]:setString("+"..tostring(_stateBefore:getMp()))
			end
			-- 金币
			N["lblGold"]:setString("+"..tostring(_stateCurrent:getGold()))
			-- 经验值[获得]
			N["lblRewardExp"]:setString("+"..tostring(_stateCurrent:getExp()))
			
			-- -- 创建标签
    -- local label = LabelMarquee.new({ 
    --     classType  = LabelMarquee.CLASSTYPE_TTF_SHADOW,      -- 类型
    --     text       = "300",                                 -- 标签文字
    --     size       = 50,                                    -- 字体大小
    --     color      = ccc3(255, 255, 255),                   -- 颜色
    -- })
    -- N["lblRewardExp"]:addChild(label, 10000)
    -- label:setPosition(ccp(10,10))

    -- -- 动画显示
    -- -- MODE: LabelMarquee.MODE_TIMES
    -- -- label:animateText({
    -- --      valueTo       = 300,                                 -- 到达值
    -- --      times         = 30,                                -- 动画次数
    -- --      duration      = 10,                                -- 动画时长
    -- -- })
    -- -- MODE: LabelMarquee.MODE_INCREMENTAL
    -- label:animateText({
    --      valueTo       = 200,                              -- 到达值
    --      duration      = 10,                             -- 动画时长
    --      mode          = LabelMarquee.MODE_INCREMENTAL,  -- 动画模式
    --      increase      = 1,                            -- 增长值
    -- })


			-- [升级层]
			-- 血量[先前]
			N["lblHpLast"]:setString(tostring(_stateBefore:getHp()))
			-- 血量[当前]
			N["lblHpCurrent"]:setString(tostring(_stateCurrent:getHp()))
			-- 等级[先前]
			N["lblLvLast"]:setString(tostring(_stateBefore:getLv()))
			-- 等级[当前]
			N["lblLvCurrent"]:setString(tostring(_stateCurrent:getLv()))
			-- 召唤值[先前]
			N["lblSpLast"]:setString(tostring(_stateBefore:getTotalcost()))
			-- 召唤值[当前]
			N["lblSpCurrent"]:setString(tostring(_stateCurrent:getTotalcost()))
			-- 卡牌上限[先前]
			N["lblCardNumLast"]:setString(tostring(_stateBefore:getCcount()))
			-- 卡牌上限[当前]
			N["lblCardNumCurrent"]:setString(tostring(_stateCurrent:getCcount()))
			-- 好友上限[先前]
			N["lblFriendNumLast"]:setString(tostring(_stateBefore:getTcount()))
			-- 好友上限[当前]
			N["lblFriendNumCurrent"]:setString(tostring(_stateCurrent:getTcount()))
			


			-- [失败层]
			local STYLE_FAILBUTTON_YELLOW = 0
			local STYLE_FAILBUTTON_BLUE   = 1
			function _newFailButton(text, handler, parent, style)
				local image = (style == STYLE_FAILBUTTON_BLUE) and (PHI .. "f_r3_btn_1.png") or (PHI .. "f_r3_btn_0.png")

	            local button = widget.newButton({
	                labelParams        = {text = text, size = 32, color = BUTTON_COLOR3.BROWN},
	                normalImage        = image,
	                selectImage        = image,
	                contentSize        = CCSize(222, 69),
	                scale 			   = 1.1,
	                -- priority 		   = -1000000,
	                swallowsTouches    = true,
	                listener           = handler,
	            })
	            parent:addChild(button)
	            util.alignNode(button, parent:getContentSize(), display.CENTER)
			end

			-- local function isJumpToHelper( )
			-- 	local msgEntity = ME:getTriggerMsgEntity()
			-- 	if msgEntity:isShowHelpInfo() 
			-- 	or msgEntity:isJumpToCardGroup()
			-- 	or msgEntity:isJumpToEnhancedHelper()
			-- 	or msgEntity:isJumpToEvolutionHelper()
			-- 	or msgEntity:isJumpToTalentHelper()
			-- 	or msgEntity:isJumpToStarHelper()
			-- 	or msgEntity:isJumpToChipHelper()
			-- 	or msgEntity:isJumpToArenaHelper()
			-- 	or msgEntity:isJumpToFriendHelper()
			-- 	or msgEntity:isJumpToUnlockCard() then
			-- 		return true
			-- 	end
			-- 	return false
			-- end
			-- checkHelperInfo( )
			-- if not isJumpToHelper() then
			if not HelperView2.isNextIndex(700) then 
				-- 再来一次（成功）
				_newFailButton(_s("FIGHT_BTN_RETRY"), onButtonRetry, N["lyrSuccessRetry"], STYLE_FAILBUTTON_YELLOW)
			end

			if isBattleEXPFBFLIGHT() then
				N["lyrSuccessRetry"]:setVisible(false)
			end
			-- end
			
			-- 关闭（成功）
			_newFailButton(_s("FIGHT_BTN_BACKMAP"), switchNextView, N["lyrSuccessClose"], STYLE_FAILBUTTON_YELLOW)

            -- 购买卡牌
            _newFailButton(_s("FIGHT_BTN_RETRY"), onButtonRetry, N["lyrFailRetry"], STYLE_FAILBUTTON_BLUE)
			-- 强化卡牌
			_newFailButton(_s("FIGHT_BTN_STRONG_CARD"), onButtonStrongCard, N["lyrFailStrongCard"], STYLE_FAILBUTTON_YELLOW)
			-- 邀请战友
			_newFailButton(_s("FIGHT_BTN_BACKMAP"), switchNextView, N["lyrFailInviteFriend"], STYLE_FAILBUTTON_YELLOW)
            -- 购买卡牌
            _newFailButton(_s("FIGHT_BTN_BUY_CARD"), onButtonBuyCard, N["lyrFailBuyCard"], STYLE_FAILBUTTON_YELLOW)

			-- [卡片层]
			loadCard()
		end

		-- 加载结点[PK][好友切磋]
		function loadNodeBattlePkLearn()
			
		end

		-- 加载结点[BOSS]
		function loadNodeBattleBOSSWar()

			if _data.mode.battle == MODE_BATTLE_BOSS then
				N["lyrBossSuccess1"]:setVisible(true)
				N["lyrBossSuccess5"]:setVisible(false)
				-- 星星
				N["lblBossStartCR"]:setString(tostring(_stateCurrent:getStar()))
			else 
				N["lyrBossSuccess1"]:setVisible(false)
				N["lyrBossSuccess2"]:setVisible(false)
				N["lyrBossSuccess5"]:setVisible(true)
			
				-- 贡献值
				N["lblBossContributeCR"]:setString(tostring(_stateCurrent:getRank()))
			end

			-- 伤害
			N["lblBossHurt"]:setString(tostring(_stateCurrent:getJjcScore()))
			
			-- 金币
			N["lblBossGold"]:setString(tostring(_stateCurrent:getGold()))
			if (_stateCurrent:getRes() == RES_WIN) then

			else
				N["lyrBossSuccess4"]:setVisible(false)
				
			end 
-- print("卡片曾。。。。。。。。。")
			-- [卡片层]
			loadCard()
		end

		-- 加载结点[PK][排名战]
		function loadNodeBattlePkRankWar()
			-- 排名上升下降文字
			N["lblRankUpDownRW"]:setString(getRankUpDownText())
			-- 排名
			N["lblRankRW"]:setString(tostring(math.abs(_stateCurrent:getRankvar())) .. _s("FIGHT_PLACES"))
			N["lblRankRW"]:setColor(getRankUpDownColor())

			-- 金币
			N["lblGoldRW"]:setString(tostring(_stateCurrent:getGold()))
			-- 经验值[获得]
			N["lblRewardExpRW"]:setString(tostring(_stateCurrent:getExp()))
		end

		-- 加载结点[PK][竞技赛]
		function loadNodeBattlePkCompetitiveRace()
			-- 排名上升下降文字
			N["lblRankUpDownCR"]:setString(getRankUpDownText())
			-- 排名
			N["lblRankCR"]:setString(tostring(math.abs(_stateCurrent:getRankvar())) .. _s("FIGHT_PLACES"))
			N["lblRankCR"]:setColor(getRankUpDownColor())

			-- 金币
			N["lblScoreGainCR"]:setString(tostring(_stateCurrent:getJjcScore()))
			-- 星星
			N["lblStartCR"]:setString(tostring(_stateCurrent:getStar()))
		end

		-- 加载结点[录像]
		function loadNodeBattleRecord()
			
		end


	    ---------


	    -- [可见性]
		-- 前处理
		function prepare()
			-- [公共]
			prepareCommon()


			-- [关卡]
			-- 是否是对战[关卡]
			if isBattleLevel() then 
				addView(N["lyrLevel"])
				prepareBattleLevel()
				return
			end

			--打塔
			if isBattleEXPFBFLIGHT() then  
				addView(N["lyrExpfbflight"])
				prepareBattleLevel()
				return
			end

			if isBOSSWar() then
				prepareBattleBOSSWar()
				return
			end
			-- [PK]
			-- 是否是对战[PK][好友切磋]
			if isBattlePkLearn() then 
				prepareBattlePkLearn()
				return
			end
			-- 是否是对战[PK][排名战]
			if isBattlePkRankWar() then 
				prepareBattlePkRankWar()
				return
			end
			-- 是否是对战[PK][竞技赛]
			if isBattlePkCompetitiveRace() then 
				prepareBattlePkCompetitiveRace()
				return
			end


			-- [录像]
			-- 是否是对战[录像]
			if isBattleRecord() then 
				prepareBattleRecord()
				return
			end
		end

		-- 是否是对战[公共]
		function prepareCommon()

		end

		-- 是否是对战[关卡]
		function prepareBattleLevel()
			-- [可见性]
			-- 设置可见性[好友]
			-- N["lyrLevelLineOpp"]:setVisible(isShowOpponent())

			-- [视图集]
			if isLevelUp() then 
				N["lyrLevel"].isErase = true 
				addView(N["lyrLevelUp"])  
			end 

			if (_stateCurrent:getRes() == RES_WIN) then

				addView(N["lyrCards"])
				addView(N["lyrSuccess"])
			else
				
				addView(N["lyrFail"])
			end 

			-- print("===========================")
			-- print("#levels: ", #_views)
			-- print("===========================")
		end

		-- 是否是对战[PK][好友切磋]
		function prepareBattlePkLearn()
			-- [可见性]
			-- 设置可见性[层]
			-- .. 

			-- [视图集]
			-- ..
		end

		-- 是否是对战[PK][排名战]
		function prepareBattleBOSSWar()
			-- [视图集]
			addView(N["lyrBossSuccess"])
			if isLevelUp() then 
				N["lyrBossSuccess"].isErase = true
 
				-- addView(N["lyrLevelUp"])
			else

				addView(N["lyrCards"])
				
			end
		end

		-- 是否是对战[PK][排名战]
		function prepareBattlePkRankWar()
			-- [视图集]
			if isLevelUp() then 
				N["lyrRankWar"].isErase = true

				addView(N["lyrRankWar"])
				addView(N["lyrLevelUp"])
			else
				addView(N["lyrRankWar"])
			end
		end

		-- 是否是对战[PK][竞技赛]
		function prepareBattlePkCompetitiveRace()
			-- [视图集]
			if isLevelUp() then 
				N["lyrCompetitiveRace"].isErase = true

				addView(N["lyrCompetitiveRace"])
				addView(N["lyrLevelUp"])
			else
				addView(N["lyrCompetitiveRace"])
			end
		end

		-- 是否是对战[录像]
		function prepareBattleRecord()
			-- [可见性]
			-- 设置可见性[层]
			-- ..
		end


	    ---------
local loadBrCards
local loadBrChips
local loadBrGoods
	
		function loadBrChips( cardId, i, count )
			 
			local entity = CardEntity.new({ id = cardId, lv = 1, })
			entity.type = CardMaster.MINISTARCARD
			local sprite = CardMaster.new(entity)
			local container = getCardContainer(i, count)
			container:setVisible(true)
			container:addChild(sprite)
			sprite:setScale(SCALE_CARD)
			util.alignNode(sprite, sprite:getParent():getContentSize(), display.CENTER)
		    local mask = display.newSprite(PHI .. "f_r3_cardchip.png")
		    sprite:addChild(mask)
		    util.alignNode(mask, sprite:getContentSize(), display.CENTER)
			_cards[i] = sprite 

			return sprite
		end

		function loadBrCards( cardId, i, count )
			
			local entity = CardEntity.new({ id = cardId, lv = 1, })
			entity.type = CardMaster.MINISTARCARD
			entity.showDetail = true
			local sprite = CardMaster.new(entity)
			-- print("i, count", i, count)
			local container = getCardContainer(i, count)
			container:setVisible(true)
			container:addChild(sprite)

			sprite:setScale(SCALE_CARD)
			util.alignNode(sprite, sprite:getParent():getContentSize(), display.CENTER)

			-- 记录高级卡牌
			if entity:getCardStar() >= ADVANCEDCARD_STAR_OVER then 
				_entitiesAdvanced[#_entitiesAdvanced + 1] = entity
			end

			_cards[i] = sprite 

			return sprite
		end

		function loadBrGoods( goodNo, i, count, brListEntity )
			local entity = GoodsEntity.new{
				no 			= brListEntity:getNo(),
				typ 		= brListEntity:getTyp(),
				count 		= brListEntity:getCount(),
				price 		= brListEntity:getPrice(),
				quality 	= brListEntity:getQuality(),
				usetype 	= brListEntity:getUsetype(),
				cansell 	= brListEntity:getCansell(),
				add 		= brListEntity:getAdd(),
				setid 		= brListEntity:getSetid(),
				eqid 		= brListEntity:getEqid(),
				pic 		= brListEntity:getPic(),
				isOn 		= brListEntity:getIsOn(),
				setids 		= brListEntity:getSetids(), 
			}
			entity.type = GoodsMaster.MATERIAL
			entity.showDetail = true  
			entity.showFrame = true  
			local sprite = GoodsMaster.new(entity)
			local container = getCardContainer(i, count)
			container:setVisible(true)
			container:addChild(sprite)

			-- sprite:setScale(SCALE_CARD)
			util.alignNode(sprite, sprite:getParent():getContentSize(), display.CENTER)

			_cards[i] = sprite 

			return sprite
		end

	    -- [结点][卡片]
		-- 加载卡片
		function loadCard()
			-- 获得卡片集
			local cards = _stateCurrent:getCards()
			-- 获得碎片集
			local chips = _stateCurrent:getChips()

			--物品集合
			local brlists = _stateCurrent:getBrlist()

			-- 获得数量
			local countCards = TDArrayUtils.isNotEmpty(cards) and #cards or 0
			local countChips = TDArrayUtils.isNotEmpty(chips) and #chips or 0
			local count 	 = countCards + countChips

			local countBrlists = TDArrayUtils.isNotEmpty(brlists) and #brlists or 0

			-- print("卡牌数量..."..table.nums(brlists))
			-- chips = cards
			-- no 编号
-- 0~5000 卡牌 点击打开卡牌展示界面
-- 5000~10000 卡牌碎片 点击打开卡牌展示界面
-- 10000~20000 物品 ，点击显示物品信息
-- 20000 ~ 30000 装备 ， 点击显示装备信息 
			if TDArrayUtils.isNotEmpty(brlists) then
				
				for i = 1, countBrlists do

					local br = brlists[i]
					local sprite = nil
					if br:getNo() > 0 and br:getNo() < 5000 then
						
						sprite = loadBrCards(br:getNo(), i, countBrlists)
					elseif br:getNo() > 5000 and br:getNo() < 10000 then
						
						sprite = loadBrChips(br:getNo(), i, countBrlists)
					elseif br:getNo() > 10000 and br:getNo() < 20000 then

						sprite = loadBrGoods(br:getNo(), i, countBrlists, br)
					end


					local goodnumlb = widget.newTTFLabelWithShadow{
		            -- local cost = ui.newTTFLabel{
		                text = "X"..br:getCount(),
		                size = 23,
		            }
		            sprite:addChild(goodnumlb)
		            util.alignNodeWithPadding(goodnumlb, sprite:getContentSize(), display.TOP_RIGHT, {left = -25, top = 5} )
		             
				end
			end

			-- if TDArrayUtils.isNotEmpty(cards) then 
			-- 	for i = 1, countCards do
			-- 		local card = cards[i]

			-- 		local entity = CardEntity.new({ id = card:getId(), lv = 1, })
			-- 		entity.type = CardMaster.MINICARD
			-- 		materialCostEntity.showDetail = true
			-- 		local sprite = CardMaster.new(entity)
			-- 		print("i, count", i, count)
			-- 		local container = getCardContainer(i, count)
			-- 		container:setVisible(true)
			-- 		container:addChild(sprite)

			-- 		sprite:setScale(SCALE_CARD)
			-- 		util.alignNode(sprite, sprite:getParent():getContentSize(), display.CENTER)

			-- 		-- 记录高级卡牌
			-- 		if card:getStar() >= ADVANCEDCARD_STAR_OVER then 
			-- 			_entitiesAdvanced[#_entitiesAdvanced + 1] = card
			-- 		end

			-- 		_cards[i] = sprite
			-- 	end
			-- end


			
		end


	    -- 获得卡牌所在容器
	    function getCardContainer(index, total)
	    	local container
	    	local conlb
	    	if 	   total == 1 then 
	    		if index == 1 then 
	    			container = N["lyrCard1_3"] 
	    		end
    		elseif total == 2 then 
	    		if 	   index == 1 then 
	    			container = N["lyrCard2_2"] 
	    		elseif index == 2 then 
	    			container = N["lyrCard2_3"] 
	    		end
    		elseif total == 3 then 
	    		if 	   index == 1 then 
	    			container = N["lyrCard1_2"] 
	    		elseif index == 2 then 
	    			container = N["lyrCard1_3"] 
	    		elseif index == 3 then 
	    			container = N["lyrCard1_4"] 
	    		end
    		elseif total == 4 then 
	    		if 	   index == 1 then 
	    			container = N["lyrCard2_1"] 
	    		elseif index == 2 then 
	    			container = N["lyrCard2_2"] 
	    		elseif index == 3 then 
	    			container = N["lyrCard2_3"] 
	    		elseif index == 4 then 
	    			container = N["lyrCard2_4"] 
	    		end
    		elseif total == 5 then 
	    		if 	   index == 1 then 
	    			container = N["lyrCard1_1"] 
	    		elseif index == 2 then 
	    			container = N["lyrCard1_2"] 
	    		elseif index == 3 then 
	    			container = N["lyrCard1_3"] 
	    		elseif index == 4 then 
	    			container = N["lyrCard1_4"] 
	    		elseif index == 5 then 
	    			container = N["lyrCard1_5"] 
	    		end
    		end

    		return container
	    end


	    ---------


	    -- [动画]
		-- 动画显示
	    function animate()
	    	-- 动画显示背景
	    	animateBackground()
	    	-- 动画显示标题
	    	animateTitle()
			-- 动画显示视图过渡
	    	animateViewTransition()
	    end

		-- 动画显示标题
	    function animateBackground()
	    	-- local node 			= N["sptBackground"]
	    	-- local array 		= {}
	    	-- local delay 		= 0
	    	-- local time1 		= .3
	    	-- local scaleOrigin 	= node:getScale()
	    	-- local scale0 		= 0
	    	-- local scale1 		= scaleOrigin


	    	-- -- 初始设置
	    	-- node:setScale(scale0)
	    	-- -- 播放音效
	    	-- playSoundResult()
	    	-- -- 隐藏
	    	-- array[#array + 1] = CCHide:create()
	    	-- -- 延迟时间
	    	-- array[#array + 1] = CCDelayTime:create(delay)
	    	-- -- 显示
	    	-- array[#array + 1] = CCShow:create()
	    	-- -- 缩放比例
	    	-- array[#array + 1] = CCEaseBackOut:create(CCScaleTo:create(time1, scale1))

	    	-- -- 处理回调函数
	    	-- if callback then 
	    	-- 	array[#array + 1] = CCCallFunc:create(callback)
	    	-- end

	    	-- node:runAction(TDAnimationUtils.sequence(array))
	    end

		-- 动画显示标题
	    function animateTitle()
	    	local node 			= (_stateCurrent:getRes() == RES_WIN) and N["sptTitleBarWin"] or N["sptTitleBarLose"]
	    	local array 		= {}
	    	local delay 		= .3
	    	local time1 		= .1
	    	local scaleOrigin 	= node:getScale()
	    	local scale0 		= scaleOrigin * 4.0
	    	local scale1 		= scaleOrigin
	    	local rate 			= .3


	    	-- 初始设置
	    	node:setScale(scale0)
	    	-- 播放音效
	    	playSoundResult()
	    	-- 隐藏
	    	array[#array + 1] = CCHide:create()
	    	-- 延迟时间
	    	array[#array + 1] = CCDelayTime:create(delay)
	    	-- 显示
	    	array[#array + 1] = CCShow:create()
	    	-- 缩放比例
	    	array[#array + 1] = CCEaseOut:create(CCScaleTo:create(time1, scale1), rate)

	    	-- 处理回调函数
	    	if callback then 
	    		array[#array + 1] = CCCallFunc:create(callback)
	    	end

	    	node:runAction(TDAnimationUtils.sequence(array))
	    end

	    -- 动画显示[高级卡牌]
	    function animateAdvancedCard()
	    	if TDArrayUtils.isNotEmpty(_entitiesAdvanced) then 
	    		local delay = 1.6

	    		for i = 1, #_entitiesAdvanced do
	    			-- [对象构建]
	    			-- 卡牌
			    	local entity = CardEntity.new({ id = _entitiesAdvanced[i]:getId() })
		            entity.type = CardMaster.MASTERCARD
		            entity.handler = nil
		            local card = CardMaster.new(entity)
		            _node:addChild(card, 100)
		            util.alignNode(card, _node:getContentSize(), display.CENTER)

	    			-- 闪光
	    			local scaleLight = .5
	    			local light1 = display.newSprite("shop/chouka/chouka_07.png")
	    			light1:setScale(scaleLight)
	    			card:addChild(light1, -1)
		            util.alignNode(light1, card:getContentSize(), display.CENTER)
	    			local light2 = display.newSprite("shop/chouka/chouka_007.png")
	    			light2:setScale(scaleLight)
	    			card:addChild(light2, -2)
		            util.alignNode(light2, card:getContentSize(), display.CENTER)





		            
		            -- [动画显示]
	    			-- 卡牌
			    	local node 			= card
			    	local array 		= {}
			    	local interval 		= delay * (i - 1) 
			    	local delay 		= interval
			    	local time1 		= .3
			    	local time2 		= .7
			    	local time3 		= .2
			    	local scaleOrigin 	= node:getScale()
			    	local scale0 		= 0
			    	local scale1 		= scaleOrigin
			    	local scale2 		= 0


			    	-- 初始设置
			    	node:setScale(scale0)
			    	-- 延迟
			    	array[#array + 1] = CCDelayTime:create(delay)
			    	-- 声音
			    	array[#array + 1] = CCCallFunc:create(function() SOUND:playEffectFightRewardAdvanced() end)
			    	-- 缩放比例
			    	array[#array + 1] = CCEaseBackOut:create(TDAnimationUtils.spawn({
			    		CCScaleTo:create(time1, scale1),
			    	}))
			    	-- 延迟
			    	array[#array + 1] = CCDelayTime:create(time2)
			    	-- 缩放比例
			    	array[#array + 1] = CCEaseIn:create(TDAnimationUtils.spawn({
			    		CCFadeOut:create(time3),
			    		CCScaleTo:create(time3, scale2),
			    	}), .3)

			    	node:runAction(TDAnimationUtils.sequence(array))

	    			-- 闪光
	    			local timeToLight = 1.0
	    			light1:runAction(TDAnimationUtils.sequenceRepeat({ CCRotateBy:create(timeToLight, 360) }))
	    			light2:runAction(TDAnimationUtils.sequenceRepeat({ CCRotateBy:create(timeToLight, -360) }))
	    		end
	    	end
	    end

	    local function animateCards( )
 
	    	if TDArrayUtils.isNotEmpty(_cards) then
	    		
	    		for i = 1, #_cards do
	    			local sprite = _cards[i]


			
		    		sprite:setOpacity(0)
			    	local finishScale = sprite:getScale()
			    	local array         = {}
			    	
		            array[#array + 1] = CCCallFunc:create(function() playSoundCardShow() end)
		            array[#array + 1] = CCScaleTo:create(i*0.2,finishScale+0.4)
		            array[#array + 1] = CCCallFunc:create(function() sprite:setOpacity(100) end)
		            array[#array + 1] = CCScaleTo:create(i*0.2,finishScale)
		            -- array[#array + 1] = CCCallFunc:create(function() sprite:setOpacity(250) end)
		            -- array[#array + 1] = CCFadeOut:create(0.1)
		            sprite:runAction(TDAnimationUtils.sequence(array))
	    	
	    		end
	    	end 
	    end

	    function animateLabels(  )
	    	
	    	local function doAnimation( node,time )
	    		node:setOpacity(0)
		    	node:setPosition( node:getPositionX(), node:getPositionY()+30)
		    	local array         = {}
		    	array[#array + 1] = CCCallFunc:create(function() node:setOpacity(50) end)
	            array[#array + 1] = CCMoveTo:create(time, ccp(node:getPositionX(), node:getPositionY()-30))
	            array[#array + 1] = CCCallFunc:create(function() node:setOpacity(250) end)
	            -- array[#array + 1] = CCFadeOut:create(0.1)
	            node:runAction(TDAnimationUtils.sequence(array))
	    	end

	    	doAnimation(N["lblGold"],0.3)
	    	doAnimation(N["lblRewardExp"],0.6)
 			doAnimation(N["lblMeFriendPoint"],0.9)
	    end

		-- 动画显示视图过渡
		function animateViewTransition()

			-- print("显示出来啦。。。。。。。。。。。。")
			if _viewIndex > #_views then 
				_isViewLock = false
				return
			end

			if _isViewLock and _viewIndex <= #_views then 
				-- [数据准备]
				-- 获得显示视图
				local viewCurrent = _views[_viewIndex]


	            -- [动画显示]
    			-- 卡牌
		    	local node 			= nil
		    	local array 		= nil
		    	local delay 		= (_viewIndex == 1) and .2 or 0
		    	local time1 		= 1.0
		    	local rate 			= .3

		    	-- [当前视图]
		    	if true then 
		    		-- [参数赋值]
		    		node  = viewCurrent
		    		array = {}


		    		-- [动画]
			    	-- 初始设置
			    	array[#array + 1] = CCCallFunc:create(function() 
			    		if node == N["lyrCards"] then 
							-- [回调]卡牌
							animateCards()
						elseif node == N["lyrLevel"] or node == N["lyrExpfbflight"] then 
				
							animateLabels()
						end
			    	end)

			    	-- 延迟
			    	array[#array + 1] = CCDelayTime:create(delay)
			    	-- 显示层
			    	array[#array + 1] = CCShow:create()
			    	-- 回调
			    	array[#array + 1] = CCCallFunc:create(function() 
			    		-- 视图切换计数加1 
			    		_viewIndex = _viewIndex + 1
			    		-- 设置当前视图隐藏
			    		node:setVisible(not node.isErase)
			    		-- 动画回调成功后的处理函数
			    		callbckAnimateCompleted(node)
			    		-- 
			    		animateViewTransition()
			    	end)

			    	array[#array + 1] = CCDelayTime:create(0.5)
			    	-- 延迟
			    	array[#array + 1] = TDAnimationUtils.spawn({ 
			    		CCCallFunc:create(function()
					    	local children 		= node:getChildren()
					    	if children == nil then

					    	else
					    		if children:count() > 0 then
								for i = 0, children:count() - 1 do
						    		-- 目标结点
						    		local childNode = util.toCCSprite(children:objectAtIndex(i))
					    			local array 	= {}

							    	-- 初始设置
							    	if childNode then 
								    	childNode:setOpacity(0)
							    		-- 透明度
								    	array[#array + 1] = CCFadeIn:create(time1)

								    	childNode:runAction(TDAnimationUtils.sequence(array))
								    end
							    end
					    		end
					    	end
					    	
			    		end),
			    		CCDelayTime:create(time1),
			    	})
			    	

			    	node:runAction(TDAnimationUtils.sequence(array))
			    end
			end
		end

		-- 动画回调成功后的处理函数
		function callbckAnimateCompleted(node)
			if 	   node == N["lyrLevel"] then 
				-- [回调]关卡奖励
				callbckAnimateLayerLevel()

			elseif node == N["lyrLevelUp"] then 
				-- [回调]升级
				callbckAnimateLayerLevelUp()
			elseif node == N["lyrCards"] then 
				-- [回调]卡牌
				callbckAnimateLayerCards()
			elseif node == N["lyrRankWar"] then 
				-- [回调]排名战
				callbckAnimateLayerRankWar()
			elseif node == N["lyrCompetitiveRace"] then 
				-- [回调]竞技赛
				callbckAnimateLayerCompetitiveRace()
			elseif node == N["lyrFail"] then 
				-- [回调]失败
				-- callbckAnimateLayerFail()
			end
		end

		-- 动画回调成功后的处理函数[关卡]
		function callbckAnimateLayerLevel()

		end

		-- 动画回调成功后的处理函数[卡牌]
		function callbckAnimateLayerCards()
			animateAdvancedCard()
		end
		
		-- 动画回调成功后的处理函数[升级]
		function callbckAnimateLayerLevelUp()
			-- 标题

			if true then 
		    	-- 动画显示
		    	local node 			= N["sptTitleLevelUp"]
		    	local delay 		= 0.0
		    	local time1 		= .6
		    	local time2 		= 1.2
		    	local time3 		= time2
		    	local scaleOrigin 	= node:getScale()
		    	local scale0 		= 0
		    	local scale1 		= scaleOrigin
		    	local opacity0 		= 0
		    	local opacity1 		= 255
		    	local rotation2 	= 5
		    	local rotation3 	= -rotation2
		    	local position2   	= ccp(node:getPosition())
		    	local position3   	= ccpAdd(position2, ccp(0, 5))


		    	node:setVisible(true)
	    		-- [印章]
    			-- 初始状态
    			node:setScale(scale0)
    			node:setOpacity(opacity0)
    			-- 动画
    			local action = TDAnimationUtils.sequence({
    				CCCallFunc:create(function()
    					playSoundLevelUp()
    				end),
    				CCEaseBackOut:create(TDAnimationUtils.spawn({
    					CCScaleTo:create(time1, scale1),
    					CCFadeTo:create(time1, opacity1),
    				})),
    				-- CCCallFunc:create(function()
		    		-- 	local action = TDAnimationUtils.sequenceRepeat({
		    		-- 		-- CCRotateTo:create(time2, rotation2),
		    		-- 		-- CCRotateTo:create(time3, rotation3),
		    		-- 		CCMoveTo:create(time2, position2),
		    		-- 		CCMoveTo:create(time3, position3),
		    		-- 	})

		    		-- 	node:runAction(action)
    				-- end),
    			})

    			node:runAction(action)
			end


			-- 箭头
			if true then 
				local arrows 	= { N["sptLevelUpArrow1"], N["sptLevelUpArrow2"], N["sptLevelUpArrow3"], N["sptLevelUpArrow4"], N["sptLevelUpArrow5"] }
		    	local timeArrow = .3

	    		for k = 1, #arrows do
		    		local arrow  = arrows[k]
		    		local action = TDAnimationUtils.sequenceRepeat({
		    			CCFadeOut:create(timeArrow),
		    			CCFadeIn:create(timeArrow),
		    		})
		    		arrow:runAction(action)
	    		end
	    	end

	    	-- 经验条
	    	-- 动画显示经验条
	    	-- animateProgress()
		end
		
		-- 动画回调成功后的处理函数[排名战]
		function callbckAnimateLayerRankWar()

		end
		
		-- 动画回调成功后的处理函数[周竞技]
		function callbckAnimateLayerCompetitiveRace()

		end
		
		-- 动画回调成功后的处理函数[录像]
		function callbckAnimateLayerRecord()

		end

		-- 动画回调成功后的处理函数[失败]
		function callbckAnimateLayerFail()

		end


	    ---------


		-- [视图过渡]
		-- 处理视图过渡
		function handleViewTransition()
			-- 播放音效[按钮]
			playSoundButton()
			-- print("_viewIndex", _viewIndex)

			-- 跳转判断
			if _viewIndex > #_views then 
				-- 跳转下一视图
				switchNextView()
			else
				animateViewTransition()
			end
		end
	    function checkHelperInfo( )
	    	local function callback( index )
	    		if index == 110010 then 
	    			HelperView2.showNext()
					CCBCenter.replaceScene(MAP_MESSAGE_ID, MAP_LAYER_ID, { 
							autoView = true, 
							autoViewAnim = false, 
							levels = _data.levels,
						}, function(node) 
						game.requestDateForLoad(node, .5)
					end)
				end
	    	end
	        local msgEntity = ME:getTriggerMsgEntity()
	        -- 排查
	        if msgEntity:isShowHelpInfo() and not msgEntity:isJumpToUnlockCard() then 
	            -- 为了容错(正常是不会进来的)
	            CCBCenter.replaceScene(MAP_MESSAGE_ID, MAP_LAYER_ID, { 
							autoView = true, 
							autoViewAnim = false, 
							levels = _data.levels,
						}, function(node) 
						game.requestDateForLoad(node, .5)
					end)
	            return true
	        elseif msgEntity:isJumpToUnlockCard() then
	            -- 卡牌解锁
	            HelperView2.setCurIndex(90010)
	            return HelperView2.showBetween(_node, nil, {90010, 90010}) ~= nil
	        elseif msgEntity:isJumpToCardGroup() then
	            -- 卡组解锁
	            HelperView2.setCurIndex(100010)
	            return HelperView2.showBetween(_node, nil, {100010, 100010}) ~= nil
	        elseif msgEntity:isJumpToEnhancedHelper() then
	            HelperView2.setCurIndex(10010)
	            return HelperView2.showBetween(_node, nil, {10010, 10010}) ~= nil
	        elseif msgEntity:isJumpToEvolutionHelper() then
	            HelperView2.setCurIndex(20010)
	            return HelperView2.showBetween(_node, nil, {20010, 20010}) ~= nil
	        elseif msgEntity:isJumpToTalentHelper() then
	            HelperView2.setCurIndex(50010)
	            return HelperView2.showBetween(_node, nil, {50010, 50010}) ~= nil
	        elseif msgEntity:isJumpToStarHelper() then
	            HelperView2.setCurIndex(40010)
	            return HelperView2.showBetween(_node, nil, {40010, 40010}) ~= nil
	        elseif msgEntity:isJumpToChipHelper() then
	            HelperView2.setCurIndex(80010)
	            return HelperView2.showBetween(_node, nil, {80010, 80010}) ~= nil
	        elseif msgEntity:isJumpToArenaHelper() then
	            HelperView2.setCurIndex(70010)
	            return HelperView2.showBetween(_node, nil, {70010, 70010}) ~= nil
	        elseif msgEntity:isJumpToFriendHelper() then
	            HelperView2.setCurIndex(30010)
	            return HelperView2.showBetween(_node, nil, {30010, 30010}) ~= nil
            elseif msgEntity:isJumpToArenaWeekHelper() then
	            HelperView2.setCurIndex(130010)
	            return HelperView2.showBetween(_node, nil, {130010, 130010}) ~= nil
	        elseif msgEntity:isJumpToEquipHelper() then
	            HelperView2.setCurIndex(120010)
	            return HelperView2.showBetween(_node, nil, {120010, 120010}) ~= nil
	        elseif msgEntity:isJumpToExploreHelper() then
	            HelperView2.setCurIndex(110010)
	            return HelperView2.showBetween(_node, callback, {110010, 110010}) ~= nil
	        elseif msgEntity:isJumpToEquipEnhancedHelper() then
	            HelperView2.setCurIndex(140010)
	            return HelperView2.showBetween(_node, callback, {140010, 140010}) ~= nil
	        elseif msgEntity:isJumpToMiningHelper() then
	            HelperView2.setCurIndex(150010)
	            return HelperView2.showBetween(_node, callback, {150010, 150010}) ~= nil
	        elseif msgEntity:isJumpToEquipEvoHelper() then
	            HelperView2.setCurIndex(160010)
	            return HelperView2.showBetween(_node, callback, {160010, 160010}) ~= nil
	        elseif msgEntity:isJumpToEquipAddHelper() then
	            HelperView2.setCurIndex(170010)
	            return HelperView2.showBetween(_node, callback, {170010, 170010}) ~= nil
	        elseif msgEntity:isJumpToTower1Helper() then
	            HelperView2.setCurIndex(200010)
	            return HelperView2.showBetween(_node, callback, {200010, 200010}) ~= nil
	        elseif msgEntity:isJumpToTower2Helper() then
	            HelperView2.setCurIndex(210010)
	            return HelperView2.showBetween(_node, callback, {210010, 210010}) ~= nil
	        end
	        
	    end
		-- 跳转下一视图
		function switchNextView()
			-- 播放背景音乐[主页]
			playMusicHome()

			local fnNextView 				= _data.fnNextView
			local isRecord 					= _data.mode.battle == MODE_BATTLE_RECORD
			local isRecordRankWar 			= _data.mode.record == MODE_RECODE_RANK_WAR
			local isRecordCompetitiveRace 	= _data.mode.record == MODE_RECODE_COMPETITIVE_RACE
			local isPk 						= _data.mode.battle == MODE_BATTLE_PK
			local isPkLearn 				= _data.mode.pk == MODE_PK_LEARN
			local isPkRankWar 				= _data.mode.pk == MODE_PK_RANK_WAR
			local isPkCompetitiveRace 		= _data.mode.pk == MODE_PK_COMPETITIVE_RACE
			local autoMap       			= _data.mode.battle == MODE_BATTLE_LEVEL    -- 自动切换地图

			if fnNextView then 
				fnNextView()
			else
				-- 新手引导启动跳过后续
				if checkHelperInfo() then
					return
				end
				if isRecord then 
					if isRecordRankWar then 
						CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 2})
					elseif isRecordCompetitiveRace then 
						CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 4})
					end
				elseif isPk then 
					if isPkLearn then 
						CCBCenter.replaceScene("MSG_FRIENDLAYER_MODEL", "ccb.c.friend.FriendLayer", {}, function(node) 
							game.requestDateForLoad(node, .5)
						end) 
					elseif isPkRankWar then 
						CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 1})
					elseif isPkCompetitiveRace then 
						CCBCenter.replaceScene("MSG_ARENASELECTLAYER_MODEL", "ccb.c.arena.ArenaSelectLayer",{flag = 3})
					end
				else
					if autoMap then 
						autoMap = not (_data.isBreak and string.endwith(_data.levelId, "-10"))
						CCBCenter.replaceScene(MAP_MESSAGE_ID, MAP_LAYER_ID, { 
								autoView = autoMap, 
								autoViewAnim = false, 
								levels = _data.levels,
							}, function(node) 
							game.requestDateForLoad(node, .5)
						end)
					else
						CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
					end
				end
			end
		end


		---------


		-- [事件处理]
		-- 处理点击事件[再次挑战]
		function onButtonRetry()
			-- print("onButtonRetry()")
			if not checkHelperInfo( ) then
				_node:getParent():gameRestart()
			end
		end 
		-- 处理点击事件[强化卡牌]
		function onButtonStrongCard()
			-- print("onButtonStrongCard()")
			if not checkHelperInfo() then
				if not ME:getTriggerMsgEntity():isUnlockEnhanced() then
					NetHelper.QuickToast(_s("COMMON_UNOPEN", require("static.unlock_level").ENHANCED, _s("CARD_ENHANCED")))
					return
				end
				CCBCenter.replaceScene("MSG_CARDGROUPLAYER_MODEL", "ccb.c.cardgroup.CardGroupLayer", {fromMain = false, toEnhanced = true, }, function(node) 
					game.requestDateForLoad(node)
				end)
			end
		end 
		-- 处理点击事件[邀请好友]
		function onButtonInviteFriend()
			-- print("onButtonInviteFriend()")
			if not checkHelperInfo() then
				if not ME:getTriggerMsgEntity():isUnlockFriend() then
					NetHelper.QuickToast(_s("COMMON_UNOPEN", require("static.unlock_level").FRIEND, _s("MAIN_FRIENDS")))
					return
				end
				CCBCenter.replaceScene("MSG_FRIENDLAYER_MODEL", "ccb.c.friend.FriendLayer", {fromMain = false, toEnhanced = true, }, function(node) 
					game.requestDateForLoad(node, .5)
				end)
			end
		end 
		-- 处理点击事件[购买卡牌]
		function onButtonBuyCard()
			-- print("onButtonBuyCard()")
			if not checkHelperInfo() then
				-- CCBCenter.replaceScene("MSG_SHOPLAYER_MODEL", "ccb.c.shop.ShopLayer", {fromMain = false, toEnhanced = true, }, function(node) 
				-- 	game.requestDateForLoad(node, .5)
				-- end)
				CCBCenter.replaceScene("MSG_SHOPNEWLAYER_MODEL", "ccb.c.shop.ShopNewLayer", {toDrawCard = true})
			end
		end 


		---------


		-- [声音]
		-- 播放音效[结果]
		function playSoundResult()
			if (_stateCurrent:getRes() == RES_WIN) then 
				SOUND:playEffectFightWin()
			else
				SOUND:playEffectFightLose()
			end
		end

		-- 播放音效[获得奖励]
		function playSoundReward()
			SOUND:playEffectFightReward()
		end

		-- 播放音效[升级]
		function playSoundLevelUp()
			SOUND:playEffectFightLevelUp()
		end

		function playSoundCardShow()

			SOUND:playSoundCardShow()
		end

		-- 播放音效[按钮]
		function playSoundButton()
	        SOUND:playEffectButton2()
		end

		-- 播放背景音乐[主页]
		function playMusicHome()
			SOUND:playMusicHome()
		end


	    ---------


	    -- [辅助方法]
	    -- 根据标识获得结点
	    function NODE(nodeTag)
	    	return CCBCenter.getNodeByTag(_node, nodeTag)
	    end

		-- 获得层[标题]
	    function getLayerTitle()
			return (_stateCurrent:getRes() == RES_WIN) and N["lyrTitleWin"] or N["lyrTitleLose"]
	    end

		-- 获得纹理图片[标题]
		function getTextureTitle()
			local fileName = PHI .. ((_stateCurrent:getRes() == RES_WIN) and "f_r2_title_win" or "f_r2_title_lose") .. ".png"
			return CCTextureCache:sharedTextureCache():addImage(fileName)
		end

	    -- 获得经验值
	    function getExpValue(current, total)
	    	return current * 1.0 / total * 100
	    end

	    -- 添加社图
	    function addView(view)
	    	_views[#_views + 1] = view
	    end

	    -- 判断是否显示对方信息（用于对方名字、友情点等）
	    function isShowOpponent()
	    	return _data.result == RES_WIN and (_stateBefore:getFname() ~= "")
	    end

	    -- 判断是否升级
	    function isLevelUp()
	    	return _stateBefore:getLv() < _stateCurrent:getLv()
	    end

	    -- 获得排名上升下降文字
	    function getRankUpDownText()
	    	return _stateCurrent:getRankvar() < 0 and _s("FIGHT_DOWN") or _s("FIGHT_UP")
	    end

	    -- 获得排名上升下降颜色
	    function getRankUpDownColor()
	    	return _stateCurrent:getRankvar() < 0 and ccc3(255, 45, 142) or ccc3(0, 249, 158)
	    end


	        

	        





	    -- [具体操作]
	    -- 视图渲染
	    viewRender()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M