
local GoodsMaster = require("cardui.GoodsMaster")
local GoodsEntity = require("model.goods.GoodsEntity")
local MessageModel = require("ccb.m.message.MessageModel")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[FriendPanelLayerView]"


	-- [私有变量]
	local _node, _nodeTable = node, luaValue
	local _userInfo  		                    -- 玩家信息
	local _uname 								-- 名字
	local _ulevel 								-- 等级
	local _ulastTime 							-- 最后登录时间
	local _usex 								-- 性别
	local _uRank 								-- 排名
	local _cname 								-- 卡名字
	local _clevel  								-- 卡等级
	local _cstar  								-- 卡星级
	local _cgroup  								-- 卡阵营
	local _cIcon  								-- 卡图标
	local _gridTable  							-- 天赋
	local _personImg
	local _nodeEquipSkill						--装备技能
	local _equipSkillGrid						--技能列表

	-- [方法声明]
	-- ..
	local createTable





--[[ ## local fuction --]]
	--加载技能数据
	local function reloadEquipSkillGrid(  )
		local skillTable = {}
		for i,v in ipairs(_userInfo:getHero():getEquipSkill()) do
			local str = v.name_ .. "LV" .. v.level_ .. ":" ..v.info_

			table.insert(skillTable,str)
		end
		_equipSkillGrid:setItems(skillTable)
	end
	--用户所穿装备列表
	local function createUserEquipmentGrid( equipmentList )
		local userEquipmentBgTable = {}
		local _mUserEquipment = _nodeTable.mUserEquipment
		--各个背景位置
		local pos = {display.TOP_LEFT,display.TOP_RIGHT,display.CENTER_LEFT,
			display.CENTER_RIGHT,display.BOTTOM_LEFT,display.BOTTOM_RIGHT}
		--各个位置偏移位置
		local pos2 = {{top = 10 ,left = 10},{top = 10 ,right = 10},{left = 10},
			{right = 10},{bottom = 10 ,left = 10},{bottom = 10 ,right = 10}}
		--部位名称
		local bone = {_s("EQUIPMENT_HEAD"),_s("EQUIPMENT_BODY"),_s("EQUIPMENT_HAND"),
			_s("EQUIPMENT_SHOES"),_s("EQUIPMENT_WEAPON"),_s("EQUIPMENT_SHIELD")}

		for i=1,6 do
			--背景
			local equipmentBg = display.newSprite("equipment/bg_equipment_3.png")
			util.alignNodeWithPadding(equipmentBg, _mUserEquipment:getContentSize(), pos[i], pos2[i])
			_mUserEquipment:addChild(equipmentBg,-1)

			--部位名称
			local lblCalender = ui.newTTFLabel{				  
                size = TALK_TABLE_TEXT_SIZE,
                text = bone[i],
                color =COLOR3.GREE
    		}
    		util.alignNode(lblCalender, equipmentBg:getContentSize(), display.CENTER)
          	equipmentBg:addChild(lblCalender,10000)

			table.insert(userEquipmentBgTable,equipmentBg)
		end
		for i,v in ipairs(equipmentList) do
			if v.part < 7 then
				local entity = GoodsEntity.new(v)
				entity.type = GoodsMaster.MATERIAL
	            entity.showDetail = true
	            entity.showFrame = true
				local equipment = GoodsMaster.new(entity)
				equipment:setPosition(2,2)
				userEquipmentBgTable[v.part]:addChild(equipment,10001)
			end
		end
		--装备数据
		reloadEquipSkillGrid()
	end
	
	local function initProNode( ... )
		_uname = CCBCenter.getNodeByTag(_node,10601,"CCLabel")
		_ulevel = CCBCenter.getNodeByTag(_node,10611,"CCLabel")
		_ulastTime = CCBCenter.getNodeByTag(_node,10605,"CCLabel")
		_usex = CCBCenter.getNodeByTag(_node,10603)--sprite
		_personImg = CCBCenter.getNodeByTag(_node,109)--sprite
		_uRank = CCBCenter.getNodeByTag(_node,10604,"CCLabel")
		_cname = CCBCenter.getNodeByTag(_node,10607,"CCLabel")
		_clevel = CCBCenter.getNodeByTag(_node,10608,"CCLabel")
		_cstar = CCBCenter.getNodeByTag(_node,10609)
		_cgroup = CCBCenter.getNodeByTag(_node,10610,"CCLabel")
		_cIcon = CCBCenter.getNodeByTag(_node,10612)
		
		-- android上的位置调整
		util.modifyPositionInAndroid(_ulastTime, 2, -3) 	 		-- 最后登录时间
		util.modifyPositionInAndroid(_cname, 0, -4) 	 			-- 主卡牌名称
	end 

	--显示玩家具体信息回调callBackShowPlayDetailL
	local function callBackShowPlayDetail( entityPlay, param )
	    	-- print("USERINFO:"..json.encode(entityPlay))
            _nodeTable.data = entityPlay
			_userInfo = entityPlay
	    	_uname:setString(_userInfo:getHero():getName())
	    	_ulevel:setString(_userInfo:getHero():getLv())
	    	_ulastTime:setString(_userInfo:getHero():getLastdate())
	    	_uRank:setString(_userInfo:getHero():getRank())
	    	_cname:setString(_userInfo:getCard():getCardName())
	    	-- _clevel:setString(_userInfo:getCard():getLv())

	    	--天赋
	    	createTable()
	    	local talentArr = string.split(string.split(_userInfo:getTalent(), "|")[1], ",")
	    	_gridTable:setItems(talentArr)
	    	--总攻击
			CCBCenter.getNodeByTag(_node, 10614,"CCLabel"):setString(_userInfo:getPlayerTalentsEntity():getAllRaceAtk())
			--总血量
			CCBCenter.getNodeByTag(_node, 10615,"CCLabel"):setString(_userInfo:getPlayerTalentsEntity():getAllRaceHp())

			--胜率
			CCBCenter.getNodeByTag(_node, 10617,"CCLabel"):setString(_userInfo:getHero():getWinrate())
	    	--星星
	    	local star = require("cardui.LinearStar").new({ 
	    	 	fileName = "card/img_card_star.png",
	    	 	margin = ccp(3, 0), 
	    	 	count = _userInfo:getCard():getCardStar(), 
	    	 	unitScale = 0.8, })
		 	util.alignNodeWithPadding(star, _cstar:getContentSize(), display.LEFT_CENTER, {left = -20, bottom = 16})
	    	_cstar:addChild(star)
	    	_cgroup:setString(_userInfo:getCard():getRace())
	    	-- 创建下角色
			local perISp = _userInfo:getHero():createPlayerView{randomAction = true}
			perISp:setPosition(260, 390)
			_node:addChild(perISp)
			local rightNode = CCBCenter.getNodeByTag(_node,106)
			local sexImSp = display.newSprite(imgFile, _usex:getPositionX(), _usex:getPositionY())
          	rightNode:addChild(sexImSp)

          	--玩家身上的装备
			createUserEquipmentGrid(_userInfo:getHero():getEquipinfolst())

			--任务总攻击
			CCBCenter.getNodeByTag(_node, 402,"CCLabel"):setString(tostring(_userInfo:getHero():getTotalatk()))
			--任务总血量
			CCBCenter.getNodeByTag(_node, 404,"CCLabel"):setString(tostring(_userInfo:getHero():getTotalhp()))

          	--主卡图片
          	-- local cardSp = display.newSprite(_userInfo:getCard():getCardIcon(), _cIcon:getPositionX(), _cIcon:getPositionY())
          	-- cardSp:setScale(0.75)
          	-- rightNode:addChild(cardSp)

    --       	local cardBtn = 
	   --        widget.newButton({ normalImage= _userInfo:getCard():getCardIcon(),
	   --              ignoreAnchor = true, 
	   --              listener = function (  )   
	                   
	   --                 local card = _userInfo:getCard()
	   --                 card:setTalent(tostring(_userInfo:getTalent()))
	                   
	   --                 CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", card)
	   --              end})
	   --      cardBtn:setPosition(_cIcon:getPositionX(), _cIcon:getPositionY())
	   --      cardBtn:setScale(0.75)
	 		-- rightNode:addChild(cardBtn)
            local CardMaster = require("cardui.CardMaster")
            local cardEntity = _userInfo:getCard()
            cardEntity.type = CardMaster.MINICARD
            cardEntity.showDetail = true
            cardEntity:setMain(TRUE)
            cardEntity:setTalent(_userInfo:getTalent())
            cardEntity:setEquipEffect(_userInfo:getHero():getEquipEffect())
            local cardView = CardMaster.new(_userInfo:getCard())
            cardView:setScale(0.8)
            local node = CCBCenter.getNodeByTag(_node, 10612)
            node:addChild(cardView, 0)
            util.alignNode(cardView, node:getContentSize(), display.CENTER)
            local cardLvLabel = widget.newTTFLabelWithShadow{
                text = "LV:" .. cardEntity:getLv(),
                size = 18,
            }
            node:addChild(cardLvLabel, 1)
            util.alignNode(cardLvLabel, node, display.LEFT_BOTTOM, {left = 4})
          	-- local cardSpKuang = display.newSprite("friend/friendPanel/friendHerokuang.png", _cIcon:getPositionX(), _cIcon:getPositionY())
          	-- cardSpKuang:setScale(0.75)
          	-- rightNode:addChild(cardSpKuang)

          	-- local entityCard = _userInfo:getCard()
           --  entityCard:setMain(TRUE)
           --  entityCard:setTalent(_userInfo:getTalent())
          	-- entityCard:setEquipEffect(_userInfo:getHero():getEquipEffect())
          	-- widget.bindTouchEvent{layer = util.toCCLayer(CCBCenter.getNodeByTag(_node,10613)) , clickListener = function (  )
          	-- 	CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", entityCard)
          	-- end}

          	if _userInfo:getIsfriend() == 1 then 
          		--103 删除
          		CCBCenter.getNodeByTag(_node,103):setVisible(true)
          	elseif _userInfo:getIsfriend() == 0 then 
          		--104 申请	
          		CCBCenter.getNodeByTag(_node,104):setVisible(true)
          	end
			if _nodeTable["showPk"] then
          		CCBCenter.getNodeByTag(_node,102):setVisible(false)
          	end

          	if _nodeTable["showBtn"] then
          		
          		CCBCenter.getNodeByTag(_node,102):setVisible(false)
          		CCBCenter.getNodeByTag(_node,103):setVisible(false)
          		CCBCenter.getNodeByTag(_node,104):setVisible(false)
          		CCBCenter.getNodeByTag(_node,105):setVisible(false)
          	end
          	
          	if _userInfo:getHero():getId() == 1 then
          		CCBCenter.getNodeByTag(_node,103):setVisible(false)
          	end
	end

--cell内容设置
	local function createCell( grid,index,item )
    		 
	 		local cell = display.newLayer()
	 		cell:ignoreAnchorPointForPosition(false)
			cell:setContentSize(grid:getCellSize())

          	local lastLoginTimeStrLB = widget.newTTFLabelWithShadow{ 
                size = 15,
                color = ccc3(0, 74, 36),
                text = _userInfo:getPlayerTalentsEntity():getTalentValue(tonumber(index)),
                textAlign = ui.TEXT_ALIGN_CENTER,
           	}
           	lastLoginTimeStrLB:setAnchorPoint(ccp(0, 0))
           	cell:addChild(lastLoginTimeStrLB)
           	util.alignNodeWithPadding(lastLoginTimeStrLB, cell:getContentSize(), display.CENTER, {left = 10})
            
    	--天赋图标 
          	local talentSp = display.newSprite(format("friend/friendPanel/%s",_userInfo:getPlayerTalentsEntity():getTalentImg(tonumber(index))))
          	util.alignNodeWithPadding(talentSp, cell:getContentSize(), display.LEFT_CENTER, {}) 
          	cell:addChild(talentSp) 
		return cell
    end
    
	--创建table
    function createTable()
    
     	local function createItemCellListener( grid,index,item )
        	local cell = createCell(grid,index,item)
          	return cell
	    end

	    local function modifyItemCellListener( grid,index,item,itemCell )
	    end

	    local function tapListener( grid,index,item )
	    end

	--tableNode
	    _tableNode = CCBCenter.getNodeByTag(_node, 110) 

	    _gridTable = widget.newScrollGrid{
	        contentSize = _tableNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( _tableNode:getContentSize().width/3, _tableNode:getContentSize().height/3),
	            padding = { 
	                middleH = 0, middleV = 0,
	                left = 0, right = 0, top = 0, bottom = 0,
	            },
	            row = 3,
	            createItemCellListener = createItemCellListener,
	            modifyItemCellListener = modifyItemCellListener,
	            tapListener = tapListener,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = _tableNode,
	    }
	    
	end  

	--技能长度
	local function getSkillSize ( msg,width )
		-- body
		local width,height = MessageModel.getMessageSize(
														msg,
														nil,
														18,
														1.5,
														width);
		
		return CCSize(width,height)
	end

	--装备技能列表
	local function createEquipSkillGrid( ... )

			--scrollview
	    local function createItemCellListener( grid, index, item )
	        local gridCell = widget.newLayer{contentSize = CCSize(110,20)}
       		-- 装备技能
	        local textSize = getSkillSize(item,_nodeEquipSkill:getContentSize().width)

			local equipSkill = ui.newTTFLabel{
                size = 18,
                text = item,
                dimensions = textSize
			}

          	gridCell:addChild(equipSkill)

          	gridCell:setContentSize(CCSize(_nodeEquipSkill:getContentSize().width,textSize.height ))
       	  
          	return gridCell
	    end

	    --scrollview
	    local scrollGrid = widget.newScrollLinear{
	        x = 0,
	        y = 0,
	        contentSize = _nodeEquipSkill:getContentSize(),
		    cellAtIndexListener = createItemCellListener,
	        contentParams = {
					            column = 1,
					            tapListener = tapListener,
					            selectedParams = nil,
					        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	    }
	    _nodeEquipSkill:addChild(scrollGrid);

	    return scrollGrid
	end 


	local function initViews()
			initProNode()
		--装备技能
		_nodeEquipSkill = CCBCenter.getNodeByTag(_node, 10618)
		--技能列表
		_equipSkillGrid = createEquipSkillGrid()
	end
 
	
--[[ ## public fuction --]]
	_node.callBackShowPlayDetail = callBackShowPlayDetail

--[[ ## MAINs --]]
	initViews()
end

return M