--GoodsAlertLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[GoodsAlertLayerView]"
	local _node, _nodeTable = node, luaValue
    local _goodsEntity = _node._DATA
    local ChatUtil = require("ccb.m.chat.ChatUtil")
--[[ ## local fuction --]]
    -- 说明
    local function addDetailView( string )
        local node = CCBCenter.getNodeByTag(_node, 10402)
        local scrollView = widget.newScrollView{
            -- bounceable = false, 
            contentSize = node:getContentSize(), 
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL, 
        }
        node:addChild(scrollView)
        local textLabel = ui.newTTFLabel{text = "" , color = COLOR_WHITE, size = 16}
        local size = scrollView:getContentSize()
        textLabel:setDimensions(CCSize(size.width, 0))
        textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
        textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
        textLabel:setString(string)
        scrollView:setContainer(textLabel)
        scrollView:updateInset()
        util.autoFixScrollView(scrollView)
    end
    -- 图标
    local function addGoodsIcon( file )
        local node = CCBCenter.getNodeByTag(_node, 1030102)
        local sprite = widget.newSprite{file = file}
        node:addChild(sprite, 1)
        util.alignNode(sprite, node:getContentSize(), display.CENTER)
    end
    -- 图标背景
    local function addGoodsIconBG( file )
        local node = CCBCenter.getNodeByTag(_node, 1030102)
        local bgSprite = widget.newSprite{ file = file}
        node:addChild(bgSprite, 0)
        util.alignNode(bgSprite, node:getContentSize(), display.CENTER)
    end
    -- 数据更新
    local function updateGoodsInfo( )
        -- 物品名
        local goodsName = _goodsEntity:getName()
        if goodsName then
            _nodeTable["mGoodsNameLabel"]:setString(goodsName)
            _nodeTable["mGoodsNameLabel"]:setColor(_GAME.CONFIG.GOODS.QUALITY[_goodsEntity:getQuality()].rgb)
        end
        -- 类型
        local goodsType = _goodsEntity:getTypString()
        if goodsType then
            _nodeTable["mTypeLabel"]:setString(string.format(_s("GOODS_TYPE"), goodsType))
        end
        -- 等级
        -- local goodsType = _goodsEntity:getTypString()
        -- if goodsType then
        _nodeTable["mLevelLabel"]:setString(string.format(_s("GOODS_LEVEL"), 0))
        -- end
        -- 需求等级
        -- local goodsType = _goodsEntity:getTypString()
        -- if goodsType then
        _nodeTable["mNeedLevelLabel"]:setString(string.format(_s("GOODS_NEED_LEVEL"), 0))
        -- end
        -- 说明
        local goodsDetail = _goodsEntity:getDetails()
        if goodsDetail then
            addDetailView(goodsDetail)
        end
        -- 售价
        local goodsPrice = _goodsEntity:getPrice()
        if goodsPrice then
            _nodeTable["mSellLabel"]:setString(string.format(_s("GOODS_PRICE"), goodsPrice))
        end
        -- 图标
        local goodsIcon = _goodsEntity:getGoodsIcon()
        if goodsIcon then
            addGoodsIcon(goodsIcon)
        end
        -- 背景图
        local bgGoodsIcon = _GAME.CONFIG.GOODS.QUALITY[_goodsEntity:getQuality()].frame
        if bgGoodsIcon then
            addGoodsIconBG(bgGoodsIcon)
        end
    end
    -- 封装聊天发送装备名字      
    local function getChatSendRealEquipName( equipname, eid, pid, quality)
        if equipname == nil then return "" end
        if eid == nil or pid == nil or quality == nil or not isnumber(eid) or not isnumber(pid) or not isnumber(quality) or quality < 1 or quality > 5 then return equipname end
        if eid <= 0 or pid <= 0 then return equipname end
        local str = "[" .. equipname .. GAMERATE:getChatEquipFlag() .. eid .. GAMERATE:getChatEquipFlag() .. quality .. GAMERATE:getChatEquipFlag() .. pid .. "]"
        return str
    end

    -- 封装聊天发送物品名字       
    local function getChatSendRealGoodsName( goodname, no, quality, pid )
        if goodname == nil then return "" end
        if no == nil or not isnumber(no) or quality == nil or not isnumber(quality) then return goodname  end
        if no <= 10000 or no > 20000 or quality < 1 or quality > 5 then return goodname end 
        if pid == nil or not isnumber(pid) then return goodname end
        if pid <= 0 then return goodname end
        local str = "[" .. goodname .. GAMERATE:getChatGoodsFlag() .. no .. GAMERATE:getChatGoodsFlag() .. quality .. GAMERATE:getChatGoodsFlag() .. pid .. "]"
        return str
    end
    local function shareToChat( button )
        button.setStateDisabled(true)
        local sendString 
        if 10000 < _goodsEntity:getNo() and _goodsEntity:getNo() < 20000 then
            sendString = getChatSendRealGoodsName(_goodsEntity:getName(), _goodsEntity:getNo(), _goodsEntity:getQuality(), ME:getUserid())
        elseif _goodsEntity:getNo() > 20000 then
            sendString = getChatSendRealEquipName(_goodsEntity:getName(), _goodsEntity:getNo(), ME:getUserid(), _goodsEntity:getQuality())
        end
        if sendString and ME:CanSpeak() then
            --   创建http请求
            NetHelper.createRequest(
                
                ACTID.MSG_SEND_CHAT,                     -- 请求id
                function ( properties, params )
                    NetHelper.QuickToast(_s("CHAT_SEND_SUCCESS"))
                end,                       -- 回调函数
                {
                    messagetype = ChatUtil.ChatWorld,   -- 消息类型 默认都是世界
                    content = sendString,               -- 内容   
                    touserid = 0,                       -- 接收者id，这里为0
                },                                      -- 请求信息实体或参数table
                { 
                    showLoading = false,
                }                           
            )
        end
    end
    local function updateAlertView( )
        -- 分享按钮
        if _goodsEntity.shareButton and _goodsEntity:getQuality() >= 2 and _GAME.CONFIG.SDK_PLATFORM.chat ~= false then
            local shareButton = widget.newButton{
                normalImage = "btn_share.png",
                scale = 1.1,
                listener = shareToChat,
                labelParams = {text = _s("GOODS_SHOW_OFF"), color = BUTTON_COLOR3.BROWN, size = 16, padding = {top = 20}},
            }
            -- _node:addChild(shareButton)
            CCBCenter.getNodeByTag(_node, 2):addChild(shareButton)
            util.alignNode(shareButton, CCBCenter.getNodeByTag(_node, 2))
        end
        if _goodsEntity.userName and _goodsEntity.userName ~= "" then
            _nodeTable["mEquipPoiLabel"]:setString(_s("EQUIP_HERO_HAVE", _goodsEntity.userName))
        end
    end
	local function initViews()
		updateGoodsInfo()
        updateAlertView( )
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M