--GoodsChangeNameAlertLayer.lua
local ChatUtil                  = require("ccb.m.chat.ChatUtil")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[GoodsChangeNameAlertLayerView]"
	local _node, _nodeTable = node, luaValue
    local _editBox
    local MAX_LENGTH    = 10
--[[ ## local fuction --]]
    local function createEditBox( )
        local layer = CCBCenter.getNodeByTag(_node, 2)
        local editbox = widget.newEditBox{
            contentSize = CCSize(layer:getContentSize().width, layer:getContentSize().height) ,
            normalBgImage = {file = "hook_ac.png"},
            textMaxLength = MAX_LENGTH
        }
        editbox:setInputMode(kEditBoxInputModeSingleLine)
        layer:addChild(editbox, 1)
        editbox:setMaxLength(MAX_LENGTH)
        util.alignNode(editbox, layer:getContentSize(), display.CENTER)
        return editbox
    end
	local function initViews()
		_editbox = createEditBox( )
	end

--[[ ## public fuction --]]
    local function resetCode( )
        _editbox:setText("")
    end
    local function getCode( )
        return _editbox:getText()
    end
    -- 是否规范
    local function isCodeCompliance( )
        if getCode( ) == "" then
            NetHelper.QuickToast(_s("GOODS_INPUT_NAME"))
            return false
        elseif ChatUtil.getTextCount2(getCode( )) > 30 then
            NetHelper.QuickToast(_s("GOODS_NAME_OVERFLOW"))
            return false
        else
            return true
        end
    end
--[[ ## MAINs --]]
	initViews()
    _node.resetCode   = resetCode
    _node.getCode   = getCode
    _node.isCodeCompliance   = isCodeCompliance
end

return M