--ActivityFirstChargeLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityFirstChargeLayerView]"
	local _node, _nodeTable = node, luaValue
    local RewardEntity = require("model.main.RewardEntity")
    local _rewardGrid
--[[ ## local fuction --]]
    -- 奖励类容
    local function createRewardGrid( )
        local rewardNode = CCBCenter.getNodeByTag(_node, 203)
        local function cellAtIndex( scrollGrid, idx , item)
            local cell = widget.newLayer{}--color = ccc4(255, 255, 100, 255),}
            cell:setContentSize(scrollGrid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            cell:addChild(item)
            util.alignNode(item, cell)

            return cell
        end
        local function onBtnClick(grid, index, item, x, y)
            if item:getType() == RewardEntity.REWARD_TYPE.CARD or item:getType() == RewardEntity.REWARD_TYPE.CHIP then
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item:getEntity())
            elseif item:getType() == RewardEntity.REWARD_TYPE.GOODS then
                if item:getEntity():getNo() > 20000 then
                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item:getEntity())
                else
                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item:getEntity())
                end
            end
        end
        local scrollGrid = widget.newScrollGrid{
            contentSize = rewardNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(95, 95),
                -- padding = { 
                --     middleH = 20,
                -- },
                row = 1,
                createItemCellListener = cellAtIndex,
                tapListener = onBtnClick,
            },
            -- bounceable = false,
            direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
            parentNode = rewardNode,
        }
        return scrollGrid
    end
	local function initViews()
		_rewardGrid = createRewardGrid()
        local btnSprite = widget.newSprite{file = "main/activity/firstcharge/img_first_charge_button.png"}
        _nodeTable["btnCharge"]:addChild(btnSprite, 11)
        util.alignNode(btnSprite, _nodeTable["btnCharge"])

        local topTitleSprite = widget.newSprite{file = "main/activity/firstcharge/img_first_charge_title.png"}
        local contentTitleSprite = widget.newSprite{file = "main/activity/firstcharge/img_first_charge_content.png"}

        CCBCenter.getNodeByTag(_node, 201):addChild(topTitleSprite)
        CCBCenter.getNodeByTag(_node, 202):addChild(contentTitleSprite)
        
        util.alignNode(topTitleSprite, CCBCenter.getNodeByTag(_node, 201))
        util.alignNode(contentTitleSprite, CCBCenter.getNodeByTag(_node, 202))
	end

--[[ ## public fuction --]]
    local function updateData( data )
        local rewardEntity = RewardEntity.new(data.reward)
        _rewardGrid:setItems(rewardEntity:getRewardViews())
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData     = updateData
end

return M