--ActivityFortuneWheelLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityFortuneWheelLayerView]"
	local _node, _nodeTable = node, luaValue
--[[ ## local fuction --]]
	local function initViews()
	    -- [常量]
	    -- 抽奖标识[首次(免费抽奖)]
	    local LOTTERY_FIRST 			= 1
	    -- 抽奖标识[再次]
	    local LOTTERY_NEXT 				= 0
	    -- 转圈数[最小]
	    local TURN_MIN 					= 6
		-- 转圈数[最大]
	    local TURN_MAX 					= 10
		-- 转圈初始偏移角度
	    local TURN_OFFSET_ANGLE			= 1
		-- 奖励索引[稀有五星]
	    local REWARD_INDEX_RARE_CARD	= 2
		-- 奖励数量
	    local NUM_REWARDS 				= 9



	    

	    




	    -- [操作变量]
	    -- 动画
	    local TDAnimationUtils 			= require(PH_MDL_UTIL .. "TDAnimationUtils")
	    -- 字符串
	    local TDStringUtils 			= require(PH_MDL_UTIL .. "TDStringUtils")
	    -- 数字
	    local TDRandomUtils 			= require(PH_MDL_UTIL .. "TDRandomUtils")
	    -- 聊天
	    local ChatUtil 					= require("ccb.m.chat.ChatUtil")
		-- 实体[列表]
		local EntityList				= require(PH_EN_ACTIVITY .. "EntityActivityFortuneWheelList")
		-- 实体[奖励]
		local EntityReward				= require(PH_EN_ACTIVITY .. "EntityActivityFortuneWheelReward")
		-- 实体[消息]
		local EntityMessage 			= require("ccb.m.chat.EntityChat")
		-- 实体[卡牌]
		local CardEntity 				= require("model.card.CardEntity")
		-- 奖励集合
		local rewards 					= require("static.activity_fw")
		-- 幸运转盘面板
		local FortuneWheelRewardPanel 	= require("cardui.FortuneWheelRewardPanel")

	    -- 抽卡标识
	    local _lotteryTag 				= LOTTERY_NEXT
	    -- 每日抽奖时间
	    local _clock1					= "?"
	    local _clock2					= "?"
	    local _clock3					= "?"
	    local _costDiamond				= 100
	    local _rewardIndex 				= -1
	    local _rewardName 				= "未知奖励"
	    local _rewardObject 			= nil
	    local _rewardScrollLabel 		= nil
	    local _messages 				= {}
	    local _messageMe 				= nil
	    -- 快捷调用
		local N 						= _nodeTable



	    

	    



	    -- [私有方法声明]
	    -- [网络]
    	-- 发起网络请求
    	local netSend
    	-- 接收网络请求
    	local netReceive
    	-- 请求失败回调函数
    	local netReceiveFail
    	-- 发起网络请求[抽奖]
    	local netSendLottery
    	-- 接收网络请求[抽奖]
    	local netReceiveLottery
    	-- 接收网络请求失败[抽奖]
    	local netReceiveFailLottery
    	-- 发起网络请求[奖励请求]
    	local netSendRewardList
    	-- 接收网络请求[奖励请求]
    	local netReceiveRewardList
    	-- 接收网络请求失败[奖励请求]
    	local netReceiveFailRewardList
    	-- 重新加载消息
	    local reloadMessage
	    -- 重新刷新奖励消息
	    local refleshRewardList

	    -- [视图渲染]
    	-- 视图渲染[基础数据]
    	local viewRenderBase
	    -- 视图渲染[回调数据]
	    local viewRenderCallback
	    -- 加载结点
	    local loadNode

	    -- [事件处理]
	    -- 处理点击事件[首次抽奖]
	    local onLotteryFirst
	    -- 处理点击事件[再次抽奖]
	    local onLotteryNext
	    -- 处理抽奖
	    local onLottery

	    -- [Loading]
	    -- 显示Loading
	    local showLoading
	    -- 隐藏Loading
	    local hideLoading

	    -- [抽奖]
	    -- 设置抽奖按钮可用性
	    local setLotteryEnable
	    -- 判断抽奖按钮可用性
	    local isLotteryEnable
		-- 刷新抽奖按钮
		local refleshLotteryButton
	    -- 动画抽奖[转盘]
		local animLotteryTurntable
	    -- 动画抽奖[结果]
		local animLotteryShowResult
		-- 设置奖励信息
		local setRewardInfo

	    -- [Util]
		-- 获得结点
		local NODE


	        

	        





	    -- [私有方法定义]
	    -- [实例方法][网络]
    	-- 发起网络请求
    	function netSend()
		    -- [正式请求]
		    --[[
		    ]]
		    -- 请求参数
		    local params = {
                failedCb    = netReceiveFail,          -- 请求失败回调函数
			}

		    -- 显示Loading
		    showLoading()
		    -- 请求动作
		    NetHelper.createRequest(
		       ACTID.MSG_GET_DRAWPRIZE_LIST,           	-- 请求ID
		       netReceive,                              -- 回调函数
		       params 									-- 请求参数
		    )
		    

		    -- [测试请求]
		    --[[
    		-- 参数解析
    		local clockArray = TDStringUtils.split("0|14|23", "|")

		    -- 设置数据对象
		    _lotteryTag 	= LOTTERY_FIRST
		    _clock1 		= clockArray[1]
		    _clock2 		= clockArray[2]
		    _clock3 		= clockArray[3]
		    _costDiamond 	= 0

		    viewRenderCallback()
		    ]]
    	end
    	-- 接收网络请求
    	function netReceive(properties, markFields)
    		-- 参数解析
    		local entity 	 = EntityList.new(properties)
    		local clockArray = TDStringUtils.split(entity:getRefreshTime(), "|")
    		-- dump(properties)

		    -- 设置数据对象
		    _lotteryTag 	= entity:getTurnNum()
		    _clock1 		= clockArray[1]
		    _clock2 		= clockArray[2]
		    _clock3 		= clockArray[3]
		    _costDiamond 	= entity:getDamPrice()

		    -- 视图渲染[基础数据]
		    viewRenderCallback()
		    -- 隐藏Loading
		    hideLoading()
    	end
    	-- 接收网络请求失败
    	function netReceiveFail()
    		-- 重新发起网络请求
    		netSend()
    	end

    	-- 发起网络请求[抽奖]
    	function netSendLottery()
		    -- [正式请求]
		    --[[
		    ]]
		    -- 请求参数
		    local params = {
                failedCb    = netReceiveFailLottery,          -- 请求失败回调函数
			}

		    -- 显示Loading
		    showLoading()
		    -- 请求动作
		    NetHelper.createRequest(
		       ACTID.MSG_GET_DRAWPRIZE_RECEIVE,        	-- 请求ID
		       netReceiveLottery,               		-- 回调函数
		       params 									-- 请求参数
		    )
		    

		    -- [测试请求]
		    --[[
		    local properties = {
		    	index = TDRandomUtils.num(1, 9),
			}

	    	-- 执行转盘动画
	    	lottery(properties.index)
		    ]]
    	end
    	-- 接收网络请求[抽奖]
    	function netReceiveLottery(properties, markFields)
		    -- 设置数据对象
		    local entity 	= EntityReward.new(properties)
		    -- 设置奖励信息
		    setRewardInfo(entity)

		    -- 隐藏Loading
		    hideLoading()
	    	-- 执行转盘动画
	    	lottery(index)

	    	-- 刷新主界面显示
--	    	if MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW then
--                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_UPDATEPLAYERINFOWITHOUTPOPUPWINDOW)
--	    	end
    	end
    	-- 接收网络请求失败[抽奖]
    	function netReceiveFailLottery()
    		CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONENABLECLOSE)
    		NetHelper.QuickToast(_s("NETWORK_CONNECT_FAILED"))
    	end

    	-- 发起网络请求[奖励请求]
    	function netSendRewardList()
		    -- 请求参数
		    local params = {
                failedCb    = netReceiveFailRewardList,        	-- 请求失败回调函数
                kind 		= ChatUtil.ChatWorld, 				-- 消息类型
			}

	        NetHelper.createRequest(
	           ACTID.MSG_GET_CHATLIST,                  -- 请求id
	           netReceiveRewardList,                   	-- 回调函数
	           params,
	           { showLoading = false }
	        )
    	end
    	-- 接收网络请求[奖励请求]
    	function netReceiveRewardList(properties, params)
	        Log.d(TAG, "chat: %s", json.encode(properties))

	        local messages = EntityMessage.new(properties)
	        reloadMessage(messages:getItems())
	    end
    	-- 接收网络请求失败[奖励请求]
    	function netReceiveFailRewardList()
    		NetHelper.QuickToast(_s("NETWORK_CONNECT_FAILED"))
    	end
    	-- 重新加载消息
	    function reloadMessage(messageItems)
	        -- 加到信息集合
	        if messageItems then 
	            for i = 1, #messageItems do
	                local item = messageItems[i]

	                if item and (item:getSenderId() ~= ME:getUserid() or item:getMessageType() == ChatUtil.ChatSystem) and item:getIsBigShow() == 2 then 
	                    
	                    -- 初始化表格集合
	                    local initItem = {}

	                    -- 消息头添加消息类型
	                    initItem[#initItem + 1] = { f = 0 , w = "[" .. ChatUtil.ChatTypeStr[item:getMessageType()] .. "]" }

	                    -- 消息人
	                    local nname = item:getSenderNickName() or ""
	                    if nname ~= "" and item:getMessageType() ~= ChatUtil.ChatSystem then 
	                        nname = nname .. "：" 
	                    end
	                    -- 消息人ID
	                    if item:getSenderId() == -1 then item:setSenderId(ME:getUserid()) end
	                    initItem[#initItem + 1] = { f = 1 , w = nname, o = item:getSenderId()}

	                    -- 生成表格集合
	                    local cellItems = ChatUtil.createCellItems(initItem, item:getContent())

	                    for i = 1,#cellItems do
	                        _messages[#_messages + 1] = { cellItem = cellItems[i], ctype = item:getMessageType(), key = item:getKey() }
	                    end
	                    
                        if _rewardScrollLabel ~= nil then 
                            _rewardScrollLabel.setEntities({messages = _messages})
                        end
	                end

	            end
	        end

	        -- 太多了，清除1页
	        if #_messages > ChatUtil.maxMsgCount then 
	            local count = #_messages - ChatUtil.maxMsgCount
	            for i = 1,count do
	                table.remove(_messages, 1)
	            end
	        end
	    end
    	-- 重新刷新奖励消息
    	function refleshRewardList()
	    	if #globalMessagesFW > 0 then 
		    	dump(globalMessagesFW)
			end

			local numMessages = #globalMessagesFW
			if numMessages > 0 then 
				for i = 1, numMessages do
					local message = globalMessagesFW[1]

					table.remove(globalMessagesFW, 1)					
					table.insert(_messages, message)
				end
	                    
                if _rewardScrollLabel ~= nil then 
                    _rewardScrollLabel.setEntities({messages = _messages})
                end
			end
    	end


	    ---------


	    -- [实例方法][视图渲染]
    	-- 视图渲染[基础数据]
    	function viewRenderBase()

    	end

	    -- 视图渲染[回调数据]
	    function viewRenderCallback()
	    	-- 加载结点
	    	loadNode()
		end
		
		-- 加载结点
		function loadNode()
			-- 抽奖按钮
			if _lotteryTag == LOTTERY_FIRST then 
				NODE(203):setVisible(true) 						-- N["btnLotteryFirst"]
				NODE(204):setVisible(false)						-- N["btnLotteryNext"]
			else
				NODE(203):setVisible(false) 					-- N["btnLotteryFirst"]
				NODE(204):setVisible(true)						-- N["btnLotteryNext"]
			end

	    	-- 每日抽奖时间
	    	N["lblClock1"]:setString(_clock1)
	    	N["lblClock2"]:setString(_clock2)
	    	N["lblClock3"]:setString(_clock3)
	    	_nodeTable["mTipLabel"]:setString(_s("ACTIVITY_FW_TIME_TIP", _clock1, _clock2, _clock3))

	    	-- 设置可用性标识
	    	setLotteryEnable(NODE(20301), true)
	    	setLotteryEnable(NODE(20401), true)

	    	-- 再次抽奖钻石显示
	    	_node:setButtonTitle("btnLotteryNext", tostring(_costDiamond))

	    	-- 设置奖励列表
        	_rewardScrollLabel = FortuneWheelRewardPanel.new{contentSize = N["lyrRewardScrollView"]:getContentSize(), onComplete = function() end, }
		    NODE(202):addChild(_rewardScrollLabel)
	        util.delayCall(function()
	            _rewardScrollLabel:schedule(refleshRewardList, 3)
	        end, LOAD_DELAY_TIME )
		end


	    ---------


	    -- [事件处理]
	    -- 处理点击事件[首次抽奖]
	    function onLotteryFirst()
	    	-- print("onLotteryFirst()")

	    	-- 定义数据源
	    	local sender = NODE(20301)
	    	-- 处理抽奖
	    	onLottery(sender)
	    end

	    -- 处理点击事件[再次抽奖]
	    function onLotteryNext()
	    	-- print("onLotteryNext()")
	    	onLottery(NODE(20401))

	   --  	-- 过滤判断
		  --   AlertLayer.new{
		  --       titleStr 	= _s("COMMON_NEWS_TIPS"),  										-- 标题
		  --       content 	= string.format(_s("ACTIVITY_FW_TIP_BUYNEXT"), _costDiamond), 	-- 内容
		  --       btnStr 		= { _s("COMMON_OK"), _s("COMMON_CANCEL") },						-- 按钮文字数组
		  --       btnColor 	= { AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_YELLOW, },
		  --       -- 按钮颜色数组
				-- btnClickEvent = { 					-- 按钮事件数组
				-- 	function() 						-- 按钮[确定]回调
				--     	-- 定义数据源
				--     	local sender = NODE(20401)
				--     	-- 处理抽奖
				--     	onLottery(sender)
			 --        end,
			 --        function() 						-- 按钮[取消]回调
			 --        end
				-- }, 
		  --   }
	    end

	    -- 处理抽奖
	    function onLottery(sender)
	    	-- 过滤判断
	    	if not isLotteryEnable(sender) then 
	    		-- print("Lottery is disable!")
	    		return
	    	end

	    	-- 设置按钮状态
	    	setLotteryEnable(sender, false)
	    	-- 发送网络请求（抽奖）
	    	netSendLottery()
	    end

	    -- 动画抽奖
	    function lottery(index)
	    	-- print("lottery(index)", index)

	    	CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONDISENABLECLOSE)
            -- [动画显示]
            animLotteryTurntable(
            	animLotteryShowResult
            )
	    end

	    -- 动画抽奖[转盘]
	    function animLotteryTurntable(callback)
			-- 转盘
	    	local node 			= N["sptTurntable"]
	    	local array 		= {}
	    	local turn 			= TDRandomUtils.num(TURN_MIN, TURN_MAX)
	    	local delay 		= 0
	    	local time1 		= .3
	    	local time2 		= 12
	    	local time3 		= 1.0
	    	local rotationFix   = 1
	    	local rotation1 	= -TURN_OFFSET_ANGLE
	    	local rotation2 	= TURN_OFFSET_ANGLE + 360 * turn 
	    	local rotation2 	= rotation2 + (360 / NUM_REWARDS) * (_rewardIndex - .5) + rotationFix


	    	-- 初始设置
	    	-- ..
	    	-- 延迟
	    	if delay ~= 0 then 
	    		array[#array + 1] = CCDelayTime:create(delay)
	    	end
	    	-- 声音
	    	array[#array + 1] = CCCallFunc:create(function() --[[ SOUND:playEffectFightRewardAdvanced() --]] end)
	    	-- 旋转1（初始偏移）
	    	array[#array + 1] = CCEaseOut:create(
	    		CCRotateBy:create(time1, rotation1),
	    		2
	    	)
	    	-- 旋转2
	    	array[#array + 1] = CCEaseExponentialInOut:create(
	    		CCRotateBy:create(time2, rotation2)
	    	)
	    	-- 旋转3
	    	--[[
	    	array[#array + 1] = CCEaseOut:create(
	    		CCRotateBy:create(time3, rotation3),
	    		2
	    	)
	    	]]
	    	-- 回调函数
	    	if callback then 
		    	array[#array + 1] = CCCallFunc:create(function()
		    		callback()
		    	end)
		    end

	    	node:runAction(TDAnimationUtils.sequence(array))
	    end

	    -- 动画抽奖[结果]
	    function animLotteryShowResult(callback)
	    	-- 添加自己获奖消息
			local numMessages = #globalMessageMeFW
			if numMessages > 0 then 
				for i = 1, numMessages do
					local message = globalMessageMeFW[1]

					table.remove(globalMessageMeFW, 1)					
					table.insert(_messages, message)
				end
	                    
                if _rewardScrollLabel ~= nil then 
                    _rewardScrollLabel.setEntities({messages = _messages})
                end
			end
						
			-- 显示[结果]对话框
			-- Version1: 
			--[[
		    AlertLayer.new{
		        titleStr 	= _s("COMMON_NEWS_TIPS"),  			-- 标题
		        content 	= string.format(_s("ACTIVITY_FW_RESULT"), _rewardName), -- 内容
		        btnStr 		= { _s("COMMON_OK") },			-- 按钮文字数组
		        btnColor 	= { AlertLayer.BTN_COLOR_YELLOW, },
		        -- 按钮颜色数组
				btnClickEvent = { 					-- 按钮事件数组
					function() 						-- 按钮[确定]回调
				    	-- 重新校正转盘偏移位置
				    	N["sptTurntable"]:setRotation(0)
				    	-- 获得抽奖按钮
			        	refleshLotteryButton()
			        end,
				}, 
		    }
		    ]]
			-- Version2:
			CCBCenter.loadCCB(
				"MSG_RECEIVEREWARDALERTLAYER_MODEL", "ccb.c.main.ReceiveRewardAlertLayer", 
				{entity = _rewardObject, onConfirm = function()
					CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINACTIVITYLAYER_ACTION_ONENABLECLOSE)
			    	-- 重新校正转盘偏移位置
			    	N["sptTurntable"]:setRotation(0)
			    	-- 获得抽奖按钮
		        	refleshLotteryButton()
				end}
			)
	    end

		-- 设置奖励信息
		function setRewardInfo(entity)
			local index = entity:getPrizeNum()

			-- Version1: 
			if index >= 0 then 
				_rewardIndex = index
				_rewardName  = rewards[index]
			else
				_rewardIndex = REWARD_INDEX_RARE_CARD
				_rewardName  = _s("ACTIVITY_FW_RARECARD") .. CardEntity.new({ id = math.abs(index) }):getCardName() 
			end


			-- Version2: 
			local RewardClass = require("model.main.RewardEntity")
			--[[
				ACTIVITY_FW_REWARD1 					= "初级经验卡",
				ACTIVITY_FW_REWARD2 					= "随机稀有5星",
				ACTIVITY_FW_REWARD3 					= "80钻",
				ACTIVITY_FW_REWARD4 					= "8000金币",
				ACTIVITY_FW_REWARD5 					= "高级经验卡",
				ACTIVITY_FW_REWARD6 					= "抽卡礼券50张",
				ACTIVITY_FW_REWARD7 					= "200友情点",
				ACTIVITY_FW_REWARD8 					= "抽卡礼券1张",
				ACTIVITY_FW_REWARD9 					= "500钻",
			--]]
			if index == 1 then 
				_rewardObject = RewardClass.new({cards = {{id = 1001},}})
			elseif index == 2 then 
				
			elseif index == 3 then 
				_rewardObject = RewardClass.new({diamond = 80,})
			elseif index == 4 then 
				_rewardObject = RewardClass.new({gold = 8000,})
			elseif index == 5 then 
				_rewardObject = RewardClass.new({cards = {{id = 1003},}})
			elseif index == 6 then 
				_rewardObject = RewardClass.new({freebuy = 5,})
			elseif index == 7 then 
				_rewardObject = RewardClass.new({fp = 200,})
			elseif index == 8 then 
				_rewardObject = RewardClass.new({freebuy = 1,})
			elseif index == 9 then 
				_rewardObject = RewardClass.new({diamond = 500,})
			elseif index < 0 then
				_rewardObject = RewardClass.new({cards = {{id = math.abs(index)},}})
			end
		end


	    ---------


	    -- [Loading]
	    -- 显示Loading
	    function showLoading()
	    	NetHelper.showLoading(true, true)
	    end

	    -- 隐藏Loading
	    function hideLoading()
	    	NetHelper.hideLoading(true)
	    end


	    ---------


	    -- [抽奖]
	    -- 设置抽奖按钮可用性
	    function setLotteryEnable(sender, isEnable)
	    	sender:setEnabled(isEnable)
	    	sender._isEnable_ = isEnable
		end

	    -- 判断抽奖按钮可用性
	    function isLotteryEnable(sender)
	    	return (type(sender._isEnable_) == "boolean" and sender._isEnable_ == true)
		end

		-- 刷新抽奖按钮
		function refleshLotteryButton()
			-- 设置抽奖标识为再次 （非第一次抽奖）
			_lotteryTag = LOTTERY_NEXT

			-- 抽奖按钮
			if _lotteryTag == LOTTERY_FIRST then 
				NODE(203):setVisible(true) 						-- N["btnLotteryFirst"]
				NODE(204):setVisible(false)						-- N["btnLotteryNext"]
			else
				NODE(203):setVisible(false) 					-- N["btnLotteryFirst"]
				NODE(204):setVisible(true)						-- N["btnLotteryNext"]
			end

			setLotteryEnable(NODE(20401), true)
		end


	    ---------


	    -- [Util]
		-- 获得结点
		function NODE(nodeTag)
			return CCBCenter.getNodeByTag(_node, nodeTag)
		end


	        

	        





	    -- [具体操作]
    	-- 视图渲染[基础数据]
    	viewRenderBase()
    	netSend()


	        

	        





	    -- [赋加属性]
	    -- 处理点击事件[首次抽奖]
		_node.onLotteryFirst 				= onLotteryFirst
	    -- 处理点击事件[再次抽奖]
		_node.onLotteryNext 				= onLotteryNext
		
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M