--ActivityInviteLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityInviteLayerView]"
	local _node, _nodeTable = node, luaValue
	local _scrollGrid
	local _shareShowStr
	local _diamondGrid
--[[ ## local fuction --]]

	local function createFriendsGrid( )
		local node = CCBCenter.getNodeByTag(_node, 305)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(node:getContentSize().width, 50))

			-- 背景
			local bgSprite = widget.newScale9{
				file = "main/activity/invitefriends/bg_friend_cell.png",
				contentSize = CCSize(node:getContentSize().width,50),
				rect = CCRectMake(0, 0, 24, 27),
			}
			cell:addChild(bgSprite)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER )

			-- 被邀请用户名
			local name = ui.newTTFLabel{text = _s("ACTIVITY_PLAYER") .. item.username , valign = ui.TEXT_VALIGN_BOTTOM, size = 20, color = ccc3(0, 0, 0)}
			cell:addChild(name)
			util.alignNodeWithPadding(name, cell:getContentSize(), display.TOP_LEFT )

			-- 首月已充钻石数
			local diamonds = ui.newTTFLabel{text = _s("ACTIVITY_FIRST_MONTH_RECHARGE") .. item.diamonds , valign = ui.TEXT_VALIGN_BOTTOM, size = 20, color = ccc3(0, 0, 0)}
			cell:addChild(diamonds)
			util.alignNodeWithPadding(diamonds, cell:getContentSize(), display.BOTTOM_LEFT )

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		_scrollGrid = widget.newScrollGrid{
	        contentSize = CCSize(node:getContentSize().width, node:getContentSize().height),
	        contentParams = {
	            cellSize = CCSize(node:getContentSize().width, 53),
	            padding = { 
	                middleH = 4, middleV = 4,
	            },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = node,
	    }
	    util.autoFixScrollView(_scrollGrid)
	end
	local function createDiamondGrid( )
		local node = CCBCenter.getNodeByTag(_node, 306)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			cell:setContentSize(CCSize(node:getContentSize().width, 30))

			local params = {{text = item.title, size = 24},
			{text = item.count, size = 24, color = ccc3(248, 112, 86)}}

			local  linearLabel = widget.newLinearLabel({paramTable = params})
			util.alignNode(linearLabel, cell,display.CENTER_LEFT)
			cell:addChild(linearLabel)

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		_diamondGrid = widget.newScrollGrid{
	        contentSize = CCSize(node:getContentSize().width, node:getContentSize().height),
	        contentParams = {
	            cellSize = CCSize(node:getContentSize().width, 32),
	            padding = { 
	                middleH = 4, middleV = 4,
	            },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = node,
	    }
	    util.autoFixScrollView(_diamondGrid)
	end
	local function initViews()
		createFriendsGrid( )
		createDiamondGrid()
		_nodeTable.mUserNoLabel:setString(ME:getUserno())

		local isShare = GAMERATE:getIsShare() == 1 --and not isandroid()

		_nodeTable["btnSinaWeibo"]:setEnabled(isShare)
		_nodeTable["btnTencentWeibo"]:setEnabled(isShare)
		_nodeTable["btnWechat"]:setEnabled(isShare)
		_nodeTable["btnFacebook"]:setEnabled(isShare)
		_nodeTable["btnTwitter"]:setEnabled(isShare)

		-- 以下是根据sdk配置进行显示控制的,在sdk中以share为key的table中设置需要显示的项,若无share则表示全显示
		local share = _GAME.CONFIG.SDK_PLATFORM.share
		if table.isnotempty(share) then 
			_nodeTable["btnSinaWeibo"]:setVisible(table.contains(share, "sinaweibo")) 
			_nodeTable["btnTencentWeibo"]:setVisible(table.contains(share, "tencentweibo")) 
			_nodeTable["btnWechat"]:setVisible(table.contains(share, "wechat")) 
			_nodeTable["btnFacebook"]:setVisible(table.contains(share, "facebook")) 
			_nodeTable["btnTwitter"]:setVisible(table.contains(share, "twitter")) 
		end

		CCBCenter.getNodeByTag(_node, 210):setVisible(not isShare)

		if device.language == "cn" then 

			CCBCenter.getNodeByTag(_node, 208):setVisible(true)
			CCBCenter.getNodeByTag(_node, 209):setVisible(false)
		else

			CCBCenter.getNodeByTag(_node, 208):setVisible(false)
			CCBCenter.getNodeByTag(_node, 209):setVisible(true)
		end

		local leftTitleSprite = widget.newSprite{file = "main/activity/invitefriends/img_activity_inviteFriends_title_left.png"}
		local rightTitleSprite = widget.newSprite{file = "main/activity/invitefriends/img_activity_inviteFriends_title_right.png"}

		_nodeTable["mLeftTitleNode"]:addChild(leftTitleSprite)
		_nodeTable["mRightTitleNode"]:addChild(rightTitleSprite)
		
		util.alignNode(leftTitleSprite, _nodeTable["mLeftTitleNode"])
		util.alignNode(rightTitleSprite, _nodeTable["mRightTitleNode"])
	end

	local function setShareShowStr( shareshowstr )
		-- body
		_shareShowStr = shareshowstr
	end

	local function getShareShowStr( ... )
		return _shareShowStr
	end

--[[ ## public fuction --]]
	function M.updateList( data )
		_scrollGrid:setItems(data.inviteusers)
		_nodeTable.mFirstInviteLabel:setString(data.showstr)
		setShareShowStr(data.shareshowstr)

		local t = {{title = _s("ACTIVITY_INVITE_FRIENDS"),count = data.totalusers},
			{title = _s("ACTIVITY_INVITE_RECEIVE_DIAMOND"),count = data.diamonds}}
		_diamondGrid:setItems(t)	
	end
--[[ ## MAINs --]]
	initViews()
	_node.updateList = M.updateList
	_node.getShareShowStr = getShareShowStr
end

return M