--ActivityRedemptionCodeLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityRedemptionCodeLayerView]"
	local _node, _nodeTable = node, luaValue
    local _editBox
    local MAX_LENGTH    = 16
--[[ ## local fuction --]]
    local function createEditBox( )
        local layer = CCBCenter.getNodeByTag(_node, 302)
        local editbox = widget.newEditBox{
            contentSize = CCSize(layer:getContentSize().width, layer:getContentSize().height) ,
            normalBgImage = {file = "hook_ac.png"},
        }
        editbox:setInputMode(kEditBoxInputModeSingleLine)
        layer:addChild(editbox, 1)
        editbox:setMaxLength(MAX_LENGTH)
        util.alignNode(editbox, layer:getContentSize(), display.CENTER)
        return editbox
    end
	local function initViews()
		_editbox = createEditBox( )
	end

--[[ ## public fuction --]]
    local function resetCode( )
        _editbox:setText("")
    end
    local function getCode( )
        return _editbox:getText()
    end
    -- 是否规范
    local function isCodeCompliance( )
        if getCode( ) == "" then
            NetHelper.QuickToast(_s("ACTIVITY_EXCHANGE_CODE_NONE"))
            return false
        elseif string.len(getCode( )) > MAX_LENGTH then
            NetHelper.QuickToast(_s("ACTIVITY_EXCHANGE_CODE_OVERFLOW"))
            return false
        else
            return true
        end
    end
--[[ ## MAINs --]]
	initViews()
    _node.resetCode   = resetCode
    _node.getCode   = getCode
    _node.isCodeCompliance   = isCodeCompliance
end

return M