--ActivityTalentRankLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityTalentRankLayerView]"
	local _node, _nodeTable = node, luaValue
	local _topGrid, _rewardGrid, _cdTimer
--[[ ## local fuction --]]
	local function updateInfo( info )
		if not info then
			return
		end
		local infoString =  string.format(_s("ACTIVITY_TALENT_RANK_INFO"), info) 
		_nodeTable.mInfoLabel:setString(infoString)
	end
	local function createTimer( )
		-- 时间
        _cdTimer = CountDownView.new{ 
                            format = _s("ARENA_TIME"),
                            labelParams = {size = 22,},
                            listener = function()
                            	-- _cdTimer:pause()
                            	_cdTimer:stop()
	                            CCBCenter.sendLuaMessage(MSG_ID.MSG_ACTIVITYTALENTRANKLAYER_ACTION_ONFETCHLEVELRANKLIST)
                            end
                        }
        CCBCenter.getNodeByTag(_node, 3040202):addChild(_cdTimer)
        util.alignNodeWithPadding(_cdTimer, CCBCenter.getNodeByTag(_node, 3040202):getContentSize(), display.CENTER)
	end
	local function createTopGrid( )

		local layer = CCBCenter.getNodeByTag(_node, 302)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(layer:getContentSize().width, 40))

			local bgSprite = widget.newSprite{file = "main/activity/levelrank/bg_cell_top.png"}
			cell:addChild(bgSprite)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER )			
			if item.rank then
				if item.rank < 4 then
					local rankSprite = widget.newSprite{file = "arena/arena_no" .. item.rank .. ".png"}
					cell:addChild(rankSprite)
					util.alignNodeWithPadding(rankSprite, cell:getContentSize(), display.CENTER_LEFT, {left = 4, top = -1} )	
				end
				
				-- 排名
				local rank = ui.newTTFLabel{text = item.rank , valign = ui.TEXT_VALIGN_BOTTOM, size = 22, color = ccc3(60, 35, 21)}
				cell:addChild(rank)
				util.alignNodeWithPadding(rank, cell:getContentSize(), display.CENTER, {left = -142, top = 2} )

				-- 等级
				local lv = ui.newTTFLabel{text = _s("ACTIVITY_TALENT_RANK_TALENT", item.lv), valign = ui.TEXT_VALIGN_BOTTOM, size = 22, color = ccc3(60, 35, 21)}
				cell:addChild(lv)
				util.alignNodeWithPadding(lv, cell:getContentSize(), display.CENTER_LEFT, {left = 66, top = 2})

				-- 用户名
				local name = ui.newTTFLabel{text = item.name , valign = ui.TEXT_VALIGN_BOTTOM, size = 22, color = ccc3(60, 35, 21)}
				cell:addChild(name)
				util.alignNodeWithPadding(name, cell:getContentSize(), display.CENTER, {left = 68, top = 2})
			end

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		local topGrid = widget.newGrid{
	        contentSize = layer:getContentSize(),
            cellSize = CCSize(layer:getContentSize().width, 40),
            padding = { 
                middleH = 4, middleV = 4,
            },
            column = 1,
            createItemCellListener = cellAtIndex,
            selectedParams = nil,
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	    }
	    return topGrid
	end
	local function createRewardGrid( )

		local layer = CCBCenter.getNodeByTag(_node, 402)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(layer:getContentSize().width, 66))

			local bgSprite = widget.newSprite{file = "main/activity/levelrank/bg_cell_reward.png"}
			cell:addChild(bgSprite)
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER )			

			local title = ui.newTTFLabel{text = item.title, color = ccc3(60, 35, 21), size = 20}
			cell:addChild(title)
			util.alignNodeWithPadding(title, cell:getContentSize(), display.LEFT_TOP )

			local card = ui.newTTFLabel{text = item.card, color = ccc3(60, 35, 21), size = 20}
			cell:addChild(card)
			util.alignNodeWithPadding(card, cell:getContentSize(), display.CENTER_BOTTOM, {left = -90, bottom = 2} )

			local diamond = ui.newTTFLabel{text = item.diamond, color = ccc3(60, 35, 21), size = 20}
			cell:addChild(diamond)
			util.alignNodeWithPadding(diamond, cell:getContentSize(), display.LEFT_BOTTOM, {left = 56, bottom = 2} )

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		local rewardGrid = widget.newGrid{
	        contentSize = layer:getContentSize(),
            cellSize = CCSize(layer:getContentSize().width, 66),
            padding = { 
                middleH = 4, middleV = 4,
            },
            column = 1,
            createItemCellListener = cellAtIndex,
            selectedParams = nil,
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	        items = {{title = string.format(_s("ACTIVITY_LEVEL_RANK"), "1"), card = _s("ACTIVITY_TALENT_RANK_REWARD_1"), diamond = 5000},
			        {title = string.format(_s("ACTIVITY_LEVEL_RANK"), "2-5"), card = _s("ACTIVITY_TALENT_RANK_REWARD_2"), diamond = 3000},
			        {title = string.format(_s("ACTIVITY_LEVEL_RANK"), "6-10"), card = _s("ACTIVITY_TALENT_RANK_REWARD_3"), diamond = 2000},
			        {title = string.format(_s("ACTIVITY_LEVEL_RANK"), "11-20"), card = _s("ACTIVITY_TALENT_RANK_REWARD_4"), diamond = 1000},
			        {title = string.format(_s("ACTIVITY_LEVEL_RANK"), "21-50"), card = _s("ACTIVITY_TALENT_RANK_REWARD_5"), diamond = 500},
			        {title = string.format(_s("ACTIVITY_LEVEL_RANK"), "51-100"), card = _s("ACTIVITY_TALENT_RANK_REWARD_6"), diamond = 300},
			        },
	    }
	    return rewardGrid
	end
	local function initViews()
		_topGrid = createTopGrid( )
		_rewardGrid = createRewardGrid( )
		createTimer( )
		_nodeTable.btnReceive:setEnabled(false)
	end

--[[ ## public fuction --]]
	function M.updateData( items )
		local topTable = {}
		
		-- local playerlist = {
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 1 , name = "1", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 2 , name = "2", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 3 , name = "3", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 4 , name = "4", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 5 , name = "5", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 6 , name = "6", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 7 , name = "7", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 8 , name = "8", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 9 , name = "9", head = "4|4"},
		-- 	{lv = 81, exp = 3788688, userid = 23861, rank = 10 , name = "9", head = "4|4"},
		-- }
		-- items.playerlist = playerlist
		if items.playerlist then
			for i = 1, 10 do
				if items.playerlist[i] then
					topTable[i] = clone(items.playerlist[i])
					topTable[i].rank = i
				else
					topTable[i] = {}
				end
			end
		end
		_topGrid:setItems(topTable)
		if items.myrank > 0 then
			_nodeTable.mMyRankLabel:setString(items.myrank)
		else
			_nodeTable.mMyRankLabel:setString(_s("ACTIVITY_TALENT_RANK_NO_RANK"))
		end
		
		updateInfo(items.enddate)
		if items.endtime > 0 then
			_cdTimer:start(items.endtime)
		else
			_cdTimer:stop(0)
			-- _cdTimer:start(0)
			_cdTimer:modifyTime(0)
		end
		_nodeTable.btnReceive:setEnabled(items.getreward == TRUE)
		
	end
--[[ ## MAINs --]]
	initViews()
	_node.updateData = M.updateData
end

return M