--ActivityTextButtonContainerLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ActivityTextButtonContainerLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = _node._DATA
	local STATUS_NOT_RECEIVE = 0
	local STATUS_CAN_RECEIVE = 1
	local STATUS_ALREADY_RECEIVE = 2
	local _scrollView
--[[ ## local fuction --]]

	local function fillInfo( info )
		_nodeTable.mTitleLabel:setString(info.title)
		_nodeTable.mMemoLabel:setString(info.memo)
		local textLabel = ui.newTTFLabel{text = "" , color = BUTTON_COLOR3.BROWN, size = 20}
		-- local colorLayer = widget.newColorLayer(ccc4(255,100,100,255))
		-- colorLayer:setContentSize(calcContainerSize(textLabel))
		local size = _scrollView:getContentSize()
		textLabel:setDimensions(CCSize(size.width, 0))--calcContainerSize(textLabel))
		textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
		textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
		textLabel:setString(info.content)
		-- colorLayer:addChild(textLabel)
		-- util.alignNode(textLabel, colorLayer:getContentSize(), display.TOP_CENTER )
		_scrollView:setContainer(textLabel)
		_scrollView:updateInset()
		util.autoFixScrollView(_scrollView)
	end

	local function createScrollView( )
		local layer = CCBCenter.getNodeByTag(_node, 102)
		local scrollView = widget.newScrollView{bounceable = false, contentSize = layer:getContentSize(), direction = widget.TABLEVIEW_DIRECTION_VERTICAL, }
		layer:addChild(scrollView)
		return scrollView
	end

	local function initViews()
		_scrollView = createScrollView( )
		if _data then
			fillInfo(_data)
			M.updateButtonStatus( _data.status )
		end
	end

--[[ ## public fuction --]]
	function M.updateButtonStatus( status )
		if status == STATUS_NOT_RECEIVE then
			_node:setButtonTitle("btnReceive", _s("REWARD_NOT_RECEIVE"), nil, CCControlStateDisabled)
		elseif status == STATUS_CAN_RECEIVE then
			_node:setButtonTitle("btnReceive", _s("REWARD_RECEIVE"), nil, CCControlStateDisabled)
		elseif status == STATUS_ALREADY_RECEIVE then
			_node:setButtonTitle("btnReceive", _s("REWARD_ALREADY_RECEIVE"), nil, CCControlStateNormal)
		end
		_nodeTable["btnReceive"]:setEnabled(status == STATUS_CAN_RECEIVE)
	end
--[[ ## MAINs --]]
	initViews()
	_node.updateButtonStatus 	= 	 M.updateButtonStatus
end

return M