--MainActivityLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MainActivityLayerView]"
	local _node, _nodeTable = node, luaValue
	local _activityGrid, _activityTabGrid
	local _selectIndex = 1
	local _listSelectIndex = 1
	local _selectAtype = _node._SELECTATYPE
	local _listItemsTable = {}
	-- 活动图片地址
	local ACTIVITY_PATH = "activity/"
	local NET_ACTIVITY_URL = BASESER_URL .. "/" .. ACTIVITY_PATH
	local ACTIVITY_IMAGE_PATH = "sd/" .. ACTIVITY_PATH
	-- 活动图片最小
	local IMAGE_MIN_SIZE = 10240
	local ACTIVITY_SHOWTYPE_TEXT 		  = 1
	local ACTIVITY_SHOWTYPE_PAGE 		  = 2
	local ACTIVITY_SHOWTYPE_WEB  		  = 3
	local ACTIVITY_SHOWTYPE_LIST  		  = 4
	local ACTIVITY_SHOWTYPE_TEXT_BUTTON   = 5
	local ACTIVITY_SHOWTYPE_JUMP_TOPAGE   = 6
	local ACTIVITY_SHOWTYPE_TIMEACTIVITY  = 100
	local ACTIVITY_FLAG_IMAGE 			= {"main/activity/img_activity_sign_new.png", "main/activity/img_activity_sign_notice.png"}
--[[ ## local fuction --]]
	
	-- 显示活动详细
	local function showActivityDetails( item )
		_node._ISLIST = false
		CCBCenter.getNodeByTag(_node, 201):setVisible(false)

		local activityNode = CCBCenter.getNodeByTag(_node, 202)
		activityNode:removeAllChildrenWithCleanup(true)
		activityNode:setVisible(true)

		--item.msgId = "MSG_ACTIVITYMONTHCARDLAYER_MODEL"
		--item.path = "ccb.c.activity.ActivityMonthCardLayer"

		CCBCenter.loadCCB(item.msgId, item.path, item.data, function( contentNode )
			if contentNode:getContentSize().height > 538 then
				local scrollView = widget.newScrollView{contentSize = activityNode:getContentSize(), direction = widget.TABLEVIEW_DIRECTION_VERTICAL }
				activityNode:addChild(scrollView)
				scrollView:setPosition(ccp(11, -1))
				contentNode:ignoreAnchorPointForPosition(true)
				scrollView:setContainer(contentNode)
				scrollView:updateInset()
				util.autoFixScrollView(scrollView)
			else
				activityNode:addChild(contentNode)
				util.alignNodeWithPadding(contentNode, activityNode:getContentSize(), display.CENTER)
			end
		end)
	end
	-- 显示活动详细小尺寸
	local function showActivityDetailsMini( item )
		_node._ISLIST = false
		-- CCBCenter.getNodeByTag(_node, 201):setVisible(false)

		local activityNode = CCBCenter.getNodeByTag(_node, 20103)
		activityNode:removeAllChildrenWithCleanup(true)
		-- activityNode:setVisible(true)

		CCBCenter.loadCCB(item.msgId, item.path, item.data, function( contentNode )
			if contentNode:getContentSize().height > 538 then
				local scrollView = widget.newScrollView{contentSize = activityNode:getContentSize(), direction = widget.TABLEVIEW_DIRECTION_VERTICAL }
				activityNode:addChild(scrollView)
				scrollView:setPosition(ccp(11, -1))
				contentNode:ignoreAnchorPointForPosition(true)
				scrollView:setContainer(contentNode)
				scrollView:updateInset()
				util.autoFixScrollView(scrollView)
			else
				activityNode:addChild(contentNode)
				util.alignNodeWithPadding(contentNode, activityNode:getContentSize(), display.CENTER)
			end
		end)
	end
	-- 显示文本页面
	local function showTextContainer( item )
		local detail = {
			msgId = "MSG_ACTIVITYTEXTCONTAINERLAYER_MODEL",
			path = "ccb.c.main.ActivityTextContainerLayer",
			data = {title = item.title , detail = item.content,},
		}
		showActivityDetails(detail)
	end
	-- 显示文本页面小尺寸
	local function showTextContainerMini( item )
		local detail = {
			msgId = "MSG_ACTIVITYTEXTCONTAINERMINLAYER_MODEL",
			path = "ccb.c.main.ActivityTextContainerMinLayer",
			data = {title = item.title , detail = item.content,},
		}
		showActivityDetailsMini(detail)
	end
	-- 显示文本button页面
	local function showTextButtonContainer( item )
		local detail = {
			msgId = "MSG_ACTIVITYTEXTBUTTONCONTAINERLAYER_MODEL",
			path = "ccb.c.main.ActivityTextButtonContainerLayer",
			-- data = {title = item.title , detail = item.content, memo = item.memo, status = item.status,},
			data = item,
		}
		showActivityDetails(detail)
	end
	-- 显示活动专属页面
	local function showActivityContainer( item )
		local msgId, path = string.match(item.content, "(.+),(.+)")
		if (not msgId and not path ) or (msgId == "" or path == "") then
			showTextContainer( item )
			return
		end
		-- msgId = "MSG_ACTIVITYCHARGELISTLAYER_MODEL"
		-- path = "ccb.c.activity.ActivityChargeListLayer"
		-- item.atype = 99992
		local detail = {
			msgId = msgId,
			path = path,
			data = {title = item.title , detail = item.content, atype = item.atype},
		}
		showActivityDetails(detail)
	end
	-- 显示活动专属页面小尺寸
	local function showActivityContainerMini( item )
		local msgId, path = string.match(item.content, "(.+),(.+)")
		if (not msgId and not path ) or (msgId == "" or path == "") then
			showTextContainer( item )
			return
		end
		local detail = {
			msgId = msgId,
			path = path,
			data = {title = item.title , detail = item.content,},}
		showActivityDetailsMini(detail)
	end
	
	-- 跳转网页
	local function showWebBrowser( item )
		-- device.openURL(item.content)
		local detail = {
			msgId = "MSG_ACTIVITYWEBBUTTONCONTAINERLAYER_MODEL",
			path = "ccb.c.main.ActivityWebButtonContainerLayer",
			data = {title = item.title , detail = item.memo, url = item.content,},}
		showActivityDetailsMini(detail)
	end
	-- 跳转页面
	local function showGamePage( item )
		local detail = {
			msgId = "MSG_ACTIVITYJUMPPAGELAYER_MODEL",
			path = "ccb.c.activity.ActivityJumpPageLayer",
			data = {title = item.title , detail = item.memo, content = item.content,},}
		showActivityDetailsMini(detail)
	end
	local function createActivityGrid( )
		--取得table容器
		local layer = CCBCenter.getNodeByTag(_node, 2010102)
		layer:removeAllChildrenWithCleanup(true)
		
		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(layer:getContentSize().width, 63))

			-- 背景
			local imageFile = "main/activity/bg_activity_list_cell_normal.png"
			if _listSelectIndex and idx == _listSelectIndex then
				imageFile = "main/activity/bg_activity_list_cell_select.png"
			end
			local bgSprite = widget.newSprite{file = imageFile}
			util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER)
			cell:addChild(bgSprite, 0, 100)
			if item.atype then
				-- 活动名称
				-- local activityTitle = widget.newTTFLabelWithOutline{text = item.title, size = 24}
				local activityTitle = ui.newTTFLabel{text = item.title, size = 24, font = FONT_1, color = BUTTON_COLOR3.BROWN}
				util.alignNode(activityTitle, cell:getContentSize(), display.CENTER)
				cell:addChild(activityTitle, 1)
				-- 活动状态
				local signFile = ACTIVITY_FLAG_IMAGE[item.flag]
				if signFile then
					local signSprite = widget.newSprite{file = signFile}
					util.alignNode(signSprite, cell:getContentSize(), display.CENTER_RIGHT)
					cell:addChild(signSprite, 2, 101)
					-- anim.fadeFade( signSprite, {playtime = 1.5, forever = true, endDelay = 1})
				end
				-- 活动概述
				-- local activityMemo = ui.newTTFLabel{dimensions = CCSize(760, 120), text = item.memo}
				-- util.alignNode(activityMemo, cell:getContentSize(), display.BOTTOM_LEFT, 10)
				-- cell:addChild(activityMemo, 0)
				-- banner条
				-- if item.banner and item.banner ~= "" then
				-- 	local function createActivitySprite( filename, downStatus )
				-- 		if downStatus ~= false then
				-- 			-- 小于尺寸的抛弃
				-- 			local filePath = device.documentsPath .. ACTIVITY_IMAGE_PATH .. filename
				-- 			if io.filesize(filePath) < IMAGE_MIN_SIZE then
				-- 				io.remove(filePath)
				-- 				return
				-- 			end
				-- 			local activityImage = widget.newSprite{file = ACTIVITY_PATH .. filename, }
				-- 			util.alignNodeWithPadding(activityImage, cell:getContentSize(), display.CENTER )
				-- 			cell:addChild(activityImage, 1 )
				-- 		end
				-- 	end
				-- 	if not io.exists(device.documentsPath .. ACTIVITY_IMAGE_PATH .. item.banner) then
				-- 		Log.d(TAG, "no exists")
				-- 		-- 不存在下载
				-- 		UpdateHelper.downloadfile( NET_ACTIVITY_URL .. item.banner, createActivitySprite, nil, ACTIVITY_IMAGE_PATH )
				-- 	else
				-- 		Log.d(TAG, "exists use")
				-- 		-- 存在直接用
				-- 		createActivitySprite(item.banner)
				-- 	end
				-- end
			end

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end
		local function modifyCellAtIndex( grid, index, item, itemCell )
			local bgSprite = itemCell:getChildByTag(100)
			bgSprite:removeFromParentAndCleanup(true)
			local imageFile = "main/activity/bg_activity_list_cell_normal.png"
			if _listSelectIndex and index == _listSelectIndex then
				imageFile = "main/activity/bg_activity_list_cell_select.png"
			end
			bgSprite = widget.newSprite{file = imageFile}
			util.alignNodeWithPadding(bgSprite, itemCell:getContentSize(), display.CENTER)
			itemCell:addChild(bgSprite, 0, 100)

			-- 活动状态
			local signSprite = itemCell:getChildByTag(101)
			if signSprite and item.flag == 0 then
				signSprite:removeFromParentAndCleanup(true)
			end
		end
		local function onBtnClick( grid,index,item )
			SOUND:playEffectButton1()
			if _listSelectIndex == index then
				return
			elseif item.showtype ~= ACTIVITY_SHOWTYPE_PAGE or item.parentid > 0 then
				_listSelectIndex = index
			end
			-- 都是小尺寸的
			if item.showtype == ACTIVITY_SHOWTYPE_TEXT then
				-- 仅仅显示文本
				-- showTextContainer(item)
				showTextContainerMini( item )
			elseif item.showtype == ACTIVITY_SHOWTYPE_TEXT_BUTTON then
				-- 显示文本 and button
				showTextButtonContainer(item)
			elseif item.showtype == ACTIVITY_SHOWTYPE_PAGE then
				-- 特有页面
				if item.atype == ACTIVITY_ATYPE.BULLETIN then
					showActivityContainerMini(item)
				else
					showActivityContainer(item)
				end				
			elseif item.showtype == ACTIVITY_SHOWTYPE_WEB then
				-- 跳网页
				showWebBrowser( item )
			elseif item.showtype == ACTIVITY_SHOWTYPE_JUMP_TOPAGE then
				-- 跳页面去吧
				showGamePage(item)
			end
			item.flag = 0
			grid:refresh()
			-- _activityGrid:scrollToItemIndex(_listSelectIndex, 0.2)
		end
		local scrollGrid = widget.newScrollGrid{
	        contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(layer:getContentSize().width, 63),
	            -- padding = { 
	            --     middleH = 4, middleV = 5,
	            -- },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            modifyItemCellListener = modifyCellAtIndex,
	            selectedParams = nil,
	            tapListener = onBtnClick,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	    }

		return scrollGrid
	end

	local function createTabGrid( )
		--取得table容器
		local layer = CCBCenter.getNodeByTag(_node, 402)
		layer:removeAllChildrenWithCleanup(true)

		local function cellAtIndex( scrollLinear, idx , item)
			local cell = display.newLayer()
			-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
			cell:setContentSize(CCSize(183, layer:getContentSize().height))

			if item.atype then
				local imageFile = "main/activity/btn_activity_tab_normal.png"
				if _selectIndex and idx == _selectIndex then
					imageFile = "main/activity/btn_activity_tab_select.png"
				end
				-- 背景
				local bgSprite = widget.newSprite{file = imageFile}
				util.alignNodeWithPadding(bgSprite, cell:getContentSize(), display.CENTER)
				cell:addChild(bgSprite, 0, 100)
				-- 图标TODO
				local activityFile = (item.banner == "" or string.endwith(item.banner, ".jpg")) and "main/activity/activity_icon_8.png" or string.format("main/activity/%s", item.banner)
				local activityIcon = widget.newSprite{file = activityFile}
				-- local activityIcon = widget.newSprite{file = "main/activity/activity_icon_8.png"}
				cell:addChild(activityIcon, 1)
				util.alignNode(activityIcon, cell)
				-- 文字背景
				local bgTitle = widget.newSprite{file = "main/activity/bg_tab_title.png"}
				cell:addChild(bgTitle, 2)
				util.alignNode(bgTitle, cell, display.CENTER_BOTTOM, 10)
				-- 活动名称
				-- local activityTitle = widget.newTTFLabelWithOutline{text = item.title, size = 20}
				local activityTitle = ui.newTTFLabel{text = item.title, size = 18}
				util.alignNode(activityTitle, cell, display.CENTER_BOTTOM, 10)
				cell:addChild(activityTitle, 3)

				local signFile = ACTIVITY_FLAG_IMAGE[item.flag]
				if signFile then
					local signSprite = widget.newSprite{file = signFile}
					util.alignNodeWithPadding(signSprite, cell:getContentSize(), display.CENTER_RIGHT, { top = -16, right = 26})
					cell:addChild(signSprite, 4, 101)
					-- anim.fadeFade( signSprite, {playtime = 1.5, forever = true, endDelay = 1})
				end
			end

			cell:ignoreAnchorPointForPosition(false)
			return cell
		end

		local function modifyCellAtIndex( grid, index, item, itemCell )
			local bgSprite = itemCell:getChildByTag(100)
			bgSprite:removeFromParentAndCleanup(true)
			local imageFile = "main/activity/btn_activity_tab_normal.png"
			if _selectIndex and index == _selectIndex then
				imageFile = "main/activity/btn_activity_tab_select.png"
			end
			bgSprite = widget.newSprite{file = imageFile}
			util.alignNodeWithPadding(bgSprite, itemCell:getContentSize(), display.CENTER)
			itemCell:addChild(bgSprite, 0, 100)

			-- 活动状态
			local signSprite = itemCell:getChildByTag(101)
			if signSprite and item.flag == 0 then
				signSprite:removeFromParentAndCleanup(true)
			end
		end

		local function onBtnClick( grid,index,item )
			SOUND:playEffectButton1()
			if _selectIndex == index and item.showtype ~= ACTIVITY_SHOWTYPE_LIST then
				return
			-- elseif item.showtype == ACTIVITY_SHOWTYPE_LIST then
			-- 	ISGSVALUES()["MAXACTIVITYID"] = ME:getNotever()
			--	GS.save(ISGSVALUES())
			end

			_selectIndex = index

			if item.showtype == ACTIVITY_SHOWTYPE_TEXT then
				-- 仅仅显示文本
				showTextContainer(item)
			elseif item.showtype == ACTIVITY_SHOWTYPE_TEXT_BUTTON then
				-- 显示文本 and button
				showTextButtonContainer(item)
			elseif item.showtype == ACTIVITY_SHOWTYPE_PAGE then
				-- 特有页面
				showActivityContainer(item)
			elseif item.showtype == ACTIVITY_SHOWTYPE_LIST then
				M.showListActivityGrid(item.atype)
			end
			item.flag = 0
			grid:refresh()
			-- _activityTabGrid:scrollToItemIndex(_selectIndex, 0.2)
		end

		_activityTabGrid = widget.newScrollGrid{
	        contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(140, layer:getContentSize().height),
	            row = 1,
	            createItemCellListener = cellAtIndex,
	            modifyItemCellListener = modifyCellAtIndex,
	            tapListener = onBtnClick,
	            -- padding = {middleH = 14},
	        },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL ,
	        parentNode = layer,
	    }
	end
	local function initViews()
		_activityGrid = createActivityGrid( )
		createTabGrid( )
		_node._ISLIST = true
    end

--[[ ## public fuction --]]
	-- 有新限时活动
    function M.hasNewActivity( )
        -- if M.isFirstLogin( ) and ME:getNotever() ~= 0 then
        --  return true
        -- end
        if  ME:getMaxActivityId() == 0 or (ISGSVALUES()["MAXACTIVITYID"] and ISGSVALUES()["MAXACTIVITYID"] == ME:getNotever()) then
            return false
        else
            -- ISGSVALUES()["MAXACTIVITYID"] = ME:getNotever()
            -- GS.save(ISGSVALUES())
            return true
        end
    end
	function M.updateData( data )
		-- 列表活动
		_listItemsTable = {}
		-- 活动tab列表
		local activityTab = {}
		local showSelectItem

		for i, v in ipairs(data.actlist) do
			if v.parentid > 0 then
				 if not _listItemsTable[v.parentid] then
				 	_listItemsTable[v.parentid] = {}
				 end
				 table.insert(_listItemsTable[v.parentid], v)
			else
				table.insert(activityTab, v)
			end
			if _selectAtype and v.atype == _selectAtype and not showSelectItem then
				showSelectItem = v
			end
		end
		_activityTabGrid:setItems(activityTab)

		-- 默认选中第一个
		if not showSelectItem then
			showSelectItem = activityTab[_selectIndex]
		-- 列表元素的选中parentid
		elseif showSelectItem.parentid > 0 then
			for i,v in ipairs(activityTab) do
				if v.atype == showSelectItem.parentid then
					_selectIndex = i
					break
				end
			end
			for i,v in ipairs(_listItemsTable[showSelectItem.parentid]) do
				if v.atype == _selectAtype then
					_listSelectIndex = i
					break
				end
			end
		else
			for i,v in ipairs(activityTab) do
				if v.atype == _selectAtype then
					_selectIndex = i
					break
				end
			end
		end
		-- _activityTabGrid:getGrid():setSelectEffect(_selectIndex)
		_activityTabGrid:getGrid():refresh()
		_activityTabGrid:scrollToItemIndex(_selectIndex, 0)
		if showSelectItem.parentid > 0 then
			-- 限时活动
			M.showListActivityGrid( showSelectItem.parentid )
		elseif showSelectItem.showtype == ACTIVITY_SHOWTYPE_TEXT then
			-- 仅仅显示文本
			showTextContainer(showSelectItem)
		elseif showSelectItem.showtype == ACTIVITY_SHOWTYPE_TEXT_BUTTON then
			-- 显示文本 and button
			showTextButtonContainer(showSelectItem)
		elseif showSelectItem.showtype == ACTIVITY_SHOWTYPE_PAGE then
			-- 特有页面
			showActivityContainer(showSelectItem)
		elseif showSelectItem.showtype == ACTIVITY_SHOWTYPE_LIST then
			-- 列表
			M.showListActivityGrid( showSelectItem.atype )
		end
	end
	function M.showListActivityGrid( atype )
		if not _listItemsTable[atype] then
			CCBCenter.getNodeByTag(_node, 201):setVisible(true)
			CCBCenter.getNodeByTag(_node, 202):setVisible(false)
			return
		end
		_node._ISLIST = true
		_activityGrid:setItems(_listItemsTable[atype])
		-- 选中某一个
		local activity = _listItemsTable[atype][_listSelectIndex]
		-- 都是小尺寸的
		if activity.showtype == ACTIVITY_SHOWTYPE_TEXT then
			-- 仅仅显示文本
			showTextContainerMini( activity )
		elseif activity.showtype == ACTIVITY_SHOWTYPE_TEXT_BUTTON then
			-- 显示文本 and button
			showTextButtonContainer(activity)
		elseif activity.showtype == ACTIVITY_SHOWTYPE_PAGE then
			-- 特有页面
			if activity.atype ~= ACTIVITY_ATYPE.BULLETIN then
				_listSelectIndex = nil
				showActivityContainer(activity)
			else
				showActivityContainerMini(activity)
			end
		elseif activity.showtype == ACTIVITY_SHOWTYPE_WEB then
			-- 跳网页
			showWebBrowser( activity )
		elseif activity.showtype == ACTIVITY_SHOWTYPE_JUMP_TOPAGE then
			-- 跳具体页面
			showGamePage( activity )
		end
		_activityGrid:scrollToItemIndex(_listSelectIndex, 0)
		CCBCenter.getNodeByTag(_node, 201):setVisible(true)
		CCBCenter.getNodeByTag(_node, 202):setVisible(false)
	end

	function M.enableTouchTab( enable )
		util.enableCustomTouch( _activityTabGrid, enable)
	end
--[[ ## MAINs --]]
	initViews()
	_node.updateData = M.updateData
	_node.showListActivityGrid = M.showListActivityGrid
	_node.enableTouchTab = M.enableTouchTab
end

return M