--MainBulletinLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MainBulletinLayerView]"
	local _node, _nodeTable = node, luaValue
	local _scrollView
--[[ ## local fuction --]]

	local function calcContainerSize( label )

        local labelSize = label:getContentSize()
        local labelWidth, labelHeight, line
        labelWidth = _scrollView:getContentSize().width

        if labelSize.width > labelWidth then 
            line = math.ceil(labelSize.width / labelWidth)
        else
            labelWidth = labelSize.width
            line = 1
        end
        labelHeight = line * (labelSize.height - 0)
        if labelHeight <= _scrollView:getContentSize().height then
        	labelHeight = _scrollView:getContentSize().height
        end
        return  CCSize(labelWidth, labelHeight)
    end

	local function createScrollView( )
		local layer = CCBCenter.getNodeByTag(_node, 202)
		local scrollView = widget.newScrollView{bounceable = false, contentSize = layer:getContentSize(), direction = widget.TABLEVIEW_DIRECTION_VERTICAL, }
		layer:addChild(scrollView)
		return scrollView
	end

	local function initViews()
		_scrollView = createScrollView( )
	end

--[[ ## public fuction --]]
	-- 设置公告内容
	function M.setContentText( info )
		local textLabel = ui.newTTFLabel{text = "", color = BUTTON_COLOR3.BROWN, size = 20 }
		_nodeTable.mTitleLabel:setString(info.title)
		-- local colorLayer = widget.newColorLayer(ccc4(255,100,100,255))
		-- colorLayer:setContentSize(calcContainerSize(textLabel))
		local size = _scrollView:getContentSize()
		textLabel:setDimensions(CCSize(size.width, 0))--calcContainerSize(textLabel))
		textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
		textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_LEFT)
		textLabel:setString(info.messages)
		-- colorLayer:addChild(textLabel)
		-- util.alignNode(textLabel, colorLayer:getContentSize(), display.TOP_CENTER )
		_scrollView:setContainer(textLabel)
		_scrollView:updateInset()
		util.autoFixScrollView(_scrollView)
-- =============================
		-- _nodeTable.mTitleLabel:setString(info.title)
		-- local size = _scrollView:getContentSize()
		-- local textLabel =  ui.newTTFLabel{
		-- 				dimensions = CCSize(size.width, size.height),
		-- 				text = info.messages,
		-- 				textValign = ui.TEXT_VALIGN_TOP,
		-- }
		-- _scrollView:setContainer(textLabel)
		-- _scrollView:updateInset()
-- =============================
	end
--[[ ## MAINs --]]
	initViews()
	_node.setContentText = M.setContentText
end

return M