--MainNewLayer.lua
local M = {}

local ChatUtil = require("ccb.m.chat.ChatUtil")
local Chat = require("ccb.m.chat.EntityChat")
local EffectButton = require("cardui.EffectButton")
local unlockLevel = require("static.unlock_level")
function M.bindView(node, luaValue)
	local TAG = "[MainNewLayerView]"
	local _node, _nodeTable = node, luaValue
    local _xp, _sp, _scrollLabel, _role, _roleHead, _treasureChest, _firecracker
    local _isFireFinish = false
    local _isGetFireReward = false
    local scrollTalkPanel
    local _mainButtons
    local _messageSchedule
    local _reward
--[[ ## local fuction --]]
    
    -- 消息气泡小点点动画
    local function createMessagePoint( )

        local layer = CCBCenter.getNodeByTag(_node, 502)

        local sprite = anim.playAnimation(nil, "main/img_point", "img_point_%d.png", 3, 1, 1, true)
        layer:addChild(sprite)
        util.alignNodeWithPadding(sprite, layer:getContentSize(), display.CENTER, {top = -5,})

        return sprite
    end
    -- 创建点击位置获取
    local function createPositionTouch( )
        local function onClick( layer, x, y )
            if not _role then
                return
            end
            local position = layer:convertToNodeSpace(ccp(x, y))
            local posX = _role:getPositionX()
            -- local widthHalved = _role:getPositionX()

            -- if math.abs(posX - position.x) <= widthHalved then 
            --     _role:random()
            -- else
            --     _role:moveToX(position.x)
            -- end
            _role:walk{x = position.x - posX, }
        end
        -- 绑定点击
        local touchLayer = CCBCenter.getNodeByTag(_node, 7, "CCLayer")
        widget.bindTouchEvent{
            layer = touchLayer,
            clickListener = onClick,
        }
    end
--******************************获取聊天信息********************************************************************************

    local function resetMessage( properties )
        -- 加到信息集合
        if properties then 
            for i=1,#properties do
                local item = properties[i]

                if item then -- and (item:getSenderId() ~= ME:getUserid() or item:getMessageType() == ChatUtil.ChatSystem) 
                    
                    -- 判断BigShow为0或1情况
                    if item:getIsBigShow() == 0 or item:getIsBigShow() == 1 then 
                        -- 初始化表格集合
                        local initItem = {}
                        local initItem2 = {}
                        -- 消息头添加消息类型
                        initItem[#initItem + 1] = { f = 0 , w = "["..ChatUtil.ChatTypeStr[item:getMessageType()].."]"}
                        initItem2[#initItem2 + 1] = { f = 0 , w = "["..ChatUtil.ChatTypeStr[item:getMessageType()].."]"}

                        -- 添加消息发送人
                        local nname = item:getSenderNickName() or ""
                        if nname ~= "" and item:getMessageType() ~= ChatUtil.ChatSystem then 
                            nname = nname .. "：" 
                        end
                        if item:getSenderId() == -1 then item:setSenderId(ME:getUserid()) end
                        initItem[#initItem + 1] = { f = 1 , w = nname, o = item:getSenderId()}
                        initItem2[#initItem2 + 1] = { f = 1 , w = nname, o = item:getSenderId()}

                        -- 生成表格集合
                        local cellItems = ChatUtil.createCellItems(initItem,item:getContent())
                        for i=1,#cellItems do
                            chat_messages[#chat_messages + 1] = { cellItem = cellItems[i], ctype = item:getMessageType(), key = item:getKey() }
                        end

                        local cellItems2 = ChatUtil.createCellItems(initItem2,item:getContent(),500)
                        -- print("....___________________....."..item:getContent())
                        for i=1,#cellItems2 do
                            -- print("__________"..json.encode(cellItems2[i]))
                            chat_messages2[#chat_messages2 + 1] = { cellItem = cellItems2[i], ctype = item:getMessageType(), key = item:getKey() }
                        end
                        

                        if item:getIsBigShow() == 1 then
                            -- postMessage[#postMessage + 1] = item:getContent()
                            
                            if _scrollLabel ~= nil then
                                CCBCenter.getNodeByTag(_node, 6):setVisible(true)

                                local showword = ChatUtil.filterFlag( item:getContent() )

                                _scrollLabel.playText({text = item:getSenderNickName()..":".. showword, size = 30, color = COLOR3.WHITE})
                            end
                        elseif item:getIsBigShow() == 0 then 

                            if scrollTalkPanel ~= nil then 

                                scrollTalkPanel.setNewMessage({messages = chat_messages2})
                            end
                        end
                    end

                    -- 判断BigShow为2情况（幸运转盘）
                    if item:getIsBigShow() == 2 then 
                        -- 初始化表格集合
                        local initItem = {}

                        -- 消息头添加消息类型
                        initItem[#initItem + 1] = { f = 0 , w = _s("CHAT_INITIAL_WHEEL"), }

                        -- 添加消息发送人
                        local nname = item:getSenderNickName() or ""
                        if item:getSenderId() == -1 then item:setSenderId(ME:getUserid()) end
                        initItem[#initItem + 1] = { f = 1 , w = nname, o = item:getSenderId()}

                        ---------------------------------------------------------------------------------------------------------------
                        -- 意图：根据是否是当前玩家的获奖消息来加入到不同的消息集中，对于非玩家自身的消息都先列出，自己的奖励消息待转盘动画结束后列出
                        ---------------------------------------------------------------------------------------------------------------
                        -- 消息集合
                        local globalMessages = (nname == ME:getName()) and globalMessageMeFW or globalMessagesFW            -- (item:getSenderId() == ME:getUserid())
                        -- 生成表格集合
                        local cellItems = ChatUtil.createCellItems(initItem, item:getContent(), 605)
                        for i = 1, #cellItems do
                            table.insert(globalMessages, { cellItem = cellItems[i], ctype = item:getMessageType(), key = item:getKey() })
                        end
                    end
                    -- print("数量:"..#postMessage)
                end
            end
        end

        -- 太多了，清除1页
        if #chat_messages > ChatUtil.maxMsgCount then 
            local count = #chat_messages - ChatUtil.maxMsgCount
            for i=1,count do
                table.remove(chat_messages,1)
                -- print("chat_messages ",json.encode(chat_messages))
            end
        end
    end
    local function callback_recchat( properties, params )
        Log.d(TAG,"chat: %s",json.encode(properties))
        local messages = Chat.new(properties)
        resetMessage(messages:getItems())
    end

    local function recChatRequest()
        --   创建http请求
        NetHelper.createRequest(
            
           ACTID.MSG_GET_CHATLIST,                   --      请求id
           callback_recchat,                   --       回调函数
           { kind = ChatUtil.ChatWorld, typ = 1, },
           { showLoading = false }
        )
    end 
--******************************获取聊天信息********************************************************************************
    local function init91Tool( ... )
        if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
            if isandroid() then
                _sdkPlatform.showToolBarForAndroid(
                        function ( ... )
                        end, 
                        function ( ... )
                        end
                    )
            else 
                _sdkPlatform.showOrHidetoolBar(
                    function ( ... )
                        -- 好像不用做什么的样子...
                    end, 
                    function ( ... )
                        -- 同样无所事事的,会不会被干掉啊~~~
                    end,
                    {show = 1}--1为显示  0为隐藏
                )
            end 
        end
    end 
    
    local function createMainButtons()
        _mainButtons = {}
        -- 闪闪发光
        local function addBlingLight_( node )
            -- local sprite = anim.playAnimation(nil, "main/img_bling", "img_bling_%d.png", 2, 1, 1, true)
            -- node:addChild(sprite, 11)
            -- util.alignNode(sprite, node)
            -- return sprite

            -- local node = widget.newNode{contentSize = CCSize(109, 70)}
            display.addSpriteFramesWithFile( "main/img_bling.plist", "main/img_bling.png")
            local sprite_1 = widget.newSprite{file = "#img_bling_1.png",}
            local sprite_2 = widget.newSprite{file = "#img_bling_2.png",}

            node:addChild(sprite_1)
            node:addChild(sprite_2)
            util.alignNode(sprite_1, node)
            util.alignNode(sprite_2, node)
            anim.fadeFade(sprite_1, {forever = true, playTime = 0.5, }) 
            anim.fadeFade(sprite_2, {forever = true, playTime = 0.5, startDelay = 1})

            return node
        end
        local function createMainButton_( parentTag, filename, text, msgId, params )
            local button = EffectButton.new(filename, text
                , function ( button )
                    CCBCenter.sendLuaMessage(msgId)
                end, params)
            local parent = CCBCenter.getNodeByTag(_node, parentTag)
            -- parent:removeAllChildrenWithCleanup(true)
            parent:addChild(button)
            util.alignNode(button, parent)
            table.insert(_mainButtons, button)
            return button
        end
        -- 首充双倍 15  btn_main_first_pay
        if ME:getFirstpay() == TRUE then
            local btnFirstPay = createMainButton_(
                15, "btn_main_first_pay", _s("MAIN_FIRST_PAY")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNFIRSTPAYCLICK
                , {
                    flash = true, light = true, mark = false, shake = true, 
                    checkRefresh = function ()
                        return ME:getFirstpay() == TRUE
                    end
                }
            )
        end
        
        -- 公告(活动) 8  btn_main_notice
        local btnNotice = createMainButton_(
                8, "btn_main_notice", _s("MAIN_SYSTEM_NOTICE")
                -- , MSG_ID.MSG_MAINNEWLAYER_ONBTNACTIVITYCLICK
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNSYSTEMNOTICECLICK
                -- , {
                --     flash = true, light = true, mark = true, shake = true, 
                --     checkRefresh = function ()
                --         return ME:getNewDiamondReward() == TRUE
                --     end
                -- }
            )
        -- 活动 24  btn_main_activity
        local btnActivity = createMainButton_(
            24, "btn_main_activity", _s("MAIN_ACTIVITY")
            , MSG_ID.MSG_MAINNEWLAYER_ONBTNACTIVITYCLICK
            -- , MSG_ID.MSG_MAINNEWLAYER_ONBTNSYSTEMNOTICECLICK
            , {
                flash = false, light = false, mark = true, shake = true, 
                checkRefresh = function ()
                    return true --ME:getNewDiamondReward() == TRUE
                end,
                bgfilename = "main/effect_buttons/bg_main_activity.png",
            }
        )
        addBlingLight_(btnActivity)
        -- 签到 14  btn_main_sign
        local btnSign = createMainButton_(
                14, "btn_main_sign", _s("REWARD_SIGN")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNSIGNCLICK
                , {
                    flash = true, light = true, mark = false, shake = true, 
                    checkRefresh = function ()
                        return ME:getTodaySigned() == TRUE
                    end
                }
            )
        -- 日常任务 9  btn_main_mission
        local btnMission = createMainButton_(
                9, "btn_main_mission", _s("REWARD_DAY")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNDAYREWARDCLICK
                , {
                    flash = true, light = true, mark = false, shake = true, 
                    checkRefresh = function ()
                        return ME:getNewDayReward() == TRUE or ME:getNewCommonReward() == TRUE
                    end
                }
            )
        -- 奖励 10  btn_main_reward
        -- local btnReward = createMainButton_(
        --         10, "btn_main_reward", _s("REWARD_TITLE")
        --         , MSG_ID.MSG_MAINNEWLAYER_ONBTNCOMMONREWARDCLICK
        --         , {
        --             flash = true, light = true, mark = false, shake = true, 
        --             checkRefresh = function ()
        --                 return ME:getNewCommonReward() == TRUE
        --             end
        --         }
        --     )
        -- 排行榜 10  btn_main_rank
        local btnRank = createMainButton_(
                10, "btn_main_rank", _s("RANK_RANKING_TITLE")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNRANKINGCLICK
                -- , {
                --     flash = true, light = true, mark = false, shake = true, 
                --     checkRefresh = function ()
                --         return ME:getNewCommonReward() == TRUE
                --     end
                -- }
            )
        -- 天赋 11  btn_main_talent
        local btnTalent = createMainButton_(
                11, "btn_main_talent", _s("MAIN_TALENT")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNTALENTCLICK
            )
        -- boss 20  btn_main_boss
        if TRUE == ME:getBosswar() then
            local btnBoss = createMainButton_(
                20, "btn_main_boss", _s("MAIN_BOSS")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNBOSSCLICK
            )
        end
        
        -- 背包 13  btn_main_backage
        -- local btnBackage = createMainButton_(
        --         13, "btn_main_backage", _s("MAIN_BACKAGE")
        --         , MSG_ID.MSG_MAINNEWLAYER_ONBTNBACKAGECLICK
        --     )
        -- 卡牌进阶 13  btn_main_evolution
        -- local btnEvolution = createMainButton_(
        --         13, "btn_main_evolution", _s("CARD_EVOLUTION")
        --         , MSG_ID.MSG_MAINNEWLAYER_ONBTNEVOLUTIONCLICK
        --     )
        -- 系统设置 13  btn_main_systemset
        local btnEvolution = createMainButton_(
                13, "btn_main_systemset", _s("MAIN_OPTIONS")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNOPTIONSCLICK
            )
        
        -- 装备 18  btn_main_equip
        -- local btnEquip = createMainButton_(
        --         18, "btn_main_equip", _s("MAIN_EQUIP")
        --         , MSG_ID.MSG_MAINNEWLAYER_ONBTNEQUIPCLICK
        --     )
        -- 铁匠铺 17  btn_main_smithy
        local btnSmithy = createMainButton_(
                17, "btn_main_smithy", _s("MAIN_SMITHY")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNSMITHYCLICK
            )
        -- 挖矿 18  btn_main_mining
        local btnMining = createMainButton_(
                18, "btn_main_mining", _s("MAIN_MINING")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNMININGCLICK
                , {
                    flash = true, light = true, mark = false, shake = true, 
                    checkRefresh = function ()
                        return ME:getCanMine() == TRUE
                    end
                }
            )
        -- 战队 19  btn_main_team
        local btnSmithy = createMainButton_(
                19, "btn_main_team", _s("MAIN_TEAM")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNTEAMCLICK
            )
        -- 大转轮 20  btn_main_big_wheel
        local btnBigWheel = createMainButton_(
                22, "btn_main_big_wheel", _s("MAIN_BIG_WHEEL")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNBIGWHEELCLICK 
            )
        btnBigWheel:lightOn(true)
        btnBigWheel:shakeOn(true)

         -- 7日签到 23  btn_main_big_wheel
        local btnShowday7 = createMainButton_(
                23, "btn_main_showday7", _s("MAIN_SHOWDAY7")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNSHOWDAY7CLICK
                ,{
                    flash = false, light = true, mark = false, shake = true, 
                    checkRefresh = function ()

                        return ME:getShowday7() == 2
                    end
                }

            )
        -- 配置指定活动按钮 25
        if ME:getActpng() ~= "" then
            local param = {}
            local targetString = string.split(ME:getActpng(), ",")
            for i, v in ipairs(targetString) do
                if string.find(v, ":") then
                    local kv = string.split(v, ":")
                    param[kv[1]] = kv[2]
                end
            end
            if not param.pic then return end
            local button = EffectButton.new(param.pic, param.text, 
                function ( button )
                    CCBCenter.loadCCB("MSG_MAINACTIVITYLAYER_MODEL", "ccb.c.main.MainActivityLayer", {selectAtype = param.selectAtype,})
                end, nil)
            local parent = CCBCenter.getNodeByTag(_node, 25)
            -- parent:removeAllChildrenWithCleanup(true)
            parent:addChild(button)
            util.alignNode(button, parent)
            table.insert(_mainButtons, button)
        end
        local poi = 26
        if _GAME.CONFIG.SDK_PLATFORM.army ~= false then
            -- 军团系统  btn_main_big_wheel
            local btnArmy7 = createMainButton_(
                    26, "btn_main_army", _s("MAIN_ARMY")
                    , MSG_ID.MSG_MAINNEWLAYER_ONBTNARMYCLICK
                )
            poi = 12
        end
        -- 许愿池 12  btn_main_wishing
        local btnWishing = createMainButton_(
                poi, "btn_main_wishing", _s("MAIN_WISHING")
                , MSG_ID.MSG_MAINNEWLAYER_ONBTNWISHINGCLICK
                , {
                    flash = true, light = true, mark = false, shake = true, 
                    checkRefresh = function ()
                        return ME:getCanWish() == TRUE
                    end
                }
            )
    end

    local function refreshAllMainButtons()
        if _mainButtons then 
            for _, button in ipairs(_mainButtons) do
                button:refresh()
            end
        end
    end

	local function initViews()

        --91工具条
        init91Tool()

        --增加经验ProgressBar
        _xp = widget.newProgressBar{
            frontSprintParams = {file = "main/progressBar_blue_img.png",},
            bgSprintParams = {file = "main/progressBar_blue_bg.png"},
            percentage = 0,
            ttfLabelParams = {size = 14, padding = {top = 20},},
        }
        _xp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 30802):addChild(_xp)

        --增加体力ProgressBar
        _sp = widget.newProgressBar{
            frontSprintsParams = {{file = "main/progressBar_green_img.png",}, {file = "main/progressBar_deep_green_img.png",}},
            bgSprintParams = {file = "main/progressBar_blue_bg.png"},
            percentage = 0,
            ttfLabelParams = {size = 14, padding = {top = 20},},
        }
        _sp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 30902):addChild(_sp)

        -- 定时接收聊天信息
        _scrollLabel = ScrollLabel.new{contentSize = CCBCenter.getNodeByTag(_node, 602):getContentSize(), playTime = 10, onComplete = function()
            CCBCenter.getNodeByTag(_node, 6):setVisible(false)
        end}
        CCBCenter.getNodeByTag(_node, 602):addChild(_scrollLabel)
        
        if ME:getLv() and ME:getLv() >= unlockLevel.MESSAGE then
            -- 启动聊天刷新
            util.delayCall(function ( )
                _messageSchedule = _scrollLabel:schedule(recChatRequest, 8)
            end, LOAD_DELAY_TIME )
        end

        createPositionTouch( )
        -- 消息点
        createMessagePoint( )

        --------按钮群---------------------------------
        createMainButtons()

        --------聊天框---------------------------------
        local chatLayer = CCBCenter.getNodeByTag(_node, 504)
        local offsetX = 100
        scrollTalkPanel = ScrollTalkPanel.new{contentSize = CCSize( 400 - offsetX, 51),}
        chatLayer:addChild(scrollTalkPanel)
        scrollTalkPanel:setPosition(ccp(offsetX, 0))
        if _GAME.CONFIG.SDK_PLATFORM.chat == false then
            scrollTalkPanel:setVisible(false)
            chatLayer:setVisible(false)
            CCBCenter.getNodeByTag(_node, 502):setVisible(false)
        end
        -- 隐藏主题图片
        -- CCBCenter.getNodeByTag(_node, 104):setVisible(false)
	end
    -- 判断是否执行新手帮助
    local function checkHelperInfo( )
        local msgEntity = ME:getTriggerMsgEntity()
        -- 排查
        if msgEntity:isShowHelpInfo() then 
            if not HelperView2.isNextIndex(300) then 
                local step = msgEntity:getHelpInfoStep()
                if 0 == step then
                    game.addGameState("STORY_PLAYED", nil)
                    HelperView2.setCurIndex(10)
                elseif 1 == step then
                    HelperView2.setCurIndex(300)
                elseif 2 == step then
                    HelperView2.setCurIndex(430)
                elseif 3 == step then
                    HelperView2.setCurIndex(655)
                elseif 4 == step then
                    HelperView2.setCurIndex(771)
                elseif 5 == step then
                    -- 卡牌解锁
                    HelperView2.setCurIndex(90010)
                    HelperView2.showBetween(_node, nil, {90010, 90010})
                    HelperView2.setCurIndex(870)
                    return true
                elseif 6 == step then
                    HelperView2.setCurIndex(920)
                elseif 7 == step then
                    HelperView2.setCurIndex(950)
                elseif 8 == step then
                    HelperView2.setCurIndex(981)
                else
                    return false
                end
            end
            return HelperView2.showBetween(_node, function ( index )
                if index == 40 then 
                    -- 好像要直接进入战斗了,急什么也不知道
                    require(PH_MDL_FACTORY .. "FightViewFactory").viewFirstFight()
                elseif index == 330 then 
                    game.showTopButtons( 1 )
                elseif index == HelperView2.INDEX_END then
                    if M.hasNote() then 
                        -- CCBCenter.loadCCB("MSG_MAINACTIVITYLAYER_MODEL", "ccb.c.main.MainActivityLayer", {selectAtype = ACTIVITY_ATYPE.BULLETIN,})
                    end
                end
            end, { 0 , 40 }, {300, 370}, {430, 430}, {655, 655}, {771, 771}, {920, 920}, {950, 950}, {981, 981}) ~= nil
        elseif msgEntity:isJumpToUnlockCard() then
            -- 卡牌解锁
            HelperView2.setCurIndex(90010)
            return HelperView2.showBetween(_node, nil, {90010, 90010}) ~= nil
        elseif msgEntity:isJumpToCardGroup() then
            -- 卡组解锁
            HelperView2.setCurIndex(100010)
            return HelperView2.showBetween(_node, nil, {100010, 100010}) ~= nil
        elseif msgEntity:isJumpToEnhancedHelper() then
            HelperView2.setCurIndex(10010)
            return HelperView2.showBetween(_node, nil, {10010, 10010}) ~= nil
        elseif msgEntity:isJumpToEvolutionHelper() then
            HelperView2.setCurIndex(20010)
            return HelperView2.showBetween(_node, nil, {20010, 20010}) ~= nil
        elseif msgEntity:isShowTalentHelper() then
            HelperView2.setCurIndex(50020)
            return HelperView2.showBetween(_node, nil, {50020, 50050}) ~= nil
        elseif msgEntity:isJumpToStarHelper() then
            HelperView2.setCurIndex(40010)
            return HelperView2.showBetween(_node, nil, {40010, 40010}) ~= nil
        elseif msgEntity:isJumpToChipHelper() then
            HelperView2.setCurIndex(80010)
            return HelperView2.showBetween(_node, nil, {80010, 80010}) ~= nil
        elseif msgEntity:isJumpToArenaHelper() then
            HelperView2.setCurIndex(70010)
            return HelperView2.showBetween(_node, nil, {70010, 70010}) ~= nil
        elseif msgEntity:isJumpToFriendHelper() then
            HelperView2.setCurIndex(30010)
            return HelperView2.showBetween(_node, nil, {30010, 30010}) ~= nil
        elseif msgEntity:isJumpToArenaWeekHelper() then
            HelperView2.setCurIndex(130010)
            return HelperView2.showBetween(_node, nil, {130010, 130010}) ~= nil
        elseif msgEntity:isShowEquipHelper() then
            HelperView2.setCurIndex(120010)
            return HelperView2.showBetween(_node, nil, {120010, 120010}) ~= nil
        elseif msgEntity:isJumpToEquipEnhancedHelper() then
            HelperView2.setCurIndex(140020)
            return HelperView2.showBetween(_node, nil, {140020, 140020}) ~= nil
        elseif msgEntity:isShowMiningHelper() then
            HelperView2.setCurIndex(150020)
            return HelperView2.showBetween(_node, nil, {150020, 150020}) ~= nil
        elseif msgEntity:isJumpToEquipEvoHelper() then
            HelperView2.setCurIndex(160020)
            return HelperView2.showBetween(_node, callback, {160020, 160020}) ~= nil
        elseif msgEntity:isJumpToEquipAddHelper() then
            HelperView2.setCurIndex(170020)
            return HelperView2.showBetween(_node, callback, {170020, 170020}) ~= nil
        elseif msgEntity:isJumpToTower1Helper() then
            HelperView2.setCurIndex(200010)
            return HelperView2.showBetween(_node, callback, {200010, 200010}) ~= nil
        elseif msgEntity:isJumpToTower2Helper() then
            HelperView2.setCurIndex(210010)
            return HelperView2.showBetween(_node, callback, {210010, 210010}) ~= nil
        end
        
    end
    -- 弹出奖励
    local function showRewardAlert( reward, onComplete, title )
        Log.d(TAG, "弹出奖励")
        local rewardEntity = require("model.main.RewardEntity").new(reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = onComplete,
                title = title,
            }
        )
    end
--[[ ## public fuction --]]
    -- 创建鞭炮
    local function createFirecracker( )
        local playTime = 3
        local layer = CCBCenter.getNodeByTag(_node, 21, "CCLayer")
        layer:removeAllChildrenWithCleanup(true)
        -- 倒计时
        local cdTimerNode = widget.newNode{contentSize = CCSize(200, 30)}
        layer:addChild(cdTimerNode, 2)
        util.alignNode(cdTimerNode, layer, display.TOP_CENTER, 10)
        -- local bgTimer = widget.newSprite{file = "map/bg_star.png"}
        -- cdTimerNode:addChild(bgTimer, 0)
        -- util.alignNode(bgTimer, cdTimerNode)
        local bgTimer = widget.newScale9{
            file = "map/bg_star.png", 
            rect = CCRect(0, 0, 88, 22),
            contentSize = CCSize(200, 30)
        }
        cdTimerNode:addChild(bgTimer, 0)
        util.alignNode(bgTimer, cdTimerNode)
        local cdTimer = CountDownView.new{ 
            format = _s("ACTIVITY_NEW_YEAR_TIME"),
            labelParams = {size = 22,},
            listener = function(timer)
                timer:stop()
                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ONFETCHGETCONFIG)
            end
        }
        cdTimerNode:addChild(cdTimer, 1)
        util.alignNode(cdTimer, cdTimerNode)
        -- 鞭炮
        local progressBar = widget.newProgressBar{
            frontSprintParams = {file =  "main/activity/newyearseve/img_firecracker.png",},
            bgSprintParams = {file = "bg_transparent.png"},
            percentage = 100,
            percentageLabelString = "",
        }
        layer:addChild(progressBar)
        progressBar:setRotation(90)
        util.alignNode(progressBar, layer, display.CENTER_TOP, {top = 30, left = -30})
        function progressBar:doFire( )
            local fireSprite = anim.playAnimation(nil, "main/activity/newyearseve/firecracker_anim", "firecracker_anim_%d.png", 6, 0.2, 1, true)
            layer:addChild(fireSprite, 2)
            fireSprite:setPosition(layer:getContentSize().width/2, 30)
            transition.moveBy(fireSprite, {time = playTime, x = 0, y = layer:getContentSize().height})
            _isFireFinish = false
            cdTimerNode:setVisible(false)
            CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ONFETCHFIRECRACKERREWARD)
            progressBar:runProgressFromTo(playTime, 100, 0, function( )
                fireSprite:stopAllActions()
                fireSprite:removeFromParentAndCleanup(true)
                util.enableCustomTouch(_node, true)
                game.enableTopButtonTouch(true)
                layer:stopAllActions()
                _isFireFinish = true
                if _isGetFireReward then
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINNEWLAYER_ACTION_ONFETCHGETCONFIG)
                    showRewardAlert(_reward, nil, _s("REWARD_TITLE_NEWYEAR"))
                end
            end)
            -- 摇一摇
            anim.shake(layer, {playTime = 0.5, rotate = 2, forever = true,})
        end

        function progressBar:updateData( )
            if GAMERATE:getCtime() > 0 then
                cdTimer:start(GAMERATE:getCtime())
            else
                local tipLabel = ui.newTTFLabel{
                    text = _s("ACTIVITY_NEW_YEAR_REWARD"),
                }
                cdTimerNode:addChild(tipLabel, 1)
                util.alignNode(tipLabel, cdTimerNode)
                cdTimer:setVisible(false)
                -- 绑定点击
                widget.bindTouchEvent{
                    layer = layer,
                    swallowsTouches = true,
                    priority = -1,
                    clickListener = function( touchLayer )
                        util.enableCustomTouch(layer, false)
                        util.enableCustomTouch(_node, false)
                        game.enableTopButtonTouch(false)
                        progressBar:doFire( )
                    end,
                }
            end
        end
        
        return progressBar
    end
    -- 除夕鞭炮
    local function updateFirecracker( reward )
        if GAMERATE:getCsta() ~= 2 and not ME:getTriggerMsgEntity():isShowHelpInfo() then
            if not _firecracker then 
                _firecracker = createFirecracker( )
            end
            _firecracker:updateData( )
        else
            CCBCenter.getNodeByTag(_node, 21):removeAllChildrenWithCleanup(true)
            _firecracker = nil
        end
        if reward then
            _reward = reward
            _isGetFireReward = true
            if _isFireFinish then
                showRewardAlert(_reward, nil, _s("REWARD_TITLE_NEWYEAR"))
            end
        end
    end
    -- 创建宝箱
    local function createTreasureChest( )
        local layer = CCBCenter.getNodeByTag(_node, 16)
        layer:removeAllChildrenWithCleanup(true)
        local button = EffectButton.new(
            "btn_main_treasure_chest", nil,--_s("REWARD_TITLE"), 
            function ( button )
                -- CCBCenter.sendLuaMessage(msgId)
                CCBCenter.loadCCB("MSG_MAINTREASURECHESTALERTLAYER_MODEL", "ccb.c.main.MainTreasureChestAlertLayer")
            end, 
            {flash = true, light = false, mark = true, markPadding = {right = 60, bottom = 90}, shake = true, noBgSprite = true}
        )

        layer:addChild(button)
        button:markOn()
        button:shakeOn()
        util.alignNode(button, layer:getContentSize(), display.CENTER)
        anim.popOut(button)
        return button
    end
    -- 登陆礼包
    local function updateTreasureChest( )
        if #GAMERATE:getLoginrewards() > 0 and not ME:getTriggerMsgEntity():isShowHelpInfo() then
            if not _treasureChest then 
                _treasureChest = createTreasureChest( )
            end
        else
            CCBCenter.getNodeByTag(_node, 16):removeAllChildrenWithCleanup(true)
            _treasureChest = nil
        end
    end
    -- 游戏中的引导与通知
    function M.checkGameInfo( )
        -- 新手帮助
        if not checkHelperInfo() then
            M.createHero()
            -- if M.hasNote() then
            --     -- 系统公告
            --     util.delayCall(function ( )
            --         -- CCBCenter.loadCCB("MSG_MAINACTIVITYLAYER_MODEL", "ccb.c.main.MainActivityLayer", {selectAtype = ACTIVITY_ATYPE.BULLETIN,})
            --     end, 0.6)
            -- end
            if not _GAME.SHOWNOTICE then
                _GAME.SHOWNOTICE = true
                CCBCenter.loadCCB("MSG_SYSTEMNOTICELAYER_MODEL", "ccb.c.main.SystemNoticeLayer", {})
            end
        else
            local curIndex = HelperView2.getCurIndex()
            if (0 <= curIndex and curIndex <= 40) or (300 <= curIndex and curIndex <= 310) then 
                -- 有前三段的新的引导,看来是不要英雄了...
            else
                M.createHero()
            end
        end
    end
    -- 有系统公告
    function M.hasNote( )
        -- if M.isFirstLogin( ) and ME:getNotever() ~= 0 then
        --  return true
        -- end
        if ME:getNotever() == 0 or (ISGSVALUES()["NOTE"] and ISGSVALUES()["NOTE"] == ME:getNotever()) or ISGSVALUES()["NOTE"] == 0 then
            return false
        else
            ISGSVALUES()["NOTE"] = ME:getNotever()
            GS.save(ISGSVALUES())
            return true
        end
    end
    -- 每个用户的首次登陆
    function M.isFirstLogin( )
        local nowTime = os.date("%Y/%m/%d")
        local function saveLocalTime( time )
            ISGSVALUES()[ME:getUserno()] = time
            GS.save(ISGSVALUES())
        end
        if ISGSVALUES()[ME:getUserno()]then
            local now = string.split(nowTime, "/")
            local saveTime = string.split(ISGSVALUES()[ME:getUserno()], "/")
            if not saveTime[1] or not saveTime[2] or not saveTime[3] then
                saveLocalTime(nowTime)
                return true
            end
            if saveTime[1] < now[1] then
                saveLocalTime(nowTime)
                return true
            elseif saveTime[2] < now[2] then
                saveLocalTime(nowTime)
                return true
            elseif saveTime[3] < now[3] then
                saveLocalTime(nowTime)
                return true
            end
            return false
        else
            saveLocalTime(nowTime)
            return true
        end
    end

    function M.createHero()
        -- 英雄形象
        if not _role then 
            local heroLayer = CCBCenter.getNodeByTag(_node, 7)
            heroLayer:removeAllChildrenWithCleanup(true)
            _role = ME:createPlayerView{randomAction = true}
            heroLayer:addChild(_role) 
            _role:setPosition(ccp(500, 120))
        end
    end
    -- 关闭
    local function enableMessageSchedule( enable )
        if enable then
            if ME:getLv() and ME:getLv() >= unlockLevel.MESSAGE then
                -- 启动聊天刷新
                _messageSchedule = _scrollLabel:schedule(recChatRequest, 8)
            end
        else
            _scrollLabel:removeAction(_messageSchedule)
        end
    end
	--[[ 

	更新玩家信息

	--]]

	function M.updatePlayerInfo( )
		-- 可优化
		if ME:getName() then
    		-- 名字
        	luaValue.mNameLabel:setString(ME:getName())
		end
        -- 性别
        CCBCenter.getNodeByTag(_node, 302):removeAllChildrenWithCleanup(true)
        local sexSprite = widget.newSprite{ 
			file = iff(ME:getSex() == MALE, "img_sex_boy.png", "img_sex_girl.png"), 
			ignoreAnchor = true, 
        }
        CCBCenter.getNodeByTag(_node, 302):addChild(sexSprite)

        -- 玩家装备
        if _role then
            _role:dressEquipments( ME:getEquiplst() )
        end

        -- 头像
        -- if not _roleHead then
            local headNode = CCBCenter.getNodeByTag(_node, 30502)
            headNode:removeAllChildrenWithCleanup(true) 
            _roleHead = ME:createPlayerHeadRectView(
                function ( )
                    -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer"
                    --     , {fid = ME:getUserid(),showBtn = true})
                    if not ME:getTriggerMsgEntity():isUnlockEquip() then
                        NetHelper.QuickToast(_s("COMMON_UNOPEN", require("static.unlock_level").EQUIP, _s("MAIN_EQUIP")))
                        return
                    end
                    -- HelperView2.showNext()
                    CCBCenter.loadCCB("MSG_EQUIPMENTLAYER_MODEL", "ccb.c.equipment.EquipmentLayer")
                end)
            _roleHead:setScale((headNode:getContentSize().width - 20) / _roleHead:getContentSize().width)
            headNode:addChild(_roleHead)
            util.alignNode(_roleHead, headNode, display.BOTTOM_LEFT, {left = 12, bottom = 12} )
        -- else
            -- _roleHead:getRole():dressEquipments( ME:getEquiplst(), true )
        -- end

        -- 等级
        luaValue.mLevelLabel:setString(ME:getLv())
        -- 召唤值
        luaValue.mCostLabel:setString( ME:getUsedcost() .. "/".. ME:getTotalcost())
        -- 经验
        local xp = ME:getCurexp() /  ME:getTotalexp() * 100
        _xp:runProgressTo( 0.5 , xp )
        _xp:setString(ME:getCurexp() .. "/" .. ME:getTotalexp())
        -- 体力
        local sp = ME:getCursp() /  ME:getActlimit() * 100
        _sp:runProgressTo( 0.5 , sp )
        _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
        -- 金币
        luaValue.mGoldLabel:setString(ME:getGold())
        -- 钻石
        luaValue.mDiamondLabel:setString(ME:getDiamond())
        -- 星星
        luaValue.mStarLabel:setString(ME:getStar())
        -- 新消息
        CCBCenter.getNodeByTag(_node, 503):setVisible(ME:getNmessage() > 0)
        luaValue.mNewMessageLabel:setString(ME:getNmessage())
        -- 首充按钮显示
        CCBCenter.getNodeByTag(_node, 15):setVisible(ME:getFirstpay() == TRUE)
        if GAMERATE.getShowBigWheel then
            CCBCenter.getNodeByTag(_node, 22):setVisible(GAMERATE:getShowBigWheel() == TRUE)
        end
        if ME:getShowday7() == 0 then
            CCBCenter.getNodeByTag(_node, 23):setVisible(false)
        else
            CCBCenter.getNodeByTag(_node, 23):setVisible(true)
        end
        refreshAllMainButtons()
    end
--[[ ## MAINs --]]
	initViews()
	_node.updatePlayerInfo 	       = M.updatePlayerInfo
    _node.checkGameInfo            = M.checkGameInfo
    _node.updateTreasureChest      = updateTreasureChest
    _node.updateFirecracker        = updateFirecracker
    _node.enableMessageSchedule    = enableMessageSchedule
    _node.checkHelperInfo          = checkHelperInfo
end

return M