--MainRewardAlertLayer.lua
local M = {}
local CardMaster = require("cardui.CardMaster")

function M.bindView(node, luaValue)
	local TAG = "[MainRewardAlertLayerView]"
	local _node, _nodeTable = node, luaValue
	local _dayRewardGrid, _commondRewardGrid
	local _dayGridOffset, _commondGridOffset
	local _missionTab
	local _unlockLevel = require("static.unlock_level")
	local GoodsMaster = require("cardui.GoodsMaster")
    local GoodsEntity = require("model.goods.GoodsEntity")
    local CardEntity = require("model.card.CardEntity")
    local CardMaster = require("cardui.CardMaster")
	local _selectTab = _node._SELECT or 1
	-- [[ 奖励类型 ]]
	local REWARD_TYPE_DAY         = 1 	-- 日常活动
	local REWARD_TYPE_ACHIEVEMENT = 2 	-- 成就
	
--[[ ## local fuction --]]
	local function saveOffset( )
		_dayGridOffset = _dayRewardGrid:getContentOffset()
		_commondGridOffset = _commondRewardGrid:getContentOffset()
	end
	local function cellAtIndex( scrollGrid, idx , item)
		local cell = display.newLayer()
		-- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
		cell:setContentSize(scrollGrid:getCellSize())
		-- 背景
		local bgSprite = widget.newScale9{
			file = "mission/bg_mission_cell.png",
			contentSize = cell:getContentSize(),
			rect = CCRectMake(0, 0, 221, 130),
		}
		util.alignNode(bgSprite, cell)
		cell:addChild(bgSprite, 0)

		-- 奖励类型背景
		local bgReward = widget.newSprite{file = "common/bg/bg_item.png", }
		util.alignNode(bgReward, cell, display.LEFT_CENTER, {left = 10, } )
		cell:addChild(bgReward )
		cell.VIEW_ = bgReward

  		local function createGoodsView_( no )
            local entity = GoodsEntity.new{no = no}
            entity.type = GoodsMaster.MATERIAL
            entity.disenableTouch = true
            entity.showFrame = true
            local goodsSprite = GoodsMaster.new(entity)
            return goodsSprite
  		end
  		local function createCardView_( no )
  			local cardEntity = CardEntity.new{id = no}
  			cardEntity.type = CardMaster.MINISTARCARD
  			cardEntity.disenableTouch = true
            local cardSprite = CardMaster.new(cardEntity)
            cardSprite:setScale(0.76)
            return cardSprite
  		end

  		local iconSprite
  		if item.pic and item.pic ~= "" then
  			iconSprite = widget.newSprite{file = item.pic,}
		elseif item.pno and item.pno > 0 then
			if item.pno > 10000 then
		       	iconSprite = createGoodsView_(item.pno)
		    elseif item.pno > 5000 then
		        iconSprite = createCardView_(item.pno)
		        local chipSprite = widget.newSprite{file = "fight/result3/f_r3_cardchip.png"}
                iconSprite:addChild(chipSprite, 2)
				util.alignNode(chipSprite, iconSprite)
	        elseif item.pno > 0 then
	        	iconSprite = createCardView_(item.pno)
		    end
  		end
  		if iconSprite then
	    	cell:addChild(iconSprite, 2)
			util.alignNode(iconSprite, cell, display.CENTER, {left = -310, } )
	    end

		local function onBtnClick( button, x, y )
			if not util.isPointInNode(CCBCenter.getNodeByTag(_node, 3), x, y) then
				return
			end
			local function resolveData_( target )
	            local msgid, path, param
	            param = {}
	            local targetString = string.split(target, ",")
	            for i, v in ipairs(targetString) do
	                if string.find(v, ":") then
	                    local kv = string.split(v, ":")
	                    param[kv[1]] = kv[2]
	                end
	            end
	            msgid = param.msgid
	            path = param.path
	            return msgid, path, param
	        end
			local function isUnlock_( lv )
				lv = tonumber(lv)
				if ME:getLv() < lv then
					NetHelper.QuickToast(_s("COMMON_LV_OPEN", lv))
					return false
				else
					return true
				end
			end
			-- item.target = "msgid:MSG_MAPCONTAINERLAYER_MODEL,path:ccb.c.map.MapContainerLayer,alert:1,unlocklv:1"
			-- 参与状态
			if item.status == 1 then
				local msgid, path, param = resolveData_(item.target)
				if tonumber(param.alert) == TRUE and isUnlock_(param.unlocklv) then
					if isUnlock_(param.unlocklv) then
						CCBCenter.replaceScene(msgid, path, param, function (node)
			                node:performWithDelay(function ( ... )
			                    game.requestDateForLoad( node )
			                    util.enableCustomTouch( scrollLinear, true )
			                end, 0.01)
			                node.onExit = function ( self )
			                    util.removeUnusedTextures()
			                end
			            end)
					end
				else
					if isUnlock_(param.unlocklv) then
						CCBCenter.loadCCB(msgid, path, param)
					end
				end
			elseif item.status == 4 or item.status == 0 then
				-- 不弹
				-- CCBCenter.loadCCB("MSG_MAINDAILYSIGNLAYER_MODEL", "ccb.c.main.MainDailySignLayer", item)
			else
				local data = {}
				data.no = item.no
				data.typ = item.typ
				util.enableCustomTouch(button, false)
				saveOffset()
				CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHRECEIVEREWARD, nil, data)
			end
		end
		
		local btnSize = CCSize(113, 60)
		local paddingtop = 0
		-- 奖励预览
		if item.showreward == TRUE then
			btnSize = CCSize(113, 50)
			paddingtop = 30
			local preButton = widget.newButton{
				contentSize = btnSize,
				normalImage = "common/buttons/btn_normal_yellow.png",
				disableImage = "common/buttons/btn_normal_gray.png",
				rect = CCRectMake(0, 0, 80, 58),
				listener = function ( button, x, y )
					if not util.isPointInNode(CCBCenter.getNodeByTag(_node, 3), x, y) then
						return
					end
					-- item.reward = {gold = 1000, diamond = 1000}
					--奖励预览串
					local rewardEntity = require("model.main.RewardEntity").new(item.reward)
					CCBCenter.loadCCB(
			            "MSG_SPECIALMAPREWARDPREVIEWLAYER_MODEL", 
			            "ccb.c.specialMap.SpecialMapRewardPreviewLayer", 
			            {
			                entity = rewardEntity,
			                title = _s("SPECIALMAP_REWARD_REWVIEW"),
			            }
			        )
				end,
				labelParams = {text = _s("SPECIALMAP_REWARD_REWVIEW"), size = 22, color = BUTTON_COLOR3.BROWN},
				scale = 1.1,
			}
			util.alignNode(preButton, cell, display.CENTER, {top = -paddingtop, left = 290,})
			cell:addChild(preButton, 1)
		end
		-- 领奖按键
		local button = widget.newButton{
			contentSize = btnSize,
			normalImage = "common/buttons/btn_normal_yellow.png",
			disableImage = "common/buttons/btn_normal_gray.png",
			rect = CCRectMake(0, 0, 80, 58),
			listener = onBtnClick,
			labelParams = {text = "", size = 22, color = BUTTON_COLOR3.BROWN},
			scale = 1.1,
		}
		util.alignNode(button, cell, display.CENTER, {top = paddingtop, left = 290,})
		cell:addChild(button, 1)

		-- 状态
		-- 未完成 0
		if item.status == MISSIONSTATUS.UNFINISHED then
			button.setStateDisabled(true)
			button.setTextString(_s("REWARD_UNFINISHED"))
		-- 参与 1
		elseif item.status == MISSIONSTATUS.JOIN then
			button.setTextString(_s("REWARD_JOIN"))
		-- 领取 2
		elseif item.status == MISSIONSTATUS.RECEIVE then
			button.setTextString(_s("REWARD_RECEIVE"))
		-- 完成 3
		elseif item.status == MISSIONSTATUS.FINISHED then
			button.setStateDisabled(true)
			button.setTextString(_s("REWARD_FINISHED"))
		-- 未开启 4
		elseif item.status == MISSIONSTATUS.NOTOPEN then
			button.setStateDisabled(true)
			button.setTextString(_s("REWARD_NOTOPEN"))
		-- 休战中
		elseif item.status == MISSIONSTATUS.TRUCE then
			button.setStateDisabled(true)
			button.setTextString(_s("REWARD_TRUCE"))
		end

		-- 标题
		local title = ui.newTTFLabel{
			text = item.title,
			size = 20,
			color = ccc3(60, 36, 21),
		}
		util.alignNode(title, cell, display.LEFT_TOP, {left = 108, top = 8,})
		cell:addChild(title, 1)
		-- 描述
		local desc = ui.newTTFLabel{
			text = item.desc,
			-- valign = ui.TEXT_VALIGN_TOP,
			size = 20,
			dimensions = CCSize(480, 70),
			color = ccc3(60, 36, 21), 
		}
		util.alignNode(desc, cell, display.LEFT_TOP, {left = 108, top = 32,})
		cell:addChild(desc, 1)

		-- -- 进度
		-- local progressText = item.memo

		-- if item.target == MISSIONTARGET.JJC then
		-- 	progressText = _s("REWARD_LAST_RANK") .. item.total
		-- end
		-- 进度
		local progress = ui.newTTFLabel{
			text = item.memo,
			size = 16, 
			color = COLOR3.RED,
		}
		util.alignNode(progress, cell, display.LEFT_BOTTOM, {left = 108, bottom = 8,})
		cell:addChild(progress, 1)
		-- 倒计时
		if item.time > 0 then
			local cdTimer = CountDownView.new({ 
				format = "[hh]:[mm]:[ss]",
				labelParams = {size = 16, color = COLOR3.RED,},
				listener = function(timer)
                    timer:stop()
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINREWARDALERTLAYER_ACTION_ONFETCHREWARDLIST)
				end,
				time = item.time,
			})
			cdTimer:start()
			cell:addChild(cdTimer, 1)
			cdTimer:setAnchorPoint(ccp(0, 0))
			cdTimer:setPosition(ccp(progress:getPositionX() + progress:getContentSize().width, progress:getPositionY()))
		end
		cell:ignoreAnchorPointForPosition(false)
		return cell
	end
	local function onItemClick( grid, index, item, x, y  )
		local cell = grid:cellAt(index)
		local view = cell.VIEW_
		if view then
			if util.isPointInNode(view, x, y) then
				-- 卡牌弹出窗
				local function showCardAlertView_( no )
				    local cardEntity = CardEntity.new{id = no}
				    CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", cardEntity)
				end
				-- 装备弹出窗
				local function showEquipAlertView_( no )
				    local equipEntity = GoodsEntity.new{no = no}
				    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", equipEntity)
				end
				-- 物品弹出窗
				local function showGoodsAlertView_( no )
				    local goodsEntity = GoodsEntity.new{no = no}
				    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", goodsEntity)
				end
				if item.pno > 20000 then
			        showEquipAlertView_(item.pno)
			    elseif item.pno > 10000 then
			        showGoodsAlertView_(item.pno)
			    elseif item.pno > 0 then
			        showCardAlertView_(item.pno)
			    end
			end
		end
		
	end
	-- 创建列表
	local function createScrollGrid( nodeId )
		--取得table容器
		local layer = CCBCenter.getNodeByTag(_node, nodeId)
		layer:removeAllChildrenWithCleanup(true)

		local scrollGrid = widget.newScrollGrid{
	        contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(layer:getContentSize().width, 130),
	            padding = { 
	                middleH = 4, middleV = 5,
	            },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            container = CCBCenter.getNodeByTag(_node, 3),
	            tapListener = onItemClick,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	    }
	    return scrollGrid
	end

	local function createTab( )
		local layer = CCBCenter.getNodeByTag(_node, 2)
		layer:removeAllChildrenWithCleanup(true)

		local function onTabClick( index, button )
			HelperView2.showNext()
			SOUND:playEffectButton1()
			_selectTab = index
			if index == REWARD_TYPE_ACHIEVEMENT then
				CCBCenter.getNodeByTag(_node, 302):setVisible(true)
				CCBCenter.getNodeByTag(_node, 301):setVisible(false)
			elseif index == REWARD_TYPE_DAY then
				CCBCenter.getNodeByTag(_node, 302):setVisible(false)
				CCBCenter.getNodeByTag(_node, 301):setVisible(true)
			end
		end

		local buttons = { }
		local buttonText = {_s("REWARD_DAY_DUTY"), _s("REWARD_ACHIEVEMENT")}
	    for i, v in ipairs(buttonText) do
	    	local btnRace = widget.newButton{   
                selectImage = "mission/btn_tab_select.png",
                normalImage = "mission/btn_tab_normal.png",
                contentSize = CCSize(147, 62),
                labelParams = {text = v, size = 22, color = BUTTON_COLOR3.BROWN},
                scale = 1.1,
            } 
		    table.insert(buttons, btnRace)   
	    end
        local tab = widget.newTab{
            items = buttons,
            selectIndex = _node._SELECT,
            padding = 10,
            listener = onTabClick,
            direction = DIRECTION_HORIZONTAL,
        }
        layer:addChild(tab)
        util.alignNode(tab, layer)
        return tab
	end
	local function checkHelperInfo( )
		HelperView2.showBetween(_node, nil, {960, 970}, {980, 990})
	end
	local function initViews()
		checkHelperInfo( )
		_missionTab = createTab( )
		_dayRewardGrid = createScrollGrid(301)
		_commondRewardGrid = createScrollGrid(302)
	end

--[[ ## public fuction --]]
	function M.updateReward( items, select )
		local day = {}
		local common = {}
		_selectTab = select or _selectTab
		-- 区分活动
		for i,v in ipairs(items) do
			if v.typ == REWARD_TYPE_ACHIEVEMENT then
				table.insert(common, v)
			elseif v.typ == REWARD_TYPE_DAY then
				table.insert(day, v)
			end
		end
		-- 选中活动
		_missionTab.selectButton(_selectTab)
		if _selectTab == REWARD_TYPE_ACHIEVEMENT then
			CCBCenter.getNodeByTag(_node, 302):setVisible(true)
			CCBCenter.getNodeByTag(_node, 301):setVisible(false)
		elseif _selectTab == REWARD_TYPE_DAY  then
			CCBCenter.getNodeByTag(_node, 302):setVisible(false)
			CCBCenter.getNodeByTag(_node, 301):setVisible(true)
		end
		_dayRewardGrid:setItems(day)
		_commondRewardGrid:setItems(common)	
		if _dayGridOffset then
			_dayRewardGrid:setContentOffset(_dayGridOffset)
		end
		if _commondGridOffset then
			_commondRewardGrid:setContentOffset(_commondGridOffset)
		end

	end
--[[ ## MAINs --]]
	initViews()
	_node.updateReward 	 = M.updateReward
	_node.checkHelperInfo 	 = checkHelperInfo
end

return M