--MainTreasureChestAlertLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MainTreasureChestAlertLayerView]"
	local _node, _nodeTable = node, luaValue
    local _scrollView
    local _contentOffset
    local STATUS_FINISHED = 0
    local STATUS_RECEIVE = 1
    
--[[ ## local fuction --]]
    local function createScrollView( )
        --取得table容器
        local layer = CCBCenter.getNodeByTag(_node, 301)
        layer:removeAllChildrenWithCleanup(true)
        layer:setVisible(true)
        local function cellAtIndex( scrollLinear, idx , item)
            local cell = display.newLayer()
            -- local cell = display.newColorLayer(ccc4(255, 255, 255, 255))
            cell:setContentSize(scrollLinear:getCellSize())
            -- 背景
            local bgSprite = widget.newScale9{
                file = "mission/bg_mission_cell.png",
                contentSize = cell:getContentSize(),
                rect = CCRectMake(0, 0, 221, 130),
            }
            util.alignNode(bgSprite, cell)
            cell:addChild(bgSprite, 0)

            -- 奖励类型背景
            local bgReward = widget.newSprite{file = "common/bg/bg_item.png", }
            util.alignNode(bgReward, cell, display.LEFT_CENTER, {left = 10, } )
            cell:addChild(bgReward )

            -- 奖励图片
            local imgFile = "minGoods/box_1.png"
            -- 图片
            -- local pic = tonumber(item.pic)
            -- if pic == MISSIONICON.DIAMOND then
            --     imgFile = "main/img_sign_diamond.png"
            -- elseif pic == MISSIONICON.GOLD then
            --     imgFile = "reward/icon/icon_gold.png"
            -- elseif pic == MISSIONICON.FP then
            --     imgFile = "main/img_sign_friendpoint.png"
            -- elseif pic == MISSIONICON.CARD then
            --     imgFile = "main/img_sign_exp.png"
            -- elseif pic == MISSIONICON.CHIP then
            --     imgFile = "main/img_sign_fragment.png"
            -- elseif pic == MISSIONICON.FREECARD then
            --     imgFile = "mission/img_sign_freebuy.png"
            -- elseif pic == MISSIONICON.SP then
            --     imgFile = "mission/img_sign_burette.png"
            -- elseif pic == MISSIONICON.EXP then
            --     imgFile = "main/img_sign_exp.png"
            -- elseif pic == MISSIONICON.ARENA then
            --     imgFile = "mission/img_sign_arena.png"
            -- elseif pic == MISSIONICON.STAR then
            --     imgFile = "map/btn_star_select.png"
            -- end

            local rewardsSprite = widget.newSprite{file = imgFile, }
            cell:addChild(rewardsSprite, 1)
            util.alignNode(rewardsSprite, cell, display.CENTER, {left = -310, } )

            local function onBtnClick( button, x, y )
                if not util.isPointInNode(CCBCenter.getNodeByTag(_node, 3), x, y) then
                    return
                end
                local data = {}
                data.no = item.no
                data.tno = item.tno
                -- 参与状态
                if item.status == 1 then
                    util.enableCustomTouch(button, false)
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAINTREASURECHESTALERTLAYER_ACTION_ONFETCHRECEIVELOGINREWARD, nil, data)
                end
            end
            -- 按键
            local button = widget.newButton{
                contentSize = CCSize(113, 60),
                normalImage = "common/buttons/btn_normal_yellow.png",
                disableImage = "common/buttons/btn_normal_gray.png",
                rect = CCRectMake(0, 0, 80, 58),
                listener = onBtnClick,
                -- container = CCBCenter.getNodeByTag(_node, 3),
                labelParams = {text = "", size = 22, color = BUTTON_COLOR3.BROWN},
                scale = 1.1,
            }
            util.alignNode(button, cell, display.CENTER, {top = 20, left = 290,})
            cell:addChild(button, 1)
            -- 领取
            if item.status == STATUS_RECEIVE then
                button.setTextString(_s("REWARD_RECEIVE"))
            -- 已领取
            elseif item.status == STATUS_FINISHED then
                button.setStateDisabled(true)
                button.setTextString(_s("REWARD_ALREADY_RECEIVE"))
            end

            -- 标题
            local title = ui.newTTFLabel{
                text = item.title,
                size = 20,
                color = ccc3(60, 36, 21),
            }
            util.alignNode(title, cell, display.LEFT_TOP, {left = 108, top = 8,})
            cell:addChild(title, 1)
            -- 描述
            local desc = ui.newTTFLabel{
                text = item.content,
                size = 18,
                dimensions = CCSize(480, 70),
                color = ccc3(60, 36, 21), 
            }
            util.alignNode(desc, cell, display.LEFT_TOP, {left = 108, top = 28,})
            cell:addChild(desc, 1)

            -- 内容
            local progress = ui.newTTFLabel{
                text = item.memo,
                size = 16, 
                color = COLOR3.RED,
            }
            util.alignNode(progress, cell, display.LEFT_BOTTOM, {left = 108, bottom = 8,})
            cell:addChild(progress, 1)
            cell:ignoreAnchorPointForPosition(false)
            return cell
        end
        local scrollView = widget.newScrollGrid{
            contentSize = layer:getContentSize(),
            contentParams = {
                cellSize = CCSize(layer:getContentSize().width, 130),
                padding = { 
                    middleH = 4, middleV = 5,
                },
                column = 1,
                createItemCellListener = cellAtIndex,
                -- tapListener = onBtnClick,
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = layer,
        }
        return scrollView
    end
    local function updateTreasureChest( )
        -- local loginrewards = {
        --     {no = 1, title = "大福利礼包1", pic = 1, content = "昨天到期", memo = "超级福利", status = STATUS_RECEIVE}, 
        --     {no = 2, title = "大福利礼包2", pic = 2, content = "昨天到期", memo = "超级福利", status = STATUS_FINISHED}, 
        --     {no = 3, title = "大福利礼包3", pic = 3, content = "昨天到期", memo = "超级福利", status = STATUS_RECEIVE},
        --     {no = 4, title = "大福利礼包4", pic = 4, content = "昨天到期", memo = "超级福利", status = STATUS_FINISHED},  
        -- }
        _scrollView:setItems(GAMERATE:getLoginrewards())
        -- _scrollView:setItems(loginrewards)
        -- if _contentOffset then
        --     _scrollView:setContentOffset(_contentOffset)
        -- end
    end
	local function initViews()
		_scrollView = createScrollView()
        updateTreasureChest( )
	end

--[[ ## public fuction --]]
    local function saveOffset( )
        _contentOffset = _scrollView:getContentOffset()
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateTreasureChest = updateTreasureChest
    _node.saveOffset = saveOffset
end

return M