--ReceiveRewardAlertLayer.lua

-- 使用方法
-- local rewardEntity = require("model.main.RewardEntity").new({cards = {{id = 1}, {id = 1002}}, gold = 10000})
-- CCBCenter.loadCCB(
	-- "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
	-- "ccb.c.main.ReceiveRewardAlertLayer", 
	-- {
		-- entity = rewardEntity, 
		-- 确认按钮事件
		-- onConfirm = function( )
			-- print("onConfirm")
		-- end
	-- }
-- )

local M = {}
function M.bindView(node, luaValue)
	local TAG = "[ReceiveRewardAlertLayerView]"
	local _node, _nodeTable = node, luaValue
	local _data = _node._DATA
	local GoodsMaster = require("cardui.GoodsMaster")
    local GoodsEntity = require("model.goods.GoodsEntity")
    local CardEntity = require("model.card.CardEntity")
    local CardMaster = require("cardui.CardMaster")
	local _scrollGrid
	local REWARD_TYPE_CARD  	= 0
	local REWARD_TYPE_CHIP  	= 1
	local REWARD_TYPE_GOODS 	= 2
	local REWARD_TYPE_SP		= 3
	local REWARD_TYPE_GOLD  	= 4
	local REWARD_TYPE_FP    	= 5
	local REWARD_TYPE_DIAMOND  	= 6
	local REWARD_TYPE_FREEBUY  	= 7
	local REWARD_TYPE_STAR  	= 8
	local REWARD_TYPE_EXP   	= 9
	local REWARD_TYPE_APOINT   	= 10

--[[ ## local fuction --]]
	-- 旋转的光效
    local function createLightAnim( )
        local light_1 = CCBCenter.getNodeByTag(_node, 10101)
        local light_2 = CCBCenter.getNodeByTag(_node, 10102)
        anim.circling(light_1, {forever = true, forward = true})
        anim.circling(light_2, {forever = true})
    end
    local function createScrollGrid( )
    	local layer = CCBCenter.getNodeByTag(_node, 105)

    	local function cellAtIndex( scrollGrid, idx , item)
    		local cell = widget.newLayer()
            cell:setContentSize(scrollGrid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- 背景
            local bgSprite = widget.newSprite{file = "goods/goodBack.png"}

            local spriteLayer = widget.newNode{color = ccc4(255, 100, 255, 100), contentSize = bgSprite:getContentSize()}
            cell:addChild(spriteLayer)
            util.alignNode(spriteLayer, cell:getContentSize(), display.CENTER_LEFT)

            spriteLayer:addChild(bgSprite, 0)
            util.alignNode(bgSprite, spriteLayer:getContentSize(), display.CENTER)
            -- 横线
            local lineSprite = widget.newSprite{file = "reward/img_reward_line.png"}
            cell:addChild(lineSprite, 0)
            util.alignNode(lineSprite, cell:getContentSize(), display.CENTER_BOTTOM)

            local rewardSprite
            local count = 1
    		if item._TYPE == REWARD_TYPE_CARD then
    			-- 卡牌
                item.type = CardMaster.MINISTARCARD
                rewardSprite = CardMaster.new(item)
                rewardSprite:setScale(0.76)
                count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_CHIP then
				-- 碎片
				item.type = CardMaster.MINISTARCARD
                rewardSprite = CardMaster.new(item)
                rewardSprite:setScale(0.76)
                local chipSprite = widget.newSprite{file = "fight/result3/f_r3_cardchip.png"}
                spriteLayer:addChild(chipSprite, 2)
				util.alignNode(chipSprite, spriteLayer:getContentSize(), display.CENTER)
                count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_GOODS then
				-- 物品
                item.type = GoodsMaster.MATERIAL
                item.showFrame = true
                rewardSprite = GoodsMaster.new(item)
                -- count = rewardSprite:getCount()
                count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_SP then
				-- 体力
				rewardSprite = widget.newSprite{file = "mission/img_sign_burette.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_GOLD then
				-- 金币
				rewardSprite = widget.newSprite{file = "reward/icon/icon_gold.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_FP then
				-- 友情点
				rewardSprite = widget.newSprite{file = "main/img_sign_friendpoint.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_DIAMOND then
				-- 钻石
				rewardSprite = widget.newSprite{file = "main/img_sign_diamond.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_FREEBUY then
				-- 免费抽奖
				rewardSprite = widget.newSprite{file = "mission/img_sign_freebuy.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_STAR then
				-- 星星
				rewardSprite = widget.newSprite{file = "main/img_main_star.png"}
				rewardSprite:setScale(1.4)
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_EXP then
				-- 经验
				rewardSprite = widget.newSprite{file = "main/img_sign_exp.png"}
				count = item._VALUE
			elseif item._TYPE == REWARD_TYPE_APOINT then
				-- 经验
				rewardSprite = widget.newSprite{file = "army/img_army_my_contribute.png"}
				count = item._VALUE
			end
			if rewardSprite then
				spriteLayer:addChild(rewardSprite, 1)
				util.alignNode(rewardSprite, spriteLayer:getContentSize(), display.CENTER)
			end
			local countLabel = ui.newTTFLabel{text = "x " .. count, size = 30, color = BUTTON_COLOR3.BROWN}
			cell:addChild(countLabel, 2)
			util.alignNode(countLabel, cell:getContentSize(), display.CENTER_LEFT, 100)

			return cell
    	end
    	local function onBtnClick(grid, index, item, x, y)
            -- item.shareButton = true
    		if item._TYPE == REWARD_TYPE_CARD or item._TYPE == REWARD_TYPE_CHIP then
    			CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item)
			elseif item._TYPE == REWARD_TYPE_GOODS then
                if item:getNo() > 20000 then
                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item)
                else
                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item)
                end
			end
    	end
    	local scrollGrid = widget.newScrollGrid{
    		contentSize = layer:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(layer:getContentSize().width, 93),
	            -- padding = { 
	            --     middleH = 4, middleV = 5,
	            -- },
	            column = 1,
	            createItemCellListener = cellAtIndex,
	            tapListener = onBtnClick,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = layer,
	    }
    	return scrollGrid
    end
    -- 设置奖励内容
    local function updateRewardInfo( data )
    	local rewardInfo = _s("REWARD_GET")
    	local rewardTable = {}
		-- 卡牌
		if #data:getCards() > 0 then
			for i, card in ipairs(data:getCards()) do
				rewardTable[#rewardTable + 1] = card
				card._TYPE = REWARD_TYPE_CARD
                card._VALUE = 1
			end
		end
		-- 碎片
		if #data:getChips() > 0 then
			for i, chip in ipairs(data:getChips()) do
				rewardTable[#rewardTable + 1] = chip
				chip._TYPE = REWARD_TYPE_CHIP
                chip._VALUE = 1
			end
		end
		-- 物品或卡牌碎片等
		if #data:getBrlist() > 0 then
            local _cache = {}
			for i,v in ipairs(data:getBrlist()) do
                if v.getNo then
                    if v:getNo() < 5000 then
                        -- 绑成卡牌
                        local cardEntity = CardEntity.new{id = v:getNo()}
                        cardEntity._TYPE = REWARD_TYPE_CARD
                        cardEntity._VALUE = v:getCount()
                        rewardTable[#rewardTable + 1] = cardEntity
                    elseif v:getNo() < 10000 then
                        -- 绑成碎片
                        local cardEntity = CardEntity.new{id = v:getNo()}
                        cardEntity._TYPE = REWARD_TYPE_CHIP
                        cardEntity._VALUE = v:getCount()
                        rewardTable[#rewardTable + 1] = cardEntity
                    else
                        -- 物品
                        v._TYPE = REWARD_TYPE_GOODS
                        v._VALUE = v:getCount()
                        rewardTable[#rewardTable + 1] = v
                    end
                elseif v.getId then
                    if v:getId() < 5000 then
                        v._TYPE = REWARD_TYPE_CARD
                        v._VALUE = 1
                        rewardTable[#rewardTable + 1] = v
                    else
                        card._TYPE = REWARD_TYPE_CHIP
                        v._VALUE = 1
                        rewardTable[#rewardTable + 1] = v
                    end
                else
                    local entity
                    if v.no < 5000 then
                        -- 绑成卡牌
                        entity = CardEntity.new{id = v.no}
                        entity._TYPE = REWARD_TYPE_CARD
                    elseif v.no < 10000 then
                        -- 碎片
                        entity = CardEntity.new{id = v.no}
                        entity._TYPE = REWARD_TYPE_CHIP
                    else
                        -- 物品
                        entity = GoodsEntity.new(v)
                        entity._TYPE = REWARD_TYPE_GOODS
                    end
                    if _cache[v.no] then
                        entity = _cache[v.no]
                        entity._VALUE = entity._VALUE + v.count
                    else
                        entity._VALUE = v.count
                        rewardTable[#rewardTable + 1] = entity
                        _cache[v.no] = entity
                    end
                end
			end
		end
		-- 体力
		if data:getSp() > 0 then
			local sp = {_VALUE = data:getSp(), _TYPE = REWARD_TYPE_SP }
			rewardTable[#rewardTable + 1] = sp
		end
		-- 金币
		if data:getGold() > 0 then
			local gold = {_VALUE = data:getGold(), _TYPE = REWARD_TYPE_GOLD }
			rewardTable[#rewardTable + 1] = gold
		end
		-- 友情点
		if data:getFp() > 0 then
			local fp = {_VALUE = data:getFp(), _TYPE = REWARD_TYPE_FP }
			rewardTable[#rewardTable + 1] = fp
		end
		-- 钻石
		if data:getDiamond() > 0 then
			local diamond = {_VALUE = data:getDiamond(), _TYPE = REWARD_TYPE_DIAMOND }
			rewardTable[#rewardTable + 1] = diamond
		end
		-- 免费抽奖
		if data:getFreebuy() > 0 then
			local freebuy = {_VALUE = data:getFreebuy(), _TYPE = REWARD_TYPE_FREEBUY }
			rewardTable[#rewardTable + 1] = freebuy
		end
		-- 经验
		if data:getExp() > 0 then
			local exp = {_VALUE = data:getExp(), _TYPE = REWARD_TYPE_EXP }
			rewardTable[#rewardTable + 1] = exp
		end
		-- 星星
		if data:getStar() > 0 then
			local star = {_VALUE = data:getStar(), _TYPE = REWARD_TYPE_STAR }
			rewardTable[#rewardTable + 1] = star
		end
		-- 军团个人贡献值
		if data:getApoint() > 0 then
			local apoint = {_VALUE = data:getApoint(), _TYPE = REWARD_TYPE_APOINT }
			rewardTable[#rewardTable + 1] = apoint
		end
		_scrollGrid:setItems(rewardTable)
    end
    local function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {931, 931}, {971, 971})
    end
	local function initViews()
        checkHelperInfo( )
		createLightAnim()
		_scrollGrid = createScrollGrid( )
		updateRewardInfo(_data)
		if _node._MISSION then
			-- CCBCenter.getNodeByTag(_node, 201):setVisible(true)
			CCBCenter.getNodeByTag(_node, 202):setVisible(true)
            _nodeTable["mTitleLabel"]:setString("")
		else
            if _node._TITLE then
                _nodeTable["mTitleLabel"]:setString(_node._TITLE)
            else
                _nodeTable["mTitleLabel"]:setString(_s("REWARD_TITLE"))
            end
			-- CCBCenter.getNodeByTag(_node, 201):setVisible(false)
			-- CCBCenter.getNodeByTag(_node, 202):setVisible(false)
		end
        
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M