--SignLayer.lua

local GoodsMaster = require("cardui.GoodsMaster")
local GoodsEntity = require("model.goods.GoodsEntity")
local CardEntity = require("model.card.CardEntity")
local CardMaster = require("cardui.CardMaster")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[SignLayerView]"
	local _node, _nodeTable = node, luaValue
    --星期node
	local _nodeWeek
    --星期grid 
	local _gridweek 
	local WEEK_TABEL = {_s("REWARD_SIGN_SUNDAY"), _s("REWARD_SIGN_MONDAY"), _s("REWARD_SIGN_TUESDAY"), _s("REWARD_SIGN_Wednesday")
		, _s("REWARD_SIGN_Thursday"), _s("REWARD_SIGN_Friday"), _s("REWARD_SIGN_Saturday")}
	local statusTable = { noSign = 0, unSign = 1, signed = 2 }
    --签到列表node
	local _nodeSign 
    --签到列表grid
	local _gridSign 
    --签到列表数据
	local _signList = {} 
	--日期
	local _day 
    --签到次数node
	local _nodeSignTimes
    --签到次数grid
	local _gridSignTimes 
    --签到次数
	local _signTimesList = {} 
    --签到次数奖励
	local _signTimesRewardList = {} 
    --签到次数奖励Node
	local _nodeSignTimesReward
    --签到次数奖励Grid 
	local _gridSignTimesReward 
    --在线时间Node
	local _nodeOnlineTime
    --在线时间列表 
	local _gridOnlineTime
    --在线时间奖励 
	local _onLineTimesList 
	--累计签到次数
	local _signCount
    --计时器
	local _cdTimer 
	--签到中次数
	local _mTotlaSignLabel
    --星期字体
    local WEEK_TABLE_TEXT_SIZE = 20

	local function reloadWeekGrid()
		_gridweek:setItems(WEEK_TABEL)
	end

	local function reloadSignGrid()
		if _signList ~= nil then
			_gridSign:setItems(_signList)
		end
	end

	local function reloadSignTimesGrid()
		createTab()
	end

	local function reloadSignTimesRewardGrid()
		_gridSignTimesReward:setItems(_signTimesRewardList)
	end

	local function reloadOnlineTime()
		_gridOnlineTime:setItems(_onLineTimesList)
	end

	local function setRewardList( index )
		local reward 
		_signTimesRewardList = {}
		if _signTimesList[index].reward.diamond ~= 0 then
			reward = {rewardType = "diamond", num = _signTimesList[index].reward.diamond}
			table.insert(_signTimesRewardList, reward) 
		end
		if _signTimesList[index].reward.gold ~= 0 then
			reward = {rewardType = "glod", num = _signTimesList[index].reward.gold, }
			table.insert(_signTimesRewardList, reward)  
		end
		if _signTimesList[index].reward.exp ~= 0 then
			reward = {rewardType = "exp", num = _signTimesList[index].reward.exp, }
			table.insert(_signTimesRewardList, reward)  
		end
		if _signTimesList[index].reward.fp ~= 0 then
			reward = {rewardType = "friendpoint", num =  _signTimesList[index].reward.fp, }
			table.insert(_signTimesRewardList, reward)  
		end
		if _signTimesList[index].reward.star ~= 0 then
			reward = {rewardType = "star", num = _signTimesList[index].reward.star, }
			table.insert(_signTimesRewardList, reward)  
		end

		if _signTimesList[index].reward.brlist ~= nil and #_signTimesList[index].reward.brlist ~= 0 then
			for i,v in ipairs(_signTimesList[index].reward.brlist) do
				local goodsView
				if v.no >10000 then
					local entity = GoodsEntity.new(v)
					entity.type = GoodsMaster.MATERIAL
                    entity.showDetail = true
                    entity.showFrame = true
					goodsView = GoodsMaster.new(entity)
				elseif v.no < 5000 then
					local entity = CardEntity.new{id = v.no}
					entity.type = CardMaster.MINISTARCARD
					entity.showDetail = true
					goodsView = CardMaster.new(entity)
					v.count = 0
				end
				reward = {rewardType = "brlist", num = v.count,sprite = goodsView}
				table.insert(_signTimesRewardList, reward)  
			end
		end
	end

	--创建星期列表
	local function createWeekGrid()
		local sprite = display.newSprite("sign/bg_sign_4.png")

		local function createItemCellListener(grid, index, item)
			 -- local cell = display.newColorLayer(ccc4(255, 200, 0, 255))

			local imgPath = "sign/bg_sign_4.png"
			if index % 2 == 0 then
				imgPath = "sign/bg_sign_3.png"
			end

	        local cell = display.newSprite(imgPath)
        	cell:ignoreAnchorPointForPosition(false)
       	    cell:setTag(3)

       	    -- 星期名
          	local weekName = ui.newTTFLabel{
                size = WEEK_TABLE_TEXT_SIZE,
                text = WEEK_TABEL[index]
			}
      		weekName:setPosition(cell:getContentSize().width / 2,cell:getContentSize().height / 2)
          	cell:addChild(weekName)

          	return cell
		end
	    --scrollview
	    local scrollGrid = widget.newGrid{
	    	contentSize = _nodeWeek:getContentSize(),
	        cellSize = CCSize( sprite:getContentSize().width + 6, _nodeWeek:getContentSize().height),
	        padding = { 
	            middleH = 5,
	        },
	        row = 1,
	        createItemCellListener = createItemCellListener,
	        selectedParams = nil,
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	    }
	    _nodeWeek:addChild(scrollGrid)

	    return scrollGrid

	end

	--创建签到列表
	function createSignGrid(  )
		local sprite = display.newSprite("sign/bg_sign_4.png")

		local function createItemCellListener(grid, index, item)
			 local cell
			if tonumber( item ) == 2 then
	       		cell = display.newSprite("sign/bg_sign_5.png")
	       	else
	       		cell = display.newSprite("sign/bg_sign_4.png")
	       	end
        	cell:ignoreAnchorPointForPosition(false)
       	    cell:setTag(3)
       	    -- 日期
       	    if tonumber( item ) ~= 0 then
	          	local lblCalender = ui.newTTFLabel{				  
                    size = TALK_TABLE_TEXT_SIZE,
                    text = _day
    			}
	          	lblCalender:setPosition(cell:getContentSize().width / 2, cell:getContentSize().height / 2)
	          	cell:addChild(lblCalender)
	          	_day = _day + 1
	        end

	        --签到标记
	        if tonumber( item ) == 2 then
	        	local signImg = display.newSprite("sign/bg_sign_2.png")
	        	signImg:setPosition(cell:getContentSize().width / 2,cell:getContentSize().height / 2)
	          	cell:addChild(signImg)
	        end

          	return cell
		end
	  	----scrollview
	    local scrollGrid = widget.newGrid{
        	contentSize = _nodeSign:getContentSize(),
            cellSize = CCSize( sprite:getContentSize().width + 6 , _nodeSign:getContentSize().height / 6),
            padding = { 
                middleH = 5, 
            },
            column = 7,
            row = 6,
            createItemCellListener = createItemCellListener,
            selectedParams = nil,
            direction = widget.TABLEVIEW_DIRECTION_BOTH,
	    }
	    _nodeSign:addChild(scrollGrid)

	    return scrollGrid
	end

	--创建签到次数列表
	local function createTab( signTimes , signCount )
		local function onTabClick( index, button )
			if _signCount and _signTimesList[index].signcount <= _signCount  then 
    			local signImg = display.newSprite("sign/bg_sign_2.png")
	        	util.alignNodeWithPadding(signImg, button:getContentSize(), display.CENTER)
	          	button:addChild(signImg,100)
		    end
			setRewardList(index)
			reloadSignTimesRewardGrid()
        end

        local buttons = { }  

        for i,v in ipairs(_signTimesList) do
        	local nomalImg,selectImg
        	if _signCount and v.signcount <= _signCount  then 
        		nomalImg = "sign/btn_signs_nomal_1.png"
        		selectImg = "sign/btn_signs_selected_1.png"
        	else
        		nomalImg = "sign/btn_signs_nomal.png"
        		selectImg = "sign/btn_signs_selected.png"
        	end

        	local str = string.format(_s("REWARD_SIGN_TIMES"),v.signcount)
        	local bgTimes = widget.newButton{
                normalImage = nomalImg,
   	    	    selectImage = selectImg,
   	    	    labelParams = { 
			 	    text = str,
			 	    size = WEEK_TABLE_TEXT_SIZE,
			 	}
   	    	}
		    table.insert(buttons, bgTimes)   
		    if _signCount and v.signcount <= _signCount  then 
    			local signImg = display.newSprite("sign/bg_sign_2.png")
	        	util.alignNodeWithPadding(signImg, bgTimes:getContentSize(), display.CENTER)
	          	bgTimes:addChild(signImg,100)
		    end
        end

        local tab = widget.newTab{
            items = buttons,
            padding = #buttons,
            listener = onTabClick,
            direction = DIRECTION_HORIZONTAL,
        }
        _nodeSignTimes:addChild(tab)
        util.alignNodeWithPadding(tab, _nodeSignTimes:getContentSize(), display.CENTER)

        setRewardList(1)
        tab.selectButton(1)
		for i,v in ipairs(_signTimesList) do
			if v.signcount > _signCount then
				setRewardList(i)
				tab.selectButton(i)
				break
			end
		end
	end
	
	--创建签到次数奖励列表
	function createSignTimesReward()

		local sprite = display.newSprite("common/bg/bg_item.png")

		local function createItemCellListener(grid, index, item)

	        local cell = display.newSprite("common/bg/bg_item.png")
        	cell:ignoreAnchorPointForPosition(false)
       	    cell:setTag(3)

       	    if item.rewardType ~= "brlist" then
       	    	local rewardImgPath = string.format("main/img_sign_%s.png",item.rewardType)
       	    	
	       	    local rewardImg = display.newSprite(rewardImgPath)
	       	    rewardImg:setPosition(cell:getContentSize().width / 2,cell:getContentSize().height / 2)
	          	cell:addChild(rewardImg)   

	        else
	        	local reward = item.sprite
	        	if item.num == 0 then
	        		reward:setScale(0.75)
	        	end
	        	cell:addChild(reward)
	        	util.alignNode(reward, cell:getContentSize(), display.CENTER)
       	    end

       	    if item.num > 1 then
       	    	-- 奖励数量
	          	local rewardNum = ui.newTTFLabel{			  
	                size = WEEK_TABLE_TEXT_SIZE,
	                text = "x" .. item.num
				}
	          	rewardNum:setAnchorPoint(ccp(1, 0))
	      		util.alignNodeWithPadding(rewardNum, cell:getContentSize(),display.BOTTOM_RIGHT, 
	      			{ right = 10, bottom = 5 })
	          	cell:addChild(rewardNum)
       	    end   

          	return cell
		end

	    --scrollview
	    local scrollGrid = widget.newScrollGrid{
	    	x = 0,
	        y = 0,
	        contentSize = _nodeSignTimesReward:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_nodeSignTimesReward:getContentSize().width / 4 , _nodeSignTimesReward:getContentSize().height),
	            row = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = _nodeSignTimesReward,
	    }

	    return scrollGrid
	end

	--创建在线奖励列表
	function createOnlineTime()
		local sprite = display.newSprite("sign/bg_sign_onLineTime.png")		

		local function createItemCellListener(grid, index, item)

			local function tapListener( getBtn )
				getBtn.setStateDisabled(true)
				CCBCenter.sendLuaMessage(MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETREWARDLIST, nil, {signintype = 2, rewardno = item.rewardno})
			end
	        local cell = display.newSprite("sign/bg_sign_onLineTime.png")
        	cell:ignoreAnchorPointForPosition(false)
       	    cell:setTag(3)

       	    local imgBg = display.newSprite("common/bg/bg_item.png")
       	    imgBg:setPosition(50, cell:getContentSize().height / 2)
          	cell:addChild(imgBg)   
  	  	    local status
          	if item.status == statusTable.noSign then
	      		status = _s("REWARD_SIGN_NOGET")
	      	elseif item.status == statusTable.unSign then
	      		status = _s("REWARD_SIGN_GET")
	      	elseif item.status == statusTable.signed then
	      		status = _s("REWARD_SIGN_GETED")
			end

          	-- 背景,使用按钮替代cell的点击，事件点击的时候改变背景
       	    local getBtn = widget.newButton{
                normalImage = "sign/btn_sign_onLineReward_normal.png",
			    selectImage = "sign/btn_sign_onLineReward_selected.png",
			    disableImage = "sign/btn_sign_onLineReward_selected.png",
			    ignoreAnchor = true,
			    listener = tapListener,
			    labelParams = { 
    			 	text = status,
    			 	size = WEEK_TABLE_TEXT_SIZE,
    			 	color = ccc3(96, 56, 19)
	   	    	}
       	    }
       	    util.alignNodeWithPadding(getBtn, cell:getContentSize(), display.BOTTOM_RIGHT, { right = 5 } )
       	    cell:addChild(getBtn)

       	    local textNode = widget.newLayer()
       	    textNode:setContentSize(CCSize(cell:getContentSize().width - imgBg:getContentSize().width - getBtn:getContentSize().width - 10
       	    	, imgBg:getContentSize().height))
       	    textNode:setPosition(imgBg:getPositionX() + imgBg:getContentSize().width / 2, 
       	    	cell:getContentSize().height / 2 - imgBg:getContentSize().height / 2)
			cell:addChild(textNode, 100)

       	     -- 奖励标题
          	local rewardTitle = ui.newTTFLabel{			  
                size = WEEK_TABLE_TEXT_SIZE,
                text = item.title,
                color = ccc3(96, 56, 19)
    		}
          	util.alignNode(rewardTitle, textNode:getContentSize(),display.TOP_LEFT, 5)
          	textNode:addChild(rewardTitle)

          	local onLineTimeRewards = item.reward

          	local rewardImg
			if onLineTimeRewards.diamond ~= 0 then
				rewardImg = "main/img_sign_diamond.png"
			end
			if onLineTimeRewards.gold ~= 0 then
				rewardImg =  "reward/icon/icon_gold.png"
			end
			if onLineTimeRewards.exp ~= 0 then
				rewardImg = "main/img_sign_exp.png"
			end
			if onLineTimeRewards.fp ~= 0 then
				rewardImg = "main/img_sign_friendpoint.png"
			end
			if onLineTimeRewards.star ~= 0 then
				rewardImg = "reward/icon/icon_star.png"
			end

			if rewardImg ~= nil then
				local rewardImg = display.newSprite(rewardImg)
				rewardTitle:setAnchorPoint(ccp(0.5, 0))
	       	    rewardImg:setPosition(imgBg:getPositionX(),cell:getContentSize().height / 2)
	          	cell:addChild(rewardImg)   
			end

			if onLineTimeRewards.brlist ~= nil and #onLineTimeRewards.brlist ~= 0 then
				for i,v in ipairs(onLineTimeRewards.brlist) do
					local goodsView
					if v.no >10000 then
						--物品
						local entity = GoodsEntity.new(v)
						entity.type = GoodsMaster.MATERIAL
                        entity.showDetail = true
                        entity.showFrame = true
						rewardView = GoodsMaster.new(entity)
					elseif v.no < 5000 then
						--卡牌
						local entity = CardEntity.new{id = v.no}
						entity.type = CardMaster.MINISTARCARD
                        entity.showDetail = true
						rewardView = CardMaster.new(entity)
						rewardView:setScale(0.75)
					end
					rewardView:setPosition(2,2)
					imgBg:addChild(rewardView)
				end
			end
			-- 时间
			local status 
			if item.status == statusTable.noSign and item.seconds ~= 0 then
				_cdTimer = CountDownView.new{ 
                    format = _s("REWARD_SIGN_TIME"),
                    labelParams = {size = 22, color = ccc3(255, 0, 0)},
                    listener = function()
                    	_cdTimer:stop()
                    	_cdTimer:setVisible(false)
                      	CCBCenter.sendLuaMessage(MSG_ID.MSG_SIGNLAYER_ACTION_ONFETCHGETSIGNLIST)
                    end
                }
	      		  
	        	util.alignNodeWithPadding(_cdTimer, textNode:getContentSize(),display.BOTTOM_LEFT, { left = 5 })
          		textNode:addChild(_cdTimer)      
	      		_cdTimer:start(item.seconds)
	      		getBtn.setStateDisabled(true)
			end
	        
	        if item.status ~= statusTable.unSign then
	          	getBtn.setStateDisabled(true)
	        end
          	return cell
		end

	     --scrollview
	    local scrollGrid = widget.newScrollGrid{
	    	x = 0,
	        y = 0,
	        contentSize = _nodeOnlineTime:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_nodeOnlineTime:getContentSize().width, sprite:getContentSize().height),
	            padding = { 
	                middleV = 5,
	            },
	            column = 1,
	            createItemCellListener = createItemCellListener,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _nodeOnlineTime,
	    }

	    return scrollGrid
	end

	--设置签到数据
	local function setSignlist( signlist , signCount )
		for i=1,42 do
			if i <= #signlist then
				_signList[i] = string.sub(signlist, i, i)
			else
				_signList[i] = "0"
			end
		end
		_day = 1
		reloadSignGrid()

		--设置签到总次数
		_signCount = signCount

		_mTotlaSignLabel:setString(string.format(_s("REWARD_SIGN_TOTALSIGNED"),_signCount))
	end

	--设置签到次数数据
	local function setSignTimes ( signTimes , signCount )

		_signTimesList = signTimes
		createTab( _signTimesList , signCount )	
		reloadSignTimesRewardGrid()
	end

	--设置在线时间奖励数据
	local function setOnlineTimesList( timereward )
		_onLineTimesList = timereward
		reloadOnlineTime()
	end

--[[ ## local fuction --]]
	local function initViews()
		
		-- 星期列表node
		_nodeWeek = CCBCenter.getNodeByTag(_node, 506)

		-- 签到列表node
		_nodeSign = CCBCenter.getNodeByTag(_node, 505)

		-- 签到次数node
		_nodeSignTimes = CCBCenter.getNodeByTag(_node, 503)

		--签到次数奖励node
		_nodeSignTimesReward = CCBCenter.getNodeByTag(_node, 504)

		--在线时间node
		_nodeOnlineTime = CCBCenter.getNodeByTag(_node, 202)

		--累计签到次数
		_mTotlaSignLabel = CCBCenter.getNodeByTag(_node, 507)

		--创建星期列表
		_gridweek = createWeekGrid()

		--创建签到列表
		_gridSign = createSignGrid()

		--创建签到次数奖励列表
		_gridSignTimesReward = createSignTimesReward()

		--创建在线时间列表
		_gridOnlineTime = createOnlineTime()

		reloadWeekGrid()

		luaValue.btnSign:setEnabled(false)

	end

	local function setSignEnabled( signed )
		if signed == 1 then
			luaValue.btnSign:setEnabled(false)
		else 
			luaValue.btnSign:setEnabled(true)
		end
	end

--[[ ## public fuction --]]

	-- 数据加载
    _node.reloadSignGrid = reloadSignGrid
    _node.setSignlist = setSignlist
    _node.setSignTimes = setSignTimes
    _node.setOnlineTimesList = setOnlineTimesList
    _node.setSignEnabled = setSignEnabled

--[[ ## MAINs --]]
	initViews()
end

return M