--MapContainerLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MapContainerLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = node._DATA
   
--[[ ## local fuction --]]
	local function initViews()
	    -- [包含文件]
	    local MapView 			= require("cardui.MapView")
	    local EffectButton = require("cardui.EffectButton")


	    

	    




	    -- [常量]
	    local Z_STATUSBAR 				= 10000
	    local TAG_STATUSBAR 			= 63371
	    local REWARD_TYPE_CARD  	= 0
		local REWARD_TYPE_CHIP  	= 1
		local REWARD_TYPE_GOODS 	= 2
		local REWARD_TYPE_SP		= 3
		local REWARD_TYPE_GOLD  	= 4
		local REWARD_TYPE_FP    	= 5
		local REWARD_TYPE_DIAMOND  	= 6
		local REWARD_TYPE_FREEBUY  	= 7
		local REWARD_TYPE_STAR  	= 8
		local REWARD_TYPE_EXP   	= 9


	    

	    




	    -- [操作变量]
	    -- 关卡DAO
		local LevelDao              	= require("db.leveldb")
	    -- 实体[地图]
	    local EntityMap					= require(PH_EN_MAP .. "EntityMap")
	    -- 实体[关卡]
	    local EntityLevel				= require(PH_EN_MAP .. "EntityLevel")
	    -- 实体[好友集]
	    local EntityFriends				= require("ccb.m.friend.EntityFriends")
	    -- 实体[好友]
	    local EntityFriend 				= require("ccb.m.friend.EntityFriend")
	    local GoodsMaster 				= require("cardui.GoodsMaster")
	    local CardMaster 				= require("cardui.CardMaster")
	    local GoodsEntity 				= require("model.goods.GoodsEntity")
	    local CardEntity 				= require("model.card.CardEntity")
	    -- 地图对象
	    local _map 	 					= nil
	    -- 游戏信息
	    local _bar 						= nil
	    -- 收集星星层
	    local _collectLayer	 			= nil
	    -- 翻倍经验倒计时
	    local _expStatusLayer	 		= nil
	    -- 神秘商店倒计时
	    local _mysteryShopStatusLayer 	= nil
	    -- 地图信息对象
	    local _mapInfo 	 				= nil
	     -- 地图偏移
		local _mapOffset 				= nil
	    -- 锁
	    local _lock 					= false
	    -- 关卡索引[1级]
	    local _level1 					= 1
	    -- 关卡索引[2级]
	    local _level2 					= 1
	    -- 地图关卡PO集（索引方式：_pos[地图索引][关卡索引])
	    local _pos 						= nil
	    --特殊本入口Layer
	    local _specialMapLayer			= nil
	        --特殊本入口Layer
	    local _towerLayer			= nil



	    

	    



	    -- [私有方法声明]
	    -- [网络]
    	-- 发起网络请求
    	local netSend
    	-- 接收网络请求
    	local netReceive
    	-- 请求失败回调函数
    	local netReceiveFail    
    	-- 接收网络请求[加载好友]
    	local netReceiveFriends

	    -- [视图渲染]
	    -- 视图渲染
	    local viewRender
	    -- 视图渲染[基础数据]
	    local viewRenderBase
	    -- 视图渲染[基础数据]
	    local viewRenderCallback
	    -- 加载状态变量
	    local loadStatus
		-- 加载地图
		local loadMap
	    -- 加载状态栏
	    local loadStatusBar
	    -- 加载收集按钮
	    local loadCollectButton
	    -- 加载经验状态
	    local loadExpStatus
	    -- 加载神秘商店状态
	    local loadMysteryShopStatus
		-- 加载渲染以外的其他操作
		local loadRenderOtherwise
		-- 渲染地图信息
	    local renderMapInfo
		-- 定位当前地图位置
		local locateLevel
		-- 判断是否执行新手帮助
		local checkHelperInfo
		--特殊副本入口
		local loadSpecialMapBtn

	    -- [资源]
	    -- 加载资源
	    local loadResources
	    -- 卸载资源
	    local unloadResources

	    -- [数据]
	    local loadData
	    local loadDataFriends

	    -- [事件处理]
	    local onTouchSubLevel

	    -- [Loading]
	    -- 显示Loading
	    local showLoading
	    -- 隐藏Loading
	    local hideLoading

	    -- [Lock]
	    -- 判断是否锁定（不让点击）
	    local isLocked
	    -- 锁定
	    local lockIt
	    -- 解除锁定
	    local unlockIt

	    -- [回调处理]
	    -- 回调函数（处理从其他界面返回到当前界面）
	    local callbackReturnToView

	    -- [音效]
		-- 播放关卡音效
		local playLevelSound

	    -- [Util]
	    -- 获得结点
	    local NODE


	        

	        





	    -- [私有方法定义]
	    -- [实例方法][网络]
    	-- 发起网络请求
    	function netSend()
    		if _data and istable(_data.levels) and table.nums(_data.levels) > 0 then 
    			if not HelperView2.isNextIndex(700) then 
	    			-- 设置数据对象
	    			_dataLevels = _data.levels
	    			_data.levels = nil
				    _dataStars  = 0
				    _dataCollecttime = 0
				    -- 视图渲染[基础数据]
			    	viewRenderCallback()
			    end
	    		_data.levels = nil
    		end
	    	-- 视图渲染[基础数据]
	    	-- viewRenderBase()


		    -- [正式请求]
		    -- 请求参数
		    local params = {
                failedCb    = netReceiveFail,          -- 请求失败回调函数π
			}

		    -- 显示Loading
		    -- showLoading()
		    -- 请求动作
		    NetHelper.createRequest(
		       ACTID.MSG_GET_LEVELLIST,                	-- 请求ID
		       netReceive,                              -- 回调函数
		       params 									-- 请求参数
		    )
		    
    	end
    	-- 接收网络请求
    	function netReceive(properties, markFields)
		 --    -- 设置数据对象, debug用
		 --    if not COWCOW then 
		 --    	COWCOW = true
			--     for i = 1, 10 do
			--     	for j = 1, 10 do 
			--     		local sn, subsn = i, j
			--     		if true or not (sn == 10 and subsn == 10) then 
			--     			table.insert(properties.levels, {sn = sn, star = 1, subsn = subsn})
			--     		end
			--     	end
			--     end
		 --    	for i,v in ipairs(properties.levels) do
		 --    		if v.sn == 10 and v.subsn == 10 then 
		 --    			properties.levels[i] = nil
		 --    			break
		 --    		end
		 --    	end
			-- end
	
		    _dataMap 	= EntityMap.new(properties)
		    _dataLevels = _dataMap:getLevels()
		    _dataStars  = _dataMap:getStars()
		    _dataCollecttime = _dataMap:getCollecttime()
		    _dataExpRate = _dataMap:getExpRate()
		    _dataExpTime = _dataMap:getExpTime()
		    _dataShopTyp = _dataMap:getShopTyp()
		    _dataShopTime = _dataMap:getShopTime()
		    -- 视图渲染[基础数据]
		    viewRenderCallback()
    	end
    	-- 接收网络请求失败
    	function netReceiveFail()
    		-- 重新发起网络请求
    		netSend()
    	end

    	-- 接收网络请求[好友]
	    function netReceiveFriends(properties, markFields)
	    	-- 实体
	    	local whole = EntityFriends.new(properties)
	    	-- 操作变量
	    	local countFriends 	= whole:getFcount() 				-- 好友数
	    	local friends 		= whole:getFriends() 				-- 好友实体

	    	_dataFriends = friends or {}

		    -- 隐藏Loading
		    hideLoading()
		end

		-- 接收网络请求[星星]
	    function netReceiveStar(properties, markFields)
	    	netSend()
		end

		local function checkStarHelperInfo( )
			if ME:getTriggerMsgEntity():isShowStarHelper() and not HelperView2.isNextIndexIn(40030, 40050) then
	            HelperView2.setCurIndex(40020)
            elseif ME:getTriggerMsgEntity():isJumpToTower1Helper() then
            	HelperView2.setCurIndex(200020)
            elseif ME:getTriggerMsgEntity():isJumpToTower2Helper() then
            	HelperView2.setCurIndex(210020)
	        end
			HelperView2.showBetween(_node, nil, {40020, 40050}, {200020, 200020}, {210020, 210020})
		end
	    -- [实例方法][视图渲染]
	    -- 视图渲染[基础数据]
	    function viewRenderBase()
	    	-- 加载地图
	    	loadMap()
		    -- 加载状态栏
			loadStatusBar()
			-- 判断是否执行新手帮助
			-- checkHelperInfo()
			checkStarHelperInfo( )
		end

		-- 加载地图
		function loadMap()
	    	_map = MapView.new(CCBCenter.getNodeByTag(_node, 1), _level1, onTouchSubLevel)
		end
	    
	    -- 加载状态栏
	    function loadStatusBar()
	    	CCBCenter.loadCCB("MSG_STATUSBARLAYER_MODEL", "ccb.c.common.StatusBarLayer", {}, function(layer)
	    		_bar = layer
	    		_node:addChild(_bar, Z_STATUSBAR, TAG_STATUSBAR)
	    		local function refleshData( )
	    			_bar.refleshData()
	    		end
	    		_node.refleshData = refleshData
	    	end)
	    end
	    
	    -- 视图渲染[基础数据]
	    function viewRenderCallback()
	    	-- 加载数据
	    	loadData()
	    	-- 加载状态变量
	    	loadStatus()
	    	--特殊副本入口
	    	loadSpecialMapBtn()
	    	-- 加载神秘商店状态
	    	loadMysteryShopStatus()
	    	-- 加载收集按钮
	    	loadCollectButton()
	    	--幽灵魔塔入口
	    	loadTowerButton()
	    	-- 加载经验系数层
	    	loadExpStatus()
			-- 加载渲染以外的其他操作
			loadRenderOtherwise()
		end

		function loadSpecialMapBtn( ... )
			if _specialMapLayer then
	    		_specialMapLayer:removeAllChildrenWithCleanup(true)
	    	else
	    		_specialMapLayer = widget.newMaskLayer(-1000, nil, ccc4(0, 0, 0, 0))
	    		CCBCenter.getNodeByTag(_node, 1):addChild(_specialMapLayer)
	    		_specialMapLayer:setContentSize(CCSize(79, 79))
				util.alignNodeWithPadding(_specialMapLayer, CCBCenter.getNodeByTag(_node, 1):getContentSize(), display.BOTTOM_CENTER, {left = -400, bottom = 220})
	    	end
	    	-- 特殊副本按钮
	    	local btnSpecialMap = widget.newButton{
				-- normalImage = "map/btn_special_map.png",
				normalImage = "main/effect_buttons/bg_main_button.png",
				selectImage = "main/effect_buttons/bg_main_button.png",
				disableImage = "main/effect_buttons/bg_main_button.png",
				priority = -1001,
				scale = 1.1,
				listener = function ( btn )
					HelperView2.showNext()
					if ME:getLv() >= require("static.unlock_level").TOWER then
						CCBCenter.loadCCB("MSG_SPECIALMAPLAYER_MODEL", "ccb.c.specialMap.SpecialMapLayer", {specialMapType = 1, mapTyp = 0, isCheckpoint = 0, fromMap = true})
					else
						NetHelper.QuickToast(_s("COMMON_UNOPEN", require("static.unlock_level").TOWER, _s("MAP_SPECIAL_MAP")))
					end
				end,
			}
			_specialMapLayer:addChild(btnSpecialMap)
			util.alignNodeWithPadding(btnSpecialMap, _specialMapLayer:getContentSize(), display.CENTER)

			-- 特殊副本提示文字容器
			local textLabel = widget.newLayer{}
            textLabel:setContentSize(CCSize(100, 30))
			_specialMapLayer:addChild(textLabel)
			util.alignNodeWithPadding(textLabel, _specialMapLayer:getContentSize(), display.BOTTOM_CENTER, {bottom = -30})

			-- 文字背景
			local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = textLabel:getContentSize(),}
			textLabel:addChild(bgSprite, 0)
			util.alignNodeWithPadding(bgSprite, textLabel:getContentSize(), display.CENTER)

			-- 特殊副本文字
			local receiveLabel = ui.newTTFLabel{text = _s("MAP_SPECIAL_MAP"), size = 20,}
			textLabel:addChild(receiveLabel)
            util.alignNodeWithPadding(receiveLabel, textLabel:getContentSize(), display.CENTER)

            -- 塔
         	local towerImg = display.newSprite("map/btn_special_map.png")
            btnSpecialMap:addChild(towerImg,1000)
            util.alignNode(towerImg, btnSpecialMap)

            _specialMapLayer:setVisible(ME:getTriggerMsgEntity():isUnlockTower1() and TRUE == ME:getScopy())
				
		end


		function loadTowerButton( ... )
			if _towerLayer then
	    		_towerLayer:removeAllChildrenWithCleanup(true)
	    	else
	    		_towerLayer = widget.newMaskLayer(-1000, nil, ccc4(0, 0, 0, 0))
	    		CCBCenter.getNodeByTag(_node, 1):addChild(_towerLayer)
	    		_towerLayer:setContentSize(CCSize(79, 79))
				util.alignNodeWithPadding(_towerLayer, CCBCenter.getNodeByTag(_node, 1):getContentSize(), display.BOTTOM_CENTER, {left = -400, bottom = 340})
	    	end
	    	-- _towerLayer:setVisible(true)
	    	-- 幽灵魔塔按钮
	    	local btnTower = widget.newButton{
						-- normalImage = "map/btn_special_map.png",
						normalImage = "main/effect_buttons/bg_main_button.png",
						selectImage = "main/effect_buttons/bg_main_button.png",
						disableImage = "main/effect_buttons/bg_main_button.png",
						priority = -1001,
						scale = 1.1,
						listener = function ( btn )
							CCBCenter.loadCCB("MSG_TOWERLAYER_MODEL", "ccb.c.tower.TowerLayer",{fromMap = true})
						end,
					}
			_towerLayer:addChild(btnTower)
			util.alignNodeWithPadding(btnTower, _towerLayer:getContentSize(), display.CENTER)

			-- 特殊副本提示文字容器
			local textLabel = widget.newLayer{}
            textLabel:setContentSize(CCSize(100, 30))
			_towerLayer:addChild(textLabel)
			util.alignNodeWithPadding(textLabel, _towerLayer:getContentSize(), display.BOTTOM_CENTER, {bottom = -30})

			-- 文字背景
			local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = textLabel:getContentSize(),}
			textLabel:addChild(bgSprite, 0)
			util.alignNodeWithPadding(bgSprite, textLabel:getContentSize(), display.CENTER)

			-- 特殊副本文字
			local receiveLabel = ui.newTTFLabel{text = _s("MAP_TOWER"), size = 20,}
			textLabel:addChild(receiveLabel)
            util.alignNodeWithPadding(receiveLabel, textLabel:getContentSize(), display.CENTER)

            -- 塔
         	local towerImg = display.newSprite("main/effect_buttons/btn_main_tower.png")
            btnTower:addChild(towerImg,1000)
            util.alignNode(towerImg, btnTower)

            _towerLayer:setVisible(ME:getTriggerMsgEntity():isUnlockTower2() and TRUE == ME:getLadder())
		end

		function loadExpStatus()
			-- if _dataExpRate ~= 1 and _dataExpTime > 0 then
				if _expStatusLayer then
					_expStatusLayer:removeAllChildrenWithCleanup(true)
				else
					_expStatusLayer = widget.newMaskLayer(-1000, nil, ccc4(0, 0, 0, 0))
		    		CCBCenter.getNodeByTag(_node, 1):addChild(_expStatusLayer)
		    		_expStatusLayer:setContentSize(CCSize(79, 79))
					util.alignNodeWithPadding(_expStatusLayer, CCBCenter.getNodeByTag(_node, 1):getContentSize(), display.BOTTOM_CENTER, {left = -260, bottom = 100})
				end
				-- 经验倍率
				local expRateLabel = widget.newTTFLabelWithShadow{
					text = string.format(_s("MAP_EXP_RATE"), _dataExpRate),
					color = COLOR3.YELLOW,
				}
				_expStatusLayer:addChild(expRateLabel)
				util.alignNodeWithPadding(expRateLabel, _expStatusLayer:getContentSize(), display.BOTTOM_CENTER)
				-- 收集提示文字容器
				local textLabel = widget.newLayer{}
	            textLabel:setContentSize(CCSize(100, 30))
				_expStatusLayer:addChild(textLabel)
				util.alignNodeWithPadding(textLabel, _expStatusLayer:getContentSize(), display.BOTTOM_CENTER, {bottom = -30})
				-- 倒计时背景
				local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = textLabel:getContentSize(),}
				textLabel:addChild(bgSprite, 0)
				util.alignNodeWithPadding(bgSprite, textLabel:getContentSize(), display.CENTER)
				if _dataExpTime > 0 then
					-- 倒计时
					local cdTime = CountDownView.new{ 
	                    format = "[h]:[mm]:[ss]",-- _s("MAP_COLLECT_TIME"),
	                    labelParams = {size = 20,},
	                    listener = function(self)
	                    	self:stop()
	                    	netSend()
	                    end
	                }
	                cdTime:start(_dataExpTime)
	                textLabel:addChild(cdTime)
	                util.alignNodeWithPadding(cdTime, textLabel:getContentSize(), display.CENTER)
				end
				_expStatusLayer:setVisible(_dataExpRate ~= 1 and _dataExpTime > 0)
			-- end
		end
		function loadMysteryShopStatus( )
			-- if _dataShopTyp ~= 0 and _dataShopTime > 0 then
				if _mysteryShopStatusLayer then
		    		_mysteryShopStatusLayer:removeAllChildrenWithCleanup(true)
		    	else
		    		-- _mysteryShopStatusLayer = widget.newLayer{}
		    		_mysteryShopStatusLayer = widget.newMaskLayer(-1000, nil, ccc4(0, 0, 0, 0))
		    		CCBCenter.getNodeByTag(_node, 1):addChild(_mysteryShopStatusLayer)
		    		_mysteryShopStatusLayer:setContentSize(CCSize(79, 79))
					util.alignNode(_mysteryShopStatusLayer, CCBCenter.getNodeByTag(_node, 1):getContentSize(), display.BOTTOM_CENTER, {left = -400, bottom = 460})
		    	end
		    	if _mapOffset then
		    		_map:setContentOffset(_mapOffset)
		    		_mapOffset = nil
		    	end

		    	-- 收集按钮
		    	local btnMysteryShop = widget.newButton{
					normalImage = _dataShopTyp == 4 and "shop/myster/btn_bear.png" or "shop/myster/btn_car.png",
					priority = -1001,
					scale = 1.1,
					listener = function ( btn )
						SOUND:playEffectButton1()
						CCBCenter.loadCCB("MSG_SHOPMYSTERYLAYER_MODEL", "ccb.c.shop.ShopMysteryLayer", {typ = _dataShopTyp, onClose = function ( )
							-- _bar.refleshData()
						end})
					end,
				}
				_mysteryShopStatusLayer:addChild(btnMysteryShop)
				util.alignNode(btnMysteryShop, _mysteryShopStatusLayer)
				-- 收集提示文字容器
				local textLabel = widget.newLayer{}
	            textLabel:setContentSize(CCSize(100, 30))
				_mysteryShopStatusLayer:addChild(textLabel)
				util.alignNodeWithPadding(textLabel, _mysteryShopStatusLayer:getContentSize(), display.BOTTOM_CENTER, {bottom = -30})
				-- 文字背景
				local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = textLabel:getContentSize(),}
				textLabel:addChild(bgSprite, 0)
				util.alignNode(bgSprite, textLabel)
				_mysteryShopStatusLayer:setVisible(_dataShopTyp ~= 0 and _dataShopTime > 0)
				if _dataShopTime > 0 then
					-- 倒计时
					local cdTime = CountDownView.new{ 
                        format = "[h]:[mm]:[ss]",-- _s("MAP_COLLECT_TIME"),
                        labelParams = {size = 20,},
                        listener = function(self)
                        	self:stop()
                        	netSend()
                        end
                    }
	                cdTime:start(_dataShopTime)
	                textLabel:addChild(cdTime)
	                util.alignNode(cdTime, textLabel)
				end
			-- elseif _mysteryShopStatusLayer then
			-- 	_mysteryShopStatusLayer:removeAllChildrenWithCleanup(true)
			-- end
		end
		-- 加载收集按钮
	    function loadCollectButton()
	    	if _collectLayer then
	    		_collectLayer:removeAllChildrenWithCleanup(true)
	    	else
	    		-- _collectLayer = widget.newLayer{}
	    		_collectLayer = widget.newMaskLayer(-1000, nil, ccc4(0, 0, 0, 0))
	    		CCBCenter.getNodeByTag(_node, 1):addChild(_collectLayer)
	    		_collectLayer:setContentSize(CCSize(79, 79))
				util.alignNodeWithPadding(_collectLayer, CCBCenter.getNodeByTag(_node, 1):getContentSize(), display.BOTTOM_CENTER, {left = -400, bottom = 100})
	    	end
	    	if _mapOffset then
	    		_map:setContentOffset(_mapOffset)
	    		_mapOffset = nil
	    	end

	    	-- 收集按钮
	    	local btnCollect = widget.newButton{
				normalImage = "map/btn_star_select.png",
				selectImage = "map/btn_star_select.png",
				disableImage = "map/btn_star_normal.png",
				priority = -1001,
				scale = 1.1,
				listener = function ( btn )
						SOUND:playEffectButton1()
						if not _mapOffset then
							HelperView2.showNext()
							btn.setStateDisabled(true)
							util.enableCustomTouch(btn, false)
							_map.collectMapStar(
								ccp(_collectLayer:getPositionX(), _collectLayer:getPositionY()), 
								function ( )
									_mapOffset = _map:getContentOffset()
									loadDataStar()
								end
							)
						end
				end,
			}
			_collectLayer:addChild(btnCollect)
			util.alignNodeWithPadding(btnCollect, _collectLayer:getContentSize(), display.CENTER)
			btnCollect.setStateDisabled(true)
			-- 收集提示文字容器
			local textLabel = widget.newLayer{}
            textLabel:setContentSize(CCSize(100, 30))
			_collectLayer:addChild(textLabel)
			util.alignNodeWithPadding(textLabel, _collectLayer:getContentSize(), display.BOTTOM_CENTER, {bottom = -30})
			-- 文字背景
			local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = textLabel:getContentSize(),}
			textLabel:addChild(bgSprite, 0)
			util.alignNodeWithPadding(bgSprite, textLabel:getContentSize(), display.CENTER)
			if not ME:getTriggerMsgEntity():isUnlockStar() then
				_collectLayer:setVisible(false)
			elseif _dataCollecttime <= 0 and _dataStars > 0 then
				-- 按钮变亮
				btnCollect.setStateDisabled(false)
				-- 领取文字
				local receiveLabel = ui.newTTFLabel{text = _s("MAP_COLLECT"), size = 20,}
				textLabel:addChild(receiveLabel)
                util.alignNodeWithPadding(receiveLabel, textLabel:getContentSize(), display.CENTER)
			elseif _dataCollecttime > 0 then
				-- 倒计时
				local cdTime = CountDownView.new{ 
                            format = "[h]:[mm]:[ss]",-- _s("MAP_COLLECT_TIME"),
                            labelParams = {size = 20,},
                            listener = function(self)
                            	self:stop()
                            	netSend()
                            end
                        }
                cdTime:start(_dataCollecttime)
                textLabel:addChild(cdTime)
                util.alignNodeWithPadding(cdTime, textLabel:getContentSize(), display.CENTER)
			end
			_bar.refleshData()
	    end

		-- 加载状态变量
		function loadStatus()
			_level1, _level2 = LevelDao.getCurrentLevelIndexes(_dataLevels)
		end

		local function checkHelperInfoForReceive(  )
			local function callback( index )
				if index == 550 or index == 656 or index == 772 or index == 1000 then 
					_map.clickFirstArea()
				end
			end
			HelperView2.showBetween(_node, callback, {550, 550}, {656, 656}, {772, 772}, {1000, 1000})
		end

		-- 加载渲染以外的其他操作	
	    function loadRenderOtherwise()
	    	-- 锁定结点点击
	    	util.enableCustomTouch(_bar, false)

			-- 渲染地图信息
			renderMapInfo()
			-- 定位当前地图位置
			locateLevel()
			-- 判断是否执行新手帮助
			checkHelperInfoForReceive()
			-- 解除锁定结点点击
			util.enableCustomTouch(_bar, true)
	    end

		-- 渲染地图信息
	    function renderMapInfo()

	    	_pos = LevelDao.getAll()
	    	for i = 1, LevelDao.NUM_MAP_SUBLEVELS do
	    		for j = 1, LevelDao.getCurrentLevels(i) do 
	    			local po = _pos[i][j]
	    			po.star = LevelDao.getStarByIndexes(_dataLevels, i, j)
	    		end
	    	end

	    	-- [重写地图方法]
			--[[ 
				根据地图索引、关卡索引获得某关卡名称
			--]]
			function _map.getFlagTitle(mapIndex, flagIndex)
				return string.format("%d-%d %s", mapIndex, flagIndex, _pos[mapIndex][flagIndex].subname)
			end

			--[[ 
				根据地图索引、关卡索引获得某关卡星星数目
			--]]
			function _map.getFlagStar(mapIndex, flagIndex)
				return _pos[mapIndex][flagIndex].star
			end

			--[[ 
				根据地图索引获得某地图已经通过的关卡数量
			--]]
			function _map.getPassedGateNum(mapIndex)
				local num = 0

				local pos = _pos[mapIndex]

				for i = 1, LevelDao.getCurrentLevels(mapIndex) do
					if pos[i].star ~= 0 then 
						num = i
					end
				end

				return num
			end

			--[[ 
				根据地图索引获得某地图已经通关的星星数量
			--]]
			function _map.getPassedStarNum(mapIndex)
				local num = 0

				local pos = _pos[mapIndex]
				for i = 1, LevelDao.getCurrentLevels(mapIndex) do
					num = num + pos[i].star
				end

				return num
			end

			--[[ 
				根据地图索引、关卡索引判断是否要生成子关卡
			--]]
			function _map.isCreateSubmapGate(mapIndex, flagIndex)
				local isCreate = false

				local index1, index2 = LevelDao.getCurrentLevelIndexes(_dataLevels)
				if mapIndex < index1 then 
					isCreate = true
				elseif mapIndex <= index1 and flagIndex <= index2 then 
					isCreate = true
				end

				return isCreate
			end

			--[[
				根据地图索引、关卡索引判断是否要对子地图关卡进行动画显示
			]]
			function _map.isAnimateSubmapGate(mapIndex, flagIndex)
				local isAnimate = false

				local index1, index2 = LevelDao.getCurrentLevelIndexes(_dataLevels)

				if index1 == mapIndex and index2 == flagIndex then 
					if mapIndex == LevelDao.getCurrentLevels(mapIndex) and flagIndex == LevelDao.getCurrentLevels(mapIndex) and _pos[mapIndex][flagIndex].star > 0 then 
						isAnimate = false
					else
						isAnimate = true
					end
				end

				return isAnimate
			end

			function _map.isShowNewMapArea( newMapIndex )
				local result = false
				local index1, index2 = LevelDao.getCurrentLevelIndexes(_dataLevels)
				-- print("@@@@@@@@@@@@", index1, index2, _pos[index1][10].star)
				if 1 <= index1 and index1 <= LevelDao.NUM_MAP_SUBLEVELS  and index1 == newMapIndex and index2 == 1 and _pos[index1][1].star == 0 then 
					result = true
				-- elseif index1 == 12 and index2 == LevelDao.getCurrentLevels(index1) and _pos[index1][10].star == 1 then 
				elseif index1 == LevelDao.NUM_MAP_SUBLEVELS + 1 then
					-- 12-15第一次通过这里要特别处理下
					result = true
				end
				return result
			end

			--[[ 
				判断地图区域是否可点击
			--]]
			function _map.canViewSubmap(mapIndex)
				local level1 = LevelDao.getCurrentLevelIndexes(_dataLevels)
				return mapIndex <= level1
			end

			-- 渲染地图显示区域（暗亮切换）
	    	if _map.renderAreas(LevelDao.getNames(), _level1) then 
	    		_data.skipMoveTo = true
	    	end
		end

		-- 定位当前地图位置
		function locateLevel()
	    	-- 重新刷新索引（从本地缓存读取）
	    	local function indexes()
	    		if GSVALUES.levelIdLast ~= nil then 
		    		local levelIdLast = GSVALUES.levelIdLast
					local levelParams = TDStringUtils.split(levelIdLast, "-")
					local level1      = levelParams[1]
					local level2	  = levelParams[2]

					local level1Last, level2Last = LevelDao.getLastLevelIndexes(_dataLevels)

					--[[
					print("=====================================================")
					print("GSVALUES.levelIdLast:", GSVALUES.levelIdLast)
					dump(_dataLevels)
					print("level record:", level1, level2)
					print("level last:", level1Last, level2Last)
					print("=====================================================")
					--]]
					if not istable(_dataLevels) or #_dataLevels == 0 then 
						_level1 = 1
						_level2 = 1
					elseif level1 ~= level1Last or level2 ~= level2Last then
						_level1 = tonumber(level1)
						_level2 = tonumber(level2)
					end
				end
	    	end
	    	indexes()
			-- _map.moveTo(_level1)
			if ME:getTriggerMsgEntity():isUnlockStar() then
				_map.showMapStar(_dataStars)
			end
			-- 处理新手引导(指定步骤不自动定位)
			-- if HelperView2.isNextIndexIn(700, 790)then  
			-- 	_map.showSubmap(1, false)
			-- 	return 
			-- end 
			if HelperView2.isNextIndexIn(40020, 40050) then  
				_data.autoView = nil
				_data.autoViewAnim = nil
				return 
			end 
			-- 处理自动切换子关地图
			if _data.autoView then 
				_data.autoView = nil
				-- util.delayCall(function() _map.showSubmap(_level1) end, .7)
				_map.showSubmap(_level1, _data.autoViewAnim)
			elseif _data.skipMoveTo then 
				-- 什么也不做
			else
				_map.moveTo(_level1)
			end
		end


	    ---------

	    local function createRewardForHelper( params )
			local layer = display.newLayer()
			-- [[创建items层]]
			-- 创建items
			local itemsLayer = widget.newLayer{
				ignoreAnchor = false,
			}
			-- 背景
			local sprite = widget.newSprite{ file = "reward/bg_reward_items.png" }
			itemsLayer:setContentSize(sprite:getContentSize())
			itemsLayer:addChild(sprite, 0)
			util.alignNode(sprite, itemsLayer)

			local gridLayer = widget.newLayer{ contentSize = CCSize(437, 120)}
			itemsLayer:addChild(gridLayer)
			util.alignNode(gridLayer, itemsLayer)

			-- 奖励类容
			local function createRewardGrid_( )
				local function cellAtIndex( scrollGrid, idx , item)
		    		local cell = widget.newLayer{}--color = ccc4(255, 255, 100, 255),}
		            cell:setContentSize(scrollGrid:getCellSize())
		            cell:ignoreAnchorPointForPosition(false)

		            -- 物品背景
		            local bgSprite = widget.newSprite{file = "goods/goodBack.png"}

		            local spriteLayer = widget.newNode{contentSize = bgSprite:getContentSize()}
		            cell:addChild(spriteLayer)
		            util.alignNode(spriteLayer, cell, display.CENTER_TOP)

		            spriteLayer:addChild(bgSprite, 0)
		            util.alignNode(bgSprite, spriteLayer:getContentSize(), display.CENTER)

		            local rewardSprite
		            local count = 1
		    		if item._TYPE == REWARD_TYPE_CARD then
		    			-- 卡牌
		                item.type = CardMaster.MINISTARCARD
		                rewardSprite = CardMaster.new(item)
		                rewardSprite:setScale(0.76)
		                count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_CHIP then
						-- 碎片
						item.type = CardMaster.MINISTARCARD
		                rewardSprite = CardMaster.new(item)
		                rewardSprite:setScale(0.76)
		                local chipSprite = widget.newSprite{file = "fight/result3/f_r3_cardchip.png"}
		                spriteLayer:addChild(chipSprite, 2)
						util.alignNode(chipSprite, spriteLayer:getContentSize(), display.CENTER)
		                count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_GOODS then
						-- 物品
		                item.type = GoodsMaster.MATERIAL
		                item.showFrame = true
		                rewardSprite = GoodsMaster.new(item)
		                -- count = rewardSprite:getCount()
		                count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_SP then
						-- 体力
						rewardSprite = widget.newSprite{file = "mission/img_sign_burette.png"}
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_GOLD then
						-- 金币
						rewardSprite = widget.newSprite{file = "reward/icon/icon_gold.png"}
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_FP then
						-- 友情点
						rewardSprite = widget.newSprite{file = "main/img_sign_friendpoint.png"}
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_DIAMOND then
						-- 钻石
						rewardSprite = widget.newSprite{file = "main/img_sign_diamond.png"}
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_FREEBUY then
						-- 免费抽奖
						rewardSprite = widget.newSprite{file = "mission/img_sign_freebuy.png"}
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_STAR then
						-- 星星
						rewardSprite = widget.newSprite{file = "main/img_main_star.png"}
						rewardSprite:setScale(1.4)
						count = item._VALUE
					elseif item._TYPE == REWARD_TYPE_EXP then
						-- 经验
						rewardSprite = widget.newSprite{file = "main/img_sign_exp.png"}
						count = item._VALUE
					end
					if rewardSprite then
						spriteLayer:addChild(rewardSprite, 1)
						util.alignNode(rewardSprite, spriteLayer:getContentSize(), display.CENTER)
					end
					local countLayer = widget.newLayer{contentSize = CCSize(93, 26)}
					cell:addChild(countLayer)
					util.alignNode(countLayer, cell, display.BOTTOM_CENTER)
					local countBg = widget.newSprite{file = "reward/bg_reward_items_count.png"}
					countLayer:addChild(countBg, 0)
					util.alignNode(countBg, countLayer)
					local countLabel = ui.newTTFLabel{text = "x " .. count, size = 22,}
					countLayer:addChild(countLabel, 1)
					util.alignNode(countLabel, countLayer)

					return cell
		    	end
		    	local function onBtnClick(grid, index, item, x, y)
		            -- item.shareButton = true
		    		if item._TYPE == REWARD_TYPE_CARD or item._TYPE == REWARD_TYPE_CHIP then
		    			CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item)
					elseif item._TYPE == REWARD_TYPE_GOODS then
		                if item:getNo() > 20000 then
		                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item)
		                else
		                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item)
		                end
					end
		    	end
				local scrollGrid = widget.newScrollGrid{
		    		contentSize = gridLayer:getContentSize(),
			        contentParams = {
			            cellSize = CCSize(95, gridLayer:getContentSize().height ),
			            padding = { 
			                middleH = 20,
			            },
			            row = 1,
			            createItemCellListener = cellAtIndex,
			            tapListener = onBtnClick,
			        },
			        bounceable = false,
			        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
			        -- parentNode = layer,
			    }
		    	return scrollGrid
			end
			local function rewardAdapter( reward )
		    	local rewardTable = {}
				-- 物品或卡牌碎片等
				if reward.brlist and #reward.brlist > 0 then
		            local _cache = {}
					for i,v in ipairs(reward.brlist) do
	                    local entity
	                    if v.no < 5000 then
	                        -- 绑成卡牌
	                        entity = CardEntity.new{id = v.no}
	                        entity._TYPE = REWARD_TYPE_CARD
	                    elseif v.no < 10000 then
	                        -- 碎片
	                        entity = CardEntity.new{id = v.no}
	                        entity._TYPE = REWARD_TYPE_CHIP
	                    else
	                        -- 物品
	                        entity = GoodsEntity.new(v)
	                        entity._TYPE = REWARD_TYPE_GOODS
	                    end
	                    if _cache[v.no] then
	                        entity = _cache[v.no]
	                        entity._VALUE = entity._VALUE + v.count
	                    else
	                        entity._VALUE = v.count
	                        rewardTable[#rewardTable + 1] = entity
	                        _cache[v.no] = entity
	                    end
					end
				end
				-- 体力
				if reward.sp and reward.sp > 0 then
					local sp = {_VALUE = reward.sp, _TYPE = REWARD_TYPE_SP }
					rewardTable[#rewardTable + 1] = sp
				end
				-- 金币
				if reward.gold and reward.gold > 0 then
					local gold = {_VALUE = reward.gold, _TYPE = REWARD_TYPE_GOLD }
					rewardTable[#rewardTable + 1] = gold
				end
				-- 友情点
				if reward.fp and reward.fp > 0 then
					local fp = {_VALUE = reward.fp, _TYPE = REWARD_TYPE_FP }
					rewardTable[#rewardTable + 1] = fp
				end
				-- 钻石
				if reward.diamond and reward.diamond > 0 then
					local diamond = {_VALUE = reward.diamond, _TYPE = REWARD_TYPE_DIAMOND }
					rewardTable[#rewardTable + 1] = diamond
				end
				-- 免费抽奖
				if reward.freebuy and reward.freebuy > 0 then
					local freebuy = {_VALUE = reward.freebuy, _TYPE = REWARD_TYPE_FREEBUY }
					rewardTable[#rewardTable + 1] = freebuy
				end
				-- 经验
				if reward.exp and reward.exp > 0 then
					local exp = {_VALUE = reward.exp, _TYPE = REWARD_TYPE_EXP }
					rewardTable[#rewardTable + 1] = exp
				end
				-- 星星
				if reward.star and reward.star > 0 then
					local star = {_VALUE = reward.star, _TYPE = REWARD_TYPE_STAR }
					rewardTable[#rewardTable + 1] = star
				end
				return rewardTable
			end
			

			local rewardGrid = createRewardGrid_()
			gridLayer:addChild(rewardGrid, 1)
			rewardGrid:setItems(rewardAdapter(params.rewards))
			-- 创建标题
			local titleLabel = ui.newTTFLabel{
				text = params.title,
				size = 30,
				font = FONT_1,
				-- color = BUTTON_COLOR3.RED,
			}
			itemsLayer:addChild(titleLabel)
			util.alignNode(titleLabel, itemsLayer:getContentSize(), display.TOP_CENTER, 12)
			-- 创建button
			local button = widget.newButton{
				normalImage = "reward/reward_button.png",
				scale = 1.1,
				labelParams = {
					text = _s("HELPER_TEXT_REWARD_BUTTON"),
					size = 30,
					color = BUTTON_COLOR3.BROWN,
				},
				listener = function ( button )
					if MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA then
		                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA)
		            end
					CCBCenter.popLastLevelCCBNode()
				end
			}
			itemsLayer:addChild(button)
			util.alignNode(button, itemsLayer:getContentSize(), display.BOTTOM_CENTER) 
			layer:addChild(itemsLayer)
			util.alignNodeWithPadding(itemsLayer, layer:getContentSize(), display.CENTER, 
				{ top = 0, left = 20, })

			local x, y = itemsLayer:getPosition()

			-- [[建个小妞放左边,依嘿嘿嘿嘿]]
			if params.showGirl then
				local girlSprite = widget.newSprite{
					file = "reward/reward_girl.png",
					x = x - 326, 
					y = y - 20,
				}
				layer:addChild(girlSprite)
			end
			-- [[放箱钻石在右边,哇哈哈哈哈]]
			local boxSprite = widget.newSprite{
				file = "reward/reward_diamond_box.png",
				x = x + 190,
				y = y - 110,
			}	
			layer:addChild(boxSprite)

			return layer
	    end

	    -- [新手帮助]
		-- 判断是否执行新手帮助
		function checkHelperInfo(  )
			local function callback( index )
				-- if index == 770 then 
				-- 	-- 弹出领取新手奖励
				-- 	local layer = createRewardForHelper{title = _s("HELPER_TEXT_REWARD_TITLE"), rewards = {diamond = 50, fp = 100, star = 200, brlist = {{no = 72, count = 1},}}}
				-- 	CCBCenter.pushLastLevelCCBNode(layer, anim.ANIMATION_POP_OUT)
				-- else
				if index == 180010 then
					-- 弹出领取新手奖励
					local layer = createRewardForHelper{title = _s("HELPER_TEXT_STAR_REWARD_TITLE"), showGirl = true, rewards = {diamond = 50, fp = 200, star = 300, brlist = {{no = 17, count = 1},}}}
					CCBCenter.pushLastLevelCCBNode(layer, anim.ANIMATION_POP_OUT)
				end
			end
			-- if HelperView2.showBetween(_node, callback, {700, 780}) == nil then
				-- if ME:getTriggerMsgEntity():isShowLevelStarRewardHelper() then
				-- 	HelperView2.setCurIndex(180010)
				-- 	HelperView2.showBetween(_node, callback, {180010, 180010})
				-- end
			-- end
			
		end

	    ---------


	    -- [视图析构]
	    -- 视图析构
	    function viewDestructor()

	    end


	    ---------


	    -- [资源]
	    -- 加载资源
	    function loadResources()

	    end

	    -- 卸载资源
	    function unloadResources()

	    end


	    ---------


	    -- [数据]
	    -- 加载数据
	    function loadData()
	    	-- 加载数据[好友]
	    	loadDataFriends()
	    end

	    -- 加载数据[好友]
	    function loadDataFriends()
		    -- 请求参数
		    -- ..

		    -- 请求动作
		    NetHelper.createRequest(
		       ACTID.MSG_INVITE_FRIPOINT_LIST,      	-- 请求ID
		       netReceiveFriends,                		-- 回调函数
		       {                                        -- 请求信息实体或参数Table
		       }
		    )
	    end

	    -- 加载数据[领取星星]
	    function loadDataStar()
		    -- 请求参数
		    -- ..

		    -- 请求动作
		    NetHelper.createRequest(
		       ACTID.MSG_GET_STAR,      				-- 请求ID
		       netReceiveStar,                			-- 回调函数
		       {                                        -- 请求信息实体或参数Table
		       },
		       {failedCb = function ( )
		       	_mapOffset = nil
		       end,}
		    )
	    end

	    ---------


	    -- [事件处理]
	    -- 处理子关卡点击事件响应
	    function onTouchSubLevel(level1, level2)
	    	-- [过滤判断]
	    	-- 判断是否锁定
	    	if isLocked() then return end
	    	-- 锁定
	    	lockIt()


	    	-- [逻辑处理]
	    	-- 关卡PO
	    	local po   = LevelDao.getByIndexes(level1, level2)	
	    	po.star    = LevelDao.getStarByIndexes(_dataLevels, level1, level2)			-- 关卡星星
	    	po.isBreak = LevelDao.isBreak(_dataLevels, level1, level2) 					-- 是否展开新关卡

	    	-- 播放关卡音效
	    	playLevelSound()
	    	
	    	local function callback()
	    		if level1 and level2 then 
	    			-- 小保存下说这个播放过了
	    			local cur = string.format("%02d-%02d-%d", level1, level2, po.star)
	    			local storyPlayed = game.getGameState("STORY_PLAYED")
	    			if not storyPlayed or cur > storyPlayed then 
	    				game.addGameState("STORY_PLAYED", string.format("%02d-%02d-%d", level1, level2, po.star), true)
	    			end
	    		end
	    		CCBCenter.loadCCB("MSG_MAPPOPUPDIFFICULTYLAYER_MODEL", "ccb.c.map.MapPopupDifficultyLayer", { dataFriends = _dataFriends , po = po, })
	    	end
	    	local storyPlayed = game.getGameState("STORY_PLAYED")
	    	local curStory = string.format("%02d-%02d-%d", level1, level2, po.star)
	    	if po.isBreak and storyPlayed and curStory < storyPlayed then 
	    		storyPlayed = nil
	    		game.addGameState("STORY_PLAYED", nil)
	    	end
	    	--测试剧情注释用，记得还原回去
	    	 if po.isBreak and (not storyPlayed or curStory > storyPlayed) then 
	    		-- print("@@@@@@@@@@@@@@@@@@@@ 这是没打过的一关啊", level1, level2)
	    		-- STORY 故事剧情放在这里~~~
	    		if not HelperView2.playStory(_map.getSubmapNode(), level1, level2, callback) then
	    			callback(level1, level2)
	    		end
	    	else
	    		-- 重打关卡
	    		-- 加载视图
	    		callback()
	    		-- CCBCenter.loadCCB("MSG_MAPPOPUPDIFFICULTYLAYER_MODEL", "ccb.c.map.MapPopupDifficultyLayer", { dataFriends = _dataFriends , po = po, })
	    	end
	    	
	    end


	    ---------


	    -- [Loading]
	    -- 显示Loading
	    function showLoading()
	    	NetHelper.showLoading(true, true)
	    end

	    -- 隐藏Loading
	    function hideLoading()
	    	NetHelper.hideLoading(true)
	    end


	    ---------


	    -- [Lock]
	    -- 判断是否锁定（不让点击）
	    function isLocked()
	    	return _lock
	    end

	    -- 锁定
	    function lockIt()
	    	_lock = true
	    end

	    -- 解除锁定
	    function unlockIt()
	    	_lock = false
	    end


	    ---------


	    -- [回调处理]
	    -- 回调函数（处理从其他界面返回到当前界面）
	    function callbackReturnToView()
	    	-- 解除锁定
	    	unlockIt()
	    end


	    ---------


	    -- [音效]
		-- 播放关卡音效
		function playLevelSound()
			SOUND:playEffectButton2()
		end


	    ---------


	    -- [Util]
		-- 获得结点
		function NODE(nodeTag)
			return CCBCenter.getNodeByTag(_node, nodeTag)
		end
		


	        

	        





	    -- [具体操作]
    	-- 视图渲染[基础数据]
    	viewRenderBase()
	    -- 视图渲染
	    _node.requestDataForLoad = function()
	    	netSend()
	    end
		


	        

	        





	    -- [事件传递]
	    _node.callbackReturnToView 		= callbackReturnToView

		-- 判断是否执行新手帮助
		checkHelperInfo()
		
		_node.netSend = netSend
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M