--MapExploreLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MapExploreLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = _node._DATA
    local _parallaxNode, _role, _xp, _sp, _enemy, _enemyLayer, _popDialog
    local MapExploreScenesInfo = require("static.map_explore_scenes_info")
    
    local _scenesStatus = 0
    local SCENES_STATUS_COMMING = 0
    local SCENES_STATUS_STAND = 1
    local SCENES_STATUS_EXPLORER = 2
    local SCENES_STATUS_FIGHTMONSTER = 3
    local SCENES_STATUS_FINDTREASURECHEST = 4
    local SCENES_STATUS_MISSOTHERHERO = 5
    local SCENES_STATUS_WAITREQUEST = 6
    local SCENES_STATUS_FINDMYSTERYSHOP = 7
    
    local ENEMY_TYPE_TREASURECHEST  = 1 -- 宝箱 
    local ENEMY_TYPE_MONSTER        = 2 -- 怪物 
    local ENEMY_TYPE_PLAYER         = 3 -- 玩家
    local ENEMY_TYPE_MYSTERYSHOP    = 4 -- 神秘商人
    local ENEMY_TYPE_TRAVELSHOP     = 5 -- 旅行商人

    -- 英雄动作
    local heroExplore, heroComing, heroAttack, heroStand, heroPraise, heroExit, shopExit
    -- 卡牌动作
    local enemyComing, enemyExit
    -- 宝箱动作
    local treasureChestFlash, treasureChestExit
    -- 事件
    local runMissOtherHero, runFightMonster, runFindTreasureChest, runExplore, runMysteryShop, runTravelShop
    local showRewardAlert, randomStart, resetHeroStatus
--[[ ## local fuction --]]
    -- 创建视差图层
    local function createParallaxNode( )        
        -- 层配置表
        local bgConfig_table = MapExploreScenesInfo.infos[MapExploreScenesInfo.SCENES_PALACE]
        local parallaxNode = require("cardui.ParallaxView").new{
            bgConfigTable = bgConfig_table, 
            contentSize = CCSize(960, 640),
            moveTime = 5,
        }
        CCBCenter.getNodeByTag(_node, 1):addChild(parallaxNode)
        return parallaxNode
    end
    -- 创建经验和体力控件
    local function createExpAndSp( )
        --增加经验ProgressBar
        _xp = widget.newProgressBar{
            frontSprintParams = {file = "map/explore/progressBar_blue_img.png",},
            bgSprintParams = {file = "map/explore/progressBar_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, padding = {top = 20}},
            percentage = 0,
        }
        _xp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 30504):addChild(_xp)

        --增加体力ProgressBar
        _sp = widget.newProgressBar{
            frontSprintsParams = {
                {file = "map/explore/progressBar_green_img.png",}, 
                {file = "map/explore/progressBar_deep_green_img.png",}
            },
            -- frontSprintParams = {file = "map/explore/progressBar_green_img.png",},
            bgSprintParams = {file = "map/explore/progressBar_bg.png"},
            ttfLabelParams = {size = 16, shadow = true, padding = {top = 20}},
            percentage = 0,
        }
        _sp:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 30502):addChild(_sp)
    end
    -- 关闭弹出窗口
    local function closePopDialog( )
        if _popDialog then
            _popDialog:removeFromParentAndCleanup(true)
        end
    end
    -- 创建其他玩家抉择窗口
    local function createPopOtherHeroDialog( params )
        Log.d(TAG, "骚年, 请选择")
        local function onPraiseClick( button )
            Log.d(TAG, "你好美!")
            button.setStateDisabled(true)
            closePopDialog( )
            heroPraise(_enemyLayer, function ( )
                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLOREPRAISE, nil, {fid = params.fid})
            end )
        end
        local function onRobberyClick( button )
            Log.d(TAG, "裤子留下")
            button.setStateDisabled(true)
            closePopDialog( )
            heroAttack(_role, function ( )
                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHEXPLORESTEAL, nil, {fid = params.fid})
            end)
        end
        local function onAddFriendClick( button )
            Log.d(TAG, "土豪做朋友")
            SOUND:playEffectButton1()
            NetHelper.QuickToast(_s("FRIEND_APPLICATION_SUCCESS"))
            button.setStateDisabled(true)
            CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHADDFRIEND, nil, {fid = params.fid})
        end
        local isFriend = params.isfriend or FALSE
        if _popDialog then
            _popDialog:removeFromParentAndCleanup(true)
        end
        -- 弹出窗口
        _popDialog = widget.newLayer{
            -- color = ccc4(255, 250, 200, 150),
            contentSize = CCSize(360, 120)
        }
        -- 背景
        local bgSprite = widget.newScale9{
            file = "QuickToast.png",
            contentSize = _popDialog:getContentSize()
        }
        _popDialog:addChild(bgSprite, 0)
        util.alignNode(bgSprite, _popDialog:getContentSize(), display.CENTER)
        -- 赞美按钮
        local btnPraise = widget.newButton{
            normalImage = "map/explore/btn_explore_friend_praise.png",
            contentSize = CCSize(81, 81),
            -- scale = 1.1,
            listener = onPraiseClick,
            labelParams = {text = _s("MAP_EXPLORE_PRAISE"), padding = {top = 56}, size = 20},
        }
        _popDialog:addChild(btnPraise)
        util.alignNodeWithPadding(btnPraise, _popDialog:getContentSize(), display.CENTER_LEFT, {left = 22, top = -10})
        -- 打劫按钮
        local btnRobbery = widget.newButton{
            normalImage = "map/explore/btn_explore_friend_fight.png",
            contentSize = CCSize(81, 81),
            -- scale = 1.1,
            listener = onRobberyClick,
            labelParams = {text = _s("MAP_EXPLORE_ROBBERY"), padding = {top = 56}, size = 20},
        }
        _popDialog:addChild(btnRobbery)
        util.alignNodeWithPadding(btnRobbery, _popDialog:getContentSize(), display.CENTER, {top = -10})
        
        -- 申请好友
        local btnAddFriend = widget.newButton{
            normalImage = "map/explore/btn_explore_friend_normal.png",
            disableImage = "map/explore/btn_explore_friend_disable.png",
            contentSize = CCSize(81, 81),
            -- scale = 1.1,
            listener = onAddFriendClick,
            labelParams = {text = _s("MAP_EXPLORE_ADDFRIEND"), padding = {top = 56}, size = 20},
        }
        _popDialog:addChild(btnAddFriend)
        util.alignNodeWithPadding(btnAddFriend, _popDialog:getContentSize(), display.CENTER_RIGHT, {right = 22, top = -10})
        if isFriend == TRUE then
            btnAddFriend.setStateDisabled(true)
        end
        
        -- 弹出动画
        anim.popOut(_popDialog)
        _node:addChild(_popDialog)
        util.alignNode(_popDialog, _node:getContentSize(), display.CENTER_TOP, 90)
    end
    -- 弹出商店页面
    local function popShopView( typ, onClose )
        CCBCenter.loadCCB("MSG_SHOPMYSTERYLAYER_MODEL", "ccb.c.shop.ShopMysteryLayer", { typ = typ, onClose = onClose})
    end
    -- 探索新手引导
    local function checkHelperInfo( )
        local msgEntity = ME:getTriggerMsgEntity()
        -- 排查
        if msgEntity:isShowHelpInfo() then 
            -- 为了容错(正常是不会进来的)
            return false
        elseif msgEntity:isJumpToUnlockCard() then
            -- 卡牌解锁
            HelperView2.setCurIndex(90010)
            return HelperView2.showBetween(_node, nil, {90010, 90010}) ~= nil
        elseif msgEntity:isJumpToCardGroup() then
            -- 卡组解锁
            HelperView2.setCurIndex(100010)
            return HelperView2.showBetween(_node, nil, {100010, 100010}) ~= nil
        elseif msgEntity:isJumpToEnhancedHelper() then
            HelperView2.setCurIndex(10010)
            return HelperView2.showBetween(_node, nil, {10010, 10010}) ~= nil
        elseif msgEntity:isJumpToEvolutionHelper() then
            HelperView2.setCurIndex(20010)
            return HelperView2.showBetween(_node, nil, {20010, 20010}) ~= nil
        elseif msgEntity:isJumpToTalentHelper() then
            HelperView2.setCurIndex(50010)
            return HelperView2.showBetween(_node, nil, {50010, 50010}) ~= nil
        elseif msgEntity:isJumpToStarHelper() then
            HelperView2.setCurIndex(40010)
            return HelperView2.showBetween(_node, nil, {40010, 40010}) ~= nil
        elseif msgEntity:isJumpToChipHelper() then
            HelperView2.setCurIndex(80010)
            return HelperView2.showBetween(_node, nil, {80010, 80010}) ~= nil
        elseif msgEntity:isJumpToArenaHelper() then
            HelperView2.setCurIndex(70010)
            return HelperView2.showBetween(_node, nil, {70010, 70010}) ~= nil
        elseif msgEntity:isJumpToArenaWeekHelper() then
            HelperView2.setCurIndex(130010)
            return HelperView2.showBetween(_node, nil, {130010, 130010}) ~= nil
        elseif msgEntity:isJumpToEquipHelper() then
            HelperView2.setCurIndex(120010)
            return HelperView2.showBetween(_node, nil, {120010, 120010}) ~= nil
        elseif msgEntity:isJumpToFriendHelper() then
            HelperView2.setCurIndex(30010)
            return HelperView2.showBetween(_node, nil, {30010, 30010}) ~= nil
        elseif msgEntity:isJumpToEquipEnhancedHelper() then
            HelperView2.setCurIndex(140010)
            return HelperView2.showBetween(_node, callback, {140010, 140010}) ~= nil
        elseif msgEntity:isJumpToMiningHelper() then
            HelperView2.setCurIndex(150010)
            return HelperView2.showBetween(_node, callback, {150010, 150010}) ~= nil
        elseif msgEntity:isJumpToEquipEvoHelper() then
            HelperView2.setCurIndex(160010)
            return HelperView2.showBetween(_node, callback, {160010, 160010}) ~= nil
        elseif msgEntity:isJumpToEquipAddHelper() then
            HelperView2.setCurIndex(170010)
            return HelperView2.showBetween(_node, callback, {170010, 170010}) ~= nil
        elseif msgEntity:isJumpToTower1Helper() then
            HelperView2.setCurIndex(200010)
            return HelperView2.showBetween(_node, callback, {200010, 200010}) ~= nil
        elseif msgEntity:isJumpToTower2Helper() then
            HelperView2.setCurIndex(210010)
            return HelperView2.showBetween(_node, callback, {210010, 210010}) ~= nil
        end
    end
    -- 英雄探索
    function heroExplore( hero, noWalk )
        hero:stopAllActions()
        hero:runAction(transition.sequence{
            CCCallFunc:create(function ()
                if not noWalk then
                    hero:run()
                end
                _parallaxNode:resumeMoveAnim()
            end),
            }
        )
    end
    -- 英雄进场
    function heroComing( hero, callback )
        _scenesStatus = SCENES_STATUS_COMMING
        hero:stopAllActions()
        hero:runAction(transition.sequence{
            CCCallFunc:create(function ()
                hero:jump()
                hero:setPosition(ccp(180, 320))
            end),
            CCDelayTime:create(0.2),
            CCCallFunc:create(function ()
                hero:setVisible(true)
            end),
            CCDelayTime:create(0.7),
            CCCallFunc:create(function ()
                hero:run()
            end),
            CCMoveBy:create(0.5, ccp(180, 0)),
            CCCallFunc:create(function ()
                if callback then callback() end
            end),
            })
    end
    -- 英雄攻击
    function heroAttack( hero, callback )
        Log.d(TAG, "主角攻击")
        local function addAttackLight( onComplete )
            -- 扫光
            local lightSprite = anim.playAnimation(
                nil, 
                "map/explore/img_hero_attack", 
                "img_hero_attack_%d.png", 
                4, 0.3, 1, false, true, 
                function ( )
                    if onComplete then
                        onComplete()
                    end
                end
            )
            lightSprite:setScaleX(hero:getScaleX())
            lightSprite:setScaleY(hero:getScaleY())
            _parallaxNode:getMainLayer():addChild(lightSprite, 1)
            local offsetX = iff(hero:getScaleX() > 0 , -60, 60)
            lightSprite:setPosition(ccp(hero:getPositionX() + offsetX, hero:getPositionY() - 40))
        end
        hero:stopAllActions()
        hero:runAction(transition.sequence{
            CCCallFunc:create(function ()
                _parallaxNode:pauseMoveAnim()
                hero:attack()
                
            end),
        })
        hero:runAction(transition.sequence{
            CCDelayTime:create(0.7),
            CCCallFunc:create(function ()
                audio.playEffect("res/sound/fight/effect/e_f_hhurt_blood3.mp3")
                addAttackLight( callback )
            end),
        })
    end
    -- 英雄赞美
    function heroPraise( hero, callback )
        hero:stopAllActions()

        local particle = CCParticleSystemQuad:create("map/explore/map_explore_praise.plist")
        local particleBatch = CCParticleBatchNode:createWithTexture(particle:getTexture())
        particleBatch:addChild(particle)
        _parallaxNode:getMainLayer():addChild(particleBatch, 20)
        particleBatch:setPosition(ccp(_enemyLayer:getPositionX() + 100, _enemyLayer:getPositionY()))
        audio.playEffect("res/sound/fight/effect/e_f_hinc_blood2.mp3")
        hero:runAction(transition.sequence{
            CCDelayTime:create(2),
            CCCallFunc:create(function ()
                particleBatch:removeFromParentAndCleanup(true)
                if callback then
                    callback()
                end
            end),
        })
    end
    -- 英雄站立
    function heroStand( hero, callback )
        Log.d(TAG, "英雄站立")
        hero:stopAllActions()
        hero:stand()
        _parallaxNode:pauseMoveAnim()
        hero:runAction(transition.sequence{
            CCDelayTime:create(0.5),
            CCCallFunc:create(function ()
                if callback then
                    callback()
                end
            end),
        })
    end
    -- 反派登场
    function enemyComing( enemy, position, time, callback )
        Log.d(TAG, "反派入场")
        enemy:stopAllActions()
        enemy:runAction(transition.sequence{
            CCMoveBy:create(time, position),
            CCCallFunc:create(function ()
                if callback then callback() end
            end),
        })
    end
    -- 反派退场
    function enemyExit( enemy, callback )
        Log.d(TAG, "反派退场, 消失")
        enemy:stopAllActions()
        enemy:setFadeOut{time = 1, onComplete = function ( )
            enemy:removeFromParentAndCleanup(true)
            if callback then
                callback()
            end
        end}
    end
    -- 反派退场
    function enemyRock( enemy, callback )
        Log.d(TAG, "反派震惊, 晃")
        local function rock( target, onComplete )
            target:stopAllActions()
            local rotationX = target:getRotationX()
            local rotationY = target:getRotationY()
            local playTime = 0.05
            local array = {}
            for i = 1, 2 do
                array[#array + 1] = CCRotateTo:create(playTime, rotationX + 20, rotationY )
                array[#array + 1] = CCRotateTo:create(playTime, -(rotationX + 20), rotationY )
                array[#array + 1] = CCRotateTo:create(playTime/2 , rotationX, rotationY)
            end
            local action = transition.sequence(array)
            transition.execute(target, action, {onComplete = onComplete})
        end
        
        -- 开前摇一摇
        -- anim.shake(enemy, {
        --     onComplete = function ( )
        --     if callback then
        --         callback()
        --     end
        -- end})
        rock(enemy, callback)
    end
    -- 商人退场
    function shopExit( hero, callback )
        hero:stopAllActions()
        transition.fadeOut(
            hero, 
            {
                time = 1, 
                onComplete = function ( )
                    hero:removeFromParentAndCleanup(true)
                    if callback then
                        callback()
                    end
                end
            }
        )
    end
    -- 玩家退场
    function heroExit( hero, callback )
        Log.d(TAG, "玩家, 消失")
        hero:stopAllActions()
        hero.setFadeOut( )
        transition.fadeOut(
            hero, 
            {
                time = 1, 
                onComplete = function ( )
                    hero:removeFromParentAndCleanup(true)
                    if callback then
                        callback()
                    end
                end
            }
        )
    end
    -- 宝箱闪烁
    function treasureChestFlash( treasureChest, callback )
        local function addAttackLight( onComplete )
            -- 闪光
            local lightSprite = anim.playAnimation(
                nil, 
                "map/explore/img_treasure_chest_flash", 
                "img_treasure_chest_flash_%d.png", 
                2, 0.1, 1, false, true, 
                function ( )
                    if onComplete then
                        onComplete()
                    end
                end
            )
            treasureChest:addChild(lightSprite, 1)
            util.alignNodeWithPadding(lightSprite, treasureChest:getContentSize(), display.CENTER, {left = -22})
        end
        addAttackLight(function ( )
            -- 开前摇一摇
            anim.shake(treasureChest, {onComplete = function ( )
                -- 箱子开嘴
                treasureChest:setDisplayFrame(display.newSpriteFrame("img_treasure_chest_2.png"))
                if callback then
                    callback()
                end
                treasureChestExit(treasureChest)
            end})
        end)
    end
    -- 宝箱消失
    function treasureChestExit( treasureChest, callback )
        Log.d(TAG, "宝箱消失")
        treasureChest:stopAllActions()
        transition.fadeOut(
            treasureChest, 
            {
                time = 1, 
                onComplete = function ( )
                    treasureChest:removeFromParentAndCleanup(true)
                    if callback then
                        callback()
                    end
                end
            }
        )
    end
    -- 随机延迟
    function randomStart( callback )
        -- local delayTime = math.random(2, 3)
        local delayTime = 1
        Log.d(TAG, "随机%d秒", delayTime)
        util.delayCall(callback, delayTime)
    end
    -- 弹出奖励
    function showRewardAlert( reward, onComplete, title )
        Log.d(TAG, "弹出奖励")
        local rewardEntity = require("model.main.RewardEntity").new(reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = onComplete,
                title = title,
            }
        )
    end
    local function updateSp( )
        -- 体力
        local sp = ME:getCursp() /  ME:getActlimit() * 100
        _sp:setPercentage( sp )
        _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
    end
    -- 更新玩家信息
    local function updatePlayerInfo( )
        Log.d(TAG, "刷新玩家信息")
        -- 头像
        local headNode = CCBCenter.getNodeByTag(_node, 30302)
        local head = ME:createPlayerHeadRectView()
        local tempScale = headNode:getContentSize().width / head:getContentSize().width
        head:setScale(tempScale)
        headNode:addChild(head)
        util.alignNode(head, headNode, display.CENTER_LEFT, {left = 1, bottom = 8})
        -- 经验
        local xp = ME:getCurexp() /  ME:getTotalexp() * 100
        _xp:runProgressTo( 0.5 , xp )
        _xp:setString(ME:getCurexp() .. "/" .. ME:getTotalexp())
        -- 体力
        local sp = ME:getCursp() /  ME:getActlimit() * 100
        _sp:setPercentage( sp )
        _sp:setString(ME:getCursp() .. "/" .. ME:getActlimit())
        -- 名字
        _nodeTable["mNameLabel"]:setString(ME:getName()) 
        _nodeTable["mAttackLabel"]:setString(ME:getTotalatk()) 
        _nodeTable["mHpLabel"]:setString(ME:getTotalHp()) 
        -- 等级
        _nodeTable["mLevelLabel"]:setString(ME:getLv()) 
        -- 关卡上限
        _nodeTable["mProgressLabel"]:setString(_s("MAP_EXPLORE_PROGRESS", _data.progress, _data.maxLv ))
        -- 通关奖励
        if _data.progress == _data.maxLv then
            _nodeTable["btnExplore"]:setEnabled(false)
            util.delayCall(
                function ( )
                    showRewardAlert(
                        _data.result.finRw, 
                        function ( )
                            -- 更新新手帮助
                            if not checkHelperInfo( ) then
                                _node.closeLayer()
                                -- CCBCenter.popLastLevelCCBNode()
                            end
                        end, 
                        _s("MAP_EXPLORE_FINISH_REWARD")
                    )
                end, 0.2
            )
            
        else
            -- 更新新手帮助
            checkHelperInfo( )
        end
        
    end
    -- 更新赞美结果
    local function updatePraiseResult( result )
        showRewardAlert(result, function ( )
            runMissOtherHero( )
        end)
    end
    -- 更新打劫结果
    local function updateRobberyResult( result )
        if result.res == TRUE then
            showRewardAlert(result.reward, function ( )
                runMissOtherHero( )
            end)
        else
            -- 播放音效[战斗－失败]
            SOUND:playEffectFightLose()
            -- 对话框提示
            AlertLayer.new4OK{
                content     = _s("MAP_EXPLORE_ROBBERY_FAIL", result.reward.gold),
                btnClickEvent = {
                    function ( )
                        runMissOtherHero( )
                    end,
                },
            }
            
        end
    end
    -- 重置英雄状态
    function resetHeroStatus( )
        _scenesStatus = SCENES_STATUS_STAND
        _nodeTable["btnExplore"]:setEnabled(true)
        _data._EXPLORE = false
        updatePlayerInfo( )
    end
    -- 执行探索(提前开始)
    function runExplore( auto )
        Log.d(TAG, "我想要搜索")
        if _scenesStatus == SCENES_STATUS_EXPLORER or _scenesStatus == SCENES_STATUS_COMMING then
            Log.d(TAG, "还再进场还是已经在搜索了..不管你")
            return
        else
            Log.d(TAG, "你搜索吧, 状态变成已搜索")
            _scenesStatus = SCENES_STATUS_EXPLORER
            heroExplore(_role, auto)
            -- 发送请求
            CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPEXPLORELAYER_ACTION_ONFETCHLEVELEXPLORE, nil, {sn = _data.mapSn, subsn = _data.mapSubsn,})
        end
    end
    -- 执行打怪兽
    function runFightMonster()
        Log.d(TAG, "我想要打怪兽")
        if _scenesStatus == SCENES_STATUS_FIGHTMONSTER then
            Log.d(TAG, "已经在打了..不管你")
            return
        else
            Log.d(TAG, "开打, 状态变成打怪兽")
            _scenesStatus = SCENES_STATUS_FIGHTMONSTER
            -- 随机延迟一会
            randomStart(function ( )
                -- 反派入场
                enemyComing(_enemy, ccp(-700, 0), 1.5, function ( )
                    -- 到跟前主角站住
                    heroStand(_role, function ( )
                        -- 主角攻击
                        heroAttack(_role, function ( )
                            -- 怪物晃了晃
                            enemyRock(_enemy, function ( )
                                -- 怪物嗝屁, 消失
                                enemyExit(_enemy, function ( )

                                    if _data.pestscno ~= 0 then
                                        NetHelper.QuickToast(_data.pestString)
                                        resetHeroStatus()
                                    else
                                        -- 弹出奖励
                                        showRewardAlert(_data.result, function ( )
                                            -- 刷新玩家信息
                                            resetHeroStatus()
                                        end)
                                    end
                                end)
                            end)
                        end)
                    end)
                end)
            end)
        end
    end
    -- 执行找到宝箱
    function runFindTreasureChest( )
        Log.d(TAG, "英雄说找到了一个宝箱")
        if _scenesStatus == SCENES_STATUS_FINDTREASURECHEST then
            Log.d(TAG, "太贪心了..不管你")
            return
        else
            Log.d(TAG, "搜刮宝箱")
            _scenesStatus = SCENES_STATUS_FINDTREASURECHEST
            -- 随机延迟一会
            randomStart(function ( )
                -- 宝箱入场
                enemyComing(_enemy, ccp(-600, 0), 1.5, function ( )
                    -- 到跟前主角站住
                    heroStand(_role, function ( )
                        -- 主角攻击
                        heroAttack(_role, function ( )
                            -- 宝箱闪烁
                            treasureChestFlash(_enemy, function ( )
                                -- 弹出奖励
                                showRewardAlert(_data.result, function ( )
                                    -- 刷新玩家信息
                                    resetHeroStatus()
                                end)
                            end)
                        end)
                    end)
                end)
            end)
        end
    end
    -- 执行遇见其他玩家
    function runMissOtherHero( )
        Log.d(TAG, "英雄说找到其他英雄")
        if _scenesStatus == SCENES_STATUS_MISSOTHERHERO then
            Log.d(TAG, "太热闹了..不管你")
            return
        elseif _scenesStatus == SCENES_STATUS_WAITREQUEST then
            Log.d(TAG, "请求回来了, 慢走不送")
            resetHeroStatus()
            heroExit(_enemyLayer)
        else
            Log.d(TAG, "走近瞧瞧")
            _scenesStatus = SCENES_STATUS_MISSOTHERHERO
            -- 随机延迟一会
            randomStart(function ( )
                -- 其他玩家入场
                enemyComing(_enemyLayer, ccp(-700, 0), 1.5, function ( )
                    -- 到跟前主角站住
                    heroStand(_role, function ( )
                        -- 抉择吧
                        _scenesStatus = SCENES_STATUS_WAITREQUEST
                        createPopOtherHeroDialog(_data.result)
                        -- 互相乱打
                        -- local rightAttack
                        -- local function leftAttack( hero )
                        --     heroAttack(hero, function ( )
                        --         rightAttack( _enemy )
                        --     end)
                        -- end
                        -- function rightAttack( hero )
                        --     heroAttack(hero, function ( )
                        --         leftAttack( _role )
                        --     end)
                        -- end
                        -- leftAttack( _role )
                    end)
                end)
            end)
        end
    end
    -- 执行发现神秘商人
    function runMysteryShop( )
        local function onCloseShop( )
            Log.d(TAG, "关闭了商店, 继续吧")
            resetHeroStatus()
            shopExit(_enemy)
        end
        _scenesStatus = SCENES_STATUS_FINDMYSTERYSHOP
        randomStart(
            function ( )
                -- 神秘商人入场
                enemyComing(_enemy, ccp(-700, 0), 1.5, function ( )
                    -- 到跟前主角站住
                    heroStand(_role, function ( )
                        -- 弹出商店
                        _scenesStatus = SCENES_STATUS_WAITREQUEST
                        -- createPopOtherHeroDialog(_data.result)
                        popShopView(ENEMY_TYPE_MYSTERYSHOP, onCloseShop)
                    end)
                end)
            end
        )
    end
    -- 执行发现旅行商人
    function runTravelShop( )
        local function onCloseShop( )
            Log.d(TAG, "关闭了商店, 继续吧")
            resetHeroStatus()
            shopExit(_enemy)
        end
        _scenesStatus = SCENES_STATUS_FINDMYSTERYSHOP
        randomStart(
            function ( )
                -- 神秘商人入场
                enemyComing(_enemy, ccp(-700, 0), 1.5, function ( )
                    -- 到跟前主角站住
                    heroStand(_role, function ( )
                        -- 弹出商店
                        _scenesStatus = SCENES_STATUS_WAITREQUEST
                        -- createPopOtherHeroDialog(_data.result)
                        popShopView(ENEMY_TYPE_TRAVELSHOP, onCloseShop)
                    end)
                end)
            end
        )
    end
    
    -- 创建英雄
    local function createPlayerView( )
        local layer = _parallaxNode:getMainLayer()
        local role = ME:createPlayerView( )
        layer:addChild(role, 2)
        role:setPosition(ccp(-180, 320))
        role:setScaleX(-0.6)
        role:setScaleY(0.6)
        return role
    end
    -- 创建宝箱
    local function createTreasureChest( )
        display.addSpriteFramesWithFile("map/explore/img_treasure_chest.plist", "map/explore/img_treasure_chest.png")
        local treasureChest = display.newSprite("#img_treasure_chest_1.png")
        _parallaxNode:getMainLayer():addChild(treasureChest, 1)
        treasureChest:setPosition(ccp(960 + treasureChest:getContentSize().width, 260))
        return treasureChest
    end
    -- 创建怪物
    local function createMonster( id )
        local CardMaster = require("cardui.CardMaster")
        local CardEntity = require("model.card.CardEntity")
        local cardEntity = CardEntity.new{id = id}
        cardEntity.type = CardMaster.MONSTERCARD
        local monster = CardMaster.new(cardEntity)
        _parallaxNode:getMainLayer():addChild(monster, 1)
        monster:setPosition(ccp(960 + monster:getContentSize().width, 210))
        return monster
    end
    -- 创建神秘商人
    local function createMysteryShop( )
        local mysteryShop = widget.newSprite{file = "shop/myster/img_bear.png"}
        _parallaxNode:getMainLayer():addChild(mysteryShop, 1)
        mysteryShop:setPosition(ccp(960 + mysteryShop:getContentSize().width * 2, 290))
        return mysteryShop
    end
    -- 创建神秘商人
    local function createTravelShop( )
        local mysteryShop = widget.newSprite{file = "shop/myster/img_car.png"}
        _parallaxNode:getMainLayer():addChild(mysteryShop, 1)
        mysteryShop:setPosition(ccp(960 + mysteryShop:getContentSize().width * 2 + 50, 300))
        return mysteryShop
    end
    -- 创建其他玩家
    local function createOtherHero( params )
        local name      = params.name or ""
        local lv        = params.lv or ""
        local sex       = params.sex or MALE
        local head      = params.head
        local otherPlayer = Player.new(sex, head, params.equiplst)
        otherPlayer:setScaleX(0.6)
        otherPlayer:setScaleY(0.6)
        otherPlayer:stand()
        if _enemyLayer then
            _enemyLayer:removeFromParentAndCleanup(true)
        end
        _enemyLayer = widget.newLayer{
            -- color = ccc4(255, 255, 200, 100),
            contentSize = CCSize(175, 202),--otherPlayer:getContentSize(),
        }
        _enemyLayer:setCascadeOpacityEnabled(true)
        _enemyLayer:addChild(otherPlayer)
        util.alignNode(otherPlayer, _enemyLayer:getContentSize(), display.BOTTOM_LEFT)
        _parallaxNode:getMainLayer():addChild(_enemyLayer, 1)
        _enemyLayer:setPosition(ccp(960 + _enemyLayer:getContentSize().width, 190))


        -- 名字
        local nameLabel = ui.newTTFLabel{
            text = _s("MAP_EXPLORE_LV_NAME", lv, name),
            size = 20,
            -- color = BUTTON_COLOR3.BROWN,
        }

        local infoLayer = widget.newLayer{contentSize = nameLabel:getContentSize()}
        infoLayer:addChild(nameLabel, 1)
        infoLayer:setCascadeOpacityEnabled(true)
        util.alignNode(nameLabel, infoLayer:getContentSize(), display.CENTER)

        -- 背景
        local bgSprite = widget.newScale9{file = "map/bg_star.png", contentSize = CCSizeAdd(nameLabel:getContentSize(), 12, 6),}
        infoLayer:addChild(bgSprite, 0)
        util.alignNodeWithPadding(bgSprite, infoLayer:getContentSize(), display.CENTER)

        _enemyLayer:addChild(infoLayer, 0, 100)
        util.alignNodeWithPadding(infoLayer, _enemyLayer:getContentSize(), display.TOP_CENTER, {top = -24, left = -16})

        function _enemyLayer.setFadeOut( )
            infoLayer:setVisible(false)
        end
        return otherPlayer
    end
    -- 更新探索数据
    local function updateExploreData( data )
        _data.progress = data.fin
        _data.result = data
        _data.pestscno = data.pestscno
        _data.pestString = data.pestString
        _node.updateSp()
        if data.pestscno ~= 0 then
            -- 怪物
            _enemy = createMonster( data.pestscno )
            runFightMonster()
        elseif data.res == ENEMY_TYPE_TREASURECHEST then
            -- 宝箱
            _enemy = createTreasureChest( )
            runFindTreasureChest( )
        elseif data.res == ENEMY_TYPE_MONSTER then
            -- 怪物
            _enemy = createMonster( data.mid )
            runFightMonster()
        elseif data.res == ENEMY_TYPE_PLAYER then
            -- 玩家
            _enemy = createOtherHero(_data.result)
            runMissOtherHero()
        elseif data.res == ENEMY_TYPE_MYSTERYSHOP then
            -- 神秘商人
            _enemy = createMysteryShop()
            runMysteryShop()
        elseif data.res == ENEMY_TYPE_TRAVELSHOP then
            -- 旅行商人
            _enemy = createTravelShop()
            runTravelShop()
        else
            heroStand(_role, function ( )
                NetHelper.QuickToast(_s("MAP_EXPLORING"))
                resetHeroStatus()
            end)            
        end
    end
	local function initViews( )
        _parallaxNode = createParallaxNode( )
        -- 角色
        _role = createPlayerView( )
        _role:setVisible(false)
        -- sp hp
        createExpAndSp( )
        -- 更新玩家信息
        updatePlayerInfo( )

        util.delayCall(function ( )
            heroComing(_role, function ( )
                _scenesStatus = SCENES_STATUS_STAND
                if _node._DATA._EXPLORE then
                    runExplore(true)
                else
                    _role:stand()
                end
            end)
        end, 0.2)
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
    _node.updatePlayerInfo   = updatePlayerInfo
    _node.updateExploreData   = updateExploreData
    _node.updatePraiseResult   = updatePraiseResult
    _node.updateRobberyResult   = updateRobberyResult
    _node.runExplore    = runExplore
    _node.updateSp    = updateSp

end

return M