--MapMiningLayer.lua
local M = {}
local GoodsEntity = require("model.goods.GoodsEntity")
function M.bindView(node, luaValue)
	local TAG = "[MapMiningLayerView]"
	local _node, _nodeTable = node, luaValue
    local _parallaxNode, _role, _roleLayer, _mineLayer
    local TAG_ROLE_LAYEY = 1
    local ROLE_SCALE = 0.8
    local DIRECTION_LEFT = 1
    local DIRECTION_RIGHT = -1
    local _isWalk = false
    local _reward = {}

    local _scenesStatus = 0
    local SCENES_STATUS_COMMING = 0
    local SCENES_STATUS_STAND = 1
    local SCENES_STATUS_SCOOP = 2
    local SCENES_STATUS_WAITING = 3
    local SCENES_STATUS_RESPONSE = 4
    local SCENES_STATUS_FINISH = 5

    local _btnMineTable = {
        {img = "map/mining/btn_mining_copper.png", position = ccp(480, 470), cdTime = 0, count = 9999},
        {img = "map/mining/btn_mining_silver.png", position = ccp(960, 470), cdTime = 0, count = 9999},
        {img = "map/mining/btn_mining_gold.png", position = ccp(1440, 470), cdTime = 0, count = 9999},
    }
    local onMiningResponse, updateMineData
    local mineExit
--[[ ## local fuction --]]
    local function playMiningSound( )
        SOUND:playMining()
    end
    local function playDropDownSound( )
        SOUND:playBlackSmith()
    end
    local function showRewardAlert( )
        local rewardEntity = require("model.main.RewardEntity").new(_reward)
        CCBCenter.loadCCB(
            "MSG_RECEIVEREWARDALERTLAYER_MODEL", 
            "ccb.c.main.ReceiveRewardAlertLayer", 
            {
                entity = rewardEntity,
                onConfirm = function ( )
                    -- 刷新矿山
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGLIST)
                end
            }
        )
    end
    -- 是否边缘
    local function isParallaxLeftEdge( )
        return _parallaxNode:getPositionX() >= 0
    end
    local function isParallaxRightEdge( )
        return _parallaxNode:getPositionX() <= -_parallaxNode:getContentSize().width 
    end
    function mineExit( )
        transition.fadeOut(_mineLayer, {time = 0.5, onComplete = function ( )
            Log.d(TAG, "山消失")
            _scenesStatus = SCENES_STATUS_FINISH
            _mineLayer:removeFromParentAndCleanup(true)
            _mineLayer = nil
        end})
    end
    -- 矿石丢出来
    local function createMinesRewardComming( )
        if not _mineLayer then
            return
        end
        _role:stand()
        local mineFiles = {}
        if _reward.gold > 0 then
            mineFiles[#mineFiles + 1] = "reward/icon/icon_gold.png"
        end
        if _reward.diamond > 0 then
            mineFiles[#mineFiles + 1] = "reward/icon/icon_diamond.png"
        end
        if _reward.star > 0 then
            mineFiles[#mineFiles + 1] = "reward/icon/icon_star.png"
        end
        for i, v in ipairs(_reward.brlist) do
            if v.no > 10000 then
                local goodsEntity = GoodsEntity.new{no = v.no}
                mineFiles[#mineFiles + 1] = goodsEntity:getGoodsIcon()
            end
        end

        local count = #mineFiles
        local times = 0
        local goodsSpriteTable = {}
        local delayTime = 0
        local function finishMines( )
            for i, v in ipairs(goodsSpriteTable) do
                transition.fadeOut(v, 
                    {
                        time = 0.5, 
                        onComplete = function ( )
                            SOUND:playGold()
                            v:removeFromParentAndCleanup(true)
                            if i == count then
                                showRewardAlert( )
                                mineExit( )
                            end
                        end
                    }
                )
            end
        end
        -- 抛物线
        local function playBezierAnim_( goodsSprite )
            local direction = _role:getScaleX() > 0 and -1 or 1
            -- local bezie = ccBezierConfig()
            local bezie = _GAME.BEZIER 
            if not bezie then
                _GAME.BEZIER = ccBezierConfig()
                bezie = _GAME.BEZIER
            end
            local offx = 200 * delayTime
            local offY = 200 * delayTime
            if -1 == direction then
                bezie.controlPoint_1 = ccp(_mineLayer:getContentSize().width / 2, goodsSprite:getContentSize().height / 2 + 10)
                bezie.controlPoint_2 = ccp(- offx, _mineLayer:getContentSize().height * 2 + offY)
                bezie.endPosition = ccp( -20 - offx, goodsSprite:getContentSize().height / 2 - 10)
            else
                bezie.controlPoint_1 = ccp(_mineLayer:getContentSize().width / 2, goodsSprite:getContentSize().height / 2)
                bezie.controlPoint_2 = ccp(_mineLayer:getContentSize().width * 0.75 + offx, _mineLayer:getContentSize().height * 2 + offY)
                bezie.endPosition = ccp(_mineLayer:getContentSize().width + 20 + offx, goodsSprite:getContentSize().height / 2 - 10)
            end

            local array     = {}
            delayTime = delayTime + 0.2
            array[#array + 1] = CCDelayTime:create(delayTime)
            array[#array + 1] = CCBezierTo:create(1, bezie)
            array[#array + 1] = CCMoveBy:create(0.1, ccp(4 * direction, 10))
            array[#array + 1] = CCCallFunc:create(function( )
                playDropDownSound()
            end)
            array[#array + 1] = CCMoveBy:create(0.1, ccp(2 * direction, -10))
            transition.execute(
                goodsSprite, 
                transition.sequence(array), 
                {
                    easing = "CCEaseOut", 
                    onComplete = function ()
                        Log.d(TAG, "掉出来了")
                        -- bezie:delete()
                        times = times + 1
                        if times >= count then
                            finishMines()
                        end
                    end 
                }
            )
        end

        for i, v in ipairs(mineFiles) do
            goodsSpriteTable[i] = widget.newSprite{file = v}
            _mineLayer:addChild(goodsSpriteTable[i], 0)
            goodsSpriteTable[i]:setPosition(_mineLayer:getContentSize().width/2, goodsSpriteTable[i]:getContentSize().height/2 + 10)
            playBezierAnim_( goodsSpriteTable[i] )
        end
        
    end
    local function heroMining( callback )
        _role:stopAllActions()
        _role:scoop(nil, {times = 2, singleCallback = playMiningSound})
        _mineLayer.progress:runProgressTo(3, 0, false, function ( )
            Log.d(TAG, "采完了. 请求去")
            if callback then
                callback()
            end
        end)
    end
    -- 移动人物位置
    local function heroMoveBy( distance, onComplete )
        local posX = _role:getPositionX()
        local function heroWalk( )
            if _isWalk then
                return
            end
            _isWalk = true
            _role:walk()
        end
        local function heroStand( )
            _isWalk = false
            _role:stand()
            if onComplete then
                onComplete()
            end
        end
        
        -- 滚动背景
        local function moveParallaxTo( distanceX, complete )
            _parallaxNode:stopAllActions()
            local direction = distanceX > 0 and DIRECTION_LEFT or DIRECTION_RIGHT
            local time
            -- 是否在边界了
            if (direction == DIRECTION_LEFT and isParallaxLeftEdge( )) or (direction == DIRECTION_RIGHT and isParallaxRightEdge( )) then
                if complete then
                    complete()
                end
                return
            end
            -- 剩余距离
            local overPosi = 0
            if direction == DIRECTION_LEFT then
                overPosi =  math.abs(_parallaxNode:getPositionX())
            elseif direction == DIRECTION_RIGHT then
                overPosi = _parallaxNode:getContentSize().width - math.abs(_parallaxNode:getPositionX())
            end
            if math.abs(distanceX) > overPosi then
                distanceX = overPosi * direction
            end
            
            local time = math.abs(distanceX) / _parallaxNode:getContentSize().width * 4
            transition.moveBy(
                _parallaxNode, 
                {
                    time = time, 
                    x = distanceX, 
                    y = 0, 
                    onComplete = complete,
                }
            )
        end
        -- 移动英雄
        local function moveHeroTo( distanceX, complete )
            _role:stopAllActions()
            if posX + distanceX  >= 960 then
                distanceX = 960 - posX 
            elseif posX + distanceX  < 0 then
                distanceX = -(posX )
            end
            local time = math.abs(distanceX) / _parallaxNode:getContentSize().width * 4
            transition.moveBy(
                _role, 
                {
                    time = time, 
                    x = distanceX, 
                    y = 0, 
                    onComplete = complete,
                }
            )
        end

        -- 距离为负数往右走
        if distance < 0 then
            Log.d(TAG, "往右走")
            -- _role:flipX()
            _role:setScaleX(-ROLE_SCALE)
            -- 如果已经在场景的边界.. 人物动
            if isParallaxRightEdge( ) then
                heroWalk( )
                moveParallaxTo(-960)
                moveHeroTo(-distance, heroStand)
            else
                heroWalk( )
                local overPosi = _parallaxNode:getContentSize().width - math.abs(_parallaxNode:getPositionX())
                local bgMove = distance
                local heroMove = -distance
                -- 滚动超出边界了...到边界停下, 人在继续走
                if math.abs(distance) > overPosi then
                    bgMove = - overPosi 
                    heroMove = math.abs(distance) - overPosi
                    moveParallaxTo(bgMove, function ( )
                        moveHeroTo(heroMove, heroStand)
                    end)
                else
                    -- 人还没到中间呢, 先走到中间, 在开始动
                    if posX < 480 then
                        if posX + math.abs(distance) < 480 then
                            moveHeroTo(heroMove, heroStand)
                        else
                            heroWalk( )
                            moveHeroTo(480 - posX, function ( )
                                moveParallaxTo(bgMove + 480 - posX, heroStand)
                            end)
                        end
                    else
                        moveParallaxTo(bgMove, heroStand)
                    end
                    
                end
            end
        elseif distance > 0 then 
            Log.d(TAG, "往左走")
            _role:setScaleX(ROLE_SCALE)
            if isParallaxLeftEdge() then
                heroWalk( )
                moveParallaxTo(960)
                moveHeroTo(-distance, heroStand)
            else
                heroWalk( )
                local overPosi = math.abs(_parallaxNode:getPositionX())
                local bgMove = distance
                local heroMove = - distance
                -- 滚动超出边界了...到边界停下, 人在继续走
                if math.abs(distance) > overPosi then
                    bgMove = overPosi
                    heroMove = - (math.abs(distance) - overPosi)
                    moveParallaxTo(bgMove, function ( )
                        moveHeroTo(heroMove, heroStand)
                    end)
                else
                    -- 人还没到边界呢, 先走到边界, 在开始动
                    if posX > 480 then
                        if posX - math.abs(distance) > 480 then
                            moveHeroTo(heroMove, heroStand)
                        else
                            heroWalk( )
                            moveHeroTo(480 - posX, function ( )
                                moveParallaxTo(bgMove + 480 - posX, heroStand)
                            end)
                        end
                    else
                        moveParallaxTo(bgMove, heroStand)
                    end
                end
            end
        end
    end
    -- 走到矿位置
    local function heroToMine( onComplete )
        if not _mineLayer then
            return
        end
        local function onMoveComplete( flipX )
            _role:setScaleX(flipX * ROLE_SCALE)
            if onComplete then
                onComplete()
            end
        end
        -- 取得当前屏幕位置
        local parallaxPosX = _parallaxNode:getPositionX()
        -- 取得矿石位置
        local minePosX = _mineLayer:getPositionX()
        -- 与矿石保持距离
        local offsetWidth = _mineLayer:getContentSize().width/2
        -- 取得英雄位置
        local heroPosX = _role:getPositionX() + math.abs(parallaxPosX)
        -- 
        if minePosX >= heroPosX then
            if offsetWidth - math.abs(heroPosX - minePosX) == 0 then
                onMoveComplete(DIRECTION_RIGHT)
            else
                heroMoveBy( offsetWidth - math.abs(heroPosX - minePosX), function ( )
                    onMoveComplete(DIRECTION_RIGHT)
                end)
            end
        else
            if heroPosX - minePosX - offsetWidth == 0 then
                onMoveComplete(DIRECTION_LEFT)
            else
                heroMoveBy( heroPosX - minePosX - offsetWidth, function ( )
                    onMoveComplete(DIRECTION_LEFT)
                end)
            end
        end
    end
    -- 创建视差容器
    local function createParallNode( )
        local layer = CCBCenter.getNodeByTag(_node, 1)
        local parallaxNode = CCParallaxNode:create()
        parallaxNode:setContentSize(layer:getContentSize())
        layer:addChild(parallaxNode)
        return parallaxNode
    end
    -- 创建点击位置获取
    local function createPositionTouch( )
        local function onClick( layer, x, y )
            if not _role then
                return
            end
            local position = layer:convertToNodeSpace(ccp(x, y))
            local posX = _role:getPositionX()
            local distance = posX - position.x
            
            -- 限制点身上
            -- if math.abs(distance) > widthHalved/2 then
                if SCENES_STATUS_STAND == _scenesStatus then
                    heroMoveBy(distance)
                end
            -- end
        end
        -- 绑定点击
        local touchLayer = CCBCenter.getNodeByTag(_node, 2, "CCLayer")
        widget.bindTouchEvent{
            layer = touchLayer,
            clickListener = onClick,
        }
    end
    -- 创建英雄
    local function createHero( )
        local role = ME:createPlayerView( )
        role:dressScoop()
        role:setPosition(ccp(200, 280))
        role:setScaleX(-ROLE_SCALE)
        role:setScaleY(ROLE_SCALE)
        _roleLayer:addChild(role, 2)
        role:stand()
        return role
    end
    -- 创建矿山进场
    local function createMineComming( index, onComplete )
        -- 屏幕震动
        local function nodeShake( )
            SOUND:playEffectFightReward()
            local posX, posY = _node:getPosition()
            _node:setPosition(ccp(posX, posY + 10))
            transition.moveTo(_node, {time = 0.1, x = posX, y = posY, easing = "CCEaseElasticInOut", onComplete = onComplete})
        end
        -- 山
        local mineSprite = widget.newSprite{file = "map/mining/img_mine.png", x = 115, y = 640, anchorPoint = ccp(0.5, 0)}
        local mineLayer = widget.newLayer{contentSize = mineSprite:getContentSize(), anchorPoint = ccp(0.5, 0.5), ignoreAnchor = false}
        mineLayer:setCascadeOpacityEnabled(true)
        mineLayer:addChild(mineSprite, 1, 1)
        -- 影子
        local mineShadow = widget.newSprite{file = "map/mining/img_mine_shadow.png", x = 112.5, y = 16}
        mineShadow:setScale(0)
        mineLayer:addChild(mineShadow, 0, 2)
        -- 进度条
        local progress = widget.newProgressBar{
            frontSprintParams = {file = "map/mining/progressBar_mine_img.png",},
            bgSprintParams = {file = "map/mining/progressBar_mine_bg.png"},
            percentageLabelString = "",
            percentage = 100,
        }
        progress:setVisible(false)
        mineLayer:addChild(progress, 2, 3)
        util.alignNode(progress, mineLayer, display.TOP_CENTER)
        mineLayer.progress = progress
        -- 入场动画
        transition.moveTo(mineSprite, {
            time = 0.3, y = 0, onComplete = function ( )
                progress:setVisible(true)
                nodeShake()
            end}
        )
        transition.scaleTo(mineShadow, {time = 0.3, scale = 1})
        return mineLayer
    end
    
    -- 创建挖矿按钮
    local function createMineButtons( layer )
        -- 采矿点击
        local function onBtnMineClick( digId )
            if SCENES_STATUS_STAND ~= _scenesStatus then
                return
            end

            HelperView2.showNext()
            _scenesStatus = SCENES_STATUS_SCOOP
            if _mineLayer then
                _mineLayer:removeFromParentAndCleanup(true)
                _mineLayer = nil
            end
            local function onMineComing( )
                heroToMine(function ( )
                    heroMining(function ( )
                        if _scenesStatus == SCENES_STATUS_RESPONSE then
                            createMinesRewardComming()
                        else
                            _scenesStatus = SCENES_STATUS_WAITING
                            _role:scoop(function ( )
                                _role:stand()
                            end, {times = 30, singleCallback = playMiningSound })
                        end
                    end)
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGREWARD, nil, {digid = digId})
                end)
            end
            _mineLayer = createMineComming(digId, onMineComing)
            layer:addChild(_mineLayer, 1) 
            _mineLayer:setPosition(ccp(_btnMineTable[digId].position.x, 230))
        end
        -- 创建剩余次数
        local function createCount_( btnMineConfig )
            -- local cdBg = widget.newSprite{file = "map/mining/bg_mining_cd.png"}
            
            local countLabel = ui.newTTFLabel{ 
                text = string.format(_s("MINE_UNLOCK"), btnMineConfig.count),
            }
            local cdBg = widget.newScale9{ file = "map/mining/bg_mining_cd.png", contentSize = CCSizeAdd(countLabel:getContentSize(), 20, 4), rect = CCRect(0, 0, 127, 30),}
            local node = widget.newNode{contentSize = cdBg:getContentSize(), x = btnMineConfig.position.x, y = btnMineConfig.position.y - 70, anchorPoint = ccp(0.5, 0.5)}
            util.alignNode(cdBg, node)
            node:addChild(cdBg, 0)

            util.alignNode(countLabel, node, display.CENTER, {top = 2})
            node:addChild(countLabel, 1)
            layer:addChild(node, 1)
            function countLabel:setCount( count, visible )
                self:setString(string.format(_s("MINE_UNLOCK"), count))
                node:setVisible(visible)
            end
            return countLabel
        end
        -- 创建cd时间
        local function createCdTime_( btnMineConfig )
            local cdBg = widget.newScale9{file = "map/mining/bg_mining_cd.png", contentSize = CCSize(156, 32),}
            local node = widget.newNode{contentSize = CCSize(156, 32), x = btnMineConfig.position.x, y = btnMineConfig.position.y - 70, anchorPoint = ccp(0.5, 0.5)}
            util.alignNode(cdBg, node)
            node:addChild(cdBg, 0)
            local cdTimer
            cdTimer = CountDownView.new{ 
                format = _s("MINE_FREE"),
                labelParams = {size = 24, },
                listener = function()
                    cdTimer:stop()
                    -- if _scenesStatus == SCENES_STATUS_STAND then
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHDIGLIST)
                    -- end
                end
            }
            util.alignNode(cdTimer, node, display.CENTER, {top = 2})
            node:addChild(cdTimer, 1)
            layer:addChild(node, 1)
            return cdTimer
        end
        local function doMining( button )
            if SCENES_STATUS_STAND ~= _scenesStatus then
                return
            end
            if _btnMineTable[button:getTag()].cd > 0 then
                AlertLayer.new4IAP{
                    isUserDiamond = true,
                    diamondIndex = 2,
                    content = _s("MINE_COST_DIAMOND", _btnMineTable[button:getTag()].diamond),   -- 内容
                    btnClickEvent = {
                        function()                      -- 按钮[确定]回调
                            -- onBtnMineClick(button)
                            --CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHBUYDIGSKIP, nil, {digid = button:getTag()})
                            if ME:getDiamond() >= _btnMineTable[button:getTag()].diamond then
                                -- CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPMININGLAYER_ACTION_ONFETCHBUYDIGSKIP, nil, {digid = button:getTag()})
                                onBtnMineClick(button:getTag())
                            else
                                NetHelper.QuickToast(_s("MINE_DIAMOND_NOT_ENOUGH"))
                            end
                        end,
                    }
                  }
            else
                local doAntiPlug = math.random(TRUE, 6)
                if doAntiPlug == TRUE and not HelperView2.isNextIndexIn(150050, 150060) then
                    CCBCenter.loadCCB("MSG_ANTIPLUGALERTLAYER_MODEL", "ccb.c.common.AntiPlugAlertLayer", {onComplete = function ( )
                        onBtnMineClick(button:getTag())
                    end })
                else
                    onBtnMineClick(button:getTag())
                end
            end
        end
        local function createButton_( btnMineConfig, tag )
            local button = widget.newButton{
                normalImage = btnMineConfig.img,
                scale = 1.1,
                listener = doMining,
                x = btnMineConfig.position.x,
                y = btnMineConfig.position.y,
            }
            
            layer:addChild(button, 1, tag)
            button:setCascadeColorEnabled(true)

            local diamondNode = widget.newNode{
                contentSize = CCSize(46, 46),
                x = btnMineConfig.position.x + 18,
                y = btnMineConfig.position.y - 52,
            }
            local diamondSprite = widget.newSprite{
                file = "map/mining/img_diamond.png",
            }
            diamondNode:addChild(diamondSprite, 0)
            util.alignNode(diamondSprite, diamondNode)
            local diamondTTFNode = widget.newNode{
                contentSize = CCSize(32, 21),
            }
            diamondNode:addChild(diamondTTFNode, 2)
            util.alignNode(diamondTTFNode, diamondNode, display.BOTTOM_RIGHT, {right = -6, bottom = -2})
            local diamondBg = widget.newScale9{
                file = "map/mining/bg_diamond.png",
                contentSize = CCSize(32, 21),
            }
            diamondTTFNode:addChild(diamondBg, 0)
            util.alignNode(diamondBg, diamondTTFNode)
            local diamondTTFlabel = ui.newTTFLabel{
                text = "",
                size = 16,
            }
            diamondTTFNode:addChild(diamondTTFlabel, 1)
            util.alignNode(diamondTTFlabel, diamondTTFNode, display.CENTER, {top = 2})
            layer:addChild(diamondNode, 2, 100 + tag)
            diamondNode:setVisible(false)
            function button:setClickEnable( enable )
                if enable then
                    button.setStateDisabled(false)
                    button:setColor(ccc3(255, 255, 255))
                else
                    button.setStateDisabled(true)
                    button:setColor(ccc3(100, 100, 100))
                end
            end
            function button:doMining( id )
                onBtnMineClick(button:getTag())
            end
            function button:setDiamond( diamond )
                diamondTTFlabel:setString(diamond)
            end
            function button:setDiamondVisible( visible )
                diamondNode:setVisible(visible)
            end
            button:setClickEnable(false)
            return button
        end
        for i, v in ipairs(_btnMineTable) do
            v.button = createButton_(v, i)
            v.cdTimer = createCdTime_(v)
            v.countLayer = createCount_(v)
        end
    end
    -- 背景层
    local function createBgLevelNode( )
        -- 背景(不动的)
        local vistaSprite = widget.newSprite{file = "map/mining/bg_mining_1.png"}
        local vistaLayer = widget.newLayer{contentSize = _parallaxNode:getContentSize()}
        vistaLayer:addChild(vistaSprite)
        util.alignNode(vistaSprite, vistaLayer, display.TOP_CENTER)
        _parallaxNode:addChild(vistaLayer, 0, CCPointZero, CCPointZero)
        -- 背景(光)
        local lightSprite = widget.newSprite{file = "map/mining/img_mining_light.png"}
        local lightLayer = widget.newLayer{contentSize = _parallaxNode:getContentSize()}
        lightLayer:addChild(lightSprite)
        util.alignNode(lightSprite, lightLayer, display.TOP_CENTER)
        _parallaxNode:addChild(lightLayer, 0, ccp(0.1, 0.1), CCPointZero)
        -- 背景(山)
        local mountainSprite
        local mountainLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        for i = 1, 2 do
            mountainSprite = widget.newSprite{file = "map/mining/bg_mining_2.png", ignoreAnchor = true}
            mountainLayer:addChild(mountainSprite, 0)
            mountainSprite:setPosition(0 + (i - 1) * mountainSprite:getContentSize().width, 0)
        end
        _parallaxNode:addChild(mountainLayer, 1, ccp(0.5, 0.5), ccp(0, 268))
        -- 背景(地板)
        local floorSprite
        local floorLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        for i = 1, 2 do
            floorSprite = widget.newSprite{file = "map/mining/bg_mining_floor.png", ignoreAnchor = true}
            floorLayer:addChild(floorSprite, 0)
            floorSprite:setPosition(0 + (i - 1) * floorSprite:getContentSize().width, 0)
        end
        _parallaxNode:addChild(floorLayer, 1, ccp(1, 1), CCPointZero)
        -- 背景(矿石)
        local mineLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        local mineSpriteTable = {}
        for i = 1, 7 do
            mineSpriteTable[i] = widget.newSprite{file = string.format("map/mining/img_mine_%d.png", i), ignoreAnchor = true}
            mineLayer:addChild(mineSpriteTable[i], 0)
            if i == 1 then
                mineSpriteTable[i]:setPosition(0, 0)
            else
                mineSpriteTable[i]:setPosition(mineSpriteTable[i - 1]:getPositionX() + mineSpriteTable[i - 1]:getContentSize().width, 0)
            end
            
        end
        _parallaxNode:addChild(mineLayer, 2, ccp(1, 1), ccp(0, 232))
        -- 背景(小物件)
        local furnishedLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        -- 支架柱子
        local postSprite = widget.newSprite{file = "map/mining/img_mining_post.png", ignoreAnchor = true}
        furnishedLayer:addChild(postSprite)
        postSprite:setPosition(ccp(330, 210))
        -- 推车
        local postSprite = widget.newSprite{file = "map/mining/img_mining_cart.png", ignoreAnchor = true}
        furnishedLayer:addChild(postSprite)
        postSprite:setPosition(ccp(590, 190))
        -- 石头
        local rock1Sprite = widget.newSprite{file = "map/mining/img_mining_rock1.png", ignoreAnchor = true}
        furnishedLayer:addChild(rock1Sprite)
        rock1Sprite:setPosition(ccp(720, 170))
        local rock2Sprite = widget.newSprite{file = "map/mining/img_mining_rock2.png", ignoreAnchor = true}
        furnishedLayer:addChild(rock2Sprite)
        rock2Sprite:setPosition(ccp(1620, 80))
        -- 箱子
        local boxSprite = widget.newSprite{file = "map/mining/img_mining_box.png", ignoreAnchor = true}
        furnishedLayer:addChild(boxSprite)
        boxSprite:setPosition(ccp(1380, 210))
        _parallaxNode:addChild(furnishedLayer, 2, ccp(1, 1), CCPointZero)
        -- 背景(顶部石头)
        local topRockLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        local topRockPoiTable = {
            {poiX = 0,}, 
            {poiX = 230,}, 
            {poiX = 370,}, 
            {poiX = 580,}, 
            {poiX = 730,}, 
            {poiX = 940,}, 
            {poiX = 1080,}, 
            {poiX = 1260,}, 
            {poiX = 1410,}, 
            {poiX = 1580,}, 
            {poiX = topRockLayer:getContentSize().width - 210,}, 
        }
        for i = 1, 11 do
            topRockPoiTable[i].sprite = widget.newSprite{file = string.format("map/mining/img_mining_top_rock%d.png", i)}
            topRockPoiTable[i].sprite:setAnchorPoint(ccp(0, 1))
            topRockPoiTable[i].sprite:setPosition(topRockPoiTable[i].poiX, topRockLayer:getContentSize().height)
            topRockLayer:addChild(topRockPoiTable[i].sprite)
        end
        _parallaxNode:addChild(topRockLayer, 2, ccp(1, 1), CCPointZero)
        -- 按钮
        local buttonLayer = widget.newLayer{contentSize = CCSizeMul(_parallaxNode:getContentSize(), 2, 1)}
        createMineButtons(buttonLayer)
        _parallaxNode:addChild(buttonLayer, 3, ccp(1, 1), CCPointZero)
        -- 人物层
        _roleLayer = widget.newLayer{contentSize = _parallaxNode:getContentSize()}
        _parallaxNode:addChild(_roleLayer, 4, CCPointZero, CCPointZero)
        
        -- 前景(石头)
        local closeRockLayer = widget.newLayer{contentSize = _parallaxNode:getContentSize()}
        local closeRockPoiTable = {
            {poiX = 200,}, 
            {poiX = 600,}, 
            {poiX = 1000,}, 
            {poiX = 1200,}, 
            {poiX = 1400,}, 
            {poiX = 1800,}, 
            {poiX = 2280,}, 
            {poiX = 2600,}, 
            {poiX = 2850,},
        }
        for i = 1, 9 do
            closeRockPoiTable[i].sprite = widget.newSprite{file = string.format("map/mining/img_mining_closerock%d.png", i), ignoreAnchor = true}
            closeRockPoiTable[i].sprite:setPosition(closeRockPoiTable[i].poiX, 0)
            closeRockLayer:addChild(closeRockPoiTable[i].sprite)
        end
        _parallaxNode:addChild(closeRockLayer, 5, ccp(2, 2), CCPointZero)
    end
    local function heroComing( hero, callback )
        hero:stopAllActions()
        hero:runAction(transition.sequence{
            CCCallFunc:create(function ()
                hero:jump(function ( )
                    hero:stand()
                    _scenesStatus = SCENES_STATUS_STAND
                end)
                hero:setVisible(true)
            end),
            }
        )
    end
    -- 运动动画
    local function playParallMoveAnim( )
        local posX = 0
        if _parallaxNode:getPositionX() >= 0 then
            posX = -_parallaxNode:getContentSize().width
        end
        transition.moveTo(
            _parallaxNode, 
            {
                time = 5, 
                x = posX, 
                y = 0, 
                onComplete = function ( )
                    playParallMoveAnim()
                end
            }
        )
    end
    -- 新手引导
    function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {150050, 150060})
    end
	local function initViews()
        checkHelperInfo( )
		_parallaxNode = createParallNode()
        createPositionTouch( )
        createBgLevelNode( )
        _role = createHero( )
        _role:setVisible(false)
        util.delayCall(function ( )
            heroComing(_role)
        end, 0.2)
        -- updateMineData()
	end

--[[ ## public fuction --]]
    local function starMineClick( digId )
        _btnMineTable[digId].button:doMining(digId)
    end
    -- 挖矿奖励返回
    function onMiningResponse( reward )
        -- reward = {
        --     diamond = 100,
        --     gold = 1000,
        --     star = 1000,
        --     brlist = {{no = 10074, count = 1}, {no = 10077, count = 1}, {no = 10078, count = 1}, {no = 10076, count = 1}},
        -- }
        _reward = reward
        if _scenesStatus == SCENES_STATUS_WAITING then
            createMinesRewardComming()
        else
            _scenesStatus = SCENES_STATUS_RESPONSE
        end
    end
    -- 更新矿山状态
    function updateMineData( data )
        -- data = {
        --     skill = 500,
        --     cd1 = 200,
        --     cd2 = 200,
        --     cd3 = 3000,
        --     k1count = 0,
        --     k2count = 200,
        --     k3count = 1000,
        --     diamond1 = 100,
        --     diamond2 = 100,
        --     diamond3 = 100,
        -- }
        -- data.diamond1 = 100
        -- data.diamond2 = 200
        -- data.diamond3 = 300
        if _scenesStatus == SCENES_STATUS_FINISH then
            _scenesStatus = SCENES_STATUS_STAND
        end
        _nodeTable["mProgressLabel"]:setString(_s("MINE_SKILL", data.skill))
        for i, v in ipairs(_btnMineTable) do
            v.cd = data["cd" .. i]
            v.count = data["k".. i .."count"]
            v.unlock = data.skill >= v.count
            v.diamond = data["diamond" .. i]
            -- v.button:setClickEnable(v.unlock and v.cd <= 0)
            v.button:setClickEnable(v.unlock)
            v.button:setDiamondVisible(v.unlock and v.cd > 0)
            v.button:setDiamond(v.diamond)
            v.countLayer:setCount(v.count, not v.unlock)
            if v.cd > 0 then
                v.cdTimer:setFormat(_s("MINE_TIME_FOR_FREE"))
                v.cdTimer:start(v.cd)
            else
                v.cdTimer:setFormat(_s("MINE_FREE"))
                v.cdTimer:start(v.cd)
                v.cdTimer:stop()
            end
        end
    end
    -- 是否运行退出
    local function isAllowExit( )
        if _scenesStatus ~= SCENES_STATUS_STAND then
            NetHelper.QuickToast(_s("MINE_MINING"))
            return false
        end
        return true
    end
--[[ ## MAINs --]]
	initViews()
    _node.isAllowExit   =   isAllowExit
    _node.updateMineData   =   updateMineData
    _node.starMineClick   =   starMineClick
    _node.onMiningResponse   =   onMiningResponse
end

return M