--MapPopupDifficultyLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MapPopupDifficultyLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = node._DATA
--[[ ## local fuction --]]


	local function initViews()
    	-- [常量]
        local S                         = SCALE_FOR_SPECIAL_NODE
    	local A_POPUP_SHOW_T 			= .2
        local Z_HELPLAYER               = 11000
        local A_PROGRESS_T              = .5
        





    	-- [操作变量]
        -- [DAO]
        local LevelDao                  = require("db.leveldb")
        -- [工具]
        local TDArrayUtils              = require(PH_MDL_UTIL .. "TDArrayUtils")
        local TDUIUtils                 = require(PH_MDL_UTIL .. "TDUIUtils")
        -- [数据]
        local _po           			= _data.po
        -- [辅助变量]
        local _progressBarSp            = nil
        -- [快捷调用]
        local N           				= _nodeTable





    	-- [方法声明]
        -- [实体渲染]
    	local entityRender
    	local loadData
        local loadDataDifficulty
    	local loadNode
        local loadNodeSp
        local loadNodeButton
    	local loadRenderOtherwise
        local highlightButton
        local animateShow
        -- [辅助方法]
        -- ..

        -- [工具]
        local NODE
        -- [外部调用]
        local rerender

        -- [新手帮助]
    	




    	-- [方法定义]
    	-- 实体渲染
    	function entityRender()
            -- 加载数据
            loadData()
            -- 加载结点
            loadNode()

			-- 加载渲染以外的其他操作
    		loadRenderOtherwise()
    	end

    	-- 加载数据
        function loadData()
            -- 加载数据[难度]
            loadDataDifficulty()
        end

        -- 加载数据[难度]
        function loadDataDifficulty()
            local star = _po.star

            local difficulty
            if star == 0 then 
                difficulty = DIFFICULTY_SIMPLE
            elseif star == 1 then 
                difficulty = DIFFICULTY_ORDINARY
            elseif star == 2 then 
                difficulty = DIFFICULTY_DIFFICULT
            elseif star == 3 then 
                difficulty = DIFFICULTY_DIFFICULT
            end

            _po.difficulty = difficulty
        end

    	-- 加载结点
        function loadNode()
        	-- 标题
            N["lblTitle"]:setString(string.format("%d-%d %s", _po.levelid, _po.sublevelid, _po.subname))
        	-- 战斗消耗点
            N["lblCostPoint"]:setString(tostring(math.ceil(_po.sp / GAMERATE:getSpRate())))
            -- 体力
            N["lblSpValue"]:setString(string.format("%d/%d", ME:getCursp(), ME:getActlimit()))
            -- 加载SP
            loadNodeSp()

            -- 按钮
            loadNodeButton()
        end

        -- 加载SP
        function loadNodeSp()
            local sprite = widget.newProgressBar({
                frontSprintsParams  = {{file = "map/popup2/difficulty/m_p2d_line0.png",}, {file = "map/popup2/difficulty/m_p2d_line1.png",}},
                bgSprintParams      = {file = "map/popup2/difficulty/m_p2d_linebg.png"},
                percentage          = 0,
                ttfLabelParams      = {size = 16 / SCALE_FOR_SPECIAL_NODE, padding = {top = 0, left = 0},},
            })
            sprite:ignoreAnchorPointForPosition(true)
            util.alignNode(sprite, N["lyrSpLine"]:getContentSize(), display.CENTER)
            N["lyrSpLine"]:addChild(sprite)

            -- 记录变量
            _progressBarSp = sprite
            -- 刷新Sp值
            refleshSp()
        end

    	-- 加载结点[按钮]
        function loadNodeButton()
            local star = _po.star

            local v1, v2, v3
            local v1Lock, v2Lock, v3Lock
            if star == 1 then 
                v1     = false
                v1Lock = true
                v2     = true
                v2Lock = false
                v3     = false
                v3Lock = true
        	elseif star == 2 then 
                v1     = false
                v1Lock = true
                v2     = false
                v2Lock = true
                v3     = true
                v3Lock = false
    		elseif star == 3 then 
                v1     = false
                v1Lock = true
                v2     = false
                v2Lock = true
                v3     = true
                v3Lock = false
    		else
                v1     = true
                v1Lock = false
                v2     = false
                v2Lock = true
                v3     = false
                v3Lock = true
    		end

    		NODE(10301):setVisible(v1Lock) 			-- N["btnDNormalLock"]
    		NODE(10302):setVisible(v2Lock) 			-- N["btnDOrdinaryLock"]
    		NODE(10303):setVisible(v3Lock) 			-- N["btnDDifficultLock"]
    		NODE(10304):setVisible(v1) 				-- N["btnDNormal"]
    		NODE(10305):setVisible(v2) 				-- N["btnDOrdinary"]
    		NODE(10306):setVisible(v3) 				-- N["btnDDifficult"]
        end

		-- 加载渲染以外的其他操作
	    function loadRenderOtherwise()
            -- 高亮按钮
            highlightButton()
	    	-- 动画显示
			animateShow()
		end

        -- 高亮按钮
        function highlightButton()
            local star = _po.star

            local e1, e2, e3
            local difficulty
            if star == 0 then 
                e1 = true
                e2 = false
                e3 = false
                difficulty = DIFFICULTY_SIMPLE
            elseif star == 1 then 
                e1 = false
                e2 = true
                e3 = false
                difficulty = DIFFICULTY_ORDINARY
            elseif star == 2 then 
                e1 = false
                e2 = false
                e3 = true
                difficulty = DIFFICULTY_DIFFICULT
            elseif star == 3 then 
                e1 = false
                e2 = false
                e3 = true
                difficulty = DIFFICULTY_DIFFICULT
            end

            -- NODE(10301):setHighlighted(e1)                  -- N["btnDNormal"]
            -- NODE(10302):setHighlighted(e2)                  -- N["btnDOrdinary"]
            -- NODE(10303):setHighlighted(e3)                  -- N["btnDDifficult"]

            _po.difficulty = difficulty
        end

	    -- 动画显示
		function animateShow()
			-- 状态存储
            --[[
			local target 	  = _node
			local originScale = target:getScale()

			-- 初始设置
			target:setScale(0)

			-- 动画
			local time 		= A_POPUP_SHOW_T
			local action 	= CCScaleTo:create(time, originScale)
			target:runAction(action)
            ]]
		end

		function NODE(tag)
			return CCBCenter.getNodeByTag(_node, tag)
		end

        function rerender()

        end


        ---------


        -- [SP体力]
        -- 刷新SP体力
        function refleshSp()
            local spCurrent = ME:getCursp()
            local spTotal   = ME:getActlimit()

            setProgressValue(_progressBarSp, spCurrent, spTotal, true)
            setProgressText(_progressBarSp, spCurrent, spTotal)
            if MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA then
                CCBCenter.sendLuaMessage(MSG_ID.MSG_MAPCONTAINERLAYER_ONACTIONUPDATESTATUSDATA)
            end
        end

        -- 设置进度条值
        function setProgressValue(node, current, total, isAnimate)
            local value = current * 1.0 / total * 100

            if isAnimate then 
                node:runProgressTo(A_PROGRESS_T , value)
            else
                node:setPercentage(value)
            end
        end

        -- 设置进度条文本
        function setProgressText(node, current, total)
            -- node:setString(string.format("%d%%", math.floor(current * 100 / total)))
            node:setString(string.format("%d / %d", current, total))
        end


        ---------


        -- [新手帮助]
        -- 判断是否执行新手帮助    	
        local function checkHelperInfo(  )
            HelperView2.showBetween(_node, nil, {600, 600}, {820, 820})
        end



    	-- [具体操作]
    	-- 实体渲染
    	entityRender()
    	




    	-- [赋加操作]
        _node.rerender          = rerender
        _node.helpJudge         = checkHelperInfo 
        _node.refleshSp         = refleshSp
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M