--MapPopupFriendLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[MapPopupFriendLayerView]"
	local _node, _nodeTable = node, luaValue
    local _data = node._DATA
    local CardMaster = require("cardui.CardMaster")
--[[ ## local fuction --]]
	local function initViews()
    	-- [常量]
        local S                                 = SCALE_FOR_SPECIAL_NODE
        local FN_LINE_ODD                       = PHI_MAP_POPUP2_FRIEND .. "m_p2f_line.png"
        local FN_LINE_EVEN                      = PHI_MAP_POPUP2_FRIEND .. "m_p2f_line.png"
        local FN_LINE_ODD_SHADOW                = PHI_MAP_POPUP2_FRIEND .. "m_p2f_line.png"
        local FN_LINE_EVEN_SHADOW               = PHI_MAP_POPUP2_FRIEND .. "m_p2f_line.png"
    	local FZ_BTN_DIFFICULTY 				= 60
        local FZ_SCROLLVIEW_LV                  = 30
        local S_SCROLLVIEW_LINE                 = 1
        local SZ_SV_PAGE_SIZE                   = CCSize(496.0, 492.0)
        local SZ_SCROLLVIEW_LINE                = CCSize(496.0 / S_SCROLLVIEW_LINE, 123 / S_SCROLLVIEW_LINE) -- CCSize(1323 * S_SCROLLVIEW_LINE, 270 * S_SCROLLVIEW_LINE)
        local SZ_SV_BOX_LV                      = 20 / S
        local P_SV_F                            = ccp(0, 0)
        local A_SLIDER_SUB_T                    = .5
        local A_SLIDER_SUB_P_SHOW               = ccp(380.8, 19.8)
        local A_SLIDER_SUB_P_HIDE               = ccp(380.8, 19.8 + 120)
        





    	-- [操作变量]
        -- [DAO]
        local LevelDao                  = require("db.leveldb")
        -- [工具]
        local TDArrayUtils              = require(PH_MDL_UTIL .. "TDArrayUtils")
        local TDUIUtils                 = require(PH_MDL_UTIL .. "TDUIUtils")
        -- [模型]
        local CardEntity                = require("model.card.CardEntity")
        -- 数据[好友]
        local _dataFriends              = _data.dataFriends
        local _po                       = _data.po
        -- 数据[传递参数]
        local _friendId                 = 0
        local _friendName               = ""
        local _friendPoint              = 0
        -- 层级
        local Z_HELPLAYER               = 11000





    	-- [方法声明]
        -- [实体渲染]
    	local entityRender
    	local loadContentView
    	local loadRenderOtherwise
    	local bindEventTouchListener
        local animateShow
        local animateContentView
        -- [辅助方法]
        -- 获得关卡[1级]子关卡数量
        local getCountLevel1Sublevels
        -- 获得关卡[1级]数据
        local getDataLevel1
        -- [工具]
        local requireU
        local requirePOP
        local pathU
        local pathPOP
        local newSpritePOP
        local newLabelPOP
        -- [外部调用]
        -- 获得好友ID
        local getFriendId
        -- 获得好友名称
        local getFriendName
        -- 获得友情点
        local getFriendPoint
        -- 获得关卡ID
        local getLevelId
        -- 获得关卡难度
        local getDifficulty
        -- 获得关卡难度[最大]
        local getDifficultyMax
        -- 是否是最新关卡（如果胜利则展开新关卡）
        local isBreak
    	




    	-- [方法定义]
    	-- 实体渲染
    	function entityRender()
            -- 加载内容视图(滚动)
            loadContentView()

			-- 加载渲染以外的其他操作
    		loadRenderOtherwise()
    	end

        -- 加载内容视图(滚动)
        function loadContentView()
            -- [初始化层]
            local layer     = CCBCenter.getNodeByTag(_node, 10101)





            -- [操作变量]
            -- 好友层
            local _layerFriend





            -- [方法声明]
            -- [2－好友选择]
            local renderLayerFriend
            local loadLayerFriend
            local hasFriends
            local loadScrollViewFriend
            local loadLabelNoFriend
            -- [3－其他操作]
            local loadRenderOtherwise
            local setVisibilities
            -- [0－工具]
            local visibleLayerDifficulty
            local visibleLayerFriend





            -- 2、分页视图[好友选择]
            -- [方法定义]
            -- 渲染好友层
            function renderLayerFriend()
                -- 加载难度层
                loadLayerFriend()

                -- 判断是否有好友
                if hasFriends() then
                    -- 加载滚动层[好友]
                    loadScrollViewFriend()
                else
                    -- 加载标签[无好友]
                    loadLabelNoFriend()
                    -- 加载按钮[添加好友]
                    loadButtonAddFriend()
                end
            end

            -- 加载难度层
            function loadLayerFriend()
                -- 创建层
                local view = display.newLayer()
                view:setContentSize(layer:getContentSize())
                layer:addChild(view)

                -- 存储属性
                _layerFriend = view
            end

            -- 判断是否有好友
            function hasFriends()
                return TDArrayUtils.isNotEmpty(_dataFriends)
            end

            -- 加载标签[无好友]
            function loadLabelNoFriend()
                -- 定义配置参数
                local params = {
                    text        = _s("MAP_NO_FRIEND"),          -- 标签文字
                    parentNode  = _layerFriend,                 -- 父结点
                    color       = BUTTON_COLOR3.BROWN,
                    align       = display.CENTER,               -- 对齐方式
                    anchor      = display.CENTER,               -- 锚点
                    offset      = ccp(0, 30),                   -- 偏移量
                }
                -- 生成标签
                local label = TDUIUtils.loadLabelTTF(params)
            end

            -- 加载按钮[添加好友]
            function loadButtonAddFriend()
                -- 定义参数
                local text              = _s("FRIEND_ADD_FRIEND")
                local textPosition      = ccp(0, 130)
                local size              = CCSize(235 / S, 69 / S)
                local handler           = function() 
                                            CCBCenter.replaceLayer("MSG_FRIENDLAYER_MODEL", "ccb.c.friend.FriendLayer", {}, function(node) 
                                                game.removeTopButtons()
                                                game.requestDateForLoad(node, 0)
                                            end)
                                        end
                local parentNode        = _layerFriend
                local fileNameNormal    = "cardgroup/enhanced/btn_card_confirm_normal.png"
                local fileNameSelect    = "cardgroup/enhanced/btn_card_confirm_normal.png"
                local fontSize          = 32.00 / S
                local offset            = ccp(0, -30)
                local scale             = S

                -- 加载按钮
                local button = widget.newButton({
                    labelParams        = {text = text, size = fontSize, shadow = true, padding = {top = -5}, },
                    normalImage        = fileNameNormal,
                    selectImage        = fileNameSelect,
                    contentSize        = size,
                    listener           = handler,
                })
                parentNode:addChild(button)
                util.alignNode(button, parentNode:getContentSize(), display.CENTER)
                button:setPosition(ccp(button:getPositionX() + offset.x, button:getPositionY() + offset.y))
                button:setScale(S)
            end

            -- 加载滚动层[好友]
            function loadScrollViewFriend()
                -- [操作变量]
                local cells = {}

                -- 辅助方法
                -- 获得单元格背景条帧名称
                local function frameNameCell(item, index)
                    if item:getStatus() == STATUS_INVITE_YES then 
                        return (index % 2 == 0) and FN_LINE_EVEN or FN_LINE_ODD
                    else
                        return (index % 2 == 0) and FN_LINE_ODD_SHADOW or FN_LINE_ODD_SHADOW
                    end
                end

                -- 获得单元格背景条帧名称
                local function coolingTime(num)
                    local str

                    local minute = math.ceil(num / 60)
                    -- local second = num % 60
                    if minute <= 1 then
                        str = _s("MAP_FRIEND_LESS_THAN_ONE")
                    else
                        str = format(_s("MAP_FRIEND_TIME_POPOP"), minute)
                    end

                    return str
                end


                -- [侦听器]
                -- [侦听器]创建单元格
                local function _createItemCellListener(grid, index, item)
                    local cell = display.newSprite(frameNameCell(item, index))
                    cell:setScale(S)


                    -- 获得参数
                    local fileNameHero      = format("role/r_ico_%s.png", item:getHero():getSex() == 1 and "m" or "fm")
                    local fileNameCard      = item:getCard():getCardIcon()
                    local fileNameStar      = "lp_icon_star.png"
                    local numStar           = item:getCard():getCardStar()


                    -- 定义精灵
                    local sprite
                    local selectedBox
                    local P_SCROLLVIEW_C_SELECT_TICK    = ccp(420 / S, 34 / S)    
                    local P_SCROLLVIEW_C_BOX_HERO       = ccp(60 / S, 66 / S)         
                    local P_SCROLLVIEW_C_BOX_CARD       = ccp(477.5 / S, 61.5 / S)
                    local P_SCROLLVIEW_C_HERO           = ccp(119 / S, 123 / S)     -- 14, 82
                    local P_SCROLLVIEW_C_BOX_LV_HERO    = ccp(50 / S, 24 / S)
                    local P_SCROLLVIEW_C_BOX_LV_CARD    = ccp(144 / S, 24 / S)
                    local P_SCROLLVIEW_C_VAL_LV_HERO    = ccp(126 / S, 94 / S)
                    local P_SCROLLVIEW_C_VAL_LV_CARD    = ccp(200 / S, 31 / S)
                    local P_SCROLLVIEW_NAME             = ccp(190 / S, 75 / S)
                    local FZ_SCROLLVIEW_NAME            = 28 / S
                    local P_SCROLLVIEW_COOLING_TEXT     = ccp(190 / S, 60 / S)
                    local FZ_SCROLLVIEW_COOLING_TEXT    = 22 / S
                    local P_SCROLLVIEW_COOLING_TIME     = ccp(240 / S, 60 / S)      
                    local FZ_SCROLLVIEW_COOLING_TIME    = 22 / S
                    local P_SCROLLVIEW_STAR             = ccp(185 / S, 38 / S)
                    local M_SCROLLVIEW_STAR             = ccp(5, 0)
                    local S_STAR                        = 1
                    local S_HOOK                        = 1

                    if true then 
                        local OFFSET = ccp(40, 0)
                        P_SCROLLVIEW_C_BOX_CARD     = ccpSub(P_SCROLLVIEW_C_BOX_CARD, OFFSET)
                        P_SCROLLVIEW_C_BOX_LV_CARD  = ccpSub(P_SCROLLVIEW_C_BOX_LV_CARD, OFFSET)
                        P_SCROLLVIEW_C_VAL_LV_CARD  = ccpSub(P_SCROLLVIEW_C_VAL_LV_CARD, OFFSET)
                    end


                    -- 定义事件
                    -- 处理点击事件[英雄]
                    local function onTouchHero()
                        -- CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", 
                        --     {entity = item})
                    end
                    -- 处理点击事件[卡片]
                    local function onTouchCard()
                        local entity = CardEntity.new({ id = item:getCard():getId(), lv = item:getCard():getLv(), })
                        CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", entity, function(layer)
                            -- 绑定点击事件
                            widget.bindTouchEvent{
                                layer =  util.toCCLayer(layer),
                                clickListener = function() layer:removeFromParentAndCleanup(true) end,
                                priority = -9999,
                                swallowsTouches = true,
                            }

                            -- 获得顶层视图
                            local topView = _node
                            -- 添加详情页
                            topView:addChild(layer, 9999)
                        end)
                    end






                    -- 加载盒子[英雄]
                    sprite = newSpritePOP("m_p2f_box_hero.png")
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_C_BOX_HERO)
                    local boxHero = sprite

                    -- 加载精灵[英雄]
                    sprite = item:getHero():createPlayerHeadRectView()
                    sprite:setScale((boxHero:getContentSize().width - 10) / sprite:getContentSize().width)
                    boxHero:addChild(sprite)
                    util.alignNode(sprite, boxHero)

                    -- 加载等级盒子[英雄]
                    -- sprite = newSpritePOP("lp_box_lv.png")
                    -- cell:addChild(sprite)
                    -- sprite:setPosition(P_SCROLLVIEW_C_BOX_LV_HERO)
                    -- sprite:setScale(sprite:getScale() * S_HOOK)

                    -- 加载等级[英雄]
                    local params = {
                        text        = tostring(item:getHero():getLv()),
                        size        = 32,
                        textAlign   = ui.TEXT_ALIGN_CENTER,
                    }
                    sprite = ui.newTTFLabel(params) --newLabelPOP(params)
                    sprite:setAnchorPoint(ccp(0.5, 0.5))
                    sprite:ignoreAnchorPointForPosition(false)
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_C_VAL_LV_HERO)






                    -- 加载盒子[主卡牌]
                    sprite = newSpritePOP("m_p2f_box_card.png")
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_C_BOX_CARD)

                    -- 加载精灵[主卡牌]
                    -- sprite = newButtonPOP({ fileNameNormal = fileNameCard, fileNameSelect = fileNameCard, handler = onTouchCard, autoPath = false, })
                    -- cell:addChild(sprite)
                    -- sprite:setPosition(P_SCROLLVIEW_C_BOX_CARD)
                    -- sprite:setScale(sprite:getScale() * .77)
                    local cardEntity = item:getCard()
                    cardEntity.type = CardMaster.MINICARD
                    cardEntity.showDetail = true
                    cardEntity:setMain(TRUE)
                    cardEntity:setTalent(item:getTalent())
                    cardEntity:setEquipEffect(item:getHero():getEquipEffect())
                    local mainCard = CardMaster.new(cardEntity)
                    cell:addChild(mainCard)
                    mainCard:setScale(.77)
                    util.alignNode(mainCard, cell:getContentSize(), display.CENTER_RIGHT, 17)

                    -- 加载等级[主卡牌]
                    local params = {
                        text        = tostring(item:getCard():getLv()),
                        size        = SZ_SV_BOX_LV,
                        textAlign   = ui.TEXT_ALIGN_LEFT,
                    }
                    sprite = newLabelPOP(params)
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_C_VAL_LV_CARD)
                    util.modifyPositionInAndroid( sprite, 0, 4 )




                    -- 加载精灵[名称]
                    local params = {
                        text        = item:getHero():getName(),
                        size        = FZ_SCROLLVIEW_NAME,
                        textAlign   = ui.TEXT_ALIGN_LEFT,
                    }
                    sprite = newLabelPOP(params)
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_NAME)
                    util.modifyPositionInAndroid( sprite, 0, 5 )


                    

                    -- 加载盒子[选中框]
                    sprite = newSpritePOP("m_p2f_tick.png")
                    cell:addChild(sprite)
                    sprite:setPosition(P_SCROLLVIEW_C_SELECT_TICK)
                    selectedBox = sprite





                    -- 加载精灵[冷却中]
                    if item:getStatus() == STATUS_INVITE_NO then 
                        local z = 999
                        local rotation = 40

                        local mask = newSpritePOP("m_p2f_line_mask.png")
                        cell:addChild(mask, z)
                        util.alignNode(mask, cell:getContentSize(), display.CENTER)


                        local params = {
                            text        = coolingTime(item:getNextInviteTime()),
                            size        = FZ_SCROLLVIEW_COOLING_TIME,
                            textAlign   = ui.TEXT_ALIGN_CENTER,
                        }
                        sprite = newLabelPOP(params)
                        cell:addChild(sprite, z)
                        sprite:setPosition(P_SCROLLVIEW_COOLING_TEXT)
                        -- util.alignNode(sprite, cell,display.CENTER,{left = -15})
                        --sprite:setPosition(P_SCROLLVIEW_COOLING_TIME)
                        -- sprite:setRotation(rotation)

                        -- if device.language ~= "en" then
                        --     local params = {
                        --         text        = _s("MAP_COOLING"),
                        --         size        = FZ_SCROLLVIEW_COOLING_TEXT,
                        --         textAlign   = ui.TEXT_ALIGN_LEFT,
                        --     }
                        --     sprite = newLabelPOP(params)
                        --     cell:addChild(sprite, z)
                        --     sprite:setPosition(P_SCROLLVIEW_COOLING_TEXT)
                        -- end
                        -- sprite:setRotation(rotation)
                    end

                    -- 加载精灵[星级]
                    for i = 1, numStar do
                        sprite = newSpritePOP(fileNameStar)
                        sprite:setScale(S_STAR)
                        cell:addChild(sprite)
                        sprite:setPosition(ccpAdd(P_SCROLLVIEW_STAR, ccp(sprite:getContentSize().width * S_STAR * i + M_SCROLLVIEW_STAR.x * (i - 1), 0)))
                    end

                    -- 外部调用
                    -- 选中
                    function cell:select()
                        selectedBox:setVisible(true)
                    end

                    -- 取消选中
                    function cell:unselect()
                        selectedBox:setVisible(false)
                    end
                    cell.unselect()
                    cells[index] = cell




                    return cell

                end
                -- [侦听器]修改单元格
                local function _modifyItemCellListener(grid, index, item, itemCell)
                    
                end
                -- [侦听器]点击事件
                local function _tapListener(grid, index, item)
                    -- print("ScrollViewFriends Tapped：", index)
                    
                    -- 过滤判断
                    if item:getStatus() == STATUS_INVITE_NO then 
                        return
                    end

                    -- 所有项目 取消选中
                    if cells ~= nil and #cells > 0 then 
                        for _, cell in pairs(cells) do
                            cell:unselect()
                        end
                    end

                    -- 当前项目 选中
                    grid:cellAt(index):select()
                    -- 存储好友
                    _friendId       = item:getHero():getId()
                    _friendName     = item:getHero():getName()
                    _friendPoint    = item:getFPoint()
                end

                -- 行尺寸
                local function _sizeLine()
                    local sprite = display.newSprite(FN_LINE_ODD)
                    return sprite:getContentSize()
                end

                -- [实例化]
                local lineWidth     = SZ_SV_PAGE_SIZE.width
                local lineHeight    = _sizeLine().height

                -- local t = {}
                -- for i = 1,20 do
                --     t[#t + 1] = _dataFriends[1]
                -- end
                -- _dataFriends = t

                local view = widget.newScrollGrid({
                    contentSize     = SZ_SV_PAGE_SIZE,
                    direction       = widget.TABLEVIEW_DIRECTION_VERTICAL,
                    parentNode      = _layerFriend,
                    items           = _dataFriends,
                    contentParams   = {
                        cellSize                = SZ_SCROLLVIEW_LINE,
                        column                  = 1,
                        createItemCellListener  = _createItemCellListener,
                        modifyItemCellListener  = _modifyItemCellListener,
                        tapListener             = _tapListener,
                        selectedParams          = nil,
                        padding                 = { 
                            middleH = 0, middleV = 0,
                            left = 0, right = 0, top = 0, bottom = 0,
                        },
                    },
                })

                view:setItems(_dataFriends)
                view:setPosition(P_SV_F)

                local function selectFirstFriend()
                    local grid = view:getGrid()
                    local item = grid:itemAt(1)

                    if item then 
                        -- 过滤判断
                        if item:getStatus() == STATUS_INVITE_NO then 
                            return
                        end
                        
                        -- 当前项目 选中
                        grid:cellAt(1):select()
                        -- 存储好友
                        _friendId       = item:getHero():getId()
                        _friendName     = item:getHero():getName()
                        _friendPoint    = item:getFPoint()
                    end
                end
                _node.selectFirstFriend = selectFirstFriend
                
                -- 默认选中第1项
                selectFirstFriend()
            end


            -- 3、其他操作
            -- [方法定义]
            -- 加载实体渲染其他操作
            function loadRenderOtherwise()
                -- 设置可见性
                setVisibilities()
            end

            -- 设置可见性
            function setVisibilities()
                -- 显示层[难度]
                -- visibleLayerFriend(false)
            end


            -- 4、工具
            -- 显示层[好友]
            function visibleLayerFriend(isAnimate)
                local isVisibleMe = true
                local isAnimate   = isAnimate == nil and true or isAnimate

                -- 好友选择
                _layerFriend:setVisible(isVisibleMe)

                -- 显示按钮栏[战斗]
                local layer = CCBCenter.getNodeByTag(_node, 102)
                if isAnimate then 
                    layer:setVisible(isVisibleMe)
                    transition.execute(layer, CCMoveTo:create(A_SLIDER_SUB_T, A_SLIDER_SUB_P_SHOW), { easing = "CCEaseBackInOut", })
                else
                    layer:setPosition(A_SLIDER_SUB_P_SHOW)
                end
            end




            -- 具体操作
            -- 加载好友滑动栏
            renderLayerFriend()
            -- 加载实体渲染其他操作
            loadRenderOtherwise()
        end

		-- 加载渲染以外的其他操作
	    function loadRenderOtherwise()
            
		end


        ---------


        -- [新手帮助]
        -- 判断是否执行新手帮助
        local function checkHelperInfo(  )
            HelperView2.showBetween(_node, nil, { 610, 630 }, { 830, 840 })
        end
        ---------


        -- [辅助方法
        -- 获得好友ID
        function getFriendId()
            return _friendId
        end

        -- 获得好友名称
        function getFriendName()
            return _friendName
        end

        -- 获得友情点
        function getFriendPoint()
            return _friendPoint
        end

        -- 获得关卡ID
        function getLevelId()
            return format("%d-%d", _po.levelid, _po.sublevelid)
        end

        -- 获得关卡难度
        function getDifficulty()
            return _po.difficulty
        end

        -- 获得关卡难度[最大]
        function getDifficultyMax()
            return _po.star
        end

        -- 是否是最新关卡（如果胜利则展开新关卡）
        function isBreak()
            return _po.isBreak
        end


        ---------


        -- [工具]  
        -- 加载Lua文件文件内容[Util]
        function requireU(luaName)
            return require(pathU(luaName))
        end

        -- 加载Lua文件文件内容[Popup]
        function requirePOP(luaName)
            return require(pathPOP(luaName))
        end

        -- 获得Lua文件所在的目录路径[Util]
        function pathU(luaName)
            return PH_MDL_UTIL .. luaName
        end

        -- 获得Lua文件所在的目录路径[Popup]
        function pathPOP(luaName)
            return PHI_MAP_POPUP2_FRIEND .. luaName
        end

        -- 加载精灵[Popup]
        function newSpritePOP(fileName)
            return display.newSprite(pathPOP(fileName))
        end

        -- 加载按钮[Popup]
        function newButtonPOP(params)
            local fileNameNomal     = params.fileNameNormal
            local fileNameSelect    = params.fileNameSelect
            local text              = params.text
            local fontName          = params.fontName
            local fontSize          = params.fontSize
            local handler           = params.handler
            local autoPath          = params.autoPath 
            if autoPath == nil then autoPath = true end

            local spriteTemp = autoPath and newSpritePOP(fileNameNomal) or display.newSprite(fileNameNomal)
            local size       = spriteTemp:getContentSize()

            local button = widget.newButton{
                normalImage = autoPath and pathPOP(fileNameNomal) or fileNameNomal,
                selectImage = autoPath and pathPOP(fileNameSelect) or fileNameSelect,
                contentSize = size,
                listener    = handler,
                labelParams = {
                    text = text     or "", 
                    font = fontName or FNT_0,
                    size = fontSize or 20,
                },
            }
            return button
        end

        -- 加载标签[Popup]
        function newLabelPOP(params)
            params.text         = tostring(params.text)
            params.size         = params.size           or 20
            params.textAlign    = params.align          or ui.TEXT_ALIGN_LEFT
            params.color        = params.color          or display.COLOR_WHITE
            params.shadowColor  = params.shadowColor    or display.COLOR_BLACK
            params.position     = params.position

            return ui.newTTFLabelWithShadow(params)
        end
    	




    	-- [具体操作]
    	-- 实体渲染
    	entityRender()
    	




    	-- [赋加操作]
        _node.helpJudge                             = checkHelperInfo
        _node.getFriendId                           = getFriendId                   -- 获得好友ID
        _node.getFriendName                         = getFriendName                 -- 获得好友名称
        _node.getFriendPoint                        = getFriendPoint                -- 获得友情点
        _node.getLevelId                            = getLevelId                    -- 获得关卡ID
        _node.getDifficulty                         = getDifficulty                 -- 获得关卡难度
        _node.getDifficultyMax                      = getDifficultyMax              -- 获得关卡难度[最大]
        _node.isBreak                               = isBreak                       -- 是否是最新关卡（如果胜利则展开新关卡）
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M