--ChangePasswordAlertLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ChangePasswordAlertLayerView]"
	local _node, _nodeTable = node, luaValue
    local PasswordViewUtil = require("cardui.PasswordViewUtil")
    local _oldPasswordEditBox, _passwordEditBox_1, _passwordEditBox_2
    local MIN_LENGTH = 8
    local MAX_LENGTH = 16
--[[ ## local fuction --]]
	local function initViews()
		_nodeTable["mNameLabel"]:setString(ME:getName())
        _oldPasswordEditBox = PasswordViewUtil:createEditBox{parentNode = CCBCenter.getNodeByTag(_node, 10303), maxLength = 16}
        _passwordEditBox_1 = PasswordViewUtil:createEditBox{parentNode = CCBCenter.getNodeByTag(_node, 10403), maxLength = 16}
        _passwordEditBox_2 = PasswordViewUtil:createEditBox{parentNode = CCBCenter.getNodeByTag(_node, 10503), maxLength = 16}
	end

--[[ ## public fuction --]]
    local function getOldPassword( )
        return _oldPasswordEditBox:getText()
    end
    local function getPassword1( )
        return _passwordEditBox_1:getText()
    end
    local function getPassword2( )
        return _passwordEditBox_2:getText()
    end
    -- 是否规范
    local function isCompliance( )
        if getOldPassword( ) == "" then
            NetHelper.QuickToast(_s("CHANGE_OLD_ERROR"))
            return false
        elseif getPassword1( ) == ""
        or string.utf8len(getPassword1( )) < MIN_LENGTH
        or string.utf8len(getPassword1( )) > MAX_LENGTH 
        or getPassword2( ) == ""
        or string.utf8len(getPassword2( )) < MIN_LENGTH
        or string.utf8len(getPassword2( )) > MAX_LENGTH then
            NetHelper.QuickToast(_s("ACCOUNT_PASSWORD_ERROR"))
            return false
        elseif getPassword1( ) ~= getPassword2( ) then
            NetHelper.QuickToast(_s("CHANGE_PASSWORD_ERROR"))
            return false
        elseif crypto.md5(getOldPassword( )) ~= GSVALUES.pass then
            NetHelper.QuickToast(_s("CHANGE_OLD_ERROR"))
            return false
        else
            return true
        end
    end
--[[ ## MAINs --]]
	initViews()
    _node.isCompliance = isCompliance
    _node.getPassword = getPassword1
end

return M