local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ShopBuyDiamondLayerView]"
	local _node, _nodeTable = node, luaValue
    local ShopViewUtil = require("cardui.ShopViewUtil")
    local RewardEntity = require("model.main.RewardEntity")
	local _tableNode
	local _diamondTable
	local _rewardGrid

--[[ ## local fuction --]]
    -- 奖励类容
    local function createRewardGrid( )
        local rewardNode = CCBCenter.getNodeByTag(_node, 10505)
        rewardNode:removeAllChildrenWithCleanup(true)
        local function cellAtIndex( scrollGrid, idx , item)
            local cell = widget.newLayer{}--color = ccc4(255, 255, 100, 255),}
            cell:setContentSize(scrollGrid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            cell:addChild(item)
            util.alignNode(item, cell)

            return cell
        end
        local function onBtnClick(grid, index, item, x, y)
            if item:getType() == RewardEntity.REWARD_TYPE.CARD or item:getType() == RewardEntity.REWARD_TYPE.CHIP then
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item:getEntity())
            elseif item:getType() == RewardEntity.REWARD_TYPE.GOODS then
                if item:getEntity():getNo() > 20000 then
                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item:getEntity())
                else
                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item:getEntity())
                end
            end
        end
        local scrollGrid = widget.newScrollGrid{
            contentSize = rewardNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(95, 95),
                -- padding = { 
                --     middleH = 20,
                -- },
                column = 2,
                createItemCellListener = cellAtIndex,
                tapListener = onBtnClick,
            },
            -- bounceable = false,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = rewardNode,
        }
        return scrollGrid
    end
	local function storeSuccessCallBack(result)
		if isSDK(_GAME.CONFIG.SDK.SDK_91) or isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then
			util.enableCustomTouch(display.getRunningScene(),true)
			return
		end
		Log.d(TAG, "购买成功: MSG_ID = %s", "successStr")

		---后台验证
        _node:performWithDelay(function ( ... )
            AlertLayer.new4OK{
                -- 按钮颜色数组
                btnClickEvent = {
                    function (  )  --按钮1事件  默认为确定
                    end
                }, -- 按钮事件数组
                titleStr = _s("COMMON_NEWS_TIPS"),  -- 标题
                content = _s("BUY_SUCCESS_REFRESH") -- 内容
            }
        end, 0.5)
	end

	local function storeErrorCallBack( result )
		if isSDK(_GAME.CONFIG.SDK.SDK_91) or isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then
			util.enableCustomTouch(display.getRunningScene(),true)
			return
		end
		-- body
		Log.d(TAG, "购买失败: MSG_ID = %s", result["errorStr"])
		Log.d(TAG, "errorCode: MSG_ID = %s", result["errorCode"] or "")
        if isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) then 
            return 
        end
        local content = ""
        if isstring(result["errorStr"]) and string.len(result["errorStr"])>0 then 
    		content = _s("BUY_SP_FAIL") -- .. " \n" ..result["errorStr"]
        else
            content = _s("BUY_SP_FAIL") -- _s("BUY_FAIL_REFRESH")
        end
        _node:performWithDelay(function ( ... )
            AlertLayer.new4OK{
                -- 按钮颜色数组
                btnClickEvent = {
                    function (  )  --按钮1事件  默认为确定
                    end
                }, -- 按钮事件数组
                titleStr = _s("COMMON_NEWS_TIPS"),  -- 标题
                content = content  -- 内容
            }
        end, 0.5)
	end
	
    

    local function createDiamondScrollPage( )
        local function createShopGoodsViewListener( grid, index, item, cell )
            local view 
            if item.getId then
                view = ShopViewUtil:createShopGoodsView{
                    title = item:getDesc2(),
                    imageDesc = item:getDesc1(),
                    image = string.format("shop/%s", item:getTitlepic()),
                    selectImage = "shop/container/btn_shop_cell_blue_select.png",
                    normalImage = "shop/container/btn_shop_cell_blue_normal.png",
                    ctype = isSDK(_GAME.CONFIG.SDK.SDK_91) and ShopViewUtil.CURRENCY_TYPE_91BEAN or ShopViewUtil.CURRENCY_TYPE_RMB,
                    -- value = item:getPrice(),
                    value = item:getBtnstring() ,
                }
            end
            return view
        end
        local function onBtnClick( grid, index, item )
            Log.d(TAG, "去购买")
            _sdkPlatform.store(
                storeSuccessCallBack,
                storeErrorCallBack,
                {
                    iapId = item:getId(),
                    price = item:getPrice(), 
                    proName = item:getDesc2(),  
                    proDesc = item:getDesc1(), 
                    deviceno = DEFLOGINBASEINFO.deviceid,
                    productId = item:getIapproductid(),
                }
            )
        end
        local function onGoodsClick( grid, index, item )
            Log.d(TAG, "onGoodsClick")
        end
        local column
        local parentNode
        local bigNode = CCBCenter.getNodeByTag(_node, 102)
        local smallNode = CCBCenter.getNodeByTag(_node, 106)
        bigNode:removeAllChildrenWithCleanup(true)
        smallNode:removeAllChildrenWithCleanup(true)
        if ME:getFirstpay() == TRUE then
            parentNode = smallNode
            column = 4
        else
            parentNode = bigNode
            column = 6
        end
        local scroll = ShopViewUtil:createShopScrollPage{
            parentNode = parentNode,
            createShopGoodsViewListener = createShopGoodsViewListener,
            onBtnClick = onBtnClick,
            column = column,
            -- onGoodsClick = onGoodsClick,
        }
        return scroll
    end
    local function createShopView( )
        -- 背景
        ShopViewUtil:createShopBackgroup{
            parentNode = CCBCenter.getNodeByTag(_node, 101),
            file = "bg_shop_blue.png",
        }
    end
    local function createChargeActivity( )
        local btnActivity = widget.newButton{
            normalImage = "common/buttons/btn_normal_yellow.png",
            rect = CCRect(0, 0, 80, 58), 
            scale = 1.1,
            size = 24,
            contentSize = CCSize(120, 58),
            labelParams = {text = _s("ACTIVITY_RECHARGE_ACTIVITY"), color = BUTTON_COLOR3.BROWN,},
            swallowsTouches = true,
            listener = function ( button )
                CCBCenter.loadCCB("MSG_ARENAWEEKALERTLAYER_MODEL", "ccb.c.arena.ArenaWeekAlertLayer", {isChargeActivity = true,})
            end,
        }
        _node:addChild(btnActivity, 10)   
        util.alignNode(btnActivity, _node, display.TOP_LEFT, {top = 100, left = 10})
    end
	local function initViews()
        -- 玩家状态
        _playerStatus = ShopViewUtil:createShopPlayerStatus{
            parentNode = CCBCenter.getNodeByTag(_node, 104),
        }
        _nodeTable["btnBuyDiamond"]:setVisible(false)
        createShopView( )
        createChargeActivity()

        local topTitleSprite = widget.newSprite{file = "main/activity/firstcharge/img_first_charge_title.png"}
        local contentTitleSprite = widget.newSprite{file = "main/activity/firstcharge/img_first_charge_content.png"}

        _nodeTable["mTopTitleLabel"]:addChild(topTitleSprite)
        _nodeTable["mContentTitleLabel"]:addChild(contentTitleSprite)
        
        util.alignNode(topTitleSprite, _nodeTable["mTopTitleLabel"])
        util.alignNode(contentTitleSprite, _nodeTable["mContentTitleLabel"])
	end

--[[ ## public fuction --]]
	--回调
    local function callBackShopList( entityFriendArr, param )
        Log.d(TAG, "商店返回数据")
        -- 显示首充
        CCBCenter.getNodeByTag(_node, 105):setVisible(ME:getFirstpay() == TRUE)
        if ME:getFirstpay() == TRUE then
            _rewardGrid = createRewardGrid()
            _rewardGrid:setItems(entityFriendArr:getReward():getRewardViews())
        end
        -- 内容
        _diamondTable = createDiamondScrollPage( )
        -- 显示返回的商店数据
        _diamondTable:setItems(entityFriendArr:getIaps(), true)     
    end
--[[ ## MAINs --]]
	initViews()
    _node.callBackShopList = callBackShopList 
end

return M