local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ShopGoodsLayerView]"
	local _node, _nodeTable = node, luaValue
    local ShopViewUtil = require("cardui.ShopViewUtil")
	local _goodsScrollGrid
    local _playerStatus
--[[ ## local fuction --]]
	
    local function createGoodsScrollPage( )
        local function createShopGoodsViewListener( grid, index, item, cell )
            local view 
            if item.id then
                view = ShopViewUtil:createShopGoodsView{
                    title = item.title,
                    imageDesc = "X" .. item.count,
                    imageNode = ShopViewUtil:getGoodsAndStarView(item),
                    ctype = ShopViewUtil.CURRENCY_TYPE_DIAMOND,
                    value = item.costvalue,
                    selectImage = "shop/container/btn_shop_cell_green_select.png",
                    normalImage = "shop/container/btn_shop_cell_green_normal.png",
                }
            end
            return view
        end
        local function onBtnClick( grid, index, goods )
            Log.d(TAG, "去购买")
            -- 购买
            if goods.id then
                if goods.costvalue > ME:getDiamond() then
                    NetHelper.QuickToast(_s("ACTIVITY_DIAMOND_NOT_ENOUGH", goods.costvalue))
                else
                    if goods.starType == STARTYPE.SP and ME:getCursp() >= ME:getActlimit() then
                        NetHelper.QuickToast(_s("ROLE_SP_FULL"))
                    else
                         AlertLayer.new4IAP{
                            isUserDiamond = true,
                            diamondIndex = 15,
                            content = string.format(_s("SHOP_STAR_BUY_CONFIRM_DIAMOND"), goods.title, goods.count, goods.costvalue),  --内容
                            btnClickEvent = {
                                function ( )
                                    local requestData = {}
                                    requestData.proid = goods.id
                                    CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPGOODSLAYER_ACTION_ONFETCHBUYGOODSSHOP, nil, requestData)
                                end,
                            }
                          }
                    end
                        
                end
            end
        end
        local function onGoodsClick( grid, index, item )
            Log.d(TAG, "查看详细")
            ShopViewUtil:showItemAlertView(item)
        end
        local scroll = ShopViewUtil:createShopScrollPage{
            parentNode = CCBCenter.getNodeByTag(_node, 102),
            createShopGoodsViewListener = createShopGoodsViewListener,
            onBtnClick = onBtnClick,
            onGoodsClick = onGoodsClick,
        }
        return scroll
    end
    local function createShopView( )
        -- 背景
        ShopViewUtil:createShopBackgroup{
            parentNode = CCBCenter.getNodeByTag(_node, 101),
            file = "bg_shop_green.png",
        }
        -- 玩家状态
        _playerStatus = ShopViewUtil:createShopPlayerStatus{
            parentNode = CCBCenter.getNodeByTag(_node, 104),
        }
        -- 内容
        _goodsScrollGrid = createGoodsScrollPage( )
    end
	local function initViews()
        createShopView( )
	end

--[[ ## public fuction --]]
	function M.updateGoods( items )
        _goodsScrollGrid:setItems(items.shops, true)
    end
    function M.refreshPlayerStatus( )
        _playerStatus.refresh()
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateGoods = M.updateGoods
    _node.refreshPlayerStatus = M.refreshPlayerStatus

end

return M