--ShopNewLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ShopNewLayerView]"
	local _node, _nodeTable = node, luaValue
    local ShopViewUtil = require("cardui.ShopViewUtil")
    local _playerStatus, _shopScrollGrid
    local ShopsConfig = {
        {id = "MSG_SHOPBUYDIAMONDLAYER_MODEL", path = "ccb.c.shop.ShopBuyDiamondLayer", file = "shop/container/icon_shop_diamond.png", text = _s("COMMON_RECHARGE")},
        {id = "MSG_SHOPLAYER_MODEL", path = "ccb.c.shop.ShopLayer", file = "shop/container/icon_shop_card.png", text = _s("SHOP_CARD_GIFTS")},
        {id = "MSG_SHOPGOODSLAYER_MODEL", path = "ccb.c.shop.ShopGoodsLayer", file = "shop/container/icon_shop_goods.png", text = _s("SHOP_GOODS")},
        {id = "MSG_SHOPSTARLAYER_MODEL" , path = "ccb.c.shop.ShopStarLayer", file = "shop/container/icon_shop_star.png", text = _s("MAIN_STARSHOP_L")},

    }
--[[ ## local fuction --]]
    -- 刷新玩家状态
    local function refreshPlayerStatus( )
        _playerStatus:refresh()
    end
    local function createScrollGrid( )
        local layer = CCBCenter.getNodeByTag(_node, 102)
        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- local bgSprite = widget.newSprite{file = "shop/container/btn_shop.png"}
            -- cell:addChild(bgSprite, 0)
            -- util.alignNode(bgSprite, cell:getContentSize(), display.CENTER)

            local shopSprite = widget.newSprite{file = item.file}
            cell:addChild(shopSprite, 1)
            util.alignNode(shopSprite, cell, display.CENTER)

            local shopName = ui.newTTFLabel{text = item.text, size = 30}
            cell:addChild(shopName, 2)
            util.alignNode(shopName, cell, display.CENTER_BOTTOM, 70)

            return cell
        end
        local function onBtnClick(grid, index, item, x, y)
            if item.id and item.id ~= "" then
                util.enableCustomTouch(_shopScrollGrid, false)
                local cell = grid:cellAt(index)
                local array     = {}
                array[#array + 1] = CCScaleTo:create(0.2, 1.1)
                array[#array + 1] = CCScaleTo:create(0.2, 1)
                transition.execute(cell, transition.sequence(array), 
                    {easing = "CCEaseBackInOut", onComplete = function ( )
                        util.enableCustomTouch(_shopScrollGrid, true)
                        HelperView2.showNext()
                        if "MSG_SHOPBUYDIAMONDLAYER_MODEL" == item.id then
                            if GAMERATE:isBuyDiamond() then
                                _sdkPlatform.storeView()
                            end
                        else
                            CCBCenter.loadCCB(item.id, item.path, {fromMain = false, })
                        end
                    end}
                )
                if index == 1 or index == 4 then
                    _shopScrollGrid:scrollToRow(index, 0.1)
                end
            end
        end

        local scrollGrid = widget.newScrollGrid{
            contentSize = CCSizeAdd(layer:getContentSize(), 0, 30),
            contentParams = {
                cellSize = CCSize( 288, 400),
                padding = {left = 10, middleH = 5,},
                row = 1,
                createItemCellListener = createItemCellListener,
                tapListener = onBtnClick,
                items = ShopsConfig,
            },
            direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
            parentNode = layer,
        }
        return scrollGrid
    end
    local function createShopView( )
        -- 背景
        ShopViewUtil:createShopBackgroup{
            parentNode = CCBCenter.getNodeByTag(_node, 101),
        }
        -- 玩家状态
        _playerStatus = ShopViewUtil:createShopPlayerStatus{
            parentNode = CCBCenter.getNodeByTag(_node, 104),
        }
        -- 内容
        _shopScrollGrid = createScrollGrid( )
    end
    local function checkHelperInfo( )
        local function helperCalllback( index )
            if index == 371 then
                CCBCenter.loadCCB("MSG_SHOPLAYER_MODEL", "ccb.c.shop.ShopLayer", {fromMain = false, })
            end
        end
        HelperView2.showBetween(_node, helperCalllback, {371, 371})
    end
	local function initViews()
        checkHelperInfo( )
		createShopView( )
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
    _node.refreshPlayerStatus = refreshPlayerStatus
end

return M