local M = {}

function M.bindView(node, luaValue)
	local TAG = "[ShopStarLayerView]"
	local _node, _nodeTable = node, luaValue
    local ShopViewUtil = require("cardui.ShopViewUtil")
	local _starScrollGrid
    local _playerStatus
--[[ ## local fuction --]]
	
    local function createStarScrollPage( )
        local function createShopGoodsViewListener( grid, index, item, cell )
            local view 
            if item.id then
                view = ShopViewUtil:createShopGoodsView{
                    title = item.title,
                    imageDesc = "X" .. item.count,
                    imageNode = ShopViewUtil:getGoodsAndStarView(item),
                    ctype = ShopViewUtil.CURRENCY_TYPE_STAR,
                    value = item.costvalue,
                }
            end
            return view
        end
        local function onBtnClick( grid, index, goods )
            Log.d(TAG, "去购买")
            -- 购买
            if goods.id then
                if goods.costvalue > ME:getStar() then
                    NetHelper.QuickToast(_s("SHOP_STAR_NOT_ENOUGH"))
                else
                    if goods.starType == STARTYPE.SP and ME:getCursp() >= ME:getActlimit() then
                        NetHelper.QuickToast(_s("ROLE_SP_FULL"))
                    else
                        AlertLayer.new{
                            btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
                            btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
                            titleStr = _s("SHOP_BUY"),  --标题
                            content = string.format(_s("SHOP_STAR_BUY_CONFIRM"), goods.title, goods.count, goods.costvalue),  --内容
                            btnClickEvent = {
                                function (  )  --按钮1事件
                                    local requestData = {}
                                    requestData.proid = goods.id
                                    CCBCenter.sendLuaMessage(MSG_ID.MSG_SHOPSTARLAYER_ACTION_ONFETCHBUYSTARSHOP, nil, requestData)
                                end,
                            },
                        }   
                    end
                        
                end
            end
        end
        local function onGoodsClick( grid, index, item )
            Log.d(TAG, "查看详细")
            ShopViewUtil:showItemAlertView(item)
        end
        local scroll = ShopViewUtil:createShopScrollPage{
            parentNode = CCBCenter.getNodeByTag(_node, 102),
            createShopGoodsViewListener = createShopGoodsViewListener,
            onBtnClick = onBtnClick,
            onGoodsClick = onGoodsClick,
        }
        return scroll
    end
    local function createShopView( )
        -- 背景
        ShopViewUtil:createShopBackgroup{
            parentNode = CCBCenter.getNodeByTag(_node, 101),
        }
        -- 玩家状态
        _playerStatus = ShopViewUtil:createShopPlayerStatus{
            parentNode = CCBCenter.getNodeByTag(_node, 104),
        }
        -- 内容
        _starScrollGrid = createStarScrollPage( )
    end
	local function initViews()
        createShopView( )
	end

--[[ ## public fuction --]]
	function M.updateGoods( items )
        _starScrollGrid:setItems(items.shops, true)
    end
    function M.refreshPlayerStatus( )
        _playerStatus.refresh()
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateGoods = M.updateGoods
    _node.refreshPlayerStatus = M.refreshPlayerStatus

end

return M