


--
--
--   商品基础类

--
-- 结点类
local shopNode = function(params)

    return display.newSprite("shop/shop_07.png", 0, 0)
end

local M = class("ShopGoodNode",shopNode)
local TDAnimationUtils              = require( "view.Fight.Util.TDAnimationUtils")

--初始化
function M:ctor(params)
    self.callBackBuyShop = params.callBackBuyShop
    self.callBack_guoqingShop = params.callBack_guoqingShop
    self.callBack_wanshengjieShop = params.callBack_wanshengjieShop
    self.callBackSetArg = params.callBackSetArg
    self._getFreebuy = nil
    self._params = params.item  --参数
    self:initBackSprite() --背景
    self:initTitle()  --title
    self:initIconSp()  --图标
    self:initHotSp()
    self:initDesc2()
    self:initDesc()
    self:initShopHengfu()
    self:initBuyBtn() --购买按钮
    self:initMemo()
    self:initHilght()
end

--背景
function M:initBackSprite( ... )
    -- local baciSp = display.newSprite("shop/shop_07.png", 0, 0)
    self:setOpacity(0)
    transition.fadeIn(self , {time = 1.0})
    self:ignoreAnchorPointForPosition(false)
    self:setTag( 3 )
    
    -- self:setContentSize(baciSp:getContentSize())
    -- self:addChild(baciSp)
end

--横幅提示
function M:initShopHengfu( )
           local btnText = ''
           --首抽必出五星
           if self._params:getPic() == "shop_zhuanshi.png" then
                btnText  = _s("SHOP_FISTBUY_FIVESTART")                                             
           end
           --免费抽卡次数
           if self._params:getPic() == "shop_mianfei.png" then
                btnText = _s("ROLE_FREEBUY") .. ME:getFreebuy()
           end


           if string.len(btnText)>0 then
                local checkInfoBtn = 
                   widget.newButton({
                          normalImage="shop/shop-30.png",selectImage = "shop/shop-30.png",
                          scale = 1.1,ignoreAnchor = true,x = 185,y = 150,
                          labelParams = {
                                                    text  = btnText,color = ccc3(96 ,57 ,19),
                                                    size  = 30*(1/SCALE_FOR_SPECIAL_NODE),textAlign = ui.TEXT_ALIGN_CENTER
                                                },
                          listener = function() end
                        })
                self:addChild(checkInfoBtn)
                --免费抽卡信息需要及时刷新
                if self._params:getPic() == "shop_mianfei.png" then
                    self._getFreebuy = checkInfoBtn
                end
                
           end
end

function M:initTitle( ... )
    --活动标题
    local titleBackSp = display.newSprite("shop/"..self._params:getTitlepic(), 0, 0)
    util.alignNodeWithPadding(titleBackSp, self:getContentSize(), display.CENTER_TOP, {top = 16} )
    self:addChild(titleBackSp)

    local titleTF = widget.newTTFLabelWithShadow{ 
                                        size = 27,
                                        text = tostring(self._params:getTitle()),
          }
    titleTF:setAnchorPoint(ccp(0.5, 0.5))
    titleBackSp:addChild(titleTF)
    util.alignNodeWithPadding(titleTF, titleBackSp:getContentSize(), display.CENTER )
end

function M:initIconSp( ... )
    --商品图标
    local shopIconSp = display.newSprite("shop/"..self._params:getPic(), 0, 0)
    shopIconSp:setPosition( 150, 215)
    self:addChild(shopIconSp)
end

function M:initDesc2( ... )
             local shopTitleLb2 = ui.newTTFLabelWithShadow{ 
                                        size = 19*(1/SCALE_FOR_SPECIAL_NODE),
                                        text = tostring(self._params:getDesc2()),
                                        x    = 40*(1/SCALE_FOR_SPECIAL_NODE),
                                        y    = 80*(1/SCALE_FOR_SPECIAL_NODE)
           }
           self:addChild(shopTitleLb2)
end

function M:initDesc( ... )
    --         --商品title
          local desc1 = ui.newTTFLabelWithShadow{ 
                                        size = 19*(1/SCALE_FOR_SPECIAL_NODE),
                                        text = tostring(self._params:getDesc1()),
                                        x    = 40*(1/SCALE_FOR_SPECIAL_NODE),
                                        y    = 110*(1/SCALE_FOR_SPECIAL_NODE)
           }
           self:addChild(desc1)
end

function M:initHotSp( ... )
    if string.len(self._params:getStatuspic()) > 0 then

            local hotSp = display.newSprite("shop/"..self._params:getStatuspic(), self:getContentSize().width-45, self:getContentSize().height-100)
            self:addChild(hotSp)

            local aniSp = display.newSprite("shop/"..self._params:getStatuspic(), hotSp:getContentSize().width/2-2,  hotSp:getContentSize().height/2+6)
            hotSp:addChild(aniSp)
            aniSp:setScale(0.4)
         TDAnimationUtils.addSpriteFramesWithResource("shop/hotlight")
            local actionParams  = {
                prefix      = "l000",
                frameCount  = 20,
                interval    = 0.02,
            }
            local function doAni(  )
             -- body
             local array         = {}
                array[#array + 1] = TDAnimationUtils.animateWithFrame(actionParams)
                array[#array + 1] = CCDelayTime:create(3)
                array[#array + 1] = CCCallFunc:create(doAni)
             aniSp:runAction(TDAnimationUtils.sequence(array))
            end
            doAni()
         end
end

function M:initBuyBtn( ... )
  -- print(":::"..self._params:getBtnstring())
        local gethpSP = 
                    widget.newButton({
                          normalImage="shop/shop_13.png",
                          selectImage = "shop/shop_14.png",
                          scale = 1.1,
                          ignoreAnchor = true,
                          x = 150,
                          y = 30,
                          labelParams = {
                                                    text  = self._params:getBtnstring(),
                                                    color = ccc3(96 ,57 ,19),
                                                    size  = 30*(1/SCALE_FOR_SPECIAL_NODE),
                                                    textAlign = ui.TEXT_ALIGN_CENTER
                                                },
                          listener = function (  ) 
                                local isUserDiamond = false
                                local diamondIndex = 8
                                SOUND:playEffectButton1()
                                --_buyId = self._params:getId()
                                -- _buyCostValue = self._params:getCostvalue()
                                -- _buyPic = self._params:getPic()
                                self.callBackSetArg({buyid = self._params:getId(),buyCostValue = self._params:getCostvalue(),buyPic=self._params:getPic()})
                                if self._params:getPic() == "shop_mianfei.png" then
                                    if ME:getFreebuy() < self._params:getCostvalue() then 
                                        NetHelper.QuickToast(_s("SHOP_FREEBUY_NOT_ENOUGH"))
                                        return
                                    end
                                elseif self._params:getPic() == "shop_17.png" or self._params:getPic() == "shop_zhuanshi.png" or self._params:getPic() == "shop_gift.png" then
                                    if ME:getDiamond() < self._params:getCostvalue() then 
                                        NetHelper.QuickToast(_s("SHOP_DIAMOND_NOT_ENOUGH"))
                                        return
                                    end
                                elseif self._params:getPic() == "shop_youqing.png" or self._params:getPic() == "shop_18.png" then
                                    if ME:getFp() < self._params:getCostvalue() then 
                                        NetHelper.QuickToast(_s("SHOP_FP_NOT_ENOUGH"))
                                        return
                                    end  
                                end

                                 if self._params:getPic() == "shop_17.png" then
                                    isUserDiamond = true
                                    diamondIndex = 8
                                elseif self._params:getPic() == "shop_zhuanshi.png" then
                                    isUserDiamond = true
                                    diamondIndex = 9
                                end

                                 AlertLayer.new4IAP{
                                    isUserDiamond = isUserDiamond,
                                    diamondIndex = diamondIndex,
                                    content =string.format(_s("SHOP_CONRIFM_CONTINUE_LOTTERY"), tostring(self._params:getDesc1())),  --内容
                                    btnClickEvent = {
                                        function ( )
                                            -- print("购买拉。。。。。。。。。"..self._params:getId())
                                                    --购买
                                                    -- CCBCenter.sendLuaMessage( 
                                                    --     MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP, 
                                                    --     nil,
                                                    --     { arg = {proid = self._params:getId()}, methodId = ACTID.MSG_BUY_SHOP, callBackmethod = self.callBackBuyShop}
                                                    -- )
                                                    -- HelperView2.showNext()


                                            if self._params:getShoptype() == 2 then
      
                                                    --购买
                                                        CCBCenter.sendLuaMessage( 
                                                          MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP, 
                                                          nil,
                                                          { arg = {proid = self._params:getId()}, methodId = ACTID.MSG_BUY_SHOP, callBackmethod = self.callBack_guoqingShop}
                                                        )
                                            elseif self._params:getShoptype() == 9 then
                                  
                                                    --购买
                                                        CCBCenter.sendLuaMessage( 
                                                          MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP, 
                                                            nil,
                                                            { arg = {proid = self._params:getId()}, methodId = ACTID.MSG_BUY_SHOP, callBackmethod = self.callBack_wanshengjieShop}
                                                          )
                                            else
                                                      --购买
                                                        CCBCenter.sendLuaMessage( 
                                                          MSG_ID.MSG_SHOPLAYER_NETGETBUYSHOP, 
                                                          nil,
                                                          { arg = {proid = self._params:getId()}, methodId = ACTID.MSG_BUY_SHOP, callBackmethod = self.callBackBuyShop}
                                                        )
                                                        HelperView2.showNext()
                                            end
                                        end,
                                    }
                                  }
                                
                                
                                HelperView2.show(display.getRunningScene(), 400)
                            end
                        })
        self:addChild(gethpSP)
end


function M:initMemo()
  if string.len(self._params:getMemo()) > 0 then
        local memoArr = TDStringUtils.split(self._params:getMemo(), "|")

        local btnStrs

        if memoArr[3] == 0 or memoArr[3] == '0' then
          
          btnStrs = {   _s("COMMON_OK") }
          
        else 
          
          btnStrs = { _s("SHOP_LOOK_NEWCARD"), _s("COMMON_CANCEL")}
        end

              local checkInfoBtn = 
                widget.newButton({
                    normalImage="shop/shop-30.png",
                    selectImage = "shop/shop-30.png",
                    scale = 1.1,
                      ignoreAnchor = true,
                      x = 185,
                      y = 150,
                      labelParams = {
                                    text  = memoArr[1],
                                    color = ccc3(96 ,57 ,19),
                                    size  = 30*(1/SCALE_FOR_SPECIAL_NODE),
                                    textAlign = ui.TEXT_ALIGN_CENTER
                                },
                      listener = function (  ) 
                        AlertLayer.new{
                          titleStr    = "",
                                    content     = memoArr[2],
                                    btnStr      = btnStrs,
                                    btnColor    = { AlertLayer.BTN_COLOR_BLUE, AlertLayer.BTN_COLOR_YELLOW },
                                    btnClickEvent = {

                                        function()
                                          if memoArr[3] == '0' then
                                        else
                                            CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", require("model.card.CardEntity").new{id = memoArr[3],lv = 60})
                                          end
                                      end
                                    },
                                }
                    end
                    })
        self:addChild(checkInfoBtn)
    end
end

function M:initHilght( ... )
  if string.len(self._params:getStatuspic()) > 0 then

          local hotSp = display.newSprite("shop/"..self._params:getStatuspic(), self:getContentSize().width-45, self:getContentSize().height-100)
          self:addChild(hotSp)

        local aniSp = display.newSprite("shop/"..self._params:getStatuspic(), hotSp:getContentSize().width/2-2,  hotSp:getContentSize().height/2+6)
        hotSp:addChild(aniSp)
          aniSp:setScale(0.4)
      TDAnimationUtils.addSpriteFramesWithResource("shop/hotlight")
        local actionParams  = {
            prefix      = "l000",
            frameCount  = 20,
            interval    = 0.02,
        }
        local function doAni(  )
          -- body
          local array         = {}
              array[#array + 1] = TDAnimationUtils.animateWithFrame(actionParams)
              array[#array + 1] = CCDelayTime:create(3)
              array[#array + 1] = CCCallFunc:create(doAni)
          aniSp:runAction(TDAnimationUtils.sequence(array))
        end
        doAni()
      end
end


function M:init( ... )
    -- body
end

return M