--TowerLayer.lua
local M = {}

function M.bindView(node, luaValue,...)
	local TAG = "[SpecialMapLayerView]"
	local _node, _nodeTable = node, luaValue

	--特殊副本类型 0 金币塔 1 恶魔塔
	local _specialMapType = _node._specialMapType

	--特殊副本列表
	local _speMapListGrid
	--关卡选择grid
	local _checkpointGrid
	--背景Layer
	local _bgLayer
	--重置按钮Layer
	local _reSetLayer
	--背景云Layer
	local _bgCloudLayer
	--拖动前的Y
	local nowGridY = 0
	--可打关卡
	local fightCheckPoint
	--副本类型
	local mapTyp
	--副本开启时间
	local _openTime
	--副本名称
	local mapNameTable = {_s("SPECIALMAP_MAP_GOLD"),_s("SPECIALMAP_MAP_STAR"),_s("SPECIALMAP_MAP_MATERIAL"),_s("SPECIALMAP_MAP_STONE"),_s("SPECIALMAP_MAP_CARD")}
	--扫荡类型
	local sweepingTable = {_s("SPECIALMAP_SWEEPING"),_s("SPECIALMAP_QUICK_SWEEPING")}
	--奖励预览串
	local _rewards
	--历史最高
	local highno
	--当前编号
	local _currentNo = 0
	--是否是关卡层 0 不是 1 是
	local _isCheckpoint = _node.isCheckpoint
	--副本层Layer
	local _mapLayer
	--关卡层Layer
	local _checkPointLayer

	--关卡选择Grid
	local function createCheckpointGrid( ... )

		_checkPointLayer = CCBCenter.getNodeByTag(_node, 4,"CCLayer")

		--背景拖动前的Y
		local bgLayerY = _bgLayer:getPositionY()
		--背景云拖动前的Y
		local bgCloudLayerY = _bgCloudLayer:getPositionY()

		local function nodeScroll(  )
			
			local nextGridY = _checkpointGrid:getContentOffset().y
			local offSetY = nextGridY - nowGridY

			bgLayerY = bgLayerY + offSetY * 0.2
			bgCloudLayerY = bgCloudLayerY +  offSetY * 0.05

			if bgLayerY > 640 or bgLayerY < -640 then
				bgLayerY = 0
			end

			if bgCloudLayerY > 640 or bgCloudLayerY < -640 then
				bgCloudLayerY = 0
			end

			_bgLayer:setPositionY(bgLayerY)
			_bgCloudLayer:setPositionY(bgCloudLayerY)

			nowGridY = nextGridY
		end

		_node:scheduleUpdate(nodeScroll)

        local function tapListener( grid, index, item )
        	local cell = grid:cellAt(index)
        	local array     = {}
            array[#array + 1] = CCScaleTo:create(0.15, 1.1)
            array[#array + 1] = CCScaleTo:create(0.15, 1)
            transition.execute(cell, transition.sequence(array), {easing = "CCEaseBackInOut"})

        	if item.status == 1 then
        		-- 场景转换
                local scene = require("view.Fight.Scene.FightScene").new({  mode = {battle = MODE_BATTLE_EXPFBFLIGHT},typ = mapTyp,no = item.no,fnNextView = function ( )        
                                    CCBCenter.replaceLayer("MSG_MAPCONTAINERLAYER_MODEL", "ccb.c.map.MapContainerLayer", {fromMain = false, }, function (node)
						                node:performWithDelay(function ( ... )
						                    game.requestDateForLoad( node )
						                end, 0.01)
						                node.onExit = function ( self )
						                    util.removeUnusedTextures()
						                end
						            end,  nil)
                                    CCBCenter.loadCCB("MSG_SPECIALMAPLAYER_MODEL", "ccb.c.specialMap.SpecialMapLayer",{specialMapType = 1,mapTyp = mapTyp,isCheckpoint = _isCheckpoint, fromMap = true})                      
                            end, })
                CCBCenter.replaceScene(scene)

			elseif item.status == 2 then
				NetHelper.QuickToast(_s("SPECIALMAP_FIGHTED"))
			end

        end

        local function createItemCellListener(grid, index, item)
            
			local cell = widget.newLayer{contentSize = CCSize(424,95)}

			local img = "specialMap/btn_checkpoint_choose_disable_".._specialMapType..".png"

			if item.status == 1 then
				img = "specialMap/btn_checkpoint_choose_selected_".._specialMapType..".png"
				_currentNo = item.no
			elseif item.status == 2 then
				img = "specialMap/btn_checkpoint_choose_normal_".._specialMapType..".png"
			end

			--关卡选择按钮
			local checkpointButton = widget.newButton{
			    normalImage = img,
			    selectImage = img,
			    cancelOnMove = true,
		    	swallowsTouches = false,
			    labelParams = { 
			 	    text = item.title,
			 	    size = WEEK_TABLE_TEXT_SIZE,
			 	    color = BUTTON_COLOR3.BROWN,
			        padding = {top = 2},
			 	}
			}
			util.alignNode(checkpointButton, cell:getContentSize(),display.CENTER)
			cell:addChild(checkpointButton)

			local str = item.name
			if item.no == highno then
				str = _s("SPECIALMAP_HIGN",item.name)
			end

			-- 副本名称
	        local checkpointLabel = ui.newTTFLabel{           
	            size = 30,
	            text = str,
	            color = BUTTON_COLOR3.BROWN
	        }
			util.alignNode(checkpointLabel, cell:getContentSize(),display.TOP_LEFT,{left = 10,top = 10})
	        cell:addChild(checkpointLabel)

			if item.status == 0 then
				checkpointButton.setStateDisabled(true)
				local lockSprite = widget.newSprite{file = "cardgroup/img_card_protection.png"}
				util.alignNode(lockSprite, cell:getContentSize(), display.CENTER)
				lockSprite:setScale(2)
				cell:addChild(lockSprite)
		    elseif item.status == 2 then
		    	-- 副本名称
		  --       local checkpointLabel = ui.newTTFLabel{           
		  --           size = 30,
		  --           text = item.name,
		  --           color = BUTTON_COLOR3.BROWN
		  --       }
				-- util.alignNode(checkpointLabel, cell:getContentSize(),display.TOP_LEFT,{left = 10,top = 10})
		  --       cell:addChild(checkpointLabel)

		    	-- 已经打过
		        local checkpointLabel = ui.newTTFLabel{           
		            size = 30,
		            text = _s("SPECIALMAP_CLEAN"),
		            color = BUTTON_COLOR3.BROWN
		        }
				util.alignNode(checkpointLabel, cell:getContentSize(),display.BOTTOM_RIGHT,{right = 10,bottom = 5})
		        cell:addChild(checkpointLabel)
			end

            return cell
        end

        local function onCellEnter( grid, index, item, itemCell )
        	--因为item为倒叙插入，因此在计算时需要用总个数去减

        	-- maxIndex 执行动画的最高cell minIndex 执行动画的最低cell

        	local minIndex = grid:getRows() - fightCheckPoint - 6
        	local maxIndex = grid:getRows() - fightCheckPoint + 1

        	-- 动画延迟时间 
        	local delayTime = ( grid:getRows() - index ) - fightCheckPoint + 2

        	--当前cell在前五个时，强制执行动画的个数为6
        	if maxIndex < 6 then
        		maxIndex = 6
        		delayTime = maxIndex - index + 1
        	end

        	if index <=  maxIndex and index >= minIndex then
        		local toY = itemCell:getPositionY()
	        	itemCell:setPositionY(toY + 640 )
	        	transition.moveTo(itemCell, {y = toY,time = 0.25
	        		, delay = delayTime * 0.125
	        		,easing = "BACKINOUT"})
        	end
        end

        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = _checkPointLayer:getContentSize(),
            contentParams = {
                cellSize = CCSize(_checkPointLayer:getContentSize().width , _checkPointLayer:getContentSize().height / 6),
                column = 1,
                tapListener = tapListener,
                createItemCellListener = createItemCellListener, 
                modifyItemCellListener = modifyItemCellListener,
                onCellEnter = onCellEnter,
             },
			bounceable = false,
			
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _checkPointLayer,
        }
        return scrollGrid

	end

	--特殊副本选择Grid
	local function createSpeMapListGrid( ... )

		_mapLayer = CCBCenter.getNodeByTag(_node, 6,"CCLayer")

        local function tapListener( grid, index, item )
        	local cell = grid:cellAt(index)

        	local array     = {}
            array[#array + 1] = CCScaleTo:create(0.15, 1.1)
            array[#array + 1] = CCScaleTo:create(0.15, 1)
            transition.execute(cell, transition.sequence(array), {easing = "CCEaseBackInOut"})

        	if item.time == 0 then
        		_isCheckpoint = 1
	        	--刷新关卡数据
				CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHEGETSPEMAPLIST,nil,{typ = item.typ})
				--特殊副本类型
				mapTyp = item.typ
			else
				NetHelper.QuickToast(_s("SPECIALMAP_RESET_WARMING"))
			end
        end

        local function createItemCellListener(grid, index, item)
            
			local cell = widget.newLayer{contentSize = CCSize(425,95)}

			local img
			if item.time == 0 then
				img = "specialMap/btn_checkpoint_choose_selected_1.png"
			else
				img = "specialMap/btn_checkpoint_choose_normal_1.png"
			end

			--副本按钮
			local mapButton = widget.newButton{
	                --scale = 1.1,
	                normalImage = img,
	                selectImage = img,
	                disableImage = img,
	                swallowsTouches = false,
	                cancelOnMove = true,
	            }
	        util.alignNode(mapButton, cell,display.CENTER)
	        cell:addChild(mapButton)

	        -- 花费钻石复活
	        local mapLabel = ui.newTTFLabel{           
	            size = 25,
	            color = BUTTON_COLOR3.BROWN,
	            text = mapNameTable[item.typ]
	        }
			util.alignNode(mapLabel, cell,display.TOP_LEFT,{left = 10,top = 20})
	        cell:addChild(mapLabel)

	        if item.time > 0 then
		        -- 开启时间
		        _openTime = CountDownView.new{ 
                    format = _s("SPECIALMAP_OPEN_TIME"),
                    labelParams = {size = 25},
                    listener = function()
                        NetHelper.hideLoading(true)
                        if status == 2 then
                            _openTime:stop()
                        end
                        _openTime:setVisible(false)
                    end
                }
                util.alignNodeWithPadding(_openTime, cell:getContentSize(),display.BOTTOM_LEFT,{left = 10,bottom = 15})
            	cell:addChild(_openTime)
            	_openTime:start(item.time)

            	mapButton:setStateDisabled(true)
		    end

            return cell
        end

        local function onCellEnter( grid, index, item, itemCell )
        	--因为item为倒叙插入，因此在计算时需要用总个数去减
        	-- maxIndex 执行动画的最高cell minIndex 执行动画的最低cell
        	local minIndex = 1
        	local maxIndex = grid:getRows() 

        	-- 动画延迟时间 
        	local delayTime = ( grid:getRows() - index ) + 1

        	--当前cell在前五个时，强制执行动画的个数为6
        	if index <=  maxIndex and index >= minIndex then
        		local toY = itemCell:getPositionY()
	        	itemCell:setPositionY(toY + 640 )
	        	transition.moveTo(itemCell, {y = toY,time = 0.25
	        		, delay = delayTime * 0.125
	        		,easing = "BACKINOUT"})
        	end
        end

        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = _mapLayer:getContentSize(),
            contentParams = {
                cellSize = CCSize(_mapLayer:getContentSize().width , _mapLayer:getContentSize().height / 6),
                column = 1,
                tapListener = tapListener,
                createItemCellListener = createItemCellListener, 
                onCellEnter = onCellEnter,
             },
            bounceable = false,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _mapLayer,
        }
        return scrollGrid

	end

	--创建重建按钮
	local function createBtns( item )

		_nodeTable["mSweepingLabel"]:setString(sweepingTable[item.sdtyp])
		
		_reSetLayer:removeChildByTag(2,true)

		--重置按钮
        reSetButton = widget.newButton{
            scale = 1.1,
            normalImage = "team/btn_cross_server.png",
            selectImage = "team/btn_cross_server.png",
            disableImage = "team/btn_cross_server.png",
            listener = function ( button )
            	if item.count > 0 then
	            	--副本重置
	            	if _currentNo > 0 and _currentNo <= #item.tinfos then	
		            	for i,v in ipairs(item.tinfos) do

	            			if v.status == 1 and  i == 1 then
	            				--该副本还未被挑战
	            				NetHelper.QuickToast(_s("SPECIALMAP_RESET_WARMING"))
	            				break
	            			else
	            				if item.needdia > ME:getDiamond() then
	            					--玩家钻石不足
	            					NetHelper.QuickToast(_s("TEAM_DIAMOND_NOT_ENOUGH"))
	            				else
	            					if item.needdia > 0 then
		            					AlertLayer.new4IAP{
			                                -- isUserDiamond = true,
			                                -- diamondIndex = 5,
			                                content = _s("SPECIALMAP_RESET_CONFIRM_1",item.needdia),  --内容
			                                btnClickEvent = {
			                                    function ( )
			                                        CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET,nil,{typ = mapTyp})
			                                    end,
			                                }
			                              }
			                        else
			                        	CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET,nil,{typ = mapTyp})
			                        end	
	            				end
		            			break
		            		end
		            	end
		            else
		            	if item.needdia > 0 then
			            	AlertLayer.new4IAP{
		                        isUserDiamond = true,
		                        diamondIndex = 5,
		                        content = _s("SPECIALMAP_RESET_CONFIRM_1",item.needdia),  --内容
		                        btnClickEvent = {
		                            function ( )
		                                CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET,nil,{typ = mapTyp})
		                            end,
		                        }
		                      }	
		                else
                        	CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHERESET,nil,{typ = mapTyp})
		                end
	            	end
	            else
	            	NetHelper.QuickToast(_s("SPECIALMAP_RESET_NOT"))
	            end
            end
        }

        local resetImg = display.newSprite("specialMap/btn_reset.png")
        util.alignNode(resetImg, reSetButton)
        reSetButton:addChild(resetImg,10000)
        
        if item.needdia > 0 then
        	--重置次数
        	_nodeTable["mResetLabel"]:setString(_s("SPECIALMAP_RESET_COUNT_2",item.count,item.needdia)) 
        else
        	_nodeTable["mResetLabel"]:setString(_s("SPECIALMAP_RESET_COUNT_1"))
        end
        _nodeTable["mResetLabel"]:setTag(1000000)
        util.alignNode(reSetButton, _reSetLayer)
        _reSetLayer:addChild(reSetButton,2)
	end

	--刷新关卡数据
	local function reloadCheckpointyGrid( tinfos )

		fightCheckPoint = 1
		for i,v in ipairs(tinfos) do
			if v.status == 1 then 
				fightCheckPoint = i
			end
		end

		_checkpointGrid:setItems(table.reverse(tinfos))
		--滚到能挑战的最高
		_checkpointGrid:scrollToColumn( #tinfos - (fightCheckPoint - 1) - 4,0)

		nowGridY = _checkpointGrid:getContentOffset().y

	end
	--设置奖励预览串
	local function setRewards( rewards )
		_rewards = rewards
	end
	
	--刷新特殊副本数据
	local function reloadSpeMapListGrid( properties )
		if _isCheckpoint == 1 then
			_currentNo = 0
			_nodeTable["mBtnLayer"]:setVisible(true)
			_checkPointLayer:setVisible(true)
			_mapLayer:setVisible(false)
			_nodeTable["btnBackMap"]:setVisible(true)

			local needdia
			for i,v in ipairs(properties.lst) do
				if #v.tinfos ~= 0 then
					mapTyp = v.typ
					highno = v.highno
					reloadCheckpointyGrid(v.tinfos)
					setRewards(v.reward)
					--创建重置按钮
					createBtns(v)
					needdia = v.needdia
				end
			end

			if properties.issd ~= 0 then 
				CCBCenter.loadCCB("MSG_SWEEPINGLAYER_MODEL", "ccb.c.specialMap.SweepingLayer",
					{issd = properties.issd, sdTime = properties.sdtime,sdTyp = properties.sdtyp,needdia = needdia})
			end
		else
			_nodeTable["mBtnLayer"]:setVisible(false)
			_nodeTable["btnBackMap"]:setVisible(false)
			_checkPointLayer:setVisible(false)
			_mapLayer:setVisible(true)
			_speMapListGrid:setItems(properties.lst)
			_speMapListGrid:scrollToColumn(1)
		end
	end

	--特殊副本扫荡
	local function mapSweeping( ... )
		if _currentNo == 0 or _currentNo > highno then
			NetHelper.QuickToast(_s("SPECIALMAP_SWEEPING_WARMING"))
		else
			CCBCenter.sendLuaMessage(MSG_ID.MSG_SPECIALMAPLAYER_ACTION_ONFETCHSWEEPING,nil,{typ = mapTyp})
		end 
	end

	--获取奖励预览串
	local function getRewards( )
		return _rewards
	end

	--获取副本类型
	local function getMapType( )
		return mapTyp
	end

	local function setIsCheckPoint( isCheckpoint )
		_isCheckpoint = isCheckpoint
	end
    local function checkHelperInfo( )
        if ME:getTriggerMsgEntity():isShowTower1Helper() then
            HelperView2.setCurIndex(200030)
        end
        HelperView2.showBetween(_node, nil, {200030, 200060})
    end
--[[ ## local fuction --]]
	local function initViews()
        checkHelperInfo( )
		for i=1,2 do

			local index = _specialMapType + 1

			if i == index then
				--显示的界面
				CCBCenter.getNodeByTag(_node, i,"CCLayer"):setVisible(true)
			else
				--隐藏的界面
				CCBCenter.getNodeByTag(_node, i,"CCLayer"):setVisible(false)
			end
			_bgCloudLayer = CCBCenter.getNodeByTag(_node, index * 100 + 1,"CCLayer")
			_bgLayer =  CCBCenter.getNodeByTag(_node, index * 100 + 2,"CCLayer")
		end

		_reSetLayer = CCBCenter.getNodeByTag(_node, 70301,"CCLayer")

		--关卡选择Grid
		_checkpointGrid = createCheckpointGrid()
		--特殊副本列表
		_speMapListGrid = createSpeMapListGrid()
		
	end

--[[ ## public fuction --]]
	--刷新特殊副本数据
	_node.reloadSpeMapListGrid = reloadSpeMapListGrid
	--特殊副本重置
	_node.mapReSet = mapReSet
	--特殊副本扫荡
	_node.mapSweeping = mapSweeping
	--获取奖励预览串
	_node.getRewards = getRewards
	--获取奖励预览串
	_node.getMapType = getMapType
	--设置是否是关卡层
	_node.setIsCheckPoint = setIsCheckPoint
	--设置是否可以重置
	_node.setIsReset = setIsReset

--[[ ## MAINs --]]
	initViews()
end

return M