--SpecialMapRewardPreviewLayer.lua
local M = {}

function M.bindView(node, luaValue,...)
	local TAG = "[SpecialMapRewardPreviewLayerView]"
	local _node, _nodeTable = node, luaValue
    local RewardEntity = require("model.main.RewardEntity")
	--奖励串
	local _data = _node._DATA
	local GoodsMaster = require("cardui.GoodsMaster")
    local GoodsEntity = require("model.goods.GoodsEntity")
    local CardEntity = require("model.card.CardEntity")
    local CardMaster = require("cardui.CardMaster")

	--奖励预览Layer
	local _rewardLayer
	--奖励预览大背景
	local _bgBigReward
	--奖励预览背景
	local _bgReward
	--奖励Table
	local rewardTable = {}
	--奖励标题背景
	local _bgRewardTitle
	--奖励行数
	local _gridRow

	 -- 设置奖励内容
    local function updateRewardInfo( data )
        rewardTable = data:getRewardViews()
    end

	--设置背景大小 
	local function setSize( ... )
		 
		_gridRow = math.ceil(#rewardTable / 5) 

		_bgBigReward:setContentSize(CCSize(_bgBigReward:getContentSize().width ,
			_bgBigReward:getContentSize().height + (_gridRow - 1) * 100))
		_bgReward:setContentSize(CCSize(_bgReward:getContentSize().width ,
			_bgReward:getContentSize().height + (_gridRow - 1) * 100))
		_rewardLayer:setContentSize(CCSize(_rewardLayer:getContentSize().width ,
			_rewardLayer:getContentSize().height + (_gridRow - 1) * 100))

		_bgRewardTitle:setPositionY(_bgRewardTitle:getPositionY() + (_gridRow - 1) * 50)
		_nodeTable["mRewardPreViewLabel"]:setPositionY(_bgRewardTitle:getPositionY())
		_nodeTable["btnConfirm"]:setPositionY(_nodeTable["btnConfirm"]:getPositionY() - (_gridRow - 1) * 50)
	end
	--奖励grid
	local function createRewardGrid( ... )
		
		local sprite = display.newSprite("common/bg/bg_item.png")

		local function createItemCellListener(grid, index, item)
	        local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)
            cell:addChild(item)
            util.alignNode(item, cell)
          	return cell
		end
        local function onBtnClick(grid, index, item, x, y)
            if item:getType() == RewardEntity.REWARD_TYPE.CARD or item:getType() == RewardEntity.REWARD_TYPE.CHIP then
                CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item:getEntity())
            elseif item:getType() == RewardEntity.REWARD_TYPE.GOODS then
                if item:getEntity():getNo() > 20000 then
                    CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item:getEntity())
                else
                    CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item:getEntity())
                end
            end
        end
	    --scrollview
		local scrollGrid = widget.newGrid{
			contentSize = _rewardLayer:getContentSize(),
			cellSize = CCSize( _rewardLayer:getContentSize().width / 5 , _rewardLayer:getContentSize().height / _gridRow),
			padding = { 
			    middleH = 5, 
			},
			column = 5,
			row = _gridRow,
            tapListener = onBtnClick,
			createItemCellListener = createItemCellListener,
			selectedParams = nil,
			direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
		}
		_rewardLayer:addChild(scrollGrid)

		scrollGrid:setItems(rewardTable)
	end


--[[ ## local fuction --]]
	local function initViews()
		updateRewardInfo(_data)
		_rewardLayer = CCBCenter.getNodeByTag(_node, 106,"CCLayer")
		_bgBigReward = CCBCenter.getNodeByTag(_node, 101,"CCScale9Sprite")
		_bgReward = CCBCenter.getNodeByTag(_node, 104,"CCScale9Sprite")
		_bgRewardTitle = CCBCenter.getNodeByTag(_node, 102)

		setSize()

		createRewardGrid()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M