--BlacksmithLayer.lua

local M = {}

function M.bindView(node, luaValue, ...)
	local TAG = "[BlacksmithLayerView]"
	local _node, _nodeTable = node, luaValue
    local _issd  = _node.issd
    local _sdTime  = _node.sdTime
    local _sdTyp = _node.sdTyp
    local _needdia = _node.needdia
    --扫荡文字
    local _sweepingLayer
    --扫荡剩余时间
    local _sweepingTime
    --副本名称
    local mapNameTable = {_s("SPECIALMAP_MAP_GOLD"),_s("SPECIALMAP_MAP_STAR"),_s("SPECIALMAP_MAP_MATERIAL"),_s("SPECIALMAP_MAP_STONE"),_s("SPECIALMAP_MAP_CARD")}
    --玩家人物
    local _player

--[[ ## local fuction --]]
    -- 新手引导
    --设置扫荡文字
    local function setSweepingText( ... )

        local str = _s("SPECIALMAP_SWEEPING_NORMAL")
        if _issd == 2 then
            str = _s("SPECIALMAP_SWEEPING_QUICK")
            _nodeTable["mSweepingLabel"]:setString(_s("SPECIALMAP_SWEEPING_TITLE_QUICK",mapNameTable[_sdTyp]))
        elseif _issd == 1 then
            _nodeTable["mSweepingLabel"]:setString(_s("SPECIALMAP_SWEEPING_TITLE",mapNameTable[_sdTyp]))
        elseif _issd == 3 then 
            _nodeTable["mSweepingLabel"]:setString(_s("SPECIALMAP_REWARD_PREVIEW"))
        end

        if _issd == 1 or _issd == 2 then
            -- 开启时间
            _sweepingTime = CountDownView.new{ 
                format = str,
                labelParams = {size = 25,textValign},
                listener = function()
                    _sweepingTime:stop()
                    _issd = 3

                    _nodeTable["btnReward"]:setVisible(true)
                    _nodeTable["btnReward"]:setEnabled(true)
                    _nodeTable["btnCompleteSweeping"]:setVisible(false)
                    _nodeTable["btnCompleteSweeping"]:setEnabled(false)
                    _nodeTable["mSweepingLayer"]:removeAllChildrenWithCleanup(true)
                    setSweepingText()
                end
            }
            util.alignNodeWithPadding(_sweepingTime, _nodeTable["mSweepingLayer"]:getContentSize(),display.CENTER)
            _nodeTable["mSweepingLayer"]:addChild(_sweepingTime)

            if _sdTime > 0 then
                _sweepingTime:start(_sdTime)
            end
        else
            -- 花费钻石复活
            local getRewardLabel = ui.newTTFLabel{           
                size = 25,
                text = _s("SPECIALMAP_SWEEPING_TITLE_END",mapNameTable[_sdTyp]),
                dimensions =  _nodeTable["mSweepingLayer"]:getContentSize()

            }
            util.alignNodeWithPadding(getRewardLabel, _nodeTable["mSweepingLayer"]:getContentSize(),display.CENTER)
            _nodeTable["mSweepingLayer"]:addChild(getRewardLabel)
        end
    end

    local function createHero( ... )
        local heroLayer = CCBCenter.getNodeByTag(_node, 106)
        heroLayer:removeAllChildrenWithCleanup(true)
        _player = ME:createPlayerView{randomAction = true}
        _player:sweep()
        _player:setScaleX(- 0.8)
        util.alignNodeWithPadding(_player, heroLayer:getContentSize(), display.CENTER)
        heroLayer:addChild(_player)
    end

    local function setSweeping( ... )
        setSweepingText()
        _node:setButtonTitle("btnCompleteSweeping", _s("SPECIALMAP_END",GAMERATE:getFinishSweepDiamond()))

        if _issd == 1 or _issd == 2 then
            _nodeTable["btnCompleteSweeping"]:setVisible(true)
            _nodeTable["btnReward"]:setVisible(false)
            _nodeTable["btnReward"]:setEnabled(false)
        elseif _issd == 3 then
            _nodeTable["btnReward"]:setVisible(true)
            _nodeTable["btnCompleteSweeping"]:setVisible(false)
            _nodeTable["btnCompleteSweeping"]:setEnabled(false)
        end
    end

	local function initViews()

        createHero()

        setSweeping()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
    --createMainButtons()
	initViews()
end

return M