--SystemSetLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[SystemSetLayerView]"
	local _node, _nodeTable = node, luaValue
--[[ ## local fuction --]]
	-- 创建音乐控制
	local function createMusicCheckBox( ... )
		local node = CCBCenter.getNodeByTag(_node, 20303)
		local function changeSelectState( checkBox )
			local selected = SOUND.isMusicOn()
			if selected then 
				SOUND.setMusicOff()
				game.addGameState( "GAME_MUSIC", false, true )
				checkBox.setSelected(true)
				checkBox.setTextString("OFF")
			else
				SOUND.setMusicOn()
				game.addGameState( "GAME_MUSIC", true, true )
				checkBox.setSelected(false)
				checkBox.setTextString("O N")
				SOUND:playMusicHome() 
			end
		end
		local checkBox = widget.newCheckBox{
			contentSize = node:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "O N", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN },
			parentNode = node,
			listener = changeSelectState,
		}
		util.alignNode(checkBox, node:getContentSize(), display.CENTER)
		if SOUND.isMusicOn() then 
			checkBox.setSelected(false)
			checkBox.setTextString("O N")
		else
			checkBox.setSelected(true)
			checkBox.setTextString("OFF")
		end
		return checkBox
	end
	-- 创建音效控制
	local function createSoundCheckBox( ... )
		local node = CCBCenter.getNodeByTag(_node, 20403)
		local function changeSelectState( checkBox )
			local selected = SOUND.isEffectsOn()
			if selected then 
				SOUND.setEffectsOff()
				game.addGameState( "GAME_SOUND", false, true )
				checkBox.setSelected(true)
				checkBox.setTextString("OFF")
			else
				SOUND.setEffectsOn()
				game.addGameState( "GAME_SOUND", true, true )
				checkBox.setSelected(false)
				checkBox.setTextString("O N")
			end
		end
		local checkBox = widget.newCheckBox{
			contentSize = node:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "O N", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN},
			parentNode = node,
			listener = changeSelectState,
		}
		util.alignNode(checkBox, node:getContentSize(), display.CENTER)
		if SOUND.isEffectsOn() then 
			checkBox.setSelected(false)
			checkBox.setTextString("O N")
		else
			checkBox.setSelected(true)
			checkBox.setTextString("OFF")
		end
		return checkBox
	end
	-- 创建版本文字
	local function createVerLabel( )
		local verLabel = ui.newTTFLabel{text = "v " .. CVERSION, size = 22,}
		_node:addChild(verLabel)
		util.alignNodeWithPadding(verLabel, _node:getContentSize(), display.BOTTOM_RIGHT, {right = 10, bottom = 2})
	end

	local function initViews()
		-- 创建音乐控制
		createMusicCheckBox()
		-- 创建音效控制
		createSoundCheckBox()
		-- 创建版本文字
		createVerLabel()
		-- 91时显示的文字不同
		if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
			-- _node:setButtonTitle( "btn_1", "18183".._s("OPTION_FORUM"), ccc3(65, 34, 16) )
			-- _node:setButtonTitle( "btn_2", _s("OPTION_FEEDBACK"), ccc3(65, 34, 16) )
			-- _node:setButtonTitle( "btn_3", _s("OPTION_PERSONAL_CENTER"), ccc3(65, 34, 16) )
		elseif isSDK(_GAME.CONFIG.SDK.SDK_360) then
			-- _nodeTable.btn_1:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then 
			_node:setButtonTitle( "btn_2", _s("OPTION_FEEDBACK"), ccc3(65, 34, 16) )
			_node:setButtonTitle( "btn_3", _s("OPTION_PERSONAL_CENTER"), ccc3(65, 34, 16) )
		elseif isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 
			_node:setButtonTitle( "btn_2", _s("OPTION_FEEDBACK"), ccc3(65, 34, 16) )
			_nodeTable.btn_4:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_XIAOMI) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_WANDOUJIA) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_3G) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_MZW) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_HW) then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE) or isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE_EN) then
			if device.language == "en" then 
				_nodeTable.btn_2:setVisible(false)
			end
		end
		-- 无SDK时控件按键显示
		if ENABLED_SDK_ONEKEYLOGIN then
			-- _nodeTable.btn_1:setVisible(false)
			_nodeTable.btn_2:setVisible(false)
			_nodeTable.btn_3:setVisible(false)
			_nodeTable.btn_4:setVisible(false)
		end
		if isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
			_node.updateDataModButton()
		end
	end

--[[ ## public fuction --]]
	local function updateDataModButton( )
		if GSVALUES.modpass == TRUE then
			_node:setButtonTitle( "btn_4", _s("CHANGE_PASSWORD_TITLE"), ccc3(65, 34, 16) )
		else
			_node:setButtonTitle( "btn_4", _s("BIND_PASSWORD_TITLE"), ccc3(65, 34, 16) )
		end
		_nodeTable.btn_4:setVisible(true)
	end
--[[ ## MAINs --]]
	_node.updateDataModButton = updateDataModButton
	initViews()
end

return M