--SystemSetNewLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[SystemSetNewLayerView]"
	local _node, _nodeTable = node, luaValue

	local function returnToLogin()
		util.delayCall(function ()
			game.returnToLogin()
		end, 0.01)
	
	end
	
	local function initMusic()
		local nodeLeft = CCBCenter.getNodeByTag(_node, 106)
		local nodeRight = CCBCenter.getNodeByTag(_node, 107)

		local musicOn,musicOff
		local function changeSelectState()
			local selected = SOUND.isMusicOn()
			if selected then 
				SOUND.setMusicOff()
				game.addGameState( "GAME_MUSIC", false, true )
				musicOn.setSelected(false)
				musicOff.setSelected(true)

			else
				SOUND.setMusicOn()
				game.addGameState( "GAME_MUSIC", true, true )
				SOUND:playMusicHome() 
				musicOn.setSelected(true)
				musicOff.setSelected(false)
			end
		end

		musicOn = widget.newButton{
			contentSize = nodeLeft:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "O N", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN },
			listener = changeSelectState,
		}
		nodeLeft:addChild(musicOn)
		util.alignNode(musicOn, nodeLeft:getContentSize(), display.CENTER)

		musicOff = widget.newButton{
			contentSize = nodeRight:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "OFF", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN },
			listener = changeSelectState,
		}
		nodeRight:addChild(musicOff)
		util.alignNode(musicOff, nodeRight:getContentSize(), display.CENTER)
		if SOUND.isMusicOn() then 
			musicOn.setSelected(true)
			musicOff.setSelected(false)
		else
			musicOn.setSelected(false)
			musicOff.setSelected(true)
		end

		return musicOn, musicOff
	end

	local function initSound()
		local nodeLeft = CCBCenter.getNodeByTag(_node, 108)
		local nodeRight = CCBCenter.getNodeByTag(_node, 109)

		local soundOn,soundOff
		local function changeSelectState()
			local selected = SOUND.isEffectsOn()
			if selected then 
				SOUND.setEffectsOff()
				game.addGameState( "GAME_SOUND", false, true )
				soundOn.setSelected(false)
				soundOff.setSelected(true)

			else
				SOUND.setEffectsOn()
				game.addGameState( "GAME_SOUND", true, true )
				soundOn.setSelected(true)
				soundOff.setSelected(false)
			end
		end

		soundOn = widget.newButton{
			contentSize = nodeLeft:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "O N", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN },
			listener = changeSelectState,
		}
		nodeLeft:addChild(soundOn)
		util.alignNode(soundOn, nodeLeft:getContentSize(), display.CENTER)

		soundOff = widget.newButton{
			contentSize = nodeRight:getContentSize(),
			normalImage = "systemset/btn_yellow_normal.png",
			selectImage = "systemset/btn_yellow_select.png", 
			ignoreAnchor = true,
			labelParams = { text = "OFF", size = 35, textAlign = ui.TEXT_ALIGN_CENTER, shadow = true, color = BUTTON_COLOR3.BROWN },
			listener = changeSelectState,
		}
		nodeRight:addChild(soundOff)
		util.alignNode(soundOff, nodeRight:getContentSize(), display.CENTER)
		if SOUND.isEffectsOn() then 
			soundOn.setSelected(true)
			soundOff.setSelected(false)
		else
			soundOn.setSelected(false)
			soundOff.setSelected(true)
		end

		return soundOn, soundOff
	end

	-- 创建版本文字
	local function createVerLabel()
		local verLabel = ui.newTTFLabel{text = "v " .. CVERSION, size = 22,}
		_node:addChild(verLabel)
		util.alignNodeWithPadding(verLabel, _node:getContentSize(), display.BOTTOM_RIGHT, {right = 10, bottom = 2})
	end

	local function updateInfoSuccessCallBack(result) 
	
		-- 清空信息
		if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 

			if isandroid() then 
				-- 充值，刷新用户数据
				if (result  and result.appordercode) then
		            util.delayCall(
				        function ( )
				                util.delayCall(
				                    function ( )
				                        CCBCenter.sendLuaMessage( MSG_ID.MSG_SHOPLAYER_NETGETSHOPS, 
				                                nil,
				                            {arg = {}, methodId = ACTID.MSG_GET_SHOPLIST, callBackmethod = reflashData} )--请求
				                    end, 
				                    0.7
				                )
				        end,    
				        35.7
				    )
		        else
		            returnToLogin()
		        end
			else 
				returnToLogin()
			end 
		elseif isSDK(_GAME.CONFIG.SDK.SDK_91) then 
			-- 不处理
		elseif isSDK(_GAME.CONFIG.SDK.SDK_360) then 
			-- 不处理
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then 
			-- 不处理
		else
			returnToLogin(  )
		end
		Log.d(TAG,"注销aaaaaaaaaaaaaaa")
	end

	local function updateInfoErrorCallBack(result) 
		if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
			returnToLogin(  )
		elseif isSDK(_GAME.CONFIG.SDK.SDK_360) or isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) or isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then
			-- 不处理
		end
		Log.d(TAG,"关闭aaaaaaaaaaaaaaaa")
	end

	

	--	创建菜单栏
	local function createMenuTable()

		local function clickChangePassword4JP()
			if GSVALUES.modpass == TRUE then
				CCBCenter.loadCCB("MSG_CHANGEPASSWORDALERTLAYER_MODEL", "ccb.c.password.ChangePasswordAlertLayer",
					{
						onConfirm = function ( )
							_node.updateDataModButton()
						end
					}
				)
			else
				CCBCenter.loadCCB("MSG_BINDPASSWORDALERTLAYER_MODEL", "ccb.c.password.BindPasswordAlertLayer", 
					{
						onConfirm = function ( )
							_node.updateDataModButton()
						end
					}
				)
			end
		end

		local button
		local function buttonListener(button)
			if(button:getTag() == 201) then
				--帮助
				CCBCenter.loadCCB("MSG_FAQLAYER_MODEL", "ccb.c.faq.FaqLayer")
			elseif(button:getTag() == 202) then --消费确认
				CCBCenter.loadCCB("MSG_DIAMONDALERTLAYER_MODEL", "ccb.c.diamondalert.DiamondAlertLayer")	
			elseif(button:getTag() == 203) then
				-- 通常是联系客服
				_sdkPlatform.feedBack()
			elseif(button:getTag() == 204) then
				-- 个人中心/用户中心...这个有什么差别,cow
				_sdkPlatform.updateInfo(
					updateInfoSuccessCallBack,
					updateInfoErrorCallBack
				)
			elseif(button:getTag() == 205) then
				-- 360切换账号
				if isSDK(_GAME.CONFIG.SDK.SDK_360) then
					_sdkPlatform.switchaccount(
						function ( ... )
							game.returnToLogin()
						end, 
						function ( ... )
							Log.d(TAG,"切换账号失败")
						end
						)
				elseif isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
					clickChangePassword4JP()	
				-- 注销掉~~~
				elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE) then
					AlertLayer.new{
				        content   = _s("OPTION_EXIT_ACCOUNT_CONFIRM"),
				        btnClickEvent = {
				          	function()
								_sdkPlatform.logout(
									function ( result )
										local actDict = result["nickname"]
										Log.d(TAG, "result.nickname == " .. actDict)
										_GAME.AUTOLOGIN.USERID = result["userid"]
										_GAME.AUTOLOGIN.TOKEN = result["usertocken"]

										if "BIND_REGISTER" == actDict 
											or "PLAY" == actDict 
											-- or "PLAY" == result["nickname"] 
										then

										else
											returnToLogin()
										end
									end, 
									function ( result )
										returnToLogin()
									end, {}
								)
				          	end,
				        },
					}
				else
					AlertLayer.new{
				        content   = _s("OPTION_EXIT_ACCOUNT_CONFIRM"),
				        btnClickEvent = {
				          	function()
				          		-- cow，万恶的云顶，没有提供直接注销处理，只能跟着弹用户中心
				          		if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 
									_sdkPlatform.updateInfo(
											function( )
												-- 清空信息
												returnToLogin()
												Log.d(TAG,"注销aaaaaaaaaaaaaaa")
											end,
											function()
												Log.d(TAG,"关闭aaaaaaaaaaaaaaaa")
											end 
									)
				          		else
						          	_sdkPlatform.logout(
						          		function (  )
						          			util.delayCall(function ()
						          				returnToLogin()
						          			end)
						          		end,
						          		function ()
						          			-- body
						          		end
						          		)
					      			if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
										-- 如果是91 直接跳出去
										if isandroid() then
											_sdkPlatform.hideToolBar()
										end
										returnToLogin()
									-- elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE) then
									-- 	returnToLogin()
									end
				          		end
				          	end,
				        },
					}
				end
			-- elseif(button:getTag() == 205) then
			-- 	print("=====第5个按钮")
			-- elseif(button:getTag() == 206) then
			-- 	print("=====第6个按钮")
			-- elseif(button:getTag() == 207) then
			-- 	print("=====第7个按钮")
			end
		end	

		local function createItemCellListener( grid,index,item )
			if item then
	        	local cell = widget.newLayer()
	        	cell:setContentSize(grid:getCellSize())
	        	cell:ignoreAnchorPointForPosition(false)

	        	local sprite = display.newSprite("systemset/btn_yellow_normal_long.png", 0, 0)
	        	button = widget.newButton{
	        		contentSize = sprite:getContentSize(),
	        		normalImage = "systemset/btn_yellow_normal_long.png",
	        		scale = 1.1,
	        		tag = item.tag, -- tag
	        		swallowsTouches = false,
	        		labelParams = {
	        			text = item.name,
	        			size = 35,
						color = ccc3(65, 34, 16),
	        		},
	        		listener = buttonListener,
	    		}
	        	cell:addChild(button)
	        	util.alignNode(button, cell)
	        	return cell
	        end	
	    end

		local cellSp = display.newSprite("systemset/btn_yellow_normal_long.png", 0, 0)
		local scrollGrid = widget.newScrollGrid{
			contentSize = _nodeTable["mChangeMenu"]:getContentSize(),
			contentParams = {
	            cellSize = CCSize(_nodeTable["mChangeMenu"]:getContentSize().width / 2, cellSp:getContentSize().height),
	            padding = { 
	                middleH = 0, middleV = 40,
	                left = 0, right = 0, top = 5, bottom = 0,
	            },
	            column = 2,
	            createItemCellListener = createItemCellListener,
	            selectedParams = nil,
	        	},
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
		}
		_nodeTable["mChangeMenu"]:addChild(scrollGrid)
		util.alignNode(scrollGrid, _nodeTable["mChangeMenu"]:getContentSize())
		return scrollGrid
	end

--[[ ## local fuction --]]
	local function initViews()
		-- 初始化音乐按钮
		initMusic()
		-- 初始化音效按钮
		initSound()
		-- 创建版本文字
		createVerLabel()

		--初始化菜单上文字
		local configs = {}
		local config_item_1 = {tag = 201}
		local config_item_2 = {tag = 202}
		local config_item_3 = {tag = 203}
		local config_item_4 = {tag = 204}
		local config_item_5 = {tag = 205}

		if isSDK(_GAME.CONFIG.SDK.SDK_360) then
			config_item_1["name"] = _s("OPTION_FORUM")
		else
			config_item_1["name"] = _s("OPTION_RAIDERS")
		end
		config_item_2["name"] = _s("USE_DIAMOND") --消费确认

		config_item_3["name"] = _s("OPTION_CUSTOMER_SERVICE")
		if isSDK(_GAME.CONFIG.SDK.SDK_360) then 
			config_item_4["name"] = _s("OPTION_SAFTINFO_ACCOUNT")
		else
			config_item_4["name"] = _s("OPTION_USER_CENTER")
		end
		if isSDK(_GAME.CONFIG.SDK.SDK_360) then 
			config_item_5["name"] = _s("OPTION_SWITCH_ACCOUNT")
		else
			config_item_5["name"] = _s("OPTION_EXIT_ACCOUNT")	
		end
		if isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then
			config_item_3["name"] = _s("OPTION_FEEDBACK")
			config_item_4["name"] = _s("OPTION_PERSONAL_CENTER")
		end
		if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then
			config_item_3["name"] = _s("OPTION_FEEDBACK")
		end
		if isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
			if GSVALUES.modpass == TRUE then
				config_item_5["name"] = _s("CHANGE_PASSWORD_TITLE")
			else
				config_item_5["name"] = _s("BIND_PASSWORD_TITLE")
			end
		end


		----------------------------------------------------------------------------------------------
		--根据渠道，显示或隐藏按钮
		if not isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
			table.insert(configs, config_item_1)--第一、二个按钮都添加（日本除外）
		end
		table.insert(configs, config_item_2)

		if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_360) then
			table.insert(configs, config_item_3)
			table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then 
			table.insert(configs, config_item_3)
			table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 
			table.insert(configs, config_item_3)
			table.insert(configs, config_item_4)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_XIAOMI) then
			table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_WANDOUJIA) then
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) then
			-- table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_3G) then
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then
			table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_MZW) then
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_HW) then
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE, _GAME.CONFIG.SDK.SDK_APPSTORE_EN) then
			if device.language == "en" then 
				config_item_4["name"] = _s("OPTION_PERSONAL_CENTER")
				-- config_item_5["name"] = _s("OPTION_EXIT_ACCOUNT")
				table.insert(configs, config_item_4)
				-- table.insert(configs, config_item_5)
			else
				config_item_3["name"] = _s("OPTION_FEEDBACK")
				config_item_4["name"] = _s("OPTION_PERSONAL_CENTER")
				-- config_item_5["name"] = _s("OPTION_EXIT_ACCOUNT")
				table.insert(configs, config_item_3)
				table.insert(configs, config_item_4)
				-- table.insert(configs, config_item_5)
			end
		elseif isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
			-- table.insert(configs, config_item_3)
			-- table.insert(configs, config_item_4)
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE) then
			config_item_5["name"] = _s("OPTION_USER_CENTER")
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE_UNALIS) then
			table.insert(configs, config_item_5)
		elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE_PLAY) then
			table.insert(configs, config_item_5)
		end

		-- dump(configs)

		local _menuTable = createMenuTable()
		_menuTable:setItems(configs)
	end

--[[ ## public fuction --]]
	local function updateDataModButton( )
		if GSVALUES.modpass == TRUE then
			-- _node:setButtonTitle( "btn_4", _s("CHANGE_PASSWORD_TITLE"), ccc3(65, 34, 16) )
		else
			-- _node:setButtonTitle( "btn_4", _s("BIND_PASSWORD_TITLE"), ccc3(65, 34, 16) )
		end
--		_nodeTable.btn_4:setVisible(true)
	end
--[[ ## MAINs --]]
	_node.updateDataModButton = updateDataModButton
	initViews()
end

return M