--TalentLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TalentLayerView]"
	local _node, _nodeTable = node, luaValue
	local callBackTalent
	local callBackUpTalent
	local setSelectCell
	local doAnimation  --升级动画
	local canTouch
	local _tableNode 	--table父node
	local _gridTable 	--table实体
	local _prevIndex    --上次点击的cell
	local _prevLv       --选中的天赋升级前的级别
	local _tlprogress    --经验条
	local _progresssp   --白条
	local _diamondNum   --升级需要的钻石数
	local _toolpanel
	local _toollayer
	local _selectOffset
	local TDAnimationUtils              = require( "view.Fight.Util.TDAnimationUtils")
--返回方法
	function callBackTalent( entityArr, param )
		-- print("fanananannananananananannan")
	--重置table	
		_gridTable:setItems(entityArr:getTalents())

	--设置选中行
		if _prevIndex then
			setSelectCell(_prevIndex, entityArr:getTalents()[_prevIndex])
		else
			setSelectCell(1, entityArr:getTalents()[1])
		end
	--按钮title
		_node:setButtonTitle("btnDiamond", 
							_diamondNum,
			 				nil,
			  				CCControlStateNormal)
	end

--升级返回方法
	function callBackUpTalent( entityArr, param )
		
	--重置table
		_gridTable:setItems(entityArr:getTalents())

	--复位选中行
		setSelectCell(_prevIndex, entityArr:getTalents()[_prevIndex])

	--等级改变后加个放大动画 
		local tlLv = CCBCenter.getNodeByTag(_node, 206,"CCLabel")
		local array         = {}
            array[#array + 1] = CCScaleTo:create(0.3,1.4)
            array[#array + 1] = CCScaleTo:create(0.3,1.0)
            tlLv:runAction(TDAnimationUtils.sequence(array))
		-- _gridTable:scrollToItemIndex(_prevIndex)
		if _selectOffset then
		 	_gridTable:setContentOffset(_selectOffset)
		end
	end

--升级天赋选择界面
	local function alertUpTalentPanel(  )
		_toolpanel = CCBCenter.getNodeByTag(_node, 6)
		_toolpanel:retain()
		_toolpanel:removeFromParentAndCleanup(false)
		_toolpanel:setVisible(true)
		
		_toollayer = widget.newLayer()
		util.alignNodeWithPadding(_toolpanel, _toollayer:getContentSize(), display.CENTER) 
		_toollayer:addChild(_toolpanel)
		_toolpanel:release()
		-- util.enableCustomTouch( _gridTable, false )
		-- util.enableCustomTouch( _nodeTable["mBtnUpTalent"], false )
		-- _nodeTable["mBtnUpTalent"]:setEnabled(false)--setStateDisabled(true)
		CCBCenter.pushThirdCCBNode(_toollayer, anim.ANIMATION_POP_OUT)
		HelperView2.showBetween(_toollayer, nil, {50090, 50110})
	end

--pop弹出框
	function popToolLayer( ... )
		_toolpanel:retain()
		_toolpanel:removeFromParentAndCleanup(false)
		_node:addChild(_toolpanel,6)
		_toolpanel:release()
		_toolpanel:setVisible(false)--隐藏弹出框
		CCBCenter.popThirdCCBNode()
	end

--让table和按钮可以点击
	function canTouch( ... )
		
		util.enableCustomTouch( _gridTable, true )
		util.enableCustomTouch( _nodeTable["mBtnUpTalent"], true )
		_nodeTable["mBtnUpTalent"]:setEnabled(true)
	end

	function doAnimation( cell )
		local aniSp = widget.newSprite{ file = "talent/talentlight001.png",}
		cell:addChild(aniSp, 4)
		util.alignNodeWithPadding(aniSp, cell:getContentSize(), display.CENTER,{top = -3, left = -3}) 
		TDAnimationUtils.addSpriteFramesWithResource("talent/talentlight")
		local actionParams  = {
		        prefix      = "talentlight00",
		        frameCount  = 15,
		        interval    = 0.04,
		}
		local function doAni(  )
		    	-- body
		    	local array         = {}
	            array[#array + 1] = TDAnimationUtils.animateWithFrame(actionParams)
	            -- array[#array + 1] = CCDelayTime:create(3)
	            -- array[#array + 1] = CCCallFunc:create(doAni)
			    aniSp:runAction(TDAnimationUtils.sequence(array))
		end
		doAni()

		local progressnode = CCBCenter.getNodeByTag(_node, 215)
		if _progresssp then
			transition.fadeOut(_progresssp , {time = 0.5})
		else
			_progresssp = widget.newSprite{ file = "talent/talent_expwhiteback.png",} 
			_progresssp:setAnchorPoint(ccp(0.0, 0.0))
			-- util.alignNodeWithPadding(progresssp, progressnode:getContentSize(), display.CENTER) 
			progressnode:addChild(_progresssp)	
			transition.fadeOut(_progresssp , {time = 0.5})
		end
	end

--设置选中行
	function setSelectCell( index, item)
		--设置选中行
	    	local cell = _gridTable:getGrid():cellAt(index)
	    	local selSp = display.newSprite("talent/talent_cell_backsel.png", 0, 0)
	    	selSp:setAnchorPoint(ccp(0, 0))
	    	cell:addChild(selSp, 2, 2)
	    	_prevIndex = index
	    --当前选中的天赋
	   		_nodeTable["item"] = item
	    --天赋图标
	    	CCBCenter.getNodeByTag(_node, 216, "CCSprite"):setTexture(TDAnimationUtils.addTextureCache(format("talent/talent_%s_%s.png", item:getCamp(), item:getTyp())))
	   	--名称
	    	CCBCenter.getNodeByTag(_node, 204,"CCLabel"):setString(item:getName())
	  	--lv
	    	CCBCenter.getNodeByTag(_node, 206,"CCLabel"):setString("LV:"..item:getLv())	

	  	--介绍
	    	CCBCenter.getNodeByTag(_node, 212,"CCLabel"):setString(item:getIntroduction())
	  	--当前等级
	    	CCBCenter.getNodeByTag(_node, 211,"CCLabel"):setString(string.format(item:getTitle(),item:getValue()))
	  	--下-等级
	  		if item:getLv() < 10 then
		    	local tlnextValue = CCBCenter.getNodeByTag(_node, 210,"CCLabel")		
		    	
		    	local str = _s("TALENT_NEEDLV")..item:getNextNeedLv()
		    	-- print("等级：：：：："..str)
		  		tlnextValue:setString(string.format(item:getTitle(),item:getNextValue())..str)
		  		tlnextValue:setColor(COLOR3.WHITE)
		  		if ME:getLv() < tonumber(item:getNextNeedLv()) then
		  			tlnextValue:setColor(COLOR3.RED)
		  		end
		  	else
		  		local tlnextValue = CCBCenter.getNodeByTag(_node, 210,"CCLabel")		
		  		tlnextValue:setString("")
		  		tlnextValue:setColor(COLOR3.WHITE)
	  		end
	  	--滚动条
	  		_tlprogress:runProgressTo( 1.0, item:getCurexp()/item:getNextexp()*100,false,nil,
		  			function (progressBar,percentage,totalPercentage)
		  				
		  			end 
	  		) 
	  	--判断是不是升级了
	  		if tonumber(_prevLv) < tonumber(item:getLv()) then
	  			--升级动画
				if _nodeTable["doanimation"] then
					-- print("执行动画")
			  		doAnimation(cell)
			   		_nodeTable["doanimation"] = false
				end 		
	  		end
	  	--设置按钮状态   10级不可点击
	  		if item:getLv() == 10 then
	  			_nodeTable["mBtnUpTalent"]:setEnabled(false)
	  		else
	  			_nodeTable["mBtnUpTalent"]:setEnabled(true)
	  		end
	  	--升级需要的钻石
		  	_diamondNum =	math.floor(GAMERATE:getTalentDiamondRate()*(item:getNextexp() - item:getCurexp()))
		  	_node:setButtonTitle("btnDiamond", 
								_diamondNum,
				 				nil,
				  				CCControlStateNormal)
		--需要放到最后面， 因为滚动条需要先判断升级动画
		_prevLv = item:getLv()
	end

--cell内容设置
	local function createCell( grid,index,item )
    		
		  local cell = display.newSprite("talent/talent_cell_back.png", 0, 0)
		  cell:setOpacity(0)
          transition.fadeIn(cell , {time = 1.0})
          cell:ignoreAnchorPointForPosition(false)
          cell:setTag( 3 )

	--天赋背景
          local talentBackSp = display.newSprite("talent/talent_talentback.png", 0, 0)
          local talentBackNode = widget.newNode{contentSize = talentBackSp:getContentSize()}
          util.alignNode(talentBackSp, talentBackNode:getContentSize(), display.CENTER )
          talentBackNode:addChild(talentBackSp)
          util.alignNodeWithPadding(talentBackNode, cell:getContentSize(), display.CENTER) 
          cell:addChild(talentBackNode, 3)
    --天赋图标
          local talentSp = widget.newSprite({file = format("talent/talent_%s_%s.png", item:getCamp(), item:getTyp())})
          util.alignNodeWithPadding(talentSp, talentBackSp:getContentSize(), display.CENTER, {top = -3, left = -3}) 
          talentBackSp:addChild(talentSp)
	--天赋等级         
		  local tlLVSp = display.newSprite("talent/talent_cell_lvback.png", 0, 0)
		  local topNode = widget.newNode{contentSize = tlLVSp:getContentSize()}
          util.alignNode(tlLVSp, topNode:getContentSize(), display.CENTER )
          topNode:addChild(tlLVSp)          
		  util.alignNodeWithPadding(topNode, talentBackNode:getContentSize(), display.BOTTOM_RIGHT, {})
          talentBackNode:addChild(topNode)
 
          local lastLoginTimeStrLB = widget.newTTFLabelWithShadow{ 
                                        size = 20,
                                        color = ccc3(0, 74, 36),
                                        text = tostring(item:getLv()),
                                        textAlign = ui.TEXT_ALIGN_CENTER,
           }
           topNode:addChild(lastLoginTimeStrLB)
           util.alignNodeWithPadding(lastLoginTimeStrLB, topNode:getContentSize(), display.CENTER, {top = 2})
    --升级需要的钻石数
		   _diamondNum =	math.floor(GAMERATE:getTalentDiamondRate()*(item:getNextexp() - item:getCurexp()))
		return cell
    end

--创建table
    local function createTable()
    
        local function createItemCellListener( grid,index,item )
        	local cell = createCell(grid,index,item)
          	return cell
	    end

	    local function modifyItemCellListener( grid,index,item,itemCell )
	    end

	    local function tapListener( grid,index,item )
	    	
	    	_selectOffset = _gridTable:getContentOffset()
            
	    --删除上一行的选中状态
	    	if _prevIndex then
		    	local prevCell = grid:cellAt(_prevIndex)
		    	prevCell:removeChildByTag(2, true)
		    	prevCell:removeChildByTag(4, true)
	    	end
	    --设置选中行的所有对应状态
	    	setSelectCell(index, item)
	    
	    end

	--tableNode
	    _tableNode = CCBCenter.getNodeByTag(_node, 4) 

	    _gridTable = widget.newScrollGrid{
	        contentSize = _tableNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize( 188, 138),
	            padding = { 
	                middleH = 0, middleV = 0,
	                left = 0, right = 0, top = 15, bottom = 0,
	            },
	            row = 2,
	            createItemCellListener = createItemCellListener,
	            modifyItemCellListener = modifyItemCellListener,
	            tapListener = tapListener,
	            selectedParams = nil,
	        },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = _tableNode,
	    }
    end

--经验滚动条监听
	local function onProgressListener( progressBar, percentage, totalPercentage )

		

	end


    local function initUserInfo( ... )
    --等级
    	CCBCenter.getNodeByTag(_node, 306,"CCLabel"):setString(ME:getLv())	
	--召唤值
  		CCBCenter.getNodeByTag(_node, 312,"CCLabel"):setString(ME:getUsedcost().."/"..ME:getTotalcost())
	--生命
		CCBCenter.getNodeByTag(_node, 310,"CCLabel"):setString(ME:getHp())
	--总攻击
		CCBCenter.getNodeByTag(_node, 304,"CCLabel"):setString(ME:getTotalatk())
		util.modifyPositionInAndroid( CCBCenter.getNodeByTag(_node, 304), 0, -1 )
	--总血量
		CCBCenter.getNodeByTag(_node, 308,"CCLabel"):setString(ME:getTotalHp())
	--昵称
		CCBCenter.getNodeByTag(_node, 313,"CCLabel"):setString(ME:getName())
		util.modifyPositionInAndroid( CCBCenter.getNodeByTag(_node, 313), 0, 3 )
	--标题
		CCBCenter.getNodeByTag(_node, 7,"CCLabel"):setString(_s("TALENT_TITLE"))
    -- 头像
        local headLayer = CCBCenter.getNodeByTag(_node, 302)
        headLayer:removeAllChildrenWithCleanup(true)
		local head = ME:createPlayerHeadRectView()
		-- head:setScale((head:getContentSize().width) / headLayer:getContentSize().width)
        headLayer:addChild(head)
        head:setScale(0.62)
        util.alignNode(head, headLayer, display.CENTER , {top = -2, left = -14,})
    --增加经验ProgressBar
        _tlprogress = widget.newProgressBar{
	                                    frontSprintParams = {file = "talent/talent_expblackback.png",},
	                                    bgSprintParams = {file = "talent/talent_expblueback.png"},
	                                    percentage = 0,
	                                    reverseProgress = true,
	                                    updateProgressListener = onProgressListener,
	                                    ttfLabelParams = {size = 14/SCALE_FOR_SPECIAL_NODE, padding = {top = 3}},
        }
        _tlprogress:ignoreAnchorPointForPosition(true)
        CCBCenter.getNodeByTag(_node, 215):addChild(_tlprogress)
        
        
    --隐藏升级卡牌选择界面
    	CCBCenter.getNodeByTag(_node, 6):setVisible(false)
    end

--[[ ## local fuction --]]
	-- 新手引导
    local function checkHelperInfo( )
        HelperView2.showBetween(_node, nil, {50060, 50080})
    end
	local function initViews()
		
	--创建table
		createTable()
	--玩家信息
		initUserInfo()
		checkHelperInfo()
	end

	local function getDiamond( ... )
		return _diamondNum
	end

--[[ ## public fuction --]]

	_node.callBackTalent = callBackTalent
	_node.alertUpTalentPanel = alertUpTalentPanel
	_node.callBackUpTalent = callBackUpTalent
	_node.canTouch = canTouch
	_node.popToolLayer = popToolLayer
	_node.getDiamond = getDiamond
--[[ ## MAINs --]]
	initViews()
end

return M