--TeamAddMemberLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TeamAddMemberLayerView]"
	local _node, _nodeTable = node, luaValue
    local _memberScrollGrid
    local _data
    local TeamViewUtil = require("cardui.TeamViewUtil")
--[[ ## local fuction --]]
    local function createMemberScrollGrid( )
        local layer = CCBCenter.getNodeByTag(_node, 3)
        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- 背景
            local bgFile = "team/bg_team_member.png"
            local bgSprite = widget.newScale9{
                file = bgFile,
                rect = CCRect(0, 0, 117, 154),
                contentSize = CCSizeAdd(grid:getCellSize(), 0, -10),
            }
            cell:addChild(bgSprite, 0)
            util.alignNode(bgSprite, cell:getContentSize(), display.CENTER_BOTTOM)

            -- 头像
            local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(headNode, 2)
            util.alignNode(headNode, cell:getContentSize(), display.TOP_LEFT, {left = 10})

            local bgHead = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            headNode:addChild(bgHead, 0)
            util.alignNode(bgHead, headNode:getContentSize(), display.CENTER)
            local bgFrameHead = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            headNode:addChild(bgFrameHead, 1)
            util.alignNode(bgFrameHead, headNode:getContentSize(), display.CENTER) 

            local heroHead = PlayerHead.new(item.sex, item.head, item.equiplst):createRect()
            headNode:addChild(heroHead, 2)
            util.alignNode(heroHead, headNode:getContentSize(), display.CENTER)
            heroHead:setScale(0.5)
            if item.id ~= ME:getUserid() then
                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {fid = item.id, fnNextView = function ( )
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                        end})
                        
                    end,
                    container = layer,
                }
            end
            -- 等级
            local lvLabel = widget.newTTFLabelWithShadow{
                text = "LV:" .. item.lv,
                size = 18,
            }
            headNode:addChild(lvLabel, 3)
            util.alignNode(lvLabel, headNode, display.TOP_LEFT, {left = 10, top = 4})
            -- 名字
            local nameNode = widget.newNode{contentSize = CCSize(194, 45)}
            cell:addChild(nameNode, 1)
            util.alignNode(nameNode, cell:getContentSize(), display.TOP_LEFT, {left = 120, top = 20})
            local bgNameFile = "team/bg_team_member_text.png"
            local bgName = widget.newScale9{
                file = bgNameFile,
                rect = CCRect(0, 0, 90, 45),
                contentSize = nameNode:getContentSize(),
            }
            nameNode:addChild(bgName, 0)
            util.alignNode(bgName, nameNode:getContentSize(), display.CENTER)
            local nameLabel = ui.newTTFLabel{text = item.name,}
            nameNode:addChild(nameLabel, 1)
            util.alignNode(nameLabel, nameNode:getContentSize(), display.CENTER_LEFT, 10)

            -- 上次登陆时间
            local contentNode = widget.newNode{contentSize = CCSize(540, 45)}
            cell:addChild(contentNode, 1)
            util.alignNode(contentNode, cell:getContentSize(), display.TOP_LEFT, {left = 380, top = 20})
            local bgContent = widget.newScale9{
                file = bgNameFile,
                rect = CCRect(0, 0, 90, 45),
                contentSize = contentNode:getContentSize(),
            }
            contentNode:addChild(bgContent, 0)
            util.alignNode(bgContent, contentNode:getContentSize(), display.CENTER)
            local dateLabel = ui.newTTFLabel{text = item.content,}
            contentNode:addChild(dateLabel, 1)
            util.alignNode(dateLabel, contentNode:getContentSize(), display.CENTER_LEFT, 10)

            -- 卡牌
            item.parentNode = layer
            local cardsLayer = TeamViewUtil:createCardLayer(item)
            cell:addChild(cardsLayer)
            util.alignNode(cardsLayer, cell:getContentSize(), display.CENTER_LEFT, {left = 120, top = 28})

            local addButton = widget.newButton{
                normalImage = "common/buttons/btn_normal_green.png",
                contentSize = CCSize(129, 58),
                rect = CCRect(0, 0, 80, 58),
                scale = 1.1,
                labelParams = {text = _s("TEAM_ADD_MEMBER"), color = BUTTON_COLOR3.BROWN, },
                listener = function ( button )
                    if _data.teamerCount < GAMERATE:getTeamMemberLimit() then
                        button.setStateDisabled(true)
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHADDTEAMER, nil, {pid = item.id, typ = 1,})
                    else
                        NetHelper.QuickToast(_s("TEAM_MEMBER_FULL"))
                    end
                end,
            }
            cell:addChild(addButton, 1)
            util.alignNode(addButton, cell:getContentSize(), display.BOTTOM_RIGHT, {right = 160, bottom = 10})

            local delButton = widget.newButton{
                normalImage = "common/buttons/btn_normal_green.png",
                contentSize = CCSize(129, 58),
                rect = CCRect(0, 0, 80, 58),
                scale = 1.1,
                labelParams = {text = _s("COMMON_REFUSE"), color = BUTTON_COLOR3.BROWN, },
                listener = function ( button )
                    button.setStateDisabled(true)
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMADDMEMBERLAYER_ACTION_ONFETCHADDTEAMER, nil, {pid = item.id, typ = 2,})
                end,
            }
            cell:addChild(delButton, 1)
            util.alignNode(delButton, cell:getContentSize(), display.BOTTOM_RIGHT, 10)

            return cell
        end
        -- local function onBtnClick(grid, index, item, x, y)
            
        -- end
        local scrollGrid = widget.newScrollGrid{
            contentSize = layer:getContentSize(),
            contentParams = {
                cellSize = CCSize( 952, 170),
                column = 1,
                createItemCellListener = createItemCellListener,
                -- tapListener = onBtnClick,
                padding = {top = 4, left = 4, right = 4,}
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = layer,
        }
        return scrollGrid 
    end
    local function setMemberCount( count )
        _nodeTable["mTeamMemberCountLabel"]:setString(count .. " / " .. GAMERATE:getTeamMemberLimit())
    end
    local function updateNoAppMember( count )
        _nodeTable["mNoAppMemberLabel"]:setVisible(count <= 0)
    end
	local function initViews()
        setMemberCount(_node._COUNT)
        _memberScrollGrid = createMemberScrollGrid()
	end

--[[ ## public fuction --]]
    local function updateData( data )
        _data = data
        _memberScrollGrid:setItems(data.teamers)
        updateNoAppMember(#data.teamers)
        setMemberCount(data.teamerCount)
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData = updateData
end

return M