--TeamCreateAlertLayer.lua
local ChatUtil                  = require("ccb.m.chat.ChatUtil")
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TeamCreateAlertLayerView]"
	local _node, _nodeTable = node, luaValue
    local _editBox
    local MAX_LENGTH    = 10
    local MIN_LENGTH    = 3
    local _limitDiamond = _node._DIAMOND or 500
    local _limitLv      = _node._LV or 30
--[[ ## local fuction --]]
    local function createEditTeamName( )
        local layer = CCBCenter.getNodeByTag(_node, 20102)
        local editbox = widget.newEditBox{
            contentSize = CCSize(layer:getContentSize().width, layer:getContentSize().height) ,
            normalBgImage = {file = "hook_ac.png"},
            placeHolderText = _s("TEAM_NO_NAME"),
            textMaxLength   = MAX_LENGTH,
        }
        editbox:setInputMode(kEditBoxInputModeSingleLine)
        layer:addChild(editbox, 1)
        -- editbox:setMaxLength(MAX_LENGTH)
        util.alignNode(editbox, layer:getContentSize(), display.CENTER)
        return editbox
    end
    -- 加入创建规则
    local function addTextContent( content )
        local node = CCBCenter.getNodeByTag(_node, 20103)
        local scrollView = widget.newScrollView{bounceable = false, contentSize = node:getContentSize(), direction = widget.TABLEVIEW_DIRECTION_VERTICAL, }
        node:addChild(scrollView)

        local textLabel = ui.newTTFLabel{text = "", color = COLOR_WHITE, size = 24}
        local size = scrollView:getContentSize()
        textLabel:setDimensions(CCSize(size.width, 0))
        textLabel:setVerticalAlignment(ui.TEXT_VALIGN_TOP)
        textLabel:setHorizontalAlignment(ui.TEXT_ALIGN_CENTER)
        textLabel:setString(content)
        scrollView:setContainer(textLabel)
        scrollView:updateInset()
        util.autoFixScrollView(scrollView)
    end
	local function initViews()
        util.delayCall(function ( )
            _editbox = createEditTeamName( )
        end, 0.2)
		addTextContent(_s("TEAM_CREATE_LIMIT", _limitLv, _limitDiamond))
	end

--[[ ## public fuction --]]
    local function getCode( )
        return _editbox:getText()
    end
    -- 是否规范
    local function isCompliance( )
        if ME:getLv() < _limitLv then
            NetHelper.QuickToast(_s("TEAM_CREATE_LEVEL_NOT_ENOUGH"))
            return false
        elseif ME:getDiamond() < _limitDiamond then
            NetHelper.QuickToast(_s("TEAM_DIAMOND_NOT_ENOUGH"))
            return false
        elseif getCode( ) == "" then
            NetHelper.QuickToast(_s("TEAM_NO_NAME"))
            return false
        elseif ChatUtil.getTextCount2(getCode( )) > 30 then
            NetHelper.QuickToast(_s("TEAM_NAME_OVERFLOW"))
            return false
        else
            return true
        end
    end

    --隐藏输入框
    local function isHideEditBox( isHide )
        _editbox:setVisible(not isHide)
    end
--[[ ## MAINs --]]
	initViews()
    _node.getCode   = getCode
    _node.isCompliance   = isCompliance
    _node.isHideEditBox   = isHideEditBox
end

return M