--TeamListLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TeamListLayerView]"
	local _node, _nodeTable = node, luaValue
    local _teamListScrollGrid
    local _data
    local _editMessageBox, _editSearchBox
    local TeamViewUtil = require("cardui.TeamViewUtil")
--[[ ## local fuction --]]
    local function createTeamListScrollGrid( )
        local layer = CCBCenter.getNodeByTag(_node, 3)
        local function createItemCellListener( grid, index, item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)

            -- 背景
            local bgFile = "team/bg_team_list.png"
            local bgSprite = widget.newScale9{
                file = bgFile,
                rect = CCRect(0, 0, 117, 113),
                contentSize = CCSizeAdd(grid:getCellSize(), 0, -20) ,
            }
            cell:addChild(bgSprite, 0)
            util.alignNode(bgSprite, cell, display.TOP_CENTER)

            -- 头像
            local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(headNode, 2)
            util.alignNode(headNode, cell:getContentSize(), display.TOP_LEFT, {top = 6, left = 16})

            local bgHead = widget.newSprite{
                file = "common/bg/bg_card_head.png",
            }
            headNode:addChild(bgHead, 0)
            util.alignNode(bgHead, headNode:getContentSize(), display.CENTER)
            local bgFrameHead = widget.newSprite{
                file = "common/bg/bg_card_head_frame.png",
            }
            headNode:addChild(bgFrameHead, 1)
            util.alignNode(bgFrameHead, headNode:getContentSize(), display.CENTER) 

            local heroHead = PlayerHead.new(item.leader.sex, item.leader.head, item.leader.equiplst):createRect()
            headNode:addChild(heroHead, 2)
            util.alignNode(heroHead, headNode)
            heroHead:setScale(0.5)
            if item.leader.id ~= ME:getUserid() and item.serid == 0 then
                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        CCBCenter.loadCCB("MSG_FRIENDPANELLAYER_MODEL", "ccb.c.friend.FriendPanelLayer", {fid = item.leader.id, fnNextView = function ( )
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                        end})
                    end,
                    container = layer,
                }
            end
            -- 名字
            local nameNode = widget.newNode{contentSize = CCSize(194, 45)}
            cell:addChild(nameNode, 1)
            util.alignNode(nameNode, cell:getContentSize(), display.TOP_LEFT, {left = 120, top = 6})
            local bgNameFile = "team/bg_team_member_text.png"
            local bgName = widget.newScale9{
                file = bgNameFile,
                rect = CCRect(0, 0, 90, 45),
                contentSize = nameNode:getContentSize(),
            }
            nameNode:addChild(bgName, 0)
            util.alignNode(bgName, nameNode:getContentSize(), display.CENTER)
            local nameLabel = ui.newTTFLabel{text = item.tname,}
            nameNode:addChild(nameLabel, 1)
            util.alignNode(nameLabel, nameNode:getContentSize(), display.CENTER_LEFT, 10)
            -- 宣言信息
            local declarationNode = widget.newNode{contentSize = CCSize(500, 45)}
            cell:addChild(declarationNode, 1)
            util.alignNode(declarationNode, cell, display.TOP_LEFT, {left = 330, top = 6})
            local bgdeclaration = widget.newScale9{
                file = bgNameFile,
                rect = CCRect(0, 0, 90, 45),
                contentSize = declarationNode:getContentSize(),
            }
            declarationNode:addChild(bgdeclaration, 0)
            util.alignNode(bgdeclaration, declarationNode:getContentSize(), display.CENTER)
            local declarationLabel = ui.newTTFLabel{text = item.declaration,contentSize = declarationNode:getContentSize()}
            declarationNode:addChild(declarationLabel, 1)
            util.alignNode(declarationLabel, declarationNode:getContentSize(), display.CENTER_LEFT, 10)
            -- 查看按钮
            local viewButton = widget.newButton{
                normalImage = "common/buttons/btn_normal_green.png",
                contentSize = CCSize(129, 56),
                rect = CCRect(0, 0, 80, 58),
                scale = 1.1,
                container = layer,
                labelParams = {text = _s("COMMON_VIEW"), color = BUTTON_COLOR3.BROWN, },
                listener = function ( button )
                    if not _node.isNeedSelect() then
                        local fromKey = _node._SERTYPE == 2 and 5 or 6
                        CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = item.tid, serid = item.serid, fromKey = fromKey})
                    end
                end,
            }
            cell:addChild(viewButton, 1)
            util.alignNode(viewButton, cell, display.BOTTOM_RIGHT, {right = 10})
            -- 加入按钮
            if TRUE == item.showadd then
                local joinButton = widget.newButton{
                    normalImage = "common/buttons/btn_normal_green.png",
                    contentSize = CCSize(129, 56),
                    rect = CCRect(0, 0, 80, 58),
                    scale = 1.1,
                    container = layer,
                    labelParams = {text = _s("TEAM_JOIN"), color = BUTTON_COLOR3.BROWN, },
                    listener = function ( button )
                        if not _node.isNeedSelect() then
                            AlertLayer.new{
                                btnStr = {_s("COMMON_OK"), _s("COMMON_CANCEL")},
                                btnColor = {AlertLayer.BTN_COLOR_YELLOW, AlertLayer.BTN_COLOR_BLUE, },  
                                titleStr = _s("TEAM_JOIN_TEAM"),  --标题
                                content = _s("TEAM_JOIN_TEAM_INFO"),  --内容
                                btnClickEvent = {
                                    function ( )
                                        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHJOINTEAM, nil, {tid = item.tid})
                                    end,
                                },
                            }
                        end
                    end,
                }
                cell:addChild(joinButton, 1)
                util.alignNode(joinButton, cell, display.BOTTOM_RIGHT, {right = 150})
            end
            -- 战队ID, 战队人数, 战队积分
            local memoLabel = ui.newTTFLabel{
                text = _s("TEAM_TEAM_MEMO", item.sername, item.tno, item.playercount, GAMERATE:getTeamMemberLimit(), item.point), 
                color = BUTTON_COLOR3.BROWN,
                size = 20,
            }
            cell:addChild(memoLabel, 1)
            util.alignNode(memoLabel, cell, display.BOTTOM_LEFT, {left = 120, bottom = 30,})
            
            return cell
        end
        -- local function onBtnClick(grid, index, item, x, y)
            
        -- end
        local scrollGrid = widget.newScrollGrid{
            contentSize = layer:getContentSize(),
            contentParams = {
                cellSize = CCSize( 840, 130),
                column = 1,
                createItemCellListener = createItemCellListener,
                -- tapListener = onBtnClick,
                padding = {top = 18,}
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            -- parentNode = layer,
        }
        layer:addChild(scrollGrid)
        return scrollGrid 
    end
    local function createSearchBox( )
        local node = CCBCenter.getNodeByTag(_node, 20403)
        local searchBox = widget.newEditBox{
            contentSize = node:getContentSize(),-- CCSize(node:getContentSize().width - 70, node:getContentSize().height) ,
            -- x = node:getPositionX() ,
            -- y = node:getPositionY() - 3,
            normalBgImage = {file = "hook_ac.png"},
        }
        searchBox:setInputMode(kEditBoxInputModeSingleLine)
        node:addChild(searchBox)
        searchBox:setMaxLength(6)
        util.alignNode(searchBox, node)
        return searchBox
    end
    local function showCardFilterLayer( isNeed )
        CCBCenter.loadCCB("MSG_CARDFILTERLAYER_MODEL", "ccb.c.cardgroup.CardFilterLayer", {_KEY = MSG_ID.MSG_TEAMLISTLAYER_MODEL, _ISNEED = isNeed})
    end
    local function saveAppMessage( message )
        CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMLISTLAYER_ACTION_ONFETCHTEAMAPPCONTENT, nil, {app = message,})
    end
    local function updatePageButton( )
        -- if 1 == _node._PAGE then
            _nodeTable["btnLast"]:setEnabled(not (1 == _node._PAGE))
        -- end
        -- if 0 == _data.teams then
            _nodeTable["btnNext"]:setEnabled( _node._PAGE < _node._MAXPAGE)
        -- end
    end
	local function initViews()
		_teamListScrollGrid = createTeamListScrollGrid( )
        -- 玩家头像
        local headNode = CCBCenter.getNodeByTag(_node, 20303)
        headNode:removeAllChildrenWithCleanup(true) 
        local roleHead = ME:createPlayerHeadRectView()
        roleHead:setScale(0.5)
        headNode:addChild(roleHead)
        util.alignNode(roleHead, headNode)
        -- 姓名
        _nodeTable["mTeamNameLabel"]:setString(ME:getName())
        -- 申请信息
        _editMessageBox = TeamViewUtil:createEditBoxWithButton{
            parentNode = CCBCenter.getNodeByTag(_node, 206),
            onSaveClick = saveAppMessage,
        }
        -- 搜索
        _editSearchBox = createSearchBox()
        updatePageButton( )
	end

--[[ ## public fuction --]]
    local function isNeedSelect( )
        if not _data then
            NetHelper.QuickToast(_s("NETWORK_NOT_GOOD"))
            return nil
        else
            if _data.needselect == TRUE then
                NetHelper.QuickToast(_s("TEAM_CONFIG_CARD_FIRST"))
                return true
            else
                return false
            end
        end
    end
    local function getSearchKey( )
        return _editSearchBox:getText()
    end
    local function getSerId( )
        if not _data or not _data.serid then
            return nil
        else
            return _data.serid
        end
    end
    local function updateData( data )
        _data = data
        _teamListScrollGrid:setItems(data.teams)
        data.handler = showCardFilterLayer
        _node._MAXPAGE = data.maxpagecount
        -- 卡牌
        local cardNode = CCBCenter.getNodeByTag(_node, 208)
        cardNode:removeAllChildrenWithCleanup(true)
        local cardLayer = TeamViewUtil:createCardLayer(data)
        cardNode:addChild(cardLayer)
        util.alignNode(cardLayer, cardNode, display.LEFT_CENTER)
        _editMessageBox:setString(data.content)
        -- 需要配置卡牌
        if TRUE == data.needselect then
            showCardFilterLayer( true )
        end
        updatePageButton( )
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData = updateData
    _node.isNeedSelect = isNeedSelect
    _node.getSerId = getSerId
    _node.getSearchKey = getSearchKey
end

return M