--TeamMainLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TeamMainLayerView]"
	local TeamViewUtil = require("cardui.TeamViewUtil")
    local _node, _nodeTable = node, luaValue
    local _sameServerCdTimer, _interServerCdTimer
    
--[[ ## local fuction --]]
    -- 阴影文字
    local function addShadowCenterById( nodeId, text )
        local node = CCBCenter.getNodeByTag(_node, nodeId)
        local ttfLabel = widget.newTTFLabelWithOutline{
            text = text,
            size = 22,
        }
        node:addChild(ttfLabel)
        util.alignNode(ttfLabel, node)
    end
    -- 倒计时
    local function createCdTimer( )
        local timer = CountDownView.new{ 
            format = _s("TEAM_WAR_TIME_FORMAT"),
            labelParams = {size = 22},
            listener = function(timer)
                timer:stop()
                CCBCenter.sendLuaMessage(MSG_ID.MSG_TEAMMAINLAYER_ACTION_ONFETCHTEAMINDEX)
            end
        }
        timer:setVisible(false)
        return timer
    end
	local function initViews()
        -- 文字阴影
        addShadowCenterById(50103, _s("TEAM_MY_TEAM"))
        addShadowCenterById(50203, _s("TEAM_RULE_DETAIL"))
        addShadowCenterById(50303, _s("TEAM_REWARDS_DETAIL"))
        -- 创建cdTimer
		_sameServerCdTimer = createCdTimer()
        sameServerCdNode = CCBCenter.getNodeByTag(_node, 30303)
        sameServerCdNode:addChild(_sameServerCdTimer)
        util.alignNodeWithPadding(_sameServerCdTimer, sameServerCdNode)
        _interServerCdTimer = createCdTimer()
        interServerCdNode = CCBCenter.getNodeByTag(_node, 40303)
        interServerCdNode:addChild(_interServerCdTimer)
        util.alignNodeWithPadding(_interServerCdTimer, interServerCdNode)
	end

--[[ ## public fuction --]]
    local function getCreateLimit( )
        if not _data then
            NetHelper.QuickToast(_s("NETWORK_NOT_GOOD"))
            return nil
        else
            local resule = {
                needlv = _data.needlv,
                needdiamond = _data.needdia,
            }   
            return resule
        end
    end
    -- 是否在队伍中
    local function inTeam( )
        if not _data then
            NetHelper.QuickToast(_s("NETWORK_NOT_GOOD"))
            return false
        else
            if FALSE == _data.btnstatus then
                return false
            elseif TRUE == _data.btnstatus then
                return true
            end
        end
    end
    local function updateData( data )
        _data = data
        -- 区赛时间
        _nodeTable["mSameServerTimeTitleLabel"]:setString(TeamViewUtil:getFightStatusText(data.status))
        _sameServerCdTimer:setVisible(true)
        if data.time and data.time > 0 then
            _sameServerCdTimer:start(data.time)
        else
            _sameServerCdTimer:modifyTime(0)
            _sameServerCdTimer:stop()
        end
        -- 跨服赛时间
        _nodeTable["mInterServerTimeTitleLabel"]:setString(TeamViewUtil:getFightStatusText(data.status2, true))
        _interServerCdTimer:setVisible(true)
        if data.time2 and data.time2 > 0 then
            _interServerCdTimer:start(data.time2)
        else
            _interServerCdTimer:modifyTime(0)
            _interServerCdTimer:stop()
        end
        -- 冠军状态
        _nodeTable["mSameServerTitleLabel"]:setString(0 == data.status and _s("TEAM_LAST_SAME_SERVER_CHAMPIONS") or _s("TEAM_THIS_SAME_SERVER_CHAMPIONS"))
        _nodeTable["mInterServerTitleLabel"]:setString(0 == data.status2 and _s("TEAM_LAST_INTER_SERVER_CHAMPIONS") or _s("TEAM_THIS_INTER_SERVER_CHAMPIONS"))

        -- 冠军名称
        _nodeTable["mSameServerLabel"]:setString(ME:getSername())
        _nodeTable["mSameServerLabel"]:setVisible(data.tname and data.tname ~= "")
        _nodeTable["mSameSeverChampionsLabel"]:setString(data.tname)
        _nodeTable["mInterServerChampionsLabel"]:setString(data.tname2)
        _nodeTable["mInterServerLabel"]:setString(data.sername)
        _nodeTable["mInterServerLabel"]:setVisible(data.tname2 and data.tname2 ~= "")

        -- 说明
        _nodeTable["mTipLabel"]:setString(data.showstr)
    end
--[[ ## MAINs --]]
	initViews()
    _node.updateData = updateData
    _node.inTeam = inTeam
    _node.getCreateLimit = getCreateLimit
end

return M