--TeamWarReviewLayer.lua
local M = {}

function M.bindView(node, luaValue, ...)
	local TAG = "[TeamWarReviewLayerView]"
	local _node, _nodeTable = node, luaValue
	--数据
	local data = ...

	--历史记录
	local records = data.records8

	--结点
	local node = data.node

	--历史记录Layer
	local _warLayer
	--历史记录grid
	local _warGrid

    --创建战队头像
    local function createTeamHead( cell,teamer,isWin,teamLayer )

        local path
        if isWin == 1 then
            path = display.CENTER_LEFT
        else
            path = display.CENTER_RIGHT
        end
        local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
        teamLayer:addChild(headNode, 10000)
        util.alignNode(headNode, teamLayer:getContentSize(), path, {left = 10,top = - 2})

        local teamHeadBg = display.newSprite("common/bg/bg_card_head.png")
        util.alignNode(teamHeadBg, headNode)
        headNode:addChild(teamHeadBg) 

        local teamHeadBg_1 = display.newSprite("common/bg/bg_card_head_frame.png")
        util.alignNode(teamHeadBg_1, headNode)
        headNode:addChild(teamHeadBg_1) 

        local leader = teamer.leader
        local heroHead = PlayerHead.new(leader.sex, leader.head, leader.equiplst):createRect()
        headNode:addChild(heroHead, 2)
        util.alignNode(heroHead, headNode)
        heroHead:setScale(0.5)

        -- 绑定头像点击
        widget.bindTouchEvent{
            layer = headNode,
            clickListener = function ( )
               local fromKey = data._TYP2 == 2 and 7 or 8
               CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = teamer.tid, serid = teamer.serid, fromMain = true, fromKey = fromKey})
            end,
            container = layer,
        }
    end

	--刷新历史战役
	local function reloadWarGrid( ... )
		
		local warsTable = {}

		for i,v in ipairs(records) do

			if v.node == node then
				local war = {title = nil,war = v}
	            table.insert(warsTable,war)
	        end
		end

		_warGrid:setItems(warsTable)
	end

	--我的战绩grid
	local function createWarGrid( ... )

		local _myWarNode = CCBCenter.getNodeByTag(_node, 301)

        local function tapListener( grid, index, item )

        end

        local function cellAtIndex(scrollGrid, index, item)

            local cell = widget.newLayer()
            cell:ignoreAnchorPointForPosition(false)

            cell:setContentSize(CCSize(_myWarNode:getContentSize().width,110))

            -- 背景
            local bgSprite = widget.newScale9{
                file = "team/bg_my_war.png",
                rect = CCRectMake(0, 0, 117, 113) , 
                contentSize = CCSize(850,110)
            }
            util.alignNode(bgSprite, cell:getContentSize(), display.CENTER)
            cell:addChild(bgSprite, 0)

            --回放按钮 760 100
            local btnReview =  widget.newButton{
                scale = 1.1,
                normalImage = "common/buttons/btn_war_review.png",
                selectImage = "common/buttons/btn_war_review.png",
                listener = function ( button )
                    --CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHTEAMRECORD,nil,{rid = item.rid})
                    -- [查看记录]
                    -- 参数赋值
                    local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")         -- 战斗视图工厂
                    local recordId                  = item.war.rid                                                  -- 记录ID
                    local serid                     = item.war.serid                                                  -- 记录ID

                    
                    
                    -- 场景转换
                    FightViewFactory.viewRecordRankWar({ recordId = recordId, serid = serid, fnNextView = function() 
                            CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                            CCBCenter.loadCCB("MSG_TEAMMAINLAYER_MODEL", "ccb.c.team.TeamMainLayer")                        
                            if data._TYP2 == 1 then
                                CCBCenter.loadCCB("MSG_TEAMWARLAYER_MODEL", "ccb.c.team.TeamWarLayer")
                            else
                                CCBCenter.loadCCB("MSG_TEAMINTERSERVICELAYER_MODEL", "ccb.c.team.TeamInterServiceLayer")      
                            end                            
                            CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer",{tag = 2, typ2 = data._TYP2}) 
                            -- CCBCenter.loadCCB("MSG_TEAMWARREVIEWLAYER_MODEL", "ccb.c.team.TeamWarReviewLayer", {records8 = records, node = node, _TYP2 = data._TYP2})
                    end, })
                end
            }
            util.alignNode(btnReview, bgSprite,display.CENTER_RIGHT,{right = 10})
            bgSprite:addChild(btnReview)  

            local bgLayer = widget.newLayer{contentSize = CCSize(760,100)}     
            util.alignNode(bgLayer, bgSprite,display.CENTER_LEFT)
            bgSprite:addChild(bgLayer)  

            --VS图像
            local vsImg = display.newSprite("team/img_team_vs.png")
            util.alignNode(vsImg, bgLayer,display.CENTER)
            bgLayer:addChild(vsImg) 

            --左边部分
            local leftLayer = widget.newLayer{contentSize = CCSize(300,100)}     
            util.alignNode(leftLayer, bgLayer,display.CENTER_LEFT)
            bgLayer:addChild(leftLayer) 

            local img_1,img_2
         
            if item.war.res == 1 then
                img_1 = "team/img_team_win.png"
                img_2 = "team/img_team_lose.png"
            else
            	img_2 = "team/img_team_win.png"
                img_1 = "team/img_team_lose.png"
            end
            --战队头像
            createTeamHead(cell,item.war.team1,1,leftLayer)
            --赢
            local winImg = display.newSprite(img_1)
            winImg:setRotation(-45)
            util.alignNode(winImg, leftLayer, display.BOTTOM_CENTER, {bottom = 40, left = 40})
            leftLayer:addChild(winImg, 10001) 
            -- 服务器
            local leftServer = ui.newTTFLabel{
                text = _s("TEAM_SERVICR", item.war.team1.sername),
                color = BUTTON_COLOR3.BROWN,
                size = 20,
            }
            util.alignNode(leftServer, leftLayer, display.BOTTOM_LEFT, {bottom = 10, left = 120})
            leftLayer:addChild(leftServer, 2) 

            -- 战队名称背景
            local teamNameBg = widget.newScale9{
                file = "team/bg_team_name.png",
                rect = CCRectMake(0, 0, 90, 45) , 
                contentSize = CCSize(195,45)
            }
            util.alignNode(teamNameBg, leftLayer:getContentSize(), display.TOP_RIGHT,{top = 5})
            leftLayer:addChild(teamNameBg, 0)

            --战队名
            local teamName = ui.newTTFLabel{
                size = 25,
                text = item.war.team1.tname
            }

            util.alignNode(teamName, teamNameBg, display.CENTER,{top = 2})
            teamNameBg:addChild(teamName)

            --右边部分
            local rightLayer = widget.newLayer{contentSize = CCSize(300,100)}     
            util.alignNode(rightLayer, bgLayer,display.CENTER_RIGHT)
            bgLayer:addChild(rightLayer) 

            --战队头像
            createTeamHead(cell,item.war.team2,2,rightLayer)

            local loseNode = widget.newLayer{contentSize = CCSize(91, 91)}
            cell:addChild(loseNode, 2)
            util.alignNode(loseNode, cell:getContentSize(), display.CENTER_RIGHT, {left = 10,top = - 2})
 

            --输
            local loseImg = display.newSprite(img_2)
            loseImg:setRotation(-45)
            util.alignNode(loseImg, rightLayer,display.BOTTOM_CENTER,{bottom = 40,left = -80})
            rightLayer:addChild(loseImg, 10001) 
            -- 服务器
            local rightServer = ui.newTTFLabel{
                text = _s("TEAM_SERVICR", item.war.team2.sername),
                color = BUTTON_COLOR3.BROWN,
                size = 20,
            }
            util.alignNode(rightServer, rightLayer, display.BOTTOM_RIGHT, {bottom = 10, right = 120})
            rightLayer:addChild(rightServer, 2)

            -- 战队名称背景
            local loseTeamNameBg = widget.newScale9{
                file = "team/bg_team_name.png",
                rect = CCRectMake(0, 0, 90, 45) , 
                contentSize = CCSize(195,45)
            }
            util.alignNode(loseTeamNameBg, rightLayer:getContentSize(), display.TOP_LEFT,{top = 5})
            rightLayer:addChild(loseTeamNameBg, 0)

            --战队名
            local loseTeamName = ui.newTTFLabel{
                size = 25,
                text = item.war.team2.tname
            }

            util.alignNode(loseTeamName, loseTeamNameBg, display.CENTER,{top = 2})
            loseTeamNameBg:addChild(loseTeamName)

            return cell
        end
        --scrollview
        local scrollGrid = widget.newScrollLinear{
            contentSize = _myWarNode:getContentSize(),
            cellAtIndexListener = cellAtIndex,
            contentParams = {
                column = 1,
                tapListener = tapListener,
                selectedParams = nil,
            },
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        _myWarNode:addChild(scrollGrid)
        return scrollGrid
	end

--[[ ## local fuction --]]
	local function initViews()
		--我的战绩
		_warLayer = CCBCenter.getNodeByTag(_node, 3)

		 CCBCenter.getNodeByTag(_node, 108)

		_warGrid = createWarGrid()

		reloadWarGrid()
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M