--TeamWarSeasonReviewLayer.lua
local M = {}

function M.bindView(node, luaValue, ...)
	local TAG = "[TeamWarSeasonReviewLayerView]"
	local _node, _nodeTable = node, luaValue

    --选中的标签
    local tag = ...

	--战绩赛况Layer
	local _teamWarSeasonLayer
	--我的战绩
	local _myWarLayer
	--我的战绩grid
	local _myWarGrid
    --对战图Laye
    local _lineLayer
    --八强名字Layer
    local _team8NameLayer
    --暂无记录
    local _mNoRecordLabel
    --八强记录
    local _records8 = {}
    --八强结点
    local _recordNode 

	--创建标签
	local function createTab( tag )

		local _nodeTab = CCBCenter.getNodeByTag(_node, 504)

		local function onTabClick( index, button )

			if index == 1 then
				_teamWarSeasonLayer:setVisible(false)
				_myWarLayer:setVisible(true)
                _lineLayer:setVisible(false)
                _team8NameLayer:setVisible(false)
			else
				_teamWarSeasonLayer:setVisible(true)
				_myWarLayer:setVisible(false)
                _lineLayer:setVisible(true)
                _team8NameLayer:setVisible(true)
                _mNoRecordLabel:setVisible(false)
			end


            CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHGETWARINFO,nil,{typ = index})
        end

		local buttons = { }  
        
        local tabTitles = {_s("TEAM_MY_WAR"),_s("TEAM_WAR_SEASON")}
        for i,v in ipairs(tabTitles) do

        	local btnTab = widget.newButton{
                normalImage = "team/btn_team_normal.png",
   	    	    selectImage = "team/btn_team_select.png",
   	    	    contentSize = CCSize(170, 45),
   	    	    rect 		= CCRectMake(0, 0, 90, 45) , 
   	    	    discolor	= COLOR3.WHITE,
   	    	    labelParams = { 
			 	    text = v,
			 	    size = WEEK_TABLE_TEXT_SIZE,
			 	    color = BUTTON_COLOR3.BROWN,
                    padding = {top = 2},
			 	}
   	    	}

		    table.insert(buttons, btnTab)   

        end

        local tab = widget.newTab{
            items = buttons,
            padding = #buttons,
            listener = onTabClick,
            direction = DIRECTION_HORIZONTAL,
        }
        _nodeTab:addChild(tab)
        util.alignNodeWithPadding(tab, _nodeTab:getContentSize(), display.LEFT_CENTER)

        tab.selectButton(tag)

	end

    --创建战队头像
    local function createTeamHead( cell,teamer,isWin,teamLayer,container )

        local path
        if isWin == 1 then
            path = display.CENTER_LEFT
        else
            path = display.CENTER_RIGHT
        end

        local headNode = widget.newLayer{contentSize = CCSize(91, 91)}
        teamLayer:addChild(headNode, 10000)
        util.alignNode(headNode, teamLayer:getContentSize(), path, {left = 10,top = - 2})

        local teamHeadBg = display.newSprite("common/bg/bg_card_head.png")
        util.alignNode(teamHeadBg, headNode)
        headNode:addChild(teamHeadBg) 

        local teamHeadBg_1 = display.newSprite("common/bg/bg_card_head_frame.png")
        util.alignNode(teamHeadBg_1, headNode)
        headNode:addChild(teamHeadBg_1) 

        local leader = teamer.leader
        local heroHead = PlayerHead.new(leader.sex, leader.head, leader.equiplst):createRect()
        headNode:addChild(heroHead, 2)
        util.alignNode(heroHead, headNode)
        heroHead:setScale(0.5)

        -- 绑定头像点击
        widget.bindTouchEvent{
            layer = headNode,
            clickListener = function ( )
                local fromKey =  _node._TYP2 == 2 and 7 or 8
                CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = teamer.tid, serid = item.serid, fromMain = true, fromKey = fromKey})
            end,
            container = container,
        }

    end

	--我的战绩grid
	local function createMyWarGrid( ... )

		local _myWarNode = CCBCenter.getNodeByTag(_node, 301)

        local function cellAtIndex(scrollGrid, index, item)

            local cell = widget.newLayer()
            cell:ignoreAnchorPointForPosition(false)

            if item.title then

                --标题
                local warTitle = ui.newTTFLabel{
                    size = 25,
                    text = item.title,
                    color = BUTTON_COLOR3.BROWN
                }

                cell:addChild(warTitle)

                cell:setContentSize(CCSize(850,40 ))
                util.alignNode(warTitle, cell:getContentSize(), display.CENTER_LEFT, {left = 12 })
            else
                cell:setContentSize(CCSize(_myWarNode:getContentSize().width,110))

                -- 背景
                local bgSprite = widget.newScale9{
                    file = "team/bg_my_war.png",
                    rect = CCRectMake(0, 0, 117, 113) , 
                    contentSize = CCSize(850,110)
                }
                util.alignNode(bgSprite, cell)
                cell:addChild(bgSprite, 0)

                --回放按钮 760 100
                local btnReview =  widget.newButton{
                    scale = 1.1,
                    normalImage = "common/buttons/btn_war_review.png",
                    selectImage = "common/buttons/btn_war_review.png",
                    container = _myWarNode,
                    listener = function ( button )
                        --CCBCenter.sendLuaMessage(MSG_ID.MSG_BOSSLAYER_ACTION_ONFETCHTEAMRECORD,nil,{rid = item.rid})
                        -- [查看记录]
                        -- 参数赋值
                        local FightViewFactory          = require(PH_MDL_FACTORY .. "FightViewFactory")         -- 战斗视图工厂
                        local recordId                  = item.war.rid                                                  -- 记录ID
                        local serid                     = item.war.serid                                                  -- 记录ID

                        -- 场景转换
                        FightViewFactory.viewRecordRankWar({ recordId = recordId, serid = serid, fnNextView = function()
                                    CCBCenter.replaceScene(MAINLAYER_ID, MAINLAYER_PATH)
                                    CCBCenter.loadCCB("MSG_TEAMMAINLAYER_MODEL", "ccb.c.team.TeamMainLayer")
                                    if _node._TYP2 == 1 then
                                        CCBCenter.loadCCB("MSG_TEAMWARLAYER_MODEL", "ccb.c.team.TeamWarLayer")
                                    else
                                        CCBCenter.loadCCB("MSG_TEAMINTERSERVICELAYER_MODEL", "ccb.c.team.TeamInterServiceLayer")      
                                    end                  
                                    CCBCenter.loadCCB("MSG_TEAMWARSEASONREVIEWLAYER_MODEL", "ccb.c.team.TeamWarSeasonReviewLayer",{tag = 1, typ2 = _node._TYP2})                        
                            end, })
                    end
                }
                util.alignNode(btnReview, bgSprite, display.CENTER_RIGHT, {right = 10})
                bgSprite:addChild(btnReview)  

                local bgLayer = widget.newLayer{contentSize = CCSize(760, 100)}     
                util.alignNode(bgLayer, bgSprite, display.CENTER_LEFT)
                bgSprite:addChild(bgLayer)  

                --VS图像
                local vsImg = display.newSprite("team/img_team_vs.png")
                util.alignNode(vsImg, bgLayer)
                bgLayer:addChild(vsImg, 3) 

                --左边部分
                local leftLayer = widget.newLayer{contentSize = CCSize(300,100)}     
                util.alignNode(leftLayer, bgLayer, display.CENTER_LEFT)
                bgLayer:addChild(leftLayer) 

                if item.war.res == TRUE then
                    img_1 = "team/img_team_win.png"
                    img_2 = "team/img_team_lose.png"
                else
                    img_2 = "team/img_team_win.png"
                    img_1 = "team/img_team_lose.png"
                end

                --战队头像
                createTeamHead(cell, item.war.team1, 1, leftLayer, _myWarNode)

                --赢
                local winImg = display.newSprite(img_1)
                winImg:setRotation(-45)
                util.alignNode(winImg, leftLayer, display.BOTTOM_CENTER, {bottom = 40, left = 40})
                leftLayer:addChild(winImg, 10001) 
                -- 服务器
                local leftServer = ui.newTTFLabel{
                    text = _s("TEAM_SERVICR", item.war.team1.sername),
                    color = BUTTON_COLOR3.BROWN,
                    size = 20,
                }
                util.alignNode(leftServer, leftLayer, display.BOTTOM_LEFT, {bottom = 10, left = 120})
                leftLayer:addChild(leftServer, 2) 

                -- 战队名称背景
                local teamNameBg = widget.newScale9{
                    file = "team/bg_team_name.png",
                    rect = CCRectMake(0, 0, 90, 45) , 
                    contentSize = CCSize(195,45)
                }
                util.alignNode(teamNameBg, leftLayer:getContentSize(), display.TOP_RIGHT, {top = 5})
                leftLayer:addChild(teamNameBg, 0)
               
                --战队名
                local teamName = ui.newTTFLabel{
                    size = 25,
                    text = item.war.team1.tname
                }

                util.alignNode(teamName, teamNameBg, display.CENTER, {top = 2})
                teamNameBg:addChild(teamName)

                --右边部分
                local rightLayer = widget.newLayer{contentSize = CCSize(300,100)}     
                util.alignNode(rightLayer, bgLayer,display.CENTER_RIGHT)
                bgLayer:addChild(rightLayer) 

                --战队头像
                createTeamHead(cell,item.war.team2,2,rightLayer,_myWarNode)

                local loseNode = widget.newLayer{contentSize = CCSize(91, 91)}
                cell:addChild(loseNode, 2)
                util.alignNode(loseNode, cell:getContentSize(), display.CENTER_RIGHT, {left = 10,top = - 2})

                --输
                local loseImg = display.newSprite(img_2)
                loseImg:setRotation(-45)
                util.alignNode(loseImg, rightLayer,display.BOTTOM_CENTER,{bottom = 40,left = -80})
                rightLayer:addChild(loseImg, 10001) 
                -- 服务器
                local rightServer = ui.newTTFLabel{
                    text = _s("TEAM_SERVICR", item.war.team2.sername),
                    color = BUTTON_COLOR3.BROWN,
                    size = 20,
                }
                util.alignNode(rightServer, rightLayer, display.BOTTOM_RIGHT, {bottom = 10, right = 120})
                rightLayer:addChild(rightServer, 2)
                -- 战队名称背景
                local loseTeamNameBg = widget.newScale9{
                    file = "team/bg_team_name.png",
                    rect = CCRectMake(0, 0, 90, 45) , 
                    contentSize = CCSize(195,45)
                }
                util.alignNode(loseTeamNameBg, rightLayer:getContentSize(), display.TOP_LEFT,{top = 5})
                rightLayer:addChild(loseTeamNameBg, 0)

                --战队名
                local loseTeamName = ui.newTTFLabel{
                    size = 25,
                    text = item.war.team2.tname
                }

                util.alignNode(loseTeamName, loseTeamNameBg, display.CENTER,{top = 2})
                loseTeamNameBg:addChild(loseTeamName)
            end

            return cell
        end
        --scrollview
        local scrollGrid = widget.newScrollLinear{
            contentSize = _myWarNode:getContentSize(),
            cellAtIndexListener = cellAtIndex,
            contentParams = {
                column = 1,
                tapListener = tapListener,
                selectedParams = nil,
            },
            container = _myWarNode,
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
        }
        _myWarNode:addChild(scrollGrid)
        return scrollGrid
	end

    --刷新我的战绩数据
    local function reloadMyWarGrid( properties )

        local warsTable = {}
        --决赛
        if properties.myrecords2 ~= nil and #properties.myrecords2 > 0 then
            local warTable = { title = _s("TEAM_FINALS_WAR"),war = nil }
            table.insert(warsTable,warTable)
            for i,v in ipairs(properties.myrecords2) do
                local war = {title = nil,war = v}
                table.insert(warsTable,war)
            end
        end
        --半决赛
        if properties.myrecords4 ~= nil and #properties.myrecords4 > 0 then
            local warTable = { title = _s("TEAM_SEMIFINAL_WAR"),war = nil }
            table.insert(warsTable,warTable)
            for i,v in ipairs(properties.myrecords4) do
                local war = {title = nil,war = v}
                table.insert(warsTable,war)
            end
        end 
        --1/4决赛
        if properties.myrecords8 ~= nil and #properties.myrecords8 > 0 then
            local warTable = { title = _s("TEAM_ONE_FOURTH_WAR"),war = nil }
            table.insert(warsTable,warTable)
            for i,v in ipairs(properties.myrecords8) do
                local war = {title = nil,war = v}
                table.insert(warsTable,war)
            end
        end 
        --淘汰赛
        if properties.myrecords ~= nil and #properties.myrecords > 0 then
            local warTable = { title = _s("TEAM_ELIMINATION_WAR"),war = nil }
            table.insert(warsTable,warTable)
            for i,v in ipairs(properties.myrecords) do
                local war = {title = nil,war = v}
                table.insert(warsTable,war)
            end
        end 
 
        _myWarGrid:setItems(warsTable)

        if #warsTable == 0 then
            _mNoRecordLabel:setVisible(true)
        else
            _mNoRecordLabel:setVisible(false)
        end
    end

    --改变线的颜色
    local function changeLineColor( records8 )
        -- body
        local recordTable =  string.split(records8, ",")
        
        for i,v in ipairs(recordTable) do
            local record = string.split(v,":")

            if record and record[1] ~= "g" then

                if record[2] and record[2] == "1" then

                    --1 上面的赢了
                    local tag_1 = 400 + 4 * i - 3
                    local tag_2 = 400 + 4 * i - 2

                    --强转成CCLayerColor
                    local line_1 = tolua.cast(CCBCenter.getNodeByTag(_node, tag_1,"CCLayerColor"), "CCLayerColor")
                    line_1:setColor(COLOR3.RED)
                    local line_2 = tolua.cast(CCBCenter.getNodeByTag(_node, tag_2,"CCLayerColor"), "CCLayerColor")
                    line_2:setColor(COLOR3.RED)
                elseif record[2] and  record[2] == "2" then

                    --2 下面的赢了
                    local tag_1 = 400 + 4 * i - 1
                    local tag_2 = 400 + 4 * i 

                    local line_1 = tolua.cast(CCBCenter.getNodeByTag(_node, tag_1,"CCLayerColor"), "CCLayerColor")
                    line_1:setColor(COLOR3.RED)
                    local line_2 = tolua.cast(CCBCenter.getNodeByTag(_node, tag_2,"CCLayerColor"), "CCLayerColor")
                    line_2:setColor(COLOR3.RED)
                end

                
            else

                if record[2] and  record[2] == "1" then

                    local line_1 = tolua.cast(CCBCenter.getNodeByTag(_node, 425,"CCLayerColor"), "CCLayerColor")
                    line_1:setColor(COLOR3.RED)
                    local line_2 = tolua.cast(CCBCenter.getNodeByTag(_node, 426,"CCLayerColor"), "CCLayerColor")
                    line_2:setColor(COLOR3.RED)
                elseif record[2] and  record[2] == "2" then
                    local line_1 = tolua.cast(CCBCenter.getNodeByTag(_node, 427,"CCLayerColor"), "CCLayerColor")
                    line_1:setColor(COLOR3.RED)
                    local line_2 = tolua.cast(CCBCenter.getNodeByTag(_node, 426,"CCLayerColor"), "CCLayerColor")
                    line_2:setColor(COLOR3.RED)
                end
            end
        end
    end

    --八强头像
    local function setRecords8Head( teams8 )
        
        for i,team in ipairs(teams8) do
            local nodeTag = 226 + i
            local headNode = CCBCenter.getNodeByTag(_node, nodeTag,"CCLayer")
            local leader = team.leader
           
            if leader then
                
                local heroHead = PlayerHead.new(leader.sex, leader.head, leader.equiplst):createRect()
                headNode:addChild(heroHead, 2)
                util.alignNode(heroHead, headNode)
                heroHead:setScale(0.5)

                -- 绑定头像点击
                widget.bindTouchEvent{
                    layer = headNode,
                    clickListener = function ( )
                        local fromKey =  _node._TYP2 == 2 and 9 or 10
                        CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = team.tid, serid = team.serid, fromKey = fromKey})
                    end,
                    container = layer,
                }

               _nodeTable["mTeamName_"..i]:setString(team.tname)
               _nodeTable["mTeamServer_"..i]:setString(team.sername)
               CCBCenter.getNodeByTag(_node, 600 + i):setVisible(true)

                --冠军
                local champion = _node._TYP2 == 1 and team.ischampion or team.ischampion2
                
                if champion == TRUE then

                    headNode = CCBCenter.getNodeByTag(_node, 235,"CCLayer")
                    heroHead = PlayerHead.new(leader.sex, leader.head, leader.equiplst):createRect()
                    headNode:addChild(heroHead, 2)
                    util.alignNode(heroHead, headNode)
                    heroHead:setScale(0.5)

                    -- 绑定头像点击
                    widget.bindTouchEvent{
                        layer = headNode,
                        clickListener = function ( )
                            local fromKey =  _node._TYP2 == 2 and 9 or 10
                            CCBCenter.loadCCB("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer", {tid = team.tid, serid = team.serid, fromKey = fromKey})
                        end,
                        container = layer,
                    }

                    _nodeTable["mTeamName_9"]:setString(_s("TEAM_CHAMPION",team.tname))
                    _nodeTable["mTeamServer_9"]:setString(team.sername)
                    CCBCenter.getNodeByTag(_node, 609):setVisible(true)
                end
            end
        end

    end
    --八强回放按钮
    local function setRecords8Btn( records8 )
        for i,record in ipairs(records8) do
            if record.node == "a" then

                CCBCenter.getNodeByTag(_node, 209,"CCControlButton"):setEnabled(true)
                break
            end
        end
        for i,record in ipairs(records8) do
            if record.node == "b" then

                CCBCenter.getNodeByTag(_node, 210,"CCControlButton"):setEnabled(true)
                break
            end
        end
        for i,record in ipairs(records8) do
            if record.node == "c" then

                CCBCenter.getNodeByTag(_node, 211,"CCControlButton"):setEnabled(true)
                break
            end
        end
        for i,record in ipairs(records8) do
            if record.node == "d" then

                CCBCenter.getNodeByTag(_node, 212,"CCControlButton"):setEnabled(true)
                break          
            end
            
        end
        for i,record in ipairs(records8) do
            if record.node == "e" then

                CCBCenter.getNodeByTag(_node, 213,"CCControlButton"):setEnabled(true)
                break          
            end
            
        end
        for i,record in ipairs(records8) do
            if record.node == "f" then

                CCBCenter.getNodeByTag(_node, 214,"CCControlButton"):setEnabled(true)
                break          
            end
            
        end
        for i,record in ipairs(records8) do
            if record.node == "g" then
               
                CCBCenter.getNodeByTag(_node, 215,"CCControlButton"):setEnabled(true)
                break          
            end
            
        end
    end

    local function setRecords8( records8 )
        _records8 = records8
    end

    local function getRecords8( )
        return _records8
    end

--[[ ## local fuction --]]
	local function initViews()
		
		--战绩赛况Layer
		_teamWarSeasonLayer = CCBCenter.getNodeByTag(_node, 2)
		--我的战绩
		_myWarLayer = CCBCenter.getNodeByTag(_node, 3)

        _lineLayer = CCBCenter.getNodeByTag(_node, 4)

        _team8NameLayer = CCBCenter.getNodeByTag(_node,6)

        _mNoRecordLabel = CCBCenter.getNodeByTag(_node, 7)

		_myWarGrid = createMyWarGrid()

		--reloadMyWarGrid()

		createTab(tag)

        if tag == 1 then
    		_teamWarSeasonLayer:setVisible(false)
    		_myWarLayer:setVisible(true)
            _lineLayer:setVisible(false)
            _team8NameLayer:setVisible(false)
        else
            _teamWarSeasonLayer:setVisible(true)
            _myWarLayer:setVisible(false)
            _lineLayer:setVisible(true)
            _team8NameLayer:setVisible(true)
            _mNoRecordLabel:setVisible(false)
        end
	end

--[[ ## public fuction --]]
    
    --设置输赢关系
    _node.changeLineColor = changeLineColor
    --刷新我的战绩
    _node.reloadMyWarGrid = reloadMyWarGrid
    --八强头像
    _node.setRecords8Head = setRecords8Head
    --八强回放按钮
    _node.setRecords8Btn = setRecords8Btn
    --设置八强信息
    _node.setRecords8 = setRecords8
     --获取八强信息
    _node.getRecords8 = getRecords8

--[[ ## MAINs --]]
	initViews()
end

return M