--TowerBuffLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TowerBuffLayerView]"
	local _node, _nodeTable = node, luaValue
	--buff刷新按钮
	local _reChooseNode
	--buffGrid
	local _buffNode

	local _buffGrid
	--选中的
	local _selectedIndex = 1

	local function createPriceBtn( price )
		
		if _reChooseNode:getChildByTag(2) then
			_reChooseNode:removeChildByTag(2,true)
		end

		--重置按钮
        local reChooseButton = widget.newButton{
            scale = 1.1,
            contentSize = _reChooseNode:getContentSize(),
            rect 		= CCRectMake(0, 0, 80, 58) , 
            normalImage = "common/buttons/btn_normal_yellow.png",
            selectImage = "common/buttons/btn_normal_yellow.png",
            disableImage = "common/buttons/btn_normal_gray.png",
            listener = function ( button )
            	if price > 0 then
	            	 AlertLayer.new4IAP{
					  	isUserDiamond = true,
					  	diamondIndex = 20,
					    content = _s("USE_DIAMOND_20",price),  --内容
					    btnClickEvent = {
					    	function ( )
					        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERBUFFLAYER_ONBTNRECHOOSEBUFFCLICK)
					        end,
					    }
					  }	
				else
					CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERBUFFLAYER_ONBTNRECHOOSEBUFFCLICK)
				end
            end
        }

        util.alignNode(reChooseButton, _reChooseNode)
        _reChooseNode:addChild(reChooseButton,2)

        local anchor = display.CENTER
        local padding = {top = 0}
        local labelSize = 35

        if price > 0 then
	        local params = {"main/img_main_diamond.png",
	            {text = price, size = 20,color = ccc3(96, 57, 19)},}
	        
	        local  costLinearLabel = widget.newLinearLabel({paramTable = params})
	        util.alignNode(costLinearLabel, reChooseButton,display.BOTTOM_CENTER,{bottom = 8})
	        reChooseButton:addChild(costLinearLabel,1000)

	        anchor = display.TOP_CENTER
	        padding = {top = 8}
			labelSize = 25
	    end

        local textLabel = ui.newTTFLabel{           
	            size = labelSize,
	            text = _s("TOWER_BUFF_RECHOOSE_TITLE"),
	            color = BUTTON_COLOR3.BROWN
	        } 
	    util.alignNode(textLabel, reChooseButton,anchor,padding)
        reChooseButton:addChild(textLabel,10001)
	end
	--创建BuffGrid
	local function createBuffGrid( )
		
		local function tapListener( grid, index, item )
			_selectedIndex = index
			grid:refresh()
		end

		local function createItemCellListener( grid, index, item )
			local cell = widget.newLayer{contentSize = CCSize(_buffNode:getContentSize().width / 3,_buffNode:getContentSize().height)}
			cell:ignoreAnchorPointForPosition(false)

			local filePath = "tower/img_buff_nomal.png"

	        if index == _selectedIndex then
	        	filePath = "tower/img_buff_selected.png"
	        end

	        local selectImg = widget.newScale9{ file = filePath, 
                    contentSize = cell:getContentSize() }
            util.alignNode(selectImg, cell)
            cell:addChild(selectImg,1000)

            local imgPath,typStr

            if item.camp == 1 then
				imgPath = "cardgroup/filter/img_race_alliance.png"
            elseif item.camp == 2 then
            	imgPath = "cardgroup/filter/img_race_tribe.png"
            elseif item.camp == 3 then
            	imgPath = "cardgroup/filter/img_race_undead.png"
            elseif item.camp == 100 then
            	imgPath = "tower/img_buff_hero_hp.png"
            end

            if item.typ == 1 then
            	typStr = "ATK"
            else
            	typStr = "HP"
            end

            local campImg = display.newSprite(imgPath)
        	util.alignNode(campImg, selectImg,display.CENTER,{top = - 30})
        	selectImg:addChild(campImg,1)

        	local params = {{text = typStr, size = 20},
            	{text = item.Jnum, size = 20},}
	        local  costLinearLabel = widget.newLinearLabel({paramTable = params,direction = widget.TABLEVIEW_DIRECTION_VERTICAL })
	        util.alignNode(costLinearLabel, selectImg,display.BOTTOM_CENTER,{bottom = 27})
	        selectImg:addChild(costLinearLabel,1000)

			return cell
		end

		--scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = _buffNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_buffNode:getContentSize().width / 3 , _buffNode:getContentSize().height),
	            row = 1,
	            createItemCellListener = createItemCellListener,
	            tapListener = tapListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
	        parentNode = _buffNode,
	    }
        return scrollGrid
	end

	--刷新buff
	local function reloadBuff( buff)

		_buffGrid:setItems(buff)
	end
	--获取选中No
	local function getSelectedIndex( ... )
		return _selectedIndex
	end

--[[ ## local fuction --]]
	local function initViews()
		
		_reChooseNode = CCBCenter.getNodeByTag(_node, 107)
		--buffNode
		_buffNode = CCBCenter.getNodeByTag(_node, 105)

		createPriceBtn(_node.price)

		--创建BuffGrid
		_buffGrid = createBuffGrid()
		--刷新buff
		reloadBuff(_node.buff)
	end

--[[ ## public fuction --]]
	--刷新buff
	_node.reloadBuff = reloadBuff
	--创建BuffGrid
	_node.createBuffGrid = createBuffGrid
	--获取选中No
	_node.getSelectedIndex = getSelectedIndex
	--创建刷新按钮
	_node.createPriceBtn = createPriceBtn
--[[ ## MAINs --]]
	initViews()
end

return M