--TowerLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TowerLayerView]"
	local _node, _nodeTable = node, luaValue
	--幽灵魔塔Grid
	local _towerGrid
	--幽灵魔塔Node
	local _towerNode
	--背景云层
	local _bgCloudLayer
	--背景云层
	local _bgLayer
	--可打关卡
	local fightCheckPoint
	--拖动前的Y
	local nowGridY = 0
	--挑战红心
	local _redHeartLayer
	--自身BuffNode
	local _selfBuffNode
	--自身BuffGrid
	local _selfBuffGrid
	--当前挑战次数
	local _challengeNum
	--总的挑战次数
	local _totalChallengeNum
	--排行自动刷新
	local _rankSchedule

	--创建幽灵魔塔Grid
	function createTowerGrid( ... )

		--背景拖动前的Y
		local bgLayerY = _bgLayer:getPositionY()
		--背景云拖动前的Y
		local bgCloudLayerY = _bgCloudLayer:getPositionY()

		local function nodeScroll(  )
			
			local nextGridY = _towerGrid:getContentOffset().y
			local offSetY = nextGridY - nowGridY

			bgLayerY = bgLayerY + offSetY * 0.2
			bgCloudLayerY = bgCloudLayerY +  offSetY * 0.05

			if bgLayerY > 640 or bgLayerY < -640 then
				bgLayerY = 0
			end

			if bgCloudLayerY > 640 or bgCloudLayerY < -640 then
				bgCloudLayerY = 0
			end

			_bgLayer:setPositionY(bgLayerY)
			_bgCloudLayer:setPositionY(bgCloudLayerY)

			nowGridY = nextGridY
		end

		_node:scheduleUpdate(nodeScroll)

        local function tapListener( grid, index, item )

        	local cell = grid:cellAt(index)
        	local array     = {}
            array[#array + 1] = CCScaleTo:create(0.15, 1.1)
            array[#array + 1] = CCScaleTo:create(0.15, 1)
            transition.execute(cell, transition.sequence(array), {easing = "CCEaseBackInOut"})

            if _challengeNum >0 then

	        	if item.status == 1 then
	        		-- -- 场景转换
	                local scene = require("view.Fight.Scene.FightScene").new({  mode = {battle = MODE_BATTLE_LADDERLIST},no = item.no,fnNextView = function ( )        
	                                    CCBCenter.replaceLayer("MSG_MAPCONTAINERLAYER_MODEL", "ccb.c.map.MapContainerLayer", {fromMain = false, }, function (node)
							                node:performWithDelay(function ( ... )
							                    game.requestDateForLoad( node )
							                end, 0.01)
							                node.onExit = function ( self )
							                    util.removeUnusedTextures()
							                end
							            end,  nil)
	                                    CCBCenter.loadCCB("MSG_TOWERLAYER_MODEL", "ccb.c.tower.TowerLayer",{fromMap = true})               
	                            end, })
	                CCBCenter.replaceScene(scene)
	          	--CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHFIGHT,nil,{no = item.no})

				elseif item.status == 2 then
					NetHelper.QuickToast(_s("SPECIALMAP_FIGHTED"))
				end
			else
				NetHelper.QuickToast(_s("TOWER_FIGHT_ERROR"))
			end

        end

        local function createItemCellListener(grid, index, item)
            
			local cell = widget.newLayer{contentSize = CCSize(424,95)}

			local img = "specialMap/btn_checkpoint_choose_disable_0.png"

			if item.status == 1 then
				img = "specialMap/btn_checkpoint_choose_selected_0.png"
				_currentNo = item.no
			elseif item.status == 2 then
				img = "specialMap/btn_checkpoint_choose_normal_0.png"
			end

			--关卡选择按钮
			local checkpointButton = widget.newButton{
			    normalImage = img,
			    selectImage = img,
			    cancelOnMove = true,
		    	swallowsTouches = false,
			    labelParams = { 
			 	    text = item.title,
			 	    size = WEEK_TABLE_TEXT_SIZE,
			 	    color = BUTTON_COLOR3.BROWN,
			        padding = {top = 2},
			 	}
			}
			util.alignNode(checkpointButton, cell:getContentSize(),display.CENTER)
			cell:addChild(checkpointButton)

			local str = item.name
			

			if item.status == 0 then
				checkpointButton.setStateDisabled(true)
				local lockSprite = widget.newSprite{file = "cardgroup/img_card_protection.png"}
				util.alignNode(lockSprite, cell:getContentSize(), display.CENTER)
				lockSprite:setScale(2)
				cell:addChild(lockSprite)
		    elseif item.status == 2 then
				str = _s("TOWER_CLEAN",item.name)
			end

			-- 副本名称
	        local checkpointLabel = ui.newTTFLabel{           
	            size = 30,
	            text = str,
	            color = BUTTON_COLOR3.BROWN
	        }
			util.alignNode(checkpointLabel, cell:getContentSize(),display.TOP_LEFT,{left = 15,top = 10})
	        cell:addChild(checkpointLabel)

			local rewardEntity = require("model.main.RewardEntity").new(item.reward)

			if rewardEntity:notEmpty() then

				--奖励预览
				local rewardPreViewButton = widget.newButton{
					scale = 1.1,
				    normalImage = "team/img_cross_server_reward.png",
				    selectImage = "team/img_cross_server_reward.png",
				    cancelOnMove = true,
			    	listener = function ( button )
            			--奖励预览串
						
						CCBCenter.loadCCB(
					            "MSG_SPECIALMAPREWARDPREVIEWLAYER_MODEL", 
					            "ccb.c.specialMap.SpecialMapRewardPreviewLayer", 
					            {
					                entity = rewardEntity,
					            }
					        )
            		end
				    
				}
				util.alignNode(rewardPreViewButton, cell:getContentSize(),display.RIGHT_CENTER)
				cell:addChild(rewardPreViewButton)
			end

            return cell
        end

        local function onCellEnter( grid, index, item, itemCell )
        	--因为item为倒叙插入，因此在计算时需要用总个数去减

        	-- maxIndex 执行动画的最高cell minIndex 执行动画的最低cell

        	local minIndex = grid:getRows() - fightCheckPoint - 6
        	local maxIndex = grid:getRows() - fightCheckPoint + 1

        	-- 动画延迟时间 
        	local delayTime = ( grid:getRows() - index ) - fightCheckPoint + 2

        	--当前cell在前五个时，强制执行动画的个数为6
        	if maxIndex < 6 then
        		maxIndex = 6
        		delayTime = maxIndex - index + 1
        	end

        	if index <=  maxIndex and index >= minIndex then
        		local toY = itemCell:getPositionY()
	        	itemCell:setPositionY(toY + 640 )
	        	transition.moveTo(itemCell, {y = toY,time = 0.25
	        		, delay = delayTime * 0.125
	        		,easing = "BACKINOUT"})
        	end
        end

        --scrollview
        local scrollGrid = widget.newScrollGrid{
            contentSize = _towerNode:getContentSize(),
            contentParams = {
                cellSize = CCSize(_towerNode:getContentSize().width , _towerNode:getContentSize().height / 6),
                column = 1,
                tapListener = tapListener,
                createItemCellListener = createItemCellListener, 
                modifyItemCellListener = modifyItemCellListener,
                onCellEnter = onCellEnter,
             },
			bounceable = false,
			
            direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
            parentNode = _towerNode,
        }
        return scrollGrid
	end

	--刷新关卡数据
	local function reloadCheckpointyGrid( tinfos )

		fightCheckPoint = 1
		for i,v in ipairs(tinfos) do
			if v.status == 1 then 
				fightCheckPoint = i
			end
		end

		_towerGrid:setItems(table.reverse(tinfos))
		if #tinfos >= 5 then
			--滚到能挑战的最高
			_towerGrid:scrollToColumn( #tinfos - (fightCheckPoint - 1) - 4,0)
		end

		nowGridY = _towerGrid:getContentOffset().y

	end
	--创建挑战次数按钮
	local function createRedHeartBtn( challengeNum,totalChallengeNum,challengePrice )

		_challengeNum = challengeNum
		_totalChallengeNum = totalChallengeNum

		if _redHeartLayer:getChildByTag(2) then
			_redHeartLayer:removeChildByTag(2,true)
		end

		local redHeartBtn = widget.newButton{
            scale = 1.1,
            normalImage = "team/btn_cross_server.png",
            selectImage = "team/btn_cross_server.png",
            disableImage = "team/btn_cross_server.png",
            listener = function ( button )
            	if challengeNum < totalChallengeNum then
            		--副本重置对话框
            		 AlertLayer.new4IAP{
					  	isUserDiamond = true,
					  	diamondIndex = 19,
					    content = _s("USE_DIAMOND_19",challengePrice),  --内容
					    btnClickEvent = {
					    	function ( )
					        	CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHBUYCHALLENGE)
					        end,
					    }
					  }	

            	end
            end
        }

        local redHeartImg = display.newSprite("tower/btn_tower_challenge.png")
        util.alignNode(redHeartImg, redHeartBtn)
        redHeartBtn:addChild(redHeartImg,1)

         local challengeLabel = widget.newTTFLabelWithShadow{
            text = challengeNum .."/".. totalChallengeNum, 
            shadow = true,
            size = 35,
        }
        util.alignNode(challengeLabel, redHeartBtn)
	    --redHeartBtn:setContentSize(challengeLabel:getContentSize())
	    redHeartBtn:addChild(challengeLabel,2)

        util.alignNode(redHeartBtn, _redHeartLayer)
        _redHeartLayer:addChild(redHeartBtn,2)
	end
	--设置记录数值
	local function setRecordString( todayResults,myrank,selfBuff,challengePrice )
		
		_nodeTable["mMyRecordLabel"]:setString(todayResults)

		local rankStr = myrank
		if myrank == 0 then
			rankStr = _s("TOWER_NO_RANK")
		end
		_nodeTable["mMyRankLabel"]:setString(rankStr)

		_nodeTable["mChallengeLabel"]:setString(_s("TOWER_USE_DIAMOND",challengePrice))

		local buffTable = {}

		for i=1,3 do
			local t = {hp = 0, atk = 0, camp = i}
			buffTable[i] = t
		end

		if #selfBuff ~= 0 then

			for i,v in ipairs(selfBuff) do
				if v.camp == 100 then
					_nodeTable["mHeroHPLabel"]:setString(_s("TOWER_BUFF_HERO_HP",v.Jnum))
				else
					if v.typ == 1 then
						buffTable[v.camp].atk = v.Jnum
					else					
						buffTable[v.camp].hp = v.Jnum
					end
				end
			end
		end

		if string.len(_nodeTable["mHeroHPLabel"]:getString()) == 0 then
			_nodeTable["mHeroHPLabel"]:setString(_s("TOWER_BUFF_HERO_HP",0))
		end

		_selfBuffGrid:setItems(buffTable)
	end
	--自身BuffGrid
	local function createSelfBuffGrid( ... )


		local function createItemCellListener( grid, index, item )
			local cell = widget.newLayer{contentSize = CCSize(_selfBuffNode:getContentSize().width ,_selfBuffNode:getContentSize().height / 3 - 5)}
			cell:ignoreAnchorPointForPosition(false)

			if item.camp == 1 then
				imgPath = "cardgroup/filter/img_race_alliance.png"
            elseif item.camp == 2 then
            	imgPath = "cardgroup/filter/img_race_tribe.png"
            elseif item.camp == 3 or item.camp == 100 then
            	imgPath = "cardgroup/filter/img_race_undead.png"
            end

			local campBg = widget.newScale9{ file = "tower/bg_tower_my_record.png", 
                    contentSize = CCSize(60,60) }
            util.alignNode(campBg, cell,display.CENTER_LEFT)
            cell:addChild(campBg,1000)

            local campImg = display.newSprite(imgPath)
            campImg:setScale(0.5)
        	util.alignNode(campImg, campBg,display.CENTER)
        	campBg:addChild(campImg,1)

        	local atkBg = widget.newScale9{ file = "tower/bg_tower_my_record.png", 
                    contentSize = CCSize(119,24) }
            util.alignNode(atkBg, cell,display.TOP_RIGHT)
            cell:addChild(atkBg,1000)

            local atkImg = display.newSprite("cardgroup/img_cardgroup_sword.png")
        	 atkImg:setScale(0.7)
 

	        local params = {atkImg,{size = 20,text = "+"..item.atk,}}
	        local  atkLinearLabel = widget.newLinearLabel({paramTable = params})
	        util.alignNode(atkLinearLabel, atkBg,display.CENTER_LEFT)
	        atkBg:addChild(atkLinearLabel)

            local hpBg = widget.newScale9{ file = "tower/bg_tower_my_record.png", 
                    contentSize = CCSize(119,24) }
            util.alignNode(hpBg, cell,display.BOTTOM_RIGHT)
            cell:addChild(hpBg,1000)

            local hpImg = display.newSprite("cardgroup/img_cardgroup_blood.png")
        	hpImg:setScale(0.7)


	        local params = {hpImg,{size = 20,text = "+"..item.hp,}}
	        local  hpLinearLabel = widget.newLinearLabel({paramTable = params,padding = 7})
	        util.alignNode(hpLinearLabel, hpBg,display.CENTER_LEFT)
	        hpBg:addChild(hpLinearLabel)

			return cell
		end

		--scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = _selfBuffNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_selfBuffNode:getContentSize().width , _selfBuffNode:getContentSize().height / 3),
	            padding = {
	            	middleV = 1
	        	},
	            column = 1,
	            createItemCellListener = createItemCellListener,
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _selfBuffNode,
	    }
        return scrollGrid
	end
    local function checkHelperInfo( )
        if ME:getTriggerMsgEntity():isShowTower2Helper() then
            HelperView2.setCurIndex(210030)
        end
        HelperView2.showBetween(_node, nil, {210030, 210070})
    end
--[[ ## local fuction --]]
	local function initViews()
        checkHelperInfo( )
		_towerNode = _nodeTable.mTowerList

		--背景云层
		_bgCloudLayer = CCBCenter.getNodeByTag(_node, 201)
		--背景塔
		_bgLayer =  CCBCenter.getNodeByTag(_node, 202)
		--挑战红心
		_redHeartLayer =  CCBCenter.getNodeByTag(_node, 70201)
		--自身BuffNode
		_selfBuffNode = CCBCenter.getNodeByTag(_node, 809)

		_towerGrid = createTowerGrid()
		--自身BuffGrid
		_selfBuffGrid = createSelfBuffGrid()

	end
	--打开或关闭刷新
	local function openSchedule( enable )

		local function getTowerList( ... )
			CCBCenter.sendLuaMessage(MSG_ID.MSG_TOWERLAYER_ACTION_ONFETCHTOWERLLIST)
		end

		if enable then
			if _rankSchedule == nil then
				_rankSchedule = _node:schedule(getTowerList,60)
			end
		else
			_node:removeAction(_rankSchedule)
		end
	end 

--[[ ## public fuction --]]
	--刷新塔层数据
	_node.reloadCheckpointyGrid = reloadCheckpointyGrid
	--创建红心按钮
	_node.createRedHeartBtn = createRedHeartBtn
	--创建红心按钮
	_node.setRecordString = setRecordString
	--打开或关闭刷新
	_node.openSchedule	= openSchedule
--[[ ## MAINs --]]
	initViews()
end

return M