--TowerRankLayer.lua
local RewardEntity = require("model.main.RewardEntity")

local M = {}

function M.bindView(node, luaValue)
	local TAG = "[TowerRankLayerView]"
	local _node, _nodeTable = node, luaValue
	--排名node
	local _rankNode
	--排名Grid
	local _rankGrid

	--奖励grid
	local function createRewardGrid( rewardLayer,rewardTable )

		local function tapListener( grid, index, item )
		  if item:getType() == RewardEntity.REWARD_TYPE.CARD or item:getType() == RewardEntity.REWARD_TYPE.CHIP then
		      CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", item:getEntity())
		  elseif item:getType() == RewardEntity.REWARD_TYPE.GOODS then
		      if item:getEntity():getNo() > 20000 then
		          CCBCenter.loadCCB("MSG_EQUIPALERTLAYER_MODEL", "ccb.c.goods.EquipAlertLayer", item:getEntity())
		      else
		          CCBCenter.loadCCB("MSG_GOODSALERTLAYER_MODEL", "ccb.c.goods.GoodsAlertLayer", item:getEntity())
		      end
		  end
		end

		local function createItemCellListener(grid, index, item)

		    local cell = widget.newLayer{contentSize = CCSize(91,91)}
		    cell:setContentSize(grid:getCellSize())
		    cell:ignoreAnchorPointForPosition(false)

		    cell:addChild(item)
		    util.alignNode(item, cell)

		  return cell
		end

		local scrollGrid = widget.newScrollGrid{
		  x = 0,
		  y = 0,
		  contentSize = rewardLayer:getContentSize(),
		  contentParams = {
		      cellSize = CCSize(100 , 91),
		      row = 1,
		      createItemCellListener = createItemCellListener,
		      tapListener = tapListener,
		      padding = {
		      	middleH = 5
		  		}
		  },
		  direction = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
		  parentNode = rewardLayer,
		}

		scrollGrid:setItems(rewardTable)
	end

	--问题类别Grid
	local function createRankGrid( ... )

		local function createItemCellListener(grid, index, item)
			--183.83
	        local cell = widget.newLayer{contentSize = CCSize(_rankNode:getContentSize().width,146)}

	        local selectImg = widget.newScale9{ file = "faq/btn_faq_nomal.png", 
	        		capInsets 		= CCRectMake(100, 40, 10, 10) ,
                    contentSize = cell:getContentSize() }
            util.alignNodeWithPadding(selectImg, cell)
            cell:addChild(selectImg)

            local rewardLayer = widget.newLayer{contentSize = CCSize(_rankNode:getContentSize().width - 5,95)}
            util.alignNodeWithPadding(rewardLayer, cell,display.BOTTOM_RIGHT,{bottom = 5})
            cell:addChild(rewardLayer)

             --奖励串
			local rewardEntity = RewardEntity.new(item.reward)
			local rewardTable = rewardEntity:getRewardViews(rewardEntity)
			createRewardGrid(rewardLayer,rewardTable)

		    local userImg = widget.newScale9{ file = "tower/bg_tower_rank_user.png", 
        		capInsets 		= CCRectMake(10, 10, 10, 5) ,
                contentSize = 	CCSize(473,36)
            }
            util.alignNode(userImg, cell,display.TOP_CENTER,{top = 8})
            cell:addChild(userImg)

            local rankStr = _s("TOWER_RANK",item.Maxrank,item.Minrank)
            local resultStr = _s("TOWER_RANK_MINRESULTS",item.Minresults)

            if item.Minrank == 1 then
            	resultStr = _s("TOWER_RANK_FIRST_RESULTS",item.Minresults)
            	rankStr = _s("TOWER_RANK_FIRST_RANK",item.name)
            end

            local rankLabel = ui.newTTFLabel{           
	            size = 20,
	            text = rankStr,
	            color = BUTTON_COLOR3.BROWN
	        }
			util.alignNode(rankLabel, userImg:getContentSize(),display.CENTER_LEFT,{left = 10})
	        userImg:addChild(rankLabel)

            local resultLabel = ui.newTTFLabel{           
	            size = 20,
	            text = resultStr,
	            color = BUTTON_COLOR3.BROWN
	        }
			util.alignNode(resultLabel, userImg:getContentSize(),display.CENTER,{left = resultLabel:getContentSize().width / 2})
	        userImg:addChild(resultLabel)

          	return cell
		end

	    --scrollview
	    local scrollGrid = widget.newScrollGrid{
	        contentSize = _rankNode:getContentSize(),
	        contentParams = {
	            cellSize = CCSize(_rankNode:getContentSize().width , 150),
	            column = 1,
	            createItemCellListener = createItemCellListener,
	            padding = {
	            	middleV = 5
	        	}
			 },
	        direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	        parentNode = _rankNode,
	    }

	    return scrollGrid
	end

	local function reloadRankGrid( rankList )
		_rankGrid:setItems(rankList)
	end

	--设置我的记录
	local function setMyRecord( myRecord,myRank )
		_nodeTable["mMyRecordLabel"]:setString(_s("TOWER_RANK_MY_RECORD",myRecord))
		if myRank == 0 then
			_nodeTable["mMyRankLabel"]:setString(_s("TOWER_MY_RANK")..":".._s("TOWER_NO_RANK"))
		else
			_nodeTable["mMyRankLabel"]:setString(_s("TOWER_RANK_MY_RANK",myRank))
		end
	end

--[[ ## local fuction --]]
	local function initViews()
		--排名Node
		_rankNode = CCBCenter.getNodeByTag(_node, 107)
		--排名Grid
		_rankGrid = createRankGrid()
	end

--[[ ## public fuction --]]
	--设置我的记录
	_node.setMyRecord = setMyRecord
	--刷新排名Grid
	_node.reloadRankGrid = reloadRankGrid
--[[ ## MAINs --]]
	initViews()
end

return M