--LoginNewLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[LoginNewLayerView]"
	local _node, _nodeTable = node, luaValue
	local _selectedSerInfo = { serid = 1, seradd = "", serstu = SERVER_STATE_MAINTAIN, sername = "",notification = ""} -- 选中id，默认为1
    local TDAnimationUtils = require(PH_MDL_UTIL .. "TDAnimationUtils")
    local TDHookUtils      = require(PH_MDL_UTIL .. "TDHookUtils")
	--背景Layter
	local _bgLayer
	--登陆按钮
	local _enter
    --服务器Grid
    local _gridTable
    --我的服务器序号
    local maServerIndex
	--定义方法
	local enterAni
    --我的服务器node
    local _myServerNode
    --最近登录的服务器编号
    local _recentlyServerIndex

	local isLoadSers = false
    local _orisers

    local isToLogin = false

    local _facebookEnter   --fecebook登录按钮
    local _twitterEnter    --twitter登录按钮

    local _serTab
    local _serTabSelectIndex = 1
	--服务器状态
	local SERVER_STATE_RECOMMEND    = 1        -- 推荐
    local SERVER_STATE_FLUENCY      = 2        -- 流畅
    local SERVER_STATE_CROWD        = 3        -- 拥挤
    local SERVER_STATE_FULL         = 4        -- 爆满
    local SERVER_STATE_MAINTAIN     = 5        -- 维护
    local SERVER_STATE_NEW          = 6        -- 新区

    local SERVER_STATE_WORDS = {
        [1] = _s("LOGIN_SERVICE_RECOMMEND"),
        [2] = _s("LOGIN_SERVICE_FLUENCY"),
        [3] = _s("LOGIN_SERVICE_CROWD"),
        [4] = _s("LOGIN_SERVICE_FULL"),
        [5] = _s("LOGIN_SERVICE_MAINTAIN"),
        [6] = _s("LOGIN_SERVICE_NEW"), 
    }

    local SERVER_SELECTED_COLOR = COLOR3.GREEN --ccc3(239,64,54)

	local function createLanguageSwitch()
        if isandroid() then return nil end 
        if not _GAME.CONFIG.LANGUAGE_SWITCH then return nil end
        local btnChinese = widget.newButton{
            normalImage = "login/btn_language_normal.png", 
            selectImage = "login/btn_language_select.png",
            labelParams = {
                text = "中文",
            },
        }
        local btnEnglish = widget.newButton{
            normalImage = "login/btn_language_normal.png", 
            selectImage = "login/btn_language_select.png",
            labelParams = {
                text = "English",
            },
        }
        local function switchLanguageListener( index, button )
            if index == 1 then 
                game.setLanguage( "cn" )
            else
                game.setLanguage( "en" )
            end
            -- 重启吧
            NetHelper.showLoading(true, true)
            _node:performWithDelay(function ()
                game.dialogVersionUpdateCompleted()
                CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFrames()
                CCTextureCache:sharedTextureCache():removeAllTextures()
            end, 0.5)
            
        end
        local selectIndex = device.language == "en" and 2 or 1
        local switchTab = widget.newTab{
            direction = DIRECTION_VERTICAL,
            items = { btnChinese, btnEnglish},
            listener = switchLanguageListener,
            selectIndex = selectIndex
        }
        _node:addChild(switchTab)
        util.alignNode(switchTab, _node, display.TOP_RIGHT, { right = 10, top = 50})

        return switchTab
    end

    --云顶中心按钮
    local function createYundingUerInfo(  )
        -- if isandroid() then return end
        local btnImage = "sdkpng/yunding/yundinglogo.png"
        if isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE_EN) then
            btnImage = "sdkpng/yunding/yundinglogoen.png"
        end
        local ydUIBtn = widget.newButton{
            normalImage = btnImage,
            listener = function ( )
                _sdkPlatform.updateInfo(
                    function( )
                        Log.d(TAG,"注销aaaaaaaaaaaaaaa")
                    end,
                    function(  )
                        Log.d(TAG,"关闭aaaaaaaaaaaaaaaa")
                    end 
                    )
            end,
        }
        util.alignNodeWithPadding(ydUIBtn, _node:getContentSize(), display.TOP_LEFT, {top = 10, left = 10})
        _node:addChild(ydUIBtn, 997, 997)
    end

    local  function enterAni( canEnter ) 

	    canEnter = ifnil(canEnter, true)

	    if canEnter then 
	        if _enter then
	            _enter:setVisible(canEnter)
	            _enter:setTouchEnabled(canEnter)                 
	        end
	        if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK, _GAME.CONFIG.SDK.SDK_TWITTER, _GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
	         
	            if _facebookEnter then
	                _facebookEnter:setVisible(canEnter)
	                _facebookEnter:setTouchEnabled(canEnter)  
	            end
	            if _twitterEnter then
	                _twitterEnter:setVisible(canEnter)
	                _twitterEnter:setTouchEnabled(canEnter)   
	            end             
	        end  
	    else

	        if _enter then

	            _enter:stopAllActions()
	            _enter:setVisible(canEnter)
	            _enter:setTouchEnabled(canEnter)                  
	        end
	        if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK, _GAME.CONFIG.SDK.SDK_TWITTER, _GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
	            
	            if _facebookEnter then
	                _facebookEnter:stopAllActions()
	                _facebookEnter:setVisible(canEnter)
	                _facebookEnter:setTouchEnabled(canEnter)                  
	            end
	            if _twitterEnter then
	                _twitterEnter:stopAllActions()
	                _twitterEnter:setVisible(canEnter)
	                _twitterEnter:setTouchEnabled(canEnter)                  
	            end
	        end
	    end
	    
	end

    local function btnClick( ... )
        if _selectedSerInfo.serstu ~= SERVER_STATE_MAINTAIN then 

            NetHelper.showLoading(true, true)
            SERVERID = _selectedSerInfo.serid
            REQUEST_URL = _selectedSerInfo.seradd

            if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "ja" then 
                -- 保存选取列表id
                ISGSVALUES()
                GS.save(GSVALUES or {})
                game.addGameState("serLstId", _serTabSelectIndex, true) 
            end
            

            Log.d(TAG,"_gridTable:getSelectedItemIndex() %d %s",SERVERID,REQUEST_URL)
            -- 添加服务器名称id到玩家信息
            ME:setProperties(_selectedSerInfo)
            local function callbackCancelUpdate()
                NetHelper.hideLoading(true)
                enterAni( )
            end
            local function callbackCompleteUpdate()
               -- CCBCenter.getNodeByTag(_node, 4):setVisible(true)
                --[[
                if isSDK( btnStr, _GAME.CONFIG.SDK.SDK_FACEBOOK )   then      --如果是facebook登陆按钮按下去， 重新初始化sdk
                     --登录平台标示为facebook
                     LOGINBASEINFO.usertype = _GAME.CONFIG.SDK.SDK_FACEBOOK[1]
                    _sdkPlatform.changeObjectClass("SdkPlatformController")

                elseif isSDK( btnStr, _GAME.CONFIG.SDK.SDK_TWITTER ) then  --如果是twitter登陆按钮按下去， 重新初始化sdk
                    --登录平台标示为twitter
                    LOGINBASEINFO.usertype = _GAME.CONFIG.SDK.SDK_TWITTER[1]
                    _sdkPlatform.changeObjectClass("SdkTwitterViewController")
                end
                --]]
                -- print("开始请求登陆")
                --开始请求登陆
                CCBCenter.sendLuaMessage(MSG_ID.MSG_OPENSDK)
            end
            local url = _selectedSerInfo.url
            if isandroid() and isstring(_selectedSerInfo.url_android) and _selectedSerInfo.url_android ~= "" then 
                url = _selectedSerInfo.url_android
            end
            if _selectedSerInfo.version and _selectedSerInfo.version > CVERSION and isstring(url) and url ~= "" then 
                -- 在appstore包的情况下对version进行判定,看是不是要跳到官方下载
                AlertLayer.new4OK{
                    content   = _s("LOGIN_FORCE_UPDATE_FOR_APPSTORE"),
                    btnClickEvent = {
                        function()
                            -- 跳到官方更新下
                            device.openURL(url)
                        end,
                    },
                } 
                
            else 
                
                -- 判定是不是要增量
                game.judgeVersionUpdate(callbackCancelUpdate, callbackCompleteUpdate, function ( )
                    ISDIAMONDALERTRELOAD = true
                    CCBCenter.getNodeByTag(_node, 4):setVisible(false)
                end)
            end
        else  

            enterAni( )
            NetHelper.QuickToast(_selectedSerInfo.notification)
        end
    end

    --登陆按钮
    local function createBtn( btnStr, positionx )

    	local btnNode = CCBCenter.getNodeByTag(_node,404)
    	btnNode:removeAllChildrenWithCleanup(true)
    	if not positionx then
            positionx = btnNode:getPositionX()
        end
    	local normalImage 
        if device.language == "cn" or device.language == "tw" then 
            normalImage = "login/cn_login_enter.png"
        else
            normalImage = "login/en_login_enter.png"
        end
        local enterBtn = widget.newButton{
            normalImage = normalImage,
            scale = 1.1,
            listener = btnClick,
        }
        btnNode:addChild(enterBtn,0)
        enterBtn:setCascadeOpacityEnabled(true)
        enterBtn:setOpacity(0)
        enterBtn:setTouchEnabled(false)

       	if btnStr then
       		enterBtn:setPosition(positionx,btnNode:getPositionY())
       	else
       		util.alignNode(enterBtn, btnNode)
       	end

        transition.fadeTo(enterBtn, { time = 1.0, opacity = 255, })

        _nodeTable["mVersionLabel"]:setString("v " .. DEFLOGINBASEINFO.cv)
        transition.fadeTo(_nodeTable["mVersionLabel"], { time = 1.0, opacity = 255, })

        -- 第1步：拿到服务器列表 
        util.delayCall(function ( )
        	CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
        end, LOAD_DELAY_TIME )

        return enterBtn
    end

    local function myServerLayerClick( ... )
    	widget.bindTouchEvent{
    		layer = _nodeTable["mMyServerLayer"],
    		clickListener = function ( layer )
				if isLoadSers then 
					util.enableCustomTouch(_bgLayer,false)
					CCBCenter.getNodeByTag(_node, 4):setVisible(false)
					_nodeTable["mServerListLayer"]:showWithMask()
				else
					NetHelper.showLoading(true,true)
                    CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
				end
    		end
   		}
    end

    local function createMyServer( index,serverName,color )
        _myServerNode:removeAllChildrenWithCleanup(true)
        local params = {{text = _s("LOGIN_SERVER_INDEX_1",index), size = 25,color = color},
            {text = serverName, size = 25,color = color},
            {text = _s("LOGIN_SERVER_CHOOSE"), size = 25,color = COLOR3.RED},}
        local  serverLinearLabel = widget.newLinearLabel({paramTable = params,padding = 20})
         util.alignNode(serverLinearLabel,_myServerNode,display.CENTER)
       _myServerNode:addChild(serverLinearLabel)

    end

    local function reloadMyServer( index )
        if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE ~= "ja" then
            local item = sers[index]
            _selectedSerInfo.serid = item.serid
            _selectedSerInfo.seradd = tostring(item.seradd)
            _selectedSerInfo.serstu = item.serstatus
            _selectedSerInfo.sername = item.sername
            _selectedSerInfo.notification = item.notification
            _selectedSerInfo.version = item.version
            _selectedSerInfo.url = item.url
            _selectedSerInfo.url_android = item.url_android
            Log.d(TAG,"YOU CLICKED %d serid %d seradd %s", index, _selectedSerInfo.serid,_selectedSerInfo.seradd)
            
            local str = item.sername
           -- _nodeTable["mMyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX_1",item.index,str,SERVER_STATE_WORDS[item.serstatus]))
            if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE ~= "ja" then
                CCBCenter.getNodeByTag(_node, 4):setVisible(true)
            end
            if item.serstatus == SERVER_STATE_MAINTAIN then 
                color = COLOR3.GREE
            elseif item.serstatus == SERVER_STATE_FULL then 
                color = COLOR3.RED
            else
                color = COLOR3.GREEN
            end
            --_nodeTable["mMyServerLabel"]:setColor(color)
            createMyServer(item.index,str.."["..SERVER_STATE_WORDS[_selectedSerInfo.serstu].."]",color)
            _nodeTable["mServerListLayer"]:hideWithMask()
            util.enableCustomTouch(_bgLayer,true)

            if sers[index].serstatus ~= 5 then
                _nodeTable["btnReflesh"]:setVisible(false)
                _nodeTable["l_enter"] :setVisible(true)
            else
                _nodeTable["btnReflesh"]:setVisible(true)
                _nodeTable["l_enter"] :setVisible(false)
            end
        else
            local serConfig = {
                {name = _s("LOGIN_SERVER_WEST"), serList = sers}, 
                {name = _s("LOGIN_SERVER_EAST"), serList = sers1},
            }
            local serIndex = 1
            if GSVALUES and GSVALUES.serverid then
                for i, v in ipairs(serConfig[_serTabSelectIndex].serList) do
                    if GSVALUES.serverid == v.serid then 
                        serIndex = i
                        break
                    end
                end
            end
            local item = serConfig[_serTabSelectIndex].serList[serIndex]
            _selectedSerInfo.serid = item.serid
            _selectedSerInfo.seradd = tostring(item.seradd)
            _selectedSerInfo.serstu = item.serstatus
            _selectedSerInfo.sername = item.sername
            _selectedSerInfo.notification = item.notification
            _selectedSerInfo.version = item.version
            _selectedSerInfo.url = item.url
            _selectedSerInfo.url_android = item.url_android
            Log.d(TAG,"YOU CLICKED %d serid %d seradd %s", serIndex, _selectedSerInfo.serid, _selectedSerInfo.seradd)
            
            local str = item.sername
           -- _nodeTable["mMyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX_1",item.index,str,SERVER_STATE_WORDS[item.serstatus]))
            if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE ~= "ja" then
                CCBCenter.getNodeByTag(_node, 4):setVisible(true)
            end
            if item.serstatus == SERVER_STATE_MAINTAIN then 
                color = COLOR3.GREE
            elseif item.serstatus == SERVER_STATE_FULL then 
                color = COLOR3.RED
            else
                color = COLOR3.GREEN
            end
            --_nodeTable["mMyServerLabel"]:setColor(color)
            createMyServer(item.serIndex, str.."["..SERVER_STATE_WORDS[_selectedSerInfo.serstu].."]", color)
            _nodeTable["mServerListLayer"]:hideWithMask()
            util.enableCustomTouch(_bgLayer,true)

            if sers[serIndex].serstatus ~= 5 then
                _nodeTable["btnReflesh"]:setVisible(false)
                _nodeTable["l_enter"] :setVisible(true)
            else
                _nodeTable["btnReflesh"]:setVisible(true)
                _nodeTable["l_enter"] :setVisible(false)
            end
        end
    end

    local function createSerListTable( ... )
    	local function createItemCellListener( grid,index,item )
            local cell = widget.newLayer()
            cell:setContentSize(grid:getCellSize())
            cell:ignoreAnchorPointForPosition(false)
            cell:setTag( index )
            local color
            if item.serstatus == SERVER_STATE_MAINTAIN then 
                color = COLOR3.GREE
            elseif item.serstatus == SERVER_STATE_FULL then 
                color = COLOR3.RED
            else
                color = COLOR3.GREEN
            end

			if item.serid == _selectedSerInfo.serid then

				_selectedSerInfo.seradd = tostring(item.seradd)
				_selectedSerInfo.serstu = item.serstatus
				_selectedSerInfo.version = item.version
				_selectedSerInfo.url    = item.url
                _selectedSerInfo.url_android    = item.url_android

				_nodeTable["mServerStatusLabel"]:setColor(color)
				_nodeTable["mRecentlyServerLabel"]:setColor(color)
				--_nodeTable["mMyServerLabel"]:setColor(color)
				--color = SERVER_SELECTED_COLOR
			end

            local serverTitle = ui.newTTFLabel{
                    size = 25,
                    text = _s("LOGIN_SERVER_INDEX",item.index)..item.sername,
                    color = color
                }
            serverTitle:setAnchorPoint(ccp(0, 0.5))
            serverTitle:setPosition(_nodeTable["mRecentlyServerLabel"]:getPositionX() - _nodeTable["mRecentlyServerLabel"]:getContentSize().width / 2,
            	cell:getPositionY() + cell:getContentSize().height / 2)
            cell:addChild(serverTitle)

            local statusTitle = ui.newTTFLabel{
                    size = 25,
                    text = SERVER_STATE_WORDS[item.serstatus],
                    color = color
                }
            statusTitle:setPosition(_nodeTable["mServerStatusLabel"]:getPositionX(),cell:getPositionY() + cell:getContentSize().height / 2)
            cell:addChild(statusTitle)

            --底线
            local lingSpr = widget.newScale9{ file = "login/login_line.png", 
                    contentSize = CCSize(cell:getContentSize().width + 10, 3) }
            util.alignNode(lingSpr, cell:getContentSize(), display.BOTTOM_CENTER)
            cell:addChild(lingSpr)

            return cell
        end

        local function tapListener( grid,index,item ) 
            maServerIndex = index

            reloadMyServer(index)
        end

        -- 生成 -- ===
        local scrollGrid = widget.newScrollGrid{
	      x = 0,
	      y = 0,
	      contentSize = _mServerListNode:getContentSize(),
	      contentParams = {
	          cellSize = CCSize(_mServerListNode:getContentSize().width , 60),
	          padding = { 
	                middleV = 5,
	            },
	          column = 1,
	          createItemCellListener = createItemCellListener,
	          tapListener = tapListener,
	      },
	      direction = widget.TABLEVIEW_DIRECTION_VERTICAL,
	      parentNode = _mServerListNode,
	    }
        return scrollGrid
    end
    -- 创建东西区按钮
    local function createServerTab( )
        if _serTab then
            _serTab:removeFromParentAndCleanup(true)
            _serTab = nil
        end
        
        local btnNode = CCBCenter.getNodeByTag(_node,7)
        local buttons = { }
        local serConfig = {
            {name = _s("LOGIN_SERVER_WEST"), serList = sers, btnImageNormal = "login/btn_west_normal.png", btnImageSelect = "login/btn_west.png"}, 
            {name = _s("LOGIN_SERVER_EAST"), serList = sers1, btnImageNormal = "login/btn_east_normal.png", btnImageSelect = "login/btn_east.png"},
        }
        -- 选择东西区
        local function onTabClick( index, button )
            Log.d(TAG, "_serTabSelectIndex = %d", index)
            _serTabSelectIndex = index
            if _bgLayer.setSerLstId then
                _bgLayer:setSerLstId(_serTabSelectIndex)
            end
            reloadMyServer()
        end
        -- 之前登陆的服务器所在列表
        -- local function isOnSer_( list )
        --     for i, v in ipairs(list) do
        --         print(" GSVALUES.serverid",  GSVALUES.serverid)
        --         print(" v.serid",  v.serid)
        --         if GSVALUES.serverid == v.serid then 
        --             return true
        --         end
        --     end
        --     return false
        -- end
        for i, v in ipairs(serConfig) do
            local btnSer = widget.newButton{   
                selectImage = v.btnImageSelect,
                normalImage = v.btnImageNormal,
                -- rect = CCRect(0, 0, 80, 58),
                contentSize = CCSize(244, 73),
                -- labelParams = {text = v.name, size = 22, shadow = true},
                scale = 1.1,
            } 
            table.insert(buttons, btnSer)
            -- if ISGSVALUES() and GSVALUES and GSVALUES.serverid and isOnSer_(v.serList) then
            --     _serTabSelectIndex = i
            -- end   
        end
        _serTab = widget.newTab{
            items = buttons,
            selectIndex = _serTabSelectIndex,
            padding = 10,
            listener = onTabClick,
            direction = DIRECTION_HORIZONTAL,
            x = btnNode:getPositionX(),
            y = btnNode:getPositionY() + 50,
        }
        _node:addChild(_serTab, 20)
        if GSVALUES and GSVALUES.serverid then
            _serTab:setVisible(false)
        end
    end
    --日版按钮
    local function createJPBtn( ... )

        local function accountMove( username, pass, serverid )
            ISGSVALUES()
            GS.save(GSVALUES or {})
            game.addGameState("udid", LOGINBASEINFO.udid)
            game.addGameState("username", username)
            game.addGameState("pass", pass)
            game.addGameState("serverid", serverid, true) 

            if _orisers and _orisers1 then 
                for i, server in ipairs(_orisers) do
                    if serverid == server.serid then 
                        _selectedSerInfo.serid = server.serid
                        _selectedSerInfo.sername = server.sername
                        _selectedSerInfo.serstu = server.serstatus
                        _selectedSerInfo.seradd = server.seradd
                        _selectedSerInfo.version = server.version
                        _selectedSerInfo.url = server.url
                        _selectedSerInfo.notification = server.notification
                        NetHelper.showLoading(true)
                        btnClick()
                        break
                    end
                end
                for i, server in ipairs(_orisers1) do
                    if serverid == server.serid then 
                        _selectedSerInfo.serid = server.serid
                        _selectedSerInfo.sername = server.sername
                        _selectedSerInfo.serstu = server.serstatus
                        _selectedSerInfo.seradd = server.seradd
                        _selectedSerInfo.version = server.version
                        _selectedSerInfo.url = server.url
                        _selectedSerInfo.notification = server.notification
                        NetHelper.showLoading(true)
                        btnClick()
                        break
                    end
                end
            end
        end

        local function createAccountMoveBtn()
            local btn = widget.newButton{
                normalImage = "login/btn_account.png",
                contentSize = CCSize(244, 73),
                -- rect = CCRect(0, 0, 80, 58),
                -- labelParams = {
                --     text = _s("LOGIN_BY_PASSWORD"), size = 30, shadow = true
                -- },
                scale = 1.1,
                listener = function ( ... )
                    if not _orisers then 
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
                        return 
                    end
                    -- TODO.弹出数据迁移框
                    CCBCenter.loadCCB(
                        "MSG_MIGRATIONACCOUNTALERTLAYER_MODEL", 
                        "ccb.c.password.MigrationAccountAlertLayer", 
                        {
                            onConfirm = accountMove,
                        }
                    )
                end,
            }
            _node:addChild(btn,1000)
            util.alignNode(btn, _node:getContentSize(), display.BOTTOM_CENTER, 80)
        end

        local function createJPLoginBtn(btnStr, positionx)
            local btnNode = CCBCenter.getNodeByTag(_node,7)
            --util.alignNode(btnNode, _node:getContentSize(), display.BOTTOM_CENTER, 210)
            if not positionx then
                positionx = btnNode:getPositionX()
            end
            local btnArg = widget.newButton{
                normalImage = "login/btn_start.png",
                contentSize = CCSize(244, 73),
                -- rect = CCRect(0, 0, 80, 58),
                -- labelParams = {
                --     text = "Start", size = 40, shadow = true
                -- },
                scale = 1.1,
                x = positionx,
                y = btnNode:getPositionY() - 40,
                listener =  function ( ... )
                    if isLoadSers then
                        btnClick()
                    else
                        NetHelper.showLoading(true,true)
                        CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
                    end
                    -- body
                end,
            }
            enterAni(false)
            _node:addChild(btnArg,1001)
            btnArg:setCascadeOpacityEnabled(true)

            enterAni( false )

            return btnArg
        end 
        if _selectedSerInfo.seradd and _selectedSerInfo.seradd ~= "" and game.getGameState("userid") then 

            NetHelper.showLoading(true)
            btnClick()
            return
        elseif GSVALUES and GSVALUES.serverid then
            isToLogin = true
        end

        if not game.getGameState("serverid") then 
            if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK, _GAME.CONFIG.SDK.SDK_TWITTER, _GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
                 --facebook和twitter按钮
                _facebookEnter = createJPLoginBtn(_GAME.CONFIG.SDK.SDK_FACEBOOK , 300)
                _twitterEnter = createJPLoginBtn(_GAME.CONFIG.SDK.SDK_TWITTER , 600)
            else
                --登录按钮
                _enter = createJPLoginBtn()
            end

            createAccountMoveBtn()
        end

    end

    --刷新服务器列表
    local function reloadSerList( properties,flag )
    	NetHelper.hideLoading(true)

        if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE ~= "ja" then
            local name = ""
            local status = ""
            local index
            sers = {}
            _orisers = properties.servers
            if _orisers then 
                
                -- -- 是否是测试环境，若不是，则去除所有测试服务器
                if TDHookUtils.existsServer() then 
                    sers = _orisers
                else
                    for i = 1, #_orisers do
                        if tonumber(_orisers[i].istest) ~= 1 then 
                            sers[#sers + 1] = _orisers[i]
                        end
                    end
                end
                -- 取得默认服务器id
                if ISGSVALUES() and GSVALUES.serverid then 
                    _selectedSerInfo.serid = GSVALUES.serverid
                else
                    if sers and #sers > 0 then  
                        _selectedSerInfo.serid = sers[1].serid
                        name = sers[1].sername
                    end
                end

                if maServerIndex then

                    reloadMyServer(maServerIndex)
                    return
                end

                local severColor

                for i=1,#sers do
                    if sers[i] and _selectedSerInfo.serid == sers[i].serid then
                        _selectedSerInfo.sername = sers[i].sername

                        _recentlyServerIndex = i
                        name = sers[i].sername 
                        index = sers[i].index
                        _nodeTable["mServerStatusLabel"]:setString(SERVER_STATE_WORDS[sers[i].serstatus])
                        _nodeTable["mRecentlyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX",sers[i].index)..name)
                        --status =  " (" .. SERVER_STATE_WORDS[sers[i].serstatus] .. ")"
                        if sers[i].serstatus == SERVER_STATE_MAINTAIN then
                            severColor = COLOR3.GREE 
                            _nodeTable["mServerStatusLabel"]:setColor(COLOR3.GREE)
                            _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.GREE)
                        elseif sers[i].serstatus == SERVER_STATE_FULL then 
                            severColor = COLOR3.RED
                            _nodeTable["mServerStatusLabel"]:setColor(COLOR3.RED)
                            _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.RED)
                        else
                            severColor = COLOR3.GREEN
                            _nodeTable["mServerStatusLabel"]:setColor(COLOR3.GREEN)
                            _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.GREEN)
                        end
                    end
                end

                if #sers > 0 then 
                    isLoadSers = true -- 已获取列表
                    enterAni( )
                end

                if name == "" then 
                    -- _selectedSerInfo.serid = sers[1].serid
                    -- _selectedSerInfo.serstu = sers[1].serstatus
                    -- _selectedSerInfo.version = sers[1].version
                    -- _selectedSerInfo.url = sers[1].url
                 --    _selectedSerInfo.url_android = sers[1].url_android
                    -- name = sers[1].sername
                    -- index = sers[1].index
                    _nodeTable["mServerStatusLabel"]:setString(SERVER_STATE_WORDS[sers[1].serstatus])
                    _nodeTable["mRecentlyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX",sers[1].index)..name)
                    game.addGameState("serverid", sers[1].serid, true)
                    --status = " (" .. SERVER_STATE_WORDS[sers[1].serstatus] .. ")"
                    _recentlyServerIndex = 1
                end
                local str = name
                -- _nodeTable["mMyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX_1",index,str,SERVER_STATE_WORDS[sers[_recentlyServerIndex].serstatus] ))
             --    _nodeTable["mMyServerLabel"]:setColor(severColor)

                _gridTable:setItems(sers)
                _gridTable:scrollToColumn(_recentlyServerIndex)

                reloadMyServer(_recentlyServerIndex)
                --reloadMyServer(1)

                if isToLogin then
                    btnClick()
                end

                -- createMyServer(index,str.."["..SERVER_STATE_WORDS[sers[_recentlyServerIndex].serstatus].."]",severColor)
            end
        else
            local name = ""
            local status = ""
            local index
            sers = {}
            sers1 = {}
            _orisers = properties.servers
            _orisers1 = properties.servers1

            if _orisers and _orisers1 then
                -- -- 是否是测试环境，若不是，则去除所有测试服务器
                if TDHookUtils.existsServer() then 
                    sers = _orisers
                    sers1 = _orisers1
                else
                    for i = 1, #_orisers do
                        if tonumber(_orisers[i].istest) ~= 1 then 
                            sers[#sers + 1] = _orisers[i]
                        end
                    end
                    for i = 1, #_orisers1 do
                        if tonumber(_orisers1[i].istest) ~= 1 then 
                            sers1[#sers1 + 1] = _orisers1[i]
                        end
                    end
                end
                -- 取得默认服务器id
                if GSVALUES and GSVALUES.serverid then 
                    _selectedSerInfo.serid = GSVALUES.serverid
                else
                    if sers and #sers > 0 then  
                        _selectedSerInfo.serid = sers[1].serid
                        -- name = sers[1].sername
                    end
                end

                -- if maServerIndex then
                --     reloadMyServer(maServerIndex)
                --     return
                -- end

                -- local severColor

                -- for i=1,#sers1 do
                --     if sers1[i] and _selectedSerInfo.serid == sers1[i].serid then
                --         _selectedSerInfo.sername = sers1[i].sername

                --         _recentlyServerIndex = i
                --         name = sers1[i].sername 
                --         index = sers1[i].index
                --         _nodeTable["mServerStatusLabel"]:setString(SERVER_STATE_WORDS[sers1[i].serstatus])
                --         _nodeTable["mRecentlyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX",sers1[i].index)..name)
                --         --status =  " (" .. SERVER_STATE_WORDS[sers1[i].serstatus] .. ")"
                --         if sers1[i].serstatus == SERVER_STATE_MAINTAIN then
                --             severColor = COLOR3.GREE 
                --             _nodeTable["mServerStatusLabel"]:setColor(COLOR3.GREE)
                --             _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.GREE)
                --         elseif sers1[i].serstatus == SERVER_STATE_FULL then 
                --             severColor = COLOR3.RED
                --             _nodeTable["mServerStatusLabel"]:setColor(COLOR3.RED)
                --             _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.RED)
                --         else
                --             severColor = COLOR3.GREEN
                --             _nodeTable["mServerStatusLabel"]:setColor(COLOR3.GREEN)
                --             _nodeTable["mRecentlyServerLabel"]:setColor(COLOR3.GREEN)
                --         end
                --     end
                -- end

                if #sers > 0 or #sers1 > 0 then 
                    isLoadSers = true -- 已获取列表
                    enterAni( )
                end

                -- if name == "" then 
                --     -- _selectedSerInfo.serid = sers1[1].serid
                --     -- _selectedSerInfo.serstu = sers1[1].serstatus
                --     -- _selectedSerInfo.version = sers1[1].version
                --     -- _selectedSerInfo.url = sers1[1].url
                --  --    _selectedSerInfo.url_android = sers1[1].url_android
                --     -- name = sers1[1].sername
                --     -- index = sers1[1].index
                --     _nodeTable["mServerStatusLabel"]:setString(SERVER_STATE_WORDS[sers1[1].serstatus])
                --     _nodeTable["mRecentlyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX",sers1[1].index)..name)
                --     game.addGameState("serverid", sers1[1].serid, true)
                --     --status = " (" .. SERVER_STATE_WORDS[sers1[1].serstatus] .. ")"
                --     _recentlyServerIndex = 1
                -- end
                -- local str = name
                -- _nodeTable["mMyServerLabel"]:setString(_s("LOGIN_SERVER_INDEX_1",index,str,SERVER_STATE_WORDS[sers1[_recentlyServerIndex].serstatus] ))
             --    _nodeTable["mMyServerLabel"]:setColor(severColor)

                -- _gridTable:setItems(sers1)
                -- _gridTable:scrollToColumn(_recentlyServerIndex)

                -- reloadMyServer(_recentlyServerIndex)
                local serConfig = {
                    {serList = sers}, 
                    {serList = sers1},
                }

                _serTabSelectIndex = 1
                -- 之前登陆的服务器所在列表
                local function isOnSer_( list )
                    for i, v in ipairs(list) do
                        if GSVALUES and GSVALUES.serverid == v.serid then 
                            return true
                        end
                    end
                    return false
                end
                for i, v in ipairs(serConfig) do
                    if isOnSer_(v.serList) then
                        _serTabSelectIndex = i
                    end
                end
                Log.d("_serTabSelectIndex", _serTabSelectIndex)
                reloadMyServer()
                createServerTab( )

                if isToLogin then
                    btnClick()
                end
            end
        end        
    end

    --英文首页动画
    local function enAniPlay( objs,sprites )
    	local startDelay = 0.05
    	local flashtime = 0.1
    	if objs and #objs > 0 then
    		local obj = objs[1]
    		table.remove(objs,1)
    		for i,v in ipairs(obj) do
    			local bgSprite = display.newSprite("login/login_cardw.png")
    			bgSprite:setOpacity(0)
    			_bgLayer:addChild(bgSprite)
    			table.insert(sprites,bgSprite)
    			if v == 4 then
       				util.alignNode(bgSprite, _bgLayer,display.CENTER,{top = - 25})
       			else
       				if i == 1 then
	       				bgSprite:setPosition(sprites[1]:getPositionX() - (sprites[1]:getContentSize().width + 4 ) * ( 4 - v ) ,
	       					sprites[1]:getPositionY())
	       			else
	       				bgSprite:setPosition(sprites[1]:getPositionX() +  (sprites[1]:getContentSize().width + 4) * ( v - 4 ),
	       					sprites[1]:getPositionY())
	       			end
	       		end

	       		local array     = {}
                -- 延迟时间
                array[#array + 1] = CCDelayTime:create(startDelay)
                -- 显示 
                array[#array + 1] = CCFadeTo:create(flashtime,255)

                array[#array + 1] = CCCallFunc:create(
                    function ()
                        local sprite = display.newSprite("login/login_card"..v..".png")
                        util.alignNode(sprite, bgSprite,display.CENTER)
                        bgSprite:addChild(sprite)

                        if v == 4 or i == 2 then 
                        	enAniPlay(objs,sprites)
                        end
                    end
                )
                array[#array + 1] = CCFadeTo:create(flashtime,0)
                bgSprite:runAction(TDAnimationUtils.sequence(array))
    		end
    	else
    		--标题
    		--display.addSpriteFramesWithFile("login/logo_anim.plist","login/logo_anim.png")
	        local titleImg = display.newSprite("login/login_word.png")
			_bgLayer:addChild(titleImg,1000)
			titleImg:setOpacity(0)
	        util.alignNode(titleImg, _bgLayer,display.CENTER, {top = - titleImg:getContentSize().height / 2})

	  		 --英文版标题
			
			 transition.fadeTo(titleImg, { time = 1.0, opacity = 255, onComplete = function ( ... )
			 		 --语言切换
			       	createLanguageSwitch()
                    if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE ~= "ja" then
    			       	if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK, _GAME.CONFIG.SDK.SDK_TWITTER, _GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
    		                 --facebook和twitter按钮
    		                _facebookEnter = createBtn(_GAME.CONFIG.SDK.SDK_FACEBOOK , 300)
    		                _twitterEnter = createBtn(_GAME.CONFIG.SDK.SDK_TWITTER , 600)
    		            else
    						--登录按钮
    				        _enter = createBtn()
    				    end
    			        --我的服务器点击
    			        myServerLayerClick()

                        _nodeTable["mMyServerLayer"]:setVisible(true)
                    else
                        createJPBtn()
                        _nodeTable["mMyServerLayer"]:setVisible(false)
                    end
                    _nodeTable["mVersionLabel"]:setString("v " .. DEFLOGINBASEINFO.cv)
                    transition.fadeTo(_nodeTable["mVersionLabel"], { time = 1.0, opacity = 255, })
			 	end
			 })
    	end
    end

    --中文背景
	local function createBgCn( ... )
		local bgImg = display.newSprite("login/login_bg.jpg")
		_bgLayer:addChild(bgImg)
        util.alignNode(bgImg, _bgLayer)

        local titleImg = display.newSprite("login/login_word.png")
		_bgLayer:addChild(titleImg)
        util.alignNode(titleImg, _bgLayer,display.TOP_CENTER)
        titleImg:setOpacity(0)
        transition.fadeTo(titleImg, { time = 1.0, opacity = 255, })

        --语言切换
		createLanguageSwitch()

		if isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK, _GAME.CONFIG.SDK.SDK_TWITTER, _GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
             --facebook和twitter按钮
            _facebookEnter = createBtn(_GAME.CONFIG.SDK.SDK_FACEBOOK , 300)
            _twitterEnter = createBtn(_GAME.CONFIG.SDK.SDK_TWITTER , 600)
        else
			--登录按钮
	        _enter = createBtn()
	    end
        --我的服务器点击
        myServerLayerClick()
        _nodeTable["mMyServerLayer"]:setVisible(true)
	end
	--英文背景
	local function createBgEn( ... )
		local bgImg = display.newSprite("login/login_bg.jpg")
		_bgLayer:addChild(bgImg)
        util.alignNode(bgImg, _bgLayer)

        enAniPlay( {{4},{3,5},{2,6},{1,7}},{} )
	end  
    -- 日文背景
    local function createBgJa( )
        local bgImgFile 
        if not GSVALUES or not GSVALUES.serLstId then
            bgImgFile = "login/login_bg_left.png"
        else
            bgImgFile = GSVALUES.serLstId == 1 and "login/login_bg_left.png" or "login/login_bg_right.png"
        end
        local bgImg = display.newSprite(bgImgFile)
        _bgLayer:addChild(bgImg)
        util.alignNode(bgImg, _bgLayer)

        local titleImg = display.newSprite("login/login_word.png")
        _bgLayer:addChild(titleImg, 10)
        util.alignNode(titleImg, _bgLayer, display.TOP_CENTER, 20)
        titleImg:setOpacity(0)
        transition.fadeTo(titleImg, { time = 1.0, opacity = 255, })

        createJPBtn()

        _nodeTable["mMyServerLayer"]:setVisible(false)
        function _bgLayer:setSerLstId( lstId )
            bgImg:removeFromParentAndCleanup(true)
            bgImgFile = lstId == 1 and "login/login_bg_left.png" or "login/login_bg_right.png"
            bgImg = display.newSprite(bgImgFile)
            _bgLayer:addChild(bgImg)
            util.alignNode(bgImg, _bgLayer)
        end
    end
--[[ ## local fuction --]]
	local function initViews()
        -- 看下这小样是不是要播放视频
        local soundDelayTime = 0
        if not isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) and _GAME.CONFIG.LANGUAGE_SET.OPENING_VIDEO ~= false then 
            if isandroid() or isios() then 
                try(function()
                    ISGSVALUES()
                    if not GSVALUES or not GSVALUES.moviePlayed then 
                        --如果不存在说明是第一次打开程序，播放cg视频
                        GSVALUES = GSVALUES or {}
                        GSVALUES.moviePlayed = true
                        GS.save(GSVALUES)
                        local MoviePlay = require("sdk.MoviePlay")
                        soundDelayTime = 15
                        MoviePlay.playMovie()
                    end
                end, nil, nil)
            end
        end
        util.delayCall(
            function ( )
                SOUND:playMusicMap(true)
            end, soundDelayTime
        )		

		_bgLayer = CCBCenter.getNodeByTag(_node, 1)

        _myServerNode = CCBCenter.getNodeByTag(_node, 406)

		_mServerListNode = CCBCenter.getNodeByTag(_node, 50102)

		if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "en" then
            -- 采用英文式的登录样式
			createBgEn()
			CCBCenter.getNodeByTag(_node, 4):setPosition(489,200)
		elseif _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "cn" then 
            -- 采用中文式的登录样式
			createBgCn()
			CCBCenter.getNodeByTag(_node, 4):setPosition(489,162)
        elseif _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "ja" then 
            createBgJa()
            CCBCenter.getNodeByTag(_node, 4):setVisible(false)
            CCBCenter.getNodeByTag(_node, 7):setVisible(true)
            -- 第1步：拿到服务器列表 
            CCBCenter.sendLuaMessage(MSG_ID.MSG_GETSERLIST)
		end

		--如果是云顶sdk 
        if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING, _GAME.CONFIG.SDK.SDK_APPSTORE, _GAME.CONFIG.SDK.SDK_APPSTORE_EN, _GAME.CONFIG.SDK.SDK_APPLEYUNDING) then
            createYundingUerInfo()
        end 

        _gridTable = createSerListTable()

        widget.bindMaskLayer(_nodeTable["mServerListLayer"],false,false,ccc4(16,8,11,153),
        	function ()
        		CCBCenter.getNodeByTag(_node, 4):setVisible(true)
        		util.enableCustomTouch(_node,true)
        		util.enableCustomTouch(_bgLayer,true)
        	end
        )
        widget.bindTouchEvent{
            layer = _nodeTable["mMyServer"],
            clickListener = function ( layer )
                _nodeTable["mServerListLayer"]:hideWithMask(false,true)
                CCBCenter.getNodeByTag(_node, 4):setVisible(true)
                util.enableCustomTouch(_node,true)
                util.enableCustomTouch(_bgLayer,true)
                reloadMyServer(_recentlyServerIndex)
            end
        }
	end

    local function setCanenter( canenter )

        if _GAME.CONFIG.LANGUAGE_SET.LOGIN_STYLE == "ja" then
            _node:removeChildByTag(1000, true)
            _node:removeChildByTag(1001, true)
            isLoadSers = false
            game.addGameState("serverid", nil, true)
            _selectedSerInfo.seradd = ""
            isToLogin = true
            createJPBtn()
        else
            if canenter then
                CCBCenter.getNodeByTag(_node, 4):setVisible(true)
            end
        end

        enterAni(canenter)
    end

--[[ ## public fuction --]]
	_node.reloadSerList = reloadSerList
	_node.setCanenter = setCanenter
--[[ ## MAINs --]]
	initViews()
end

return M