--UserRegisterLayer.lua
local M = {}

function M.bindView(node, luaValue)
	local TAG = "[UserRegisterLayerView]"
	local _node, _nodeTable = node, luaValue
--[[ ## local fuction --]]
	local function initViews()
	    -- [包含文件]
	    -- require("static.data_map")


	    -- [常量]
	    local PHI 					= "register/"
	    local D_GENDER 				= MALE
		local POSITION_PLAYER 		= ccp(0, 0)

	    -- [操作变量]
	    -- 数字
	    local TDNumberUtils 			= require(PH_MDL_UTIL .. "TDNumberUtils")
	    -- 动画
	    local TDAnimationUtils 			= require(PH_MDL_UTIL .. "TDAnimationUtils")
	    -- 语言差异
	    local LanguageDifference 		= require("cardui.LanguageDifference")
        -- [通用]
        local _ebNamebox    			= nil
        local _ebInvitecode				= nil
        --性别选择背后光圈
        local _sexSelectedBg
        --性别
        local _genderId = 1
        --动画名称
        local actionName = {"male_selected","female_selected","user_slected_scale"}

        local userTable = {}
        --名字是否随机 0 随机 1 自己输入
        local isEdit = 0
        local _placeHolderText = nil

        -- [快捷调用]
        local N           				= _nodeTable

	    -- [私有方法声明]
	    -- [视图渲染]
	    --layer绑定点击事件
	    local bindLayerClick
	    -- 视图渲染
	    local viewRender
	    -- 加载结点
	    local loadNode
	    -- 加载结点[角色名]
		local loadNodeRoleName
	    -- 加载结点[邀请码]
		local loadNodeInvitecode
		-- 加载渲染以外的其他操作
		local loadRenderOtherwise
		--动画完成方法
		local bindAnimationCompletedEven

	    -- [数据]

	    -- [全局调用]
    	-- 显示角色动画
    	local animateRole
	    -- 刷新角色
	    local refleshRole

	    -- 设置角色名称
	    local setRoleName
	    -- 获得角色名称
	    local getRoleName
	    -- 获得邀请码
	    local getInvitecode
	    --设置邀请码
	    local setInvitecode
	    -- 重新加载玩家
	    local hookReloadPlayer
		-- 获得随机角色名
		local getRandomName
	    -- 设置随机角色名称
	    local setRandomRoleName

	    -- [Util]
	    -- 获得结点
	    local NODE

	    -- [私有方法定义]
	    -- [实例方法][视图渲染]
	    -- 视图渲染
	    function viewRender()
		    -- 加载结点
			loadNode()
			-- 加载渲染以外的其他操作
			loadRenderOtherwise()
			--layer绑定点击事件
	    	bindLayerClick()
	    	--layer点击事件
	    	layerClick()
		end

		--layer绑定点击事件
		function bindLayerClick( ... )

			_sexSelectedBg =  CCBCenter.getNodeByTag(_node, 301,"CCSprite")

			--点击取消的区域
			widget.bindTouchEvent{
				layer = userTable[1].layer,
				priority = 10000,
				clickListener = function (  )

					if isEdit == 0 and _genderId == 2 then
						_genderId = 1
						setRandomRoleName()
					end

					_genderId = 1

					layerClick()
				end,
			}

			widget.bindTouchEvent{
				layer = userTable[2].layer,
				priority = 10000,
				clickListener = function (  )

					if isEdit == 0 and _genderId == 1 then
						_genderId = 2
						setRandomRoleName()
					end

					_genderId = 2
					
					layerClick()
				end,
			}

			_node:bindAnimationCompletedEvent(animationCompletedCallback)
		end
	    
	    -- 加载结点
	    function loadNode()

	    	local maleLayer = CCBCenter.getNodeByTag(_node, 302,"CCLayer")
			local femaleLayer = CCBCenter.getNodeByTag(_node, 303,"CCLayer")
			local maleSprite = CCBCenter.getNodeByTag(_node, 30201,"CCSprite")
			local femaleSprite = CCBCenter.getNodeByTag(_node, 30301,"CCSprite")
			local maleIcoSprite = CCBCenter.getNodeByTag(_node, 30203,"CCSprite")
			local femaleIcoSprite = CCBCenter.getNodeByTag(_node, 30303,"CCSprite")
			local maleNameLabel = CCBCenter.getNodeByTag(_node, 30205,"CCLabel")
			local femaleNameLabel = CCBCenter.getNodeByTag(_node, 30305,"CCLabel")

			local t = {layer = maleLayer,sprit = maleSprite , icon = maleIcoSprite,label = maleNameLabel}
			local t2 = {layer = femaleLayer,sprit = femaleSprite , icon = femaleIcoSprite,label = femaleNameLabel}

			table.insert(userTable , t)
			table.insert(userTable , t2)

		    -- 加载结点[角色名]
			loadNodeRoleName()
	    end

	    -- 加载结点[角色名]
		function loadNodeRoleName()
			_placeHolderText = _s("REGISTER_INPUT_NAME")
			local parent = _node -- CCBCenter.getNodeByTag(_node, 1,"CCLayer")
			local nameLayer = CCBCenter.getNodeByTag(_node, 102,"CCLayer")

			_ebNamebox = widget.newEditBox({
				contentSize 	= CCSize(190, 40), -- parent:getContentSize(),
				x 				= nameLayer:getPositionX() , 
				y 				= nameLayer:getPositionY() - 2 ,
				normalBgImage 	= {file = "hook_ac.png"},
				text 			= "",
				placeHolderText = _placeHolderText,
				placeholderFontColor = device.language == "cn" and COLOR3.WHITE or COLOR3.GREE ,
				textMaxLength 	= 10,
				textChangedListener = function(editBox, text)
					isEdit = 1
					if text == "" then 
						_ebNamebox:setPlaceHolder(_placeHolderText)
					end
				end,
			})   

			--_ebNamebox:setPosition(nameLayer:getPositionX(),nameLayer:getPositionY())
			parent:addChild(_ebNamebox, 99000, 99000)
		end

	    -- 加载渲染以外的其他操作
	    function loadRenderOtherwise()

			-- 设置随机角色名
			setRandomRoleName()

			if device.language == "cn" then 
				N["btnRandom"]:setVisible(true)
			else
				_ebNamebox:setPositionX(568)
				CCBCenter.getNodeByTag(_node, 401,"CCLayer"):setPositionX(480)
				N["btnRandom"]:setVisible(false)
			end
	    end

	    -- [全局调用]

	    -- 设置角色名称
	    function setRoleName(name)
	    	isEdit = 0
	    	_ebNamebox:setText(name)
	    	_ebNamebox:setPlaceHolder(name)

		    _ebNamebox:setOpacity(255)
			_ebNamebox:setColor(ccc3(255, 255, 255))
			_ebNamebox:setMaxLength(_ebNamebox:getMaxLength())
	    end

	    -- 获得角色名称
	    function getRoleName()
	    	return _ebNamebox:getText()
	    end

		-- 获得随机角色名
		function getRandomName()
			local name = ""

			local ns
			local nameStore = require("ccb.m.user.NameStore")
			if _genderId == 1 then 
				ns = UTF8(nameStore.MALENAMESTORE)
			else 
				ns = UTF8(nameStore.FEMALENAMESTORE)
			end

			local ranwordt = {}
			local numWords = TDNumberUtils.random(2, 6)
			for i = 1, numWords do
				local ranindex = TDNumberUtils.random(1, ns:len())
				local w = ns:sub(ranindex,ranindex)
				ranwordt[#ranwordt + 1] = tostring(w)
				name = name .. tostring(w)
			end
			nameStore = nil
			return name
		end

		-- 设置随机角色名称
		function setRandomRoleName()
			if device.language == "cn" then 
				setRoleName(getRandomName())
			end
		end
		--设置邀请码
		function setInvitecode( ... )

			userTable[_genderId].label:setString(getRoleName())
			_node:playCCBAnimation( actionName[_genderId], 0 )

			_ebNamebox:setPlaceholderFontColor(COLOR3.GREE )
			_placeHolderText = _s("REGISTER_CAN_NOT_INPUT")
			_ebNamebox:setPlaceHolder(_placeHolderText)
			_ebNamebox:setText("")
			_ebNamebox:setPositionX(CCBCenter.getNodeByTag(_node, 103,"CCLayer"):getPositionX())
			_ebNamebox:setPositionY(CCBCenter.getNodeByTag(_node, 103,"CCLayer"):getPositionY())
			_ebNamebox:setVisible(false)

		end

		function layerClick( ... )
			userTable[_genderId].sprit:setColor(COLOR3.WHITE)
			userTable[_genderId].icon:setColor(COLOR3.WHITE)
            userTable[3 - _genderId].sprit:setColor(BUTTON_COLOR3.GREE)
            userTable[3 - _genderId].icon:setColor(BUTTON_COLOR3.GREE)

            _sexSelectedBg:setPosition(userTable[_genderId].layer:getPositionX(),userTable[_genderId].layer:getPositionY())
		end

		--动画结束
		function animationCompletedCallback(  animationManager, animName, luaEventHandler  )
			if animName == actionName[3] then
				_node:playCCBAnimation( actionName[3], 0 )
				layerClick()
			else
				_ebNamebox:setVisible(true)
            end
		end

	    -- [Util]
		-- 获得结点
		function NODE(nodeTag)
			return CCBCenter.getNodeByTag(_node, nodeTag)
		end

		function getGenderId( ... )
			return _genderId
		end

	    -- [具体操作]
	    -- 视图渲染
	    viewRender()

	    -- [赋加属性]
	    -- 刷新角色
		_node.refleshRole 					= refleshRole
	    -- 设置角色名称
	    _node.setRoleName 					= setRoleName
	    -- 获得角色名称
	    _node.getRoleName 					= getRoleName
	    -- 设置随机角色名称
	    _node.setRandomRoleName 			= setRandomRoleName
	    -- 获得邀请码
	    _node.getInvitecode 				= getInvitecode
	    -- 填写邀请码
	    _node.setInvitecode 				= setInvitecode
	    -- 获取角色性别
	    _node.getGenderId 					= getGenderId
	end

--[[ ## public fuction --]]

--[[ ## MAINs --]]
	initViews()
end

return M