FragmentView = require("cardui.FragmentView")

--屏蔽新版功能入口
SKILL_NEW_FUNCTION = false

-- [[ 新旧版首页 ]]
MAINLAYER_PATH = "ccb.c.main.MainNewLayer"
MAINLAYER_ID = "MSG_MAINNEWLAYER_MODEL"
-- [卡组缓存]
CARD_CACHE = nil

-- [天赋作用类型]
TALENT_EFFECT_ATK  = 1 	-- 攻击
TALENT_EFFECT_HP   = 2 	-- 生命
TALENT_EFFECT_SP   = 3 	-- 提高体力上限
TALENT_EFFECT_STAR = 4 	-- 星星采集量

-- [种族]
RACE_ALL 	   = 0 		-- 全种族
RACE_ALLIANCE  = 1 		-- 联盟
RACE_TRIBE     = 2 		-- 部落
RACE_UNDEAD    = 3 		-- 亡灵
RACE_HERO 	   = 100 	-- 英雄
RACE_MAIN 	   = 101 	-- 主卡

RACE_NAMES = {
	_s("CARD_RACE_ALLIANCE"),
   	_s("CARD_RACE_TRIBE"),
   	_s("CARD_RACE_UNDEAD"),
}

-- [[ 活动atype ]]

ACTIVITY_ATYPE = {
	INVITE            = 7,	-- 邀请好友送钻
	FIRST             = 4,	-- 首次充值
	EIGHT_DAY         = 10,	-- 八天领钻
	FORTUNEWHEEL      = 12,	-- 大转盘
	LIMIT_TIME        = 13,	-- 限时活动
	BULLETIN          = 14,	-- 公告
	DAILY_DIAMOND	  = 99989,-- 天天领钻
	Daily_Expense  	  = 99998, -- 天天消费
	WORSHIP  	  	  = 99997, -- 祭拜屈原
	KILL_BUG		  = 99996, -- 端午节除害
	LIMIT_TIME_LOGIN  = 99995, -- 限时连续登录
	ONE_DAY_COST      = 99994, -- 单天累计消费
	ONE_DAY_CHARGE    = 99993, -- 单天累计充值
	LIMIT_TIME_CHARGE = 99990, -- 限时充值活动
	SINGLE_CHARGE     = 99992, -- 单笔充值活动
	LIMIT_TIME_COST   = 99991, -- 限时消费活动
}

-- 奖励类型
REWARDTYPE = {
		DIAMOND   = 1, -- 钻石
		GOLD 	  = 2, -- 金币
		FP 		  = 3, -- 友情点
		CARD      = 4, -- 卡牌
		CHIP      = 5, -- 碎片
		FREECARD  = 6, -- 免费抽奖
		SP 		  = 7, -- 体力
		EXP       = 8, -- 经验
		STAR 	  = 9, -- 星星
}

-- 任务图标
MISSIONICON = {
		DIAMOND   =  1, -- 钻石
		GOLD 	  =  2, -- 金币
		FP 		  =  3, -- 友情点
		CARD      =  4, -- 卡牌
		CHIP      =  5, -- 碎片
		FREECARD  =  6, -- 免费抽奖
		SP 		  =  7, -- 体力
		EXP       =  8, -- 经验
		ARENA     =  9, -- 竞技场
		STAR 	  = 10, -- 星星
}

-- 任务与奖励类型
MISSIONTARGET = { 
		SIGNIN  			= 1, 	-- 签到
		JJC     			= 2, 	-- 竞技场
		SP      			= 3, 	-- 领体力
		UPGRADE 			= 4, 	-- 升级奖励
		BITMAP 				= 5, 	-- 大地图奖励
		BLUNT 				= 6, 	-- 冲级赛
		FIRSTCHARGE 		= 7, 	-- 首次充值
		JJCRWARD 			= 8, 	-- 竞技场日常
		GETSTAR				= 9,	-- 领星星
		CHARGEREWARD1 		= 21 ,	-- 首次充值奖励
		CHARGEREWARD1000 	= 22 ,	-- 充值1000奖励
		CHARGEREWARD3000 	= 23,	-- 充值3000奖励
		CHARGEREWARD5000 	= 24 ,	-- 充值5000奖励
		CHARGEREWARD10000 	= 25 ,	-- 充值10000奖励
		CHARGEREWARD30000 	= 26 ,	-- 充值30000奖励
		CHARGEREWARD50000 	= 27 ,	-- 充值50000奖励
		RECHARGE 			= 100, 	-- 充值活动
}

-- 活动状态
MISSIONSTATUS = { 
		UNFINISHED  = 0, -- 未完成
		JOIN	  	= 1, -- 参与
		RECEIVE    	= 2, -- 领取
		FINISHED   	= 3, -- 完成
		NOTOPEN	    = 4, -- 未开启
		TRUCE	    = 5, -- 休战中
}

-- 星星商店商品类型
STARTYPE = {
		FREEBUY 	= 1,  -- 免费抽卡次数
		SP 	    	= 2,  -- 体力
		EXPCARD1  	= 3,  -- 卡牌（初级经验卡）
		EXPCARD2  	= 4,  -- 卡牌（中级经验卡）
		EXPCARD3  	= 5,  -- 卡牌（高级经验卡）
		CHIP    	= 6,  -- 碎片
		FP  		= 7,  -- 友情点
		DIAMOND	    = 8,  -- 钻石
		UNDEFINE    = 9,  -- 后期各种装备，强化石
		GOODS 	    = 10, -- 物品

}

-- 卡牌数量上限
-- CARD_MAX_COUNT = 120
-- 卡牌等级上限
CARD_MAX_LEVEL = 60
-- 卡组上限
CARDGROUP_LIMIT = 500

-- [模板]
-- 卡片图标文件模板
CARD_ICON 			= "photoCard/img_photoCard_%d.png"
-- 卡片图像文件模板
CARD_IMAGE 			= "minCard/img_minCard_%d.jpg" 
-- 卡片图像文件(加大版)模板
CARD_IMAGEEX		= "middleCard/img_middleCard_%d.jpg" 
-- 卡片图像文件(最大)模板
CARD_IMAGEMAX		= "maxCard/img_maxCard_%d.jpg" 

-- [碎片排法]
FragmentView.TILE_ORDERS = {
	
}