-----------sdk充值平台全局参数---------------------------
--[[
[1]:识别符;
[2]:服务器url片段(ios);
[3]:android用luaj的类名;
[android]:android时的服务器url片段,无则用[2];
[domain]:连接的服务器,连同端口号;
[lan]:此sdk使用的语言,若为字符串则为固定此语言,或为table,表示从table中定义的语言中由系统语言匹配一个,若不存在则以第一个为默认语言
--]]
_GAME.CONFIG.SDK = { 
	-- 非SDK版
	SDK_NONE        = { 0, "_knm", "com/csgame/card/Card", android = "_tmp", lan = {"cn", "en"}}, 
	-- SDK_NONE        = { 0, "_knm", "com/funcript/dungeonsevil/Card", android = "_tmp", onekeylogin = true, lan = {"ja"}}, 
	-- 云顶
	SDK_YUNDING     = { 1, "_app", "com/csgame/eudemonswar/appfame/Card", android = "_android_myzg", lan = "cn" },
	-- 网龙
	SDK_91          = { 2, "_91", "com/csgame/card91/Card", android = "_android_myzg", lan = "cn" },
	-- 苹果
	SDK_APPSTORE    = { 3, "_ios_myzg", lan = {"cn", "en"}, domain = "http://ahdxc.app-fame.com:189" },
	-- 苹果 英文
	SDK_APPSTORE_EN = { 3, "_ios_myzg_en", lan = "en", domain = "http://myzggs3.app-fame.com:89" , share = {"facebook"}},--
	-- 点金游戏平台
	SDK_DJGAME      = { 70, "_none", "com/csgame/card/djgame/Card" },
	-- 小米游戏平台,仅android
	SDK_XIAOMI      = { 4, "_android_myzg", "com/gao7gao8/myzg/mi/Card", lan = "cn" },
	-- 360,仅android
	SDK_360      	= { 5, "_android_myzg", "com/gao7gao8/myzg/sdk360/Card", lan = "cn" },
	-- 豌豆荚,仅android
	SDK_WANDOUJIA   = { 6, "_android_myzg", "com/gao7gao8/myzg/wdj/Card", lan = "cn" },
	-- 多酷,仅android
	SDK_DUOKU 		= { 7, "_android_myzg", "com/gao7gao8/myzg/sdkDK/Card", lan = "cn" },
	-- 当乐
	SDK_DOWNJOY 	= { 8, "_android_myzg", "com/gao7gao8/myzg/downjoy/Card", lan = "cn" },
	-- 3g
	SDK_3G 			= { 9, "_android_myzg", "com/gao7gao8/myzg/sdk3g/Card", lan = "cn" },
	-- 拇指玩
	SDK_MZW 		= { 12, "_android_myzg", "com/gao7gao8/myzg/mzw/Card", lan = "cn" },
	-- facebook ios
	SDK_FACEBOOK    = { 10, "_test" },
	-- twitter IOS
	SDK_TWITTER    	= { 11, "_test"},
	-- twitter and facebook
	SDK_TWITTERANDFACEBOOK = {13, "_test"},
	-- 华为, 仅android
	SDK_HW 			= { 16, "_android_myzg", "com/gao7gao8/knm/huawei/Card", lan = "cn" },
	-- 日本 PLAY
	-- SDK_JP_PLAY 	= { 15, "", "com/funcript/dungeonsevil/Card", onekeylogin = true, lan = "ja", domain = "http://dw.apps4jp.com:2089" },
	-- SDK_JP_PLAY 	= { 15, "_jptest", "com/funcript/dungeonsevil/Card", domain = "http://dw.apps4jp.com:2089", onekeylogin = true, lan = "ja", army = false, chat = false, share = {"facebook"}, albumShowCard = false},
	-- SDK_APPSTORE_JP	= { 15, "_jptest", "com/funcript/dungeonsevil/Card", domain = "http://dw.apps4jp.com:2089", onekeylogin = true, lan = "ja", army = false, chat = false, share = {"facebook"}, albumShowCard = false},
	-- 日本测试用
	SDK_JP_PLAY 	= { 15, "_ios", "com/funcript/dungeonsevil/Card", onekeylogin = true, lan = "ja", army = false, chat = false, share = {"facebook"}, albumShowCard = false, domain = "http://dw.apps4jp.com:2089"},
	SDK_APPSTORE_JP	= { 20, "_ios", "com/funcript/dungeonsevil/Card", onekeylogin = true, lan = "ja", army = false, chat = false, share = {"facebook"}, albumShowCard = false, domain = "http://dw.apps4jp.com:2089"},
	-- 台湾松岗 http://mm-login.play168.com.tw/server_tmp.txt
	SDK_UCUBE 		= { 17, "_ios_tw", lan = "tw", domain = "http://mm-login.play168.com.tw:80", share = {"facebook"}, army = false},

	-- 松岗登陆，松岗支付
	SDK_UCUBE_UNALIS = { 19, "_ios_tw", "com/gao7gao8/myzg/ucubeUnalis/Card", domain = "http://mm-login.play168.com.tw:80", lan = "tw", share = {"facebook"}, army = false},
	-- 松岗登陆，google play支付
	SDK_UCUBE_PLAY = { 18, "_ios_tw", "com/gao7gao8/myzg/ucubePlay/Card", domain = "http://mm-login.play168.com.tw:80", lan = "tw" , share = {"facebook"}, army = false},
	-- 越南，google play支付
	SDK_VIETNAM_PLAY = {21, "_knm", "com/gao7gao8/myzg/vietnamPlay/Card", android = "_tmp", lan = {"cn", "en"}}
}

_GAME.CONFIG.SDK_PLATFORM = _GAME.CONFIG.SDK.SDK_YUNDING

_GAME.CONFIG.DEFAULT_LANGUAGE = _GAME.CONFIG.SDK_PLATFORM.lan

-- function isSDK( destSDK, srcSDK )
-- 	if not srcSDK then 
-- 		srcSDK = _GAME.CONFIG.SDK_PLATFORM
-- 	end
-- 	return destSDK == srcSDK
-- end

function isSDK( ... )
	local sdks = { ... }
	local cur = _GAME.CONFIG.SDK_PLATFORM
    for i, v in ipairs(sdks) do
        if v == cur then 
            return true
        end
    end
    return false
end

if isSDK(_GAME.CONFIG.SDK.SDK_NONE) or _GAME.CONFIG.SDK_PLATFORM.onekeylogin == true then
    ENABLED_SDK_ONEKEYLOGIN = true -- 强制开启NO SDK
end

-- if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) then 
-- 	-- 看来是欧美版,传说中的暗黑地下城,luaj的路径要改下
-- 	_GAME.CONFIG.SDK.SDK_PLATFORM[3] = "com/csgame/card/yunding/Card"
-- end

if CCApplication:sharedApplication():getTargetPlatform() == kTargetAndroid then 
	
	ANDROID_CLASS_NAME = _GAME.CONFIG.SDK_PLATFORM[3]

	-- if ENABLED_SDK_ONEKEYLOGIN then 
	-- 	ANDROID_CLASS_NAME = "com/csgame/card/Card"
	-- end
	-- 在android时区分出和ios的访问地址区别
	if _GAME.CONFIG.SDK_PLATFORM.android then 
		_GAME.CONFIG.SDK_PLATFORM[2] = _GAME.CONFIG.SDK_PLATFORM.android
	end
end

SDK_TEAKEY = "67c7c4465aa0a10c6d6345fbec" --发布打乱


