-- 卡片数据库操作
require("sqlite3")

BackpackDB = {}

local TAG = "[BackpackDB]"
local DB_PATH = util.fullPath( PATH_CARD_DB )


--[=[ ## local params --]=]

--[[ ## local fuction --]]
local _db
local _backpackCache = {}

-- 打开数据库
local function openDB( )
	_db = sqlite3.open(DB_PATH)
end

-- 关闭数据库
local function closeDB( )
	_db:close()
end

--[[ ## public fuction --]]
-- 通过name获取
function BackpackDB.getByName( name )
	if _backpackCache[name] then
		-- 缓存有则直接返回
		return _backpackCache[name]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM packagetb WHERE name = ' .. '"' .. name .. '"') do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_backpackCache[name] = result
		end
		return result
	end
end
-- 通过id获取
function BackpackDB.getByID( id )
	if _backpackCache[id] then
		-- 缓存有则直接返回
		return _backpackCache[id]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM packagetb WHERE no = ' .. id) do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_backpackCache[id] = result
		end
		return result
	end
end

-- 通过id获取
function BackpackDB.getByIDs( ids )
	local result = {}
	local noCachedIds = {}
	for i, id in ipairs(ids) do
		if _backpackCache[id] then
			-- 缓存有则直接返回
			result[id] = _backpackCache[id]
		else
			-- 收集没有的id
			table.insert(noCachedIds, id)
		end
	end
	-- 查数据
	if #noCachedIds > 0 then
		openDB( )
		for v in _db:nrows('SELECT * FROM packagetb WHERE no in (' .. table.concat(noCachedIds, ",") .. ')' ) do
			result[v.cardno] = v
			-- 加入缓存
			_backpackCache[v.cardno] = v
		end
		closeDB( )
	end
	return result
end

-- 清空缓存
function BackpackDB.cleanAllCard( )
	_backpackCache = nil
end