-- 装备套装数据库操作
require("sqlite3")

EquipaddsetDB = {}

local TAG = "[EquipaddsetDB]"
local DB_PATH = util.fullPath( PATH_CARD_DB )


--[=[ ## local params --]=]

--[[ ## local fuction --]]
local _db
local _equipaddsetCache = {}

-- 打开数据库
local function openDB( )
	_db = sqlite3.open(DB_PATH)
end

-- 关闭数据库
local function closeDB( )
	_db:close()
end

--[[ ## public fuction --]]

-- 通过id获取
function EquipaddsetDB.getByID( id )
	if _equipaddsetCache[id] then
		-- 缓存有则直接返回
		return _equipaddsetCache[id]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM equipaddtb WHERE addlv = ' .. id) do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_equipaddsetCache[id] = result
		end
		return result
	end
end

-- 通过id获取
function EquipaddsetDB.getByIDs( ids )
	local result = {}
	local noCachedIds = {}
	for i, id in ipairs(ids) do
		if _equipaddsetCache[id] then
			-- 缓存有则直接返回
			result[id] = _equipaddsetCache[id]
		else
			-- 收集没有的id
			table.insert(noCachedIds, id)
		end
	end
	-- 查数据
	if #noCachedIds > 0 then
		openDB( )
		for v in _db:nrows('SELECT * FROM equipaddtb WHERE addlv in (' .. table.concat(noCachedIds, ",") .. ')' ) do
			result[v.cardno] = v
			-- 加入缓存
			_equipaddsetCache[v.cardno] = v
		end
		closeDB( )
	end
	return result
end

-- 清空缓存
function EquipaddsetDB.cleanAllCard( )
	_equipevotCache = nil
end