-- 装备数据库操作
require("sqlite3")

EquipDB = {}

local TAG = "[EquipDB]"
local DB_PATH = util.fullPath( PATH_CARD_DB )


--[=[ ## local params --]=]

--[[ ## local fuction --]]
local _db
local _equipCache = {}

-- 打开数据库
local function openDB( )
	_db = sqlite3.open(DB_PATH)
end

-- 关闭数据库
local function closeDB( )
	_db:close()
end

--[[ ## public fuction --]]
-- 通过name获取
function EquipDB.getByName( name )
	if _equipCache[name] then
		-- 缓存有则直接返回
		return _equipCache[name]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM equiptb WHERE name = ' .. '"' .. name .. '"') do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_equipCache[name] = result
		end
		return result
	end
end
-- 通过id获取
function EquipDB.getByID( id )
	if _equipCache[id] then
		-- 缓存有则直接返回
		return _equipCache[id]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM equiptb WHERE no = ' .. id) do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_equipCache[id] = result
		end
		return result
	end
end

-- 通过id获取
function EquipDB.getByIDs( ids )
	local result = {}
	local noCachedIds = {}
	for i, id in ipairs(ids) do
		if _equipCache[id] then
			-- 缓存有则直接返回
			result[id] = _equipCache[id]
		else
			-- 收集没有的id
			table.insert(noCachedIds, id)
		end
	end
	-- 查数据
	if #noCachedIds > 0 then
		openDB( )
		for v in _db:nrows('SELECT * FROM equiptb WHERE no in (' .. table.concat(noCachedIds, ",") .. ')' ) do
			result[v.cardno] = v
			-- 加入缓存
			_equipCache[v.cardno] = v
		end
		closeDB( )
	end
	return result
end

-- 清空缓存
function EquipDB.cleanAllCard( )
	_equipCache = nil
end