-- 装备技能数据库操作
require("sqlite3")
local SkillEntity = require("model.card.SkillEntity")
EquipSkillDB = {}

local TAG = "[EquipSkillDB]"
local DB_PATH = util.fullPath( PATH_CARD_DB )


--[=[ ## local params --]=]

--[[ ## local fuction --]]
local _db
local _equipSkillCache = {}

-- 打开数据库
local function openDB( )
	_db = sqlite3.open(DB_PATH)
end

-- 关闭数据库
local function closeDB( )
	_db:close()
end

--[[ ## public fuction --]]

-- 通过id获取
function EquipSkillDB.getByID( id )
	if _equipSkillCache[id] then
		-- 缓存有则直接返回
		return _equipSkillCache[id]
	else
		-- 开
		openDB( )
		local result
		for v in _db:nrows('SELECT * FROM equipskilltb WHERE esid = ' .. id) do 
			result = v
			break
		end
		-- 关
		closeDB( )
		-- 加入缓存
		if result then
			_equipSkillCache[id] = result
		end
		return result
	end
end

-- 通过id获取
function EquipSkillDB.getByIDs( ids )
	local result = {}
	local noCachedIds = {}
	for i, id in ipairs(ids) do
		if _equipSkillCache[id] then
			-- 缓存有则直接返回
			result[id] = _equipSkillCache[id]
		else
			-- 收集没有的id
			table.insert(noCachedIds, id)
		end
	end
	-- 查数据
	if #noCachedIds > 0 then
		openDB( )
		for v in _db:nrows('SELECT * FROM equipskilltb WHERE esid in (' .. table.concat(noCachedIds, ",") .. ')' ) do
			result[v.cardno] = v
			-- 加入缓存
			_equipSkillCache[v.cardno] = v
		end
		closeDB( )
	end
	return result
end
-- 通过id获取
function EquipSkillDB.getSkillEntity( id, level )
	local skill
	if _equipSkillCache[id] then
		-- 缓存有则直接返回
		skill = _equipSkillCache[id]
	else
		skill = EquipSkillDB.getByID( id )
	end
	if not skill then
		return skill
	end
	local skillEntity = SkillEntity.new{
		skillno = skill.esid,
		name = skill.name, 			-- 名称
		info = string.format(skill.memo, skill["s"..level]) ,	-- 说明	
		level = level,	
	}
	return skillEntity
end
-- 清空缓存
function EquipSkillDB.cleanAllCard( )
	_equipSkillCache = nil
end