
CVERSION = "2.0.9"

local TAG      = "game"

-- DEBUG = 2
-- LOG_LEVEL = 3
-- CCDirector:sharedDirector():setAnimationInterval(1.0 / 60)

-- define global module
game = {}


_GAME.CACHE = {}
-- 说话间隔时间
_GAME.CONFIG.SPEAK_INTERVAL = 5

_GAME.SHOWNOTICE = false

_GAME.AUTOLOGIN = {}
_GAME.AUTOLOGIN.USERID = nil
_GAME.AUTOLOGIN.TOKEN = nil

require("game_init")


if istable(_GAME.CONFIG.LANGUAGE_DIFFS[device.language]) then
    if istable(_GAME.CONFIG.LANGUAGE_DIFFS[device.language].common) then
        _GAME.CONFIG.LANGUAGE_SET = clone(_GAME.CONFIG.LANGUAGE_DIFFS[device.language].common)
    else
        _GAME.CONFIG.LANGUAGE_SET = {}
    end
    if istable(_GAME.CONFIG.LANGUAGE_DIFFS[device.language][device.platform]) then
        table.merge(_GAME.CONFIG.LANGUAGE_SET, _GAME.CONFIG.LANGUAGE_DIFFS[device.language][device.platform])
    end
else
    Log.d(TAG, "ERROR LANGUAGE SET, LANGUAGE: %s, PLATFORM: %s", device.language, device.platform)
    _GAME.CONFIG.LANGUAGE_SET = {
    }
end

display.setDesignResolutionSize(CONFIG_SCREEN_WIDTH, CONFIG_SCREEN_HEIGHT)
-- local function testMd5( )
--     local file = io.readfile("/Volumes/mac_data/Cocos2d-x/Lua/Card/client/DungeonsEvil/res/sd/img_mark.png")
--     local md5 = crypto.md5(file)
-- end
-- 生成数据库卡牌到文件夹
local function getAllCards( )
    local path = "/Volumes/mac_data/newCardImage/%s.jpg"
    local cards = CardDB.getAllCards()
    for i, card in ipairs(cards) do
        util.copyfile(string.format(CARD_IMAGEMAX, card.cardno), string.format(path, card.name))
    end
end
local function showCard( )
    GAMERATE = GameRateEntity.new{}
    local scene = display.newScene()
    display.replaceScene(scene)
    local layer = widget.newLayer{
        color = ccc4(255, 255, 100, 255), 
        contentSize = CCSize(960, 640)
    }
    scene:addChild(layer)
    util.alignNode(layer, scene)
    -- 95 60 30
    local cardEntity = require("model.card.CardEntity").new{id = 95, lv = 60, evolv = 6}
    -- cardEntity.type = require("cardui.CardMaster").MAXCARD
    -- cardEntity.type = require("cardui.CardMaster").MASTERCARD
    -- cardEntity.type = require("cardui.CardMaster").CONFIGCARD
    -- cardEntity.type = require("cardui.CardMaster").FRAGMENTCARD
    -- cardEntity.type = require("cardui.CardMaster").MONSTERCARD
    -- cardEntity.type = require("cardui.CardMaster").VICECARD
    -- cardEntity.type = require("cardui.CardMaster").ALBUMCARD
    -- cardEntity.type = require("cardui.CardMaster").MINICARD
    -- cardEntity.type = require("cardui.CardMaster").MINISTARCARD
    CardMaster = require("cardui.CardMaster")
    cardEntity.type = require("cardui.CardMaster").MAXCARD
    local card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(0, 10)
    cardEntity.type = CardMaster.MASTERCARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(410, 320)
    cardEntity.type = CardMaster.CONFIGCARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(404, 10)
    cardEntity.type = CardMaster.FRAGMENTCARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(623, 320)
    cardEntity.type = CardMaster.MONSTERCARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(623, 10)
    cardEntity.type = CardMaster.VICECARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(840, 470)
    cardEntity.type = CardMaster.ALBUMCARD
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setUnlock(true)
    card:setPosition(840, 280)
    cardEntity.type = CardMaster.MINICARD
    cardEntity.showLv = true
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(840, 160)
    cardEntity.type = CardMaster.MINISTARCARD
    cardEntity.showLv = true
    card = CardMaster.new(cardEntity)
    layer:addChild(card)
    card:setPosition(840, 10)
    -- CCBCenter.loadCCB("MSG_CARDDETAILLAYER_MODEL", "ccb.c.cardgroup.CardDetailLayer", cardEntity, function ( node )
    --     layer:addChild(node)
    --     util.alignNode(node, layer)
    -- end)
end
function game.startup()
    local DEVICE_MODEL = "sd"
    SCALE_FOR_SPECIAL_NODE = 1
    SCALE_FOR_SPECIAL_LABEL = 0.5
    -- Log.d( "game", "Device Model: %s", DEVICE_MODEL)
    AlertLayer             = require("ccb.v.common.AlertLayerView")
    PATH_CCB_FILE = PATH_CCB_FILE .. DEVICE_MODEL .. "/"
    CCFileUtils:sharedFileUtils():addSearchPath(PTAH_STORAGE_RES .. DEVICE_MODEL .. "/country/" .. device.language .. "/")
    CCFileUtils:sharedFileUtils():addSearchPath(PTAH_STORAGE_RES .. DEVICE_MODEL .. "/")
    CCFileUtils:sharedFileUtils():addSearchPath(PTAH_STORAGE_RES .. "img/")
    CCFileUtils:sharedFileUtils():addSearchPath("res/" .. DEVICE_MODEL .. "/country/" .. device.language .. "/")
    CCFileUtils:sharedFileUtils():addSearchPath("res/" .. DEVICE_MODEL .. "/")
    CCFileUtils:sharedFileUtils():addSearchPath("res/img/")

    -- util.startDebug()
    -- CCBCenter.registerHandler()

    -- [预加载背景音乐]
    -- 预加载背景音乐[主页]
    SOUND:preloadMusicHome()
    -- 预加载背景音乐[竞技场]
    SOUND:preloadMusicArena() 
    -- 预加载背景音乐[战斗]
    -- SOUND:preloadMusicFight() 
    game.getGameState()
    if game.getGameState("GAME_MUSIC") == false then 
        SOUND.setMusicOff()
    end
    if game.getGameState("GAME_SOUND") == false then 
        SOUND.setEffectsOff()
    end
    -- showCard( )
    game.enterLoginScene()
    -- getAllCards( )
    -- testMd5( )
    -- [其他]

    -- 2、幸运转盘入口
    -- CCBCenter.replaceScene("MSG_ACTIVITYFORTUNEWHEELLAYER_MODEL", "ccb.c.main.ActivityFortuneWheelLayer")

    -- 3、注册
    -- CCBCenter.replaceScene("MSG_USERREGISTERLAYER_MODEL", "ccb.c.user.UserRegisterLayer")

    -- 4、四格漫画
    -- CCBCenter.replaceScene("MSG_COMICOPENING_01_LAYER_MODEL", "ccb.c.comic.ComicOpening_01_Layer")

    -- 6、活动
    -- CCBCenter.replaceScene("MSG_MAINACTIVITYLAYER_MODEL", "ccb.c.main.MainActivityLayer")
    -- 7、战队
    -- CCBCenter.replaceScene("MSG_TEAMMEMBERLAYER_MODEL", "ccb.c.team.TeamMemberLayer")
    -- 8、排行榜
    -- CCBCenter.replaceScene("MSG_RANKINGSLAYER_MODEL", "ccb.c.rankings.RankingsLayer")
end

function game.enterLoginScene()
    -- if _GAME.CONFIG.LANGUAGE_SWITCH  then 
    --     CCBCenter.replaceScene("MSG_LOGINNEWLAYER_MODEL", "ccb.c.user.LoginNewLayer")
    -- else

    --     CCBCenter.replaceScene("MSG_LOGINLAYER_MODEL", "ccb.c.user.LoginLayer")
    -- end
    CCBCenter.replaceScene("MSG_LOGINNEWLAYER_MODEL", "ccb.c.user.LoginNewLayer")
end



