
local ActivityModel = {}
ActivityModel.TAG = "[ActivityModel]"

-- 首冲界面
function ActivityModel.fetchFirshCharge( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_FIRST_CHARGE ,         --  请求id
      responseItems,                     --  回调函数
      params.data,                       --  请求信息实体或参数table
      params.data
    )
end
-- 充值活动
function ActivityModel.fetchChargeActivity( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_CHARGE_ACTIVITY ,             --  请求id
      responseItems,                     --  回调函数
      params.data,                       --  请求信息实体或参数table
      params.data
    )
end
-- 限时充值
function ActivityModel.fetchLimitCharge( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_LIMIT_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 限时充值 领取
function ActivityModel.fetchLimitChargeReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_LIMIT_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 限时消费
function ActivityModel.fetchLimitCost( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_LIMIT_COST ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 限时消费 领取
function ActivityModel.fetchLimitCostReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_LIMIT_COST ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 连续登录
function ActivityModel.fetchConLogin( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_CON_LOGIN ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 连续登录 领取
function ActivityModel.fetchConLoginReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_CON_LOGIN ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 单笔充值
function ActivityModel.fetchSingleCharge( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_SINGLE_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 单笔充值 领取
function ActivityModel.fetchSingleChargeReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_SINGLE_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 单天累计充值
function ActivityModel.fetchOneDayCharge( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ONE_DAY_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 单天累计充值 领取
function ActivityModel.fetchOneDayChargeReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_ONE_DAY_CHARGE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 当天累计消费
function ActivityModel.fetchOneDayCost( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ONE_DAY_COST ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 当天累计消费 领取
function ActivityModel.fetchOneDayCostReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_FETCH_ONE_DAY_COST ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end
-- 月卡
function ActivityModel.fetchMonthCard( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_MONTH_CARD,             --  请求id
      responseItems,                     --  回调函数
      params.data,                       --  请求信息实体或参数table
      params.data
    )
end
-- 领取月卡奖励
function ActivityModel.fetchMonthCardReward( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_MONTH_CARD_REWARD,             --  请求id
      responseItems,                     --  回调函数
      params.data,                       --  请求信息实体或参数table
      params.data
    )
end
-- 祭拜
function ActivityModel.fetchWaeship( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_WAESHIP ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 献祭
function ActivityModel.fetchSacrifice( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_SACRIFICE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end

-- 献祭 领取
function ActivityModel.fetchSacrificeReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_SACRIFICE_REWARD ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end
-- 除害
function ActivityModel.fetchKillBug( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_KILL_BUG ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end
-- 天天消费
function ActivityModel.fetchDailyExpense( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ACTIVITY_DAILY_EXPENS ,             --  请求id
    responseItems,                     --  回调函数
    {},                       --  请求信息实体或参数table
    {}
  )
end
-- 天天消费
function ActivityModel.fetchDailyExpenseReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ACTIVITY_GET_DAILY_EXPENSE ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end
-- 天天领钻
function ActivityModel.fetchDailyDiamond( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ACTIVITY_DAILY_DIAMOND ,             --  请求id
    responseItems,                     --  回调函数
    {},                       --  请求信息实体或参数table
    {}
  )
end
-- 天天领钻 奖励
function ActivityModel.fetchDailyDiamondReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ACTIVITY_GET_DAILY_DIAMON ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                           --  请求信息实体或参数table
    {}
  )
end
-- 天天领钻 参与
function ActivityModel.fetchDailyDiamondJoin( params )
  local function responseItems( properties )

    -- 配置数值分类
    if params.callback and isfunction(params.callback) then

      params.callback(properties, params.data)
    end 
  end
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_ACTIVITY_JOIN_DAILY_DIAMOND ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    {}
  )
end
-- 除害 领取
function ActivityModel.fetchKillBugReward( params )
  local function responseItems( properties )
    if properties then
      -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
    end
  end
  
  --  创建http请求
  NetHelper.createRequest(
    ACTID.MSG_KILL_BUG_REWARD ,             --  请求id
    responseItems,                     --  回调函数
    params.data,                       --  请求信息实体或参数table
    params.data
  )
end
return ActivityModel