local M = class( "DiamondAlertEntity" )

local file = require("tandyfw.file").new(device.writablePath .. "diamondalert")

local diamondAleryTable = {}

local count = 23

if _GAME.CONFIG.SDK_PLATFORM.army == false then
	count = 20
end

-- 有需要增加就加在后面,并将总个数count改变
-- 1	幸运转盘
-- 2	挖矿冷却
-- 3	创建战队
-- 4	BOSS战冷却
-- 5	军团boss攻击次数
-- 6	购买体力
-- 7	战斗跳过
-- 8	钻石单抽
-- 9	钻石十连抽
-- 10	装备进阶成功率
-- 11	天赋钻石升级
-- 12	竞技挑战CD
-- 13	竞技场次数购买
-- 14	周赛挑战CD
-- 15	商店购买
-- 16	天天领钻重置
-- 17	藏宝海湾扫荡
-- 18 	BOSS战钻石鼓舞
-- 19	幽灵魔塔挑战次数
-- 20 	幽灵魔塔BUFF刷新
-- 21	军团创建
-- 22 	进行献祭
-- 23	军团钻石建设

--02:1或02:0   02指具体功能，1指开启弹窗，0则不开启

--给消费确认Table赋值
function M:open( )

	if ISDIAMONDALERTRELOAD then

		ISDIAMONDALERTRELOAD = false
		--无记录，创建记录
		M:createDiamondAlert( )
		return
	end

	if file.value[GSVALUES.username] then
		--已有过记录
		M:valueToTable(file.value[GSVALUES.username])
	else
		--无记录，创建记录
		M:createDiamondAlert( )
	end
end

--创建消费确认Table
function M:createDiamondAlert(  )
	local str = ""
	diamondAleryTable[0] = 0
	for i=1,count do
		-- if device.language ~= "cn" then
		-- 	str = str..i..":1,"
		-- 	diamondAleryTable[i] = 1
		-- else
		-- 	str = str..i..":0,"
		-- 	diamondAleryTable[i] = 0
		-- end

		str = str..i..","
		diamondAleryTable[i] = 1
		
	end
	file.value[GSVALUES.username] = str
	file:save()
end

function M:getIsAlert( index )

	if not table.isnotempty(diamondAleryTable) then
		--如果diamondAleryTable为空，则是第一次进入，

		M:open( )
	end
	return diamondAleryTable[index]
end

--将文件中的字符串转化为table
function M:valueToTable( value )
	local valueTbale = string.split(value, ",")
	diamondAleryTable[0] = 0
	for i = 1,count do
		diamondAleryTable[i] = 0
	end

	for i,v in ipairs(valueTbale) do
		if v ~= "" then
			--diamondAleryTable[tonumber(v)] = 1
			-- local t = string.split(v,":")
			-- diamondAleryTable[tonumber(t[1])] = tonumber(t[2])
			local t = string.split(v,":")

			if #t == 2 and tonumber(t[2]) == 1 then

				diamondAleryTable[tonumber(t[1])] = 1
			else
				diamondAleryTable[tonumber(v)] = 1
			end 

		end
	end

end
--更新某个功能的消费确认
function M:updateValue( index,newValue )
	diamondAleryTable[index] = newValue
	
	local str = ""
	if diamondAleryTable[0] == 1 and newValue == 0 then
		diamondAleryTable[0] = 0
	end
	for i,v in ipairs(diamondAleryTable) do
		if v == 1 then  
			str = str..i..","
		end
	end
	file.value[GSVALUES.username] = str
	file:save()
end
--更新所有功能的消费确认
function M:updateTable( table )

	diamondAleryTable = table
	local str = ""
	if table[0] == 1 then
		str = "0,"
	end
	for i,v in ipairs(table) do
		if v == 1 then  
			str = str..i..","
		end
	end
	file.value[GSVALUES.username] = str
	file:save()
end
--获取所有功能的消费确认
function M:getDiamondAleryTable( ... )
	if not table.isnotempty(diamondAleryTable) then
		--没有记录就打开连接
		M:open( )
	end
	return diamondAleryTable
end

return M