
local ArenaModel = {}
ArenaModel.TAG = "[ArenaModel]"

-- 获取周赛列表
function ArenaModel.fetchWeekRankList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_WEEK_RANKLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 购买周赛冷却CD
function ArenaModel.fetchWeekBuyRankCd( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_WEEK_BUY_RANKCD , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 周录像列表
function ArenaModel.fetchWeekRecordList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_WEEK_RECORDLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取周竞技奖励
function ArenaModel.fetchWeekReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_WEEK_JJCREWARD , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

return ArenaModel