
local CardModel = {}
CardModel.TAG = "[CardModel]"
CardEntity = require("model.card.CardEntity")
CardGroupEntity = require("model.card.CardGroupEntity")

-- 进入卡组界面3101
function CardModel.fetchIntoCardGroup( params )
    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_INTO_CARD  ,    --  请求id
           responseItems,               --  回调函数
           params.data,                 --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 进入配置卡牌3102
function CardModel.fetchIntoSetCard( params )
    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_INTO_SETCARD  ,    --  请求id
           responseItems,               --  回调函数
           params.data,                 --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 进入出售卡牌界面 3105
function CardModel.fetchIntoSellCard( params )
    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_INTO_SELLCARD,    --  请求id
           responseItems,               --  回调函数
           params.data,                 --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 进入保护卡牌界面 3106
function CardModel.fetchIntoProtectCard( params )
    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_INTO_PROTECT_CARD,   --  请求id
           responseItems,                   --  回调函数
           params.data,                     --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 进入保护卡牌界面 3106
function CardModel.fetchIntoEnhancedCard( params )
    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_CANSTRONG_CARDS,   --  请求id
           responseItems,                   --  回调函数
           params.data,                     --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 获取卡组信息
function CardModel.fetchCardGroup( params )

    local function responseItems( properties )
    	if properties then
    		local cardGroup = CardGroupEntity.new(properties)
    		if params.callback and isfunction(params.callback) then
		    	params.callback(cardGroup, params.data)
		    end 
    	end
    end

    --	创建http请求
	    NetHelper.createRequest(
	       ACTID.MSG_GET_CARDLIST  ,    --  请求id
	       responseItems,    			--  回调函数
	       params.data,      			--  请求信息实体或参数table
           params.data
	       -- ,nil,nil,true
	    )
end

-- 卡牌图鉴
function CardModel.fetchCardAlbum( params )

    local function responseItems( properties )
    	--把返回的json数据转换成item,然后调用回调
    	if properties then
    		local cardbooks = properties.cardbooks
    		local cards = {}
    		for i = 1 , #cardbooks do
    			local card = CardEntity.new(cardbooks[i])
                cards[i] = card
    			-- table.insert(cards, card)
    		end
    		if params.callback and isfunction(params.callback) then
		    	params.callback(cards, params.data)
		    end
    	end
    	
    end
    --   创建http请求
    NetHelper.createRequest(
    ACTID.MSG_GET_CARDBOOK , --       请求id
       responseItems,    --    	  回调函数
       params.data      --       请求信息实体或参数table
       -- ,nil,nil,true
    )
end

-- 卡片碎片
function CardModel.fetchCardFragment( params )

    local function responseItems( properties )
    	--把返回的json数据转换成item,然后调用回调
    	if properties then
    		if params.callback and isfunction(params.callback) then
		    	params.callback(properties.cardchips, params.data)
		    end
    	end
    end
    --   创建http请求
    NetHelper.createRequest(
    ACTID.MSG_GET_CARDCHIP , --       请求id
   	responseItems,    --    	  回调函数
   	params.data      --       请求信息实体或参数table
    )
end

-- 领取碎片
function CardModel.fetchReceiveCardFragment( params )

    local function responseItems( properties )
    	--把返回的json数据转换成item,然后调用回调
		if params.callback and isfunction(params.callback) then
	    	params.callback(properties, params.data)
	    end
    end
    --   创建http请求
    NetHelper.createRequest(
	   	ACTID.MSG_EARN_CARDBYCHIP , --       请求id
	   	responseItems,    --    	  回调函数
	   	params.data      --       请求信息实体或参数table
    )
end
-- 卡牌配置
function CardModel.fetchConfigCard( params )

    local function responseItems( properties )
    	if properties then
    		local group = CardGroupEntity.new(properties)
    		if params.callback and isfunction(params.callback) then
		    	params.callback(group, params.data)
		    end 
    	end
    end

    --   创建http请求
    NetHelper.createRequest(
    ACTID.MSG_SET_CARD ,  --       请求id
       responseItems,    --    	  回调函数
       params.data      --       请求信息实体或参数table
    )
end

-- 卡牌出售
function CardModel.fetchSellCard( params )

    local function responseItems( properties )
    	-- if properties then
    	-- 	local cardGroup = CardGroupEntity.new(properties)
    	if params.callback and isfunction(params.callback) then
	    	params.callback(cardGroup, params.data)
	    end
    	-- end
    end

    --   创建http请求
	    NetHelper.createRequest(
	    ACTID.MSG_SELL_CARD  ,  --       请求id
	       responseItems,    --    	  回调函数
	       params.data      --       请求信息实体或参数table
	    )
end

-- 卡牌保护
function CardModel.fetchProtectCard( params )

    local function responseItems( properties )
    	-- if properties then
    	-- 	local cardGroup = CardGroupEntity.new(properties)
    	if params.callback and isfunction(params.callback) then
	    	params.callback(properties, params.data)
	    end
    	-- end
    end

    --   创建http请求
	    NetHelper.createRequest(
	    ACTID.MSG_PROTECT_CARD   ,  -- 请求id
	       responseItems,    		-- 回调函数
	       params.data      		-- 请求信息实体或参数table
	    )
end

-- 解除卡牌保护
function CardModel.fetchUnprotectCard( params )

    local function responseItems( properties )
    	if properties then
    		local cardGroup = CardGroupEntity.new(properties)
	    	if params.callback and isfunction(params.callback) then
		    	params.callback(cardGroup, params.data)
		    end
    	end
    end

    --   创建http请求
	    NetHelper.createRequest(
	       ACTID.MSG_UNPROTECT_CARD ,  	-- 请求id
	       responseItems,    			-- 回调函数
	       params.data      			-- 请求信息实体或参数table
	    )
end

-- 强化卡牌
function CardModel.fetchUpgradeCard( params )

    local function responseItems( properties )
    	if properties then
    		local cardGroup = CardGroupEntity.new(properties)
	    	if params.callback and isfunction(params.callback) then
		    	params.callback(cardGroup, params.data)
		    end
    	end
    end

    --   创建http请求
	    NetHelper.createRequest(
	   	ACTID.MSG_CARD_STRENGTHEN , --   请求id
	       responseItems,    		--   回调函数
		       params.data      	--   请求信息实体或参数table
		    )
end

-- 切换卡组
function CardModel.fetchSwitchCard( params )
	params = params or {}
    local function responseItems( properties )
    	if properties then
    		local cardGroup = CardGroupEntity.new(properties)
	    	if params.callback and isfunction(params.callback) then
		    	params.callback(cardGroup, params.data)
		    end
    	end
    end

    --   创建http请求
	    NetHelper.createRequest(
	    ACTID.MSG_CARD_SELECTGROUP ,  --       请求id
       	responseItems,    --    	  回调函数
       	params.data      --       请求信息实体或参数table
	    )
end

-- 获得卡牌进化列表
function CardModel.fetchEvoCardGroup( params )

    local function responseItems( properties )
        if properties then
            local cardGroup = CardGroupEntity.new(properties)
            cardGroup._LIST = properties.getlist
            -- cardGroup._LIST[1] = iff(properties.list1 and properties.list1 ~= "", properties.list1, "0,0,0,0,0,0,0,0,0,0,0,0")
            -- cardGroup._LIST[2] = iff(properties.list2 and properties.list2 ~= "", properties.list2, "0,0,0,0,0,0,0,0,0,0,0,0")
            -- cardGroup._LIST[3] = iff(properties.list3 and properties.list3 ~= "", properties.list3, "0,0,0,0,0,0,0,0,0,0,0,0")
            if params.callback and isfunction(params.callback) then
                params.callback(cardGroup, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_GET_EVOCARDS  ,    --  请求id
           responseItems,               --  回调函数
           params.data,                  --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

-- 卡牌进化
function CardModel.fetchEvolutionCard( params )

    local function responseItems( properties )
        if properties then
            if params.callback and isfunction(params.callback) then
                params.callback(properties, params.data)
            end 
        end
    end

    --  创建http请求
        NetHelper.createRequest(
           ACTID.MSG_CARD_EVOLUTION  ,    --  请求id
           responseItems,               --  回调函数
           params.data,                  --  请求信息实体或参数table
           params.data
           -- ,nil,nil,true
        )
end

return CardModel