--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

技能信息实体类，定义技能基础信息实体Entity相关操作方法及逻辑实现。

-   存储技能基础信息相关信息。


]]

local M = class("SkillEntity", BaseEntity)



-- [包含文件]


-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end




-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    skillno         = { "number", },
    -- 名称
    name            = { "string", },
    -- 介绍
    info            = { "string", },
    -- 等级
    level           = { "number", },
}





-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "skillno",                  -- 类型：无。        ID。
    "name",                   	-- 类型：无。        名称。
    "info",                		-- 类型：无。        介绍。
    "level"
}










-- [Gettor/Settor方法]
-- ID
function M:getSkillno()
    return self.skillno_
end
function M:setSkillno(newKey)
    self.skillno_ = newKey
end

-- 名称
function M:getName()
    return self.name_
end
function M:setName(newKey)
    self.name_ = newKey
end

-- 介绍
function M:getInfo()
    return self.info_
end
function M:setInfo(newKey)
    self.info_ = newKey
end

-- 等级
function M:getLevel()
    return self.level_
end
function M:setLevel(newKey)
    self.level_ = newKey
end







return M