--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

活动[幸运转盘]信息实体类，定义活动[幸运转盘]信息实体Entity相关操作方法及逻辑实现。

-   存储活动[幸运转盘]信息相关信息。


]]

local M = class("EntityActivityFortuneWheelList", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                   	-- 类型：无。            ID。
    "TurnNum",                  -- 类型：无。            免费抽奖次数。
    "RefreshTime",              -- 类型：无。            免费机会刷新时间。
    "DamPrice",                 -- 类型：无。            钻石抽奖价格。
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id       		= { "number", I.UNSET_NUMBER },
    -- 免费抽奖次数
    TurnNum      	= { "number", I.UNSET_NUMBER },
    -- 免费机会刷新时间
    RefreshTime     = { "string", I.UNSET_STRING },
    -- 钻石抽奖价格
    DamPrice        = { "number", I.UNSET_NUMBER },
}










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 免费抽奖次数
function M:getTurnNum()
    return self.TurnNum_
end
function M:setTurnNum(newKey)
    self.TurnNum_ = newKey
end

-- 免费机会刷新时间
function M:getRefreshTime()
    return self.RefreshTime_
end
function M:setRefreshTime(newKey)
    self.RefreshTime_ = newKey
end

-- 钻石抽奖价格
function M:getDamPrice()
    return self.DamPrice_
end
function M:setDamPrice(newKey)
    self.DamPrice_ = newKey
end





return M