--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗信息[PK]发送的网络实体类，定义战斗信息发送的网络实体Entity相关操作方法及逻辑实现。

-   存储PK对战发送的相关信息。

]]

local M = class("EntityBattlePK", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                -- 类型：无。           ID
    "oid", 				 -- 类型：无。	       敌方玩家ID
    "kind",              -- 类型：无。           竞技类型：切磋，排名战
    "pid", 				 -- 类型：无。	       角色ID
    "op",                -- 类型：无。           操作（进入战斗，开始攻击，结束回合，自动战斗，跳过）
    "fcards",            -- 类型：无。           上场卡牌sn数组(卡牌1，2，3，4。。。)
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id          = { "number", I.UNSET_NUMBER },
    -- 敌方玩家ID
    oid   		= { "number", I.UNSET_NUMBER },
    -- 竞技类型：切磋，排名战
    kind        = { "number", I.UNSET_NUMBER },
    -- 角色ID
    pid  		= { "number", I.UNSET_NUMBER },
    -- 操作（进入战斗，开始攻击，结束回合，自动战斗，跳过）
    op          = { "number", I.UNSET_NUMBER },
    -- 上场卡牌sn数组(卡牌1，2，3，4。。。)
    fcards      = { "table", I.UNSET_TABLE, "number" },
}










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 敌方玩家ID
function M:getOid()
    return self.oid_
end
function M:setOid(newKey)
    self.oid_ = newKey
end

-- 竞技类型：切磋，排名战
function M:getKind()
    return self.kind_
end
function M:setKind(newKey)
    self.kind_ = newKey
end

-- 角色ID
function M:getPid()
    return self.pid_
end
function M:setPid(newKey)
    self.pid_ = newKey
end

-- 操作（进入战斗，开始攻击，结束回合，自动战斗，跳过）
function M:getOp()
    return self.op_
end
function M:setOp(newKey)
    self.op_ = newKey
end

-- 上场卡牌sn数组(卡牌1，2，3，4。。。)
function M:getFcards()
    return self.fcards_
end
function M:setFcards(newKey)
    self.fcards_ = newKey
end





return M