--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

英雄信息实体类，定义英雄基础信息实体Entity相关操作方法及逻辑实现。

-   存储英雄基础信息相关信息。


]]

local M = class("EntityHero", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    -- [属性注入]
    self:setProperties(properties)


    -- [覆盖方法]
    --[[
    -- 设置头像
    function self:setHead(imageNo)
        self.head_ = string.gsub(TPL_CARD_ICON, "{0}", imageNo)
    end


    -- 重新操作
    self:setHead(properties.head)
    ]]
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                    -- 类型：无。           ID
    "name",                  -- 类型：无。           名字。
    "head",                  -- 类型：无。           头像。
    "lv",                    -- 类型：无。           等级。
    "hp",                    -- 类型：无。           血量。
    "exp",                   -- 类型：无。           经验值。
    "rank",                  -- 类型：无。           排名。
    "lastdate",              -- 类型：无。           最后登录时间。
    "sex",                   -- 类型：无。           性别。
    "winrate",               -- 类型：无。           胜率。
    "equipEffect",           -- 装备加成
    "equiplst",              -- 装备简述
    "equipinfolst",          -- 装备详情
    "totalhp",               -- 总血量
    "totalatk",              -- 总攻击
    "EquipSk",               -- 装备技能
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id          = { "number", I.UNSET_NUMBER },
    -- 名字
    name        = { "string", I.UNSET_STRING },
    -- 头像
    head        = { "string", I.UNSET_STRING },
    -- 等级
    lv          = { "number", I.UNSET_NUMBER },
    -- 血量
    hp          = { "number", I.UNSET_NUMBER },
    -- 经验值
    exp         = { "number", I.UNSET_NUMBER },
    -- 排名
    rank        = { "number", I.UNSET_NUMBER },
    -- 最后登录时间
    lastdate    = { "string", I.UNSET_STRING },
    -- 性别
    sex         = { "number", I.UNSET_NUMBER },
    -- 拥有者
    owner       = { "number", I.UNSET_NUMBER },
    -- 胜率
    winrate     = { "number", I.UNSET_NUMBER },
    -- 装备加成
    equipEffect = { "string", I.UNSET_STRING},
    -- 装备简述
    equiplst    = { "string", },
    -- 装备详情
    equipinfolst= { "table" }, 
    -- 总血量
    totalhp = { "number", 0 },
    -- 总攻击
    totalatk    = { "number", },
    -- 装备技能
    EquipSk    = { "string", },
}










-- [覆盖方法]
-- -- 设置头像
-- function M:setHead(imageNo)
--     print("ImageNo: " .. imageNo)
--     self.head_ = string.gsub(TPL_CARD_ICON, "{0}", imageNo)
-- end










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 名字
function M:getName()
    return self.name_
end
function M:setName(newKey)
    self.name_ = newKey
end

-- 头像
function M:getHead()
    return self.head_
end
function M:setHead(newKey)
    self.head_ = newKey
end

-- 等级
function M:getLv()
    return self.lv_
end
function M:setLv(newKey)
    self.lv_ = newKey
end

-- 血量
function M:getHp()
    return self.hp_
end
function M:setHp(newKey)
    self.hp_ = newKey
end

-- 经验值
function M:getExp()
    return self.exp_
end
function M:setExp(newKey)
    self.exp_ = newKey
end

-- 排名
function M:getRank()
    return self.rank_
end
function M:setRank(newKey)
    self.rank_ = newKey
end

-- 最后登录时间
function M:getLastdate()
    return self.lastdate_
end
function M:setLastdate(newKey)
    self.lastdate_ = newKey
end

-- 性别
function M:getSex()
    return self.sex_
end
function M:setSex(newKey)
    self.sex_ = newKey
end

-- 拥有者
function M:getOwner()
    return self.owner_
end
function M:setOwner(newKey)
    self.owner_ = newKey
end

-- 胜率
function M:getWinrate()
    return self.winrate_
end
function M:setWinrate(newKey)
    self.winrate_ = newKey
end

-- 装备加成
function M:getEquipEffect( ) 
    return self.equipEffect_ 
end 
function M:setEquipEffect(equipEffect) 
    self.equipEffect_ = equipEffect 
end

-- 装备简述
function M:getEquiplst()
    return self.equiplst_
end
function M:setEquiplst( equiplst )
    self.equiplst_ = equiplst
end

-- 装备详情
function M:getEquipinfolst()
    return self.equipinfolst_
end
function M:setEquipinfolst( equipinfolst )
    self.equipinfolst_ = equipinfolst
end

-- 总攻击
function M:getTotalatk()
    return self.totalatk_
end
function M:setTotalatk(newKey)
    self.totalatk_ = newKey
end

-- 总血量
function M:getTotalhp()
    return self.totalhp_
end
function M:setTotalhp(totalhp)
    self.totalhp_ = totalhp
end
-- 装备技能
function M:getEquipSk()
    return self.EquipSk_
end
function M:setEquipSk(EquipSk)
    self.EquipSk_ = EquipSk
end
-- 装备技能
function M:getEquipSkill()
    local skillsTable = {}
    local skills = string.split(self.EquipSk_, "|")
    local params
    local entity
    local lv, skillid
    for i, v in ipairs(skills) do
        params = string.split(v, ":")
        skillid = params[1]
        lv = params[2]
        if skillid and lv then
            entity = EquipSkillDB.getSkillEntity( skillid, lv )
            if entity then
                skillsTable[#skillsTable + 1] = entity
            end
        end
    end
    return skillsTable
end             
function M:createPlayerView( params )
    local equiplst = self:getEquipinfolst()
    if table.isnotempty(equiplst) then
        equiplst = table.pickupkv(self:getEquipinfolst(), "part", "no")
    else
        equiplst = self:getEquiplst()
    end
    return Player.new(self:getSex(), self:getHead(), equiplst, params)
end

function M:createPlayerHeadRectView(clickListener, params)
    -- self.equiplst_ = self.equiplst_ or ""
    -- self.equiplst_ = self.equiplst_ .. "1:20044,"
    local equiplst = self:getEquipinfolst()
    if table.isnotempty(equiplst) then
        equiplst = table.pickupkv(self:getEquipinfolst(), "part", "no")
    else
        equiplst = self:getEquiplst()
    end
    return PlayerHead.new(self:getSex(), self:getHead(), equiplst, params):createRect(clickListener)
end

return M