--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗信息接收的网络实体类，定义战斗信息接收的网络实体Entity相关操作方法及逻辑实现。

-   存储PVP, PVAE对战相关信息。(包括用户信息，卡组信息等)


]]

local M = class("EntityRecFight", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                   -- 类型：无。           ID
    "info", 				-- 类型：EntityFighters。	基本信息（英雄、卡牌），战斗一开始取一次，后面都为空，
    "fight", 				-- 类型：EntityFightRound。	战斗信息(回合数组) 
    "result", 				-- 类型：EntityFightResult。	战斗结果信息
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id          = { "number", I.UNSET_NUMBER },
    -- 基本信息（英雄、卡牌）
    info   		= { PH_EN_FIGHT .. "EntityFighters", I.UNSET_TABLE },
    -- 战斗信息(回合数组) 
    fight  		= { "table", I.UNSET_TABLE, PH_EN_FIGHT .. "EntityFightRound" },
    -- 战斗结果信息
    result 		= { PH_EN_FIGHT .. "EntityFightResult", I.UNSET_CLASS },
}










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 基本信息（英雄、卡牌）
function M:getInfo()
    return self.info_
end
function M:setInfo(newKey)
    self.info_ = newKey
end

-- 战斗信息(回合数组)
function M:getFight()
    return self.fight_
end
function M:setFight(newKey)
    self.fight_ = newKey
end

-- 战斗结果信息
function M:getResult()
    return self.result_
end
function M:setResult(newKey)
    self.result_ = newKey
end





return M