--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

用户信息实体类，定义玩家基础信息实体Entity相关操作方法及逻辑实现。

-   存储用户信息相关信息。
-   存储英雄信息
-   存储卡组信息

]]

local M = class("EntityUser", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                	-- 类型：无。           ID
    "hero", 				-- 类型：EntityHero。   玩家信息。
    "cards", 			    -- 类型：EntityCard。	  卡牌信息集合。
    "talent",               -- 类型：无。           天赋字符串
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id          = { "number", I.UNSET_NUMBER },
    -- 玩家信息
    hero   	    = { PH_EN_FIGHT .. "EntityHero", {}  },
    -- 卡牌信息集合
    cards  	    = { "table", {}, PH_EN_FIGHT .. "EntityCard" },
    -- 天赋等级
    --  1:全阵营加生命
    --  2:全阵营加生命
    --  3:联盟加攻
    --  4:联盟生命
    --  5:部落加攻
    --  6:部落生命
    --  7:亡灵加攻
    --  8:亡灵生命
    --  9:英雄生命
    talent      = { "string", I.UNSET_STRING }
}










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 玩家信息
function M:getHero()
    return self.hero_
end
function M:setHero(newKey)
    self.hero_ = newKey
end

-- 卡牌信息集合
function M:getCards()
    return self.cards_
end
function M:setCards(newKey)
    self.cards_ = newKey
end

-- 天赋等级
function M:getTalent()
    return self.talent_
end
function M:setTalent(newKey)
    self.talent_ = newKey
end




return M