--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

关卡信息实体类，定义关卡基础信息实体Entity相关操作方法及逻辑实现。

-   存储关卡基础信息相关信息。


]]

local M = class("EntityLevel", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "id",                   	-- 类型：无。            ID。
    "sn",                       -- 类型：无。            关卡序号[主]。
    "subsn",                    -- 类型：无。            关卡序号[子]。
    "star",                     -- 类型：无。            关卡星级（通关难度）。
    -- "hero",                     -- 类型：EntityHero.    占领关卡英雄。
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- ID
    id       		= { "number", I.UNSET_NUMBER },
    -- 关卡序号[主]
    sn      		= { "number", I.UNSET_NUMBER },
    -- 关卡序号[子]
    subsn           = { "number", I.UNSET_NUMBER },
    -- 关卡星级（通关难度）
    star            = { "number", I.UNSET_NUMBER },
    -- 占领关卡英雄
    -- hero            = { PH_EN_FIGHT .. "EntityHero", {} },
    -- 关卡名称
    name            = { "string", I.UNSET_STRING },
    -- 关卡说明
    memo            = { "string", I.UNSET_STRING },
    -- 关卡奖励
    rewards         = { "number", I.UNSET_NUMBER },
}










-- [Gettor/Settor方法]
-- ID
function M:getId()
    return self.id_
end
function M:setId(newKey)
    self.id_ = newKey
end

-- 关卡序号[主]
function M:getSn()
    return self.sn_
end
function M:setSn(newKey)
    self.sn_ = newKey
end

-- 关卡序号[子]
function M:getSubsn()
    return self.subsn_
end
function M:setSubsn(newKey)
    self.subsn_ = newKey
end

-- 关卡星级（通关难度）
function M:getStar()
    return self.star_
end
function M:setStar(newKey)
    self.star_ = newKey
end

-- 关卡名称
function M:getName()
    return self.name_
end
function M:setName(newKey)
    self.name_ = newKey
end

-- 关卡说明
function M:getMemo()
    return self.memo_
end
function M:setMemo(newKey)
    self.memo_ = newKey
end

-- 关卡奖励
function M:getRewards()
    return self.rewards_
end
function M:setRewards(newKey)
    self.rewards_ = newKey
end





return M