--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

地图信息实体类，定义地图基础信息实体Entity相关操作方法及逻辑实现。

-   存储地图基础信息相关信息。


]]

local M = class("EntityMap", BaseEntity)



-- [包含文件]
-- 模型常量
local I = require(PH_EN_I .. NAM_CONSTANT)










-- [构造方法]
-- 构造方法，定义实体初始化赋值操作。
function M:ctor(properties)
    self:setProperties(properties)
end










-- [辅助方法]
-- 属性定义，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.fields = {
    "levels",                  -- 类型：EntityLevel。   子关卡集。
    "stars",				   -- 类型：number。 可收集星星数
    "collecttime",             -- 类型：number。 收集星星倒计时
    "expRate",                 -- 类型：number。 经验系数
	"expTime",		           -- 类型：number。 经验倒计时
    "shopTyp",                 -- 类型：number。 商店类型倒计时
    "shopTime",                -- 类型：number。 商店倒计时
}

-- 属性细则，标识实体属性具体的类型、默认值、子元素类型、验证操作等属性相关规则
M.schema = {
    -- 关卡集
    levels         	= { "table", I.UNSET_TABLE, PH_EN_MAP .. "EntityLevel" },
    stars         	= { "number", 0},
    collecttime     = { "number", 0},
    expRate         = { "number", 1},
    expTime         = { "number", 0},
    shopTyp         = { "number", 0},
    shopTime        = { "number", 0},
}










-- [Gettor/Settor方法]
-- 关卡集
function M:getLevels()
    return self.levels_
end
function M:setLevels(newKey)
    self.levels_ = newKey
end

function M:getStars()
    return self.stars_
end
function M:setStars(newKey)
    self.stars_ = newKey
end

function M:getCollecttime()
    return self.collecttime_
end
function M:setCollecttime(newKey)
    self.collecttime_ = newKey
end

function M:getExpRate()
    return self.expRate_
end
function M:setExpRate(newKey)
    self.expRate_ = newKey
end

function M:getExpTime()
    return self.expTime_
end
function M:setExpTime(newKey)
    self.expTime_ = newKey
end

function M:getShopTyp()
    return self.shopTyp_
end
function M:setShopTyp(newKey)
    self.shopTyp_ = newKey
end

function M:getShopTime()
    return self.shopTime_
end
function M:setShopTime(newKey)
    self.shopTime_ = newKey
end

return M