--Create Class GoodsEntity
local GoodsEntity = class( "GoodsEntity", BaseEntity )

function GoodsEntity:ctor( properties )
	self:setProperties( properties )
end

GoodsEntity.schema = {
	-- 编号
	no 				= { "number", 0},
	-- 类型
	typ 			= { "number", 0},
	-- 数量
	count 		 	= { "number", 1},
	-- 售价
	price      		= { "number", 0},
	-- 品质
	quality      	= { "number", 0},
	-- 使用类型
	usetype      	= { "number", 0},
	-- 是否可以出售
	cansell      	= { "number", 0},
	-- 扩展属性
	ext      		= { "string", ""},
	-- 名称
	name 			= { "string", ""},
	-- 说明
	memo 			= { "string", ""},
	-- 2级类型
	styp 			= { "number", 0},
	-- 性别
	sex 			= { "number", 0},
	-- 需求人物等级
	needlv 			= { "number", 0},
	-- 强化等级 （装备才有）
	strlv 			= { "number", 0},
	-- 阶数 (装备才有)
	evolv 			= { "number", 0},
	-- 部位（装备才有）
	part 			= { "number", 0},
	-- 属性数组（装备才有）
	pros 			= { "table", {}},
	-- 技能数组（装备才有）
	skills 			= { "table", {}},
	-- 追加等级（装备才有）
	add 			= { "number", 0},
	-- 套装id （装备才有）
	setid 			= { "number", 0},
	-- 装备关系id（装备才有）
	eqid 			= { "number", 0},
	-- 传递的图片
	pic 			= { "string", ""},
	-- 是否穿在身上（装备才有）
	isOn 			= { "number", 0},
	-- 对应套装id数组
	setids 			= { "table", {}},
}

GoodsEntity.fields = {

	"no" ,			-- 编号
	"typ" ,			-- 类型
	"styp", 		-- 2级类型
	"count",		-- 数量
	"price",		-- 售价
	"quality",		-- 品质
	"usetype",		-- 使用类型
	"cansell",		-- 是否可以出售
	"ext",			-- 扩展属性
	"name", 		-- 名称
	"memo", 		-- 说明
	"sex", 			-- 性别
	"needlv", 		-- 需求人物等级
	"strlv", 		-- 强化等级 （装备才有）
	"evolv", 		-- 阶数 (装备才有)
	"part", 		-- 部位（装备才有）
	"pros", 		-- 属性数组（装备才有）
	"skills", 		-- 技能数组（装备才有）
	"add", 			-- 追加等级（装备才有）
	"setid", 		-- 套装id （装备才有）
	"eqid", 		-- 装备关系id（装备才有）
	"pic", 			-- 传递的图片
	"isOn", 		-- 是否穿在身上（装备才有）
	"setids", 		-- 对应套装id数组
}

local function getGoodsDB( no )
	if no > 20000 then
		return EquipDB.getByID(no)
	else
		return BackpackDB.getByID(no)
	end
end
-- [Gettor/Settor方法]
-- 编号
function GoodsEntity:getNo()
	return self.no_
end
function GoodsEntity:setNo(newKey)
	self.no_ = newKey
end

-- 类型
function GoodsEntity:getTyp()
	if self.typ_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.typ and goodsDB.typ > 0 then
				return goodsDB.typ
			end
		end
	end
	return self.typ_
end
function GoodsEntity:setTyp(newKey)
	self.typ_ = newKey
end
function GoodsEntity:getTypString()
	local result = nil
	if self.typ_ then
		for k,v in pairs(_GAME.CONFIG.GOODS.TYPE) do
			if v.KEY == self.typ_ then
				result = v.TEXT
				break
			end
		end
	end
	return result
end
-- 数量
function GoodsEntity:getCount()
	return self.count_
end
function GoodsEntity:setCount(newKey)
	self.count_ = newKey
end

-- 售价
function GoodsEntity:getPrice()
	if self.price_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.price and goodsDB.price > 0 then
				return goodsDB.price
			end
		end
	end
	return self.price_
end
function GoodsEntity:setPrice(newKey)
	self.price_ = newKey
end

-- 品质
function GoodsEntity:getQuality()
	if self.quality_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.quality and goodsDB.quality > 0 then
				return goodsDB.quality
			end
		end
	end
	return self.quality_
end
function GoodsEntity:setQuality(newKey)
	self.quality_ = newKey
end

-- 使用类型
function GoodsEntity:getUsetype()
	if self.usetype_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.usetype and goodsDB.usetype ~= 0 then
				return goodsDB.usetype
			end
		end
	end
	return self.usetype_
end
function GoodsEntity:setUsetype(newKey)
	self.usetype_ = newKey
end

-- 是否可以出售
function GoodsEntity:getCansell()
	if self.cansell_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.cansell and goodsDB.cansell ~= 0 then
				return goodsDB.cansell
			end
		end
	end
	return self.cansell_
end
function GoodsEntity:setCansell(newKey)
	self.cansell_ = newKey
end

-- 扩展属性
function GoodsEntity:getExt()
	if self.ext_ == "" then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.ext and goodsDB.ext ~= "" then
				return goodsDB.ext
			end
		end
	end
	return self.ext_
end
function GoodsEntity:setExt(newKey)
	self.ext_ = newKey
end

-- 名称
function GoodsEntity:getName()
	if self.name_ ~= "" then
		return self.name_
	else
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			return goodsDB.name
		end
	end
end
function GoodsEntity:setName( newKey )
	self.name_ = newKey
end

-- 详细信息
function GoodsEntity:getDetails()
	if self.memo_ ~= "" then
		return self.memo_
	else
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.memo then
				return string.format(goodsDB.memo, self:getExt())
			end
			
		end
	end
end

function GoodsEntity:getMemo()
	return self:getDetails()
end
function GoodsEntity:setMemo( newKey )
	self.memo_ = newKey
end

-- 物品图片
function GoodsEntity:getGoodsIcon()
	if self.no_ > 20000 then
		-- 装备
		return string.format(_GAME.CONFIG.GOODS.EQUIPICON, self.no_)
	else
		-- 物品
		if self.pic_ == "" then
			if self.name_ ~= "" then
				-- 有自定义的物品名称, 是新物品, 默认图标上
				return string.format(_GAME.CONFIG.GOODS.GOODSICON, 0)
			else
				-- 数据库
				local goodsDB = getGoodsDB( self.no_ )
				if goodsDB then
					if goodsDB.pic and goodsDB.pic ~= "" then
						return string.format(_GAME.CONFIG.GOODS.PATH, goodsDB.pic)
					else
						return string.format(_GAME.CONFIG.GOODS.GOODSICON, self.no_)
					end
				end
			end
		else
			-- 服务端传了图片id
			return string.format(_GAME.CONFIG.GOODS.PATH, self.pic_)
		end
	end
	
	-- 装备
end
		
-- 2级类型
function GoodsEntity:getStyp()
	return self.styp_
end
function GoodsEntity:setStyp(newKey)
	self.styp_ = newKey
end
function GoodsEntity:getPartString( )
	local result = ""
	if self.part_ == "" or self.part_ == 0 then
		local goodsDB = getGoodsDB( self.no_ )
		if goodsDB then
			if goodsDB.part then
				self.part_ = goodsDB.part
			end
		end

	end
	for k, v in pairs(_GAME.CONFIG.GOODS.SYPE) do
		if self.part_ == v.KEY then

			result = v.TEXT
			break
		end
	end
	return result
end
-- 性别
function GoodsEntity:getSex()
	return self.sex_
end
function GoodsEntity:setSex(newKey)
	self.sex_ = newKey
end

-- 需求人物等级
function GoodsEntity:getNeedlv()
	return self.needlv_
end
function GoodsEntity:setNeedlv(newKey)
	self.needlv_ = newKey
end

-- 强化等级 （装备才有）
function GoodsEntity:getStrlv()
	return self.strlv_
end
function GoodsEntity:setStrlv(newKey)
	self.strlv_ = newKey
end

-- 阶数 (装备才有)
function GoodsEntity:getEvolv()
	return self.evolv_
end
function GoodsEntity:setEvolv(newKey)
	self.evolv_ = newKey
end

-- 部位（装备才有）
function GoodsEntity:getPart()
	return self.part_
end
function GoodsEntity:setPart(newKey)
	self.part_ = newKey
end

-- 属性数组（装备才有）
function GoodsEntity:getPros()

	return self.pros_
end
function GoodsEntity:setPros(newKey)
	self.pros_ = newKey
end

-- 技能数组（装备才有）
function GoodsEntity:getSkills()
	return self.skills_
end
function GoodsEntity:setSkills(newKey)
	self.skills_ = newKey
end

-- 追加等级（装备才有）
function GoodsEntity:getAdd()
	return self.add_
end
function GoodsEntity:setAdd(newKey)
	self.add_ = newKey
end

-- 套装id （装备才有）
function GoodsEntity:getSetid()
	return self.setid_
end
function GoodsEntity:setSetid(newKey)
	self.setid_ = newKey
end

-- 装备关系id（装备才有）
function GoodsEntity:getEqid()
	return self.eqid_
end
function GoodsEntity:setEqid(newKey)
	self.eqid_ = newKey
end

-- 传递的图片
function GoodsEntity:getPic()
	return self.pic_
end
function GoodsEntity:setPic(newKey)
	self.pic_ = newKey
end

-- 是否穿在身上（装备才有）
function GoodsEntity:getIsOn()
	return self.isOn_
end
function GoodsEntity:setIsOn(newKey)
	self.isOn_ = newKey
end

-- 对应套装id数组
function GoodsEntity:getSetids()
	return self.setids_
end
function GoodsEntity:setSetids(newKey)
	self.setids_ = newKey
end

--装备升级系数
function GoodsEntity:getProAddrate()
	local goodsDB = getGoodsDB( self.no_ )
	if goodsDB then
		if goodsDB.proAddrate then
			return goodsDB.proAddrate
		end
	end
end

--装备升级系数
function GoodsEntity:getAddInit()
	local goodsDB = getGoodsDB( self.no_ )
	if goodsDB then
		if goodsDB.addInit then
			return goodsDB.addInit
		end
	end
end

--装备最大追加值
function GoodsEntity:getAddMax()
	local goodsDB = getGoodsDB( self.no_ )
	if goodsDB then
		if goodsDB.addMax then
			return goodsDB.addMax
		end
	end
end

return GoodsEntity