
local GoodsModel = {}
GoodsModel.TAG = "[GoodsModel]"
BackpackEntity = require("model.goods.BackpackEntity")


-- 获取背包
function GoodsModel.fetchPackage( params )
    local function responseItems( properties )
      if properties then
        local backage = BackpackEntity.new(properties)
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(backage, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_PACKAGE,
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      {failedCb = params.data.failed,}
    )
end

-- 出售物品
function GoodsModel.fetchSellGoods( params )
    local function responseItems( properties )
      if properties then
        local backage = BackpackEntity.new(properties)
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(backage, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_SELL,
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      {failedCb = params.data.failed,}
    )
end

-- 使用物品
function GoodsModel.fetchUseGoods( params )
    local function responseItems( properties )
      if properties then
        local backage = BackpackEntity.new(properties)
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(backage, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_USE,
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      {failedCb = params.data.failed,}
    )
end
-- 更改名字
function GoodsModel.fetchUpdateNickName( params )
    local function responseItems( properties )
        -- 配置数值分类
        -- if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
        -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_UPDATE_NICKNAME,
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      {failedCb = params.data.failed,}
    )
end
return GoodsModel