
local MailModel = {}
MailModel.TAG = "[MailModel]"

-- 获取邮件列表
function MailModel.fetchMailList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_MAILIST,        --  请求id
      responseItems,                --  回调函数
      params.data,                   --  请求信息实体或参数table
      params.data 
    )
end



-- 提取邮件中的奖励
function MailModel.fetchMailReward( params)
 
  local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_MAILREWARD,        --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end

-- 删除邮件
function MailModel.fetchDeleteMail( params)

  local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_DELETE_MAIL,        --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end

-- 发送聊天消息
function MailModel.fetchSendMail( params)
 
  local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_SEND_MAIL,        --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end

-- 读取邮件
function MailModel.fetchReadMail( params)
 
  local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_READ_MAIL,        --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end

return MailModel