--Create Class GameRateEntity
local GameRateEntity = class( "GameRateEntity", BaseEntity )

function GameRateEntity:ctor( properties )
	self:setProperties( properties )
end

GameRateEntity.schema = {
	-- 登陆奖励
	loginrewards				= { "table", {}},
	-- 除夕开始时间
	ctime 						= { "number", },
	-- 除夕奖励状态 0 不可领 1 可以领 2 已领
	csta 						= { "number", 2},
	-- 卡牌强化经验系数 1001	
	enhancedExpRate 			= { "number", },
	-- 卡牌强化价格系数 1002	
	enhancedGlodRate 			= { "number", },
	-- 卡牌销售星级系数 1007	
	sellStartLevelRate 			= { "number", },
	-- 卡牌销售经验系数 1008	
	sellExpRate      			= { "number", },
	-- 关卡难度2描述 3001	
	infoDifficulty2      		= { "string", },
	-- 关卡难度3描述 3002	
	infoDifficulty3      		= { "string", },
	-- 体力比率 3003 （xx / rate）
	spRate      				= { "number", },
	-- 钻石体力 1999  ［例：100|50|2］
	spDiamond      				= { "string", },
	-- 跳过钻石 1998
	jumpDiamond 				= { "number", },
	-- 天赋需求卡牌经验降低值 4001
	talentExpRate 				= { "number", },
	-- 天赋需求钻石系数值 4002	
	talentDiamondRate 			= { "number", },
	-- 天赋需求星星系数值 4003	
	talentStarRate 				= { "number", },
	-- 天赋需求星星系数值 4004	
	talentGoldRate 				= { "number", },
	-- 进化提升系数 6001	
	evoRate 		 			= { "number", },
	-- 进化所需材料 6002	
	evoFourStarMaterial			= { "string", },
	-- 进化5星花费金币 6003	
	evoFiveStarGold 			= { "string", },
	-- 卡牌一阶成长率提升值	6011
	evoRate_1 					= { "number", 1},
	-- 卡牌二阶成长率提升值	6006
	evoRate_2 					= { "number", 1},
	-- 卡牌三阶成长率提升值	6007
	evoRate_3 					= { "number", 1},
	-- 卡牌四阶成长率提升值	6008
	evoRate_4 					= { "number", 1},
	-- 卡牌五阶成长率提升值	6009
	evoRate_5 					= { "number", 1},
	-- 卡牌六阶成长率提升值	6010
	evoRate_6 					= { "number", 1},
	-- 周赛解锁 8003	
	arenaWeekUnlock 			= { "number", },
	-- 装备强化金币系数 8004	
	equipGoldRate 				= { "number", },
	-- 装备强化宝石系数 8005	
	equipGemRate 	 			= { "number", },
	-- 追加高级石头限制等级 8006	
	equipAddLevelLimit			= { "number", },
	-- 追加金币系数 8007	
	equipAddGoldRate			= { "number", },
	-- 进阶使用钻石增加概率值 8008
	equipEvoGemRate 			= { "number", },
	-- 进阶金币系数 8009	
	equipEvoGoldRate			= { "number", },
	-- 聊天卡牌标识位 10001	
	chatCardFlag 				= { "string", },
	-- 聊天装备标识位 10002	
	chatEquipFlag  				= { "string", },
	-- 聊天玩家标识位 10003	
	chatPlayerFlag  			= { "string", },
	-- 聊天物品家标识位 10004	
	chatGoodsFlag  				= { "string", },
	-- 聊天战队标识位 10005	
	chatTeamFlag  				= { "string", },
	-- boss金币鼓舞 11001	
	bossInspirationGold  		= { "number", },
	-- boss钻石鼓舞 11002	
	bossInspirationDiamond  	= { "number", },
	-- boss金币鼓舞成功率 11003
	bossInspirationGoldRate  	= { "number", },
	-- boss钻石鼓舞成功率 11004
	bossInspirationDiamondRate  = { "number", },
	-- boss奖励星星上限 11005
	bossRewardStarLimit  		= { "number", },
	-- 自己鼓舞atk提升上限 11006
	inspirationAtkLimit  		= { "number", },
	-- 自己鼓舞hp提升上限 11008
	inspirationHpLimit  		= { "number", },
	-- 战队人数上限	12001
	teamMemberLimit 	  		= { "number", },
	-- 战队参战卡牌数量	12002
	teamCardLimit		  		= { "number", },
	-- 加入战队等级限制	12003
	teamJoinLvLimit		  		= { "number", },
	-- 立即完成扫荡钻石数 13001
	finishSweepDiamond	  		= { "number", },
	-- 是否展示大转轮 13002
	showBigWheel	  			= { "number", 0},
	--是否分享 14001
	isShare	  					= { "number", 0},
	--英文版跳转到购买钻石界面的启用 14002
	isBuyDiamond				= { "number", 0},
	--军团天赋金币系数 5003
	armyTalentGold				= { "number", 0},
	--军团天赋需求卡片经验降低值 5002
	armyTalentCardEXP			= { "number", 0},
	--军团开放等级 14000
	armyOpenLvLimit				= { "number", 0},

}

GameRateEntity.fields = {
	"loginrewards", 				-- 登陆奖励
	"ctime", 						-- 除夕开始时间	
	"csta",							-- 除夕奖励状态 0 不可领 1 可以领 2 已领
	"enhancedExpRate" ,				-- 卡牌强化经验系数
	"enhancedGlodRate" ,			-- 卡牌强化价格系数				
	"sellStartLevelRate",			-- 卡牌销售星级系数
	"sellExpRate",					-- 卡牌销售经验系数
	"infoDifficulty2",				-- 关卡难度2描述 
	"infoDifficulty3",				-- 关卡难度3描述 
	"spRate",						-- 体力比率
	"spDiamond",					-- 钻石体力
	"jumpDiamond",					-- 跳过钻石
	"talentExpRate",				-- 天赋需求卡牌经验降低值
	"talentDiamondRate",			-- 天赋需求钻石系数值
	"talentStarRate",				-- 天赋需求星星系数值
	"talentGoldRate",				-- 天赋需求星星系数值
	"evoRate",						-- 进化提升系数 6001
	"evoFourStarMaterial",			-- 进化4星花费金币 6002
	"evoFiveStarGold",				-- 进化5星花费金币 6003
	"evoRate_1",					-- 卡牌一阶成长率提升值	6011	
	"evoRate_2",					-- 卡牌二阶成长率提升值	6006
	"evoRate_3",					-- 卡牌三阶成长率提升值	6007
	"evoRate_4",					-- 卡牌四阶成长率提升值	6008
	"evoRate_5",					-- 卡牌五阶成长率提升值	6009
	"evoRate_6",					-- 卡牌六阶成长率提升值	6010
	"arenaWeekUnlock", 				-- 周赛解锁 8003
	"equipGemRate", 				-- 装备强化宝石系数 8004
	"equipGoldRate", 				-- 装备强化金币系数 8005
	"equipAddLevelLimit",			-- 追加高级石头限制等级 8006
	"equipAddGoldRate", 			-- 追加金币系数 8007
	"equipEvoGemRate", 				-- 进阶使用钻石增加概率值 8008
	"equipEvoGoldRate", 			-- 进阶金币系数 8009
	"chatCardFlag", 				-- 聊天卡牌标识位 10001
	"chatEquipFlag", 				-- 聊天装备标识位 10002
	"chatPlayerFlag", 				-- 聊天玩家标识位 10003
	"chatGoodsFlag", 				-- 聊天物品家标识位 10004 
	"chatTeamFlag",  				-- 聊天战队标识位 10005
	"bossInspirationGold",  		-- boss金币鼓舞 11001
	"bossInspirationDiamond",		-- boss钻石鼓舞 11002
  	"bossInspirationGoldRate",  	-- boss金币鼓舞成功率 11003
	"bossInspirationDiamondRate",	-- boss钻石鼓舞成功率 11004	
	"bossRewardStarLimit",			-- boss奖励星星上限 11005	
	"inspirationAtkLimit",			-- 自己鼓舞atk提升上限 11006	
	"inspirationHpLimit",			-- 自己鼓舞hp提升上限 11008	
	"teamMemberLimit", 				-- 战队人数上限	12001
	"teamCardLimit",				-- 战队参战卡牌数量	12002
	"teamJoinLvLimit",				-- 加入战队等级限制	12003
	"finishSweepDiamond",			-- 立即完成扫荡钻石数 13001  
	"showBigWheel",		  			-- 是否展示大转轮 13002
	"isShare",						-- 是否分享 14001
	"isBuyDiamond",					--英文版跳转到购买钻石界面的启用 14002
	"armyTalentGold",				--军团天赋金币系数 5003
	"armyTalentCardEXP",			--军团天赋需求卡片经验降低值 5002
	"armyOpenLvLimit",				--军团开放等级 14000
}










-- [Gettor/Settor方法]
-- 登陆奖励
function GameRateEntity:getLoginrewards()
	return self.loginrewards_
end
function GameRateEntity:setLoginrewards(newKey)
	self.loginrewards_ = newKey
end
-- 除夕开始时间
function GameRateEntity:getCtime()
	return self.ctime_
end
function GameRateEntity:setCtime(newKey)
	self.ctime_ = newKey
end
-- 除夕奖励状态 0 不可领 1 可以领 2 已领
function GameRateEntity:getCsta()
	return self.csta_
end
function GameRateEntity:setCsta(newKey)
	self.csta_ = newKey
end				
-- 卡牌强化经验系数 1001
function GameRateEntity:getEnhancedExpRate()
	return self.enhancedExpRate_
end
function GameRateEntity:setEnhancedExpRate(newKey)
	self.enhancedExpRate_ = newKey
end

-- 卡牌强化价格系数 1002
function GameRateEntity:getEnhancedGlodRate()
	return self.enhancedGlodRate_
end
function GameRateEntity:setEnhancedGlodRate(newKey)
	self.enhancedGlodRate_ = newKey
end

-- 卡牌销售星级系数 1007
function GameRateEntity:getSellStartLevelRate()
	return self.sellStartLevelRate_
end
function GameRateEntity:setSellStartLevelRate(newKey)
	self.sellStartLevelRate_ = newKey
end

-- 卡牌销售经验系数 1008
function GameRateEntity:getSellExpRate()
	return self.sellExpRate_
end
function GameRateEntity:setSellExpRate(newKey)
	self.sellExpRate_ = newKey
end

-- 关卡难度2描述 3001
function GameRateEntity:getInfoDifficulty2()
	return self.infoDifficulty2_
end
function GameRateEntity:setInfoDifficulty2(newKey)
	self.infoDifficulty2_ = newKey
end

-- 关卡难度3描述 3002
function GameRateEntity:getInfoDifficulty3()
	return self.infoDifficulty3_
end
function GameRateEntity:setInfoDifficulty3(newKey)
	self.infoDifficulty3_ = newKey
end

-- 体力比率 3003 （xx / rate）
function GameRateEntity:getSpRate()
	return self.spRate_
end
function GameRateEntity:setSpRate(newKey)
	self.spRate_ = newKey
end

-- 钻石体力 1999  ［例：100|50|2］
function GameRateEntity:getSpDiamond()
	return self.spDiamond_
end
function GameRateEntity:setSpDiamond(newKey)
	self.spDiamond_ = newKey
end

-- 跳过钻石 1998
function GameRateEntity:getJumpDiamond()
	return self.jumpDiamond_
end
function GameRateEntity:setJumpDiamond(newKey)
	self.jumpDiamond_ = newKey
end

-- 天赋需求卡牌经验降低值 4001
function GameRateEntity:getTalentExpRate()
	return self.talentExpRate_
end
function GameRateEntity:setTalentExpRate(newKey)
	self.talentExpRate_ = newKey
end

-- 天赋需求钻石系数值 4002
function GameRateEntity:getTalentDiamondRate()
	return self.talentDiamondRate_
end
function GameRateEntity:setTalentDiamondRate(newKey)
	self.talentDiamondRate_ = newKey
end

-- 天赋需求星星系数值 4003
function GameRateEntity:getTalentStarRate()
	return self.talentStarRate_
end
function GameRateEntity:setTalentStarRate(newKey)
	self.talentStarRate_ = newKey
end

-- 天赋需求星星系数值 4004
function GameRateEntity:getTalentGoldRate()
	return self.talentGoldRate_
end
function GameRateEntity:setTalentGoldRate(newKey)
	self.talentGoldRate_ = newKey
end

-- 进化提升系数 6001
function GameRateEntity:getEvoRate()
	return self.evoRate_
end
function GameRateEntity:setEvoRate(newKey)
	self.evoRate_ = newKey
end

-- 进化4星花费金币 6002
function GameRateEntity:getEvoFourStarMaterial()
	return self.evoFourStarMaterial_
end
function GameRateEntity:setEvoFourStarMaterial(newKey)
	self.evoFourStarMaterial_ = newKey
end

-- 进化5星花费金币 6003
function GameRateEntity:getEvoFiveStarGold()
	return self.evoFiveStarGold_
end
function GameRateEntity:setEvoFiveStarGold(newKey)
	self.evoFiveStarGold_ = newKey
end
-- 卡牌一阶成长率提升值	6011
function GameRateEntity:getEvoRate_1()
	return self.evoRate_1_
end
function GameRateEntity:setEvoRate_1(newKey)
	self.evoRate_1_ = newKey
end
-- -- 卡牌二阶成长率提升值	6006
function GameRateEntity:getEvoRate_2()
	return self.evoRate_2_
end
function GameRateEntity:setEvoRate_2(newKey)
	self.evoRate_2_ = newKey
end
-- -- 卡牌三阶成长率提升值	6007
function GameRateEntity:getEvoRate_3()
	return self.evoRate_3_
end
function GameRateEntity:setEvoRate_3(newKey)
	self.evoRate_3_ = newKey
end
-- -- 卡牌四阶成长率提升值	6008
function GameRateEntity:getEvoRate_4()
	return self.evoRate_4_
end
function GameRateEntity:setEvoRate_4(newKey)
	self.evoRate_4_ = newKey
end
-- -- 卡牌五阶成长率提升值	6009
function GameRateEntity:getEvoRate_5()
	return self.evoRate_5_
end
function GameRateEntity:setEvoRate_5(newKey)
	self.evoRate_5_ = newKey
end
-- -- 卡牌六阶成长率提升值	6010
function GameRateEntity:getEvoRate_6()
	return self.evoRate_6_
end
function GameRateEntity:setEvoRate_6(newKey)
	self.evoRate_6_ = newKey
end				
-- 周赛解锁 8003
function GameRateEntity:getArenaWeekUnlock()
	return tonumber(self.arenaWeekUnlock_)
end
function GameRateEntity:setArenaWeekUnlock(newKey)
	self.arenaWeekUnlock_ = newKey
end
 	
-- 装备强化宝石系数 8004
function GameRateEntity:getEquipGemRate()
	return tonumber(self.equipGemRate_)
end
function GameRateEntity:setEquipGemRate(newKey)
	self.equipGemRate_ = newKey
end

-- 装备强化金币系数 8005
function GameRateEntity:getEquipGoldRate()
	return tonumber(self.equipGoldRate_)
end
function GameRateEntity:setEquipGoldRate(newKey)
	self.equipGoldRate_ = newKey
end
-- 追加高级石头限制等级 8006
function GameRateEntity:getEquipAddLevelLimit()
	return tonumber(self.equipAddLevelLimit_)
end
function GameRateEntity:setEquipAddLevelLimit(newKey)
	self.equipAddLevelLimit_ = newKey
end
-- 追加金币系数 8007
function GameRateEntity:getEquipAddGoldRate()
	return tonumber(self.equipAddGoldRate_)
end
function GameRateEntity:setEquipAddGoldRate(newKey)
	self.equipAddGoldRate_ = newKey
end
-- 进阶使用钻石增加概率值 8008
function GameRateEntity:getEquipEvoGemRate()
	return tonumber(self.equipEvoGemRate_)
end
function GameRateEntity:setEquipEvoGemRate(newKey)
	self.equipEvoGemRate_ = newKey
end
-- 进阶金币系数 8009
function GameRateEntity:getEquipEvoGoldRate()
	return tonumber(self.equipEvoGoldRate_)
end
function GameRateEntity:setEquipEvoGoldRate(newKey)
	self.equipEvoGoldRate_ = newKey
end

-- 聊天卡牌标识位 10001
function GameRateEntity:getChatCardFlag()
	return self.chatCardFlag_
end
function GameRateEntity:setChatCardFlag(newKey)
	self.chatCardFlag_ = newKey
end

-- 聊天装备标识位 10002
function GameRateEntity:getChatEquipFlag()
	return self.chatEquipFlag_
end
function GameRateEntity:setChatEquipFlag(newKey)
	self.chatEquipFlag_ = newKey
end 	

-- 聊天玩家标识位 10003
function GameRateEntity:getChatPlayerFlag()
	return self.chatPlayerFlag_
end
function GameRateEntity:setChatPlayerFlag(newKey)
	self.chatPlayerFlag_ = newKey
end 
-- 聊天物品家标识位 10004
function GameRateEntity:getChatGoodsFlag()
	return self.chatGoodsFlag_
end
function GameRateEntity:setChatGoodsFlag(newKey)
	self.chatGoodsFlag_ = newKey
end 
-- 聊天战队标识位 10005
function GameRateEntity:getChatTeamFlag()
	return self.chatTeamFlag_
end
function GameRateEntity:setChatTeamFlag(newKey)
	self.chatTeamFlag_ = newKey
end 
-- boss金币鼓舞 11001
function GameRateEntity:getBossInspirationGold()
	return tonumber(self.bossInspirationGold_)
end
function GameRateEntity:setBossInspirationGold(newKey)
	self.bossInspirationGold_ = newKey
end 
-- boss钻石鼓舞 11002
function GameRateEntity:getBossInspirationDiamond()
	return tonumber(self.bossInspirationDiamond_)
end
function GameRateEntity:setBossInspirationDiamond(newKey)
	self.bossInspirationDiamond_ = newKey
end 
-- boss金币鼓舞成功率 11003
function GameRateEntity:getBossInspirationGoldRate()
	return tonumber(self.bossInspirationGoldRate_)
end
function GameRateEntity:setBossInspirationGoldRate(newKey)
	self.bossInspirationGoldRate_ = newKey
end 
-- boss钻石鼓舞成功率 11004
function GameRateEntity:getBossInspirationDiamondRate()
	return tonumber(self.bossInspirationDiamondRate_)
end
function GameRateEntity:setBossInspirationDiamondRate(newKey)
	self.bossInspirationDiamondRate_ = newKey
end 
-- boss奖励星星上限 11005	
function GameRateEntity:getBossRewardStarLimit()
	return tonumber(self.bossRewardStarLimit_)
end
function GameRateEntity:setBossRewardStarLimit(newKey)
	self.bossRewardStarLimit_ = newKey
end 
-- 自己鼓舞atk提升上限 11006
function GameRateEntity:getInspirationAtkLimit()
	return tonumber(self.inspirationAtkLimit_)
end
function GameRateEntity:setInspirationAtkLimit(newKey)
	self.inspirationAtkLimit_ = newKey
end 
-- 自己鼓舞hp提升上限 11008	
function GameRateEntity:getInspirationHpLimit()
	return tonumber(self.inspirationHpLimit_)
end
function GameRateEntity:setInspirationHpLimit(newKey)
	self.inspirationHpLimit_ = newKey
end 
-- 战队人数上限 12001
function GameRateEntity:getTeamMemberLimit()
	return tonumber(self.teamMemberLimit_)
end
function GameRateEntity:setTeamMemberLimit(newKey)
	self.teamMemberLimit_ = newKey
end 
-- 战队参战卡牌数量 12002
function GameRateEntity:getTeamCardLimit()
	return tonumber(self.teamCardLimit_)
end
function GameRateEntity:setTeamCardLimit(newKey)
	self.teamCardLimit_ = newKey
end

-- 加入战队等级限制	12003
function GameRateEntity:getTeamJoinLvLimit()
	return tonumber(self.teamJoinLvLimit_)
end
function GameRateEntity:setTeamJoinLvLimit(newKey)
	self.teamJoinLvLimit_ = newKey
end
-- 立即完成扫荡钻石数 13001
function GameRateEntity:getFinishSweepDiamond()
	return tonumber(self.finishSweepDiamond_)
end
function GameRateEntity:setFinishSweepDiamond(newKey)
	self.finishSweepDiamond_ = newKey
end
-- 是否展示大转轮 13002
function GameRateEntity:getShowBigWheel()
	return tonumber(self.showBigWheel_)
end
function GameRateEntity:setShowBigWheel(newKey)
	self.showBigWheel_ = newKey
end
--是否分享 14001
function GameRateEntity:getIsShare( )
	return tonumber(self.isShare_)
end

function GameRateEntity:setIsShare( newKey )
	self.isShare_ = newKey
end

--英文版跳转到购买钻石界面的启用 14002
function GameRateEntity:isBuyDiamond( showToast )
	local flag = tonumber(self.isBuyDiamond_) == 1

	if not flag and showToast ~= false then
		NetHelper.QuickToast(_s("ACTIVITY_INVITE_SHARE_OPEN"))
	end
	return flag
end

function GameRateEntity:setIsBuyDiamond( newKey )
	self.isBuyDiamond_ = newKey
end

--军团天赋金币系数 5003
function GameRateEntity:getArmyTalentGold( )
	return tonumber(self.armyTalentGold_)
end

function GameRateEntity:setArmyTalentGold( newKey )
	self.armyTalentGold_ = newKey
end

--军团天赋需求卡片经验降低值 5002
function GameRateEntity:getArmyTalentCardEXP( )
	return tonumber(self.armyTalentCardEXP_)
end

function GameRateEntity:setArmyTalentCardEXP( newKey )
	self.armyTalentCardEXP_ = newKey
end

--军团开放等级 14000
function GameRateEntity:getArmyOpenLvLimit( )
	return tonumber(self.armyOpenLvLimit_)
end

function GameRateEntity:setArmyOpenLvLimit( newKey )
	self.armyOpenLvLimit_ = newKey
end
	  			
return GameRateEntity