
local MainModel = {}
MainModel.TAG = "[MainModel]"
GameRateEntity = require("model.main.GameRateEntity")

-- 获取游戏配置信息
function MainModel.fetchGetConfig( params )

    local function responseItems( properties )
    	if properties then
        local result = {}
        -- 配置数值分类
    		local gameRate = GameRateEntity.new{}
        for i , v in ipairs(properties.configs) do
            if v.cno == 1001 then
              gameRate:setEnhancedExpRate(v.cvalue)
            elseif v.cno == 1002 then
              gameRate:setEnhancedGlodRate(v.cvalue)
            elseif v.cno == 1007 then
              gameRate:setSellStartLevelRate(v.cvalue)
            elseif v.cno == 1008 then
              gameRate:setSellExpRate(v.cvalue)
            elseif v.cno == 3001 then
              gameRate:setInfoDifficulty2(v.cvalue)
            elseif v.cno == 3002 then
              gameRate:setInfoDifficulty3(v.cvalue)
            elseif v.cno == 3003 then
              gameRate:setSpRate(v.cvalue)
            elseif v.cno == 1999 then
              gameRate:setSpDiamond(v.cvalue)
            elseif v.cno == 1998 then
              gameRate:setJumpDiamond(v.cvalue)
            elseif v.cno == 4001 then
              gameRate:setTalentExpRate(v.cvalue)
            elseif v.cno == 4002 then
              gameRate:setTalentDiamondRate(v.cvalue)
            elseif v.cno == 4003 then
              gameRate:setTalentStarRate(v.cvalue)
            elseif v.cno == 4004 then
              gameRate:setTalentGoldRate(v.cvalue)
            elseif v.cno == 6001 then
              gameRate:setEvoRate(v.cvalue)
            elseif v.cno == 6002 then
              gameRate:setEvoFourStarMaterial(v.cvalue)
            elseif v.cno == 6003 then
              gameRate:setEvoFiveStarGold(v.cvalue)
            elseif v.cno == 6011 then
              gameRate:setEvoRate_1(v.cvalue)
            elseif v.cno == 6006 then
              gameRate:setEvoRate_2(v.cvalue)
            elseif v.cno == 6007 then
              gameRate:setEvoRate_3(v.cvalue)
            elseif v.cno == 6008 then
              gameRate:setEvoRate_4(v.cvalue)
            elseif v.cno == 6009 then
              gameRate:setEvoRate_5(v.cvalue)
            elseif v.cno == 6010 then
              gameRate:setEvoRate_6(v.cvalue)
            elseif v.cno == 8003 then
              gameRate:setArenaWeekUnlock(v.cvalue)
            elseif v.cno == 8004 then
              gameRate:setEquipGoldRate(v.cvalue)
            elseif v.cno == 8005 then
              gameRate:setEquipGemRate(v.cvalue)
            elseif v.cno == 8006 then
              gameRate:setEquipAddLevelLimit(v.cvalue)
            elseif v.cno == 8007 then
              gameRate:setEquipAddGoldRate(v.cvalue)
            elseif v.cno == 8008 then
              gameRate:setEquipEvoGemRate(v.cvalue)
            elseif v.cno == 8009 then
              gameRate:setEquipEvoGoldRate(v.cvalue)
            elseif v.cno == 10001 then
              gameRate:setChatCardFlag(v.cvalue)
            elseif v.cno == 10002 then
              gameRate:setChatEquipFlag(v.cvalue)
            elseif v.cno == 10003 then
              gameRate:setChatPlayerFlag(v.cvalue)
            elseif v.cno == 10004 then
              gameRate:setChatGoodsFlag(v.cvalue)
            elseif v.cno == 10005 then
              gameRate:setChatTeamFlag(v.cvalue)
            elseif v.cno == 11001 then
              gameRate:setBossInspirationGold(v.cvalue)
            elseif v.cno == 11002 then
              gameRate:setBossInspirationDiamond(v.cvalue)
            elseif v.cno == 11003 then
              gameRate:setBossInspirationGoldRate(v.cvalue)
            elseif v.cno == 11004 then
              gameRate:setBossInspirationDiamondRate(v.cvalue)
            elseif v.cno == 11005 then
              gameRate:setBossRewardStarLimit(v.cvalue)
            elseif v.cno == 11006 then
              gameRate:setInspirationAtkLimit(v.cvalue)
            elseif v.cno == 11008 then
              gameRate:setInspirationHpLimit(v.cvalue)
            elseif v.cno == 12001 then
              gameRate:setTeamMemberLimit(v.cvalue)
            elseif v.cno == 12002 then
              gameRate:setTeamCardLimit(v.cvalue)
            elseif v.cno == 12003 then
              gameRate:setTeamJoinLvLimit(v.cvalue)
            elseif v.cno == 13001 then
              gameRate:setFinishSweepDiamond(v.cvalue)
            elseif v.cno == 13002 then
              gameRate:setShowBigWheel(v.cvalue)
            elseif v.cno == 14002 then
              gameRate:setIsBuyDiamond(v.cvalue)
            elseif v.cno == 14001 then
              gameRate:setIsShare(v.cvalue)
            elseif v.cno == 5002 then
              gameRate:setArmyTalentCardEXP(v.cvalue)
            elseif v.cno == 5003 then
              gameRate:setArmyTalentGold(v.cvalue)
            elseif  v.cno == 14000 then
              gameRate:setArmyOpenLvLimit(v.cvalue)
            end
        end
        gameRate:setLoginrewards(properties.loginrewards)
        gameRate:setCtime(properties.ctime)
        gameRate:setCsta(properties.csta)
    		if params.callback and isfunction(params.callback) then
		    	params.callback(gameRate, params.data)
		    end 
    	end
    end
    
    --	创建http请求
    NetHelper.createRequest(
       ACTID.MSG_GET_CONFIG ,       --  请求id
       responseItems,    			--  回调函数
       params.data,      			--  请求信息实体或参数table
       {showLoading = false,}
    )
end

-- 获取游戏公告
function MainModel.fetchBulletin( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_NOTEINFO,
      -- ACTID.MSG_GET_REWARDLIST ,--  请求id /TODO要改
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      params.data               --  请求信息实体或参数table
    )
end

-- 获取奖励列表
function MainModel.fetchRewardList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties.tasks, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_REWARDLIST ,--  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取奖励
function MainModel.fetchReceiveReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_EARN_REWARD ,   --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 参与活动
function MainModel.fetchJoinActivity( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GOTO_ACTIVITY , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 获取邀请记录(最后十条记录)
function MainModel.fetchInviteList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_INVITELIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取邀请钻石
function MainModel.fetchInviteDiamond( params )

    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
      if params.callback and isfunction(params.callback) then
        params.callback(properties, params.data)
      end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_INVITEDIAMOND , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 获取冲级赛列表(最后十条记录)
function MainModel.fetchLevelRankList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_LEVELRANKLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取冲级赛奖励
function MainModel.fetchLevelRankReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_EARN_LEVELRANKREWARD , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
-- 获取天赋排行赛列表(最后十条记录)
function MainModel.fetchTalentRankList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_TALENTRANKLIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取天赋排行赛奖励
function MainModel.fetchTalentRankReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_EARN_TALENTRANKREWARD , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 八天奖励列表
function MainModel.fetchEightDayList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_EIGHTDAY_LIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 领取八天奖励
function MainModel.fetchEightDayReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_EIGHTDAY_RECEIVE , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 重置八天奖励
function MainModel.fetchResetEightDayReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_EIGHTDAY_RES , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end

-- 获取活动列表
function MainModel.fetchActivityList( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_ACTIVITY_LIST , --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end


-- 领取moon奖励
function MainModel.fetchReceiveMoonReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_MOONREWARD ,   --  请求id
      responseItems,            --  回调函数
      params.data               --  请求信息实体或参数table
    )
end
-- 兑换码
function MainModel.fetchExchangeCode( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_EXCHANGECODE ,   --  请求id
      responseItems,            --  回调函数
      params.data,               --  请求信息实体或参数table
      params.data               --  请求信息实体或参数table
    )
end
-- 领取登陆奖励
function MainModel.fetchReceiveLoginReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_LOGINREWARD ,   --  请求id
      responseItems,                --  回调函数
      params.data,                   --  请求信息实体或参数table
      params.data
    )
end
-- 领取鞭炮奖励
function MainModel.fetchFirecrackerReward( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_CHUNJIE ,   --  请求id
      responseItems,                --  回调函数
      params.data,                   --  请求信息实体或参数table
      params.data
    )
end
return MainModel