--Create Class PlayerEntity
local PlayerEntity = class( "PlayerEntity", BaseEntity )

-- 版本
local TDVersionUtils = require(PH_MDL_UTIL .. "TDVersionUtils")
local PlayerTalentsEntity = require("model.player.PlayerTalentsEntity")
local PlayerEquipEffectEntity = require("model.player.PlayerEquipEffectEntity")
local TriggerMsgEntity = require("model.player.TriggerMsgEntity")

function PlayerEntity:ctor( properties )
	self:setProperties( properties )
	if properties.talent == "" then
		self:setTalent("0,0,0,0,0,0,0,0,0|0,0,0,0,0,0,0,0,0")
	end
end

PlayerEntity.schema = {
	-- 编号
	userid 					= { "number", },
	-- userno?			
	userno 					= { "string", },
	-- 名称			
	name 					= { "string", },
	-- 头像			
	head 					= { "string", },
	-- 性别			
	sex 					= { "number", },
	-- 当前经验			
	curexp      			= { "number", },
	-- 等级			
	lv 						= { "number", },
	-- 拥有的友情点数
	fp 						= { "number", },
	-- 生命			
	hp 						= { "number", },
	-- 钻石			
	diamond					= { "number", },
	-- 总召唤值			
	totalcost 				= { "number", },
	-- 金币			
	gold 					= { "number", }, 
	-- 当前疲劳值			
	cursp 					= { "number", },
	-- 已用召唤值			
	usedcost 				= { "number", },
	-- 总经验值			
	totalexp 				= { "number", },
	-- 新活动			
	nreward 				= { "number", },
	-- 好友申请			
	nfriend 				= { "number", FALSE},
	-- 新商品			
	nshop 					= { "number", FALSE},
	-- 新留言公告数字
	nmessage 				= { "number", },
	-- 服务器id			
	serid 					= { "number", },
	-- 服务器名			
	sername 				= { "string", },
	-- 卡牌上限			
	ccount 					= { "number", },
	-- 卡组上限			
	gcount 					= { "number", },
	-- 好友上限			
	tcount 					= { "number", },
	-- sp时间			
	sptime 					= { "number", }, 
	-- 下次增加sp的时间
	nextsptime 				= { "number", 0},
	-- 免费抽卡次数
	freebuy					= { "number", },
	-- 总攻击
	totalatk 				= { "number", },
	-- 当前好友个数
	tcurrent				= { "number", },
	-- 禁言时间			
	nospeaktime 			= { "number", },
	-- 上场卡组			
	upcardcount 			= { "number", },
	-- 购买体力次数
	buyCostCount 			= { "number", }, 
	-- 最后系统公告版本
	notever 				= { "number", 0 },
	-- 新手引导步骤
	helpstep 				= { "number", -1 },
	-- 星星数量			
	star 					= { "number", 0 },
	-- 首付			
	firstpay 				= { "number", 0 },
	-- 客户端版本号
	versionClient 			= { "string" }, 	
	-- 客户端版本更新内容
	versionContent 			= { "string", },
	-- 首次十连抽
	firstTenDraw 			= { "number", 0 },
	-- 是否有新普通奖励
	newCommonReward 		= { "number", 0 },
	-- 是否有新日常奖励
	newDayReward 			= { "number", 0 },
	-- 天赋等级&军团天赋等级
	talent 					= { "string", "0,0,0,0,0,0,0,0,0|0,0,0,0,0,0,0,0,0"},
	-- 总血量
	totalHp 				= { "number", 0 },
	-- 最大的限时活动编号
	maxActivityId 			= { "number", 0 },
	-- 触发消息
	TriggerMsg 				= { "string", "" },
	-- 是否有新上线领钻(0没有1有)
	NewDiamondReward 		= { "number", 0}, 
	-- 是否有签到
	TodaySigned 			= { "number", 0}, 
	-- 装备效果
	EquipEffect 			= { "string", ""}, 
	-- 装备
	Equiplst 				= { "string", ""}, 
	-- 装备技能
	EquipSk 				= { "string", ""}, 
	-- 是否可以许愿
	CanWish 				= { "number", 0}, 
	-- 是否可以挖矿
	CanMine 				= { "number", 0}, 
	-- 错误信息
	ErrorInfo				= { "string", ""}, 
	-- 是否显示7天奖励 0 不显示 1 显示，无高亮 2 显示有高亮
	showday7				= { "number", 0}, 
	-- 首页活动图片
	actpng					= { "string", ""}, 
	-- 最大体力
	actlimit				= { "number", 0},
	-- 全服boss战 0 不开启 1开启
	bosswar					= { "number", 0},
	-- 藏宝港湾 0 不开启 1开启
	scopy					= { "number", 0},
	-- 幽冥魔塔 0 不开启 1开启
	ladder					= { "number", 0},
}

PlayerEntity.fields = {
	
	"userid" ,	-- 编号
	"userno" ,	-- userno				
	"name" 	,	-- 名称
	"head"	,	-- 头像
	"sex"	, 	-- 性别
	"curexp",	-- 当前经验
	"lv",		-- 等级
	"fp" ,		-- 友情点数
	"hp" ,		-- 生命
	"diamond",	-- 钻石
	"totalcost",-- 总召唤值
	"gold" , 	-- 金币
	"cursp" ,	-- 当前体力				
	"usedcost" ,-- 已用召唤				
	"totalexp" ,-- 总经验值
	"nreward" , -- 新活动
	"nfriend",  -- 好友申请
	"nshop"  ,  -- 新商品
	"nmessage", -- 新留言公告数字
	"serid" ,	-- 服务器id
	"sername" , -- 服务器名称
	"ccount", 	-- 卡牌上限
	"gcount", 	-- 卡组上限
	"tcount", 	-- 好友上限
	"sptime",	-- sp时间
	"freebuy",	-- 免费抽卡次数
	"totalatk", -- 总攻击
	"tcurrent", -- 当前好友个数
	"nospeaktime", -- 禁言时间
	"upcardcount", -- 上场卡组
	"buyCostCount", -- 购买体力次数
	"notever", 	-- 最后系统公告版本
	"helpstep",	-- 新手引导步骤
	"star", 	-- 星星数量
	"firstpay", -- 首付
	"versionClient", 	-- 客户端版本号
	"versionContent", 	-- 客户端版本更新内容
	"firstTenDraw", 	-- 首次十连抽
	"newCommonReward", 	-- 是否有新普通奖励
	"newDayReward", 	-- 是否有新日常奖励
	"talent", 			-- 天赋等级
	"totalHp", 			-- 总血量
	"maxActivityId", 	-- 最大的限时活动编号
	"TriggerMsg", 		-- 触发消息
	"NewDiamondReward", -- 是否有新上线领钻(0没有1有)
	"TodaySigned",		-- 每日签到
	"EquipEffect",  	-- 装备效果
	"Equiplst",  		-- 装备
	"EquipSk",  		-- 装备技能
	"CanWish",  		-- 是否可以许愿
	"CanMine",  		-- 是否可以挖矿
	"ErrorInfo",  		-- 错误信息
	"showday7",  		-- 是否显示7天奖励 0 不显示 1 显示，无高亮 2 显示有高亮
	"actpng", 			-- 首页活动图片
	"actlimit",			-- 最大体力
	"bosswar",			-- 全服boss
	"scopy",			-- 藏宝港湾
	"ladder",			-- 幽冥魔塔
}

PlayerEntity.setProperties_ = PlayerEntity.setProperties

function PlayerEntity:setProperties( properties )
	self:setProperties_( properties )

	-- 判断版本
	if type(properties.versionClient) == "string" and TDVersionUtils.isOutdate(properties.versionClient) then 
		-- 显示[更新]对话框
		game.dialogVersionFound(properties.versionClient, properties.versionContent)
		return
	end

	-- 更新SP时间
	if properties.sptime then
		if properties.sptime > 0 then
			self:setNextsptime(os.time() + self:getSptime())
		else
			self:setNextsptime(0)
		end
	end
end

-- 取得体力下一点所需时间
function PlayerEntity:getSpNextTime( )
	if self:getNextsptime() > 0 and self:getCursp() < self:getActlimit() then
		local result = self:getNextsptime() - os.time()
		if result < 0 then
			result = -result
			while result > 300 do
				result = result - 300
			end
			result = 300 - result
		end
		return result
	else
		return 0
	end
end










-- [Gettor/Settor方法]
-- 编号
function PlayerEntity:getUserid()
	return self.userid_
end
function PlayerEntity:setUserid(newKey)
	self.userid_ = newKey
end

-- userno?
function PlayerEntity:getUserno()
	return self.userno_
end
function PlayerEntity:setUserno(newKey)
	self.userno_ = newKey
end

-- 名称
function PlayerEntity:getName()
	return self.name_
end
function PlayerEntity:setName(newKey)
	self.name_ = newKey
end

-- 头像
function PlayerEntity:getHead()
	return self.head_
end
function PlayerEntity:setHead(newKey)
	self.head_ = newKey
end

-- 性别
function PlayerEntity:getSex()
	return self.sex_
end
function PlayerEntity:setSex(newKey)
	self.sex_ = newKey
end

-- 当前经验
function PlayerEntity:getCurexp()
	return self.curexp_
end
function PlayerEntity:setCurexp(newKey)
	self.curexp_ = newKey
end

-- 等级
function PlayerEntity:getLv()
	-- return 99
	return self.lv_
end
function PlayerEntity:setLv(newKey)
	self.lv_ = newKey
end

-- 拥有的友情点数
function PlayerEntity:getFp()
	return self.fp_
end
function PlayerEntity:setFp(newKey)
	self.fp_ = newKey
end

-- 生命
function PlayerEntity:getHp()
	return self.hp_
end
function PlayerEntity:setHp(newKey)
	self.hp_ = newKey
end

-- 钻石
function PlayerEntity:getDiamond()
	-- return 99999
	return self.diamond_
end
function PlayerEntity:setDiamond(newKey)
	self.diamond_ = newKey
end

-- 总召唤值
function PlayerEntity:getTotalcost()
	return self.totalcost_
end
function PlayerEntity:setTotalcost(newKey)
	self.totalcost_ = newKey
end

-- 金币
function PlayerEntity:getGold()
	return self.gold_
end
function PlayerEntity:setGold(newKey)
	self.gold_ = newKey
end
 
-- 当前疲劳值
function PlayerEntity:getCursp()
	return self.cursp_
end
function PlayerEntity:setCursp(newKey)
	self.cursp_ = newKey
end

-- 已用召唤值
function PlayerEntity:getUsedcost()
	return self.usedcost_
end
function PlayerEntity:setUsedcost(newKey)
	self.usedcost_ = newKey
end

-- 总经验值
function PlayerEntity:getTotalexp()
	return self.totalexp_
end
function PlayerEntity:setTotalexp(newKey)
	self.totalexp_ = newKey
end

-- 新活动
function PlayerEntity:getNreward()
	return self.nreward_
end
function PlayerEntity:setNreward(newKey)
	self.nreward_ = newKey
end

-- 好友申请
function PlayerEntity:getNfriend()
	return self.nfriend_
end
function PlayerEntity:setNfriend(newKey)
	self.nfriend_ = newKey
end

-- 新商品
function PlayerEntity:getNshop()
	return self.nshop_
end
function PlayerEntity:setNshop(newKey)
	self.nshop_ = newKey
end

-- 新留言公告数字
function PlayerEntity:getNmessage()
	return self.nmessage_
end
function PlayerEntity:setNmessage(newKey)
	self.nmessage_ = newKey
end

-- 服务器id
function PlayerEntity:getSerid()
	return self.serid_
end
function PlayerEntity:setSerid(newKey)
	self.serid_ = newKey
end

-- 服务器名
function PlayerEntity:getSername()
	return self.sername_
end
function PlayerEntity:setSername(newKey)
	self.sername_ = newKey
end

-- 卡牌上限
function PlayerEntity:getCcount()
	return self.ccount_
end
function PlayerEntity:setCcount(newKey)
	self.ccount_ = newKey
end

-- 卡组上限
function PlayerEntity:getGcount()
	return self.gcount_
end
function PlayerEntity:setGcount(newKey)
	self.gcount_ = newKey
end

-- 好友上限
function PlayerEntity:getTcount()
	return self.tcount_
end
function PlayerEntity:setTcount(newKey)
	self.tcount_ = newKey
end

-- sp时间
function PlayerEntity:getSptime()
	return self.sptime_
end
function PlayerEntity:setSptime(newKey)
	self.sptime_ = newKey
end
 
-- 下次增加sp的时间
function PlayerEntity:getNextsptime()
	return self.nextsptime_
end
function PlayerEntity:setNextsptime(newKey)
	self.nextsptime_ = newKey
end

-- 免费抽卡次数
function PlayerEntity:getFreebuy()
	return self.freebuy_
end
function PlayerEntity:setFreebuy(newKey)
	self.freebuy_ = newKey
end

-- 总攻击
function PlayerEntity:getTotalatk()
	return self.totalatk_
end
function PlayerEntity:setTotalatk(newKey)
	self.totalatk_ = newKey
end

-- 当前好友个数
function PlayerEntity:getTcurrent()
	return self.tcurrent_
end
function PlayerEntity:setTcurrent(newKey)
	self.tcurrent_ = newKey
end

-- 禁言时间
function PlayerEntity:getNospeaktime()
	return self.nospeaktime_
end
function PlayerEntity:setNospeaktime(newKey)
	self.nospeaktime_ = newKey
end

-- 上场卡组
function PlayerEntity:getUpcardcount()
	return self.upcardcount_
end
function PlayerEntity:setUpcardcount(newKey)
	self.upcardcount_ = newKey
end

-- 购买体力次数
function PlayerEntity:getBuyCostCount()
	return self.buyCostCount_
end
function PlayerEntity:setBuyCostCount(newKey)
	self.buyCostCount_ = newKey
end
 
-- 最后系统公告版本
function PlayerEntity:getNotever()
	return self.notever_
end
function PlayerEntity:setNotever(newKey)
	self.notever_ = newKey
end

-- 新手引导步骤
function PlayerEntity:getHelpstep()
	return self.helpstep_
end
function PlayerEntity:setHelpstep(newKey)
	self.helpstep_ = newKey
end

-- 星星数量
function PlayerEntity:getStar()
	return self.star_
end
function PlayerEntity:setStar(newKey)
	self.star_ = newKey
end

-- 首付
function PlayerEntity:getFirstpay()
	return self.firstpay_
end
function PlayerEntity:setFirstpay(newKey)
	self.firstpay_ = newKey
end

-- 客户端版本号
function PlayerEntity:getVersionClient()
	return self.versionClient_
end
function PlayerEntity:setVersionClient(newKey)
	self.versionClient_ = newKey
end
 	
-- 客户端版本更新内容
function PlayerEntity:getVersionContent()
	return self.versionContent_
end
function PlayerEntity:setVersionContent(newKey)
	self.versionContent_ = newKey
end

-- 首次十连抽
function PlayerEntity:getFirstTenDraw()
	return self.firstTenDraw_
end
function PlayerEntity:setFirstTenDraw(firstTenDraw)
	self.firstTenDraw_ = firstTenDraw
end

-- 是否有新普通奖励
function PlayerEntity:getNewCommonReward()
	return self.newCommonReward_
end
function PlayerEntity:setNewCommonReward(newCommonReward)
	self.newCommonReward_ = newCommonReward
end

-- 是否有新日常奖励
function PlayerEntity:getNewDayReward()
	return self.newDayReward_
end
function PlayerEntity:setNewDayReward(newDayReward)
	self.newDayReward_ = newDayReward
end

-- 天赋等级
function PlayerEntity:getTalent()
	return self.talent_
	-- return "0,0,0,0,0,0,0,0,0|30,30,30,30,30,30,30,30,30"
end
function PlayerEntity:setTalent(talent)
	self.talent_ = talent
end

-- 取得天赋实体
function PlayerEntity:getPlayerTalentsEntity( )
	return PlayerTalentsEntity.new{ talent = self:getTalent()}
end

-- 取得触发消息实体 1.奖励 2.卡槽 3.卡组 4.强化 5.进阶 6.天赋 7.星星 8.碎片 9.竞技场 10.好友 
-- 11.新手 12.探索 13.周赛 14.装备 15.装备强化 16.矿山 17.装备追加 18.装备进阶 19.关卡5星奖励 20.藏宝海湾 21.幽冥魔塔
function PlayerEntity:getTriggerMsgEntity( )
	return TriggerMsgEntity.new(self:getTriggerMsg())
	-- return TriggerMsgEntity.new("1:1-200|2:0-0|3:0-0|4:3|5:3|6:3|7:3|8:3|9:3|10:3|11:9|12:3|13:3|14:3|15:3|16:3|17:3|18:3|19:3|20:3|21:3")
end

-- 总血量
function PlayerEntity:getTotalHp()
	return self.totalHp_
end
function PlayerEntity:setTotalHp(totalHp)
	self.totalHp_ = totalHp
end

-- 最大的限时活动编号
function PlayerEntity:getMaxActivityId()
	return self.maxActivityId_
end
function PlayerEntity:setMaxActivityId(maxActivityId)
	self.maxActivityId_ = maxActivityId
end

-- 触发消息
function PlayerEntity:getTriggerMsg()
	return self.TriggerMsg_
end
function PlayerEntity:setTriggerMsg(TriggerMsg)
	self.TriggerMsg_ = TriggerMsg
end

-- 是否有新上线领钻(0没有1有)
function PlayerEntity:getNewDiamondReward()
	return self.NewDiamondReward_
end
function PlayerEntity:setNewDiamondReward(NewDiamondReward)
	self.NewDiamondReward_ = NewDiamondReward
end
-- 每日签到(0没有1有)
function PlayerEntity:getTodaySigned()
	return self.TodaySigned_
end
function PlayerEntity:setTodaySigned(TodaySigned)
	self.TodaySigned_ = TodaySigned
end
-- 是否可以许愿(0没有1有)
function PlayerEntity:getCanWish()
	return self.CanWish_
end
function PlayerEntity:setCanWish(CanWish)
	self.CanWish_ = CanWish
end
-- 是否可以挖矿(0没有1有)
function PlayerEntity:getCanMine()
	return self.CanMine_
end
function PlayerEntity:setCanMine(CanMine)
	self.CanMine_ = CanMine
end

-- 装备效果
function PlayerEntity:getEquipEffect()
	return self.EquipEffect_
end
function PlayerEntity:setEquipEffect(EquipEffect)
	self.EquipEffect_ = EquipEffect
end
-- 取得装备效果实体
function PlayerEntity:getPlayerEquipEffectEntity( )
	return PlayerEquipEffectEntity.new{ equipEffect = self:getEquipEffect()}
end
-- 装备技能
function PlayerEntity:getEquipSk()
	return self.EquipSk_
end
function PlayerEntity:setEquipSk(EquipSk)
	self.EquipSk_ = EquipSk
end
-- 装备效果
function PlayerEntity:getEquiplst()
	return self.Equiplst_
end
function PlayerEntity:setEquiplst(Equiplst)
	self.Equiplst_ = Equiplst
end
-- 装备技能
function PlayerEntity:getEquipSkill()
	local skillsTable = {}
	local skills = string.split(self.EquipSk_, "|")
	local params
	local entity
	local lv, skillid
	for i, v in ipairs(skills) do
		params = string.split(v, ":")
		skillid = params[1]
		lv = params[2]
		if skillid and lv then
			entity = EquipSkillDB.getSkillEntity( skillid, lv )
			if entity then
				skillsTable[#skillsTable + 1] = entity
			end
		end
	end
	return skillsTable
end
-- 创建人物形象
function PlayerEntity:createPlayerView( params )
	local role = Player.new(self:getSex(), self:getHead(), self:getEquiplst(), params)
	return role
end

function PlayerEntity:createPlayerHeadRectView( clickListener, params )
	local role = PlayerHead.new(self:getSex(), self:getHead(), self:getEquiplst(), params)
					:createRect(clickListener)
	return role
end
-- 是否能说话
function PlayerEntity:CanSpeak( )
	local curTime = os.time()
	local lastTime = self.lastSpeakTime_ or 0
	if (curTime - lastTime) > _GAME.CONFIG.SPEAK_INTERVAL then
		self.lastSpeakTime_ = curTime
		return true
	else
		NetHelper.QuickToast(_s("CHAT_SEND_REST"))
		return false
	end
end

-- 装备效果
function PlayerEntity:getErrorInfo()
	return self.ErrorInfo_
end
function PlayerEntity:setErrorInfo(ErrorInfo)
	self.ErrorInfo_ = ErrorInfo
end
-- 装备效果
function PlayerEntity:getShowday7()
	return self.showday7_
end
function PlayerEntity:setShowday7(showday7)
	self.showday7_ = showday7
end

-- 首页活动图片
function PlayerEntity:getActpng()
	return self.actpng_
end
function PlayerEntity:setActpng(actpng)
	self.actpng_ = actpng
end
--最大体力
function PlayerEntity:getActlimit( ... )
	return self.actlimit_
end
function PlayerEntity:setActlimit( newVal )
	self.actlimit_ = newVal
end
-- 全服boss
function PlayerEntity:getBosswar( ... )
	return self.bosswar_
end
function PlayerEntity:setBosswar( newVal )
	self.bosswar_ = newVal
end
-- 藏宝港湾
function PlayerEntity:getScopy( ... )
	return self.scopy_
end
function PlayerEntity:setScopy( newVal )
	self.scopy_ = newVal
end
-- 幽冥魔塔
function PlayerEntity:getLadder( ... )
	return self.ladder_
end
function PlayerEntity:setLadder( newVal )
	self.ladder_ = newVal
end

return PlayerEntity