
local TeamModel = {}
TeamModel.TAG = "[TeamModel]"
local CardGroupEntity = require("model.card.CardGroupEntity")
-- 战队首页
function TeamModel.fetchTeamIndex( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_INDEX_TEAMINDEX , --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end

-- 获取战队信息
function TeamModel.fetchTeamInfo( params )

    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_TEAMINFO , --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end
-- 创建战队
function TeamModel.fetchCreateTeam( params )

    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_CREATE_TEAM , --  请求id
      responseItems,                --  回调函数
      params.data                   --  请求信息实体或参数table
    )
end
-- 获取战队卡牌
function TeamModel.fetchIntoTeamCard( params )

    local function responseItems( properties )
      if properties then
        local cardGroup = CardGroupEntity.new(properties)
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(cardGroup, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_INTO_SELECTTEAMCARDS ,  --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end

-- 配置战队卡
function TeamModel.fetchTeamCard( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_SELECT_TEAMCARDS ,  --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end

-- 获取战队申请请求
function TeamModel.fetchIntoTeamApp( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_INTO_TEAMAPP ,  --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end

-- 战队添加队员
function TeamModel.fetchAddTeamer( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_ADD_TEAMER ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end

-- 解散战队
function TeamModel.fetchDismissalTeam( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_DIS_TEAM ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 战队宣言
function TeamModel.fetchWriteTeamDeclaration( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_WRITE_TEAMDE ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 战队报名
function TeamModel.fetchSignUpTeamWar( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_SIGNUP_TEAM ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 战队踢人
function TeamModel.fetchKickTeamMember( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_REMOVE_TEAMER ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 退出战队
function TeamModel.fetchExitTeam( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_EXIT_TEAME ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 退出战队
function TeamModel.fetchJoinTeam( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_APP_TEAM,              --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 发送战队广告
function TeamModel.fetchSendTeamAD( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_SEND_TEAMAD ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 获取战队列表
function TeamModel.fetchTeamList( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_TEAMLST ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 战队申请信息
function TeamModel.fetchTeamAppContent( params )
    local function responseItems( properties )
      -- if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      -- end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_WRITE_TEAMAPPCON ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 领取战队奖励
function TeamModel.fetchTeamReward( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_GET_TEAMREWARD ,        --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end
-- 开战测试
function TeamModel.fetchStartTeamFightTest( params )
    local function responseItems( properties )
      if properties then
        -- 配置数值分类
        if params.callback and isfunction(params.callback) then
          params.callback(properties, params.data)
        end 
      end
    end
    
    --  创建http请求
    NetHelper.createRequest(
      ACTID.MSG_START_TEAM ,            --  请求id
      responseItems,                    --  回调函数
      params.data                       --  请求信息实体或参数table
    )
end

return TeamModel