--[[
    使用例子：
    1. 创建请求
    NetHelper.createRequest(
        acId.MSG_LEVEL_BATTLE,  -- 请求id
        TestCallBack,           -- 回调函数
        entity,                 -- 请求实体
        {
            other = other,          -- 追加参数
            failedCb  = TestCallBack_failed    -- 错误回调函数
            cbParams = {a = 1},     -- 回调参数
            showLoading = true      -- 是否显示蒙板
        }
    )

    2. 回调函数
    **Parameters:**

-   properties:  table    服务端返回信息
-   params:      table    回调参数
    function TestCallBack( properties, params )
        Log.d(TAG,"TestCallBack:   "..params.a)

        if properties then
            -- 创建实体
            xxx = xxxEntity.new(properties)
        else
            Log.d(TAG,"err")
        end
    end
    
    2. 错误后回调函数
    **Parameters:**
-   result:      number   操作结果
    function TestCallBack_failed( result )
        -- body
    end
--]]

--[[
0，未知iOS设备
1，iPhone
2，iPod
3，iPad
10 Android Phone
11 Android Tablet  
--]]
local function getDevicetype()
    local dtype = 0

    if device.platform == "ios" then 
        if device.model == "iphone" then 
            dtype = 1
        elseif device.model == "ipad" then 
            dtype = 3
        else
            dtype = 2
        end
    elseif device.platform == "android" then 
        dtype = 10
    end 

    return dtype
end

local function istest() 
    return not RELEASE_MODE or DEBUG == 2
end

DEFLOGINBASEINFO = {
                    deviceid = device.getOpenUDID(),
                    devicetype = getDevicetype(),  -- 设备类型
                    imsi = device.getOpenUDID(),     -- imsi
                    cid = 1,         -- 渠道
                    lang = device.language,     -- 语言
                    cv = CVERSION,      -- 版本
                    udid = device.getOpenUDID(), -- 用户id 默认用设备id
                    ext1 = "",
                    ext2 = "",
                    ext3 = "",
                    usertype = _GAME.CONFIG.SDK_PLATFORM[1], 
                }
LOGINBASEINFO = DEFLOGINBASEINFO


local M = {}
local TAG = "[NetHelper]"

SERVERID = 1 -- 服务器id(默认为1，用于访问选择服务器接口)

local BASESER_DOMAIN = _GAME.CONFIG.SDK_PLATFORM.domain or DEFAULT_BASESER_DOMAIN
if not BASESER_DOMAIN then 
    BASESER_DOMAIN = "http://ahdxc.app-fame.com"
    -- BASESER_DOMAIN = "http://yszc.app-fame.com"
end
-- 请求地址
REQUEST_URL = "" 
-- 基本服务器地址,若没以端口号结尾就要加上默认189端口,不要问我为什么,兼容是件很麻烦的事,花客  
if string.endwith(BASESER_DOMAIN, ":[%d]+") then 
    BASESER_URL = BASESER_DOMAIN 
else
    BASESER_URL = BASESER_DOMAIN .. ":189"--"http://116.255.234.138:99"--
end
-- 获取服务器列表地址
local SETLISTURL = BASESER_URL .. "/Server.ashx"
local SERURL = string.format("%s/server%s.txt", BASESER_URL, game.getServerSDKTag()) --BASESER_URL .. "/server.txt"

-- 重置默认域名,这个东东很危险啊
function M:changeBaseDomain( domain )
    BASESER_DOMAIN = domain
    BASESER_URL = BASESER_DOMAIN
    SETLISTURL = BASESER_URL .. "/Server.ashx"
    SERURL = string.format("%s/server%s.txt", BASESER_URL, game.getServerSDKTag())
end

-- 蒙板
local SL_CANLOAD = 0
local SL_LOADING = 1
local SL_NOLOAD = 2
local SL = 0

-- 网络写入对象
local W = NetWriter:getInstance()

-- 网络读取对象
local R = NetReader:getInstance()

-- 请求实体配置文件
require("net.NetConfig")

-- 返回信息处理器
local GETDATA = require("net.NetGetData")

-- 发送请求参数
sendParams = {}
local CUR_MSGID = 0 -- 当前发送msgid

-- 心跳时间
local HEART_BEAT_TIME = 3 * 60
HEART_BEAT_STATUS_NOJUMP = true
HEART_BEAT_HANDLE = nil

-- 是否可以发送，默认可以发送
local CANSENDREQUEST = true

-- 重新请求次数
local reSendCount = 0
local reSendMaxCount = 5

local SHOWLOADINGTIME = 15
local SHOWLOADINGHANDLE = nil
local NONEEDAUTOCLOSE = false -- 需要自动关闭

local crypto = require("framework.client.crypto")

local onRequest
local sendRequest
local onGetSerListRequest
local neterrcatch
local SHOWNETERRHANDLE = nil

local wrongCount = 0 -- 出错次数

function M.QuickToast( text, enableTouchClose, delayTime )
    widget.newToast{
        text =  text,
        padding = 20,
        bgParams = {
            file = "QuickToast.png",
        },
        width = display.width / 2,
        -- image = "btn_mail_select.png",
        enableTouchClose =  enableTouchClose or true,
        delayTime = delayTime or 0.5,
    }
end

-- 关闭loading
function M.hideLoading( falsenoneed )
    -- 恢复自动关闭
    if falsenoneed then 
        NONEEDAUTOCLOSE = false
        SL = SL_CANLOAD
        quickui.hideLoadingLayer()
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ hideLoading 强制关闭,恢复自动关闭 @@@@@@@@@@@@@@@@@")
    end
    if NONEEDAUTOCLOSE then 
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ hideLoading NONEEDAUTOCLOSE 什么也没干 @@@@@@@@@@@@@@@@@")
    else 
        if SL == SL_LOADING then 
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ hideLoading 关闭 @@@@@@@@@@@@@@@@@")
            -- CCBCenter.popFirstCCBNode()
            SL = SL_CANLOAD

            if SHOWLOADINGHANDLE then 
                -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ hideLoading 取消自动关闭 @@@@@@@@@@@@@@@@@")
                scheduler.unscheduleGlobal(SHOWLOADINGHANDLE)
                SHOWLOADINGHANDLE = nil
            end

            NONEEDAUTOCLOSE = false
            quickui.hideLoadingLayer()
        else
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ hideLoading 没东东关闭 @@@@@@@@@@@@@@@@@")
        end
    end

end

-- 转圈超时
local function loadingtimeout()
    if #sendParams > 0 then
        table.remove(sendParams,1)
    end
    CANSENDREQUEST = true
    SL = SL_CANLOAD
    -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ loadingtimeout 超时关闭 @@@@@@@@@@@@@@@@@")
    -- NetHelper.QuickToast(_s("NETWORK_CONNECT_FAILED2"))
    -- AlertLayer.new4OK{
    --        content = _s("NETWORK_CONNECT_FAILED2")
    --    }
    quickui.hideLoadingLayer()

    if SHOWLOADINGHANDLE then 
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ loadingtimeout 超时取消自动关闭 @@@@@@@@@@@@@@@@@")
        scheduler.unscheduleGlobal(SHOWLOADINGHANDLE)
        SHOWLOADINGHANDLE = nil
    end
    -- 恢复自动关闭状态
    NONEEDAUTOCLOSE = false
end


-- 显示loading
function M.showLoading( sLoading , noneed, nohand, text )
    noneed = false
    if SL == SL_LOADING then 
        if not sLoading then return end 
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 开启但已显示 %s %s @@@@@@@@@@@@@@@@@"
            -- , noneed == true and "手动关闭模式" or "自动关闭模式"
            -- , nohand == true and "延迟调用" or "直接调用"
            -- )
        if NONEEDAUTOCLOSE ~= true then 
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 设置不进行自动关闭 @@@@@@@@@@@@@@@@@")
            NONEEDAUTOCLOSE = noneed == true
        end

        if SHOWLOADINGHANDLE then 
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 取消自动关闭 @@@@@@@@@@@@@@@@@")
            scheduler.unscheduleGlobal(SHOWLOADINGHANDLE) 
            SHOWLOADINGHANDLE = nil
        end

        if not NONEEDAUTOCLOSE and not noneed then
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 重新设置自动关闭 @@@@@@@@@@@@@@@@@")
            SHOWLOADINGHANDLE = util.delayCall(loadingtimeout, SHOWLOADINGTIME)
        end

        if not text then 
            return 
        else
            -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 文字改变,关掉loading,重新开启 @@@@@@@@@@@@@@@@@")
            quickui.hideLoadingLayer()
        end
    end

    SL = iff(sLoading, SL_CANLOAD, SL_NOLOAD )

    if SL == SL_CANLOAD then
        -- 开启蒙板
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 开启 %s %s @@@@@@@@@@@@@@@@@"
            -- , noneed == true and "手动关闭模式" or "自动关闭模式"
            -- , nohand == true and "延迟调用" or "直接调用"
            -- )
        -- 非手动0.6秒
        if nohand then 
            quickui.showLoadingLayer{delay = 0.6, text = text}
        else
            quickui.showLoadingLayer{text = text}
        end

        -- 不需要自动关闭,直到手动调用自动关闭才关闭
        if noneed then 
            NONEEDAUTOCLOSE = noneed
        end 

        SL = SL_LOADING
        
        -- 开启即时
        if SHOWLOADINGHANDLE then 
            scheduler.unscheduleGlobal(SHOWLOADINGHANDLE)
            SHOWLOADINGHANDLE = nil
        end
        if not noneed then 
            SHOWLOADINGHANDLE = util.delayCall(loadingtimeout, SHOWLOADINGTIME)
        end
    else
        -- Log.d(TAG,"@@@@@@@@@@@@@@@@@ showLoading 不用开启 @@@@@@@@@@@@@@@@@")
    end


end

--[[

-   处理基本信息
--]]
local function readBaseData()
    -- 得到基本信息
    local baseData = GETDATA.GetData_Base()
    if istest() then 
        -- Log.d(TAG,"baseData:%s",json.encode(baseData))
        dump(baseData, "baseData")
    end
    if baseData then
        ME:setProperties(baseData)
    end
    -- 得到事件信息，暂时为空
    local eventCount = R:readINT()
    Log.d(TAG,"eventCount:%d",eventCount)
end

--[[ 

-   配置请求table

**Parameters:**

-   actionId:    number      请求id
-   properties:  table       请求信息
--]]
local function createQuestTable( actionId, properties )
        local t = {}

        -- 从配置表中得到key
        local keys = RequestKey[actionId]

        -- 根据key萃取请求信息
        if keys then

            for i=1,#keys do
                local key = keys[i]
                local value = properties[key]
                if value then
                    t[key] = value
                else
                    Log.d(TAG,"===================================")
                    Log.d(TAG,"******错误，找不到参数：%s",key,"******")
                    Log.d(TAG,"===================================")
                end
                
            end

        end

    return t
end

--[[ 

-   写入具体请求信息

**Parameters:**

-   actionId:    number      请求id
-   properties:  table       请求信息
--]]
local function writeProperties( actionId, properties )
    if properties then
        Log.d(TAG,"=============writeProperties===============")
        if not isandroid() then
            if istest() then 
                -- Log.p(TAG,"properties:%s",json.encode(properties))
                dump(properties, "writeProperties.properties")
            end
        end
        local t = createQuestTable(actionId, properties)
        Log.d(TAG,"===================================")
        if istest() then 
            -- Log.d(TAG,"after properties:%s",json.encode(t))
            dump(t, "after createQuestTable")
        end

        -- 遍历读取t，写入请求
        for k, v in pairs(t) do
            if isnumber(v) or isstring(v) then
                -- 都用string就好了
                W:writeString(k,v)
                -- -- 目前只要32就够了
                -- W:writeInt32(k,v)
            -- elseif isstring(v) then
            --     W:writeString(k,v)
            elseif istable(v) then
                -- 若是数组 拼成,号隔开的字符串
                local vStr = ""
                for i=1,#v do
                    if i ~= #v then
                        vStr = vStr .. v[i] .. ","
                    else
                        vStr = vStr .. v[i]
                    end
                end
                W:writeString(k,vStr)
            end
        end
    end
end

--[[ 

-   发送心跳包
--]]
local function sendHeartPackage()
    Log.d(TAG,"~~~ I'm alive~~~%s",os.date())
    --   创建http请求
    NetHelper.createRequest(
    
       ACTID.MSG_HEART_BEAT,
       nil,
       {},
       {showLoading = false}

    )

end

--[[ 

-   设置基础参数

**Parameters:**
-   actionId:    number      请求id

-   return msgid
--]]
local function loadBaseRequest( actionId )

    if actionId and actionId > 0 and REQUEST_URL and REQUEST_URL ~= "" then 
        -- 设置地址
        NetWriter:setUrl(REQUEST_URL)
        -- msgid   +1 每次自增
        -- sid  sessionId 服务器传来 直接传入
        -- actionid  操作接口编号
        -- serverid  服务器编号

        NetWriter:setActionId(actionId)

        -- 如果是登录
        if ACTID.MSG_USER_LOGIN == actionId then 
            -- 清除session 重新登录
            if ISGSVALUES() then
                GSVALUES.sid = ""
                GS.save(GSVALUES)
            end

            NetWriter:setSessionID("")
            Log.d(TAG,"MSG_USER_LOGIN ")
            
        end

        -- Log.d(TAG,"values.msgid %d",values.msgid)

        Log.d(TAG,"setServerId %d",SERVERID)
        NetWriter:setServerId(SERVERID)
        -- 不是获取服务器列表请求时，写入服务器id到本地
        if ISGSVALUES() and ACTID.MSG_GET_SERLIST ~= actionId then
            GSVALUES.serverid = SERVERID 
            GS.save(GSVALUES)
        end

        return true
    else
        return false
    end
 
end

--[[

-   发送请求

**Parameters:**

-   vmsgid:   number    msgid
--]]
function sendRequest( vmsgid )

    if not network.isInternetConnectionAvailable() then 
        neterrcatch()
        return
    end 

    if CANSENDREQUEST and #sendParams > 0 then 
        CANSENDREQUEST = false
        -- 得到请求数据
        local actionId = sendParams[1].actionId
        local callback = sendParams[1].callback
        local entity = sendParams[1].entity
        local params = sendParams[1].params

        -- msgid 每次自增
        -- 若当前msgid为0 去本地文件取
        if CUR_MSGID == 0 then 
            if ISGSVALUES() and GSVALUES.msgid and GSVALUES.msgid > 0 then
                CUR_MSGID = GSVALUES.msgid
            end
        end
        CUR_MSGID = CUR_MSGID + 1

        -- vmsgid有值，说明是重发的
        if vmsgid and vmsgid > 0 and actionId ~= ACTID.MSG_HEART_BEA then 
            CUR_MSGID = vmsgid + 1 
            -- 小于最大次数就重发
            if reSendCount < reSendMaxCount then 
                reSendCount = reSendCount + 1
            else
                reSendCount = 0

                neterrcatch()
                -- AlertLayer.new4OK{
                --     content = "网络不给力，请稍后重试"
                -- }
                -- 关闭loading
                M.hideLoading(true)
                return
            end
        end

        -- msgid写入请求
        NetWriter:setCounter(CUR_MSGID)

        -- 再存到本地
        if ISGSVALUES() then
            GSVALUES.msgid = CUR_MSGID
            GS.save(GSVALUES)
        end 

        local other
        local failedCb
        local cbParams
        local sLoading

        if params then 
            other = params.other
            failedCb = params.failedCb
            cbParams = params.cbParams
            sLoading = params.showLoading
        end 

        -- 设置基础参数
       if loadBaseRequest(actionId) then 
            -- 默认开启蒙板
            if sLoading == nil then 
                -- 不要弹出来啊
                sLoading = not game.skipCacheLoading(actionId) -- true
            end
            -- Log.d(TAG,"sLoading %d",sLoading)
            M.showLoading(sLoading, false, true)

            local properties = {}
            -- 从entity中读取需要的值设入
            if entity and entity.getProperties then
                properties = entity:getProperties()
            else
                properties = entity
            end

            if other and properties then
                    try(function ()
                        table.merge(properties,other)
                    end,
                    function ( )
                        -- body
                    end,
                    nil)
                
            end

            -- 写入请求参数
            writeProperties(actionId,properties)

            -- 得到请求链接字符串
            local post = W:createPostData()
            Log.d(TAG,"===================================")
            -- Log.d(TAG,"post:%s", post)

            -- if not network.isHostNameReachable(post) then 
            --     neterrcatch()
            --     return
            -- end

            -- 创建请求
            local request = network.createHTTPRequest(function(event)
                onRequest(callback, event, failedCb, cbParams)
            end, post)
            -- 设置超时时间
            request:setTimeout(10)
            -- 设置gzip
            request:setAcceptEncoding(kCCHTTPRequestAcceptEncodingGzip);
            -- request:setAcceptEncoding(kCCHTTPRequestAcceptEncodingDeflate)
            -- 发送请求
            request:start()
       else
            -- neterrcatch()
            -- AlertLayer.new4OK{
            --     content = "网络不给力，请稍后重试"
            -- }
            --GameHelper.returnToLogin()
       end
    end

end


--[[

-   回调函数    登录

--   properties:  table    服务端返回信息
--   params:      table    回调参数
--]]
local function callback_login( properties, params )

    if ISGSVALUES() == nil then return end

    if properties then 
        -- 保存用户id ，no
        GSVALUES.userid = properties.userid
        GSVALUES.userno = properties.userno
        GSVALUES.needmodify = 0
        -- 不需要修改则存入名字，性别，头像
        GSVALUES.name = properties.name
        GSVALUES.sex = properties.sex
        GSVALUES.head = properties.head

    end 
    
    -- 保存sessionid
    if properties and properties.sessionid then
        NetWriter:setSessionID(properties.sessionid)
        -- 存入session
        GSVALUES.sid = properties.sessionid
        
    end

    GS.save(GSVALUES)

    -- 初始化本地基本信息
    NetHelper.initLocalBaseInfo()

    if params and params.lastParam and params.rmId then 
        sendParams[#sendParams + 1] = params.lastParam
        -- 发送请求
        sendRequest(params.rmId + 1)--
    end

end

--[[

-   出现网络错误提示

**Parameters:**

-   text:   string   文本
--]]
local function showneterrcatch(text)
    if SHOWNETERRHANDLE then 
        scheduler.unscheduleGlobal(SHOWNETERRHANDLE)
        SHOWNETERRHANDLE = nil
    end
        
    NetHelper.hideLoading(true)
    local rtext = text or _s("NETWORK_NOT_GOOD")
    if rtext ~= "" then M.QuickToast(rtext) end
    
end

--[[

-   网络错误提示

**Parameters:**

-   flag:   bool    是否即时出现
-   text:   string   文本
-   lv: number 错误等级
--]]
function neterrcatch(flag, text, lv)

    local vlv = lv or RREST_SHOW_UNCOUNT -- 默认为提示但不计数
    if vlv == RREST_IGNORE then  return end -- 直接忽略

    if wrongCount < 5  then 

        -- 记录错误次数
        if  vlv == RREST_SHOW_COUNT or vlv == RREST_UNSHOW_COUNT then 
            wrongCount = wrongCount + 1
        end
        
        -- 弹出提示
        if vlv == RREST_SHOW_UNCOUNT or vlv == RREST_SHOW_COUNT then 
            if flag then 
                showneterrcatch(text)
            else 
                SHOWNETERRHANDLE = util.delayCall(showneterrcatch, 5.0)
            end
        end
    else

        NetHelper.hideLoading(true)
        -- M.QuickToast("网络异常，请重新登录")
        GameHelper.returnToLogin()

        wrongCount = 0 
    end


    
end

--[[

-   获取更新信息

**Parameters:**

-   callback:   function    回调函数
-   event:      table       操作响应
--]]
function onGetUpdateInfo( callback, event )

    try(function ()
            local request = event.request
            -- 处理base64类
            local res = request:getResponseString()
            if res and string.len(res) > 4 then
                -- Log.d(TAG,"res %s",res)
                res = string.sub(res,4)
                -- Log.d(TAG,"res %s",res)
                res = crypto.decodeBase64(res)
                -- Log.d(TAG,"res %s",res)
                -- android方面不知道为什么这里会多几个字符,扣掉吧
                while res ~= "" and not string.endwith(res, "}") do 
                    res = string.sub(res, 0, string.len(res) - 1)
                end
                -- if string.find(res, "}$") == nil then 
                --     res = string.sub(res, 0, string.len(res) - 1)
                -- end
                local tres = json.decode(res)
                if tres and tres.result ~= 10000 then 
                    neterrcatch()
                    -- AlertLayer.new4OK{
                    --     content = "网络不给力，请稍后重试。"
                    -- }
                else 
                    if callback then 
                        callback(tres)
                    end
                end
            end

        end,
        neterrcatch,
        nil)

end

--[[

-   获取服务器列表

**Parameters:**

-   callback:   function    回调函数
-   event:      table       操作响应
-   flag:       number      是否是按钮点击的刷新 1是 0不是
-   errorcallback: function  失败回调方法
--]]
function onGetSerListRequest(callback, event, flag, errorcallback)
    
    try(function ()
        -- 得到请求对象
        local request = event.request
        -- 处理base64类
        local res = request:getResponseString()
        if res then 
            Log.d(TAG,"onGetSerListRequest %s",res)
            local tres = json.decode(res)
            if callback then 
                callback(tres,flag)
            end
        else 
            if isfunction(errorcallback) then
                errorcallback()
            end
            neterrcatch()
        end
    end,
    function (  )
        if isfunction(errorcallback) then
                errorcallback()
        end
        neterrcatch()
    end
    ,
    nil)


end


--[[

-   服务端返回

**Parameters:**

-   callback:   function    回调函数
-   event:      table       操作响应
-   failedCb:   function    错误回调函数
-   cbParams:   table       回调函数参数
--]]
function onRequest( callback, event, failedCb, cbParams )

    -- 设置为可以发送
    CANSENDREQUEST = true
    --if (event.name ~= "completed") then 
--        
--        AlertLayer.new4OK{
--                    btnClickEvent = {
--                        function (  ) 
--                            M.hideLoading(true)
--                        end,
--                    },
--                    content = _s("NETWORK_CONNECT_FAILED2")
--                }
--    end
    -- 得到请求对象
    local request = event.request
    local rs = false

    -- 收到网络消息包时调用此函数进行数据设置
    try(function (  )
        rs = R:pushNetDataStream(request)
    end,
    function (  )
        rs = false
    end,nil)
    
    if rs == false then 
       Log.d(TAG,"请求失败")
       sendRequest( CUR_MSGID + 1) -- msgid + 1 重新发送
       
       -- if #sendParams > 0 then 
       --      table.remove(sendParams,1)
       --  end
       --  -- neterrcatch() -- "rs false"

       -- -- AlertLayer.new4OK{
       -- --      content = "网络不给力，请稍后重试。"
       -- --  }
       -- -- 关闭loading
       --  M.hideLoading(true)
       --  if failedCb then failedCb(0,cbParams) end -- 调用错误回调函数
        return
    end
    -- Log.d(TAG,"===================================rs:%d",rs)

    local result = R:getResult() -- 结果
    Log.d(TAG,"result:%d",result)
    local rmId = R:getRmId() -- return 自增msgId
    Log.d(TAG,"mId:%d",rmId)
    local errMsg = R:getErrMsg() -- 错误信息
    Log.d(TAG,"errMsg:%s",errMsg)
    local actionId = R:getActionID() -- 请求id
    Log.d(TAG,"actionId:%d",actionId)
    local st = R:getStime() -- 获取St时间数据
    Log.d(TAG,"st:%s",st)
    

    -- 请求未认证 被踢下线
    if result == RREST.NET_WCODE_10003 then
        Log.d(TAG,"清除session 重新登录")
        -- 清除session 重新登录
        NetWriter:setSessionID("")
        -- 跳到登录
        -- GameHelper.returnToLogin()

        -- 清除上一个请求但保存下来发到下一个请求去
        local cbParams = {}
        if #sendParams > 0 then 
            cbParams = { lastParam = sendParams[1], rmId = rmId }
            table.remove(sendParams,1)
        end

        -- 登录请求
        NetHelper.createRequest(

            ACTID.MSG_USER_LOGIN,
            callback_login,
            GSVALUES,
            { 
              other = LOGINBASEINFO,
              cbParams = cbParams
            }
        )

        -- if failedCb then failedCb(result,cbParams) end -- 调用错误回调函数
        return
    end
    if result == RREST.NET_WCODE_10004 
        or result == RREST.NET_WCODE_N10003
        then 
        Log.d(TAG,"清除session 重新登录")
        -- 清除session 重新登录
        NetWriter:setSessionID("")
        -- 跳到登录
        sendParams = {}
        GSVALUES = {}
        GSVALUES.moviePlayed = true
        GS.save(GSVALUES)
        LOGINBASEINFO = DEFLOGINBASEINFO
        -- if istest() then 
        --     -- Log.d(TAG,"qingchu+++++++%s",json.encode(GSVALUES))
        --     dump(GSVALUES, "清除")
        -- end
        

        -- 关闭loading
        M.hideLoading(true)
        if failedCb then 
            failedCb(result,cbParams) 
        else
            -- M.QuickToast("网络异常，请稍等几分钟后再重新登录")

            AlertLayer.new4OK( {
                    btnClickEvent = {
                        function (  ) 
                          GameHelper.returnToLogin()
                        end,
                    },
                    content = _s("ACCOUNT_EXCEPTION")
                } )
            
        end -- 调用错误回调函数
        return
    end

    -- 若msg小于之前值 则忽略请求 并且+1
    Log.d(TAG,"~CUR_MSGIDd ~%d ~%d ~%d",CUR_MSGID,RREST.NET_WCODE_N10003,result)
    if CUR_MSGID ~= rmId or result == RREST.NET_WCODE_10005 then 
        Log.d(TAG,"msgid不一致")
        sendRequest( rmId + 1) -- msgid + 1 重新发送
        -- if failedCb then failedCb(result,cbParams) end -- 调用错误回调函数
        return
    end

    if result ~= RREST.Success and actionId ~= ACTID.MSG_HEART_BEAT then 

        local stext = ""
        local rlv = RREST_IGNORE
        try(function (  )
            stext = _s(RREST_TIP[result].code)
            rlv = RREST_TIP[result].lv
        end,nil,nil)
        stext =  stext .. "    "
        if result ~= NET_WCODE_10001 then 
            neterrcatch(true,stext,rlv)
        end
        
        -- print("~~~~~",result,"    ",_s(RREST_TIP[result]))
        -- M.QuickToast(_s(RREST_TIP[result])) --.. "，错误编号：" .. result)
        -- AlertLayer.new4OK{
        --     content = _s(RREST_TIP[result]) .. "，错误编号：" .. result
        -- }

        if #sendParams > 0 then
            table.remove(sendParams,1)
        end

        -- 关闭loading
        M.hideLoading(true)
        if failedCb then failedCb(result,cbParams) end -- 调用错误回调函数
        Log.d(TAG,"请求出错")
        return
    end 

    -- ********************* 请求成功 ***************************
    wrongCount = 0 -- 清空错误次数

    if SHOWNETERRHANDLE then 
        scheduler.unscheduleGlobal(SHOWNETERRHANDLE)
        SHOWNETERRHANDLE = nil
    end

    -- 清除上一个请求
    if #sendParams > 0 then 
        table.remove(sendParams,1)
    end
    -- 清空重发次数
    reSendCount = 0
    -- 发送请求
    sendRequest()

    if actionId ~= 0 then
        --   处理基本信息
        readBaseData()

        if ME:getErrorInfo() ~= "" then
            neterrcatch(true,ME:getErrorInfo())
            -- 关闭loading
            M.hideLoading(true)
            if failedCb then failedCb(result,cbParams) end -- 调用错误回调函数
            Log.d(TAG,"请求出错")
            ME:setErrorInfo("")
            return
        end
    end

    -- 得到具体信息
    local properties
    if  GETDATA["GetData_"..actionId] then
        properties = GETDATA["GetData_" .. actionId]()
        if istest() then 
            Log.d(TAG,"properties:%s",json.encode(properties))
            -- dump(properties, "properties")
        end
    else
        Log.d(TAG,"err:找不到信息处理方法")
    end

    -- 关闭loading
    if CANSENDREQUEST and #sendParams == 0 then
        M.hideLoading()
    end 

    if callback then
        -- 调用回调函数
        Log.d(TAG,"调用回调函数", actionId)
        -- 添加数据缓存
        if game.addCache(actionId, properties) then 
            callback(properties,cbParams)
        end
    else
        Log.d(TAG,"无回调函数")
    end

end

local function onAppCheckRequest(callback, event)
    try(function ()
        -- 得到请求对象
        local request = event.request
        -- 处理base64类
        local res = request:getResponseString()
        if res then 
            Log.d(TAG,"onGetSerListRequest %s",res)
            -- print("504:::",request:getResponseStatusCode())
            if request:getResponseStatusCode() == 504 then 
                if callback then 
                    callback(504)
                end
            else
                local tres = json.decode(res)
                if callback then 
                    callback(tres)
                end    
            end
        else 
            neterrcatch()
        end
    end,
    neterrcatch,
    nil)
end

--[[

-   请求获取苹果验证

**Parameters:**

-   callback:   function    回调函数
--]]
function M.sendAppCheckRequest(callback,params)
    if not network.isInternetConnectionAvailable() then 
        neterrcatch()
        return
    end 

    local rUrl = BASESER_URL .. "/ItunesPayHandle.ashx"

    local request = network.createHTTPRequest(function(event)
        onAppCheckRequest(callback, event)
    end, rUrl,"POST")
    request:addPOSTValue("receipt", params.receipt)
    request:addPOSTValue("isSandbox", params.isSandbox)
    request:addPOSTValue("oId", params.oId)
    request:setTimeout(30)
    -- 发送请求
    request:start()
end

--[[

-   请求获取更新信息

**Parameters:**

-   callback:   function    回调函数
--]]
function M.sendGetUpdateInfo(callback)
    if not network.isInternetConnectionAvailable() then 
        neterrcatch()
        return
    end 

    -- 创建请求
    local param = "serverid=" .. SERVERID .. "&ver=" .. LOGINBASEINFO.cv
    local con = "?"

    -- Log.d(TAG,"param %s",param)
    param = crypto.encodeBase64(param)
    -- Log.d(TAG,"param %s",param)
    local TDNumberUtils                 = require(PH_MDL_UTIL .. "TDNumberUtils")
    local ranstr = 
    {
     "a","b","c","d","e","f","g","h",
     "i","j","k","l","m","n","o","p",
     "q","r","s","d","u","v","w","x",
     "y","z","1","2","3","4","5","6",
     "7","8","9","0","_",
    }
    for i=1,3 do
        local rannum = TDNumberUtils.random(1, #ranstr)
        local ran = ranstr[rannum]
        -- Log.d(TAG," %s",ran)
        param = ran .. param
    end
    -- Log.d(TAG,"param %s",param)
    con = con .. "p="

    local rUrl = SETLISTURL .. con .. param
    -- Log.d(TAG," %s",rUrl)

    -- if not network.isHostNameReachable(rUrl) then 
    --     neterrcatch()
    --     return
    -- end

    local request = network.createHTTPRequest(function(event)
        onGetUpdateInfo(callback, event)
    end, rUrl)
    -- 设置超时时间
    request:setTimeout(10)
    request:addRequestHeader("USER_AGENT1:1003")

    -- 发送请求
    request:start()
end


--[[

-   请求获取服务器列表

**Parameters:**

-   callback:   function    回调函数
-   flag:       number      是否是按钮点击的刷新 1是 0不是
--]]
function M.sendGetSerListRequest(callback,flag)
    if not network.isInternetConnectionAvailable() then
        neterrcatch()
        return
    end 

    local rUrl = SERURL

    -- if not network.isHostNameReachable(rUrl) then 
    --     neterrcatch()
    --     return
    -- end
    local request = network.createHTTPRequest(function(event)
        onGetSerListRequest(callback, event, flag, errorcallback)
    end, rUrl)

    -- 发送请求
    request:start()
end


--[[ 

-   创建http请求

**Parameters:**
-   actionId:    number      请求id
-   callback:    function    回调函数
-   entity:      table       请求信息实体或参数table
-   params: 数组包含
            [必填项]
            [选填项]
        -   other:       table       追加参数
        -   failedCb:    function    错误回调函数
        -   cbParams:    table       回调函数参数
        -   showLoading: bool        是否显示蒙板loading
--]]
function M.createRequest( actionId, callback, entity, params )
    -- 先用缓存数据回调
    game.callbackWithCache(actionId, callback)
    -- 屏蔽网络链接测试
    if CONFIG_WITHOUT_NET_TEST == true then 
        callback()
        return 
    end

    -- 若心跳包没开启，则开启心跳包(请求服务器列表和注册，登录，修改信息时不发)
    if actionId > ACTID.MSG_HEART_BEAT 
      and HEART_BEAT_STATUS_NOJUMP then 
        Log.d(TAG,"开启心跳包")
        HEART_BEAT_STATUS_NOJUMP = false -- 开启后就设置为不用再开了
        HEART_BEAT_HANDLE = scheduler.scheduleGlobal(sendHeartPackage, HEART_BEAT_TIME)
    end
    
    -- 保存本次请求信息
    sendParams[#sendParams + 1] = 
    { actionId = actionId, callback = callback, entity = entity, params = params }

    -- 发送请求
    sendRequest()
end


--[[ 

-   初始化本地基本信息
--]]
function M.initLocalBaseInfo()
    if ISGSVALUES() then 
        -- 初始化基本信息
        local info = 
        {
            userid = GSVALUES.userid,
            userno = GSVALUES.userno,
            name = GSVALUES.name,
            sex = GSVALUES.sex,
            head = GSVALUES.head
        }

        ME:setProperties(info)
    end
end

return M