--[[--

	第三方平台sdk统一管理类
]]


local M = {}

local SdkPlat --平台

if isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE, _GAME.CONFIG.SDK.SDK_APPSTORE_EN, _GAME.CONFIG.SDK.SDK_UCUBE, _GAME.CONFIG.SDK.SDK_APPSTORE_JP) then
	--appstore
	SdkPlat = require("sdk.SdkPlatformApple").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_91) then
	--91
	SdkPlat = require("sdk.SdkPlatform91").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_360) then
	--360
	SdkPlat = require("sdk.SdkPlatform360").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_DJGAME) then
	--点金游戏
	SdkPlat = require("sdk.SdkPlatformDJ").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_XIAOMI) then
	-- 小米平台
	SdkPlat = require("sdk.SdkPlatformXiaomi").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_WANDOUJIA) then
	-- 碗豆荚平台
	SdkPlat = require("sdk.SdkPlatformWdj").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_DUOKU) then
	-- 多酷
	SdkPlat = require("sdk.SdkPlatformDuoku").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_FACEBOOK) then
	-- facebook
	SdkPlat = require("sdk.SdkPlatformFacebook").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_TWITTER) then
	-- twitter
	SdkPlat = require("sdk.SdkPlatformTwitter").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_TWITTERANDFACEBOOK) then
	-- twitter and facebook
	SdkPlat = require("sdk.SdkPlatformFAndT").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_3G) then
	-- 3G
	SdkPlat = require("sdk.SdkPlatform3G").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_MZW) then
	-- 拇指玩
	SdkPlat = require("sdk.SdkPlatformMzw").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_HW) then
	-- 华为
	SdkPlat = require("sdk.SdkPlatformHw").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_DOWNJOY) then
	-- 当乐
	SdkPlat = require("sdk.SdkPlatformDownjoy").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_APPLEYUNDING) then
	--苹果区 云顶充值
	SdkPlat = require("sdk.SdkPlatformYD1").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_JP_PLAY) then
	--日本play
	SdkPlat = require("sdk.SdkPlatformJPPlay").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE_UNALIS) then
	--松岗登陆 支付
	SdkPlat = require("sdk.SdkPlatformUcubeUnalis").new()
elseif isSDK(_GAME.CONFIG.SDK.SDK_UCUBE_PLAY) then
	--松岗登陆 play支付
	SdkPlat = require("sdk.SdkPlatformUcubePlay").new()
else 
	--云顶越狱
	SdkPlat = require("sdk.SdkPlatformYD1").new()
end

--打开商城
function M.storeFirstView(  )
	SdkPlat:storeFirstView( )
end
--打开商城
function M.storeView(  )
	SdkPlat:storeView( )
end

function M.changeObjectClass( className )
	SdkPlat.platformC = className
end

function M.initServerInfo( serverId, serverName, roleId, roleName )
	 
	if isSDK(_GAME.CONFIG.SDK.SDK_YUNDING) or isSDK(_GAME.CONFIG.SDK.SDK_XIAOMI) or isSDK(_GAME.CONFIG.SDK.SDK_360) then 
		SdkPlat:initServerInfo(  serverId, serverName, roleId, roleName )
	end
	if isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE) or isSDK(_GAME.CONFIG.SDK.SDK_APPSTORE_EN) or isSDK(_GAME.CONFIG.SDK.SDK_APPLEYUNDING) then 
		SdkPlat:initServerInfo(  serverId, serverName, roleId, roleName )
	end
end
--登录
function M.login( successCallBack, errorCallBack, argParams )
	SdkPlat:login( successCallBack, errorCallBack, argParams )
end

function M.changeLanguage( successCallBack, errorCallBack, argParams )

	SdkPlat:changeLanguage( successCallBack, errorCallBack, argParams)
end

--切换账号
function M.switchaccount(  successCallBack, errorCallBack, argParams  )
	SdkPlat:switchaccount( successCallBack, errorCallBack, argParams )
end

--91论坛
function M.sb91bbs(  successCallBack, errorCallBack, argParams  )
	SdkPlat:sb91bbs( successCallBack, errorCallBack, argParams )
end

function M.fxFacebookFirst( successCallBack, errorCallBack, argParams )
	-- body
	SdkPlat:fxFacebookFirst( successCallBack, errorCallBack, argParams )
end


--显示或者隐藏工具栏 91 {show = 1}--1为显示  0为隐藏
function M.showOrHidetoolBar( successCallBack, errorCallBack, argParams )
	SdkPlat:showOrHidetoolBar( successCallBack, errorCallBack, argParams )
end
--显示91工具栏
function M.showToolBar( )
	if isSDK(_GAME.CONFIG.SDK.SDK_91) then 
		if isandroid() then
			SdkPlat:showToolBarForAndroid( successCallBack, errorCallBack, argParams )
		else 
			SdkPlat:showOrHidetoolBar( function ( ... )end,
			 function ( ... )
			 	SOUND.setMusicOff()
			    Log.d(TAG,"注销~")
			    sendParams = {}
			    GSVALUES = {}
			    GSVALUES.serverid = SERVERID 
			    GSVALUES.moviePlayed = true
				GS.save(GSVALUES)
				ME.isHelpLoaded = false
				LOGINBASEINFO = DEFLOGINBASEINFO
				Log.d(TAG, "注销+++++++%s",json.encode(GSVALUES))
				GameHelper.returnToLogin()
			end,{show = 1} )
		end
		
	end
end
--隐藏91工具栏
function M.hideToolBar( )
	if isSDK(_GAME.CONFIG.SDK.SDK_91) then
		if isandroid() then
			SdkPlat:hideToolBarForAndroid( successCallBack, errorCallBack, argParams )
		else 
			SdkPlat:showOrHidetoolBar( function ( ... )end, function ( ... )end,{show = 0} )
		end
	end
end

--隐藏91工具栏
function M.showToolBarForAndroid( )
	SdkPlat:showToolBarForAndroid( successCallBack, errorCallBack, argParams )
end

--隐藏91工具栏
function M.hideToolBarForAndroid( )
	SdkPlat:hideToolBarForAndroid( successCallBack, errorCallBack, argParams )
end

--登出
function M.logout( successCallBack, errorCallBack, argParams )
	SdkPlat:logout( successCallBack, errorCallBack, argParams )
end
--退出游戏
function M.exitgame( successCallBack, errorCallBack, argParams )
	SdkPlat:exitgame( successCallBack, errorCallBack, argParams )
end
--商店充值
function M.store( successCallBack, errorCallBack, argParams )
	
    SdkPlat:store( successCallBack, errorCallBack, argParams )
end

function M.setUserInfo( successCallBack, errorCallBack, argParams )
	
	SdkPlat:setUserInfo( successCallBack, errorCallBack, argParams )
end

--[[--
修改信息, 用法和login方法一样,
]]
function M.updateInfo( successCallBack, errorCallBack, argParams )
	SdkPlat:updateInfo( successCallBack, errorCallBack, argParams )
end
--反馈
function M.feedBack()
	SdkPlat:feedBack()
end 

function M.hasCheckSession()
	return SdkPlat.checkSession ~= nil
end
-- 验证session
function M.checkSession( successCallBack, errorCallBack, params )
	if SdkPlat.checkSession then 
		SdkPlat:checkSession( successCallBack, errorCallBack, params )
	end
end

return M