--充值公共类


local Sdkpfbase = class("SdkPlatformBase")

-- local luaM --= require("framework.client.luaoc") --lua 桥接类
-- local platformC                                --第三方原生控制层
-- local shopModel = require("ccb.m.shop.ShopModel")

function Sdkpfbase:ctor( sdkName )

	self.platformC = sdkName or "SdkPlatformController" 	--平台原生sdk代码类
	self.LOGIN = "login"            				--登录
	self.LOGOUT = "logout"          				--注销
	self.EXITGAME = "exitgame"                      --退出游戏
	self.STORE = "store"            				--充值
	self.USERINFO = "userinfo"                      --角色信息
	self.BBS = "SB91bbs"            				--sb91的 论坛
	self.shareinfo = "shareInfo"
	self.FACEBOOKFIRSTSHARE = "firstLoginShare"
	self.TWITTERFIRSTSHARE = "firstLoginShare"
	self.UPDATEINFO = "updateInfo"                  --更新个人信息
	self.SWITCHACCOUNT = "switchaccount" 
	self.FEEDBACK = "showUmengFeedBack" 			--友盟反馈
	self.shopModel = require("ccb.m.shop.ShopModel")--商店游戏服务端
	self.SHOWORHIDEBAR = "showOrHidetoolBar"        --显示或者隐藏工具条
	self.SHOWTOOLBARFORANDROID = "showToolBarForAndroid"		--显示工具条(android)
	self.HIDETOOLBARFORANDROID = "hideToolBarForAndroid"				--隐藏工具条(android)
	self.CHANGELANGUAGE  = "changeLanguage"       --切换语言
	if device.platform == "android" then
	
		self.luaM      = require("framework.client.luaj")       --java
		self.platformC = ANDROID_CLASS_NAME or "com/csgame/card/Card" --com/qeeplay/games/SDKAndroidYDPlatformController"
	elseif device.platform == "ios" or device.platform == "mac" then
	    self.luaM      = require("framework.client.luaoc")      --ios
	end
end

function Sdkpfbase:initServerInfo( serverId, serverName, roleId, roleName )
	if isandroid() then
		local argParams = {
			serverId, serverName, roleId, roleName
		}
		self.luaM.callStaticMethod( self.platformC, "initServerInfo", argParams)
	else
		local argParams = {
			serverid = serverId, servername = serverName, roleid = roleId, rolename = roleName
		}
		self.luaM.callStaticMethod( self.platformC, "initServerInfo", argParams)
	end

end

--充值视图
function Sdkpfbase:storeView(  )
	if GAMERATE:isBuyDiamond() then
		--判断首付
	   	if ME:getFirstpay() == TRUE then 
	   		
	     	-- CCBCenter.loadCCB("MSG_MAINACTIVITYLAYER_MODEL", "ccb.c.main.MainActivityLayer", {showFirshCharge = true,})
	     	CCBCenter.loadCCB("MSG_ACTIVITYFIRSTCHARGELAYER_MODEL", "ccb.c.main.ActivityFirstChargeLayer")
	    else
	    	self:storeFirstView()
	    end
    end
end

function Sdkpfbase:storeFirstView( )
end


function Sdkpfbase:changeLanguage( successCallBack, errorCallBack, argParams )
	Log.d(TAG, "base切换语言: MSG_ID = %s", "切换语言")--  local args = {table(为空不传)}
	self:callStaticMethod(self.CHANGELANGUAGE, successCallBack, errorCallBack, argParams) 
end

function Sdkpfbase:setUserInfo( successCallBack, errorCallBack, argParams )
end


--登录
function Sdkpfbase:login( successCallBack, errorCallBack, argParams )
	Log.d(TAG, "base开始登陆: MSG_ID = %s", "开始")--  local args = {table(为空不传)}
	self:callStaticMethod(self.LOGIN, successCallBack, errorCallBack, argParams) 
end

--退出登陆
function Sdkpfbase:logout( successCallBack, errorCallBack, argParams )
	 Log.d(TAG, "注销: MSG_ID = %s", "灯，等灯，等灯")
	 self:callStaticMethod(self.LOGOUT, successCallBack, errorCallBack, argParams) 
end

--退出游戏
function Sdkpfbase:exitgame( successCallBack, errorCallBack, argParams )
	 Log.d(TAG, "退出游戏...")
	 self:callStaticMethod(self.EXITGAME, successCallBack, errorCallBack, argParams) 
end

--中心
function Sdkpfbase:updateInfo( successCallBack, errorCallBack, argParams )
	argParams = argParams or {}
   	self:callStaticMethod(self.UPDATEINFO, successCallBack, errorCallBack, argParams)
end

--商店
function Sdkpfbase:store( successCallBack, errorCallBack, argParams )
end

function Sdkpfbase:feedBack()
	local sig  = "()Ljava/lang/String;" 
	local ok, ret = self.luaM.callStaticMethod( self.platformC, self.FEEDBACK, {}, sig)
    if ok then
    	-- print("ret = ", ret)
	else
    	-- print("error code = ", ret)
	end 
end

function Sdkpfbase:callStaticMethod(callType , successCallBack, errorCallBack, argParams)
 
	argParams = argParams or {}
	if isSDK(_GAME.CONFIG.SDK.SDK_91) then
		--91的没返回直，关闭不了，不加蒙班
	else
		-- util.enableCustomTouch(display.getRunningScene(),false) --添加游戏蒙板，避免后面ui被点到
	end
	local sig  = "(I)Ljava/lang/String;" --java专用，ios不管
	if argParams and argParams.sig then 
		sig = argParams.sig
		if "" == sig then sig = nil end
	end
	
	local function localSuccess( result )

		-- print("@@@@@@@@@@@@@@@@@ localSuccess SDK返回成功")
		-- util.enableCustomTouch(display.getRunningScene(),true)
		if result and isandroid() then 
			result = json.decode(result)
		end
		successCallBack(result)
	end
	local function localError( result )

		-- print("@@@@@@@@@@@@@@@@@ localError SDK返回失败")
		-- util.enableCustomTouch(display.getRunningScene(),true)
		if result and isandroid() then 
			if result ~= "" then
				result = json.decode(result)
				errorCallBack(result)
			end
		else 
			errorCallBack(result)
		end
	end
	-- if type(argParams) ～= "table" then
	-- 	Log.d(TAG, "不是table啊", "callStaticMethod");
	-- 	argParams = {}
	-- end
	--返回方法
	if isandroid() then 
		local function androidCallback( result )
			-- util.delayCall(function ( ... )
				if result and (result ~= "" and string.find(result, "errorCode") == nil)then
					localSuccess( result )
				else
					localError( result )
				end
			-- end, 1.0)
			
		end
		local argParamsTemp = argParams
		if argParamsTemp and argParamsTemp.params then 
			argParams = argParamsTemp.params
			table.insert(argParams, 1, androidCallback)
		else
			argParams = {androidCallback}
		end
		
		-- store时
		-- if callType == M.STORE then
		-- 	argParams[2] = argParamsTemp.apporderCode or ""
		-- end
	else
		argParams.successMethod = localSuccess
		argParams.errorMethod = localError
	end
	-- print("哈哈哈哈哈哈哈哈")
    local ok, ret = self.luaM.callStaticMethod( self.platformC, callType, argParams, sig)
    if ok then
    	-- print("base ret ", ret)
	else
    	-- print("base error code = ", ret)
	end
end

return Sdkpfbase