local Sdkpfbase = require("sdk.SdkPlatformBase")

local SdkPlatformXiaomi = class("SdkPlatformXiaomi", Sdkpfbase)

function SdkPlatformXiaomi:ctor()
    SdkPlatformXiaomi.super.ctor(self)
    self.key_ = "Tdudlw3Up789asdfgh"
end

--商店视图
function SdkPlatformXiaomi:storeFirstView(  )
	CCBCenter.loadCCB("MSG_SHOPBUYDIAMONDLAYER_MODEL", "ccb.c.shop.ShopBuyDiamondLayer", {})
end

--商店
function SdkPlatformXiaomi:store( successCallBack, errorCallBack, argParams )
	--向服务端获取appordercode,
	local function getAppOrderCodeCallback( entityFriendArr, param )
		NetHelper.showLoading(true)
		argParams.apporderCode = entityFriendArr:getAppordercode() 
	 	--发送appordercode给第三方sdk购买钻石
		if ISGSVALUES() then
	        GSVALUES.ordercode = entityFriendArr:getAppordercode() --保存单号到userinfo
	        GS.save(GSVALUES)
		end
		local function callback_store(  )
			local function checkCallback( event )
				if event and "completed" == event.name then 
					local request = event.request
					local response = request:getResponseString()
					local result = json.decode(response)
					if result.result == RREST.Success then 
						if successCallBack then 
							successCallBack()
						end
					elseif errorCallBack then 
						local res = {
								errorCode = tostring(result.result),
								errorStr = result.desc,
							}
						errorCallBack(res)
					end
				else
					callback_store()
				end
			end
			local p = string.format("orderid=%s&userid=%s", 
				entityFriendArr:getAppordercode(),
				ME:getUserid())
			p = crypto.encodeBase64(crypto.encryptXXTEA(p, self.key_))
			p = string.gsub(p, string.char(10), "")
			local url = BASESER_URL .. "/xiaomi/PayHandle.ashx?p=" .. p
			local request = network.createHTTPRequest(checkCallback, url)
			request:start()
		end

		local function errorCallBack_( result )
			if errorCallBack then 
				errorCallBack(result)
			end
			util.delayCall(function ( ... )
				NetHelper.hideLoading(true)
			end, 1.0)
		end

		NetHelper.hideLoading(true)
		util.delayCall(function ( ... )
			self:callStaticMethod(self.STORE, callback_store, errorCallBack_, {
				sig = "(ILjava/lang/String;ILjava/lang/String;I)V";
				params = {
							entityFriendArr:getAppordercode(), 	-- orderId
							toint(argParams.price), 	-- money
							tostring(argParams.price), -- userInfo
							toint(ME:getLv()) -- lv
						}, 
				}
			)
		end, 0.05)
		-- util.delayCall(callback_store, 3.0)
	end
	--请求单号
	self.shopModel.getSDKIapApporderCode{
		callback = getAppOrderCodeCallback,
 		methodId = ACTID.MSG_BUY_IAP,		 		
 		args = {
 			iid = argParams.iapId , 
 			deviceno = argParams.deviceno , 
 			platform = _GAME.CONFIG.SDK_PLATFORM[1]
 		}
	}
end

function SdkPlatformXiaomi:checkSession( successCallBack, errorCallBack, params )
	params = params or {}
	dump(params)
	local uid, session = params.uid, params.session
	if uid and session then 
		local function checkCallback( event )
			if event and "completed" == event.name then 
				local request = event.request
				local response = request:getResponseString()
				local result = json.decode(response)
				if result.result == RREST.Success then 
					if successCallBack then 
						successCallBack()
					end
				elseif errorCallBack then 
					local res = {
							errorCode = tostring(result.result),
							errorStr = result.desc,
						}
					errorCallBack(res)
				end
			elseif errorCallBack then 
				local res = {
						errorCode = RREST.NET_WCODE_N10001,
						errorStr = _s("NETWORK_NOT_GOOD"),
					}
				errorCallBack(res)
			end
		end
		local p = string.format("uid=%s&session=%s", tostring(uid), session)
		p = crypto.encodeBase64(crypto.encryptXXTEA(p, self.key_))
		p = string.gsub(p, string.char(10), "")
		local url = BASESER_URL .. "/xiaomi/VerifySession.ashx?p=" .. p
		local request = network.createHTTPRequest(checkCallback, url)
		request:start()
	else
		local res = {
						errorCode = RREST.NET_WCODE_N10001,
						errorStr = _s("NETWORK_NOT_GOOD"),
					}
		errorCallBack(res)
	end
end

function SdkPlatformXiaomi:setUserInfo( successCallBack, errorCallBack, argParams )
end

return SdkPlatformXiaomi