--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

场景扩展类，扩展场景相关操作方法及逻辑实现。

-   公共场景扩展定义。

]]

local M = {}



-- [公共参数]
-- 常量

-- 操作变量





-- [工具方法]
-- 扩展
function M.extendRenderDestuctor(target)
    local function handler(event)
        if event == "enter" then
            echoInfo("Scene \"%s:onEnter()\"", target.name or (target.className or "unknown"))
            target:onEnter()
            echoInfo("Node \"%s:viewRender()\"", target.name or (target.className or "unknown"))
            target:viewRender()
        elseif event == "enterTransitionFinish" then
            target:onEnterTransitionFinish()
        elseif event == "exitTransitionStart" then
            target:onExitTransitionStart()
        elseif event == "cleanup" then
            target:onCleanup()
        elseif event == "exit" then
            echoInfo("Scene \"%s:onExit()\"", target.name or (target.className or "unknown"))

            if target.AUTO_CLEANUP_IMAGES then
                for imageName, v in pairs(target.AUTO_CLEANUP_IMAGES) do
                    display.removeSpriteFrameByImageName(imageName)
                end
                target.AUTO_CLEANUP_IMAGES = nil
            end

            target:onExit()
            echoInfo("Scene \"%s:viewDestructor()\"", target.name or (target.className or "unknown"))
            target:viewDestructor()

            if DEBUG_MEM then
                CCTextureCache:sharedTextureCache():dumpCachedTextureInfo()
            end
        elseif event == "cleanup" then
            target:onCleanup()
        end
    end

    target:registerScriptHandler(handler)
end




return M