local M = class( "file" )

function M:ctor( file, pw )
	self.file = file
	self.pw = pw
	self.value = nil
	self:load()
end

function M:load()
	local jsonContent = io.readfile(self.file)
	if jsonContent then 
		self.value = json.decode(jsonContent)
	end
	if table.isnotempty(self.value) then 
		return true
	else
		self.value = {}
		return false
	end
end

function M:save()
	local jsonContent = json.encode(self.value)
	if jsonContent then 
		return io.writefile(self.file, jsonContent, "w")
	end
	return false
end

function M:add( value )
	util.walk(function ( t )
		table.insert(self.value, t)
	end, value)
	self:save()
end

return M