local M = {}
M.TAG = "[richer.model.ModelHelper]"
-- local _dataCache = {}
--[[ 

请求数据

**Parameters:**

-   msgId: 				int 				请求的message id
- 	pageIndex: 			int 				请求的第几页
- 	pageSize: 			int 				页容量
- 	itemsCallback:		fun(items) 			请求到数据后的回调方法

--]]
-- function M.requireData( msgId, pageIndex, pageSize, itemsCallback )
-- 	local category = _s(msgId)
-- 	local function fetchNetItems( pageIndex, itemsCallback )
-- 		if pageIndex > 0 then 
--     		CCBCenter.sendLuaMessage(
-- 		    	msgId, nil, 
-- 		    	{ 
-- 		    		pageIndex = pageIndex, 
-- 		    		callback = function(items) 
-- 		    			-- _dataCache[category][pageIndex] = items
-- 		    			if itemsCallback then 
-- 		    				itemsCallback(items)
-- 		    			end
-- 		    		end,
-- 		    	} 
-- 		    )
--     	end
-- 	end
-- 	-- fetchNetItems(pageIndex, itemsCallback)
-- 	local items
-- 	if not _dataCache[category] or not _dataCache[category][pageIndex] then 
-- 		_dataCache[category] = {}
-- 		fetchNetItems(pageIndex, iff(#_dataCache[category] == 0, itemsCallback, nil))
-- 	else
-- 		items = _dataCache[category][pageIndex]
-- 	end
-- 	--开始预提取数据
-- 	_dataCache[category] = {}
-- 	fetchNetItems(pageIndex - 1)
-- 	if not items then fetchNetItems(pageIndex) end
-- 	fetchNetItems(pageIndex + 1)

-- 	if items and itemsCallback then 
-- 		itemsCallback(items)
-- 	end
-- end

--[[ 

清空数据缓存,若指定cate

**Parameters:**

-   msgId:        int     数据分类,这里是指使用的msgId

--]]
-- function M.clearDataCache( msgId )
-- 	local category = iff(msgId, _s(msgId), nil)
-- 	if category and _dataCache[category] then 
-- 		_dataCache[category] = nil 
-- 	else
-- 		_dataCache = {}
-- 	end
-- end
--*************************************************

--[[ 

请求数据,通过调用Message方式进行数据请求,要求在对应的controller中有对应的方法

**Parameters:**

-   msgId: 				int 				请求的message id
- 	itemsCallback:		fun(items, params) 	请求到数据后的回调方法
- 	params: 			table 				请求的参数

--]]
function M.requireData( msgId, itemsCallback, params )
	Log.a(isnumber(msgId), M.TAG, "requireData() invalid param msgId")
	Log.a(isfunction(itemsCallback), M.TAG, "requireData() invalid param itemsCallback")
	if not params then params = {} end
	params.callback = itemsCallback
	CCBCenter.sendLuaMessage( msgId, nil, params )
end

--[[ 

请求数据,直接调用Model中的指定方法

**Parameters:**

-   modelPath: 			string 				请求的model路径
- 	fn: 				string 				请求的方法名
- 	itemsCallback:		fun(items, params) 	请求到数据后的回调方法
- 	data: 				table 				请求的参数

--]]
function M.requireDataWithFun(modelPath, fn, itemsCallback, data)
	Log.a(isstring(modelPath), M.TAG, "requireDataWithFun() invalid param modelPath")
	Log.a(isstring(fn), M.TAG, "requireDataWithFun() invalid param fn")
	Log.a(isfunction(itemsCallback), M.TAG, "requireDataWithFun() invalid param itemsCallback")
	local m = require(modelPath)
	if m and m[fn] then
		local params = {}
		params.data = data or {}
		params.callback = itemsCallback
		m[fn](params)
	end
end

return M