--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作类[[持续]火]，定义战斗动作相关操作方法及逻辑实现。

-   定义战斗动作方法及成员变量。

]]

local M = class("ActionCtnFire", EffectActionStep2)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [构建参数]
    params._e1Sound             = FA__CTN_FIRE__S1                   -- [声音]
    params._e1Resource          = FA__CTN_FIRE__E1_RES               -- [效果1]资源
    params.e1Z                  = FA__CTN_FIRE__E1_Z                 -- [效果1]Z值
    params.e1Prefix             = FA__CTN_FIRE__E1_PFX               -- [效果1]帧前缀
    params.e1Num                = FA__CTN_FIRE__E1_NUM               -- [效果1]帧数量
    params.e1Interval           = FA__CTN_FIRE__E1_ITV               -- [效果1]帧间隔
    params.e1OffsetStart        = FA__CTN_FIRE__E1_OS                -- [效果1]位移起始
    params.e1OffsetEnd          = FA__CTN_FIRE__E1_OE                -- [效果1]位移结束
    params.aTime1               = FA__CTN_FIRE__T1                   -- [动画]时间1

    params._e2Resource          = FA__CTN_FIRE__E2_RES               -- [效果2]资源
    params.e2Z                  = FA__CTN_FIRE__E2_Z                 -- [效果2]Z值
    params.e2Prefix             = FA__CTN_FIRE__E2_PFX               -- [效果2]帧前缀
    params.e2Num                = FA__CTN_FIRE__E2_NUM               -- [效果2]帧数量
    params.e2Interval           = FA__CTN_FIRE__E2_ITV               -- [效果2]帧间隔
    params.e2OffsetStart        = FA__CTN_FIRE__E2_OS                -- [效果1]位移起始
    params.e2OffsetEnd          = FA__CTN_FIRE__E2_OE                -- [效果2]位移结束
    params.aTime2               = FA__CTN_FIRE__T2                   -- [动画]时间2
    params.isSustained          = FA__CTN_FIRE__ISSUSTAINED          -- [效果]持续标识（如果持续，则播放至目标位置后动画不进行消除）
    params.isRecord             = true                               -- [效果]是否记录
    params.recordTag            = ActionEnum.CTN_FIRE                -- [效果]动作记录标识



    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._node                  = self._nodeUp                      -- 目标结点
    self._e2Z                   = params.e2Z                        -- [效果2]Z值
    self._e2Prefix              = params.e2Prefix                   -- [效果2]帧前缀
    self._e2Num                 = params.e2Num                      -- [效果2]帧数量
    self._e2Interval            = params.e2Interval                 -- [效果2]帧间隔
end




    





-- [实例方法]
-- [实例方法][资源]
-- 获得预加载的资源[图片]
function M:getResourcesImage(params)
    return {
        params._e1Resource,
        params._e2Resource,
    }
end


---------


-- [实例方法][方法覆写]
-- 处理效果结束后的逻辑
-- function M:onCompletedEffect()
--     -- [构建实体]
--     -- 定义配置参数
--     local params = {
--         fileName    = "#" .. TDAnimationUtils.frameNameAtFirst(self._e2Prefix),        -- 文件名
--         parentNode  = self:getNode(),                                   -- 父结点
--         align       = display.CENTER,                                   -- 对齐方式
--         anchor      = display.CENTER,                                   -- 锚点
--         z           = self._e2Z,                                        -- 层深度
--     }
--     -- 生成精灵
--     local mask = TDUIUtils.loadSprite(params)

--     -- 存储状态
--     local actions = self._node:getActions()
--     if actions[ActionEnum.CTN_FIRE]  ~= nil then
--         local effects = actions[ActionEnum.CTN_FIRE]
--         for k in pairs(effects) do
--             effects[k]:removeFromParentAndCleanup(true)
--         end
--     end
--     actions[ActionEnum.CTN_FIRE] = { [1] = mask, [2] = self:getEffectAction(2, 2), }


--     -- [构建动作]
--     local actionParams  = {
--         prefix      = self._e2Prefix,
--         frameCount  = self._e2Num,
--         interval    = self._e2Interval,
--     }
--     local action        = TDAnimationUtils.animateWithFrameRepeat(actionParams)
--     mask:runAction(action)
-- end


---------


-- [实例方法][外部调用]
-- ..


-- [实例方法][属性Getter/Setter]
-- ..





return M