--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作类[[持续]撕裂]，定义战斗动作相关操作方法及逻辑实现。

-   定义战斗动作方法及成员变量。

]]

local M = class("ActionCtnTear", EffectActionStep1)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [构建参数]
    params._e1Resource          = FA__CTN_TEAR__E1_RES               -- [效果1]资源
    params._e1Sound             = FA__CTN_TEAR__S1                   -- [声音]
    params.e1Z                  = FA__CTN_TEAR__E1_Z                 -- [效果1]Z值
   -- params.e1Prefix             = FA__CTN_TEAR__E1_PFX               -- [效果1]帧前缀
    params.e1Num                = FA__CTN_TEAR__E1_NUM               -- [效果1]帧数量
    params.e1Interval           = FA__CTN_TEAR__E1_ITV               -- [效果1]帧间隔
    params.e1OffsetStart        = FA__CTN_TEAR__E1_OS                -- [效果1]位移起始
    params.e1OffsetEnd          = FA__CTN_TEAR__E1_OE                -- [效果1]位移结束
    params.isSustained          = FA__CTN_TEAR__E1_STN               -- [动画]持续标识
    params.aTime1               = FA__CTN_TEAR__T1                   -- [动画]时间1
    params.isRecord             = true                               -- [效果]是否记录
    params.recordTag            = ActionEnum.CTN_TEAR                -- [效果]动作记录标识



    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._node                  = self._nodeUp                      -- 目标结点
    self._recordTag             = ActionEnum.CCL_TEAR
end



-- [覆写方法]
-- 运行动作
function M:buildAction(params)
     --local time              = self._e1Interval * self._e1Num
    -- [效果]
    if true then 
        -- [目标对象]（血量）
        local target = self._node 

        -- [构建实体]
        -- [效果][起始动画]
        local _e1Resource       = self._e1Resource                                -- 帧前缀
        local frameCount        = self._e1Num                                   -- 动画帧数
        local interval          = self._e1Interval                              -- 帧间隔
        local z                 = self._e1Z                                     -- 层深度
        local params            = {
            prefix      = prefix,
            frameCount  = frameCount,
            interval    = interval,
        }

        local action =  display.newSprite(_e1Resource)


        -- 定义配置参数
        local paramsCtor = {
           -- fileName    = "#" .. TDAnimationUtils.frameNameAtFirst(prefix),     -- 文件名
            parentNode  = target,                                               -- 父结点
            align       = display.CENTER,                                       -- 对齐方式
            anchor      = display.CENTER,                                       -- 锚点
            z           = z,                                                    -- 层深度
            offset      = FA_E_BLOOD_O,                                         -- 效果偏移量
        }
        -- 生成精灵
        local effect =  display.newSprite(self:pathResource(FA__CTN_TEAR__E1_RES)..".png")
        target:removeChildByTag(z, true)
        target:addChild(effect,z,z)
        util.alignNode(effect, target)

        -- [动画定义]
        local delay             = self:T(self._e1Delay)                             -- 延迟时间
        local time              = self._e1Interval * self._e1Num                    -- 时间
        local positionOrigin    = ccp(action:getPosition())                         -- 位置[原]
        local positionStart     = ccpAdd(positionOrigin, self._e1OffsetStart)       -- 位置[起始]
        local positionEnd       = ccpAdd(positionOrigin, self._e1OffsetEnd)         -- 位置[结束]
        effect:setVisible(true)
       -- effect:setPosition(positionStart)

        -- local function onComplete()
        --    -- target:animateHp(self._curHp)
        --     effect:removeFromParentAndCleanup(true)
        -- end

        


        if delay == 0 then 

         --   effect:runAction(CCRepeatForever:create(transition.sequence(array)))
            effect:runAction(CCRepeatForever:create(transition.sequence{
                CCFadeTo:create(time * 20,50),
                CCFadeTo:create(time * 20,255),
            }))
        else

            effect:runAction(TDAnimationUtils.sequence({ effect, CCDelayTime:create(delay) }))
            effect:runAction(TDAnimationUtils.sequence({
                CCDelayTime:create(delay),
                 CCFadeTo:create(time,50),
                 CCFadeTo:create(time,255),
                --CCMoveTo:create(time, positionEnd),             -- move 
               -- CCCallFunc:create(onComplete),
            }))
        end
        local actions = self:getNode():getActions()
        actions[self._recordTag] = { [1] = effect, }
    end

    -- local array     = {}
    -- array[#array + 1] = CCFadeTo:create(time,50)
    -- array[#array + 1] = CCFadeTo:create(time,255)

    -- [卡片]
    local action

    -- 动画参数
    local time1             = self:T(self._aTime1)                  -- [动画]时间1


    -- 构建动作对象
    action = transition.sequence({
        -- CCFadeTo:create(time,50),
        -- CCFadeTo:create(time,255),
        CCCallFunc:create(function() self:playSound() end),         -- play effect
        CCDelayTime:create(time1),                  -- delay
    })

    return action
end
    





-- [实例方法]
-- [实例方法][外部调用]
-- ..


-- [实例方法][属性Getter/Setter]
-- ..





return M