--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作类[[伤害]电]，定义战斗动作相关操作方法及逻辑实现。

-   定义战斗动作方法及成员变量。

]]

local M = class("ActionHurtElectric", EffectActionStep1)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [构建参数](1.0 / 24)
    params._e1Resource          = FA__HURT_ELECTRIC__E1_RES               -- [效果1]资源
    params._e1Sound             = FA__HURT_ELECTRIC__S1                   -- [声音1]
    params.e1Z                  = FA__HURT_ELECTRIC__E1_Z                 -- [效果1]Z值
    params.e1Prefix             = FA__HURT_ELECTRIC__E1_PFX               -- [效果1]帧前缀
    params.e1Num                = FA__HURT_ELECTRIC__E1_NUM               -- [效果1]帧数量
    params.e1Interval           = FA__HURT_ELECTRIC__E1_ITV               -- [效果1]帧间隔
    params.e1OffsetStart        = FA__HURT_ELECTRIC__E1_OS                -- [效果1]位移起始
    params.e1OffsetEnd          = FA__HURT_ELECTRIC__E1_OE                -- [效果1]位移结束
    params.aTime1               = FA__HURT_ELECTRIC__T1                   -- [动画]时间1



    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._node                  = self._nodeUp                      -- 目标结点
end



-- 构建卡片动作对象
function M:buildActionCard(params) 
    -- 定义动作对象
    local action = nil

-- print("ActionHurtNormal受伤害")

    -- 辅助参数
    local originScale       = self:getNode():getScale()                 -- 原始缩放比例
    local positionOrigin    = ccp(self:getNode():getPosition()) 
    -- 动画参数
   local position4         = self:P(positionOrigin)                    -- [动画]位置4



   

    local pointL = ccp(positionOrigin.x - 7, positionOrigin.y)
    local pointR = ccp(positionOrigin.x + 7, positionOrigin.y)

    local pointU7 = ccp(positionOrigin.x, positionOrigin.y + 15)
    local pointD7 = ccp(positionOrigin.x, positionOrigin.y - 15)
    local pointU6 = ccp(positionOrigin.x, positionOrigin.y + 10)
    local pointD6 = ccp(positionOrigin.x, positionOrigin.y - 10)
    local pointU5 = ccp(positionOrigin.x, positionOrigin.y + 7)
    local pointD5 = ccp(positionOrigin.x, positionOrigin.y - 7)
    local pointU4 = ccp(positionOrigin.x, positionOrigin.y + 5)
    local pointD4 = ccp(positionOrigin.x, positionOrigin.y - 5)
    local pointU3 = ccp(positionOrigin.x, positionOrigin.y + 2)
    local pointD3 = ccp(positionOrigin.x, positionOrigin.y - 2)


    -- 位置重排
    local isChange = self:handleViewSwitch()
    -- 构建动作对象
    action = TDAnimationUtils.sequence({
        CCDelayTime:create(isChange and FA__BASE_CORRECT__T or 0),
        CCCallFunc:create(function() self:playSound() end),     -- 播放音效
        -- CCCallFunc:create(onHurtColor),                         -- 伤害颜色
        -- CCScaleTo:create(0.05, 0.95),                        -- scale -
        
        CCMoveTo:create(0.03, pointU7), --上
        CCMoveTo:create(0.03, pointD7), --下
        CCMoveTo:create(0.03, pointU6), --上
        CCMoveTo:create(0.03, pointD6), --下
        CCMoveTo:create(0.03, pointU5), --上
        CCMoveTo:create(0.03, pointD5), --下
        CCMoveTo:create(0.03, pointU4), --上
        CCMoveTo:create(0.03, pointD4), --下
        CCMoveTo:create(0.03, pointU3), --上
        CCMoveTo:create(0.03, pointD3), --下
        -- CCMoveTo:create(0.02, pointL), --左
        -- CCMoveTo:create(0.02, pointR),  --右
        
        
        CCMoveTo:create(0.02, position4), 
        -- CCScaleTo:create(0.05, 1),                        -- scale +
        -- 
       
    })
    




    return action
end
    





-- [实例方法]
-- [实例方法][外部调用]
-- ..


-- [实例方法][属性Getter/Setter]
-- ..





return M