--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作类[[其他]召唤]，定义战斗动作相关操作方法及逻辑实现。

-   定义战斗动作方法及成员变量。

]]

local M = class("ActionOthSummon", EffectActionStep1)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [构建参数]
    params._e1Resource          = FA__OTH_SUMMON__E1_RES               -- [效果1]资源
    params._e1Sound             = FA__OTH_SUMMON__S1                   -- [声音]
    params.e1Z                  = FA__OTH_SUMMON__E1_Z                 -- [效果1]Z值
    params.e1Prefix             = FA__OTH_SUMMON__E1_PFX               -- [效果1]帧前缀
    params.e1Num                = FA__OTH_SUMMON__E1_NUM               -- [效果1]帧数量
    params.e1Interval           = FA__OTH_SUMMON__E1_ITV               -- [效果1]帧间隔
    params.e1OffsetStart        = FA__OTH_SUMMON__E1_OS                -- [效果1]位移起始
    params.e1OffsetEnd          = FA__OTH_SUMMON__E1_OE                -- [效果1]位移结束
    params.aTime1               = FA__OTH_SUMMON__T1                   -- [动画]时间1



    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._node                  = self._nodeDown                        -- 目标结点
end




    





-- [实例方法]
-- [实例方法][外部调用]
-- ..


---------


-- [实例方法][卡片]
-- 构建卡片动作对象
function M:buildActionCard(params)
    local action


    local delay             = self:T(.3)
    local time              = self:T(.3)
    local prototype         = self._prototypes:getPrototype(self._index)    -- 原型对象
    local position          = prototype:getPosition()                       -- [动画]目标位置
    local rotation          = prototype:getRotation()                       -- [动画]目标旋转角度
    local scale             = prototype:getScale()                          -- [动画]目标缩放比例


    -- 上浮卡牌
    local function floatCard()
        self._node:setVisible(true)
        self._node:float()
    end

    -- [加载超类函数]
    action = TDAnimationUtils.sequence({
        CCCallFunc:create(floatCard),
        M.super.buildActionCard(self, params),                  
        CCDelayTime:create(delay),                         -- 伤害颜色
        TDAnimationUtils.spawn({
            CCMoveTo:create(time, position),                -- 位移
            CCRotateTo:create(time, rotation),              -- 旋转角度
            CCScaleTo:create(time, scale),                  -- 缩放比例
        }),
        CCCallFunc:create(function()
            self._node:reset()
        end),
    })

    return action
end


-- [实例方法][属性Getter/Setter]
-- ..





return M