--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作类[[系统]游戏结束]，定义战斗动作相关操作方法及逻辑实现。

-   定义动作方法及成员变量。

]]

local M = class("ActionSystemGameOver", AbstractAction)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._result            = params.result                                     -- 战斗结果
end

    

    





-- [抽象方法]
-- 运行动作
function M:buildAction(params)
    -- 定义动作对象
    local action = nil



    -- 辅助变量
    local isGameOver    = self._result:getRes() ~= 0
    local view          = self._node:getParent():getParent()  -- 视图



    -- 定义函数
    -- 游戏结束判定
    local function onJudge()
        -- 判断游戏结束
        if isGameOver then 
            -- print("2222222222222222222222222")
            if self._result:getFlag() >= 1 then
                -- 重置战斗数据
                view:resetData()
                -- 判断是否存在战斗数据，如果存在，则继续解析战斗逻辑，否则设置状态为交互模式，等待玩家操作
                if view:getData() ~= nil then 
                    -- print("再来战斗")
                    -- 解析战斗逻辑
                    view:fight()
                else
                    -- 设置交互状态
                    view:setInteractive(true)
                end
            else 
                -- print("游戏结束")
                -- 游戏结束
                view:gameOver()    
            end
            
        else
            -- print("11111111111111111111111111")
            -- 重置战斗数据
            view:resetData()
            -- 判断是否存在战斗数据，如果存在，则继续解析战斗逻辑，否则设置状态为交互模式，等待玩家操作
            if view:getData() ~= nil then 
                -- 解析战斗逻辑
                view:fight()
            else
                -- 设置交互状态
                view:setInteractive(true)
            end
        end
    end

    -- 定义动作
    action = CCCallFunc:create(onJudge)

    return action
end




    





-- [实例方法]
-- [实例方法][外部调用]
-- ..



-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- [加载超类函数]
    M.super.assertParameters(self, params)
end



-- [实例方法][属性Getter/Setter]
-- ..





return M