--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

效果卡片动作[消除]，定义效果卡片动作相关操作方法及逻辑实现。

-   定义效果卡片动作方法及成员变量。

]]

local M = class("EffectActionEliminate", AbstractFightAction)



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [加载超类构造函数]
    M.super.ctor(self, params)



    -- [参数赋值]
    self._node                  = self._nodeUp                                          -- 目标结点
    self._tagEliminate          = self:getTagEliminate()                                -- 消除标识


    -- 具体操作
    -- ..
end

    

    





-- [抽象方法]
-- 获得消除标识
function M:getTagEliminate()
    TDExceptionUtils.raiseUnRunHereException("EffectActionEliminate:getTagEliminate()")
    return -1
end


    

    





-- [覆写方法]
-- 运行动作
function M:buildAction(params)
    -- 定义动作对象
    local action = nil



    -- 辅助参数
    local target            = self._node                                -- 目标结点
    local eliminateTag      = self._tagEliminate                        -- 消除标识
    local actionsWhole      = target:getActions()                       -- 目标动作集[总]
    local effects           = actionsWhole[eliminateTag]                -- 目标效果集



    -- 位置重排
    -- local isChange = self:handleViewSwitch()
    -- 构建动作对象
    action = TDAnimationUtils.sequence({
        -- CCDelayTime:create(isChange and FA__BASE_CORRECT__T or 0),
        CCCallFunc:create(function()
            if TDArrayUtils.isNotEmpty(effects) then
                for k in pairs(effects) do
                    effects[k]:removeFromParentAndCleanup(true)
                end
            end
        end),              -- eliminate nodes
    })



    return action
end




    





-- [实例方法]
-- [实例方法][外部调用]
-- ..


-- [实例方法][属性Getter/Setter]
-- ..





return M