--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

动作类命名映射类，定义动作类命名映射相关操作方法及逻辑实现。

-   定义动作类命名映射方法及成员变量。

]]

local M = {
    
    -- [舞台]上场
    ["ActionStageUp"] = "[舞台]上场",
    -- [舞台]下场
    ["ActionStageDown"] = "[舞台]下场",
    -- [舞台]复活
    ["ActionStageRevival"] = "[舞台]复活",
    -- [舞台]死亡
    ["ActionStageDeath"] = "[舞台]死亡",
    -- [舞台]上手牌
    ["ActionStageHand"] = "[舞台]上手牌",

    -- [攻击]普通
    ["ActionAtkNormal"] = "[攻击]普通",
    -- [攻击]火
    ["ActionAtkFire"] = "[攻击]火",
    -- [攻击]冰
    ["ActionAtkIce"] = "[攻击]冰",
    -- [攻击]电
    ["ActionAtkElectric"] = "[攻击]电",
    -- [攻击]血
    ["ActionAtkBlood"] = "[攻击]血",
    -- [攻击]毒
    ["ActionAtkPoison"] = "[攻击]毒",
    -- [攻击]光
    ["ActionAtkBright"] = "[攻击]光",
    -- [攻击]暗
    ["ActionAtkDark"] = "[攻击]暗",
    -- [攻击]狙击
    ["ActionAtkSniper"] = "[攻击]狙击",
    -- [攻击]陷阱
    ["ActionAtkTrap"] = "[攻击]陷阱",
    -- [攻击]封印
    ["ActionAtkSeal"] = "[攻击]封印",
    -- [攻击]撕裂
    ["ActionAtkTear"] = "[攻击]撕裂",
    -- [攻击]横扫
    ["ActionAtkSweepAway"] = "[攻击]横扫",
    -- [攻击]横扫
    ["ActionAtkSpike"] = "[攻击]秒杀",
    -- [攻击]隐盾
    ["ActionAtkStealth"] = "[攻击]隐盾",

    -- [伤害]普通
    ["ActionHurtNormal"] = "[伤害]普通",
    -- [伤害]火
    ["ActionHurtFire"] = "[伤害]火",
    -- [伤害]冰
    ["ActionHurtIce"] = "[伤害]冰",
    -- [伤害]电
    ["ActionHurtElectric"] = "[伤害]电",
    -- [伤害]血
    ["ActionHurtBlood"] = "[伤害]血",
    -- [伤害]毒
    ["ActionHurtPoison"] = "[伤害]毒",
    -- [伤害]光
    ["ActionHurtBright"] = "[伤害]光",
    -- [伤害]暗
    ["ActionHurtDark"] = "[伤害]暗",
    -- [伤害]狙击
    ["ActionHurtSniper"] = "[伤害]狙击",
    -- [伤害]陷阱
    ["ActionHurtTrap"] = "[伤害]陷阱",
    -- [伤害]封印
    ["ActionHurtSeal"] = "[伤害]封印",
    -- [伤害]撕裂
    ["ActionHurtTear"] = "[伤害]撕裂",
    -- [伤害]横扫
    ["ActionHurtSweepAway"] = "[伤害]横扫",
    -- [伤害]横扫
    ["ActionHurtSpike"] = "[伤害]秒杀",
    -- [伤害]隐盾
    ["ActionHurtStealth"] = "[伤害]隐盾",

    -- [增效]血
    ["ActionIncBlood"] = "[增效]血",
    -- [增效]攻击
    ["ActionIncAttack"] = "[增效]攻击",
    -- [增效]暴击
    ["ActionIncCrit"] = "[增效]暴击",

    -- [减效]血
    ["ActionDecBlood"] = "[减效]血",
    -- [减效]物理
    ["ActionDecAttack"] = "[减效]物理",
    -- [减效]魔法
    ["ActionDecMagic"] = "[减效]魔法",

    -- [固定]血
    ["ActionFixBlood"] = "[固定]血",
    -- [固定]攻击
    ["ActionFixAttack"] = "[固定]攻击",

    -- [反弹]血[+]
    ["ActionRebBloodUp"] = "[反弹]血[+]",
    -- [反弹]血[-]
    ["ActionRebBloodDown"] = "[反弹]血[-]",
    -- [反弹]攻击
    ["ActionRebAttack"] = "[反弹]攻击",
    -- [反弹]魔法
    ["ActionRebMagic"] = "[反弹]魔法",
    -- [反弹]火
    ["ActionRebFire"] = "[反弹]火",

    -- [其他]克制
    ["ActionOthRestraint"] = "[其他]克制",
    -- [其他]横扫
    ["ActionOthSweepAway"] = "[其他]横扫",
    -- [其他]自爆
    ["ActionOthSelfBomb"] = "[其他]自爆",
    -- [其他]免疫(全)
    ["ActionOthImmunityAll"] = "[其他]免疫(全)",
    -- [其他]免疫(魔法)
    ["ActionOthImmunityMagic"] = "[其他]免疫(魔法)",
    -- [其他]秒杀
    ["ActionOthSpike"] = "[其他]秒杀",
    -- [其他]撕裂
    ["ActionOthTear"] = "[其他]撕裂",
    -- [其他]MISS
    ["ActionOthMiss"] = "[其他]MISS",
    -- [其他]鼓舞加血
    ["ActionOthEncouragedBlood"] = "[其他]鼓舞加血",
    -- [其他]鼓舞加攻
    ["ActionOthEncouragedAttack"] = "[其他]鼓舞加攻",
    -- [其他]召唤
    ["ActionOthSummon"]  = "[其他]召唤",
    ["ActionOthSummon2"] = "[其他]召唤",

    -- [持续]普通
    ["ActionCtnNormal"] = "[持续]普通",
    -- [持续]火
    ["ActionCtnFire"] = "[持续]火",
    -- [持续]冰
    ["ActionCtnIce"] = "[持续]冰",
    -- [持续]电
    ["ActionCtnElectric"] = "[持续]电",
    -- [持续]血
    ["ActionCtnBlood"] = "[持续]血",
    -- [持续]毒
    ["ActionCtnPoison"] = "[持续]毒",
    -- [持续]光
    ["ActionCtnBright"] = "[持续]光",
    -- [持续]暗
    ["ActionCtnDark"] = "[持续]暗",
    -- [持续]狙击
    ["ActionCtnSniper"] = "[持续]狙击",
    -- [持续]陷阱
    ["ActionCtnTrap"] = "[持续]陷阱",
    -- [持续]封印
    ["ActionCtnSeal"] = "[持续]封印",
    -- [持续]撕裂
    ["ActionCtnTear"] = "[持续]撕裂",
    -- [持续]隐盾
    ["ActionCtnStealth"] = "[持续]隐盾",

    -- [解除]普通
    ["ActionCclNormal"] = "[解除]普通",
    -- [解除]火
    ["ActionCclFire"] = "[解除]火",
    -- [解除]冰
    ["ActionCclIce"] = "[解除]冰",
    -- [解除]电
    ["ActionCclElectric"] = "[解除]电",
    -- [解除]血
    ["ActionCclBlood"] = "[解除]血",
    -- [解除]毒
    ["ActionCclPoison"] = "[解除]毒",
    -- [解除]光
    ["ActionCclBright"] = "[解除]光",
    -- [解除]暗
    ["ActionCclDark"] = "[解除]暗",
    -- [解除]狙击
    ["ActionCclSniper"] = "[解除]狙击",
    -- [解除]陷阱
    ["ActionCclTrap"] = "[解除]陷阱",
    -- [解除]封印
    ["ActionCclSeal"] = "[解除]封印",
    -- [解除]隐盾
    ["ActionCclStealth"] = "[解除]隐盾",

    -- [英雄]扣血
    ["ActionHHurtBlood"] = "[英雄]扣血",
    -- [英雄]增血
    ["ActionHIncBlood"] = "[英雄]增血",
    -- [英雄]扣血
    ["ActionHDecBlood"] = "[英雄]扣血",



    -- [操作]
    -- [操作]数值
    ["ActionOptValue"] = "[操作]数值",



    -- [系统]
    -- [系统]切换回合
    ["ActionSystemTurnRound"] = "[系统]切换回合",
    -- -- [系统]过渡延迟
    ["ActionSystemDelay"] = "[系统]过渡延迟",
    -- -- [系统]重新排列位置
    ["ActionSystemRearrangePositions"] = "[系统]重新排列位置",
    -- -- [系统]校正冷却时间
    ["ActionSystemCorrectCD"] = "[系统]校正冷却时间",
    -- -- [系统]状态刷新
    ["ActionSystemStateRenew"] = "[系统]状态刷新",
    -- -- [系统]游戏结束
    ["ActionSystemGameOver"] = "[系统]游戏结束",
}





return M