--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

动作扩展门面类，定义动作扩展解释相关操作方法及逻辑实现。

-   定义动作扩展门面方法及成员变量。

]]

local M = {}



-- [包含文件]
-- ..


-- [操作变量]
-- ..


-- [公共参数]
-- [常量]
-- ..

    

    





-- [扩展方法]
-- 扩展定位接口，使卡动作扩展位置集定位方式
function M.extendLocation(o, params)
    -- 验证参数合法性
    -- 验证是否拥有setPositionStart & setPositionEnd方法


	-- 参数赋值
    o._indexStart      		= params.indexStart         or 0                        -- 索引[起始]
    o._indexEnd        		= params.indexEnd           or 0                        -- 索引[结束]



	-- [实例方法]
	-- [实例方法][属性Getter/Setter]
	-- 设置索引[起始]
	function o:setIndexStart(index)
	    self._indexStart = index
	end
	-- 获得索引[起始]
	function o:getIndexStart()
	    return self._indexStart
	end

	-- 设置索引[结束]
	function o:setIndexEnd(index)
	    self._indexEnd = index
	end
	-- 获得索引[结束]
	function o:getIndexEnd()
	    return self._indexEnd
	end



    -- [具体操作]
    -- 设置坐标[起始]
    o:setPositionStart(o._positions[o._indexStart])
    -- 设置坐标[结束]
    o:setPositionEnd(o._positions[o._indexEnd])
end





return M