--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

卡牌玩家类，定义卡牌玩家相关操作方法及逻辑实现。

-   存储卡牌玩家相关信息。

]]

local M = class("CardPlayer")

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    self._heroHp                        = params.heroHp                                     -- 英雄血量
    self._cards                         = params.cards                      or {}           -- 卡片集
    self._prototypes                    = params.prototypes                 or {}           -- 原型集
end










-- [实例方法]
-- [实例方法][外部调用]
-- ..


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    TDAssertUtils.assertParameters(params)
end


---------


-- [实例方法][属性Getter/Setter]
-- 获得英雄血量
function M:getHeroHp()
    return self._heroHp
end
-- 设置英雄血量
function M:setHeroHp(hp)
    self._heroHp = hp
end

-- 获得卡片集
function M:getCards()
    return self._cards
end
-- 设置卡片集
function M:setCards(cards)
    self._cards = cards
end

-- 获得原型集
function M:getPrototypes()
    return self._prototypes
end
-- 设置原型集
function M:setPrototypes(prototypes)
    self._prototypes = prototypes
end



return M