--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

卡牌原型类，定义卡牌原型相关操作方法及逻辑实现。

-   存储卡牌原型相关信息。

]]

local M = class("CardPrototype")



-- [包含文件]
-- ...



-- [公共参数]
-- [常量]
-- .. 


-- [操作变量]
-- ..


-- [枚举]
-- ..










-- [私有方法声明]
-- [实例方法][视图渲染]
-- ..
-- [视图析构]
-- ..

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    self._position                      = params.position                   or P_ZERO       -- 位置
    self._scale                         = params.scale                      or 1            -- 缩放比例
    self._rotation                      = params.rotation                   or 0            -- 旋转角度
end










-- [实例方法]
-- [实例方法][外部调用]
-- 属性注入
function M:inject(card)
    -- 位置
    card:setPosition(self._position)
    -- 缩放比例
    card:setScale(self._scale)
    -- 旋转角度
    card:setRotation(self._rotation)
end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    TDAssertUtils.assertParameters(params)
end


---------


-- [实例方法][属性Getter/Setter]
-- 获得位置
function M:getPosition()
    return self._position
end
-- 设置位置
function M:setPosition(position)
    self._position = position
end

-- 获得缩放比例
function M:getScale()
    return self._scale
end
-- 设置缩放比例
function M:setScale(scale)
    self._scale = scale
end

-- 获得旋转角度
function M:getRotation()
    return self._rotation
end
-- 设置旋转角度
function M:setRotation(rotation)
    self._rotation = rotation
end



return M