--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

卡牌原型集类，定义卡牌原型集相关操作方法及逻辑实现。

-   存储卡牌原型集相关信息。

]]

local M = class("CardPrototypeSet")



-- [包含文件]
-- ...



-- [公共参数]
-- [常量]
-- .. 


-- [操作变量]
-- ..


-- [枚举]
-- ..










-- [私有方法声明]
-- [实例方法][视图渲染]
-- ..
-- [视图析构]
-- ..

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    self._prototypes                = params.prototypes                 or {}       -- 原型集
    self._positions                 = {}                                            -- 位置集
    self._rotations                 = {}                                            -- 旋转角度集
    self._scales                    = {}                                            -- 缩放比例集



    -- [具体操作]
    -- 校正原型信息
    self:correct()
end










-- [实例方法]]
-- [实例方法][外部调用]
-- 校正原型信息
function M:count()
    return #self._prototypes
end


---------


-- [实例方法][内部调用]
-- 校正位置集
function M:correct()
    -- 校正位置集
    self:correctPositions()
    -- 校正旋转角度集
    self:correctRotations()
    -- 校正缩放比例集
    self:correctScales()
end

-- 校正位置集
function M:correctPositions()
    if self:notEmpty(_prototypes) then 
        for i,v in pairs(_prototypes) do
            self._positions[i] = self._prototypes[i]:getPosition()
        end
    end
end
-- 校正旋转角度集
function M:correctRotations()
    if self:notEmpty(_prototypes) then 
        for i,v in pairs(_prototypes) do
            self._rotations[i] = self._prototypes[i]:getRotation()
        end
    end
end
-- 校正缩放比例集
function M:correctScales()
    if self:notEmpty(_prototypes) then 
        for i,v in pairs(_prototypes) do
            self._scales[i] = self._prototypes[i]:getScale()
        end
    end
end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)

end


---------


-- [实例方法][辅助方法]
function M:notEmpty(set)
    return set ~= nil and #set > 0
end


---------


-- [实例方法][属性Getter/Setter]
-- 获得原型
function M:getPrototype(index)
    return self._prototypes[index]
end

-- 获得原型集
function M:getPrototypes()
    return self._prototypes
end
-- 设置原型集
function M:setPrototypes(set)
    self._prototypes = set
    self:correct()
end

-- 获得位置集
function M:getPositions()
    return self._positions
end
-- 获得旋转角度
function M:getRotations()
    return self._rotations
end
-- 获得缩放比例
function M:getScales()
    return self._scales
end





return M