
--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动画类枚举，定义战斗动画类枚举相关操作方法及逻辑实现。

-   存储战斗动画类枚举相关信息。

]]
local M = {}


-- [舞台]上场
M.STAGE_UP      		=  1; M.UP_STAGE      			=  1
-- [舞台]下场
M.STAGE_DOWN     		=  2; M.DOWN_STAGE     			=  2
-- [舞台]复活
M.STAGE_REVIVAL     	=  3; M.REVIVAL_STAGE  			=  3
-- [舞台]死亡
M.STAGE_DEATH     		=  4; M.DEATH_STAGE     		=  4
-- [舞台]上手牌
M.STAGE_HAND     		=  5; M.HAND_STAGE     			=  5

-- [攻击]普通
M.ATK_NORMAL   			= 11; M.NORMAL_ATK   			= 11
-- [攻击]火
M.ATK_FIRE     			= 12; M.FIRE_ATK     			= 12
-- [攻击]冰
M.ATK_ICE 	  			= 13; M.ICE_ATK   	 			= 13
-- [攻击]电
M.ATK_ELECTRIC  		= 14; M.ELECTRIC_ATK  			= 14
-- [攻击]血
M.ATK_BLOOD   			= 15; M.BLOOD_ATK   			= 15
-- [攻击]毒
M.ATK_POISON  			= 16; M.POISON_ATK  			= 16
-- [攻击]光
M.ATK_BRIGHT 			= 17; M.BRIGHT_ATK	 			= 17
-- [攻击]暗
M.ATK_DARK 				= 18; M.DARK_ATK 				= 18
-- [攻击]狙击
M.ATK_SNIPER 			= 19; M.SNIPER_ATK 				= 19
-- [攻击]陷阱
M.ATK_TRAP 				= 20; M.TRAP_ATK 				= 20
-- [攻击]封印
M.ATK_SEAL 				= 21; M.SEAL_ATK 				= 21
-- [攻击]撕裂
M.ATK_TEAR 				= 22;M.TEAR_ATK 				= 22
-- [攻击]横扫
M.ATK_SWEEP_AWAY 		= 23;M.SWEEP_AWAYT_ATK 			= 23
-- [攻击]秒杀
M.ATK_SPIKE 			= 24;M.SPIKE_ATK 				= 24
-- [攻击]隐盾
M.ATK_STEALTH 			= 25;M.STEALTH_ATK 				= 25
-- [攻击]月蚀
M.ATK_LUNAR_ECLIPSE 	= 26;M.LUNAR_ECLIPSE_ATK 		= 26
-- [攻击]裂魂 split soul
M.ATK_SPLIT_SOUL 	    = 27;M.SPLIT_SOUL_ATK 		    = 27
-- [攻击]末日
M.ATK_END_DAY 	        = 28;M.END_DAY_ATK 		        = 28
-- [攻击]洗礼 
M.ATK_BAPTISM           = 2001;M.BAPTISM_ATK            = 2001
-- [攻击]龙息 
M.ATK_DRAGON_BREATH     = 2002;M.DRAGON_BREATH_ATK      = 2002

-- [攻击]奥术冲击 
M.ATK_ARCANE_BLAST      = 2003;M.ARCANE_BLAST_ATK       = 2003

-- boss攻击
M.ATK_BOSS              = 9998;M.BOSS_ATK               = 9998

-- boss攻击
M.HURT_BOSS              = 9999;M.BOSS_HURT               = 9999



-- [伤害]普通
M.HURT_NORMAL   		= 31; M.NORMAL_HURT   			= 31
-- [伤害]火
M.HURT_FIRE     		= 32; M.FIRE_HURT     			= 32
-- [伤害]冰
M.HURT_ICE 	  			= 33; M.ICE_HURT   	 			= 33
-- [伤害]电
M.HURT_ELECTRIC  		= 34; M.ELECTRIC_HURT  			= 34
-- [伤害]血
M.HURT_BLOOD   			= 35; M.BLOOD_HURT   			= 35
-- [伤害]毒
M.HURT_POISON  			= 36; M.POISON_HURT  			= 36
-- [伤害]光
M.HURT_BRIGHT 			= 37; M.BRIGHT_HURT 			= 37
-- [伤害]暗
M.HURT_DARK 			= 38; M.DARK_HURT 				= 38
-- [伤害]狙击
M.HURT_SNIPER 			= 39; M.SNIPER_HURT 			= 39
-- [伤害]陷阱
M.HURT_TRAP 			= 40; M.TRAP_HURT 				= 40
-- [伤害]封印
M.HURT_SEAL 			= 41; M.SEAL_HURT 				= 41
-- [伤害]撕裂
M.HURT_TEAR 			= 42;M.TEAR_HURT 				= 42
-- [伤害]横扫
M.HURT_SWEEP_AWAY 		= 43;M.SWEEP_AWAYT_HURT 		= 43
-- [伤害]秒杀
M.HURT_SPIKE 			= 44;M.SPIKE_HURT 				= 44
-- [伤害]隐盾
M.HURT_STEALTH 			= 45;M.STEALTH_HURT 			= 45
-- [伤害]月蚀
M.HURT_LUNAR_ECLIPSE 	= 46;M.LUNAR_ECLIPSE_HURT 		= 46
-- [伤害]裂魂 split soul
M.HURT_SPLIT_SOUL 	    = 47;M.SPLIT_SOUL_HURT 		    = 47
-- [伤害]末日
M.HURT_END_DAY 	        = 48;M.END_DAY_HURT  		    = 48
-- [伤害]龙息 
M.HURT_DRAGON_BREATH    = 49;M.DRAGON_BREATH_HURT       = 49

-- [伤害]连环攻击
M.HURT_CHAIN_ATK = 5001;M.CHAIN_ATK_HURT                = 5001

-- [伤害]灵魂震殇
M.HURT_SOUL_SHOCK = 5002;M.SOUL_SHOCK_HURT                = 5002
    
-- [伤害]奥术冲击
M.HURT_ARCANE_BLAST     = 50;M.ARCANE_BLAST_HURT        = 50;

-- [增效]血
M.INC_BLOOD 			= 51; M.BLOOD_INC 				= 51
-- [增效]攻击
M.INC_ATTACK 			= 52; M.ATTACK_INC 				= 52
-- [增效]暴击
M.INC_CRIT 				= 53; M.CRIT_INC 				= 53

-- [减效]血
M.DEC_BLOOD 			= 61; M.BLOOD_DEC 				= 61
-- [减效]物理
M.DEC_ATTACK 			= 62; M.ATTACK_DEC 				= 62
-- [减效]魔法
M.DEC_MAGIC 			= 63; M.MAGIC_DEC 				= 63
-- [攻击]盾墙 
M.DEC_SHIELD_WALL       = 64; M.DEC_WALL_ATK            = 65

-- [固定]血
M.FIX_BLOOD 			= 71; M.BLOOD_FIX 				= 71
-- [固定]攻击
M.FIX_ATTACK 			= 72; M.ATTACK_FIX 				= 72

-- [反弹]血[+]
M.REB_BLOOD_U 			= 81; M.BLOOD_U_REB 			= 81
-- [反弹]血[-]
M.REB_BLOOD_D 			= 82; M.BLOOD_D_REB 			= 82
-- [反弹]攻击
M.REB_ATTACK 			= 83; M.ATTACK_REB 				= 83
-- [反弹]魔法
M.REB_MAGIC 			= 84; M.MAGIC_REB 				= 84
-- [反弹]火
M.REB_FIRE 				= 85; M.FIRE_REB 				= 85

-- [其他]克制
M.OTH_RESTRAINT 		= 101;M.RESTRAINT_OTH 			= 101
-- [其他]
-- TODO: 102
-- [其他]自爆
M.OTH_SELF_BOMB 		= 103;M.SELF_BOMB_OTH 			= 103
-- [其他]免疫(全)
M.OTH_IMMUNITY_ALL 		= 104;M.IMMUNITY_ALL_OTH 		= 104
-- [其他]免疫(魔法)
M.OTH_IMMUNITY_MAGIC 	= 105;M.IMMUNITY_MAGIC_OTH 		= 105
-- [其他]秒杀
-- M.OTH_SPIKE 			= 106;M.SPIKE_OTH 				= 106
-- [其他]MISS
M.OTH_MISS 				= 107;M.MISS_OTH 				= 107
-- [其他]鼓舞加血
M.OTH_ENCOURAGED_BLOOD	= 108;M.ENCOURAGED_BLOOD_OTH 	= 108
-- [其他]鼓舞加攻
M.OTH_ENCOURAGED_ATTACK	= 109;M.ENCOURAGED_ATTACK_OTH 	= 109
-- [其他]召唤[主动]
M.OTH_CALL_LIVE 		= 110;M.CALL_LIVE_OTH 			= 110
-- [其他]召唤[被动]
M.OTH_SUMMON 			= 111;M.SUMMON_OTH 				= 111
-- [其他]格挡
M.OTH_BLOCK 			= 112;M.BLOCK_OTH 				= 112
-- [其他]洗礼 
M.OTH_BAPTISM           = 113;M.BAPTISM_OTH             = 113

-- [其他]送还
M.OTH_GIVE_BACK			= 119;M.GIVE_BACK_OTH 			= 119

-- [持续]普通
M.CTN_NORMAL   			= 301;M.NORMAL_CTN   			= 301
-- [持续]火
M.CTN_FIRE     			= 302;M.FIRE_CTN     			= 302
-- [持续]冰
M.CTN_ICE 	  			= 303;M.ICE_CTN   	 			= 303
-- [持续]电
M.CTN_ELECTRIC  		= 304;M.ELECTRIC_CTN  			= 304
-- [持续]血
M.CTN_BLOOD   			= 305;M.BLOOD_CTN   			= 305
-- [持续]毒
M.CTN_POISON  			= 306;M.POISON_CTN  			= 306
-- [持续]光
M.CTN_BRIGHT 			= 307;M.BRIGHT_CTN 				= 307
-- [持续]暗
M.CTN_DARK 				= 308;M.DARK_CTN 				= 308
-- [持续]狙击
M.CTN_SNIPER 			= 309;M.SNIPER_CTN 				= 309
-- [持续]陷阱
M.CTN_TRAP 				= 310;M.TRAP_CTN 				= 310
-- [持续]封印
M.CTN_SEAL 				= 311; M.SEAL_CTN 				= 311
-- [持续]撕裂
M.CTN_TEAR 				= 312;M.TEAR_CTN 				= 312
-- [持续]隐盾
M.CTN_STEALTH 			= 313;M.STEALTH_CTN 			= 313
-- [持续]末日
M.CTN_END_DAY 			= 314;M.END_DAY_CTN			    = 314


-- [解除]普通
M.CCL_NORMAL   			= 401;M.NORMAL_CCL   			= 401
-- [解除]火
M.CCL_FIRE     			= 402;M.FIRE_CCL     			= 402
-- [解除]冰
M.CCL_ICE 	  			= 403;M.ICE_CCL   	 			= 403
-- [解除]电
M.CCL_ELECTRIC  		= 404;M.ELECTRIC_CCL  			= 404
-- [解除]血
M.CCL_BLOOD   			= 405;M.BLOOD_CCL   			= 405
-- [解除]毒
M.CCL_POISON  			= 406;M.POISON_CCL  			= 406
-- [解除]光
M.CCL_BRIGHT 			= 407;M.BRIGHT_CCL 				= 407
-- [解除]暗
M.CCL_DARK 				= 408;M.DARK_CCL 				= 408
-- [解除]狙击
M.CCL_SNIPER 			= 409;M.SNIPER_CCL 				= 409
-- [解除]陷阱
M.CCL_TRAP 				= 410;M.TRAP_CCL 				= 410
-- [解除]封印
M.CCL_SEAL 				= 411;M.SEAL_CCL 				= 411
-- [解除]隐盾
M.CCL_STEALTH 			= 412;M.STEALTH_CCL 			= 412
-- [解除]末日
M.CCL_END_DAY 			= 413;M.END_DAY_CCL			    = 413
-- [解除]撕裂
M.CCL_TEAR 				= 414;M.TEAR_CCL			    = 414

-- [英雄]
-- [英雄]扣血
M.ATK_H_HURT_BLOOD 		= 501;M.DEC_BLOOD_HURT_H		= 501
-- [英雄]增血
M.ATK_H_INC_BLOOD 		= 502;M.INC_BLOOD_INC_H 		= 502
-- [英雄]减血
M.ATK_H_DEC_BLOOD 		= 503;M.DEC_BLOOD_DEC_H 		= 503
 
-- [英雄]陷阵 
M.ATK_H_TRAP_BLOOD      = 504;M.TRAP_BLOOD_TRAP_H       = 504

-- [伤害]幻之刃 
M.HURT_REGION      = 504;M.REGION_HURT       = 505


-- [操作]
-- [操作]值
M.OPT_VALUE 			= 999;M.VALUE_OPT 				= 999



M.ACTIONS = {
	-- [舞台]上场
	[1]			= "ActionStageUp",
	-- [舞台]下场
	[2]			= "ActionStageDown",
	-- [舞台]复活
	[3]			= "ActionStageRevival",
	-- [舞台]死亡
	[4]			= "ActionStageDeath",
	-- [舞台]上手牌
	[5]			= "ActionStageHand",

	-- [攻击]普通
	[11]		= "ActionAtkNormal",
	-- [攻击]火
	[12]		= "ActionAtkFire",
	-- [攻击]冰
	[13]		= "ActionAtkIce",
	-- [攻击]电
	[14]		= "ActionAtkElectric",
	-- [攻击]血
	[15]		= "ActionAtkBlood",
	-- [攻击]毒
	[16]		= "ActionAtkPoison",
	-- [攻击]光
	[17]		= "ActionAtkBright",
	-- [攻击]暗
	[18]		= "ActionAtkDark",
	-- [攻击]狙击
	[19]		= "ActionAtkSniper",
	-- [攻击]陷阱
	[20]		= "ActionAtkTrap",
	-- [攻击]封印
	[21]		= "ActionAtkSeal",
	-- [攻击]撕裂
	[22]		= "ActionAtkTear",
	-- [攻击]横扫
	[23]		= "ActionAtkSweepAway",
	-- [攻击]秒杀
	[24]		= "ActionAtkSpike",
	-- [攻击]隐盾
	[25]		= "ActionAtkStealth",
	-- [攻击]月蚀
	[26]		= "ActionAtkLunarEclipse",
	-- [攻击]裂魂
	[27]		= "ActionAtkSplitSoul",
	-- [攻击]末日
	[28]		= "ActionAtkEndDay",

	-- [攻击]boss
	[9998]      = "ActionAtkBoss",


	-- [伤害]普通
	[9999]		= "ActionHurtBoss",
	-- [伤害]普通
	[31]		= "ActionHurtNormal",
	-- [伤害]火
	[32]		= "ActionHurtFire",
	-- [伤害]冰
	[33]		= "ActionHurtIce",
	-- [伤害]电
	[34]		= "ActionHurtElectric",
	-- [伤害]血
	[35]		= "ActionHurtBlood",
	-- [伤害]毒
	[36]		= "ActionHurtPoison",
	-- [伤害]光
	[37]		= "ActionHurtBright",
	-- [伤害]暗
	[38]		= "ActionHurtDark",
	-- [伤害]狙击
	[39]		= "ActionHurtSniper",
	-- [伤害]陷阱
	[40]		= "ActionHurtTrap",
	-- [伤害]封印
	[41]		= "ActionHurtSeal",
	-- [伤害]撕裂
	[42]		= "ActionHurtTear",
	-- [伤害]横扫
	[43]		= "ActionHurtSweepAway",
	-- [伤害]秒杀
	[44]		= "ActionHurtSpike",
	-- [伤害]隐盾
	[45]		= "ActionHurtStealth",
	-- [伤害]月蚀
	[46]		= "ActionHurtLunarEclipse",
	-- [伤害]裂魂
	[47]		= "ActionHurtSplitSoul",
	-- [伤害]末日
	[48]		= "ActionHurtEndDay",
	-- [伤害]龙息
	[49]		= "ActionHurtDragonBreath",
	-- [伤害]奥素冲击
	[50]		= "ActionHurtArcaneBlast",
	[5001]		= "ActionHurtChainAtk",
 
    -- [伤害]灵魂震殇
    [5002]		= "ActionHurtSoulShock",
    

	-- [增效]血
	[51]		= "ActionIncBlood",
	-- [增效]攻击
	[52]		= "ActionIncAttack",
	-- [增效]暴击
	[53]		= "ActionIncCrit",

	-- [减效]血
	[61]		= "ActionDecBlood",
	-- [减效]物理
	[62]		= "ActionDecAttack",
	-- [减效]魔法
	[63]		= "ActionDecMagic",
	-- [减效]盾墙
	[64]        = "ActionDecShieldWall",
	
	-- [固定]血
	[71]		= "ActionFixBlood",
	-- [固定]攻击
	[72]		= "ActionFixAttack",

	-- [反弹]血[+]
	[81]		= "ActionRebBloodUp",
	-- [反弹]血[-]
	[82]		= "ActionRebBloodDown",
	-- [反弹]攻击
	[83]		= "ActionRebAttack",
	-- [反弹]魔法
	[84]		= "ActionRebMagic",
	-- [反弹]火
	[85]		= "ActionRebFire",

	-- [其他]克制
	[101]		= "ActionOthRestraint",
	-- [其他]
	-- TODO: 102
	-- [其他]自爆
	[103]		= "ActionOthSelfBomb",
	-- [其他]免疫(全)
	[104]		= "ActionOthImmunityAll",
	-- [其他]免疫(魔法)
	[105]		= "ActionOthImmunityMagic",
	-- [其他]秒杀
	-- [106]		= "ActionOthSpike",
	-- [其他]MISS
	[107]		= "ActionOthMiss",
	-- [其他]鼓舞加血
	[108]		= "ActionOthEncouragedBlood",
	-- [其他]鼓舞加攻
	[109]		= "ActionOthEncouragedAttack",
	-- [其他]召唤[主动]
	[110]		= "ActionOthCallLive",
	-- [其他]召唤[被动]
	[111]		= "ActionOthSummon2", 				-- ActionOthSummon
	-- [其他]格挡
	[112]		= "ActionOthBlock",
	-- [其他]洗礼
	[113]       = "ActionOthBaptism",
	-- [其他]送还
	[119]		= "ActionOthGiveBack",

	-- [持续]普通
	[301]		= "ActionCtnNormal",
	-- [持续]火
	[302]		= "ActionCtnFire",
	-- [持续]冰
	[303]		= "ActionCtnIce",
	-- [持续]电
	[304]		= "ActionCtnElectric",
	-- [持续]血
	[305]		= "ActionCtnBlood",
	-- [持续]毒
	[306]		= "ActionCtnPoison",
	-- [持续]光
	[307]		= "ActionCtnBright",
	-- [持续]暗
	[308]		= "ActionCtnDark",
	-- [持续]狙击
	[309]		= "ActionCtnSniper",
	-- [持续]陷阱
	[310]		= "ActionCtnTrap",
	-- [持续]封印
	[311]		= "ActionCtnSeal",
	-- [持续]撕裂
	[312]		= "ActionCtnTear",
	-- [持续]隐盾
	[313]		= "ActionCtnStealth",
	-- [持续]末日
	[314]		= "ActionCtnEndDay",

	-- [解除]普通
	[401]		= "ActionCclNormal",
	-- [解除]火
	[402]		= "ActionCclFire",
	-- [解除]冰
	[403]		= "ActionCclIce",
	-- [解除]电
	[404]		= "ActionCclElectric",
	-- [解除]血
	[405]		= "ActionCclBlood",
	-- [解除]毒
	[406]		= "ActionCclPoison",
	-- [解除]光
	[407]		= "ActionCclBright",
	-- [解除]暗
	[408]		= "ActionCclDark",
	-- [解除]狙击
	[409]		= "ActionCclSniper",
	-- [解除]陷阱
	[410]		= "ActionCclTrap",
	-- [解除]封印
	[411]		= "ActionCclSeal",
	-- [解除]隐盾
	[412]		= "ActionCclStealth",
	-- [解除]末日
	[413]		= "ActionCclEndDay",
	-- [解除]撕裂
	[414]		= "ActionCclTear",

	-- [英雄]扣血
	[501]		= "ActionHHurtBlood",
	-- [英雄]增血
	[502]		= "ActionHIncBlood",
	-- [英雄]减血
	[503]		= "ActionHDecBlood",
	-- [英雄]陷阵
	[504]		= "ActionHTrapBlood",
	-- [伤害]幻之刃
	[505]		= "ActionHurtRegionEclipse",
	
	-- [英雄]渐射血
	[509]		= "ActionHShotBlood",

	-- [操作]值
	[999]		= "ActionOptValue",
}


return M