
--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗动作助手类，定义战斗动作公共操作方法及逻辑实现。

-   定义战斗动作公共方法。

]]

local M = class("FightActionHelper")


-- [包含文件]
-- ..


-- [操作变量]
-- .. 


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- 验证参数合法性
    -- TDAssertUtils.assertClassname(po, UserPo);

    params = params or {}


    -- 提取配置参数
    self._rate              = params.rate 				or 1.0                  -- 播放速率 



    -- 验证参数合法性（文件名）
    -- ..





    -- 具体操作
    -- ..
end

    

    





-- [实例方法]
-- [实例方法][外部调用]
-- 获得动作时间
function M:time(aTime)
	return (aTime / self._rate)
end

-- 获得位置
function M:position(aPosition)
    return aPosition
end

-- 获得位置偏移
function M:offset(aPosition, aOffset)
    return ccpAdd(aPosition, aOffset)
end

-- 获得距离
function M:distance(aDistance)
    return aDistance
end

-- 获得旋转角度
function M:rotation(aRotation)
    return aRotation
end

-- 获得缩放比例
function M:scale(aScale)
    return aScale
end

-- 获得透明度
function M:alpha(aAlpha)
    return aAlpha
end

-- 获得结点
function M:node(aNode)
    return aNode
end


-- [实例方法][属性Getter/Setter]
-- 设置播放速率
function M:setRate(rate)
    self._rate = rate
end
-- 获得播放速率
function M:getRate()
    return self._rate
end





return M