
--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗数据栈类，定义战斗数据栈公共操作方法及逻辑实现。

-   定义战斗数据栈公共方法。

]]

local M = class("FightDataQueue")


-- [包含文件]
-- 集合
local TDArrayUtils                  = require(PH_MDL_UTIL .. "TDArrayUtils")
-- 断言
local TDAssertUtils                 = require(PH_MDL_UTIL .. "TDAssertUtils")


-- [操作变量]
-- .. 


-- [公共参数]
-- [常量]
-- ..


-- [成员变量]
-- ..

    

    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor()
    -- 私有属性
    self._queue                             = {}                  -- 数据队列





    -- 具体操作
    -- ..
end

    

    





-- [实例方法]
-- [实例方法][外部调用]
-- 添加数据
function M:add(data)
    -- 验证数据合法性
    -- TDAssertUtils.assertClassname(data, FightRecData)

    -- 添加数据
    TDArrayUtils.addItemOrder(self._queue, data)
end

-- 弹出数据[首部]
function M:shift()
    local index = 1
    local item  = self._queue[index]

    table.remove(self._queue, index)
    return item
end

-- 弹出数据[尾部]
function M:pop()
    local index = #self._queue
    local item  = self._queue[index]

    table.remove(self._queue, index)
    return item
end

-- 判断队列是否为空
function M:isEmpty()
    return #self._queue == 0
end


---------


-- [实例方法][属性Getter/Setter]
-- 设置播放速率
function M:getStack()
    return self._stack
end

-- 设置索引
function M:setIndex(index)
    self._index = index
end
-- 获得索引
function M:getIndex()
    return self._index
end





return M