
--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

局部包含文件，定义公共包含等相关操作方法及逻辑实现。

-   定义公共包含。

]]

-- [公共方法定义]
-- [路径]
-- 获得Lua文件所在的目录路径[Constant]
function pathC(luaName)
    return PH_MDL_CONSTANT .. luaName
end
-- 获得Lua文件所在的目录路径[Scene]
function pathX(luaName)
    return PH_MDL_SCENE .. luaName
end
-- 获得Lua文件所在的目录路径[Layer]
function pathL(luaName)
    return PH_MDL_LAYER .. luaName
end
-- 获得Lua文件所在的目录路径[Sprite]
function pathS(luaName)
    return PH_MDL_SPRITE .. luaName
end
-- 获得Lua文件所在的目录路径[Component]
function pathCOM(luaName)
    return PH_MDL_COMPONENT .. luaName
end
-- 获得Lua文件所在的目录路径[Action]
function pathA(luaName)
    -- print("name:"..luaName)
    return PH_MDL_ACTION .. luaName
end
-- 获得Lua文件所在的目录路径[Factory]
function pathF(luaName)
    return PH_MDL_FACTORY .. luaName
end
-- 获得Lua文件所在的目录路径[Util]
function pathU(luaName)
    return PH_MDL_UTIL .. luaName
end
-- 获得Lua文件所在的目录路径[Extend]
function pathE(luaName)
    return PH_MDL_EXTEND .. luaName
end
-- 获得Lua文件所在的目录路径[Entity:Fight]
function pathEN(luaName)
    return PH_EN_FIGHT .. luaName
end
-- 获得Lua文件所在的目录路径[Net]
function pathNET(luaName)
    return PH_N .. luaName
end
-- 获得Lua文件所在的目录路径[Action-Support]
function pathAS(luaName)
    return PH_MDL_ACTION .. NAM_SUPPORT .. "." .. luaName
end
-- 获得Lua文件所在的目录路径[Clazz]
function pathCLS(luaName)
    return PH_MDL_CLASS .. luaName
end

-- [包含]
-- 加载Lua文件文件内容[Constant]
function requireC(luaName)
    return require(pathC(luaName))
end
-- 加载Lua文件文件内容[Scene]
function requireM(luaName)
    return require(pathM(luaName))
end
-- 加载Lua文件文件内容[Layer]
function requireL(luaName)
    return require(pathL(luaName))
end
-- 加载Lua文件文件内容[Sprite]
function requireS(luaName)
    return require(pathS(luaName))
end
-- 加载Lua文件文件内容[Component]
function requireCOM(luaName)
    return require(pathC(luaName))
end
-- 加载Lua文件文件内容[Action]
function requireA(luaName)
    return require(pathA(luaName))
end
-- 加载Lua文件文件内容[Factory]
function requireF(luaName)
    return require(pathF(luaName))
end
-- 加载Lua文件文件内容[Util]
function requireU(luaName)
    return require(pathU(luaName))
end
-- 加载Lua文件文件内容[Extend]
function requireE(luaName)
    return require(pathE(luaName))
end
-- 加载Lua文件文件内容[Entity:Fight]
function requireEN(luaName)
    return require(pathEN(luaName))
end
-- 加载Lua文件文件内容[Net]
function requireNET(luaName)
    return require(pathNET(luaName))
end
-- 加载Lua文件文件内容[Action-Support]
function requireAS(luaName)
    return require(pathAS(luaName))
end
-- 加载Lua文件文件内容[Clazz]
function requireCLS(luaName)
    return require(pathCLS(luaName))
end










-- [包含文件]
-- 引用文件[类]
require(PH_MDL_CONSTANT .. "IncludeClass")
-- 引用文件[动作]
require(PH_MDL_CONSTANT .. "IncludeAction")



-- [操作变量]
-- ..









-- [公共参数]
-- [常量]
-- ..

