--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

动作包含文件类，定义战斗相关操作方法及逻辑实现。

-   引入战斗动作枚举及动作相关类。
-   定义动作操作的时间常量

]]



-- [包含文件]
-- 回合测试数据
-- requireC("FightActionData")





-- [操作变量]
-- ..





-- [公共参数]
-- [常量]
-- 起始编号[场下]
FA_NO_BEGIN_STAGE_OFF 		= 1
-- 起始编号[场上]
FA_NO_BEGIN_STAGE_ON 		= 11
-- 起始编号[]
FA_NO_CEMETERY 				= 10
-- 起始编号[]
FA_A_INTERVAL 				= (1.0 / 24)
-- [血量]效果偏移量
FA_E_BLOOD_O 				= ccp(0, 0)

-- [动画参数]
-- [基础]文字		Class: None
FA__BASE_NUM__T 			= .1 					-- [数字]时间
FA__BASE_NUM__T_CLEAN 		= .5 					-- [数字]时间清除
FA__BASE_CORRECT__T 		= 1.0 	-- 时间[移动]

-- [基础]文字		Class: ActionBaseText
FA__BASE_TEXT__O 			= ccp(0, 20) 			-- 偏移量
FA__BASE_TEXT__T1 			= .5 					-- 时间1
FA__BASE_TEXT__T2 			= .8 					-- 时间2
FA__BASE_TEXT__R1 			= 720 					-- 旋转角度1
FA__BASE_TEXT__S2 			= 3 					-- 缩放比例2
FA__BASE_TEXT__A2 			= 0 					-- 透明度2
FA__BASE_TEXT__FNT_FN 		= DEFAULT_FONT 			-- 字体名称
FA__BASE_TEXT__FNT_SZ 		= 30 					-- 字体尺寸

-- [基础]动作		Class: ActionBaseOperate
FA__BASE_OPERATE__T1 		= .08 				-- 时间1[偏移]
FA__BASE_OPERATE__T3 		= .08 				-- 时间3[还原]
FA__BASE_OPERATE__T4 		= .07 				-- 时间3[延迟]
FA__BASE_OPERATE__O1 		= acp(0, 10) 		-- 位移1
FA__BASE_OPERATE__E1_RES 	= "e_f_base_operate" 			-- [效果]资源文件
FA__BASE_OPERATE__E1_Z 		= -10 							-- [效果]Z值
FA__BASE_OPERATE__E1_PFX	= "e_f_base_operate" 			-- [效果][1阶]帧前缀
FA__BASE_OPERATE__E1_NUM	= 8 							-- [效果][1阶]帧数量
FA__BASE_OPERATE__E1_ITV 	= (1.0 / 18) 					-- [效果][1阶]帧间隔
FA__BASE_OPERATE__T2 		= FA__BASE_OPERATE__E1_NUM * FA__BASE_OPERATE__E1_ITV		-- 时间1

-- [基础]效果[两阶段]		Class: EffectActionStep2
FA__EFFECT_2__T1 			= .15 					-- 时间1
FA__EFFECT_2__T2 			= .15 					-- 时间2
FA__EFFECT_2__T3 			= .05 					-- 时间3
FA__EFFECT_2__O2 			= acp(0, 5) 			-- 位移2

-- [动画参数]FightActionPosition
FA__POSITION__T 			= 1.0 					-- 时间

-- [舞台]下场		Class: ActionStageMovement
FA__STAGE_MOVEMENT_T1 		= .5 					-- 时间1[移动]
FA__STAGE_MOVEMENT_T2 		= .15 					-- 时间2[攻击旋转－目标]
FA__STAGE_MOVEMENT_S1 		= 1 					-- 缩放比例1

-- [公共]移动		Class: ActionCommonMove
FA__COMMON_MOVE__T 			= .15 					-- 时间[移动]

-- [舞台]上场		Class: ActionStageUp
FA__STAGE_UP__T 			= FA__COMMON_MOVE__T 	-- 时间[移动]
FA__STAGE_UP__D_E 			= .1 					-- 时间[延迟－结束]

-- [舞台]下场		Class: ActionStageDown
FA__STAGE_DOWN__T 			= FA__STAGE_UP__T 		-- 时间[移动]

-- ..

-- [舞台]复活		Class: ActionStageRevival
FA__STAGE_REVIVAL__S1 			= "e_f_stage_revival.mp3" 		-- [声音]
FA__STAGE_REVIVAL__S1_DEATH 	= "e_f_stage_death.mp3" 		-- [声音]
FA__STAGE_REVIVAL__E1_RES 		= "e_f_stage_revival" 			-- [效果]资源文件
FA__STAGE_REVIVAL__E1_Z 		= 0 							-- [效果]Z值
FA__STAGE_REVIVAL__E1_PFX		= "e_f_stage_revival" 			-- [效果][1阶]帧前缀
FA__STAGE_REVIVAL__E1_NUM		= 8 							-- [效果][1阶]帧数量
FA__STAGE_REVIVAL__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__STAGE_REVIVAL__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__STAGE_REVIVAL__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__STAGE_REVIVAL__T1 			= FA__STAGE_REVIVAL__E1_NUM * FA__STAGE_REVIVAL__E1_ITV		-- 时间1

-- [舞台]死亡		Class: ActionStageDeath
FA__STAGE_DEATH__S 				= "e_f_stage_death.mp3" 		-- [声音]
FA__STAGE_DEATH__T1 			= .15 				-- 时间1[渐隐]
FA__STAGE_DEATH__T2 			= .15 				-- 时间2[渐显]
FA__STAGE_DEATH__T3 			= .3 				-- 时间3[移动]
FA__STAGE_DEATH__T4 			= .1 				-- 时间3[移动]
FA__STAGE_DEATH__A1 			= .15 				-- 时间1[渐隐]
FA__STAGE_DEATH__A2 			= .85 				-- 时间2[渐显]
FA__STAGE_DEATH__A3 			= .15 				-- 时间3[渐隐]
FA__STAGE_DEATH_E__T	 		= .15 				-- 时间[效果－时间]
FA__STAGE_DEATH_E__O 			= acp(20, 0)		-- 时间[效果－偏移量] 

-- [舞台]上手牌	Class: ActionStageHand
FA__STAGE_HAND__S 				= "e_f_hand.mp3" 	-- [声音]
FA__STAGE_HAND__T1 				= .08				-- 时间1[还原显示]
FA__STAGE_HAND__T2 				= .08				-- 时间1[上场]

-- [攻击]普通		Class: ActionAtkNormal
FA__ATK_NORMAL__T1 			= .08 				-- 时间1[偏移]
FA__ATK_NORMAL__T2 			= .06 				-- 时间2[攻击旋转－目标]
FA__ATK_NORMAL__T3 			= .08 				-- 时间3[攻击旋转－起始]
FA__ATK_NORMAL__T4 			= .12 				-- 时间4[还原]
FA__ATK_NORMAL__O1 			= acp(0, 10) 		-- 位移1
FA__ATK_NORMAL__R2 			= 20 				-- 旋转角度2[攻击旋转－目标]
FA__ATK_NORMAL__R3 			= 0 				-- 旋转角度3[攻击旋转－起始]

-- [攻击]火		Class: ActionAtkFire
FA__ATK_FIRE0__T1 			= .2 				-- 时间1[偏移]
FA__ATK_FIRE0__T2 			= .1 				-- 时间2[延迟]
FA__ATK_FIRE0__O1 			= acp(0, 15) 		-- 位移1

-- [攻击]冰		Class: ActionAtkIce
FA__ATK_ICE0__T1 			= .2 				-- 时间1[偏移]
FA__ATK_ICE0__T2 			= .1 				-- 时间2[延迟]
FA__ATK_ICE0__O1 			= acp(0, 15) 		-- 位移1

-- [攻击]电		Class: ActionAtkElectric
-- ..

-- [攻击]血		Class: ActionAtkBlood
-- ..

-- [攻击]毒		Class: ActionAtkPoison
-- ..

-- [攻击]光		Class: ActionAtkBright
-- ..

-- [攻击]暗		Class: ActionAtkDark
-- ..

-- [攻击]狙击		Class: ActionAtkSniper
-- ..

-- [攻击]陷阱		Class: ActionAtkTrap
-- ..

-- [攻击]隐盾		Class: ActionAtkStealth
FA__ATK_STEALTH__S1 			= "e_f_atk_stealth.mp3" 		-- [声音]
FA__ATK_STEALTH__E1_RES 		= "e_f_atk_stealth" 			-- [效果]资源文件
FA__ATK_STEALTH__E1_Z 			= 0 							-- [效果]Z值
FA__ATK_STEALTH__E1_PFX			= "e_f_atk_stealth" 			-- [效果][1阶]帧前缀
FA__ATK_STEALTH__E1_NUM			= 21 							-- [效果][1阶]帧数量
FA__ATK_STEALTH__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__ATK_STEALTH__E1_OS 			= acp(0, 6) 					-- [效果][1阶]位移[起始]
FA__ATK_STEALTH__E1_OE 			= acp(0, 6) 					-- [效果][1阶]位移[结束]
FA__ATK_STEALTH__E1_STN 		= false							-- [效果][1阶]持续标识
FA__ATK_STEALTH__T1 			= FA__ATK_STEALTH__E1_NUM * FA__ATK_STEALTH__E1_ITV		-- 时间1

-- FA__ATK_BOSS__S1 			= "e_f_atk_stealth.mp3" 		-- [声音]
-- FA__ATK_BOSS__E1_RES 		= "e_f_hurt_bossheng" 			-- [效果]资源文件
-- FA__ATK_BOSS__E1_Z 			= 0 							-- [效果]Z值
-- FA__ATK_BOSS__E1_PFX		= "e_f_hurt_bossheng" 			-- [效果][1阶]帧前缀
-- FA__ATK_BOSS__E1_NUM		= 21 							-- [效果][1阶]帧数量
-- FA__ATK_BOSS__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
-- FA__ATK_BOSS__E1_OS 		= acp(0, 6) 					-- [效果][1阶]位移[起始]
-- FA__ATK_BOSS__E1_OE 		= acp(0, 6) 					-- [效果][1阶]位移[结束]
-- FA__ATK_BOSS__E1_STN 		= false							-- [效果][1阶]持续标识
-- FA__ATK_BOSS__T1 			= FA__ATK_STEALTH__E1_NUM * FA__ATK_STEALTH__E1_ITV		-- 时间1

FA__HURT_BOSSHENG__S1 			= "e_f_atk_bossheng.wav" 		-- [声音]
FA__HURT_BOSSHENG__E1__RES 		= "e_f_hurt_bossheng" 			-- [效果]资源文件
FA__HURT_BOSSHENG__E1_Z 		= 0 						-- [效果][1阶]Z值
FA__HURT_BOSSHENG__E1_PFX		= "e_f_hurt_bossheng" 			-- [效果][1阶]帧前缀
FA__HURT_BOSSHENG__E1_NUM		= 7 						-- [效果][1阶]帧数量
FA__HURT_BOSSHENG__E1_ITV 		= 0.1 			-- [效果][1阶]帧间隔
FA__HURT_BOSSHENG__E1_OS 		= acp(0, -200) 				-- [效果][1阶]位移[起始]
FA__HURT_BOSSHENG__E1_OE 		= acp(0, -200) 				-- [效果][1阶]位移[结束]
FA__HURT_BOSSHENG__T1           = FA__HURT_BOSSHENG__E1_NUM * FA__HURT_BOSSHENG__E1_ITV       -- 时间1


-- [伤害]普通		Class: ActionHurtNormal
FA__HURT_NORMAL__S  		= "e_f_hurt_normal.mp3" 	-- [声音]
FA__HURT_NORMAL__E_Z 		= 100 						-- [效果]层深度
FA__HURT_NORMAL__T1 		= .03 						-- 时间1
FA__HURT_NORMAL__T2 		= .03 						-- 时间2
FA__HURT_NORMAL__S1 		= .9 						-- 缩放比例1[变小]
FA__HURT_NORMAL__E_T 		= .3 						-- 效果－时间
FA__HURT_NORMAL__E_O 		= acp(0, 30) 				-- 效果－偏移量
-- [种族1]
FA__HURT_NORMAL__1_E1_RES 		= "e_f_hurt_normal1" 			-- [效果]资源文件
FA__HURT_NORMAL__1_E1_Z 		= 0 							-- [效果]Z值
FA__HURT_NORMAL__1_E1_PFX		= "e_f_hurt_normal1" 			-- [效果][1阶]帧前缀
FA__HURT_NORMAL__1_E1_NUM		= 12 							-- [效果][1阶]帧数量
FA__HURT_NORMAL__1_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_NORMAL__1_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_NORMAL__1_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_NORMAL__1_T1 			= FA__HURT_NORMAL__1_E1_NUM * FA__HURT_NORMAL__1_E1_ITV		-- 时间1
-- [种族2]
FA__HURT_NORMAL__2_E1_RES 		= "e_f_hurt_normal2" 			-- [效果]资源文件
FA__HURT_NORMAL__2_E1_Z 		= 0 							-- [效果]Z值
FA__HURT_NORMAL__2_E1_PFX		= "e_f_hurt_normal2" 			-- [效果][1阶]帧前缀
FA__HURT_NORMAL__2_E1_NUM		= 9 							-- [效果][1阶]帧数量
FA__HURT_NORMAL__2_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_NORMAL__2_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_NORMAL__2_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_NORMAL__2_T1 			= FA__HURT_NORMAL__2_E1_NUM * FA__HURT_NORMAL__2_E1_ITV		-- 时间1
-- [种族3]
FA__HURT_NORMAL__3_E1_RES 		= "e_f_hurt_normal3" 			-- [效果]资源文件
FA__HURT_NORMAL__3_E1_Z 		= 0 							-- [效果]Z值
FA__HURT_NORMAL__3_E1_PFX		= "e_f_hurt_normal3" 			-- [效果][1阶]帧前缀
FA__HURT_NORMAL__3_E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__HURT_NORMAL__3_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_NORMAL__3_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_NORMAL__3_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_NORMAL__3_T1 			= FA__HURT_NORMAL__3_E1_NUM * FA__HURT_NORMAL__3_E1_ITV		-- 时间1

-- [伤害]火		Class: ActionHurtFire
FA__HURT_FIRE__S1 			= "e_f_hurt_fire.mp3" 		-- [声音]
FA__HURT_FIRE__E__RES 		= "e_f_fireball" 			-- [效果]资源文件
FA__HURT_FIRE__E1_Z 		= 0 						-- [效果][1阶]Z值
FA__HURT_FIRE__E1_PFX		= "e_f_fireball0_" 			-- [效果][1阶]帧前缀
FA__HURT_FIRE__E1_NUM		= 8						-- [效果][1阶]帧数量
FA__HURT_FIRE__E1_ITV 		= FA_A_INTERVAL 			-- [效果][1阶]帧间隔
FA__HURT_FIRE__E1_OS 		= acp(0, 200) 				-- [效果][1阶]位移[起始]
FA__HURT_FIRE__E1_OE 		= acp(0, -20) 				-- [效果][1阶]位移[结束]
FA__HURT_FIRE__E2_Z 		= 0 						-- [效果][2阶]Z值
FA__HURT_FIRE__E2_PFX		= "e_f_fireball1_" 			-- [效果][2阶]帧前缀
FA__HURT_FIRE__E2_NUM		= 5 						-- [效果][2阶]帧数量
FA__HURT_FIRE__E2_ITV 		= (1.0 / 12) 				-- [效果][2阶]帧间隔
FA__HURT_FIRE__E2_OS 		= acp(-10, -20) 			-- [效果][2阶]位移[起始]
FA__HURT_FIRE__E2_OE 		= P_ZERO 					-- [效果][2阶]位移[结束]

-- [伤害]BOss		Class: ActionHurtFire
FA__HURT_BOSS__S1 			= "e_f_hurt_bossnormal.wav" 		-- [声音]
FA__HURT_BOSS__E1__RES 		= "e_f_hurt_bossnormal" 			-- [效果]资源文件
FA__HURT_BOSS__E1_Z 		= 0 						-- [效果][1阶]Z值
FA__HURT_BOSS__E1_PFX		= "e_f_hurt_bossnormal" 			-- [效果][1阶]帧前缀
FA__HURT_BOSS__E1_NUM		= 7 						-- [效果][1阶]帧数量
FA__HURT_BOSS__E1_ITV 		= FA_A_INTERVAL 			-- [效果][1阶]帧间隔
FA__HURT_BOSS__E1_OS 		= acp(0, 200) 				-- [效果][1阶]位移[起始]
FA__HURT_BOSS__E1_OE 		= acp(0, -20) 				-- [效果][1阶]位移[结束]
FA__HURT_BOSS__T1              = FA__HURT_BOSS__E1_NUM * FA__HURT_BOSS__E1_ITV       -- 时间1


-- [伤害]冰		Class: ActionHurtIce
FA__HURT_ICE__S1 			= "e_f_hurt_ice.mp3" 		-- [声音]
FA__HURT_ICE__E__RES 		= "e_f_ice" 				-- [效果]资源文件
FA__HURT_ICE__E1_Z 			= 0 						-- [效果][1阶]Z值
FA__HURT_ICE__E1_PFX		= "e_f_ice0_" 				-- [效果][1阶]帧前缀
FA__HURT_ICE__E1_NUM		= 1 						-- [效果][1阶]帧数量
FA__HURT_ICE__E1_ITV 		= FA_A_INTERVAL 			-- [效果][1阶]帧间隔
FA__HURT_ICE__E1_OS 		= acp(0, 200) 				-- [效果][1阶]位移[起始]
FA__HURT_ICE__E1_OE 		= acp(0, -10) 				-- [效果][1阶]位移[结束]
FA__HURT_ICE__E2_Z 			= 0 						-- [效果][2阶]Z值
FA__HURT_ICE__E2_PFX		= "e_f_ice1_" 				-- [效果][2阶]帧前缀
FA__HURT_ICE__E2_NUM		= 7 						-- [效果][2阶]帧数量
FA__HURT_ICE__E2_ITV 		= (1.0 / 12) 				-- [效果][2阶]帧间隔
FA__HURT_ICE__E2_OS 		= acp(0, -10) 				-- [效果][2阶]位移[起始]
FA__HURT_ICE__E2_OE 		= P_ZERO 					-- [效果][2阶]位移[结束]

-- [伤害]电		Class: ActionHurtElectric
--[[
FA__HURT_ELECTRIC__E__RES 		= "e_f_thunder" 		-- [效果]资源文件
FA__HURT_ELECTRIC__E1_Z 		= 0 					-- [效果][1阶]Z值
FA__HURT_ELECTRIC__E1_PFX		= "e_f_thunder1_" 		-- [效果][1阶]帧前缀
FA__HURT_ELECTRIC__E1_NUM		= 1 					-- [效果][1阶]帧数量
FA__HURT_ELECTRIC__E1_ITV 		= FA_A_INTERVAL 		-- [效果][1阶]帧间隔
FA__HURT_ELECTRIC__E1_OS 		= acp(0, 200) 			-- [效果][1阶]位移[起始]
FA__HURT_ELECTRIC__E1_OE 		= acp(0, -20) 			-- [效果][1阶]位移[结束]
FA__HURT_ELECTRIC__E2_Z 		= 0 					-- [效果][2阶]Z值
FA__HURT_ELECTRIC__E2_PFX		= "e_f_thunder2_" 		-- [效果][2阶]帧前缀
FA__HURT_ELECTRIC__E2_NUM		= 7 					-- [效果][2阶]帧数量
FA__HURT_ELECTRIC__E2_ITV 		= (1.0 / 12) 			-- [效果][2阶]帧间隔
FA__HURT_ELECTRIC__E2_OS 		= acp(0, -20) 			-- [效果][2阶]位移[起始]
FA__HURT_ELECTRIC__E2_OE 		= P_ZERO 				-- [效果][2阶]位移[结束]
--]]
FA__HURT_ELECTRIC__S1 			= "e_f_hurt_electric.mp3" 		-- [声音]
FA__HURT_ELECTRIC__E1_RES 		= "e_f_hurt_electric" 			-- [效果]资源文件
FA__HURT_ELECTRIC__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_ELECTRIC__E1_PFX		= "e_f_hurt_electric" 			-- [效果][1阶]帧前缀
FA__HURT_ELECTRIC__E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__HURT_ELECTRIC__E1_ITV 		= (2.0 / 24) 				-- [效果][1阶]帧间隔
FA__HURT_ELECTRIC__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_ELECTRIC__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_ELECTRIC__T1 			= FA__HURT_ELECTRIC__E1_NUM * FA__HURT_ELECTRIC__E1_ITV		-- 时间1

-- [伤害]血		Class: ActionHurtBlood
FA__HURT_BLOOD__S1 				= "e_f_reb_bloodup.mp3" 		-- [声音]
FA__HURT_BLOOD__E1_RES 			= "e_f_hurt_blood"				-- [效果]资源文件
FA__HURT_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_BLOOD__E1_PFX			= "e_f_hurt_blood" 				-- [效果][1阶]帧前缀
FA__HURT_BLOOD__E1_NUM			= 14 							-- [效果][1阶]帧数量
FA__HURT_BLOOD__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_BLOOD__T1 				= FA__HURT_BLOOD__E1_NUM * FA__HURT_BLOOD__E1_ITV		-- 时间1


-- [伤害]灵魂震殇	Class: ActionHurtChainAtk
FA__HURT_SOUL_SHOCK__S1 				= "e_f_reb_bloodup.mp3" 		-- [声音]
FA__HURT_SOUL_SHOCK__E1_RES 			= "e_f_hurt_soul_shock"				-- [效果]资源文件
FA__HURT_SOUL_SHOCK__E1_Z 				= 0 							-- [效果]Z值
FA__HURT_SOUL_SHOCK__E1_PFX				= "e_f_hurt_soul_shock" 				-- [效果][1阶]帧前缀
FA__HURT_SOUL_SHOCK__E1_NUM				= 9 							-- [效果][1阶]帧数量
FA__HURT_SOUL_SHOCK__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_SOUL_SHOCK__E1_OS 				= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_SOUL_SHOCK__E1_OE 				= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_SOUL_SHOCK__T1 				= FA__HURT_SOUL_SHOCK__E1_NUM * FA__HURT_SOUL_SHOCK__E1_ITV		-- 时间1


-- [伤害]连环攻击		Class: ActionHurtSoulShock
FA__HURT_CHAIN_ATK__S1 				= "e_f_reb_bloodup.mp3" 		-- [声音]
FA__HURT_CHAIN_ATK__E1_RES 			= "e_f_hurt_chain_atk"				-- [效果]资源文件
FA__HURT_CHAIN_ATK__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_CHAIN_ATK__E1_PFX			= "e_f_hurt_chain_atk" 				-- [效果][1阶]帧前缀
FA__HURT_CHAIN_ATK__E1_NUM			= 13							-- [效果][1阶]帧数量
FA__HURT_CHAIN_ATK__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_CHAIN_ATK__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_CHAIN_ATK__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_CHAIN_ATK__T1 				= FA__HURT_CHAIN_ATK__E1_NUM * FA__HURT_CHAIN_ATK__E1_ITV		-- 时间1

-- [伤害]毒		Class: ActionHurtPoison
FA__HURT_POISON__S1 			= "e_f_hurt_poison.mp3" 	-- [声音]
FA__HURT_POISON__E__RES 		= "e_f_poison" 				-- [效果]资源文件
FA__HURT_POISON__E1_Z 			= 0 						-- [效果][1阶]Z值
FA__HURT_POISON__E1_PFX			= "e_f_poison1_" 			-- [效果][1阶]帧前缀
FA__HURT_POISON__E1_NUM			= 4 						-- [效果][1阶]帧数量
FA__HURT_POISON__E1_ITV 		= FA_A_INTERVAL 			-- [效果][1阶]帧间隔
FA__HURT_POISON__E1_OS 			= acp(0, 200) 				-- [效果][1阶]位移[起始]
FA__HURT_POISON__E1_OE 			= acp(0, -10) 				-- [效果][1阶]位移[结束]
FA__HURT_POISON__E2_Z 			= 0 						-- [效果][2阶]Z值
FA__HURT_POISON__E2_PFX			= "e_f_poison2_" 			-- [效果][2阶]帧前缀
FA__HURT_POISON__E2_NUM			= 6 						-- [效果][2阶]帧数量
FA__HURT_POISON__E2_ITV 		= (1.0 / 12) 				-- [效果][2阶]帧间隔
FA__HURT_POISON__E2_OS 			= acp(0, 0) 	 			-- [效果][2阶]位移[起始]
FA__HURT_POISON__E2_OE 			= P_ZERO 					-- [效果][2阶]位移[结束]

-- [伤害]光		Class: ActionHurtBright
-- ..

-- [伤害]暗		Class: ActionHurtDark
-- ..

-- [伤害]狙击		Class: ActionHurtSniper
FA__HURT_SNIPER__S1 			= "e_f_hurt_sniper.mp3" 		-- [声音]
FA__HURT_SNIPER__E1_RES 		= "e_f_hurt_sniper" 			-- [效果]资源文件
FA__HURT_SNIPER__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_SNIPER__E1_PFX			= "e_f_hurt_sniper" 			-- [效果][1阶]帧前缀
FA__HURT_SNIPER__E1_NUM			= 6 							-- [效果][1阶]帧数量
FA__HURT_SNIPER__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_SNIPER__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_SNIPER__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_SNIPER__T1 			= FA__HURT_SNIPER__E1_NUM * FA__HURT_SNIPER__E1_ITV		-- 时间1

-- [伤害]龙息		Class: ActionHurtDrgonBreath
FA__HURT_DRAGON_BREATH__S1 			= "e_f_hurt_dragon_breath.mp3" 		-- [声音]
FA__HURT_DRAGON_BREATH__E1_RES 		= "e_f_hurt_dragon_breath" 			-- [效果]资源文件
FA__HURT_DRAGON_BREATH__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_DRAGON_BREATH__E1_PFX		= "e_f_hurt_dragon_breath" 			-- [效果][1阶]帧前缀
FA__HURT_DRAGON_BREATH__E1_NUM		= 11 							-- [效果][1阶]帧数量
FA__HURT_DRAGON_BREATH__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_DRAGON_BREATH__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_DRAGON_BREATH__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_DRAGON_BREATH__T1 			= FA__HURT_DRAGON_BREATH__E1_NUM * FA__HURT_DRAGON_BREATH__E1_ITV		-- 时间1


-- [伤害]奥素冲击		Class: ActionHurtArcaneBlast
FA__HURT_ARCANE_BLOST__S1 			= "e_f_hurt_arcane_blast.mp3" 		-- [声音]
FA__HURT_ARCANE_BLOST__E1_RES 		= "e_f_hurt_arcane_blast" 			-- [效果]资源文件
FA__HURT_ARCANE_BLOST__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_ARCANE_BLOST__E1_PFX		= "e_f_hurt_arcane_blast" 			-- [效果][1阶]帧前缀
FA__HURT_ARCANE_BLOST__E1_NUM		= 6 							-- [效果][1阶]帧数量
FA__HURT_ARCANE_BLOST__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_ARCANE_BLOST__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_ARCANE_BLOST__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_ARCANE_BLOST__T1 			= FA__HURT_ARCANE_BLOST__E1_NUM * FA__HURT_ARCANE_BLOST__E1_ITV		-- 时间1

-- [伤害]末日		Class: ActionHurtEndDay
FA__HURT_ENDDAY__S1 			= "e_f_hurt_sniper.mp3" 		-- [声音]
FA__HURT_ENDDAY__E1_RES 		= "e_f_ctn_endday" 				-- [效果]资源文件
FA__HURT_ENDDAY__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_ENDDAY__E1_PFX			= "e_f_ctn_endday" 				-- [效果][1阶]帧前缀
FA__HURT_ENDDAY__E1_NUM			= 5 							-- [效果][1阶]帧数量
FA__HURT_ENDDAY__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_ENDDAY__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_ENDDAY__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_ENDDAY__T1 			= FA__HURT_ENDDAY__E1_NUM * FA__HURT_ENDDAY__E1_ITV	

-- [伤害]裂魂		Class: ActionHurtSplitSoul
FA__HURT_SPLIT_SOUL__S1 			= "e_f_hurt_sniper.mp3" 		-- [声音]
FA__HURT_SPLIT_SOUL__E1_RES 		= "e_f_hurt_splitsoul" 			-- [效果]资源文件
FA__HURT_SPLIT_SOUL__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_SPLIT_SOUL__E1_PFX			= "e_f_hurt_splitsoul" 			-- [效果][1阶]帧前缀
FA__HURT_SPLIT_SOUL__E1_NUM			= 19 							-- [效果][1阶]帧数量
FA__HURT_SPLIT_SOUL__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_SPLIT_SOUL__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_SPLIT_SOUL__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_SPLIT_SOUL__T1 			= FA__HURT_SNIPER__E1_NUM * FA__HURT_SNIPER__E1_ITV		-- 时间1

-- [伤害]陷阱		Class: ActionHurtTrap
FA__HURT_TRAP__S1 			= "e_f_hurt_trap.mp3" 			-- [声音]
FA__HURT_TRAP__E1_RES 		= "e_f_hurt_trap" 				-- [效果]资源文件
FA__HURT_TRAP__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_TRAP__E1_PFX		= "e_f_hurt_trap" 				-- [效果][1阶]帧前缀
FA__HURT_TRAP__E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__HURT_TRAP__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_TRAP__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_TRAP__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_TRAP__T1 			= FA__HURT_TRAP__E1_NUM * FA__HURT_TRAP__E1_ITV		-- 时间1

-- [伤害]撕裂		Class: ActionHurtTear
FA__HURT_TEAR__S1 			= "e_f_hurt_tear.mp3" 			-- [声音]
FA__HURT_TEAR__E1_RES 		= "e_f_hurt_tear" 				-- [效果]资源文件
FA__HURT_TEAR__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_TEAR__E1_PFX		= "e_f_hurt_tear" 				-- [效果][1阶]帧前缀
FA__HURT_TEAR__E1_NUM		= 3 							-- [效果][1阶]帧数量
FA__HURT_TEAR__E1_ITV 		= (1.0 / 12) 					-- [效果][1阶]帧间隔
FA__HURT_TEAR__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_TEAR__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_TEAR__T1 			= FA__HURT_TEAR__E1_NUM * FA__HURT_TEAR__E1_ITV		-- 时间1

-- [伤害]横扫		Class: ActionHurtSweepAway
FA__HURT_SWEEPAWAY__S1 			= "e_f_hurt_sweepaway.mp3" 		-- [声音]
FA__HURT_SWEEPAWAY__E1_RES 		= "e_f_hurt_sweepaway" 			-- [效果]资源文件
FA__HURT_SWEEPAWAY__E1_Z 		= 0 							-- [效果]Z值
FA__HURT_SWEEPAWAY__E1_PFX		= "e_f_hurt_sweepaway" 			-- [效果][1阶]帧前缀
FA__HURT_SWEEPAWAY__E1_NUM		= 16 							-- [效果][1阶]帧数量
FA__HURT_SWEEPAWAY__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_SWEEPAWAY__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_SWEEPAWAY__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_SWEEPAWAY__T1 			= FA__HURT_SWEEPAWAY__E1_NUM * FA__HURT_SWEEPAWAY__E1_ITV		-- 时间1

-- [伤害]秒杀		Class: ActionHurtSpike
FA__HURT_SPIKE__S1 				= "e_f_hurt_spike.mp3" 			-- [声音]
FA__HURT_SPIKE__E1_RES 			= "e_f_hurt_spike" 				-- [效果]资源文件
FA__HURT_SPIKE__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_SPIKE__E1_PFX			= "e_f_hurt_spike" 				-- [效果][1阶]帧前缀
FA__HURT_SPIKE__E1_NUM			= 11 							-- [效果][1阶]帧数量
FA__HURT_SPIKE__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_SPIKE__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_SPIKE__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_SPIKE__T1 				= FA__HURT_SPIKE__E1_NUM * FA__HURT_SPIKE__E1_ITV		-- 时间1

-- [伤害]隐盾		Class: ActionHurtStealth
FA__HURT_STEALTH__S1 				= "e_f_hurt_stealth.mp3" 		-- [声音]
FA__HURT_STEALTH__E1_RES 			= "e_f_hurt_stealth" 			-- [效果]资源文件
FA__HURT_STEALTH__E1_Z 				= 0 							-- [效果]Z值
FA__HURT_STEALTH__E1_PFX			= "e_f_hurt_stealth" 			-- [效果][1阶]帧前缀
FA__HURT_STEALTH__E1_NUM			= 18 							-- [效果][1阶]帧数量
FA__HURT_STEALTH__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_STEALTH__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_STEALTH__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_STEALTH__T1 				= FA__HURT_STEALTH__E1_NUM * FA__HURT_STEALTH__E1_ITV		-- 时间1

-- [伤害]狙击		Class: ActionHurtLunarEclipse
FA__HURT_LUNAR_ECLIPSE__S1 			= "e_f_hurt_le.mp3" 				-- [声音]
FA__HURT_LUNAR_ECLIPSE__E1_RES 		= "e_f_hurt_le" 					-- [效果]资源文件
FA__HURT_LUNAR_ECLIPSE__E1_Z 		= 0 								-- [效果]Z值
FA__HURT_LUNAR_ECLIPSE__E1_PFX		= "e_f_hurt_le" 					-- [效果][1阶]帧前缀
FA__HURT_LUNAR_ECLIPSE__E1_NUM		= 21 								-- [效果][1阶]帧数量
FA__HURT_LUNAR_ECLIPSE__E1_ITV 		= FA_A_INTERVAL 					-- [效果][1阶]帧间隔
FA__HURT_LUNAR_ECLIPSE__E1_OS 		= acp(0, 0) 						-- [效果][1阶]位移[起始]
FA__HURT_LUNAR_ECLIPSE__E1_OE 		= acp(0, 0) 						-- [效果][1阶]位移[结束]
FA__HURT_LUNAR_ECLIPSE__T  			= FA__HURT_LUNAR_ECLIPSE__E1_NUM * FA__HURT_LUNAR_ECLIPSE__E1_ITV		-- 时间1
FA__HURT_LUNAR_ECLIPSE__T1 			= FA__HURT_LUNAR_ECLIPSE__T * .6 	-- 时间1[偏移]
FA__HURT_LUNAR_ECLIPSE__T2 			= FA__HURT_LUNAR_ECLIPSE__T - FA__HURT_LUNAR_ECLIPSE__T1 	-- 时间2[攻击旋转－目标]
FA__HURT_LUNAR_ECLIPSE__O1 			= acp(0, 10) 						-- 位移1

-- [增效]血		Class: ActionIncBlood
FA__INC_BLOOD__S1 			= "e_f_inc_blood.mp3" 			-- [声音]
FA__INC_BLOOD__E1_RES 		= "e_f_inc_blood" 				-- [效果]资源文件
FA__INC_BLOOD__E1_Z 		= 0 							-- [效果]Z值
FA__INC_BLOOD__E1_PFX		= "e_f_inc_blood" 				-- [效果][1阶]帧前缀
FA__INC_BLOOD__E1_NUM		= 11 							-- [效果][1阶]帧数量
FA__INC_BLOOD__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__INC_BLOOD__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__INC_BLOOD__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__INC_BLOOD__T1 			= FA__INC_BLOOD__E1_NUM * FA__INC_BLOOD__E1_ITV		-- 时间1

-- [增效]攻击		Class: ActionIncAttack
FA__INC_ATTACK__S1 			= "e_f_inc_attack.mp3" 			-- [声音]
FA__INC_ATTACK__E1_RES 		= "e_f_inc_attack" 				-- [效果]资源文件
FA__INC_ATTACK__E1_Z 		= 0 							-- [效果]Z值
FA__INC_ATTACK__E1_PFX		= "e_f_inc_attack" 				-- [效果][1阶]帧前缀
FA__INC_ATTACK__E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__INC_ATTACK__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__INC_ATTACK__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__INC_ATTACK__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__INC_ATTACK__T1 			= FA__INC_ATTACK__E1_NUM * FA__INC_ATTACK__E1_ITV		-- 时间1

-- [增效]暴击		Class: ActionIncCrit
FA__INC_CRIT__S1 			= "e_f_inc_crit.mp3" 			-- [声音]
FA__INC_CRIT__E1_RES 		= "e_f_inc_crit" 				-- [效果]资源文件
FA__INC_CRIT__E1_Z 			= 0 							-- [效果]Z值
FA__INC_CRIT__E1_PFX		= "e_f_inc_crit" 				-- [效果][1阶]帧前缀
FA__INC_CRIT__E1_NUM		= 11 							-- [效果][1阶]帧数量
FA__INC_CRIT__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__INC_CRIT__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__INC_CRIT__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__INC_CRIT__T1 			= FA__INC_CRIT__E1_NUM * FA__INC_CRIT__E1_ITV		-- 时间1

-- [减效]血		Class: ActionDecBlood
FA__DEC_BLOOD__S1 			= "e_f_dec_blood.mp3" 			-- [声音]
FA__DEC_BLOOD__E1_RES 		= "e_f_dec_blood" 				-- [效果]资源文件
FA__DEC_BLOOD__E1_Z 		= 0 							-- [效果]Z值
FA__DEC_BLOOD__E1_PFX		= "e_f_dec_blood" 				-- [效果][1阶]帧前缀
FA__DEC_BLOOD__E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__DEC_BLOOD__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__DEC_BLOOD__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__DEC_BLOOD__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__DEC_BLOOD__T1 			= FA__DEC_BLOOD__E1_NUM * FA__DEC_BLOOD__E1_ITV		-- 时间1

-- [减效]物理		Class: ActionDecAttack
FA__DEC_ATTACK__S1 			= "e_f_dec_attack.mp3" 			-- [声音]
FA__DEC_ATTACK__E1_RES 		= "e_f_dec_attack" 				-- [效果]资源文件
FA__DEC_ATTACK__E1_Z 		= 0 							-- [效果]Z值
FA__DEC_ATTACK__E1_PFX		= "e_f_dec_attack" 				-- [效果][1阶]帧前缀
FA__DEC_ATTACK__E1_NUM		= 8 							-- [效果][1阶]帧数量
FA__DEC_ATTACK__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__DEC_ATTACK__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__DEC_ATTACK__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__DEC_ATTACK__T1 			= FA__DEC_ATTACK__E1_NUM * FA__DEC_ATTACK__E1_ITV		-- 时间1

-- [减效]魔法		Class: ActionDecMagic
FA__DEC_MAGIC__S1 			= "e_f_dec_magic.mp3" 			-- [声音]
FA__DEC_MAGIC__E1_RES 		= "e_f_dec_magic" 				-- [效果]资源文件
FA__DEC_MAGIC__E1_Z 		= 0 							-- [效果]Z值
FA__DEC_MAGIC__E1_PFX		= "e_f_dec_magic" 				-- [效果][1阶]帧前缀
FA__DEC_MAGIC__E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__DEC_MAGIC__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__DEC_MAGIC__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__DEC_MAGIC__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__DEC_MAGIC__T1 			= FA__DEC_MAGIC__E1_NUM * FA__DEC_MAGIC__E1_ITV		-- 时间1

-- [减效]盾墙		Class: ActionDecShieldWall
FA__DEC_SHIELDWALL__S1 			= "e_f_dec_shieldwall.mp3" 			-- [声音]
FA__DEC_SHIELDWALL__E1_RES 		= "e_f_dec_shieldwall" 				-- [效果]资源文件
FA__DEC_SHIELDWALL__E1_Z 		= 0 							-- [效果]Z值
FA__DEC_SHIELDWALL__E1_PFX		= "e_f_dec_shieldwall" 				-- [效果][1阶]帧前缀
FA__DEC_SHIELDWALL__E1_NUM		= 8 							-- [效果][1阶]帧数量
FA__DEC_SHIELDWALL__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__DEC_SHIELDWALL__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__DEC_SHIELDWALL__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__DEC_SHIELDWALL__T1 			= FA__DEC_SHIELDWALL__E1_NUM * FA__DEC_SHIELDWALL__E1_ITV		-- 时间1


-- [固定]血		Class: ActionFixBlood
-- ..

-- [固定]攻击		Class: ActionFixAttack
FA__FIX_ATTACK__C_ATK_B	 	= ccc3(  0,   0,   0) 	-- 颜色[攻击力－起始]
FA__FIX_ATTACK__C_ATK_E 	= ccc3(  0,   0,   0) 	-- 颜色[攻击力－结束]
FA__FIX_ATTACK__C_HP_B	 	= ccc3(  0,   0,   0) 	-- 颜色[血 量－起始]
FA__FIX_ATTACK__C_HP_E		= ccc3(  0,   0,   0) 	-- 颜色[血 量－结束]

-- [反弹]血(赤谷)	Class: ActionRebBlood
FA__REB_BLOOD__S1 				= "e_f_reb_bloodup.mp3" 		-- [声音]
FA__REB_BLOOD__E1_RES 			= "e_f_reb_blood" 				-- [效果]资源文件
FA__REB_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__REB_BLOOD__E1_PFX			= "e_f_reb_blood" 				-- [效果][1阶]帧前缀
FA__REB_BLOOD__E1_NUM			= 15 							-- [效果][1阶]帧数量
FA__REB_BLOOD__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_BLOOD__T1 				= FA__REB_BLOOD__E1_NUM * FA__REB_BLOOD__E1_ITV		-- 时间1

-- [反弹]血(+)[赤谷]	Class: ActionRebBloodUp
FA__REB_BLOODUP__S1 			= "e_f_reb_bloodup.mp3" 		-- [声音]
FA__REB_BLOODUP__E1_RES 		= "e_f_reb_bloodup"				-- [效果]资源文件
FA__REB_BLOODUP__E1_Z 			= 0 							-- [效果]Z值
FA__REB_BLOODUP__E1_PFX			= "e_f_reb_bloodup" 			-- [效果][1阶]帧前缀
FA__REB_BLOODUP__E1_NUM			= 5 							-- [效果][1阶]帧数量
FA__REB_BLOODUP__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_BLOODUP__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_BLOODUP__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_BLOODUP__T1 			= FA__REB_BLOODUP__E1_NUM * FA__REB_BLOODUP__E1_ITV		-- 时间1

-- [反弹]血(-)[赤谷]	Class: ActionRebBloodDown
FA__REB_BLOODDOWN__S1 			= "e_f_hurt_sweepaway.mp3" 		-- [声音]
FA__REB_BLOODDOWN__E1_RES 		= "e_f_reb_blooddown"			-- [效果]资源文件
FA__REB_BLOODDOWN__E1_Z 		= 0 							-- [效果]Z值
FA__REB_BLOODDOWN__E1_PFX		= "e_f_reb_blooddown" 			-- [效果][1阶]帧前缀
FA__REB_BLOODDOWN__E1_NUM		= 9 							-- [效果][1阶]帧数量
FA__REB_BLOODDOWN__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_BLOODDOWN__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_BLOODDOWN__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_BLOODDOWN__T1 			= FA__REB_BLOODDOWN__E1_NUM * FA__REB_BLOODDOWN__E1_ITV		-- 时间1

-- [反弹]攻击		Class: ActionRebAttack
FA__REB_ATTACK__S1_1 			= "e_f_reb_attack1.mp3" 		-- [声音]
FA__REB_ATTACK__E1_1_RES 		= "e_f_reb_attack1"				-- [效果]资源文件
FA__REB_ATTACK__E1_1_Z 			= 0 							-- [效果]Z值
FA__REB_ATTACK__E1_1_PFX		= "e_f_reb_attack1"				-- [效果][1阶]帧前缀
FA__REB_ATTACK__E1_1_NUM		= 13 							-- [效果][1阶]帧数量
FA__REB_ATTACK__E1_1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_ATTACK__E1_1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_ATTACK__E1_1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_ATTACK__T1_1 			= FA__REB_ATTACK__E1_1_NUM * FA__REB_ATTACK__E1_1_ITV		-- 时间1
FA__REB_ATTACK__S1_N 			= "e_f_reb_attackn.mp3" 		-- [声音]
FA__REB_ATTACK__E1_N_RES 		= "e_f_reb_attackn"				-- [效果]资源文件
FA__REB_ATTACK__E1_N_Z 			= 0 							-- [效果]Z值
FA__REB_ATTACK__E1_N_PFX		= "e_f_reb_attackn_"			-- [效果][1阶]帧前缀
FA__REB_ATTACK__E1_N_NUM		= 10 							-- [效果][1阶]帧数量
FA__REB_ATTACK__E1_N_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_ATTACK__E1_N_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_ATTACK__E1_N_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_ATTACK__T1_N 			= FA__REB_ATTACK__E1_N_NUM * FA__REB_ATTACK__E1_N_ITV		-- 时间1

-- [反弹]魔法		Class: ActionRebMagic
FA__REB_MAGIC__S1 				= "e_f_reb_magic.mp3" 			-- [声音]
FA__REB_MAGIC__E1_RES 			= "e_f_reb_magic" 				-- [效果]资源文件
FA__REB_MAGIC__E1_Z 			= 0 							-- [效果]Z值
FA__REB_MAGIC__E1_PFX			= "e_f_reb_magic" 				-- [效果][1阶]帧前缀
FA__REB_MAGIC__E1_NUM			= 12 							-- [效果][1阶]帧数量
FA__REB_MAGIC__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__REB_MAGIC__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__REB_MAGIC__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__REB_MAGIC__T1 				= FA__REB_MAGIC__E1_NUM * FA__REB_MAGIC__E1_ITV		-- 时间1

-- [其他]克制		Class: ActionOthRestraint
-- ..

-- [其他]召唤		Class: ActionOthSummon
-- [V1]
FA__OTH_SUMMON__S1 			= "e_f_oth_summon.mp3" 			-- [声音]
FA__OTH_SUMMON__E1_RES 		= "e_f_oth_summon" 				-- [效果]资源文件
FA__OTH_SUMMON__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_SUMMON__E1_PFX		= "e_f_oth_summon" 				-- [效果][1阶]帧前缀
FA__OTH_SUMMON__E1_NUM		= 9 							-- [效果][1阶]帧数量
FA__OTH_SUMMON__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_SUMMON__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_SUMMON__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_SUMMON__T1 			= FA__OTH_SUMMON__E1_NUM * FA__OTH_SUMMON__E1_ITV		-- 时间1
-- [V2]
FA__OTH_SUMMON2__S1 		= "e_f_oth_summon.mp3" 			-- [声音]
FA__OTH_SUMMON2__E1_RES 	= "e_f_oth_summon2" 			-- [效果]资源文件
FA__OTH_SUMMON2__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_SUMMON2__E1_PFX		= "e_f_oth_summon2" 			-- [效果][1阶]帧前缀
FA__OTH_SUMMON2__E1_NUM		= 6 							-- [效果][1阶]帧数量
FA__OTH_SUMMON2__E1_ITV 	= (1.0 / 12) 					-- [效果][1阶]帧间隔
FA__OTH_SUMMON2__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_SUMMON2__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_SUMMON2__T1 		= FA__OTH_SUMMON2__E1_NUM * FA__OTH_SUMMON2__E1_ITV		-- 时间1

-- [其他]自爆		Class: ActionOthSelfBomb
FA__OTH_SELFBOMB__S1 			= "e_f_oth_selfbomb.mp3" 		-- [声音]
FA__OTH_SELFBOMB__E1_RES 		= "e_f_oth_selfbomb" 			-- [效果]资源文件
FA__OTH_SELFBOMB__E1_Z 			= 0 							-- [效果]Z值
FA__OTH_SELFBOMB__E1_PFX		= "e_f_oth_selfbomb" 			-- [效果][1阶]帧前缀
FA__OTH_SELFBOMB__E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__OTH_SELFBOMB__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_SELFBOMB__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_SELFBOMB__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_SELFBOMB__T1 			= FA__OTH_SELFBOMB__E1_NUM * FA__OTH_SELFBOMB__E1_ITV		-- 时间1

-- [其他]免疫		Class: ActionOthImmunityAll
FA__OTH_IMMUNITYALL__S1 			= "e_f_oth_immunityall.mp3" 	-- [声音]
FA__OTH_IMMUNITYALL__E1_RES 		= "e_f_oth_immunityall" 		-- [效果]资源文件
FA__OTH_IMMUNITYALL__E1_Z 			= 0 							-- [效果]Z值
FA__OTH_IMMUNITYALL__E1_PFX			= "e_f_oth_immunityall" 		-- [效果][1阶]帧前缀
FA__OTH_IMMUNITYALL__E1_NUM			= 8 							-- [效果][1阶]帧数量
FA__OTH_IMMUNITYALL__E1_ITV 		= (1.0 / 16) 					-- [效果][1阶]帧间隔
FA__OTH_IMMUNITYALL__E1_OS 			= acp(-10, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_IMMUNITYALL__E1_OE 			= acp(-10, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_IMMUNITYALL__T1 			= FA__OTH_IMMUNITYALL__E1_NUM * FA__OTH_IMMUNITYALL__E1_ITV		-- 时间1

-- [其他]免疫		Class: ActionOthImmunityMagic 
FA__OTH_IMMUNITYMAGIC__S1 			= "e_f_oth_immunitymagic.mp3" 	-- [声音]
FA__OTH_IMMUNITYMAGIC__E1_RES 		= "e_f_oth_immunitymagic" 		-- [效果]资源文件
FA__OTH_IMMUNITYMAGIC__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_IMMUNITYMAGIC__E1_PFX		= "e_f_oth_immunitymagic" 		-- [效果][1阶]帧前缀
FA__OTH_IMMUNITYMAGIC__E1_NUM		= 10 							-- [效果][1阶]帧数量
FA__OTH_IMMUNITYMAGIC__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_IMMUNITYMAGIC__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_IMMUNITYMAGIC__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_IMMUNITYMAGIC__T1 			= FA__OTH_IMMUNITYMAGIC__E1_NUM * FA__OTH_IMMUNITYMAGIC__E1_ITV		-- 时间1

-- [其他]MISS	Class: ActionOthMiss
FA__OTH_MISS__S1 			= "e_f_oth_miss.mp3" 			-- [声音]
FA__OTH_MISS__E1_RES 		= "e_f_oth_miss" 				-- [效果]资源文件
FA__OTH_MISS__E1_Z 			= 0 							-- [效果]Z值
FA__OTH_MISS__E1_PFX		= "e_f_oth_miss" 				-- [效果][1阶]帧前缀
FA__OTH_MISS__E1_NUM		= 6 							-- [效果][1阶]帧数量
FA__OTH_MISS__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_MISS__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_MISS__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_MISS__T1 			= FA__OTH_MISS__E1_NUM * FA__OTH_MISS__E1_ITV		-- 时间1

-- [其他]鼓舞加血	Class: ActionOthEncouragedBlood
FA__OTH_ENCOURAGEDBLOOD__S1 		= "e_f_oth_eb.mp3" 			-- [声音]
FA__OTH_ENCOURAGEDBLOOD__E1_RES 	= "e_f_oth_eb" 					-- [效果]资源文件
FA__OTH_ENCOURAGEDBLOOD__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_ENCOURAGEDBLOOD__E1_PFX		= "e_f_oth_eb" 					-- [效果][1阶]帧前缀
FA__OTH_ENCOURAGEDBLOOD__E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__OTH_ENCOURAGEDBLOOD__E1_ITV 	= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_ENCOURAGEDBLOOD__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_ENCOURAGEDBLOOD__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_ENCOURAGEDBLOOD__T1 		= FA__OTH_ENCOURAGEDBLOOD__E1_NUM * FA__OTH_ENCOURAGEDBLOOD__E1_ITV		-- 时间1

-- [其他]鼓舞加攻	Class: ActionOthEncouragedAttack
FA__OTH_ENCOURAGEDATTACK__S1 			= "e_f_oth_et.mp3" 			-- [声音]
-- [种族1]
FA__OTH_ENCOURAGEDATTACK__1_E1_RES 		= "e_f_oth_et1" 				-- [效果]资源文件
FA__OTH_ENCOURAGEDATTACK__1_E1_Z 		= 0 							-- [效果]Z值
FA__OTH_ENCOURAGEDATTACK__1_E1_PFX		= "e_f_oth_et1" 				-- [效果][1阶]帧前缀
FA__OTH_ENCOURAGEDATTACK__1_E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__OTH_ENCOURAGEDATTACK__1_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_ENCOURAGEDATTACK__1_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_ENCOURAGEDATTACK__1_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_ENCOURAGEDATTACK__1_T1 			= FA__OTH_ENCOURAGEDATTACK__1_E1_NUM * FA__OTH_ENCOURAGEDATTACK__1_E1_ITV		-- 时间1
-- [种族2]
FA__OTH_ENCOURAGEDATTACK__2_E1_RES 		= "e_f_oth_et2" 				-- [效果]资源文件
FA__OTH_ENCOURAGEDATTACK__2_E1_Z 		= 0 							-- [效果]Z值
FA__OTH_ENCOURAGEDATTACK__2_E1_PFX		= "e_f_oth_et2" 				-- [效果][1阶]帧前缀
FA__OTH_ENCOURAGEDATTACK__2_E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__OTH_ENCOURAGEDATTACK__2_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_ENCOURAGEDATTACK__2_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_ENCOURAGEDATTACK__2_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_ENCOURAGEDATTACK__2_T1 			= FA__OTH_ENCOURAGEDATTACK__2_E1_NUM * FA__OTH_ENCOURAGEDATTACK__2_E1_ITV		-- 时间1
-- [种族3]
FA__OTH_ENCOURAGEDATTACK__3_E1_RES 		= "e_f_oth_et3" 				-- [效果]资源文件
FA__OTH_ENCOURAGEDATTACK__3_E1_Z 		= 0 							-- [效果]Z值
FA__OTH_ENCOURAGEDATTACK__3_E1_PFX		= "e_f_oth_et3" 				-- [效果][1阶]帧前缀
FA__OTH_ENCOURAGEDATTACK__3_E1_NUM		= 13 							-- [效果][1阶]帧数量
FA__OTH_ENCOURAGEDATTACK__3_E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_ENCOURAGEDATTACK__3_E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_ENCOURAGEDATTACK__3_E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_ENCOURAGEDATTACK__3_T1 			= FA__OTH_ENCOURAGEDATTACK__3_E1_NUM * FA__OTH_ENCOURAGEDATTACK__3_E1_ITV		-- 时间1

-- [其他]格挡		Class: ActionOthBlock
--[[
FA__OTH_BLOCK__S_T 			= .1 						-- [效果][盾]时间
FA__OTH_BLOCK__S_T_CLEAN 	= .5 						-- [效果][盾]时间清除
FA__OTH_BLOCK__L_T 			= .1 						-- [效果][光]时间
FA__OTH_BLOCK__L_T_CLEAN 	= .2 						-- [效果][光]时间清除
--]]
FA__OTH_BLOCK__S1 			= "e_f_oth_block.mp3" 			-- [声音]
FA__OTH_BLOCK__E1_RES 		= "e_f_oth_block" 				-- [效果]资源文件
FA__OTH_BLOCK__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_BLOCK__E1_PFX		= "e_f_oth_block" 				-- [效果][1阶]帧前缀
FA__OTH_BLOCK__E1_NUM		= 10 							-- [效果][1阶]帧数量
FA__OTH_BLOCK__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_BLOCK__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_BLOCK__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_BLOCK__T1 			= FA__OTH_BLOCK__E1_NUM * FA__OTH_BLOCK__E1_ITV		-- 时间1

-- [其他]送还		Class: ActionOthGiveBack
FA__OTH_GIVE_BACK__S1 			= "e_f_oth_giveback.mp3" 		-- [声音]
FA__OTH_GIVE_BACK__E1_RES 		= "e_f_oth_giveback" 			-- [效果]资源文件
FA__OTH_GIVE_BACK__E1_Z 		= 0 							-- [效果]Z值
FA__OTH_GIVE_BACK__E1_PFX		= "e_f_oth_giveback" 			-- [效果][1阶]帧前缀
FA__OTH_GIVE_BACK__E1_NUM		= 10 							-- [效果][1阶]帧数量
FA__OTH_GIVE_BACK__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_GIVE_BACK__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_GIVE_BACK__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_GIVE_BACK__T1 			= FA__OTH_GIVE_BACK__E1_NUM * FA__OTH_GIVE_BACK__E1_ITV		-- 时间1


-- [其他]洗礼		Class: ActionOthBaptism
FA__OTH_BAPTISM__S1 			= "e_f_oth_baptism.mp3" 		-- [声音]
FA__OTH_BAPTISM__E1__RES 		= "e_f_oth_baptism" 			-- [效果]资源文件
FA__OTH_BAPTISM__E1__Z 		    = 0 							-- [效果]Z值
FA__OTH_BAPTISM__E1__PFX		    = "e_f_oth_baptism" 			-- [效果][1阶]帧前缀
FA__OTH_BAPTISM__E1__NUM		    = 12 							-- [效果][1阶]帧数量
FA__OTH_BAPTISM__E1__ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__OTH_BAPTISM__E1__OS 		    = acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__OTH_BAPTISM__E1__OE 		    = acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__OTH_BAPTISM__T1 			= FA__OTH_BAPTISM__E1__NUM * FA__OTH_BAPTISM__E1__ITV		-- 时间1

-- [持续]普通		Class: ActionCtnNormal
-- ..

-- [持续]火		Class: ActionCtnFire
FA__CTN_FIRE__S1 			= "e_f_ctn_fire2.mp3" 			-- [声音]
FA__CTN_FIRE__E1_RES 		= "e_f_ctn_fire" 				-- [效果][1阶]资源文件
FA__CTN_FIRE__E1_Z 			= 0 							-- [效果][1阶]Z值
FA__CTN_FIRE__E1_PFX		= "e_f_ctn_fire" 				-- [效果][1阶]帧前缀
FA__CTN_FIRE__E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__CTN_FIRE__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_FIRE__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_FIRE__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_FIRE__T1 			= FA__CTN_FIRE__E1_NUM * FA__CTN_FIRE__E1_ITV		-- 时间1
FA__CTN_FIRE__E2_RES 		= "e_f_ctn_fire_2" 				-- [效果][2阶]资源文件
FA__CTN_FIRE__E2_Z 			= 0 							-- [效果][2阶]Z值
FA__CTN_FIRE__E2_PFX		= "e_f_ctn_fire_2_" 			-- [效果][2阶]帧前缀
FA__CTN_FIRE__E2_NUM		= 15 							-- [效果][2阶]帧数量
FA__CTN_FIRE__E2_ITV 		= FA_A_INTERVAL 				-- [效果][2阶]帧间隔
FA__CTN_FIRE__E2_OS 		= acp(0, 0) 					-- [效果][2阶]位移[起始]
FA__CTN_FIRE__E2_OE 		= acp(0, 0) 					-- [效果][2阶]位移[结束]
FA__CTN_FIRE__T2 			= FA__CTN_FIRE__E2_NUM * FA__CTN_FIRE__E2_ITV		-- 时间1
FA__CTN_FIRE__ISSUSTAINED 	= true

-- [持续]冰		Class: ActionCtnIce
FA__CTN_ICE__S1 			= "e_f_ctn_ice.mp3" 			-- [声音]
FA__CTN_ICE__E1_RES 		= "e_f_ctn_ice" 				-- [效果]资源文件
FA__CTN_ICE__E1_Z 			= 0 							-- [效果]Z值
FA__CTN_ICE__E1_PFX			= "e_f_ctn_ice" 				-- [效果][1阶]帧前缀
FA__CTN_ICE__E1_NUM			= 13 							-- [效果][1阶]帧数量
FA__CTN_ICE__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_ICE__E1_OS 			= acp(20, 50) 					-- [效果][1阶]位移[起始]
FA__CTN_ICE__E1_OE 			= acp(20, 50) 					-- [效果][1阶]位移[结束]
FA__CTN_ICE__E1_STN 		= true							-- [效果][1阶]持续标识
FA__CTN_ICE__T1 			= FA__CTN_ICE__E1_NUM * FA__CTN_ICE__E1_ITV		-- 时间1


-- [持续]末日		Class: ActionCtnEndDay
FA__CTN_END_DAY__S1 			= "e_f_ctn_ice.mp3" 			-- [声音]
FA__CTN_END_DAY__E1_RES 		= "e_f_ctn_endday" 				-- [效果]资源文件
FA__CTN_END_DAY__E1_Z 	        = 0 							-- [效果]Z值
FA__CTN_END_DAY__E1_PFX		    = "e_f_ctn_endday" 				-- [效果][1阶]帧前缀
FA__CTN_END_DAY__E1_NUM		    = 5 							-- [效果][1阶]帧数量
FA__CTN_END_DAY__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_END_DAY__E1_OS 		    = acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_END_DAY__E1_OE 		    = acp(0, -30) 					-- [效果][1阶]位移[结束]
FA__CTN_END_DAY__E1_STN 		= true							-- [效果][1阶]持续标识
FA__CTN_END_DAY__T1 			= FA__CTN_END_DAY__E1_NUM * FA__CTN_END_DAY__E1_ITV		-- 时间1

-- [持续]封印		Class: ActionCtnSeal
--[[
FA__CTN_SEAL__S_T 			= .1 						-- [效果][盾]时间
FA__CTN_SEAL__S_T_CLEAN 	= .5 						-- [效果][盾]时间清除
FA__CTN_SEAL__S_L_T 		= .1 						-- [效果][光]时间
FA__CTN_SEAL__S_L_T_CLEAN 	= .2 						-- [效果][光]时间清除
]]
FA__CTN_SEAL__S1 			= "e_f_ctn_seal.mp3" 			-- [声音]
FA__CTN_SEAL__E1_RES 		= "e_f_ctn_seal" 				-- [效果]资源文件
FA__CTN_SEAL__E1_Z 			= 0 							-- [效果]Z值
FA__CTN_SEAL__E1_PFX		= "e_f_ctn_seal" 				-- [效果][1阶]帧前缀
FA__CTN_SEAL__E1_NUM		= 15 							-- [效果][1阶]帧数量
FA__CTN_SEAL__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_SEAL__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_SEAL__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_SEAL__E1_STN 		= true							-- [效果][1阶]持续标识
FA__CTN_SEAL__T1 			= FA__CTN_SEAL__E1_NUM * FA__CTN_SEAL__E1_ITV		-- 时间1

-- [持续]电		Class: ActionCtnElectric
FA__CTN_ELECTRIC__S1 			= "e_f_ctn_electric.mp3" 		-- [声音]
FA__CTN_ELECTRIC__E1_RES 		= "e_f_ctn_electric" 			-- [效果]资源文件
FA__CTN_ELECTRIC__E1_Z 			= 0 							-- [效果]Z值
FA__CTN_ELECTRIC__E1_PFX		= "e_f_ctn_electric" 			-- [效果][1阶]帧前缀
FA__CTN_ELECTRIC__E1_NUM		= 12 							-- [效果][1阶]帧数量
FA__CTN_ELECTRIC__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_ELECTRIC__E1_OS 		= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_ELECTRIC__E1_OE 		= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_ELECTRIC__E1_STN 		= true							-- [效果][1阶]持续标识
FA__CTN_ELECTRIC__T1 			= FA__CTN_ELECTRIC__E1_NUM * FA__CTN_ELECTRIC__E1_ITV		-- 时间1

-- [持续]血		Class: ActionCtnBlood
-- ..

-- [持续]毒		Class: ActionCtnPoison
FA__CTN_POISON__S1 				= "e_f_ctn_poison.mp3" 			-- [声音]
FA__CTN_POISON__E1_RES 			= "e_f_ctn_poison" 				-- [效果]资源文件
FA__CTN_POISON__E1_Z 			= 0 							-- [效果]Z值
FA__CTN_POISON__E1_PFX			= "e_f_ctn_poison" 				-- [效果][1阶]帧前缀
FA__CTN_POISON__E1_NUM			= 16 							-- [效果][1阶]帧数量
FA__CTN_POISON__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_POISON__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_POISON__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_POISON__E1_STN 			= true							-- [效果][1阶]持续标识
FA__CTN_POISON__T1 				= FA__CTN_POISON__E1_NUM * FA__CTN_POISON__E1_ITV		-- 时间1
FA__CTN_POISON__E2_RES 			= "e_f_ctn_poison2" 			-- [效果]资源文件
FA__CTN_POISON__E2_Z 			= 0 							-- [效果][2阶]Z值
FA__CTN_POISON__E2_PFX			= "e_f_ctn_poison2_" 			-- [效果][2阶]帧前缀
FA__CTN_POISON__E2_NUM			= 15 							-- [效果][2阶]帧数量
FA__CTN_POISON__E2_ITV 			= FA_A_INTERVAL 				-- [效果][2阶]帧间隔
FA__CTN_POISON__E2_OS 			= acp(0, 0) 					-- [效果][2阶]位移[起始]
FA__CTN_POISON__E2_OE 			= acp(0, 0) 					-- [效果][2阶]位移[结束]
FA__CTN_POISON__ISSUSTAINED 	= true 							-- [效果]持续标识

-- [持续]光		Class: ActionCtnBright
-- ..

-- [持续]暗		Class: ActionCtnDark
-- ..

-- [持续]狙击		Class: ActionCtnSniper
-- ..

-- [持续]撕裂 	Class: ActionCtnTear
FA__CTN_TEAR__E1_RES 			= "e_f_ctn_tear" 				-- [效果]资源文件
FA__CTN_TEAR__E1_Z 				= 0 							-- [效果]Z值
FA__CTN_TEAR__E1_PFX			= "e_f_ctn_tear" 				-- [效果][1阶]帧前缀
FA__CTN_TEAR__E1_NUM			= 1 							-- [效果][1阶]帧数量
FA__CTN_TEAR__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_TEAR__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_TEAR__E1_OE 			= acp(480, 320) 					-- [效果][1阶]位移[结束]
FA__CTN_TEAR__E1_STN 			= true 							-- [效果][1阶]持续标识
FA__CTN_TEAR__T1 				= FA__CTN_TEAR__E1_NUM * FA__CTN_TEAR__E1_ITV		-- 时间1

-- [持续]陷阱 	Class: ActionCtnTrap
FA__CTN_TRAP__E1_RES 			= "e_f_ctn_trap" 				-- [效果]资源文件
FA__CTN_TRAP__E1_Z 				= 0 							-- [效果]Z值
FA__CTN_TRAP__E1_PFX			= "e_f_ctn_trap" 				-- [效果][1阶]帧前缀
FA__CTN_TRAP__E1_NUM			= 2 							-- [效果][1阶]帧数量
FA__CTN_TRAP__E1_ITV 			= (1.0 / 3) 					-- [效果][1阶]帧间隔
FA__CTN_TRAP__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_TRAP__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_TRAP__E1_STN 			= true 							-- [效果][1阶]持续标识
FA__CTN_TRAP__T1 				= FA__CTN_TRAP__E1_NUM * FA__CTN_TRAP__E1_ITV		-- 时间1

-- [持续]隐盾		Class: ActionCtnStealth
FA__CTN_STEALTH__S1 			= "e_f_ctn_stealth.mp3" 		-- [声音]
FA__CTN_STEALTH__E1_RES 		= "e_f_ctn_stealth" 			-- [效果]资源文件
FA__CTN_STEALTH__E1_Z 			= 0 							-- [效果]Z值
FA__CTN_STEALTH__E1_PFX			= "e_f_ctn_stealth" 			-- [效果][1阶]帧前缀
FA__CTN_STEALTH__E1_NUM			= 21 							-- [效果][1阶]帧数量
FA__CTN_STEALTH__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__CTN_STEALTH__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__CTN_STEALTH__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__CTN_STEALTH__E1_STN 		= true							-- [效果][1阶]持续标识
FA__CTN_STEALTH__T1 			= FA__CTN_STEALTH__E1_NUM * FA__CTN_STEALTH__E1_ITV		-- 时间1

-- [英雄]扣血		Class: ActionHHurtBlood
FA__H_HURT_BLOOD__S1 		= "e_f_hhurt_blood3.mp3" 			-- [声音]
FA__H_HURT_BLOOD__T1 		= .15 								-- 时间1
FA__H_HURT_BLOOD__T2 		= .35 								-- 时间2
FA__H_HURT_BLOOD__P2 		= acp(0, 30) 						-- 位置2
FA__H_HURT_BLOOD__E_T1 		= .3 								-- 效果－时间1
FA__H_HURT_BLOOD__E_T2 		= .3 								-- 效果－时间2
FA__H_HURT_BLOOD__E_O 		= acp(0, 30) 						-- 效果－偏移量
FA__HERO_HURT_BLOOD__E1_RES 		= "e_f_hero_hurtblood" 			-- [效果]资源文件
FA__HERO_HURT_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HERO_HURT_BLOOD__E1_PFX			= "e_f_hero_hurtblood" 			-- [效果][1阶]帧前缀
FA__HERO_HURT_BLOOD__E1_NUM			= 9 							-- [效果][1阶]帧数量
FA__HERO_HURT_BLOOD__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HERO_HURT_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HERO_HURT_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HERO_HURT_BLOOD__T1 			= FA__HERO_HURT_BLOOD__E1_NUM * FA__HERO_HURT_BLOOD__E1_ITV		-- 时间1

-- [英雄]增血		Class: ActionHIncBlood
FA__HERO_INC_BLOOD__S1 				= "e_f_hinc_blood2.mp3" 		-- [声音]
FA__HERO_INC_BLOOD__E1_RES 			= "e_f_hero_incblood" 			-- [效果]资源文件
FA__HERO_INC_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HERO_INC_BLOOD__E1_PFX			= "e_f_hero_incblood" 			-- [效果][1阶]帧前缀
FA__HERO_INC_BLOOD__E1_NUM			= 15 							-- [效果][1阶]帧数量
FA__HERO_INC_BLOOD__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HERO_INC_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HERO_INC_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HERO_INC_BLOOD__T1 				= FA__HERO_INC_BLOOD__E1_NUM * FA__HERO_INC_BLOOD__E1_ITV		-- 时间1

-- [英雄]减血		Class: ActionHDecBlood
FA__HERO_DEC_BLOOD__S1 				= "e_f_hdec_blood.mp3" 			-- [声音]
FA__HERO_DEC_BLOOD__E1_RES 			= "e_f_hero_decblood" 			-- [效果]资源文件
FA__HERO_DEC_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HERO_DEC_BLOOD__E1_PFX			= "e_f_hero_decblood" 			-- [效果][1阶]帧前缀
FA__HERO_DEC_BLOOD__E1_NUM			= 10 							-- [效果][1阶]帧数量
FA__HERO_DEC_BLOOD__E1_ITV 			= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HERO_DEC_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HERO_DEC_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HERO_DEC_BLOOD__T1 				= FA__HERO_DEC_BLOOD__E1_NUM * FA__HERO_DEC_BLOOD__E1_ITV		-- 时间1

-- [英雄]渐射血	Class: ActionHShotBlood
FA__HERO_SHOT_BLOOD__S1 			= "e_f_hshot_blood.mp3" 		-- [声音]
FA__HERO_SHOT_BLOOD__E1_RES 		= "e_f_hero_shotblood" 			-- [效果]资源文件
FA__HERO_SHOT_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HERO_SHOT_BLOOD__E1_PFX			= "e_f_hero_shotblood" 			-- [效果][1阶]帧前缀
FA__HERO_SHOT_BLOOD__E1_NUM			= 21 							-- [效果][1阶]帧数量
FA__HERO_SHOT_BLOOD__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HERO_SHOT_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HERO_SHOT_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HERO_SHOT_BLOOD__T1 			= FA__HERO_SHOT_BLOOD__E1_NUM * FA__HERO_SHOT_BLOOD__E1_ITV		-- 时间1

-- [英雄]陷阵	Class: ActionHTapBlood
FA__HERO_TRAP_BLOOD__S1 			= "e_f_hshot_blood.mp3" 		-- [声音]
FA__HERO_TRAP_BLOOD__E1_RES 		= "e_f_hero_trapblood" 			-- [效果]资源文件
FA__HERO_TRAP_BLOOD__E1_Z 			= 0 							-- [效果]Z值
FA__HERO_TRAP_BLOOD__E1_PFX			= "e_f_hero_trapblood" 			-- [效果][1阶]帧前缀
FA__HERO_TRAP_BLOOD__E1_NUM			= 8							-- [效果][1阶]帧数量
FA__HERO_TRAP_BLOOD__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HERO_TRAP_BLOOD__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HERO_TRAP_BLOOD__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HERO_TRAP_BLOOD__T1 			= FA__HERO_SHOT_BLOOD__E1_NUM * FA__HERO_SHOT_BLOOD__E1_ITV		-- 时间1

-- [伤害]幻之刃	Class: ActionHurtRegion
FA__HURT_REGION__S1 			= "e_f_hshot_blood.mp3" 		-- [声音]
FA__HURT_REGION__E1_RES 		= "e_f_hurt_region" 			-- [效果]资源文件
FA__HURT_REGION__E1_Z 			= 0 							-- [效果]Z值
FA__HURT_REGION__E1_PFX			= "e_f_hurt_region" 			-- [效果][1阶]帧前缀
FA__HURT_REGION__E1_NUM			= 8							-- [效果][1阶]帧数量
FA__HURT_REGION__E1_ITV 		= FA_A_INTERVAL 				-- [效果][1阶]帧间隔
FA__HURT_REGION__E1_OS 			= acp(0, 0) 					-- [效果][1阶]位移[起始]
FA__HURT_REGION__E1_OE 			= acp(0, 0) 					-- [效果][1阶]位移[结束]
FA__HURT_REGION__T1 			= FA__HURT_REGION__E1_NUM * FA__HURT_REGION__E1_ITV		-- 时间1

-- [操作]值	Class: ActionOptValue
FA__OPT_VALUE__T 			= .3 					-- 时间1
FA__OPT_VALUE__C_ATK_U	 	= ccc3( 30, 144, 255) 	-- 颜色[攻击力－增长]
FA__OPT_VALUE__C_ATK_UE 	= ccc3( 30, 144, 255) 	-- 颜色[攻击力－增长结束]
FA__OPT_VALUE__C_ATK_D 		= ccc3(176,  48,  96) 	-- 颜色[攻击力－减少]
FA__OPT_VALUE__C_ATK_DE 	= ccc3(176,  48,  96) 	-- 颜色[攻击力－减少结束]
FA__OPT_VALUE__C_ATK_WH 	= ccc3(255,  255,  255) 	-- 颜色[攻击力－白色]
FA__OPT_VALUE__C_HP_U	 	= ccc3(  0, 255,   0) 	-- 颜色[血 量－增长]
FA__OPT_VALUE__C_HP_UE		= ccc3(255, 255, 255) 	-- 颜色[血 量－增长结束]
FA__OPT_VALUE__C_HP_D 		= ccc3(227,  23,  13) 	-- 颜色[血 量－减少]
FA__OPT_VALUE__C_HP_DE		= ccc3(255, 255, 255) 	-- 颜色[血 量－减少结束]

-- [系统]校正CD	Class: ActionSystemTurnRound
FA__S_TURN_ROUND__A_T1		= .06 				-- 时间1
FA__S_TURN_ROUND__A_T2		= .06 				-- 时间2

-- [系统]校正CD	Class: ActionSystemCorrectCD
FA__S_CORRECT_CD__A_IS 		= false				-- 动画切换效果标识
FA__S_CORRECT_CD__A_T1		= .05 				-- 时间1
FA__S_CORRECT_CD__A_T2		= .05 				-- 时间2

-- [系统]延迟时间	Class: ActionSystemDelay
FA__S_DELAY__T 				= 0.3				-- 时间




    

    

    

    

    

    

    

    

    
