--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

类包含文件类，定义公共类相关操作方法及逻辑实现。

-   引入预加载类
-   定义类操作扩展

]]


-- [类定义]
-- ..





-- [类包含]
-- [工具]
-- 动画
TDAnimationUtils  			= requireU("TDAnimationUtils")
-- 数组
TDArrayUtils          		= requireU("TDArrayUtils")
-- 断言
TDAssertUtils      			= requireU("TDAssertUtils")
-- 异常
TDExceptionUtils      		= requireU("TDExceptionUtils")
-- 数字
TDNumberUtils     			= requireU("TDNumberUtils")
-- 点
TDPointUtils          		= requireU("TDPointUtils")
-- 定位[点]
acp                   		= TDPointUtils.point
-- 定位[百分比]
acpc                  		= TDPointUtils.percentage
-- 触碰事件
TDTouchUtils      			= requireU("TDTouchUtils")
-- UI
TDUIUtils 					= requireU("TDUIUtils")
-- 随机数
TDRandomUtils 				= requireU("TDRandomUtils")
-- 性能测试
TDPerformanceTestingUtils 	= requireU("TDPerformanceTestingUtils")
-- 陷门
TDHookUtils 				= requireU("TDHookUtils")


-- [工厂]
-- 工厂[卡牌]
CardFactory               	= requireF("CardFactory")


-- [层]
-- 英雄层
FightHerosLayer       		= requireL("FightHerosLayer")
-- 按钮层
FightButtonLayer      		= requireL("FightButtonLayer")
-- 卡牌详情层
CardDetailLayer 			= requireL("CardDetailLayer")
-- 卡牌集层
FightCardSetLayer 			= requireL("FightCardSetLayer")
-- 场上卡牌层
FightCardsUpLayer 			= requireL("FightCardsUpLayer")
-- 场下卡牌层
FightCardsDownLayer 		= requireL("FightCardsDownLayer")
-- 战斗开场层
FightWelcomeLayer 			= requireL("FightWelcomeLayer")
-- 战斗变速层
FightSpeedLayer 			= requireL("FightSpeedLayer")


-- [实体]
-- 实体[战斗接收]
EntityRecFight        		= requireEN("EntityRecFight")
-- 实体[英雄]
EntityHero           		= requireEN("EntityHero")
-- 实体[卡片]
EntityCard            		= requireEN("EntityCard")
-- 实体[技能]
EntitySkill           		= requireEN("EntitySkill")
-- 实体[战斗状态]
EntityFightState           	= require("ccb.m.fight.EntityFightState")


-- [模型]
CardEntity 					= require("model.card.CardEntity")


-- [对象]
-- 血量
Blood 						= requireS("Blood")
-- 回合
Round 						= requireS("Round")
-- 角色名字
HeroName  					= requireS("HeroName")
-- 角色等级
HeroLevel 					= requireS("HeroLevel")
-- 卡片原型
CardPrototype 				= requireCLS("CardPrototype")
-- 卡片原型集
CardPrototypeSet 			= requireCLS("CardPrototypeSet")
-- 卡片玩家
CardPlayer 					= requireCLS("CardPlayer")
-- 墓地
Cemetery 					= requireS("Cemetery")
-- 英雄[欢迎场景]
WelcomeHero 				= requireS("WelcomeHero")
-- 线性数字
LinearNum 					= require("cardui.LinearNum")
-- 线性星星
LinearStar 					= require("cardui.LinearStar")
-- 战斗CD
FightCD 					= requireS("FightCD")


-- [卡牌]
-- 抽象卡牌类
AbstractCard 				= requireS("AbstractCard")
-- 位置卡牌类
LocationCard 				= requireS("LocationCard")
-- 原型卡牌类
PrototypeCard				= requireS("PrototypeCard")
-- 英雄卡牌类
HeroCard 					= requireS("HeroCard")
-- 图标卡牌类
IconCard 					= requireS("IconCard")
-- 图片卡牌类
ImageCard 					= requireS("ImageCard")
-- 下场卡牌类
StageDownCard 				= requireS("StageDownCard")
-- 上场卡牌类
StageUpCard 				= requireS("StageUpCard")


-- [动作]
-- 战斗动作枚举 
ActionEnum 					= requireC("FightActionEnum")
-- 战斗类命名映射
ActionClassNamingMapper 	= requireAS("ActionClassNamingMapper")
-- 战斗类颜色映射
ActionClassColorMapper 		= requireAS("ActionClassColorMapper")
-- 抽象动作
AbstractAction 				= requireAS("AbstractAction")
-- 抽象卡片动作
AbstractFightAction 		= requireAS("AbstractFightAction")
-- 抽象效果卡片动作
AbstractEffectFightAction   = requireAS("AbstractEffectFightAction")
-- 效果卡片动作[单阶段]
EffectActionStep1   		= requireA("EffectActionStep1")
-- 效果卡片动作[两阶段]
EffectActionStep2   		= requireA("EffectActionStep2")
-- 效果卡片动作[消除]
EffectActionEliminate 		= requireA("EffectActionEliminate")
-- 方字卡片动作
ActionBaseText 				= requireA("ActionBaseText")
-- 公共动作
ActionBaseOperate			= requireA("ActionBaseOperate")
-- 抽象战斗解释器
AbstractFightInterpreter 	= requireAS("AbstractFightInterpreter")
-- 战斗动作助手类
FightActionHelper 			= requireC("FightActionHelper").new({ rate = 1 })
-- 战斗动作解释器
FightInterpreter 			= requireA("FightInterpreter").new()
-- 战斗动作扩展类
ActionExtendFacade 			= requireAS("ActionExtendFacade")
-- 位置战斗动作
FightActionPosition 		= requireA("FightActionPosition")
-- 动作[伤害]
ActionHurtNormal 			= requireA("ActionHurtNormal")
-- 动作[操作－数值]
ActionOptValue 				= requireA("ActionOptValue")


-- [网络]
NetHelper             		= requireNET("NetHelper")
-- [Json]
Json                  		= require("framework.shared.json")


