--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

示例效果层类，定义示例效果层相关操作方法及逻辑实现。

-   实现各种3D效果动画效果。
-   存储效果相关信息。

]]

local M = class("DemoEffectLayer", TDLayer)



-- [包含文件]
-- ...



-- [公共参数]
-- [常量]
-- .. 


-- [操作变量]
-- 
local size = CCDirector:sharedDirector():getWinSize()


-- [枚举]
-- ..










-- [私有方法声明]
-- [实例方法][视图渲染]
-- ..
-- [视图析构]
-- ..
-- [效果]
local Shaky3DDemo
local Waves3DDemo
local FlipX3DDemo
local FlipY3DDemo
local Lens3DDemo
local Ripple3DDemo
local LiquidDemo
local WavesDemo
local wirlDemo
local Shakyiles3DDemo
local Shaerediles3DDemo
local ShuffleilesDemo
local FadeOuRilesDemo
local FadeOuBLilesDemo
local FadeOuUpilesDemo
local FadeOuDownilesDemo
local urnOffilesDemo
local Wavesiles3DDemo
local Jumpiles3DDemo
local SpliRowsDemo
local SpliColsDemo
local Pageurn3DDemolocal 

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    -- ..


    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendLayer.extendRenderDestuctor(self)
end










-- [实例方法]
-- [实例方法][视图渲染]
-- 视图渲染
function M:viewRender()
    -- print("DemoEffectLayer:viewRender()")

    local time = 2
    -- 0,2,3,6,7,8,9,10,11,12,13,14,15,16,19,20,21
    local ActionIdx = 2


    -- 1、添加特效结点
    local node = CCNode:create()
    local effect = createEffect(ActionIdx, time)
    node:runAction(effect)
    self:addChild(node, 0)



    -- 2、添加普通结点
    local card = display.newSprite("fight/card/f_c_image.png")
    node:addChild(card)
    card:setPosition(ccp(display.cx, display.cy))
end

-- [实例方法][视图析构]
-- 视图析构
function M:viewDestructor()

end


-- [实例方法][外部调用]
-- ..


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)

end


-- [实例方法][效果]
--------------------------------------
--  Shaky3DDemo
--------------------------------------
function Shaky3DDemo(t)
    return CCShaky3D:create(t, CCSize(15,10), 5, false);
end

--------------------------------------
--  Waves3DDemo
--------------------------------------
function Waves3DDemo(t)
    return CCWaves3D:create(t, CCSize(15,10), 5, 40);
end

--------------------------------------
--  FlipX3DDemo
--------------------------------------
function FlipX3DDemo(t)
    local flipx  = CCFlipX3D:create(t)
    local flipx_back = flipx:reverse()
    local delay = CCDelayTime:create(2)

    local array = CCArray:create()
    array:addObject(flipx)
    array:addObject(flipx_back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  FlipY3DDemo
--------------------------------------
function FlipY3DDemo(t)
    local flipy  = CCFlipY3D:create(t)
    local flipy_back = flipy:reverse()
    local delay = CCDelayTime:create(2)

    local array = CCArray:create()
    array:addObject(flipy)
    array:addObject(flipy_back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  Lens3DDemo
--------------------------------------
function Lens3DDemo(t)
    return CCLens3D:create(t, CCSize(15,10), ccp(size.width/2,size.height/2), 240); 
end

--------------------------------------
--  Ripple3DDemo
--------------------------------------
function Ripple3DDemo(t)
    return CCRipple3D:create(t, CCSize(32,24), ccp(size.width/2,size.height/2), 240, 4, 160);
end

--------------------------------------
--  LiquidDemo
--------------------------------------
function LiquidDemo(t)
    return CCLiquid:create(t, CCSize(16,12), 4, 20); 
end

--------------------------------------
--  WavesDemo
--------------------------------------
function WavesDemo(t)
    return CCWaves:create(t, CCSize(16,12), 4, 20, true, true);  
end

--------------------------------------
--  TwirlDemo
--------------------------------------
function TwirlDemo(t)
    return CCTwirl:create(t, CCSize(12,8), ccp(size.width/2, size.height/2), 1, 2.5); 
end

--------------------------------------
--  ShakyTiles3DDemo
--------------------------------------
function ShakyTiles3DDemo(t)
    return CCShakyTiles3D:create(t, CCSize(16,12), 5, false) ;
end

--------------------------------------
--  ShatteredTiles3DDemo
--------------------------------------
function ShatteredTiles3DDemo(t)
    return CCShatteredTiles3D:create(t, CCSize(16,12), 5, false); 
end

--------------------------------------
--  ShuffleTilesDemo
--------------------------------------
function ShuffleTilesDemo(t)
    local shuffle = CCShuffleTiles:create(t, CCSize(100,100), 25); -- CCSize(16,12), 25
    local shuffle_back = shuffle:reverse()
    local delay = CCDelayTime:create(2)

    local array = CCArray:create()
    array:addObject(shuffle)
    array:addObject(shuffle_back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  FadeOutTRTilesDemo
--------------------------------------
function FadeOutTRTilesDemo(t)
    local fadeout = CCFadeOutTRTiles:create(t, CCSize(16,12));
    local back = fadeout:reverse()
    local delay = CCDelayTime:create(0.5)

    local array = CCArray:create()
    array:addObject(fadeout)
    array:addObject(back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  FadeOutBLTilesDemo
--------------------------------------
function FadeOutBLTilesDemo(t)
    local fadeout = CCFadeOutBLTiles:create(t, CCSize(16,12));
    local back = fadeout:reverse()
    local delay = CCDelayTime:create(0.5)

    local array = CCArray:create()
    array:addObject(fadeout)
    array:addObject(back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  FadeOutUpTilesDemo
--------------------------------------
function FadeOutUpTilesDemo(t)
    local fadeout = CCFadeOutUpTiles:create(t, CCSize(16,12));
    local back = fadeout:reverse()
    local delay = CCDelayTime:create(0.5)

    local array = CCArray:create()
    array:addObject(fadeout)
    array:addObject(back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  FadeOutDownTilesDemo
--------------------------------------
function FadeOutDownTilesDemo(t)
    local fadeout = CCFadeOutDownTiles:create(t, CCSize(16,12));
    local back = fadeout:reverse()
    local delay = CCDelayTime:create(0.5)

    local array = CCArray:create()
    array:addObject(fadeout)
    array:addObject(back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  TurnOffTilesDemo
--------------------------------------
function TurnOffTilesDemo(t)
    local fadeout = CCTurnOffTiles:create(t, CCSize(48,32), 25);
    local back = fadeout:reverse()
    local delay = CCDelayTime:create(0.5)

    local array = CCArray:create()
    array:addObject(fadeout)
    array:addObject(back)
    array:addObject(delay)
    return CCSequence:create(array)
end

--------------------------------------
--  WavesTiles3DDemo
--------------------------------------
function WavesTiles3DDemo(t)
    return CCWavesTiles3D:create(t, CCSize(15,10), 4, 120); 
end

--------------------------------------
--  JumpTiles3DDemo
--------------------------------------
function JumpTiles3DDemo(t)
    return CCJumpTiles3D:create(t, CCSize(15,10), 2, 30); 
end

--------------------------------------
--  SplitRowsDemo
--------------------------------------
function SplitRowsDemo(t)
    return CCSplitRows:create(t, 4); -- t, 9
end

--------------------------------------
--  SplitColsDemo
--------------------------------------
function SplitColsDemo(t)
    return CCSplitCols:create(t, 9); 
end

--------------------------------------
--  PageTurn3DDemo
--------------------------------------
function PageTurn3DDemo(t)
    CCDirector:sharedDirector():setDepthTest(true)
    return CCPageTurn3D:create(t, CCSize(15,10)); 
end

--------------------------------------
--  Effects Test
--------------------------------------
function createEffect(idx, t)
    CCDirector:sharedDirector():setDepthTest(false)
    local action = nil

    if idx == 0 then
        action = Shaky3DDemo(t)
    elseif idx == 1 then
        action = Waves3DDemo(t)
    elseif idx == 2 then
        action = FlipX3DDemo(t)
    elseif idx == 3 then
        action = FlipY3DDemo(t)
    elseif idx == 4 then
        action = Lens3DDemo(t)
    elseif idx == 5 then
        action = Ripple3DDemo(t)
    elseif idx == 6 then
        action = LiquidDemo(t)
    elseif idx == 7 then
        action = WavesDemo(t)
    elseif idx == 8 then
        action = TwirlDemo(t)
    elseif idx == 9 then
        action = ShakyTiles3DDemo(t)
    elseif idx == 10 then
        action = ShatteredTiles3DDemo(t)
    elseif idx == 11 then
        action = ShuffleTilesDemo(t)
    elseif idx == 12 then
        action = FadeOutTRTilesDemo(t)
    elseif idx == 13 then
        action = FadeOutBLTilesDemo(t)
    elseif idx == 14 then
        action = FadeOutUpTilesDemo(t)
    elseif idx == 15 then
        action = FadeOutDownTilesDemo(t)
    elseif idx == 16 then
        action = TurnOffTilesDemo(t)
    elseif idx == 17 then
        action = WavesTiles3DDemo(t)
    elseif idx == 18 then
        action = JumpTiles3DDemo(t)
    elseif idx == 19 then
        action = SplitRowsDemo(t)
    elseif idx == 20 then
        action = SplitColsDemo(t)
    elseif idx == 21 then
        action = PageTurn3DDemo(t)
    end

    return action
end



return M