--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗主场景类，定义战斗主场景层相关操作方法及逻辑实现。

-   存储战斗主场景户相关信息。

]]

local M = class("DemoViewWindowLayer", function()
    return display.newLayer()
end)



-- [包含文件]
-- 断言
local TDAssertUtils     = requireU("TDAssertUtils")
-- 点
local TDPointUtils      = requireU("TDPointUtils")
-- 定位[点]
local acp               = TDPointUtils.point
-- 定位[百分比]
local acpc              = TDPointUtils.percentage










-- [公共参数]
-- [常量]
local M_ITEM                = acp(20, 0)
local NUM_VIEW_ITEMS        = 5


-- [操作变量]


-- [枚举]

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor()
    -- [操作变量]
    local _posData = {}                             -- 数据Po集合
    local _contentSizeView                          -- 视图内容尺寸



    

    





    -- [私有方法声明]
    -- [实例方法][视图渲染]
    -- 视图渲染
    local viewRender
    -- 加载数据准备工作
    local loadDataPreparation
    -- 加载状态变量
    local loadStatuses
    -- 加载内容视图
    local loadContentView
    -- 加载渲染视图其他操作
    local loadRenderOtherwise
    -- 配置视图大小
    local configViewSize

    -- [视图析构]
    -- 视图析构
    local viewDestructor
    
    -- [辅助方法]
    -- 获得视图内容尺寸
    local getContentSizeView
    
    -- [工具方法]


        

        





    -- [私有方法定义]
    -- [实例方法][视图渲染]
    -- 视图渲染
    function viewRender()
        -- 加载数据准备工作
        loadDataPreparation()
        -- 加载状态变量
        loadStatuses()

        -- 加载内容视图
        loadContentView()

        -- 加载渲染视图其他操作
        loadRenderOtherwise()
    end

    -- 加载数据准备工作 
    function loadDataPreparation()
        for i = 1, 10 do
            _posData[i] = { fileName = "img_photoCard_" .. i .. ".jpg" }
        end
    end

    -- 加载状态变量
    function loadStatuses()
        -- 视图内容尺寸
        _contentSizeView = getContentSizeView()
    end

    -- 加载内容视图
    function loadContentView()
        local function onItemTapped( scrollLinear, index, item ) 
            -- print("Tapped Index!!!!!!!", index)

            if index ~= scrollLinear.selectIndex then
                scrollLinear.selectIndex = index
            end
        end

        local function cellAtIndex( scrollLinear, idx , item)
            -- 创建容器
            local cell = display.newSprite(item.fileName)
            cell:ignoreAnchorPointForPosition(false)

            return cell
        end

        local layer = ViewFactory.create({
            viewType            = WIDGET_TYPE.ScrollLinear,
            contentSize         = _contentSizeView,
            cellAtIndexListener = cellAtIndex,
            bounceable          = false,
            contentParams       = { padding = M_ITEM.x, },
            selectedParams      = { file = "board_ready.png" },
            direction           = widget.TABLEVIEW_DIRECTION_HORIZONTAL,
            tapListener         = onItemTapped,
        })
        layer:setItems(_posData)
        self:addChild(layer)








    end

    -- 加载渲染视图其他操作
    function loadRenderOtherwise()
        -- 配置视图大小
        -- configViewSize()
    end

    -- 配置视图大小
    function configViewSize()
        self:setContentSize(CCSize(180, 190))
    end


    ---------


    -- [辅助方法]
    -- 视图内容尺寸
    function getContentSizeView()
        local contentSizeItem = getContentSizeItem()

        return CCSize(contentSizeItem.width * NUM_VIEW_ITEMS + M_ITEM.x * (NUM_VIEW_ITEMS - 1),  contentSizeItem.height)
    end

    -- 数据顶尺寸
    function getContentSizeItem()
        local spriteTemp = display.newSprite("img_photoCard_1.jpg")
        TDAssertUtils.assertNotNil(spriteTemp)

        return spriteTemp:getContentSize()
    end


    ---------


    -- [工具方法]


        

        





    -- [具体操作]
    viewRender()
end



return M