--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗主场景类，定义战斗主场景层相关操作方法及逻辑实现。

-   存储战斗主场景户相关信息。

]]

local M = class("FightMainLayer", TDLayer)



-- [包含文件]
-- ...



-- [公共参数]
-- [常量]
local P_ROUND                   = ccp(103, 319)
local T_ROUND_TIME              = 1.0


-- [操作变量]
-- ..


-- [枚举]
M.NODETAG__LOWERBOUND           = 500
M.NODETAG_ROUND                 = M.NODETAG__LOWERBOUND + 10

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    -- ..


    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendLayer.extendRenderDestuctor(self)
end










-- [实例方法]
-- [实例方法][视图渲染]
-- 视图渲染
function M:viewRender()
    -- 加载回合数
    self:loadRound()
end

-- 加载回合数
function M:loadRound()
    local sprite = Round.new({ fileName = PHI_FIGHT .. "f_box_round.png", no = round, })
    self:addChild(sprite, 0, M.NODETAG_ROUND)

    sprite:setPosition(P_ROUND)
    sprite:setScale(.5)
end


---------


-- [实例方法][视图析构]
-- 视图析构
function M:viewDestructor()

end


---------


-- [实例方法][外部调用]
-- 添加精灵[回合]
function M:getRound()
    local node = self:getChildByTag(M.NODETAG_ROUND)
    TDAssertUtils.assertInherit(node, Round)

    return node
end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    -- TDAssertUtils.assertParameters(params)
end


---------


-- [工具方法]
-- 添加按钮
function newButton(fileNormal, fileSelect, handler)
    return widget.newButton({ normalImage = PHI_FIGHT_BUTTON .. fileNormal, selectImage = PHI_FIGHT_BUTTON .. fileSelect, listener = handler, })
end
-- 添加结点
function addNode(file, position)
    addNodeXY(file, position.x, position.y)
end
-- 添加结点
function addNodeXY(file, x, y)
    sprite = display.newSprite(file, x, y)
    self:addChild(sprite, x, y)
end

-- 添加精灵
function newSprite(className, params)
    return requireS(className).new(params)
end





return M