--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗变速层类，定义战斗变速层相关操作方法及逻辑实现。

-   存储战斗变速相关信息。

]]

local M = class("FightSpeedLayer", TDLayer)



-- [包含文件]
-- ...



-- [公共参数]
-- [常量]
local O_LABEL                   = acp(-50, 5) -- acp(-50, -150)
local FZ_LABEL                  = 30


-- [操作变量]
-- 速度集
local SPPEDS = {
    [1] = { name = "x1", value = 1 },
    [2] = { name = "x2", value = 2 },
    [3] = { name = "x5", value = 5 },
    [4] = { name = "x0.1", value = .1 },
    [5] = { name = "x0.5", value = .5 },
    [6] = { name = "x.01", value = .01 },
}
local MAX_SPEEDS = 6



-- [枚举]
M.NODETAG__LOWERBOUND           = 500
M.NODETAG_LABEL_SPEED           = M.NODETAG__LOWERBOUND + 10










-- [私有方法声明]
-- [实例方法][视图渲染]
-- ..
-- [视图析构]
-- ..

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    -- ..


    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendLayer.extendRenderDestuctor(self)
end










-- [实例方法]
-- [实例方法][视图渲染]
-- 视图渲染
function M:viewRender()
    -- 加载标签[变速]
    self:loadLabelSpeed()
end

-- 加载标签[变速]
function M:loadLabelSpeed()
    -- 定义配置
    local index = 1
    local speed = SPPEDS[index]

    -- 定义配置参数
    local params = {
        text        = speed.name,                   -- 标签文字
        parentNode  = self,                         -- 父结点
        align       = display.CENTER_RIGHT,         -- 对齐方式
        anchor      = display.CENTER_LEFT,          -- 锚点
        offset      = O_LABEL,                      -- 偏移量
    }
    -- 生成标签
    local label = TDUIUtils.loadLabelTTF(params)

    TDTouchUtils.bindNodeTouchEvent({ node = label, handler = function() self:onSpeed(label) end })
    label.mutiply = index

    -- 存储变量
    self.label = label
end

-- 加载按钮[回合结束]
function M:onSpeed(sender)
    local index = sender.mutiply
    index = index + 1

    if index > MAX_SPEEDS then 
        index = 1
    end

    local value = SPPEDS[index].value
    local name  = SPPEDS[index].name
    FightActionHelper:setRate(value)
    self.label:setString(name)
    self.label.mutiply = index
end


---------


-- [实例方法][视图析构]
-- 视图析构
function M:viewDestructor()

end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    -- TDAssertUtils.assertParameters(params)
end



return M