--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

战斗提示层类，定义战斗变速层相关操作方法及逻辑实现。

-   存储战斗提示相关信息。

]]

local M = class("FightTipLayer", TDLayer)



-- [包含文件]
-- ...



-- [公共参数]


-- [操作变量]
-- 关卡DAO
local LevelDao                  = require("db.leveldb")
-- 字符串工具
local TDStringUtils             = require(PH_MDL_UTIL .. "TDStringUtils")



-- [枚举]
M.NODETAG__LOWERBOUND           = 500
M.NODETAG_LABEL_SPEED           = M.NODETAG__LOWERBOUND + 10










-- [私有方法声明]
-- [实例方法][视图渲染]
-- ..
-- [视图析构]
-- ..

    


    





-- [构造方法]
-- 构造方法，定义视图加载逻辑
function M:ctor(params)
    -- [合法性验证]
    self:assertParameters(params)



    -- [参数赋值]
    self._levelId               = params.levelId                            -- 关卡ID


    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendLayer.extendRenderDestuctor(self)
end










-- [实例方法]
-- [实例方法][视图渲染]
-- 视图渲染
function M:viewRender()
    -- 加载战斗提示
    self:loadFightTip()

    -- 加载实体渲染其他操作
    self:loadRenderOtherwise()
end

-- 加载战斗提示
function M:loadFightTip()
    -- 定义配置
    local levelParams = TDStringUtils.split(self._levelId, "-")
    local level1      = tonumber(levelParams[1])
    local level2      = tonumber(levelParams[2])
    local levelName   = LevelDao.getNextLevelName(level1, level2)

    -- 定义配置参数
    local params = {
        text        = levelName,                   -- 标签文字
        fileName    = PHI_FIGHT_RESULT .. "r_tip_bar.png",
    }
    -- 生成标签
    local sprite = require(PH_MDL_SPRITE .. "FightTip").new(params)
    self:addChild(sprite)

    -- 存储变量
    self.tip = sprite
end

-- 加载实体渲染其他操作
function M:loadRenderOtherwise()
    self.tip:show()
end


---------


-- [实例方法][视图析构]
-- 视图析构
function M:viewDestructor()

end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    -- TDAssertUtils.assertParameters(params)
end



return M