--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

抽象卡片类，定义游戏卡片公用操作方法及逻辑实现。

-   指定通用卡片公共逻辑。

]]

local M = class("AbstractCard", TDSprite)



-- [包含文件]
-- ...




-- [公共参数]
-- 常量
-- 标签字体大小
local CARD_A_CORRECT_TIME           = 1.0

-- 操作变量
-- ..










-- [辅助方法]










-- [实例方法]
--[[--
    创建对象
]]
function M:ctor(params)
    -- [验证参数合法性]
    self:assertParameters(params)



    -- [参数赋值]
    -- [标识]
    self._owner         = params.owner  or OWNER_ME         -- 拥有者标识(我方/敌方)
    -- [文件名/帧]
    self._fileName      = params.fileName                   -- 文件名
    self._name = params.po:getName()
-- print("nnnnnnnnnnnnnnn"..params.po:getName())
    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendNode.extendRenderDestuctor(self)
end






function M:getCardName( ... )
    return self._name
end



-- [实例方法]
-- [实例方法][实体渲染]
-- 实体渲染
function M:entityRender()
    TDExceptionUtils.raiseUnimpletentException("AbstractCard:entityRender()")
end


---------


-- [实例方法][实体析构]
-- 实体析构
function M:entityDestructor()
    -- TDExceptionUtils.raiseUnimpletentException("AbstractCard:entityDestructor()")
end


---------


-- [实例方法][可见性]
-- 设置可见性[隐藏]
function M:hide()
    self:setVisible(false)
end

-- 设置可见性[显示]
function M:show()
    self:setVisible(true)
end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证参数集
    TDAssertUtils.assertParameters(params)
end


---------


-- [实例方法][属性Getter/Setter]
-- 设置拥有者标识
function M:setOwner(owner)
    self._owner = owner
end
-- 获得拥有者标识
function M:getOwner()
    return self._owner
end

-- 获得文件名
function M:getFileName()
    return self._fileName
end





return M