--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

英雄名字类，定义英雄名字公用操作方法及逻辑实现。

-   定义英雄名字相关信息。

]]

local M = class("HeroName", TDSprite)



-- [包含文件]
-- ...




-- [公共参数]
-- [常量]
-- 字体尺寸[名字]
local FZ_TEXT                   = (15 * display.contentScaleFactor)

-- 字体颜色[名字]
local C_TEXT                    = display.COLOR_WHITE










-- [实例方法]
--[[--
    创建对象
]]
function M:ctor(params)
    -- [加载超类构造函数]
    self:assertParameters(params)



    -- [参数赋值]
    self._fileName          = params.fileName                           -- 文件名[图片]
    self._text              = params.text                               -- 文字
    self._owner             = params.owner                              -- 拥有者标识
    self._labelText         = nil                                       -- 标签[文本]


    
    -- [具体操作]
    -- 扩展onEnter/onExit事件处理
    TDExtendNode.extendRenderDestuctor(self)
end










-- [实例方法]
-- [实例方法][实体渲染]
-- 实体渲染
function M:entityRender()
    -- 加载头像
    self:loadText()
end

-- 加载文字
function M:loadText()
    -- 定义配置参数
    local params = {
        text        = self._text,                   -- 标签文字
        fontSize    = FZ_TEXT,                      -- 字体大小
        color       = C_TEXT,                       -- 颜色
        parentNode  = self,                         -- 父结点
        align       = display.CENTER,               -- 对齐方式
        offset      = ccp(0, -2),                   -- 偏移量
    }
    -- 生成标签
    local sprite = TDUIUtils.loadLabelTTF(params)


    -- 标记
    self._labelText = sprite
end


---------


-- [实例方法][实体析构]
-- 实体析构
function M:entityDestructor()

end


---------


-- [实例方法][验证]
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    -- 验证图像文件名
    TDAssertUtils.assertTypeString(params.fileName)
end


---------


-- [实例方法][属性Getter/Setter]
-- 获得文字内容
function M:getText()
    return self._text
end
-- 设置文字内容
function M:setText(text)
    self._text = text
end





return M