--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

陷门工具类，定义陷门相关操作方法及逻辑实现。

-   指定陷门逻辑。
-   提供便捷生成陷门接口。

]]

local M = {}



-- [公共参数]
-- 引入文件
local crypto = require("framework.client.crypto")

-- 全局变量
-- 是否开启性能测试
local IS_HOOK                       = true
local KEY                           = "xxoo"
local PATH_FOLDER                   = device.documentsPath
local SUFFIX                        = ".xxoo"

-- 常量
-- 命令
local COMMAND_SERVER                = "server"
local COMMAND_FIGHT                 = "fight"










-- [工具方法]
function M.keyServer()
	return "MycsZg" -- "D.xxoo"
end
function M.keyFight()
    return "F>x5"
end

-- 生成陷门文件[服务器列表]
function M.hookServer()
    local fileName = M.cryptoFileNameServer()
    io.writefile(PATH_FOLDER .. fileName .. SUFFIX, "", "w")
end
-- 生成陷门文件[战斗]
function M.hookFight()
    local fileName = M.cryptoFileNameFight()
    io.writefile(PATH_FOLDER .. fileName .. SUFFIX, "", "w")
end

-- 是否存在陷门文件[服务器列表]
function M.existsServer()
    local fileName = M.cryptoFileNameServer()
	return io.exists(PATH_FOLDER .. fileName .. SUFFIX)
end
-- 是否存在陷门文件[战斗]
function M.existsFight()
    local fileName = M.cryptoFileNameFight()
    return io.exists(PATH_FOLDER .. fileName .. SUFFIX)
end











-- [私有方法]
-- 获得加密文件名[服务器列表]
function M.cryptoFileNameServer()
    return M.cryptoID(COMMAND_SERVER)
end
-- 获得加密文件名[战斗]
function M.cryptoFileNameFight()
    return M.cryptoID(COMMAND_FIGHT)
end

-- 获得加密ID
function M.cryptoID(command)
    local id  = device.getOpenUDID()
    local raw = format("%s:%s", command, id)

    -- return crypto.encryptAES256(raw, KEY)
    return crypto.md5(raw)
end





return M