--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

布局工具类，定义布局相关操作方法及逻辑实现。

-   定义结点的9向布局。
-   实现相对定位、参考定位。

]]

local M = {}



-- [公共参数]
-- 常量





-- [私有方法]
-- [声明]
local isTypeString;

-- [定义]
function isTypeString(str)
    return type(str) == "string";
end





-- [断言方法]
-- 验证参数合法性（是否为表格类型）
function M.assertParameters(params, source, tag)
    -- 默认赋值
    source  = source    or "Unknown";
    tag     = tag       or "";

    -- 验证合法性
    assert(type(params) == "table",
           "[" .. source .. "]" .. tag .. " invalid params!")
end

-- 验证是否为字符串
function M.assertTypeString(str, source, tag)
    -- 默认赋值
    source  = source    or "Unknown";
    tag     = tag       or " ";

    -- 验证合法性
    assert(isTypeString(str),
           "[" .. source .. "]" .. tag .. "invalid type \"string\"!")
end

return M;
