--[[

Copyright (c) 2012-2013 gao7.com

http://www.gao7.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

集合工具类，定义集合相关操作方法及逻辑实现。

-   指定集合逻辑。
-   公共集合定义。



-- [性能测试]
-- 引入头文件
local TDPerformanceTestingUtils = require(TDPerformanceTestingUtils .. "TDAssertUtils")

-- 调用方式
-- 在方法{}内顶部调用
TDPerformanceTestingUtils.clockBegin("Method Name")
-- 在方法{}内底部调用
TDPerformanceTestingUtils.clockEnd("Method Name")

-- 会自动记录时间到Document/ahdxc.txt,上面调用方式自动记录方法执行时间，可嵌套调用

]]

local M = {}



-- [公共参数]
-- 是否开启性能测试
local IS_TEST 						= false
local PATH_FILE 					= device.documentsPath .. "ahdxc.txt"
local stackClock 					= {}

-- 操作变量
-- 断言
local TDAssertUtils      			= require(PH_MDL_UTIL .. "TDAssertUtils")
-- 数组
local TDArrayUtils      			= require(PH_MDL_UTIL .. "TDArrayUtils")





-- [私有方法]
-- [声明]

-- [定义]





-- [公有方法]
-- 开启记录
function M.clockBegin(tag)
	-- [过滤判断]
	if not IS_TEST then 
		return
	end


	-- [参数赋值]
	tag = tag or "Unknown"


	-- [逻辑处理]
	-- print("[start]", tag)
	M.pushClock()
end

-- 输出结果
function M.clockEnd(tag)
	-- [过滤判断]
	if not IS_TEST then 
		return
	end


	-- [参数赋值]
	tag = tag or "Unknown"


	-- [逻辑处理]
	local timeStart = M.popClock()
	local message = string.format("[%s] Time Elapsed %f\n", tag, os.clock() - timeStart)

    -- print("=======================================")
    -- print(message)
    io.writefile(PATH_FILE, message, "a+")
    -- print("=======================================")
end





-- [私有方法]
-- 推入当前时间
function M.pushClock()
	TDArrayUtils.pushItem(stackClock, os.clock())
end

-- 推入当前时间
function M.popClock()
	return TDArrayUtils.popItem(stackClock)
end

return M