local M = {}
M.TAG = "[NetGetData]"

-- 网络读取对象
local R = NetReader:getInstance()

-- table工具类
require("net.CommonTable")

-- 基本信息
function M.GetData_Base()
    local response_base = nil
    if R:readINT() ~= 0 then 
        response_base = {}
        R:readBEGIN()
        response_base.hp = R:readINT()
        response_base.lv = R:readINT()
        response_base.curexp = R:readINT()
        response_base.totalexp = R:readINT()
        response_base.usedcost = R:readINT()
        response_base.totalcost = R:readINT()
        response_base.cursp = R:readINT()
        response_base.gold = R:readINT64()
        response_base.diamond = R:readINT()
        response_base.fp = R:readINT()
        response_base.nreward = R:readINT()
        response_base.nfriend = R:readINT()
        response_base.nshop = R:readINT()
        response_base.nmessage = R:readINT()
        response_base.ccount = R:readINT()
        response_base.gcount = R:readINT()
        response_base.tcount = R:readINT()
        response_base.sptime = R:readINT()
        response_base.freebuy = R:readINT()
        response_base.totalatk = R:readINT()
        response_base.tcurrent = R:readINT()
        response_base.helpstep = R:readINT()
        response_base.nospeaktime = R:readINT()
        response_base.upcardcount = R:readINT()
        response_base.buyCostCount = R:readINT()
        response_base.notever = R:readINT()
        response_base.star = R:readINT()
        response_base.firstpay = R:readINT()
        response_base.versionClient = R:readSTRING()
        response_base.versionContent = R:readSTRING()
        response_base.firstTenDraw = R:readINT()
        response_base.newCommonReward = R:readINT()
        response_base.newDayReward = R:readINT()
        response_base.talent = R:readSTRING()
        response_base.totalHp = R:readINT()
        response_base.maxActivityId = R:readINT()
        response_base.TriggerMsg = R:readSTRING()
        response_base.NewDiamondReward = R:readINT()
        response_base.TodaySigned = R:readINT()
        response_base.EquipEffect = R:readSTRING()
        response_base.Equiplst = R:readSTRING()
        response_base.EquipSk = R:readSTRING()
        response_base.CanWish = R:readINT()
        response_base.CanMine = R:readINT()
        response_base.ErrorInfo = R:readSTRING()
        response_base.showday7 = R:readINT()
        response_base.actpng = R:readSTRING()
        response_base.actlimit = R:readINT()
        response_base.bosswar = R:readINT()
        response_base.scopy = R:readINT()
        response_base.ladder = R:readINT()
        R:readEND()
    end
    return response_base
end

--[[ 
    ************************ 基本请求 ************************ 1xxx
--]]
-- 注册请求 1000
function M.GetData_1000()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1000  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1000 = {}
            R:readBEGIN()
            m_Response_Action_1000.isexist = R:readBYTE() == 1
            m_Response_Action_1000.username = R:readSTRING()
            m_Response_Action_1000.pass = R:readSTRING()
            R:readEND()
            return m_Response_Action_1000
        end
    end
    return nil
end

-- 登录请求 1001
function M.GetData_1001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1001 = {}
            R:readBEGIN()
        m_Response_Action_1001.sessionid = R:readSTRING()
            m_Response_Action_1001.userid = R:readINT64()
            m_Response_Action_1001.userno = R:readSTRING()
            m_Response_Action_1001.needmodify = R:readBYTE()
            m_Response_Action_1001.name = R:readSTRING()
            m_Response_Action_1001.head = R:readSTRING()
            m_Response_Action_1001.sex = R:readINT()
            m_Response_Action_1001.modpass = R:readINT();
            R:readEND()
            return m_Response_Action_1001
        end
    end
    return nil
end

--获取服务器列表
function M.GetData_1003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1003 = {}
            R:readBEGIN();
            local m_servers =  {}
            m_Response_Action_1003.servers = m_servers
            local nNum_m_servers = R:readINT();
            for index_m_servers = 1, nNum_m_servers do
                local item_m_servers = {}
                R:readBEGIN();
                item_m_servers.serid = R:readINT();
                item_m_servers.sername = R:readSTRING();
                item_m_servers.serstatus = R:readINT();
                item_m_servers.seradd = R:readSTRING();
                item_m_servers.notification = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_servers,item_m_servers)
            end
            R:readEND();
            return m_Response_Action_1003
        end
    end
    return nil
end

--获取配置系数
function M.GetData_1005()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1005 = {}
            R:readBEGIN();
            local m_configs =  {}
            m_Response_Action_1005.configs = m_configs
            local nNum_m_configs = R:readINT();
            for index_m_configs = 1, nNum_m_configs do
                local item_m_configs = {}
                R:readBEGIN();
                item_m_configs.cno = R:readINT();
                item_m_configs.cvalue = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_configs,item_m_configs)
            end
            local m_loginrewards =  {}
            m_Response_Action_1005.loginrewards = m_loginrewards
            local nNum_m_loginrewards = R:readINT();
            for index_m_loginrewards = 1, nNum_m_loginrewards do
                local item_m_loginrewards = {}
                R:readBEGIN();
                item_m_loginrewards.no = R:readINT();
                item_m_loginrewards.title = R:readSTRING();
                item_m_loginrewards.content = R:readSTRING();
                item_m_loginrewards.memo = R:readSTRING();
                item_m_loginrewards.pic = R:readSTRING();
                item_m_loginrewards.status = R:readINT();
                item_m_loginrewards.tno = R:readINT64();
                R:readEND();
                CommonTable.push_back(m_loginrewards,item_m_loginrewards)
            end
            m_Response_Action_1005.ctime = R:readINT();
            m_Response_Action_1005.csta = R:readINT();
            local m_push =  {}
            m_Response_Action_1005.push = m_push
            local nNum_m_push = R:readINT();
            for index_m_push = 1, nNum_m_push do
                local item_m_push = {}
                R:readBEGIN();
                item_m_push.no = R:readINT();
                item_m_push.time = R:readSTRING();
                item_m_push.content = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_push,item_m_push)
            end
            R:readEND();
            return m_Response_Action_1005
        end
    end
    return nil
end

--获取系统更新信息
function M.GetData_1006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1006 = {}
            R:readBEGIN();
            m_Response_Action_1006.messages = R:readSTRING();
            R:readEND();
            return m_Response_Action_1006
        end
    end
    return nil
end

--获取系统公告
function M.GetData_1007()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1007  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1007 = {}
            R:readBEGIN();
            m_Response_Action_1007.title = R:readSTRING();
            m_Response_Action_1007.messages = R:readSTRING();
            m_Response_Action_1007.notetype = R:readINT();
            R:readEND();
            return m_Response_Action_1007
        end
    end
    return nil
end
--领取登录奖励
function M.GetData_1010()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1010  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1010 = {}
            R:readBEGIN();
            local m_loginrewards =  {}
            m_Response_Action_1010.loginrewards = m_loginrewards
            local nNum_m_loginrewards = R:readINT();
            for index_m_loginrewards = 1, nNum_m_loginrewards do
                local item_m_loginrewards = {}
                R:readBEGIN();
                item_m_loginrewards.no = R:readINT();
                item_m_loginrewards.title = R:readSTRING();
                item_m_loginrewards.content = R:readSTRING();
                item_m_loginrewards.memo = R:readSTRING();
                item_m_loginrewards.pic = R:readSTRING();
                item_m_loginrewards.status = R:readINT();
                item_m_loginrewards.tno = R:readINT64();
                R:readEND();
                CommonTable.push_back(m_loginrewards,item_m_loginrewards)
            end
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_1010.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_1010
        end
    end
    return nil
end
--修改用户密码
function M.GetData_1013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1013 = {}
            R:readBEGIN();
            m_Response_Action_1013.username = R:readSTRING();
            m_Response_Action_1013.pass = R:readSTRING();
            R:readEND();
            return m_Response_Action_1013
        end
    end
    return nil
end
--绑定旧账户
function M.GetData_1014()
    if R:getResult() == RREST.Success then
        local m_Response_Action_1014  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_1014 = {}
            R:readBEGIN();
            m_Response_Action_1014.userid = R:readINT64();
            m_Response_Action_1014.usertype = R:readINT();
            m_Response_Action_1014.username = R:readSTRING();
            m_Response_Action_1014.pass = R:readSTRING();
            m_Response_Action_1014.serverid = R:readINT();
            R:readEND();
            return m_Response_Action_1014
        end
    end
    return nil
end
--[[ 
    ************************ 战斗系统 ************************ 2xxx
--]]
-- 战斗请求
local function GetData_fight()
    if R:getResult() == RREST.Success then
        local m_Response_Action_2001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_2001 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_2001.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_2001.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_2001.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                m_result.jjcScore = R:readINT();
                m_result.rank = R:readINT();
                m_result.rankvar = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                local m_levels =  {}
                m_result.levels = m_levels
                local nNum_m_levels = R:readINT();
                for index_m_levels = 1, nNum_m_levels do
                    local item_m_levels = {}
                    R:readBEGIN();
                    item_m_levels.sn = R:readINT();
                    item_m_levels.subsn = R:readINT();
                    item_m_levels.star = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_levels,item_m_levels)
                end
                m_result.flag = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_2001
        end
    end
    return nil
end

-- 关卡战斗请求 2001
function M.GetData_2001()
    return GetData_fight()
end
--关卡战斗
-- function M.GetData_2001()
    
-- end

-- 竞技战斗请求 2002
function M.GetData_2002()
    return GetData_fight()
end
-- BOSS战斗请求 2003
function M.GetData_2003()
    return GetData_fight()
end


--竞技PK
function M.GetData_2004()
    return GetData_fight()
end


--[[ 
    ************************ 卡组系统 ************************ 3xxx
--]]
-- 卡牌列表
local function GetData_cardlist()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common = {}
            R:readBEGIN();
            m_Response_Action_Common.curgroup = R:readINT();
            m_Response_Action_Common.ccount = R:readINT();
            m_Response_Action_Common.gcount = R:readINT();
            local m_onwarcards =  {}
            m_Response_Action_Common.onwarcards = m_onwarcards
            local nNum_m_onwarcards = R:readINT();
            for index_m_onwarcards = 1, nNum_m_onwarcards do
                local item_m_onwarcards = {}
                R:readBEGIN();
                item_m_onwarcards.id = R:readINT64();
                item_m_onwarcards.lv = R:readINT();
                item_m_onwarcards.main = R:readINT();
                item_m_onwarcards.locked = R:readINT();
                item_m_onwarcards.cpid = R:readINT64();
                item_m_onwarcards.curexp = R:readINT64();
                item_m_onwarcards.totalexp = R:readINT64();
                item_m_onwarcards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_onwarcards,item_m_onwarcards)
            end
            local m_cards =  {}
            m_Response_Action_Common.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Response_Action_Common
        end
    end
    return nil
end
-- 请求卡牌信息 3001
function M.GetData_3001()
    return GetData_cardlist()
end

-- 配置卡牌 3002
function M.GetData_3002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_MainCards  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_MainCards = {}
            R:readBEGIN();
            m_Response_Action_MainCards.curgroup = R:readINT();
            m_Response_Action_MainCards.ccount = R:readINT();
            m_Response_Action_MainCards.gcount = R:readINT();
            local m_onwarcards =  {}
            m_Response_Action_MainCards.onwarcards = m_onwarcards
            local nNum_m_onwarcards = R:readINT();
            for index_m_onwarcards = 1, nNum_m_onwarcards do
                local item_m_onwarcards = {}
                R:readBEGIN();
                item_m_onwarcards.id = R:readINT64();
                item_m_onwarcards.lv = R:readINT();
                item_m_onwarcards.main = R:readINT();
                item_m_onwarcards.locked = R:readINT();
                item_m_onwarcards.cpid = R:readINT64();
                item_m_onwarcards.curexp = R:readINT64();
                item_m_onwarcards.totalexp = R:readINT64();
                item_m_onwarcards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_onwarcards,item_m_onwarcards)
            end
            R:readEND();
            return m_Response_Action_MainCards
        end
    end
    return nil
end

-- 卡牌强化 3003
function M.GetData_3003()
    if R:getResult() == RREST.Success then
        local m_Respone_Action_ConditionCards  = nil
        if R:readINT() ~= 0 then 
            m_Respone_Action_ConditionCards = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Respone_Action_ConditionCards.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Respone_Action_ConditionCards
        end
    end
    return nil
end

-- 卡组切换 3004
function M.GetData_3004()
    if R:getResult() == RREST.Success then
        local m_Response_Action_MainCards  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_MainCards = {}
            R:readBEGIN();
            m_Response_Action_MainCards.curgroup = R:readINT();
            m_Response_Action_MainCards.ccount = R:readINT();
            m_Response_Action_MainCards.gcount = R:readINT();
            local m_onwarcards =  {}
            m_Response_Action_MainCards.onwarcards = m_onwarcards
            local nNum_m_onwarcards = R:readINT();
            for index_m_onwarcards = 1, nNum_m_onwarcards do
                local item_m_onwarcards = {}
                R:readBEGIN();
                item_m_onwarcards.id = R:readINT64();
                item_m_onwarcards.lv = R:readINT();
                item_m_onwarcards.main = R:readINT();
                item_m_onwarcards.locked = R:readINT();
                item_m_onwarcards.cpid = R:readINT64();
                item_m_onwarcards.curexp = R:readINT64();
                item_m_onwarcards.totalexp = R:readINT64();
                item_m_onwarcards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_onwarcards,item_m_onwarcards)
            end
            R:readEND();
            return m_Response_Action_MainCards
        end
    end
    return nil
end

-- 卡牌出售 3005
-- function M.GetData_3005()
--     return GetData_cardlist()
-- end

-- 卡牌保护 3006
-- function M.GetData_3006()
--     return GetData_cardlist()
-- end

-- 取消卡牌保护 3007
function M.GetData_3007()
    return GetData_cardlist()
end

-- 获得图鉴列表 3008 
function M.GetData_3008()
    if R:getResult() == RREST.Success then
        local m_Response_Action_3008  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_3008 = {}
            R:readBEGIN()
            local m_cardbooks =  {}
            m_Response_Action_3008.cardbooks = m_cardbooks
            local nNum_m_cardbooks = R:readINT()
            for index_m_cardbooks = 1, nNum_m_cardbooks do
                local item_m_cardbooks = {}
                R:readBEGIN()
                item_m_cardbooks.id = R:readINT64()
                R:readEND()
                CommonTable.push_back(m_cardbooks,item_m_cardbooks)
            end
            R:readEND()
            return m_Response_Action_3008
        end
    end
    return nil
end

-- 获得卡牌碎片列表 3009 
function M.GetData_3009()
    if R:getResult() == RREST.Success then
        local m_Response_Action_3009  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_3009 = {}
            R:readBEGIN();
            local m_cardchips =  {}
            m_Response_Action_3009.cardchips = m_cardchips
            local nNum_m_cardchips = R:readINT();
            for index_m_cardchips = 1, nNum_m_cardchips do
                local item_m_cardchips = {}
                R:readBEGIN();
                item_m_cardchips.id = R:readINT64();
                item_m_cardchips.cur = R:readINT();
                item_m_cardchips.total = R:readINT();
                item_m_cardchips.status = R:readINT();
                item_m_cardchips.levelid = R:readSTRING()
                R:readEND();
                CommonTable.push_back(m_cardchips,item_m_cardchips)
            end
            R:readEND();
            return m_Response_Action_3009
        end
    end
    return nil
end

-- 卡牌进化 3011
function M.GetData_3011()
    return GetData_cardlist()
end

--获得卡牌进化列表  3012
function M.GetData_3012()
    if R:getResult() == RREST.Success then
        local m_Response_Action_3012  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_3012 = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Response_Action_3012.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT64();
                item_m_cards.lv = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.onwar = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            m_Response_Action_3012.list1 = R:readSTRING();
            m_Response_Action_3012.list2 = R:readSTRING();
            m_Response_Action_3012.list3 = R:readSTRING();
            R:readEND();
            return m_Response_Action_3012
        end
    end
    return nil
end
function M.GetData_3013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_3013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_3013 = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Response_Action_3013.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT64();
                item_m_cards.lv = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.teamcard = R:readINT();
                item_m_cards.isover = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            m_Response_Action_3013.getlist = R:readSTRING();
            R:readEND();
            return m_Response_Action_3013
        end
    end
    return nil
end

--
function M.GetData_3014()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common = {}
            R:readBEGIN();
            m_Response_Action_Common.curgroup = R:readINT();
            m_Response_Action_Common.ccount = R:readINT();
            m_Response_Action_Common.gcount = R:readINT();
            local m_onwarcards =  {}
            m_Response_Action_Common.onwarcards = m_onwarcards
            local nNum_m_onwarcards = R:readINT();
            for index_m_onwarcards = 1, nNum_m_onwarcards do
                local item_m_onwarcards = {}
                R:readBEGIN();
                item_m_onwarcards.id = R:readINT64();
                item_m_onwarcards.lv = R:readINT();
                item_m_onwarcards.main = R:readINT();
                item_m_onwarcards.locked = R:readINT();
                item_m_onwarcards.cpid = R:readINT64();
                item_m_onwarcards.curexp = R:readINT64();
                item_m_onwarcards.totalexp = R:readINT64();
                item_m_onwarcards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_onwarcards,item_m_onwarcards)
            end
            local m_cards =  {}
            m_Response_Action_Common.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Response_Action_Common
        end
    end
    return nil
end
--进入卡组界面
function M.GetData_3101()
    if R:getResult() == RREST.Success then
        local m_Response_Action_MainCards  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_MainCards = {}
            R:readBEGIN();
            m_Response_Action_MainCards.curgroup = R:readINT();
            m_Response_Action_MainCards.ccount = R:readINT();
            m_Response_Action_MainCards.gcount = R:readINT();
            local m_onwarcards =  {}
            m_Response_Action_MainCards.onwarcards = m_onwarcards
            local nNum_m_onwarcards = R:readINT();
            for index_m_onwarcards = 1, nNum_m_onwarcards do
                local item_m_onwarcards = {}
                R:readBEGIN();
                item_m_onwarcards.id = R:readINT64();
                item_m_onwarcards.lv = R:readINT();
                item_m_onwarcards.main = R:readINT();
                item_m_onwarcards.locked = R:readINT();
                item_m_onwarcards.cpid = R:readINT64();
                item_m_onwarcards.curexp = R:readINT64();
                item_m_onwarcards.totalexp = R:readINT64();
                item_m_onwarcards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_onwarcards,item_m_onwarcards)
            end
            R:readEND();
            return m_Response_Action_MainCards
        end
    end
    return nil
end
-- 进入配置卡牌
function M.GetData_3102()
    if R:getResult() == RREST.Success then
        local m_Respone_Action_ConditionCards  = nil
        if R:readINT() ~= 0 then 
            m_Respone_Action_ConditionCards = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Respone_Action_ConditionCards.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Respone_Action_ConditionCards
        end
    end
    return nil
end
-- 获得卡牌强化列表
function M.GetData_3103()
    if R:getResult() == RREST.Success then
        local m_Respone_Action_ConditionCards  = nil
        if R:readINT() ~= 0 then 
            m_Respone_Action_ConditionCards = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Respone_Action_ConditionCards.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Respone_Action_ConditionCards
        end
    end
    return nil
end

-- 进入出售卡牌界面
function M.GetData_3105()
    if R:getResult() == RREST.Success then
        local m_Respone_Action_ConditionCards  = nil
        if R:readINT() ~= 0 then 
            m_Respone_Action_ConditionCards = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Respone_Action_ConditionCards.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Respone_Action_ConditionCards
        end
    end
    return nil
end

-- 进入卡牌保护界面
function M.GetData_3106()
    if R:getResult() == RREST.Success then
        local m_Respone_Action_ConditionCards  = nil
        if R:readINT() ~= 0 then 
            m_Respone_Action_ConditionCards = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Respone_Action_ConditionCards.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.onwar = R:readINT();
                item_m_cards.main = R:readINT();
                item_m_cards.locked = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                item_m_cards.teamcard = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Respone_Action_ConditionCards
        end
    end
    return nil
end
--[[ 
    ************************ 关卡系统 ************************ 4xxx
--]]
--请求关卡列表信息
function M.GetData_4001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4001 = {}
            R:readBEGIN();
            local m_levels =  {}
            m_Response_Action_4001.levels = m_levels
            local nNum_m_levels = R:readINT();
            for index_m_levels = 1, nNum_m_levels do
                local item_m_levels = {}
                R:readBEGIN();
                item_m_levels.sn = R:readINT();
                item_m_levels.subsn = R:readINT();
                item_m_levels.star = R:readINT();
                R:readEND();
                CommonTable.push_back(m_levels,item_m_levels)
            end
            m_Response_Action_4001.stars = R:readINT();
            m_Response_Action_4001.collecttime = R:readINT();
            m_Response_Action_4001.expRate = R:readINT();
            m_Response_Action_4001.expTime = R:readINT();
            m_Response_Action_4001.shopTyp = R:readINT();
            m_Response_Action_4001.shopTime = R:readINT();
            R:readEND();
            return m_Response_Action_4001
        end
    end
    return nil
end
--探索关卡 4002
function M.GetData_4002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4002 = {}
            R:readBEGIN();
            m_Response_Action_4002.res = R:readINT();
            m_Response_Action_4002.diamond = R:readINT();
            m_Response_Action_4002.gold = R:readINT64();
            m_Response_Action_4002.exp = R:readINT();
            m_Response_Action_4002.fp = R:readINT();
            m_Response_Action_4002.star = R:readINT();
            local m_brlist =  {}
            m_Response_Action_4002.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            m_Response_Action_4002.mid = R:readINT();
            m_Response_Action_4002.fid = R:readINT64();
            m_Response_Action_4002.isfriend = R:readINT();
            m_Response_Action_4002.fin = R:readINT();
            m_Response_Action_4002.name = R:readSTRING();
            m_Response_Action_4002.lv = R:readINT();
            m_Response_Action_4002.sex = R:readINT();
            m_Response_Action_4002.head = R:readSTRING();
            local m_finRw  = nil
            if R:readINT() ~= 0 then 
                m_finRw = {}
                m_Response_Action_4002.finRw = m_finRw
                R:readBEGIN();
                m_finRw.diamond = R:readINT();
                m_finRw.gold = R:readINT64();
                m_finRw.exp = R:readINT();
                m_finRw.fp = R:readINT();
                m_finRw.star = R:readINT();
                local m_brlist =  {}
                m_finRw.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_finRw.sp = R:readINT();
                R:readEND();
            end
            m_Response_Action_4002.equiplst = R:readSTRING();
            local m_shops =  {}
            m_Response_Action_4002.shops = m_shops
            local nNum_m_shops = R:readINT();
            for index_m_shops = 1, nNum_m_shops do
                local item_m_shops = {}
                R:readBEGIN();
                item_m_shops.id = R:readINT();
                item_m_shops.title = R:readSTRING();
                item_m_shops.costvalue = R:readINT();
                item_m_shops.starType = R:readINT();
                local m_info  = nil
                if R:readINT() ~= 0 then 
                    m_info = {}
                    item_m_shops.info = m_info
                    R:readBEGIN();
                    m_info.no = R:readINT();
                    m_info.count = R:readINT();
                    m_info.typ = R:readINT();
                    m_info.styp = R:readINT();
                    m_info.price = R:readINT64();
                    m_info.quality = R:readINT();
                    m_info.usetype = R:readINT();
                    m_info.cansell = R:readINT();
                    m_info.sex = R:readINT();
                    m_info.needlv = R:readINT();
                    m_info.strlv = R:readINT();
                    m_info.evolv = R:readINT();
                    m_info.part = R:readINT();
                    local m_pros =  {}
                    m_info.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    m_info.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    m_info.ext = R:readSTRING();
                    m_info.name = R:readSTRING();
                    m_info.memo = R:readSTRING();
                    m_info.add = R:readINT();
                    m_info.setid = R:readINT();
                    m_info.eqid = R:readINT64();
                    m_info.pic = R:readSTRING();
                    m_info.isOn = R:readINT();
                    local m_setids =  {}
                    m_info.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                end
                item_m_shops.count = R:readINT();
                item_m_shops.buytyp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_shops,item_m_shops)
            end
            m_Response_Action_4002.shoptyp = R:readINT();
            m_Response_Action_4002.pestscno = R:readINT();
            m_Response_Action_4002.pestString = R:readSTRING();
            R:readEND();
            return m_Response_Action_4002
        end
    end
    return nil
end

--获得关卡固定奖励 4007
function M.GetData_4007()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4007  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4007 = {}
            R:readBEGIN();
            local m_expInfos =  {}
            m_Response_Action_4007.expInfos = m_expInfos
            local nNum_m_expInfos = R:readINT();
            for index_m_expInfos = 1, nNum_m_expInfos do
                local item_m_expInfos = {}
                R:readBEGIN();
                local m_rewards =  {}
                item_m_expInfos.rewards = m_rewards
                local nNum_m_rewards = R:readINT();
                for index_m_rewards = 1, nNum_m_rewards do
                    local item_m_rewards = {}
                    R:readBEGIN();
                    local m_brlist  = nil
                    if R:readINT() ~= 0 then 
                        m_brlist = {}
                        item_m_rewards.brlist = m_brlist
                        R:readBEGIN();
                        m_brlist.no = R:readINT();
                        m_brlist.count = R:readINT();
                        m_brlist.typ = R:readINT();
                        m_brlist.styp = R:readINT();
                        m_brlist.price = R:readINT64();
                        m_brlist.quality = R:readINT();
                        m_brlist.usetype = R:readINT();
                        m_brlist.cansell = R:readINT();
                        m_brlist.sex = R:readINT();
                        m_brlist.needlv = R:readINT();
                        m_brlist.strlv = R:readINT();
                        m_brlist.evolv = R:readINT();
                        m_brlist.part = R:readINT();
                        local m_pros =  {}
                        m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        m_brlist.ext = R:readSTRING();
                        m_brlist.name = R:readSTRING();
                        m_brlist.memo = R:readSTRING();
                        m_brlist.add = R:readINT();
                        m_brlist.setid = R:readINT();
                        m_brlist.eqid = R:readINT64();
                        m_brlist.pic = R:readSTRING();
                        m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                    end
                    item_m_rewards.status = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_rewards,item_m_rewards)
                end
                item_m_expInfos.fin = R:readINT();
                item_m_expInfos.cd = R:readINT();
                item_m_expInfos.subsn = R:readINT();
                item_m_expInfos.isopen = R:readINT();
                R:readEND();
                CommonTable.push_back(m_expInfos,item_m_expInfos)
            end
            m_Response_Action_4007.sp = R:readINT();
            m_Response_Action_4007.maxlv = R:readINT();
            R:readEND();
            return m_Response_Action_4007
        end
    end
    return nil
end

-- 赞美
function M.GetData_4008()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4008  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4008 = {}
            R:readBEGIN();
            m_Response_Action_4008.fp = R:readINT();
            R:readEND();
            return m_Response_Action_4008
        end
    end
    return nil
end

-- 偷盗
function M.GetData_4009()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4009  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4009 = {}
            R:readBEGIN();
            m_Response_Action_4009.res = R:readINT();
            m_Response_Action_4009.gold = R:readINT64();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_4009.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_4009
        end
    end
    return nil
end
--
function M.GetData_4010()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4010  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4010 = {}
            R:readBEGIN();
            local m_rs  = nil
            if R:readINT() ~= 0 then 
                m_rs = {}
                m_Response_Action_4010.rs = m_rs
                R:readBEGIN();
                m_rs.diamond = R:readINT();
                m_rs.gold = R:readINT64();
                m_rs.exp = R:readINT();
                m_rs.fp = R:readINT();
                m_rs.star = R:readINT();
                local m_brlist =  {}
                m_rs.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_4010
        end
    end
    return nil
end
--进入神秘商店页面
function M.GetData_4011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4011  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4011 = {}
            R:readBEGIN();
            m_Response_Action_4011.shoptyp = R:readINT();
            local m_shops =  {}
            m_Response_Action_4011.shops = m_shops
            local nNum_m_shops = R:readINT();
            for index_m_shops = 1, nNum_m_shops do
                local item_m_shops = {}
                R:readBEGIN();
                item_m_shops.id = R:readINT();
                item_m_shops.title = R:readSTRING();
                item_m_shops.costvalue = R:readINT();
                item_m_shops.starType = R:readINT();
                local m_info  = nil
                if R:readINT() ~= 0 then 
                    m_info = {}
                    item_m_shops.info = m_info
                    R:readBEGIN();
                    m_info.no = R:readINT();
                    m_info.count = R:readINT();
                    m_info.typ = R:readINT();
                    m_info.styp = R:readINT();
                    m_info.price = R:readINT64();
                    m_info.quality = R:readINT();
                    m_info.usetype = R:readINT();
                    m_info.cansell = R:readINT();
                    m_info.sex = R:readINT();
                    m_info.needlv = R:readINT();
                    m_info.strlv = R:readINT();
                    m_info.evolv = R:readINT();
                    m_info.part = R:readINT();
                    local m_pros =  {}
                    m_info.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    m_info.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    m_info.ext = R:readSTRING();
                    m_info.name = R:readSTRING();
                    m_info.memo = R:readSTRING();
                    m_info.add = R:readINT();
                    m_info.setid = R:readINT();
                    m_info.eqid = R:readINT64();
                    m_info.pic = R:readSTRING();
                    m_info.isOn = R:readINT();
                    local m_setids =  {}
                    m_info.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                end
                item_m_shops.count = R:readINT();
                item_m_shops.state = R:readINT();
                item_m_shops.buytyp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_shops,item_m_shops)
            end
            R:readEND();
            return m_Response_Action_4011
        end
    end
    return nil
end
--获得特殊副本列表
function M.GetData_4101()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4101  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4101 = {}
            R:readBEGIN();
            m_Response_Action_4101.issd = R:readINT();
            m_Response_Action_4101.sdtime = R:readINT();
            m_Response_Action_4101.sdtyp = R:readINT();
            m_Response_Action_4101.curtyp = R:readINT();
            local m_lst =  {}
            m_Response_Action_4101.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.typ = R:readINT();
                item_m_lst.time = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_lst.highno = R:readINT();
                item_m_lst.needdia = R:readINT();
                item_m_lst.sdtyp = R:readINT();
                item_m_lst.count = R:readINT();
                local m_tinfos =  {}
                item_m_lst.tinfos = m_tinfos
                local nNum_m_tinfos = R:readINT();
                for index_m_tinfos = 1, nNum_m_tinfos do
                    local item_m_tinfos = {}
                    R:readBEGIN();
                    item_m_tinfos.no = R:readINT();
                    item_m_tinfos.name = R:readSTRING();
                    item_m_tinfos.status = R:readINT();
                    item_m_tinfos.demo = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_tinfos,item_m_tinfos)
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_4101
        end
    end
    return nil
end

--领奖、立即完成扫荡
function M.GetData_4102()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4102  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4102 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_4102.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_4102
        end
    end
    return nil
end

--特殊副本战斗
function M.GetData_4103()
    if R:getResult() == RREST.Success then
        local m_Response_Action_2001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_2001 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_2001.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_2001.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_2001.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                m_result.jjcScore = R:readINT();
                m_result.rank = R:readINT();
                m_result.rankvar = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                local m_levels =  {}
                m_result.levels = m_levels
                local nNum_m_levels = R:readINT();
                for index_m_levels = 1, nNum_m_levels do
                    local item_m_levels = {}
                    R:readBEGIN();
                    item_m_levels.sn = R:readINT();
                    item_m_levels.subsn = R:readINT();
                    item_m_levels.star = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_levels,item_m_levels)
                end
                m_result.flag = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_2001
        end
    end
    return nil
end
--[[ 
    ************************ 竞技系统 ************************ 5xxx
--]]
--排行列表
function M.GetData_5001()
    if R:getResult() == RREST.Success then
        local m_MsgGetRankList  = nil
        if R:readINT() ~= 0 then 
            m_MsgGetRankList = {}
            R:readBEGIN();
            m_MsgGetRankList.cd = R:readINT();
            m_MsgGetRankList.count = R:readINT();
            m_MsgGetRankList.myrank = R:readINT();
            local m_players =  {}
            m_MsgGetRankList.players = m_players
            local nNum_m_players = R:readINT();
            for index_m_players = 1, nNum_m_players do
                local item_m_players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_players.isfriend = R:readINT();
                item_m_players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_players,item_m_players)
            end
            local m_top10players =  {}
            m_MsgGetRankList.top10players = m_top10players
            local nNum_m_top10players = R:readINT();
            for index_m_top10players = 1, nNum_m_top10players do
                local item_m_top10players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_top10players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_top10players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_top10players.isfriend = R:readINT();
                item_m_top10players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_top10players,item_m_top10players)
            end
            m_MsgGetRankList.jjcState = R:readINT();
            R:readEND();
            return m_MsgGetRankList
        end
    end
    return nil
end

--购买挑战次数
function M.GetData_5002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_5002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_5002 = {}
            R:readBEGIN()
            m_Response_Action_5002.count = R:readINT()
            R:readEND()
            return m_Response_Action_5002
        end
    end
    return nil
end

--排行列表
function M.GetData_5006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_5006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_5006 = {}
            R:readBEGIN();
            local m_records =  {}
            m_Response_Action_5006.records = m_records
            local nNum_m_records = R:readINT();
            for index_m_records = 1, nNum_m_records do
                local item_m_records = {}
                R:readBEGIN();
                item_m_records.id = R:readINT64();
                item_m_records.res = R:readINT();
                item_m_records.rankvar = R:readINT();
                item_m_records.pkdate = R:readSTRING();
                local m_players  = nil
                if R:readINT() ~= 0 then 
                    m_players = {}
                    item_m_records.players = m_players
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_players.hero = m_hero
                        R:readBEGIN();
                        m_hero.id = R:readINT64();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.lv = R:readINT();
                        m_hero.winrate = R:readINT();
                        m_hero.count = R:readINT();
                        m_hero.rank = R:readINT();
                        m_hero.lastdate = R:readSTRING();
                        m_hero.org = R:readSTRING();
                        m_hero.sex = R:readINT();
                        R:readEND();
                    end
                    local m_card  = nil
                    if R:readINT() ~= 0 then 
                        m_card = {}
                        m_players.card = m_card
                        R:readBEGIN();
                        m_card.id = R:readINT64();
                        m_card.lv = R:readINT();
                        m_card.evolv = R:readINT();
                        R:readEND();
                    end
                    m_players.isfriend = R:readINT();
                    m_players.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_records,item_m_records)
            end
            local m_top10players =  {}
            m_Response_Action_5006.top10players = m_top10players
            local nNum_m_top10players = R:readINT();
            for index_m_top10players = 1, nNum_m_top10players do
                local item_m_top10players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_top10players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_top10players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_top10players.isfriend = R:readINT();
                item_m_top10players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_top10players,item_m_top10players)
            end
            R:readEND();
            return m_Response_Action_5006
        end
    end
    return nil
end


-- 播放录像请求 5007
function M.GetData_5007()
    return GetData_fight()
end

--周竞技场列表
function M.GetData_5008()
    if R:getResult() == RREST.Success then
        local m_Msg_JJC  = nil
        if R:readINT() ~= 0 then 
            m_Msg_JJC = {}
            R:readBEGIN();
            m_Msg_JJC.cd = R:readINT();
            m_Msg_JJC.spareTime = R:readSTRING();
            m_Msg_JJC.jjcScore = R:readINT();
            local m_players =  {}
            m_Msg_JJC.players = m_players
            local nNum_m_players = R:readINT();
            for index_m_players = 1, nNum_m_players do
                local item_m_players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_players.isfriend = R:readINT();
                item_m_players.score = R:readINT();
                item_m_players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_players,item_m_players)
            end
            m_Msg_JJC.curGameNum = R:readINT();
            m_Msg_JJC.upRank = R:readINT();
            m_Msg_JJC.curRank = R:readINT();
            local m_top10players =  {}
            m_Msg_JJC.top10players = m_top10players
            local nNum_m_top10players = R:readINT();
            for index_m_top10players = 1, nNum_m_top10players do
                local item_m_top10players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_top10players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_top10players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_top10players.isfriend = R:readINT();
                item_m_top10players.score = R:readINT();
                item_m_top10players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_top10players,item_m_top10players)
            end
            m_Msg_JJC.reward = R:readINT();
            m_Msg_JJC.getNextRewardTime = R:readSTRING();
            m_Msg_JJC.jjcState = R:readINT();
            R:readEND();
            return m_Msg_JJC
        end
    end
    return nil
end

--排行列表
function M.GetData_5009()
    if R:getResult() == RREST.Success then
        local m_Response_Action_5009  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_5009 = {}
            -- R:readBEGIN();
            -- R:readEND();
            return m_Response_Action_5009
        end
    end
    return nil
end


--录像回放
function M.GetData_5010()
    if R:getResult() == RREST.Success then
        local m_Response_Action_5010  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_5010 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_5010.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_5010.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_5010.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                local m_cards =  {}
                m_result.cards = m_cards
                local nNum_m_cards = R:readINT();
                for index_m_cards = 1, nNum_m_cards do
                    local item_m_cards = {}
                    R:readBEGIN();
                    item_m_cards.id = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_cards,item_m_cards)
                end
                local m_chips =  {}
                m_result.chips = m_chips
                local nNum_m_chips = R:readINT();
                for index_m_chips = 1, nNum_m_chips do
                    local item_m_chips = {}
                    R:readBEGIN();
                    item_m_chips.id = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_chips,item_m_chips)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_5010
        end
    end
    return nil
end

--排行列表
function M.GetData_5011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_5011  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_5011 = {}
            R:readBEGIN();
            local m_records =  {}
            m_Response_Action_5011.records = m_records
            local nNum_m_records = R:readINT();
            for index_m_records = 1, nNum_m_records do
                local item_m_records = {}
                R:readBEGIN();
                item_m_records.id = R:readINT64();
                item_m_records.res = R:readINT();
                item_m_records.rankvar = R:readINT();
                item_m_records.pkdate = R:readSTRING();
                local m_players  = nil
                if R:readINT() ~= 0 then 
                    m_players = {}
                    item_m_records.players = m_players
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_players.hero = m_hero
                        R:readBEGIN();
                        m_hero.id = R:readINT64();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.lv = R:readINT();
                        m_hero.winrate = R:readINT();
                        m_hero.count = R:readINT();
                        m_hero.rank = R:readINT();
                        m_hero.lastdate = R:readSTRING();
                        m_hero.org = R:readSTRING();
                        m_hero.sex = R:readINT();
                        R:readEND();
                    end
                    local m_card  = nil
                    if R:readINT() ~= 0 then 
                        m_card = {}
                        m_players.card = m_card
                        R:readBEGIN();
                        m_card.id = R:readINT64();
                        m_card.lv = R:readINT();
                        m_card.evolv = R:readINT();
                        R:readEND();
                    end
                    m_players.isfriend = R:readINT();
                    m_players.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_records,item_m_records)
            end
            local m_top10players =  {}
            m_Response_Action_5011.top10players = m_top10players
            local nNum_m_top10players = R:readINT();
            for index_m_top10players = 1, nNum_m_top10players do
                local item_m_top10players = {}
                R:readBEGIN();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_top10players.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_top10players.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_top10players.isfriend = R:readINT();
                item_m_top10players.score = R:readINT();
                item_m_top10players.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_top10players,item_m_top10players)
            end
            R:readEND();
            return m_Response_Action_5011
        end
    end
    return nil
end


--[[ 
    ************************ 商店系统 ************************ 6xxx
--]]
-- 进入商店页面 6001
function M.GetData_6001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6001 = {}
            R:readBEGIN();
            local m_shops =  {}
            m_Response_Action_6001.shops = m_shops
            local nNum_m_shops = R:readINT();
            for index_m_shops = 1, nNum_m_shops do
                local item_m_shops = {}
                R:readBEGIN();
                item_m_shops.id = R:readINT();
                item_m_shops.btnstring = R:readSTRING();
                item_m_shops.title = R:readSTRING();
                item_m_shops.desc1 = R:readSTRING();
                item_m_shops.desc2 = R:readSTRING();
                item_m_shops.pic = R:readSTRING();
                item_m_shops.statuspic = R:readSTRING();
                item_m_shops.titlepic = R:readSTRING();
                item_m_shops.costvalue = R:readINT();
                item_m_shops.iapproductid = R:readSTRING();
                item_m_shops.shoptype = R:readINT();
                item_m_shops.memo = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_shops,item_m_shops)
            end
            R:readEND();
            return m_Response_Action_6001
        end
    end
    return nil
end

-- 购买请求 6002
--进入商店页面
function M.GetData_6002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6002 = {}
            R:readBEGIN();
            local m_newcards =  {}
            m_Response_Action_6002.newcards = m_newcards
            local nNum_m_newcards = R:readINT();
            for index_m_newcards = 1, nNum_m_newcards do
                local item_m_newcards = {}
                R:readBEGIN();
                item_m_newcards.no = R:readINT();
                item_m_newcards.count = R:readINT();
                item_m_newcards.typ = R:readINT();
                item_m_newcards.styp = R:readINT();
                item_m_newcards.price = R:readINT64();
                item_m_newcards.quality = R:readINT();
                item_m_newcards.usetype = R:readINT();
                item_m_newcards.cansell = R:readINT();
                item_m_newcards.sex = R:readINT();
                item_m_newcards.needlv = R:readINT();
                item_m_newcards.strlv = R:readINT();
                item_m_newcards.evolv = R:readINT();
                item_m_newcards.part = R:readINT();
                local m_pros =  {}
                item_m_newcards.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_newcards.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_newcards.ext = R:readSTRING();
                item_m_newcards.name = R:readSTRING();
                item_m_newcards.memo = R:readSTRING();
                item_m_newcards.add = R:readINT();
                item_m_newcards.setid = R:readINT();
                item_m_newcards.eqid = R:readINT64();
                item_m_newcards.pic = R:readSTRING();
                item_m_newcards.isOn = R:readINT();
                local m_setids =  {}
                item_m_newcards.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_newcards,item_m_newcards)
            end
            m_Response_Action_6002.typ = R:readINT();
            R:readEND();
            return m_Response_Action_6002
        end
    end
    return nil
end

--进入商店页面
function M.GetData_6003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6003 = {}
            R:readBEGIN();
            local m_iaps =  {}
            m_Response_Action_6003.iaps = m_iaps
            local nNum_m_iaps = R:readINT();
            for index_m_iaps = 1, nNum_m_iaps do
                local item_m_iaps = {}
                R:readBEGIN();
                item_m_iaps.id = R:readSTRING();
                item_m_iaps.kind = R:readINT();
                item_m_iaps.desc1 = R:readSTRING();
                item_m_iaps.desc2 = R:readSTRING();
                item_m_iaps.btnstring = R:readSTRING();
                item_m_iaps.statuspic = R:readSTRING();
                item_m_iaps.pic = R:readSTRING();
                item_m_iaps.titlepic = R:readSTRING();
                item_m_iaps.iapproductid = R:readSTRING();
                item_m_iaps.price = R:readINT();
                R:readEND();
                CommonTable.push_back(m_iaps,item_m_iaps)
            end
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_6003.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_6003
        end
    end
    return nil
end

--进入商店页面
function M.GetData_6004()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6004  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6004 = {}
            R:readBEGIN();
            m_Response_Action_6004.appordercode = R:readSTRING();
            R:readEND();
            return m_Response_Action_6004
        end
    end
    return nil
end


--进入商店页面
--进入商店页面
function M.GetData_6005()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6005 = {}
            R:readBEGIN();
            local m_shops =  {}
            m_Response_Action_6005.shops = m_shops
            local nNum_m_shops = R:readINT();
            for index_m_shops = 1, nNum_m_shops do
                local item_m_shops = {}
                R:readBEGIN();
                item_m_shops.id = R:readINT();
                item_m_shops.title = R:readSTRING();
                item_m_shops.costvalue = R:readINT();
                item_m_shops.starType = R:readINT();
                local m_info  = nil
                if R:readINT() ~= 0 then 
                    m_info = {}
                    item_m_shops.info = m_info
                    R:readBEGIN();
                    m_info.no = R:readINT();
                    m_info.count = R:readINT();
                    m_info.typ = R:readINT();
                    m_info.styp = R:readINT();
                    m_info.price = R:readINT64();
                    m_info.quality = R:readINT();
                    m_info.usetype = R:readINT();
                    m_info.cansell = R:readINT();
                    m_info.sex = R:readINT();
                    m_info.needlv = R:readINT();
                    m_info.strlv = R:readINT();
                    m_info.evolv = R:readINT();
                    m_info.part = R:readINT();
                    local m_pros =  {}
                    m_info.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    m_info.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    m_info.ext = R:readSTRING();
                    m_info.name = R:readSTRING();
                    m_info.memo = R:readSTRING();
                    m_info.add = R:readINT();
                    m_info.setid = R:readINT();
                    m_info.eqid = R:readINT64();
                    m_info.pic = R:readSTRING();
                    m_info.isOn = R:readINT();
                    local m_setids =  {}
                    m_info.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                end
                item_m_shops.count = R:readINT();
                R:readEND();
                CommonTable.push_back(m_shops,item_m_shops)
            end
            R:readEND();
            return m_Response_Action_6005
        end
    end
    return nil
end

--新买的卡牌信息数组
function M.GetData_6006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_6006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_6006 = {}
            R:readBEGIN();
            local m_rs  = nil
            if R:readINT() ~= 0 then 
                m_rs = {}
                m_Response_Action_6006.rs = m_rs
                R:readBEGIN();
                m_rs.diamond = R:readINT();
                m_rs.gold = R:readINT64();
                m_rs.exp = R:readINT();
                m_rs.fp = R:readINT();
                m_rs.star = R:readINT();
                local m_brlist =  {}
                m_rs.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_6006
        end
    end
    return nil
end

--进入商店页面
function M.GetData_6007()
    return M.GetData_6005()
end

--新买的卡牌信息数组
function M.GetData_6008()
    return M.GetData_6006()
end


--[[ 
    ************************ 互动系统 ************************ 7xxx
--]]
-- ***好友系统*** 71xx
-- 好友列表
local function GetData_friendlist()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common_Friend  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common_Friend = {}
            R:readBEGIN();
            m_Response_Action_Common_Friend.fcount = R:readINT();
            m_Response_Action_Common_Friend.tcount = R:readINT();
            local m_friends =  {}
            m_Response_Action_Common_Friend.friends = m_friends
            local nNum_m_friends = R:readINT();
            for index_m_friends = 1, nNum_m_friends do
                local item_m_friends = {}
                R:readBEGIN();
                item_m_friends.isfriend = R:readINT();
                item_m_friends.afripoint = R:readINT();
                item_m_friends.sfripoint = R:readINT();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_friends.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    m_hero.equipEffect = R:readSTRING();
                    m_hero.equiplst = R:readSTRING();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_friends.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_friends.fPoint = R:readINT();
                item_m_friends.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_friends,item_m_friends)
            end
            R:readEND();
            return m_Response_Action_Common_Friend
        end
    end
    return nil
end
-- 好友申请列表
local function GetData_friapplist()
    if R:getResult() == RREST.Success then
        local m_FriendApps_comm  = nil
        if R:readINT() ~= 0 then 
            m_FriendApps_comm = {}
            R:readBEGIN();
            local m_friendapps =  {}
            m_FriendApps_comm.friendapps = m_friendapps
            local nNum_m_friendapps = R:readINT();
            for index_m_friendapps = 1, nNum_m_friendapps do
                local item_m_friendapps = {}
                R:readBEGIN();
                item_m_friendapps.appId = R:readINT64();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_friendapps.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    m_hero.equipEffect = R:readSTRING();
                    m_hero.equiplst = R:readSTRING();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_friendapps.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_friendapps.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_friendapps,item_m_friendapps)
            end
            m_FriendApps_comm.fcount = R:readINT();
            R:readEND();
            return m_FriendApps_comm
        end
    end
    return nil
end

-- 请求好友列表 7101
function M.GetData_7101()
    return GetData_friendlist()
end

-- 随机玩家列表 7102
function M.GetData_7102()
    return GetData_friendlist()
end

-- 查找指定玩家 7103
function M.GetData_7103()
    return GetData_friendlist()
end

-- 好友申请 7104
function M.GetData_7104()
    return GetData_friendlist()
end

-- 删除好友 7105
function M.GetData_7105()
    return GetData_friendlist()
end

-- 获取好友申请列表 7106
function M.GetData_7106()
    return GetData_friapplist()
end

-- 同意好友申请 7107
function M.GetData_7107()
    return GetData_friapplist()
end

-- 删除好友申请 7108
function M.GetData_7108()
    return GetData_friapplist()
end

-- 查看玩家详细信息 7109
function M.GetData_7109()
    if R:getResult() == RREST.Success then
        local m_PlayerDetail  = nil
        if R:readINT() ~= 0 then 
            m_PlayerDetail = {}
            R:readBEGIN();
            m_PlayerDetail.isfriend = R:readINT();
            local m_hero  = nil
            if R:readINT() ~= 0 then 
                m_hero = {}
                m_PlayerDetail.hero = m_hero
                R:readBEGIN();
                m_hero.id = R:readINT64();
                m_hero.name = R:readSTRING();
                m_hero.head = R:readSTRING();
                m_hero.lv = R:readINT();
                m_hero.winrate = R:readINT();
                m_hero.count = R:readINT();
                m_hero.rank = R:readINT();
                m_hero.lastdate = R:readSTRING();
                m_hero.org = R:readSTRING();
                m_hero.sex = R:readINT();
                m_hero.totalhp = R:readINT();
                m_hero.totalatk = R:readINT();
                m_hero.equipEffect = R:readSTRING();
                local m_equipinfolst =  {}
                m_hero.equipinfolst = m_equipinfolst
                local nNum_m_equipinfolst = R:readINT();
                for index_m_equipinfolst = 1, nNum_m_equipinfolst do
                    local item_m_equipinfolst = {}
                    R:readBEGIN();
                    item_m_equipinfolst.no = R:readINT();
                    item_m_equipinfolst.count = R:readINT();
                    item_m_equipinfolst.typ = R:readINT();
                    item_m_equipinfolst.styp = R:readINT();
                    item_m_equipinfolst.price = R:readINT64();
                    item_m_equipinfolst.quality = R:readINT();
                    item_m_equipinfolst.usetype = R:readINT();
                    item_m_equipinfolst.cansell = R:readINT();
                    item_m_equipinfolst.sex = R:readINT();
                    item_m_equipinfolst.needlv = R:readINT();
                    item_m_equipinfolst.strlv = R:readINT();
                    item_m_equipinfolst.evolv = R:readINT();
                    item_m_equipinfolst.part = R:readINT();
                    local m_pros =  {}
                    item_m_equipinfolst.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_equipinfolst.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_equipinfolst.ext = R:readSTRING();
                    item_m_equipinfolst.name = R:readSTRING();
                    item_m_equipinfolst.memo = R:readSTRING();
                    item_m_equipinfolst.add = R:readINT();
                    item_m_equipinfolst.setid = R:readINT();
                    item_m_equipinfolst.eqid = R:readINT64();
                    item_m_equipinfolst.pic = R:readSTRING();
                    item_m_equipinfolst.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_equipinfolst.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_equipinfolst,item_m_equipinfolst)
                end
                m_hero.EquipSk = R:readSTRING();
                R:readEND();
            end
            local m_card  = nil
            if R:readINT() ~= 0 then 
                m_card = {}
                m_PlayerDetail.card = m_card
                R:readBEGIN();
                m_card.id = R:readINT64();
                m_card.lv = R:readINT();
                m_card.evolv = R:readINT();
                R:readEND();
            end
            m_PlayerDetail.talent = R:readSTRING();
            R:readEND();
            return m_PlayerDetail
        end
    end
    return nil
end

--赠送友情点数
function M.GetData_7110()
    return GetData_friendlist()
end

--接受友情点数
function M.GetData_7111()
    return GetData_friendlist()
end

--请求好友列表
function M.GetData_7113()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common_Friend_Invite  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common_Friend_Invite = {}
            R:readBEGIN();
            m_Response_Action_Common_Friend_Invite.fcount = R:readINT();
            m_Response_Action_Common_Friend_Invite.tcount = R:readINT();
            local m_friends =  {}
            m_Response_Action_Common_Friend_Invite.friends = m_friends
            local nNum_m_friends = R:readINT();
            for index_m_friends = 1, nNum_m_friends do
                local item_m_friends = {}
                R:readBEGIN();
                item_m_friends.isfriend = R:readINT();
                item_m_friends.afripoint = R:readINT();
                item_m_friends.sfripoint = R:readINT();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_friends.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    m_hero.equipEffect = R:readSTRING();
                    m_hero.equiplst = R:readSTRING();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_friends.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_friends.fPoint = R:readINT();
                item_m_friends.status = R:readINT();
                item_m_friends.nextInviteTime = R:readINT();
                item_m_friends.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_friends,item_m_friends)
            end
            R:readEND();
            return m_Response_Action_Common_Friend_Invite
        end
    end
    return nil
end
--赠送友情点数
function M.GetData_7114()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common_Friend  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common_Friend = {}
            R:readBEGIN();
            m_Response_Action_Common_Friend.fcount = R:readINT();
            m_Response_Action_Common_Friend.tcount = R:readINT();
            local m_friends =  {}
            m_Response_Action_Common_Friend.friends = m_friends
            local nNum_m_friends = R:readINT();
            for index_m_friends = 1, nNum_m_friends do
                local item_m_friends = {}
                R:readBEGIN();
                item_m_friends.isfriend = R:readINT();
                item_m_friends.afripoint = R:readINT();
                item_m_friends.sfripoint = R:readINT();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_friends.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    m_hero.equipEffect = R:readSTRING();
                    m_hero.equiplst = R:readSTRING();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_friends.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_friends.fPoint = R:readINT();
                item_m_friends.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_friends,item_m_friends)
            end
            R:readEND();
            return m_Response_Action_Common_Friend
        end
    end
    return nil
end

--接受友情点数
function M.GetData_7115()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Common_Friend  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Common_Friend = {}
            R:readBEGIN();
            m_Response_Action_Common_Friend.fcount = R:readINT();
            m_Response_Action_Common_Friend.tcount = R:readINT();
            local m_friends =  {}
            m_Response_Action_Common_Friend.friends = m_friends
            local nNum_m_friends = R:readINT();
            for index_m_friends = 1, nNum_m_friends do
                local item_m_friends = {}
                R:readBEGIN();
                item_m_friends.isfriend = R:readINT();
                item_m_friends.afripoint = R:readINT();
                item_m_friends.sfripoint = R:readINT();
                local m_hero  = nil
                if R:readINT() ~= 0 then 
                    m_hero = {}
                    item_m_friends.hero = m_hero
                    R:readBEGIN();
                    m_hero.id = R:readINT64();
                    m_hero.name = R:readSTRING();
                    m_hero.head = R:readSTRING();
                    m_hero.lv = R:readINT();
                    m_hero.winrate = R:readINT();
                    m_hero.count = R:readINT();
                    m_hero.rank = R:readINT();
                    m_hero.lastdate = R:readSTRING();
                    m_hero.org = R:readSTRING();
                    m_hero.sex = R:readINT();
                    m_hero.equipEffect = R:readSTRING();
                    m_hero.equiplst = R:readSTRING();
                    R:readEND();
                end
                local m_card  = nil
                if R:readINT() ~= 0 then 
                    m_card = {}
                    item_m_friends.card = m_card
                    R:readBEGIN();
                    m_card.id = R:readINT64();
                    m_card.lv = R:readINT();
                    m_card.evolv = R:readINT();
                    R:readEND();
                end
                item_m_friends.fPoint = R:readINT();
                item_m_friends.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_friends,item_m_friends)
            end
            R:readEND();
            return m_Response_Action_Common_Friend
        end
    end
    return nil
end
-- ***留言系统（玩家）*** 72xx
-- 好友留言列表
local function GetData_frimeslist()
    if R:getResult() == RREST.Success then
        local m_Message_sys_common  = nil
        if R:readINT() ~= 0 then 
            m_Message_sys_common = {}
            R:readBEGIN()
            local m_messages =  {}
            m_Message_sys_common.messages = m_messages
            local nNum_m_messages = R:readINT()
            for index_m_messages = 1, nNum_m_messages do
                local item_m_messages = {}
                R:readBEGIN()
                item_m_messages.id = R:readINT()
                item_m_messages.content = R:readSTRING()
                item_m_messages.isnew = R:readINT()
                item_m_messages.date = R:readSTRING()
                local m_heroObj  = nil
                if R:readINT() ~= 0 then 
                    m_heroObj = {}
                    item_m_messages.heroObj = m_heroObj
                    R:readBEGIN()
                    m_heroObj.id = R:readINT64()
                    m_heroObj.name = R:readSTRING()
                    R:readEND()
                end
                R:readEND()
                CommonTable.push_back(m_messages,item_m_messages)
            end
            R:readEND()
            return m_Message_sys_common
        end
    end
    return nil
end
-- 查看留言 7201 
function M.GetData_7201()
    return GetData_frimeslist()
end

-- 删除留言 7203 (暂无) 
function M.GetData_7203()
    return GetData_frimeslist()
end

-- ***邮件系统(系统公告)*** 73xx
-- 系统邮件列表
local function GetData_maillist()
    if R:getResult() == RREST.Success then
        local m_Email_sys_comm  = nil
        if R:readINT() ~= 0 then 
            m_Email_sys_comm = {}
            R:readBEGIN()
            local m_mails =  {}
            m_Email_sys_comm.mails = m_mails
            local nNum_m_mails = R:readINT()
            for index_m_mails = 1, nNum_m_mails do
                local item_m_mails = {}
                R:readBEGIN()
                item_m_mails.id = R:readINT()
                item_m_mails.content = R:readSTRING()
                item_m_mails.isnew = R:readINT()
                item_m_mails.date = R:readSTRING()
                R:readEND()
                CommonTable.push_back(m_mails,item_m_mails)
            end
            R:readEND()
            return m_Email_sys_comm
        end
    end
    return nil
end
-- 邮件列表 7301 
function M.GetData_7301()
    return GetData_maillist()
end

-- 删除邮件 7302 
function M.GetData_7302()
    return GetData_maillist()
end


--[[ 
    ************************ 活动系统 ************************ 8xxx
--]]
--活动列表 8001
function M.GetData_8001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8001 = {}
            R:readBEGIN();
            local m_rewards =  {}
            m_Response_Action_8001.rewards = m_rewards
            local nNum_m_rewards = R:readINT();
            for index_m_rewards = 1, nNum_m_rewards do
                local item_m_rewards = {}
                R:readBEGIN();
                item_m_rewards.aid = R:readINT();
                item_m_rewards.rid = R:readINT();
                item_m_rewards.pic = R:readSTRING();
                item_m_rewards.title = R:readSTRING();
                item_m_rewards.desc = R:readSTRING();
                item_m_rewards.cur = R:readINT();
                item_m_rewards.total = R:readINT();
                item_m_rewards.status = R:readINT();
                item_m_rewards.target = R:readINT();
                item_m_rewards.sign = R:readSTRING();
                local m_signrewards =  {}
                item_m_rewards.signrewards = m_signrewards
                local nNum_m_signrewards = R:readINT();
                for index_m_signrewards = 1, nNum_m_signrewards do
                    local item_m_signrewards = {}
                    R:readBEGIN();
                    item_m_signrewards.location = R:readINT();
                    item_m_signrewards.rewardtype = R:readINT();
                    item_m_signrewards.num = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_signrewards,item_m_signrewards)
                end
                item_m_rewards.rewardtype = R:readINT();
                R:readEND();
                CommonTable.push_back(m_rewards,item_m_rewards)
            end
            R:readEND();
            return m_Response_Action_8001
        end
    end
    return nil
end

--奖励列表 8002
function M.GetData_8002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8002 = {}
            R:readBEGIN();
            m_Response_Action_8002.diamond = R:readINT();
            m_Response_Action_8002.gold = R:readINT64();
            m_Response_Action_8002.exp = R:readINT();
            m_Response_Action_8002.fp = R:readINT();
            m_Response_Action_8002.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8002.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8002.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = {}
                R:readBEGIN();
                item_m_chips.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8002.freebuy = R:readINT();
            m_Response_Action_8002.bigrewardtype = R:readINT();
            m_Response_Action_8002.bigrewardvalue = R:readINT();
            m_Response_Action_8002.star = R:readINT();
            local m_brlist =  {}
            m_Response_Action_8002.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            R:readEND();
            return m_Response_Action_8002
        end
    end
    return nil
end

--冲级赛列表 8011
function M.GetData_8011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8011  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8011 = {}
            R:readBEGIN();
            m_Response_Action_8011.myrank = R:readINT64();
            local m_playerlist =  {}
            m_Response_Action_8011.playerlist = m_playerlist
            local nNum_m_playerlist = R:readINT();
            for index_m_playerlist = 1, nNum_m_playerlist do
                local item_m_playerlist = {}
                R:readBEGIN();
                item_m_playerlist.userid = R:readINT64();
                item_m_playerlist.name = R:readSTRING();
                item_m_playerlist.head = R:readSTRING();
                item_m_playerlist.lv = R:readINT();
                item_m_playerlist.rank = R:readINT();
                item_m_playerlist.exp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_playerlist,item_m_playerlist)
            end
            m_Response_Action_8011.endtime = R:readINT();
            m_Response_Action_8011.enddate = R:readSTRING();
            m_Response_Action_8011.getreward = R:readINT();
            R:readEND();
            return m_Response_Action_8011
        end
    end
    return nil
end

--冲级赛奖励列表 8012
function M.GetData_8012()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8012  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8012 = {}
            R:readBEGIN();
            m_Response_Action_8012.diamond = R:readINT();
            m_Response_Action_8012.gold = R:readINT64();
            m_Response_Action_8012.exp = R:readINT();
            m_Response_Action_8012.fp = R:readINT();
            m_Response_Action_8012.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8012.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8012.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = {}
                R:readBEGIN();
                item_m_chips.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8012.freebuy = R:readINT();
            local m_brlist =  {}
            m_Response_Action_8012.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            m_Response_Action_8012.star = R:readINT();
            R:readEND();
            return m_Response_Action_8012
        end
    end
    return nil
end

--中秋每日奖励 8013
function M.GetData_8013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8013 = {}
            R:readBEGIN();
            m_Response_Action_8013.diamond = R:readINT();
            m_Response_Action_8013.gold = R:readINT64();
            m_Response_Action_8013.exp = R:readINT();
            m_Response_Action_8013.fp = R:readINT();
            m_Response_Action_8013.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8013.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = R:readINT();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8013.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = R:readINT();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8013.freebuy = R:readINT();
            local m_brlist =  {}
            m_Response_Action_8013.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            m_Response_Action_8013.star = R:readINT();
            R:readEND();
            return m_Response_Action_8013
        end
    end
    return nil
end

--天赋排名赛列表返回包 8014
function M.GetData_8014()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8014  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8014 = {}
            R:readBEGIN();
            m_Response_Action_8014.myrank = R:readINT64();
            local m_playerlist =  {}
            m_Response_Action_8014.playerlist = m_playerlist
            local nNum_m_playerlist = R:readINT();
            for index_m_playerlist = 1, nNum_m_playerlist do
                local item_m_playerlist = {}
                R:readBEGIN();
                item_m_playerlist.userid = R:readINT64();
                item_m_playerlist.name = R:readSTRING();
                item_m_playerlist.head = R:readSTRING();
                item_m_playerlist.lv = R:readINT();
                item_m_playerlist.rank = R:readINT();
                item_m_playerlist.exp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_playerlist,item_m_playerlist)
            end
            m_Response_Action_8014.endtime = R:readINT();
            m_Response_Action_8014.enddate = R:readSTRING();
            m_Response_Action_8014.getreward = R:readINT();
            R:readEND();
            return m_Response_Action_8014
        end
    end
    return nil
end

--获取天赋排名赛奖励 8015
function M.GetData_8015()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8015  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8015 = {}
            R:readBEGIN();
            m_Response_Action_8015.diamond = R:readINT();
            m_Response_Action_8015.gold = R:readINT64();
            m_Response_Action_8015.exp = R:readINT();
            m_Response_Action_8015.fp = R:readINT();
            m_Response_Action_8015.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8015.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8015.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = {}
                R:readBEGIN();
                item_m_chips.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8015.freebuy = R:readINT();
            local m_brlist =  {}
            m_Response_Action_8015.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            m_Response_Action_8015.star = R:readINT();
            R:readEND();
            return m_Response_Action_8015
        end
    end
    return nil
end

--竞技赛奖励列表 8020
function M.GetData_8020()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8020  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8020 = {}
            R:readBEGIN();
            m_Response_Action_8020.diamond = R:readINT();
            m_Response_Action_8020.gold = R:readINT64();
            m_Response_Action_8020.exp = R:readINT();
            m_Response_Action_8020.fp = R:readINT();
            m_Response_Action_8020.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8020.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.no = R:readINT();
                item_m_cards.count = R:readINT();
                item_m_cards.typ = R:readINT();
                item_m_cards.styp = R:readINT();
                item_m_cards.price = R:readINT64();
                item_m_cards.quality = R:readINT();
                item_m_cards.usetype = R:readINT();
                item_m_cards.cansell = R:readINT();
                item_m_cards.sex = R:readINT();
                item_m_cards.needlv = R:readINT();
                item_m_cards.strlv = R:readINT();
                item_m_cards.evolv = R:readINT();
                item_m_cards.part = R:readINT();
                local m_pros =  {}
                item_m_cards.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_cards.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_cards.ext = R:readSTRING();
                item_m_cards.name = R:readSTRING();
                item_m_cards.memo = R:readSTRING();
                item_m_cards.add = R:readINT();
                item_m_cards.setid = R:readINT();
                item_m_cards.eqid = R:readINT64();
                item_m_cards.pic = R:readSTRING();
                item_m_cards.isOn = R:readINT();
                local m_setids =  {}
                item_m_cards.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8020.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = {}
                R:readBEGIN();
                item_m_chips.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8020.freebuy = R:readINT();
            R:readEND();
            return m_Response_Action_8020
        end
    end
    return nil
end

--周排名奖励获取 8021
function M.GetData_8021()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8021  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8021 = {}
            R:readBEGIN();
            m_Response_Action_8021.diamond = R:readINT();
            m_Response_Action_8021.gold = R:readINT64();
            m_Response_Action_8021.exp = R:readINT();
            m_Response_Action_8021.fp = R:readINT();
            m_Response_Action_8021.sp = R:readINT();
            local m_cards =  {}
            m_Response_Action_8021.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_chips =  {}
            m_Response_Action_8021.chips = m_chips
            local nNum_m_chips = R:readINT();
            for index_m_chips = 1, nNum_m_chips do
                local item_m_chips = {}
                R:readBEGIN();
                item_m_chips.id = R:readINT();
                R:readEND();
                CommonTable.push_back(m_chips,item_m_chips)
            end
            m_Response_Action_8021.freebuy = R:readINT();
            local m_brlist =  {}
            m_Response_Action_8021.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            m_Response_Action_8021.star = R:readINT();
            R:readEND();
            return m_Response_Action_8021
        end
    end
    return nil
end

--
function M.GetData_8022()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8022  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8022 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_8022.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_8022
        end
    end
    return nil
end

--获得已邀请注册用户列表 8100
function M.GetData_8100()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8100  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8100 = {}
            R:readBEGIN();
            m_Response_Action_8100.diamonds = R:readINT();
            local m_inviteusers =  {}
            m_Response_Action_8100.inviteusers = m_inviteusers
            local nNum_m_inviteusers = R:readINT();
            for index_m_inviteusers = 1, nNum_m_inviteusers do
                local item_m_inviteusers = {}
                R:readBEGIN();
                item_m_inviteusers.userid = R:readINT64();
                item_m_inviteusers.username = R:readSTRING();
                item_m_inviteusers.diamonds = R:readINT();
                item_m_inviteusers.invitetime = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_inviteusers,item_m_inviteusers)
            end
            m_Response_Action_8100.totalusers = R:readINT();
            m_Response_Action_8100.totaldiamonds = R:readINT();
            m_Response_Action_8100.showstr = R:readSTRING();
            m_Response_Action_8100.shareshowstr = R:readSTRING();
            m_Response_Action_8100.shareDefaultContent = R:readSTRING();
            m_Response_Action_8100.shareImage = R:readSTRING();
            m_Response_Action_8100.shareImageWithPath = R:readSTRING();
            m_Response_Action_8100.shareTitle = R:readSTRING();
            m_Response_Action_8100.shareUrl = R:readSTRING();
            m_Response_Action_8100.shareDescription = R:readSTRING();
            R:readEND();
            return m_Response_Action_8100
        end
    end
    return nil
end

-- 获得邀请奖励钻石 8101
function M.GetData_8101()
    if R:getResult() == RREST.Success then
    end
    return nil
end

-- 获取签到列表  8201
function M.GetData_8201()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8201  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8201 = {}
            R:readBEGIN();
            local m_timereward =  {}
            m_Response_Action_8201.timereward = m_timereward
            local nNum_m_timereward = R:readINT();
            for index_m_timereward = 1, nNum_m_timereward do
                local item_m_timereward = {}
                R:readBEGIN();
                item_m_timereward.title = R:readSTRING();
                item_m_timereward.rewardno = R:readINT();
                item_m_timereward.seconds = R:readINT();
                item_m_timereward.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_timereward.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_timereward,item_m_timereward)
            end
            local m_totalsign =  {}
            m_Response_Action_8201.totalsign = m_totalsign
            local nNum_m_totalsign = R:readINT();
            for index_m_totalsign = 1, nNum_m_totalsign do
                local item_m_totalsign = {}
                R:readBEGIN();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_totalsign.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_totalsign.signcount = R:readINT();
                R:readEND();
                CommonTable.push_back(m_totalsign,item_m_totalsign)
            end
            m_Response_Action_8201.signlist = R:readSTRING();
            m_Response_Action_8201.signcount = R:readINT();
            m_Response_Action_8201.signed = R:readINT();
            R:readEND();
            return m_Response_Action_8201
        end
    end
    return nil
end

--获取签到奖励
function M.GetData_8202()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8202  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8202 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_8202.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_8202
        end
    end
    return nil
end

--
function M.GetData_8301()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8301  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8301 = {}
            R:readBEGIN();
            m_Response_Action_8301.cd1 = R:readINT();
            m_Response_Action_8301.cd2 = R:readINT();
            m_Response_Action_8301.cd3 = R:readINT();
            m_Response_Action_8301.k1count = R:readINT();
            m_Response_Action_8301.k2count = R:readINT();
            m_Response_Action_8301.k3count = R:readINT();
            m_Response_Action_8301.skill = R:readINT();
            m_Response_Action_8301.diamond1 = R:readINT();
            m_Response_Action_8301.diamond2 = R:readINT();
            m_Response_Action_8301.diamond3 = R:readINT();
            R:readEND();
            return m_Response_Action_8301
        end
    end
    return nil
end

--
function M.GetData_8302()
    if R:getResult() == RREST.Success then
        local m_Response_Action_8302  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_8302 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_8302.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_8302
        end
    end
    return nil
end
function M.GetData_8303()
    return M.GetData_8301()
end
--[七天签到]活动-列表 9001
function M.GetData_9001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9001 = {}
            R:readBEGIN();
            local m_Rewards =  {}
            m_Response_Action_9001.Rewards = m_Rewards
            local nNum_m_Rewards = R:readINT();
            for index_m_Rewards = 1, nNum_m_Rewards do
                local item_m_Rewards = {}
                R:readBEGIN();
                item_m_Rewards.diamonds = R:readINT();
                item_m_Rewards.status = R:readSTRING();
                item_m_Rewards.RewardId = R:readINT();
                R:readEND();
                CommonTable.push_back(m_Rewards,item_m_Rewards)
            end
            m_Response_Action_9001.LoginDay = R:readINT();
            m_Response_Action_9001.ResPrice = R:readINT();
            R:readEND();
            return m_Response_Action_9001
        end
    end
    return nil
end

--[七天签到]活动-领取奖励 9002
function M.GetData_9002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9002 = {}
            R:readBEGIN();
            m_Response_Action_9002.diamonds = R:readINT();
            R:readEND();
            return m_Response_Action_9002
        end
    end
    return nil
end

--获取活动列表
function M.GetData_9003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9003 = {}
            R:readBEGIN();
            local m_actlist =  {}
            m_Response_Action_9003.actlist = m_actlist
            local nNum_m_actlist = R:readINT();
            for index_m_actlist = 1, nNum_m_actlist do
                local item_m_actlist = {}
                R:readBEGIN();
                item_m_actlist.atype = R:readINT();
                item_m_actlist.showtype = R:readINT();
                item_m_actlist.title = R:readSTRING();
                item_m_actlist.memo = R:readSTRING();
                item_m_actlist.content = R:readSTRING();
                item_m_actlist.banner = R:readSTRING();
                item_m_actlist.parentid = R:readINT();
                item_m_actlist.status = R:readINT();
                item_m_actlist.flag = R:readINT();
                R:readEND();
                CommonTable.push_back(m_actlist,item_m_actlist)
            end
            R:readEND();
            return m_Response_Action_9003
        end
    end
    return nil
end
--获取活动列表
function M.GetData_13017()
    return M.GetData_9003()
end
--[幸运大转盘]进入转盘界面
function M.GetData_9004()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9004  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9004 = {}
            R:readBEGIN();
            m_Response_Action_9004.TurnNum = R:readINT();
            m_Response_Action_9004.RefreshTime = R:readSTRING();
            m_Response_Action_9004.DamPrice = R:readINT();
            R:readEND();
            return m_Response_Action_9004
        end
    end
    return nil
end

--[幸运大转盘]进入转盘界面
function M.GetData_9005()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9005 = {}
            R:readBEGIN();
            m_Response_Action_9005.PrizeNum = R:readINT();
            R:readEND();
            return m_Response_Action_9005
        end
    end
    return nil
end

--[七天签到]活动-重置时间
function M.GetData_9006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9006 = {}
            R:readBEGIN();
            R:readEND();
            return m_Response_Action_9006
        end
    end
    return nil
end
--兑换码兑换
function M.GetData_9007()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9007  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9007 = {}
            R:readBEGIN();
            local m_brlist =  {}
            m_Response_Action_9007.brlist = m_brlist
            local nNum_m_brlist = R:readINT();
            for index_m_brlist = 1, nNum_m_brlist do
                local item_m_brlist = {}
                R:readBEGIN();
                item_m_brlist.no = R:readINT();
                item_m_brlist.count = R:readINT();
                item_m_brlist.typ = R:readINT();
                item_m_brlist.styp = R:readINT();
                item_m_brlist.price = R:readINT64();
                item_m_brlist.quality = R:readINT();
                item_m_brlist.usetype = R:readINT();
                item_m_brlist.cansell = R:readINT();
                item_m_brlist.sex = R:readINT();
                item_m_brlist.needlv = R:readINT();
                item_m_brlist.strlv = R:readINT();
                item_m_brlist.evolv = R:readINT();
                item_m_brlist.part = R:readINT();
                local m_pros =  {}
                item_m_brlist.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_brlist.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_brlist.ext = R:readSTRING();
                item_m_brlist.name = R:readSTRING();
                item_m_brlist.memo = R:readSTRING();
                item_m_brlist.add = R:readINT();
                item_m_brlist.setid = R:readINT();
                item_m_brlist.eqid = R:readINT64();
                item_m_brlist.pic = R:readSTRING();
                item_m_brlist.isOn = R:readINT();
                local m_setids =  {}
                item_m_brlist.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_brlist,item_m_brlist)
            end
            R:readEND();
            return m_Response_Action_9007
        end
    end
    return nil
end
--
function M.GetData_9010()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9010  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9010 = {}
            R:readBEGIN();
            m_Response_Action_9010.cur = R:readINT();
            m_Response_Action_9010.total = R:readINT();
            m_Response_Action_9010.canget = R:readINT();
            R:readEND();
            return m_Response_Action_9010
        end
    end
    return nil
end

--
function M.GetData_9011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9011  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9011 = {}
            R:readBEGIN();
            m_Response_Action_9011.cur = R:readINT();
            m_Response_Action_9011.total = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_9011.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_9011
        end
    end
    return nil
end
function M.GetData_9012()
    if R:getResult() == RREST.Success then
        local m_Response_Action_9012  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_9012 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_9012.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_9012
        end
    end
    return nil
end
--===============天赋=================--

--获得天赋列表
function M.GetData_10001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_10001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_10001 = {}
            R:readBEGIN();
            local m_talents =  {}
            m_Response_Action_10001.talents = m_talents
            local nNum_m_talents = R:readINT();
            for index_m_talents = 1, nNum_m_talents do
                local item_m_talents = {}
                R:readBEGIN();
                item_m_talents.lv = R:readINT();
                item_m_talents.typ = R:readINT();
                item_m_talents.camp = R:readINT();
                item_m_talents.curexp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_talents,item_m_talents)
            end
            R:readEND();
            return m_Response_Action_10001
        end
    end
    return nil
end

--天赋加点
function M.GetData_10002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_10001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_10001 = {}
            R:readBEGIN();
            local m_talents =  {}
            m_Response_Action_10001.talents = m_talents
            local nNum_m_talents = R:readINT();
            for index_m_talents = 1, nNum_m_talents do
                local item_m_talents = {}
                R:readBEGIN();
                item_m_talents.lv = R:readINT();
                item_m_talents.typ = R:readINT();
                item_m_talents.camp = R:readINT();
                item_m_talents.curexp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_talents,item_m_talents)
            end
            R:readEND();
            return m_Response_Action_10001
        end
    end
    return nil
end

--获得可吃卡牌列表  10003
-- function M.GetData_10003()
--     if R:getResult() == RREST.Success then
--         local m_Response_Action_10003  = nil
--         if R:readINT() ~= 0 then 
--             m_Response_Action_10003 = {}
--             R:readBEGIN();
--             m_Response_Action_10003.id = R:readINT64();
--             m_Response_Action_10003.lv = R:readINT();
--             m_Response_Action_10003.cpid = R:readINT64();
--             m_Response_Action_10003.curexp = R:readINT64();
--             m_Response_Action_10003.totalexp = R:readINT64();
--             m_Response_Action_10003.evolv = R:readINT();
--             R:readEND();
--             return m_Response_Action_10003
--         end
--     end
--     return nil
-- end

function M.GetData_10003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_10003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_10003 = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Response_Action_10003.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT64();
                item_m_cards.lv = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Response_Action_10003
        end
    end
    return nil
end

--=============== 背包系统 =================--
--请求背包信息
function M.GetData_11001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Package  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Package = {}
            R:readBEGIN();
            local m_Package =  {}
            m_Response_Action_Package.Package = m_Package
            local nNum_m_Package = R:readINT();
            for index_m_Package = 1, nNum_m_Package do
                local item_m_Package = {}
                R:readBEGIN();
                item_m_Package.typ = R:readINT();
                local m_objs =  {}
                item_m_Package.objs = m_objs
                local nNum_m_objs = R:readINT();
                for index_m_objs = 1, nNum_m_objs do
                    local item_m_objs = {}
                    R:readBEGIN();
                    item_m_objs.no = R:readINT();
                    item_m_objs.typ = R:readINT();
                    item_m_objs.count = R:readINT();
                    item_m_objs.price = R:readINT64();
                    item_m_objs.quality = R:readINT();
                    item_m_objs.usetype = R:readINT();
                    item_m_objs.cansell = R:readINT();
                    item_m_objs.ext = R:readSTRING();
                    item_m_objs.name = R:readSTRING();
                    item_m_objs.memo = R:readSTRING();
                    item_m_objs.pic = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_objs,item_m_objs)
                end
                R:readEND();
                CommonTable.push_back(m_Package,item_m_Package)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_Package.result = m_result
                R:readBEGIN();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT64();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            m_Response_Action_Package.useEvent = R:readSTRING();
            R:readEND();
            return m_Response_Action_Package
        end
    end
    return nil
end

--出售物品
function M.GetData_11002()
    return M.GetData_11001()
end

--
function M.GetData_11003()
    return M.GetData_11001()
end

--请求装备信息
function M.GetData_11004()
    if R:getResult() == RREST.Success then
        local m_Response_Action_Equip  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_Equip = {}
            R:readBEGIN();
            local m_equippackage =  {}
            m_Response_Action_Equip.equippackage = m_equippackage
            local nNum_m_equippackage = R:readINT();
            for index_m_equippackage = 1, nNum_m_equippackage do
                local item_m_equippackage = {}
                R:readBEGIN();
                item_m_equippackage.typ = R:readINT();
                local m_objs =  {}
                item_m_equippackage.objs = m_objs
                local nNum_m_objs = R:readINT();
                for index_m_objs = 1, nNum_m_objs do
                    local item_m_objs = {}
                    R:readBEGIN();
                    item_m_objs.no = R:readINT();
                    item_m_objs.count = R:readINT();
                    item_m_objs.typ = R:readINT();
                    item_m_objs.styp = R:readINT();
                    item_m_objs.price = R:readINT64();
                    item_m_objs.quality = R:readINT();
                    item_m_objs.usetype = R:readINT();
                    item_m_objs.cansell = R:readINT();
                    item_m_objs.sex = R:readINT();
                    item_m_objs.needlv = R:readINT();
                    item_m_objs.strlv = R:readINT();
                    item_m_objs.evolv = R:readINT();
                    item_m_objs.part = R:readINT();
                    local m_pros =  {}
                    item_m_objs.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_objs.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_objs.ext = R:readSTRING();
                    item_m_objs.name = R:readSTRING();
                    item_m_objs.memo = R:readSTRING();
                    item_m_objs.add = R:readINT();
                    item_m_objs.setid = R:readINT();
                    item_m_objs.eqid = R:readINT64();
                    item_m_objs.pic = R:readSTRING();
                    item_m_objs.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_objs.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_objs,item_m_objs)
                end
                R:readEND();
                CommonTable.push_back(m_equippackage,item_m_equippackage)
            end
            local m_parts =  {}
            m_Response_Action_Equip.parts = m_parts
            local nNum_m_parts = R:readINT();
            for index_m_parts = 1, nNum_m_parts do
                local item_m_parts = {}
                R:readBEGIN();
                item_m_parts.typ = R:readINT();
                local m_objs =  {}
                item_m_parts.objs = m_objs
                local nNum_m_objs = R:readINT();
                for index_m_objs = 1, nNum_m_objs do
                    local item_m_objs = {}
                    R:readBEGIN();
                    item_m_objs.no = R:readINT();
                    item_m_objs.count = R:readINT();
                    item_m_objs.typ = R:readINT();
                    item_m_objs.styp = R:readINT();
                    item_m_objs.price = R:readINT64();
                    item_m_objs.quality = R:readINT();
                    item_m_objs.usetype = R:readINT();
                    item_m_objs.cansell = R:readINT();
                    item_m_objs.sex = R:readINT();
                    item_m_objs.needlv = R:readINT();
                    item_m_objs.strlv = R:readINT();
                    item_m_objs.evolv = R:readINT();
                    item_m_objs.part = R:readINT();
                    local m_pros =  {}
                    item_m_objs.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_objs.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_objs.ext = R:readSTRING();
                    item_m_objs.name = R:readSTRING();
                    item_m_objs.memo = R:readSTRING();
                    item_m_objs.add = R:readINT();
                    item_m_objs.setid = R:readINT();
                    item_m_objs.eqid = R:readINT64();
                    item_m_objs.pic = R:readSTRING();
                    item_m_objs.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_objs.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_objs,item_m_objs)
                end
                R:readEND();
                CommonTable.push_back(m_parts,item_m_parts)
            end
            R:readEND();
            return m_Response_Action_Equip
        end
    end
    return nil
end

--出售物品
function M.GetData_11005()
        if R:getResult() == RREST.Success then
        local m_Response_Action_11005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_11005 = {}
            R:readBEGIN();
            local m_equip  = nil
            if R:readINT() ~= 0 then 
                m_equip = {}
                m_Response_Action_11005.equip = m_equip
                R:readBEGIN();
                local m_equippackage =  {}
                m_equip.equippackage = m_equippackage
                local nNum_m_equippackage = R:readINT();
                for index_m_equippackage = 1, nNum_m_equippackage do
                    local item_m_equippackage = {}
                    R:readBEGIN();
                    item_m_equippackage.typ = R:readINT();
                    local m_objs =  {}
                    item_m_equippackage.objs = m_objs
                    local nNum_m_objs = R:readINT();
                    for index_m_objs = 1, nNum_m_objs do
                        local item_m_objs = {}
                        R:readBEGIN();
                        item_m_objs.no = R:readINT();
                        item_m_objs.count = R:readINT();
                        item_m_objs.typ = R:readINT();
                        item_m_objs.styp = R:readINT();
                        item_m_objs.price = R:readINT64();
                        item_m_objs.quality = R:readINT();
                        item_m_objs.usetype = R:readINT();
                        item_m_objs.cansell = R:readINT();
                        item_m_objs.sex = R:readINT();
                        item_m_objs.needlv = R:readINT();
                        item_m_objs.strlv = R:readINT();
                        item_m_objs.evolv = R:readINT();
                        item_m_objs.part = R:readINT();
                        local m_pros =  {}
                        item_m_objs.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_objs.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_objs.ext = R:readSTRING();
                        item_m_objs.name = R:readSTRING();
                        item_m_objs.memo = R:readSTRING();
                        item_m_objs.add = R:readINT();
                        item_m_objs.setid = R:readINT();
                        item_m_objs.eqid = R:readINT64();
                        item_m_objs.pic = R:readSTRING();
                        item_m_objs.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_objs.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_objs,item_m_objs)
                    end
                    R:readEND();
                    CommonTable.push_back(m_equippackage,item_m_equippackage)
                end
                local m_parts =  {}
                m_equip.parts = m_parts
                local nNum_m_parts = R:readINT();
                for index_m_parts = 1, nNum_m_parts do
                    local item_m_parts = {}
                    R:readBEGIN();
                    item_m_parts.typ = R:readINT();
                    local m_objs =  {}
                    item_m_parts.objs = m_objs
                    local nNum_m_objs = R:readINT();
                    for index_m_objs = 1, nNum_m_objs do
                        local item_m_objs = {}
                        R:readBEGIN();
                        item_m_objs.no = R:readINT();
                        item_m_objs.count = R:readINT();
                        item_m_objs.typ = R:readINT();
                        item_m_objs.styp = R:readINT();
                        item_m_objs.price = R:readINT64();
                        item_m_objs.quality = R:readINT();
                        item_m_objs.usetype = R:readINT();
                        item_m_objs.cansell = R:readINT();
                        item_m_objs.sex = R:readINT();
                        item_m_objs.needlv = R:readINT();
                        item_m_objs.strlv = R:readINT();
                        item_m_objs.evolv = R:readINT();
                        item_m_objs.part = R:readINT();
                        local m_pros =  {}
                        item_m_objs.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_objs.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_objs.ext = R:readSTRING();
                        item_m_objs.name = R:readSTRING();
                        item_m_objs.memo = R:readSTRING();
                        item_m_objs.add = R:readINT();
                        item_m_objs.setid = R:readINT();
                        item_m_objs.eqid = R:readINT64();
                        item_m_objs.pic = R:readSTRING();
                        item_m_objs.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_objs.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_objs,item_m_objs)
                    end
                    R:readEND();
                    CommonTable.push_back(m_parts,item_m_parts)
                end
                R:readEND();
            end
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_11005.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_11005
        end
    end
    return nil
end

--出售物品
function M.GetData_11006()
    return M.GetData_11004()
end
--===============天赋=================--
function M.GetData_11007()
    if R:getResult() == RREST.Success then
        local m_Response_11007  = nil
        if R:readINT() ~= 0 then 
            m_Response_11007 = {}
            R:readBEGIN();
            local m_equips =  {}
            m_Response_11007.equips = m_equips
            local nNum_m_equips = R:readINT();
            for index_m_equips = 1, nNum_m_equips do
                local item_m_equips = {}
                R:readBEGIN();
                item_m_equips.no = R:readINT();
                item_m_equips.count = R:readINT();
                item_m_equips.typ = R:readINT();
                item_m_equips.styp = R:readINT();
                item_m_equips.price = R:readINT64();
                item_m_equips.quality = R:readINT();
                item_m_equips.usetype = R:readINT();
                item_m_equips.cansell = R:readINT();
                item_m_equips.sex = R:readINT();
                item_m_equips.needlv = R:readINT();
                item_m_equips.strlv = R:readINT();
                item_m_equips.evolv = R:readINT();
                item_m_equips.part = R:readINT();
                local m_pros =  {}
                item_m_equips.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_equips.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_equips.ext = R:readSTRING();
                item_m_equips.name = R:readSTRING();
                item_m_equips.memo = R:readSTRING();
                item_m_equips.add = R:readINT();
                item_m_equips.setid = R:readINT();
                item_m_equips.eqid = R:readINT64();
                item_m_equips.pic = R:readSTRING();
                item_m_equips.isOn = R:readINT();
                local m_setids =  {}
                item_m_equips.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_equips,item_m_equips)
            end
            m_Response_11007.stone1 = R:readINT();
            m_Response_11007.stone2 = R:readINT();
            m_Response_11007.crit = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_11007.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_11007
        end
    end
    return nil
end

--强化装备
function M.GetData_11008()
    return M.GetData_11007()
end
--追加装备
function M.GetData_11009()
    return M.GetData_11007()
end

--进阶装备
function M.GetData_11010()
    return M.GetData_11007()
end
--追加装备列表
function M.GetData_11013()
    return M.GetData_11007()
end

--进阶装备列表
function M.GetData_11014()
    return M.GetData_11007()
end



--请求装备信息
function M.GetData_11011()
    if R:getResult() == RREST.Success then
        local m_Response_Reward_Obj_Chat  = nil
        if R:readINT() ~= 0 then 
            m_Response_Reward_Obj_Chat = {}
            R:readBEGIN();
            m_Response_Reward_Obj_Chat.uname = R:readSTRING();
            local m_obj  = nil
            if R:readINT() ~= 0 then 
                m_obj = {}
                m_Response_Reward_Obj_Chat.obj = m_obj
                R:readBEGIN();
                m_obj.no = R:readINT();
                m_obj.count = R:readINT();
                m_obj.typ = R:readINT();
                m_obj.styp = R:readINT();
                m_obj.price = R:readINT64();
                m_obj.quality = R:readINT();
                m_obj.usetype = R:readINT();
                m_obj.cansell = R:readINT();
                m_obj.sex = R:readINT();
                m_obj.needlv = R:readINT();
                m_obj.strlv = R:readINT();
                m_obj.evolv = R:readINT();
                m_obj.part = R:readINT();
                local m_pros =  {}
                m_obj.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                m_obj.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                m_obj.ext = R:readSTRING();
                m_obj.name = R:readSTRING();
                m_obj.memo = R:readSTRING();
                m_obj.add = R:readINT();
                m_obj.setid = R:readINT();
                m_obj.eqid = R:readINT64();
                m_obj.pic = R:readSTRING();
                m_obj.isOn = R:readINT();
                local m_setids =  {}
                m_obj.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Reward_Obj_Chat
        end
    end
    return nil
end

--请求物品信息
function M.GetData_11012()
    return M.GetData_11011()
end

function M.GetData_11015()
    if R:getResult() == RREST.Success then
        local m_Response_11007  = nil
        if R:readINT() ~= 0 then 
            m_Response_11007 = {}
            R:readBEGIN();
            local m_equips =  {}
            m_Response_11007.equips = m_equips
            local nNum_m_equips = R:readINT();
            for index_m_equips = 1, nNum_m_equips do
                local item_m_equips = {}
                R:readBEGIN();
                item_m_equips.no = R:readINT();
                item_m_equips.count = R:readINT();
                item_m_equips.typ = R:readINT();
                item_m_equips.styp = R:readINT();
                item_m_equips.price = R:readINT64();
                item_m_equips.quality = R:readINT();
                item_m_equips.usetype = R:readINT();
                item_m_equips.cansell = R:readINT();
                item_m_equips.sex = R:readINT();
                item_m_equips.needlv = R:readINT();
                item_m_equips.strlv = R:readINT();
                item_m_equips.evolv = R:readINT();
                item_m_equips.part = R:readINT();
                local m_pros =  {}
                item_m_equips.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_equips.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_equips.ext = R:readSTRING();
                item_m_equips.name = R:readSTRING();
                item_m_equips.memo = R:readSTRING();
                item_m_equips.add = R:readINT();
                item_m_equips.setid = R:readINT();
                item_m_equips.eqid = R:readINT64();
                item_m_equips.pic = R:readSTRING();
                item_m_equips.isOn = R:readINT();
                local m_setids =  {}
                item_m_equips.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_equips,item_m_equips)
            end
            m_Response_11007.stone1 = R:readINT();
            m_Response_11007.stone2 = R:readINT();
            m_Response_11007.crit = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_11007.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_11007
        end
    end
    return nil
end

--裝備拆解
function M.GetData_11016()
    if R:getResult() == RREST.Success then
        local m_Response_11007  = nil
        if R:readINT() ~= 0 then 
            m_Response_11007 = {}
            R:readBEGIN();
            local m_equips =  {}
            m_Response_11007.equips = m_equips
            local nNum_m_equips = R:readINT();
            for index_m_equips = 1, nNum_m_equips do
                local item_m_equips = {}
                R:readBEGIN();
                item_m_equips.no = R:readINT();
                item_m_equips.count = R:readINT();
                item_m_equips.typ = R:readINT();
                item_m_equips.styp = R:readINT();
                item_m_equips.price = R:readINT64();
                item_m_equips.quality = R:readINT();
                item_m_equips.usetype = R:readINT();
                item_m_equips.cansell = R:readINT();
                item_m_equips.sex = R:readINT();
                item_m_equips.needlv = R:readINT();
                item_m_equips.strlv = R:readINT();
                item_m_equips.evolv = R:readINT();
                item_m_equips.part = R:readINT();
                local m_pros =  {}
                item_m_equips.pros = m_pros
                local nNum_m_pros = R:readINT();
                for index_m_pros = 1, nNum_m_pros do
                    local item_m_pros = {}
                    R:readBEGIN();
                    item_m_pros.typ = R:readINT();
                    item_m_pros.camp = R:readINT();
                    item_m_pros.value = R:readSTRING();
                    item_m_pros.isact = R:readINT();
                    item_m_pros.setid = R:readINT();
                    item_m_pros.initval = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_pros,item_m_pros)
                end
                local m_skills =  {}
                item_m_equips.skills = m_skills
                local nNum_m_skills = R:readINT();
                for index_m_skills = 1, nNum_m_skills do
                    local item_m_skills = {}
                    R:readBEGIN();
                    item_m_skills.id = R:readINT();
                    item_m_skills.lv = R:readINT();
                    item_m_skills.isact = R:readINT();
                    item_m_skills.setid = R:readINT();
                    item_m_skills.value = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_skills,item_m_skills)
                end
                item_m_equips.ext = R:readSTRING();
                item_m_equips.name = R:readSTRING();
                item_m_equips.memo = R:readSTRING();
                item_m_equips.add = R:readINT();
                item_m_equips.setid = R:readINT();
                item_m_equips.eqid = R:readINT64();
                item_m_equips.pic = R:readSTRING();
                item_m_equips.isOn = R:readINT();
                local m_setids =  {}
                item_m_equips.setids = m_setids
                local nNum_m_setids = R:readINT();
                for index_m_setids = 1, nNum_m_setids do
                    local item_m_setids = {}
                    R:readBEGIN();
                    item_m_setids.setid = R:readINT();
                    item_m_setids.ison = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_setids,item_m_setids)
                end
                R:readEND();
                CommonTable.push_back(m_equips,item_m_equips)
            end
            m_Response_11007.stone1 = R:readINT();
            m_Response_11007.stone2 = R:readINT();
            m_Response_11007.crit = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_11007.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_11007
        end
    end
    return nil
end
--[[ 
    ************************ 聊天系统 ************************ 85xxx
--]]
--[聊天消息]获取
-- function M.GetData_85000()
--     if R:getResult() == RREST.Success then
--         local m_Response_Action_85000  = nil
--         if R:readINT() ~= 0 then 
--             m_Response_Action_85000 = {}
--             R:readBEGIN();
--             local m_Items =  {}
--             m_Response_Action_85000.items = m_Items
--             local nNum_m_Items = R:readINT();
--             for index_m_Items = 1, nNum_m_Items do
--                 local item_m_Items = {}
--                 R:readBEGIN();
--                 item_m_Items.senderId = R:readINT64();
--                 item_m_Items.senderNickName = R:readSTRING();
--                 item_m_Items.vipLevel = R:readINT();
--                 item_m_Items.msgId = R:readINT64();
--                 item_m_Items.content = R:readSTRING();
--                 item_m_Items.sendTime = R:readINT64();
--                 item_m_Items.messageType = R:readINT();
--                 R:readEND();
--                 CommonTable.push_back(m_Items,item_m_Items)
--             end
--             R:readEND();
--             return m_Response_Action_85000
--         end
--     end
--     return nil
-- end

function M.GetData_85000()
    if R:getResult() == RREST.Success then
        local m_Response_Action_85000  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_85000 = {}
            R:readBEGIN();
            local m_Items =  {}
            m_Response_Action_85000.items = m_Items
            local nNum_m_Items = R:readINT();
            for index_m_Items = 1, nNum_m_Items do
                local item_m_Items = {}
                R:readBEGIN();
                item_m_Items.senderId = R:readINT64();
                item_m_Items.senderNickName = R:readSTRING();
                item_m_Items.vipLevel = R:readINT();
                item_m_Items.msgId = R:readINT64();
                item_m_Items.content = R:readSTRING();
                item_m_Items.sendTime = R:readINT64();
                item_m_Items.messageType = R:readINT();
                item_m_Items.receiveId = R:readINT64();
                item_m_Items.isBigShow = R:readINT();
                R:readEND();
                CommonTable.push_back(m_Items,item_m_Items)
            end
            R:readEND();
            return m_Response_Action_85000
        end
    end
    return nil
end

--
function M.GetData_4201()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4201  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4201 = {}
            R:readBEGIN();
            m_Response_Action_4201.bossno = R:readINT();
            m_Response_Action_4201.bossname = R:readSTRING();
            m_Response_Action_4201.findname = R:readSTRING();
            m_Response_Action_4201.killname = R:readSTRING();
            m_Response_Action_4201.star = R:readINT();
            m_Response_Action_4201.status = R:readINT();
            m_Response_Action_4201.cd = R:readINT();
            m_Response_Action_4201.cddia = R:readINT();
            m_Response_Action_4201.hp = R:readINT64();
            m_Response_Action_4201.totalhp = R:readINT64();
            m_Response_Action_4201.morale = R:readINT64();
            m_Response_Action_4201.maxmorale = R:readINT64();
            m_Response_Action_4201.moraleAddAtk = R:readINT();
            m_Response_Action_4201.moraleAddHp = R:readINT();
            m_Response_Action_4201.moraleAddAtkSelf = R:readINT();
            m_Response_Action_4201.moraleAddHpSelf = R:readINT();
            m_Response_Action_4201.time = R:readINT();
            m_Response_Action_4201.myrank = R:readINT64();
            m_Response_Action_4201.mypoint = R:readINT();
            m_Response_Action_4201.myper = R:readINT();
            m_Response_Action_4201.addstar = R:readINT();
            m_Response_Action_4201.addmorale = R:readINT();
            local m_players =  {}
            m_Response_Action_4201.players = m_players
            local nNum_m_players = R:readINT();
            for index_m_players = 1, nNum_m_players do
                local item_m_players = {}
                R:readBEGIN();
                item_m_players.uid = R:readINT64();
                item_m_players.uname = R:readSTRING();
                item_m_players.rank = R:readINT64();
                item_m_players.point = R:readINT();
                item_m_players.pointper = R:readINT();
                item_m_players.morale = R:readINT();
                item_m_players.star = R:readINT();
                R:readEND();
                CommonTable.push_back(m_players,item_m_players)
            end
            m_Response_Action_4201.memo = R:readSTRING();
            R:readEND();
            return m_Response_Action_4201
        end
    end
    return nil
end


--
function M.GetData_4202()
    return GetData_fight()
end

--
function M.GetData_4203()
    return M.GetData_4201()
end
--获取奖励
function M.GetData_4204()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4204  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4204 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_4204.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_4204
        end
    end
    return nil
end
--进入幽冥魔塔界面
function M.GetData_4301()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4301  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4301 = {}
            R:readBEGIN();
            m_Response_Action_4301.MaxResults = R:readINT();
            m_Response_Action_4301.TodayResults = R:readINT();
            m_Response_Action_4301.MaxRecord = R:readINT();
            m_Response_Action_4301.TodayRecord = R:readINT();
            local m_SelfBuff =  {}
            m_Response_Action_4301.SelfBuff = m_SelfBuff
            local nNum_m_SelfBuff = R:readINT();
            for index_m_SelfBuff = 1, nNum_m_SelfBuff do
                local item_m_SelfBuff = {}
                R:readBEGIN();
                item_m_SelfBuff.typ = R:readINT();
                item_m_SelfBuff.camp = R:readINT();
                item_m_SelfBuff.Jnum = R:readINT();
                item_m_SelfBuff.No = R:readINT();
                R:readEND();
                CommonTable.push_back(m_SelfBuff,item_m_SelfBuff)
            end
            m_Response_Action_4301.ChallengeNum = R:readINT();
            m_Response_Action_4301.TotalChallengeNum = R:readINT();
            m_Response_Action_4301.ChallengePrice = R:readINT();
            m_Response_Action_4301.ResetBuffPrice = R:readINT();
            m_Response_Action_4301.MaxLayer = R:readINT();
            local m_Buff =  {}
            m_Response_Action_4301.Buff = m_Buff
            local nNum_m_Buff = R:readINT();
            for index_m_Buff = 1, nNum_m_Buff do
                local item_m_Buff = {}
                R:readBEGIN();
                item_m_Buff.typ = R:readINT();
                item_m_Buff.camp = R:readINT();
                item_m_Buff.Jnum = R:readINT();
                item_m_Buff.No = R:readINT();
                R:readEND();
                CommonTable.push_back(m_Buff,item_m_Buff)
            end
            local m_tinfos =  {}
            m_Response_Action_4301.tinfos = m_tinfos
            local nNum_m_tinfos = R:readINT();
            for index_m_tinfos = 1, nNum_m_tinfos do
                local item_m_tinfos = {}
                R:readBEGIN();
                item_m_tinfos.no = R:readINT();
                item_m_tinfos.name = R:readSTRING();
                item_m_tinfos.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_tinfos.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_tinfos,item_m_tinfos)
            end
            m_Response_Action_4301.myrank = R:readINT64();
            R:readEND();
            return m_Response_Action_4301
        end
    end
    return nil
end

--
function M.GetData_4302()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4301  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4301 = {}
            R:readBEGIN();
            m_Response_Action_4301.MaxResults = R:readINT();
            m_Response_Action_4301.TodayResults = R:readINT();
            m_Response_Action_4301.MaxRecord = R:readINT();
            m_Response_Action_4301.TodayRecord = R:readINT();
            local m_SelfBuff =  {}
            m_Response_Action_4301.SelfBuff = m_SelfBuff
            local nNum_m_SelfBuff = R:readINT();
            for index_m_SelfBuff = 1, nNum_m_SelfBuff do
                local item_m_SelfBuff = {}
                R:readBEGIN();
                item_m_SelfBuff.typ = R:readINT();
                item_m_SelfBuff.camp = R:readINT();
                item_m_SelfBuff.Jnum = R:readINT();
                item_m_SelfBuff.No = R:readINT();
                R:readEND();
                CommonTable.push_back(m_SelfBuff,item_m_SelfBuff)
            end
            m_Response_Action_4301.ChallengeNum = R:readINT();
            m_Response_Action_4301.TotalChallengeNum = R:readINT();
            m_Response_Action_4301.ChallengePrice = R:readINT();
            m_Response_Action_4301.ResetBuffPrice = R:readINT();
            m_Response_Action_4301.MaxLayer = R:readINT();
            local m_Buff =  {}
            m_Response_Action_4301.Buff = m_Buff
            local nNum_m_Buff = R:readINT();
            for index_m_Buff = 1, nNum_m_Buff do
                local item_m_Buff = {}
                R:readBEGIN();
                item_m_Buff.typ = R:readINT();
                item_m_Buff.camp = R:readINT();
                item_m_Buff.Jnum = R:readINT();
                item_m_Buff.No = R:readINT();
                R:readEND();
                CommonTable.push_back(m_Buff,item_m_Buff)
            end
            local m_tinfos =  {}
            m_Response_Action_4301.tinfos = m_tinfos
            local nNum_m_tinfos = R:readINT();
            for index_m_tinfos = 1, nNum_m_tinfos do
                local item_m_tinfos = {}
                R:readBEGIN();
                item_m_tinfos.no = R:readINT();
                item_m_tinfos.name = R:readSTRING();
                item_m_tinfos.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_tinfos.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_tinfos,item_m_tinfos)
            end
            R:readEND();
            return m_Response_Action_4301
        end
    end
    return nil
end

--幽冥魔塔排行榜
function M.GetData_4305()
    if R:getResult() == RREST.Success then
        local m_Response_Action_4305  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_4305 = {}
            R:readBEGIN();
            m_Response_Action_4305.myrank = R:readINT64();
            m_Response_Action_4305.myresults = R:readINT();
            local m_playerlist =  {}
            m_Response_Action_4305.playerlist = m_playerlist
            local nNum_m_playerlist = R:readINT();
            for index_m_playerlist = 1, nNum_m_playerlist do
                local item_m_playerlist = {}
                R:readBEGIN();
                item_m_playerlist.name = R:readSTRING();
                item_m_playerlist.Maxrank = R:readINT();
                item_m_playerlist.Minrank = R:readINT();
                item_m_playerlist.Minresults = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_playerlist.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_playerlist,item_m_playerlist)
            end
            R:readEND();
            return m_Response_Action_4305
        end
    end
    return nil
end

--
function M.GetData_4306()
    if R:getResult() == RREST.Success then
        local m_Response_Action_2001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_2001 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_2001.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_2001.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_2001.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                m_result.jjcScore = R:readINT();
                m_result.rank = R:readINT();
                m_result.rankvar = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                local m_levels =  {}
                m_result.levels = m_levels
                local nNum_m_levels = R:readINT();
                for index_m_levels = 1, nNum_m_levels do
                    local item_m_levels = {}
                    R:readBEGIN();
                    item_m_levels.sn = R:readINT();
                    item_m_levels.subsn = R:readINT();
                    item_m_levels.star = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_levels,item_m_levels)
                end
                m_result.flag = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_2001
        end
    end
    return nil
end
--
function M.GetData_12001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_12001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_12001 = {}
            R:readBEGIN();
            m_Response_Action_12001.btnstatus = R:readINT();
            m_Response_Action_12001.status = R:readINT();
            m_Response_Action_12001.time = R:readINT();
            m_Response_Action_12001.lasttid = R:readINT64();
            m_Response_Action_12001.rewardsta = R:readINT();
            local m_teamers =  {}
            m_Response_Action_12001.teamers = m_teamers
            local nNum_m_teamers = R:readINT();
            for index_m_teamers = 1, nNum_m_teamers do
                local item_m_teamers = {}
                R:readBEGIN();
                item_m_teamers.id = R:readINT64();
                item_m_teamers.name = R:readSTRING();
                item_m_teamers.head = R:readSTRING();
                item_m_teamers.lv = R:readINT();
                item_m_teamers.sex = R:readINT();
                item_m_teamers.lastdate = R:readSTRING();
                item_m_teamers.equiplst = R:readSTRING();
                item_m_teamers.isleader = R:readINT();
                item_m_teamers.status = R:readINT();
                item_m_teamers.content = R:readSTRING();
                local m_cards =  {}
                item_m_teamers.cards = m_cards
                local nNum_m_cards = R:readINT();
                for index_m_cards = 1, nNum_m_cards do
                    local item_m_cards = {}
                    R:readBEGIN();
                    item_m_cards.id = R:readINT();
                    item_m_cards.lv = R:readINT();
                    item_m_cards.evolv = R:readINT();
                    item_m_cards.addvalue = R:readSTRING();
                    item_m_cards.cpid = R:readINT64();
                    item_m_cards.teamcard = R:readINT();
                    item_m_cards.equipEffect = R:readSTRING();
                    item_m_cards.talent = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_cards,item_m_cards)
                end
                R:readEND();
                CommonTable.push_back(m_teamers,item_m_teamers)
            end
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_12001.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            m_Response_Action_12001.needlv = R:readINT();
            m_Response_Action_12001.needdia = R:readINT();
            m_Response_Action_12001.rank = R:readSTRING();
            m_Response_Action_12001.tname = R:readSTRING();
            m_Response_Action_12001.showstr = R:readSTRING();
            m_Response_Action_12001.status2 = R:readINT();
            m_Response_Action_12001.time2 = R:readINT();
            m_Response_Action_12001.lasttid2 = R:readINT64();
            m_Response_Action_12001.tname2 = R:readSTRING();
            local m_teamers2 =  {}
            m_Response_Action_12001.teamers2 = m_teamers2
            local nNum_m_teamers2 = R:readINT();
            for index_m_teamers2 = 1, nNum_m_teamers2 do
                local item_m_teamers2 = {}
                R:readBEGIN();
                item_m_teamers2.id = R:readINT64();
                item_m_teamers2.name = R:readSTRING();
                item_m_teamers2.head = R:readSTRING();
                item_m_teamers2.lv = R:readINT();
                item_m_teamers2.sex = R:readINT();
                item_m_teamers2.lastdate = R:readSTRING();
                item_m_teamers2.equiplst = R:readSTRING();
                item_m_teamers2.isleader = R:readINT();
                item_m_teamers2.status = R:readINT();
                item_m_teamers2.content = R:readSTRING();
                local m_cards =  {}
                item_m_teamers2.cards = m_cards
                local nNum_m_cards = R:readINT();
                for index_m_cards = 1, nNum_m_cards do
                    local item_m_cards = {}
                    R:readBEGIN();
                    item_m_cards.id = R:readINT();
                    item_m_cards.lv = R:readINT();
                    item_m_cards.evolv = R:readINT();
                    item_m_cards.addvalue = R:readSTRING();
                    item_m_cards.cpid = R:readINT64();
                    item_m_cards.teamcard = R:readINT();
                    item_m_cards.equipEffect = R:readSTRING();
                    item_m_cards.talent = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_cards,item_m_cards)
                end
                R:readEND();
                CommonTable.push_back(m_teamers2,item_m_teamers2)
            end
            m_Response_Action_12001.rank2 = R:readSTRING();
            m_Response_Action_12001.rewardsta2 = R:readINT();
            m_Response_Action_12001.sername = R:readSTRING();
            m_Response_Action_12001.sernames = R:readSTRING();
            R:readEND();
            return m_Response_Action_12001
        end
    end
    return nil
end

--
function M.GetData_12004()
    if R:getResult() == RREST.Success then
        local m_Response_TeamAppLst  = nil
        if R:readINT() ~= 0 then 
            m_Response_TeamAppLst = {}
            R:readBEGIN();
            local m_teamers =  {}
            m_Response_TeamAppLst.teamers = m_teamers
            local nNum_m_teamers = R:readINT();
            for index_m_teamers = 1, nNum_m_teamers do
                local item_m_teamers = {}
                R:readBEGIN();
                item_m_teamers.id = R:readINT64();
                item_m_teamers.name = R:readSTRING();
                item_m_teamers.head = R:readSTRING();
                item_m_teamers.lv = R:readINT();
                item_m_teamers.sex = R:readINT();
                item_m_teamers.lastdate = R:readSTRING();
                item_m_teamers.equiplst = R:readSTRING();
                item_m_teamers.isleader = R:readINT();
                item_m_teamers.status = R:readINT();
                item_m_teamers.content = R:readSTRING();
                local m_cards =  {}
                item_m_teamers.cards = m_cards
                local nNum_m_cards = R:readINT();
                for index_m_cards = 1, nNum_m_cards do
                    local item_m_cards = {}
                    R:readBEGIN();
                    item_m_cards.id = R:readINT();
                    item_m_cards.lv = R:readINT();
                    item_m_cards.evolv = R:readINT();
                    item_m_cards.addvalue = R:readSTRING();
                    item_m_cards.cpid = R:readINT64();
                    item_m_cards.teamcard = R:readINT();
                    item_m_cards.equipEffect = R:readSTRING();
                    item_m_cards.talent = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_cards,item_m_cards)
                end
                R:readEND();
                CommonTable.push_back(m_teamers,item_m_teamers)
            end
            m_Response_TeamAppLst.teamerCount = R:readINT();
            R:readEND();
            return m_Response_TeamAppLst
        end
    end
    return nil
end

--
function M.GetData_12010()
    if R:getResult() == RREST.Success then
        local m_Response_TeamLst  = nil
        if R:readINT() ~= 0 then 
            m_Response_TeamLst = {}
            R:readBEGIN();
            m_Response_TeamLst.needselect = R:readINT();
            m_Response_TeamLst.content = R:readSTRING();
            local m_cards =  {}
            m_Response_TeamLst.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.evolv = R:readINT();
                item_m_cards.addvalue = R:readSTRING();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.teamcard = R:readINT();
                item_m_cards.equipEffect = R:readSTRING();
                item_m_cards.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            local m_teams =  {}
            m_Response_TeamLst.teams = m_teams
            local nNum_m_teams = R:readINT();
            for index_m_teams = 1, nNum_m_teams do
                local item_m_teams = {}
                R:readBEGIN();
                item_m_teams.needselect = R:readINT();
                item_m_teams.tname = R:readSTRING();
                item_m_teams.tno = R:readSTRING();
                item_m_teams.point = R:readINT();
                item_m_teams.declaration = R:readSTRING();
                item_m_teams.isleader = R:readINT();
                item_m_teams.status1 = R:readINT();
                item_m_teams.status2 = R:readINT();
                local m_teamers =  {}
                item_m_teams.teamers = m_teamers
                local nNum_m_teamers = R:readINT();
                for index_m_teamers = 1, nNum_m_teamers do
                    local item_m_teamers = {}
                    R:readBEGIN();
                    item_m_teamers.id = R:readINT64();
                    item_m_teamers.name = R:readSTRING();
                    item_m_teamers.head = R:readSTRING();
                    item_m_teamers.lv = R:readINT();
                    item_m_teamers.sex = R:readINT();
                    item_m_teamers.lastdate = R:readSTRING();
                    item_m_teamers.equiplst = R:readSTRING();
                    item_m_teamers.isleader = R:readINT();
                    item_m_teamers.status = R:readINT();
                    item_m_teamers.content = R:readSTRING();
                    local m_cards =  {}
                    item_m_teamers.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        item_m_cards.cpid = R:readINT64();
                        item_m_cards.teamcard = R:readINT();
                        item_m_cards.equipEffect = R:readSTRING();
                        item_m_cards.talent = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    R:readEND();
                    CommonTable.push_back(m_teamers,item_m_teamers)
                end
                item_m_teams.tid = R:readINT64();
                item_m_teams.showadd = R:readINT();
                item_m_teams.ischampion = R:readINT();
                local m_leader  = nil
                if R:readINT() ~= 0 then 
                    m_leader = {}
                    item_m_teams.leader = m_leader
                    R:readBEGIN();
                    m_leader.id = R:readINT64();
                    m_leader.name = R:readSTRING();
                    m_leader.head = R:readSTRING();
                    m_leader.lv = R:readINT();
                    m_leader.sex = R:readINT();
                    m_leader.equiplst = R:readSTRING();
                    R:readEND();
                end
                item_m_teams.playercount = R:readINT();
                item_m_teams.showpk = R:readINT();
                item_m_teams.sername = R:readSTRING();
                item_m_teams.status3 = R:readINT();
                item_m_teams.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_teams,item_m_teams)
            end
            m_Response_TeamLst.maxpagecount = R:readINT();
            R:readEND();
            return m_Response_TeamLst
        end
    end
    return nil
end

--
function M.GetData_12011()
    if R:getResult() == RREST.Success then
        local m_Response_TeamInfo  = nil
        if R:readINT() ~= 0 then 
            m_Response_TeamInfo = {}
            R:readBEGIN();
            m_Response_TeamInfo.needselect = R:readINT();
            m_Response_TeamInfo.tname = R:readSTRING();
            m_Response_TeamInfo.tno = R:readSTRING();
            m_Response_TeamInfo.point = R:readINT();
            m_Response_TeamInfo.declaration = R:readSTRING();
            m_Response_TeamInfo.isleader = R:readINT();
            m_Response_TeamInfo.status1 = R:readINT();
            m_Response_TeamInfo.status2 = R:readINT();
            local m_teamers =  {}
            m_Response_TeamInfo.teamers = m_teamers
            local nNum_m_teamers = R:readINT();
            for index_m_teamers = 1, nNum_m_teamers do
                local item_m_teamers = {}
                R:readBEGIN();
                item_m_teamers.id = R:readINT64();
                item_m_teamers.name = R:readSTRING();
                item_m_teamers.head = R:readSTRING();
                item_m_teamers.lv = R:readINT();
                item_m_teamers.sex = R:readINT();
                item_m_teamers.lastdate = R:readSTRING();
                item_m_teamers.equiplst = R:readSTRING();
                item_m_teamers.isleader = R:readINT();
                item_m_teamers.status = R:readINT();
                item_m_teamers.content = R:readSTRING();
                local m_cards =  {}
                item_m_teamers.cards = m_cards
                local nNum_m_cards = R:readINT();
                for index_m_cards = 1, nNum_m_cards do
                    local item_m_cards = {}
                    R:readBEGIN();
                    item_m_cards.id = R:readINT();
                    item_m_cards.lv = R:readINT();
                    item_m_cards.evolv = R:readINT();
                    item_m_cards.addvalue = R:readSTRING();
                    item_m_cards.cpid = R:readINT64();
                    item_m_cards.teamcard = R:readINT();
                    item_m_cards.equipEffect = R:readSTRING();
                    item_m_cards.talent = R:readSTRING();
                    R:readEND();
                    CommonTable.push_back(m_cards,item_m_cards)
                end
                R:readEND();
                CommonTable.push_back(m_teamers,item_m_teamers)
            end
            m_Response_TeamInfo.tid = R:readINT64();
            m_Response_TeamInfo.showadd = R:readINT();
            m_Response_TeamInfo.ischampion = R:readINT();
            local m_leader  = nil
            if R:readINT() ~= 0 then 
                m_leader = {}
                m_Response_TeamInfo.leader = m_leader
                R:readBEGIN();
                m_leader.id = R:readINT64();
                m_leader.name = R:readSTRING();
                m_leader.head = R:readSTRING();
                m_leader.lv = R:readINT();
                m_leader.sex = R:readINT();
                m_leader.equiplst = R:readSTRING();
                R:readEND();
            end
            m_Response_TeamInfo.playercount = R:readINT();
            m_Response_TeamInfo.showpk = R:readINT();
            m_Response_TeamInfo.sername = R:readSTRING();
            m_Response_TeamInfo.status3 = R:readINT();
            m_Response_TeamInfo.serid = R:readINT();
            m_Response_TeamInfo.ischampion2 = R:readINT();
            R:readEND();
            return m_Response_TeamInfo
        end
    end
    return nil
end

--
function M.GetData_12012()
    if R:getResult() == RREST.Success then
        local m_Response_Action_12012  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_12012 = {}
            R:readBEGIN();
            m_Response_Action_12012.progress = R:readSTRING();
            local m_teams8 =  {}
            m_Response_Action_12012.teams8 = m_teams8
            local nNum_m_teams8 = R:readINT();
            for index_m_teams8 = 1, nNum_m_teams8 do
                local item_m_teams8 = {}
                R:readBEGIN();
                item_m_teams8.needselect = R:readINT();
                item_m_teams8.tname = R:readSTRING();
                item_m_teams8.tno = R:readSTRING();
                item_m_teams8.point = R:readINT();
                item_m_teams8.declaration = R:readSTRING();
                item_m_teams8.isleader = R:readINT();
                item_m_teams8.status1 = R:readINT();
                item_m_teams8.status2 = R:readINT();
                local m_teamers =  {}
                item_m_teams8.teamers = m_teamers
                local nNum_m_teamers = R:readINT();
                for index_m_teamers = 1, nNum_m_teamers do
                    local item_m_teamers = {}
                    R:readBEGIN();
                    item_m_teamers.id = R:readINT64();
                    item_m_teamers.name = R:readSTRING();
                    item_m_teamers.head = R:readSTRING();
                    item_m_teamers.lv = R:readINT();
                    item_m_teamers.sex = R:readINT();
                    item_m_teamers.lastdate = R:readSTRING();
                    item_m_teamers.equiplst = R:readSTRING();
                    item_m_teamers.isleader = R:readINT();
                    item_m_teamers.status = R:readINT();
                    item_m_teamers.content = R:readSTRING();
                    local m_cards =  {}
                    item_m_teamers.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        item_m_cards.cpid = R:readINT64();
                        item_m_cards.teamcard = R:readINT();
                        item_m_cards.equipEffect = R:readSTRING();
                        item_m_cards.talent = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    R:readEND();
                    CommonTable.push_back(m_teamers,item_m_teamers)
                end
                item_m_teams8.tid = R:readINT64();
                item_m_teams8.showadd = R:readINT();
                item_m_teams8.ischampion = R:readINT();
                local m_leader  = nil
                if R:readINT() ~= 0 then 
                    m_leader = {}
                    item_m_teams8.leader = m_leader
                    R:readBEGIN();
                    m_leader.id = R:readINT64();
                    m_leader.name = R:readSTRING();
                    m_leader.head = R:readSTRING();
                    m_leader.lv = R:readINT();
                    m_leader.sex = R:readINT();
                    m_leader.equiplst = R:readSTRING();
                    R:readEND();
                end
                item_m_teams8.playercount = R:readINT();
                item_m_teams8.showpk = R:readINT();
                item_m_teams8.sername = R:readSTRING();
                item_m_teams8.status3 = R:readINT();
                item_m_teams8.serid = R:readINT();
                item_m_teams8.ischampion2 = R:readINT();
                R:readEND();
                CommonTable.push_back(m_teams8,item_m_teams8)
            end
            local m_records8 =  {}
            m_Response_Action_12012.records8 = m_records8
            local nNum_m_records8 = R:readINT();
            for index_m_records8 = 1, nNum_m_records8 do
                local item_m_records8 = {}
                R:readBEGIN();
                item_m_records8.node = R:readSTRING();
                item_m_records8.rid = R:readINT64();
                item_m_records8.res = R:readINT();
                local m_team1  = nil
                if R:readINT() ~= 0 then 
                    m_team1 = {}
                    item_m_records8.team1 = m_team1
                    R:readBEGIN();
                    m_team1.needselect = R:readINT();
                    m_team1.tname = R:readSTRING();
                    m_team1.tno = R:readSTRING();
                    m_team1.point = R:readINT();
                    m_team1.declaration = R:readSTRING();
                    m_team1.isleader = R:readINT();
                    m_team1.status1 = R:readINT();
                    m_team1.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team1.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team1.tid = R:readINT64();
                    m_team1.showadd = R:readINT();
                    m_team1.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team1.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team1.playercount = R:readINT();
                    m_team1.showpk = R:readINT();
                    m_team1.sername = R:readSTRING();
                    m_team1.status3 = R:readINT();
                    m_team1.serid = R:readINT();
                    m_team1.ischampion2 = R:readINT();
                    R:readEND();
                end
                local m_team2  = nil
                if R:readINT() ~= 0 then 
                    m_team2 = {}
                    item_m_records8.team2 = m_team2
                    R:readBEGIN();
                    m_team2.needselect = R:readINT();
                    m_team2.tname = R:readSTRING();
                    m_team2.tno = R:readSTRING();
                    m_team2.point = R:readINT();
                    m_team2.declaration = R:readSTRING();
                    m_team2.isleader = R:readINT();
                    m_team2.status1 = R:readINT();
                    m_team2.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team2.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team2.tid = R:readINT64();
                    m_team2.showadd = R:readINT();
                    m_team2.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team2.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team2.playercount = R:readINT();
                    m_team2.showpk = R:readINT();
                    m_team2.sername = R:readSTRING();
                    m_team2.status3 = R:readINT();
                    m_team2.serid = R:readINT();
                    m_team2.ischampion2 = R:readINT();
                    R:readEND();
                end
                item_m_records8.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_records8,item_m_records8)
            end
            local m_myrecords =  {}
            m_Response_Action_12012.myrecords = m_myrecords
            local nNum_m_myrecords = R:readINT();
            for index_m_myrecords = 1, nNum_m_myrecords do
                local item_m_myrecords = {}
                R:readBEGIN();
                item_m_myrecords.node = R:readSTRING();
                item_m_myrecords.rid = R:readINT64();
                item_m_myrecords.res = R:readINT();
                local m_team1  = nil
                if R:readINT() ~= 0 then 
                    m_team1 = {}
                    item_m_myrecords.team1 = m_team1
                    R:readBEGIN();
                    m_team1.needselect = R:readINT();
                    m_team1.tname = R:readSTRING();
                    m_team1.tno = R:readSTRING();
                    m_team1.point = R:readINT();
                    m_team1.declaration = R:readSTRING();
                    m_team1.isleader = R:readINT();
                    m_team1.status1 = R:readINT();
                    m_team1.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team1.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team1.tid = R:readINT64();
                    m_team1.showadd = R:readINT();
                    m_team1.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team1.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team1.playercount = R:readINT();
                    m_team1.showpk = R:readINT();
                    m_team1.sername = R:readSTRING();
                    m_team1.status3 = R:readINT();
                    m_team1.serid = R:readINT();
                    m_team1.ischampion2 = R:readINT();
                    R:readEND();
                end
                local m_team2  = nil
                if R:readINT() ~= 0 then 
                    m_team2 = {}
                    item_m_myrecords.team2 = m_team2
                    R:readBEGIN();
                    m_team2.needselect = R:readINT();
                    m_team2.tname = R:readSTRING();
                    m_team2.tno = R:readSTRING();
                    m_team2.point = R:readINT();
                    m_team2.declaration = R:readSTRING();
                    m_team2.isleader = R:readINT();
                    m_team2.status1 = R:readINT();
                    m_team2.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team2.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team2.tid = R:readINT64();
                    m_team2.showadd = R:readINT();
                    m_team2.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team2.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team2.playercount = R:readINT();
                    m_team2.showpk = R:readINT();
                    m_team2.sername = R:readSTRING();
                    m_team2.status3 = R:readINT();
                    m_team2.serid = R:readINT();
                    m_team2.ischampion2 = R:readINT();
                    R:readEND();
                end
                item_m_myrecords.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_myrecords,item_m_myrecords)
            end
            local m_myrecords8 =  {}
            m_Response_Action_12012.myrecords8 = m_myrecords8
            local nNum_m_myrecords8 = R:readINT();
            for index_m_myrecords8 = 1, nNum_m_myrecords8 do
                local item_m_myrecords8 = {}
                R:readBEGIN();
                item_m_myrecords8.node = R:readSTRING();
                item_m_myrecords8.rid = R:readINT64();
                item_m_myrecords8.res = R:readINT();
                local m_team1  = nil
                if R:readINT() ~= 0 then 
                    m_team1 = {}
                    item_m_myrecords8.team1 = m_team1
                    R:readBEGIN();
                    m_team1.needselect = R:readINT();
                    m_team1.tname = R:readSTRING();
                    m_team1.tno = R:readSTRING();
                    m_team1.point = R:readINT();
                    m_team1.declaration = R:readSTRING();
                    m_team1.isleader = R:readINT();
                    m_team1.status1 = R:readINT();
                    m_team1.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team1.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team1.tid = R:readINT64();
                    m_team1.showadd = R:readINT();
                    m_team1.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team1.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team1.playercount = R:readINT();
                    m_team1.showpk = R:readINT();
                    m_team1.sername = R:readSTRING();
                    m_team1.status3 = R:readINT();
                    m_team1.serid = R:readINT();
                    m_team1.ischampion2 = R:readINT();
                    R:readEND();
                end
                local m_team2  = nil
                if R:readINT() ~= 0 then 
                    m_team2 = {}
                    item_m_myrecords8.team2 = m_team2
                    R:readBEGIN();
                    m_team2.needselect = R:readINT();
                    m_team2.tname = R:readSTRING();
                    m_team2.tno = R:readSTRING();
                    m_team2.point = R:readINT();
                    m_team2.declaration = R:readSTRING();
                    m_team2.isleader = R:readINT();
                    m_team2.status1 = R:readINT();
                    m_team2.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team2.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team2.tid = R:readINT64();
                    m_team2.showadd = R:readINT();
                    m_team2.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team2.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team2.playercount = R:readINT();
                    m_team2.showpk = R:readINT();
                    m_team2.sername = R:readSTRING();
                    m_team2.status3 = R:readINT();
                    m_team2.serid = R:readINT();
                    m_team2.ischampion2 = R:readINT();
                    R:readEND();
                end
                item_m_myrecords8.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_myrecords8,item_m_myrecords8)
            end
            local m_myrecords4 =  {}
            m_Response_Action_12012.myrecords4 = m_myrecords4
            local nNum_m_myrecords4 = R:readINT();
            for index_m_myrecords4 = 1, nNum_m_myrecords4 do
                local item_m_myrecords4 = {}
                R:readBEGIN();
                item_m_myrecords4.node = R:readSTRING();
                item_m_myrecords4.rid = R:readINT64();
                item_m_myrecords4.res = R:readINT();
                local m_team1  = nil
                if R:readINT() ~= 0 then 
                    m_team1 = {}
                    item_m_myrecords4.team1 = m_team1
                    R:readBEGIN();
                    m_team1.needselect = R:readINT();
                    m_team1.tname = R:readSTRING();
                    m_team1.tno = R:readSTRING();
                    m_team1.point = R:readINT();
                    m_team1.declaration = R:readSTRING();
                    m_team1.isleader = R:readINT();
                    m_team1.status1 = R:readINT();
                    m_team1.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team1.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team1.tid = R:readINT64();
                    m_team1.showadd = R:readINT();
                    m_team1.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team1.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team1.playercount = R:readINT();
                    m_team1.showpk = R:readINT();
                    m_team1.sername = R:readSTRING();
                    m_team1.status3 = R:readINT();
                    m_team1.serid = R:readINT();
                    m_team1.ischampion2 = R:readINT();
                    R:readEND();
                end
                local m_team2  = nil
                if R:readINT() ~= 0 then 
                    m_team2 = {}
                    item_m_myrecords4.team2 = m_team2
                    R:readBEGIN();
                    m_team2.needselect = R:readINT();
                    m_team2.tname = R:readSTRING();
                    m_team2.tno = R:readSTRING();
                    m_team2.point = R:readINT();
                    m_team2.declaration = R:readSTRING();
                    m_team2.isleader = R:readINT();
                    m_team2.status1 = R:readINT();
                    m_team2.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team2.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team2.tid = R:readINT64();
                    m_team2.showadd = R:readINT();
                    m_team2.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team2.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team2.playercount = R:readINT();
                    m_team2.showpk = R:readINT();
                    m_team2.sername = R:readSTRING();
                    m_team2.status3 = R:readINT();
                    m_team2.serid = R:readINT();
                    m_team2.ischampion2 = R:readINT();
                    R:readEND();
                end
                item_m_myrecords4.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_myrecords4,item_m_myrecords4)
            end
            local m_myrecords2 =  {}
            m_Response_Action_12012.myrecords2 = m_myrecords2
            local nNum_m_myrecords2 = R:readINT();
            for index_m_myrecords2 = 1, nNum_m_myrecords2 do
                local item_m_myrecords2 = {}
                R:readBEGIN();
                item_m_myrecords2.node = R:readSTRING();
                item_m_myrecords2.rid = R:readINT64();
                item_m_myrecords2.res = R:readINT();
                local m_team1  = nil
                if R:readINT() ~= 0 then 
                    m_team1 = {}
                    item_m_myrecords2.team1 = m_team1
                    R:readBEGIN();
                    m_team1.needselect = R:readINT();
                    m_team1.tname = R:readSTRING();
                    m_team1.tno = R:readSTRING();
                    m_team1.point = R:readINT();
                    m_team1.declaration = R:readSTRING();
                    m_team1.isleader = R:readINT();
                    m_team1.status1 = R:readINT();
                    m_team1.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team1.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team1.tid = R:readINT64();
                    m_team1.showadd = R:readINT();
                    m_team1.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team1.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team1.playercount = R:readINT();
                    m_team1.showpk = R:readINT();
                    m_team1.sername = R:readSTRING();
                    m_team1.status3 = R:readINT();
                    m_team1.serid = R:readINT();
                    m_team1.ischampion2 = R:readINT();
                    R:readEND();
                end
                local m_team2  = nil
                if R:readINT() ~= 0 then 
                    m_team2 = {}
                    item_m_myrecords2.team2 = m_team2
                    R:readBEGIN();
                    m_team2.needselect = R:readINT();
                    m_team2.tname = R:readSTRING();
                    m_team2.tno = R:readSTRING();
                    m_team2.point = R:readINT();
                    m_team2.declaration = R:readSTRING();
                    m_team2.isleader = R:readINT();
                    m_team2.status1 = R:readINT();
                    m_team2.status2 = R:readINT();
                    local m_teamers =  {}
                    m_team2.teamers = m_teamers
                    local nNum_m_teamers = R:readINT();
                    for index_m_teamers = 1, nNum_m_teamers do
                        local item_m_teamers = {}
                        R:readBEGIN();
                        item_m_teamers.id = R:readINT64();
                        item_m_teamers.name = R:readSTRING();
                        item_m_teamers.head = R:readSTRING();
                        item_m_teamers.lv = R:readINT();
                        item_m_teamers.sex = R:readINT();
                        item_m_teamers.lastdate = R:readSTRING();
                        item_m_teamers.equiplst = R:readSTRING();
                        item_m_teamers.isleader = R:readINT();
                        item_m_teamers.status = R:readINT();
                        item_m_teamers.content = R:readSTRING();
                        local m_cards =  {}
                        item_m_teamers.cards = m_cards
                        local nNum_m_cards = R:readINT();
                        for index_m_cards = 1, nNum_m_cards do
                            local item_m_cards = {}
                            R:readBEGIN();
                            item_m_cards.id = R:readINT();
                            item_m_cards.lv = R:readINT();
                            item_m_cards.evolv = R:readINT();
                            item_m_cards.addvalue = R:readSTRING();
                            item_m_cards.cpid = R:readINT64();
                            item_m_cards.teamcard = R:readINT();
                            item_m_cards.equipEffect = R:readSTRING();
                            item_m_cards.talent = R:readSTRING();
                            R:readEND();
                            CommonTable.push_back(m_cards,item_m_cards)
                        end
                        R:readEND();
                        CommonTable.push_back(m_teamers,item_m_teamers)
                    end
                    m_team2.tid = R:readINT64();
                    m_team2.showadd = R:readINT();
                    m_team2.ischampion = R:readINT();
                    local m_leader  = nil
                    if R:readINT() ~= 0 then 
                        m_leader = {}
                        m_team2.leader = m_leader
                        R:readBEGIN();
                        m_leader.id = R:readINT64();
                        m_leader.name = R:readSTRING();
                        m_leader.head = R:readSTRING();
                        m_leader.lv = R:readINT();
                        m_leader.sex = R:readINT();
                        m_leader.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    m_team2.playercount = R:readINT();
                    m_team2.showpk = R:readINT();
                    m_team2.sername = R:readSTRING();
                    m_team2.status3 = R:readINT();
                    m_team2.serid = R:readINT();
                    m_team2.ischampion2 = R:readINT();
                    R:readEND();
                end
                item_m_myrecords2.serid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_myrecords2,item_m_myrecords2)
            end
            R:readEND();
            return m_Response_Action_12012
        end
    end
    return nil
end

--
function M.GetData_12013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_12013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_12013 = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Response_Action_12013.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT();
                item_m_cards.lv = R:readINT();
                item_m_cards.evolv = R:readINT();
                item_m_cards.addvalue = R:readSTRING();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.teamcard = R:readINT();
                item_m_cards.equipEffect = R:readSTRING();
                item_m_cards.talent = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Response_Action_12013
        end
    end
    return nil
end

--
function M.GetData_12016()
    if R:getResult() == RREST.Success then
        local m_Response_Action_2001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_2001 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_2001.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_2001.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_2001.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                m_result.jjcScore = R:readINT();
                m_result.rank = R:readINT();
                m_result.rankvar = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                local m_levels =  {}
                m_result.levels = m_levels
                local nNum_m_levels = R:readINT();
                for index_m_levels = 1, nNum_m_levels do
                    local item_m_levels = {}
                    R:readBEGIN();
                    item_m_levels.sn = R:readINT();
                    item_m_levels.subsn = R:readINT();
                    item_m_levels.star = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_levels,item_m_levels)
                end
                m_result.flag = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_2001
        end
    end
    return nil
end

--
function M.GetData_12018()
    if R:getResult() == RREST.Success then
        local m_Response_Action_12018  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_12018 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_12018.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_12018
        end
    end
    return nil
end

function M.GetData_12021()
    return GetData_fight()
end
--
function M.GetData_13001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13001 = {}
            R:readBEGIN();
            m_Response_Action_13001.MyRank = R:readSTRING();
            local m_Players =  {}
            m_Response_Action_13001.Players = m_Players
            local nNum_m_Players = R:readINT();
            for index_m_Players = 1, nNum_m_Players do
                local item_m_Players = {}
                R:readBEGIN();
                item_m_Players.id = R:readINT64();
                item_m_Players.name = R:readSTRING();
                item_m_Players.head = R:readSTRING();
                item_m_Players.lv = R:readINT();
                item_m_Players.winrate = R:readINT();
                item_m_Players.count = R:readINT();
                item_m_Players.rank = R:readINT();
                item_m_Players.lastdate = R:readSTRING();
                item_m_Players.org = R:readSTRING();
                item_m_Players.sex = R:readINT();
                item_m_Players.equipEffect = R:readSTRING();
                item_m_Players.equiplst = R:readSTRING();
                item_m_Players.talvalue = R:readINT();
                item_m_Players.gold = R:readINT64();
                item_m_Players.totalatk = R:readINT64();
                item_m_Players.totalhp = R:readINT64();
                item_m_Players.worshiptimes = R:readINT();
                R:readEND();
                CommonTable.push_back(m_Players,item_m_Players)
            end
            local m_Hero  = nil
            if R:readINT() ~= 0 then 
                m_Hero = {}
                m_Response_Action_13001.Hero = m_Hero
                R:readBEGIN();
                m_Hero.id = R:readINT64();
                m_Hero.name = R:readSTRING();
                m_Hero.head = R:readSTRING();
                m_Hero.lv = R:readINT();
                m_Hero.winrate = R:readINT();
                m_Hero.count = R:readINT();
                m_Hero.rank = R:readINT();
                m_Hero.lastdate = R:readSTRING();
                m_Hero.org = R:readSTRING();
                m_Hero.sex = R:readINT();
                m_Hero.equipEffect = R:readSTRING();
                m_Hero.equiplst = R:readSTRING();
                m_Hero.talvalue = R:readINT();
                m_Hero.gold = R:readINT64();
                m_Hero.totalatk = R:readINT64();
                m_Hero.totalhp = R:readINT64();
                m_Hero.worshiptimes = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13001
        end
    end
    return nil
end

--
function M.GetData_13002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13002 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13002.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13002
        end
    end
    return nil
end
--[大转盘]进入大转盘界面
function M.GetData_13003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13003 = {}
            R:readBEGIN();
            m_Response_Action_13003.DamPrice = R:readINT();
            m_Response_Action_13003.GoldPrice = R:readINT();
            local m_rewardlst =  {}
            m_Response_Action_13003.rewardlst = m_rewardlst
            local nNum_m_rewardlst = R:readINT();
            for index_m_rewardlst = 1, nNum_m_rewardlst do
                local item_m_rewardlst = {}
                R:readBEGIN();
                item_m_rewardlst.diamond = R:readINT();
                item_m_rewardlst.gold = R:readINT64();
                item_m_rewardlst.exp = R:readINT();
                item_m_rewardlst.fp = R:readINT();
                item_m_rewardlst.star = R:readINT();
                local m_brlist =  {}
                item_m_rewardlst.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
                CommonTable.push_back(m_rewardlst,item_m_rewardlst)
            end
            R:readEND();
            return m_Response_Action_13003
        end
    end
    return nil
end

--
function M.GetData_13004()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13004  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13004 = {}
            R:readBEGIN();
            m_Response_Action_13004.point = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13004.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13004
        end
    end
    return nil
end
-- 限时充值
function M.GetData_13005()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13005 = {}
            R:readBEGIN();
            m_Response_Action_13005.showstr = R:readSTRING();
            m_Response_Action_13005.curval = R:readINT();
            local m_lst =  {}
            m_Response_Action_13005.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_lst.count = R:readINT();
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13005
        end
    end
    return nil
end

-- 限时充值 领取
function M.GetData_13006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
-- 限时消费
function M.GetData_13007()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13005 = {}
            R:readBEGIN();
            m_Response_Action_13005.showstr = R:readSTRING();
            m_Response_Action_13005.curval = R:readINT();
            local m_lst =  {}
            m_Response_Action_13005.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13005
        end
    end
    return nil
end

-- 限时消费 领取
function M.GetData_13008()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
-- 连续登录
function M.GetData_13009()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13009  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13009 = {}
            R:readBEGIN();
            m_Response_Action_13009.showstr = R:readSTRING();
            local m_lst =  {}
            m_Response_Action_13009.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_lst.needdia = R:readINT();
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            m_Response_Action_13009.curval = R:readINT();
            R:readEND();
            return m_Response_Action_13009
        end
    end
    return nil
end

-- 连续登录 领取
function M.GetData_13010()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
-- 单笔充值
function M.GetData_13011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13005 = {}
            R:readBEGIN();
            m_Response_Action_13005.showstr = R:readSTRING();
            m_Response_Action_13005.curval = R:readINT();
            local m_lst =  {}
            m_Response_Action_13005.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_lst.count = R:readINT();
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13005
        end
    end
    return nil
end

-- 单笔充值 领取
function M.GetData_13012()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
function M.GetData_13013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13013 = {}
            R:readBEGIN();
            m_Response_Action_13013.showstr = R:readSTRING();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13013.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13013
        end
    end
    return nil
end
-- 充值活动
function M.GetData_13014()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13014  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13014 = {}
            R:readBEGIN();
            local m_lst =  {}
            m_Response_Action_13014.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.str = R:readSTRING();
                item_m_lst.title = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13014
        end
    end
    return nil
end
-- 注册后登录7天
function M.GetData_13015()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13015  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13015 = {}
            R:readBEGIN();
            local m_lst =  {}
            m_Response_Action_13015.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            m_Response_Action_13015.str = R:readSTRING();
            R:readEND();
            return m_Response_Action_13015
        end
    end
    return nil
end

-- 注册后登录7天 领取
function M.GetData_13016()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13016  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13016 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13016.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13016
        end
    end
    return nil
end


-- 单天累计充值
function M.GetData_13018()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13005 = {}
            R:readBEGIN();
            m_Response_Action_13005.showstr = R:readSTRING();
            m_Response_Action_13005.curval = R:readINT();
            local m_lst =  {}
            m_Response_Action_13005.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13005
        end
    end
    return nil
end

-- 单天累计充值 领取
function M.GetData_13019()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
-- 当天累计消费
function M.GetData_13020()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13005  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13005 = {}
            R:readBEGIN();
            m_Response_Action_13005.showstr = R:readSTRING();
            m_Response_Action_13005.curval = R:readINT();
            local m_lst =  {}
            m_Response_Action_13005.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13005
        end
    end
    return nil
end

-- 当天累计消费 领取
function M.GetData_13021()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13006 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13006.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13006
        end
    end
    return nil
end
-- 月卡
function M.GetData_13022()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13022  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13022 = {}
            R:readBEGIN();
            m_Response_Action_13022.days = R:readINT();
            m_Response_Action_13022.cost = R:readSTRING();
            m_Response_Action_13022.dia = R:readINT();
            m_Response_Action_13022.status = R:readINT();
            R:readEND();
            return m_Response_Action_13022
        end
    end
    return nil
end

-- 月卡奖励
function M.GetData_13023()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13023  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13023 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13023.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13023
        end
    end
    return nil
end
--
function M.GetData_13024()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13024  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13024 = {}
            R:readBEGIN();
            m_Response_Action_13024.showstr = R:readSTRING();
            m_Response_Action_13024.curval = R:readSTRING();
            local m_lst =  {}
            m_Response_Action_13024.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.tag = R:readINT();
                item_m_lst.target = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_reward.sp = R:readINT();
                    R:readEND();
                end
                item_m_lst.status = R:readINT();
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13024
        end
    end
    return nil
end

--
function M.GetData_13025()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13025  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13025 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13025.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13025
        end
    end
    return nil
end

--
function M.GetData_13026()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13026  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13026 = {}
            R:readBEGIN();
            m_Response_Action_13026.showstr = R:readSTRING();
            m_Response_Action_13026.curval = R:readINT();
            m_Response_Action_13026.price = R:readINT();
            m_Response_Action_13026.LmmoNum = R:readINT();
            local m_lst =  {}
            m_Response_Action_13026.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.status = R:readINT();
                item_m_lst.tag = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_reward.sp = R:readINT();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            R:readEND();
            return m_Response_Action_13026
        end
    end
    return nil
end

--
function M.GetData_13027()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13025  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13025 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13025.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13025
        end
    end
    return nil
end

--
function M.GetData_13028()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13025  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13025 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13025.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13025
        end
    end
    return nil
end
--
function M.GetData_13029()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13029  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13029 = {}
            R:readBEGIN();
            m_Response_Action_13029.curExpenseDay = R:readINT();
            m_Response_Action_13029.curval = R:readINT();
            m_Response_Action_13029.totalTargetExpense = R:readINT();
            local m_lst =  {}
            m_Response_Action_13029.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.targetDay = R:readINT();
                item_m_lst.targetExpense = R:readINT();
                item_m_lst.status = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_reward.sp = R:readINT();
                    m_reward.apoint = R:readINT();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            m_Response_Action_13029.activityTime = R:readSTRING();
            R:readEND();
            return m_Response_Action_13029
        end
    end
    return nil
end

--
function M.GetData_13030()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13030  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13030 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13030.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13030
        end
    end
    return nil
end
--
function M.GetData_13031()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13031  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13031 = {}
            R:readBEGIN();
            m_Response_Action_13031.publishTime = R:readINT();
            m_Response_Action_13031.rewardTime = R:readINT();
            local m_lst =  {}
            m_Response_Action_13031.lst = m_lst
            local nNum_m_lst = R:readINT();
            for index_m_lst = 1, nNum_m_lst do
                local item_m_lst = {}
                R:readBEGIN();
                item_m_lst.index = R:readINT();
                item_m_lst.openTime = R:readINT();
                item_m_lst.rewardTime = R:readINT();
                item_m_lst.rewardStatus = R:readINT();
                item_m_lst.joindStatus = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_lst.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_reward.sp = R:readINT();
                    m_reward.apoint = R:readINT();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_lst,item_m_lst)
            end
            m_Response_Action_13031.activityTime = R:readSTRING();
            R:readEND();
            return m_Response_Action_13031
        end
    end
    return nil
end

--
function M.GetData_13033()
    if R:getResult() == RREST.Success then
        local m_Response_Action_13033  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_13033 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_13033.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_13033
        end
    end
    return nil
end

--
function M.GetData_14000()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14000  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14000 = {}
            R:readBEGIN();
            m_Response_Action_14000.armytyp = R:readINT();
            R:readEND();
            return m_Response_Action_14000
        end
    end
    return nil
end

--
function M.GetData_14001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14001 = {}
            R:readBEGIN();
            local m_armylist =  {}
            m_Response_Action_14001.armylist = m_armylist
            local nNum_m_armylist = R:readINT();
            for index_m_armylist = 1, nNum_m_armylist do
                local item_m_armylist = {}
                R:readBEGIN();
                item_m_armylist.aid = R:readINT64();
                item_m_armylist.ano = R:readSTRING();
                item_m_armylist.aname = R:readSTRING();
                item_m_armylist.aleve = R:readINT();
                item_m_armylist.apoint = R:readINT();
                item_m_armylist.aleadername = R:readSTRING();
                item_m_armylist.aleaderlv = R:readINT();
                item_m_armylist.acount = R:readINT();
                item_m_armylist.alimit = R:readINT();
                item_m_armylist.anotice = R:readSTRING();
                item_m_armylist.butstatus = R:readINT();
                item_m_armylist.aleadersex = R:readINT();
                item_m_armylist.aleaderhead = R:readSTRING();
                item_m_armylist.aleadereq = R:readSTRING();
                item_m_armylist.aleaderid = R:readINT();
                R:readEND();
                CommonTable.push_back(m_armylist,item_m_armylist)
            end
            m_Response_Action_14001.userlv = R:readINT();
            m_Response_Action_14001.lastexitarmytime = R:readSTRING();
            m_Response_Action_14001.creatarmy = R:readINT();
            m_Response_Action_14001.creatlv = R:readINT();
            R:readEND();
            return m_Response_Action_14001
        end
    end
    return nil
end

--
function M.GetData_14003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14003  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14003 = {}
            R:readBEGIN();
            local m_armyinfo  = nil
            if R:readINT() ~= 0 then 
                m_armyinfo = {}
                m_Response_Action_14003.armyinfo = m_armyinfo
                R:readBEGIN();
                m_armyinfo.aid = R:readINT64();
                m_armyinfo.ano = R:readSTRING();
                m_armyinfo.aname = R:readSTRING();
                m_armyinfo.aleve = R:readINT();
                m_armyinfo.apoint = R:readINT();
                m_armyinfo.aleadername = R:readSTRING();
                m_armyinfo.aleaderlv = R:readINT();
                m_armyinfo.acount = R:readINT();
                m_armyinfo.alimit = R:readINT();
                m_armyinfo.anotice = R:readSTRING();
                m_armyinfo.butstatus = R:readINT();
                m_armyinfo.aleadersex = R:readINT();
                m_armyinfo.aleaderhead = R:readSTRING();
                m_armyinfo.aleadereq = R:readSTRING();
                m_armyinfo.aleaderid = R:readINT64();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_14003
        end
    end
    return nil
end

--
function M.GetData_14006()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14006  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14006 = {}
            R:readBEGIN();
            m_Response_Action_14006.armyname = R:readSTRING();
            m_Response_Action_14006.armylv = R:readINT();
            m_Response_Action_14006.apoint = R:readINT();
            m_Response_Action_14006.armyplayercount = R:readINT();
            m_Response_Action_14006.armyplayerlimit = R:readINT();
            m_Response_Action_14006.armynotice = R:readSTRING();
            m_Response_Action_14006.identity = R:readINT();
            m_Response_Action_14006.nextpoint = R:readINT();
            m_Response_Action_14006.leadername = R:readSTRING();
            m_Response_Action_14006.armycontribute = R:readINT();
            m_Response_Action_14006.isnew = R:readINT();
            R:readEND();
            return m_Response_Action_14006
        end
    end
    return nil
end

--
function M.GetData_14008()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14008  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14008 = {}
            R:readBEGIN();
            local m_armyplayerlist =  {}
            m_Response_Action_14008.armyplayerlist = m_armyplayerlist
            local nNum_m_armyplayerlist = R:readINT();
            for index_m_armyplayerlist = 1, nNum_m_armyplayerlist do
                local item_m_armyplayerlist = {}
                R:readBEGIN();
                item_m_armyplayerlist.id = R:readINT64();
                item_m_armyplayerlist.name = R:readSTRING();
                item_m_armyplayerlist.head = R:readSTRING();
                item_m_armyplayerlist.equiplst = R:readSTRING();
                item_m_armyplayerlist.lv = R:readINT();
                item_m_armyplayerlist.lastdate = R:readSTRING();
                item_m_armyplayerlist.identity = R:readINT();
                item_m_armyplayerlist.status = R:readINT();
                item_m_armyplayerlist.credit = R:readINT();
                item_m_armyplayerlist.rank = R:readINT();
                local m_maincard  = nil
                if R:readINT() ~= 0 then 
                    m_maincard = {}
                    item_m_armyplayerlist.maincard = m_maincard
                    R:readBEGIN();
                    m_maincard.id = R:readINT64();
                    m_maincard.lv = R:readINT();
                    m_maincard.evolv = R:readINT();
                    R:readEND();
                end
                item_m_armyplayerlist.jurisdiction = R:readSTRING();
                item_m_armyplayerlist.sex = R:readINT();
                item_m_armyplayerlist.talent = R:readSTRING();
                item_m_armyplayerlist.equipEffect = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_armyplayerlist,item_m_armyplayerlist)
            end
            m_Response_Action_14008.isnew = R:readINT();
            R:readEND();
            return m_Response_Action_14008
        end
    end
    return nil
end

--
function M.GetData_14011()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14011  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14011 = {}
            R:readBEGIN();
            local m_armyproposerlist =  {}
            m_Response_Action_14011.armyproposerlist = m_armyproposerlist
            local nNum_m_armyproposerlist = R:readINT();
            for index_m_armyproposerlist = 1, nNum_m_armyproposerlist do
                local item_m_armyproposerlist = {}
                R:readBEGIN();
                item_m_armyproposerlist.proposerid = R:readINT64();
                item_m_armyproposerlist.proposername = R:readSTRING();
                item_m_armyproposerlist.head = R:readSTRING();
                item_m_armyproposerlist.equiplst = R:readSTRING();
                item_m_armyproposerlist.lv = R:readINT();
                item_m_armyproposerlist.lastdate = R:readSTRING();
                item_m_armyproposerlist.isshowstatus = R:readINT();
                item_m_armyproposerlist.rank = R:readINT();
                local m_maincard  = nil
                if R:readINT() ~= 0 then 
                    m_maincard = {}
                    item_m_armyproposerlist.maincard = m_maincard
                    R:readBEGIN();
                    m_maincard.id = R:readINT64();
                    m_maincard.lv = R:readINT();
                    m_maincard.evolv = R:readINT();
                    R:readEND();
                end
                item_m_armyproposerlist.sex = R:readINT();
                item_m_armyproposerlist.talent = R:readSTRING();
                item_m_armyproposerlist.equipEffect = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_armyproposerlist,item_m_armyproposerlist)
            end
            m_Response_Action_14011.isnew = R:readINT();
            R:readEND();
            return m_Response_Action_14011
        end
    end
    return nil
end

--
function M.GetData_14013()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14013  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14013 = {}
            R:readBEGIN();
            m_Response_Action_14013.armylv = R:readINT();
            m_Response_Action_14013.apoint = R:readINT();
            m_Response_Action_14013.nextpoint = R:readINT();
            R:readEND();
            return m_Response_Action_14013
        end
    end
    return nil
end

--
function M.GetData_14014()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14014  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14014 = {}
            R:readBEGIN();
            m_Response_Action_14014.apoint = R:readINT();
            m_Response_Action_14014.acredit = R:readINT();
            m_Response_Action_14014.identity = R:readINT();
            m_Response_Action_14014.nextpoint = R:readINT();
            local m_armyshoplist =  {}
            m_Response_Action_14014.armyshoplist = m_armyshoplist
            local nNum_m_armyshoplist = R:readINT();
            for index_m_armyshoplist = 1, nNum_m_armyshoplist do
                local item_m_armyshoplist = {}
                R:readBEGIN();
                item_m_armyshoplist.sid = R:readINT();
                item_m_armyshoplist.sname = R:readSTRING();
                item_m_armyshoplist.sprice = R:readINT();
                item_m_armyshoplist.count = R:readINT();
                item_m_armyshoplist.needlv = R:readINT();
                item_m_armyshoplist.num = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_armyshoplist.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_reward.sp = R:readINT();
                    m_reward.apoint = R:readINT();
                    R:readEND();
                end
                R:readEND();
                CommonTable.push_back(m_armyshoplist,item_m_armyshoplist)
            end
            m_Response_Action_14014.shoplv = R:readINT();
            R:readEND();
            return m_Response_Action_14014
        end
    end
    return nil
end

--
function M.GetData_14015()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14015  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14015 = {}
            R:readBEGIN();
            m_Response_Action_14015.apoint = R:readINT();
            m_Response_Action_14015.nextpoint = R:readINT();
            m_Response_Action_14015.shoplv = R:readINT();
            R:readEND();
            return m_Response_Action_14015
        end
    end
    return nil
end

--
function M.GetData_14016()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14016  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14016 = {}
            R:readBEGIN();
            local m_rs  = nil
            if R:readINT() ~= 0 then 
                m_rs = {}
                m_Response_Action_14016.rs = m_rs
                R:readBEGIN();
                m_rs.diamond = R:readINT();
                m_rs.gold = R:readINT64();
                m_rs.exp = R:readINT();
                m_rs.fp = R:readINT();
                m_rs.star = R:readINT();
                local m_brlist =  {}
                m_rs.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_rs.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_14016
        end
    end
    return nil
end

--
function M.GetData_14017()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14017  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14017 = {}
            R:readBEGIN();
            local m_armynewslist =  {}
            m_Response_Action_14017.armynewslist = m_armynewslist
            local nNum_m_armynewslist = R:readINT();
            for index_m_armynewslist = 1, nNum_m_armynewslist do
                local item_m_armynewslist = {}
                R:readBEGIN();
                item_m_armynewslist.content = R:readSTRING();
                item_m_armynewslist.newstime = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_armynewslist,item_m_armynewslist)
            end
            R:readEND();
            return m_Response_Action_14017
        end
    end
    return nil
end

--
function M.GetData_14018()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14018  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14018 = {}
            R:readBEGIN();
            local m_armylist =  {}
            m_Response_Action_14018.armylist = m_armylist
            local nNum_m_armylist = R:readINT();
            for index_m_armylist = 1, nNum_m_armylist do
                local item_m_armylist = {}
                R:readBEGIN();
                item_m_armylist.aid = R:readINT64();
                item_m_armylist.ano = R:readSTRING();
                item_m_armylist.aname = R:readSTRING();
                item_m_armylist.aleve = R:readINT();
                item_m_armylist.apoint = R:readINT();
                item_m_armylist.aleadername = R:readSTRING();
                item_m_armylist.aleaderlv = R:readINT();
                item_m_armylist.acount = R:readINT();
                item_m_armylist.alimit = R:readINT();
                item_m_armylist.anotice = R:readSTRING();
                item_m_armylist.butstatus = R:readINT();
                item_m_armylist.aleadersex = R:readINT();
                item_m_armylist.aleaderhead = R:readSTRING();
                item_m_armylist.aleadereq = R:readSTRING();
                item_m_armylist.aleaderid = R:readINT64();
                R:readEND();
                CommonTable.push_back(m_armylist,item_m_armylist)
            end
            R:readEND();
            return m_Response_Action_14018
        end
    end
    return nil
end

--
function M.GetData_14019()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14019  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14019 = {}
            R:readBEGIN();
            local m_armybuildlist =  {}
            m_Response_Action_14019.armybuildlist = m_armybuildlist
            local nNum_m_armybuildlist = R:readINT();
            for index_m_armybuildlist = 1, nNum_m_armybuildlist do
                local item_m_armybuildlist = {}
                R:readBEGIN();
                item_m_armybuildlist.bid = R:readINT();
                item_m_armybuildlist.btyp = R:readINT();
                item_m_armybuildlist.bno = R:readINT();
                item_m_armybuildlist.bname = R:readSTRING();
                item_m_armybuildlist.sprice = R:readINT();
                item_m_armybuildlist.bpoint = R:readINT();
                item_m_armybuildlist.bcredit = R:readINT();
                R:readEND();
                CommonTable.push_back(m_armybuildlist,item_m_armybuildlist)
            end
            m_Response_Action_14019.count = R:readINT();
            m_Response_Action_14019.apoint = R:readINT();
            m_Response_Action_14019.bcredit = R:readINT();
            R:readEND();
            return m_Response_Action_14019
        end
    end
    return nil
end

--
function M.GetData_14020()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14020  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14020 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_14020.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_14020
        end
    end
    return nil
end

--获得天赋列表
function M.GetData_14021()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14021  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14021 = {}
            R:readBEGIN();
            local m_armytalents =  {}
            m_Response_Action_14021.armytalents = m_armytalents
            local nNum_m_armytalents = R:readINT();
            for index_m_armytalents = 1, nNum_m_armytalents do
                local item_m_armytalents = {}
                R:readBEGIN();
                item_m_armytalents.lv = R:readINT();
                item_m_armytalents.typ = R:readINT();
                item_m_armytalents.camp = R:readINT();
                item_m_armytalents.curexp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_armytalents,item_m_armytalents)
            end
            m_Response_Action_14021.armylv = R:readINT();
            R:readEND();
            return m_Response_Action_14021
        end
    end
    return nil
end

--
function M.GetData_14022()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14022  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14022 = {}
            R:readBEGIN();
            local m_cards =  {}
            m_Response_Action_14022.cards = m_cards
            local nNum_m_cards = R:readINT();
            for index_m_cards = 1, nNum_m_cards do
                local item_m_cards = {}
                R:readBEGIN();
                item_m_cards.id = R:readINT64();
                item_m_cards.lv = R:readINT();
                item_m_cards.cpid = R:readINT64();
                item_m_cards.curexp = R:readINT64();
                item_m_cards.totalexp = R:readINT64();
                item_m_cards.evolv = R:readINT();
                R:readEND();
                CommonTable.push_back(m_cards,item_m_cards)
            end
            R:readEND();
            return m_Response_Action_14022
        end
    end
    return nil
end

--
function M.GetData_14023()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14023  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14023 = {}
            R:readBEGIN();
            local m_armytalents =  {}
            m_Response_Action_14023.armytalents = m_armytalents
            local nNum_m_armytalents = R:readINT();
            for index_m_armytalents = 1, nNum_m_armytalents do
                local item_m_armytalents = {}
                R:readBEGIN();
                item_m_armytalents.lv = R:readINT();
                item_m_armytalents.typ = R:readINT();
                item_m_armytalents.camp = R:readINT();
                item_m_armytalents.curexp = R:readINT();
                R:readEND();
                CommonTable.push_back(m_armytalents,item_m_armytalents)
            end
            m_Response_Action_14023.armylv = R:readINT();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_14023.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_14023
        end
    end
    return nil
end

--进入军团副本
--
function M.GetData_14024()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14024  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14024 = {}
            R:readBEGIN();
            m_Response_Action_14024.attackNum = R:readINT();
            m_Response_Action_14024.attackPrice = R:readINT();
            local m_bossList =  {}
            m_Response_Action_14024.bossList = m_bossList
            local nNum_m_bossList = R:readINT();
            for index_m_bossList = 1, nNum_m_bossList do
                local item_m_bossList = {}
                R:readBEGIN();
                item_m_bossList.bossNo = R:readINT64();
                item_m_bossList.bossName = R:readSTRING();
                item_m_bossList.hp = R:readINT();
                item_m_bossList.totalhp = R:readINT();
                item_m_bossList.bpoint = R:readINT();
                local m_Rw  = nil
                if R:readINT() ~= 0 then 
                    m_Rw = {}
                    item_m_bossList.Rw = m_Rw
                    R:readBEGIN();
                    m_Rw.diamond = R:readINT();
                    m_Rw.gold = R:readINT64();
                    m_Rw.exp = R:readINT();
                    m_Rw.fp = R:readINT();
                    m_Rw.star = R:readINT();
                    local m_brlist =  {}
                    m_Rw.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    m_Rw.sp = R:readINT();
                    m_Rw.apoint = R:readINT();
                    R:readEND();
                end
                item_m_bossList.status = R:readINT();
                item_m_bossList.bossSortNo = R:readINT();
                item_m_bossList.armylv = R:readINT();
                item_m_bossList.showno = R:readINT64();
                R:readEND();
                CommonTable.push_back(m_bossList,item_m_bossList)
            end
            R:readEND();
            return m_Response_Action_14024
        end
    end
    return nil
end

--伤害排行
function M.GetData_14026()
    if R:getResult() == RREST.Success then
        local m_Response_Action_14026  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_14026 = {}
            R:readBEGIN();
            local m_bossList =  {}
            m_Response_Action_14026.bossList = m_bossList
            local nNum_m_bossList = R:readINT();
            for index_m_bossList = 1, nNum_m_bossList do
                local item_m_bossList = {}
                R:readBEGIN();
                item_m_bossList.palyerNmae = R:readSTRING();
                item_m_bossList.attackTotal = R:readINT();
                item_m_bossList.palyerId = R:readINT64();
                R:readEND();
                CommonTable.push_back(m_bossList,item_m_bossList)
            end
            R:readEND();
            return m_Response_Action_14026
        end
    end
    return nil
end

--攻击军团BOSS
function M.GetData_14027()
    if R:getResult() == RREST.Success then
        local m_Response_Action_2001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_2001 = {}
            R:readBEGIN();
            local m_info  = nil
            if R:readINT() ~= 0 then 
                m_info = {}
                m_Response_Action_2001.info = m_info
                R:readBEGIN();
                local m_me  = nil
                if R:readINT() ~= 0 then 
                    m_me = {}
                    m_info.me = m_me
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_me.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_me.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_me.talent = R:readSTRING();
                    R:readEND();
                end
                local m_opp  = nil
                if R:readINT() ~= 0 then 
                    m_opp = {}
                    m_info.opp = m_opp
                    R:readBEGIN();
                    local m_hero  = nil
                    if R:readINT() ~= 0 then 
                        m_hero = {}
                        m_opp.hero = m_hero
                        R:readBEGIN();
                        m_hero.hp = R:readINT();
                        m_hero.lv = R:readINT();
                        m_hero.name = R:readSTRING();
                        m_hero.head = R:readSTRING();
                        m_hero.sex = R:readINT();
                        m_hero.equipEffect = R:readSTRING();
                        m_hero.equiplst = R:readSTRING();
                        R:readEND();
                    end
                    local m_cards =  {}
                    m_opp.cards = m_cards
                    local nNum_m_cards = R:readINT();
                    for index_m_cards = 1, nNum_m_cards do
                        local item_m_cards = {}
                        R:readBEGIN();
                        item_m_cards.id = R:readINT();
                        item_m_cards.lv = R:readINT();
                        item_m_cards.sn = R:readSTRING();
                        item_m_cards.evolv = R:readINT();
                        item_m_cards.ismain = R:readINT();
                        item_m_cards.addvalue = R:readSTRING();
                        R:readEND();
                        CommonTable.push_back(m_cards,item_m_cards)
                    end
                    m_opp.talent = R:readSTRING();
                    R:readEND();
                end
                R:readEND();
            end
            local m_fight =  {}
            m_Response_Action_2001.fight = m_fight
            local nNum_m_fight = R:readINT();
            for index_m_fight = 1, nNum_m_fight do
                local item_m_fight = {}
                R:readBEGIN();
                item_m_fight.round = R:readINT();
                item_m_fight.turn = R:readINT();
                local m_fme =  {}
                item_m_fight.fme = m_fme
                local nNum_m_fme = R:readINT();
                for index_m_fme = 1, nNum_m_fme do
                    local item_m_fme = {}
                    R:readBEGIN();
                    item_m_fme.sn = R:readSTRING();
                    item_m_fme.cd = R:readINT();
                    item_m_fme.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fme,item_m_fme)
                end
                local m_fopp =  {}
                item_m_fight.fopp = m_fopp
                local nNum_m_fopp = R:readINT();
                for index_m_fopp = 1, nNum_m_fopp do
                    local item_m_fopp = {}
                    R:readBEGIN();
                    item_m_fopp.sn = R:readSTRING();
                    item_m_fopp.cd = R:readINT();
                    item_m_fopp.po = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_fopp,item_m_fopp)
                end
                local m_actions =  {}
                item_m_fight.actions = m_actions
                local nNum_m_actions = R:readINT();
                for index_m_actions = 1, nNum_m_actions do
                    local item_m_actions = {}
                    R:readBEGIN();
                    item_m_actions.sn = R:readSTRING();
                    item_m_actions.actid = R:readINT();
                    item_m_actions.varhp = R:readINT();
                    item_m_actions.varatk = R:readINT();
                    item_m_actions.curhp = R:readINT();
                    item_m_actions.curatk = R:readINT();
                    item_m_actions.po = R:readINT();
                    item_m_actions.syn = R:readINT();
                    item_m_actions.nb = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_actions,item_m_actions)
                end
                R:readEND();
                CommonTable.push_back(m_fight,item_m_fight)
            end
            local m_result  = nil
            if R:readINT() ~= 0 then 
                m_result = {}
                m_Response_Action_2001.result = m_result
                R:readBEGIN();
                m_result.res = R:readINT();
                m_result.diamond = R:readINT();
                m_result.gold = R:readINT();
                m_result.exp = R:readINT();
                m_result.fp = R:readINT();
                m_result.star = R:readINT();
                m_result.jjcScore = R:readINT();
                m_result.rank = R:readINT();
                m_result.rankvar = R:readINT();
                local m_brlist =  {}
                m_result.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                local m_levels =  {}
                m_result.levels = m_levels
                local nNum_m_levels = R:readINT();
                for index_m_levels = 1, nNum_m_levels do
                    local item_m_levels = {}
                    R:readBEGIN();
                    item_m_levels.sn = R:readINT();
                    item_m_levels.subsn = R:readINT();
                    item_m_levels.star = R:readINT();
                    R:readEND();
                    CommonTable.push_back(m_levels,item_m_levels)
                end
                m_result.flag = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_2001
        end
    end
    return nil
end

--任务成就 20001
function M.GetData_20001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_20001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_20001 = {}
            R:readBEGIN();
            local m_tasks =  {}
            m_Response_Action_20001.tasks = m_tasks
            local nNum_m_tasks = R:readINT();
            for index_m_tasks = 1, nNum_m_tasks do
                local item_m_tasks = {}
                R:readBEGIN();
                item_m_tasks.no = R:readINT();
                item_m_tasks.typ = R:readINT();
                item_m_tasks.pic = R:readSTRING();
                item_m_tasks.pno = R:readINT();
                item_m_tasks.title = R:readSTRING();
                item_m_tasks.desc = R:readSTRING();
                item_m_tasks.memo = R:readSTRING();
                item_m_tasks.status = R:readINT();
                item_m_tasks.target = R:readSTRING();
                item_m_tasks.time = R:readINT();
                local m_reward  = nil
                if R:readINT() ~= 0 then 
                    m_reward = {}
                    item_m_tasks.reward = m_reward
                    R:readBEGIN();
                    m_reward.diamond = R:readINT();
                    m_reward.gold = R:readINT64();
                    m_reward.exp = R:readINT();
                    m_reward.fp = R:readINT();
                    m_reward.star = R:readINT();
                    local m_brlist =  {}
                    m_reward.brlist = m_brlist
                    local nNum_m_brlist = R:readINT();
                    for index_m_brlist = 1, nNum_m_brlist do
                        local item_m_brlist = {}
                        R:readBEGIN();
                        item_m_brlist.no = R:readINT();
                        item_m_brlist.count = R:readINT();
                        item_m_brlist.typ = R:readINT();
                        item_m_brlist.styp = R:readINT();
                        item_m_brlist.price = R:readINT64();
                        item_m_brlist.quality = R:readINT();
                        item_m_brlist.usetype = R:readINT();
                        item_m_brlist.cansell = R:readINT();
                        item_m_brlist.sex = R:readINT();
                        item_m_brlist.needlv = R:readINT();
                        item_m_brlist.strlv = R:readINT();
                        item_m_brlist.evolv = R:readINT();
                        item_m_brlist.part = R:readINT();
                        local m_pros =  {}
                        item_m_brlist.pros = m_pros
                        local nNum_m_pros = R:readINT();
                        for index_m_pros = 1, nNum_m_pros do
                            local item_m_pros = {}
                            R:readBEGIN();
                            item_m_pros.typ = R:readINT();
                            item_m_pros.camp = R:readINT();
                            item_m_pros.value = R:readSTRING();
                            item_m_pros.isact = R:readINT();
                            item_m_pros.setid = R:readINT();
                            item_m_pros.initval = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_pros,item_m_pros)
                        end
                        local m_skills =  {}
                        item_m_brlist.skills = m_skills
                        local nNum_m_skills = R:readINT();
                        for index_m_skills = 1, nNum_m_skills do
                            local item_m_skills = {}
                            R:readBEGIN();
                            item_m_skills.id = R:readINT();
                            item_m_skills.lv = R:readINT();
                            item_m_skills.isact = R:readINT();
                            item_m_skills.setid = R:readINT();
                            item_m_skills.value = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_skills,item_m_skills)
                        end
                        item_m_brlist.ext = R:readSTRING();
                        item_m_brlist.name = R:readSTRING();
                        item_m_brlist.memo = R:readSTRING();
                        item_m_brlist.add = R:readINT();
                        item_m_brlist.setid = R:readINT();
                        item_m_brlist.eqid = R:readINT64();
                        item_m_brlist.pic = R:readSTRING();
                        item_m_brlist.isOn = R:readINT();
                        local m_setids =  {}
                        item_m_brlist.setids = m_setids
                        local nNum_m_setids = R:readINT();
                        for index_m_setids = 1, nNum_m_setids do
                            local item_m_setids = {}
                            R:readBEGIN();
                            item_m_setids.setid = R:readINT();
                            item_m_setids.ison = R:readINT();
                            R:readEND();
                            CommonTable.push_back(m_setids,item_m_setids)
                        end
                        R:readEND();
                        CommonTable.push_back(m_brlist,item_m_brlist)
                    end
                    R:readEND();
                end
                item_m_tasks.showreward = R:readINT();
                R:readEND();
                CommonTable.push_back(m_tasks,item_m_tasks)
            end
            R:readEND();
            return m_Response_Action_20001
        end
    end
    return nil
end
--
function M.GetData_20002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_20002  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_20002 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_20002.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_20002
        end
    end
    return nil
end
--邮件系统列表
function M.GetData_86000()
    if R:getResult() == RREST.Success then
        local m_Response_Action_86000  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_86000 = {}
            R:readBEGIN();
            local m_mcontent =  {}
            m_Response_Action_86000.mcontent = m_mcontent
            local nNum_m_mcontent = R:readINT();
            for index_m_mcontent = 1, nNum_m_mcontent do
                local item_m_mcontent = {}
                R:readBEGIN();
                item_m_mcontent.mtyp = R:readINT();
                item_m_mcontent.mid = R:readINT64();
                item_m_mcontent.sendername = R:readSTRING();
                item_m_mcontent.sendtime = R:readSTRING();
                item_m_mcontent.title = R:readSTRING();
                item_m_mcontent.state = R:readINT();
                local m_detailed =  {}
                item_m_mcontent.detailed = m_detailed
                local nNum_m_detailed = R:readINT();
                for index_m_detailed = 1, nNum_m_detailed do
                    local item_m_detailed = {}
                    R:readBEGIN();
                    item_m_detailed.content = R:readSTRING();
                    local m_reward  = nil
                    if R:readINT() ~= 0 then 
                        m_reward = {}
                        item_m_detailed.reward = m_reward
                        R:readBEGIN();
                        m_reward.diamond = R:readINT();
                        m_reward.gold = R:readINT64();
                        m_reward.exp = R:readINT();
                        m_reward.fp = R:readINT();
                        m_reward.star = R:readINT();
                        local m_brlist =  {}
                        m_reward.brlist = m_brlist
                        local nNum_m_brlist = R:readINT();
                        for index_m_brlist = 1, nNum_m_brlist do
                            local item_m_brlist = {}
                            R:readBEGIN();
                            item_m_brlist.no = R:readINT();
                            item_m_brlist.count = R:readINT();
                            item_m_brlist.typ = R:readINT();
                            item_m_brlist.styp = R:readINT();
                            item_m_brlist.price = R:readINT64();
                            item_m_brlist.quality = R:readINT();
                            item_m_brlist.usetype = R:readINT();
                            item_m_brlist.cansell = R:readINT();
                            item_m_brlist.sex = R:readINT();
                            item_m_brlist.needlv = R:readINT();
                            item_m_brlist.strlv = R:readINT();
                            item_m_brlist.evolv = R:readINT();
                            item_m_brlist.part = R:readINT();
                            local m_pros =  {}
                            item_m_brlist.pros = m_pros
                            local nNum_m_pros = R:readINT();
                            for index_m_pros = 1, nNum_m_pros do
                                local item_m_pros = {}
                                R:readBEGIN();
                                item_m_pros.typ = R:readINT();
                                item_m_pros.camp = R:readINT();
                                item_m_pros.value = R:readSTRING();
                                item_m_pros.isact = R:readINT();
                                item_m_pros.setid = R:readINT();
                                item_m_pros.initval = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_pros,item_m_pros)
                            end
                            local m_skills =  {}
                            item_m_brlist.skills = m_skills
                            local nNum_m_skills = R:readINT();
                            for index_m_skills = 1, nNum_m_skills do
                                local item_m_skills = {}
                                R:readBEGIN();
                                item_m_skills.id = R:readINT();
                                item_m_skills.lv = R:readINT();
                                item_m_skills.isact = R:readINT();
                                item_m_skills.setid = R:readINT();
                                item_m_skills.value = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_skills,item_m_skills)
                            end
                            item_m_brlist.ext = R:readSTRING();
                            item_m_brlist.name = R:readSTRING();
                            item_m_brlist.memo = R:readSTRING();
                            item_m_brlist.add = R:readINT();
                            item_m_brlist.setid = R:readINT();
                            item_m_brlist.eqid = R:readINT64();
                            item_m_brlist.pic = R:readSTRING();
                            item_m_brlist.isOn = R:readINT();
                            local m_setids =  {}
                            item_m_brlist.setids = m_setids
                            local nNum_m_setids = R:readINT();
                            for index_m_setids = 1, nNum_m_setids do
                                local item_m_setids = {}
                                R:readBEGIN();
                                item_m_setids.setid = R:readINT();
                                item_m_setids.ison = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_setids,item_m_setids)
                            end
                            R:readEND();
                            CommonTable.push_back(m_brlist,item_m_brlist)
                        end
                        R:readEND();
                    end
                    item_m_detailed.state = R:readINT();
                    item_m_detailed.sendid = R:readINT64();
                    R:readEND();
                    CommonTable.push_back(m_detailed,item_m_detailed)
                end
                item_m_mcontent.head = R:readSTRING();
                item_m_mcontent.sex = R:readINT();
                item_m_mcontent.equiplst = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_mcontent,item_m_mcontent)
            end
            R:readEND();
            return m_Response_Action_86000
        end
    end
    return nil
end

--
function M.GetData_86001()
    if R:getResult() == RREST.Success then
        local m_Response_Action_86001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_86001 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_86001.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                m_reward.sp = R:readINT();
                m_reward.apoint = R:readINT();
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_86001
        end
    end
    return nil
end


--
function M.GetData_86002()
    if R:getResult() == RREST.Success then
        local m_Response_Action_86001  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_86001 = {}
            R:readBEGIN();
            local m_reward  = nil
            if R:readINT() ~= 0 then 
                m_reward = {}
                m_Response_Action_86001.reward = m_reward
                R:readBEGIN();
                m_reward.diamond = R:readINT();
                m_reward.gold = R:readINT64();
                m_reward.exp = R:readINT();
                m_reward.fp = R:readINT();
                m_reward.star = R:readINT();
                local m_brlist =  {}
                m_reward.brlist = m_brlist
                local nNum_m_brlist = R:readINT();
                for index_m_brlist = 1, nNum_m_brlist do
                    local item_m_brlist = {}
                    R:readBEGIN();
                    item_m_brlist.no = R:readINT();
                    item_m_brlist.count = R:readINT();
                    item_m_brlist.typ = R:readINT();
                    item_m_brlist.styp = R:readINT();
                    item_m_brlist.price = R:readINT64();
                    item_m_brlist.quality = R:readINT();
                    item_m_brlist.usetype = R:readINT();
                    item_m_brlist.cansell = R:readINT();
                    item_m_brlist.sex = R:readINT();
                    item_m_brlist.needlv = R:readINT();
                    item_m_brlist.strlv = R:readINT();
                    item_m_brlist.evolv = R:readINT();
                    item_m_brlist.part = R:readINT();
                    local m_pros =  {}
                    item_m_brlist.pros = m_pros
                    local nNum_m_pros = R:readINT();
                    for index_m_pros = 1, nNum_m_pros do
                        local item_m_pros = {}
                        R:readBEGIN();
                        item_m_pros.typ = R:readINT();
                        item_m_pros.camp = R:readINT();
                        item_m_pros.value = R:readSTRING();
                        item_m_pros.isact = R:readINT();
                        item_m_pros.setid = R:readINT();
                        item_m_pros.initval = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_pros,item_m_pros)
                    end
                    local m_skills =  {}
                    item_m_brlist.skills = m_skills
                    local nNum_m_skills = R:readINT();
                    for index_m_skills = 1, nNum_m_skills do
                        local item_m_skills = {}
                        R:readBEGIN();
                        item_m_skills.id = R:readINT();
                        item_m_skills.lv = R:readINT();
                        item_m_skills.isact = R:readINT();
                        item_m_skills.setid = R:readINT();
                        item_m_skills.value = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_skills,item_m_skills)
                    end
                    item_m_brlist.ext = R:readSTRING();
                    item_m_brlist.name = R:readSTRING();
                    item_m_brlist.memo = R:readSTRING();
                    item_m_brlist.add = R:readINT();
                    item_m_brlist.setid = R:readINT();
                    item_m_brlist.eqid = R:readINT64();
                    item_m_brlist.pic = R:readSTRING();
                    item_m_brlist.isOn = R:readINT();
                    local m_setids =  {}
                    item_m_brlist.setids = m_setids
                    local nNum_m_setids = R:readINT();
                    for index_m_setids = 1, nNum_m_setids do
                        local item_m_setids = {}
                        R:readBEGIN();
                        item_m_setids.setid = R:readINT();
                        item_m_setids.ison = R:readINT();
                        R:readEND();
                        CommonTable.push_back(m_setids,item_m_setids)
                    end
                    R:readEND();
                    CommonTable.push_back(m_brlist,item_m_brlist)
                end
                R:readEND();
            end
            R:readEND();
            return m_Response_Action_86001
        end
    end
    return nil
end

--
function M.GetData_86003()
    if R:getResult() == RREST.Success then
        local m_Response_Action_86000  = nil
        if R:readINT() ~= 0 then 
            m_Response_Action_86000 = {}
            R:readBEGIN();
            local m_mcontent =  {}
            m_Response_Action_86000.mcontent = m_mcontent
            local nNum_m_mcontent = R:readINT();
            for index_m_mcontent = 1, nNum_m_mcontent do
                local item_m_mcontent = {}
                R:readBEGIN();
                item_m_mcontent.mtyp = R:readINT();
                item_m_mcontent.mid = R:readINT64();
                item_m_mcontent.sendername = R:readSTRING();
                item_m_mcontent.sendtime = R:readSTRING();
                item_m_mcontent.title = R:readSTRING();
                item_m_mcontent.state = R:readINT();
                local m_detailed =  {}
                item_m_mcontent.detailed = m_detailed
                local nNum_m_detailed = R:readINT();
                for index_m_detailed = 1, nNum_m_detailed do
                    local item_m_detailed = {}
                    R:readBEGIN();
                    item_m_detailed.content = R:readSTRING();
                    local m_reward  = nil
                    if R:readINT() ~= 0 then 
                        m_reward = {}
                        item_m_detailed.reward = m_reward
                        R:readBEGIN();
                        m_reward.diamond = R:readINT();
                        m_reward.gold = R:readINT64();
                        m_reward.exp = R:readINT();
                        m_reward.fp = R:readINT();
                        m_reward.star = R:readINT();
                        local m_brlist =  {}
                        m_reward.brlist = m_brlist
                        local nNum_m_brlist = R:readINT();
                        for index_m_brlist = 1, nNum_m_brlist do
                            local item_m_brlist = {}
                            R:readBEGIN();
                            item_m_brlist.no = R:readINT();
                            item_m_brlist.count = R:readINT();
                            item_m_brlist.typ = R:readINT();
                            item_m_brlist.styp = R:readINT();
                            item_m_brlist.price = R:readINT64();
                            item_m_brlist.quality = R:readINT();
                            item_m_brlist.usetype = R:readINT();
                            item_m_brlist.cansell = R:readINT();
                            item_m_brlist.sex = R:readINT();
                            item_m_brlist.needlv = R:readINT();
                            item_m_brlist.strlv = R:readINT();
                            item_m_brlist.evolv = R:readINT();
                            item_m_brlist.part = R:readINT();
                            local m_pros =  {}
                            item_m_brlist.pros = m_pros
                            local nNum_m_pros = R:readINT();
                            for index_m_pros = 1, nNum_m_pros do
                                local item_m_pros = {}
                                R:readBEGIN();
                                item_m_pros.typ = R:readINT();
                                item_m_pros.camp = R:readINT();
                                item_m_pros.value = R:readSTRING();
                                item_m_pros.isact = R:readINT();
                                item_m_pros.setid = R:readINT();
                                item_m_pros.initval = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_pros,item_m_pros)
                            end
                            local m_skills =  {}
                            item_m_brlist.skills = m_skills
                            local nNum_m_skills = R:readINT();
                            for index_m_skills = 1, nNum_m_skills do
                                local item_m_skills = {}
                                R:readBEGIN();
                                item_m_skills.id = R:readINT();
                                item_m_skills.lv = R:readINT();
                                item_m_skills.isact = R:readINT();
                                item_m_skills.setid = R:readINT();
                                item_m_skills.value = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_skills,item_m_skills)
                            end
                            item_m_brlist.ext = R:readSTRING();
                            item_m_brlist.name = R:readSTRING();
                            item_m_brlist.memo = R:readSTRING();
                            item_m_brlist.add = R:readINT();
                            item_m_brlist.setid = R:readINT();
                            item_m_brlist.eqid = R:readINT64();
                            item_m_brlist.pic = R:readSTRING();
                            item_m_brlist.isOn = R:readINT();
                            local m_setids =  {}
                            item_m_brlist.setids = m_setids
                            local nNum_m_setids = R:readINT();
                            for index_m_setids = 1, nNum_m_setids do
                                local item_m_setids = {}
                                R:readBEGIN();
                                item_m_setids.setid = R:readINT();
                                item_m_setids.ison = R:readINT();
                                R:readEND();
                                CommonTable.push_back(m_setids,item_m_setids)
                            end
                            R:readEND();
                            CommonTable.push_back(m_brlist,item_m_brlist)
                        end
                        R:readEND();
                    end
                    item_m_detailed.state = R:readINT();
                    item_m_detailed.sendid = R:readINT64();
                    R:readEND();
                    CommonTable.push_back(m_detailed,item_m_detailed)
                end
                item_m_mcontent.head = R:readSTRING();
                item_m_mcontent.sex = R:readINT();
                item_m_mcontent.equiplst = R:readSTRING();
                R:readEND();
                CommonTable.push_back(m_mcontent,item_m_mcontent)
            end
            R:readEND();
            return m_Response_Action_86000
        end
    end
    return nil
end
return M
