local M = {}

M.MODE_DIALOG = 1 
M.MODE_COVER = 2 
M.MODE_HINT = 3 
M.MODE_TRIGGERMSG = 4

M.PATH_IMG_PRE = "help/"
M.IMG_HAND = M.PATH_IMG_PRE .. "h_hand.png"
M.IMG_HAND_DOWN = M.PATH_IMG_PRE .. "h_dialog_d.png"
M.IMG_HAND_LEFT = M.PATH_IMG_PRE .. "h_dialog_l.png"
M.IMG_HAND_CENTER = M.PATH_IMG_PRE .. "h_dialog_c.png"
M.IMG_DIALOG_BG = M.PATH_IMG_PRE .. "h_dialog_bg.png"
M.IMG_DIALOG_ASIDE_BG = M.PATH_IMG_PRE .. "h_dialog_bg.png"

M.HAND_DIRECTION_UP = 1
M.HAND_DIRECTION_DOWN = 2
M.HAND_DIRECTION_LEFT = 3
M.HAND_DIRECTION_RIGHT = 4
M.HAND_DIRECTION_CENTER = 5

M.TIME_DEFAULT_AUTO_NEXT_TIME = 2.0

M.reset = function ()
	M.ROLE = {
		-- 玩家
		PLAYER = {
			NAME =  ME:getName() or _s("HELPER_INFO_KNIGHT"),
			IMG = M.PATH_IMG_PRE .. (ME:getSex() == MALE and "h_role_hero_male.png" or "h_role_hero_female.png"),
			HONOUR = ME:getSex() == MALE and _s("HELPER_INFO_ROLE_PLAYER_HONOUR_MALE") or _s("HELPER_INFO_ROLE_PLAYER_HONOUR_FEMALE"),
			HEAD  = M.PATH_IMG_PRE .. (ME:getSex() == MALE and "h_head_hero_male.png" or "h_head_hero_female.png"),
		},
		-- 女仆 薇儿 
		MAID = {
			NAME = _s("HELPER_INFO_ROLE_MAID"),
			IMG = M.PATH_IMG_PRE .. "h_role_maid.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_maid.png",
		},
		-- 维卡大叔
		UNCLE = {
			NAME = _s("HELPER_INFO_ROLE_UNCLE"),
			IMG = M.PATH_IMG_PRE .. "h_role_uncle.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_uncle.png",
		},
		-- 好基友 利亚姆
		FRIEND = {
			NAME = _s("HELPER_INFO_ROLE_FRIEND"),
			IMG = M.PATH_IMG_PRE .. "h_role_guy.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_guy.png",
		},
		-- 魔族杀手
		KILLER = {
			NAME = _s("HELPER_INFO_ROLE_KILLER"),
			IMG = M.PATH_IMG_PRE .. "h_role_orc_green.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_orc_green.png",
		},
		-- 魔族拦截者
		ENEMIES = {
			NAME = _s("HELPER_INFO_ROLE_ENEMIES"),
			IMG = M.PATH_IMG_PRE .. "h_role_orc_blue.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_orc_blue.png",
		},
		-- 人类士兵
		HUMAN_SOLDIER = {
			NAME = _s("HELPER_INFO_ROLE_HUMAN_SOLDIER"),
			IMG = M.PATH_IMG_PRE .. "h_role_soldier.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_soldier.png",
		},
		-- 人类领主 卡洛领主
		LORD_K = {
			NAME = _s("HELPER_INFO_ROLE_LORD_K"),
			IMG = M.PATH_IMG_PRE .. "h_role_lord_k.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_lord_k.png",
		},
		-- 人类领主 斯旺领主
		LORD_S = {
			NAME = _s("HELPER_INFO_ROLE_LORD_S"),
			IMG = M.PATH_IMG_PRE .. "h_role_lord_s.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_lord_s.png",
		},
		-- 伪装刺客
		SECRET_ASSASSIN = {
			NAME = _s("HELPER_INFO_ROLE_SECRET_ASSASSIN"),
			IMG = M.PATH_IMG_PRE .. "h_role_assassin.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_assassin.png",
		},
		-- 猛兽 野猪
		WILD_BOAR = {
			NAME = _s("HELPER_INFO_ROLE_WILD_BOAR"),
			IMG = M.PATH_IMG_PRE .. "h_role_wild_boar.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_wild_boar.png",
		},
		-- 猛兽 魔兽
		DEMON_MONSTER = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_MONSTER"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_monster.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_monster.png",
		},
		-- 术士灵魂
		WARLOCK_SOUL = {
			NAME = _s("HELPER_INFO_ROLE_WARLOCK_SOUL"),
			IMG = M.PATH_IMG_PRE .. "h_role_warlock_soul.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_warlock_soul.png",
		},
		-- 圣灵虚影
		GOD_SPIRIT = {
			NAME = _s("HELPER_INFO_ROLE_GOD_SPIRIT"),
			IMG = M.PATH_IMG_PRE .. "h_role_god_spirit.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_god_spirit.png",
		},
		-- 魔族成员 【四魔将】莫卡
		DEMON_GENERAL_M = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_GENERAL_M"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_general_m.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_general_m.png",
		},
		-- 魔族成员 【四魔将】朱旺
		DEMON_GENERAL_Z = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_GENERAL_Z"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_general_z.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_general_z.png",
		},
		-- 魔族成员 【四魔将】毕卡斯
		DEMON_GENERAL_B = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_GENERAL_B"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_general_b.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_general_b.png",
		},
		-- 魔族成员 【四魔将】斯齐亚
		DEMON_GENERAL_S = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_GENERAL_S"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_general_s.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_general_s.png",
		},
		-- 魔族成员 魔君
		DEMON_KING = {
			NAME = _s("HELPER_INFO_ROLE_DEMON_KING"),
			IMG = M.PATH_IMG_PRE .. "h_role_demon_king.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_demon_king.png",
		},
		-- 神魔人
		SECRET_MYSTICAL = {
			NAME = _s("HELPER_INFO_ROLE_MYSTICAL"),
			IMG = M.PATH_IMG_PRE .. "h_role_assassin.png",
			HEAD  = M.PATH_IMG_PRE .. "h_head_assassin.png",
		},
	}
end

M.reset()

M.infos = {
	--[[
		括号内为可选值,[]表示默认值,每个都带有index,以10为单位累加,方便日后追加东东,具体如下:
		1.mode: ([M.MODE_DIALOG] | M.MODE_COVER | M.MODE_HINT ) 
		-- dialog 时显示对话框
			2.left: string 左边显示的图片名
			3.right: string 右边显示的图片名
			4.flip: (true|[false]) 是否翻转
			5.text: string 显示的文字
			6.hint : table
				7.cover: (true | [false])  是否用灰色遮罩
				8-11.x, y, w, h : float 可点击的区域
				12.hand: enum(M.HAND_DIRECTION_) 指示用手的方向
				13.text: string 显示的文字
				14.anim: ([true]|false) 是否启用动画,默认是为true啊
				15.anim_move_time: int 播放一个方向移动的时间,单位s,默认为0.5
				16.anim_move_desdance: int 播放一个方向移动的距离,默认为10
		-- cover 时显示的是只可以点击的
			17-20.x, y, w, h : float 可点击的区域
			21.hand: enum(M.HAND_DIRECTION_) 指示用手的方向
			22.text: string 显示的文字
			23.anim: ([true]|false) 是否启用动画,默认是为true啊
			24.anim_move_time: int 播放一个方向移动的时间,单位s,默认为0.5
			25.anim_move_desdance: int 播放一个方向移动的距离,默认为10
		-- hint 时显示简要的提示信息
			参数同cover
		26.nextIndex: int 下一个动作
		27.stop: (true|[false]) 是否停止此次动作,不用这个可停不下来
		28.delay: float 延迟调用秒数
		29.update: (true|[false]) 是否更新记录,即保存下一步的index到本地文件及服务器中,
		30.autoNext: (true|[false]) 是否自动切换下一步
		31.autoNextTime: float 自动切换时间,默认为参看M.TIME_DEFAULT_AUTO_NEXT_TIME
		32.swallowsTouches: (true|[false]) 设置是否点击吞噬
		33.allClickable:(true|[false]) 是否全界面可点击触发
		34.enable: ([true]|false) 设置引导机制的可用性,在一块功能结束后就要考虑设置为false
	--]]

-- [====================[序引导]====================]
-- ==================== 第一阶段 BEGIN ====================
	-- [[首页 MainNewLayer BEGIN]]
	[10] = { -- 维卡大叔（凝重）	薇儿，你先带着皇子殿下从暗门撤离！我解决了这批杀手就去和你们汇合！
		left = M.ROLE.UNCLE,
		right = M.ROLE.MAID,
		text = _s("HELPER_INFO_000010", M.ROLE.PLAYER.HONOUR),
		speaker = M.ROLE.UNCLE,
	},
	[20] = { -- 薇儿（担心）	可是。。。大叔您一个人！？
		left = M.ROLE.UNCLE,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[30] = { -- 维卡大叔（凝重）	别可是了，王室最后的血脉和这颗神铁一定要保住！快走！
		left = M.ROLE.UNCLE,
		right = M.ROLE.MAID,
		speaker = M.ROLE.UNCLE,
	},
	[40] = { -- 魔君（鄙夷）	哼！不知死活！我倒要看看王国首席禁卫长有什么能耐！
		left = M.ROLE.UNCLE,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
		stop = true,
	},
	-- [[首页 MainNewLayer END]]

	-- [[由主界面直接切换战斗界面 FightScene BEGIN]]
	-- [2, 1前](双方卡牌上阵,大叔小演讲下) 
	[50] = { -- 维卡大叔	殒身不恤！誓荡魔军！我忠诚的卫队，让他们见识下“王国铁壁”的威严！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		autoNext = true,
		stop = true,
	},
	-- [3, 1前](大叔轮完了,魔君小鸟他) 
	[60] = { -- 维卡方卡牌行动结束，魔君开始说话： 哼！蝼蚁之辈！感受死亡的恐惧吧！
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
		autoNext = true,
		stop = true,
	},
	-- [5, 21后](战斗结束，维卡战败时,点击后直接回到首页)
	[70] = { -- 维卡大叔（重伤）	这就是魔君的力量么。。。拖延了这么久，希望薇儿他们平安无事。殿下！您一定要复原圣剑，重振帝国啊！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		autoNext = true,
		stop = true,
		nextIndex = 300,
		update = 11, -- step = 1
	},
	--[===[
	-- [4, 2后](双方抽牌至第4回合,魔族杀手卡牌上场) 
	[50] = { -- 维卡大叔（凝重）	可恶！他的卡牌上场CD短，被抢先一步！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		hint = { -- 注释信息	【卡牌上场CD：显示于卡牌左下角，每回合减1，为0时卡牌可入场】
			text = _s("HELPER_INFO_000050_HINT"),
			hand = M.HAND_DIRECTION_CENTER,
			anim = false,
		},
	},
	[60] = { -- 魔族杀手（奸笑）	先下手为强！我上场卡牌的对位没卡牌，可以直接攻击老家伙！
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
		stop = true,
	},
	-- [5, 1前, 定点70](第5回合，维卡卡牌可上场, 点击可上场卡牌)
	[70] = { -- 注释信息	【可上场卡牌的边框会有醒目特效】
		mode = M.MODE_COVER, 
		x = 190, y = 0, 
		w = 130, h = 100, 
		hand = M.HAND_DIRECTION_UP, 
		text = _s("HELPER_INFO_000070"),
	},
	-- -- [5, 1后, 定点80](维卡卡牌上场后)
	[80] = { -- 维卡大叔（从容）	对付你这种杂鱼，拥有【格挡】技能的豺狼守卫已绰绰有余。况且豺狼守卫还是2星卡牌，实力优于你的1星骷髅！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		nextIndex = 81,
	},
	[81] ={ -- 点击开始战斗
        mode = M.MODE_COVER, 
		x = 845, y = 185, 
		w = 91, h = 90, 
		hand = M.HAND_DIRECTION_LEFT, 
		stop = true,
	},
	-- [6, 7前](第6回合，魔族杀手卡牌上场)
	[90] = { -- 魔族杀手（奸笑）	天下武功，唯快不破！上场快才能以多欺少，尝尝【火球】术的厉害！看你还怎么格挡！
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
		stop = true,
		-- nextIndex = 170, --------------------
	},
	-- [7?点击上场前](第7回合，维卡准备回合)
	[100] = { -- 维卡大叔（从容）	欲速则不达！选好时机上场压制才是王道！看我的狮鹫骑士！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
	},
	-- (点击可上场卡牌)
	[110] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 190, y = 0,
		w = 130, h = 100,
	},
	-- [7?点击上场后](第7回合，维卡卡牌上场)
	[120] = { -- 维卡大叔（从容）	狮鹫骑士拥有【魔法盾】，可不怕你那些【火球】，玩压制，你还太嫩了点！受死吧！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.UNCLE,
		nextIndex = 121,
	},
	[121] ={ -- 点击开始战斗
        mode = M.MODE_COVER, 
		x = 845, y = 185, 
		w = 91, h = 90, 
		hand = M.HAND_DIRECTION_LEFT, 
		stop = true,
		-- nextIndex = 170, --------------------
	},
	-- [9?操作前](第9回合，维卡卡牌可上场)
	[130] = { -- 维卡大叔（凝重）	（心想）圣战天使，终于等到你了，该结束了。嗯？！慢着，是亡灵族的杀戮者！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		nextIndex = 150,
	},
	-- (点击杀戮者卡牌,弹开详情)
	[140] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 100, y = 540,
		w = 130, h = 100,
		stop = true,
	},
	-- (中间小穿插下,到CardDetailLayer去下, 这步点击后要关闭详情哈)
	[150] = { -- 维卡大叔（凝重）	不行！如果圣战天使先上场，碰上【毁灭】技能就糟了！先按兵不动，暂避其锋！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
	},
	-- (点击开始战斗)
	[160] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_LEFT,
		x = 845, y = 185,
		w = 91, h = 90,
		stop = true,
		nextIndex = 161,
	},
	-- [11?操作前]第11回合，维卡卡牌可上场
	[161] = { -- 维卡大叔（凝重）	无	再坚持一轮！只要杀戮者上场，我的圣战天使就没后顾之忧了。
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		nextIndex = 165,
	},
	[165] = { -- 点击开始战斗
        mode = M.MODE_COVER, 
		x = 845, y = 185, 
		w = 91, h = 90, 
		hand = M.HAND_DIRECTION_LEFT, 
		stop = true,
	},
	-- [12, 6前](第12回合，杀戮者上场，发动毁灭技能)
	[170] = { -- 魔族杀手（狂妄）	哇哈哈！老家伙，见识到我杀戮者的厉害了吧，这就是【毁灭】的威力！吃屎吧你！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
		stop = true,
		-- nextIndex = 210, -------------
	},
	-- [13?点击上场前](第13回合，维卡卡牌可上场)
	[180] = { -- 维卡大叔（怒吼）	圣光庇护，荣耀永存！圣战天使！让他们见识下5星卡牌的威力！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.UNCLE,
	},
	-- (点击可上场卡牌)
	[190] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 190, y = 0,
		w = 130, h = 100,
	},
	-- [13?点击上场后](第13回合，圣战天使上场)
	[200] = { -- 维卡大叔（怒吼）	【圣光】耀世！当攻击对象是亡灵种族时可大幅提高攻击力，让你看看联盟的力量！一击必杀！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.UNCLE,
		nextIndex = 201,
	},
	[201] = { -- 点击开始战斗
        mode = M.MODE_COVER, 
		x = 845, y = 185, 
		w = 91, h = 90, 
		hand = M.HAND_DIRECTION_LEFT, 
		stop = true,
	},
	-- [13, 7前](第13回合，杀戮者被秒后)
	[210] = { -- 维卡大叔（从容）	在联盟的【圣光】面前，亡灵只有死路一条！还有什么杂碎，赶快出来一并受死吧！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		stop = true,
	},
	-- [14, 1前](第14回合，拦截者准备回合)
	[220] = { -- 魔族杀手（鄙夷）	（心想）切！帝国首席禁卫果然不是省油的灯！幸好出发前魔君大人给了个杀手锏，哼哼！
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
		stop = true,
	},
	-- [14, 1后](第14回合，隐刃上场后)
	[230] = { -- 魔族杀手（狰狞）	（冷笑）不知死活！胆敢与魔君作对！死刑宣告——隐刃！下地狱吧，老家伙！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[240] = { -- 维卡大叔（凝重）	嗯？！从未见过的家伙。。。难道这就是魔君的力量？！
		left = M.ROLE.UNCLE,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.UNCLE,
		update = 11,
		stop = true,
	},
	-- [14, 10后](战斗结束，维卡战败时,点击后直接回到首页)
	[250] = { -- 维卡大叔（重伤）	唔。。。拖延了这么久，希望薇儿他们平安无事！殿下。。。您一定要把神铁复原成圣灵之剑！重振帝国啊！
		left = M.ROLE.UNCLE,
		speaker = M.ROLE.UNCLE,
		stop = true,
		nextIndex = 300,
	},
	--]===]
	-- [[由主界面直接切换战斗界面 FightScene END]]
-- ==================== 第一阶段 END ====================

-- ==================== 第二阶段 START ====================
	-- [[首页 MainNewLayer BEGIN]]
	[300] = { -- （旁白）	当恶魔之瞳开始闪光，王国铁壁将为之颤抖。圣灵之剑和他新的主人即将踏上一段未知的无尽之旅。。。
		-- text = _s("HELPER_INFO_000300"),
	},
	[310] = { -- 薇儿（高兴）	王子殿下，我们暂时安全了，不知道大叔这会安全了没。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_000310", M.ROLE.PLAYER.HONOUR),
		nextIndex = 350,
	},
	-- [320] = { -- 主角（杯具）	啊~~~！头好痛啊，刚才哪个家伙砸了我一板砖！？对了，维卡大叔呢？！记得刚才。。。
	-- 	left = M.ROLE.PLAYER,
	-- 	right = M.ROLE.MAID,
	-- 	speaker = M.ROLE.PLAYER,
	-- },
	-- [330] = { -- 薇儿（无奈）	（心想）刚才殿下死活不走，薇儿没办法才弄一板砖的。不知道大叔这会安全了没。
	-- 	left = M.ROLE.PLAYER,
	-- 	right = M.ROLE.MAID,
	-- 	speaker = M.ROLE.MAID,
	-- },
	-- [340] = { -- 拦截者（奸笑）	原来你们俩躲在这，乖乖把神铁交出来！免得和刚才那老家伙一样的下场！
	-- 	left = M.ROLE.PLAYER,
	-- 	right = M.ROLE.ENEMIES,
	-- 	speaker = M.ROLE.ENEMIES,
	-- },
	[350] = { -- 主角（咬牙切齿）	不好了，刚才手忙脚乱的，我的卡牌都丢光了>.<！
		left = M.ROLE.PLAYER,
		right = M.ROLE.ENEMIES,
		speaker = M.ROLE.PLAYER,
	},
	[360] = { -- 薇儿 殿下别慌，薇儿认识个黑市商人。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击界面上方的商店控件)
	[370] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 840, y = 550,
		w = 120, h = 90,
		stop = true,
		nextIndex = 371,
	},
	-- [[抽卡商店 ShopNewLayer BEGIN]] 
	[371] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_LEFT,
		x = 320, y = 130,
		w = 255, h = 340,
		stop = true,
		swallowsTouches = true,
	},
	-- (进入抽卡商店界面)
	[380] = { -- 薇儿（高兴）强力的卡牌需要靠钻石才能获取，不过当前情况紧急，薇儿只能卖点人情，先帮殿下获取些实用的普通卡牌了！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		-- hint = { -- 注释信息	【邀请好友助阵，在战斗结束后就能获得友情点；而抽卡礼券能在活动或是任务中获取哦】
		-- 	text = _s("HELPER_INFO_000380_HINT"),
		-- 	hand = M.HAND_DIRECTION_CENTER,
		-- 	anim = false,
		-- },
	},
	-- (点击钻石单抽)
	[390] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 72, y = 118, -- x = 354,
		w = 134, h = 50,
		stop = true,
	},
	-- (弹框确认) 注意啦,在这步会向服务端发出抽卡请求,同时会把新手引导的update 11自动执行一次(由服务端进行)
	[400] = {  -- step = 2
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 240, y = 202,
		w = 130, h = 45,
		stop = true,
	},
	-- [[抽卡商店 ShopNewLayer END]]

	-- [[商店抽卡 ShopNewCardView BEGIN]]

	-- (翻牌动画界面, 点击领取卡牌)
	[410] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 265, y = 22,
		w = 213, h = 58,
		stop = true,
	},
	-- [[商店抽卡 ShopNewCardView END]]

	-- [[商店 ShopNewLayer START]]
	-- (回到商店界面后)
	[420] = { -- 薇儿（高兴）	获取了新卡牌，要赶紧配置进卡组，否则卡牌就成了摆设哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击界面上方的卡组控件)
	[430] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 240, y = 550,
		w = 120, h = 90,
		stop = true,
	},
	-- [[抽卡商店 ShopNewLayer END]]

	-- [[卡组 CardGroupLayer START]]
	-- (进入卡牌界面)
	[440] = { -- 薇儿	殿下！左侧最大的卡槽用于设置主卡，其余的均为副卡。主卡可在好友助阵时参战！所以务必要把最强力的卡牌放在主卡位哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[450] = { -- 薇儿	另外，主卡和副卡的配置是互相独立的，那么让我们先来配置主卡吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击卡牌配置控件)
	[460] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 734, y = 135,
		w = 205, h = 51,
		swallowsTouches = true,
	},
	-- (点击主卡槽位)
	[470] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 280, y = 216,
		w = 212, h = 324,
		stop = true,
	},
	-- [[卡组 CardGroupLayer END]]

	-- [[卡组主卡牌配置 CardFilterLayer BEGIN]]
	-- (进入卡牌选择界面)
	[480] = { -- 薇儿	选择一张卡牌作为主卡吧，别忘了点击卡牌上方的【查看】按键还能了解卡牌的详细技能哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
	},
	-- [[卡组主卡牌配置 CardFilterLayer END]]

	-- [[卡组 CardGroupLayer START]]
	-- (返回卡组界面)
	[490] = { -- 薇儿（高兴）	简单吧！不过配置卡牌时要注意角色的召唤值（头像右侧）必须高于卡组内全部卡牌的总COST值（COST值显示于卡牌右上角）！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		nextIndex = 491,
	},
	[491] = { -- 薇儿（高兴）	一旦召唤值不足只有努力升级来提高了！接下来该配置副卡了。
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[500] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 508, y = 378,
		w = 106, h = 162,
		stop = true,
	},
	-- [[卡组 CardGroupLayer END]]

	-- [[卡组副卡牌配置 CardFilterLayer BEGIN]]
	-- (进入卡牌选择界面)
	[510] = { -- 薇儿	已配置的主卡是不会出现在副卡选择列表中的哦！同样的，选择一张卡牌后点击确定吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
	},
	-- [[卡组副卡牌配置 CardFilterLayer END]]

	-- [[卡组 CardGroupLayer START]]
	-- (返回卡组界面, 点击确定配置)
	[520] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 734, y = 135,
		w = 205, h = 51,
		swallowsTouches = true,
	},
	[530] = { -- 薇儿（义愤填膺）	好了！卡组配置完成了！现在该给那些坏蛋点颜色瞧瞧了！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击界面上方地下城控件)
	[540] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 120, y = 550,
		w = 120, h = 90,
		stop = true,
	},
	-- [[卡组 CardGroupLayer END]]

	-- [[地下城 MapContainerLayer BEGIN]]
	-- (点击片区一)
	[550] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 144, y = 130,
		w = 356, h = 380,
		stop = true,
		nextIndex = 555,
		swallowsTouches = true,
	},
	-- (进入片区一【翡翠草原】后, 点击关卡1.1)
	[555] = {
		mode = M.MODE_COVER, 
		x = 760, y = 430, 
		w = 85, h = 107, 
		hand = M.HAND_DIRECTION_RIGHT, 
		stop = true,
	}, 
	[560] = { -- 利亚姆	殿下！总算找到你了，我还以为你和维卡大叔都。。。
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[570] = { -- 主角（咬牙切齿）	看来大叔真的已经。。。！可恶，你们这群恶魔，绝不轻饶！
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
	},
	[580] = { -- 拦截者（奸笑）哼！小鬼，你以为你找个帮手，我就怕你了！正好买一送一，送你们一起上路！
		left = M.ROLE.ENEMIES,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.ENEMIES,
	},

	[590] = { -- 利亚姆	大言不惭！殿下小心！我来助阵！
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
		stop = true,
	},

	-- [[地下城 地图 难度选择 MapPopupDifficultyLayer BEGIN]]
	-- (弹出难度选择界面, 点击确定)
	[600] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 377, y = 4,
		w = 216, h = 62,
		stop = true,
	},
	-- [[地下城 地图 难度选择 MapPopupDifficultyLayer END]]

	-- [[地下城 地图 好友选择 MapPopupFriendLayer BEGIN]]
	-- (弹出好友助阵界面)
	[610] = { -- 薇儿	在“普通”和“英雄”难度可以选择一位好友，让他的主卡加入战斗哦！结交强力好友，善用他们的主卡说不定能扭转战局呢！现在赶紧选择利亚姆助阵
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (选择利亚姆)
	[620] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 235, y = 446,
		w = 492, h = 110,
		swallowsTouches = true,
	},
	-- (点击开始战斗)
	[630] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 375, y = 4,
		w = 216, h = 62,
		stop = true,
	},
	-- [[地下城 地图 好友选择 MapPopupFriendLayer END]]

	-- [[地下城 MapContainerLayer END]]

	-- [[战斗界面 FightScene BEGIN]]
	-- (进入战斗界面，主角先手，主角有卡牌可入场)
	[640] = { -- 薇儿	有利亚姆助阵，对付这些鱼腩就轻松多了！殿下试试自动战斗，以逸待劳吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击自动战斗) 注意啦,这里的update 11 交由服务端进行自动设置,yeah
	[650] = {  -- step = 3
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_LEFT,
		x = 845, y = 364,
		w = 91, h = 89,
		stop = true,
		nextIndex = 657,
		-- update = 11,
	},
	-- [[战斗界面 FightScene END]]
-- ==================== 第二阶段 END ====================

-- ==================== 第三阶段 START ====================
	-- (点击界面上方地下城控件)
	[655] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 120, y = 550,
		w = 120, h = 90,
		stop = true,
		nextIndex = 656,
	},
	-- (点击片区一)
	[656] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 144, y = 130,
		w = 356, h = 380,
		stop = true,
		nextIndex = 657,
		swallowsTouches = true,
	},
	-- (进入片区一【翡翠草原】后, 点击关卡1.2)
	[657] = {
		mode = M.MODE_COVER, 
		x = 498, y = 516, 
		w = 85, h = 107, 
		hand = M.HAND_DIRECTION_RIGHT, 
		stop = true,
		nextIndex = 700,
		-- enable = false,
		-- update = 11, -- step = 5
	}, 
	-- [[地下城 MapContainerLayer START]]
	-- (关卡1.1战斗胜利后，返回大地图, 无需进入片区一)
	[700] = { -- 主角（累趴）	呼！终于甩开那些杀手了，先找个地方避一晚，明早黎明时分我们摸出镇去。
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
	},
	[710] = { -- 利亚姆	事不宜迟，赶紧先找个安全的地方吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[720] = { -- 薇儿	可是殿下！这块破石头怎么看也不像是什么“圣灵之剑”啊？！为了它，牺牲了那么多人。。。
		left = M.ROLE.MAID,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.MAID,
	},
	[730] = { -- 主角	我听大叔说过，当初剑成之日却是城破之时，先父为保圣剑，不得已将其熔炼成一块铁石，以躲过魔君耳目，免遭毁坏。
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[740] = { -- 薇儿	那想必魔君十分忌惮这圣剑，要不派了这么多杀手，弄的小镇鸡犬不宁！还害死了大叔！
		left = M.ROLE.MAID,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.MAID,
	},
	[750] = { -- 主角	大叔的仇，迟早要魔君血债血偿！
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[760] = { -- （旁白）	暮色降临，喧哗尽褪。主人公一行静静等待着黎明的来临。勇士！准备好踏上征程了么？魔域战歌，圣光凯旋！
		-- text = _s("HELPER_INFO_000850"),
		-- stop = true,
		update = 11,  -- step = 4
		-- enable = false,
	},
	[770] = { -- 薇儿	殿下！序章完成了呢！哇，还有奖励可以领哟！赶快行动吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		nextIndex = 790,
		-- stop = true,
		-- enable = false,
		-- update = 11,
	},
	-- (点击界面上方地下城控件)
	[771] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 120, y = 550,
		w = 120, h = 90,
		stop = true,
		nextIndex = 772,
	},
	-- (点击片区一)
	[772] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 144, y = 130,
		w = 356, h = 380,
		stop = true,
		swallowsTouches = true,
	},
	
	-- (进入片区一【翡翠草原】后, 点击关卡1.2)
	[780] = {
		mode = M.MODE_COVER, 
		x = 498, y = 516, 
		w = 85, h = 107, 
		hand = M.HAND_DIRECTION_RIGHT, 
		stop = true,
		-- enable = false,
		-- update = 11, -- step = 5
	}, 
	[790] = { -- 薇儿	推图可是前期积攒实力的最佳途径哦！首张地图星数达到5星，薇儿还有新手成长大礼，殿下赶紧行动吧！（每通过一个关卡的难度，即可获得1颗星星奖励）
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		-- stop = true,
		-- enable = false,
		-- update = 11,
	},
	--===================关卡1.2begin
	[800] = {	-- 利亚姆  殿下！就要天亮了，趁现在离开小镇！
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.FRIEND,
	},
	[810] = {	-- 魔族杀手  你们这群小鬼，害我们找了一个通宵，想出镇？躺着出去吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
		stop = true,
	},
	-- [[地下城 地图 难度选择 MapPopupDifficultyLayer BEGIN]]
	-- (弹出难度选择界面, 点击确定)
	[820] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 377, y = 4,
		w = 216, h = 62,
		stop = true,
	},
	-- [[地下城 地图 难度选择 MapPopupDifficultyLayer END]]

	-- [[地下城 地图 好友选择 MapPopupFriendLayer BEGIN]]
	-- (选择利亚姆)
	[830] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 235, y = 446,
		w = 492, h = 110,
		swallowsTouches = true,
	},
	-- (点击开始战斗)
	[840] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 375, y = 4,
		w = 216, h = 62,
		stop = true,
	},
	-- [[地下城 地图 好友选择 MapPopupFriendLayer END]]
	-- [[地下城 MapContainerLayer END]]
	-- [[战斗界面 FightScene BEGIN]]
	-- (进入战斗界面，主角先手，主角有卡牌可入场)
	[850] = { -- 利亚姆	殿下小心了！速战速决，别被纠缠太久。
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.FRIEND,
	},
	-- (点击自动战斗) 注意啦,这里的update 11 交由服务端进行自动设置,yeah
	[860] = {  -- step = 5
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_LEFT,
		x = 845, y = 364,
		w = 91, h = 89,
		stop = true,
		-- update = 11,
	},
	-- [[战斗界面 FightScene END]]
	-- [[卡组 CardGroupLayer START]]
	-- (返回卡组界面)
	[870] = { -- 薇儿（对话）：殿下，有新卡槽可配置咯！赶紧上阵新卡牌吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[880] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 614, y = 378,
		w = 106, h = 162,
		stop = true,
	},
	-- [[卡组 CardGroupLayer END]]

	-- [[卡组副卡牌配置 CardFilterLayer BEGIN]]
	-- (进入卡牌选择界面)
	[890] = { -- 薇儿（对话）：合理分配召唤值可是配卡的一大学问哦！若召唤值不足时，记得取消选择卡牌哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
	},
	-- [[卡组副卡牌配置 CardFilterLayer END]]

	-- [[卡组 CardGroupLayer START]]
	-- (返回卡组界面, 点击确定配置)
	[900] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 734, y = 135,
		w = 205, h = 51,
		swallowsTouches = true,
		-- update = 11, -- step = 6
	},
	-- (点击界面上方首页控件)
	[910] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_DOWN,
		x = 0, y = 550,
		w = 120, h = 90,
		stop = true,
	},
	-- [[卡组 CardGroupLayer END]]
	-- [[首页 MainLayer BEGIN]]
	-- (点击登陆礼包图标)
	[920] = {
		mode = M.MODE_COVER, 
		x = 600, y = 467, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_DOWN,
		stop = true,
	},
	-- [[首页 MainLayer END]]
	-- [[登陆礼包页面 FestivalSignLayer BEGIN]]
	-- (领取礼包)
	[930] = {
		mode = M.MODE_COVER, 
		x = 83, y = 478, 
		w = 90, h = 90, 
		hand = M.HAND_DIRECTION_DOWN,
		-- update = 11, -- step = 7
		nextIndex = 931,
		stop = true,
	},
	-- 确认领取
	[931] = {
		mode = M.MODE_COVER, 
		x = 440, y = 56, 
		w = 90, h = 90, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- (关闭)
	[940] = {
		mode = M.MODE_COVER, 
		x = 900, y = 580, 
		w = 51, h = 51, 
		hand = M.HAND_DIRECTION_DOWN,
		stop = true,
	},
	-- [[登陆礼包页面 FestivalSignLayer END]]
	-- [[首页 MainLayer BEGIN]]
	-- (点击任务成就图标)
	[950] = {
		mode = M.MODE_COVER, 
		x = 876, y = 292, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- [[首页 MainLayer END]]
	-- [[任务成就页面 MainRewardAlertLayer BEGIN]]
	-- (点击成就)
	[960] = {
		mode = M.MODE_COVER, 
		x = 245, y = 525, 
		w = 146, h = 63, 
		hand = M.HAND_DIRECTION_DOWN,
	},
	-- 领取铁血成就
	[970] = {
		mode = M.MODE_COVER, 
		x = 717, y = 252, 
		w = 113, h = 46, 
		hand = M.HAND_DIRECTION_LEFT,
		-- update = 11, -- step = 8
		stop = true,
		nextIndex = 971,
	},
	-- 确认领取
	[971] = {
		mode = M.MODE_COVER, 
		x = 440, y = 56, 
		w = 90, h = 90, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- (点击每日任务)
	[980] = {
		mode = M.MODE_COVER, 
		x = 90, y = 524, 
		w = 146, h = 63, 
		hand = M.HAND_DIRECTION_DOWN,
	},
	-- (点击成就)
	[981] = {
		mode = M.MODE_COVER, 
		x = 876, y = 292, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- 参与地下城
	[990] = {
		mode = M.MODE_COVER, 
		x = 717, y = 252, 
		w = 113, h = 46, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- [[任务成就页面 MainRewardAlertLayer END]]

	-- [[地下城 MapContainerLayer BEGIN]]
	-- (点击片区一)
	[1000] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_RIGHT,
		x = 144, y = 130,
		w = 356, h = 380,
		stop = true,
		swallowsTouches = true,
	},
	-- (进入片区一【翡翠草原】后, 点击关卡1.3)
	[1010] = {
		mode = M.MODE_COVER, 
		x = 293, y = 479, 
		w = 85, h = 107, 
		hand = M.HAND_DIRECTION_RIGHT, 
		stop = true,
		enable = false,
		update = 11, -- step = 9
	}, 
	-- [[地下城 MapContainerLayer END]]

-- ==================== 第四阶段 END ====================


-- [====================[独立引导]====================]
-- ==================== 卡牌强化 BEGIN ====================
	[10010] = { -- 薇儿	王子殿下！战斗中获得了不少卡牌吧，是时候用【卡牌强化】把它们都利用起来了！前往卡组界面吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_010010", M.ROLE.PLAYER.HONOUR),
		stop = true,
		-- mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_CARDGROUPLAYER_MODEL", 
			path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 4, 
			text = _s("HELPER_INFO_010010_MSG"), 
			imgFile = "trigger/img_trigger_enhanced.png",
			data = {fromMain = false, toEnhanced = false,},
		},
	},
	-- [[卡组页面 CardGroupLayer BEGIN]]
	[10020] = { -- 薇儿	卡牌强化就是吞噬其他卡牌来提升其等级，从而增强属性，还能解锁技能哦！让我们赶紧来试试吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击卡牌强化)
	[10030] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 280, y = 70, 
		w = 205, h = 52,
		stop = true,
	},
	-- [[卡组页面 CardGroupLayer END]]

	-- [[卡组卡牌强化 CardEnhancedLayer BEGIN]]
	-- (点击选择卡牌控件)
	[10040] = { 
			mode = M.MODE_COVER,
			x = 70, y = 98, 
			w = 208, h = 314,
			hand = M.HAND_DIRECTION_RIGHT,
			nextIndex = 10041,
			stop = true,
			-- swallowsTouches = true,
		    },
	-- [[卡组卡牌强化 CardEnhancedLayer END]]

	-- [[卡组卡牌选择 CardFilterLayer BEGIN]]
	[10041] = { -- 薇儿	请选择要强化的一张卡牌吧！ 
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		nextIndex = 10070,
		stop = true,
	},
	-- (选中一张欲强化卡牌)
	[10050] = { 
			mode = M.MODE_COVER,
			x = 8, y = 230, 
			w = 200, h = 300,
			hand = M.HAND_DIRECTION_RIGHT,
			swallowsTouches = true,
		    },	
    -- (点击确认)
	[10060] = { 
			mode = M.MODE_COVER,
			x = 733, y = 43, 
			w = 218, h = 54,
			hand = M.HAND_DIRECTION_UP,
			stop = true,
		    },
	-- [[卡组卡牌选择 CardFilterLayer END]]

	-- [[卡组卡牌强化 CardEnhancedLayer BEGIN]]
	[10070] = { -- 薇儿	接下来要选择素材卡，每次吞噬素材卡的数量是不限的哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击素材卡控件)
	[10080] = { 
			mode = M.MODE_COVER,
			x = 634, y = 71, 
			w = 304, h = 385,
			hand = M.HAND_DIRECTION_LEFT,
			stop = true,
		    },
	-- [[卡组卡牌强化 CardEnhancedLayer END]]

	-- [[卡组卡牌选择 CardFilterLayer BEGIN]]
	[10090] = { -- 薇儿	强化时要注意别选取过量的素材卡，否则卡牌满级后超额的经验是会被浪费掉的！当卡牌过多时，可以使用【智能选取】来轻松完成哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[10100] = { -- 薇儿	这次先吞噬一张看看效果吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		nextIndex = 10130,
		stop = true,
	},
	-- (选中一张素材卡牌)
	[10110] = { 
			mode = M.MODE_COVER,
			x = 8, y = 230, 
			w = 200, h = 300,
			hand = M.HAND_DIRECTION_RIGHT,
			swallowsTouches = true,
		    },
	-- (点击确定)
	[10120] ={ 
			mode = M.MODE_COVER,
			x = 733, y = 43, 
			w = 219, h = 54,
			hand = M.HAND_DIRECTION_UP,
			stop = true,
		    },	
	-- [[卡组卡牌选择 CardFilterLayer END]]

	-- [[卡组卡牌强化 CardEnhancedLayer BEGIN]]
	-- (点击升级)
	[10130] = { 
			mode = M.MODE_COVER,
			x = 373, y = 67, 
			w = 211, h = 52,
			hand = M.HAND_DIRECTION_UP,
			nextIndex = 10131,
			update = 4,
			stop = true,
		    },
	-- (点击确认)	    
    [10131] = {
			mode = M.MODE_COVER,
			x = 270, y = 202, 
			w = 130, h = 45,
			delay = 0.3,
			hand = M.HAND_DIRECTION_UP,
			stop = true,
		    },
    [10140] = { -- 薇儿	哇！卡牌经验提升了！强化卡牌可是提升实力的最佳途径哦，殿下可要加油哦！
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	-- [[卡组卡牌强化 CardEnhancedLayer END]]
-- ==================== 卡牌强化 END ====================

-- ==================== 卡牌进阶 BEGIN ====================
	[20010] = { -- 薇儿	王子殿下！您最近老偷懒，不好好提升实力怎么对付魔君。是时候学习下【卡牌进阶】了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_020010", M.ROLE.PLAYER.HONOUR),
		stop = true,
		triggerMsg = {
			id = "MSG_CARDGROUPLAYER_MODEL", 
			path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 5, 
			text = _s("HELPER_INFO_020010_MSG"), 
			imgFile = "trigger/img_trigger_evolution.png",
			data = {fromMain = false, toEnhanced = false,},
		},
	},

	-- [[卡组页面 CardGroupLayer BEGIN]]
	-- (点击卡牌进阶)
	[20020] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_UP,
		x = 280, y = 0, 
		w = 205, h = 55,
		stop = true,
	},
	-- [[卡组页面 CardGroupLayer END]]

	-- [[卡牌进阶页面 CardEvolutionLayer BEGIN]]
	[20030] = { -- 薇儿	【卡牌进阶】是将两张满级的相同卡牌进行融合，新生高阶卡牌的成长值将会得到大幅提升哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[20040] = { -- 薇儿	但是要注意只有4星及以上卡牌才能进阶；而且进阶后的高阶卡牌会重生为1级！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[20050] = { -- 主角	也就是说我用两张60级的4星或5星卡牌就能融合咯！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[20060] = { -- 薇儿	殿下悟性不错！可惜只对了一半，进阶还需要4种材料，而且不同种族对应的材料也是不同的！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[20070] = { -- 主角	我就知道没那么简单，天下之大，我上哪打材料啊？
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[20080] = { -- 薇儿	嘻嘻，看到右下方的问号了么，点击查看就能获得进阶相关的资料了。接下来就看殿下的咯。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		update = 5,
		stop = true,
		enable = false,
	},
	-- [[卡牌进阶页面 CardEvolutionLayer BEGIN]]

-- ==================== 卡牌进阶 END ====================

-- ==================== 好友系统 BEGIN ====================
	[30010] = { -- 薇儿	殿下！还记得薇儿之前和你说的么？善用好友的主卡助阵是可以改变战局的哦！那么让我们看看如何结交新朋友吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		triggerMsg = {
			id = "MSG_FRIENDLAYER_MODEL", 
			path = "ccb.c.friend.FriendLayer", 
			msgId = 10, 
			text = _s("HELPER_INFO_030010_MSG"), 
			imgFile = "trigger/img_trigger_friend.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[好友页面 FriendLayer BEGIN]]
	-- (点击好友添加)
	[30020] = {
		mode = M.MODE_COVER, 
		x = 14, y = 162, 
		w = 220, h = 48, 
		hand = M.HAND_DIRECTION_RIGHT, 
		delay = 0.5,
	},
	-- (点击【申请加为好友】)
	[30030] = {
		mode = M.MODE_COVER, 
		x = 700, y = 484, 
		w = 182, h = 52, 
		hand = M.HAND_DIRECTION_RIGHT,
	},
	[30040] = { -- 薇儿	剩下的就是等待对方的回复了，简单吧！但要注意当前好友上限是受角色等级限制的哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[30050] = { -- 薇儿	每日还能和好友们互赠体力，互助前进！平日里，殿下可要及时查收好友申请哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		update = 10,
		stop = true,
		enable = false,
	},
	-- [[好友页面 FriendLayer END]]
-- ==================== 好友系统 END ====================

-- ==================== 星星收集 BEGIN ====================
	-- (点击前往控件)
	[40010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAP_MESSAGE_ID, 
			path = MAP_LAYER_ID, 
			msgId = 7, 
			text = _s("HELPER_INFO_040010_MSG"), 
			imgFile = "trigger/img_trigger_star.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[地下城 地图 MapLayer BEGIN]]
	[40020] = { -- 薇儿	殿下！是星星雨耶，听大叔他们说星星有神奇的力量哦！赶紧收集吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击右下角星星收集控件)
	[40030] = {
		mode = M.MODE_COVER, 
		x = 850, y = 107, 
		w = 62, h = 62, 
		hand = M.HAND_DIRECTION_LEFT,
		-- stop = true,
	},
	[40040] = { -- 薇儿	太棒了！拥有的星星数量增加了，下一波星星要过一段时间才能收集，殿下可别忘了哦！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[40050] = { -- 薇儿	每完成一个关卡难度，在收集时就能多获得一颗星星！一个片区最多能收获30颗哦！努力挑战吧！
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		update = 7,
		enable = false,
	},
	-- [[地下城 地图 MapLayer END]]
-- ==================== 星星收集 END ====================

-- ==================== 天赋系统 BEGIN ====================
	-- (点击前往控件)
	[50010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAINLAYER_ID, 
			path = MAINLAYER_PATH, 
			msgId = 6, 
			text = _s("HELPER_INFO_050010_MSG"), 
			imgFile = "trigger/img_trigger_talent.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[首页 MainLayer BEGIN]]
	[50020] = { -- 薇儿	殿下！这里有本书耶，是维卡大叔留下的，好像很牛逼的样子哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[50030] = { -- 主角	咦？！我看看，《天赋大全》？！(#‵′)靠，本殿下最不擅长的就是读书了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[50040] = { -- 薇儿	哇！这是有关王国行军作战的手册耶；大叔一定是有意留下的，快看看！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击天赋图标)
	[50050] = {
		mode = M.MODE_COVER, 
		x = 871, y = 104, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- [[首页 MainLayer END]]

	-- [[天赋页面 TalentLayer BEGIN]]
	[50060] = { -- 主角（杯具）	咦？！我看看，《天赋大全》？！(#‵′)靠，本殿下最不擅长的就是读书了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[50070] = { -- 薇儿	殿下别怕，有薇儿呢！先选中欲学习的天赋，然后再点击右下的升级按键。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击天赋图标)
	[50080] = {
		mode = M.MODE_COVER, 
		x = 734, y = 40, 
		w = 155, h = 43, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	[50090] = { -- 主角	哦？！有两种方式。一看就知道钻石方便，直截了当，就用钻石吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[50100] = { -- 薇儿	殿下！钻石升级是轻松，可我们的钱袋都快空了。还是看看消耗卡牌升级吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击选择卡牌控件)
	[50110] = {
		mode = M.MODE_COVER, 
		x = 510, y = 224, 
		w = 145, h = 43, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- [[天赋页面 TalentLayer END]]

	-- [[天赋材料卡选择页面 TalentUp4CardLayer BEGIN]]
	[50120] = { -- 主角（杯具）	骗子啊！明明要卡牌、金币和星星3种材料嘛，东西更多了。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[50130] = { -- 薇儿	相比钻石，这些东西殿下平时注意收集还是不难获得的！在战斗中高级天赋的作用不可小觑哦！殿下努力升级吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		update = 6,
		stop = true,
		enable = false,
	},
	-- [[天赋材料卡选择页面 TalentUp4CardLayer END]]
-- ==================== 天赋系统 END ====================

-- ==================== 竞技场 BEGIN ====================
	-- (点击前往控件)
	[70010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_ARENASELECTLAYER_MODEL", 
			path = "ccb.c.arena.ArenaSelectLayer", 
			msgId = 9, 
			text = _s("HELPER_INFO_070010_MSG"), 
			imgFile = "trigger/img_trigger_arena.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[竞技场页面 ArenaSelectLayer BEGIN]]
	[70020] = { -- 主角	薇儿，这是什么地方？怎么让人有种跃跃欲试的感觉。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[70030] = { -- 薇儿	殿下！这是王国的竞技场，王国的勇士们在这同场竞技，胜者为王！还有丰厚的奖励哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[70040] = { -- 主角	哇！那怎么能少了本殿下，让我看看，咦？貌似只能参加排名赛啊！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[70050] = { -- 薇儿	更高级的周季赛还需要殿下努力升级才能参加哦。当前的排名赛是每日结算奖励的，赶紧进去看看规则吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击排行赛)
	[70060] = {
		mode = M.MODE_COVER, 
		x = 130, y = 80, 
		w = 255, h = 273, 
		hand = M.HAND_DIRECTION_RIGHT,
		stop = true,
	},
	-- [[竞技场页面 ArenaSelectLayer END]]

	-- [[排行赛页面 ArenaLayer BEGIN]]
	-- 点击【规则】
	[70070] = {
		mode = M.MODE_COVER, 
		x = 452, y = 6, 
		w = 88, h = 70, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	[70080] = { -- 主角（杯具）	我靠，这么多字！不行，我又犯晕了，不如先干一场再说，哈哈！
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		update = 9,
		stop = true,
		enable = false,
	},
	-- [[排行赛页面 ArenaLayer END]]
-- ==================== 竞技场 END ====================

-- ==================== 卡牌碎片 BEGIN ====================
	-- (点击前往控件)
	[80010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_CARDGROUPLAYER_MODEL", 
			path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 8, 
			text = _s("HELPER_INFO_080010_MSG"), 
			imgFile = "trigger/img_trigger_cardchip.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[卡组页面 CardGroupLayer BEGIN]]
	[80020] = { -- 主角	薇儿，你刚才说的卡牌碎片是什么啊！想必是集齐后可以获得强力卡牌的好东西吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[80030] = { -- 薇儿	殿下真是聪明！在一些特定关卡的战斗会掉落卡牌碎片，集齐一定数量后就能获得对应的卡牌了！就是这么简单！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[80040] = { -- 主角	我就知道，嘿嘿！不过要去哪打啊。。。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[80050] = { -- 薇儿	这好办，前往【卡牌碎片】界面就知道咯！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- 点击卡牌碎片
	[80060] = {
		mode = M.MODE_COVER, 
		x = 732, y = 0, 
		w = 213, h = 53, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- [[卡组页面 CardGroupLayer END]]

	-- [[卡牌碎片页面 CardFragmentLayer BEGIN]]
	[80070] = { -- 主角	原来如此！掉落关卡，碎片类型，持有数量，在这一看便知！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[80080] = { -- 薇儿	不过碎片的掉落是有概率的，而且每种卡牌仅限集齐一次哦！殿下赶紧行动吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		update = 8,
		stop = true,
		enable = false,
	},
	-- [[卡牌碎片页面 CardFragmentLayer END]]
-- ==================== 卡牌碎片 END ====================

-- ==================== 卡槽解锁 BEGIN ====================
	-- (点击前往控件)
	[90010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_CARDGROUPLAYER_MODEL", 
			path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 2, 
			text = _s("HELPER_INFO_090010_MSG"), 
			imgFile = "trigger/img_trigger_unlockcard.png",
			data = {fromMain = false,},
		},
		stop = true,
		enable = false,
	},
-- ==================== 卡槽解锁 END ====================

-- ==================== 卡组解锁 BEGIN ====================
	-- (点击前往控件)
	[100010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_CARDGROUPLAYER_MODEL", 
			path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 3, 
			text = _s("HELPER_INFO_100010_MSG"), 
			imgFile = "trigger/img_trigger_unlockcardgroup.png",
			data = {fromMain = false,},
		},
		stop = true,
		enable = false,
	},
-- ==================== 卡组解锁 END ====================

-- ==================== 地图探索 BEGIN ====================
	-- (点击前往控件)
	[110010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			-- id = "MSG_CARDGROUPLAYER_MODEL", 
			-- path = "ccb.c.cardgroup.CardGroupLayer", 
			msgId = 12, 
			text = _s("HELPER_INFO_110010_MSG"), 
			imgFile = "trigger/img_trigger_explore.png",
		},
		stop = true,
		-- enable = false,
	},

	-- [[小地图页面 SubMapView BEGIN]]
	-- (点击地图探索)
	[110020] = { 
		mode = M.MODE_COVER,
		hand = M.HAND_DIRECTION_LEFT,
		x = 876, y = 24, 
		w = 75, h = 75,
		stop = true,
	},
	-- [[小地图页面 SubMapView END]]

	-- [[地图探索选择页面 MapExploreLayer BEGIN]]
	[110030] = { -- 薇儿	殿下！有个荒废的小城堡耶，要不要进去看看？说不定能找到些贵族们遗留的财宝呢。 
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[110040] = { -- 主角	哈哈！探宝什么的，本殿下最擅长了，这种机会怎么能放过！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[110050] = { -- 主角	咦？怎么有的关卡探索是灰色的？
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[110060] = { -- 薇儿	要探索后续的关卡必须要探索过前一关卡！而且右侧加锁的奖励需要完成对应关卡的英雄和挑战难度才能探索哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[110070] = { -- 主角	原来如此！那事不宜迟，赶紧进去一探究竟吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		update = 12,
		stop = true,
		enable = false,
	},
	-- [[地图探索选择页面 MapExploreLayer BEGIN]]

-- ==================== 地图探索 END ====================

-- ==================== 装备 BEGIN ====================
	-- (点击前往控件)
	[120010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_EQUIPMENTLAYER_MODEL", 
			path = "ccb.c.equipment.EquipmentLayer", 
			msgId = 14, 
			text = _s("HELPER_INFO_120010_MSG"), 
			imgFile = "trigger/img_trigger_equip.png",
		},
		stop = true,
		-- enable = false,
	},

	-- [[装备选择页面 EquipmentLayer BEGIN]]
	[120020] = { -- 薇儿	殿下，该发挥下你铁匠的一技之长了；这年头没套体面的装备都不好意思出门了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[120030] = { -- 主角	打造装备啥的本殿下可不虚，我看看。咦！？薇儿，左边这个不是我小时候的照片嘛！你哪搞的。。。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[120040] = { -- 薇儿	哎呀！殿下别纠结那么多啦，你不看看这身装备土死了。赶紧换上薇儿从利亚姆那要来的新装备吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		update = 14,
		speaker = M.ROLE.MAID,
	},
	-- (点击装备)
	[120050] = {
		mode = M.MODE_COVER, 
		x = 525, y = 411, 
		w = 75, h = 75, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	[120060] = { -- 薇儿	哇！殿下，立马显得高端大气上档次了耶，有木有！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[120070] = { -- 主角	切！那是天生的好不。不过这装备的底子虽好，但还需打磨一番。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[120080] = { -- 薇儿	殿下的铁匠技艺果然没白学啊，使用右下的铁匠铺就能强化装备，提高属性了。平日可要记得锤炼哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		-- update = 14,
		stop = true,
		enable = false,
	},
	-- [[装备选择页面 EquipmentLayer BEGIN]]

-- ==================== 装备 END ====================

-- ==================== 竞技场周赛 BEGIN ====================
	-- (点击前往控件)
	[130010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = "MSG_ARENASELECTLAYER_MODEL", 
			path = "ccb.c.arena.ArenaSelectLayer", 
			msgId = 13, 
			text = _s("HELPER_INFO_130010_MSG"), 
			imgFile = "trigger/img_trigger_arena.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[竞技场页面 ArenaSelectLayer BEGIN]]
	[130020] = { -- 薇儿	殿下，您终于可以参加周季赛了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[130030] = { -- 主角	本殿下是什么人，这点小事可难不倒我！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	-- (点击排行赛)
	[130040] = {
		mode = M.MODE_COVER, 
		x = 585, y = 94, 
		w = 200, h = 256, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	-- [[竞技场页面 ArenaSelectLayer END]]

	-- [[排行赛页面 ArenaLayer BEGIN]]
	[130050] = { -- 薇儿	周季赛顾名思义，每周一个轮回，具体的规则和奖励同样可以在界面下方的【规则】内查看哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		update = 13,
		stop = true,
		enable = false,
	},
	-- [[排行赛页面 ArenaLayer END]]
-- ==================== 竞技场周赛 END ====================

-- ==================== 装备强化 BEGIN ====================
	-- (点击前往控件)
	[140010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAINLAYER_ID, 
			path = MAINLAYER_PATH, 
			msgId = 15, 
			text = _s("HELPER_INFO_140010_MSG"), 
			imgFile = "trigger/img_trigger_equiplv.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[首页 MainLayer BEGIN]]
	-- (点击装备图标)
	[140020] = {
		mode = M.MODE_COVER, 
		x = 691, y = 20, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- [[首页 MainLayer END]]

	-- [[铁匠铺页面 BlacksmithLayer BEGIN]]
	[140030] = { -- 主角	这种久违的感觉，一定是铁匠铺了吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[140040] = { -- 薇儿	铁匠协会已经同意殿下免费使用各地的铁匠铺咯！不过强化装备所需的金币和材料还得靠殿下自己收集。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[140050] = { -- 主角	唉！协会还是一如既往的小气啊，话说我要去哪搞这些材料啊。。。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[140060] = { -- 薇儿	地图探索和许愿池都是可以获得装备强化需要的材料哦！而且努力升级，解锁【矿山】的话，就不怕缺材料啦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[140070] = { -- 主角	原来如此！那可要加油啦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,	
		update = 15,
		stop = true,
		enable = false,
	},
	-- (点击装备图标)
	-- [140080] = {
	-- 	mode = M.MODE_COVER, 
	-- 	x = 13, y = 553, 
	-- 	w = 94, h = 94, 
	-- 	hand = M.HAND_DIRECTION_DOWN,
	-- 	stop = true,
	-- 	update = 15,
	-- 	enable = false,
	-- },
	-- [[铁匠铺页面 BlacksmithLayer END]]
-- ==================== 装备强化 END ====================

-- ==================== 矿山 BEGIN ====================
	-- (点击前往控件)
	[150010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAINLAYER_ID, 
			path = MAINLAYER_PATH, 
			msgId = 16, 
			text = _s("HELPER_INFO_150010_MSG"), 
			imgFile = "trigger/img_trigger_mine.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[首页 MainLayer BEGIN]]
	[150020] = { -- 主角	薇儿，你这是要带我去哪啊，没看我正忙着找装备强化材料么？！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[150030] = { -- 薇儿	铁匠协会看殿下这么努力，允许殿下前往矿山进行采集了！赶紧去淘矿石吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},	
	-- (点击矿山图标)
	[150040] = {
		mode = M.MODE_COVER, 
		x = 600, y = 20, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- [[首页 MainLayer END]]

	-- [[矿山页面 MapMiningLayer BEGIN]]
	[150050] = { -- 主角	哇塞！太棒了，这下不愁装备材料了，哈哈！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[150060] = { -- 薇儿	要想开采好的矿石，可是要磨练技艺的哦。殿下可别偷懒啊！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		-- update = 16,
		-- stop = true,
		-- enable = false,
	},
	-- (点击装备图标)
	[150070] = {
		mode = M.MODE_COVER, 
		x = 434, y = 416, 
		w = 100, h = 100, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
		update = 16,
		enable = false,
	},
	-- [[矿山页面 MapMiningLayer END]]
-- ==================== 矿山 END ====================

-- ==================== 装备进阶 BEGIN ====================
	-- (点击前往控件)
	[160010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAINLAYER_ID, 
			path = MAINLAYER_PATH, 
			msgId = 18, 
			text = _s("HELPER_INFO_160010_MSG"), 
			imgFile = "trigger/img_trigger_equipevo.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[首页 MainLayer BEGIN]]
	-- (点击装备图标)
	[160020] = {
		mode = M.MODE_COVER, 
		x = 691, y = 20, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- [[首页 MainLayer END]]

	-- [[铁匠铺页面 BlacksmithLayer BEGIN]]
	[160030] = { -- 薇儿	殿下！是时候进阶下您的装备啦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[160040] = { -- 主角	装备进阶？这是什么东西，我怎么没印象？
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[160050] = { -- 薇儿	殿下怎么这么快就忘了。装备进阶后可以提高装备的阶数，而阶数越高装备的成长值也越高哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[160060] = { -- 主角	啊！这么牛逼的技术本殿下怎么可能忘了呢，其实是想考考薇儿你嘛？
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[160070] = { -- 薇儿	哼！殿下可别光说不练哦。而且进阶也有专属材料，别忘了常去矿山看看哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	-- (点击装备图标)
	[160080] = {
		mode = M.MODE_COVER, 
		x = 112, y = 558, 
		w = 95, h = 95, 
		hand = M.HAND_DIRECTION_DOWN,
		stop = true,
		update = 18,
		enable = false,
	},
	-- [[铁匠铺页面 BlacksmithLayer END]]
-- ==================== 装备进阶 END ====================

-- ==================== 装备追加 BEGIN ====================
	-- (点击前往控件)
	[170010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAINLAYER_ID, 
			path = MAINLAYER_PATH, 
			msgId = 17, 
			text = _s("HELPER_INFO_170010_MSG"), 
			imgFile = "trigger/img_trigger_equipadd.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[首页 MainLayer BEGIN]]
	-- (点击装备图标)
	[170020] = {
		mode = M.MODE_COVER, 
		x = 691, y = 20, 
		w = 71, h = 71, 
		hand = M.HAND_DIRECTION_UP,
		stop = true,
	},
	-- [[首页 MainLayer END]]

	-- [[铁匠铺页面 BlacksmithLayer BEGIN]]
	[170030] = { -- 主角	薇儿！我就快领悟铁匠的真谛了！看我有朝一日，也像父王那样打造一把圣剑！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[170040] = { -- 薇儿	（殿下又来了）提问：什么是装备追加！？
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[170050] = { -- 主角	回答：不知道！O(╯□╰)o
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[170060] = { -- 薇儿	装备追加可以提高装备的基础属性值，是打造一把神兵不可或缺的哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[170070] = { -- 主角	不用说，追加的材料一定也是专属的。我还是默默的带着我的矿镐去矿山吧。
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	-- (点击装备图标)
	[170080] = {
		mode = M.MODE_COVER, 
		x = 214, y = 558, 
		w = 95, h = 95, 
		hand = M.HAND_DIRECTION_DOWN,
		stop = true,
		update = 17,
		enable = false,
	},
	-- [[铁匠铺页面 BlacksmithLayer END]]
-- ==================== 装备追加 END ====================

-- ==================== 关卡5星奖励 BEGIN ====================
	[180010] = {
		mode = M.MODE_COVER, 
		x = 0, y = 0, 
		w = 960, h = 640, 
		update = 19,
		stop = true,
		enable = false,
		swallowsTouches = true,
	},
-- ==================== 关卡5星奖励 END ====================
-- ==================== 藏宝港湾 BEGIN ====================
	-- (点击前往控件)
	[200010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAP_MESSAGE_ID, 
			path = MAP_LAYER_ID, 
			msgId = 20, 
			text = _s("HELPER_INFO_200010_MSG"), 
			imgFile = "trigger/img_trigger_special_map.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[地下城 地图 MapLayer BEGIN]]
	-- (点击藏宝港湾控件)
	[200020] = {
		mode = M.MODE_COVER, 
		x = 850, y = 227, 
		w = 62, h = 62, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	[200030] = { -- 主角	难道这就是传说中大胡子海盗私藏宝藏的地方？！这是要发呀！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	
	[200040] = { -- 薇儿 高塔可是有守卫把守的，没有强力的伙伴是无法获取高塔中的财宝哦！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[200050] = { -- 主角	那待我兵强马壮，再来爬塔如何？难不成这塔还能长脚跑了！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[200060] = { -- 薇儿	殿下别耍嘴皮了，赶紧进去一探究竟吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		update = 20,
		enable = false,
	},
	-- [[地下城 地图 MapLayer END]]
-- ==================== 藏宝港湾 END ====================
-- ==================== 幽冥魔塔 BEGIN ====================
	-- (点击前往控件)
	[210010] = {
		mode = M.MODE_TRIGGERMSG,
		triggerMsg = {
			id = MAP_MESSAGE_ID, 
			path = MAP_LAYER_ID, 
			msgId = 21, 
			text = _s("HELPER_INFO_210010_MSG"), 
			imgFile = "trigger/img_trigger_tower.png",
			data = {fromMain = false,},
		},
		stop = true,
	},
	-- [[地下城 地图 MapLayer BEGIN]]
	-- (点击幽冥魔塔控件)
	[210020] = {
		mode = M.MODE_COVER, 
		x = 850, y = 347, 
		w = 65, h = 65, 
		hand = M.HAND_DIRECTION_LEFT,
		stop = true,
	},
	[210030] = { -- 薇儿	殿下，这是什么地方啊，这塔高耸入云，都看不见顶！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	
	[210040] = { -- 主角 这是魔族的禁地，据说能爬至顶峰的人就有资格成为新一任的魔君！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[210050] = { -- 薇儿	啊！殿下不会是想遁入魔道吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[210060] = { -- 主角	哎呀>.<！薇儿说啥呢，这可是检验本殿下真正实力的地方，看我爬它个100层！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[210070] = { -- 薇儿	殿下，不作死就不会死哦！还是要量力而行吧！
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		update = 21,
		enable = false,
	},
	-- [[地下城 地图 MapLayer END]]
-- ==================== 幽冥魔塔 END ====================
-- [====================[剧情故事引导]====================]


--===关卡点击触发式剧情===
	--[[
	[900110] = {	--===================关卡1.2begin
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.FRIEND,
	},
	[900120] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900130] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[900140] = {
		left = M.ROLE.MAID,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[900150] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.FRIEND,
		stop = true,
		enable = false,
	},
	--]]
	[900210] = {	--===================关卡1.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[900220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[900230] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.MAID,
		speaker = M.ROLE.FRIEND,
	},
	[900240] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900250] = {
		left = M.ROLE.KILLER,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.KILLER,
		stop = true,
		enable = false,
	},
	[900310] = {	--===================关卡1.4begin
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.FRIEND,
	},
	[900320] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[900330] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900340] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[900350] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.FRIEND,
		stop = true,
		enable = false,
	},
	[900410] = {	--===================关卡1.5begin
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[900420] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900430] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[900440] = {
		left = M.ROLE.MAID,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[900450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[900510] = {	--===================关卡1.6begin
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[900530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.WILD_BOAR,
	},
	[900540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[900610] = {	--===================关卡1.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
	},
	[900620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[900630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[900640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		enable = false,
		stop = true,
	},
	[900710] = {	--===================关卡1.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.WILD_BOAR,
	},
	[900720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.PLAYER,
	},
	[900730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.WILD_BOAR,
	},
	[900740] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WILD_BOAR,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[900810] = {	--===================关卡1.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[900820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
	},
	[900830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.FRIEND,
	},
	[900840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.FRIEND,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[900910] = {	--===================关卡1.10begin
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[900920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[900930] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_900930", M.ROLE.PLAYER.HONOUR),
	},
	[900940] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_900940", M.ROLE.PLAYER.HONOUR),
	},
	[900950] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.FRIEND,
	},
	[900960] = {
		left = M.ROLE.FRIEND,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[900970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901010] = {	--===================关卡2.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901050] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901110] = {	--===================关卡2.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_901110", M.ROLE.PLAYER.HONOUR),
	},
	[901120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901140] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901210] = {	--===================关卡2.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_901210", M.ROLE.PLAYER.HONOUR),
	},
	[901220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901310] = {	--===================关卡2.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.PLAYER,
	},
	[901320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.DEMON_MONSTER,
		stop = true,
		enable = false,
	},
	[901410] = {	--===================关卡2.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[901420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_901420", M.ROLE.PLAYER.HONOUR),
	},
	[901430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901510] = {	--===================关卡2.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.DEMON_MONSTER,
	},
	[901520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.PLAYER,
	},
	[901530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.DEMON_MONSTER,
	},
	[901540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_MONSTER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901610] = {	--===================关卡2.7begin
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901620] = {
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[901630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901710] = {	--===================关卡2.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_901710", M.ROLE.PLAYER.HONOUR),
	},
	[901720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901740] = {
		left = M.ROLE.ENEMIES,
		right = M.ROLE.MAID,
		speaker = M.ROLE.ENEMIES,
	},
	[901750] = {
		left = M.ROLE.ENEMIES,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[901810] = {	--===================关卡2.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_901820", M.ROLE.PLAYER.HONOUR),
	},
	[901830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901850] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.ENEMIES,
		speaker = M.ROLE.ENEMIES,
		stop = true,
		enable = false,
	},
	[901910] = {	--===================关卡2.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[901930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[901940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_901940", M.ROLE.PLAYER.HONOUR),
	},
	[901950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.DEMON_GENERAL_M,
		text = _s("HELPER_INFO_901950", M.ROLE.PLAYER.HONOUR),
	},
	[901960] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.PLAYER,
	},
	[901970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.DEMON_GENERAL_M,
	},
	[901980] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902010] = {	--===================关卡3.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[902040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902110] = {	--===================关卡3.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902210] = {	--===================关卡3.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902240] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902250] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902260] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902270] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[902310] = {	--===================关卡3.4begin
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[902320] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902320", M.ROLE.PLAYER.HONOUR),
	},
	[902330] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[902340] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[902350] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[902360] = {
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902410] = {	--===================关卡3.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902410", M.ROLE.PLAYER.HONOUR),
	},
	[902420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902430", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[902510] = {	--===================关卡3.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_902510", M.ROLE.PLAYER.HONOUR),
	},
	[902520] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902520", M.ROLE.PLAYER.HONOUR),
	},
	[902530] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_902530", M.ROLE.PLAYER.HONOUR),
	},
	[902540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902610] = {	--===================关卡3.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902610", M.ROLE.PLAYER.HONOUR),
	},
	[902620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902630", M.ROLE.PLAYER.HONOUR),
	},
	[902640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902710] = {	--===================关卡3.8begin
		left = M.ROLE.MAID,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902710", M.ROLE.PLAYER.HONOUR),
	},
	[902720] = {
		left = M.ROLE.MAID,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[902730] = {
		left = M.ROLE.MAID,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.MAID,
	},
	[902740] = {
		left = M.ROLE.MAID,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[902750] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[902810] = {	--===================关卡3.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[902820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902830", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[902910] = {	--===================关卡3.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_902910", M.ROLE.PLAYER.HONOUR),
	},
	[902920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[902930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
		text = _s("HELPER_INFO_902930", M.ROLE.PLAYER.HONOUR),
	},
	[902940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903010] = {	--===================关卡4.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[903020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[903040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903110] = {	--===================关卡4.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903110", M.ROLE.PLAYER.HONOUR),
	},
	[903120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[903140] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903210] = {	--===================关卡4.3begin
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[903220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[903230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
	},
	[903240] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
		stop = true,
		enable = false,
	},
	[903310] = {	--===================关卡4.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903310", M.ROLE.PLAYER.HONOUR),
	},
	[903320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903410] = {	--===================关卡4.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903410", M.ROLE.PLAYER.HONOUR),
	},
	[903420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[903440] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
	},
	[903450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
		stop = true,
		enable = false,
	},
	[903510] = {	--===================关卡4.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903520", M.ROLE.PLAYER.HONOUR),
	},
	[903530] = {
		left = M.ROLE.SECRET_ASSASSIN,
		right = M.ROLE.MAID,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[903540] = {
		left = M.ROLE.SECRET_ASSASSIN,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903540", M.ROLE.PLAYER.HONOUR),
	},
	[903550] = {
		left = M.ROLE.SECRET_ASSASSIN,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903610] = {	--===================关卡4.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[903620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[903640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[903710] = {	--===================关卡4.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_903710", M.ROLE.PLAYER.HONOUR),
	},
	[903720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[903810] = {	--===================关卡4.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[903820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[903830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		stop = true,
		enable = false,
	},
	[903910] = {	--===================关卡4.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[903920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[903930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.DEMON_GENERAL_Z,
		text = _s("HELPER_INFO_903930", M.ROLE.PLAYER.HONOUR),
	},
	[903940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.PLAYER,
	},
	[903950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_903950", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[904010] = {	--===================关卡5.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904010", M.ROLE.PLAYER.HONOUR),
	},
	[904020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904050] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904050", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[904110] = {	--===================关卡5.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904110", M.ROLE.PLAYER.HONOUR),
	},
	[904120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904140] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[904210] = {	--===================关卡5.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904240] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[904310] = {	--===================关卡5.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904310", M.ROLE.PLAYER.HONOUR),
	},
	[904320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904330] = {
		left = M.ROLE.DEMON_MONSTER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.DEMON_MONSTER,
	},
	[904340] = {
		left = M.ROLE.DEMON_MONSTER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904340", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[904410] = {	--===================关卡5.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904410", M.ROLE.PLAYER.HONOUR),
	},
	[904420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904440] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[904510] = {	--===================关卡5.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		text = _s("HELPER_INFO_904510", M.ROLE.PLAYER.HONOUR),
	},
	[904520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[904530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		text = _s("HELPER_INFO_904530", M.ROLE.PLAYER.HONOUR),
	},
	[904540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[904550] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		text = _s("HELPER_INFO_904550", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[904610] = {	--===================关卡5.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		text = _s("HELPER_INFO_904610", M.ROLE.PLAYER.HONOUR),
	},
	[904620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[904630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		stop = true,
		enable = false,
	},
	[904710] = {	--===================关卡5.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		text = _s("HELPER_INFO_904710", M.ROLE.PLAYER.HONOUR),
	},
	[904720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[904730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
	},
	[904740] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[904750] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
		stop = true,
		enable = false,
	},
	[904810] = {	--===================关卡5.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[904820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904830", M.ROLE.PLAYER.HONOUR),
	},
	[904840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[904910] = {	--===================关卡5.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_904910", M.ROLE.PLAYER.HONOUR),
	},
	[904920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[904930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
		text = _s("HELPER_INFO_904930", M.ROLE.PLAYER.HONOUR),
	},
	[904940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[905010] = {	--===================关卡6.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905010", M.ROLE.PLAYER.HONOUR),
	},
	[905020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[905030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[905040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[905110] = {	--===================关卡6.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_905110", M.ROLE.PLAYER.HONOUR),
	},
	[905120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[905130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[905140] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[905210] = {	--===================关卡6.3begin
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
	},
	[905220] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905220", M.ROLE.PLAYER.HONOUR),
	},
	[905230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[905240] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[905310] = {	--===================关卡6.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[905320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		text = _s("HELPER_INFO_905320", M.ROLE.PLAYER.HONOUR),
	},
	[905330] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905330", M.ROLE.PLAYER.HONOUR),
	},
	[905340] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
	},
	[905350] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905350", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[905410] = {	--===================关卡6.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905410", M.ROLE.PLAYER.HONOUR),
	},
	[905420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[905430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[905440] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[905450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_905450", M.ROLE.PLAYER.HONOUR),
	},
	[905460] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_905460", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[905510] = {	--===================关卡6.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[905520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.PLAYER,
	},
	[905530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_905530", M.ROLE.PLAYER.HONOUR),
	},
	[905540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[905610] = {	--===================关卡6.7begin
		left = M.ROLE.MAID,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.MAID,
	},
	[905620] = {
		left = M.ROLE.MAID,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
	},
	[905630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.PLAYER,
	},
	[905640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
		stop = true,
		enable = false,
	},
	[905710] = {	--===================关卡6.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
	},
	[905720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.PLAYER,
	},
	[905730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
		stop = true,
		enable = false,
	},
	[905810] = {	--===================关卡6.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.PLAYER,
	},
	[905820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
		stop = true,
		enable = false,
	},
	[905910] = {	--===================关卡6.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_905910", M.ROLE.PLAYER.HONOUR),
	},
	[905920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[905930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_B,
		speaker = M.ROLE.DEMON_GENERAL_B,
	},
	[905940] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_B,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_905940", M.ROLE.PLAYER.HONOUR),
	},
	[905950] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_B,
		speaker = M.ROLE.DEMON_GENERAL_B,
		stop = true,
		enable = false,
	},
	[906010] = {	--===================关卡7.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_906010", M.ROLE.PLAYER.HONOUR),
	},
	[906020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[906030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[906040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906110] = {	--===================关卡7.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[906120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
	},
	[906130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[906210] = {	--===================关卡7.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_906210", M.ROLE.PLAYER.HONOUR),
	},
	[906220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[906230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_906230", M.ROLE.PLAYER.HONOUR),
	},
	[906240] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
	},
	[906250] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906310] = {	--===================关卡7.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_906310", M.ROLE.PLAYER.HONOUR),
	},
	[906320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[906330] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[906340] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906410] = {	--===================关卡7.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_906410", M.ROLE.PLAYER.HONOUR),
	},
	[906420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[906430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
		text = _s("HELPER_INFO_906430", M.ROLE.PLAYER.HONOUR),
	},
	[906440] = {
		left = M.ROLE.MAID,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_906440", M.ROLE.PLAYER.HONOUR),
	},
	[906450] = {
		left = M.ROLE.MAID,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[906460] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906510] = {	--===================关卡7.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		text = _s("HELPER_INFO_906510", M.ROLE.PLAYER.HONOUR),
	},
	[906520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[906530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[906540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906610] = {	--===================关卡7.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[906620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[906630] = {
		left = M.ROLE.MAID,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_906630", M.ROLE.PLAYER.HONOUR),
	},
	[906640] = {
		left = M.ROLE.MAID,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
		text = _s("HELPER_INFO_906640", M.ROLE.PLAYER.HONOUR),
	},
	[906650] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906710] = {	--===================关卡7.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		text = _s("HELPER_INFO_906710", M.ROLE.PLAYER.HONOUR),
	},
	[906720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[906730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_906730", M.ROLE.PLAYER.HONOUR),
	},
	[906740] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
		text = _s("HELPER_INFO_906740", M.ROLE.PLAYER.HONOUR),
	},
	[906750] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
	},
	[906760] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[906770] = {
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_906770", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[906810] = {	--===================关卡7.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[906820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[906830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[906840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[906910] = {	--===================关卡7.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[906920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[906930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[906940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[907010] = {	--===================关卡8.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[907020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[907030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[907040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[907110] = {	--===================关卡8.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[907120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907140] = {
		left = M.ROLE.LORD_K,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.LORD_K,
		stop = true,
		enable = false,
	},
	[907210] = {	--===================关卡8.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[907220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.PLAYER,
	},
	[907230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[907240] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[907310] = {	--===================关卡8.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[907330] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[907340] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[907410] = {	--===================关卡8.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[907430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[907440] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		stop = true,
		enable = false,
	},
	[907510] = {	--===================关卡8.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		stop = true,
		enable = false,
	},
	[907610] = {	--===================关卡8.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[907620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[907650] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		stop = true,
		enable = false,
	},
	[907710] = {	--===================关卡8.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[907720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[907730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907740] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[907750] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[907760] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[907770] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[907810] = {	--===================关卡8.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[907820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[907830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[907840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[907910] = {	--===================关卡8.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.DEMON_GENERAL_S,
	},
	[907920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.PLAYER,
	},
	[907930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.DEMON_GENERAL_S,
	},
	[907940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908010] = {	--===================关卡9.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908050] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908110] = {	--===================关卡9.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[908140] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[908150] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		stop = true,
		enable = false,
	},
	[908210] = {	--===================关卡9.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[908220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908310] = {	--===================关卡9.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[908320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[908330] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908340] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
	},
	[908350] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
		stop = true,
		enable = false,
	},
	[908410] = {	--===================关卡9.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908430] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[908440] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908510] = {	--===================关卡9.6begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
	},
	[908520] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[908530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[908540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908610] = {	--===================关卡9.7begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[908620] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[908630] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908640] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908650] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
		stop = true,
		enable = false,
	},
	[908710] = {	--===================关卡9.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[908720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908810] = {	--===================关卡9.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[908830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[908840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[908910] = {	--===================关卡9.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[908920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[908930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[908940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[908950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.PLAYER,
	},
	[908960] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.KILLER,
	},
	[908970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.KILLER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909010] = {	--===================关卡10.1begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909020] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[909030] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909040] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909110] = {	--===================关卡10.2begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[909120] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909130] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909210] = {	--===================关卡10.3begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909220] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.LORD_S,
	},
	[909230] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909310] = {	--===================关卡10.4begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[909320] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[909330] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909340] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[909350] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		stop = true,
		enable = false,
	},
	[909410] = {	--===================关卡10.5begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909420] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.DEMON_GENERAL_M,
		text = _s("HELPER_INFO_909420", M.ROLE.PLAYER.HONOUR),
	},
	[909430] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.MAID,
	},
	[909440] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.DEMON_GENERAL_M,
	},
	[909450] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909510] = {	--===================关卡10.6begin
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[909520] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.DEMON_GENERAL_Z,
	},
	[909530] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.PLAYER,
	},
	[909540] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.DEMON_GENERAL_Z,
		stop = true,
		enable = false,
	},
	[909610] = {	--===================关卡10.7begin
		left = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909620] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_B,
		speaker = M.ROLE.DEMON_GENERAL_B,
	},
	[909630] = {
		left = M.ROLE.MAID,
		right = M.ROLE.DEMON_GENERAL_B,
		speaker = M.ROLE.MAID,
	},
	[909640] = {
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909710] = {	--===================关卡10.8begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909720] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.DEMON_GENERAL_S,
	},
	[909730] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_S,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909810] = {	--===================关卡10.9begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
	},
	[909820] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.PLAYER,
	},
	[909830] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
	},
	[909840] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[909910] = {	--===================关卡10.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[909920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[909930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
	},
	[909940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.PLAYER,
	},
	[909950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.GOD_SPIRIT,
		speaker = M.ROLE.GOD_SPIRIT,
	},
	[909960] = {
		left = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[909970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
		stop = true,
		enable = false,
	},
	[9010010] = {	--===================关卡11.01begin
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[9010020] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9010030] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9010040] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9010110] = {	--===================关卡11.02begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010120] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010130] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010140] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010150] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010160] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},

	[9010210] = {	--===================关卡11.03begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010220] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010230] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010240] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010250] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010310] = {	--===================关卡11.04begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010320] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010330] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010340] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010350] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010360] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010370] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010380] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010390] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010410] = {	--===================关卡11.05begin
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9010420] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9010430] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9010440] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9010450] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9010460] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9010510] = {	--===================关卡11.06begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010520] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010530] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010610] = {	--===================关卡11.07begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010620] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010630] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010640] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010710] = {	--===================关卡11.08begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010720] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010730] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010740] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010750] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[9010760] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[9010770] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9010780] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[9010810] = {	--===================关卡11.09begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010820] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010830] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010840] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010910] = {	--===================关卡11.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010920] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9010930] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9010940] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101010] = {	--===================关卡11.11begin
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[90101020] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[90101030] = {	
		left = M.ROLE.SECRET_MYSTICAL,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101040] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_MYSTICAL,
		speaker = M.ROLE.PLAYER,
	},
	[90101050] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_MYSTICAL,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[90101060] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_MYSTICAL,
		speaker = M.ROLE.PLAYER,
	},
	[90101070] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_MYSTICAL,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[90101080] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_MYSTICAL,
		speaker = M.ROLE.SECRET_MYSTICAL,
	},
	[90101110] = {	--===================关卡11.12begin
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[90101120] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[90101130] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[90101140] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[90101210] = {	--===================关卡11.13begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101220] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101230] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101240] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101250] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101310] = {	--===================关卡11.14begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101320] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101330] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101340] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101350] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101360] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101370] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101410] = {	--===================关卡11.15begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90101420] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90101430] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011010] = {	--===================关卡12.01begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011020] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011030] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011040] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011110] = {	--===================关卡12.02begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011120] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011130] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011210] = {	--===================关卡12.03begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011220] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011230] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011240] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011310] = {	--===================关卡12.04begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011320] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011330] = {	
		left = M.ROLE.GOD_SPIRIT,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.GOD_SPIRIT,
	},
	[9011340] = {	
		left = M.ROLE.GOD_SPIRIT,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9011350] = {	
		left = M.ROLE.GOD_SPIRIT,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.GOD_SPIRIT,
	},
	[9011410] = {	--===================关卡12.05begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011420] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011430] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011440] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011510] = {	--===================关卡12.06begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011520] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011530] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011540] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011550] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.LORD_K,
	},
	[9011560] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9011570] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.LORD_K,
	},
	[9011580] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9011590] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.LORD_K,
		nextIndex =  9011591
	},
	[9011591] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		nextIndex =  9011592
	},
	[9011592] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[9011610] = {	--===================关卡12.07begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011620] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011630] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011640] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011710] = {	--===================关卡12.08begin
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9011720] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9011730] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.MAID,
	},
	[9011740] = {	
		left = M.ROLE.MAID,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[9011810] = {	--===================关卡12.09begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011820] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9011830] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9011910] = {	--===================关卡12.10begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[9011920] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
	},
	[9011930] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.PLAYER,
	},
	[9011940] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.WARLOCK_SOUL,
		speaker = M.ROLE.WARLOCK_SOUL,
	},
	[90111010] = {	--===================关卡12.11begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[90111020] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[90111030] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90111040] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[90111110] = {	--===================关卡12.12begin
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[90111120] = {	
		left = M.ROLE.LORD_K,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.LORD_K,
	},
	[90111130] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90111140] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[90111210] = {	--===================关卡12.13begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90111220] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[90111230] = {	
		left = M.ROLE.KILLER,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.KILLER,
	},
	[90111240] = {	
		left = M.ROLE.KILLER,
		right = M.ROLE.PLAYER,
		speaker = M.ROLE.PLAYER,
	},
	[90111310] = {	--===================关卡12.14begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[90111320] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[90111330] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[90111340] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[90111410] = {	--===================关卡12.15begin
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[90111420] = {	
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},



--===关卡战斗胜利触发式剧情===
	[910910] = {	--===================关卡1.10战斗胜利
		left = M.ROLE.HUMAN_SOLDIER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[910920] = {
		left = M.ROLE.MAID,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_910920", M.ROLE.PLAYER.HONOUR),
	},
	[910930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		text = _s("HELPER_INFO_910930", M.ROLE.PLAYER.HONOUR),
	},
	[910940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[910950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
		text = _s("HELPER_INFO_910950", M.ROLE.PLAYER.HONOUR),
	},
	[910960] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[911910] = {	--===================关卡2.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.DEMON_GENERAL_M,
	},
	[911920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_M,
		speaker = M.ROLE.PLAYER,
	},
	[911930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_911930", M.ROLE.PLAYER.HONOUR),
	},
	[911940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[912910] = {	--===================关卡3.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.PLAYER,
	},
	[912920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.SECRET_ASSASSIN,
		speaker = M.ROLE.SECRET_ASSASSIN,
	},
	[912930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[913910] = {	--===================关卡4.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.PLAYER,
	},
	[913920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.DEMON_GENERAL_Z,
		speaker = M.ROLE.DEMON_GENERAL_Z,
	},
	[913930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_913930", M.ROLE.PLAYER.HONOUR),
	},
	[913940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[913950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_913950", M.ROLE.PLAYER.HONOUR),
	},
	[913960] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_913960", M.ROLE.PLAYER.HONOUR),
	},
	[913970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[914910] = {	--===================关卡5.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[914920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[914930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_914930", M.ROLE.PLAYER.HONOUR),
	},
	[914940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[915910] = {	--===================关卡6.10战斗胜利
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.MAID,
	},
	[915920] = {
		left = M.ROLE.MAID,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
		text = _s("HELPER_INFO_915920", M.ROLE.PLAYER.HONOUR),
	},
	[915930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[915940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[915950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_915950", M.ROLE.PLAYER.HONOUR),
		stop = true,
		enable = false,
	},
	[916910] = {	--===================关卡7.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		text = _s("HELPER_INFO_916910", M.ROLE.PLAYER.HONOUR),
	},
	[916920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[916930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[916940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[917910] = {	--===================关卡8.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[917920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
		stop = true,
		enable = false,
	},
	[918910] = {	--===================关卡9.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.LORD_K,
	},
	[918920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.LORD_K,
		speaker = M.ROLE.PLAYER,
	},
	[918930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[919910] = {	--===================关卡10.10战斗胜利
		left = M.ROLE.DEMON_KING,
		speaker = M.ROLE.DEMON_KING,
	},
	[919920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[919930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[919940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[919950] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[919960] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[919970] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[919980] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
		stop = true,
		enable = false,
	},
	[9110910] = {	--===================关卡11.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9110920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9110930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},
	[9110940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.PLAYER,
	},
	[9111910] = {	--===================关卡12.10战斗胜利
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[9111920] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.HUMAN_SOLDIER,
	},
	[9111930] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.HUMAN_SOLDIER,
		speaker = M.ROLE.PLAYER,
	},
	[9111940] = {
		left = M.ROLE.PLAYER,
		right = M.ROLE.MAID,
		speaker = M.ROLE.MAID,
	},

-- ====================[剧情故事] END====================

}







return M